use std.textio.all;
library IEEE;
use IEEE.std_logic_1164.all;


package Sital_textio is

     -- finds first occurence of S in l.
     -- returns good if S is in l.
     -- else false. 
     procedure StrStr(variable l : inout line; S : string; 
		      good :out boolean);
    
    -- Reads a line with readline.
    -- Cleans leading white spaces.
    procedure ReadCleanLine(file f: TEXT; L : inout LINE);
--    procedure ReadCleanLine(variable f: in TEXT; L : inout LINE);

    -- Asserts an error flag.
    -- Writes error to error file.
    procedure error_report(file f: TEXT; 
			   S : string;
			   LineNum : in natural);
--    procedure error_report(variable f: out TEXT; 
--			   S : string; 
--			   LineNum : in natural);

    -- Asserts an error flag.
    -- Writes error to the screen.
    procedure error_print(variable f: out TEXT; 
			   S : string; 
			   LineNum : in natural);

    -- Asserts a note flag with message.
    -- Writes note to error file.
    procedure note_report(file f: TEXT; 
                          S : string;
                          LineNum : in natural);
--    procedure note_report(variable f: out TEXT; 
--			   S : string; 
--			   LineNum : in natural);

    -- reads a hex value
	procedure ReadHex(L:inout LINE; VALUE:out BIT_VECTOR;
	                  GOOD: out BOOLEAN);
    -- reads a hex value and returns a Std_ulogic value
	procedure ReadHex(L:inout LINE; VALUE:out Std_ulogic_VECTOR;
	                  GOOD: out BOOLEAN);
    -- reads a hex value and returns a Std_logic value
	procedure ReadHex(L:inout LINE; VALUE:out Std_logic_VECTOR;
	                  GOOD: out BOOLEAN);


    -- returns true if line is empty.
    procedure LineEmpty(L : inout Line;Good : out boolean);

    --- converts an integer into string -----
    function Int_to_string(val : integer) return string;

    --- converts an std_logic_vector into string -----
    function HEX_to_string(value : std_logic_vector) return string;

    -----Reads a string from a line without the leading white 
    -----spaces, appends spaces if line terminates before end string.
    procedure ReadString(l : inout line; S : out string);

    PROCEDURE readword(VARIABLE field_str : INOUT STRING ; work_line : INOUT LINE ; VARIABLE cursor : INOUT INTEGER);

    procedure Shrink_line(L : inout LINE; pos : in integer);
    procedure Skip_white(variable L : in LINE; pos : inout integer);

    function  to_lower  ( constant  c    : in character
                    ) return character;

    -- convert std_logic_vector to hex string
    function vec2hexstring(VALUE:in std_logic_vector) return string;

end;

