-- VHDL Entity Bus_tester.sital_1553_bus_tester2.symbol
--
-- Created:
--          by - Admin.UNKNOWN (OFERH-LAP)
--          at - 12:12:44 01/24/2019
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY sital_1553_bus_tester2 IS
   GENERIC( 
      file_name : string
   );
   PORT( 
      Rx_N_a   : IN     STD_LOGIC;
      Rx_N_b   : IN     STD_LOGIC;
      Rx_P_a   : IN     STD_LOGIC;
      Rx_P_b   : IN     STD_LOGIC;
      TA_Pulse : OUT    std_logic;
      TB_Pulse : OUT    std_logic;
      Tx_N_a   : OUT    std_logic  := '0';
      Tx_N_b   : OUT    STD_LOGIC  := '0';
      Tx_P_a   : OUT    STD_LOGIC  := '0';
      Tx_P_b   : OUT    STD_LOGIC  := '0';
      RA_Data  : BUFFER STD_LOGIC_VECTOR (15 DOWNTO 0);  --MSB sent first.
      RB_Data  : BUFFER STD_LOGIC_VECTOR (15 DOWNTO 0);  --MSB sent first.
      TA_Data  : BUFFER STD_LOGIC_VECTOR (15 DOWNTO 0);  --MSB sent first.
      TB_Data  : BUFFER STD_LOGIC_VECTOR (15 DOWNTO 0)   --MSB sent first.
   );

-- Declarations

END sital_1553_bus_tester2 ;

--
-- VHDL Architecture Bus_tester.sital_1553_bus_tester2.Sital_Ofer_Hofman
--
-- Created:
--          by - Admin.UNKNOWN (OFERH-LAP)
--          at - 12:12:44 01/24/2019
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ARCHITECTURE Sital_Ofer_Hofman OF sital_1553_bus_tester2 IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL RA_CS           : boolean;
   SIGNAL RA_Gap          : time      := 4 us;
   SIGNAL RA_RxRdy        : BOOLEAN;
   SIGNAL RA_Sync         : STD_LOGIC := '0';
   -- Receiver A --
   SIGNAL RA_receiveing   : BOOLEAN;
   SIGNAL RB_CS           : boolean;
   SIGNAL RB_Gap          : time      := 4 us;
   SIGNAL RB_RxRdy        : BOOLEAN;
   SIGNAL RB_Sync         : STD_LOGIC := '0';
   -- Receiver B --
   SIGNAL RB_receiveing   : BOOLEAN;
   -- transmitter_A INterface --
   SIGNAL TA_Go           : boolean;
   SIGNAL TA_Sync         : std_logic;
   SIGNAL TA_Transmitting : boolean;
   -- transmitter_A INterface --
   SIGNAL TB_Go           : boolean;
   SIGNAL TB_Sync         : std_logic;
   SIGNAL TB_Transmitting : boolean;


   -- Component Declarations
   COMPONENT Executer_simple2
   GENERIC (
      comm_file_name : string := "../hds2004/bus_tester.dat"
   );
   PORT (
      -- transmitter_A INterface --
      TA_Go           : OUT    boolean ;
      TA_Sync         : OUT    std_logic ;
      TA_Data         : OUT    STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      TA_Transmitting : IN     boolean ;
      TA_Pulse        : OUT    std_logic ;
      -- transmitter_A INterface --
      TB_Go           : OUT    boolean ;
      TB_Sync         : OUT    std_logic ;
      TB_Data         : OUT    STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      TB_Transmitting : IN     boolean ;
      TB_Pulse        : OUT    std_logic ;
      -- Receiver A --
      RA_receiveing   : IN     BOOLEAN ;
      RA_RxRdy        : IN     BOOLEAN ;
      RA_Sync         : IN     STD_LOGIC  := '0';
      RA_Data         : IN     STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      RA_CS           : IN     boolean ;
      RA_Gap          : IN     time       := 4 us;
      -- Receiver B --
      RB_receiveing   : IN     BOOLEAN ;
      RB_RxRdy        : IN     BOOLEAN ;
      RB_Sync         : IN     STD_LOGIC  := '0';
      RB_Data         : IN     STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      RB_CS           : IN     boolean ;
      RB_Gap          : IN     time       := 4 us
   );
   END COMPONENT;
   COMPONENT Transmitter
   PORT (
      Go           : IN     boolean ;
      Sync         : IN     std_logic ;
      Data         : IN     STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      Line_P       : OUT    STD_LOGIC  := '0';
      Line_N       : OUT    STD_LOGIC  := '0';
      Transmitting : BUFFER boolean 
   );
   END COMPONENT;
   COMPONENT receiver_simple
   PORT (
      Line_P     : IN     STD_LOGIC ;
      Line_N     : IN     STD_LOGIC ;
      receiveing : OUT    BOOLEAN ;
      RxRdy      : OUT    BOOLEAN ;
      Sync       : OUT    STD_LOGIC  := '0';
      Data       : OUT    STD_LOGIC_VECTOR (15 DOWNTO 0); --MSB sent first.
      CS         : OUT    boolean ;
      Gap        : OUT    time       := 4 us
   );
   END COMPONENT;


BEGIN

   -- Instance port mappings.
   Executer_simple : Executer_simple2
      GENERIC MAP (
         comm_file_name => file_name
      )
      PORT MAP (
         TA_Go           => TA_Go,
         TA_Sync         => TA_Sync,
         TA_Data         => TA_Data,
         TA_Transmitting => TA_Transmitting,
         TA_Pulse        => TA_Pulse,
         TB_Go           => TB_Go,
         TB_Sync         => TB_Sync,
         TB_Data         => TB_Data,
         TB_Transmitting => TB_Transmitting,
         TB_Pulse        => TB_Pulse,
         RA_receiveing   => RA_receiveing,
         RA_RxRdy        => RA_RxRdy,
         RA_Sync         => RA_Sync,
         RA_Data         => RA_Data,
         RA_CS           => RA_CS,
         RA_Gap          => RA_Gap,
         RB_receiveing   => RB_receiveing,
         RB_RxRdy        => RB_RxRdy,
         RB_Sync         => RB_Sync,
         RB_Data         => RB_Data,
         RB_CS           => RB_CS,
         RB_Gap          => RB_Gap
      );
   Transmitter1 : Transmitter
      PORT MAP (
         Go           => TA_Go,
         Sync         => TA_Sync,
         Data         => TA_Data,
         Line_P       => Tx_P_a,
         Line_N       => Tx_N_a,
         Transmitting => TA_Transmitting
      );
   Transmitter2 : Transmitter
      PORT MAP (
         Go           => TB_Go,
         Sync         => TB_Sync,
         Data         => TB_Data,
         Line_P       => Tx_P_b,
         Line_N       => Tx_N_b,
         Transmitting => TB_Transmitting
      );
   receiver_simple1 : receiver_simple
      PORT MAP (
         Line_P     => Rx_P_a,
         Line_N     => Rx_N_a,
         receiveing => RA_receiveing,
         RxRdy      => RA_RxRdy,
         Sync       => RA_Sync,
         Data       => RA_Data,
         CS         => RA_CS,
         Gap        => RA_Gap
      );
   receiver_simple2 : receiver_simple
      PORT MAP (
         Line_P     => Rx_P_b,
         Line_N     => Rx_N_b,
         receiveing => RB_receiveing,
         RxRdy      => RB_RxRdy,
         Sync       => RB_Sync,
         Data       => RB_Data,
         CS         => RB_CS,
         Gap        => RB_Gap
      );

END Sital_Ofer_Hofman;
