
-- 
-- Definition of  BRM1553D_ver8_4_Limited_64Mhz
-- 
--      06/13/19 20:56:13
--      
--      Precision RTL Synthesis, 2010a_Update1.228
-- 

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity ram_new_0_RAM2_5_16_1_Sital is 
   port (
      wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
      rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
      addr1 : IN std_logic_vector (4 DOWNTO 0) ;
      wr_clk1 : IN std_logic ;
      rd_clk1 : IN std_logic ;
      wr_ena1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      ena1 : IN std_logic ;
      rst1 : IN std_logic ;
      regce1 : IN std_logic) ;
end ram_new_0_RAM2_5_16_1_Sital ;

architecture INTERFACE of ram_new_0_RAM2_5_16_1_Sital is 
   component clocked_ram_16_5_32_F_F_F_F_F_F_F_F_F
      generic (ram_type : integer := 1) ;
      
      port (
         clk : IN std_logic ;
         we : IN std_logic ;
         address : IN std_logic_vector (4 DOWNTO 0) ;
         data : IN std_logic_vector (15 DOWNTO 0) ;
         q : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   signal nx44, nx46, nx48, nx50: std_logic ;

begin
   nx44 <= '0' ;
   nx46 <= '1' ;
   mem : clocked_ram_16_5_32_F_F_F_F_F_F_F_F_F port map ( clk=>wr_clk1, we=>
      nx48, address(4)=>addr1(4), address(3)=>addr1(3), address(2)=>addr1(2), 
      address(1)=>addr1(1), address(0)=>addr1(0), data(15)=>wr_data1(15), 
      data(14)=>wr_data1(14), data(13)=>wr_data1(13), data(12)=>wr_data1(12), 
      data(11)=>wr_data1(11), data(10)=>wr_data1(10), data(9)=>wr_data1(9), 
      data(8)=>wr_data1(8), data(7)=>wr_data1(7), data(6)=>wr_data1(6), 
      data(5)=>wr_data1(5), data(4)=>wr_data1(4), data(3)=>wr_data1(3), 
      data(2)=>wr_data1(2), data(1)=>wr_data1(1), data(0)=>wr_data1(0), 
      q(15)=>rd_data1(15), q(14)=>rd_data1(14), q(13)=>rd_data1(13), q(12)=>
      rd_data1(12), q(11)=>rd_data1(11), q(10)=>rd_data1(10), q(9)=>
      rd_data1(9), q(8)=>rd_data1(8), q(7)=>rd_data1(7), q(6)=>rd_data1(6), 
      q(5)=>rd_data1(5), q(4)=>rd_data1(4), q(3)=>rd_data1(3), q(2)=>
      rd_data1(2), q(1)=>rd_data1(1), q(0)=>rd_data1(0));
   nx48 <= wr_ena1 AND ena1 ;
   nx50 <= rd_ena1 AND ena1 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity RAM2_5_16_1 is 
   port (
      D : IN std_logic_vector (15 DOWNTO 0) ;
      A : IN std_logic_vector (4 DOWNTO 0) ;
      WE : IN std_logic ;
      Q : OUT std_logic_vector (15 DOWNTO 0) ;
      Clock : IN std_logic) ;
end RAM2_5_16_1 ;

architecture Sital of RAM2_5_16_1 is 
   component ram_new_0_RAM2_5_16_1_Sital
      port (
         wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
         rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
         addr1 : IN std_logic_vector (4 DOWNTO 0) ;
         wr_clk1 : IN std_logic ;
         rd_clk1 : IN std_logic ;
         wr_ena1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         ena1 : IN std_logic ;
         rst1 : IN std_logic ;
         regce1 : IN std_logic) ;
   end component ;
   signal nx28, nx30: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   mem : ram_new_0_RAM2_5_16_1_Sital port map ( wr_data1(15)=>D(15), 
      wr_data1(14)=>D(14), wr_data1(13)=>D(13), wr_data1(12)=>D(12), 
      wr_data1(11)=>D(11), wr_data1(10)=>D(10), wr_data1(9)=>D(9), 
      wr_data1(8)=>D(8), wr_data1(7)=>D(7), wr_data1(6)=>D(6), wr_data1(5)=>
      D(5), wr_data1(4)=>D(4), wr_data1(3)=>D(3), wr_data1(2)=>D(2), 
      wr_data1(1)=>D(1), wr_data1(0)=>D(0), rd_data1(15)=>Q(15), 
      rd_data1(14)=>Q(14), rd_data1(13)=>Q(13), rd_data1(12)=>Q(12), 
      rd_data1(11)=>Q(11), rd_data1(10)=>Q(10), rd_data1(9)=>Q(9), 
      rd_data1(8)=>Q(8), rd_data1(7)=>Q(7), rd_data1(6)=>Q(6), rd_data1(5)=>
      Q(5), rd_data1(4)=>Q(4), rd_data1(3)=>Q(3), rd_data1(2)=>Q(2), 
      rd_data1(1)=>Q(1), rd_data1(0)=>Q(0), addr1(4)=>A(4), addr1(3)=>A(3), 
      addr1(2)=>A(2), addr1(1)=>A(1), addr1(0)=>A(0), wr_clk1=>Clock, 
      rd_clk1=>DANGLING(0), wr_ena1=>WE, rd_ena1=>nx30, ena1=>nx30, rst1=>
      nx28, regce1=>nx30);
   nx28 <= '0' ;
   nx30 <= '1' ;
end Sital ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 ;

architecture INTERFACE_unfold_1 of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, PWR, nx42, nx44, nx46, 
      nx48, nx50, NOT_nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx25 ;
   q(3) <= nx27 ;
   q(2) <= nx29 ;
   q(1) <= nx31 ;
   q(0) <= nx33 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 OR sclear ;
   nx21 <= nx18 AND clk_en ;
   DFFPCE (nx24,GND,aclear,nx21,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx21,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx21,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx21,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx21,clock,nx33) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx25, a(3)=>nx27, a(2)=>
      nx29, a(1)=>nx31, a(0)=>nx33, d(4)=>nx34, d(3)=>nx35, d(2)=>nx36, d(1)
      =>nx37, d(0)=>nx38, cout=>DANGLING(0));
   PWR <= '1' ;
   nx42 <= data(4) when sload = '1' else nx34 ;
   nx44 <= data(3) when sload = '1' else nx35 ;
   nx46 <= data(2) when sload = '1' else nx36 ;
   nx48 <= data(1) when sload = '1' else nx37 ;
   nx50 <= data(0) when sload = '1' else nx38 ;
   NOT_nx17 <= NOT sclear ;
   nx24 <= nx42 AND NOT_nx17 ;
   nx26 <= nx44 AND NOT_nx17 ;
   nx28 <= nx46 AND NOT_nx17 ;
   nx30 <= nx48 AND NOT_nx17 ;
   nx32 <= nx50 AND NOT_nx17 ;
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (6 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 ;

architecture INTERFACE_unfold_1 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx22, nx25, nx26, nx27, nx28, nx29, nx30, nx31, nx32, 
      nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, 
      nx45, PWR, NOT_nx18: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx26 ;
   q(5) <= nx28 ;
   q(4) <= nx30 ;
   q(3) <= nx32 ;
   q(2) <= nx34 ;
   q(1) <= nx36 ;
   q(0) <= nx38 ;
   GND <= '0' ;
   nx19 <= cnt_en OR sclear ;
   nx22 <= nx19 AND clk_en ;
   DFFPCE (nx25,GND,aclear,nx22,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,nx22,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,nx22,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx22,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx22,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx22,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx22,clock,nx38) ;
   inc : inc_7u_7u_0_0 port map ( cin=>PWR, a(6)=>nx26, a(5)=>nx28, a(4)=>
      nx30, a(3)=>nx32, a(2)=>nx34, a(1)=>nx36, a(0)=>nx38, d(6)=>nx39, d(5)
      =>nx40, d(4)=>nx41, d(3)=>nx42, d(2)=>nx43, d(1)=>nx44, d(0)=>nx45, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx18 <= NOT sclear ;
   nx25 <= nx39 AND NOT_nx18 ;
   nx27 <= nx40 AND NOT_nx18 ;
   nx29 <= nx41 AND NOT_nx18 ;
   nx31 <= nx42 AND NOT_nx18 ;
   nx33 <= nx43 AND NOT_nx18 ;
   nx35 <= nx44 AND NOT_nx18 ;
   nx37 <= nx45 AND NOT_nx18 ;
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_sload_aclear_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_sload_aclear_clock_clk_en_0_5 ;

architecture INTERFACE_unfold_3 of counter_dn_sload_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx15 <= data(4) when sload = '1' else nx25 ;
   nx17 <= data(3) when sload = '1' else nx26 ;
   nx19 <= data(2) when sload = '1' else nx27 ;
   nx21 <= data(1) when sload = '1' else nx28 ;
   nx23 <= data(0) when sload = '1' else nx29 ;
end INTERFACE_unfold_3 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (15 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (15 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 ;

architecture INTERFACE_unfold_1 of 
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_16u_16u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx37, nx40, nx43, nx46, nx47, nx48, nx49, nx50, nx51, nx52, 
      nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, nx61, nx62, nx63, nx64, 
      nx65, nx66, nx67, nx68, nx69, nx70, nx71, nx72, nx73, nx74, nx75, nx76, 
      nx77, nx78, nx79, nx80, nx81, nx82, nx83, nx84, nx85, nx86, nx87, nx88, 
      nx89, nx90, nx91, nx92, nx93, nx95, nx97, nx99, nx101, nx103, nx105, 
      nx107, nx109, nx111, nx113, nx115, nx117, nx119, nx121, nx123, nx125, 
      NOT_nx39: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(15) <= nx47 ;
   q(14) <= nx49 ;
   q(13) <= nx51 ;
   q(12) <= nx53 ;
   q(11) <= nx55 ;
   q(10) <= nx57 ;
   q(9) <= nx59 ;
   q(8) <= nx61 ;
   q(7) <= nx63 ;
   q(6) <= nx65 ;
   q(5) <= nx67 ;
   q(4) <= nx69 ;
   q(3) <= nx71 ;
   q(2) <= nx73 ;
   q(1) <= nx75 ;
   q(0) <= nx77 ;
   GND <= '0' ;
   nx37 <= cnt_en OR sload ;
   nx40 <= nx37 OR sclear ;
   nx43 <= nx40 AND clk_en ;
   DFFPCE (nx46,GND,aclear,nx43,clock,nx47) ;
   DFFPCE (nx48,GND,aclear,nx43,clock,nx49) ;
   DFFPCE (nx50,GND,aclear,nx43,clock,nx51) ;
   DFFPCE (nx52,GND,aclear,nx43,clock,nx53) ;
   DFFPCE (nx54,GND,aclear,nx43,clock,nx55) ;
   DFFPCE (nx56,GND,aclear,nx43,clock,nx57) ;
   DFFPCE (nx58,GND,aclear,nx43,clock,nx59) ;
   DFFPCE (nx60,GND,aclear,nx43,clock,nx61) ;
   DFFPCE (nx62,GND,aclear,nx43,clock,nx63) ;
   DFFPCE (nx64,GND,aclear,nx43,clock,nx65) ;
   DFFPCE (nx66,GND,aclear,nx43,clock,nx67) ;
   DFFPCE (nx68,GND,aclear,nx43,clock,nx69) ;
   DFFPCE (nx70,GND,aclear,nx43,clock,nx71) ;
   DFFPCE (nx72,GND,aclear,nx43,clock,nx73) ;
   DFFPCE (nx74,GND,aclear,nx43,clock,nx75) ;
   DFFPCE (nx76,GND,aclear,nx43,clock,nx77) ;
   dec : dec_16u_16u_0_0 port map ( cin=>GND, a(15)=>nx47, a(14)=>nx49, 
      a(13)=>nx51, a(12)=>nx53, a(11)=>nx55, a(10)=>nx57, a(9)=>nx59, a(8)=>
      nx61, a(7)=>nx63, a(6)=>nx65, a(5)=>nx67, a(4)=>nx69, a(3)=>nx71, a(2)
      =>nx73, a(1)=>nx75, a(0)=>nx77, d(15)=>nx78, d(14)=>nx79, d(13)=>nx80, 
      d(12)=>nx81, d(11)=>nx82, d(10)=>nx83, d(9)=>nx84, d(8)=>nx85, d(7)=>
      nx86, d(6)=>nx87, d(5)=>nx88, d(4)=>nx89, d(3)=>nx90, d(2)=>nx91, d(1)
      =>nx92, d(0)=>nx93, cout=>DANGLING(0));
   nx95 <= data(15) when sload = '1' else nx78 ;
   nx97 <= data(14) when sload = '1' else nx79 ;
   nx99 <= data(13) when sload = '1' else nx80 ;
   nx101 <= data(12) when sload = '1' else nx81 ;
   nx103 <= data(11) when sload = '1' else nx82 ;
   nx105 <= data(10) when sload = '1' else nx83 ;
   nx107 <= data(9) when sload = '1' else nx84 ;
   nx109 <= data(8) when sload = '1' else nx85 ;
   nx111 <= data(7) when sload = '1' else nx86 ;
   nx113 <= data(6) when sload = '1' else nx87 ;
   nx115 <= data(5) when sload = '1' else nx88 ;
   nx117 <= data(4) when sload = '1' else nx89 ;
   nx119 <= data(3) when sload = '1' else nx90 ;
   nx121 <= data(2) when sload = '1' else nx91 ;
   nx123 <= data(1) when sload = '1' else nx92 ;
   nx125 <= data(0) when sload = '1' else nx93 ;
   NOT_nx39 <= NOT sclear ;
   nx46 <= nx95 AND NOT_nx39 ;
   nx48 <= nx97 AND NOT_nx39 ;
   nx50 <= nx99 AND NOT_nx39 ;
   nx52 <= nx101 AND NOT_nx39 ;
   nx54 <= nx103 AND NOT_nx39 ;
   nx56 <= nx105 AND NOT_nx39 ;
   nx58 <= nx107 AND NOT_nx39 ;
   nx60 <= nx109 AND NOT_nx39 ;
   nx62 <= nx111 AND NOT_nx39 ;
   nx64 <= nx113 AND NOT_nx39 ;
   nx66 <= nx115 AND NOT_nx39 ;
   nx68 <= nx117 AND NOT_nx39 ;
   nx70 <= nx119 AND NOT_nx39 ;
   nx72 <= nx121 AND NOT_nx39 ;
   nx74 <= nx123 AND NOT_nx39 ;
   nx76 <= nx125 AND NOT_nx39 ;
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_sload_aclear_clock_clk_en_0_12 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (11 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (11 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_sload_aclear_clock_clk_en_0_12 ;

architecture INTERFACE of counter_dn_sload_aclear_clock_clk_en_0_12 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_12u_12u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic_vector (11 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx29, nx30, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, 
      nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, nx61, nx62, 
      nx63, nx64: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(11) <= nx30 ;
   q(10) <= nx32 ;
   q(9) <= nx34 ;
   q(8) <= nx36 ;
   q(7) <= nx38 ;
   q(6) <= nx40 ;
   q(5) <= nx42 ;
   q(4) <= nx44 ;
   q(3) <= nx46 ;
   q(2) <= nx48 ;
   q(1) <= nx50 ;
   q(0) <= nx52 ;
   GND <= '0' ;
   DFFPCE (nx29,GND,aclear,clk_en,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,clk_en,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,clk_en,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,clk_en,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,clk_en,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,clk_en,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,clk_en,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,clk_en,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,clk_en,clock,nx46) ;
   DFFPCE (nx47,GND,aclear,clk_en,clock,nx48) ;
   DFFPCE (nx49,GND,aclear,clk_en,clock,nx50) ;
   DFFPCE (nx51,GND,aclear,clk_en,clock,nx52) ;
   dec : dec_12u_12u_0_0 port map ( cin=>GND, a(11)=>nx30, a(10)=>nx32, a(9)
      =>nx34, a(8)=>nx36, a(7)=>nx38, a(6)=>nx40, a(5)=>nx42, a(4)=>nx44, 
      a(3)=>nx46, a(2)=>nx48, a(1)=>nx50, a(0)=>nx52, d(11)=>nx53, d(10)=>
      nx54, d(9)=>nx55, d(8)=>nx56, d(7)=>nx57, d(6)=>nx58, d(5)=>nx59, d(4)
      =>nx60, d(3)=>nx61, d(2)=>nx62, d(1)=>nx63, d(0)=>nx64, cout=>DANGLING
      (0));
   nx29 <= data(11) when sload = '1' else nx53 ;
   nx31 <= data(10) when sload = '1' else nx54 ;
   nx33 <= data(9) when sload = '1' else nx55 ;
   nx35 <= data(8) when sload = '1' else nx56 ;
   nx37 <= data(7) when sload = '1' else nx57 ;
   nx39 <= data(6) when sload = '1' else nx58 ;
   nx41 <= data(5) when sload = '1' else nx59 ;
   nx43 <= data(4) when sload = '1' else nx60 ;
   nx45 <= data(3) when sload = '1' else nx61 ;
   nx47 <= data(2) when sload = '1' else nx62 ;
   nx49 <= data(1) when sload = '1' else nx63 ;
   nx51 <= data(0) when sload = '1' else nx64 ;
end INTERFACE ;


architecture INTERFACE of 
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_16u_16u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx37, nx40, nx43, nx46, nx47, nx48, nx49, nx50, nx51, nx52, 
      nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, nx61, nx62, nx63, nx64, 
      nx65, nx66, nx67, nx68, nx69, nx70, nx71, nx72, nx73, nx74, nx75, nx76, 
      nx77, nx78, nx79, nx80, nx81, nx82, nx83, nx84, nx85, nx86, nx87, nx88, 
      nx89, nx90, nx91, nx92, nx93, nx95, nx97, nx99, nx101, nx103, nx105, 
      nx107, nx109, nx111, nx113, nx115, nx117, nx119, nx121, nx123, nx125, 
      NOT_nx39: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(15) <= nx47 ;
   q(14) <= nx49 ;
   q(13) <= nx51 ;
   q(12) <= nx53 ;
   q(11) <= nx55 ;
   q(10) <= nx57 ;
   q(9) <= nx59 ;
   q(8) <= nx61 ;
   q(7) <= nx63 ;
   q(6) <= nx65 ;
   q(5) <= nx67 ;
   q(4) <= nx69 ;
   q(3) <= nx71 ;
   q(2) <= nx73 ;
   q(1) <= nx75 ;
   q(0) <= nx77 ;
   GND <= '0' ;
   nx37 <= cnt_en OR sload ;
   nx40 <= nx37 OR sclear ;
   nx43 <= nx40 AND clk_en ;
   DFFPCE (nx46,GND,aclear,nx43,clock,nx47) ;
   DFFPCE (nx48,GND,aclear,nx43,clock,nx49) ;
   DFFPCE (nx50,GND,aclear,nx43,clock,nx51) ;
   DFFPCE (nx52,GND,aclear,nx43,clock,nx53) ;
   DFFPCE (nx54,GND,aclear,nx43,clock,nx55) ;
   DFFPCE (nx56,GND,aclear,nx43,clock,nx57) ;
   DFFPCE (nx58,GND,aclear,nx43,clock,nx59) ;
   DFFPCE (nx60,GND,aclear,nx43,clock,nx61) ;
   DFFPCE (nx62,GND,aclear,nx43,clock,nx63) ;
   DFFPCE (nx64,GND,aclear,nx43,clock,nx65) ;
   DFFPCE (nx66,GND,aclear,nx43,clock,nx67) ;
   DFFPCE (nx68,GND,aclear,nx43,clock,nx69) ;
   DFFPCE (nx70,GND,aclear,nx43,clock,nx71) ;
   DFFPCE (nx72,GND,aclear,nx43,clock,nx73) ;
   DFFPCE (nx74,GND,aclear,nx43,clock,nx75) ;
   DFFPCE (nx76,GND,aclear,nx43,clock,nx77) ;
   dec : dec_16u_16u_0_0 port map ( cin=>GND, a(15)=>nx47, a(14)=>nx49, 
      a(13)=>nx51, a(12)=>nx53, a(11)=>nx55, a(10)=>nx57, a(9)=>nx59, a(8)=>
      nx61, a(7)=>nx63, a(6)=>nx65, a(5)=>nx67, a(4)=>nx69, a(3)=>nx71, a(2)
      =>nx73, a(1)=>nx75, a(0)=>nx77, d(15)=>nx78, d(14)=>nx79, d(13)=>nx80, 
      d(12)=>nx81, d(11)=>nx82, d(10)=>nx83, d(9)=>nx84, d(8)=>nx85, d(7)=>
      nx86, d(6)=>nx87, d(5)=>nx88, d(4)=>nx89, d(3)=>nx90, d(2)=>nx91, d(1)
      =>nx92, d(0)=>nx93, cout=>DANGLING(0));
   nx95 <= data(15) when sload = '1' else nx78 ;
   nx97 <= data(14) when sload = '1' else nx79 ;
   nx99 <= data(13) when sload = '1' else nx80 ;
   nx101 <= data(12) when sload = '1' else nx81 ;
   nx103 <= data(11) when sload = '1' else nx82 ;
   nx105 <= data(10) when sload = '1' else nx83 ;
   nx107 <= data(9) when sload = '1' else nx84 ;
   nx109 <= data(8) when sload = '1' else nx85 ;
   nx111 <= data(7) when sload = '1' else nx86 ;
   nx113 <= data(6) when sload = '1' else nx87 ;
   nx115 <= data(5) when sload = '1' else nx88 ;
   nx117 <= data(4) when sload = '1' else nx89 ;
   nx119 <= data(3) when sload = '1' else nx90 ;
   nx121 <= data(2) when sload = '1' else nx91 ;
   nx123 <= data(1) when sload = '1' else nx92 ;
   nx125 <= data(0) when sload = '1' else nx93 ;
   NOT_nx39 <= NOT sclear ;
   nx46 <= nx95 AND NOT_nx39 ;
   nx48 <= nx97 AND NOT_nx39 ;
   nx50 <= nx99 AND NOT_nx39 ;
   nx52 <= nx101 AND NOT_nx39 ;
   nx54 <= nx103 AND NOT_nx39 ;
   nx56 <= nx105 AND NOT_nx39 ;
   nx58 <= nx107 AND NOT_nx39 ;
   nx60 <= nx109 AND NOT_nx39 ;
   nx62 <= nx111 AND NOT_nx39 ;
   nx64 <= nx113 AND NOT_nx39 ;
   nx66 <= nx115 AND NOT_nx39 ;
   nx68 <= nx117 AND NOT_nx39 ;
   nx70 <= nx119 AND NOT_nx39 ;
   nx72 <= nx121 AND NOT_nx39 ;
   nx74 <= nx123 AND NOT_nx39 ;
   nx76 <= nx125 AND NOT_nx39 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_sclear_aclear_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_sclear_aclear_clock_clk_en_0_5 ;

architecture INTERFACE_unfold_1 of counter_up_sclear_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, PWR, NOT_SCLEAR: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_SCLEAR <= NOT sclear ;
   nx15 <= nx25 AND NOT_SCLEAR ;
   nx17 <= nx26 AND NOT_SCLEAR ;
   nx19 <= nx27 AND NOT_SCLEAR ;
   nx21 <= nx28 AND NOT_SCLEAR ;
   nx23 <= nx29 AND NOT_SCLEAR ;
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_updn_cnt_en_sload_aclear_clock_clk_en_0_16 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (15 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (15 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_updn_cnt_en_sload_aclear_clock_clk_en_0_16 ;

architecture INTERFACE of counter_updn_cnt_en_sload_aclear_clock_clk_en_0_16
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_16u_16u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_16u_16u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR316: std_logic_vector (15 DOWNTO 0) ;
   
   signal nx33, nx37, nx40, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, nx61, nx62, 
      nx63, nx64, nx65, nx66, nx67, nx68, nx69, nx70, nx71, nx72, nx73, nx74, 
      nx75, nx76, nx77, nx78, nx79, nx80, nx81, nx82, nx83, nx84, nx85, nx86, 
      nx87, nx88, nx89, nx90, nx92, nx94, nx95, nx96, nx97, nx98, nx99, 
      nx100, nx101, nx102, nx103, nx104, nx105, nx106, nx107, nx108, nx109, 
      nx111, nx113, nx115, nx117, nx119, nx121, nx123, nx125, nx127, nx129, 
      nx131, nx133, nx135, nx137, nx139, nx141: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(15) <= nx44 ;
   q(14) <= nx46 ;
   q(13) <= nx48 ;
   q(12) <= nx50 ;
   q(11) <= nx52 ;
   q(10) <= nx54 ;
   q(9) <= nx56 ;
   q(8) <= nx58 ;
   q(7) <= nx60 ;
   q(6) <= nx62 ;
   q(5) <= nx64 ;
   q(4) <= nx66 ;
   q(3) <= nx68 ;
   q(2) <= nx70 ;
   q(1) <= nx72 ;
   q(0) <= nx74 ;
   nx33 <= '0' ;
   nx37 <= cnt_en OR sload ;
   nx40 <= nx37 AND clk_en ;
   DFFPCE (nx43,nx33,aclear,nx40,clock,nx44) ;
   DFFPCE (nx45,nx33,aclear,nx40,clock,nx46) ;
   DFFPCE (nx47,nx33,aclear,nx40,clock,nx48) ;
   DFFPCE (nx49,nx33,aclear,nx40,clock,nx50) ;
   DFFPCE (nx51,nx33,aclear,nx40,clock,nx52) ;
   DFFPCE (nx53,nx33,aclear,nx40,clock,nx54) ;
   DFFPCE (nx55,nx33,aclear,nx40,clock,nx56) ;
   DFFPCE (nx57,nx33,aclear,nx40,clock,nx58) ;
   DFFPCE (nx59,nx33,aclear,nx40,clock,nx60) ;
   DFFPCE (nx61,nx33,aclear,nx40,clock,nx62) ;
   DFFPCE (nx63,nx33,aclear,nx40,clock,nx64) ;
   DFFPCE (nx65,nx33,aclear,nx40,clock,nx66) ;
   DFFPCE (nx67,nx33,aclear,nx40,clock,nx68) ;
   DFFPCE (nx69,nx33,aclear,nx40,clock,nx70) ;
   DFFPCE (nx71,nx33,aclear,nx40,clock,nx72) ;
   DFFPCE (nx73,nx33,aclear,nx40,clock,nx74) ;
   inc : inc_16u_16u_0_0 port map ( cin=>nx92, a(15)=>nx44, a(14)=>nx46, 
      a(13)=>nx48, a(12)=>nx50, a(11)=>nx52, a(10)=>nx54, a(9)=>nx56, a(8)=>
      nx58, a(7)=>nx60, a(6)=>nx62, a(5)=>nx64, a(4)=>nx66, a(3)=>nx68, a(2)
      =>nx70, a(1)=>nx72, a(0)=>nx74, d(15)=>nx75, d(14)=>nx76, d(13)=>nx77, 
      d(12)=>nx78, d(11)=>nx79, d(10)=>nx80, d(9)=>nx81, d(8)=>nx82, d(7)=>
      nx83, d(6)=>nx84, d(5)=>nx85, d(4)=>nx86, d(3)=>nx87, d(2)=>nx88, d(1)
      =>nx89, d(0)=>nx90, cout=>DANGLING(0));
   nx92 <= '1' ;
   dec : dec_16u_16u_0_0 port map ( cin=>nx33, a(15)=>nx44, a(14)=>nx46, 
      a(13)=>nx48, a(12)=>nx50, a(11)=>nx52, a(10)=>nx54, a(9)=>nx56, a(8)=>
      nx58, a(7)=>nx60, a(6)=>nx62, a(5)=>nx64, a(4)=>nx66, a(3)=>nx68, a(2)
      =>nx70, a(1)=>nx72, a(0)=>nx74, d(15)=>nx94, d(14)=>nx95, d(13)=>nx96, 
      d(12)=>nx97, d(11)=>nx98, d(10)=>nx99, d(9)=>nx100, d(8)=>nx101, d(7)
      =>nx102, d(6)=>nx103, d(5)=>nx104, d(4)=>nx105, d(3)=>nx106, d(2)=>
      nx107, d(1)=>nx108, d(0)=>nx109, cout=>DANGLING(1));
   nx111 <= nx75 when updn = '1' else nx94 ;
   nx113 <= nx76 when updn = '1' else nx95 ;
   nx115 <= nx77 when updn = '1' else nx96 ;
   nx117 <= nx78 when updn = '1' else nx97 ;
   nx119 <= nx79 when updn = '1' else nx98 ;
   nx121 <= nx80 when updn = '1' else nx99 ;
   nx123 <= nx81 when updn = '1' else nx100 ;
   nx125 <= nx82 when updn = '1' else nx101 ;
   nx127 <= nx83 when updn = '1' else nx102 ;
   nx129 <= nx84 when updn = '1' else nx103 ;
   nx131 <= nx85 when updn = '1' else nx104 ;
   nx133 <= nx86 when updn = '1' else nx105 ;
   nx135 <= nx87 when updn = '1' else nx106 ;
   nx137 <= nx88 when updn = '1' else nx107 ;
   nx139 <= nx89 when updn = '1' else nx108 ;
   nx141 <= nx90 when updn = '1' else nx109 ;
   nx43 <= data(15) when sload = '1' else nx111 ;
   nx45 <= data(14) when sload = '1' else nx113 ;
   nx47 <= data(13) when sload = '1' else nx115 ;
   nx49 <= data(12) when sload = '1' else nx117 ;
   nx51 <= data(11) when sload = '1' else nx119 ;
   nx53 <= data(10) when sload = '1' else nx121 ;
   nx55 <= data(9) when sload = '1' else nx123 ;
   nx57 <= data(8) when sload = '1' else nx125 ;
   nx59 <= data(7) when sload = '1' else nx127 ;
   nx61 <= data(6) when sload = '1' else nx129 ;
   nx63 <= data(5) when sload = '1' else nx131 ;
   nx65 <= data(4) when sload = '1' else nx133 ;
   nx67 <= data(3) when sload = '1' else nx135 ;
   nx69 <= data(2) when sload = '1' else nx137 ;
   nx71 <= data(1) when sload = '1' else nx139 ;
   nx73 <= data(0) when sload = '1' else nx141 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_sload_aclear_clock_clk_en_1_15 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (15 DOWNTO 1) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (15 DOWNTO 1) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_sload_aclear_clock_clk_en_1_15 ;

architecture INTERFACE of counter_up_sload_aclear_clock_clk_en_1_15 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_15u_15u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (14 DOWNTO 0) ;
         d : OUT std_logic_vector (14 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR380: std_logic_vector (15 DOWNTO 1) ;
   
   signal nx31, nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, 
      nx45, nx46, nx47, nx48, nx49, nx50, nx51, nx52, nx53, nx54, nx55, nx56, 
      nx57, nx58, nx59, nx60, nx61, nx62, nx63, nx64, nx65, nx66, nx67, nx68, 
      nx69, nx70, nx71, nx72, nx73, nx74, nx75, nx76, nx77, nx78, nx79, nx81
   : std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(15) <= nx36 ;
   q(14) <= nx38 ;
   q(13) <= nx40 ;
   q(12) <= nx42 ;
   q(11) <= nx44 ;
   q(10) <= nx46 ;
   q(9) <= nx48 ;
   q(8) <= nx50 ;
   q(7) <= nx52 ;
   q(6) <= nx54 ;
   q(5) <= nx56 ;
   q(4) <= nx58 ;
   q(3) <= nx60 ;
   q(2) <= nx62 ;
   q(1) <= nx64 ;
   nx31 <= '0' ;
   DFFPCE (nx35,nx31,aclear,clk_en,clock,nx36) ;
   DFFPCE (nx37,nx31,aclear,clk_en,clock,nx38) ;
   DFFPCE (nx39,nx31,aclear,clk_en,clock,nx40) ;
   DFFPCE (nx41,nx31,aclear,clk_en,clock,nx42) ;
   DFFPCE (nx43,nx31,aclear,clk_en,clock,nx44) ;
   DFFPCE (nx45,nx31,aclear,clk_en,clock,nx46) ;
   DFFPCE (nx47,nx31,aclear,clk_en,clock,nx48) ;
   DFFPCE (nx49,nx31,aclear,clk_en,clock,nx50) ;
   DFFPCE (nx51,nx31,aclear,clk_en,clock,nx52) ;
   DFFPCE (nx53,nx31,aclear,clk_en,clock,nx54) ;
   DFFPCE (nx55,nx31,aclear,clk_en,clock,nx56) ;
   DFFPCE (nx57,nx31,aclear,clk_en,clock,nx58) ;
   DFFPCE (nx59,nx31,aclear,clk_en,clock,nx60) ;
   DFFPCE (nx61,nx31,aclear,clk_en,clock,nx62) ;
   DFFPCE (nx63,nx31,aclear,clk_en,clock,nx64) ;
   inc : inc_15u_15u_0_0 port map ( cin=>nx81, a(14)=>nx36, a(13)=>nx38, 
      a(12)=>nx40, a(11)=>nx42, a(10)=>nx44, a(9)=>nx46, a(8)=>nx48, a(7)=>
      nx50, a(6)=>nx52, a(5)=>nx54, a(4)=>nx56, a(3)=>nx58, a(2)=>nx60, a(1)
      =>nx62, a(0)=>nx64, d(14)=>nx65, d(13)=>nx66, d(12)=>nx67, d(11)=>nx68, 
      d(10)=>nx69, d(9)=>nx70, d(8)=>nx71, d(7)=>nx72, d(6)=>nx73, d(5)=>
      nx74, d(4)=>nx75, d(3)=>nx76, d(2)=>nx77, d(1)=>nx78, d(0)=>nx79, cout
      =>DANGLING(0));
   nx81 <= '1' ;
   nx35 <= data(15) when sload = '1' else nx65 ;
   nx37 <= data(14) when sload = '1' else nx66 ;
   nx39 <= data(13) when sload = '1' else nx67 ;
   nx41 <= data(12) when sload = '1' else nx68 ;
   nx43 <= data(11) when sload = '1' else nx69 ;
   nx45 <= data(10) when sload = '1' else nx70 ;
   nx47 <= data(9) when sload = '1' else nx71 ;
   nx49 <= data(8) when sload = '1' else nx72 ;
   nx51 <= data(7) when sload = '1' else nx73 ;
   nx53 <= data(6) when sload = '1' else nx74 ;
   nx55 <= data(5) when sload = '1' else nx75 ;
   nx57 <= data(4) when sload = '1' else nx76 ;
   nx59 <= data(3) when sload = '1' else nx77 ;
   nx61 <= data(2) when sload = '1' else nx78 ;
   nx63 <= data(1) when sload = '1' else nx79 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity 
   rom_4_7_128_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
    is 
   port (
      address : IN std_logic_vector (6 DOWNTO 0) ;
      inclock : IN std_logic ;
      outclock : IN std_logic ;
      outclockena : IN std_logic ;
      q : OUT std_logic_vector (3 DOWNTO 0)) ;
end rom_4_7_128_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
 ;

architecture INTERFACE of 
   rom_4_7_128_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
    is 
   component mux_128u_128u
      port (
         a : IN std_logic_vector (127 DOWNTO 0) ;
         b : IN std_logic_vector (127 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_759 : mux_128u_128u port map ( a(127)=>GND, a(126)=>GND, 
      a(125)=>GND, a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, 
      a(120)=>GND, a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, 
      a(115)=>GND, a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, 
      a(110)=>GND, a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, 
      a(105)=>GND, a(104)=>PWR, a(103)=>GND, a(102)=>GND, a(101)=>GND, 
      a(100)=>GND, a(99)=>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>
      GND, a(94)=>GND, a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)
      =>GND, a(88)=>GND, a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, 
      a(83)=>GND, a(82)=>GND, a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>PWR, 
      a(77)=>GND, a(76)=>GND, a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, 
      a(71)=>GND, a(70)=>GND, a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, 
      a(65)=>GND, a(64)=>GND, a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, 
      a(59)=>GND, a(58)=>GND, a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, 
      a(53)=>GND, a(52)=>GND, a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, 
      a(47)=>GND, a(46)=>GND, a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, 
      a(41)=>GND, a(40)=>GND, a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, 
      a(35)=>GND, a(34)=>GND, a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, 
      a(29)=>GND, a(28)=>GND, a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, 
      a(23)=>GND, a(22)=>GND, a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, 
      a(17)=>GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, 
      a(11)=>GND, a(10)=>GND, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, 
      a(5)=>GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, 
      b(127)=>GND, b(126)=>GND, b(125)=>GND, b(124)=>GND, b(123)=>GND, 
      b(122)=>GND, b(121)=>GND, b(120)=>GND, b(119)=>GND, b(118)=>GND, 
      b(117)=>GND, b(116)=>GND, b(115)=>GND, b(114)=>GND, b(113)=>GND, 
      b(112)=>GND, b(111)=>GND, b(110)=>GND, b(109)=>GND, b(108)=>GND, 
      b(107)=>GND, b(106)=>GND, b(105)=>GND, b(104)=>GND, b(103)=>GND, 
      b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)=>GND, b(98)=>GND, b(97)=>
      GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, b(93)=>GND, b(92)=>GND, b(91)
      =>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, b(87)=>GND, b(86)=>GND, 
      b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, b(81)=>GND, b(80)=>GND, 
      b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, b(75)=>GND, b(74)=>GND, 
      b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, b(69)=>GND, b(68)=>GND, 
      b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, b(63)=>GND, b(62)=>GND, 
      b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, b(57)=>GND, b(56)=>GND, 
      b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, b(51)=>GND, b(50)=>GND, 
      b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, b(45)=>GND, b(44)=>GND, 
      b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, b(39)=>GND, b(38)=>GND, 
      b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, b(33)=>GND, b(32)=>GND, 
      b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, b(27)=>GND, b(26)=>GND, 
      b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, b(21)=>GND, b(20)=>GND, 
      b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, 
      b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, 
      b(7)=>GND, b(6)=>address(6), b(5)=>address(5), b(4)=>address(4), b(3)
      =>address(3), b(2)=>address(2), b(1)=>address(1), b(0)=>address(0), d
      =>q(3));
   modgen_mux_760 : mux_128u_128u port map ( a(127)=>GND, a(126)=>GND, 
      a(125)=>GND, a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, 
      a(120)=>GND, a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, 
      a(115)=>GND, a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, 
      a(110)=>GND, a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, 
      a(105)=>GND, a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, 
      a(100)=>GND, a(99)=>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>
      GND, a(94)=>GND, a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)
      =>GND, a(88)=>PWR, a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, 
      a(83)=>GND, a(82)=>GND, a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, 
      a(77)=>GND, a(76)=>PWR, a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, 
      a(71)=>GND, a(70)=>GND, a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, 
      a(65)=>GND, a(64)=>GND, a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, 
      a(59)=>GND, a(58)=>GND, a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, 
      a(53)=>GND, a(52)=>GND, a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, 
      a(47)=>GND, a(46)=>GND, a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, 
      a(41)=>GND, a(40)=>GND, a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, 
      a(35)=>GND, a(34)=>GND, a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, 
      a(29)=>GND, a(28)=>GND, a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, 
      a(23)=>GND, a(22)=>GND, a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, 
      a(17)=>GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, 
      a(11)=>GND, a(10)=>GND, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, 
      a(5)=>GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, 
      b(127)=>GND, b(126)=>GND, b(125)=>GND, b(124)=>GND, b(123)=>GND, 
      b(122)=>GND, b(121)=>GND, b(120)=>GND, b(119)=>GND, b(118)=>GND, 
      b(117)=>GND, b(116)=>GND, b(115)=>GND, b(114)=>GND, b(113)=>GND, 
      b(112)=>GND, b(111)=>GND, b(110)=>GND, b(109)=>GND, b(108)=>GND, 
      b(107)=>GND, b(106)=>GND, b(105)=>GND, b(104)=>GND, b(103)=>GND, 
      b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)=>GND, b(98)=>GND, b(97)=>
      GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, b(93)=>GND, b(92)=>GND, b(91)
      =>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, b(87)=>GND, b(86)=>GND, 
      b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, b(81)=>GND, b(80)=>GND, 
      b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, b(75)=>GND, b(74)=>GND, 
      b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, b(69)=>GND, b(68)=>GND, 
      b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, b(63)=>GND, b(62)=>GND, 
      b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, b(57)=>GND, b(56)=>GND, 
      b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, b(51)=>GND, b(50)=>GND, 
      b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, b(45)=>GND, b(44)=>GND, 
      b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, b(39)=>GND, b(38)=>GND, 
      b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, b(33)=>GND, b(32)=>GND, 
      b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, b(27)=>GND, b(26)=>GND, 
      b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, b(21)=>GND, b(20)=>GND, 
      b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, 
      b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, 
      b(7)=>GND, b(6)=>address(6), b(5)=>address(5), b(4)=>address(4), b(3)
      =>address(3), b(2)=>address(2), b(1)=>address(1), b(0)=>address(0), d
      =>q(2));
   modgen_mux_761 : mux_128u_128u port map ( a(127)=>GND, a(126)=>GND, 
      a(125)=>GND, a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, 
      a(120)=>GND, a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, 
      a(115)=>GND, a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, 
      a(110)=>GND, a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, 
      a(105)=>GND, a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, 
      a(100)=>GND, a(99)=>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>
      GND, a(94)=>PWR, a(93)=>GND, a(92)=>PWR, a(91)=>GND, a(90)=>PWR, a(89)
      =>GND, a(88)=>GND, a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, 
      a(83)=>GND, a(82)=>GND, a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, 
      a(77)=>GND, a(76)=>GND, a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, 
      a(71)=>GND, a(70)=>GND, a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, 
      a(65)=>GND, a(64)=>GND, a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, 
      a(59)=>GND, a(58)=>GND, a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, 
      a(53)=>GND, a(52)=>GND, a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, 
      a(47)=>GND, a(46)=>GND, a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, 
      a(41)=>GND, a(40)=>GND, a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, 
      a(35)=>GND, a(34)=>GND, a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, 
      a(29)=>GND, a(28)=>GND, a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, 
      a(23)=>GND, a(22)=>GND, a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, 
      a(17)=>GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, 
      a(11)=>GND, a(10)=>GND, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, 
      a(5)=>GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, 
      b(127)=>GND, b(126)=>GND, b(125)=>GND, b(124)=>GND, b(123)=>GND, 
      b(122)=>GND, b(121)=>GND, b(120)=>GND, b(119)=>GND, b(118)=>GND, 
      b(117)=>GND, b(116)=>GND, b(115)=>GND, b(114)=>GND, b(113)=>GND, 
      b(112)=>GND, b(111)=>GND, b(110)=>GND, b(109)=>GND, b(108)=>GND, 
      b(107)=>GND, b(106)=>GND, b(105)=>GND, b(104)=>GND, b(103)=>GND, 
      b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)=>GND, b(98)=>GND, b(97)=>
      GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, b(93)=>GND, b(92)=>GND, b(91)
      =>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, b(87)=>GND, b(86)=>GND, 
      b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, b(81)=>GND, b(80)=>GND, 
      b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, b(75)=>GND, b(74)=>GND, 
      b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, b(69)=>GND, b(68)=>GND, 
      b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, b(63)=>GND, b(62)=>GND, 
      b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, b(57)=>GND, b(56)=>GND, 
      b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, b(51)=>GND, b(50)=>GND, 
      b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, b(45)=>GND, b(44)=>GND, 
      b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, b(39)=>GND, b(38)=>GND, 
      b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, b(33)=>GND, b(32)=>GND, 
      b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, b(27)=>GND, b(26)=>GND, 
      b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, b(21)=>GND, b(20)=>GND, 
      b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, 
      b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, 
      b(7)=>GND, b(6)=>address(6), b(5)=>address(5), b(4)=>address(4), b(3)
      =>address(3), b(2)=>address(2), b(1)=>address(1), b(0)=>address(0), d
      =>q(1));
   modgen_mux_762 : mux_128u_128u port map ( a(127)=>GND, a(126)=>GND, 
      a(125)=>GND, a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, 
      a(120)=>GND, a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, 
      a(115)=>GND, a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, 
      a(110)=>GND, a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>PWR, 
      a(105)=>GND, a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, 
      a(100)=>GND, a(99)=>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>
      GND, a(94)=>GND, a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)
      =>GND, a(88)=>GND, a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, 
      a(83)=>GND, a(82)=>GND, a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, 
      a(77)=>GND, a(76)=>GND, a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, 
      a(71)=>GND, a(70)=>GND, a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>PWR, 
      a(65)=>GND, a(64)=>GND, a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, 
      a(59)=>GND, a(58)=>GND, a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, 
      a(53)=>GND, a(52)=>GND, a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, 
      a(47)=>GND, a(46)=>GND, a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, 
      a(41)=>GND, a(40)=>GND, a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, 
      a(35)=>GND, a(34)=>GND, a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, 
      a(29)=>GND, a(28)=>GND, a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, 
      a(23)=>GND, a(22)=>GND, a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, 
      a(17)=>GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, 
      a(11)=>GND, a(10)=>GND, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, 
      a(5)=>GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, 
      b(127)=>GND, b(126)=>GND, b(125)=>GND, b(124)=>GND, b(123)=>GND, 
      b(122)=>GND, b(121)=>GND, b(120)=>GND, b(119)=>GND, b(118)=>GND, 
      b(117)=>GND, b(116)=>GND, b(115)=>GND, b(114)=>GND, b(113)=>GND, 
      b(112)=>GND, b(111)=>GND, b(110)=>GND, b(109)=>GND, b(108)=>GND, 
      b(107)=>GND, b(106)=>GND, b(105)=>GND, b(104)=>GND, b(103)=>GND, 
      b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)=>GND, b(98)=>GND, b(97)=>
      GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, b(93)=>GND, b(92)=>GND, b(91)
      =>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, b(87)=>GND, b(86)=>GND, 
      b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, b(81)=>GND, b(80)=>GND, 
      b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, b(75)=>GND, b(74)=>GND, 
      b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, b(69)=>GND, b(68)=>GND, 
      b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, b(63)=>GND, b(62)=>GND, 
      b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, b(57)=>GND, b(56)=>GND, 
      b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, b(51)=>GND, b(50)=>GND, 
      b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, b(45)=>GND, b(44)=>GND, 
      b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, b(39)=>GND, b(38)=>GND, 
      b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, b(33)=>GND, b(32)=>GND, 
      b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, b(27)=>GND, b(26)=>GND, 
      b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, b(21)=>GND, b(20)=>GND, 
      b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, 
      b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, 
      b(7)=>GND, b(6)=>address(6), b(5)=>address(5), b(4)=>address(4), b(3)
      =>address(3), b(2)=>address(2), b(1)=>address(1), b(0)=>address(0), d
      =>q(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity 
   rom_new_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   port (
      rd_data1 : OUT std_logic_vector (3 DOWNTO 0) ;
      addr1 : IN std_logic_vector (6 DOWNTO 0) ;
      rd_clk1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      regce1 : IN std_logic ;
      rst1 : IN std_logic) ;
end 
rom_new_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
 ;

architecture INTERFACE of 
   rom_new_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   component 
      rom_4_7_128_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
      port (
         address : IN std_logic_vector (6 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0)) ;
   end component ;
   signal nx15, nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx15 <= '0' ;
   nx17 <= '1' ;
   modgen_rom_ix7675 : 
      rom_4_7_128_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
       port map ( address(6)=>addr1(6), address(5)=>addr1(5), address(4)=>
      addr1(4), address(3)=>addr1(3), address(2)=>addr1(2), address(1)=>
      addr1(1), address(0)=>addr1(0), inclock=>DANGLING(0), outclock=>
      DANGLING(1), outclockena=>DANGLING(2), q(3)=>rd_data1(3), q(2)=>
      rd_data1(2), q(1)=>rd_data1(1), q(0)=>rd_data1(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_7_5_19_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
    is 
   port (
      address : IN std_logic_vector (4 DOWNTO 0) ;
      inclock : IN std_logic ;
      outclock : IN std_logic ;
      outclockena : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0)) ;
end rom_7_5_19_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman ;

architecture INTERFACE of 
   rom_7_5_19_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman is 
   component mux_19u_19u
      port (
         a : IN std_logic_vector (18 DOWNTO 0) ;
         b : IN std_logic_vector (18 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_763 : mux_19u_19u port map ( a(18)=>GND, a(17)=>PWR, a(16)=>
      GND, a(15)=>GND, a(14)=>GND, a(13)=>PWR, a(12)=>GND, a(11)=>PWR, a(10)
      =>GND, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>PWR, a(5)=>PWR, a(4)=>
      PWR, a(3)=>PWR, a(2)=>PWR, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(6));
   modgen_mux_764 : mux_19u_19u port map ( a(18)=>PWR, a(17)=>GND, a(16)=>
      PWR, a(15)=>PWR, a(14)=>PWR, a(13)=>GND, a(12)=>PWR, a(11)=>GND, a(10)
      =>PWR, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>PWR, a(5)=>GND, a(4)=>
      PWR, a(3)=>PWR, a(2)=>GND, a(1)=>PWR, a(0)=>PWR, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(5));
   modgen_mux_765 : mux_19u_19u port map ( a(18)=>GND, a(17)=>GND, a(16)=>
      PWR, a(15)=>PWR, a(14)=>GND, a(13)=>PWR, a(12)=>GND, a(11)=>GND, a(10)
      =>GND, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, a(5)=>PWR, a(4)=>
      GND, a(3)=>PWR, a(2)=>PWR, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(4));
   modgen_mux_766 : mux_19u_19u port map ( a(18)=>GND, a(17)=>PWR, a(16)=>
      GND, a(15)=>GND, a(14)=>PWR, a(13)=>GND, a(12)=>PWR, a(11)=>PWR, a(10)
      =>GND, a(9)=>GND, a(8)=>PWR, a(7)=>PWR, a(6)=>GND, a(5)=>GND, a(4)=>
      PWR, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(3));
   modgen_mux_767 : mux_19u_19u port map ( a(18)=>GND, a(17)=>GND, a(16)=>
      GND, a(15)=>PWR, a(14)=>PWR, a(13)=>PWR, a(12)=>PWR, a(11)=>GND, a(10)
      =>GND, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>GND, a(5)=>PWR, a(4)=>
      PWR, a(3)=>PWR, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(2));
   modgen_mux_768 : mux_19u_19u port map ( a(18)=>GND, a(17)=>GND, a(16)=>
      PWR, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)=>GND, a(10)
      =>GND, a(9)=>PWR, a(8)=>GND, a(7)=>PWR, a(6)=>PWR, a(5)=>GND, a(4)=>
      GND, a(3)=>GND, a(2)=>PWR, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(1));
   modgen_mux_769 : mux_19u_19u port map ( a(18)=>GND, a(17)=>PWR, a(16)=>
      PWR, a(15)=>PWR, a(14)=>PWR, a(13)=>GND, a(12)=>PWR, a(11)=>PWR, a(10)
      =>GND, a(9)=>PWR, a(8)=>GND, a(7)=>GND, a(6)=>PWR, a(5)=>GND, a(4)=>
      GND, a(3)=>GND, a(2)=>PWR, a(1)=>GND, a(0)=>GND, b(18)=>GND, b(17)=>
      GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)
      =>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>
      GND, b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), b(1)=>
      address(1), b(0)=>address(0), d=>q(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity 
   rom_new_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   port (
      rd_data1 : OUT std_logic_vector (6 DOWNTO 0) ;
      addr1 : IN std_logic_vector (4 DOWNTO 0) ;
      rd_clk1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      regce1 : IN std_logic ;
      rst1 : IN std_logic) ;
end 
rom_new_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
 ;

architecture INTERFACE of 
   rom_new_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   component 
      rom_7_5_19_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
      port (
         address : IN std_logic_vector (4 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0)) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   signal nx16, nx18, dup_0_Do_once_4, dup_0_Do_once_3, dup_0_Do_once_2, 
      dup_0_Do_once_1, dup_0_Do_once_0: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx16 <= '0' ;
   nx18 <= '1' ;
   modgen_rom_ix7676 : 
      rom_7_5_19_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
       port map ( address(4)=>dup_0_Do_once_4, address(3)=>dup_0_Do_once_3, 
      address(2)=>dup_0_Do_once_2, address(1)=>dup_0_Do_once_1, address(0)=>
      dup_0_Do_once_0, inclock=>DANGLING(0), outclock=>DANGLING(1), 
      outclockena=>DANGLING(2), q(6)=>rd_data1(6), q(5)=>rd_data1(5), q(4)=>
      rd_data1(4), q(3)=>rd_data1(3), q(2)=>rd_data1(2), q(1)=>rd_data1(1), 
      q(0)=>rd_data1(0));
   DFFPCE (addr1(4),nx16,rst1,rd_ena1,rd_clk1,dup_0_Do_once_4) ;
   DFFPCE (addr1(3),nx16,rst1,rd_ena1,rd_clk1,dup_0_Do_once_3) ;
   DFFPCE (addr1(2),nx16,rst1,rd_ena1,rd_clk1,dup_0_Do_once_2) ;
   DFFPCE (addr1(1),nx16,rst1,rd_ena1,rd_clk1,dup_0_Do_once_1) ;
   DFFPCE (addr1(0),nx16,rst1,rd_ena1,rd_clk1,dup_0_Do_once_0) ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_7_5_20_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
    is 
   port (
      address : IN std_logic_vector (4 DOWNTO 0) ;
      inclock : IN std_logic ;
      outclock : IN std_logic ;
      outclockena : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0)) ;
end rom_7_5_20_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman ;

architecture INTERFACE of 
   rom_7_5_20_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman is 
   component mux_20u_20u
      port (
         a : IN std_logic_vector (19 DOWNTO 0) ;
         b : IN std_logic_vector (19 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_770 : mux_20u_20u port map ( a(19)=>GND, a(18)=>PWR, a(17)=>
      GND, a(16)=>GND, a(15)=>GND, a(14)=>PWR, a(13)=>PWR, a(12)=>PWR, a(11)
      =>PWR, a(10)=>PWR, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>PWR, a(5)=>
      GND, a(4)=>PWR, a(3)=>PWR, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(6));
   modgen_mux_771 : mux_20u_20u port map ( a(19)=>PWR, a(18)=>GND, a(17)=>
      PWR, a(16)=>PWR, a(15)=>PWR, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)
      =>GND, a(10)=>PWR, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>PWR, a(5)=>
      PWR, a(4)=>PWR, a(3)=>PWR, a(2)=>PWR, a(1)=>PWR, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(5));
   modgen_mux_772 : mux_20u_20u port map ( a(19)=>GND, a(18)=>PWR, a(17)=>
      GND, a(16)=>PWR, a(15)=>PWR, a(14)=>GND, a(13)=>PWR, a(12)=>GND, a(11)
      =>GND, a(10)=>PWR, a(9)=>GND, a(8)=>GND, a(7)=>GND, a(6)=>GND, a(5)=>
      GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(4));
   modgen_mux_773 : mux_20u_20u port map ( a(19)=>GND, a(18)=>GND, a(17)=>
      GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>PWR, a(11)
      =>PWR, a(10)=>PWR, a(9)=>PWR, a(8)=>PWR, a(7)=>PWR, a(6)=>GND, a(5)=>
      GND, a(4)=>GND, a(3)=>PWR, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(3));
   modgen_mux_774 : mux_20u_20u port map ( a(19)=>GND, a(18)=>GND, a(17)=>
      GND, a(16)=>PWR, a(15)=>GND, a(14)=>PWR, a(13)=>GND, a(12)=>PWR, a(11)
      =>PWR, a(10)=>GND, a(9)=>PWR, a(8)=>PWR, a(7)=>GND, a(6)=>PWR, a(5)=>
      GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(2));
   modgen_mux_775 : mux_20u_20u port map ( a(19)=>GND, a(18)=>GND, a(17)=>
      GND, a(16)=>GND, a(15)=>GND, a(14)=>GND, a(13)=>PWR, a(12)=>GND, a(11)
      =>GND, a(10)=>GND, a(9)=>PWR, a(8)=>PWR, a(7)=>GND, a(6)=>GND, a(5)=>
      GND, a(4)=>GND, a(3)=>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(1));
   modgen_mux_776 : mux_20u_20u port map ( a(19)=>GND, a(18)=>GND, a(17)=>
      GND, a(16)=>PWR, a(15)=>PWR, a(14)=>GND, a(13)=>PWR, a(12)=>GND, a(11)
      =>PWR, a(10)=>PWR, a(9)=>PWR, a(8)=>PWR, a(7)=>GND, a(6)=>PWR, a(5)=>
      GND, a(4)=>PWR, a(3)=>PWR, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(19)=>GND, 
      b(18)=>GND, b(17)=>GND, b(16)=>GND, b(15)=>GND, b(14)=>GND, b(13)=>GND, 
      b(12)=>GND, b(11)=>GND, b(10)=>GND, b(9)=>GND, b(8)=>GND, b(7)=>GND, 
      b(6)=>GND, b(5)=>GND, b(4)=>address(4), b(3)=>address(3), b(2)=>
      address(2), b(1)=>address(1), b(0)=>address(0), d=>q(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity 
   rom_new_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   port (
      rd_data1 : OUT std_logic_vector (6 DOWNTO 0) ;
      addr1 : IN std_logic_vector (4 DOWNTO 0) ;
      rd_clk1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      regce1 : IN std_logic ;
      rst1 : IN std_logic) ;
end 
rom_new_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
 ;

architecture INTERFACE of 
   rom_new_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
    is 
   component 
      rom_7_5_20_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
      port (
         address : IN std_logic_vector (4 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0)) ;
   end component ;
   signal nx16, nx18: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx16 <= '0' ;
   nx18 <= '1' ;
   modgen_rom_ix7677 : 
      rom_7_5_20_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman
       port map ( address(4)=>addr1(4), address(3)=>addr1(3), address(2)=>
      addr1(2), address(1)=>addr1(1), address(0)=>addr1(0), inclock=>
      DANGLING(0), outclock=>DANGLING(1), outclockena=>DANGLING(2), q(6)=>
      rd_data1(6), q(5)=>rd_data1(5), q(4)=>rd_data1(4), q(3)=>rd_data1(3), 
      q(2)=>rd_data1(2), q(1)=>rd_data1(1), q(0)=>rd_data1(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity selcounter_9_9_9_0_1_up is 
   port (
      cin : IN std_logic ;
      mode : IN std_logic ;
      updn : IN std_logic ;
      a : IN std_logic_vector (8 DOWNTO 0) ;
      k : IN std_logic_vector (8 DOWNTO 0) ;
      d : OUT std_logic_vector (8 DOWNTO 0)) ;
end selcounter_9_9_9_0_1_up ;

architecture INTERFACE of selcounter_9_9_9_0_1_up is 
   component inc_9u_9u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic_vector (8 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal nx30, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx41, 
      nx43, nx45, nx47, nx49, nx51, nx53, nx55, nx57, nx69, nx70, nx72: 
   std_logic ;

begin
   nx39 <= k(8) when mode = '1' else a(8) ;
   nx41 <= k(7) when mode = '1' else a(7) ;
   nx43 <= k(6) when mode = '1' else a(6) ;
   nx45 <= k(5) when mode = '1' else a(5) ;
   nx47 <= k(4) when mode = '1' else a(4) ;
   nx49 <= k(3) when mode = '1' else a(3) ;
   nx51 <= k(2) when mode = '1' else a(2) ;
   nx53 <= k(1) when mode = '1' else a(1) ;
   nx55 <= k(0) when mode = '1' else a(0) ;
   modgen_inc_128 : inc_9u_9u_0 port map ( cin=>nx72, a(8)=>nx39, a(7)=>nx41, 
      a(6)=>nx43, a(5)=>nx45, a(4)=>nx47, a(3)=>nx49, a(2)=>nx51, a(1)=>nx53, 
      a(0)=>nx55, d=>d, cout=>nx69);
   nx70 <= '0' ;
   nx72 <= nx70 when mode = '1' else cin ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1 is 
   port (
      Ack : IN std_logic ;
      Address : IN std_logic_vector (15 DOWNTO 0) ;
      Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
      BC_1553A_ME : IN std_logic ;
      BC_Command_Sync : IN std_logic ;
      BC_Coupling_error : IN std_logic ;
      BC_DISABLE : IN std_logic ;
      BC_Echo : IN std_logic ;
      BC_FE_All_Errors : IN std_logic ;
      BC_FE_Logic_error : IN std_logic ;
      BC_Found_Format_Error : IN std_logic ;
      BC_Found_wrong_RT_Address : IN std_logic ;
      BC_Found_wrong_word_count : IN std_logic ;
      BC_Loopback_error : IN std_logic ;
      BC_Message_Active : IN std_logic ;
      BC_Read : IN std_logic ;
      BC_Response_timeout_Error : IN std_logic ;
      BC_Rx_Data : IN std_logic_vector (15 DOWNTO 0) ;
      BC_Write : IN std_logic ;
      BC_wrong_sync : IN std_logic ;
      BE_Revision : IN std_logic_vector (15 DOWNTO 0) ;
      CE : IN std_logic ;
      CPU_Address : IN std_logic_vector (15 DOWNTO 0) ;
      CPU_CS : IN std_logic ;
      CPU_Data_in_wide : IN std_logic_vector (31 DOWNTO 0) ;
      CPU_RE_vec : IN std_logic_vector (1 DOWNTO 0) ;
      CPU_WE_vec : IN std_logic_vector (1 DOWNTO 0) ;
      Channel_Status : IN std_logic_vector (10 DOWNTO 0) ;
      Constants_readback : IN std_logic_vector (15 DOWNTO 0) ;
      Current_command : IN std_logic_vector (15 DOWNTO 0) ;
      Data_From_FE : IN std_logic_vector (15 DOWNTO 0) ;
      Data_o_temp : IN std_logic_vector (15 DOWNTO 0) ;
      Ext_Trigger : IN std_logic ;
      Goldenberg : IN std_logic ;
      Good_data_block_recieved : IN std_logic ;
      Handshake_Error : IN std_logic ;
      M1760 : IN std_logic ;
      MEM_Data_out_wide : IN std_logic_vector (31 DOWNTO 0) ;
      MEM_nREG : IN std_logic ;
      MIL1553_errors_Inhibit_TF : IN std_logic ;
      MIL1553_errors_invalid_command : IN std_logic ;
      MIL1553_errors_RT2RT_format_gap : IN std_logic ;
      MIL1553_errors_RT2RT_format_error : IN std_logic ;
      MIL1553_errors_Invalid_word : IN std_logic ;
      MIL1553_errors_Parity_Manchester : IN std_logic ;
      MIL1553_errors_incorrect_data_sync : IN std_logic ;
      MIL1553_errors_Low_word_count : IN std_logic ;
      MIL1553_errors_high_word_count : IN std_logic ;
      MIL1553_errors_Format_error : IN std_logic ;
      MIL1553_errors_Message_Error_set : IN std_logic ;
      MIL1553_errors_Address_Parity : IN std_logic ;
      MIL1553_errors_echo_back_bus_B : IN std_logic ;
      MIL1553_errors_echo_back_bus_A : IN std_logic ;
      MIL1553_errors_bus_B_shutdown : IN std_logic ;
      MIL1553_errors_bus_A_shutdown : IN std_logic ;
      MIL1553_errors_transmitter_timout : IN std_logic ;
      Message_ended_OK : IN std_logic ;
      Message_ended_not_OK : IN std_logic ;
      Monitor_Active_command : IN std_logic_vector (15 DOWNTO 0) ;
      Monitor_Ended_not_OK : IN std_logic ;
      Monitor_MIL1553_errors_Inhibit_TF : IN std_logic ;
      Monitor_MIL1553_errors_invalid_command : IN std_logic ;
      Monitor_MIL1553_errors_RT2RT_format_gap : IN std_logic ;
      Monitor_MIL1553_errors_RT2RT_format_error : IN std_logic ;
      Monitor_MIL1553_errors_Invalid_word : IN std_logic ;
      Monitor_MIL1553_errors_Parity_Manchester : IN std_logic ;
      Monitor_MIL1553_errors_incorrect_data_sync : IN std_logic ;
      Monitor_MIL1553_errors_Low_word_count : IN std_logic ;
      Monitor_MIL1553_errors_high_word_count : IN std_logic ;
      Monitor_MIL1553_errors_Format_error : IN std_logic ;
      Monitor_MIL1553_errors_Message_Error_set : IN std_logic ;
      Monitor_MIL1553_errors_Address_Parity : IN std_logic ;
      Monitor_MIL1553_errors_echo_back_bus_B : IN std_logic ;
      Monitor_MIL1553_errors_echo_back_bus_A : IN std_logic ;
      Monitor_MIL1553_errors_bus_B_shutdown : IN std_logic ;
      Monitor_MIL1553_errors_bus_A_shutdown : IN std_logic ;
      Monitor_MIL1553_errors_transmitter_timout : IN std_logic ;
      Monitor_RT2RT_Message : IN std_logic ;
      Monitor_bus_a : IN std_logic ;
      Monitor_ended_OK : IN std_logic ;
      Monitor_new_command : IN std_logic ;
      Monitor_write : IN std_logic ;
      Monitor_write_data : IN std_logic_vector (15 DOWNTO 0) ;
      New_command : IN std_logic ;
      RT2RT_Message : IN std_logic ;
      RTAD : IN std_logic_vector (4 DOWNTO 0) ;
      RTADP : IN std_logic ;
      RTAD_SW_EN : IN std_logic ;
      RT_ADR_LAT : IN std_logic ;
      Raw_resetN : IN std_logic ;
      Read : IN std_logic ;
      Set_SSFLAG : IN std_logic ;
      Strobe_TT : IN std_logic ;
      Tag_CLK : IN std_logic ;
      Tails_data_out_wide : IN std_logic_vector (31 DOWNTO 0) ;
      Tx_InhB : IN std_logic ;
      Tx_inhA : IN std_logic ;
      WM_Descriptor : IN std_logic_vector (15 DOWNTO 0) ;
      WM_Req : IN std_logic ;
      WM_Word : IN std_logic_vector (15 DOWNTO 0) ;
      Write : IN std_logic ;
      bus_A : IN std_logic ;
      clock : IN std_logic ;
      last_command : IN std_logic_vector (15 DOWNTO 0) ;
      pTDR_INT : IN std_logic ;
      ADDr_i_A : OUT std_logic_vector (15 DOWNTO 0) ;
      BC_FE_ResetN : OUT std_logic ;
      BC_RT2RT : OUT std_logic ;
      BC_Test : OUT std_logic ;
      BIT_Word : OUT std_logic_vector (15 DOWNTO 0) ;
      BUSY_in_LUT : OUT std_logic ;
      CPU_Data_out_wide : OUT std_logic_vector (31 DOWNTO 0) ;
      Data_i_A : OUT std_logic_vector (15 DOWNTO 0) ;
      ENC_TEST_GO : OUT std_logic ;
      ENC_TEST_on : OUT std_logic ;
      INTn : OUT std_logic ;
      IP_Freq_sel : OUT std_logic_vector (1 DOWNTO 0) ;
      No_Response_timeout : OUT std_logic_vector (2 DOWNTO 0) ;
      RE_A : OUT std_logic ;
      TT_Load : OUT std_logic ;
      Tails_WE_vec : OUT std_logic_vector (1 DOWNTO 0) ;
      WE_A : OUT std_logic ;
      debug : OUT std_logic_vector (15 DOWNTO 0) ;
      mem_WE_vec : OUT std_logic_vector (1 DOWNTO 0) ;
      n16Mhz_12 : OUT std_logic ;
      one_micro_increment : OUT std_logic ;
      pTDR_CS : OUT std_logic ;
      record_message_A : OUT std_logic ;
      record_message_B : OUT std_logic ;
      BC_1553A : OUT std_logic ;
      BC_BUS_A : OUT std_logic ;
      BC_Go : OUT std_logic ;
      BC_TX_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      BC_on : OUT std_logic ;
      Config_reg_4 : OUT std_logic_vector (15 DOWNTO 0) ;
      Data_to_FE : OUT std_logic_vector (15 DOWNTO 0) ;
      Do_illegal : OUT std_logic ;
      MODE_CODE1553A : OUT std_logic ;
      NO_BCST : OUT std_logic ;
      RT_Address : OUT std_logic_vector (5 DOWNTO 0) ;
      RT_On : OUT std_logic ;
      ResetN : OUT std_logic ;
      WM_Ack : OUT std_logic ;
      WM_Started : OUT std_logic ;
      host_status_bits : OUT std_logic_vector (10 DOWNTO 0) ;
      illegal_message : OUT std_logic ;
      time_tag : OUT std_logic_vector (15 DOWNTO 0)) ;
end DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1 ;

architecture Sital_Ofer_hofman_unfold_3298 of 
   DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1 is 
   component RAM2_5_16_1
      port (
         D : IN std_logic_vector (15 DOWNTO 0) ;
         A : IN std_logic_vector (4 DOWNTO 0) ;
         WE : IN std_logic ;
         Q : OUT std_logic_vector (15 DOWNTO 0) ;
         Clock : IN std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_5_5
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component mux_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component dec_16u_16u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component or_11u_11u
      port (
         a : IN std_logic_vector (10 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_13u_13u
      port (
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_8u_8u
      port (
         a : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_18u_18u
      port (
         a : IN std_logic_vector (17 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_12u_12u
      port (
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_15u_15u
      port (
         a : IN std_logic_vector (14 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_17u_17u
      port (
         a : IN std_logic_vector (16 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_10u_10u
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_25u_25u
      port (
         a : IN std_logic_vector (24 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_16u_16u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component addsub_16u_16u_16u_0
      port (
         mode : IN std_logic ;
         cin : IN std_logic ;
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic_vector (15 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component gt_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_16_16
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_12_12
      port (
         a : IN std_logic_vector (11 DOWNTO 0) ;
         b : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_13_13
      port (
         a : IN std_logic_vector (12 DOWNTO 0) ;
         b : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_14_14
      port (
         a : IN std_logic_vector (13 DOWNTO 0) ;
         b : IN std_logic_vector (13 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_15_15
      port (
         a : IN std_logic_vector (14 DOWNTO 0) ;
         b : IN std_logic_vector (14 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component mux_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_6_6
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_7_7
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         b : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_9_9
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         b : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_10_10
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         b : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_11_11
      port (
         a : IN std_logic_vector (10 DOWNTO 0) ;
         b : IN std_logic_vector (10 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component mux_8u_8u
      port (
         a : IN std_logic_vector (7 DOWNTO 0) ;
         b : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_8u_8u
      port (
         a : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_44u_44u
      port (
         a : IN std_logic_vector (43 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_12u_12u
      port (
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_11u_11u
      port (
         a : IN std_logic_vector (10 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_12u_12u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic_vector (11 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (15 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (15 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_12
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (11 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (11 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component inc_15u_15u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (14 DOWNTO 0) ;
         d : OUT std_logic_vector (14 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_14u_14u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (13 DOWNTO 0) ;
         d : OUT std_logic_vector (13 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component eq_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component eq_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFRSE (
      constant data   : in std_logic;
      constant set    : in std_logic;
      constant reset  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (clk'event and clk'last_value = '0' and clk = '1') then
           if (reset = '1') then
               q <= '0' ;
           elsif (set = '1') then
               q <= '1' ;
           elsif (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((set/='1' or reset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFRSE ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_2_2
      port (
         a : IN std_logic_vector (1 DOWNTO 0) ;
         b : IN std_logic_vector (1 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_updn_cnt_en_sload_aclear_clock_clk_en_0_16
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (15 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (15 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_sload_aclear_clock_clk_en_1_15
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (15 DOWNTO 1) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (15 DOWNTO 1) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component 
      rom_new_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
      port (
         rd_data1 : OUT std_logic_vector (3 DOWNTO 0) ;
         addr1 : IN std_logic_vector (6 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component 
      rom_new_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
      port (
         rd_data1 : OUT std_logic_vector (6 DOWNTO 0) ;
         addr1 : IN std_logic_vector (4 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component 
      rom_new_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
      port (
         rd_data1 : OUT std_logic_vector (6 DOWNTO 0) ;
         addr1 : IN std_logic_vector (4 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component and_17u_17u
      port (
         a : IN std_logic_vector (16 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_28u_28u
      port (
         a : IN std_logic_vector (27 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_13u_13u
      port (
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component selcounter_9_9_9_0_1_up
      port (
         cin : IN std_logic ;
         mode : IN std_logic ;
         updn : IN std_logic ;
         a : IN std_logic_vector (8 DOWNTO 0) ;
         k : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic_vector (8 DOWNTO 0)) ;
   end component ;
   for modgen_counter_INTn_count : 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE_unfold_1
   );
   for modgen_counter_Timeout_counter : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7(INTERFACE_unfold_1);
   
   for modgen_counter_Micro_second_counter : 
   counter_dn_sload_aclear_clock_clk_en_0_5 use entity work.
   counter_dn_sload_aclear_clock_clk_en_0_5(INTERFACE_unfold_3);
   for modgen_counter_BC_GAP_to_next_msg_counter : 
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 use entity work.
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16(
   INTERFACE_unfold_1);
   for modgen_counter_BC_frame_GAP_counter : 
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 use entity work.
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16(INTERFACE);
   for modgen_counter_count_1us : counter_up_sclear_aclear_clock_clk_en_0_5
    use entity work.counter_up_sclear_aclear_clock_clk_en_0_5(
   INTERFACE_unfold_1);
   signal BC_RT2RT_EXMPLR781, BC_Test_EXMPLR782: std_logic ;
   
   signal IP_Freq_sel_EXMPLR994: std_logic_vector (1 DOWNTO 0) ;
   
   signal n16Mhz_12_EXMPLR860, BC_1553A_EXMPLR864, BC_BUS_A_EXMPLR865, 
      BC_Go_EXMPLR866, BC_TX_Data_10_EXMPLR872, BC_TX_Data_9_EXMPLR873, 
      BC_TX_Data_8_EXMPLR874, BC_TX_Data_7_EXMPLR875, BC_TX_Data_6_EXMPLR876, 
      BC_TX_Data_5_EXMPLR877, BC_TX_Data_4_EXMPLR878, BC_TX_Data_3_EXMPLR879, 
      BC_TX_Data_2_EXMPLR880, BC_TX_Data_1_EXMPLR881, BC_TX_Data_0_EXMPLR882, 
      BC_on_EXMPLR883: std_logic ;
   
   signal Config_reg_4_EXMPLR998: std_logic_vector (15 DOWNTO 0) ;
   
   signal Data_to_FE_EXMPLR999: std_logic_vector (15 DOWNTO 0) ;
   
   signal Do_illegal_EXMPLR916, MODE_CODE1553A_EXMPLR917: std_logic ;
   
   signal RT_Address_EXMPLR1000: std_logic_vector (5 DOWNTO 0) ;
   
   signal RT_On_EXMPLR924, ResetN_EXMPLR925, WM_Ack_EXMPLR926, 
      WM_Started_EXMPLR927, host_status_bits_3_EXMPLR935, 
      illegal_message_EXMPLR939: std_logic ;
   
   signal time_tag_EXMPLR1002: std_logic_vector (15 DOWNTO 0) ;
   
   signal Arbiter_timeout, BCR, BC_Control_word_15, BC_Control_word_14, 
      BC_Control_word_13, BC_Control_word_12, BC_Control_word_11, 
      BC_Control_word_10, BC_Control_word_9, BC_Control_word_8, 
      BC_Control_word_7: std_logic ;
   
   signal debug_EXMPLR1003: std_logic_vector (15 DOWNTO 15) ;
   
   signal BC_Control_word_5, BC_Control_word_4, BC_Control_word_2, 
      BC_Control_word_1, BC_EOF, BC_EOM: std_logic ;
   
   signal BC_Echo_word: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_First_write, BC_Frame_active_part: std_logic ;
   
   signal BC_GAP_to_next_msg_counter: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_IDLE, BC_Load_frame_gap_counter, BC_Load_msg_gap_counter: 
   std_logic ;
   
   signal BC_Num_Msgs: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_OFF: std_logic ;
   
   signal BC_Ram_Address: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Ram_RE, BC_Ram_WE: std_logic ;
   
   signal BC_Ram_data: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Retry_pulse, BC_SP, BC_SP_D, BC_START, BC_STS_Word_12_d: 
   std_logic ;
   
   signal BC_Stack_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Started, BC_Stop_EOF, BC_Stop_EOM: std_logic ;
   
   signal BC_Sts_Word: std_logic_vector (13 DOWNTO 0) ;
   
   signal BC_frame_GAP_counter: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_msg_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_reported_errors: std_logic ;
   
   signal BC_word_number: std_logic_vector (1 DOWNTO 0) ;
   
   signal BIT_Test_complete, Clean_ISR1_by_write, Clean_ISR2_by_write, 
      Clean_status2_bits, Clean_status_bits, Clear_Intn_level, 
      Clear_Stop_EOF, Clear_Stop_EOM, Clear_Test_Status_reg: std_logic ;
   
   signal Config_reg_1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Config_reg_2: std_logic_vector (15 DOWNTO 0) ;
   
   signal Config_reg_3_15, Config_reg_3_14, Config_reg_3_13, Config_reg_3_12, 
      Config_reg_3_11, Config_reg_3_10, Config_reg_3_9, Config_reg_3_8, 
      Config_reg_3_7, Config_reg_3_6, Config_reg_3_5, Config_reg_3_4, 
      Config_reg_3_3, Config_reg_3_2, Config_reg_3_0: std_logic ;
   
   signal Config_reg_5: std_logic_vector (14 DOWNTO 0) ;
   
   signal Config_reg_6_15, Config_reg_6_14, Config_reg_6_13, Config_reg_6_12, 
      Config_reg_6_11, Config_reg_6_10, Config_reg_6_9, Config_reg_6_8, 
      Config_reg_6_7, Config_reg_6_6, Config_reg_6_5, Config_reg_6_4, 
      Config_reg_6_3, Config_reg_6_2: std_logic ;
   
   signal Counter_100us: std_logic_vector (11 DOWNTO 0) ;
   
   signal Current_Area_B, Current_command_is_sync_with_data, 
      Current_command_is_sync_without_data: std_logic ;
   
   signal Data_Pointer_register: std_logic_vector (15 DOWNTO 0) ;
   
   signal Data_Rollover, Do_Protocol_test, Do_RAM_test: std_logic ;
   
   signal Dummy_register_0x4: std_logic_vector (15 DOWNTO 0) ;
   
   signal EOM_phase_go, EOM_req, Enhanced_status_set_dt, Ext_Trigger_D, 
      Ext_Trigger_DD, Ext_Trigger_Dx, First_After_Reset, First_Thing, 
      First_time: std_logic ;
   
   signal Frame_length_reg_0xD: std_logic_vector (15 DOWNTO 0) ;
   
   signal GMM: std_logic_vector (2 DOWNTO 0) ;
   
   signal HW_ResetN: std_logic ;
   
   signal INTn_count: std_logic_vector (4 DOWNTO 0) ;
   
   signal INTn_level, INTn_level_D, INTn_pulse, ISR1_during_clear_13, 
      ISR1_during_clear_12, ISR1_during_clear_11, ISR1_during_clear_10, 
      ISR1_during_clear_8, ISR1_during_clear_6, ISR1_during_clear_5, 
      ISR1_during_clear_4, ISR1_during_clear_3, ISR1_during_clear_2, 
      ISR1_during_clear_1, ISR1_during_clear_0, ISR2_during_clear_14, 
      ISR2_during_clear_12, ISR2_during_clear_11, ISR2_during_clear_10, 
      ISR2_during_clear_7, ISR2_during_clear_6, ISR2_during_clear_5, 
      ISR2_during_clear_4, ISR2_during_clear_3, ISR2_during_clear_1, 
      Int1_Chain, Internal_BIT_Word_15, Internal_BIT_Word_14, 
      Internal_BIT_Word_13, Internal_BIT_Word_11, Internal_BIT_Word_10, 
      Internal_BIT_Word_9: std_logic ;
   
   signal Interrupt_mask_register_1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Interrupt_mask_register_2: std_logic_vector (15 DOWNTO 0) ;
   
   signal Interrupt_status_register_1: std_logic_vector (14 DOWNTO 0) ;
   
   signal Interrupt_status_register_2_15, Interrupt_status_register_2_14, 
      Interrupt_status_register_2_12, Interrupt_status_register_2_11, 
      Interrupt_status_register_2_10, Interrupt_status_register_2_7, 
      Interrupt_status_register_2_6, Interrupt_status_register_2_5, 
      Interrupt_status_register_2_4, Interrupt_status_register_2_3, 
      Interrupt_status_register_2_2, Interrupt_status_register_2_1, 
      Interrupt_status_register_2_0, Ksts: std_logic ;
   
   signal LIFO_Pointer: std_logic_vector (4 DOWNTO 0) ;
   
   signal LUT_Control: std_logic_vector (15 DOWNTO 0) ;
   
   signal Latched_Monitor_data_stack_rollover, Latched_Monitor_ended_OK: 
   std_logic ;
   
   signal Latched_TT: std_logic_vector (15 DOWNTO 0) ;
   
   signal M1760_D: std_logic ;
   
   signal MM: std_logic_vector (2 DOWNTO 0) ;
   
   signal MM_Error_detected, MON_EOM_phase_go, MON_EOM_req, MON_SOM_phase_go, 
      MON_SOM_req, MON_WR_req, MON_phase_go, MT_On, MT_On_Async, M_W, 
      Message_failed: std_logic ;
   
   signal Micro_second_counter: std_logic_vector (4 DOWNTO 0) ;
   
   signal Monitor_command_is_sync_with_data, 
      Monitor_command_is_sync_without_data, Monitor_command_stack_half_pass, 
      Monitor_command_stack_rollover, Monitor_data_stack_half_pass, 
      Monitor_data_stack_rollover, NO, New_command_record, Non_masked_Event, 
      Non_masked_Event_D, Once, PrimeCheck, RETRY_ON_1553A: std_logic ;
   
   signal Ram_Address: std_logic_vector (15 DOWNTO 0) ;
   
   signal Ram_RE, Ram_WE: std_logic ;
   
   signal Ram_data_i: std_logic_vector (15 DOWNTO 0) ;
   
   signal ReTry_count: std_logic_vector (1 DOWNTO 0) ;
   
   signal Read_from_int_vec, Read_from_int_vec2, Record_enable, 
      Rollover_Int_Enable, SOM_phase_go, SOM_req, STM_ended, SW_Reset, 
      Stack_rollover_interrupt: std_logic ;
   
   signal Strobe_TT_D: std_logic_vector (1 DOWNTO 0) ;
   
   signal Sync_with_Data, Tag_CLK_D, Tag_CLK_DD, Test_Status_reg_15, 
      Test_Status_reg_14, Test_Status_reg_11, Test_Status_reg_7, 
      Test_Status_reg_6: std_logic ;
   
   signal Timeout_counter: std_logic_vector (6 DOWNTO 0) ;
   
   signal Tx_Timeout_D: std_logic ;
   
   signal VARAM_ADD: std_logic_vector (4 DOWNTO 0) ;
   
   signal VARAM_D: std_logic_vector (15 DOWNTO 0) ;
   
   signal VARAM_Q: std_logic_vector (15 DOWNTO 0) ;
   
   signal VARAM_WE, WM_On: std_logic ;
   
   signal WM_RAM_Address: std_logic_vector (15 DOWNTO 0) ;
   
   signal WM_RAM_WE: std_logic ;
   
   signal WM_RAM_data_i: std_logic_vector (15 DOWNTO 0) ;
   
   signal WM_Ram_RE, WM_Trigger_event, WM_triggered, WRD_req, W_R: std_logic
    ;
   
   signal WhichVAR: std_logic_vector (3 DOWNTO 0) ;
   
   signal Wire_RT_Address: std_logic_vector (5 DOWNTO 0) ;
   
   signal YES, arbiter: std_logic ;
   
   signal count_1us: std_logic_vector (4 DOWNTO 0) ;
   
   signal count_T_RESus: std_logic_vector (5 DOWNTO 0) ;
   
   signal data_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal eBC, eBC_Bad_Parity, eBC_Bad_instruction, eBC_CFT_do, eBC_CMT_do, 
      eBC_CMV_do, eBC_Conditions_11, eBC_Conditions_9, eBC_FT_Load: 
   std_logic ;
   
   signal eBC_Frame_length: std_logic_vector (15 DOWNTO 0) ;
   
   signal eBC_GP: std_logic_vector (7 DOWNTO 0) ;
   
   signal eBC_GP_do, eBC_IRQ_do, eBC_Inc_Q_pointer: std_logic ;
   
   signal eBC_Q_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal eBC_Stack_error, eBC_TT_do, eBC_Watchdog_enable, eBC_Watchdog_eq0, 
      eBC_start_FT, frame_gap_eq_0, gap_eq_0, illegalization_enable, 
      mode_command: std_logic ;
   
   signal monitor_data_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal monitor_pointer_protection_error: std_logic ;
   
   signal monitor_stack_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal monitor_stack_pointer_plus4: std_logic_vector (15 DOWNTO 0) ;
   
   signal one_micro_increment_wide, phase_go: std_logic ;
   
   signal reg_data_out_wide: std_logic_vector (31 DOWNTO 0) ;
   
   signal stack_pointer: std_logic_vector (15 DOWNTO 0) ;
   
   signal status_set, status_set_dt, status_set_in_frame, test_complete, 
      time_tag15d, time_tag_inc: std_logic ;
   
   signal state: std_logic_vector (8 DOWNTO 0) ;
   
   signal BC_State: std_logic_vector (91 DOWNTO 0) ;
   
   signal MON_Phase: std_logic_vector (1 DOWNTO 0) ;
   
   signal MON_SOM_phase: std_logic_vector (7 DOWNTO 0) ;
   
   signal MON_EOM_phase: std_logic_vector (1 DOWNTO 0) ;
   
   signal Phase: std_logic_vector (1 DOWNTO 0) ;
   
   signal SOM_phase_9, SOM_phase_8, SOM_phase_7, SOM_phase_6, SOM_phase_5, 
      SOM_phase_4, SOM_phase_3, SOM_phase_1, SOM_phase_0: std_logic ;
   
   signal EOM_phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal PWR, eBC_Conditions_9_0n0s3, eBC_Conditions_9_0n0s2, 
      not_Ext_Trigger_DD, Ext_Trigger_Dx_0n0s4, Ext_Trigger_Dx_0n0s6, 
      Ext_Trigger_Dx_0n0s2, not_WM_Started, not_BC_State_1, rtlc1n30, 
      rtlc1_P5_SS0_n33, not_rtlcn1237, not_SW_Reset, not_MEM_nREG, not_BC_SP, 
      rtlc12n13, rtlc13n16, not_Config_reg_6_5, not_RTAD_SW_EN, rtlc16n20, 
      not_RT_ADR_LAT, rtlc16n22, not_ResetN, 
      monitor_stack_pointer_plus4_22n1ss1_13, 
      monitor_stack_pointer_plus4_22n1ss1_12, 
      monitor_stack_pointer_plus4_22n1ss1_11, 
      monitor_stack_pointer_plus4_22n1ss1_10, 
      monitor_stack_pointer_plus4_22n1ss1_9, 
      monitor_stack_pointer_plus4_22n1ss1_8, Ram_Address_22n4ss1_15, 
      Ram_Address_22n4ss1_14, Ram_Address_22n4ss1_13, Ram_Address_22n4ss1_12, 
      Ram_Address_22n4ss1_11, Ram_Address_22n4ss1_10, 
      Stack_rollover_interrupt_22n8ss1: std_logic ;
   
   signal Ram_Address_22n25ss1: std_logic_vector (1 DOWNTO 1) ;
   
   signal Ram_Address_22n27ss1: std_logic_vector (1 DOWNTO 1) ;
   
   signal Ram_data_i_22n27ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal STM_ended_22n27ss1, Stack_rollover_interrupt_22n27ss1: std_logic
    ;
   
   signal data_pointer_22n46ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal data_pointer_22n48ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Ram_Address_22n50ss1_8, Ram_Address_22n50ss1_5, 
      Ram_Address_22n50ss1_4, Ram_Address_22n50ss1_3, Ram_Address_22n50ss1_2, 
      Ram_Address_22n50ss1_0, Ram_data_i_22n50ss1_15, Ram_data_i_22n50ss1_14, 
      Ram_data_i_22n50ss1_13, Ram_data_i_22n50ss1_11, Ram_data_i_22n50ss1_8, 
      Ram_data_i_22n50ss1_7, Ram_data_i_22n50ss1_6, Ram_data_i_22n50ss1_5, 
      Ram_data_i_22n50ss1_4, Ram_data_i_22n50ss1_3, Ram_data_i_22n50ss1_2, 
      Ram_data_i_22n50ss1_1, Ram_data_i_22n50ss1_0, 
      stack_pointer_22n50ss1_10, stack_pointer_22n50ss1_9, 
      stack_pointer_22n50ss1_8, stack_pointer_22n50ss1_7, 
      stack_pointer_22n50ss1_6, stack_pointer_22n50ss1_5, 
      stack_pointer_22n50ss1_4, stack_pointer_22n50ss1_3, 
      stack_pointer_22n50ss1_2, illegal_message_22n50ss1, 
      BUSY_in_LUT_22n50ss1, Ram_Address_22n52ss1_4, Ram_Address_22n54ss1_8, 
      Ram_Address_22n54ss1_5, Ram_Address_22n54ss1_4, Ram_Address_22n54ss1_3, 
      Ram_Address_22n54ss1_2, Ram_Address_22n54ss1_1, Ram_Address_22n54ss1_0, 
      Ram_Address_22n76ss1_15, Ram_Address_22n76ss1_14, 
      Ram_Address_22n76ss1_13, Ram_Address_22n76ss1_12, 
      Ram_Address_22n76ss1_11, Ram_Address_22n76ss1_10, 
      Ram_Address_22n76ss1_8, Ram_Address_22n76ss1_6, Ram_Address_22n76ss1_2, 
      Ram_Address_22n76ss1_1, Ram_Address_22n76ss1_0: std_logic ;
   
   signal Ram_data_i_22n76ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal data_pointer_22n76ss1: std_logic_vector (12 DOWNTO 0) ;
   
   signal Monitor_command_stack_rollover_22n80ss1, 
      Monitor_command_stack_half_pass_22n80ss1, Ram_Address_22n84ss1_2: 
   std_logic ;
   
   signal Ram_Address_22n85ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Ram_data_i_22n85ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Monitor_command_stack_rollover_22n85ss1, 
      Monitor_command_stack_half_pass_22n85ss1, 
      Latched_Monitor_MIL1553_errors_22n85ss1_11, 
      Latched_Monitor_MIL1553_errors_22n85ss1_8, 
      Latched_Monitor_MIL1553_errors_22n85ss1_6, 
      Latched_Monitor_MIL1553_errors_22n85ss1_4, 
      Latched_Monitor_MIL1553_errors_22n85ss1_3, 
      Latched_Monitor_MIL1553_errors_22n85ss1_2, 
      Latched_Monitor_MIL1553_errors_22n85ss1_1, 
      Latched_Monitor_data_stack_rollover_22n85ss1, 
      Latched_Monitor_ended_OK_22n85ss1: std_logic ;
   
   signal Ram_Address_22n103ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Ram_data_i_22n103ss1_15, Ram_data_i_22n103ss1_14, 
      Ram_data_i_22n103ss1_13, Ram_data_i_22n103ss1_12, 
      Ram_data_i_22n103ss1_11, Ram_data_i_22n103ss1_10, 
      Ram_data_i_22n103ss1_9, Ram_data_i_22n103ss1_8, Ram_data_i_22n103ss1_7, 
      Ram_data_i_22n103ss1_5, Ram_data_i_22n103ss1_4, Ram_data_i_22n103ss1_3, 
      Ram_data_i_22n103ss1_2, Ram_data_i_22n103ss1_1, Ram_data_i_22n103ss1_0, 
      record_message_A_22n103ss1, record_message_B_22n103ss1, 
      Ram_RE_22n103ss1, Monitor_data_stack_rollover_22n107ss1, 
      Monitor_data_stack_half_pass_22n107ss1: std_logic ;
   
   signal Ram_Address_22n108ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Ram_data_i_22n108ss1_15, Ram_data_i_22n108ss1_13, 
      Ram_data_i_22n108ss1_12, Ram_data_i_22n108ss1_11, 
      Ram_data_i_22n108ss1_10, Ram_data_i_22n108ss1_9, 
      Ram_data_i_22n108ss1_8, Ram_data_i_22n108ss1_7, Ram_data_i_22n108ss1_6, 
      Ram_data_i_22n108ss1_5, Ram_data_i_22n108ss1_4, Ram_data_i_22n108ss1_3, 
      Ram_data_i_22n108ss1_2, Ram_data_i_22n108ss1_1, Ram_data_i_22n108ss1_0, 
      Ram_WE_22n108ss1: std_logic ;
   
   signal Data_Pointer_register_22n108ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal monitor_data_pointer_22n108ss1: std_logic_vector (14 DOWNTO 0) ;
   
   signal Monitor_data_stack_rollover_22n108ss1, 
      Monitor_data_stack_half_pass_22n108ss1, STM_ended_22n108ss1: std_logic
    ;
   
   signal MM_22n111ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal MM_22n112ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal Rollover_Int_Enable_22n114ss1, MM_Error_detected_22n1s1, 
      Latched_Monitor_MIL1553_errors_6_22n1s8, 
      Latched_Monitor_MIL1553_errors_5_22n1s7, 
      Latched_Monitor_MIL1553_errors_5_22n1s6, 
      Latched_Monitor_MIL1553_errors_4_22n1s5, 
      Latched_Monitor_MIL1553_errors_3_22n1s4, 
      Latched_Monitor_MIL1553_errors_2_22n1s3, 
      Latched_Monitor_MIL1553_errors_1_22n1s2, 
      Latched_Monitor_MIL1553_errors_0_22n1s1, 
      Latched_Monitor_data_stack_rollover_22n1s1, 
      Latched_Monitor_ended_OK_22n1s1, monitor_stack_pointer_plus4_22n1s4_13, 
      monitor_stack_pointer_plus4_22n1s4_12, 
      monitor_stack_pointer_plus4_22n1s4_11, 
      monitor_stack_pointer_plus4_22n1s4_10, 
      monitor_stack_pointer_plus4_22n1s4_9, 
      monitor_stack_pointer_plus4_22n1s4_8, 
      monitor_stack_pointer_plus4_22n1s4_7, 
      monitor_stack_pointer_plus4_22n1s4_6, 
      monitor_stack_pointer_plus4_22n1s4_5, 
      monitor_stack_pointer_plus4_22n1s4_4, 
      monitor_stack_pointer_plus4_22n1s4_3, 
      monitor_stack_pointer_plus4_22n1s4_2, rtlc22n7220, rtlc22n7221, 
      Ram_data_i_0_22n2s1, Ram_data_i_1_22n2s3, Ram_data_i_2_22n2s4, 
      Ram_data_i_3_22n2s5, Ram_data_i_4_22n2s6, Ram_data_i_5_22n2s7, 
      Ram_data_i_6_22n2s8: std_logic ;
   
   signal Ram_data_i_22n2s11: std_logic_vector (5 DOWNTO 1) ;
   
   signal Ram_data_i_8_22n2s10, Ram_data_i_9_22n2s12, Ram_data_i_10_22n2s13, 
      Ram_data_i_11_22n2s14, Ram_data_i_12_22n2s15, Ram_data_i_13_22n2s16, 
      Ram_data_i_14_22n2s17: std_logic ;
   
   signal Ram_Address_22n2s1: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlc22n7393, not_illegal_message, not_EOM_phase_go, not_bus_A, 
      Ram_data_i_8_22n8s3, Stack_rollover_interrupt_22n8s2, 
      Stack_rollover_interrupt_22n8s4, Stack_rollover_interrupt_22n8s6, 
      Stack_rollover_interrupt_22n8s8, not_rtlcs101, not_rtlcs100, 
      rtlc22n7690, rtlc22n7696, rtlc22n7697, rtlc22n7698, not_data_pointer_5, 
      not_Config_reg_2_1, rtlc22n7720, rtlc22n7730, rtlc22n7744, rtlc22n7764, 
      rtlc22n7769, rtlc22n7770, rtlc22n7771, rtlc22n7772, 
      not_Message_ended_not_OK, rtlc22n7782, not_rtlcn1240, not_SOM_phase_go, 
      not_BCR, illegal_message_22n31s1, rtlc22n7839, BUSY_in_LUT_22n33s1, 
      rtlc22n7973, rtlc22n7975, rtlc22n7976, rtlc22n7978, rtlc22n7980, 
      rtlc22n7981, not_mode_command, rtlc22n8022, not_Current_command_10, 
      not_rtlcn10656, rtlc22n8059, rtlc22n8060, rtlc22n8064, not_phase_go, 
      rtlc22n8108, rtlc22n8113, rtlc22n8131, rtlc22n8137, rtlc22n8155, 
      rtlc22n8161, rtlc22n8177, rtlc22n8183, rtlc22n8199, rtlc22n8205, 
      not_rtlc22n8199, rtlc22n8221, rtlc22n8227, not_rtlc22n8221, 
      rtlc22n8243, rtlc22n8249, not_rtlc22n8243, rtlc22n8275, rtlc22n8280, 
      not_Address_10, not_Read, rtlc22n8328, rtlc22n8329, rtlc22n8331, 
      rtlc22n8334, rtlc22n8337, rtlc22n8340, rtlc22n8351, rtlc22n8354, 
      rtlc22n8358, rtlc22n8363, rtlc22n8369, rtlc22n8376, rtlc22n8384, 
      rtlc22n8391, rtlc22n8398, rtlc22n8422, rtlc22n8426, rtlc22n8427, 
      rtlc22n8428, rtlc22n8429, rtlc22n8430, rtlc22n8431, rtlc22n8432, 
      rtlc22n8434, rtlc22n8435, rtlc22n8436, not_MON_EOM_phase_go, 
      not_Monitor_bus_a, Ram_data_i_12_22n78s1, 
      Monitor_command_stack_rollover_22n80s1, 
      Monitor_command_stack_half_pass_22n80s1, 
      Monitor_command_stack_rollover_22n80s2, 
      Monitor_command_stack_half_pass_22n80s2, 
      Monitor_command_stack_rollover_22n80s3, 
      Monitor_command_stack_half_pass_22n80s3, 
      Monitor_command_stack_rollover_22n80s4, 
      Monitor_command_stack_half_pass_22n80s4, rtlc22n8588, 
      not_MON_SOM_phase_go, Record_enable_22n87s2, Record_enable_22n87s1, 
      not_Record_enable, rtlc22n8752, rtlc22n8768, rtlc22n8769, rtlc22n8781, 
      rtlc22n8782, rtlc22n8788, rtlc22n8790, rtlc22n8791, rtlc22n8802, 
      rtlc22n8833, rtlc22n8834, rtlc22n8835, 
      not_monitor_pointer_protection_error, rtlc22n8856, 
      Monitor_data_stack_rollover_22n107s1, 
      Monitor_data_stack_half_pass_22n107s1, 
      Monitor_data_stack_rollover_22n107s2, 
      Monitor_data_stack_half_pass_22n107s2, 
      Monitor_data_stack_rollover_22n107s3, 
      Monitor_data_stack_half_pass_22n107s3, 
      Monitor_data_stack_rollover_22n107s4, 
      Monitor_data_stack_half_pass_22n107s4, 
      Monitor_data_stack_rollover_22n107s5, 
      Monitor_data_stack_half_pass_22n107s5, 
      Monitor_data_stack_rollover_22n107s6, 
      Monitor_data_stack_half_pass_22n107s6, rtlc22_PS506_n8983, 
      Monitor_data_stack_rollover_22n107s7, 
      Monitor_data_stack_half_pass_22n107s7, rtlc22n9096, not_rtlc22n7393, 
      rtlc22n10046, rtlc22n10048, rtlc22n10050, not_rtlc22n10050, 
      rtlc22n10068, rtlc22n10084, not_rtlc22n10084, rtlc22n10119, 
      rtlc22n10133, rtlc22n10219, rtlc22n10248, rtlc22n10298, rtlc22n10309, 
      rtlc22n10314, rtlc22n10316, rtlc22n10340, rtlc22n10342, rtlc22n10405, 
      rtlc22n10407, rtlc22n10408, rtlc22n10410, rtlc22n10429, rtlc22n10476, 
      rtlc22n10479, rtlc22n10482, rtlc22n10504, rtlc22n10520, rtlc22n10529, 
      rtlc22n10530, rtlc22n10531, rtlc22n10532, rtlc22n10537, rtlc22n10553, 
      rtlc22n10560, rtlc22n10561, rtlc22n10562, rtlc22n10563, rtlc22n10564, 
      rtlc22n10565, rtlc22n10566, rtlc22n10569, rtlc22n10573, rtlc22n10589, 
      rtlc22n10590, rtlc22n10591, rtlc22n10592, rtlc22n10608, rtlc22n10633, 
      rtlc22n10634, rtlc22n10635, rtlc22n10636, rtlc22n10637, rtlc22n10638, 
      rtlc22n10639, rtlc22n10640, rtlc22n10641, rtlc22n10642, rtlc22n10658, 
      rtlc22n10715, rtlc22n10716, rtlc22n10717, rtlc22n10718, rtlc22n10721, 
      rtlc22n10729, rtlc22n10731, rtlc22n10733, rtlc22n10743, rtlc22n10748, 
      not_rtlc22n10316, not_rtlcs61, not_rtlc22n10408, not_rtlc22n10119, 
      rtlc22n11259, not_rtlcn1232, rtlc22n11324, not_rtlcn1234, 
      BC_Num_Msgs_26n12ss1_10, BC_Num_Msgs_26n12ss1_9, 
      BC_Num_Msgs_26n12ss1_8, BC_State_fsm_26n69ss1_70, 
      BC_State_fsm_26n69ss1_63, BC_State_fsm_26n69ss1_61, 
      BC_State_fsm_26n69ss1_34, BC_State_fsm_26n116ss1_54, 
      BC_State_fsm_26n116ss1_52, BC_BUS_A_26n180ss1, BC_EOM_26n180ss1: 
   std_logic ;
   
   signal BC_Echo_word_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Go_26n180ss1, BC_Load_msg_gap_counter_26n180ss1: std_logic ;
   
   signal BC_Ram_Address_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Ram_data_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Stack_pointer_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_TX_Data_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_msg_pointer_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_word_number_26n180ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal ReTry_count_26n180ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal VARAM_ADD_26n180ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal VARAM_D_26n180ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal VARAM_WE_26n180ss1, eBC_Bad_Parity_26n180ss1, eBC_CMV_do_26n180ss1, 
      eBC_FT_Load_26n180ss1, eBC_GP_do_26n180ss1, eBC_IRQ_do_26n180ss1, 
      eBC_Inc_Q_pointer_26n180ss1, eBC_TT_do_26n180ss1, 
      eBC_start_FT_26n180ss1, BC_State_fsm_26n180ss1_54, 
      BC_State_fsm_26n180ss1_20, BC_State_fsm_26n182ss1_77, 
      BC_State_fsm_26n182ss1_70, BC_State_fsm_26n182ss1_66, 
      BC_State_fsm_26n182ss1_63, BC_State_fsm_26n182ss1_61, 
      BC_State_fsm_26n182ss1_55, BC_State_fsm_26n182ss1_54, 
      BC_State_fsm_26n182ss1_53, BC_State_fsm_26n182ss1_52, 
      BC_State_fsm_26n182ss1_51, BC_State_fsm_26n182ss1_40, 
      BC_State_fsm_26n182ss1_34, BC_State_fsm_26n182ss1_29, 
      BC_State_fsm_26n182ss1_22, BC_State_fsm_26n182ss1_21, 
      BC_State_fsm_26n182ss1_20, BC_State_fsm_26n182ss1_12, 
      not_Config_reg_6_15, not_BC_OFF, rtlc26n12419, rtlc26n12428, 
      rtlc26n12441, rtlc26n12461, not_rtlc26n12461, rtlc26n12464: std_logic
    ;
   
   signal BC_Num_Msgs_26n12s1: std_logic_vector (10 DOWNTO 0) ;
   
   signal BC_Ram_data_26n15s1: std_logic_vector (15 DOWNTO 0) ;
   
   signal not_BC_Echo, rtlc26n12613, rtlc26n12614: std_logic ;
   
   signal BC_Ram_data_26n30s4: std_logic_vector (8 DOWNTO 0) ;
   
   signal BC_msg_pointer_26n43s1_15, BC_msg_pointer_26n43s1_14, 
      BC_msg_pointer_26n43s1_13, BC_msg_pointer_26n43s1_12, 
      BC_msg_pointer_26n43s1_11, BC_msg_pointer_26n43s1_10, 
      BC_msg_pointer_26n43s1_9, rtlc26n12839, not_BC_Control_word_7, 
      rtlc26_PS144_n12968, not_ReTry_count_1, not_Config_reg_1_5, 
      not_rtlcn1226, rtlc26n13005, rtlc26n13014, rtlc26n13018, rtlc26n13019, 
      rtlc26n13037, rtlc26n13041, rtlc26n13144, rtlc26n13151, rtlc26n13194, 
      rtlc26n13223, rtlc26n13224, rtlc26n13229, rtlc26n13231, rtlc26n13232, 
      rtlc26n13234, rtlc26n13236, rtlc26n13295, rtlc26n13370, rtlc26n13371, 
      rtlc26n13384, rtlc26n13393, rtlc26n13428, not_BC_Message_Active, 
      not_rtlc26n13617, rtlc26n13617, not_Config_reg_1_4, 
      not_BC_Control_word_8, rtlc26n13638, rtlc26n13646, not_Config_reg_1_3, 
      rtlc26n13656, rtlc26n13657, not_rtlc26n13657, rtlc26n13674, 
      rtlc26n13675, rtlc26n13676, rtlc26n13677, rtlc26n13678, 
      not_BC_msg_pointer_4, not_LIFO_Pointer_4, not_BC_Echo_word_10, 
      rtlc26n13816: std_logic ;
   
   signal LIFO_Pointer_26n126s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal not_rtlc26n13816, not_BC_Echo_word_13, not_BC_Echo_word_14, 
      rtlc26n13923, rtlc26n14017, not_BC_Echo_word_11, rtlc26n14110, 
      eBC_Bad_Parity_26n180s2, not_eBC_Bad_Parity_26n180s2, rtlc26n14265, 
      not_rtlcs153, rtlc26n14300, BC_Stack_pointer_26n167s1_15, 
      BC_Stack_pointer_26n167s1_14, BC_Stack_pointer_26n167s1_13, 
      BC_Stack_pointer_26n167s1_12, BC_Stack_pointer_26n167s1_11, 
      BC_Stack_pointer_26n167s1_10, BC_Stack_pointer_26n167s1_9, 
      rtlc26n14359, VARAM_D_26n172s1_15, VARAM_D_26n172s1_14, 
      VARAM_D_26n172s1_13, VARAM_D_26n172s1_12, VARAM_D_26n172s1_11, 
      VARAM_D_26n172s1_10, VARAM_D_26n172s1_9, VARAM_D_26n172s1_8, 
      VARAM_D_26n172s1_7, VARAM_D_26n172s1_6, VARAM_D_26n172s1_5, 
      rtlc26n14484, rtlc26n14488, rtlc26n14489, rtlc26n14491, rtlc26n14530, 
      rtlc26n14559, rtlc26n14562, rtlc26n14576, rtlc26n14581, rtlc26n14583, 
      rtlc26n14584: std_logic ;
   
   signal BC_Stack_pointer_26n31s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal BC_Stack_pointer_26n31s2_6, BC_Stack_pointer_26n31s3_7, 
      BC_Stack_pointer_26n31s4_8, rtlc26n14732, rtlc26n14736, rtlc26n14737, 
      rtlc26n14739, rtlc26n14740, not_rtlcs353, rtlc26n14917, 
      not_rtlc26n14917, rtlc26n14919, rtlc26n14920, not_Data_o_temp_12, 
      not_Data_o_temp_14, rtlc26_PS698_n14998, not_Data_o_temp_13, 
      rtlc26_PS699_n15006, rtlc26n15015, rtlc26n15063, rtlc26n15067, 
      rtlc26n15114, not_BC_reported_errors, rtlc26n15172, rtlc26n15182, 
      not_eBC, rtlc26n15184, rtlc26n15208, rtlc26n15232, VARAM_WE_26n125s2, 
      rtlc26n15271, eBC_FT_Load_26n148s1, rtlc26n15369, rtlc26n15481, 
      rtlc26n15497, rtlc26n15803, rtlc26n15915, rtlc26n15937, rtlc26n15994, 
      not_rtlc26n15994, rtlc26n15998, not_rtlc26n16783, rtlc26n16088, 
      rtlc26n16112, rtlc26n16119, rtlc26n16122, rtlc26n16129, rtlc26n16130, 
      rtlc26n16131, rtlc26n16138, rtlc26n16139, rtlc26n16146, rtlc26n16148, 
      rtlc26n16200, not_rtlc26n16200, rtlc26n16203, rtlc26n16204, 
      rtlc26n16205, rtlc26n16206, rtlc26n16305, rtlc26n16321, rtlc26n16323, 
      rtlc26n16352, rtlc26n16354, rtlc26n16356, not_rtlc26n17337, 
      rtlc26n16362, rtlc26n16375, rtlc26n16381, rtlc26n16656, rtlc26n16783, 
      rtlc26n16913, rtlc26n16929, rtlc26n16947, rtlc26n16949, rtlc26n16950, 
      rtlc26n16970, rtlc26n16986, rtlc26n17013, rtlc26n17014, rtlc26n17015, 
      rtlc26n17016, rtlc26n17021, rtlc26n17038, rtlc26n17054, rtlc26n17057, 
      rtlc26n17066, rtlc26n17067, rtlc26n17069, rtlc26n17070, rtlc26n17075, 
      rtlc26n17091, rtlc26n17097, rtlc26n17110, rtlc26n17283, rtlc26n17286, 
      rtlc26n17289, rtlc26n17293, not_rtlc26n17293, rtlc26n17297, 
      rtlc26n17300, rtlc26n17314, rtlc26n17317, rtlc26n17320, rtlc26n17323, 
      not_rtlc26n17323, rtlc26n17331, rtlc26n17334, rtlc26n17337, 
      rtlc26n17341, rtlc26n18663, not_rtlc26n18663, rtlc26n18667, 
      rtlc26n18670, rtlc26n18672, rtlc26n18821, rtlc26n18822, rtlc26n19009, 
      rtlc26n19466, rtlc26n19509, Non_masked_Event_D_29n1ss1, rtlc29n261, 
      rtlc29n262, rtlc29n287, rtlc29n292, rtlc29n298, rtlc29n304, rtlc29n310, 
      rtlc29n316, rtlc29n322, rtlc29n328, rtlc29n334, rtlc29n340, rtlc29n346, 
      rtlc29n352, rtlc29n358, rtlc29n364, rtlc29n370, rtlc29n371, rtlc29n383, 
      rtlc29n388, rtlc29n394, rtlc29n400, rtlc29n406, rtlc29n412, rtlc29n418, 
      rtlc29n424, rtlc29n430, rtlc29n436, rtlc29n442, rtlc29n443, 
      not_Non_masked_Event_D, rtlc29n455, rtlc29n463, rtlc29n464, rtlc29n472, 
      rtlc29n518, rtlc29n526, rtlc29n609, rtlc29n642, not_INTn_count_4, 
      rtlc29n677, not_rtlcn1252, rtlc29n681, WRD_req_32n14ss1, 
      MON_WR_req_32n14ss1, rtlc32n408, not_host_status_bits_3, rtlc32n411, 
      not_rtlc32n411, rtlc32n426, not_Channel_Status_3, rtlc32n429, 
      not_rtlc32n429, W_R_32n3s1, not_W_R, rtlc32n441, rtlc32n450, 
      rtlc32n451, not_rtlc32n451, rtlc32n459, not_rtlc32n459, not_M_W, 
      rtlc32n468, not_rtlc32n468, not_WRD_req, not_EOM_req, not_SOM_req, 
      not_MON_WR_req, not_MON_EOM_req, not_MON_SOM_req, not_STM_ended, 
      rtlc32n551, rtlc32n552, rtlc32n554, rtlc32n555, rtlc32n556, rtlc32n557, 
      not_arbiter, rtlc32n581, rtlc32n583, rtlc32n700, rtlc32n701, 
      rtlc32n702, rtlc32n703, rtlc32n704, rtlc32n705, rtlc32n706, 
      not_Timeout_counter_6, rtlc32n756, not_rtlcn1230, rtlc32n759, 
      not_MODE_CODE1553A, rtlc35n91, rtlc35n98, not_BC_Go, rtlc38n63, 
      BC_Sts_Word_41n13ss1_13, BC_Sts_Word_41n13ss1_4, rtlc41n105, 
      rtlc41n128, rtlc41n130, rtlc41n132, rtlc41n148, rtlc41n341, rtlc41n342, 
      rtlc41n343, rtlc41n344, rtlc41n346, rtlc41n347, rtlc41n348, rtlc41n349, 
      rtlc41n350, rtlc41n351, rtlc41n352, rtlc41n353, rtlc44n159, rtlc44n161, 
      not_BC_Control_word_14, rtlc44n168, not_BC_Control_word_13, rtlc44n176, 
      not_BC_Control_word_12, rtlc44n182, not_BC_Control_word_11, rtlc44n188, 
      not_BC_Control_word_10, rtlc44n197, not_rtlcn1224, rtlc44n222, 
      rtlc44n225, rtlc44n226, not_rtlcs170, rtlc44n263, not_rtlcn1225, 
      rtlc44n271, not_BC_Control_word_5, rtlc44n274, rtlc44n275, rtlc44n314, 
      rtlc44n315, YES_45n1ss1, YES_45n2ss1, YES_45n1s2, YES_45n2s1, 
      YES_45n2s2, gap_eq_0_48n3ss1, gap_eq_0_48n3s1, 
      not_BC_Load_msg_gap_counter, rtlc48n177, rtlc48_X_0_n209, 
      not_rtlc48n339, rtlc48n253, rtlc48n339, frame_gap_eq_0_51n5ss1, 
      eBC_Watchdog_eq0_51n5ss1, frame_gap_eq_0_51n6ss1, 
      eBC_Watchdog_eq0_51n6ss1, frame_gap_eq_0_51n6s1, frame_gap_eq_0_51n5s1, 
      rtlc51n160, not_BC_Load_frame_gap_counter, rtlc51_X_0_n289, 
      rtlc51_X_0_n319, not_rtlc51n502, rtlc51n378, rtlc51n394, rtlc51n502, 
      BC_SP_54n1ss1, BC_SP_54n1s1, BC_SP_54n1s2, BC_SP_54n1s3, BC_SP_54n1s4, 
      Tag_CLK_D_60n5ss1: std_logic ;
   
   signal time_tag_60n13ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal time_tag_60n15ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal one_micro_increment_60n16ss1, MT_On_Async_60n27ss1, 
      MT_On_Async_60n28ss1: std_logic ;
   
   signal time_tag_60n30ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Clear_Test_Status_reg_60n33ss1, eBC_GP_60n34ss1, eBC_GP_60n35ss1, 
      eBC_GP_60n36ss1, eBC_GP_60n37ss1, eBC_GP_60n38ss1, eBC_GP_60n39ss1, 
      eBC_GP_60n40ss1, eBC_GP_60n41ss1: std_logic ;
   
   signal count_T_RESus_60n43ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal time_tag_60n43ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Tag_CLK_D_60n43ss1, Config_reg_1_60n43ss1_15, 
      Config_reg_1_60n43ss1_14, Config_reg_1_60n43ss1_13, 
      Config_reg_1_60n43ss1_12, Config_reg_1_60n43ss1_11, 
      Config_reg_1_60n43ss1_10, Config_reg_1_60n43ss1_8, 
      Config_reg_1_60n43ss1_7, Config_reg_1_60n43ss1_6, 
      Config_reg_1_60n43ss1_5, Config_reg_1_60n43ss1_4, 
      Config_reg_1_60n43ss1_3, Config_reg_1_60n43ss1_1: std_logic ;
   
   signal Dummy_register_0x4_60n43ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Clear_Test_Status_reg_60n43ss1, host_status_bits_60n45ss1_8, 
      host_status_bits_60n45ss1_3, host_status_bits_60n45ss1_2, 
      host_status_bits_60n45ss1_0, host_status_bits_60n46ss1_10, 
      host_status_bits_60n46ss1_9, host_status_bits_60n46ss1_7, 
      host_status_bits_60n46ss1_6, host_status_bits_60n46ss1_5, 
      host_status_bits_60n46ss1_4, host_status_bits_60n46ss1_3, 
      host_status_bits_60n46ss1_2, host_status_bits_60n46ss1_1, 
      host_status_bits_60n46ss1_0: std_logic ;
   
   signal Config_reg_5_60n51ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal eBC_Q_pointer_60n51ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal eBC_GP_60n55ss1, eBC_GP_60n56ss1, eBC_GP_60n57ss1, eBC_GP_60n58ss1, 
      eBC_GP_60n59ss1, eBC_GP_60n60ss1, eBC_GP_60n61ss1, eBC_GP_60n62ss1: 
   std_logic ;
   
   signal eBC_GP_60n73ss1: std_logic_vector (7 DOWNTO 0) ;
   
   signal Clean_status_bits_60n76ss1, Clean_status2_bits_60n78ss1, 
      Config_reg_1_60n84ss1, Config_reg_1_60n89ss1: std_logic ;
   
   signal Config_reg_1_60n90ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal host_status_bits_60n91ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal Config_reg_1_60n91ss1_3, Config_reg_1_60n91ss1_1: std_logic ;
   
   signal GMM_60n92ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal rtlc60n5038, not_rtlc60n5038, rtlc60n5111, rtlc60n5123, 
      rtlc60n5136, rtlc60n5149, rtlc60n5162, rtlc60n5175, rtlc60n5176: 
   std_logic ;
   
   signal count_T_RESus_60n6s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_Tag_CLK_DD: std_logic ;
   
   signal time_tag_60n10s1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Current_command_is_sync_with_data_60n11s2, 
      Current_command_is_sync_with_data_60n11s3, 
      Current_command_is_sync_with_data_60n11s1, 
      Current_command_is_sync_without_data_60n11s2, 
      Current_command_is_sync_without_data_60n11s3, 
      Current_command_is_sync_without_data_60n11s1, 
      Monitor_command_is_sync_with_data_60n11s5, 
      Monitor_command_is_sync_with_data_60n11s6, 
      Monitor_command_is_sync_with_data_60n11s4, 
      Monitor_command_is_sync_with_data_60n11s3, 
      Monitor_command_is_sync_with_data_60n11s2, not_RT_On, 
      Monitor_command_is_sync_with_data_60n11s1, 
      Monitor_command_is_sync_without_data_60n11s5, 
      Monitor_command_is_sync_without_data_60n11s6, 
      Monitor_command_is_sync_without_data_60n11s4, 
      Monitor_command_is_sync_without_data_60n11s3, 
      Monitor_command_is_sync_without_data_60n11s2, 
      Monitor_command_is_sync_without_data_60n11s1, not_Test_Status_reg_14, 
      rtlc60n5308, not_Test_Status_reg_6, rtlc60n5311, rtlc60n5312, 
      rtlc60n5317, rtlc60n5319, rtlc60n5320, rtlc60n5321, rtlc60n5323, 
      rtlc60n5324, not_MON_Phase_1, rtlc60n5337, rtlc60n5338, rtlc60n5339, 
      not_rtlc60n5339, rtlc60n5350, rtlc60n5352, rtlc60n5353, rtlc60n5359, 
      not_rtlcn10838, not_rtlcn1245, rtlc60n5383, rtlc60n5384, rtlc60n5385, 
      rtlc60n5386, rtlc60n5387, rtlc60n5424, not_CPU_Data_in_wide_30, 
      MT_On_Async_60n18s2, MT_On_Async_60n18s1, not_rtlc60n5424, rtlc60n5464, 
      not_WM_On, Clear_Test_Status_reg_60n20s1, not_CPU_Data_in_wide_25, 
      rtlc60n5482, not_CPU_Data_in_wide_23, rtlc60n5491, 
      not_CPU_Data_in_wide_22, not_CPU_Data_in_wide_21, 
      not_CPU_Data_in_wide_20, not_CPU_Data_in_wide_19, rtlc60n5527, 
      not_CPU_Data_in_wide_18, MT_On_Async_60n27s3, not_MT_On_Async_60n27s3, 
      MT_On_Async_60n27s1, rtlc60n5557, rtlc60n5559, rtlc60n5560, 
      rtlc60n5566, rtlc60n5569, rtlc60n5579, not_rtlc60n5579, rtlc60n5595, 
      not_rtlc60n5595, rtlc60n5601, rtlc60n5602, not_CPU_Address_1, 
      not_CPU_Address_2, rtlc60n5666, not_eBC_GP_0, not_eBC_GP_1, 
      not_eBC_GP_2, not_eBC_GP_3, not_eBC_GP_4, not_eBC_GP_5, not_eBC_GP_6, 
      not_eBC_GP_7, rtlc60n5894, rtlc60n5895, rtlc60n5896, rtlc60n5897, 
      rtlc60n5898, rtlc60n5899, rtlc60n5900, rtlc60n5901, rtlc60n5903, 
      rtlc60n5904, rtlc60n5905, rtlc60n5906, rtlc60n5914, rtlc60n5915, 
      rtlc60n5916, rtlc60n5918, rtlc60n5919, rtlc60n5920, rtlc60n5925, 
      rtlc60n5926, rtlc60n5927, rtlc60n5928, rtlc60n5929, rtlc60n5930, 
      rtlc60n5931, rtlc60n5932, rtlc60n5933, not_Config_reg_3_5, rtlc60n5942, 
      not_Config_reg_1_7, not_Config_reg_1_8, host_status_bits_2_60n45s2, 
      not_Config_reg_1_10, rtlc60n5981, rtlc60n5987, not_rtlc60n5987, 
      rtlc60n6000, rtlc60n6002, not_rtlc60n6002: std_logic ;
   
   signal eBC_Q_pointer_60n50s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_eBC_Inc_Q_pointer, rtlc60n6052, rtlc60n6053, rtlc60n6054, 
      rtlc60n6060, rtlc60n6061, rtlc60n6074, rtlc60n6084, rtlc60n6438, 
      rtlc60n6439, rtlc60n6442, rtlc60n6443, rtlc60n6444, rtlc60n6445, 
      rtlc60n6446, rtlc60n6447, rtlc60n6448, rtlc60n6449, not_test_complete, 
      rtlc60n6473, rtlc60n6476, not_Read_from_int_vec, rtlc60n6494, 
      rtlc60n6499, rtlc60n6506, rtlc60n6509, not_Read_from_int_vec2, 
      rtlc60n6544, rtlc60n6552, rtlc60n6560, not_rtlc60n6552, rtlc60n6577, 
      rtlc60n6584, rtlc60n6587, not_Config_reg_3_2, rtlc60n6602, not_BC_IDLE, 
      rtlc60n6612, rtlc60n6623, not_rtlc32n408, rtlc60n6633, not_rtlc60n6633, 
      rtlc60n6646, rtlc60n6648, not_rtlc60n6648, not_rtlc32n450, not_BC_on, 
      rtlc60n6679, rtlc60n6680, rtlc60n6681, rtlc60n6683, rtlc60n6684, 
      rtlc60n6685, rtlc60n6686, rtlc60n6687, rtlc60n6696, rtlc60n6699, 
      rtlc60n6706, rtlc60n6707, rtlc60n6711, rtlc60n6714, rtlc60n6721, 
      rtlc60n6722, rtlc60n6723, rtlc60n6724, rtlc60n7249, rtlc60n7254, 
      not_rtlc60n5903, not_rtlc60n5904, not_rtlc60n5905, not_rtlc60n6683, 
      rtlc60n7285, not_rtlc60n6684, not_rtlc60n5981, not_rtlc60n6685, 
      not_rtlc60n6686, not_rtlc60n6687, rtlc60n7302, not_rtlc60n5906, 
      rtlc60n7324, rtlc60n7340, rtlc60n7356, rtlc60n7370, rtlc60n7372, 
      rtlc60n7388, rtlc60n7404, rtlc60n7420, rtlc60n7421, rtlc60n7422, 
      not_rtlc60n5915, not_rtlc60n5916, rtlc60n7455, not_rtlc60n6052, 
      not_rtlc60n6053, not_rtlc60n5920, rtlc60n7460, rtlc60n7461, 
      rtlc60n7462, rtlc60n7463, not_rtlc60n6054, not_rtlc60n5925, 
      not_rtlc60n6442, not_rtlc60n6443, not_rtlc60n6444, not_rtlc60n6445, 
      not_rtlc60n6446, not_rtlc60n6447, not_rtlc60n6448, not_rtlc60n6449, 
      rtlc60n7496, rtlc60n7497, not_rtlcs236, not_rtlc60n7254, rtlc60n7640, 
      rtlc60n7906, rtlc60n7956, not_Raw_resetN, not_Config_reg_1_14, 
      RT_On_63n1s1, not_Config_reg_1_15, WM_On_63n3s2, not_Config_reg_1_12, 
      WM_On_63n3s1, eBC_63n3s1, SW_Reset_66n1ss1, rtlc66n47, 
      rtlc75_Interrupt_status_register_1_D_n493_13, 
      rtlc75_Interrupt_status_register_1_D_n493_12, 
      rtlc75_Interrupt_status_register_1_D_n493_11, 
      rtlc75_Interrupt_status_register_1_D_n493_10, 
      rtlc75_Interrupt_status_register_1_D_n493_8, 
      rtlc75_Interrupt_status_register_1_D_n493_6, 
      rtlc75_Interrupt_status_register_1_D_n493_5, 
      rtlc75_Interrupt_status_register_1_D_n493_4, 
      rtlc75_Interrupt_status_register_1_D_n493_3, 
      rtlc75_Interrupt_status_register_1_D_n493_2, 
      rtlc75_Interrupt_status_register_1_D_n493_1, 
      rtlc75_Interrupt_status_register_1_D_n493_0, 
      rtlc75_Interrupt_status_register_2_D_n494_15, 
      rtlc75_Interrupt_status_register_2_D_n494_12, 
      rtlc75_Interrupt_status_register_2_D_n494_11, 
      rtlc75_Interrupt_status_register_2_D_n494_10, 
      rtlc75_Interrupt_status_register_2_D_n494_7, 
      rtlc75_Interrupt_status_register_2_D_n494_6, 
      rtlc75_Interrupt_status_register_2_D_n494_1, 
      rtlc75_ISR1_during_clear_D_n498_13: std_logic ;
   
   signal Interrupt_status_register_1_75n7ss1: std_logic_vector
    (14 DOWNTO 0) ;
   
   signal Interrupt_status_register_2_75n7ss1_14, 
      Interrupt_status_register_2_75n7ss1_12, 
      Interrupt_status_register_2_75n7ss1_11, 
      Interrupt_status_register_2_75n7ss1_10, 
      Interrupt_status_register_2_75n7ss1_7, 
      Interrupt_status_register_2_75n7ss1_6, 
      Interrupt_status_register_2_75n7ss1_5, 
      Interrupt_status_register_2_75n7ss1_4, 
      Interrupt_status_register_2_75n7ss1_3, 
      Interrupt_status_register_2_75n7ss1_2, 
      Interrupt_status_register_2_75n7ss1_1: std_logic ;
   
   signal Interrupt_status_register_2_75n26ss1: std_logic_vector
    (1 DOWNTO 1) ;
   
   signal Non_masked_Event_75n31ss1, Non_masked_Event_75n33ss1, 
      Non_masked_Event_75n35ss1: std_logic ;
   
   signal Interrupt_status_register_2_75n36ss1: std_logic_vector
    (3 DOWNTO 0) ;
   
   signal Non_masked_Event_75n37ss1: std_logic ;
   
   signal reg_data_out_wide_75n41ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n43ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n50ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n54ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n69ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n70ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal reg_data_out_wide_75n71ss1: std_logic_vector (31 DOWNTO 0) ;
   
   signal Non_masked_Event_75n1s3_13, Non_masked_Event_75n1s3_12, 
      Non_masked_Event_75n1s3_11, Non_masked_Event_75n1s3_10, 
      Non_masked_Event_75n1s3_8, Non_masked_Event_75n1s3_6, 
      Non_masked_Event_75n1s3_5, Non_masked_Event_75n1s3_4, 
      Non_masked_Event_75n1s3_3, Non_masked_Event_75n1s3_2, 
      Non_masked_Event_75n1s3_1, Non_masked_Event_75n1s3_0, 
      Non_masked_Event_75n1s1, Non_masked_Event_75n3s3_14, 
      Non_masked_Event_75n3s3_12, Non_masked_Event_75n3s3_11, 
      Non_masked_Event_75n3s3_10, Non_masked_Event_75n3s3_7, 
      Non_masked_Event_75n3s3_6, Non_masked_Event_75n3s3_5, 
      Non_masked_Event_75n3s3_4, Non_masked_Event_75n3s3_3, 
      Non_masked_Event_75n3s3_1, Non_masked_Event_75n3s1, 
      not_Clean_status2_bits, rtlc75n1435, rtlc75n1436, rtlc75n1438: 
   std_logic ;
   
   signal Interrupt_status_register_1_75n6s2: std_logic_vector (14 DOWNTO 0)
    ;
   
   signal Interrupt_status_register_1_75n6s1_13, 
      Interrupt_status_register_1_75n6s1_12, 
      Interrupt_status_register_1_75n6s1_11, 
      Interrupt_status_register_1_75n6s1_10, 
      Interrupt_status_register_1_75n6s1_9, 
      Interrupt_status_register_1_75n6s1_8, 
      Interrupt_status_register_1_75n6s1_6, 
      Interrupt_status_register_1_75n6s1_5, 
      Interrupt_status_register_1_75n6s1_4, 
      Interrupt_status_register_1_75n6s1_3, 
      Interrupt_status_register_1_75n6s1_2, 
      Interrupt_status_register_1_75n6s1_1, 
      Interrupt_status_register_1_75n6s1_0, 
      Interrupt_status_register_2_75n6s1_14, 
      Interrupt_status_register_2_75n6s1_12, 
      Interrupt_status_register_2_75n6s1_11, 
      Interrupt_status_register_2_75n6s1_10, 
      Interrupt_status_register_2_75n6s1_7, 
      Interrupt_status_register_2_75n6s1_6, 
      Interrupt_status_register_2_75n6s1_5, 
      Interrupt_status_register_2_75n6s1_4, 
      Interrupt_status_register_2_75n6s1_3, 
      Interrupt_status_register_2_75n6s1_2, 
      Interrupt_status_register_2_75n6s1_1, rtlc75n1492, rtlc75n1493, 
      Non_masked_Event_75n10s1, not_Tx_Timeout_D, rtlc75n1547, 
      not_Clean_status_bits, not_time_tag_15, rtlc75n1647, rtlc75n1659, 
      rtlc75n1662, rtlc75n1665, rtlc75n1680, rtlc75n1687, rtlc75n1690, 
      rtlc75n1695, rtlc75n1698, rtlc75n1699, rtlc75n1704, rtlc75n1711, 
      rtlc75n1712, rtlc75n1713, rtlc75n1714, rtlc75n1728, rtlc75n1730, 
      not_BC_STS_Word_12_d, rtlc75n1757, rtlc75n1764, rtlc75n1765, 
      rtlc75n1779, rtlc75n1788, rtlc75n1790, rtlc75n1793, rtlc75n1794, 
      rtlc75n1795, rtlc75n1810, rtlc75n1813, rtlc75n1815, rtlc75n1816, 
      rtlc75n1818, rtlc75n1819, rtlc75n1848, not_rtlcn11108, 
      not_BC_msg_pointer_3, not_BC_msg_pointer_1, not_BC_msg_pointer_0, 
      rtlc75n1961, rtlc75n1968, rtlc75n1969, rtlc75n1970, rtlc75n1971, 
      rtlc75n1972, rtlc75n2832, rtlc75n2833, rtlc75n2834, rtlc75n2835, 
      rtlc75n2836, rtlc75n2837, rtlc75n2838, rtlc75n2840, rtlc75n2842, 
      rtlc75n2843, rtlc75n2844, rtlc75n2845, rtlc75n2847, rtlc75n2848, 
      rtlc75n2849, rtlc75n2850, rtlc75n2851, rtlc75n2852, rtlc75n2853, 
      rtlc75n2856, rtlc75n2857, rtlc75n2858, rtlc75n2860, rtlc75n2861, 
      rtlc75n2862, rtlc75n2863, rtlc75n2864, rtlc75n2865, rtlc75n2866, 
      rtlc75n2867, rtlc75n2868, rtlc75n2869, rtlc75n2870, rtlc75n2872, 
      rtlc75n2874, rtlc75n2875, rtlc75n2876, rtlc75n2877, rtlc75n2881, 
      not_rtlc75n1970, not_rtlc75n1971, not_rtlc75n1972, rtlc75n2886, 
      rtlc75n2887, rtlc75n2890, rtlc75n2891, rtlc75n2892, rtlc75n2894, 
      rtlc75n2896, not_rtlcs270, not_rtlcs246, rtlc78n119, rtlc78n136, 
      rtlc78n145, rtlc78n394, rtlc78n395, rtlc78n396, rtlc78n398, rtlc78n399, 
      rtlc78n400, rtlc81n54, rtlc81n71, rtlc81n79, rtlc81n82, rtlc81n121, 
      not_HW_ResetN: std_logic ;
   
   signal Test_Status_reg_84n4ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal Test_Status_reg_84n7ss1: std_logic_vector (1 DOWNTO 0) ;
   
   signal BIT_Test_complete_84n7ss1, rtlc84n98, rtlc84n99, rtlc84n141, 
      not_rtlcs311, rtlc84n174, rtlc84n177, rtlc84n179, rtlc84n180, 
      rtlc84n235, not_rtlc84n180, not_rtlc84n179, rtlc84n247, not_rtlc84n141, 
      rtlc84n251, not_rtlcn1246: std_logic ;
   
   signal WM_RAM_Address_87n11ss1: std_logic_vector (15 DOWNTO 1) ;
   
   signal WM_Ack_87n13ss1: std_logic ;
   
   signal WM_RAM_Address_87n13ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal WM_RAM_data_i_87n13ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal WM_Ack_87n14ss1, WM_RAM_WE_87n14ss1, WM_Ram_RE_87n14ss1, 
      state_fsm_87n14ss1_6, not_Config_reg_1_11, rtlc87n364, rtlc87n367, 
      rtlc87n403, rtlc87n423, not_eBC_Q_pointer_10, rtlc87n426, rtlc87n429, 
      not_rtlc87n429, rtlc87n431, rtlc87n440, not_Ack, 
      WM_RAM_data_i_6_87n9s3, WM_RAM_data_i_6_87n9s2, rtlc87n508, rtlc87n519, 
      rtlc87n522, rtlc87n616, rtlc87n636, rtlc87n646, rtlc87n684, rtlc87n699, 
      rtlc87n716, rtlc87n790, rtlcn1224, rtlcn1225, rtlcn1226, rtlcn1227, 
      rtlcn1228, rtlcn1229, rtlcn1230, rtlcn1231, rtlcn1232, rtlcn1233, 
      rtlcn1234, rtlcn1237, rtlcn1239, rtlcn1240, rtlcn1245, rtlcn1246, 
      rtlcn1252, rtlcn1257, not_rtlcn9862, not_rtlcn8795, rtlcn2058, 
      rtlcn2077, rtlcn2079, rtlcn2081, rtlcn2082, rtlcn2084, rtlcn2142, 
      rtlcn2170, rtlcn2233, rtlcn2269, rtlcn2275, rtlcn2296, rtlcn2297, 
      rtlcn2392, rtlcn2400, rtlcn2402, rtlcn2408, rtlcn2412, rtlcn2417, 
      rtlcn2419, rtlcn2422, rtlcn2444, rtlcn2464, rtlcn2466, rtlcn2467, 
      rtlcn2468, rtlcn2475, rtlcn2477, rtlcn2478, rtlcn2479, rtlcn2480, 
      rtlcn2481, rtlcn2482, rtlcn2483, rtlcn2485, rtlcn2486, rtlcn2487, 
      rtlcn2494, rtlcn2495, rtlcn2496, rtlcn2497, rtlcn2512, rtlcn2520, 
      rtlcn2522, rtlcn2524, rtlcn2624, rtlcn2625, rtlcn2637, rtlcn2667, 
      rtlcn2673, rtlcn2683, rtlcn2698, rtlcn2713, rtlcn2724, rtlcn2733, 
      rtlcn2741, rtlcn2760, rtlcn2761, rtlcn2762, rtlcn2768, not_rtlcn9875, 
      rtlcn2784, rtlcn2797, rtlcn2816, rtlcn2861, rtlcn2878, rtlcn2889, 
      rtlcn2900, rtlcn2915, rtlcn2926, rtlcn2941, rtlcn2973, rtlcn2996, 
      rtlcn3036, not_rtlcn9888, rtlcn3048, rtlcn3058, rtlcn3059, rtlcn3098, 
      rtlcn3107, rtlcn3126, rtlcn3137, rtlcn3148, rtlcn3159, rtlcn3170, 
      rtlcn3181, rtlcn3192, rtlcn3203, rtlcn3214, rtlcn3225, rtlcn3244, 
      rtlcn3263, rtlcn3286, rtlcn3296, rtlcn3297, rtlcn3301, rtlcn3308, 
      rtlcn3335, rtlcn3358, rtlcn3375, rtlcn3390, rtlcn3405, rtlcn3416, 
      rtlcn3425, rtlcn3436, rtlcn3447, rtlcn3458, rtlcn3469, rtlcn3481, 
      rtlcn3504, rtlcn3516, rtlcn3537, rtlcn3547, rtlcn3553, rtlcn3568, 
      rtlcn3579, rtlcn3591, rtlcn3616, rtlcn3640, rtlcn3668, rtlcn3677, 
      rtlcn3693, rtlcn3704, rtlcn3720, rtlcn3724, rtlcn3736, rtlcn3748, 
      rtlcn3758, rtlcn3773, rtlcn3810, rtlcn3826, rtlcn3837, rtlcn3849, 
      rtlcn3857, rtlcn3860, rtlcn3929, rtlcn3930, rtlcn3931, rtlcn3932, 
      rtlcn3938, rtlcn3950, rtlcn3961, rtlcn3985, rtlcn3986, rtlcn4001, 
      rtlcn4016, rtlcn4031, rtlcn4042, rtlcn4057, rtlcn4066, rtlcn4079, 
      rtlcn4087, rtlcn4099, rtlcn4111, rtlcn4142, rtlcn4145, rtlcn4156, 
      rtlcn4157, rtlcn4158, rtlcn4159, rtlcn4185, rtlcn4186, rtlcn4187, 
      not_rtlcn9892, rtlcn4218, rtlcn4244, rtlcn4253, not_rtlcn4253, 
      rtlcn4265, not_rtlcn4265, rtlcn4285, not_rtlcn9879, rtlcn4289, 
      rtlcn4315, not_rtlcn4315, rtlcn4353, not_rtlcn9893, not_rtlcn9896, 
      rtlcn4450, rtlcn4454, rtlcn4457, rtlcn4471, rtlcn4475, rtlcn4479, 
      rtlcn4483, rtlcn4506, rtlcn4522, rtlcn4524, rtlcn4528, not_rtlcn9897, 
      rtlcn4554, rtlcn4557, rtlcn4566, rtlcn4570, rtlcn4574, rtlcn4578, 
      rtlcn4582, rtlcn4586, rtlcn4590, rtlcn4594, rtlcn4619, rtlcn4623, 
      rtlcn4627, rtlcn4635, not_rtlcn9895, not_rtlcn9894, rtlcn5178, 
      rtlcn5238, rtlcn5392, rtlcn5393, rtlcn5394, rtlcn5395, rtlcn5396, 
      rtlcn5404, rtlcn5414, rtlcn5416, rtlcn5417, rtlcn5418, rtlcn5425, 
      rtlcn5529, rtlcn5571, rtlcn5635, rtlcn5690, rtlcn5730, rtlcn5738, 
      rtlcn5781, rtlcn5822, rtlcn5823, rtlcn5837, rtlcn5838, rtlcn5877, 
      rtlcn5878, rtlcn5921, rtlcn5932, rtlcn5934, rtlcn5967, rtlcn5968, 
      rtlcn5970, rtlcn5979, rtlcn5982, rtlcn5994, rtlcn6003, rtlcn6004, 
      rtlcn6013, rtlcn6014, rtlcn6026, rtlcn6027, rtlcn6031, rtlcn6071, 
      rtlcn6074, rtlcn6078, rtlcn6091, rtlcn6104, rtlcn6137, rtlcn6142, 
      rtlcn6155, rtlcn6188, rtlcn6376, rtlcn6637, rtlcn6662, rtlcn6679, 
      rtlcn6681, rtlcn6683, rtlcn6690, rtlcn6702, rtlcn6744, rtlcn6769, 
      rtlcn6794, rtlcn6918, rtlcn6997, rtlcn7037, rtlcn7048, rtlcn7049, 
      rtlcn7050, rtlcn7064, rtlcn7067, rtlcn7074, rtlcn7081, rtlcn7082, 
      rtlcn7083, not_rtlc22n10429, rtlcn7090, rtlcn7091, rtlcn7141, 
      rtlcn7184, rtlcn7193, rtlcn7194, rtlcn7208, rtlcn7209, rtlcn7227, 
      rtlcn7228, rtlcn7234, rtlcn7235, rtlcn7250, rtlcn7310, rtlcn7311, 
      rtlcn7345, rtlcn7362, rtlcn7363, rtlcn7368, not_rtlcn9885, rtlcn7396, 
      rtlcn7404, rtlcn7433, rtlcn7443, rtlcn7451, rtlcn7465, rtlcn7480, 
      rtlcn7481, rtlcn7577, rtlcn7581, rtlcn7585, rtlcn7632, rtlcn7659, 
      not_rtlc22n8177, not_rtlc22n8155, not_rtlc22n8131, not_rtlc22n8108, 
      rtlcn7956, rtlcn7957, not_rtlcn9873, not_rtlcn9876, not_rtlcn9877, 
      not_rtlcn9878, not_rtlcn9865, not_rtlcn9882, not_rtlcn9883, rtlcn8146, 
      rtlcn8254, rtlcn8277, rtlcn8284, rtlcn8295, rtlcn8351, rtlcn8358, 
      rtlcn8366, rtlcn8375, rtlcn8379, rtlcn8383, rtlcn8386, rtlcn8390, 
      rtlcn8394, rtlcn8405, rtlcn8412, rtlcn8418, not_rtlcn9887, rtlcn8479, 
      rtlcn8482, rtlcn8548, not_rtlcn9884, rtlcn8558, rtlcn8563, rtlcn8583, 
      not_rtlcn9886, rtlcn8643, rtlcn8645, rtlcn8646, rtlcn8651, rtlcn8652, 
      rtlcn8653, rtlcn8668, rtlcn8669, rtlcn8681, rtlcn8685, rtlcn8707, 
      not_Config_reg_3_12, not_Config_reg_3_11, not_MON_EOM_phase_1, 
      not_MON_EOM_phase_0, not_MON_Phase_0, not_rtlcn9863, 
      not_Config_reg_5_9, rtlcn8785, not_rtlcn8785, not_rtlcn9864, rtlcn8789, 
      not_rtlcn8789, not_rtlcn9880, rtlcn8795, rtlcn8796, rtlcn8797, 
      rtlcn8798, rtlcn8799, rtlcn8801, rtlcn8802, rtlcn8803, rtlcn8804, 
      rtlcn8806, rtlcn8808, rtlcn8809, rtlcn8810, rtlcn8811, rtlcn8812, 
      rtlcn8813, rtlcn8815, rtlcn8817, rtlcn8818, rtlcn8819, rtlcn8820, 
      rtlcn8821, rtlcn8822, rtlcn8823, rtlcn8824, rtlcn8825, rtlcn8826, 
      rtlcn8827, rtlcn8828, rtlcn8829, rtlcn8830, rtlcn8831, rtlcn8833, 
      rtlcn8834, rtlcn8835, rtlcn8837, rtlcn8838, rtlcn8839, rtlcn8840, 
      rtlcn8841, not_rtlcn9889, rtlcn8844, rtlcn8846, rtlcn8849, rtlcn8851, 
      rtlcn8852, rtlcn8853, rtlcn8854, rtlcn8855, rtlcn8858, rtlcn8860, 
      rtlcn8861, rtlcn8862, rtlcn8865, rtlcn8867, rtlcn8868, rtlcn8869, 
      rtlcn8870, rtlcn8871, rtlcn8872, rtlcn8874, rtlcn8875, rtlcn8876, 
      rtlcn8877, rtlcn8878, rtlcn8879, rtlcn8880, rtlcn8881, rtlcn8882, 
      rtlcn8883, rtlcn8885, rtlcn8886, rtlcn8887, rtlcn8888, rtlcn8892, 
      rtlcn8897, rtlcn8898, rtlcn8900, rtlcn8901, rtlcn8902, rtlcn8905, 
      rtlcn8906, rtlcn8907, rtlcn8909, rtlcn8910, rtlcn8911, rtlcn8912, 
      rtlcn8913, rtlcn8914, rtlcn8915, rtlcn8916, rtlcn8917, rtlcn8918, 
      rtlcn8919, rtlcn8920, rtlcn8921, rtlcn8922, rtlcn8923, rtlcn8924, 
      rtlcn8925, rtlcn8927, rtlcn8928, rtlcn8929, rtlcn8930, rtlcn8933, 
      rtlcn8935, rtlcn8936, rtlcn8937, rtlcn8938, rtlcn8939, rtlcn8940, 
      rtlcn8941, rtlcn8942, rtlcn8943, rtlcn8944, rtlcn8945, rtlcn8946, 
      rtlcn8947, rtlcn8948, rtlcn8949, rtlcn8950, rtlcn8951, rtlcn8952, 
      rtlcn8953, rtlcn8954, rtlcn8957, rtlcn8958, rtlcn8959, rtlcn8961, 
      rtlcn8962, rtlcn8963, rtlcn8964, rtlcn8965, not_rtlc60n5464, 
      not_CPU_Address_4, not_MON_SOM_phase_2, not_rtlcn8796, rtlcn8978, 
      not_rtlc87n403, rtlcn8980, not_CE, not_rtlcn2638, rtlcn8986, 
      not_rtlcn8835, not_rtlcn9874, not_eBC_start_FT, rtlcn8992, 
      not_rtlc26n15184, rtlcn8994, rtlcn8998, rtlcn8999, rtlcn9002, 
      not_eBC_CFT_do, not_eBC_CMT_do, not_eBC_CMV_do, not_rtlcn10454, 
      rtlcn9010, rtlcn9011, rtlcn9012, not_rtlcs357, rtlcn9014, not_rtlcs355, 
      rtlcn9016, not_rtlcs356, rtlcn9018, rtlcn9020, rtlcn9022, rtlcn9024, 
      rtlcn9025, rtlcn9026, rtlcn9027, rtlcn9028, not_rtlc26n13295, 
      rtlcn9030, not_BC_Command_Sync, not_rtlcn8839, not_CPU_Data_in_wide_17, 
      rtlcn9036, rtlcn9037, rtlcn9038, rtlcn9039, not_rtlcn8813, rtlcn9043, 
      not_First_After_Reset, not_New_command_record, not_rtlcn8818, 
      rtlcn9047, rtlcn9049, rtlcn9050, rtlcn9051, rtlcn9052, rtlcn9053, 
      rtlcn9054, not_rtlc22n8275, not_Config_reg_2_0, not_Current_Area_B, 
      not_rtlcn8849, not_rtlcn8806, rtlcn9069, rtlcn9070, not_rtlc22n8280, 
      rtlcn9072, rtlcn9076, rtlcn9077, rtlcn9079, rtlcn9080, rtlcn9081, 
      rtlcn9083, rtlcn9084, not_rtlc26n13428, rtlcn9086, not_rtlcn9881, 
      not_rtlcn7659, rtlcn9092, rtlcn9094, not_MON_SOM_phase_3, 
      not_rtlc22n10476, not_rtlc22n10248, rtlcn9101, rtlcn9105, 
      not_rtlc60n6646, rtlcn9109, rtlcn9114, rtlcn9115, not_rtlc22n8398, 
      rtlcn9118, rtlcn9120, not_Phase_1, not_rtlcs66, rtlcn9123, rtlcn9126, 
      not_Data_Rollover, rtlcn9128, not_rtlcs152, not_Config_reg_3_14, 
      rtlcn9131, rtlcn9132, rtlcn9133, not_rtlcs151, rtlcn9135, rtlcn9136, 
      not_rtlc26n16088, not_BC_State_18, rtlcn9147, rtlcn9148, rtlcn9149, 
      rtlcn9150, not_BC_msg_pointer_2, rtlcn9156, rtlcn9157, 
      not_rtlc26n13041, rtlcn9159, not_rtlc26n15067, rtlcn9161, rtlcn9164, 
      not_rtlc22n7690, rtlcn9166, rtlcn9167, rtlcn9172, rtlcn9173, rtlcn9174, 
      rtlcn9176, rtlcn9182, rtlcn9183, not_rtlc60n5359, rtlcn9190, 
      not_rtlc60n6494, rtlcn9199, not_rtlc87n431, not_WM_Ack, rtlcn9202, 
      not_state_6, not_rtlcn8821, rtlcn9205, not_rtlc87n440, rtlcn9207, 
      rtlcn9208, rtlcn9209, rtlcn9210, not_rtlcn8870, rtlcn9212, rtlcn9213, 
      rtlcn9214, not_BC_START, rtlcn9216, rtlcn9217, rtlcn9218, 
      not_rtlc26n14491, rtlcn9220, not_rtlc26n12464, rtlcn9222, 
      not_rtlc26n13005, rtlcn9224, rtlcn9225, rtlcn9226, rtlcn9227, 
      not_rtlc26n12419, not_rtlc26n12441, not_rtlc26n12428, rtlcn9231, 
      rtlcn9232, rtlcn9233, rtlcn9234, rtlcn9235, not_rtlc26n14530, 
      rtlcn9237, rtlcn9238, rtlcn9239, rtlcn9240, rtlcn9242, rtlcn9243, 
      rtlcn9244, rtlcn9245, rtlcn9246, rtlcn9247, rtlcn9248, 
      not_rtlc26n13236, not_BC_State_32, not_BC_State_57, not_BC_State_63, 
      not_BC_State_31, not_rtlc26n13151, not_rtlc26n13144, rtlcn9257, 
      not_BC_State_0, rtlcn9259, not_rtlc26n15271, not_rtlcn8801, 
      not_rtlcn8912, rtlcn9264, not_rtlcn8803, rtlcn9267, rtlcn9268, 
      not_rtlc26n15015, rtlcn9270, not_rtlcn8804, not_BC_State_52, rtlcn9274, 
      rtlcn9275, rtlcn9276, rtlcn9277, rtlcn9278, not_rtlcn8827, rtlcn9280, 
      not_rtlc26n14359, rtlcn9282, rtlcn9283, rtlcn9284, rtlcn9285, 
      not_BC_Read, rtlcn9288, rtlcn9289, rtlcn9290, rtlcn9291, rtlcn9292, 
      rtlcn9293, rtlcn9294, rtlcn9295, rtlcn9296, rtlcn9297, rtlcn9298, 
      rtlcn9299, rtlcn9300, rtlcn9302, rtlcn9303, rtlcn9304, rtlcn9305, 
      rtlcn9306, rtlcn9307, rtlcn9308, rtlcn9309, rtlcn9310, rtlcn9311, 
      rtlcn9312, not_rtlc26n13194, rtlcn9314, rtlcn9315, rtlcn9316, 
      rtlcn9317, rtlcn9318, not_BC_State_8, rtlcn9320, not_rtlc26n14584, 
      not_rtlcn8819, rtlcn9323, rtlcn9324, rtlcn9325, not_rtlc26n12614, 
      rtlcn9327, rtlcn9328, rtlcn9329, rtlcn9330, not_rtlc26n13393, 
      rtlcn9332, rtlcn9333, rtlcn9334, rtlcn9335, not_rtlc26n12839, 
      rtlcn9337, rtlcn9338, rtlcn9339, rtlcn9340, rtlcn9341, rtlcn9342, 
      rtlcn9343, rtlcn9344, rtlcn9345, rtlcn9346, rtlcn9347, rtlcn9348, 
      rtlcn9349, rtlcn9350, not_BC_First_write, rtlcn9352, not_rtlc26n14300, 
      rtlcn9354, rtlcn9355, not_Clear_Test_Status_reg, rtlcn9357, rtlcn9359, 
      not_rtlc26n14740, rtlcn9361, rtlcn9363, not_BC_State_24, not_rtlcn9890, 
      rtlcn9368, rtlcn9369, rtlcn9370, rtlcn9371, not_rtlc26n15369, 
      rtlcn9373, not_rtlc26n14110, rtlcn9375, rtlcn9376, rtlcn9377, 
      rtlcn9378, rtlcn9379, rtlcn9380, rtlcn9381, rtlcn9382, rtlcn9383, 
      rtlcn9384, rtlcn9385, rtlcn9386, rtlcn9387, rtlcn9388, rtlcn9389, 
      rtlcn9390, rtlcn9391, rtlcn9392, rtlcn9393, rtlcn9394, 
      not_rtlc26n13384, rtlcn9396, not_rtlcn9891, rtlcn9400, 
      not_rtlc26n14017, rtlcn9402, rtlcn9403, rtlcn9404, rtlcn9405, 
      rtlcn9406, rtlcn9407, not_rtlc26n14265, rtlcn9409, rtlcn9410, 
      rtlcn9411, not_rtlcn8810, rtlcn9413, not_Ext_Trigger_Dx_0n0s4, 
      rtlcn9415, not_rtlc26n15182, rtlcn9417, rtlcn9418, rtlcn9419, 
      not_rtlc87n616, not_Arbiter_timeout, not_rtlc32n759, not_rtlcn8829, 
      not_rtlcn8844, rtlcn9435, not_rtlcn8902, not_rtlc60n6476, 
      not_rtlc22n8782, rtlcn9444, rtlcn9445, not_state_2, not_rtlcn8901, 
      not_rtlc60n6509, not_rtlcn9898, not_Config_reg_2_3, rtlcn9456, 
      not_rtlc87n790, not_rtlc29n681, not_rtlc22n8022, rtlcn9461, rtlcn9462, 
      rtlcn9463, rtlcn9464, rtlcn9468, not_rtlc22n10342, rtlcn9470, 
      not_rtlc60n5942, rtlcn9475, not_rtlc22n10298, rtlcn9480, not_rtlcn8871, 
      not_rtlcn8837, not_rtlcn9900, not_rtlcn5178, not_rtlcn9899, 
      not_rtlcn8840, not_rtlcn9901, rtlcn9493, rtlcn9495, rtlcn9496, 
      rtlcn9497, not_rtlcn8846, rtlcn9499, rtlcn9500, rtlcn9501, rtlcn9502, 
      not_rtlc22n8227, rtlcn9504, not_rtlc22n8249, rtlcn9507, not_rtlcn8802, 
      rtlcn9509, not_rtlcs84, not_rtlcs68, not_rtlcn8907, rtlcn9513, 
      not_Write, rtlcn9517, rtlcn9518, rtlcn9519, not_rtlc22n7730, rtlcn9521, 
      rtlcn9522, not_rtlc22n10133, not_rtlcs103, not_rtlc22n7221, rtlcn9526, 
      rtlcn9528, rtlcn9529, rtlcn9530, rtlcn9531, rtlcn9532, rtlcn9533, 
      rtlcn9534, rtlcn9536, rtlcn9537, not_rtlcn8867, rtlcn9540, rtlcn9547, 
      not_rtlc26n16112, rtlcn9843, rtlcn9848, not_rtlcn9848, rtlcn9855, 
      not_rtlc26n15497, not_rtlcn3748, rtlcn9860, rtlcn9862, rtlcn9863, 
      rtlcn9864, rtlcn9865, rtlcn9867, not_rtlcn9867, rtlcn9870, 
      not_rtlcn9870, rtlcn9873, rtlcn9874, rtlcn9875, rtlcn9876, rtlcn9877, 
      rtlcn9878, rtlcn9879, rtlcn9880, rtlcn9881, rtlcn9882, rtlcn9883, 
      rtlcn9884, rtlcn9885, rtlcn9886, rtlcn9887, rtlcn9888, rtlcn9889, 
      rtlcn9890, rtlcn9891, rtlcn9892, rtlcn9893, rtlcn9894, rtlcn9895, 
      rtlcn9896, rtlcn9897, rtlcn9898, rtlcn9899, rtlcn9900, rtlcn9901, 
      rtlcn9912, rtlcn9913, rtlcn9914, rtlcn9915, rtlcn9916, rtlcn9917, 
      rtlcn9918, rtlcn9919, rtlcn9920, rtlcn9921, rtlcn9922, rtlcn9923, 
      rtlcn9924, rtlcn9925, rtlcn9926, rtlcn9927, rtlcn9928, rtlcn9930, 
      rtlcn9932, rtlcn9933, rtlcn9936, rtlcn9937, rtlcn9938, rtlcn9939, 
      rtlcn9940, rtlcn9941, rtlcn9942, rtlcn9943, rtlcn9944, rtlcn9945, 
      rtlcn9946, rtlcn9947, rtlcn9948, rtlcn9949, rtlcn9950, rtlcn9951, 
      rtlcn9952, rtlcn9953, rtlcn9954, rtlcn9955, rtlcn9956, rtlcn9957, 
      rtlcn9958, not_rtlcn2077, rtlcn9960, not_rtlcn2079, rtlcn9962, 
      not_rtlc22n8435, rtlcn9964, not_rtlcn2081, rtlcn9966, not_rtlcn2084, 
      rtlcn9968, not_rtlcs60, not_rtlc22n8856, not_rtlcs49, rtlcn9972, 
      rtlcn9973, not_rtlc22n8064, not_rtlc22n8436, not_rtlc22n8434, 
      not_rtlcn8854, rtlcn9981, rtlcn9982, rtlcn9983, rtlcn9984, rtlcn9985, 
      rtlcn9986, not_rtlcn2468, rtlcn9988, not_rtlcn2467, rtlcn9990, 
      not_rtlcn2466, rtlcn9992, rtlcn9993, not_rtlc22n8835, not_rtlc22n8834, 
      not_rtlc22n8833, rtlcn9997, not_rtlc22n8060, not_rtlc22n8059, 
      not_rtlc22n8432, not_rtlc22n8431, not_rtlc22n8430, not_rtlc22n8429, 
      not_rtlc22n8428, not_rtlc22n8427, not_rtlc22n8426, rtlcn10007, 
      not_rtlc22n7771, rtlcn10010, not_rtlc22n7770, rtlcn10012, 
      not_rtlc22n7769, rtlcn10014, rtlcn10016, not_EOM_phase_0, not_rtlcs64, 
      not_rtlc22n10219, rtlcn10022, not_rtlcn11031, not_SOM_phase_0, 
      not_rtlcs102, not_MON_SOM_phase_0, rtlcn10032, not_rtlc26n16381, 
      rtlcn10035, not_rtlcn2497, not_BC_State_83, rtlcn10039, not_rtlcn2524, 
      rtlcn10044, not_BC_State_13, rtlcn10046, not_rtlc26n15481, 
      not_BC_Write, not_BC_State_44, not_rtlc26n19009, not_BC_State_15, 
      rtlcn10052, not_BC_State_40, rtlcn10054, not_rtlcn2522, rtlcn10057, 
      not_rtlcn2520, rtlcn10060, not_rtlc26n16321, not_rtlc22n7698, 
      rtlcn10068, not_rtlc22n7697, rtlcn10071, not_rtlc22n7696, rtlcn10073, 
      rtlcn10074, not_rtlcn2512, rtlcn10076, not_BC_State_16, 
      not_BC_State_17, not_BC_State_21, not_BC_State_23, not_BC_State_26, 
      not_BC_State_27, not_BC_State_28, not_BC_State_29, not_BC_State_33, 
      not_BC_State_34, not_BC_State_35, not_BC_State_41, not_BC_State_46, 
      not_BC_State_50, not_BC_State_53, not_BC_State_55, not_BC_State_60, 
      not_BC_State_61, not_BC_State_64, not_BC_State_66, not_BC_State_67, 
      not_BC_State_68, not_BC_State_69, not_BC_State_70, not_BC_State_72, 
      not_BC_State_76, not_BC_State_77, not_BC_State_78, not_BC_State_80, 
      not_BC_State_81, not_BC_State_82, not_BC_State_85, not_BC_State_89, 
      not_BC_State_90, not_BC_State_91, not_rtlcn9940, not_rtlcn2297, 
      not_BC_State_7, rtlcn10120, rtlcn10122, not_rtlc32n583, not_rtlc32n556, 
      not_rtlc32n555, not_rtlc32n554, not_rtlcn2479, not_rtlc32n552, 
      not_rtlc32n551, rtlcn10132, rtlcn10133, rtlcn10134, rtlcn10135, 
      rtlcn10136, rtlcn10137, rtlcn10138, rtlcn10139, rtlcn10140, rtlcn10141, 
      rtlcn10142, rtlcn10143, rtlcn10144, rtlcn10145, rtlcn10146, rtlcn10148, 
      rtlcn10150, not_rtlcn10264, not_rtlc60n5569, rtlcn10156, rtlcn10157, 
      not_rtlc60n5914, not_rtlcn2487, not_rtlcn2485, not_Config_reg_3_15, 
      not_First_Thing, not_M1760_D, not_rtlc60n5385, not_rtlc75n1438, 
      not_rtlc75n1969, not_rtlcn9912, not_rtlcn10215, not_rtlcn10214, 
      not_rtlc75n1968, not_rtlc75n1493, not_rtlcn10219, not_rtlcn10218, 
      not_rtlcn10217, not_rtlcn10216, not_rtlc75n1492, rtlcn10184, 
      rtlcn10185, rtlcn10186, rtlcn10187, rtlcn10188, rtlcn10189, 
      not_rtlcn2496, not_rtlcn2495, rtlcn10201, rtlcn10203, rtlcn10204, 
      rtlcn10205, rtlcn10206, rtlcn10207, rtlcn10208, rtlcn10211, rtlcn10212, 
      rtlcn10213, rtlcn10214, rtlcn10215, rtlcn10216, rtlcn10217, rtlcn10218, 
      rtlcn10219, rtlcn10220, rtlcn10221, rtlcn10222, rtlcn10223, rtlcn10224, 
      rtlcn10225, rtlcn10226, rtlcn10227, rtlcn10228, rtlcn10229, rtlcn10230, 
      rtlcn10231, rtlcn10232, rtlcs11, rtlcs13, rtlcs14, rtlcs16, rtlcs19, 
      not_monitor_data_pointer_14, not_monitor_data_pointer_13, 
      not_monitor_data_pointer_12, not_monitor_data_pointer_11, 
      not_monitor_data_pointer_10, not_monitor_data_pointer_9, rtlcs47, 
      rtlcs48, rtlcs50, rtlcs51, rtlcs52, rtlcs53, rtlcs54, rtlcs56, rtlcs57, 
      rtlcs59, rtlcs60, rtlcs61, rtlcs62, rtlcs64, rtlcs65, rtlcs66, rtlcs67, 
      rtlcs68, rtlcs69, rtlcs70, rtlcs71, rtlcs72, rtlcs73, rtlcs74, rtlcs75, 
      rtlcs76, rtlcs77, rtlcs78, rtlcs79, rtlcs81, rtlcs82, rtlcs83, rtlcs84, 
      rtlcs85, rtlcs86, rtlcs87, rtlcs88, rtlcs89, rtlcs90, rtlcs91, rtlcs92, 
      rtlcs93, rtlcs94, rtlcs95, rtlcs97, rtlcs98, rtlcs99, rtlcs100, 
      rtlcs101, rtlcs102, rtlcs103, rtlcs105, rtlcs106, rtlcs108, rtlcs109, 
      rtlcs114, rtlcs117, rtlcs118, rtlcs119, rtlcs120, rtlcs121, rtlcs122, 
      rtlcs123, rtlcs124, rtlcs127, rtlcs131, rtlcs133, rtlcs136, rtlcs137, 
      rtlcs138, rtlcs139, rtlcs140, rtlcs142, rtlcs143, rtlcs144, rtlcs145, 
      rtlcs148, rtlcs150, rtlcs151, rtlcs152, rtlcs153, rtlcs154, rtlcs156, 
      rtlcs157, rtlcs158, rtlcs159, rtlcs161, rtlcs162, rtlcs164, rtlcs165, 
      rtlcs168, rtlcs170, rtlcs171, rtlcs172, rtlcs173, rtlcs174, rtlcs178, 
      not_Current_command_4, rtlcs192, rtlcs199, rtlcs209, rtlcs210, 
      rtlcs211, rtlcs212, rtlcs213, rtlcs214, rtlcs215, rtlcs216, rtlcs217, 
      rtlcs218, rtlcs219, rtlcs220, rtlcs221, rtlcs222, rtlcs223, rtlcs224, 
      rtlcs225, rtlcs226, rtlcs227, rtlcs228, rtlcs230, rtlcs231, rtlcs232, 
      rtlcs234, rtlcs235, rtlcs236, rtlcs237, rtlcs239, rtlcs240, rtlcs242, 
      rtlcs243, rtlcs244, rtlcs246, rtlcs248, rtlcs249, rtlcs250, rtlcs251, 
      rtlcs252, rtlcs257, rtlcs258, rtlcs259, rtlcs260, rtlcs261, rtlcs262, 
      rtlcs264, rtlcs265, rtlcs267, rtlcs269, rtlcs270, rtlcs272, rtlcs273, 
      rtlcs274, rtlcs275, rtlcs276, rtlcs277, rtlcs281, rtlcs282, rtlcs285, 
      not_count_T_RESus_2, rtlcs288, rtlcs289, rtlcs290, not_count_T_RESus_3, 
      rtlcs292, rtlcs293, rtlcs294, rtlcs305, rtlcs307, rtlcs308, rtlcs309, 
      rtlcs311, rtlcs319, rtlcs320, not_CPU_Address_3, not_Current_command_9, 
      not_Current_command_8, not_Current_command_7, not_Current_command_6, 
      not_Current_command_5, not_Current_command_3, not_Current_command_0, 
      not_Current_command_2, not_Current_command_1, not_Config_reg_4_2, 
      not_Config_reg_4_0, rtlcn10264, not_BC_Rx_Data_7, not_BC_Rx_Data_6, 
      not_BC_Rx_Data_5, not_rtlc26n13678, not_Data_o_temp_11, 
      not_LIFO_Pointer_3, not_LIFO_Pointer_2, not_LIFO_Pointer_1, 
      not_LIFO_Pointer_0, not_Frame_length_reg_0xD_15, 
      not_Frame_length_reg_0xD_14, not_Frame_length_reg_0xD_13, 
      not_Frame_length_reg_0xD_12, not_Frame_length_reg_0xD_11, 
      not_Frame_length_reg_0xD_10, not_Frame_length_reg_0xD_9, 
      not_Frame_length_reg_0xD_8, not_Frame_length_reg_0xD_7, 
      not_Frame_length_reg_0xD_6, not_Frame_length_reg_0xD_5, 
      not_Frame_length_reg_0xD_4, not_Frame_length_reg_0xD_3, 
      not_Frame_length_reg_0xD_2, not_Frame_length_reg_0xD_1, 
      not_Frame_length_reg_0xD_0, not_Counter_100us_11, not_Counter_100us_10, 
      not_Counter_100us_9, not_Counter_100us_8, not_Counter_100us_7, 
      not_Counter_100us_6, not_Counter_100us_5, not_Counter_100us_4, 
      not_Counter_100us_3, not_Counter_100us_2, not_Counter_100us_1, 
      not_Counter_100us_0, not_Data_o_temp_15, not_Micro_second_counter_4, 
      not_Micro_second_counter_3, not_Micro_second_counter_2, 
      not_Micro_second_counter_1, not_Micro_second_counter_0, 
      not_Config_reg_3_13, not_ReTry_count_0, not_CPU_Data_in_wide_31, 
      not_rtlcs232, not_BC_msg_pointer_15, not_BC_msg_pointer_7, 
      not_rtlcn3857, not_BC_msg_pointer_14, not_BC_msg_pointer_6, 
      not_CPU_Data_in_wide_29, not_BC_msg_pointer_13, not_BC_msg_pointer_5, 
      not_CPU_Data_in_wide_28, not_BC_msg_pointer_12, 
      not_CPU_Data_in_wide_27, not_BC_msg_pointer_11, 
      not_CPU_Data_in_wide_26, not_BC_msg_pointer_10, rtlcn10454, 
      not_BC_msg_pointer_9, not_eBC_GP_do, not_CPU_Data_in_wide_24, 
      not_CPU_Data_in_wide_16, not_BC_msg_pointer_8, not_BC_Echo_word_1, 
      not_BC_State_86, not_eBC_Frame_length_15, not_eBC_Frame_length_14, 
      not_eBC_Frame_length_13, not_eBC_Frame_length_12, 
      not_eBC_Frame_length_11, not_eBC_Frame_length_10, 
      not_eBC_Frame_length_9, not_eBC_Frame_length_8, not_eBC_Frame_length_7, 
      not_eBC_Frame_length_6, not_eBC_Frame_length_5, not_eBC_Frame_length_4, 
      not_eBC_Frame_length_3, not_eBC_Frame_length_2, not_eBC_Frame_length_1, 
      not_eBC_Frame_length_0, not_BC_frame_GAP_counter_15, 
      not_BC_frame_GAP_counter_14, not_BC_frame_GAP_counter_13, 
      not_BC_frame_GAP_counter_12, not_BC_frame_GAP_counter_11, 
      not_BC_frame_GAP_counter_10, not_BC_frame_GAP_counter_9, 
      not_BC_frame_GAP_counter_8, not_BC_frame_GAP_counter_7, 
      not_BC_frame_GAP_counter_6, not_BC_frame_GAP_counter_5, 
      not_BC_frame_GAP_counter_4, not_BC_frame_GAP_counter_3, 
      not_BC_frame_GAP_counter_2, not_BC_frame_GAP_counter_1, not_rtlcn2772, 
      rtlcn10632, not_BC_word_number_1, not_rtlcn4244, rtlcn10652, 
      not_rtlcn4285, rtlcn10654, rtlcn10655, rtlcn10656, not_GMM_2, 
      not_GMM_1, not_GMM_0, not_LUT_Control_15, not_MM_2, not_MM_1, not_MM_0, 
      not_Config_reg_3_10, not_Config_reg_3_9, not_Config_reg_3_8, 
      not_rtlcs48, not_Phase_0, not_SOM_phase_8, not_Do_once_4, 
      not_Do_once_3, not_Do_once_2, not_Do_once_1, not_Do_once_0, 
      not_EOM_phase_1, rtlcn10752, rtlcn10753, rtlcn10754, rtlcn10755, 
      rtlcn10756, rtlcn10757, rtlcn10758, rtlcn10759, not_rtlcs67, 
      not_Monitor_Active_command_10, not_Monitor_Active_command_9, 
      not_Monitor_Active_command_8, not_Monitor_Active_command_7, 
      not_Monitor_Active_command_6, not_Monitor_Active_command_5, 
      not_Monitor_Active_command_3, not_Monitor_Active_command_2, 
      not_Monitor_Active_command_1, not_Address_9, not_Address_8, 
      not_Address_7, not_Address_6, not_Address_5, not_Address_3, 
      not_Address_2, not_Address_1, not_Config_reg_2_9, not_Config_reg_2_8, 
      not_Config_reg_2_7, not_rtlcn8707, rtlcn10838, not_count_T_RESus_5, 
      not_count_T_RESus_4, not_count_T_RESus_1, not_time_tag_14, 
      not_time_tag_13, not_time_tag_12, not_time_tag_11, not_time_tag_10, 
      not_time_tag_9, not_time_tag_8, not_time_tag_7, not_time_tag_6, 
      not_time_tag_5, not_time_tag_3, not_time_tag_2, not_time_tag_1, 
      not_time_tag_0, not_rtlc84n99, not_Do_RAM_test, 
      not_Monitor_Active_command_4, not_BC_Rx_Data_10, not_BC_Rx_Data_9, 
      not_BC_Rx_Data_8, not_eBC_IRQ_do, not_monitor_data_pointer_8, 
      not_monitor_stack_pointer_13, not_monitor_stack_pointer_11, 
      not_monitor_stack_pointer_9, not_monitor_stack_pointer_7, 
      not_Strobe_TT_D_1, rtlcn10962, rtlcn10964, rtlcn10966, rtlcn10967, 
      rtlcn11031, rtlcn11034, rtlcn11058, rtlcn11059, rtlcn11060, rtlcn11062, 
      rtlcn11108, not_rtlc29n262, not_INTn_count_3, not_INTn_count_2, 
      not_INTn_count_1, not_INTn_count_0, not_Config_reg_5_10, 
      not_BC_word_number_0, not_BC_TX_Data_10, not_BC_TX_Data_3, 
      not_BC_TX_Data_2, not_BC_TX_Data_1, not_BC_TX_Data_9, not_BC_TX_Data_8, 
      not_BC_TX_Data_7, not_BC_TX_Data_6, not_BC_TX_Data_5, rtlcn11137, 
      rtlcn11457, rtlcn12096, rtlcn12098, rtlcn12100, rtlcn12102, rtlcn12119, 
      rtlcn12120, rtlcn12121, rtlcn12122, rtlcn12123, rtlcn12124, rtlcn12131, 
      rtlcn12136: std_logic ;
   
   signal rtlcn12137: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlcn12140: std_logic_vector (14 DOWNTO 0) ;
   
   signal rtlcn12141: std_logic_vector (13 DOWNTO 0) ;
   
   signal not_rtlc51n276, rtlcs352, rtlcs353, rtlcs355, rtlcs356, rtlcs357, 
      rtlcs359, rtlcn15001, rtlcn15003, not_rtlcn15003, rtlcn15009, 
      not_rtlcn15009, rtlcn15013, not_rtlcn15013, rtlcn15023, rtlcn15024, 
      rtlcn15025, rtlcn15026, rtlcn15027, rtlcn15028, 
      Latched_Monitor_MIL1553_errors_invalid_command, 
      Latched_Monitor_MIL1553_errors_RT2RT_format_gap, 
      Latched_Monitor_MIL1553_errors_RT2RT_format_error, 
      Latched_Monitor_MIL1553_errors_Invalid_word, 
      Latched_Monitor_MIL1553_errors_incorrect_data_sync, 
      Latched_Monitor_MIL1553_errors_high_word_count, 
      Latched_Monitor_MIL1553_errors_Address_Parity, rtlcn15241, rtlcn15242, 
      rtlcn15243: std_logic ;
   
   signal BC_msg_pointer_26n43s1f1: std_logic_vector (8 DOWNTO 0) ;
   
   signal BC_Stack_pointer_26n167s1f1: std_logic_vector (8 DOWNTO 0) ;
   
   signal VARAM_D_26n172s1f1: std_logic_vector (4 DOWNTO 0) ;
   
   signal VARAM_D_26n172s1f2: std_logic_vector (4 DOWNTO 0) ;
   
   signal NOT_BC_State_59, NOT_BC_State_12, not_rtlc60n7249, not_rtlc60n7906, 
      not_rtlc60n7956, g0_I1_I_d, g0_I1_not_I_d, g0_I2_I_d, g0_I2_not_I_d, 
      rtlc22_1116_or_59_nx0, rtlc26_1554_or_91_nx0, rtlc26n16306, 
      rtlc26_2362_or_117_nx0, rtlc26_3207_or_128_nx0, rtlc26_3711_or_130_nx0, 
      rtlc26_5650_and_133_nx0, rtlc51_258_and_151_nx0, 
      rtlc60_1067_or_153_nx0, rtlc60_1071_or_154_nx0, rtlc_3211_or_204_nx0, 
      rtlc_12570_or_467_nx0, rtlc_12628_or_468_nx0, rtlc_13681_or_469_nx0, 
      rtlc_13716_or_471_nx0, rtlc_13720_or_473_nx0, rtlc_13736_or_474_nx0, 
      rtlc_13784_and_476_nx0, rtlc_13802_and_477_nx0, rtlc_13808_or_478_nx0, 
      rtlc_13815_or_479_nx0, rtlc_13826_or_481_nx0, rtlc_13830_or_482_nx0, 
      rtlc_13851_or_486_nx0, rtlc_13864_and_487_nx0, rtlc_13881_or_489_nx0, 
      rtlc_13905_or_492_nx0, rtlc_13938_and_493_nx0, rtlc_13967_or_495_nx0, 
      rtlc_13971_or_496_nx0, rtlc_13975_and_497_nx0, rtlc_13985_or_502_nx0, 
      rtlc_13989_or_503_nx0, rtlc_13990_or_504_nx0, rtlc_13992_or_505_nx0, 
      rtlc_14015_and_506_nx0, rtlcs110, eBC_TT_do_26n148s1, 
      rtlc_14136_or_509_nx0, rtlc_14139_and_510_nx0, rtlc_14148_or_511_nx0, 
      rtlc_14155_or_513_nx0, rtlc_14166_and_514_nx0, rtlcn2638, 
      rtlc_14208_or_518_nx0, rtlc_14228_or_520_nx0, rtlc_14236_and_521_nx0, 
      rtlc_14243_and_522_nx0, rtlc_14253_and_523_nx0, rtlc_14258_and_525_nx0, 
      rtlc_14260_and_526_nx0, rtlc_14277_and_529_nx0, rtlc_14280_or_531_nx0, 
      rtlc_14286_and_532_nx0, rtlc_14295_and_533_nx0, rtlc_14328_and_535_nx0, 
      rtlc_14329_or_536_nx0, rtlc_14367_or_541_nx0, rtlc_14380_and_542_nx0, 
      rtlc_14384_and_543_nx0, rtlc_14416_and_544_nx0, rtlc_14418_and_545_nx0, 
      rtlc_14419_and_546_nx0, rtlc_14431_and_547_nx0, rtlc_14432_or_548_nx0, 
      rtlc_14434_and_549_nx0, rtlc_14442_and_553_nx0, rtlc_14445_and_554_nx0, 
      rtlc_14461_and_556_nx0, rtlc_14469_and_559_nx0, rtlc_14498_and_563_nx0, 
      rtlc_14502_and_564_nx0, rtlc_14534_and_566_nx0, rtlc_14549_and_568_nx0, 
      rtlc_14552_and_569_nx0, rtlc_14560_or_570_nx0, rtlc_14573_and_571_nx0, 
      rtlc_14575_and_572_nx0, rtlc_14581_and_573_nx0, rtlc_14595_and_574_nx0, 
      rtlc_14604_and_575_nx0, rtlc_14608_and_576_nx0, rtlc_14638_and_579_nx0, 
      rtlc_14650_or_580_nx0, rtlc_14673_or_583_nx0, rtlc_14677_and_584_nx0, 
      rtlc_14708_and_586_nx0, rtlc_14746_and_589_nx0, rtlc_14756_or_591_nx0, 
      rtlc_14768_and_593_nx0, rtlc_14798_and_595_nx0, rtlc_14801_and_597_nx0, 
      rtlc_14803_and_598_nx0, rtlc_14804_or_599_nx0, rtlc_14807_and_600_nx0, 
      rtlc_14813_and_602_nx0, rtlc_14830_or_604_nx0, rtlc_14837_and_606_nx0, 
      rtlc_14845_and_608_nx0, rtlc_14850_or_609_nx0, rtlc_14859_and_610_nx0, 
      rtlc_14939_or_611_nx0, rtlc_14940_or_612_nx0, rtlc_14942_and_613_nx0, 
      rtlc_14943_and_614_nx0, rtlc_14944_and_615_nx0, rtlc_14948_or_619_nx0, 
      rtlc_14949_or_620_nx0, rtlc_14950_and_621_nx0, rtlc_14953_and_623_nx0, 
      rtlc_14954_or_624_nx0, rtlc_14955_or_625_nx0, rtlc_16285_or_629_nx0, 
      rtlc_16287_or_630_nx0, rtlc_16298_or_631_nx0, rtlc_16329_or_633_nx0, 
      rtlc_17513_and_642_nx0, rtlc_17524_and_643_nx0, rtlc_17529_and_644_nx0, 
      rtlc_17533_or_645_nx0, rtlc_17539_and_646_nx0, rtlc_17551_and_647_nx0, 
      rtlc_17553_and_648_nx0, rtlc_17556_and_649_nx0, rtlc_17570_and_650_nx0, 
      rtlc_17638_and_652_nx0, rtlc_17651_and_653_nx0, rtlc_17699_and_656_nx0, 
      rtlc51n276, rtlc_17733_or_658_nx0, rtlcn2772, rtlc_17772_and_661_nx0, 
      rtlc_17779_or_662_nx0, rtlc_17910_or_664_nx0, rtlc87n628, 
      rtlc_17931_and_668_nx0, rtlc_17933_and_670_nx0, rtlc_17934_and_671_nx0, 
      rtlcn2428, rtlc_17978_or_674_nx0, rtlc_18039_and_678_nx0, 
      rtlc_18064_and_679_nx0, rtlc_18085_and_680_nx0, rtlc_18090_and_681_nx0, 
      rtlc_18225_and_689_nx0, rtlc_18583_and_700_nx0, rtlc_18593_and_701_nx0, 
      rtlc_18624_and_702_nx0, rtlc_18928_and_724_nx0, rtlc_18933_and_725_nx0, 
      rtlc_18942_and_727_nx0, rtlc_19024_and_733_nx0, rtlc_19168_or_738_nx0, 
      rtlc_19825_or_752_nx0, rtlc_19826_or_753_nx0, nx101, nx109, nx116, 
      nx123, nx151, nx155, nx158, nx161, nx169, nx172, nx178, nx185, nx191, 
      nx198, nx204, nx212, nx218, nx224, nx230, nx236, nx244, nx252, nx260, 
      nx267, nx274, nx282, nx290, nx294, nx298, nx302, nx306, nx310, nx314, 
      nx318, nx322, nx326, nx330, nx334, nx338, nx342, nx346, nx350, nx354, 
      nx358, nx362, nx369, nx375, nx381, nx446, nx447, nx448, nx449, nx450, 
      nx451, nx452, nx453, nx454, nx455, nx456, nx457, nx458, nx459, nx460, 
      nx461, nx462, rtlcn9931, modgen_counter_Do_once_nx18, 
      modgen_counter_Do_once_nx21, modgen_counter_Do_once_nx24, 
      modgen_counter_Do_once_nx26, modgen_counter_Do_once_nx28, 
      modgen_counter_Do_once_nx30, modgen_counter_Do_once_nx32, 
      modgen_counter_Do_once_nx34, modgen_counter_Do_once_nx35, 
      modgen_counter_Do_once_nx36, modgen_counter_Do_once_nx37, 
      modgen_counter_Do_once_nx40, modgen_counter_Do_once_nx42, 
      modgen_counter_Do_once_nx44, modgen_counter_Do_once_nx46, 
      modgen_counter_Do_once_nx48, modgen_counter_Do_once_dec_nx28, 
      modgen_counter_Do_once_dec_nx42, modgen_counter_Do_once_dec_nx56, 
      nx596: std_logic ;
   
   signal Do_once: std_logic_vector (4 DOWNTO 0) ;
   
   signal nx601, nx605, nx609, nx613, nx642, nx707, nx709, nx711, nx713, 
      nx716, nx718, nx720, nx722, nx724, nx726, nx728, nx730, nx732, nx734, 
      nx742, nx744, nx746, nx748, nx750, nx752, nx754, nx756, nx758, nx760, 
      nx762, nx764, nx766, nx769: std_logic ;
   
   signal DANGLING : std_logic_vector (24 downto 0 );

begin
   BC_RT2RT <= BC_RT2RT_EXMPLR781 ;
   BC_Test <= BC_Test_EXMPLR782 ;
   IP_Freq_sel(1) <= debug_EXMPLR1003(15) ;
   IP_Freq_sel(0) <= debug_EXMPLR1003(15) ;
   TT_Load <= debug_EXMPLR1003(15) ;
   Tails_WE_vec(1) <= debug_EXMPLR1003(15) ;
   Tails_WE_vec(0) <= debug_EXMPLR1003(15) ;
   debug(15) <= debug_EXMPLR1003(15) ;
   debug(14) <= debug_EXMPLR1003(15) ;
   debug(13) <= debug_EXMPLR1003(15) ;
   debug(12) <= debug_EXMPLR1003(15) ;
   debug(11) <= debug_EXMPLR1003(15) ;
   debug(10) <= debug_EXMPLR1003(15) ;
   debug(9) <= debug_EXMPLR1003(15) ;
   debug(8) <= debug_EXMPLR1003(15) ;
   debug(7) <= debug_EXMPLR1003(15) ;
   debug(6) <= debug_EXMPLR1003(15) ;
   debug(5) <= debug_EXMPLR1003(15) ;
   debug(4) <= debug_EXMPLR1003(15) ;
   debug(3) <= debug_EXMPLR1003(15) ;
   debug(2) <= debug_EXMPLR1003(15) ;
   debug(1) <= debug_EXMPLR1003(15) ;
   debug(0) <= debug_EXMPLR1003(15) ;
   n16Mhz_12 <= debug_EXMPLR1003(15) ;
   pTDR_CS <= debug_EXMPLR1003(15) ;
   BC_1553A <= BC_1553A_EXMPLR864 ;
   BC_BUS_A <= BC_BUS_A_EXMPLR865 ;
   BC_Go <= BC_Go_EXMPLR866 ;
   BC_TX_Data(10) <= BC_TX_Data_10_EXMPLR872 ;
   BC_TX_Data(9) <= BC_TX_Data_9_EXMPLR873 ;
   BC_TX_Data(8) <= BC_TX_Data_8_EXMPLR874 ;
   BC_TX_Data(7) <= BC_TX_Data_7_EXMPLR875 ;
   BC_TX_Data(6) <= BC_TX_Data_6_EXMPLR876 ;
   BC_TX_Data(5) <= BC_TX_Data_5_EXMPLR877 ;
   BC_TX_Data(4) <= BC_TX_Data_4_EXMPLR878 ;
   BC_TX_Data(3) <= BC_TX_Data_3_EXMPLR879 ;
   BC_TX_Data(2) <= BC_TX_Data_2_EXMPLR880 ;
   BC_TX_Data(1) <= BC_TX_Data_1_EXMPLR881 ;
   BC_TX_Data(0) <= BC_TX_Data_0_EXMPLR882 ;
   BC_on <= BC_on_EXMPLR883 ;
   Config_reg_4(15) <= debug_EXMPLR1003(15) ;
   Config_reg_4(14) <= debug_EXMPLR1003(15) ;
   Config_reg_4(13) <= debug_EXMPLR1003(15) ;
   Config_reg_4(12) <= debug_EXMPLR1003(15) ;
   Config_reg_4(11) <= debug_EXMPLR1003(15) ;
   Config_reg_4(10) <= debug_EXMPLR1003(15) ;
   Config_reg_4(9) <= debug_EXMPLR1003(15) ;
   Config_reg_4(8) <= debug_EXMPLR1003(15) ;
   Config_reg_4(7) <= debug_EXMPLR1003(15) ;
   Config_reg_4(6) <= Config_reg_4_EXMPLR998(6) ;
   Config_reg_4(5) <= Config_reg_4_EXMPLR998(5) ;
   Config_reg_4(4) <= debug_EXMPLR1003(15) ;
   Config_reg_4(3) <= debug_EXMPLR1003(15) ;
   Config_reg_4(2) <= debug_EXMPLR1003(15) ;
   Config_reg_4(1) <= debug_EXMPLR1003(15) ;
   Config_reg_4(0) <= debug_EXMPLR1003(15) ;
   Data_to_FE(15) <= Data_to_FE_EXMPLR999(15) ;
   Data_to_FE(14) <= Data_to_FE_EXMPLR999(14) ;
   Data_to_FE(13) <= Data_to_FE_EXMPLR999(13) ;
   Data_to_FE(12) <= Data_to_FE_EXMPLR999(12) ;
   Data_to_FE(11) <= Data_to_FE_EXMPLR999(11) ;
   Data_to_FE(10) <= Data_to_FE_EXMPLR999(10) ;
   Data_to_FE(9) <= Data_to_FE_EXMPLR999(9) ;
   Data_to_FE(8) <= Data_to_FE_EXMPLR999(8) ;
   Data_to_FE(7) <= Data_to_FE_EXMPLR999(7) ;
   Data_to_FE(6) <= Data_to_FE_EXMPLR999(6) ;
   Data_to_FE(5) <= Data_to_FE_EXMPLR999(5) ;
   Data_to_FE(4) <= Data_to_FE_EXMPLR999(4) ;
   Data_to_FE(3) <= Data_to_FE_EXMPLR999(3) ;
   Data_to_FE(2) <= Data_to_FE_EXMPLR999(2) ;
   Data_to_FE(1) <= Data_to_FE_EXMPLR999(1) ;
   Data_to_FE(0) <= Data_to_FE_EXMPLR999(0) ;
   Do_illegal <= Do_illegal_EXMPLR916 ;
   MODE_CODE1553A <= MODE_CODE1553A_EXMPLR917 ;
   NO_BCST <= debug_EXMPLR1003(15) ;
   RT_Address(5) <= debug_EXMPLR1003(15) ;
   RT_Address(4) <= debug_EXMPLR1003(15) ;
   RT_Address(3) <= debug_EXMPLR1003(15) ;
   RT_Address(2) <= debug_EXMPLR1003(15) ;
   RT_Address(1) <= debug_EXMPLR1003(15) ;
   RT_Address(0) <= debug_EXMPLR1003(15) ;
   RT_On <= RT_On_EXMPLR924 ;
   ResetN <= ResetN_EXMPLR925 ;
   WM_Ack <= WM_Ack_EXMPLR926 ;
   WM_Started <= WM_Started_EXMPLR927 ;
   host_status_bits(3) <= host_status_bits_3_EXMPLR935 ;
   illegal_message <= illegal_message_EXMPLR939 ;
   time_tag(15) <= time_tag_EXMPLR1002(15) ;
   time_tag(14) <= time_tag_EXMPLR1002(14) ;
   time_tag(13) <= time_tag_EXMPLR1002(13) ;
   time_tag(12) <= time_tag_EXMPLR1002(12) ;
   time_tag(11) <= time_tag_EXMPLR1002(11) ;
   time_tag(10) <= time_tag_EXMPLR1002(10) ;
   time_tag(9) <= time_tag_EXMPLR1002(9) ;
   time_tag(8) <= time_tag_EXMPLR1002(8) ;
   time_tag(7) <= time_tag_EXMPLR1002(7) ;
   time_tag(6) <= time_tag_EXMPLR1002(6) ;
   time_tag(5) <= time_tag_EXMPLR1002(5) ;
   time_tag(4) <= time_tag_EXMPLR1002(4) ;
   time_tag(3) <= time_tag_EXMPLR1002(3) ;
   time_tag(2) <= time_tag_EXMPLR1002(2) ;
   time_tag(1) <= time_tag_EXMPLR1002(1) ;
   time_tag(0) <= time_tag_EXMPLR1002(0) ;
   debug_EXMPLR1003(15) <= '0' ;
   PWR <= '1' ;
   g0_I5 : RAM2_5_16_1 port map ( D(15)=>VARAM_D(15), D(14)=>VARAM_D(14), 
      D(13)=>VARAM_D(13), D(12)=>VARAM_D(12), D(11)=>VARAM_D(11), D(10)=>
      VARAM_D(10), D(9)=>VARAM_D(9), D(8)=>VARAM_D(8), D(7)=>VARAM_D(7), 
      D(6)=>VARAM_D(6), D(5)=>VARAM_D(5), D(4)=>VARAM_D(4), D(3)=>VARAM_D(3), 
      D(2)=>VARAM_D(2), D(1)=>VARAM_D(1), D(0)=>VARAM_D(0), A(4)=>
      VARAM_ADD(4), A(3)=>VARAM_ADD(3), A(2)=>VARAM_ADD(2), A(1)=>
      VARAM_ADD(1), A(0)=>VARAM_ADD(0), WE=>VARAM_WE, Q(15)=>VARAM_Q(15), 
      Q(14)=>VARAM_Q(14), Q(13)=>VARAM_Q(13), Q(12)=>VARAM_Q(12), Q(11)=>
      VARAM_Q(11), Q(10)=>VARAM_Q(10), Q(9)=>VARAM_Q(9), Q(8)=>VARAM_Q(8), 
      Q(7)=>VARAM_Q(7), Q(6)=>VARAM_Q(6), Q(5)=>VARAM_Q(5), Q(4)=>VARAM_Q(4), 
      Q(3)=>VARAM_Q(3), Q(2)=>VARAM_Q(2), Q(1)=>VARAM_Q(1), Q(0)=>VARAM_Q(0), 
      Clock=>clock);
   eBC_Conditions_9 <= eBC_Conditions_9_0n0s2 OR BC_Sts_Word(3) ;
   eBC_Conditions_9_0n0s2 <= eBC_Conditions_9_0n0s3 OR BC_Sts_Word(2) ;
   eBC_Conditions_9_0n0s3 <= BC_Sts_Word(0) OR BC_Sts_Word(1) ;
   Ext_Trigger_Dx <= Ext_Trigger_Dx_0n0s2 AND Config_reg_1(7) ;
   Ext_Trigger_Dx_0n0s2 <= Ext_Trigger_Dx_0n0s4 AND Ext_Trigger_Dx_0n0s6 ;
   Ext_Trigger_Dx_0n0s4 <= Ext_Trigger_D AND not_Ext_Trigger_DD ;
   not_Ext_Trigger_DD <= NOT Ext_Trigger_DD ;
   Ext_Trigger_Dx_0n0s6 <= BC_on_EXMPLR883 OR WM_On ;
   test_complete <= Test_Status_reg_15 OR Test_Status_reg_7 ;
   RETRY_ON_1553A <= Config_reg_4_EXMPLR998(10) AND BC_1553A_EXMPLR864 ;
   ADDr_i_A_select_0Bus1_0 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(0), b(1)=>BC_Ram_Address(0), b(0)=>Ram_Address(0), 
      d=>ADDr_i_A(0));
   ADDr_i_A_select_0Bus1_1 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(1), b(1)=>BC_Ram_Address(1), b(0)=>Ram_Address(1), 
      d=>ADDr_i_A(1));
   ADDr_i_A_select_0Bus1_2 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(2), b(1)=>BC_Ram_Address(2), b(0)=>Ram_Address(2), 
      d=>ADDr_i_A(2));
   ADDr_i_A_select_0Bus1_3 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(3), b(1)=>BC_Ram_Address(3), b(0)=>Ram_Address(3), 
      d=>ADDr_i_A(3));
   ADDr_i_A_select_0Bus1_4 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(4), b(1)=>BC_Ram_Address(4), b(0)=>Ram_Address(4), 
      d=>ADDr_i_A(4));
   ADDr_i_A_select_0Bus1_5 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(5), b(1)=>BC_Ram_Address(5), b(0)=>Ram_Address(5), 
      d=>ADDr_i_A(5));
   ADDr_i_A_select_0Bus1_6 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(6), b(1)=>BC_Ram_Address(6), b(0)=>Ram_Address(6), 
      d=>ADDr_i_A(6));
   ADDr_i_A_select_0Bus1_7 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(7), b(1)=>BC_Ram_Address(7), b(0)=>Ram_Address(7), 
      d=>ADDr_i_A(7));
   ADDr_i_A_select_0Bus1_8 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(8), b(1)=>BC_Ram_Address(8), b(0)=>Ram_Address(8), 
      d=>ADDr_i_A(8));
   ADDr_i_A_select_0Bus1_9 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(9), b(1)=>BC_Ram_Address(9), b(0)=>Ram_Address(9), 
      d=>ADDr_i_A(9));
   ADDr_i_A_select_0Bus1_10 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(10), b(1)=>BC_Ram_Address(10), b(0)=>
      Ram_Address(10), d=>ADDr_i_A(10));
   ADDr_i_A_select_0Bus1_11 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(11), b(1)=>BC_Ram_Address(11), b(0)=>
      Ram_Address(11), d=>ADDr_i_A(11));
   ADDr_i_A_select_0Bus1_12 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(12), b(1)=>BC_Ram_Address(12), b(0)=>
      Ram_Address(12), d=>ADDr_i_A(12));
   ADDr_i_A_select_0Bus1_13 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(13), b(1)=>BC_Ram_Address(13), b(0)=>
      Ram_Address(13), d=>ADDr_i_A(13));
   ADDr_i_A_select_0Bus1_14 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(14), b(1)=>BC_Ram_Address(14), b(0)=>
      Ram_Address(14), d=>ADDr_i_A(14));
   ADDr_i_A_select_0Bus1_15 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_Address(15), b(1)=>BC_Ram_Address(15), b(0)=>
      Ram_Address(15), d=>ADDr_i_A(15));
   not_BC_State_1 <= NOT BC_State(1) ;
   rtlc1n30 <= BC_on_EXMPLR883 AND not_BC_State_1 ;
   not_WM_Started <= NOT WM_Started_EXMPLR927 ;
   rtlc1_P5_SS0_n33 <= not_WM_Started AND rtlc1n30 ;
   Data_i_A_select_16Bus6_0 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(0), b(1)=>BC_Ram_data(0), b(0)=>Ram_data_i(0), d=>
      Data_i_A(0));
   Data_i_A_select_16Bus6_1 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(1), b(1)=>BC_Ram_data(1), b(0)=>Ram_data_i(1), d=>
      Data_i_A(1));
   Data_i_A_select_16Bus6_2 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(2), b(1)=>BC_Ram_data(2), b(0)=>Ram_data_i(2), d=>
      Data_i_A(2));
   Data_i_A_select_16Bus6_3 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(3), b(1)=>BC_Ram_data(3), b(0)=>Ram_data_i(3), d=>
      Data_i_A(3));
   Data_i_A_select_16Bus6_4 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(4), b(1)=>BC_Ram_data(4), b(0)=>Ram_data_i(4), d=>
      Data_i_A(4));
   Data_i_A_select_16Bus6_5 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(5), b(1)=>BC_Ram_data(5), b(0)=>Ram_data_i(5), d=>
      Data_i_A(5));
   Data_i_A_select_16Bus6_6 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(6), b(1)=>BC_Ram_data(6), b(0)=>Ram_data_i(6), d=>
      Data_i_A(6));
   Data_i_A_select_16Bus6_7 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(7), b(1)=>BC_Ram_data(7), b(0)=>Ram_data_i(7), d=>
      Data_i_A(7));
   Data_i_A_select_16Bus6_8 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(8), b(1)=>BC_Ram_data(8), b(0)=>Ram_data_i(8), d=>
      Data_i_A(8));
   Data_i_A_select_16Bus6_9 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(9), b(1)=>BC_Ram_data(9), b(0)=>Ram_data_i(9), d=>
      Data_i_A(9));
   Data_i_A_select_16Bus6_10 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(10), b(1)=>BC_Ram_data(10), b(0)=>Ram_data_i(10), 
      d=>Data_i_A(10));
   Data_i_A_select_16Bus6_11 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(11), b(1)=>BC_Ram_data(11), b(0)=>Ram_data_i(11), 
      d=>Data_i_A(11));
   Data_i_A_select_16Bus6_12 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(12), b(1)=>BC_Ram_data(12), b(0)=>Ram_data_i(12), 
      d=>Data_i_A(12));
   Data_i_A_select_16Bus6_13 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(13), b(1)=>BC_Ram_data(13), b(0)=>Ram_data_i(13), 
      d=>Data_i_A(13));
   Data_i_A_select_16Bus6_14 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(14), b(1)=>BC_Ram_data(14), b(0)=>Ram_data_i(14), 
      d=>Data_i_A(14));
   Data_i_A_select_16Bus6_15 : select_3_3 port map ( a(2)=>
      WM_Started_EXMPLR927, a(1)=>rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, 
      b(2)=>WM_RAM_data_i(15), b(1)=>BC_Ram_data(15), b(0)=>Ram_data_i(15), 
      d=>Data_i_A(15));
   WE_A_select_32 : select_3_3 port map ( a(2)=>WM_Started_EXMPLR927, a(1)=>
      rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, b(2)=>WM_RAM_WE, b(1)=>
      BC_Ram_WE, b(0)=>Ram_WE, d=>WE_A);
   RE_A_select_33 : select_3_3 port map ( a(2)=>WM_Started_EXMPLR927, a(1)=>
      rtlc1_P5_SS0_n33, a(0)=>not_rtlcn1237, b(2)=>WM_Ram_RE, b(1)=>
      BC_Ram_RE, b(0)=>Ram_RE, d=>RE_A);
   not_SW_Reset <= NOT SW_Reset ;
   not_MEM_nREG <= NOT MEM_nREG ;
   not_BC_SP <= NOT BC_SP ;
   rtlc12n13 <= BC_SP_D AND not_BC_SP ;
   rtlc13n16 <= MEM_nREG AND CPU_CS ;
   rtlc16n20 <= not_Config_reg_6_5 OR not_RTAD_SW_EN ;
   rtlc16n22 <= rtlc16n20 OR not_RT_ADR_LAT ;
   not_Config_reg_6_5 <= NOT Config_reg_6_5 ;
   not_RTAD_SW_EN <= NOT RTAD_SW_EN ;
   not_RT_ADR_LAT <= NOT RT_ADR_LAT ;
   Latched_Monitor_MIL1553_errors_0_22n1s1 <= 
   Latched_Monitor_MIL1553_errors_invalid_command OR 
   Monitor_MIL1553_errors_invalid_command ;
   Latched_Monitor_MIL1553_errors_1_22n1s2 <= 
   Latched_Monitor_MIL1553_errors_RT2RT_format_gap OR 
   Monitor_MIL1553_errors_RT2RT_format_gap ;
   Latched_Monitor_MIL1553_errors_2_22n1s3 <= 
   Latched_Monitor_MIL1553_errors_RT2RT_format_error OR 
   Monitor_MIL1553_errors_RT2RT_format_error ;
   Latched_Monitor_MIL1553_errors_3_22n1s4 <= 
   Latched_Monitor_MIL1553_errors_Invalid_word OR 
   Monitor_MIL1553_errors_Invalid_word ;
   Latched_Monitor_MIL1553_errors_4_22n1s5 <= 
   Latched_Monitor_MIL1553_errors_incorrect_data_sync OR 
   Monitor_MIL1553_errors_incorrect_data_sync ;
   Latched_Monitor_MIL1553_errors_5_22n1s6 <= 
   Latched_Monitor_MIL1553_errors_5_22n1s7 OR 
   Monitor_MIL1553_errors_Low_word_count ;
   Latched_Monitor_MIL1553_errors_5_22n1s7 <= 
   Latched_Monitor_MIL1553_errors_high_word_count OR 
   Monitor_MIL1553_errors_high_word_count ;
   Latched_Monitor_MIL1553_errors_6_22n1s8 <= 
   Latched_Monitor_MIL1553_errors_Address_Parity OR 
   Monitor_MIL1553_errors_Address_Parity ;
   Latched_Monitor_data_stack_rollover_22n1s1 <= 
   Latched_Monitor_data_stack_rollover OR Monitor_data_stack_rollover ;
   Latched_Monitor_ended_OK_22n1s1 <= Latched_Monitor_ended_OK OR 
   Monitor_MIL1553_errors_Inhibit_TF ;
   Ram_data_i_8_22n8s3 <= MIL1553_errors_echo_back_bus_A OR 
   MIL1553_errors_echo_back_bus_B ;
   not_bus_A <= NOT bus_A ;
   not_data_pointer_5 <= NOT data_pointer(5) ;
   rtlc22n10048 <= EOM_phase(1) OR EOM_phase(3) ;
   rtlc22n10050 <= EOM_phase(0) OR EOM_phase(1) ;
   not_rtlc22n10050 <= NOT rtlc22n10050 ;
   Ram_data_i_select_22i1Bus88_0 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_0_22n2s1, b(2)=>debug_EXMPLR1003(15), b(1)=>data_pointer(0), 
      b(0)=>stack_pointer(0), d=>Ram_data_i_22n27ss1(0));
   rtlc22n10068 <= EOM_phase(2) OR EOM_phase(4) ;
   Ram_data_i_select_22i1Bus88_1 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_1_22n2s3, b(2)=>debug_EXMPLR1003(15), b(1)=>data_pointer(1), 
      b(0)=>stack_pointer(1), d=>Ram_data_i_22n27ss1(1));
   Ram_data_i_select_22i1Bus88_2 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_2_22n2s4, b(2)=>debug_EXMPLR1003(15), b(1)=>data_pointer(2), 
      b(0)=>stack_pointer(2), d=>Ram_data_i_22n27ss1(2));
   Ram_data_i_select_22i1Bus88_3 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_3_22n2s5, b(2)=>debug_EXMPLR1003(15), b(1)=>data_pointer(3), 
      b(0)=>stack_pointer(3), d=>Ram_data_i_22n27ss1(3));
   Ram_data_i_select_22i1Bus88_4 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_4_22n2s6, b(2)=>debug_EXMPLR1003(15), b(1)=>data_pointer(4), 
      b(0)=>stack_pointer(4), d=>Ram_data_i_22n27ss1(4));
   Ram_data_i_select_22i6 : select_5_5 port map ( a(4)=>EOM_phase(0), a(3)=>
      EOM_phase(1), a(2)=>EOM_phase(2), a(1)=>EOM_phase(3), a(0)=>
      EOM_phase(4), b(4)=>Ram_data_i_5_22n2s7, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>not_data_pointer_5, b(1)=>stack_pointer(5), b(0)=>
      data_pointer(5), d=>Ram_data_i_22n27ss1(5));
   Ram_data_i_select_22i7Bus89_6 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_6_22n2s8, b(2)=>illegal_message_EXMPLR939, b(1)=>
      data_pointer(6), b(0)=>stack_pointer(6), d=>Ram_data_i_22n27ss1(6));
   Ram_data_i_select_22i7Bus89_8 : select_4_4 port map ( a(3)=>EOM_phase(0), 
      a(2)=>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_8_22n2s10, b(2)=>Ram_data_i_8_22n8s3, b(1)=>data_pointer(8), 
      b(0)=>stack_pointer(8), d=>Ram_data_i_22n27ss1(8));
   Ram_data_i_select_22i9 : select_4_4 port map ( a(3)=>EOM_phase(0), a(2)=>
      EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      Ram_data_i_11_22n2s14, b(2)=>RT2RT_Message, b(1)=>data_pointer(11), 
      b(0)=>stack_pointer(11), d=>Ram_data_i_22n27ss1(11));
   Ram_data_i_select_22i10 : select_4_4 port map ( a(3)=>EOM_phase(0), a(2)
      =>EOM_phase(1), a(1)=>rtlc22n10068, a(0)=>EOM_phase(3), b(3)=>
      debug_EXMPLR1003(15), b(2)=>PWR, b(1)=>data_pointer(15), b(0)=>
      stack_pointer(15), d=>Ram_data_i_22n27ss1(15));
   rtlc22n10084 <= EOM_phase(0) OR EOM_phase(4) ;
   not_rtlc22n10084 <= NOT rtlc22n10084 ;
   illegal_message_mux_22i11 : mux_16u_16u port map ( a(15)=>Data_o_temp(15), 
      a(14)=>Data_o_temp(14), a(13)=>Data_o_temp(13), a(12)=>Data_o_temp(12), 
      a(11)=>Data_o_temp(11), a(10)=>Data_o_temp(10), a(9)=>Data_o_temp(9), 
      a(8)=>Data_o_temp(8), a(7)=>Data_o_temp(7), a(6)=>Data_o_temp(6), a(5)
      =>Data_o_temp(5), a(4)=>Data_o_temp(4), a(3)=>Data_o_temp(3), a(2)=>
      Data_o_temp(2), a(1)=>Data_o_temp(1), a(0)=>Data_o_temp(0), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>
      Current_command(3), b(2)=>Current_command(2), b(1)=>Current_command(1), 
      b(0)=>Current_command(0), d=>illegal_message_22n31s1);
   BUSY_in_LUT_mux_22i12 : mux_16u_16u port map ( a(15)=>Data_o_temp(15), 
      a(14)=>Data_o_temp(14), a(13)=>Data_o_temp(13), a(12)=>Data_o_temp(12), 
      a(11)=>Data_o_temp(11), a(10)=>Data_o_temp(10), a(9)=>Data_o_temp(9), 
      a(8)=>Data_o_temp(8), a(7)=>Data_o_temp(7), a(6)=>Data_o_temp(6), a(5)
      =>Data_o_temp(5), a(4)=>Data_o_temp(4), a(3)=>Data_o_temp(3), a(2)=>
      Data_o_temp(2), a(1)=>Data_o_temp(1), a(0)=>Data_o_temp(0), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>
      Current_command(8), b(2)=>Current_command(7), b(1)=>Current_command(6), 
      b(0)=>Current_command(5), d=>BUSY_in_LUT_22n33s1);
   not_Current_command_10 <= NOT Current_command(10) ;
   rtlc22n10119 <= SOM_phase_1 OR Do_illegal_EXMPLR916 ;
   Ram_data_i_select_22i13Bus96_0 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(0), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(0), b(1)=>
      time_tag_EXMPLR1002(0), b(0)=>data_pointer(0), d=>
      Ram_data_i_22n50ss1_0);
   Ram_data_i_select_22i13Bus96_1 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(1), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(1), b(1)=>
      time_tag_EXMPLR1002(1), b(0)=>data_pointer(1), d=>
      Ram_data_i_22n50ss1_1);
   Ram_data_i_select_22i13Bus96_2 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(2), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(2), b(1)=>
      time_tag_EXMPLR1002(2), b(0)=>data_pointer(2), d=>
      Ram_data_i_22n50ss1_2);
   Ram_data_i_select_22i13Bus96_3 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(3), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(3), b(1)=>
      time_tag_EXMPLR1002(3), b(0)=>data_pointer(3), d=>
      Ram_data_i_22n50ss1_3);
   Ram_data_i_select_22i13Bus96_4 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(4), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(4), b(1)=>
      time_tag_EXMPLR1002(4), b(0)=>data_pointer(4), d=>
      Ram_data_i_22n50ss1_4);
   Ram_data_i_select_22i13Bus96_5 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(5), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(5), b(1)=>
      time_tag_EXMPLR1002(5), b(0)=>data_pointer(5), d=>
      Ram_data_i_22n50ss1_5);
   Ram_data_i_select_22i13Bus96_6 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(6), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(6), b(1)=>
      time_tag_EXMPLR1002(6), b(0)=>data_pointer(6), d=>
      Ram_data_i_22n50ss1_6);
   Ram_data_i_select_22i13Bus96_7 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(7), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(7), b(1)=>
      time_tag_EXMPLR1002(7), b(0)=>data_pointer(7), d=>
      Ram_data_i_22n50ss1_7);
   Ram_data_i_select_22i13Bus96_8 : select_5_5 port map ( a(4)=>
      not_rtlc22n10133, a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>
      SOM_phase_7, a(0)=>SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(8), b(3)=>
      debug_EXMPLR1003(15), b(2)=>Current_command(8), b(1)=>
      time_tag_EXMPLR1002(8), b(0)=>data_pointer(8), d=>
      Ram_data_i_22n50ss1_8);
   Ram_data_i_select_22i22 : select_5_5 port map ( a(4)=>not_rtlc22n10133, 
      a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>
      SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(11), b(3)=>debug_EXMPLR1003(15), 
      b(2)=>Current_command(11), b(1)=>time_tag_EXMPLR1002(11), b(0)=>
      data_pointer(11), d=>Ram_data_i_22n50ss1_11);
   Ram_data_i_select_22i23 : select_5_5 port map ( a(4)=>not_rtlc22n10133, 
      a(3)=>SOM_phase_5, a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>
      SOM_phase_9, b(4)=>Ram_data_i_22n27ss1(15), b(3)=>debug_EXMPLR1003(15), 
      b(2)=>Current_command(15), b(1)=>time_tag_EXMPLR1002(15), b(0)=>
      data_pointer(15), d=>Ram_data_i_22n50ss1_15);
   rtlc22n10219 <= rtlcs65 OR rtlcs102 ;
   Ram_data_i_12_22n78s1 <= MM_Error_detected OR 
   Latched_Monitor_MIL1553_errors_Address_Parity ;
   rtlc22n10309 <= rtlcs64 OR rtlcs61 ;
   Record_enable_22n87s1 <= Record_enable_22n87s2 AND Config_reg_1(12) ;
   Record_enable_mux_22i24 : mux_16u_16u port map ( a(15)=>Data_o_temp(15), 
      a(14)=>Data_o_temp(14), a(13)=>Data_o_temp(13), a(12)=>Data_o_temp(12), 
      a(11)=>Data_o_temp(11), a(10)=>Data_o_temp(10), a(9)=>Data_o_temp(9), 
      a(8)=>Data_o_temp(8), a(7)=>Data_o_temp(7), a(6)=>Data_o_temp(6), a(5)
      =>Data_o_temp(5), a(4)=>Data_o_temp(4), a(3)=>Data_o_temp(3), a(2)=>
      Data_o_temp(2), a(1)=>Data_o_temp(1), a(0)=>Data_o_temp(0), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>
      Monitor_Active_command(8), b(2)=>Monitor_Active_command(7), b(1)=>
      Monitor_Active_command(6), b(0)=>Monitor_Active_command(5), d=>
      Record_enable_22n87s2);
   Ram_Address_select_22i95Bus107_1 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>not_rtlcn8785, a(0)=>
      rtlc22n10314, b(3)=>Ram_Address_22n85ss1(1), b(2)=>
      Monitor_Active_command(10), b(1)=>PWR, b(0)=>debug_EXMPLR1003(15), d=>
      Ram_Address_22n103ss1(1));
   rtlc22n10314 <= MON_SOM_phase(4) OR MON_SOM_phase(5) ;
   rtlc22n10316 <= MON_SOM_phase(2) OR MON_SOM_phase(3) ;
   Ram_data_i_select_22i26Bus110_0 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(0), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(0), b(1)=>
      monitor_data_pointer(0), b(0)=>Monitor_Active_command(0), d=>
      Ram_data_i_22n103ss1_0);
   rtlc22_1119_or_61 : or_4u_4u port map ( a(3)=>MON_SOM_phase(0), a(2)=>
      MON_SOM_phase(1), a(1)=>MON_SOM_phase(2), a(0)=>MON_SOM_phase(3), d=>
      rtlc22n10342);
   Ram_data_i_select_22i26Bus110_1 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(1), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(1), b(1)=>
      monitor_data_pointer(1), b(0)=>Monitor_Active_command(1), d=>
      Ram_data_i_22n103ss1_1);
   Ram_data_i_select_22i26Bus110_2 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(2), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(2), b(1)=>
      monitor_data_pointer(2), b(0)=>Monitor_Active_command(2), d=>
      Ram_data_i_22n103ss1_2);
   Ram_data_i_select_22i26Bus110_3 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(3), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(3), b(1)=>
      monitor_data_pointer(3), b(0)=>Monitor_Active_command(3), d=>
      Ram_data_i_22n103ss1_3);
   Ram_data_i_select_22i26Bus110_4 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(4), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(4), b(1)=>
      monitor_data_pointer(4), b(0)=>Monitor_Active_command(4), d=>
      Ram_data_i_22n103ss1_4);
   Ram_data_i_select_22i26Bus110_5 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(5), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(5), b(1)=>
      monitor_data_pointer(5), b(0)=>Monitor_Active_command(5), d=>
      Ram_data_i_22n103ss1_5);
   Ram_data_i_select_22i32Bus111_7 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(7), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(7), b(1)=>
      monitor_data_pointer(7), b(0)=>Monitor_Active_command(7), d=>
      Ram_data_i_22n103ss1_7);
   Ram_data_i_select_22i32Bus111_8 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(8), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(8), b(1)=>
      monitor_data_pointer(8), b(0)=>Monitor_Active_command(8), d=>
      Ram_data_i_22n103ss1_8);
   Ram_data_i_select_22i32Bus111_9 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(9), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(9), b(1)=>
      monitor_data_pointer(9), b(0)=>Monitor_Active_command(9), d=>
      Ram_data_i_22n103ss1_9);
   Ram_data_i_select_22i32Bus111_10 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>
      Ram_data_i_22n85ss1(10), b(3)=>debug_EXMPLR1003(15), b(2)=>
      time_tag_EXMPLR1002(10), b(1)=>monitor_data_pointer(10), b(0)=>
      Monitor_Active_command(10), d=>Ram_data_i_22n103ss1_10);
   Ram_data_i_select_22i32Bus111_11 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>
      Ram_data_i_22n85ss1(11), b(3)=>debug_EXMPLR1003(15), b(2)=>
      time_tag_EXMPLR1002(11), b(1)=>monitor_data_pointer(11), b(0)=>
      Monitor_Active_command(11), d=>Ram_data_i_22n103ss1_11);
   Ram_data_i_select_22i32Bus111_12 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>
      Ram_data_i_22n85ss1(12), b(3)=>debug_EXMPLR1003(15), b(2)=>
      time_tag_EXMPLR1002(12), b(1)=>monitor_data_pointer(12), b(0)=>
      Monitor_Active_command(12), d=>Ram_data_i_22n103ss1_12);
   Ram_data_i_select_22i32Bus111_13 : select_5_5 port map ( a(4)=>
      rtlc22n10342, a(3)=>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>
      MON_SOM_phase(6), a(0)=>MON_SOM_phase(7), b(4)=>
      Ram_data_i_22n85ss1(13), b(3)=>not_Monitor_bus_a, b(2)=>
      time_tag_EXMPLR1002(13), b(1)=>monitor_data_pointer(13), b(0)=>
      Monitor_Active_command(13), d=>Ram_data_i_22n103ss1_13);
   Ram_data_i_select_22i39 : select_5_5 port map ( a(4)=>rtlc22n10342, a(3)
      =>MON_SOM_phase(4), a(2)=>MON_SOM_phase(5), a(1)=>MON_SOM_phase(6), 
      a(0)=>MON_SOM_phase(7), b(4)=>Ram_data_i_22n85ss1(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>time_tag_EXMPLR1002(15), b(1)=>
      monitor_data_pointer(15), b(0)=>Monitor_Active_command(15), d=>
      Ram_data_i_22n103ss1_15);
   rtlc22n10410 <= rtlcs57 OR rtlcs54 ;
   rtlc22n10482 <= rtlcs47 OR rtlcs60 ;
   rtlc22n8384 <= rtlc22n8376 AND not_rtlc22n8108 ;
   rtlc22n8376 <= rtlc22n8369 AND not_rtlc22n8131 ;
   rtlc22n8369 <= rtlc22n8363 AND not_rtlc22n8155 ;
   rtlc22n8363 <= rtlc22n8358 AND not_rtlc22n8177 ;
   rtlc22n8358 <= rtlc22n8354 AND not_rtlc22n8199 ;
   rtlc22n8354 <= rtlc22n8351 AND not_rtlc22n8221 ;
   rtlc22n8351 <= rtlc22n8059 AND not_rtlc22n8243 ;
   rtlc22n7782 <= rtlc22n7772 AND not_Message_ended_not_OK ;
   rtlc22n7975 <= rtlc22n7973 AND illegalization_enable ;
   rtlc22n7973 <= rtlc22n7782 AND not_Ack ;
   rtlc22_1880_select_75 : select_3_3 port map ( a(2)=>not_rtlc22n10316, 
      a(1)=>MON_SOM_phase(2), a(0)=>MON_SOM_phase(3), b(2)=>not_rtlcs61, 
      b(1)=>rtlc22n8781, b(0)=>rtlc22n8790, d=>rtlc22n8833);
   not_rtlcs61 <= NOT rtlcs61 ;
   rtlc22n8781 <= not_rtlcs61 AND Record_enable ;
   rtlc22n8790 <= rtlc22n8788 AND not_Monitor_bus_a ;
   rtlc22n8788 <= not_rtlcs61 AND not_Record_enable ;
   rtlc22_1890_select_76 : select_3_3 port map ( a(2)=>not_rtlc22n10316, 
      a(1)=>MON_SOM_phase(2), a(0)=>MON_SOM_phase(3), b(2)=>not_rtlcs61, 
      b(1)=>rtlc22n8781, b(0)=>rtlc22n8791, d=>rtlc22n8834);
   rtlc22n8791 <= rtlc22n8788 AND Monitor_bus_a ;
   rtlc22n7744 <= not_Ack AND rtlc22n7730 ;
   rtlc22n7976 <= not_Ack AND illegalization_enable ;
   rtlc22n7980 <= not_Ack AND rtlc22n7839 ;
   rtlc22n8422 <= not_Ack AND rtlc22n8398 ;
   rtlc22n8588 <= not_Ack AND Record_enable ;
   rtlc22n8802 <= not_Ack AND New_command_record ;
   not_rtlc22n10119 <= NOT rtlc22n10119 ;
   rtlc22n8331 <= not_rtlc22n10119 AND rtlc22n8113 ;
   rtlc22n8334 <= not_rtlc22n10119 AND rtlc22n8137 ;
   rtlc22n8337 <= not_rtlc22n10119 AND rtlc22n8161 ;
   rtlc22n8340 <= not_rtlc22n10119 AND rtlc22n8183 ;
   rtlc22n7981 <= rtlc22n7978 AND rtlc22n7839 ;
   rtlc22n7978 <= not_rtlcn1240 AND not_Ack ;
   rtlc22n8328 <= not_Read OR not_Ack ;
   rtlc22n8782 <= not_Record_enable OR not_Ack ;
   rtlc22n7690 <= not_EOM_phase_go OR not_illegal_message ;
   not_rtlc22n7393 <= NOT rtlc22n7393 ;
   rtlc22n9096 <= not_rtlcs100 OR not_rtlcs101 ;
   rtlc22_PS506_n8983 <= rtlcs59 OR rtlcs51 ;
   rtlc22n8856 <= Monitor_write AND not_monitor_pointer_protection_error ;
   rtlc22n8768 <= rtlcn1233 AND not_rtlcn1234 ;
   rtlc22n8752 <= rtlcn1231 AND not_rtlcn1232 ;
   rtlc22n8769 <= rtlc22n8752 OR rtlc22n8768 ;
   not_MON_SOM_phase_go <= NOT MON_SOM_phase_go ;
   not_MON_EOM_phase_go <= NOT MON_EOM_phase_go ;
   rtlc22n8398 <= mode_command AND Address(4) ;
   rtlc22n8280 <= BCR AND Config_reg_2(0) ;
   rtlc22n8275 <= rtlc22n8398 AND Config_reg_3_0 ;
   rtlc22n8243 <= rtlcs89 OR rtlcs73 ;
   rtlc22n8221 <= rtlcs87 OR rtlcs71 ;
   rtlc22n8199 <= rtlcs91 OR rtlcs75 ;
   rtlc22n8177 <= rtlcs85 OR rtlcs69 ;
   rtlc22n8155 <= rtlcs97 OR rtlcs81 ;
   rtlc22n8131 <= rtlcs95 OR rtlcs79 ;
   rtlc22n8108 <= rtlcs99 OR rtlcs83 ;
   not_phase_go <= NOT phase_go ;
   rtlc22n8022 <= mode_command AND Config_reg_3_0 ;
   rtlc22n7839 <= Config_reg_2(13) AND Config_reg_3_15 ;
   not_SOM_phase_go <= NOT SOM_phase_go ;
   not_Message_ended_not_OK <= NOT Message_ended_not_OK ;
   rtlc22n7720 <= LUT_Control(15) OR not_Config_reg_2_1 ;
   not_EOM_phase_go <= NOT EOM_phase_go ;
   rtlc22n7220 <= WM_On OR BC_START ;
   rtlc22n7221 <= rtlc22n7220 OR RT_On_EXMPLR924 ;
   Ram_Address_dec16_22i40 : dec_16u_16u_0 port map ( cin=>
      debug_EXMPLR1003(15), a(15)=>Ram_Address(15), a(14)=>Ram_Address(14), 
      a(13)=>Ram_Address(13), a(12)=>Ram_Address(12), a(11)=>Ram_Address(11), 
      a(10)=>Ram_Address(10), a(9)=>Ram_Address(9), a(8)=>Ram_Address(8), 
      a(7)=>Ram_Address(7), a(6)=>Ram_Address(6), a(5)=>Ram_Address(5), a(4)
      =>Ram_Address(4), a(3)=>Ram_Address(3), a(2)=>Ram_Address(2), a(1)=>
      Ram_Address(1), a(0)=>Ram_Address(0), d(15)=>Ram_Address_22n2s1(15), 
      d(14)=>Ram_Address_22n2s1(14), d(13)=>Ram_Address_22n2s1(13), d(12)=>
      Ram_Address_22n2s1(12), d(11)=>Ram_Address_22n2s1(11), d(10)=>
      Ram_Address_22n2s1(10), d(9)=>Ram_Address_22n2s1(9), d(8)=>
      Ram_Address_22n2s1(8), d(7)=>Ram_Address_22n2s1(7), d(6)=>
      Ram_Address_22n2s1(6), d(5)=>Ram_Address_22n2s1(5), d(4)=>
      Ram_Address_22n2s1(4), d(3)=>Ram_Address_22n2s1(3), d(2)=>
      Ram_Address_22n2s1(2), d(1)=>Ram_Address_22n2s1(1), d(0)=>
      Ram_Address_22n2s1(0), cout=>DANGLING(0));
   not_monitor_pointer_protection_error <= NOT 
   monitor_pointer_protection_error ;
   not_Config_reg_2_1 <= NOT Config_reg_2(1) ;
   rtlc22n11259 <= monitor_data_pointer(9) AND monitor_data_pointer(8) ;
   rtlc22n11324 <= monitor_stack_pointer(9) AND monitor_stack_pointer(8) ;
   BC_Num_Msgs_26n12s1(0) <= NOT Data_o_temp(0) ;
   BC_Num_Msgs_26n12s1(1) <= NOT Data_o_temp(1) ;
   BC_Num_Msgs_26n12s1(2) <= NOT Data_o_temp(2) ;
   BC_Num_Msgs_26n12s1(3) <= NOT Data_o_temp(3) ;
   BC_Num_Msgs_26n12s1(4) <= NOT Data_o_temp(4) ;
   BC_Num_Msgs_26n12s1(5) <= NOT Data_o_temp(5) ;
   BC_Num_Msgs_26n12s1(6) <= NOT Data_o_temp(6) ;
   BC_Num_Msgs_26n12s1(7) <= NOT Data_o_temp(7) ;
   BC_Num_Msgs_26n12s1(8) <= NOT Data_o_temp(8) ;
   BC_Num_Msgs_26n12s1(9) <= NOT Data_o_temp(9) ;
   BC_Num_Msgs_26n12s1(10) <= NOT Data_o_temp(10) ;
   BC_Ram_data_26n15s1(0) <= NOT BC_Num_Msgs(0) ;
   BC_Ram_data_26n15s1(1) <= NOT BC_Num_Msgs(1) ;
   BC_Ram_data_26n15s1(2) <= NOT BC_Num_Msgs(2) ;
   BC_Ram_data_26n15s1(3) <= NOT BC_Num_Msgs(3) ;
   BC_Ram_data_26n15s1(4) <= NOT BC_Num_Msgs(4) ;
   BC_Ram_data_26n15s1(5) <= NOT BC_Num_Msgs(5) ;
   BC_Ram_data_26n15s1(6) <= NOT BC_Num_Msgs(6) ;
   BC_Ram_data_26n15s1(7) <= NOT BC_Num_Msgs(7) ;
   BC_Ram_data_26n15s1(8) <= NOT BC_Num_Msgs(8) ;
   BC_Ram_data_26n15s1(9) <= NOT BC_Num_Msgs(9) ;
   BC_Ram_data_26n15s1(10) <= NOT BC_Num_Msgs(10) ;
   BC_Ram_data_26n15s1(11) <= NOT BC_Num_Msgs(11) ;
   BC_Ram_data_26n15s1(12) <= NOT BC_Num_Msgs(12) ;
   BC_Ram_data_26n15s1(13) <= NOT BC_Num_Msgs(13) ;
   BC_Ram_data_26n15s1(14) <= NOT BC_Num_Msgs(14) ;
   BC_Ram_data_26n15s1(15) <= NOT BC_Num_Msgs(15) ;
   not_BC_Control_word_7 <= NOT BC_Control_word_7 ;
   not_BC_msg_pointer_4 <= NOT BC_msg_pointer(4) ;
   VARAM_WE_26n125s2 <= LIFO_Pointer(4) AND BC_Echo_word(10) ;
   rtlc26n15915 <= BC_State(8) OR BC_State(24) ;
   rtlc26n15937 <= BC_State(76) OR BC_State(77) ;
   rtlc26n15994 <= BC_State(55) OR BC_State(54) ;
   not_rtlc26n15994 <= NOT rtlc26n15994 ;
   rtlc26n15998 <= BC_State(52) OR BC_State(56) ;
   rtlc26n16088 <= BC_State(14) OR BC_State(48) ;
   rtlc26_1422_or_83 : or_11u_11u port map ( a(10)=>BC_State(0), a(9)=>
      BC_State(1), a(8)=>BC_State(2), a(7)=>BC_State(3), a(6)=>BC_State(4), 
      a(5)=>BC_State(5), a(4)=>BC_State(6), a(3)=>BC_State(24), a(2)=>
      BC_State(30), a(1)=>BC_State(31), a(0)=>BC_State(90), d=>rtlc26n16112
   );
   rtlc26n16122 <= BC_State(5) OR BC_State(30) ;
   rtlc26_1460_or_84 : or_6u_6u port map ( a(5)=>BC_State(10), a(4)=>
      BC_State(18), a(3)=>BC_State(19), a(2)=>BC_State(25), a(1)=>
      BC_State(37), a(0)=>BC_State(75), d=>rtlc26n16129);
   rtlc26_1461_or_85 : or_13u_13u port map ( a(12)=>BC_State(32), a(11)=>
      BC_State(36), a(10)=>BC_State(56), a(9)=>BC_State(58), a(8)=>
      BC_State(62), a(7)=>BC_State(65), a(6)=>BC_State(71), a(5)=>
      BC_State(74), a(4)=>BC_State(79), a(3)=>BC_State(83), a(2)=>
      BC_State(86), a(1)=>BC_State(87), a(0)=>BC_State(88), d=>rtlc26n16130
   );
   rtlc26n16131 <= BC_State(73) OR BC_State(84) ;
   rtlc26_1471_or_86 : or_8u_8u port map ( a(7)=>BC_State(2), a(6)=>
      BC_State(3), a(5)=>BC_State(4), a(4)=>BC_State(5), a(3)=>BC_State(6), 
      a(2)=>BC_State(12), a(1)=>BC_State(13), a(0)=>BC_State(30), d=>
      rtlc26n16138);
   rtlc26_1472_or_87 : or_18u_18u port map ( a(17)=>BC_State(7), a(16)=>
      BC_State(8), a(15)=>BC_State(9), a(14)=>BC_State(14), a(13)=>
      BC_State(20), a(12)=>BC_State(32), a(11)=>BC_State(36), a(10)=>
      BC_State(56), a(9)=>BC_State(58), a(8)=>BC_State(62), a(7)=>
      BC_State(65), a(6)=>BC_State(71), a(5)=>BC_State(74), a(4)=>
      BC_State(79), a(3)=>BC_State(83), a(2)=>BC_State(86), a(1)=>
      BC_State(87), a(0)=>BC_State(88), d=>rtlc26n16139);
   rtlc26_1480_or_88 : or_12u_12u port map ( a(11)=>BC_State(10), a(10)=>
      BC_State(18), a(9)=>BC_State(19), a(8)=>BC_State(25), a(7)=>
      BC_State(37), a(6)=>BC_State(38), a(5)=>BC_State(45), a(4)=>
      BC_State(47), a(3)=>BC_State(48), a(2)=>BC_State(49), a(1)=>
      BC_State(54), a(0)=>BC_State(75), d=>rtlc26n16146);
   rtlc26_1483_or_89 : or_12u_12u port map ( a(11)=>BC_State(0), a(10)=>
      BC_State(2), a(9)=>BC_State(3), a(8)=>BC_State(4), a(7)=>BC_State(5), 
      a(6)=>BC_State(6), a(5)=>BC_State(11), a(4)=>BC_State(12), a(3)=>
      BC_State(13), a(2)=>BC_State(30), a(1)=>BC_State(31), a(0)=>
      BC_State(42), d=>rtlc26n16148);
   rtlc26_1549_or_90 : or_15u_15u port map ( a(14)=>BC_State(4), a(13)=>
      BC_State(6), a(12)=>BC_State(9), a(11)=>BC_State(12), a(10)=>
      BC_State(13), a(9)=>BC_State(18), a(8)=>BC_State(19), a(7)=>
      BC_State(20), a(6)=>BC_State(43), a(5)=>BC_State(45), a(4)=>
      BC_State(49), a(3)=>BC_State(54), a(2)=>BC_State(56), a(1)=>
      BC_State(73), a(0)=>BC_State(84), d=>rtlc26n16200);
   not_rtlc26n16200 <= NOT rtlc26n16200 ;
   rtlc26n16203 <= BC_State(4) OR BC_State(12) ;
   rtlc26n16204 <= BC_State(9) OR BC_State(49) ;
   rtlc26n16206 <= BC_State(20) OR BC_State(54) ;
   rtlc26n16305 <= BC_State(22) OR BC_State(51) ;
   rtlc26n16323 <= BC_State(33) OR BC_State(90) ;
   rtlc26n16352 <= BC_State(80) OR BC_State(81) ;
   rtlc26n16354 <= BC_State(13) OR BC_State(52) ;
   rtlc26_1785_or_93 : or_4u_4u port map ( a(3)=>BC_State(1), a(2)=>
      BC_State(13), a(1)=>BC_State(31), a(0)=>BC_State(52), d=>rtlc26n16356
   );
   VARAM_ADD_select_26i1Bus134_0 : select_4_4 port map ( a(3)=>BC_State(32), 
      a(2)=>BC_State(59), a(1)=>BC_State(82), a(0)=>BC_State(83), b(3)=>
      LIFO_Pointer(0), b(2)=>LIFO_Pointer_26n126s1(0), b(1)=>WhichVAR(0), 
      b(0)=>Data_o_temp(0), d=>VARAM_ADD_26n180ss1(0));
   VARAM_ADD_select_26i1Bus134_1 : select_4_4 port map ( a(3)=>BC_State(32), 
      a(2)=>BC_State(59), a(1)=>BC_State(82), a(0)=>BC_State(83), b(3)=>
      LIFO_Pointer(1), b(2)=>LIFO_Pointer_26n126s1(1), b(1)=>WhichVAR(1), 
      b(0)=>Data_o_temp(1), d=>VARAM_ADD_26n180ss1(1));
   VARAM_ADD_select_26i1Bus134_2 : select_4_4 port map ( a(3)=>BC_State(32), 
      a(2)=>BC_State(59), a(1)=>BC_State(82), a(0)=>BC_State(83), b(3)=>
      LIFO_Pointer(2), b(2)=>LIFO_Pointer_26n126s1(2), b(1)=>WhichVAR(2), 
      b(0)=>Data_o_temp(2), d=>VARAM_ADD_26n180ss1(2));
   VARAM_ADD_select_26i1Bus134_3 : select_4_4 port map ( a(3)=>BC_State(32), 
      a(2)=>BC_State(59), a(1)=>BC_State(82), a(0)=>BC_State(83), b(3)=>
      LIFO_Pointer(3), b(2)=>LIFO_Pointer_26n126s1(3), b(1)=>WhichVAR(3), 
      b(0)=>Data_o_temp(3), d=>VARAM_ADD_26n180ss1(3));
   VARAM_D_select_26i5Bus135_0 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(0), 
      b(1)=>LIFO_Pointer_26n126s1(0), b(0)=>Data_o_temp(0), d=>
      VARAM_D_26n180ss1(0));
   VARAM_D_select_26i5Bus135_1 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(1), 
      b(1)=>LIFO_Pointer_26n126s1(1), b(0)=>Data_o_temp(1), d=>
      VARAM_D_26n180ss1(1));
   VARAM_D_select_26i5Bus135_2 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(2), 
      b(1)=>LIFO_Pointer_26n126s1(2), b(0)=>Data_o_temp(2), d=>
      VARAM_D_26n180ss1(2));
   VARAM_D_select_26i5Bus135_3 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(3), 
      b(1)=>LIFO_Pointer_26n126s1(3), b(0)=>Data_o_temp(3), d=>
      VARAM_D_26n180ss1(3));
   VARAM_D_select_26i5Bus135_4 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(4), 
      b(1)=>LIFO_Pointer_26n126s1(4), b(0)=>Data_o_temp(4), d=>
      VARAM_D_26n180ss1(4));
   VARAM_D_select_26i5Bus135_5 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(5), 
      b(1)=>VARAM_D_26n172s1_5, b(0)=>Data_o_temp(5), d=>
      VARAM_D_26n180ss1(5));
   VARAM_D_select_26i5Bus135_6 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(6), 
      b(1)=>VARAM_D_26n172s1_6, b(0)=>Data_o_temp(6), d=>
      VARAM_D_26n180ss1(6));
   VARAM_D_select_26i5Bus135_7 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(7), 
      b(1)=>VARAM_D_26n172s1_7, b(0)=>Data_o_temp(7), d=>
      VARAM_D_26n180ss1(7));
   VARAM_D_select_26i5Bus135_8 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(8), 
      b(1)=>VARAM_D_26n172s1_8, b(0)=>Data_o_temp(8), d=>
      VARAM_D_26n180ss1(8));
   VARAM_D_select_26i5Bus135_9 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(9), 
      b(1)=>VARAM_D_26n172s1_9, b(0)=>Data_o_temp(9), d=>
      VARAM_D_26n180ss1(9));
   VARAM_D_select_26i5Bus135_10 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(10), 
      b(1)=>VARAM_D_26n172s1_10, b(0)=>Data_o_temp(10), d=>
      VARAM_D_26n180ss1(10));
   VARAM_D_select_26i5Bus135_11 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(11), 
      b(1)=>VARAM_D_26n172s1_11, b(0)=>Data_o_temp(11), d=>
      VARAM_D_26n180ss1(11));
   VARAM_D_select_26i5Bus135_12 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(12), 
      b(1)=>VARAM_D_26n172s1_12, b(0)=>Data_o_temp(12), d=>
      VARAM_D_26n180ss1(12));
   VARAM_D_select_26i5Bus135_13 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(13), 
      b(1)=>VARAM_D_26n172s1_13, b(0)=>Data_o_temp(13), d=>
      VARAM_D_26n180ss1(13));
   VARAM_D_select_26i5Bus135_14 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(14), 
      b(1)=>VARAM_D_26n172s1_14, b(0)=>Data_o_temp(14), d=>
      VARAM_D_26n180ss1(14));
   VARAM_D_select_26i5Bus135_15 : select_3_3 port map ( a(2)=>BC_State(58), 
      a(1)=>BC_State(86), a(0)=>BC_State(87), b(2)=>BC_Stack_pointer(15), 
      b(1)=>VARAM_D_26n172s1_15, b(0)=>Data_o_temp(15), d=>
      VARAM_D_26n180ss1(15));
   rtlc26_1810_select_114 : select_3_3 port map ( a(2)=>not_rtlc26n17337, 
      a(1)=>BC_State(58), a(0)=>rtlc26n16362, b(2)=>debug_EXMPLR1003(15), 
      b(1)=>VARAM_WE_26n125s2, b(0)=>PWR, d=>rtlcn2475);
   not_rtlc26n17337 <= NOT rtlc26n17337 ;
   rtlc26n16362 <= BC_State(86) OR BC_State(87) ;
   rtlc26n16375 <= BC_State(57) OR BC_State(59) ;
   rtlc26n16381 <= BC_State(12) OR BC_State(52) ;
   rtlc26_2185_or_115 : or_9u_9u port map ( a(8)=>BC_State(0), a(7)=>
      BC_State(31), a(6)=>BC_State(32), a(5)=>BC_State(35), a(4)=>
      BC_State(57), a(3)=>BC_State(59), a(2)=>BC_State(63), a(1)=>
      BC_State(76), a(0)=>BC_State(77), d=>rtlc26n16656);
   BC_State_fsm_select_26i21 : select_3_3 port map ( a(2)=>not_rtlc26n15994, 
      a(1)=>BC_State(55), a(0)=>BC_State(54), b(2)=>debug_EXMPLR1003(15), 
      b(1)=>PWR, b(0)=>BC_State_fsm_26n116ss1_54, d=>
      BC_State_fsm_26n180ss1_54);
   not_eBC_Bad_Parity_26n180s2 <= NOT eBC_Bad_Parity_26n180s2 ;
   rtlc26_3111_or_118 : or_5u_5u port map ( a(4)=>BC_State(14), a(3)=>
      BC_State(22), a(2)=>BC_State(48), a(1)=>BC_State(51), a(0)=>
      BC_State(80), d=>rtlc26n17283);
   rtlc26n17286 <= BC_State(10) OR BC_State(37) ;
   rtlc26n17289 <= BC_State(17) OR BC_State(32) ;
   rtlc26_3131_or_119 : or_6u_6u port map ( a(5)=>BC_State(5), a(4)=>
      BC_State(12), a(3)=>BC_State(30), a(2)=>BC_State(40), a(1)=>
      BC_State(44), a(0)=>BC_State(47), d=>rtlc26n17293);
   not_rtlc26n17293 <= NOT rtlc26n17293 ;
   rtlc26_3139_or_120 : or_17u_17u port map ( a(16)=>BC_State(2), a(15)=>
      BC_State(3), a(14)=>BC_State(33), a(13)=>BC_State(34), a(12)=>
      BC_State(35), a(11)=>BC_State(57), a(10)=>BC_State(58), a(9)=>
      BC_State(59), a(8)=>BC_State(60), a(7)=>BC_State(61), a(6)=>
      BC_State(63), a(5)=>BC_State(64), a(4)=>BC_State(67), a(3)=>
      BC_State(69), a(2)=>BC_State(70), a(1)=>BC_State(72), a(0)=>
      BC_State(82), d=>rtlc26n17297);
   rtlc26_3144_or_121 : or_18u_18u port map ( a(17)=>BC_State(2), a(16)=>
      BC_State(3), a(15)=>BC_State(12), a(14)=>BC_State(33), a(13)=>
      BC_State(34), a(12)=>BC_State(35), a(11)=>BC_State(57), a(10)=>
      BC_State(58), a(9)=>BC_State(59), a(8)=>BC_State(60), a(7)=>
      BC_State(61), a(6)=>BC_State(63), a(5)=>BC_State(64), a(4)=>
      BC_State(67), a(3)=>BC_State(69), a(2)=>BC_State(70), a(1)=>
      BC_State(72), a(0)=>BC_State(82), d=>rtlc26n17300);
   rtlc26_3173_or_123 : or_10u_10u port map ( a(9)=>BC_State(8), a(8)=>
      BC_State(15), a(7)=>BC_State(16), a(6)=>BC_State(36), a(5)=>
      BC_State(62), a(4)=>BC_State(71), a(3)=>BC_State(74), a(2)=>
      BC_State(75), a(1)=>BC_State(79), a(0)=>BC_State(88), d=>rtlc26n17317
   );
   rtlc26_3178_or_124 : or_5u_5u port map ( a(4)=>BC_State(14), a(3)=>
      BC_State(15), a(2)=>BC_State(40), a(1)=>BC_State(44), a(0)=>
      BC_State(48), d=>rtlc26n17320);
   rtlc26_3182_select_125 : select_3_3 port map ( a(2)=>not_rtlc26n17323, 
      a(1)=>BC_State(58), a(0)=>BC_State(59), b(2)=>PWR, b(1)=>rtlc26n15232, 
      b(0)=>not_rtlc26n13816, d=>rtlc26n15481);
   rtlc26n17323 <= BC_State(58) OR BC_State(59) ;
   rtlc26_3197_or_126 : or_4u_4u port map ( a(3)=>BC_State(14), a(2)=>
      BC_State(26), a(1)=>BC_State(41), a(0)=>BC_State(48), d=>rtlc26n17331
   );
   rtlc26_3202_or_127 : or_4u_4u port map ( a(3)=>BC_State(32), a(2)=>
      BC_State(59), a(1)=>BC_State(82), a(0)=>BC_State(83), d=>rtlc26n17334
   );
   rtlc26_3215_or_129 : or_5u_5u port map ( a(4)=>BC_State(1), a(3)=>
      BC_State(4), a(2)=>BC_State(12), a(1)=>BC_State(31), a(0)=>
      BC_State(52), d=>rtlc26n17341);
   rtlc26n15114 <= BC_Write OR BC_Command_Sync ;
   rtlc26n15497 <= eBC AND eBC_Watchdog_eq0 ;
   rtlc26n15369 <= Ack AND not_BC_Echo_word_10 ;
   rtlc26n15182 <= not_Config_reg_1_5 OR gap_eq_0 ;
   rtlc26n15063 <= rtlcs143 AND Sync_with_Data ;
   rtlc26n15067 <= rtlc26n15063 AND BC_Control_word_15 ;
   rtlc26_4620_and_131 : and_5u_5u port map ( a(4)=>Data_o_temp(9), a(3)=>
      not_Data_o_temp_12, a(2)=>not_Data_o_temp_13, a(1)=>not_Data_o_temp_14, 
      a(0)=>Ack, d=>rtlc26_PS699_n15006);
   rtlc26_4628_and_132 : and_5u_5u port map ( a(4)=>BC_Num_Msgs_26n12s1(9), 
      a(3)=>not_Data_o_temp_12, a(2)=>not_Data_o_temp_13, a(1)=>
      Data_o_temp(14), a(0)=>Ack, d=>rtlc26_PS698_n14998);
   rtlc26n14917 <= rtlcs137 OR rtlcs139 ;
   not_rtlc26n14917 <= NOT rtlc26n14917 ;
   not_rtlcs353 <= NOT rtlcs353 ;
   rtlc26n14919 <= not_rtlcs353 OR not_rtlc26n14917 ;
   rtlc26n14920 <= Ack AND rtlc26n14919 ;
   rtlc26n14736 <= Config_reg_1(10) AND eBC_Conditions_11 ;
   rtlc26n14732 <= Config_reg_1(12) AND BC_reported_errors ;
   rtlc26n14737 <= rtlc26n14732 OR rtlc26n14736 ;
   rtlc26n14739 <= rtlc26n14737 OR BC_Stop_EOM ;
   rtlc26n14740 <= Ack AND rtlc26n14739 ;
   rtlc26n14581 <= not_Config_reg_1_8 OR not_Config_reg_3_15 ;
   rtlc26n14583 <= rtlc26n14581 OR BC_Stop_EOF ;
   rtlc26n14584 <= rtlc26n14576 AND rtlc26n14583 ;
   rtlc26n14559 <= rtlc26n14576 AND Config_reg_1(8) ;
   rtlc26n14562 <= rtlc26n14559 AND Config_reg_3_15 ;
   rtlc26n14530 <= Ack AND Config_reg_1(15) ;
   rtlc26n14488 <= Config_reg_1(9) AND status_set_in_frame ;
   rtlc26n14484 <= Config_reg_1(11) AND Message_failed ;
   rtlc26n14489 <= rtlc26n14484 OR rtlc26n14488 ;
   rtlc26n14491 <= rtlc26n14489 OR BC_Stop_EOF ;
   not_rtlcs153 <= NOT rtlcs153 ;
   rtlc26n14300 <= not_WM_On OR not_rtlcs153 ;
   rtlc26n14265 <= gap_eq_0 OR not_eBC ;
   rtlc26n14110 <= YES AND not_BC_Echo_word_11 ;
   rtlc26n14017 <= frame_gap_eq_0 OR not_eBC ;
   rtlc26n13923 <= YES AND not_BC_Echo_word_14 ;
   rtlc26n13816 <= YES AND rtlc26n18822 ;
   not_LIFO_Pointer_4 <= NOT LIFO_Pointer(4) ;
   rtlc26n13676 <= RETRY_ON_1553A AND BC_1553A_ME ;
   rtlc26n13674 <= eBC_Conditions_11 AND Config_reg_4_EXMPLR998(9) ;
   rtlc26n13675 <= BC_reported_errors OR rtlc26n13674 ;
   rtlc26n13677 <= rtlc26n13675 OR rtlc26n13676 ;
   rtlc26n13678 <= Ack AND rtlc26n13677 ;
   rtlc26n13656 <= YES_45n2s1 AND not_Config_reg_1_3 ;
   rtlc26n13638 <= not_Config_reg_1_4 OR not_BC_Control_word_8 ;
   rtlc26n13646 <= rtlc26n13638 OR rtlcs150 ;
   rtlc26n13657 <= rtlc26n13646 OR rtlc26n13656 ;
   rtlc26n13617 <= rtlcs148 OR rtlc26_PS144_n12968 ;
   not_rtlc26n13617 <= NOT rtlc26n13617 ;
   rtlc26n13428 <= rtlc26n19009 AND BC_RT2RT_EXMPLR781 ;
   rtlc26n13393 <= BC_Write AND BC_Echo ;
   rtlc26n13384 <= BC_Write AND not_BC_Echo ;
   rtlc26n13370 <= rtlcs145 OR rtlcs144 ;
   rtlc26n13371 <= rtlcs143 AND rtlc26n13370 ;
   rtlc26n13295 <= rtlcs143 AND BC_RT2RT_EXMPLR781 ;
   rtlc26n13229 <= Config_reg_1(10) OR Config_reg_1(9) ;
   rtlc26n13231 <= rtlc26n13229 AND status_set_in_frame ;
   rtlc26n13223 <= Config_reg_1(12) OR Config_reg_1(11) ;
   rtlc26n13224 <= rtlc26n13223 AND Message_failed ;
   rtlc26n13232 <= rtlc26n13224 OR rtlc26n13231 ;
   rtlc26n13234 <= rtlc26n13232 OR BC_Stop_EOM ;
   rtlc26n13236 <= rtlc26n13234 OR not_eBC ;
   rtlc26n13194 <= NO AND not_BC_Echo_word_14 ;
   rtlc26n13151 <= BC_START OR Ext_Trigger_Dx ;
   rtlc26n13144 <= not_eBC OR BC_OFF ;
   rtlc26n13037 <= rtlcs142 AND Sync_with_Data ;
   rtlc26n13041 <= rtlc26n13037 AND BC_Control_word_15 ;
   rtlc26n13014 <= frame_gap_eq_0 AND Config_reg_1(6) ;
   rtlc26n13018 <= rtlc26n13014 OR Ext_Trigger_Dx ;
   rtlc26n13019 <= rtlc26n13018 OR BC_START ;
   rtlc26n13005 <= not_rtlcn1226 OR BC_Stop_EOF ;
   rtlc26n12839 <= Ack AND not_BC_Message_Active ;
   rtlc26n12613 <= not_BC_Message_Active AND BC_First_write ;
   rtlc26n12614 <= rtlc26n13384 OR rtlc26n12613 ;
   rtlc26n12461 <= rtlcs154 AND not_Config_reg_6_15 ;
   not_rtlc26n12461 <= NOT rtlc26n12461 ;
   rtlc26n12464 <= not_rtlc26n12461 OR BC_OFF ;
   rtlc26n12441 <= WM_On AND rtlcs153 ;
   rtlc26n12428 <= eBC AND not_BC_OFF ;
   rtlc26n12419 <= rtlc26n12461 AND not_BC_OFF ;
   not_BC_Echo <= NOT BC_Echo ;
   not_Config_reg_1_5 <= NOT Config_reg_1(5) ;
   not_Data_o_temp_12 <= NOT Data_o_temp(12) ;
   not_Data_o_temp_14 <= NOT Data_o_temp(14) ;
   not_Data_o_temp_13 <= NOT Data_o_temp(13) ;
   not_BC_Echo_word_14 <= NOT BC_Echo_word(14) ;
   not_BC_Echo_word_11 <= NOT BC_Echo_word(11) ;
   not_Config_reg_6_15 <= NOT Config_reg_6_15 ;
   not_BC_OFF <= NOT BC_OFF ;
   not_Config_reg_1_4 <= NOT Config_reg_1(4) ;
   not_BC_Control_word_8 <= NOT BC_Control_word_8 ;
   not_Config_reg_1_3 <= NOT Config_reg_1(3) ;
   not_Config_reg_1_7 <= NOT Config_reg_1(7) ;
   not_ReTry_count_1 <= NOT ReTry_count(1) ;
   not_BC_Echo_word_13 <= NOT BC_Echo_word(13) ;
   rtlc26_8051_or_134 : or_5u_5u port map ( a(4)=>BC_State(0), a(3)=>
      BC_State(1), a(2)=>BC_State(2), a(1)=>BC_State(3), a(0)=>BC_State(31), 
      d=>rtlc26n18663);
   rtlc26_8062_or_136 : or_25u_25u port map ( a(24)=>BC_State(2), a(23)=>
      BC_State(3), a(22)=>BC_State(5), a(21)=>BC_State(7), a(20)=>
      BC_State(8), a(19)=>BC_State(10), a(18)=>BC_State(25), a(17)=>
      BC_State(30), a(16)=>BC_State(32), a(15)=>BC_State(36), a(14)=>
      BC_State(37), a(13)=>BC_State(38), a(12)=>BC_State(39), a(11)=>
      BC_State(47), a(10)=>BC_State(58), a(9)=>BC_State(62), a(8)=>
      BC_State(65), a(7)=>BC_State(71), a(6)=>BC_State(74), a(5)=>
      BC_State(75), a(4)=>BC_State(79), a(3)=>BC_State(83), a(2)=>
      BC_State(86), a(1)=>BC_State(87), a(0)=>BC_State(88), d=>rtlc26n18670
   );
   rtlc26_8065_or_137 : or_17u_17u port map ( a(16)=>BC_State(4), a(15)=>
      BC_State(6), a(14)=>BC_State(9), a(13)=>BC_State(12), a(12)=>
      BC_State(13), a(11)=>BC_State(14), a(10)=>BC_State(18), a(9)=>
      BC_State(19), a(8)=>BC_State(20), a(7)=>BC_State(43), a(6)=>
      BC_State(45), a(5)=>BC_State(48), a(4)=>BC_State(49), a(3)=>
      BC_State(54), a(2)=>BC_State(56), a(1)=>BC_State(73), a(0)=>
      BC_State(84), d=>rtlc26n18672);
   rtlc26_8143_or_138 : or_4u_4u port map ( a(3)=>LIFO_Pointer(0), a(2)=>
      LIFO_Pointer(1), a(1)=>LIFO_Pointer(2), a(0)=>LIFO_Pointer(3), d=>
      rtlc26n18821);
   rtlc26n18822 <= rtlc26n18821 AND LIFO_Pointer(4) ;
   rtlc26n19009 <= BC_word_number(1) AND BC_word_number(0) ;
   BC_msg_pointer_inc16_26i22 : inc_16u_16u_0 port map ( cin=>PWR, a(15)=>
      BC_msg_pointer(15), a(14)=>BC_msg_pointer(14), a(13)=>
      BC_msg_pointer(13), a(12)=>BC_msg_pointer(12), a(11)=>
      BC_msg_pointer(11), a(10)=>BC_msg_pointer(10), a(9)=>BC_msg_pointer(9), 
      a(8)=>BC_msg_pointer_26n43s1f1(8), a(7)=>BC_msg_pointer_26n43s1f1(7), 
      a(6)=>BC_msg_pointer_26n43s1f1(6), a(5)=>BC_msg_pointer_26n43s1f1(5), 
      a(4)=>BC_msg_pointer_26n43s1f1(4), a(3)=>BC_msg_pointer_26n43s1f1(3), 
      a(2)=>BC_msg_pointer_26n43s1f1(2), a(1)=>BC_msg_pointer_26n43s1f1(1), 
      a(0)=>BC_msg_pointer_26n43s1f1(0), d(15)=>BC_msg_pointer_26n43s1_15, 
      d(14)=>BC_msg_pointer_26n43s1_14, d(13)=>BC_msg_pointer_26n43s1_13, 
      d(12)=>BC_msg_pointer_26n43s1_12, d(11)=>BC_msg_pointer_26n43s1_11, 
      d(10)=>BC_msg_pointer_26n43s1_10, d(9)=>BC_msg_pointer_26n43s1_9, d(8)
      =>BC_Ram_data_26n30s4(8), d(7)=>BC_Ram_data_26n30s4(7), d(6)=>
      BC_Ram_data_26n30s4(6), d(5)=>BC_Ram_data_26n30s4(5), d(4)=>
      BC_Ram_data_26n30s4(4), d(3)=>BC_Ram_data_26n30s4(3), d(2)=>
      BC_Ram_data_26n30s4(2), d(1)=>BC_Ram_data_26n30s4(1), d(0)=>
      BC_Ram_data_26n30s4(0), cout=>DANGLING(1));
   BC_Stack_pointer_inc16_26i23 : inc_16u_16u_0 port map ( cin=>PWR, a(15)=>
      BC_Stack_pointer(15), a(14)=>BC_Stack_pointer(14), a(13)=>
      BC_Stack_pointer(13), a(12)=>BC_Stack_pointer(12), a(11)=>
      BC_Stack_pointer(11), a(10)=>BC_Stack_pointer(10), a(9)=>
      BC_Stack_pointer(9), a(8)=>BC_Stack_pointer_26n167s1f1(8), a(7)=>
      BC_Stack_pointer_26n167s1f1(7), a(6)=>BC_Stack_pointer_26n167s1f1(6), 
      a(5)=>BC_Stack_pointer_26n167s1f1(5), a(4)=>
      BC_Stack_pointer_26n167s1f1(4), a(3)=>BC_Stack_pointer_26n167s1f1(3), 
      a(2)=>BC_Stack_pointer_26n167s1f1(2), a(1)=>
      BC_Stack_pointer_26n167s1f1(1), a(0)=>BC_Stack_pointer_26n167s1f1(0), 
      d(15)=>BC_Stack_pointer_26n167s1_15, d(14)=>
      BC_Stack_pointer_26n167s1_14, d(13)=>BC_Stack_pointer_26n167s1_13, 
      d(12)=>BC_Stack_pointer_26n167s1_12, d(11)=>
      BC_Stack_pointer_26n167s1_11, d(10)=>BC_Stack_pointer_26n167s1_10, 
      d(9)=>BC_Stack_pointer_26n167s1_9, d(8)=>BC_Stack_pointer_26n31s4_8, 
      d(7)=>BC_Stack_pointer_26n31s3_7, d(6)=>BC_Stack_pointer_26n31s2_6, 
      d(5)=>BC_Stack_pointer_26n31s1(5), d(4)=>BC_Stack_pointer_26n31s1(4), 
      d(3)=>BC_Stack_pointer_26n31s1(3), d(2)=>BC_Stack_pointer_26n31s1(2), 
      d(1)=>BC_Stack_pointer_26n31s1(1), d(0)=>BC_Stack_pointer_26n31s1(0), 
      cout=>DANGLING(2));
   NOT_BC_State_59 <= NOT BC_State(59) ;
   VARAM_D_addsub16_26i24 : addsub_16u_16u_16u_0 port map ( mode=>
      NOT_BC_State_59, cin=>BC_State(59), a(15)=>Data_o_temp(15), a(14)=>
      Data_o_temp(14), a(13)=>Data_o_temp(13), a(12)=>Data_o_temp(12), a(11)
      =>Data_o_temp(11), a(10)=>Data_o_temp(10), a(9)=>Data_o_temp(9), a(8)
      =>Data_o_temp(8), a(7)=>Data_o_temp(7), a(6)=>Data_o_temp(6), a(5)=>
      Data_o_temp(5), a(4)=>VARAM_D_26n172s1f1(4), a(3)=>
      VARAM_D_26n172s1f1(3), a(2)=>VARAM_D_26n172s1f1(2), a(1)=>
      VARAM_D_26n172s1f1(1), a(0)=>VARAM_D_26n172s1f1(0), b(15)=>VARAM_Q(15), 
      b(14)=>VARAM_Q(14), b(13)=>VARAM_Q(13), b(12)=>VARAM_Q(12), b(11)=>
      VARAM_Q(11), b(10)=>VARAM_Q(10), b(9)=>VARAM_Q(9), b(8)=>VARAM_Q(8), 
      b(7)=>VARAM_Q(7), b(6)=>VARAM_Q(6), b(5)=>VARAM_Q(5), b(4)=>
      VARAM_D_26n172s1f2(4), b(3)=>VARAM_D_26n172s1f2(3), b(2)=>
      VARAM_D_26n172s1f2(2), b(1)=>VARAM_D_26n172s1f2(1), b(0)=>
      VARAM_D_26n172s1f2(0), d(15)=>VARAM_D_26n172s1_15, d(14)=>
      VARAM_D_26n172s1_14, d(13)=>VARAM_D_26n172s1_13, d(12)=>
      VARAM_D_26n172s1_12, d(11)=>VARAM_D_26n172s1_11, d(10)=>
      VARAM_D_26n172s1_10, d(9)=>VARAM_D_26n172s1_9, d(8)=>
      VARAM_D_26n172s1_8, d(7)=>VARAM_D_26n172s1_7, d(6)=>VARAM_D_26n172s1_6, 
      d(5)=>VARAM_D_26n172s1_5, d(4)=>LIFO_Pointer_26n126s1(4), d(3)=>
      LIFO_Pointer_26n126s1(3), d(2)=>LIFO_Pointer_26n126s1(2), d(1)=>
      LIFO_Pointer_26n126s1(1), d(0)=>LIFO_Pointer_26n126s1(0), cout=>
      DANGLING(3));
   VARAM_D_select_26i26Bus190_1 : select_3_3 port map ( a(2)=>BC_State(86), 
      a(1)=>rtlc26n17323, a(0)=>rtlcn2269, b(2)=>Data_o_temp(1), b(1)=>
      LIFO_Pointer(1), b(0)=>BC_word_number(1), d=>VARAM_D_26n172s1f1(1));
   VARAM_D_select_26i26Bus190_0 : select_3_3 port map ( a(2)=>BC_State(86), 
      a(1)=>rtlc26n17323, a(0)=>rtlcn2269, b(2)=>Data_o_temp(0), b(1)=>
      LIFO_Pointer(0), b(0)=>BC_word_number(0), d=>VARAM_D_26n172s1f1(0));
   NOT_BC_State_12 <= NOT BC_State(12) ;
   rtlc29n609 <= rtlc29n464 OR rtlc29n472 ;
   rtlc29n526 <= Clean_ISR1_by_write OR Clean_ISR2_by_write ;
   rtlc29n518 <= Clean_status_bits OR Clean_status2_bits ;
   rtlc29n472 <= rtlc75_Interrupt_status_register_2_D_n494_15 AND 
   INTn_level_D ;
   rtlc29n463 <= rtlcs157 OR rtlcs156 ;
   not_Non_masked_Event_D <= NOT Non_masked_Event_D ;
   rtlc29n455 <= Non_masked_Event AND not_Non_masked_Event_D ;
   rtlc29n464 <= rtlc29n455 AND rtlc29n463 ;
   rtlc29n442 <= Interrupt_status_register_2_1 AND 
   Interrupt_mask_register_2(1) ;
   rtlc29n436 <= Interrupt_status_register_2_2 AND 
   Interrupt_mask_register_2(2) ;
   rtlc29n430 <= Interrupt_status_register_2_3 AND 
   Interrupt_mask_register_2(3) ;
   rtlc29n424 <= Interrupt_status_register_2_4 AND 
   Interrupt_mask_register_2(4) ;
   rtlc29n418 <= Interrupt_status_register_2_5 AND 
   Interrupt_mask_register_2(5) ;
   rtlc29n412 <= Interrupt_status_register_2_6 AND 
   Interrupt_mask_register_2(6) ;
   rtlc29n406 <= Interrupt_status_register_2_7 AND 
   Interrupt_mask_register_2(7) ;
   rtlc29n400 <= Interrupt_status_register_2_10 AND 
   Interrupt_mask_register_2(10) ;
   rtlc29n394 <= Interrupt_status_register_2_11 AND 
   Interrupt_mask_register_2(11) ;
   rtlc29n388 <= Interrupt_status_register_2_12 AND 
   Interrupt_mask_register_2(12) ;
   rtlc29n383 <= Interrupt_status_register_2_14 AND 
   Interrupt_mask_register_2(14) ;
   rtlc29n370 <= Interrupt_status_register_1(0) AND 
   Interrupt_mask_register_1(0) ;
   rtlc29n364 <= Interrupt_status_register_1(1) AND 
   Interrupt_mask_register_1(1) ;
   rtlc29n358 <= Interrupt_status_register_1(2) AND 
   Interrupt_mask_register_1(2) ;
   rtlc29n352 <= Interrupt_status_register_1(3) AND 
   Interrupt_mask_register_1(3) ;
   rtlc29n346 <= Interrupt_status_register_1(4) AND 
   Interrupt_mask_register_1(4) ;
   rtlc29n340 <= Interrupt_status_register_1(5) AND 
   Interrupt_mask_register_1(5) ;
   rtlc29n334 <= Interrupt_status_register_1(6) AND 
   Interrupt_mask_register_1(6) ;
   rtlc29n328 <= Interrupt_status_register_1(7) AND 
   Interrupt_mask_register_1(7) ;
   rtlc29n322 <= Interrupt_status_register_1(8) AND 
   Interrupt_mask_register_1(8) ;
   rtlc29n316 <= Interrupt_status_register_1(9) AND 
   Interrupt_mask_register_1(9) ;
   rtlc29n310 <= Interrupt_status_register_1(10) AND 
   Interrupt_mask_register_1(10) ;
   rtlc29n304 <= Interrupt_status_register_1(11) AND 
   Interrupt_mask_register_1(11) ;
   rtlc29n298 <= Interrupt_status_register_1(12) AND 
   Interrupt_mask_register_1(12) ;
   rtlc29n292 <= Interrupt_status_register_1(13) AND 
   Interrupt_mask_register_1(13) ;
   rtlc29n287 <= Interrupt_status_register_1(14) AND 
   Interrupt_mask_register_1(14) ;
   rtlc29n261 <= rtlc29n518 OR Clean_ISR1_by_write ;
   rtlc29n262 <= rtlc29n261 OR Clean_ISR2_by_write ;
   rtlc75_Interrupt_status_register_2_D_n494_15 <= NOT INTn_level ;
   not_INTn_count_4 <= NOT INTn_count(4) ;
   rtlc29n681 <= not_rtlcn1252 OR not_INTn_count_4 ;
   W_R_32n3s1 <= Write OR Read ;
   rtlc32n557 <= not_STM_ended AND arbiter ;
   rtlc32n581 <= rtlc32n557 AND rtlc32n759 ;
   not_STM_ended <= NOT STM_ended ;
   not_rtlc32n468 <= NOT rtlc32n468 ;
   rtlc32n468 <= Monitor_write AND not_M_W ;
   not_rtlc32n459 <= NOT rtlc32n459 ;
   rtlc32n459 <= Monitor_new_command AND MT_On_Async ;
   not_rtlc32n451 <= NOT rtlc32n451 ;
   rtlc32n450 <= Monitor_Ended_not_OK OR Monitor_ended_OK ;
   rtlc32n451 <= rtlc32n450 AND MT_On ;
   rtlc32n441 <= W_R_32n3s1 AND not_W_R ;
   not_rtlc32n429 <= NOT rtlc32n429 ;
   rtlc32n426 <= Message_ended_OK AND RT_On_EXMPLR924 ;
   rtlc32n429 <= rtlc32n426 AND not_Channel_Status_3 ;
   not_rtlc32n411 <= NOT rtlc32n411 ;
   rtlc32n408 <= New_command AND RT_On_EXMPLR924 ;
   rtlc32n411 <= rtlc32n408 AND not_host_status_bits_3 ;
   not_Channel_Status_3 <= NOT Channel_Status(3) ;
   not_M_W <= NOT M_W ;
   not_W_R <= NOT W_R ;
   not_host_status_bits_3 <= NOT host_status_bits_3_EXMPLR935 ;
   not_Timeout_counter_6 <= NOT Timeout_counter(6) ;
   rtlc32_336_and_146 : and_5u_5u port map ( a(4)=>Timeout_counter(4), a(3)
      =>Timeout_counter(3), a(2)=>Timeout_counter(2), a(1)=>
      Timeout_counter(1), a(0)=>Timeout_counter(0), d=>rtlc32n756);
   rtlc32n759 <= not_rtlcn1230 OR not_Timeout_counter_6 ;
   not_MODE_CODE1553A <= NOT MODE_CODE1553A_EXMPLR917 ;
   rtlc35n91 <= rtlcs164 AND not_MODE_CODE1553A ;
   rtlc35n98 <= rtlc35n91 OR rtlcs158 ;
   rtlc41n148 <= BC_Loopback_error OR BC_Coupling_error ;
   rtlc41n128 <= BC_Found_Format_Error OR BC_wrong_sync ;
   rtlc41n130 <= rtlc41n128 OR BC_Found_wrong_word_count ;
   rtlc41n132 <= rtlc41n130 OR BC_Found_wrong_RT_Address ;
   rtlc41n105 <= BC_FE_All_Errors OR BC_FE_Logic_error ;
   rtlc44n271 <= Config_reg_4_EXMPLR998(11) AND BC_Rx_Data(4) ;
   rtlc44n274 <= rtlc44n271 AND not_BC_Control_word_5 ;
   not_rtlcs170 <= NOT rtlcs170 ;
   rtlc44n222 <= Config_reg_4_EXMPLR998(11) AND not_BC_Control_word_5 ;
   rtlc44n225 <= rtlc44n222 AND BC_Rx_Data(4) ;
   rtlc44n197 <= not_BC_Control_word_10 AND BC_Rx_Data(0) ;
   rtlc44n188 <= not_BC_Control_word_11 AND BC_Rx_Data(2) ;
   rtlc44n182 <= not_BC_Control_word_12 AND BC_Rx_Data(3) ;
   rtlc44n176 <= not_BC_Control_word_13 AND BC_Rx_Data(8) ;
   rtlc44n168 <= not_BC_Control_word_14 AND BC_Rx_Data(10) ;
   rtlc44n159 <= rtlc26n13384 AND BC_Command_Sync ;
   rtlc44n161 <= rtlc44n159 AND not_BC_reported_errors ;
   not_BC_Control_word_5 <= NOT BC_Control_word_5 ;
   not_BC_Control_word_14 <= NOT BC_Control_word_14 ;
   not_BC_Control_word_13 <= NOT BC_Control_word_13 ;
   not_BC_Control_word_12 <= NOT BC_Control_word_12 ;
   not_BC_Control_word_11 <= NOT BC_Control_word_11 ;
   not_BC_Control_word_10 <= NOT BC_Control_word_10 ;
   YES_mux_45i1 : mux_16u_16u port map ( a(15)=>PWR, a(14)=>BC_Sts_Word(6), 
      a(13)=>BC_Sts_Word(5), a(12)=>BC_Sts_Word(12), a(11)=>
      eBC_Conditions_11, a(10)=>Good_data_block_recieved, a(9)=>
      eBC_Conditions_9, a(8)=>BC_Sts_Word(9), a(7)=>eBC_GP(7), a(6)=>
      eBC_GP(6), a(5)=>eBC_GP(5), a(4)=>eBC_GP(4), a(3)=>eBC_GP(3), a(2)=>
      eBC_GP(2), a(1)=>eBC_GP(1), a(0)=>eBC_GP(0), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Echo_word(3), b(2)=>BC_Echo_word(2), b(1)=>BC_Echo_word(1), b(0)=>
      BC_Echo_word(0), d=>YES_45n1s2);
   rtlc48n177 <= rtlcn1228 AND not_BC_Load_msg_gap_counter ;
   not_rtlc48n339 <= NOT rtlc48n339 ;
   rtlc48_169_or_149 : or_15u_15u port map ( a(14)=>
      BC_GAP_to_next_msg_counter(1), a(13)=>BC_GAP_to_next_msg_counter(2), 
      a(12)=>BC_GAP_to_next_msg_counter(3), a(11)=>
      BC_GAP_to_next_msg_counter(4), a(10)=>BC_GAP_to_next_msg_counter(5), 
      a(9)=>BC_GAP_to_next_msg_counter(6), a(8)=>
      BC_GAP_to_next_msg_counter(7), a(7)=>BC_GAP_to_next_msg_counter(8), 
      a(6)=>BC_GAP_to_next_msg_counter(9), a(5)=>
      BC_GAP_to_next_msg_counter(10), a(4)=>BC_GAP_to_next_msg_counter(11), 
      a(3)=>BC_GAP_to_next_msg_counter(12), a(2)=>
      BC_GAP_to_next_msg_counter(13), a(1)=>BC_GAP_to_next_msg_counter(14), 
      a(0)=>BC_GAP_to_next_msg_counter(15), d=>rtlc48n339);
   rtlc51_173_and_150 : and_4u_4u port map ( a(3)=>not_rtlc51n502, a(2)=>
      rtlcn1227, a(1)=>not_eBC_start_FT, a(0)=>not_BC_Load_frame_gap_counter, 
      d=>rtlc51_X_0_n319);
   not_rtlc51n502 <= NOT rtlc51n502 ;
   rtlc51_360_or_152 : or_15u_15u port map ( a(14)=>BC_frame_GAP_counter(1), 
      a(13)=>BC_frame_GAP_counter(2), a(12)=>BC_frame_GAP_counter(3), a(11)
      =>BC_frame_GAP_counter(4), a(10)=>BC_frame_GAP_counter(5), a(9)=>
      BC_frame_GAP_counter(6), a(8)=>BC_frame_GAP_counter(7), a(7)=>
      BC_frame_GAP_counter(8), a(6)=>BC_frame_GAP_counter(9), a(5)=>
      BC_frame_GAP_counter(10), a(4)=>BC_frame_GAP_counter(11), a(3)=>
      BC_frame_GAP_counter(12), a(2)=>BC_frame_GAP_counter(13), a(1)=>
      BC_frame_GAP_counter(14), a(0)=>BC_frame_GAP_counter(15), d=>
      rtlc51n502);
   Current_command_is_sync_with_data_60n11s1 <= 
   Current_command_is_sync_with_data_60n11s2 OR 
   Current_command_is_sync_with_data_60n11s3 ;
   Current_command_is_sync_without_data_60n11s1 <= 
   Current_command_is_sync_without_data_60n11s2 OR 
   Current_command_is_sync_without_data_60n11s3 ;
   Monitor_command_is_sync_with_data_60n11s1 <= 
   Monitor_command_is_sync_with_data_60n11s2 AND not_RT_On ;
   Monitor_command_is_sync_with_data_60n11s2 <= 
   Monitor_command_is_sync_with_data_60n11s3 AND MT_On ;
   Monitor_command_is_sync_with_data_60n11s3 <= 
   Monitor_command_is_sync_with_data_60n11s4 AND Config_reg_6_3 ;
   Monitor_command_is_sync_with_data_60n11s4 <= 
   Monitor_command_is_sync_with_data_60n11s5 OR 
   Monitor_command_is_sync_with_data_60n11s6 ;
   Monitor_command_is_sync_without_data_60n11s1 <= 
   Monitor_command_is_sync_without_data_60n11s2 AND not_RT_On ;
   Monitor_command_is_sync_without_data_60n11s2 <= 
   Monitor_command_is_sync_without_data_60n11s3 AND MT_On ;
   Monitor_command_is_sync_without_data_60n11s3 <= 
   Monitor_command_is_sync_without_data_60n11s4 AND Config_reg_6_3 ;
   Monitor_command_is_sync_without_data_60n11s4 <= 
   Monitor_command_is_sync_without_data_60n11s5 OR 
   Monitor_command_is_sync_without_data_60n11s6 ;
   MT_On_Async_60n18s1 <= MT_On_Async_60n18s2 AND CPU_Data_in_wide(28) ;
   MT_On_Async_60n18s2 <= CPU_Data_in_wide(31) AND not_CPU_Data_in_wide_30 ;
   Clear_Test_Status_reg_60n20s1 <= CPU_Data_in_wide(26) AND not_WM_On ;
   MT_On_Async_60n27s1 <= not_MT_On_Async_60n27s3 AND Config_reg_1(12) ;
   not_MT_On_Async_60n27s3 <= NOT MT_On_Async_60n27s3 ;
   not_eBC_GP_0 <= NOT eBC_GP(0) ;
   not_eBC_GP_1 <= NOT eBC_GP(1) ;
   not_eBC_GP_2 <= NOT eBC_GP(2) ;
   not_eBC_GP_3 <= NOT eBC_GP(3) ;
   not_eBC_GP_4 <= NOT eBC_GP(4) ;
   not_eBC_GP_5 <= NOT eBC_GP(5) ;
   not_eBC_GP_6 <= NOT eBC_GP(6) ;
   not_eBC_GP_7 <= NOT eBC_GP(7) ;
   host_status_bits_2_60n45s2 <= Set_SSFLAG OR not_Config_reg_1_8 ;
   not_Config_reg_1_10 <= NOT Config_reg_1(10) ;
   rtlc60n7254 <= rtlcs307 OR rtlcs305 ;
   not_BC_IDLE <= NOT BC_IDLE ;
   rtlc60n5601 <= rtlc60n5559 AND not_rtlc60n5595 ;
   rtlc60n5602 <= rtlc60n5560 AND not_rtlc60n5595 ;
   rtlc60n5527 <= rtlc60n5491 AND not_CPU_Data_in_wide_19 ;
   rtlc60n5491 <= rtlc60n5482 AND not_CPU_Data_in_wide_23 ;
   rtlc60n5482 <= rtlc60n5384 AND not_CPU_Data_in_wide_25 ;
   rtlc60n6602 <= rtlc60n5981 AND not_Config_reg_3_2 ;
   rtlc60n6577 <= rtlc60n5981 AND not_rtlc60n6552 ;
   rtlc60n6680 <= rtlc60n6612 AND not_WM_On ;
   rtlc60n6612 <= rtlc60n5906 AND not_BC_on ;
   rtlc60n6681 <= rtlc60n6623 AND not_WM_On ;
   rtlc60n6623 <= rtlc60n6612 AND not_rtlc60n6646 ;
   rtlc60n5666 <= rtlc60n5566 AND not_rtlcs236 ;
   rtlc60n5566 <= not_CE AND not_rtlc60n5464 ;
   rtlc60n5557 <= not_CPU_Data_in_wide_22 AND not_CPU_Data_in_wide_17 ;
   rtlc60n5933 <= not_rtlc60n6494 OR rtlc60n5901 ;
   rtlc60n5932 <= not_rtlc60n6494 OR rtlc60n5900 ;
   rtlc60n5931 <= not_rtlc60n6494 OR rtlc60n5899 ;
   rtlc60n5930 <= not_rtlc60n6494 OR rtlc60n5898 ;
   rtlc60n5929 <= not_rtlc60n6494 OR rtlc60n5897 ;
   rtlc60n5928 <= not_rtlc60n6494 OR rtlc60n5896 ;
   rtlc60n5927 <= not_rtlc60n6494 OR rtlc60n5895 ;
   rtlc60n5926 <= not_rtlc60n6494 OR rtlc60n5894 ;
   rtlc60n5387 <= not_CE OR not_rtlc60n5038 ;
   rtlc60n5386 <= not_CE OR not_rtlc60n5339 ;
   rtlc60n5384 <= not_CE OR not_rtlcn1245 ;
   rtlc60n5383 <= not_CE OR not_rtlcn10838 ;
   rtlc60n6711 <= not_Current_command_10 AND not_BCR ;
   rtlc60n6714 <= rtlc60n6711 AND LUT_Control(15) ;
   rtlc60n6722 <= rtlc60n6714 AND rtlc60n6721 ;
   rtlc60n6696 <= not_Current_command_10 AND BCR ;
   rtlc60n6699 <= rtlc60n6696 AND LUT_Control(15) ;
   rtlc60n6707 <= rtlc60n6699 AND rtlc60n6706 ;
   rtlc60n6723 <= rtlc60n6707 OR rtlc60n6722 ;
   rtlc60n6724 <= Config_reg_6_12 AND rtlc60n6723 ;
   rtlc60n6646 <= not_RT_On AND MT_On ;
   rtlc60n6648 <= rtlc60n6646 AND Monitor_new_command ;
   rtlc60n6633 <= Message_ended_OK OR Message_ended_not_OK ;
   not_Config_reg_3_2 <= NOT Config_reg_3_2 ;
   rtlc60n6584 <= MIL1553_errors_transmitter_timout OR 
   MIL1553_errors_echo_back_bus_B ;
   rtlc60n6587 <= rtlc60n6584 OR MIL1553_errors_echo_back_bus_A ;
   rtlc60n6560 <= Config_reg_3_5 AND Config_reg_3_15 ;
   rtlc60n6544 <= rtlcs165 OR rtlcs159 ;
   not_Read_from_int_vec2 <= NOT Read_from_int_vec2 ;
   rtlc60n6494 <= CPU_CS AND not_MEM_nREG ;
   rtlc60n6499 <= rtlc60n6494 AND Config_reg_2(4) ;
   rtlc60n6506 <= rtlc60n6499 AND rtlcs243 ;
   rtlc60n6509 <= rtlc60n6506 AND CPU_RE_vec(0) ;
   rtlc60n6473 <= rtlc60n6499 AND rtlcs269 ;
   rtlc60n6476 <= rtlc60n6473 AND CPU_RE_vec(0) ;
   rtlc60_1719_gt_155 : gt_16u_16u port map ( a(15)=>VARAM_Q(15), a(14)=>
      VARAM_Q(14), a(13)=>VARAM_Q(13), a(12)=>VARAM_Q(12), a(11)=>
      VARAM_Q(11), a(10)=>VARAM_Q(10), a(9)=>VARAM_Q(9), a(8)=>VARAM_Q(8), 
      a(7)=>VARAM_Q(7), a(6)=>VARAM_Q(6), a(5)=>VARAM_Q(5), a(4)=>VARAM_Q(4), 
      a(3)=>VARAM_Q(3), a(2)=>VARAM_Q(2), a(1)=>VARAM_Q(1), a(0)=>VARAM_Q(0), 
      b(15)=>BC_msg_pointer(15), b(14)=>BC_msg_pointer(14), b(13)=>
      BC_msg_pointer(13), b(12)=>BC_msg_pointer(12), b(11)=>
      BC_msg_pointer(11), b(10)=>BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), 
      b(8)=>BC_msg_pointer(8), b(7)=>BC_msg_pointer(7), b(6)=>
      BC_msg_pointer(6), b(5)=>BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), 
      b(3)=>BC_msg_pointer(3), b(2)=>BC_msg_pointer(2), b(1)=>
      BC_msg_pointer(1), b(0)=>BC_msg_pointer(0), d=>not_rtlc60n7249);
   rtlc60n7249 <= NOT not_rtlc60n7249 ;
   rtlc60n6084 <= MON_SOM_phase_go AND not_RT_On ;
   rtlc60n6074 <= RT_On_EXMPLR924 AND SOM_req ;
   rtlc60n6060 <= BC_IDLE OR BC_EOF ;
   rtlc60n6061 <= BC_on_EXMPLR883 AND rtlc60n6060 ;
   not_eBC_Inc_Q_pointer <= NOT eBC_Inc_Q_pointer ;
   not_rtlc60n6002 <= NOT rtlc60n6002 ;
   rtlc60n6000 <= Clear_Stop_EOF OR Clear_Stop_EOM ;
   rtlc60n6002 <= rtlc60n6000 OR not_BC_on ;
   not_rtlc60n5987 <= NOT rtlc60n5987 ;
   rtlc60n5987 <= Clear_Stop_EOM OR not_BC_on ;
   rtlc60n5942 <= not_Config_reg_3_5 OR not_Config_reg_3_15 ;
   rtlc60n5595 <= rtlcs267 AND CPU_WE_vec(1) ;
   not_rtlc60n5579 <= NOT rtlc60n5579 ;
   rtlc60n5579 <= rtlcs267 AND CPU_WE_vec(0) ;
   not_CPU_Data_in_wide_18 <= NOT CPU_Data_in_wide(18) ;
   not_CPU_Data_in_wide_20 <= NOT CPU_Data_in_wide(20) ;
   not_CPU_Data_in_wide_21 <= NOT CPU_Data_in_wide(21) ;
   rtlc60n5464 <= rtlcs272 AND CPU_WE_vec(1) ;
   rtlc60n5424 <= rtlcs273 AND CPU_WE_vec(1) ;
   rtlc60n5359 <= Monitor_ended_OK AND Monitor_command_is_sync_with_data ;
   rtlc60n5350 <= Write AND Config_reg_2(5) ;
   rtlc60n5352 <= rtlc60n5350 AND not_illegal_message ;
   rtlc60n5353 <= rtlc60n5352 AND Current_command_is_sync_with_data ;
   not_rtlc60n5339 <= NOT rtlc60n5339 ;
   rtlc60n5337 <= MON_Phase(0) AND not_MON_Phase_1 ;
   rtlc60n5338 <= Once AND rtlc60n5337 ;
   rtlc60n5339 <= rtlc60n5338 AND Monitor_command_is_sync_with_data ;
   rtlc60n5323 <= Monitor_command_is_sync_without_data AND Monitor_ended_OK
    ;
   rtlc60n5317 <= Do_illegal_EXMPLR916 AND Config_reg_2(6) ;
   rtlc60n5319 <= rtlc60n5317 AND not_illegal_message ;
   rtlc60n5320 <= rtlc60n5319 AND Current_command_is_sync_without_data ;
   rtlc60n5311 <= Do_RAM_test AND not_Test_Status_reg_6 ;
   rtlc60n5308 <= Do_Protocol_test AND not_Test_Status_reg_14 ;
   rtlc60n5312 <= rtlc60n5308 OR rtlc60n5311 ;
   rtlc60n5321 <= rtlc60n5312 OR rtlc60n5320 ;
   rtlc60n5324 <= rtlc60n5321 OR rtlc60n5323 ;
   rtlc60n5149 <= rtlcs281 AND rtlcs289 ;
   rtlc60n5136 <= rtlcs282 AND rtlcs293 ;
   not_rtlc60n5038 <= NOT rtlc60n5038 ;
   rtlc60n5038 <= BC_Started OR WM_Started_EXMPLR927 ;
   count_T_RESus_inc6_60i1 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>
      count_T_RESus(5), a(4)=>count_T_RESus(4), a(3)=>count_T_RESus(3), a(2)
      =>count_T_RESus(2), a(1)=>count_T_RESus(1), a(0)=>count_T_RESus(0), 
      d(5)=>count_T_RESus_60n6s1(5), d(4)=>count_T_RESus_60n6s1(4), d(3)=>
      count_T_RESus_60n6s1(3), d(2)=>count_T_RESus_60n6s1(2), d(1)=>
      count_T_RESus_60n6s1(1), d(0)=>count_T_RESus_60n6s1(0), cout=>DANGLING
      (4));
   time_tag_inc16_60i2 : inc_16u_16u_0 port map ( cin=>PWR, a(15)=>
      time_tag_EXMPLR1002(15), a(14)=>time_tag_EXMPLR1002(14), a(13)=>
      time_tag_EXMPLR1002(13), a(12)=>time_tag_EXMPLR1002(12), a(11)=>
      time_tag_EXMPLR1002(11), a(10)=>time_tag_EXMPLR1002(10), a(9)=>
      time_tag_EXMPLR1002(9), a(8)=>time_tag_EXMPLR1002(8), a(7)=>
      time_tag_EXMPLR1002(7), a(6)=>time_tag_EXMPLR1002(6), a(5)=>
      time_tag_EXMPLR1002(5), a(4)=>time_tag_EXMPLR1002(4), a(3)=>
      time_tag_EXMPLR1002(3), a(2)=>time_tag_EXMPLR1002(2), a(1)=>
      time_tag_EXMPLR1002(1), a(0)=>time_tag_EXMPLR1002(0), d(15)=>
      time_tag_60n10s1(15), d(14)=>time_tag_60n10s1(14), d(13)=>
      time_tag_60n10s1(13), d(12)=>time_tag_60n10s1(12), d(11)=>
      time_tag_60n10s1(11), d(10)=>time_tag_60n10s1(10), d(9)=>
      time_tag_60n10s1(9), d(8)=>time_tag_60n10s1(8), d(7)=>
      time_tag_60n10s1(7), d(6)=>time_tag_60n10s1(6), d(5)=>
      time_tag_60n10s1(5), d(4)=>time_tag_60n10s1(4), d(3)=>
      time_tag_60n10s1(3), d(2)=>time_tag_60n10s1(2), d(1)=>
      time_tag_60n10s1(1), d(0)=>time_tag_60n10s1(0), cout=>DANGLING(5));
   eBC_Q_pointer_inc6_60i3 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>
      eBC_Q_pointer(5), a(4)=>eBC_Q_pointer(4), a(3)=>eBC_Q_pointer(3), a(2)
      =>eBC_Q_pointer(2), a(1)=>eBC_Q_pointer(1), a(0)=>eBC_Q_pointer(0), 
      d(5)=>eBC_Q_pointer_60n50s1(5), d(4)=>eBC_Q_pointer_60n50s1(4), d(3)=>
      eBC_Q_pointer_60n50s1(3), d(2)=>eBC_Q_pointer_60n50s1(2), d(1)=>
      eBC_Q_pointer_60n50s1(1), d(0)=>eBC_Q_pointer_60n50s1(0), cout=>
      DANGLING(6));
   not_CPU_Address_1 <= NOT CPU_Address(1) ;
   not_CPU_Address_2 <= NOT CPU_Address(2) ;
   not_Test_Status_reg_14 <= NOT Test_Status_reg_14 ;
   not_Test_Status_reg_6 <= NOT Test_Status_reg_6 ;
   not_MON_Phase_1 <= NOT MON_Phase(1) ;
   not_Tag_CLK_DD <= NOT Tag_CLK_DD ;
   not_Config_reg_3_5 <= NOT Config_reg_3_5 ;
   not_CPU_Data_in_wide_30 <= NOT CPU_Data_in_wide(30) ;
   rtlc60_2649_gt_159 : gt_16u_16u port map ( a(15)=>
      BC_frame_GAP_counter(15), a(14)=>BC_frame_GAP_counter(14), a(13)=>
      BC_frame_GAP_counter(13), a(12)=>BC_frame_GAP_counter(12), a(11)=>
      BC_frame_GAP_counter(11), a(10)=>BC_frame_GAP_counter(10), a(9)=>
      BC_frame_GAP_counter(9), a(8)=>BC_frame_GAP_counter(8), a(7)=>
      BC_frame_GAP_counter(7), a(6)=>BC_frame_GAP_counter(6), a(5)=>
      BC_frame_GAP_counter(5), a(4)=>BC_frame_GAP_counter(4), a(3)=>
      BC_frame_GAP_counter(3), a(2)=>BC_frame_GAP_counter(2), a(1)=>
      BC_frame_GAP_counter(1), a(0)=>BC_frame_GAP_counter(0), b(15)=>
      BC_msg_pointer(15), b(14)=>BC_msg_pointer(14), b(13)=>
      BC_msg_pointer(13), b(12)=>BC_msg_pointer(12), b(11)=>
      BC_msg_pointer(11), b(10)=>BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), 
      b(8)=>BC_msg_pointer(8), b(7)=>BC_msg_pointer(7), b(6)=>
      BC_msg_pointer(6), b(5)=>BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), 
      b(3)=>BC_msg_pointer(3), b(2)=>BC_msg_pointer(2), b(1)=>
      BC_msg_pointer(1), b(0)=>BC_msg_pointer(0), d=>not_rtlc60n7906);
   rtlc60n7906 <= NOT not_rtlc60n7906 ;
   rtlc60_2674_gt_160 : gt_16u_16u port map ( a(15)=>
      BC_GAP_to_next_msg_counter(15), a(14)=>BC_GAP_to_next_msg_counter(14), 
      a(13)=>BC_GAP_to_next_msg_counter(13), a(12)=>
      BC_GAP_to_next_msg_counter(12), a(11)=>BC_GAP_to_next_msg_counter(11), 
      a(10)=>BC_GAP_to_next_msg_counter(10), a(9)=>
      BC_GAP_to_next_msg_counter(9), a(8)=>BC_GAP_to_next_msg_counter(8), 
      a(7)=>BC_GAP_to_next_msg_counter(7), a(6)=>
      BC_GAP_to_next_msg_counter(6), a(5)=>BC_GAP_to_next_msg_counter(5), 
      a(4)=>BC_GAP_to_next_msg_counter(4), a(3)=>
      BC_GAP_to_next_msg_counter(3), a(2)=>BC_GAP_to_next_msg_counter(2), 
      a(1)=>BC_GAP_to_next_msg_counter(1), a(0)=>
      BC_GAP_to_next_msg_counter(0), b(15)=>BC_msg_pointer(15), b(14)=>
      BC_msg_pointer(14), b(13)=>BC_msg_pointer(13), b(12)=>
      BC_msg_pointer(12), b(11)=>BC_msg_pointer(11), b(10)=>
      BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), b(8)=>BC_msg_pointer(8), 
      b(7)=>BC_msg_pointer(7), b(6)=>BC_msg_pointer(6), b(5)=>
      BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), b(3)=>BC_msg_pointer(3), 
      b(2)=>BC_msg_pointer(2), b(1)=>BC_msg_pointer(1), b(0)=>
      BC_msg_pointer(0), d=>not_rtlc60n7956);
   rtlc60n7956 <= NOT not_rtlc60n7956 ;
   RT_On_63n1s1 <= Config_reg_1(15) AND not_Config_reg_1_14 ;
   WM_On_63n3s1 <= WM_On_63n3s2 AND not_Config_reg_1_12 ;
   WM_On_63n3s2 <= not_Config_reg_1_15 AND Config_reg_1(14) ;
   not_Config_reg_1_14 <= NOT Config_reg_1(14) ;
   not_Config_reg_1_15 <= NOT Config_reg_1(15) ;
   not_Config_reg_1_12 <= NOT Config_reg_1(12) ;
   rtlc66n47 <= rtlc60n6494 AND rtlcs272 ;
   Non_masked_Event_75n1s3_0 <= ISR1_during_clear_0 AND 
   Interrupt_mask_register_1(0) ;
   Non_masked_Event_75n1s3_1 <= ISR1_during_clear_1 AND 
   Interrupt_mask_register_1(1) ;
   Non_masked_Event_75n1s3_2 <= ISR1_during_clear_2 AND 
   Interrupt_mask_register_1(2) ;
   Non_masked_Event_75n1s3_3 <= ISR1_during_clear_3 AND 
   Interrupt_mask_register_1(3) ;
   Non_masked_Event_75n1s3_4 <= ISR1_during_clear_4 AND 
   Interrupt_mask_register_1(4) ;
   Non_masked_Event_75n1s3_5 <= ISR1_during_clear_5 AND 
   Interrupt_mask_register_1(5) ;
   Non_masked_Event_75n1s3_6 <= ISR1_during_clear_6 AND 
   Interrupt_mask_register_1(6) ;
   Non_masked_Event_75n1s3_8 <= ISR1_during_clear_8 AND 
   Interrupt_mask_register_1(8) ;
   Non_masked_Event_75n1s3_10 <= ISR1_during_clear_10 AND 
   Interrupt_mask_register_1(10) ;
   Non_masked_Event_75n1s3_11 <= ISR1_during_clear_11 AND 
   Interrupt_mask_register_1(11) ;
   Non_masked_Event_75n1s3_12 <= ISR1_during_clear_12 AND 
   Interrupt_mask_register_1(12) ;
   Non_masked_Event_75n1s3_13 <= ISR1_during_clear_13 AND 
   Interrupt_mask_register_1(13) ;
   Non_masked_Event_75n3s3_1 <= ISR2_during_clear_1 AND 
   Interrupt_mask_register_2(1) ;
   Non_masked_Event_75n3s3_3 <= ISR2_during_clear_3 AND 
   Interrupt_mask_register_2(3) ;
   Non_masked_Event_75n3s3_4 <= ISR2_during_clear_4 AND 
   Interrupt_mask_register_2(4) ;
   Non_masked_Event_75n3s3_5 <= ISR2_during_clear_5 AND 
   Interrupt_mask_register_2(5) ;
   Non_masked_Event_75n3s3_6 <= ISR2_during_clear_6 AND 
   Interrupt_mask_register_2(6) ;
   Non_masked_Event_75n3s3_7 <= ISR2_during_clear_7 AND 
   Interrupt_mask_register_2(7) ;
   Non_masked_Event_75n3s3_10 <= ISR2_during_clear_10 AND 
   Interrupt_mask_register_2(10) ;
   Non_masked_Event_75n3s3_11 <= ISR2_during_clear_11 AND 
   Interrupt_mask_register_2(11) ;
   Non_masked_Event_75n3s3_12 <= ISR2_during_clear_12 AND 
   Interrupt_mask_register_2(12) ;
   Non_masked_Event_75n3s3_14 <= ISR2_during_clear_14 AND 
   Interrupt_mask_register_2(14) ;
   Interrupt_status_register_1_75n6s1_0 <= Interrupt_status_register_1(0)
    AND Interrupt_status_register_1_75n6s2(0) ;
   Interrupt_status_register_1_75n6s1_1 <= Interrupt_status_register_1(1)
    AND Interrupt_status_register_1_75n6s2(1) ;
   Interrupt_status_register_1_75n6s1_2 <= Interrupt_status_register_1(2)
    AND Interrupt_status_register_1_75n6s2(2) ;
   Interrupt_status_register_1_75n6s1_3 <= Interrupt_status_register_1(3)
    AND Interrupt_status_register_1_75n6s2(3) ;
   Interrupt_status_register_1_75n6s1_4 <= Interrupt_status_register_1(4)
    AND Interrupt_status_register_1_75n6s2(4) ;
   Interrupt_status_register_1_75n6s1_5 <= Interrupt_status_register_1(5)
    AND Interrupt_status_register_1_75n6s2(5) ;
   Interrupt_status_register_1_75n6s1_6 <= Interrupt_status_register_1(6)
    AND Interrupt_status_register_1_75n6s2(6) ;
   Interrupt_status_register_1_75n6s1_8 <= Interrupt_status_register_1(8)
    AND Interrupt_status_register_1_75n6s2(8) ;
   Interrupt_status_register_1_75n6s1_9 <= Interrupt_status_register_1(9)
    AND Interrupt_status_register_1_75n6s2(9) ;
   Interrupt_status_register_1_75n6s1_10 <= Interrupt_status_register_1(10)
    AND Interrupt_status_register_1_75n6s2(10) ;
   Interrupt_status_register_1_75n6s1_11 <= Interrupt_status_register_1(11)
    AND Interrupt_status_register_1_75n6s2(11) ;
   Interrupt_status_register_1_75n6s1_12 <= Interrupt_status_register_1(12)
    AND Interrupt_status_register_1_75n6s2(12) ;
   Interrupt_status_register_1_75n6s1_13 <= Interrupt_status_register_1(13)
    AND Interrupt_status_register_1_75n6s2(13) ;
   Interrupt_status_register_1_75n6s2(0) <= NOT CPU_Data_in_wide(0) ;
   Interrupt_status_register_1_75n6s2(1) <= NOT CPU_Data_in_wide(1) ;
   Interrupt_status_register_1_75n6s2(2) <= NOT CPU_Data_in_wide(2) ;
   Interrupt_status_register_1_75n6s2(3) <= NOT CPU_Data_in_wide(3) ;
   Interrupt_status_register_1_75n6s2(4) <= NOT CPU_Data_in_wide(4) ;
   Interrupt_status_register_1_75n6s2(5) <= NOT CPU_Data_in_wide(5) ;
   Interrupt_status_register_1_75n6s2(6) <= NOT CPU_Data_in_wide(6) ;
   Interrupt_status_register_1_75n6s2(7) <= NOT CPU_Data_in_wide(7) ;
   Interrupt_status_register_1_75n6s2(8) <= NOT CPU_Data_in_wide(8) ;
   Interrupt_status_register_1_75n6s2(9) <= NOT CPU_Data_in_wide(9) ;
   Interrupt_status_register_1_75n6s2(10) <= NOT CPU_Data_in_wide(10) ;
   Interrupt_status_register_1_75n6s2(11) <= NOT CPU_Data_in_wide(11) ;
   Interrupt_status_register_1_75n6s2(12) <= NOT CPU_Data_in_wide(12) ;
   Interrupt_status_register_1_75n6s2(13) <= NOT CPU_Data_in_wide(13) ;
   Interrupt_status_register_1_75n6s2(14) <= NOT CPU_Data_in_wide(14) ;
   Interrupt_status_register_2_75n6s1_1 <= Interrupt_status_register_2_1
    AND Interrupt_status_register_1_75n6s2(1) ;
   Interrupt_status_register_2_75n6s1_2 <= Interrupt_status_register_2_2
    AND Interrupt_status_register_1_75n6s2(2) ;
   Interrupt_status_register_2_75n6s1_3 <= Interrupt_status_register_2_3
    AND Interrupt_status_register_1_75n6s2(3) ;
   Interrupt_status_register_2_75n6s1_4 <= Interrupt_status_register_2_4
    AND Interrupt_status_register_1_75n6s2(4) ;
   Interrupt_status_register_2_75n6s1_5 <= Interrupt_status_register_2_5
    AND Interrupt_status_register_1_75n6s2(5) ;
   Interrupt_status_register_2_75n6s1_6 <= Interrupt_status_register_2_6
    AND Interrupt_status_register_1_75n6s2(6) ;
   Interrupt_status_register_2_75n6s1_7 <= Interrupt_status_register_2_7
    AND Interrupt_status_register_1_75n6s2(7) ;
   Interrupt_status_register_2_75n6s1_10 <= Interrupt_status_register_2_10
    AND Interrupt_status_register_1_75n6s2(10) ;
   Interrupt_status_register_2_75n6s1_11 <= Interrupt_status_register_2_11
    AND Interrupt_status_register_1_75n6s2(11) ;
   Interrupt_status_register_2_75n6s1_12 <= Interrupt_status_register_2_12
    AND Interrupt_status_register_1_75n6s2(12) ;
   Interrupt_status_register_2_75n6s1_14 <= Interrupt_status_register_2_14
    AND Interrupt_status_register_1_75n6s2(14) ;
   Non_masked_Event_75n10s1 <= Interrupt_mask_register_1(13) AND 
   not_Tx_Timeout_D ;
   not_Tx_Timeout_D <= NOT Tx_Timeout_D ;
   not_rtlcs270 <= NOT rtlcs270 ;
   not_rtlcs246 <= NOT rtlcs246 ;
   rtlc75n1436 <= not_CE OR not_Clean_status2_bits ;
   rtlc75n1435 <= not_CE OR not_Clean_status_bits ;
   not_BC_msg_pointer_0 <= NOT BC_msg_pointer(0) ;
   not_BC_msg_pointer_1 <= NOT BC_msg_pointer(1) ;
   rtlc75n1818 <= Monitor_Ended_not_OK AND MT_On ;
   rtlc75n1815 <= Monitor_ended_OK AND MT_On ;
   rtlc75n1810 <= RT_On_EXMPLR924 AND rtlc60n6633 ;
   rtlc75n1813 <= rtlc75n1810 OR BC_EOM ;
   rtlc75n1816 <= rtlc75n1813 OR rtlc75n1815 ;
   rtlc75n1819 <= rtlc75n1816 OR rtlc75n1818 ;
   rtlc75_1677_mux_161 : mux_16u_16u port map ( a(15)=>LUT_Control(15), 
      a(14)=>LUT_Control(14), a(13)=>LUT_Control(13), a(12)=>LUT_Control(12), 
      a(11)=>LUT_Control(11), a(10)=>LUT_Control(10), a(9)=>LUT_Control(9), 
      a(8)=>LUT_Control(8), a(7)=>LUT_Control(7), a(6)=>LUT_Control(6), a(5)
      =>LUT_Control(5), a(4)=>LUT_Control(4), a(3)=>LUT_Control(3), a(2)=>
      LUT_Control(2), a(1)=>LUT_Control(1), a(0)=>LUT_Control(0), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>
      Current_command(3), b(2)=>Current_command(2), b(1)=>Current_command(1), 
      b(0)=>Current_command(0), d=>rtlc75n1788);
   rtlc75n1790 <= mode_command AND rtlc75n1788 ;
   rtlc75n1793 <= rtlc75n1790 AND EOM_phase(4) ;
   rtlc75n1779 <= status_set_dt OR BC_Found_wrong_RT_Address ;
   rtlc75n1794 <= rtlc75n1779 OR rtlc75n1793 ;
   rtlc75n1795 <= rtlc75n1794 OR WM_Trigger_event ;
   rtlc75n1764 <= MON_EOM_phase_go AND Ram_data_i_12_22n78s1 ;
   rtlc75n1757 <= BC_Sts_Word(12) AND not_BC_STS_Word_12_d ;
   rtlc75n1728 <= not_eBC AND BC_EOF ;
   rtlc75n1730 <= rtlc75n1728 OR rtlc26n15497 ;
   rtlc75n1704 <= LUT_Control(4) AND EOM_phase(4) ;
   rtlc75n1711 <= rtlc75n1704 AND rtlcs168 ;
   rtlc75n1695 <= LUT_Control(9) AND EOM_phase(4) ;
   rtlc75n1698 <= rtlc75n1695 AND not_Current_command_10 ;
   rtlc75n1687 <= LUT_Control(14) AND EOM_phase(4) ;
   rtlc75n1690 <= rtlc75n1687 AND Current_command(10) ;
   rtlc75n1699 <= rtlc75n1690 OR rtlc75n1698 ;
   rtlc75n1712 <= rtlc75n1699 OR rtlc75n1711 ;
   rtlc75n1713 <= not_mode_command AND rtlc75n1712 ;
   rtlc75n1680 <= BC_EOM AND BC_Control_word_4 ;
   rtlc75n1714 <= rtlc75n1680 OR rtlc75n1713 ;
   rtlc75n1659 <= Rollover_Int_Enable AND Data_Rollover ;
   rtlc75n1662 <= rtlc75n1659 AND Config_reg_2(1) ;
   rtlc75n1665 <= rtlc75n1662 AND EOM_phase(4) ;
   rtlc75n1647 <= not_time_tag_15 AND time_tag15d ;
   not_Clean_status_bits <= NOT Clean_status_bits ;
   rtlc75n1547 <= rtlc12n13 OR Stack_rollover_interrupt ;
   not_Clean_status2_bits <= NOT Clean_status2_bits ;
   not_BC_STS_Word_12_d <= NOT BC_STS_Word_12_d ;
   not_time_tag_15 <= NOT time_tag_EXMPLR1002(15) ;
   rtlc78n136 <= mode_command AND Current_command(10) ;
   rtlc81n71 <= rtlc60n6494 AND Config_reg_4_EXMPLR998(3) ;
   rtlc81n79 <= rtlc81n71 AND rtlcs261 ;
   rtlc81n82 <= rtlc81n79 AND CPU_WE_vec(1) ;
   rtlc81n54 <= CE AND First_After_Reset ;
   rtlc84n174 <= not_Clear_Test_Status_reg AND not_rtlcs311 ;
   rtlc84n177 <= rtlc84n174 AND rtlcn1246 ;
   rtlc84n98 <= Do_Protocol_test AND not_WM_On ;
   rtlc84n99 <= First_time OR rtlc84n98 ;
   WM_RAM_data_i_6_87n9s2 <= WM_RAM_data_i_6_87n9s3 AND WM_Descriptor(3) ;
   rtlc87n616 <= state(0) OR state(1) ;
   rtlc87n636 <= state(8) OR state(6) ;
   rtlc87n646 <= state(2) OR state(6) ;
   rtlc87n508 <= Config_reg_1(11) AND Config_reg_1(9) ;
   rtlc87n519 <= rtlc87n508 AND rtlcs359 ;
   rtlc87n522 <= rtlc87n519 AND WM_Descriptor(3) ;
   rtlc87n440 <= WM_Req AND not_WM_Ack ;
   not_rtlc87n429 <= NOT rtlc87n429 ;
   rtlc87n423 <= rtlc87n440 AND rtlcs153 ;
   rtlc87n426 <= rtlc87n423 AND not_eBC_Q_pointer_10 ;
   rtlc87n431 <= rtlc87n426 AND not_rtlc87n429 ;
   rtlc87n364 <= not_Config_reg_1_11 OR not_Config_reg_1_10 ;
   rtlc87n367 <= rtlc87n364 AND not_Config_reg_1_7 ;
   not_Config_reg_1_11 <= NOT Config_reg_1(11) ;
   not_eBC_Q_pointer_10 <= NOT eBC_Q_pointer(10) ;
   rtlc87_708_or_163 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(2), a(0)=>state(7), d=>rtlc87n790);
   not_rtlcn1224 <= NOT rtlcn1224 ;
   not_rtlcn1225 <= NOT rtlcn1225 ;
   not_rtlcn1226 <= NOT rtlcn1226 ;
   rtlc26n19466 <= BC_State(15) OR BC_State(16) ;
   rtlc26n19509 <= BC_State(12) AND rtlcs151 ;
   not_rtlcn1230 <= NOT rtlcn1230 ;
   not_rtlcn1232 <= NOT rtlcn1232 ;
   not_rtlcn1234 <= NOT rtlcn1234 ;
   not_rtlcn1237 <= NOT rtlcn1237 ;
   not_rtlcn1240 <= NOT rtlcn1240 ;
   not_rtlcn1245 <= NOT rtlcn1245 ;
   not_rtlcn1252 <= NOT rtlcn1252 ;
   rtlcn1224 <= BC_Control_word_9 OR rtlcs172 ;
   rtlcn1225 <= Config_reg_4_EXMPLR998(11) OR rtlc44n263 ;
   rtlcn1226 <= Config_reg_1(6) OR Config_reg_1(7) ;
   rtlcn1227 <= rtlcs178 OR frame_gap_eq_0 ;
   rtlcn1228 <= rtlcs174 OR gap_eq_0 ;
   rtlcn1230 <= Timeout_counter(5) OR rtlc32n756 ;
   rtlcn1237 <= WM_Started_EXMPLR927 OR rtlc1n30 ;
   rtlcn1239 <= EOM_phase(4) OR Message_ended_not_OK ;
   rtlcn1240 <= rtlcn1239 OR Message_ended_OK ;
   rtlcn1252 <= rtlc29n677 OR INTn_count(0) ;
   rtlc_1910_and_164 : and_5u_5u port map ( a(4)=>Data_o_temp(11), a(3)=>
      not_Data_o_temp_12, a(2)=>not_Data_o_temp_13, a(1)=>not_Data_o_temp_14, 
      a(0)=>Ack, d=>rtlcn1257);
   Clear_Test_Status_reg_select_60i4 : select_3_3 port map ( a(2)=>rtlcs236, 
      a(1)=>not_rtlcn9862, a(0)=>rtlc60n5464, b(2)=>CPU_Data_in_wide(28), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>Clear_Test_Status_reg_60n20s1, d=>
      Clear_Test_Status_reg_60n33ss1);
   reg_data_out_wide_select_75i1 : select_16_16 port map ( a(15)=>rtlcs243, 
      a(14)=>rtlcs251, a(13)=>rtlcs231, a(12)=>rtlcs239, a(11)=>rtlcs225, 
      a(10)=>rtlcs250, a(9)=>rtlcs227, a(8)=>rtlcs257, a(7)=>rtlcs264, a(6)
      =>rtlcs259, a(5)=>rtlcs261, a(4)=>rtlcs269, a(3)=>rtlcs267, a(2)=>
      rtlcs272, a(1)=>rtlcs273, a(0)=>not_rtlcn8795, b(15)=>eBC_Q_pointer(9), 
      b(14)=>Interrupt_mask_register_2(9), b(13)=>eBC_Conditions_9, b(12)=>
      PrimeCheck, b(11)=>debug_EXMPLR1003(15), b(10)=>Latched_TT(9), b(9)=>
      PWR, b(8)=>Internal_BIT_Word_9, b(7)=>reg_data_out_wide_75n54ss1(9), 
      b(6)=>BC_frame_GAP_counter(9), b(5)=>Config_reg_5(9), b(4)=>
      Config_reg_3_9, b(3)=>time_tag_EXMPLR1002(9), b(2)=>
      reg_data_out_wide_75n41ss1(9), b(1)=>Config_reg_1(9), b(0)=>
      debug_EXMPLR1003(15), d=>reg_data_out_wide_75n70ss1(9));
   rtlc_2929_select_167 : select_4_4 port map ( a(3)=>EOM_phase(0), a(2)=>
      rtlc22n10048, a(1)=>EOM_phase(2), a(0)=>EOM_phase(4), b(3)=>
      not_EOM_phase_go, b(2)=>not_Ack, b(1)=>rtlc22n7744, b(0)=>rtlc22n7764, 
      d=>rtlcn2077);
   rtlc_2932_select_168 : select_5_5 port map ( a(4)=>SOM_phase_0, a(3)=>
      SOM_phase_1, a(2)=>Do_illegal_EXMPLR916, a(1)=>not_rtlcn9863, a(0)=>
      SOM_phase_8, b(4)=>not_SOM_phase_go, b(3)=>rtlc22n7976, b(2)=>
      rtlc22n7980, b(1)=>not_Ack, b(0)=>not_rtlcn10656, d=>rtlcn2079);
   rtlc_2939_select_169 : select_4_4 port map ( a(3)=>MON_SOM_phase(0), a(2)
      =>rtlcn2082, a(1)=>MON_SOM_phase(2), a(0)=>not_rtlcn9864, b(3)=>
      not_MON_SOM_phase_go, b(2)=>not_Ack, b(1)=>rtlc22n8588, b(0)=>
      rtlc22n8802, d=>rtlcn2084);
   BC_Go_select_26i28 : select_3_3 port map ( a(2)=>not_rtlcn8789, a(1)=>
      BC_State(80), a(0)=>rtlc26n16088, b(2)=>debug_EXMPLR1003(15), b(1)=>
      eBC_Q_pointer(11), b(0)=>Ack, d=>BC_Go_26n180ss1);
   BC_Stack_pointer_select_26i45 : select_5_5 port map ( a(4)=>BC_State(33), 
      a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16306, a(0)=>
      BC_State(58), b(4)=>Frame_length_reg_0xD(0), b(3)=>VARAM_Q(0), b(2)=>
      BC_Stack_pointer_26n31s1(0), b(1)=>Data_o_temp(0), b(0)=>
      debug_EXMPLR1003(15), d=>BC_Stack_pointer_26n180ss1(0));
   BC_Stack_pointer_select_26i46 : select_4_4 port map ( a(3)=>BC_State(33), 
      a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, b(3)=>
      Frame_length_reg_0xD(1), b(2)=>VARAM_Q(1), b(1)=>
      BC_Stack_pointer_26n31s1(1), b(0)=>Data_o_temp(1), d=>
      BC_Stack_pointer_26n180ss1(1));
   BC_Stack_pointer_select_26i47Bus128_2 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(2), b(3)=>VARAM_Q(2), 
      b(2)=>BC_Stack_pointer_26n31s1(2), b(1)=>Data_o_temp(2), b(0)=>
      BC_Stack_pointer_26n31s1(0), d=>BC_Stack_pointer_26n180ss1(2));
   BC_Stack_pointer_select_26i47Bus128_3 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(3), b(3)=>VARAM_Q(3), 
      b(2)=>BC_Stack_pointer_26n31s1(3), b(1)=>Data_o_temp(3), b(0)=>
      BC_Stack_pointer_26n31s1(1), d=>BC_Stack_pointer_26n180ss1(3));
   BC_Stack_pointer_select_26i47Bus128_4 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(4), b(3)=>VARAM_Q(4), 
      b(2)=>BC_Stack_pointer_26n31s1(4), b(1)=>Data_o_temp(4), b(0)=>
      BC_Stack_pointer_26n31s1(2), d=>BC_Stack_pointer_26n180ss1(4));
   BC_Stack_pointer_select_26i47Bus128_5 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(5), b(3)=>VARAM_Q(5), 
      b(2)=>BC_Stack_pointer_26n31s1(5), b(1)=>Data_o_temp(5), b(0)=>
      BC_Stack_pointer_26n31s1(3), d=>BC_Stack_pointer_26n180ss1(5));
   BC_Stack_pointer_select_26i47Bus128_6 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(6), b(3)=>VARAM_Q(6), 
      b(2)=>BC_Stack_pointer_26n31s2_6, b(1)=>Data_o_temp(6), b(0)=>
      BC_Stack_pointer_26n31s1(4), d=>BC_Stack_pointer_26n180ss1(6));
   BC_Stack_pointer_select_26i47Bus128_7 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(7), b(3)=>VARAM_Q(7), 
      b(2)=>BC_Stack_pointer_26n31s3_7, b(1)=>Data_o_temp(7), b(0)=>
      BC_Stack_pointer_26n31s1(5), d=>BC_Stack_pointer_26n180ss1(7));
   BC_Stack_pointer_select_26i47Bus128_8 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(8), b(3)=>VARAM_Q(8), 
      b(2)=>BC_Stack_pointer_26n31s4_8, b(1)=>Data_o_temp(8), b(0)=>
      BC_Stack_pointer_26n31s2_6, d=>BC_Stack_pointer_26n180ss1(8));
   BC_Stack_pointer_select_26i47Bus128_9 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(9), b(3)=>VARAM_Q(9), 
      b(2)=>BC_Stack_pointer_26n167s1_9, b(1)=>Data_o_temp(9), b(0)=>
      BC_Stack_pointer_26n31s3_7, d=>BC_Stack_pointer_26n180ss1(9));
   BC_Stack_pointer_select_26i47Bus128_10 : select_5_5 port map ( a(4)=>
      BC_State(33), a(3)=>BC_State(60), a(2)=>rtlcn2233, a(1)=>rtlc26n16321, 
      a(0)=>BC_State(12), b(4)=>Frame_length_reg_0xD(10), b(3)=>VARAM_Q(10), 
      b(2)=>BC_Stack_pointer_26n167s1_10, b(1)=>Data_o_temp(10), b(0)=>
      BC_Stack_pointer_26n31s4_8, d=>BC_Stack_pointer_26n180ss1(10));
   BC_Stack_pointer_select_26i56Bus129_11 : select_4_4 port map ( a(3)=>
      BC_State(33), a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, 
      b(3)=>Frame_length_reg_0xD(11), b(2)=>VARAM_Q(11), b(1)=>
      BC_Stack_pointer_26n167s1_11, b(0)=>Data_o_temp(11), d=>
      BC_Stack_pointer_26n180ss1(11));
   BC_Stack_pointer_select_26i56Bus129_12 : select_4_4 port map ( a(3)=>
      BC_State(33), a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, 
      b(3)=>Frame_length_reg_0xD(12), b(2)=>VARAM_Q(12), b(1)=>
      BC_Stack_pointer_26n167s1_12, b(0)=>Data_o_temp(12), d=>
      BC_Stack_pointer_26n180ss1(12));
   BC_Stack_pointer_select_26i56Bus129_13 : select_4_4 port map ( a(3)=>
      BC_State(33), a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, 
      b(3)=>Frame_length_reg_0xD(13), b(2)=>VARAM_Q(13), b(1)=>
      BC_Stack_pointer_26n167s1_13, b(0)=>Data_o_temp(13), d=>
      BC_Stack_pointer_26n180ss1(13));
   BC_Stack_pointer_select_26i56Bus129_14 : select_4_4 port map ( a(3)=>
      BC_State(33), a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, 
      b(3)=>Frame_length_reg_0xD(14), b(2)=>VARAM_Q(14), b(1)=>
      BC_Stack_pointer_26n167s1_14, b(0)=>Data_o_temp(14), d=>
      BC_Stack_pointer_26n180ss1(14));
   rtlc_3157_or_202 : or_12u_12u port map ( a(11)=>BC_State(34), a(10)=>
      BC_State(35), a(9)=>BC_State(57), a(8)=>BC_State(59), a(7)=>
      BC_State(61), a(6)=>BC_State(63), a(5)=>BC_State(64), a(4)=>
      BC_State(67), a(3)=>BC_State(69), a(2)=>BC_State(70), a(1)=>
      BC_State(72), a(0)=>BC_State(82), d=>rtlcn2233);
   BC_Stack_pointer_select_26i56Bus129_15 : select_4_4 port map ( a(3)=>
      BC_State(33), a(2)=>BC_State(60), a(1)=>rtlcn2233, a(0)=>rtlc26n16321, 
      b(3)=>Frame_length_reg_0xD(15), b(2)=>VARAM_Q(15), b(1)=>
      BC_Stack_pointer_26n167s1_15, b(0)=>Data_o_temp(15), d=>
      BC_Stack_pointer_26n180ss1(15));
   VARAM_ADD_select_26i61 : select_3_3 port map ( a(2)=>BC_State(32), a(1)=>
      BC_State(59), a(0)=>rtlcn2275, b(2)=>LIFO_Pointer(4), b(1)=>
      LIFO_Pointer_26n126s1(4), b(0)=>debug_EXMPLR1003(15), d=>
      VARAM_ADD_26n180ss1(4));
   rtlc_3252_select_206 : select_4_4 port map ( a(3)=>not_rtlc26n17293, a(2)
      =>rtlcn2296, a(1)=>BC_State(40), a(0)=>BC_State(44), b(3)=>PWR, b(2)=>
      not_Ack, b(1)=>BC_Command_Sync, b(0)=>rtlc26n15114, d=>rtlcn2297);
   rtlc_3255_select_207 : select_3_3 port map ( a(2)=>not_rtlc26n17337, a(1)
      =>BC_State(58), a(0)=>rtlc26n16362, b(2)=>PWR, b(1)=>
      not_BC_Echo_word_10, b(0)=>debug_EXMPLR1003(15), d=>rtlcn2497);
   BC_msg_pointer_select_26i63Bus187_1 : select_3_3 port map ( a(2)=>
      rtlc26n19466, a(1)=>BC_State(12), a(0)=>rtlc26n16305, b(2)=>
      BC_msg_pointer(1), b(1)=>BC_Stack_pointer(3), b(0)=>ReTry_count(1), d
      =>BC_msg_pointer_26n43s1f1(1));
   BC_msg_pointer_select_26i63Bus187_0 : select_3_3 port map ( a(2)=>
      rtlc26n19466, a(1)=>BC_State(12), a(0)=>rtlc26n16305, b(2)=>
      BC_msg_pointer(0), b(1)=>BC_Stack_pointer(2), b(0)=>ReTry_count(0), d
      =>BC_msg_pointer_26n43s1f1(0));
   reg_data_out_wide_select_75i2Bus169_0 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcn2392, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_0, b(10)=>debug_EXMPLR1003(15), b(9)=>PWR, 
      b(8)=>IP_Freq_sel_EXMPLR994(0), b(7)=>Channel_Status(0), b(6)=>
      BC_GAP_to_next_msg_counter(0), b(5)=>reg_data_out_wide_75n50ss1(0), 
      b(4)=>Config_reg_4_EXMPLR998(0), b(3)=>Interrupt_status_register_1(0), 
      b(2)=>reg_data_out_wide_75n43ss1(0), b(1)=>Config_reg_2(0), b(0)=>
      Interrupt_mask_register_1(0), d=>reg_data_out_wide_75n69ss1(0));
   reg_data_out_wide_select_75i2Bus169_1 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcn2392, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_1, b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>IP_Freq_sel_EXMPLR994(1), b(7)=>
      Channel_Status(1), b(6)=>BC_GAP_to_next_msg_counter(1), b(5)=>
      reg_data_out_wide_75n50ss1(1), b(4)=>Config_reg_4_EXMPLR998(1), b(3)=>
      Interrupt_status_register_1(1), b(2)=>reg_data_out_wide_75n43ss1(1), 
      b(1)=>Config_reg_2(1), b(0)=>Interrupt_mask_register_1(1), d=>
      reg_data_out_wide_75n69ss1(1));
   reg_data_out_wide_select_75i2Bus169_2 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcn2392, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_2, b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>Config_reg_6_2, b(7)=>Channel_Status(2), 
      b(6)=>BC_GAP_to_next_msg_counter(2), b(5)=>
      reg_data_out_wide_75n50ss1(2), b(4)=>Config_reg_4_EXMPLR998(2), b(3)=>
      Interrupt_status_register_1(2), b(2)=>reg_data_out_wide_75n43ss1(2), 
      b(1)=>Config_reg_2(2), b(0)=>Interrupt_mask_register_1(2), d=>
      reg_data_out_wide_75n69ss1(2));
   reg_data_out_wide_select_75i5Bus170_3 : select_13_13 port map ( a(12)=>
      rtlcs243, a(11)=>rtlcn2400, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>
      rtlcs225, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(12)=>Interrupt_status_register_2_3, b(11)=>
      debug_EXMPLR1003(15), b(10)=>PWR, b(9)=>Config_reg_6_3, b(8)=>PWR, 
      b(7)=>Channel_Status(3), b(6)=>BC_GAP_to_next_msg_counter(3), b(5)=>
      reg_data_out_wide_75n50ss1(3), b(4)=>Config_reg_4_EXMPLR998(3), b(3)=>
      Interrupt_status_register_1(3), b(2)=>reg_data_out_wide_75n43ss1(3), 
      b(1)=>Config_reg_2(3), b(0)=>Interrupt_mask_register_1(3), d=>
      reg_data_out_wide_75n69ss1(3));
   reg_data_out_wide_select_75i5Bus170_4 : select_13_13 port map ( a(12)=>
      rtlcs243, a(11)=>rtlcn2402, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>
      rtlcs227, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(12)=>Interrupt_status_register_2_4, b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      Config_reg_6_4, b(8)=>PWR, b(7)=>Channel_Status(4), b(6)=>
      BC_GAP_to_next_msg_counter(4), b(5)=>reg_data_out_wide_75n50ss1(4), 
      b(4)=>Config_reg_4_EXMPLR998(4), b(3)=>Interrupt_status_register_1(4), 
      b(2)=>reg_data_out_wide_75n43ss1(4), b(1)=>Config_reg_2(4), b(0)=>
      Interrupt_mask_register_1(4), d=>reg_data_out_wide_75n69ss1(4));
   reg_data_out_wide_select_75i5Bus170_5 : select_13_13 port map ( a(12)=>
      rtlcs243, a(11)=>rtlcs251, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>
      not_rtlcn9867, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(12)=>Interrupt_status_register_2_5, b(11)=>
      Test_Status_reg_7, b(10)=>PWR, b(9)=>Config_reg_6_5, b(8)=>
      debug_EXMPLR1003(15), b(7)=>Channel_Status(5), b(6)=>
      BC_GAP_to_next_msg_counter(5), b(5)=>reg_data_out_wide_75n50ss1(5), 
      b(4)=>Config_reg_4_EXMPLR998(5), b(3)=>Interrupt_status_register_1(5), 
      b(2)=>reg_data_out_wide_75n43ss1(5), b(1)=>Config_reg_2(5), b(0)=>
      Interrupt_mask_register_1(5), d=>reg_data_out_wide_75n69ss1(5));
   reg_data_out_wide_select_75i5Bus170_6 : select_13_13 port map ( a(12)=>
      rtlcs243, a(11)=>rtlcs251, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>
      not_rtlcn9867, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(12)=>Interrupt_status_register_2_6, b(11)=>
      Test_Status_reg_6, b(10)=>PWR, b(9)=>Config_reg_6_6, b(8)=>
      debug_EXMPLR1003(15), b(7)=>Channel_Status(6), b(6)=>
      BC_GAP_to_next_msg_counter(6), b(5)=>reg_data_out_wide_75n50ss1(6), 
      b(4)=>Config_reg_4_EXMPLR998(6), b(3)=>Interrupt_status_register_1(6), 
      b(2)=>reg_data_out_wide_75n43ss1(6), b(1)=>Config_reg_2(6), b(0)=>
      Interrupt_mask_register_1(6), d=>reg_data_out_wide_75n69ss1(6));
   reg_data_out_wide_select_75i9 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcs239, a(9)=>rtlcs225, 
      a(8)=>rtlcn2408, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)
      =>rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>Interrupt_status_register_2_7, b(12)=>
      Test_Status_reg_7, b(11)=>debug_EXMPLR1003(15), b(10)=>Config_reg_6_7, 
      b(9)=>PWR, b(8)=>debug_EXMPLR1003(15), b(7)=>Channel_Status(7), b(6)=>
      BC_GAP_to_next_msg_counter(7), b(5)=>reg_data_out_wide_75n50ss1(7), 
      b(4)=>Config_reg_4_EXMPLR998(7), b(3)=>Interrupt_status_register_1(7), 
      b(2)=>reg_data_out_wide_75n43ss1(7), b(1)=>Config_reg_2(7), b(0)=>
      Interrupt_mask_register_1(7), d=>reg_data_out_wide_75n69ss1(7));
   reg_data_out_wide_select_75i10 : select_13_13 port map ( a(12)=>rtlcs243, 
      a(11)=>rtlcn2400, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>rtlcs225, 
      a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(12)=>
      Interrupt_status_register_2_10, b(11)=>debug_EXMPLR1003(15), b(10)=>
      PWR, b(9)=>Config_reg_6_10, b(8)=>PWR, b(7)=>Channel_Status(10), b(6)
      =>BC_GAP_to_next_msg_counter(10), b(5)=>reg_data_out_wide_75n50ss1(10), 
      b(4)=>Config_reg_4_EXMPLR998(10), b(3)=>
      Interrupt_status_register_1(10), b(2)=>reg_data_out_wide_75n43ss1(10), 
      b(1)=>Config_reg_2(10), b(0)=>Interrupt_mask_register_1(10), d=>
      reg_data_out_wide_75n69ss1(10));
   reg_data_out_wide_select_75i11Bus171_11 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcs251, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcn2417, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_11, b(10)=>Test_Status_reg_11, b(9)=>
      debug_EXMPLR1003(15), b(8)=>Config_reg_6_11, b(7)=>
      debug_EXMPLR1003(15), b(6)=>BC_GAP_to_next_msg_counter(11), b(5)=>
      reg_data_out_wide_75n50ss1(11), b(4)=>Config_reg_4_EXMPLR998(11), b(3)
      =>Interrupt_status_register_1(11), b(2)=>
      reg_data_out_wide_75n43ss1(11), b(1)=>Config_reg_2(11), b(0)=>
      Interrupt_mask_register_1(11), d=>reg_data_out_wide_75n69ss1(11));
   reg_data_out_wide_select_75i11Bus171_12 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcn2419, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcs224, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_12, b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>Config_reg_6_12, b(7)=>PWR, b(6)=>
      BC_GAP_to_next_msg_counter(12), b(5)=>reg_data_out_wide_75n50ss1(12), 
      b(4)=>Config_reg_4_EXMPLR998(12), b(3)=>
      Interrupt_status_register_1(12), b(2)=>reg_data_out_wide_75n43ss1(12), 
      b(1)=>Config_reg_2(12), b(0)=>Interrupt_mask_register_1(12), d=>
      reg_data_out_wide_75n69ss1(12));
   reg_data_out_wide_select_75i11Bus171_14 : select_12_12 port map ( a(11)=>
      rtlcs243, a(10)=>rtlcs251, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcn2417, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      Interrupt_status_register_2_14, b(10)=>Test_Status_reg_14, b(9)=>
      debug_EXMPLR1003(15), b(8)=>Config_reg_6_14, b(7)=>
      debug_EXMPLR1003(15), b(6)=>BC_GAP_to_next_msg_counter(14), b(5)=>
      reg_data_out_wide_75n50ss1(14), b(4)=>Config_reg_4_EXMPLR998(14), b(3)
      =>Interrupt_status_register_1(14), b(2)=>
      reg_data_out_wide_75n43ss1(14), b(1)=>Config_reg_2(14), b(0)=>
      Interrupt_mask_register_1(14), d=>reg_data_out_wide_75n69ss1(14));
   reg_data_out_wide_select_75i14 : select_13_13 port map ( a(12)=>rtlcs243, 
      a(11)=>rtlcs251, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>not_rtlcn9867, 
      a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(12)=>
      Interrupt_status_register_2_15, b(11)=>Test_Status_reg_15, b(10)=>
      debug_EXMPLR1003(15), b(9)=>Config_reg_6_15, b(8)=>
      debug_EXMPLR1003(15), b(7)=>Ksts, b(6)=>BC_GAP_to_next_msg_counter(15), 
      b(5)=>reg_data_out_wide_75n50ss1(15), b(4)=>Config_reg_4_EXMPLR998(15), 
      b(3)=>Interrupt_status_register_2_0, b(2)=>
      reg_data_out_wide_75n43ss1(15), b(1)=>Config_reg_2(15), b(0)=>
      Interrupt_mask_register_1(15), d=>reg_data_out_wide_75n69ss1(15));
   reg_data_out_wide_select_75i15 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcn2428, a(9)=>rtlcs225, 
      a(8)=>rtlcs250, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>eBC_Q_pointer(0), b(12)=>Interrupt_mask_register_2(0), 
      b(11)=>eBC_GP(0), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>Latched_TT(0), b(7)=>debug_EXMPLR1003(15), 
      b(6)=>reg_data_out_wide_75n54ss1(0), b(5)=>BC_frame_GAP_counter(0), 
      b(4)=>RT_Address_EXMPLR1000(5), b(3)=>Config_reg_3_0, b(2)=>
      time_tag_EXMPLR1002(0), b(1)=>reg_data_out_wide_75n41ss1(0), b(0)=>
      Config_reg_1(0), d=>reg_data_out_wide_75n70ss1(0));
   reg_data_out_wide_select_75i16 : select_15_15 port map ( a(14)=>rtlcs243, 
      a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, a(10)=>
      rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)=>
      rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(2), 
      b(13)=>Interrupt_mask_register_2(2), b(12)=>eBC_GP(2), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>Latched_TT(2), 
      b(8)=>PWR, b(7)=>debug_EXMPLR1003(15), b(6)=>
      reg_data_out_wide_75n54ss1(2), b(5)=>BC_frame_GAP_counter(2), b(4)=>
      RT_Address_EXMPLR1000(1), b(3)=>Config_reg_3_2, b(2)=>
      time_tag_EXMPLR1002(2), b(1)=>reg_data_out_wide_75n41ss1(2), b(0)=>
      Config_reg_1(2), d=>reg_data_out_wide_75n70ss1(2));
   reg_data_out_wide_select_75i17 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcn2428, a(9)=>rtlcs225, 
      a(8)=>rtlcs250, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>eBC_Q_pointer(3), b(12)=>Interrupt_mask_register_2(3), 
      b(11)=>eBC_GP(3), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>Latched_TT(3), b(7)=>debug_EXMPLR1003(15), 
      b(6)=>reg_data_out_wide_75n54ss1(3), b(5)=>BC_frame_GAP_counter(3), 
      b(4)=>RT_Address_EXMPLR1000(2), b(3)=>Config_reg_3_3, b(2)=>
      time_tag_EXMPLR1002(3), b(1)=>reg_data_out_wide_75n41ss1(3), b(0)=>
      Config_reg_1(3), d=>reg_data_out_wide_75n70ss1(3));
   reg_data_out_wide_select_75i18 : select_15_15 port map ( a(14)=>rtlcs243, 
      a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, a(10)=>
      rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)=>
      rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(4), 
      b(13)=>Interrupt_mask_register_2(4), b(12)=>eBC_GP(4), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>Latched_TT(4), 
      b(8)=>PWR, b(7)=>debug_EXMPLR1003(15), b(6)=>
      reg_data_out_wide_75n54ss1(4), b(5)=>BC_frame_GAP_counter(4), b(4)=>
      RT_Address_EXMPLR1000(3), b(3)=>Config_reg_3_4, b(2)=>
      time_tag_EXMPLR1002(4), b(1)=>reg_data_out_wide_75n41ss1(4), b(0)=>
      Config_reg_1(4), d=>reg_data_out_wide_75n70ss1(4));
   reg_data_out_wide_select_75i19 : select_15_15 port map ( a(14)=>rtlcs243, 
      a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, a(10)=>
      rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)=>
      rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(6), 
      b(13)=>Interrupt_mask_register_2(6), b(12)=>eBC_GP(6), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>Latched_TT(6), 
      b(8)=>PWR, b(7)=>debug_EXMPLR1003(15), b(6)=>
      reg_data_out_wide_75n54ss1(6), b(5)=>BC_frame_GAP_counter(6), b(4)=>
      Config_reg_5(6), b(3)=>Config_reg_3_6, b(2)=>time_tag_EXMPLR1002(6), 
      b(1)=>reg_data_out_wide_75n41ss1(6), b(0)=>Config_reg_1(6), d=>
      reg_data_out_wide_75n70ss1(6));
   reg_data_out_wide_select_75i20 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcn2428, a(9)=>rtlcs225, 
      a(8)=>rtlcs250, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>eBC_Q_pointer(7), b(12)=>Interrupt_mask_register_2(7), 
      b(11)=>eBC_GP(7), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>Latched_TT(7), b(7)=>debug_EXMPLR1003(15), 
      b(6)=>reg_data_out_wide_75n54ss1(7), b(5)=>BC_frame_GAP_counter(7), 
      b(4)=>Config_reg_5(7), b(3)=>Config_reg_3_7, b(2)=>
      time_tag_EXMPLR1002(7), b(1)=>reg_data_out_wide_75n41ss1(7), b(0)=>
      Config_reg_1(7), d=>reg_data_out_wide_75n70ss1(7));
   reg_data_out_wide_select_75i21 : select_13_13 port map ( a(12)=>rtlcs243, 
      a(11)=>rtlcs251, a(10)=>rtlcs231, a(9)=>rtlcn2444, a(8)=>rtlcs225, 
      a(7)=>rtlcs250, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(12)=>
      eBC_Q_pointer(8), b(11)=>Interrupt_mask_register_2(8), b(10)=>
      BC_Sts_Word(9), b(9)=>debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), 
      b(7)=>Latched_TT(8), b(6)=>reg_data_out_wide_75n54ss1(8), b(5)=>
      BC_frame_GAP_counter(8), b(4)=>Config_reg_5(8), b(3)=>Config_reg_3_8, 
      b(2)=>time_tag_EXMPLR1002(8), b(1)=>reg_data_out_wide_75n41ss1(8), 
      b(0)=>Config_reg_1(8), d=>reg_data_out_wide_75n70ss1(8));
   reg_data_out_wide_select_75i22 : select_15_15 port map ( a(14)=>rtlcs243, 
      a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, a(10)=>
      rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)=>
      rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(10), 
      b(13)=>Interrupt_mask_register_2(10), b(12)=>Good_data_block_recieved, 
      b(11)=>debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      Latched_TT(10), b(8)=>PWR, b(7)=>Internal_BIT_Word_10, b(6)=>
      reg_data_out_wide_75n54ss1(10), b(5)=>BC_frame_GAP_counter(10), b(4)=>
      Config_reg_5(10), b(3)=>Config_reg_3_10, b(2)=>time_tag_EXMPLR1002(10), 
      b(1)=>reg_data_out_wide_75n41ss1(10), b(0)=>Config_reg_1(10), d=>
      reg_data_out_wide_75n70ss1(10));
   reg_data_out_wide_select_75i23 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcn2428, a(9)=>rtlcs225, 
      a(8)=>rtlcs250, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>eBC_Q_pointer(11), b(12)=>
      Interrupt_mask_register_2(11), b(11)=>eBC_Conditions_11, b(10)=>
      debug_EXMPLR1003(15), b(9)=>debug_EXMPLR1003(15), b(8)=>Latched_TT(11), 
      b(7)=>Internal_BIT_Word_11, b(6)=>reg_data_out_wide_75n54ss1(11), b(5)
      =>BC_frame_GAP_counter(11), b(4)=>Config_reg_5(11), b(3)=>
      Config_reg_3_11, b(2)=>time_tag_EXMPLR1002(11), b(1)=>
      reg_data_out_wide_75n41ss1(11), b(0)=>Config_reg_1(11), d=>
      reg_data_out_wide_75n70ss1(11));
   reg_data_out_wide_select_75i24Bus172_13 : select_15_15 port map ( a(14)=>
      rtlcs243, a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, 
      a(10)=>rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)
      =>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(13), 
      b(13)=>Interrupt_mask_register_2(13), b(12)=>BC_Sts_Word(5), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      Latched_TT(13), b(8)=>PWR, b(7)=>Internal_BIT_Word_13, b(6)=>
      reg_data_out_wide_75n54ss1(13), b(5)=>BC_frame_GAP_counter(13), b(4)=>
      Config_reg_5(13), b(3)=>Config_reg_3_13, b(2)=>time_tag_EXMPLR1002(13), 
      b(1)=>reg_data_out_wide_75n41ss1(13), b(0)=>Current_Area_B, d=>
      reg_data_out_wide_75n70ss1(13));
   reg_data_out_wide_select_75i24Bus172_14 : select_15_15 port map ( a(14)=>
      rtlcs243, a(13)=>rtlcs251, a(12)=>rtlcs231, a(11)=>not_rtlcn9870, 
      a(10)=>rtlcs225, a(9)=>rtlcs250, a(8)=>rtlcs227, a(7)=>rtlcs257, a(6)
      =>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(14)=>eBC_Q_pointer(14), 
      b(13)=>Interrupt_mask_register_2(14), b(12)=>BC_Sts_Word(6), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      Latched_TT(14), b(8)=>PWR, b(7)=>Internal_BIT_Word_14, b(6)=>
      reg_data_out_wide_75n54ss1(14), b(5)=>BC_frame_GAP_counter(14), b(4)=>
      Config_reg_5(14), b(3)=>Config_reg_3_14, b(2)=>time_tag_EXMPLR1002(14), 
      b(1)=>reg_data_out_wide_75n41ss1(14), b(0)=>Config_reg_1(14), d=>
      reg_data_out_wide_75n70ss1(14));
   reg_data_out_wide_select_75i26 : select_14_14 port map ( a(13)=>rtlcs243, 
      a(12)=>rtlcs251, a(11)=>rtlcs231, a(10)=>rtlcn2428, a(9)=>rtlcs225, 
      a(8)=>rtlcs250, a(7)=>rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>
      rtlcs261, a(3)=>rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>
      rtlcs273, b(13)=>eBC_Q_pointer(15), b(12)=>
      Interrupt_mask_register_2(15), b(11)=>PWR, b(10)=>debug_EXMPLR1003(15), 
      b(9)=>debug_EXMPLR1003(15), b(8)=>Latched_TT(15), b(7)=>
      Internal_BIT_Word_15, b(6)=>reg_data_out_wide_75n54ss1(15), b(5)=>
      BC_frame_GAP_counter(15), b(4)=>n16Mhz_12_EXMPLR860, b(3)=>
      Config_reg_3_15, b(2)=>time_tag_EXMPLR1002(15), b(1)=>
      reg_data_out_wide_75n41ss1(15), b(0)=>Config_reg_1(15), d=>
      reg_data_out_wide_75n70ss1(15));
   rtlc22n7764 <= not_Ack AND rtlc22n9096 ;
   rtlc22n8329 <= not_Ack AND W_R_32n3s1 ;
   VARAM_WE_26n180ss1 <= Ack AND rtlcn2475 ;
   Stack_rollover_interrupt_mux_22i42 : mux_4u_4u port map ( a(3)=>
      Stack_rollover_interrupt_22n8s8, a(2)=>Stack_rollover_interrupt_22n8s6, 
      a(1)=>Stack_rollover_interrupt_22n8s4, a(0)=>
      Stack_rollover_interrupt_22n8s2, b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>Config_reg_3_14, b(0)=>Config_reg_3_13, d
      =>Stack_rollover_interrupt_22n8ss1);
   Ram_Address_mux_22i43Bus100_0 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      debug_EXMPLR1003(15), a(1)=>Ram_Address_22n54ss1_0, a(0)=>
      Ram_Address_22n50ss1_0, b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>Phase(1), b(0)=>Phase(0), d=>
      Ram_Address_22n76ss1_0);
   Ram_Address_mux_22i43Bus100_1 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>PWR, 
      a(1)=>Ram_Address_22n54ss1_1, a(0)=>rtlcn10759, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>Phase(1), b(0)
      =>Phase(0), d=>Ram_Address_22n76ss1_1);
   Ram_Address_mux_22i43Bus100_2 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      stack_pointer(2), a(1)=>Ram_Address_22n54ss1_2, a(0)=>
      Ram_Address_22n50ss1_2, b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>Phase(1), b(0)=>Phase(0), d=>
      Ram_Address_22n76ss1_2);
   Ram_Address_mux_22i46 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      stack_pointer(8), a(1)=>Ram_Address_22n54ss1_8, a(0)=>
      Ram_Address_22n50ss1_8, b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>Phase(1), b(0)=>Phase(0), d=>
      Ram_Address_22n76ss1_8);
   Monitor_command_stack_rollover_mux_22i47 : mux_4u_4u port map ( a(3)=>
      Monitor_command_stack_rollover_22n80s4, a(2)=>
      Monitor_command_stack_rollover_22n80s3, a(1)=>
      Monitor_command_stack_rollover_22n80s2, a(0)=>
      Monitor_command_stack_rollover_22n80s1, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>Config_reg_3_12, b(0)=>
      Config_reg_3_11, d=>Monitor_command_stack_rollover_22n80ss1);
   Monitor_command_stack_half_pass_mux_22i48 : mux_4u_4u port map ( a(3)=>
      Monitor_command_stack_half_pass_22n80s4, a(2)=>
      Monitor_command_stack_half_pass_22n80s3, a(1)=>
      Monitor_command_stack_half_pass_22n80s2, a(0)=>
      Monitor_command_stack_half_pass_22n80s1, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>Config_reg_3_12, b(0)=>
      Config_reg_3_11, d=>Monitor_command_stack_half_pass_22n80ss1);
   Ram_Address_mux_22i49Bus104_0 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      debug_EXMPLR1003(15), a(1)=>debug_EXMPLR1003(15), a(0)=>
      Ram_Address_22n76ss1_0, b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_Address_22n85ss1(0));
   Ram_Address_mux_22i49Bus104_1 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>PWR, 
      a(1)=>debug_EXMPLR1003(15), a(0)=>Ram_Address_22n76ss1_1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(1));
   Ram_Address_mux_22i49Bus104_2 : mux_4u_4u port map ( a(3)=>
      Ram_Address_22n84ss1_2, a(2)=>Current_Area_B, a(1)=>
      monitor_stack_pointer(2), a(0)=>Ram_Address_22n76ss1_2, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(2));
   Ram_Address_mux_22i49Bus104_3 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(3), a(0)=>rtlcn10758, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>
      MON_EOM_phase(0), d=>Ram_Address_22n85ss1(3));
   Ram_Address_mux_22i49Bus104_4 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(4), a(0)=>rtlcn10757, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>
      MON_EOM_phase(0), d=>Ram_Address_22n85ss1(4));
   Ram_Address_mux_22i49Bus104_5 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(5), a(0)=>rtlcn10756, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>
      MON_EOM_phase(0), d=>Ram_Address_22n85ss1(5));
   Ram_Address_mux_22i49Bus104_6 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(6), a(0)=>Ram_Address_22n76ss1_6, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(6));
   Ram_Address_mux_22i49Bus104_7 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(7), a(0)=>rtlcn10754, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>
      MON_EOM_phase(0), d=>Ram_Address_22n85ss1(7));
   Ram_Address_mux_22i49Bus104_8 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>PWR, 
      a(1)=>monitor_stack_pointer(8), a(0)=>Ram_Address_22n76ss1_8, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(8));
   Ram_Address_mux_22i49Bus104_9 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(9), a(0)=>rtlcn10752, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>
      MON_EOM_phase(0), d=>Ram_Address_22n85ss1(9));
   Ram_Address_mux_22i49Bus104_10 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(10), a(0)=>Ram_Address_22n76ss1_10, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(10)
   );
   Ram_Address_mux_22i49Bus104_11 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(11), a(0)=>Ram_Address_22n76ss1_11, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(11)
   );
   Ram_Address_mux_22i49Bus104_12 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(12), a(0)=>Ram_Address_22n76ss1_12, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(12)
   );
   Ram_Address_mux_22i49Bus104_13 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(13), a(0)=>Ram_Address_22n76ss1_13, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(13)
   );
   Ram_Address_mux_22i49Bus104_14 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(14), a(0)=>Ram_Address_22n76ss1_14, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(14)
   );
   Ram_Address_mux_22i49Bus104_15 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>debug_EXMPLR1003(15), a(1)=>
      monitor_stack_pointer(15), a(0)=>Ram_Address_22n76ss1_15, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_Address_22n85ss1(15)
   );
   Ram_data_i_mux_22i65Bus105_0 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(0), a(2)=>monitor_stack_pointer_plus4(0), a(1)=>
      Latched_Monitor_MIL1553_errors_invalid_command, a(0)=>
      Ram_data_i_22n76ss1(0), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(0));
   Ram_data_i_mux_22i65Bus105_1 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(1), a(2)=>monitor_stack_pointer_plus4(1), a(1)=>
      Latched_Monitor_MIL1553_errors_RT2RT_format_error, a(0)=>
      Ram_data_i_22n76ss1(1), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(1));
   Ram_data_i_mux_22i65Bus105_2 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(2), a(2)=>monitor_stack_pointer_plus4(2), a(1)=>
      Latched_Monitor_MIL1553_errors_RT2RT_format_gap, a(0)=>
      Ram_data_i_22n76ss1(2), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(2));
   Ram_data_i_mux_22i65Bus105_3 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(3), a(2)=>monitor_stack_pointer_plus4(3), a(1)=>
      Latched_Monitor_MIL1553_errors_Invalid_word, a(0)=>
      Ram_data_i_22n76ss1(3), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(3));
   Ram_data_i_mux_22i65Bus105_4 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(4), a(2)=>monitor_stack_pointer_plus4(4), a(1)=>
      Latched_Monitor_MIL1553_errors_incorrect_data_sync, a(0)=>
      Ram_data_i_22n76ss1(4), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(4));
   Ram_data_i_mux_22i65Bus105_5 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(5), a(2)=>monitor_stack_pointer_plus4(5), a(1)=>
      Latched_Monitor_MIL1553_errors_high_word_count, a(0)=>
      Ram_data_i_22n76ss1(5), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(5));
   Ram_data_i_mux_22i65Bus105_7 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(7), a(2)=>monitor_stack_pointer_plus4(7), a(1)=>
      Latched_Monitor_data_stack_rollover, a(0)=>Ram_data_i_22n76ss1(7), 
      b(3)=>debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(7));
   Ram_data_i_mux_22i65Bus105_8 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(8), a(2)=>monitor_stack_pointer_plus4(8), a(1)=>
      Latched_Monitor_ended_OK, a(0)=>Ram_data_i_22n76ss1(8), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(8));
   Ram_data_i_mux_22i65Bus105_9 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(9), a(2)=>monitor_stack_pointer_plus4(9), a(1)=>
      Latched_Monitor_MIL1553_errors_Address_Parity, a(0)=>
      Ram_data_i_22n76ss1(9), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(9));
   Ram_data_i_mux_22i65Bus105_10 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(10), a(2)=>monitor_stack_pointer_plus4(10), a(1)
      =>MM_Error_detected, a(0)=>Ram_data_i_22n76ss1(10), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(10));
   Ram_data_i_mux_22i65Bus105_11 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(11), a(2)=>monitor_stack_pointer_plus4(11), a(1)
      =>Monitor_RT2RT_Message, a(0)=>Ram_data_i_22n76ss1(11), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(11));
   Ram_data_i_mux_22i65Bus105_12 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(12), a(2)=>monitor_stack_pointer_plus4(12), a(1)
      =>Ram_data_i_12_22n78s1, a(0)=>Ram_data_i_22n76ss1(12), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(12));
   Ram_data_i_mux_22i65Bus105_13 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(13), a(2)=>monitor_stack_pointer_plus4(13), a(1)
      =>not_Monitor_bus_a, a(0)=>Ram_data_i_22n76ss1(13), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), d=>Ram_data_i_22n85ss1(13));
   Ram_data_i_mux_22i78 : mux_4u_4u port map ( a(3)=>
      monitor_data_pointer(15), a(2)=>monitor_stack_pointer_plus4(15), a(1)
      =>PWR, a(0)=>Ram_data_i_22n76ss1(15), b(3)=>debug_EXMPLR1003(15), b(2)
      =>debug_EXMPLR1003(15), b(1)=>MON_EOM_phase(1), b(0)=>MON_EOM_phase(0), 
      d=>Ram_data_i_22n85ss1(15));
   Ram_Address_mux_22i79Bus112_0 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      Ram_Address_22n103ss1(0), a(1)=>monitor_data_pointer(0), a(0)=>
      Ram_Address_22n103ss1(0), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_Phase(1), b(0)=>MON_Phase(0), d=>
      Ram_Address_22n108ss1(0));
   Ram_Address_mux_22i79Bus112_1 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      Ram_Address_22n103ss1(1), a(1)=>monitor_data_pointer(1), a(0)=>
      Ram_Address_22n103ss1(1), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_Phase(1), b(0)=>MON_Phase(0), d=>
      Ram_Address_22n108ss1(1));
   Ram_Address_mux_22i79Bus112_2 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      Ram_Address_22n103ss1(2), a(1)=>monitor_data_pointer(2), a(0)=>
      Ram_Address_22n103ss1(2), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_Phase(1), b(0)=>MON_Phase(0), d=>
      Ram_Address_22n108ss1(2));
   Ram_Address_mux_22i79Bus112_3 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(3), a(1)=>
      monitor_data_pointer(3), a(0)=>Ram_Address_22n103ss1(3), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(3));
   Ram_Address_mux_22i79Bus112_4 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(4), a(1)=>
      monitor_data_pointer(4), a(0)=>Ram_Address_22n103ss1(4), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(4));
   Ram_Address_mux_22i79Bus112_5 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(5), a(1)=>
      monitor_data_pointer(5), a(0)=>Ram_Address_22n103ss1(5), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(5));
   Ram_Address_mux_22i79Bus112_6 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(6), a(1)=>
      monitor_data_pointer(6), a(0)=>Ram_Address_22n103ss1(6), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(6));
   Ram_Address_mux_22i79Bus112_7 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(7), a(1)=>
      monitor_data_pointer(7), a(0)=>Ram_Address_22n103ss1(7), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(7));
   Ram_Address_mux_22i79Bus112_8 : mux_4u_4u port map ( a(3)=>PWR, a(2)=>
      Ram_Address_22n103ss1(8), a(1)=>monitor_data_pointer(8), a(0)=>
      Ram_Address_22n103ss1(8), b(3)=>debug_EXMPLR1003(15), b(2)=>
      debug_EXMPLR1003(15), b(1)=>MON_Phase(1), b(0)=>MON_Phase(0), d=>
      Ram_Address_22n108ss1(8));
   Ram_Address_mux_22i79Bus112_9 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(9), a(1)=>
      monitor_data_pointer(9), a(0)=>Ram_Address_22n103ss1(9), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(9));
   Ram_Address_mux_22i79Bus112_10 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(10), a(1)=>
      monitor_data_pointer(10), a(0)=>Ram_Address_22n103ss1(10), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(10));
   Ram_Address_mux_22i79Bus112_11 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(11), a(1)=>
      monitor_data_pointer(11), a(0)=>Ram_Address_22n103ss1(11), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(11));
   Ram_Address_mux_22i79Bus112_12 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(12), a(1)=>
      monitor_data_pointer(12), a(0)=>Ram_Address_22n103ss1(12), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(12));
   Ram_Address_mux_22i79Bus112_13 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(13), a(1)=>
      monitor_data_pointer(13), a(0)=>Ram_Address_22n103ss1(13), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(13));
   Ram_Address_mux_22i79Bus112_14 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(14), a(1)=>
      monitor_data_pointer(14), a(0)=>Ram_Address_22n103ss1(14), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(14));
   Ram_Address_mux_22i79Bus112_15 : mux_4u_4u port map ( a(3)=>
      debug_EXMPLR1003(15), a(2)=>Ram_Address_22n103ss1(15), a(1)=>
      monitor_data_pointer(15), a(0)=>Ram_Address_22n103ss1(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>MON_Phase(1), 
      b(0)=>MON_Phase(0), d=>Ram_Address_22n108ss1(15));
   rtlc_3986_mux_288 : mux_4u_4u port map ( a(3)=>debug_EXMPLR1003(15), a(2)
      =>rtlc22n8422, a(1)=>rtlc22n8329, a(0)=>not_phase_go, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>Phase(1), b(0)
      =>Phase(0), d=>rtlc22n8435);
   BC_SP_mux_54i1 : mux_4u_4u port map ( a(3)=>BC_SP_54n1s4, a(2)=>
      BC_SP_54n1s3, a(1)=>BC_SP_54n1s2, a(0)=>BC_SP_54n1s1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      Config_reg_3_14, b(0)=>Config_reg_3_13, d=>BC_SP_54n1ss1);
   eBC_GP_mux_60i5 : mux_4u_4u port map ( a(3)=>not_eBC_GP_0, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(24), b(0)=>CPU_Data_in_wide(16), d=>eBC_GP_60n34ss1);
   eBC_GP_mux_60i6 : mux_4u_4u port map ( a(3)=>not_eBC_GP_1, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(25), b(0)=>CPU_Data_in_wide(17), d=>eBC_GP_60n35ss1);
   eBC_GP_mux_60i7 : mux_4u_4u port map ( a(3)=>not_eBC_GP_2, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(26), b(0)=>CPU_Data_in_wide(18), d=>eBC_GP_60n36ss1);
   eBC_GP_mux_60i8 : mux_4u_4u port map ( a(3)=>not_eBC_GP_3, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(27), b(0)=>CPU_Data_in_wide(19), d=>eBC_GP_60n37ss1);
   eBC_GP_mux_60i9 : mux_4u_4u port map ( a(3)=>not_eBC_GP_4, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(28), b(0)=>CPU_Data_in_wide(20), d=>eBC_GP_60n38ss1);
   eBC_GP_mux_60i10 : mux_4u_4u port map ( a(3)=>not_eBC_GP_5, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(29), b(0)=>CPU_Data_in_wide(21), d=>eBC_GP_60n39ss1);
   eBC_GP_mux_60i11 : mux_4u_4u port map ( a(3)=>not_eBC_GP_6, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(30), b(0)=>CPU_Data_in_wide(22), d=>eBC_GP_60n40ss1);
   eBC_GP_mux_60i12 : mux_4u_4u port map ( a(3)=>not_eBC_GP_7, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>debug_EXMPLR1003(15), b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      CPU_Data_in_wide(31), b(0)=>CPU_Data_in_wide(23), d=>eBC_GP_60n41ss1);
   eBC_GP_mux_60i13 : mux_4u_4u port map ( a(3)=>not_eBC_GP_0, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n34ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(8), b(0)=>BC_msg_pointer(0), d=>eBC_GP_60n55ss1);
   eBC_GP_mux_60i14 : mux_4u_4u port map ( a(3)=>not_eBC_GP_1, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n35ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(9), b(0)=>BC_msg_pointer(1), d=>eBC_GP_60n56ss1);
   eBC_GP_mux_60i15 : mux_4u_4u port map ( a(3)=>not_eBC_GP_2, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n36ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(10), b(0)=>BC_msg_pointer(2), d=>eBC_GP_60n57ss1);
   eBC_GP_mux_60i16 : mux_4u_4u port map ( a(3)=>not_eBC_GP_3, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n37ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(11), b(0)=>BC_msg_pointer(3), d=>eBC_GP_60n58ss1);
   eBC_GP_mux_60i17 : mux_4u_4u port map ( a(3)=>not_eBC_GP_4, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n38ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(12), b(0)=>BC_msg_pointer(4), d=>eBC_GP_60n59ss1);
   eBC_GP_mux_60i18 : mux_4u_4u port map ( a(3)=>not_eBC_GP_5, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n39ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(13), b(0)=>BC_msg_pointer(5), d=>eBC_GP_60n60ss1);
   eBC_GP_mux_60i19 : mux_4u_4u port map ( a(3)=>not_eBC_GP_6, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n40ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(14), b(0)=>BC_msg_pointer(6), d=>eBC_GP_60n61ss1);
   eBC_GP_mux_60i20 : mux_4u_4u port map ( a(3)=>not_eBC_GP_7, a(2)=>
      debug_EXMPLR1003(15), a(1)=>PWR, a(0)=>eBC_GP_60n41ss1, b(3)=>
      debug_EXMPLR1003(15), b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_msg_pointer(15), b(0)=>BC_msg_pointer(7), d=>eBC_GP_60n62ss1);
   WM_Ack_select_87i1 : select_3_3 port map ( a(2)=>rtlc87n636, a(1)=>
      not_rtlcn9873, a(0)=>rtlcn2683, b(2)=>PWR, b(1)=>debug_EXMPLR1003(15), 
      b(0)=>WM_Req, d=>WM_Ack_87n13ss1);
   Config_reg_1_select_60i21 : select_3_3 port map ( a(2)=>rtlcn2761, a(1)=>
      rtlcn2762, a(0)=>rtlcn2760, b(2)=>PWR, b(1)=>CPU_Data_in_wide(25), 
      b(0)=>debug_EXMPLR1003(15), d=>Config_reg_1_60n91ss1_3);
   rtlc_4201_select_308 : select_3_3 port map ( a(2)=>eBC_start_FT, a(1)=>
      not_rtlcn9875, a(0)=>rtlcn2784, b(2)=>frame_gap_eq_0_51n5s1, b(1)=>
      debug_EXMPLR1003(15), b(0)=>PWR, d=>rtlcn10201);
   BC_State_fsm_select_26i64 : select_3_3 port map ( a(2)=>not_rtlcn9876, 
      a(1)=>rtlcn3058, a(0)=>rtlcn3059, b(2)=>debug_EXMPLR1003(15), b(1)=>
      PWR, b(0)=>BC_State_fsm_26n116ss1_52, d=>BC_State_fsm_26n182ss1_52);
   BC_State_fsm_select_26i65 : select_3_3 port map ( a(2)=>not_rtlcn9877, 
      a(1)=>rtlcn3296, a(0)=>rtlcn3297, b(2)=>debug_EXMPLR1003(15), b(1)=>
      PWR, b(0)=>BC_State_fsm_26n116ss1_52, d=>BC_State_fsm_26n182ss1_12);
   BC_State_fsm_select_26i66 : select_3_3 port map ( a(2)=>rtlcn3301, a(1)=>
      not_rtlcn9878, a(0)=>BC_State(20), b(2)=>PWR, b(1)=>
      debug_EXMPLR1003(15), b(0)=>BC_State_fsm_26n116ss1_54, d=>
      BC_State_fsm_26n180ss1_20);
   eBC_GP_select_60i23Bus154_1 : select_4_4 port map ( a(3)=>rtlcn3932, a(2)
      =>rtlcn3929, a(1)=>rtlcn3930, a(0)=>rtlcn3931, b(3)=>eBC_GP_60n35ss1, 
      b(2)=>PWR, b(1)=>debug_EXMPLR1003(15), b(0)=>eBC_GP_60n56ss1, d=>
      eBC_GP_60n73ss1(1));
   eBC_GP_select_60i23Bus154_0 : select_4_4 port map ( a(3)=>rtlcn3932, a(2)
      =>rtlcn3985, a(1)=>rtlcn3986, a(0)=>rtlcn3931, b(3)=>eBC_GP_60n34ss1, 
      b(2)=>PWR, b(1)=>debug_EXMPLR1003(15), b(0)=>eBC_GP_60n55ss1, d=>
      eBC_GP_60n73ss1(0));
   BC_Ram_Address_select_26i67Bus122_0 : select_6_6 port map ( a(5)=>
      rtlcn4156, a(4)=>rtlcn4157, a(3)=>rtlc26n16129, a(2)=>rtlc26n16130, 
      a(1)=>rtlc26n16131, a(0)=>rtlcn4158, b(5)=>debug_EXMPLR1003(15), b(4)
      =>PWR, b(3)=>BC_msg_pointer(0), b(2)=>BC_Stack_pointer(0), b(1)=>
      eBC_Q_pointer(0), b(0)=>BC_Num_Msgs(0), d=>BC_Ram_Address_26n180ss1(0)
   );
   Ram_Address_select_22i95Bus107_0 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn4185, a(0)=>
      rtlcn4186, b(3)=>Ram_Address_22n85ss1(0), b(2)=>
      Monitor_Active_command(9), b(1)=>PWR, b(0)=>debug_EXMPLR1003(15), d=>
      Ram_Address_22n103ss1(0));
   MT_On_Async_select_60i24 : select_3_3 port map ( a(2)=>
      CPU_Data_in_wide(17), a(1)=>not_rtlcn9879, a(0)=>rtlcn4289, b(2)=>
      MT_On_Async_60n27s1, b(1)=>MT_On_Async_60n18s1, b(0)=>
      debug_EXMPLR1003(15), d=>MT_On_Async_60n27ss1);
   not_Config_reg_1_8 <= NOT Config_reg_1(8) ;
   not_eBC <= NOT eBC ;
   NO <= NOT YES ;
   rtlc26n15184 <= rtlc26n15182 OR not_eBC ;
   not_MON_WR_req <= NOT MON_WR_req ;
   not_SOM_req <= NOT SOM_req ;
   not_EOM_req <= NOT EOM_req ;
   not_WRD_req <= NOT WRD_req ;
   not_arbiter <= NOT arbiter ;
   not_CPU_Data_in_wide_22 <= NOT CPU_Data_in_wide(22) ;
   not_MON_EOM_req <= NOT MON_EOM_req ;
   not_rtlc22n10408 <= NOT rtlc22n10408 ;
   illegalization_enable <= NOT Config_reg_3_7 ;
   not_illegal_message <= NOT illegal_message_EXMPLR939 ;
   Ram_Address_select_22i96 : select_6_6 port map ( a(5)=>rtlcn5393, a(4)=>
      Do_illegal_EXMPLR916, a(3)=>rtlcn5394, a(2)=>rtlcn5395, a(1)=>
      rtlcn5396, a(0)=>rtlcn5392, b(5)=>Current_command(4), b(4)=>
      Current_command(9), b(3)=>debug_EXMPLR1003(15), b(2)=>PWR, b(1)=>
      Current_command(5), b(0)=>Ram_Address_22n2s1(0), d=>
      Ram_Address_22n50ss1_0);
   Ram_Address_select_22i107Bus109_15 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>not_rtlcn9865, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(15), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(15), d=>Ram_Address_22n103ss1(15));
   Ram_Address_select_22i108Bus101_15 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(15), b(1)=>
      Ram_Address_22n4ss1_15, b(0)=>data_pointer(15), d=>
      Ram_Address_22n76ss1_15);
   Ram_Address_select_22i107Bus109_14 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>rtlcn5425, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(14), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(14), d=>Ram_Address_22n103ss1(14));
   Ram_Address_select_22i108Bus101_14 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(14), b(1)=>
      Ram_Address_22n4ss1_14, b(0)=>data_pointer(14), d=>
      Ram_Address_22n76ss1_14);
   Ram_Address_select_22i107Bus109_13 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>rtlcn5425, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(13), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(13), d=>Ram_Address_22n103ss1(13));
   Ram_Address_select_22i108Bus101_13 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(13), b(1)=>
      Ram_Address_22n4ss1_13, b(0)=>data_pointer(13), d=>
      Ram_Address_22n76ss1_13);
   Ram_Address_select_22i107Bus109_12 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>rtlcn5425, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(12), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(12), d=>Ram_Address_22n103ss1(12));
   Ram_Address_select_22i108Bus101_12 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(12), b(1)=>
      Ram_Address_22n4ss1_12, b(0)=>data_pointer(12), d=>
      Ram_Address_22n76ss1_12);
   Ram_Address_select_22i107Bus109_11 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>rtlcn5425, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(11), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(11), d=>Ram_Address_22n103ss1(11));
   Ram_Address_select_22i108Bus101_11 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(11), b(1)=>
      Ram_Address_22n4ss1_11, b(0)=>data_pointer(11), d=>
      Ram_Address_22n76ss1_11);
   Ram_Address_select_22i107Bus109_10 : select_3_3 port map ( a(2)=>
      MON_SOM_phase(0), a(1)=>rtlcn5425, a(0)=>rtlcn5404, b(2)=>
      Ram_Address_22n85ss1(10), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(10), d=>Ram_Address_22n103ss1(10));
   Ram_Address_select_22i108Bus101_10 : select_4_4 port map ( a(3)=>
      rtlcn5417, a(2)=>rtlcn5418, a(1)=>rtlcn5414, a(0)=>rtlcn5416, b(3)=>
      debug_EXMPLR1003(15), b(2)=>stack_pointer(10), b(1)=>
      Ram_Address_22n4ss1_10, b(0)=>data_pointer(10), d=>
      Ram_Address_22n76ss1_10);
   Ram_Address_select_22i118Bus108_9 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(9), b(2)=>PWR, b(1)=>
      debug_EXMPLR1003(15), b(0)=>monitor_stack_pointer(9), d=>
      Ram_Address_22n103ss1(9));
   Ram_Address_select_22i118Bus108_8 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(8), b(2)=>debug_EXMPLR1003(15), 
      b(1)=>PWR, b(0)=>monitor_stack_pointer(8), d=>Ram_Address_22n103ss1(8)
   );
   Ram_Address_select_22i118Bus108_7 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(7), b(2)=>PWR, b(1)=>
      debug_EXMPLR1003(15), b(0)=>monitor_stack_pointer(7), d=>
      Ram_Address_22n103ss1(7));
   Ram_Address_select_22i118Bus108_6 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(6), b(2)=>
      Monitor_Active_command(15), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(6), d=>Ram_Address_22n103ss1(6));
   Ram_Address_select_22i113 : select_4_4 port map ( a(3)=>rtlcn5781, a(2)=>
      rtlcs102, a(1)=>rtlcs66, a(0)=>rtlcn5416, b(3)=>debug_EXMPLR1003(15), 
      b(2)=>rtlcn10755, b(1)=>stack_pointer(6), b(0)=>data_pointer(6), d=>
      Ram_Address_22n76ss1_6);
   Ram_Address_select_22i118Bus108_5 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(5), b(2)=>
      Monitor_Active_command(14), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(5), d=>Ram_Address_22n103ss1(5));
   Ram_Address_select_22i117Bus99_5 : select_3_3 port map ( a(2)=>
      not_rtlc22n8275, a(1)=>rtlcn5822, a(0)=>rtlcn5823, b(2)=>
      data_pointer(5), b(1)=>PWR, b(0)=>Address(10), d=>
      Ram_Address_22n54ss1_5);
   Ram_Address_select_22i118Bus108_4 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(4), b(2)=>
      Monitor_Active_command(13), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(4), d=>Ram_Address_22n103ss1(4));
   Ram_Address_select_22i117Bus99_4 : select_3_3 port map ( a(2)=>
      not_rtlc22n8275, a(1)=>rtlcn5822, a(0)=>rtlcn5823, b(2)=>
      Ram_Address_22n52ss1_4, b(1)=>PWR, b(0)=>not_Address_10, d=>
      Ram_Address_22n54ss1_4);
   Ram_Address_select_22i118Bus108_3 : select_4_4 port map ( a(3)=>
      MON_SOM_phase(0), a(2)=>MON_SOM_phase(1), a(1)=>rtlcn5571, a(0)=>
      rtlcn5404, b(3)=>Ram_Address_22n85ss1(3), b(2)=>
      Monitor_Active_command(12), b(1)=>debug_EXMPLR1003(15), b(0)=>
      monitor_stack_pointer(3), d=>Ram_Address_22n103ss1(3));
   Ram_Address_select_22i119 : select_5_5 port map ( a(4)=>MON_SOM_phase(0), 
      a(3)=>MON_SOM_phase(1), a(2)=>rtlcn5932, a(1)=>rtlcn5404, a(0)=>
      rtlcn5934, b(4)=>Ram_Address_22n85ss1(2), b(3)=>
      Monitor_Active_command(11), b(2)=>Current_Area_B, b(1)=>
      monitor_stack_pointer(2), b(0)=>PWR, d=>Ram_Address_22n103ss1(2));
   Ram_Address_select_22i120 : select_7_7 port map ( a(6)=>SOM_phase_1, a(5)
      =>rtlcn5967, a(4)=>rtlcn5968, a(3)=>rtlcn5690, a(2)=>rtlcn5970, a(1)=>
      rtlcn5396, a(0)=>rtlcn5392, b(6)=>Current_command(6), b(5)=>BCR, b(4)
      =>Current_Area_B, b(3)=>stack_pointer(2), b(2)=>PWR, b(1)=>
      Current_command(7), b(0)=>Ram_Address_22n2s1(2), d=>
      Ram_Address_22n50ss1_2);
   BC_Ram_Address_select_26i67Bus122_1 : select_6_6 port map ( a(5)=>
      rtlcn6003, a(4)=>rtlcn6004, a(3)=>rtlc26n16129, a(2)=>rtlc26n16130, 
      a(1)=>rtlc26n16131, a(0)=>rtlcn4158, b(5)=>debug_EXMPLR1003(15), b(4)
      =>PWR, b(3)=>BC_msg_pointer(1), b(2)=>BC_Stack_pointer(1), b(1)=>
      eBC_Q_pointer(1), b(0)=>BC_Num_Msgs(1), d=>BC_Ram_Address_26n180ss1(1)
   );
   BC_Ram_Address_select_26i69 : select_7_7 port map ( a(6)=>rtlcn6013, a(5)
      =>rtlc26n16138, a(4)=>rtlc26n16139, a(3)=>rtlc26n16129, a(2)=>
      rtlcn6014, a(1)=>rtlc26n16131, a(0)=>rtlcn4158, b(6)=>
      debug_EXMPLR1003(15), b(5)=>Current_Area_B, b(4)=>BC_Stack_pointer(2), 
      b(3)=>BC_msg_pointer(2), b(2)=>PWR, b(1)=>eBC_Q_pointer(2), b(0)=>
      BC_Num_Msgs(2), d=>BC_Ram_Address_26n180ss1(2));
   BC_Ram_Address_select_26i70 : select_6_6 port map ( a(5)=>rtlcn6026, a(4)
      =>rtlc26n16138, a(3)=>rtlc26n16139, a(2)=>rtlcn6027, a(1)=>
      rtlc26n16131, a(0)=>rtlcn4158, b(5)=>PWR, b(4)=>debug_EXMPLR1003(15), 
      b(3)=>BC_Stack_pointer(3), b(2)=>BC_msg_pointer(3), b(1)=>
      eBC_Q_pointer(3), b(0)=>BC_Num_Msgs(3), d=>BC_Ram_Address_26n180ss1(3)
   );
   BC_Ram_Address_select_26i71Bus123_4 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>BC_Stack_pointer(4), 
      b(2)=>BC_msg_pointer(4), b(1)=>eBC_Q_pointer(4), b(0)=>BC_Num_Msgs(4), 
      d=>BC_Ram_Address_26n180ss1(4));
   BC_Ram_Address_select_26i71Bus123_5 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>BC_Stack_pointer(5), 
      b(2)=>BC_msg_pointer(5), b(1)=>eBC_Q_pointer(5), b(0)=>BC_Num_Msgs(5), 
      d=>BC_Ram_Address_26n180ss1(5));
   BC_Ram_Address_select_26i71Bus123_6 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>BC_Stack_pointer(6), 
      b(2)=>BC_msg_pointer(6), b(1)=>eBC_Q_pointer(6), b(0)=>BC_Num_Msgs(6), 
      d=>BC_Ram_Address_26n180ss1(6));
   BC_Ram_Address_select_26i71Bus123_7 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>BC_Stack_pointer(7), 
      b(2)=>BC_msg_pointer(7), b(1)=>eBC_Q_pointer(7), b(0)=>BC_Num_Msgs(7), 
      d=>BC_Ram_Address_26n180ss1(7));
   BC_Ram_Address_select_26i71Bus123_8 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>PWR, b(3)=>BC_Stack_pointer(8), b(2)=>
      BC_msg_pointer(8), b(1)=>eBC_Q_pointer(8), b(0)=>BC_Num_Msgs(8), d=>
      BC_Ram_Address_26n180ss1(8));
   BC_Ram_Address_select_26i71Bus123_9 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>BC_Stack_pointer(9), 
      b(2)=>BC_msg_pointer(9), b(1)=>eBC_Q_pointer(9), b(0)=>BC_Num_Msgs(9), 
      d=>BC_Ram_Address_26n180ss1(9));
   BC_Ram_Address_select_26i71Bus123_10 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(10), b(2)=>BC_msg_pointer(10), b(1)=>
      eBC_Q_pointer(10), b(0)=>BC_Num_Msgs(10), d=>
      BC_Ram_Address_26n180ss1(10));
   BC_Ram_Address_select_26i71Bus123_11 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(11), b(2)=>BC_msg_pointer(11), b(1)=>
      eBC_Q_pointer(11), b(0)=>BC_Num_Msgs(11), d=>
      BC_Ram_Address_26n180ss1(11));
   BC_Ram_Address_select_26i71Bus123_12 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(12), b(2)=>BC_msg_pointer(12), b(1)=>
      eBC_Q_pointer(12), b(0)=>BC_Num_Msgs(12), d=>
      BC_Ram_Address_26n180ss1(12));
   BC_Ram_Address_select_26i71Bus123_13 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(13), b(2)=>BC_msg_pointer(13), b(1)=>
      eBC_Q_pointer(13), b(0)=>BC_Num_Msgs(13), d=>
      BC_Ram_Address_26n180ss1(13));
   BC_Ram_Address_select_26i71Bus123_14 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(14), b(2)=>BC_msg_pointer(14), b(1)=>
      eBC_Q_pointer(14), b(0)=>BC_Num_Msgs(14), d=>
      BC_Ram_Address_26n180ss1(14));
   BC_Ram_Address_select_26i71Bus123_15 : select_5_5 port map ( a(4)=>
      rtlc26n16148, a(3)=>rtlc26n16139, a(2)=>rtlcn6031, a(1)=>rtlc26n16131, 
      a(0)=>rtlcn4158, b(4)=>debug_EXMPLR1003(15), b(3)=>
      BC_Stack_pointer(15), b(2)=>BC_msg_pointer(15), b(1)=>
      eBC_Q_pointer(15), b(0)=>BC_Num_Msgs(15), d=>
      BC_Ram_Address_26n180ss1(15));
   time_tag_select_60i40Bus143_15 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>not_rtlcn9880, b(2)=>CPU_Data_in_wide(31), b(1)
      =>time_tag_60n15ss1(15), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(15));
   time_tag_select_60i40Bus143_14 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(30), b(1)=>
      time_tag_60n15ss1(14), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(14));
   time_tag_select_60i40Bus143_13 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(29), b(1)=>
      time_tag_60n15ss1(13), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(13));
   time_tag_select_60i40Bus143_12 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(28), b(1)=>
      time_tag_60n15ss1(12), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(12));
   time_tag_select_60i40Bus143_11 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(27), b(1)=>
      time_tag_60n15ss1(11), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(11));
   time_tag_select_60i40Bus143_10 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(26), b(1)=>
      time_tag_60n15ss1(10), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(10));
   time_tag_select_60i40Bus143_9 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(25), b(1)=>
      time_tag_60n15ss1(9), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(9));
   time_tag_select_60i40Bus143_8 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(24), b(1)=>
      time_tag_60n15ss1(8), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(8));
   time_tag_select_60i40Bus143_7 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(23), b(1)=>
      time_tag_60n15ss1(7), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(7));
   time_tag_select_60i40Bus143_6 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(22), b(1)=>
      time_tag_60n15ss1(6), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(6));
   time_tag_select_60i40Bus143_5 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(21), b(1)=>
      time_tag_60n15ss1(5), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(5));
   time_tag_select_60i40Bus143_4 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(20), b(1)=>
      time_tag_60n15ss1(4), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(4));
   time_tag_select_60i40Bus143_3 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(19), b(1)=>
      time_tag_60n15ss1(3), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(3));
   time_tag_select_60i40Bus143_2 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(18), b(1)=>
      time_tag_60n15ss1(2), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(2));
   time_tag_select_60i40Bus143_1 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(17), b(1)=>
      time_tag_60n15ss1(1), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(1));
   time_tag_select_60i40Bus143_0 : select_3_3 port map ( a(2)=>rtlc60n5595, 
      a(1)=>rtlcn6137, a(0)=>rtlcn6155, b(2)=>CPU_Data_in_wide(16), b(1)=>
      time_tag_60n15ss1(0), b(0)=>debug_EXMPLR1003(15), d=>
      time_tag_60n30ss1(0));
   BC_EOM_select_26i83 : select_3_3 port map ( a(2)=>not_rtlcn9882, a(1)=>
      BC_State(54), a(0)=>rtlcn6637, b(2)=>debug_EXMPLR1003(15), b(1)=>
      BC_State_fsm_26n116ss1_52, b(0)=>PWR, d=>BC_EOM_26n180ss1);
   Data_Pointer_register_select_22i121Bus114_0 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(0), b(1)=>data_pointer(0), b(0)=>Data_o_temp(0), d=>
      Data_Pointer_register_22n108ss1(0));
   Data_Pointer_register_select_22i121Bus114_1 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(1), b(1)=>data_pointer(1), b(0)=>Data_o_temp(1), d=>
      Data_Pointer_register_22n108ss1(1));
   Data_Pointer_register_select_22i121Bus114_2 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(2), b(1)=>data_pointer(2), b(0)=>Data_o_temp(2), d=>
      Data_Pointer_register_22n108ss1(2));
   Data_Pointer_register_select_22i121Bus114_3 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(3), b(1)=>data_pointer(3), b(0)=>Data_o_temp(3), d=>
      Data_Pointer_register_22n108ss1(3));
   Data_Pointer_register_select_22i121Bus114_4 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(4), b(1)=>data_pointer(4), b(0)=>Data_o_temp(4), d=>
      Data_Pointer_register_22n108ss1(4));
   Data_Pointer_register_select_22i121Bus114_5 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(5), b(1)=>data_pointer(5), b(0)=>Data_o_temp(5), d=>
      Data_Pointer_register_22n108ss1(5));
   Data_Pointer_register_select_22i121Bus114_6 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(6), b(1)=>data_pointer(6), b(0)=>Data_o_temp(6), d=>
      Data_Pointer_register_22n108ss1(6));
   Data_Pointer_register_select_22i121Bus114_7 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(7), b(1)=>data_pointer(7), b(0)=>Data_o_temp(7), d=>
      Data_Pointer_register_22n108ss1(7));
   Data_Pointer_register_select_22i121Bus114_8 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(8), b(1)=>data_pointer(8), b(0)=>Data_o_temp(8), d=>
      Data_Pointer_register_22n108ss1(8));
   Data_Pointer_register_select_22i121Bus114_9 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(9), b(1)=>data_pointer(9), b(0)=>Data_o_temp(9), d=>
      Data_Pointer_register_22n108ss1(9));
   Data_Pointer_register_select_22i121Bus114_10 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(10), b(1)=>data_pointer(10), b(0)=>Data_o_temp(10), d=>
      Data_Pointer_register_22n108ss1(10));
   Data_Pointer_register_select_22i121Bus114_11 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(11), b(1)=>data_pointer(11), b(0)=>Data_o_temp(11), d=>
      Data_Pointer_register_22n108ss1(11));
   Data_Pointer_register_select_22i121Bus114_12 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(12), b(1)=>data_pointer(12), b(0)=>Data_o_temp(12), d=>
      Data_Pointer_register_22n108ss1(12));
   Data_Pointer_register_select_22i121Bus114_13 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(13), b(1)=>data_pointer(13), b(0)=>Data_o_temp(13), d=>
      Data_Pointer_register_22n108ss1(13));
   Data_Pointer_register_select_22i121Bus114_14 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(14), b(1)=>data_pointer(14), b(0)=>Data_o_temp(14), d=>
      Data_Pointer_register_22n108ss1(14));
   Data_Pointer_register_select_22i121Bus114_15 : select_3_3 port map ( a(2)
      =>rtlcn6681, a(1)=>rtlcn6679, a(0)=>not_rtlcn9883, b(2)=>
      Ram_Address(15), b(1)=>data_pointer(15), b(0)=>Data_o_temp(15), d=>
      Data_Pointer_register_22n108ss1(15));
   Config_reg_1_select_60i41 : select_3_3 port map ( a(2)=>WM_On, a(1)=>
      rtlcn7048, a(0)=>rtlcn7049, b(2)=>WM_triggered, b(1)=>
      Config_reg_1_60n43ss1_1, b(0)=>BC_Frame_active_part, d=>
      Config_reg_1_60n90ss1(1));
   BC_Ram_data_select_26i84Bus124_0 : select_9_9 port map ( a(8)=>
      not_rtlc26n16200, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlcn7082, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(0), b(6)=>BC_Ram_data_26n15s1(0), b(5)=>
      time_tag_EXMPLR1002(0), b(4)=>BC_Echo_word(0), b(3)=>BC_Rx_Data(0), 
      b(2)=>BC_Sts_Word(0), b(1)=>BC_msg_pointer(0), b(0)=>VARAM_Q(0), d=>
      BC_Ram_data_26n180ss1(0));
   Ram_data_i_select_22i137Bus102_0 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_0, b(1)=>
      Data_From_FE(0), b(0)=>Data_to_FE_EXMPLR999(0), d=>
      Ram_data_i_22n76ss1(0));
   BC_Ram_data_select_26i84Bus124_1 : select_9_9 port map ( a(8)=>
      not_rtlc26n16200, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlcn7082, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(1), b(6)=>BC_Ram_data_26n15s1(1), b(5)=>
      time_tag_EXMPLR1002(1), b(4)=>BC_Echo_word(1), b(3)=>BC_Rx_Data(1), 
      b(2)=>BC_Sts_Word(1), b(1)=>BC_msg_pointer(1), b(0)=>VARAM_Q(1), d=>
      BC_Ram_data_26n180ss1(1));
   Ram_data_i_select_22i137Bus102_1 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_1, b(1)=>
      Data_From_FE(1), b(0)=>Data_to_FE_EXMPLR999(1), d=>
      Ram_data_i_22n76ss1(1));
   BC_Ram_data_select_26i86Bus125_2 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>BC_State(4), a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(12), a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>
      rtlcn7082, a(1)=>rtlcn7083, a(0)=>BC_State(84), b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(2), b(7)=>
      BC_Ram_data_26n15s1(2), b(6)=>time_tag_EXMPLR1002(2), b(5)=>
      BC_Ram_data_26n30s4(0), b(4)=>BC_Echo_word(2), b(3)=>BC_Rx_Data(2), 
      b(2)=>BC_Sts_Word(2), b(1)=>BC_msg_pointer(2), b(0)=>VARAM_Q(2), d=>
      BC_Ram_data_26n180ss1(2));
   Ram_data_i_select_22i137Bus102_2 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_2, b(1)=>
      Data_From_FE(2), b(0)=>Data_to_FE_EXMPLR999(2), d=>
      Ram_data_i_22n76ss1(2));
   BC_Ram_data_select_26i86Bus125_3 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>BC_State(4), a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(12), a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>
      rtlcn7082, a(1)=>rtlcn7083, a(0)=>BC_State(84), b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(3), b(7)=>
      BC_Ram_data_26n15s1(3), b(6)=>time_tag_EXMPLR1002(3), b(5)=>
      BC_Ram_data_26n30s4(1), b(4)=>BC_Echo_word(3), b(3)=>BC_Rx_Data(3), 
      b(2)=>BC_Sts_Word(3), b(1)=>BC_msg_pointer(3), b(0)=>VARAM_Q(3), d=>
      BC_Ram_data_26n180ss1(3));
   Ram_data_i_select_22i137Bus102_3 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_3, b(1)=>
      Data_From_FE(3), b(0)=>Data_to_FE_EXMPLR999(3), d=>
      Ram_data_i_22n76ss1(3));
   BC_Ram_data_select_26i88 : select_11_11 port map ( a(10)=>
      not_rtlc26n16200, a(9)=>BC_State(4), a(8)=>rtlcn2170, a(7)=>rtlcn7081, 
      a(6)=>BC_State(12), a(5)=>BC_State(18), a(4)=>rtlc26n16205, a(3)=>
      rtlcn7082, a(2)=>BC_State(56), a(1)=>BC_State(84), a(0)=>rtlcn7141, 
      b(10)=>debug_EXMPLR1003(15), b(9)=>BC_Stack_pointer(4), b(8)=>
      BC_Ram_data_26n15s1(4), b(7)=>time_tag_EXMPLR1002(4), b(6)=>
      BC_Ram_data_26n30s4(2), b(5)=>BC_Echo_word(4), b(4)=>BC_Rx_Data(4), 
      b(3)=>BC_Sts_Word(4), b(2)=>not_BC_msg_pointer_4, b(1)=>VARAM_Q(4), 
      b(0)=>BC_msg_pointer(4), d=>BC_Ram_data_26n180ss1(4));
   Ram_data_i_select_22i137Bus102_4 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_4, b(1)=>
      Data_From_FE(4), b(0)=>Data_to_FE_EXMPLR999(4), d=>
      Ram_data_i_22n76ss1(4));
   BC_Ram_data_select_26i89Bus126_5 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>BC_State(4), a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(12), a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>
      rtlcn7082, a(1)=>rtlcn7083, a(0)=>BC_State(84), b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(5), b(7)=>
      BC_Ram_data_26n15s1(5), b(6)=>time_tag_EXMPLR1002(5), b(5)=>
      BC_Ram_data_26n30s4(3), b(4)=>BC_Echo_word(5), b(3)=>BC_Rx_Data(5), 
      b(2)=>BC_Sts_Word(5), b(1)=>BC_msg_pointer(5), b(0)=>VARAM_Q(5), d=>
      BC_Ram_data_26n180ss1(5));
   Ram_data_i_select_22i137Bus102_5 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_5, b(1)=>
      Data_From_FE(5), b(0)=>Data_to_FE_EXMPLR999(5), d=>
      Ram_data_i_22n76ss1(5));
   BC_Ram_data_select_26i89Bus126_6 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>BC_State(4), a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(12), a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>
      rtlcn7082, a(1)=>rtlcn7083, a(0)=>BC_State(84), b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(6), b(7)=>
      BC_Ram_data_26n15s1(6), b(6)=>time_tag_EXMPLR1002(6), b(5)=>
      BC_Ram_data_26n30s4(4), b(4)=>BC_Echo_word(6), b(3)=>BC_Rx_Data(6), 
      b(2)=>BC_Sts_Word(6), b(1)=>BC_msg_pointer(6), b(0)=>VARAM_Q(6), d=>
      BC_Ram_data_26n180ss1(6));
   Ram_data_i_select_22i137Bus102_6 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_6, b(1)=>
      Data_From_FE(6), b(0)=>Data_to_FE_EXMPLR999(6), d=>
      Ram_data_i_22n76ss1(6));
   BC_Ram_data_select_26i89Bus126_7 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>BC_State(4), a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(12), a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>
      rtlcn7082, a(1)=>rtlcn7083, a(0)=>BC_State(84), b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(7), b(7)=>
      BC_Ram_data_26n15s1(7), b(6)=>time_tag_EXMPLR1002(7), b(5)=>
      BC_Ram_data_26n30s4(5), b(4)=>BC_Echo_word(7), b(3)=>BC_Rx_Data(7), 
      b(2)=>BC_Sts_Word(7), b(1)=>BC_msg_pointer(7), b(0)=>VARAM_Q(7), d=>
      BC_Ram_data_26n180ss1(7));
   Ram_data_i_select_22i137Bus102_7 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_7, b(1)=>
      Data_From_FE(7), b(0)=>Data_to_FE_EXMPLR999(7), d=>
      Ram_data_i_22n76ss1(7));
   BC_Ram_data_select_26i89Bus126_8 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>rtlcn7209, a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(18), a(4)=>rtlc26n16205, a(3)=>rtlcn7082, a(2)=>
      rtlcn7083, a(1)=>BC_State(84), a(0)=>rtlcn7208, b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(8), b(7)=>
      BC_Ram_data_26n15s1(8), b(6)=>time_tag_EXMPLR1002(8), b(5)=>
      BC_Echo_word(8), b(4)=>BC_Rx_Data(8), b(3)=>BC_Sts_Word(8), b(2)=>
      BC_msg_pointer(8), b(1)=>VARAM_Q(8), b(0)=>BC_Ram_data_26n30s4(6), d=>
      BC_Ram_data_26n180ss1(8));
   Ram_data_i_select_22i137Bus102_8 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_8, b(1)=>
      Data_From_FE(8), b(0)=>Data_to_FE_EXMPLR999(8), d=>
      Ram_data_i_22n76ss1(8));
   BC_Ram_data_select_26i89Bus126_9 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>rtlcn7228, a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(18), a(4)=>rtlc26n16205, a(3)=>rtlcn7082, a(2)=>
      rtlcn7083, a(1)=>BC_State(84), a(0)=>rtlcn7227, b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(9), b(7)=>
      BC_Ram_data_26n15s1(9), b(6)=>time_tag_EXMPLR1002(9), b(5)=>
      BC_Echo_word(9), b(4)=>BC_Rx_Data(9), b(3)=>BC_Sts_Word(9), b(2)=>
      BC_msg_pointer(9), b(1)=>VARAM_Q(9), b(0)=>BC_Ram_data_26n30s4(7), d=>
      BC_Ram_data_26n180ss1(9));
   Ram_data_i_select_22i137Bus102_9 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>rtlcn11058, b(1)=>
      Data_From_FE(9), b(0)=>Data_to_FE_EXMPLR999(9), d=>
      Ram_data_i_22n76ss1(9));
   BC_Ram_data_select_26i89Bus126_10 : select_10_10 port map ( a(9)=>
      not_rtlc26n16200, a(8)=>rtlcn7250, a(7)=>rtlcn2170, a(6)=>rtlcn7081, 
      a(5)=>BC_State(18), a(4)=>rtlc26n16205, a(3)=>rtlcn7082, a(2)=>
      rtlcn7083, a(1)=>BC_State(84), a(0)=>rtlc26n19509, b(9)=>
      debug_EXMPLR1003(15), b(8)=>BC_Stack_pointer(10), b(7)=>
      BC_Ram_data_26n15s1(10), b(6)=>time_tag_EXMPLR1002(10), b(5)=>
      BC_Echo_word(10), b(4)=>BC_Rx_Data(10), b(3)=>BC_Sts_Word(10), b(2)=>
      BC_msg_pointer(10), b(1)=>VARAM_Q(10), b(0)=>BC_Ram_data_26n30s4(8), d
      =>BC_Ram_data_26n180ss1(10));
   Ram_data_i_select_22i137Bus102_10 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>rtlcn11059, b(1)=>
      Data_From_FE(10), b(0)=>Data_to_FE_EXMPLR999(10), d=>
      Ram_data_i_22n76ss1(10));
   BC_Ram_data_select_26i95Bus127_11 : select_9_9 port map ( a(8)=>
      not_rtlc26n16200, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlcn7082, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(11), b(6)=>BC_Ram_data_26n15s1(11), b(5)=>
      time_tag_EXMPLR1002(11), b(4)=>BC_Echo_word(11), b(3)=>BC_Rx_Data(11), 
      b(2)=>BC_Sts_Word(11), b(1)=>BC_msg_pointer(11), b(0)=>VARAM_Q(11), d
      =>BC_Ram_data_26n180ss1(11));
   Ram_data_i_select_22i137Bus102_11 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_11, b(1)=>
      Data_From_FE(11), b(0)=>Data_to_FE_EXMPLR999(11), d=>
      Ram_data_i_22n76ss1(11));
   BC_Ram_data_select_26i95Bus127_12 : select_9_9 port map ( a(8)=>
      not_rtlc26n16200, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlcn7082, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(12), b(6)=>BC_Ram_data_26n15s1(12), b(5)=>
      time_tag_EXMPLR1002(12), b(4)=>BC_Echo_word(12), b(3)=>BC_Rx_Data(12), 
      b(2)=>BC_Sts_Word(12), b(1)=>BC_msg_pointer(12), b(0)=>VARAM_Q(12), d
      =>BC_Ram_data_26n180ss1(12));
   Ram_data_i_select_22i137Bus102_12 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>rtlcn11060, b(1)=>
      Data_From_FE(12), b(0)=>Data_to_FE_EXMPLR999(12), d=>
      Ram_data_i_22n76ss1(12));
   BC_Ram_data_select_26i95Bus127_13 : select_9_9 port map ( a(8)=>
      not_rtlc26n16200, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlcn7082, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(13), b(6)=>BC_Ram_data_26n15s1(13), b(5)=>
      time_tag_EXMPLR1002(13), b(4)=>BC_Echo_word(13), b(3)=>BC_Rx_Data(13), 
      b(2)=>BC_Sts_Word(13), b(1)=>BC_msg_pointer(13), b(0)=>VARAM_Q(13), d
      =>BC_Ram_data_26n180ss1(13));
   BC_BUS_A_select_26i98 : select_3_3 port map ( a(2)=>BC_State(80), a(1)=>
      rtlcn7311, a(0)=>rtlcn7310, b(2)=>eBC_Q_pointer(15), b(1)=>
      BC_Control_word_7, b(0)=>not_BC_Control_word_7, d=>BC_BUS_A_26n180ss1
   );
   Ram_data_i_select_22i150 : select_5_5 port map ( a(4)=>not_rtlc22n10133, 
      a(3)=>rtlcn7234, a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>rtlcn7235, 
      b(4)=>Ram_data_i_22n27ss1(13), b(3)=>not_bus_A, b(2)=>
      Current_command(13), b(1)=>time_tag_EXMPLR1002(13), b(0)=>
      data_pointer(13), d=>Ram_data_i_22n50ss1_13);
   Ram_data_i_select_22i137Bus102_13 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_13, b(1)=>
      Data_From_FE(13), b(0)=>Data_to_FE_EXMPLR999(13), d=>
      Ram_data_i_22n76ss1(13));
   BC_Ram_data_select_26i95Bus127_14 : select_9_9 port map ( a(8)=>
      not_rtlcn9884, a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, 
      a(4)=>rtlc26n16088, a(3)=>BC_State(18), a(2)=>rtlc26n16205, a(1)=>
      rtlcn7083, a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(14), b(6)=>BC_Ram_data_26n15s1(14), b(5)=>
      time_tag_EXMPLR1002(14), b(4)=>PWR, b(3)=>BC_Echo_word(14), b(2)=>
      BC_Rx_Data(14), b(1)=>BC_msg_pointer(14), b(0)=>VARAM_Q(14), d=>
      BC_Ram_data_26n180ss1(14));
   Ram_data_i_select_22i152 : select_3_3 port map ( a(2)=>not_rtlc22n10133, 
      a(1)=>SOM_phase_6, a(0)=>rtlcn7235, b(2)=>Ram_data_i_22n27ss1(14), 
      b(1)=>Current_command(14), b(0)=>data_pointer(14), d=>
      Ram_data_i_22n50ss1_14);
   Ram_data_i_select_22i137Bus102_14 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn7345, b(2)=>Ram_data_i_22n50ss1_14, b(1)=>
      Data_From_FE(14), b(0)=>Data_to_FE_EXMPLR999(14), d=>
      Ram_data_i_22n76ss1(14));
   Ram_data_i_select_22i154 : select_3_3 port map ( a(2)=>rtlc22n10342, a(1)
      =>rtlcn7184, a(0)=>MON_SOM_phase(7), b(2)=>Ram_data_i_22n85ss1(14), 
      b(1)=>monitor_data_pointer(14), b(0)=>Monitor_Active_command(14), d=>
      Ram_data_i_22n103ss1_14);
   BC_Ram_data_select_26i95Bus127_15 : select_9_9 port map ( a(8)=>rtlcn7368, 
      a(7)=>rtlc26n16203, a(6)=>rtlcn2170, a(5)=>rtlcn7081, a(4)=>
      BC_State(18), a(3)=>rtlc26n16205, a(2)=>rtlc26n16206, a(1)=>rtlcn7083, 
      a(0)=>BC_State(84), b(8)=>debug_EXMPLR1003(15), b(7)=>
      BC_Stack_pointer(15), b(6)=>BC_Ram_data_26n15s1(15), b(5)=>
      time_tag_EXMPLR1002(15), b(4)=>BC_Echo_word(15), b(3)=>BC_Rx_Data(15), 
      b(2)=>PWR, b(1)=>BC_msg_pointer(15), b(0)=>VARAM_Q(15), d=>
      BC_Ram_data_26n180ss1(15));
   Ram_data_i_select_22i137Bus102_15 : select_3_3 port map ( a(2)=>rtlcn7090, 
      a(1)=>rtlcn7091, a(0)=>rtlcn8146, b(2)=>Ram_data_i_22n50ss1_15, b(1)=>
      Data_From_FE(15), b(0)=>Data_to_FE_EXMPLR999(15), d=>
      Ram_data_i_22n76ss1(15));
   Non_masked_Event_select_75i27 : select_3_3 port map ( a(2)=>
      BC_msg_pointer(2), a(1)=>not_rtlcn9885, a(0)=>rtlcn7396, b(2)=>
      Interrupt_mask_register_2(4), b(1)=>Non_masked_Event_75n31ss1, b(0)=>
      Interrupt_mask_register_2(5), d=>Non_masked_Event_75n33ss1);
   BC_TX_Data_select_26i101Bus130_0 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(0), b(1)=>time_tag_EXMPLR1002(0), b(0)=>
      Data_o_temp(0), d=>BC_TX_Data_26n180ss1(0));
   BC_TX_Data_select_26i101Bus130_10 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(10), b(1)=>time_tag_EXMPLR1002(10), b(0)=>
      Data_o_temp(10), d=>BC_TX_Data_26n180ss1(10));
   BC_TX_Data_select_26i101Bus130_9 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(9), b(1)=>time_tag_EXMPLR1002(9), b(0)=>
      Data_o_temp(9), d=>BC_TX_Data_26n180ss1(9));
   BC_TX_Data_select_26i101Bus130_8 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(8), b(1)=>time_tag_EXMPLR1002(8), b(0)=>
      Data_o_temp(8), d=>BC_TX_Data_26n180ss1(8));
   BC_TX_Data_select_26i101Bus130_7 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(7), b(1)=>time_tag_EXMPLR1002(7), b(0)=>
      Data_o_temp(7), d=>BC_TX_Data_26n180ss1(7));
   BC_TX_Data_select_26i101Bus130_6 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(6), b(1)=>time_tag_EXMPLR1002(6), b(0)=>
      Data_o_temp(6), d=>BC_TX_Data_26n180ss1(6));
   BC_TX_Data_select_26i101Bus130_5 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(5), b(1)=>time_tag_EXMPLR1002(5), b(0)=>
      Data_o_temp(5), d=>BC_TX_Data_26n180ss1(5));
   BC_TX_Data_select_26i101Bus130_4 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(4), b(1)=>time_tag_EXMPLR1002(4), b(0)=>
      Data_o_temp(4), d=>BC_TX_Data_26n180ss1(4));
   BC_TX_Data_select_26i101Bus130_3 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(3), b(1)=>time_tag_EXMPLR1002(3), b(0)=>
      Data_o_temp(3), d=>BC_TX_Data_26n180ss1(3));
   BC_TX_Data_select_26i101Bus130_2 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(2), b(1)=>time_tag_EXMPLR1002(2), b(0)=>
      Data_o_temp(2), d=>BC_TX_Data_26n180ss1(2));
   BC_TX_Data_select_26i101Bus130_1 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(1), b(1)=>time_tag_EXMPLR1002(1), b(0)=>
      Data_o_temp(1), d=>BC_TX_Data_26n180ss1(1));
   BC_TX_Data_select_26i101Bus130_11 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(11), b(1)=>time_tag_EXMPLR1002(11), b(0)=>
      Data_o_temp(11), d=>BC_TX_Data_26n180ss1(11));
   BC_TX_Data_select_26i101Bus130_12 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(12), b(1)=>time_tag_EXMPLR1002(12), b(0)=>
      Data_o_temp(12), d=>BC_TX_Data_26n180ss1(12));
   BC_TX_Data_select_26i101Bus130_13 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(13), b(1)=>time_tag_EXMPLR1002(13), b(0)=>
      Data_o_temp(13), d=>BC_TX_Data_26n180ss1(13));
   BC_TX_Data_select_26i101Bus130_14 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(14), b(1)=>time_tag_EXMPLR1002(14), b(0)=>
      Data_o_temp(14), d=>BC_TX_Data_26n180ss1(14));
   BC_TX_Data_select_26i101Bus130_15 : select_3_3 port map ( a(2)=>
      BC_State(80), a(1)=>rtlcn7480, a(0)=>rtlcn7481, b(2)=>
      Frame_length_reg_0xD(15), b(1)=>time_tag_EXMPLR1002(15), b(0)=>
      Data_o_temp(15), d=>BC_TX_Data_26n180ss1(15));
   not_rtlcs100 <= NOT rtlcs100 ;
   not_mode_command <= NOT mode_command ;
   not_BCR <= NOT BCR ;
   not_CPU_Data_in_wide_19 <= NOT CPU_Data_in_wide(19) ;
   not_rtlc22n8221 <= NOT rtlc22n8221 ;
   not_rtlc32n450 <= NOT rtlc32n450 ;
   not_rtlc60n6648 <= NOT rtlc60n6648 ;
   not_BC_on <= NOT BC_on_EXMPLR883 ;
   not_rtlc60n6633 <= NOT rtlc60n6633 ;
   not_rtlc32n408 <= NOT rtlc32n408 ;
   not_BC_Echo_word_10 <= NOT BC_Echo_word(10) ;
   not_Address_10 <= NOT Address(10) ;
   not_Read <= NOT Read ;
   not_Monitor_bus_a <= NOT Monitor_bus_a ;
   not_RT_On <= NOT RT_On_EXMPLR924 ;
   not_rtlc60n6552 <= NOT rtlc60n6552 ;
   STM_ended_select_22i156 : select_3_3 port map ( a(2)=>rtlcn7956, a(1)=>
      rtlcn7957, a(0)=>rtlcn5982, b(2)=>debug_EXMPLR1003(15), b(1)=>PWR, 
      b(0)=>Ram_Address_22n25ss1(1), d=>STM_ended_22n27ss1);
   not_rtlcs101 <= NOT rtlcs101 ;
   not_rtlc22n8131 <= NOT rtlc22n8131 ;
   not_rtlc22n8108 <= NOT rtlc22n8108 ;
   not_rtlc22n8155 <= NOT rtlc22n8155 ;
   not_rtlc22n8177 <= NOT rtlc22n8177 ;
   not_rtlc22n8199 <= NOT rtlc22n8199 ;
   Ram_Address_select_22i157 : select_4_4 port map ( a(3)=>not_rtlcn9886, 
      a(2)=>rtlcn8394, a(1)=>rtlcn5690, a(0)=>rtlcn5392, b(3)=>PWR, b(2)=>
      debug_EXMPLR1003(15), b(1)=>stack_pointer(8), b(0)=>
      Ram_Address_22n2s1(8), d=>Ram_Address_22n50ss1_8);
   time_tag_select_60i57Bus140_15 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(15), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(15), d=>
      time_tag_60n13ss1(15));
   time_tag_select_60i57Bus140_14 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(14), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(14), d=>
      time_tag_60n13ss1(14));
   time_tag_select_60i57Bus140_13 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(13), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(13), d=>
      time_tag_60n13ss1(13));
   time_tag_select_60i57Bus140_12 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(12), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(12), d=>
      time_tag_60n13ss1(12));
   time_tag_select_60i57Bus140_11 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(11), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(11), d=>
      time_tag_60n13ss1(11));
   time_tag_select_60i57Bus140_10 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(10), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(10), d=>
      time_tag_60n13ss1(10));
   time_tag_select_60i57Bus140_9 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(9), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(9), d=>
      time_tag_60n13ss1(9));
   time_tag_select_60i57Bus140_8 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(8), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(8), d=>
      time_tag_60n13ss1(8));
   time_tag_select_60i57Bus140_7 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(7), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(7), d=>
      time_tag_60n13ss1(7));
   time_tag_select_60i57Bus140_6 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(6), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(6), d=>
      time_tag_60n13ss1(6));
   time_tag_select_60i57Bus140_5 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(5), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(5), d=>
      time_tag_60n13ss1(5));
   time_tag_select_60i57Bus140_4 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(4), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(4), d=>
      time_tag_60n13ss1(4));
   time_tag_select_60i57Bus140_3 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(3), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(3), d=>
      time_tag_60n13ss1(3));
   time_tag_select_60i57Bus140_2 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(2), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(2), d=>
      time_tag_60n13ss1(2));
   time_tag_select_60i57Bus140_1 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(1), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(1), d=>
      time_tag_60n13ss1(1));
   time_tag_select_60i57Bus140_0 : select_3_3 port map ( a(2)=>rtlc60n5359, 
      a(1)=>rtlcn8418, a(0)=>not_rtlcn9887, b(2)=>Dummy_register_0x4(0), 
      b(1)=>debug_EXMPLR1003(15), b(0)=>time_tag_60n10s1(0), d=>
      time_tag_60n13ss1(0));
   not_MON_SOM_req <= NOT MON_SOM_req ;
   not_rtlc22n8243 <= NOT rtlc22n8243 ;
   not_rtlc60n5424 <= NOT rtlc60n5424 ;
   not_Record_enable <= NOT Record_enable ;
   Monitor_data_stack_rollover_mux_22i158 : mux_8u_8u port map ( a(7)=>
      Monitor_data_stack_rollover_22n107s7, a(6)=>
      Monitor_data_stack_rollover_22n107s6, a(5)=>
      Monitor_data_stack_rollover_22n107s5, a(4)=>
      Monitor_data_stack_rollover_22n107s4, a(3)=>
      Monitor_data_stack_rollover_22n107s3, a(2)=>
      Monitor_data_stack_rollover_22n107s2, a(1)=>
      Monitor_data_stack_rollover_22n107s1, a(0)=>
      Monitor_data_stack_rollover_22n107s7, b(7)=>debug_EXMPLR1003(15), b(6)
      =>debug_EXMPLR1003(15), b(5)=>debug_EXMPLR1003(15), b(4)=>
      debug_EXMPLR1003(15), b(3)=>debug_EXMPLR1003(15), b(2)=>
      Config_reg_3_10, b(1)=>Config_reg_3_9, b(0)=>Config_reg_3_8, d=>
      Monitor_data_stack_rollover_22n107ss1);
   Monitor_data_stack_half_pass_mux_22i159 : mux_8u_8u port map ( a(7)=>
      Monitor_data_stack_half_pass_22n107s7, a(6)=>
      Monitor_data_stack_half_pass_22n107s6, a(5)=>
      Monitor_data_stack_half_pass_22n107s5, a(4)=>
      Monitor_data_stack_half_pass_22n107s4, a(3)=>
      Monitor_data_stack_half_pass_22n107s3, a(2)=>
      Monitor_data_stack_half_pass_22n107s2, a(1)=>
      Monitor_data_stack_half_pass_22n107s1, a(0)=>
      Monitor_data_stack_half_pass_22n107s7, b(7)=>debug_EXMPLR1003(15), 
      b(6)=>debug_EXMPLR1003(15), b(5)=>debug_EXMPLR1003(15), b(4)=>
      debug_EXMPLR1003(15), b(3)=>debug_EXMPLR1003(15), b(2)=>
      Config_reg_3_10, b(1)=>Config_reg_3_9, b(0)=>Config_reg_3_8, d=>
      Monitor_data_stack_half_pass_22n107ss1);
   reg_data_out_wide_mux_75i28 : mux_16u_16u port map ( a(15)=>
      eBC_Q_pointer(1), a(14)=>Interrupt_mask_register_2(1), a(13)=>
      eBC_GP(1), a(12)=>eBC_Watchdog_enable, a(11)=>debug_EXMPLR1003(15), 
      a(10)=>Latched_TT(1), a(9)=>debug_EXMPLR1003(15), a(8)=>
      debug_EXMPLR1003(15), a(7)=>debug_EXMPLR1003(15), a(6)=>
      reg_data_out_wide_75n54ss1(1), a(5)=>BC_frame_GAP_counter(1), a(4)=>
      RT_Address_EXMPLR1000(0), a(3)=>MODE_CODE1553A_EXMPLR917, a(2)=>
      time_tag_EXMPLR1002(1), a(1)=>reg_data_out_wide_75n41ss1(1), a(0)=>
      Config_reg_1(1), b(15)=>debug_EXMPLR1003(15), b(14)=>
      debug_EXMPLR1003(15), b(13)=>debug_EXMPLR1003(15), b(12)=>
      debug_EXMPLR1003(15), b(11)=>debug_EXMPLR1003(15), b(10)=>
      debug_EXMPLR1003(15), b(9)=>debug_EXMPLR1003(15), b(8)=>
      debug_EXMPLR1003(15), b(7)=>debug_EXMPLR1003(15), b(6)=>
      debug_EXMPLR1003(15), b(5)=>debug_EXMPLR1003(15), b(4)=>
      debug_EXMPLR1003(15), b(3)=>CPU_Address(4), b(2)=>CPU_Address(3), b(1)
      =>CPU_Address(2), b(0)=>CPU_Address(1), d=>
      reg_data_out_wide_75n70ss1(1));
   reg_data_out_wide_mux_75i29 : mux_16u_16u port map ( a(15)=>
      eBC_Q_pointer(5), a(14)=>Interrupt_mask_register_2(5), a(13)=>
      eBC_GP(5), a(12)=>PrimeCheck, a(11)=>debug_EXMPLR1003(15), a(10)=>
      Latched_TT(5), a(9)=>debug_EXMPLR1003(15), a(8)=>debug_EXMPLR1003(15), 
      a(7)=>debug_EXMPLR1003(15), a(6)=>reg_data_out_wide_75n54ss1(5), a(5)
      =>BC_frame_GAP_counter(5), a(4)=>RT_Address_EXMPLR1000(4), a(3)=>
      Config_reg_3_5, a(2)=>time_tag_EXMPLR1002(5), a(1)=>
      reg_data_out_wide_75n41ss1(5), a(0)=>Config_reg_1(5), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>CPU_Address(4), 
      b(2)=>CPU_Address(3), b(1)=>CPU_Address(2), b(0)=>CPU_Address(1), d=>
      reg_data_out_wide_75n70ss1(5));
   reg_data_out_wide_mux_75i30 : mux_16u_16u port map ( a(15)=>
      eBC_Q_pointer(12), a(14)=>Interrupt_mask_register_2(12), a(13)=>
      BC_Sts_Word(12), a(12)=>debug_EXMPLR1003(15), a(11)=>
      debug_EXMPLR1003(15), a(10)=>Latched_TT(12), a(9)=>PWR, a(8)=>
      debug_EXMPLR1003(15), a(7)=>debug_EXMPLR1003(15), a(6)=>
      reg_data_out_wide_75n54ss1(12), a(5)=>BC_frame_GAP_counter(12), a(4)=>
      Config_reg_5(12), a(3)=>Config_reg_3_12, a(2)=>time_tag_EXMPLR1002(12), 
      a(1)=>reg_data_out_wide_75n41ss1(12), a(0)=>Config_reg_1(12), b(15)=>
      debug_EXMPLR1003(15), b(14)=>debug_EXMPLR1003(15), b(13)=>
      debug_EXMPLR1003(15), b(12)=>debug_EXMPLR1003(15), b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      debug_EXMPLR1003(15), b(8)=>debug_EXMPLR1003(15), b(7)=>
      debug_EXMPLR1003(15), b(6)=>debug_EXMPLR1003(15), b(5)=>
      debug_EXMPLR1003(15), b(4)=>debug_EXMPLR1003(15), b(3)=>CPU_Address(4), 
      b(2)=>CPU_Address(3), b(1)=>CPU_Address(2), b(0)=>CPU_Address(1), d=>
      reg_data_out_wide_75n70ss1(12));
   not_Config_reg_3_12 <= NOT Config_reg_3_12 ;
   not_Config_reg_3_11 <= NOT Config_reg_3_11 ;
   rtlc22n10046 <= not_Config_reg_3_12 OR not_Config_reg_3_11 ;
   not_MON_EOM_phase_1 <= NOT MON_EOM_phase(1) ;
   not_MON_EOM_phase_0 <= NOT MON_EOM_phase(0) ;
   rtlc22n10298 <= not_MON_EOM_phase_1 OR not_MON_EOM_phase_0 ;
   not_MON_Phase_0 <= NOT MON_Phase(0) ;
   rtlc22n10429 <= MON_Phase(1) OR not_MON_Phase_0 ;
   rtlc22n10476 <= not_MON_Phase_1 OR MON_Phase(0) ;
   rtlc22n10479 <= not_MON_Phase_1 OR not_MON_Phase_0 ;
   rtlc22n10248 <= not_Phase_1 OR Phase(0) ;
   rtlc22n10408 <= rtlcs53 OR rtlcs56 ;
   rtlc22n10405 <= rtlcs52 OR rtlcs59 ;
   rtlc26n15803 <= Config_reg_3_14 OR Config_reg_3_13 ;
   not_Config_reg_5_9 <= NOT Config_reg_5(9) ;
   not_rtlcn8785 <= NOT rtlcn8785 ;
   rtlcn8789 <= BC_State(80) OR rtlc26n16088 ;
   not_rtlcn8789 <= NOT rtlcn8789 ;
   not_rtlc26n17323 <= NOT rtlc26n17323 ;
   not_rtlc60n5464 <= NOT rtlc60n5464 ;
   not_rtlcs236 <= NOT rtlcs236 ;
   not_CPU_Address_4 <= NOT CPU_Address(4) ;
   rtlc_13701_or_470 : or_4u_4u port map ( a(3)=>CPU_Address(1), a(2)=>
      CPU_Address(2), a(1)=>CPU_Address(3), a(0)=>not_CPU_Address_4, d=>
      rtlcn8795);
   not_rtlcn8795 <= NOT rtlcn8795 ;
   rtlcn2082 <= MON_SOM_phase(1) OR MON_SOM_phase(3) ;
   not_MON_SOM_phase_2 <= NOT MON_SOM_phase(2) ;
   rtlcn2275 <= BC_State(82) OR BC_State(83) ;
   rtlc_13718_or_472 : or_4u_4u port map ( a(3)=>BC_State(5), a(2)=>
      BC_State(12), a(1)=>BC_State(30), a(0)=>BC_State(47), d=>rtlcn2296);
   not_rtlcn8796 <= NOT rtlcn8796 ;
   rtlcn2392 <= rtlcs224 OR rtlcn2412 ;
   rtlcn2400 <= rtlcs227 OR rtlcn2412 ;
   rtlcn2402 <= rtlcs225 OR rtlcn2412 ;
   rtlcn2419 <= rtlcs257 OR rtlcn2412 ;
   rtlcn8883 <= BC_State(12) OR BC_State(3) ;
   rtlcn2520 <= BC_State(25) OR BC_State(39) ;
   rtlc_13740_or_475 : or_5u_5u port map ( a(4)=>BC_State(8), a(3)=>
      BC_State(36), a(2)=>BC_State(74), a(1)=>BC_State(75), a(0)=>rtlcn8906, 
      d=>rtlcn2522);
   rtlcn2524 <= BC_State(26) OR BC_State(41) ;
   not_Ack <= NOT Ack ;
   rtlcn8978 <= not_Ack AND state(7) ;
   rtlcn2625 <= state(4) OR rtlcn8978 ;
   rtlcn2624 <= Ack AND state(7) ;
   rtlcn8834 <= Ext_Trigger_Dx OR rtlc87n367 ;
   not_rtlc87n403 <= NOT rtlc87n403 ;
   rtlcn8901 <= not_rtlc87n403 OR rtlcn8834 ;
   rtlcn8980 <= state(2) AND rtlcn8901 ;
   rtlcn2683 <= state(7) OR rtlcn8980 ;
   not_CE <= NOT CE ;
   rtlcn8835 <= not_CE OR not_rtlc60n6552 ;
   not_rtlcn2638 <= NOT rtlcn2638 ;
   rtlcn8986 <= not_rtlcn2638 AND rtlcn8835 ;
   not_rtlcn8835 <= NOT rtlcn8835 ;
   rtlcn2761 <= rtlcn8986 OR not_rtlcn9874 ;
   rtlcn2762 <= rtlcn2638 AND rtlcn8835 ;
   rtlcn2760 <= rtlc60n6560 AND not_rtlcn8835 ;
   not_eBC_start_FT <= NOT eBC_start_FT ;
   rtlcn2784 <= not_eBC_start_FT AND rtlc51n160 ;
   rtlcn8992 <= rtlc26n13657 AND BC_State(53) ;
   not_rtlc26n15184 <= NOT rtlc26n15184 ;
   rtlcn8994 <= BC_State(52) AND not_rtlc26n15184 ;
   rtlcn8923 <= rtlcn8992 OR rtlcn8994 ;
   rtlcn3058 <= not_rtlc26n15497 AND rtlcn8923 ;
   rtlcn3059 <= BC_State(54) AND not_rtlc26n15497 ;
   rtlcn8809 <= not_Ack AND not_rtlc26n15497 ;
   rtlcn8998 <= BC_State(12) AND rtlcn8809 ;
   rtlcn3296 <= rtlcn8998 OR rtlcn8999 ;
   rtlcn3297 <= not_rtlc26n15497 AND BC_State(20) ;
   rtlcn9002 <= rtlc26n12839 AND BC_State(18) ;
   rtlcn3301 <= BC_State(29) OR rtlcn9002 ;
   not_eBC_CFT_do <= NOT eBC_CFT_do ;
   not_eBC_CMT_do <= NOT eBC_CMT_do ;
   not_eBC_CMV_do <= NOT eBC_CMV_do ;
   rtlcn3932 <= not_CE OR not_rtlcn10454 ;
   rtlcn8852 <= CE AND not_eBC_CMV_do ;
   rtlcn8878 <= CE AND eBC_CMV_do ;
   rtlcn8880 <= eBC_CMT_do AND rtlcn8852 ;
   rtlcn9010 <= rtlcs357 AND rtlcn8797 ;
   rtlcn9011 <= rtlcs355 AND rtlcn8878 ;
   rtlcn9012 <= rtlcs356 AND rtlcn8880 ;
   not_rtlcs357 <= NOT rtlcs357 ;
   rtlcn9014 <= not_rtlcs357 AND rtlcn8797 ;
   not_rtlcs355 <= NOT rtlcs355 ;
   rtlcn9016 <= not_rtlcs355 AND rtlcn8878 ;
   not_rtlcs356 <= NOT rtlcs356 ;
   rtlcn9018 <= not_rtlcs356 AND rtlcn8880 ;
   rtlc_13816_and_480 : and_4u_4u port map ( a(3)=>eBC_GP_do, a(2)=>
      not_eBC_CFT_do, a(1)=>not_eBC_CMT_do, a(0)=>rtlcn8852, d=>rtlcn3931);
   rtlcn9020 <= rtlcn8797 AND not_rtlc60n7906 ;
   rtlcn9022 <= not_rtlc60n7249 AND rtlcn8878 ;
   rtlcn9024 <= not_rtlc60n7956 AND rtlcn8880 ;
   rtlcn9025 <= rtlcn8797 AND rtlc60n7906 ;
   rtlcn9026 <= rtlc60n7249 AND rtlcn8878 ;
   rtlcn9027 <= rtlc60n7956 AND rtlcn8880 ;
   rtlcn8841 <= BC_State(39) AND BC_Command_Sync ;
   rtlcn9028 <= rtlc26n13295 AND rtlcn8841 ;
   rtlcn8905 <= rtlcn8874 OR rtlcn9028 ;
   rtlc_13836_or_483 : or_11u_11u port map ( a(10)=>BC_State(0), a(9)=>
      BC_State(2), a(8)=>BC_State(4), a(7)=>BC_State(7), a(6)=>BC_State(14), 
      a(5)=>BC_State(20), a(4)=>BC_State(45), a(3)=>BC_State(47), a(2)=>
      BC_State(49), a(1)=>rtlcn8883, a(0)=>rtlcn8905, d=>rtlcn4156);
   rtlcn8831 <= BC_Command_Sync AND BC_State(43) ;
   rtlcn8865 <= BC_State(5) OR BC_State(6) ;
   rtlcn8885 <= BC_State(54) OR BC_State(48) ;
   not_rtlc26n13295 <= NOT rtlc26n13295 ;
   rtlcn9030 <= not_rtlc26n13295 AND rtlcn8841 ;
   rtlc_13842_or_484 : or_9u_9u port map ( a(8)=>BC_State(8), a(7)=>
      BC_State(9), a(6)=>BC_State(13), a(5)=>BC_State(30), a(4)=>
      BC_State(38), a(3)=>rtlcn8831, a(2)=>rtlcn8865, a(1)=>rtlcn8885, a(0)
      =>rtlcn9030, d=>rtlcn4157);
   rtlcn8924 <= BC_State(39) OR BC_State(43) ;
   not_BC_Command_Sync <= NOT BC_Command_Sync ;
   rtlcn4158 <= not_BC_Command_Sync AND rtlcn8924 ;
   rtlcn8879 <= MON_SOM_phase(2) AND not_Record_enable ;
   rtlc_13848_or_485 : or_4u_4u port map ( a(3)=>MON_SOM_phase(3), a(2)=>
      MON_SOM_phase(5), a(1)=>MON_SOM_phase(7), a(0)=>rtlcn8879, d=>
      rtlcn4185);
   rtlcn8839 <= not_MON_SOM_phase_2 OR not_Record_enable ;
   not_rtlcn8839 <= NOT rtlcn8839 ;
   not_CPU_Data_in_wide_17 <= NOT CPU_Data_in_wide(17) ;
   rtlcn4289 <= not_CPU_Data_in_wide_17 AND CPU_Data_in_wide(22) ;
   rtlcn9036 <= mode_command AND SOM_phase_4 ;
   rtlcn5393 <= SOM_phase_1 OR rtlcn9036 ;
   rtlcn9037 <= SOM_phase_9 AND not_Ack ;
   rtlcn8886 <= SOM_phase_5 OR rtlcn9037 ;
   rtlcn9038 <= SOM_phase_0 AND rtlc22n10048 ;
   rtlcn8887 <= SOM_phase_3 OR rtlcn9038 ;
   rtlcn5394 <= rtlcn8886 OR rtlcn8887 ;
   rtlcn8813 <= Ack OR rtlcs101 ;
   rtlcn8858 <= EOM_phase(4) AND SOM_phase_0 ;
   rtlcn8876 <= SOM_phase_9 AND Ack ;
   rtlcn9039 <= rtlcn8813 AND rtlcn8858 ;
   rtlcn8888 <= SOM_phase_6 OR SOM_phase_7 ;
   rtlcn8914 <= SOM_phase_8 AND not_rtlcs100 ;
   not_rtlcn8813 <= NOT rtlcn8813 ;
   rtlcn8913 <= EOM_phase(4) AND not_rtlcn8813 ;
   rtlcn8812 <= EOM_phase(2) OR rtlcn8913 ;
   rtlcn8799 <= SOM_phase_0 AND rtlcn8812 ;
   rtlcn8922 <= SOM_phase_8 AND rtlcs100 ;
   rtlcn9043 <= not_mode_command AND SOM_phase_4 ;
   not_First_After_Reset <= NOT First_After_Reset ;
   rtlcn5979 <= EOM_phase(0) AND not_First_After_Reset ;
   rtlcn5392 <= rtlcn5979 AND SOM_phase_0 ;
   not_New_command_record <= NOT New_command_record ;
   rtlcn8818 <= Ack OR not_New_command_record ;
   not_rtlcn8818 <= NOT rtlcn8818 ;
   rtlcn9047 <= MON_SOM_phase(7) AND not_rtlcn8818 ;
   rtlc_13890_or_490 : or_4u_4u port map ( a(3)=>MON_SOM_phase(4), a(2)=>
      MON_SOM_phase(5), a(1)=>MON_SOM_phase(6), a(0)=>rtlcn9047, d=>
      rtlcn5404);
   rtlcn8824 <= SOM_phase_0 AND rtlcs102 ;
   rtlcn8826 <= SOM_phase_4 AND rtlcs102 ;
   rtlcn8830 <= SOM_phase_8 AND rtlcs102 ;
   rtlcn9049 <= rtlc22n8275 AND rtlcs67 ;
   rtlcn5781 <= rtlcs65 OR rtlcn9049 ;
   rtlcn9050 <= SOM_phase_3 AND rtlcs102 ;
   rtlcn8925 <= rtlcn8876 OR rtlc22n10119 ;
   rtlcn9051 <= not_rtlc22n10050 AND rtlcn8824 ;
   rtlcn9052 <= rtlcs102 AND rtlcn8925 ;
   rtlcn9053 <= EOM_phase(1) AND SOM_phase_0 ;
   rtlcn9054 <= rtlcs102 AND rtlcn5690 ;
   rtlcn5418 <= rtlcs66 OR rtlcn9054 ;
   rtlcn5414 <= EOM_phase(0) AND rtlcn8824 ;
   not_rtlc22n8275 <= NOT rtlc22n8275 ;
   rtlcn5416 <= not_rtlc22n8275 AND rtlcs67 ;
   rtlcn8881 <= MON_SOM_phase(7) AND rtlcn8818 ;
   rtlcn5425 <= rtlc22n10340 OR rtlcn8881 ;
   rtlcn5571 <= rtlc22n10316 OR rtlcn8881 ;
   not_Config_reg_2_0 <= NOT Config_reg_2(0) ;
   rtlcn8806 <= not_BCR OR not_Config_reg_2_0 ;
   not_Current_Area_B <= NOT Current_Area_B ;
   rtlcn8849 <= not_Current_Area_B OR rtlcn8806 ;
   rtlcn8861 <= mode_command AND rtlcn8826 ;
   not_rtlcn8849 <= NOT rtlcn8849 ;
   rtlcn5878 <= rtlcs102 AND rtlcn8798 ;
   not_rtlcn8806 <= NOT rtlcn8806 ;
   rtlcn9069 <= not_rtlcn8806 AND rtlcn8922 ;
   rtlcn8817 <= rtlcn9043 OR rtlcn9069 ;
   rtlcn5738 <= rtlcn5878 OR rtlcn9070 ;
   rtlcn5822 <= rtlc22n8275 AND rtlc22n8280 ;
   not_rtlc22n8280 <= NOT rtlc22n8280 ;
   rtlcn5823 <= rtlc22n8275 AND not_rtlc22n8280 ;
   rtlcn9072 <= EOM_phase(3) AND SOM_phase_0 ;
   rtlcn8820 <= rtlcn8914 OR rtlcn9072 ;
   rtlcn9076 <= not_mode_command AND rtlcn8826 ;
   rtlcn5837 <= rtlcn5878 OR rtlcn9076 ;
   rtlcn8917 <= rtlcn8812 AND rtlcn8824 ;
   rtlcn9077 <= rtlcs100 AND rtlcn8830 ;
   rtlcn8927 <= rtlcn8917 OR rtlcn9077 ;
   rtlcn5838 <= rtlcn8806 AND rtlcn8927 ;
   rtlcn5877 <= rtlcs102 AND rtlcn5396 ;
   rtlcn5921 <= rtlcn5878 OR rtlcn8861 ;
   rtlcn5932 <= MON_SOM_phase(3) OR not_rtlcn8839 ;
   rtlcn5934 <= rtlcn8879 OR rtlcn8881 ;
   rtlcn5967 <= Do_illegal_EXMPLR916 OR rtlcn9036 ;
   rtlc_13966_and_494 : and_4u_4u port map ( a(3)=>not_Ack, a(2)=>
      not_rtlcs100, a(1)=>rtlcs101, a(0)=>rtlcn8858, d=>rtlcn9079);
   rtlcn9080 <= rtlcs100 AND rtlcs101 ;
   rtlcn8928 <= Ack OR rtlcn9080 ;
   rtlcn9081 <= rtlcn8858 AND rtlcn8928 ;
   rtlcn5982 <= rtlcs101 AND EOM_phase(4) ;
   rtlc_13976_or_498 : or_4u_4u port map ( a(3)=>SOM_phase_6, a(2)=>
      SOM_phase_9, a(1)=>rtlcn8798, a(0)=>rtlcn9083, d=>rtlcn5994);
   rtlcn9084 <= rtlc26n13428 AND rtlcn8831 ;
   rtlcn8853 <= BC_State(0) OR rtlcn9084 ;
   rtlc_13979_or_499 : or_12u_12u port map ( a(11)=>BC_State(4), a(10)=>
      BC_State(9), a(9)=>BC_State(13), a(8)=>BC_State(14), a(7)=>
      BC_State(20), a(6)=>BC_State(49), a(5)=>rtlcn8841, a(4)=>rtlcn8853, 
      a(3)=>rtlcn8865, a(2)=>rtlcn8874, a(1)=>rtlcn8883, a(0)=>rtlcn8885, d
      =>rtlcn6003);
   not_rtlc26n13428 <= NOT rtlc26n13428 ;
   rtlcn9086 <= not_rtlc26n13428 AND rtlcn8831 ;
   rtlcn8892 <= BC_State(45) OR rtlcn9086 ;
   rtlc_13983_or_500 : or_7u_7u port map ( a(6)=>BC_State(2), a(5)=>
      BC_State(7), a(4)=>BC_State(8), a(3)=>BC_State(30), a(2)=>BC_State(38), 
      a(1)=>BC_State(47), a(0)=>rtlcn8892, d=>rtlcn6004);
   rtlc_13984_or_501 : or_5u_5u port map ( a(4)=>BC_State(38), a(3)=>
      BC_State(47), a(2)=>rtlcn8841, a(1)=>rtlcn8853, a(0)=>rtlcn8874, d=>
      rtlcn6013);
   rtlcn6026 <= rtlcn8853 OR rtlcn8905 ;
   not_rtlcn7659 <= NOT rtlcn7659 ;
   rtlcn9092 <= rtlc60n5464 AND not_rtlcn7659 ;
   rtlcn6137 <= not_rtlcn9881 OR rtlcn9092 ;
   not_rtlc60n5595 <= NOT rtlc60n5595 ;
   rtlcn6155 <= rtlc60n5464 AND rtlcn7659 ;
   rtlcn8921 <= BC_State(13) AND rtlc26n14740 ;
   rtlcn9094 <= BC_State(13) AND Ack ;
   not_MON_SOM_phase_3 <= NOT MON_SOM_phase(3) ;
   rtlcn8854 <= not_MON_SOM_phase_3 OR not_Ack ;
   not_rtlc22n10476 <= NOT rtlc22n10476 ;
   not_rtlc22n10248 <= NOT rtlc22n10248 ;
   rtlcn9101 <= not_rtlc22n10248 AND rtlcn8854 ;
   rtlcn6681 <= not_rtlc22n10476 OR rtlcn9101 ;
   rtlcn9105 <= rtlc32n408 AND not_rtlc32n450 ;
   rtlcn8929 <= rtlc60n6648 OR rtlcn9105 ;
   rtlcn7037 <= not_BC_on AND rtlcn8929 ;
   not_WM_On <= NOT WM_On ;
   rtlcn7048 <= not_BC_on AND not_WM_On ;
   rtlcn7049 <= BC_on_EXMPLR883 AND not_WM_On ;
   rtlcn7064 <= MT_On_Async AND rtlc60n6646 ;
   not_rtlc60n6646 <= NOT rtlc60n6646 ;
   rtlcn7067 <= BC_on_EXMPLR883 AND not_rtlc60n6646 ;
   rtlcn9109 <= rtlcn7048 AND not_rtlc60n6646 ;
   rtlcn8855 <= not_CE OR rtlcn9109 ;
   rtlcn7074 <= rtlcn2638 AND rtlcn8855 ;
   rtlcn2170 <= BC_State(6) OR BC_State(13) ;
   rtlcn7081 <= rtlc26n16204 OR rtlcn9114 ;
   rtlcn7082 <= rtlc26n16206 OR rtlcn9115 ;
   rtlcn7141 <= BC_Echo_word(11) AND BC_State(73) ;
   rtlcn7083 <= BC_State(56) OR rtlcn7141 ;
   not_rtlc22n8398 <= NOT rtlc22n8398 ;
   rtlcn9118 <= rtlcs66 AND not_rtlc22n8398 ;
   rtlcn7090 <= rtlc22n10219 OR rtlcn9118 ;
   rtlcn8920 <= rtlcs66 AND rtlc22n8398 ;
   rtlcn9120 <= not_Address_10 AND rtlcn8920 ;
   rtlcn7091 <= rtlcs67 OR rtlcn9120 ;
   not_Phase_1 <= NOT Phase(1) ;
   not_rtlcs66 <= NOT rtlcs66 ;
   rtlcn9123 <= rtlc22n8398 AND Address(10) ;
   rtlcn8930 <= not_rtlcs66 OR rtlcn9123 ;
   rtlcn8146 <= not_rtlc22n10248 AND rtlcn8930 ;
   rtlcn9126 <= rtlc22n10342 AND rtlcs61 ;
   rtlcn7184 <= MON_SOM_phase(6) OR rtlcn9126 ;
   not_Data_Rollover <= NOT Data_Rollover ;
   rtlcn7193 <= EOM_phase(1) AND not_Data_Rollover ;
   rtlcn7194 <= Data_Rollover AND EOM_phase(1) ;
   rtlcn9128 <= BC_State(12) AND rtlcs152 ;
   rtlcn7209 <= BC_State(4) OR rtlcn9128 ;
   not_rtlcs152 <= NOT rtlcs152 ;
   rtlcn7208 <= BC_State(12) AND not_rtlcs152 ;
   not_Config_reg_3_14 <= NOT Config_reg_3_14 ;
   rtlcn9131 <= BC_State(12) AND not_Config_reg_3_14 ;
   rtlcn7228 <= BC_State(4) OR rtlcn9131 ;
   rtlcn7227 <= BC_State(12) AND Config_reg_3_14 ;
   rtlcn9132 <= EOM_phase(1) AND not_rtlc22n10133 ;
   rtlcn7234 <= SOM_phase_5 OR rtlcn9132 ;
   rtlcn9133 <= rtlc22n10068 AND not_rtlc22n10133 ;
   rtlcn7235 <= SOM_phase_9 OR rtlcn9133 ;
   not_rtlcs151 <= NOT rtlcs151 ;
   rtlcn9135 <= BC_State(12) AND not_rtlcs151 ;
   rtlcn7250 <= BC_State(4) OR rtlcn9135 ;
   rtlcn9136 <= not_rtlc26n13617 AND rtlc26n16305 ;
   rtlcn7311 <= rtlc26n16088 OR rtlcn9136 ;
   rtlcn7310 <= rtlc26n16305 AND rtlc26n13617 ;
   not_rtlc26n16088 <= NOT rtlc26n16088 ;
   not_BC_State_18 <= NOT BC_State(18) ;
   rtlcn7345 <= Address(10) AND rtlcn8920 ;
   not_rtlc22n10429 <= NOT rtlc22n10429 ;
   rtlcn8882 <= rtlc22n10342 AND rtlc22n10429 ;
   rtlcn9147 <= MON_SOM_phase(4) AND rtlc22n10429 ;
   rtlcn9148 <= SOM_phase_5 AND rtlcn8909 ;
   rtlcn7362 <= rtlcn9147 OR rtlcn9148 ;
   rtlcn9149 <= MON_SOM_phase(5) AND rtlc22n10429 ;
   rtlcn9150 <= SOM_phase_7 AND rtlcn8909 ;
   rtlcn7363 <= rtlcn9149 OR rtlcn9150 ;
   rtlcn7368 <= not_rtlc26n16200 OR rtlcn9115 ;
   not_BC_msg_pointer_2 <= NOT BC_msg_pointer(2) ;
   not_BC_msg_pointer_3 <= NOT BC_msg_pointer(3) ;
   rtlcn7396 <= not_BC_msg_pointer_2 AND BC_msg_pointer(3) ;
   rtlcn9156 <= BC_State(25) AND rtlc26n13041 ;
   rtlcn9157 <= BC_State(39) AND rtlc26n15067 ;
   rtlcn7480 <= rtlcn9156 OR rtlcn9157 ;
   not_rtlc26n13041 <= NOT rtlc26n13041 ;
   rtlcn9159 <= BC_State(25) AND not_rtlc26n13041 ;
   not_rtlc26n15067 <= NOT rtlc26n15067 ;
   rtlcn9161 <= BC_State(39) AND not_rtlc26n15067 ;
   rtlcn7481 <= rtlcn9159 OR rtlcn9161 ;
   rtlcn9164 <= EOM_phase(0) AND rtlc22n7690 ;
   not_rtlc22n7690 <= NOT rtlc22n7690 ;
   rtlcn9166 <= EOM_phase(0) AND not_rtlc22n7690 ;
   rtlcn7957 <= rtlcn9166 OR rtlcn9167 ;
   rtlcn9172 <= Current_Area_B AND rtlcn8817 ;
   rtlcn9173 <= not_rtlcn8849 AND rtlcn8917 ;
   rtlcn9174 <= rtlcs102 AND rtlcn8933 ;
   rtlcn8390 <= rtlcn9173 OR rtlcn9174 ;
   rtlcn8386 <= rtlcn5392 AND rtlcs102 ;
   rtlcn5730 <= rtlcn8806 AND rtlcn8922 ;
   rtlcn8915 <= rtlcn8799 AND rtlcn8806 ;
   rtlcn9182 <= Current_Area_B AND rtlcn8915 ;
   rtlcn8405 <= rtlcn9182 OR rtlcn9183 ;
   rtlc_14168_or_515 : or_4u_4u port map ( a(3)=>Do_illegal_EXMPLR916, a(2)
      =>rtlcn5730, a(1)=>rtlcn8798, a(0)=>rtlcn8915, d=>rtlcn8412);
   not_rtlc60n5359 <= NOT rtlc60n5359 ;
   rtlcn8418 <= not_rtlc60n5359 AND rtlc60n5324 ;
   rtlc_14180_and_516 : and_5u_5u port map ( a(4)=>not_rtlc60n6648, a(3)=>
      not_rtlc32n408, a(2)=>not_rtlc32n450, a(1)=>rtlcn7048, a(0)=>
      not_rtlc60n6633, d=>rtlcn9190);
   rtlcn8822 <= not_CE OR rtlcn9190 ;
   not_rtlc60n6494 <= NOT rtlc60n6494 ;
   not_BC_Message_Active <= NOT BC_Message_Active ;
   not_rtlc26n13657 <= NOT rtlc26n13657 ;
   not_rtlc26n18663 <= NOT rtlc26n18663 ;
   not_rtlc26n16783 <= NOT rtlc26n16783 ;
   not_ResetN <= NOT ResetN_EXMPLR925 ;
   not_rtlc60n7254 <= NOT rtlc60n7254 ;
   not_Raw_resetN <= NOT Raw_resetN ;
   not_HW_ResetN <= NOT HW_ResetN ;
   rtlcn2058 <= Config_reg_3_12 OR Config_reg_3_11 ;
   rtlcn8910 <= WM_On AND state(3) ;
   rtlcn8916 <= not_Ack AND WM_On ;
   rtlcn9199 <= state(4) AND rtlcn8916 ;
   not_rtlc87n431 <= NOT rtlc87n431 ;
   not_WM_Ack <= NOT WM_Ack_EXMPLR926 ;
   rtlc_14220_and_519 : and_4u_4u port map ( a(3)=>not_rtlc87n431, a(2)=>
      WM_Req, a(1)=>not_WM_Ack, a(0)=>rtlcn8910, d=>rtlcn9202);
   rtlcn2637 <= rtlcn9199 OR rtlcn9202 ;
   not_state_6 <= NOT state(6) ;
   rtlcn8821 <= not_state_6 OR rtlc87n522 ;
   rtlcn8870 <= rtlc87n403 OR rtlcn8834 ;
   not_rtlcn8821 <= NOT rtlcn8821 ;
   rtlcn9205 <= state(2) AND rtlcn8870 ;
   not_rtlc87n440 <= NOT rtlc87n440 ;
   rtlcn9207 <= not_rtlc87n440 AND rtlcn8910 ;
   rtlcn9208 <= WM_On AND rtlcn8935 ;
   rtlcn2667 <= rtlcn9207 OR rtlcn9208 ;
   rtlcn2673 <= rtlc87n431 AND rtlcn8910 ;
   rtlcn9209 <= state(5) AND rtlcn8916 ;
   rtlcn2698 <= rtlcn9209 OR rtlcn9210 ;
   not_rtlcn8870 <= NOT rtlcn8870 ;
   rtlcn9212 <= state(2) AND not_rtlcn8870 ;
   rtlcn8936 <= rtlcn2624 OR rtlcn9212 ;
   rtlcn2713 <= WM_On AND rtlcn8936 ;
   rtlcn9213 <= state(7) AND rtlcn8916 ;
   rtlcn2724 <= rtlcn9213 OR rtlcn9214 ;
   not_BC_START <= NOT BC_START ;
   rtlcn9216 <= not_BC_START AND state(1) ;
   rtlcn8937 <= state(0) OR rtlcn9216 ;
   rtlcn2733 <= WM_On AND rtlcn8937 ;
   rtlcn9217 <= state(6) AND rtlc87n522 ;
   rtlcn2741 <= not_WM_On OR rtlcn9217 ;
   rtlcn2768 <= CPU_Data_in_wide(17) AND rtlcn2772 ;
   not_rtlc26n14491 <= NOT rtlc26n14491 ;
   rtlcn2797 <= rtlcn9218 OR rtlcn9220 ;
   not_rtlc26n12464 <= NOT rtlc26n12464 ;
   not_rtlc26n13005 <= NOT rtlc26n13005 ;
   rtlcn8938 <= rtlcn9222 OR rtlcn9224 ;
   rtlcn2816 <= not_rtlc26n15497 AND rtlcn8938 ;
   rtlcn8911 <= not_rtlc26n15497 AND BC_State(81) ;
   rtlcn9225 <= rtlc26n12464 AND BC_State(1) ;
   rtlcn9226 <= BC_State(31) AND rtlc26n13144 ;
   rtlcn9227 <= BC_State(7) AND rtlc26n14530 ;
   not_rtlc26n12419 <= NOT rtlc26n12419 ;
   not_rtlc26n12441 <= NOT rtlc26n12441 ;
   not_rtlc26n12428 <= NOT rtlc26n12428 ;
   rtlc_14270_and_527 : and_4u_4u port map ( a(3)=>BC_State(0), a(2)=>
      not_rtlc26n12419, a(1)=>not_rtlc26n12441, a(0)=>not_rtlc26n12428, d=>
      rtlcn9231);
   rtlc_14271_or_528 : or_4u_4u port map ( a(3)=>rtlcn9225, a(2)=>rtlcn9226, 
      a(1)=>rtlcn9227, a(0)=>rtlcn9231, d=>rtlcn8939);
   rtlcn9232 <= rtlc26n14300 AND rtlcn8911 ;
   rtlcn9233 <= not_rtlc26n15497 AND rtlcn8939 ;
   rtlcn2861 <= rtlcn9232 OR rtlcn9233 ;
   rtlcn8811 <= Ack AND not_rtlc26n15497 ;
   rtlcn9234 <= rtlcn8811 AND rtlcn8865 ;
   not_rtlc26n14530 <= NOT rtlc26n14530 ;
   rtlcn9238 <= BC_State(5) AND rtlcn8809 ;
   rtlcn9239 <= BC_State(3) AND rtlcn8811 ;
   rtlcn2889 <= rtlcn9238 OR rtlcn9239 ;
   rtlcn9240 <= BC_State(3) AND rtlcn8809 ;
   rtlcn2900 <= rtlcn9240 OR rtlcn9242 ;
   rtlcn9243 <= BC_State(6) AND rtlcn8809 ;
   rtlcn9244 <= BC_State(4) AND rtlcn8811 ;
   rtlcn2915 <= rtlcn9243 OR rtlcn9244 ;
   rtlcn9245 <= BC_State(4) AND rtlcn8809 ;
   rtlcn9246 <= BC_State(30) AND rtlcn8811 ;
   rtlcn2926 <= rtlcn9245 OR rtlcn9246 ;
   rtlcn9247 <= BC_State(30) AND rtlcn8809 ;
   rtlcn2941 <= rtlcn9247 OR rtlcn9248 ;
   not_rtlc26n13236 <= NOT rtlc26n13236 ;
   rtlcn8801 <= not_rtlc26n13236 AND BC_State(35) ;
   not_BC_State_32 <= NOT BC_State(32) ;
   rtlcn8803 <= not_BC_State_32 OR not_eBC ;
   not_BC_State_57 <= NOT BC_State(57) ;
   rtlcn8804 <= rtlc26n15208 OR not_BC_State_57 ;
   not_BC_State_63 <= NOT BC_State(63) ;
   rtlcn8810 <= rtlc26n13923 OR not_BC_State_63 ;
   not_BC_State_31 <= NOT BC_State(31) ;
   not_rtlc26n13151 <= NOT rtlc26n13151 ;
   not_rtlc26n13144 <= NOT rtlc26n13144 ;
   rtlcn9257 <= not_rtlc26n13151 AND not_rtlc26n13144 ;
   rtlcn8815 <= not_BC_State_31 OR rtlcn9257 ;
   not_BC_State_0 <= NOT BC_State(0) ;
   rtlcn9259 <= not_rtlc26n12419 AND rtlc26n12428 ;
   rtlcn8828 <= not_BC_State_0 OR rtlcn9259 ;
   not_rtlc26n15271 <= NOT rtlc26n15271 ;
   rtlcn8912 <= BC_State(59) AND not_rtlc26n15271 ;
   not_rtlcn8801 <= NOT rtlcn8801 ;
   not_rtlcn8912 <= NOT rtlcn8912 ;
   rtlc_14319_and_534 : and_8u_8u port map ( a(7)=>rtlc26n16656, a(6)=>
      not_rtlcn8801, a(5)=>rtlcn8803, a(4)=>rtlcn8804, a(3)=>rtlcn8810, a(2)
      =>rtlcn8815, a(1)=>rtlcn8828, a(0)=>not_rtlcn8912, d=>rtlcn9264);
   rtlcn2973 <= rtlc26n15497 OR rtlcn9264 ;
   not_rtlcn8803 <= NOT rtlcn8803 ;
   rtlcn8940 <= BC_State(33) OR rtlcn8801 ;
   rtlcn9267 <= BC_State(58) AND rtlcn8811 ;
   rtlcn9268 <= not_rtlc26n15497 AND rtlcn8940 ;
   not_rtlc26n15015 <= NOT rtlc26n15015 ;
   rtlcn8862 <= BC_State(82) AND not_rtlc26n15497 ;
   not_rtlcn8804 <= NOT rtlcn8804 ;
   rtlc_14335_or_537 : or_8u_8u port map ( a(7)=>BC_State(61), a(6)=>
      BC_State(63), a(5)=>BC_State(64), a(4)=>BC_State(67), a(3)=>
      BC_State(70), a(2)=>BC_State(72), a(1)=>rtlcn8912, a(0)=>not_rtlcn8804, 
      d=>rtlcn8943);
   not_BC_State_52 <= NOT BC_State(52) ;
   rtlcn8827 <= not_BC_State_52 OR rtlc26n15172 ;
   rtlcn9274 <= rtlc26n13194 AND BC_State(34) ;
   rtlcn9276 <= Ext_Trigger_Dx_0n0s4 AND BC_State(91) ;
   rtlcn9277 <= rtlc26n14017 AND BC_State(68) ;
   rtlcn9278 <= rtlc26n14265 AND BC_State(78) ;
   not_rtlcn8827 <= NOT rtlcn8827 ;
   rtlcn9280 <= rtlc26n15184 AND not_rtlcn8827 ;
   rtlc_14345_or_538 : or_7u_7u port map ( a(6)=>BC_State(60), a(5)=>
      rtlcn9274, a(4)=>rtlcn9275, a(3)=>rtlcn9276, a(2)=>rtlcn9277, a(1)=>
      rtlcn9278, a(0)=>rtlcn9280, d=>rtlcn8942);
   rtlc_14346_or_539 : or_6u_6u port map ( a(5)=>BC_State(56), a(4)=>
      BC_State(62), a(3)=>BC_State(73), a(2)=>BC_State(84), a(1)=>
      rtlc26n16362, a(0)=>rtlcn8906, d=>rtlcn8941);
   not_rtlc26n14359 <= NOT rtlc26n14359 ;
   rtlcn9282 <= not_rtlc26n14359 AND rtlcn8862 ;
   rtlcn9284 <= not_rtlc26n15497 AND rtlcn8942 ;
   rtlcn9285 <= rtlcn8811 AND rtlcn8941 ;
   rtlc_14352_or_540 : or_4u_4u port map ( a(3)=>rtlcn9282, a(2)=>rtlcn9283, 
      a(1)=>rtlcn9284, a(0)=>rtlcn9285, d=>rtlcn3036);
   rtlcn3048 <= not_rtlc26n15497 AND not_rtlcn9888 ;
   rtlcn8919 <= BC_State(42) AND not_rtlcn9889 ;
   not_BC_Read <= NOT BC_Read ;
   rtlcn8918 <= BC_Message_Active AND not_BC_Read ;
   rtlcn8945 <= BC_State(44) OR BC_State(50) ;
   rtlcn9288 <= BC_State(41) AND not_BC_Read ;
   rtlcn9289 <= BC_Message_Active AND BC_State(46) ;
   rtlcn8944 <= rtlcn9288 OR rtlcn9289 ;
   rtlcn9290 <= rtlcn8918 AND rtlcn8919 ;
   rtlcn9291 <= not_rtlcn9889 AND rtlcn8945 ;
   rtlcn9292 <= not_rtlc26n15497 AND rtlcn8944 ;
   rtlcn9293 <= BC_State(41) AND BC_Read ;
   rtlcn8946 <= BC_State(40) OR rtlcn9293 ;
   rtlcn3107 <= not_rtlc26n15497 AND rtlcn8946 ;
   rtlcn9294 <= BC_State(39) AND rtlcn8809 ;
   rtlcn9295 <= BC_Read AND rtlcn8919 ;
   rtlcn3126 <= rtlcn9294 OR rtlcn9295 ;
   rtlcn8877 <= not_rtlc26n15497 AND BC_Write ;
   rtlcn9296 <= BC_State(43) AND rtlcn8811 ;
   rtlcn9297 <= BC_State(44) AND rtlcn8877 ;
   rtlcn3137 <= rtlcn9296 OR rtlcn9297 ;
   rtlcn9298 <= BC_State(43) AND rtlcn8809 ;
   rtlcn3148 <= rtlcn9298 OR rtlcn9299 ;
   rtlcn9300 <= BC_State(48) AND rtlcn8811 ;
   rtlcn3159 <= rtlcn9300 OR rtlcn9302 ;
   rtlcn9303 <= BC_State(48) AND rtlcn8809 ;
   rtlcn9304 <= BC_State(49) AND rtlcn8811 ;
   rtlcn3170 <= rtlcn9303 OR rtlcn9304 ;
   rtlcn9305 <= BC_State(49) AND rtlcn8809 ;
   rtlcn9306 <= BC_State(38) AND rtlcn8811 ;
   rtlcn3181 <= rtlcn9305 OR rtlcn9306 ;
   rtlcn9307 <= BC_State(38) AND rtlcn8809 ;
   rtlcn9308 <= BC_State(47) AND rtlcn8811 ;
   rtlcn3192 <= rtlcn9307 OR rtlcn9308 ;
   rtlcn9309 <= BC_State(47) AND rtlcn8809 ;
   rtlcn9310 <= BC_State(37) AND rtlcn8811 ;
   rtlcn3203 <= rtlcn9309 OR rtlcn9310 ;
   rtlcn9311 <= BC_State(37) AND rtlcn8809 ;
   rtlcn9312 <= BC_State(36) AND rtlcn8811 ;
   rtlcn3214 <= rtlcn9311 OR rtlcn9312 ;
   not_rtlc26n13194 <= NOT rtlc26n13194 ;
   rtlcn9314 <= not_rtlc26n13194 AND BC_State(34) ;
   rtlcn8947 <= BC_State(51) OR rtlcn9314 ;
   rtlcn9315 <= BC_State(36) AND rtlcn8809 ;
   rtlcn9316 <= not_rtlc26n15497 AND rtlcn8947 ;
   rtlcn3225 <= rtlcn9315 OR rtlcn9316 ;
   rtlcn9317 <= BC_State(10) AND rtlcn8809 ;
   rtlcn9318 <= BC_State(9) AND rtlcn8811 ;
   rtlcn3244 <= rtlcn9317 OR rtlcn9318 ;
   not_BC_State_8 <= NOT BC_State(8) ;
   rtlcn8819 <= not_BC_State_8 OR rtlc26n14562 ;
   rtlcn9320 <= BC_State(9) AND rtlcn8809 ;
   not_rtlc26n14584 <= NOT rtlc26n14584 ;
   not_rtlcn8819 <= NOT rtlcn8819 ;
   rtlcn3263 <= rtlcn9320 OR rtlcn9323 ;
   rtlcn3286 <= rtlcn9324 OR rtlcn9325 ;
   rtlcn8860 <= not_rtlc26n15497 AND BC_State(11) ;
   not_rtlc26n12614 <= NOT rtlc26n12614 ;
   rtlcn3308 <= not_rtlc26n12614 AND rtlcn8860 ;
   rtlcn8949 <= BC_State(17) OR BC_State(28) ;
   rtlcn9327 <= BC_State(26) AND not_BC_Read ;
   rtlcn9328 <= BC_Message_Active AND BC_State(27) ;
   rtlcn8948 <= rtlcn9327 OR rtlcn9328 ;
   rtlcn9329 <= not_rtlcn9889 AND rtlcn8949 ;
   rtlcn9330 <= not_rtlc26n15497 AND rtlcn8948 ;
   not_rtlc26n13393 <= NOT rtlc26n13393 ;
   rtlcn9333 <= BC_State(17) AND rtlcn8877 ;
   rtlcn3358 <= rtlcn9333 OR rtlcn9334 ;
   not_rtlc26n12839 <= NOT rtlc26n12839 ;
   rtlcn3390 <= rtlcn9335 OR rtlcn9337 ;
   rtlcn9338 <= rtlc26n12614 AND rtlcn8860 ;
   rtlcn3405 <= rtlcn9338 OR rtlcn9339 ;
   rtlcn9340 <= BC_State(25) AND rtlcn8811 ;
   rtlcn3416 <= rtlcn9340 OR rtlcn9341 ;
   rtlcn9342 <= BC_State(15) AND not_rtlc26n15497 ;
   rtlcn9343 <= BC_State(25) AND rtlcn8809 ;
   rtlcn3425 <= rtlcn9342 OR rtlcn9343 ;
   rtlcn9344 <= BC_State(14) AND rtlcn8811 ;
   rtlcn3436 <= rtlcn9344 OR rtlcn9345 ;
   rtlcn9346 <= BC_State(14) AND rtlcn8809 ;
   rtlcn9347 <= BC_State(10) AND rtlcn8811 ;
   rtlcn3447 <= rtlcn9346 OR rtlcn9347 ;
   rtlcn9348 <= BC_State(19) AND rtlcn8811 ;
   rtlcn9349 <= BC_State(28) AND rtlcn8877 ;
   rtlcn3458 <= rtlcn9348 OR rtlcn9349 ;
   rtlcn9350 <= BC_State(19) AND rtlcn8809 ;
   not_BC_First_write <= NOT BC_First_write ;
   rtlcn3469 <= rtlcn9350 OR rtlcn9352 ;
   not_rtlc26n14300 <= NOT rtlc26n14300 ;
   rtlc_14465_and_558 : and_4u_4u port map ( a(3)=>BC_State(0), a(2)=>
      not_rtlc26n12419, a(1)=>rtlc26n12441, a(0)=>not_rtlc26n12428, d=>
      rtlcn9354);
   rtlcn8950 <= BC_State(80) OR rtlcn9354 ;
   rtlcn9355 <= not_rtlc26n15497 AND rtlcn8950 ;
   not_Clear_Test_Status_reg <= NOT Clear_Test_Status_reg ;
   rtlcn3504 <= rtlcn9355 OR rtlcn9357 ;
   rtlcn3516 <= not_CE OR not_rtlc60n6002 ;
   rtlcn9359 <= BC_State(12) AND rtlcn8811 ;
   not_rtlc26n14740 <= NOT rtlc26n14740 ;
   rtlcn3537 <= rtlcn9359 OR rtlcn9361 ;
   rtlcn3547 <= not_CE OR not_rtlc60n5987 ;
   rtlcn9363 <= rtlc26n13236 AND BC_State(35) ;
   rtlcn3553 <= rtlcn8921 OR rtlcn9363 ;
   not_BC_State_24 <= NOT BC_State(24) ;
   rtlcn8868 <= not_BC_State_24 OR not_rtlcn9890 ;
   rtlc_14486_and_561 : and_4u_4u port map ( a(3)=>not_rtlc26n15497, a(2)=>
      rtlc26n15915, a(1)=>rtlcn8819, a(0)=>rtlcn8868, d=>rtlcn3568);
   rtlcn3579 <= Ack AND BC_State(71) ;
   rtlcn8833 <= not_rtlc26n15497 AND YES ;
   rtlcn9368 <= BC_State(71) AND rtlcn8809 ;
   rtlcn9369 <= BC_State(70) AND rtlcn8833 ;
   rtlcn3591 <= rtlcn9368 OR rtlcn9369 ;
   rtlcn9370 <= BC_State(62) AND rtlcn8809 ;
   rtlcn9371 <= BC_State(61) AND rtlcn8833 ;
   rtlcn3616 <= rtlcn9370 OR rtlcn9371 ;
   not_rtlc26n15369 <= NOT rtlc26n15369 ;
   not_rtlc26n14110 <= NOT rtlc26n14110 ;
   rtlcn3640 <= rtlcn9373 OR rtlcn9375 ;
   rtlcn9376 <= BC_State(75) AND rtlcn8809 ;
   rtlcn3668 <= rtlcn9376 OR rtlcn9377 ;
   rtlcn9378 <= not_rtlc26n15497 AND BC_State(69) ;
   rtlcn9379 <= BC_State(79) AND rtlcn8809 ;
   rtlcn3677 <= rtlcn9378 OR rtlcn9379 ;
   rtlcn9380 <= BC_State(88) AND rtlcn8809 ;
   rtlcn9381 <= rtlcs108 AND rtlcn8862 ;
   rtlcn3704 <= rtlcn9380 OR rtlcn9381 ;
   rtlcn3720 <= rtlc26_PS699_n15006 AND rtlcn3048 ;
   rtlcn3724 <= not_rtlc26n15497 AND BC_State(89) ;
   rtlcn3736 <= rtlcn8833 AND rtlcn8912 ;
   rtlcn9382 <= BC_State(86) AND rtlcn8809 ;
   rtlcn9383 <= rtlcs114 AND rtlcn8862 ;
   rtlcn3758 <= rtlcn9382 OR rtlcn9383 ;
   rtlcn9384 <= BC_State(58) AND rtlcn8809 ;
   rtlcn9385 <= not_rtlcn8804 AND rtlcn8833 ;
   rtlcn3773 <= rtlcn9384 OR rtlcn9385 ;
   rtlcn9386 <= BC_State(87) AND rtlcn8809 ;
   rtlcn9387 <= rtlcs105 AND rtlcn8862 ;
   rtlcn3837 <= rtlcn9386 OR rtlcn9387 ;
   rtlcn9388 <= BC_State(83) AND rtlcn8809 ;
   rtlcn9389 <= rtlcs110 AND rtlcn8862 ;
   rtlcn3849 <= rtlcn9388 OR rtlcn9389 ;
   rtlcn3857 <= CE AND eBC_GP_do ;
   rtlcn3860 <= Ack AND BC_State(62) ;
   rtlcn9390 <= BC_State(65) AND rtlcn8809 ;
   rtlcn9391 <= BC_State(64) AND rtlcn8833 ;
   rtlcn3961 <= rtlcn9390 OR rtlcn9391 ;
   rtlcn9392 <= BC_State(45) AND rtlcn8811 ;
   rtlcn9393 <= BC_State(50) AND rtlcn8877 ;
   rtlcn4001 <= rtlcn9392 OR rtlcn9393 ;
   rtlcn9394 <= BC_State(45) AND rtlcn8809 ;
   not_rtlc26n13384 <= NOT rtlc26n13384 ;
   rtlc_14543_and_567 : and_4u_4u port map ( a(3)=>not_rtlc26n15497, a(2)=>
      BC_State(42), a(1)=>not_rtlc26n13384, a(0)=>rtlc26n13393, d=>rtlcn9396
   );
   rtlcn4016 <= rtlcn9394 OR rtlcn9396 ;
   rtlcn8900 <= rtlcn8809 OR not_rtlcn9891 ;
   rtlcn9400 <= BC_State(67) AND rtlcn8833 ;
   not_rtlc26n14017 <= NOT rtlc26n14017 ;
   rtlcn4042 <= rtlcn9400 OR rtlcn9402 ;
   rtlcn9403 <= BC_State(72) AND rtlc26n14110 ;
   rtlcn9404 <= BC_State(74) AND rtlc26n15369 ;
   rtlcn8951 <= rtlcn9403 OR rtlcn9404 ;
   rtlcn9405 <= BC_State(73) AND rtlcn8809 ;
   rtlcn9406 <= BC_State(75) AND rtlcn8811 ;
   rtlcn9407 <= not_rtlc26n15497 AND rtlcn8951 ;
   not_rtlc26n14265 <= NOT rtlc26n14265 ;
   rtlcn9409 <= not_rtlc26n14265 AND BC_State(78) ;
   rtlcn8952 <= BC_State(66) OR rtlcn9409 ;
   rtlcn4066 <= not_rtlc26n15497 AND rtlcn8952 ;
   rtlcn9410 <= not_rtlc26n15497 AND BC_State(85) ;
   rtlcn9411 <= BC_State(84) AND rtlcn8809 ;
   rtlcn4079 <= rtlcn9410 OR rtlcn9411 ;
   not_rtlcn8810 <= NOT rtlcn8810 ;
   rtlcn9413 <= not_rtlcn8810 AND rtlcn8833 ;
   not_Ext_Trigger_Dx_0n0s4 <= NOT Ext_Trigger_Dx_0n0s4 ;
   rtlcn4099 <= rtlcn9413 OR rtlcn9415 ;
   not_rtlc26n15182 <= NOT rtlc26n15182 ;
   rtlcn9417 <= not_rtlc26n15182 AND BC_State(23) ;
   rtlcn8953 <= BC_State(22) OR rtlcn9417 ;
   rtlcn9418 <= not_rtlc26n15497 AND rtlcn8953 ;
   rtlcn4142 <= rtlcn9418 OR rtlcn9419 ;
   not_rtlc87n616 <= NOT rtlc87n616 ;
   rtlcn4145 <= WM_On AND not_rtlc87n616 ;
   rtlcn4159 <= CE AND eBC_Inc_Q_pointer ;
   rtlcn4187 <= not_rtlc22n8275 AND rtlc22n9096 ;
   not_Arbiter_timeout <= NOT Arbiter_timeout ;
   not_rtlc32n759 <= NOT rtlc32n759 ;
   rtlcn4218 <= arbiter AND not_rtlc32n759 ;
   rtlcn4244 <= not_arbiter AND WRD_req ;
   not_rtlcn4253 <= NOT rtlcn4253 ;
   rtlcn8823 <= EOM_req OR WRD_req ;
   rtlcn8829 <= arbiter OR rtlcn8823 ;
   not_rtlcn8829 <= NOT rtlcn8829 ;
   rtlcn4265 <= SOM_req AND not_rtlcn8829 ;
   not_rtlcn4265 <= NOT rtlcn4265 ;
   rtlcn8844 <= MON_WR_req OR SOM_req ;
   not_rtlcn8844 <= NOT rtlcn8844 ;
   not_rtlcn4315 <= NOT rtlcn4315 ;
   rtlcn8871 <= MON_EOM_req OR rtlcn8844 ;
   rtlcn8651 <= rtlc22_PS506_n8983 OR rtlc22n10476 ;
   rtlcn4450 <= not_Arbiter_timeout AND not_rtlcn8839 ;
   rtlcn4454 <= MON_SOM_phase(1) AND not_Arbiter_timeout ;
   rtlcn4457 <= MON_SOM_phase(0) AND not_Arbiter_timeout ;
   rtlcn4471 <= MON_SOM_phase(6) AND not_Arbiter_timeout ;
   rtlcn4475 <= MON_SOM_phase(5) AND not_Arbiter_timeout ;
   rtlcn4479 <= MON_SOM_phase(4) AND not_Arbiter_timeout ;
   rtlcn4483 <= MON_SOM_phase(3) AND not_Arbiter_timeout ;
   rtlcn4506 <= not_MON_SOM_phase_2 AND Record_enable ;
   rtlcn8652 <= rtlc22n10476 OR rtlc22n10405 ;
   rtlcn8653 <= rtlc22n10476 OR rtlc22n10407 ;
   rtlcn4522 <= rtlc22n10476 OR not_rtlc22n10408 ;
   rtlcn4524 <= not_rtlc22n10476 AND rtlc22n10410 ;
   rtlcn4528 <= not_rtlc22n10476 AND rtlcs57 ;
   rtlcn4557 <= SOM_phase_0 AND not_Arbiter_timeout ;
   rtlcn8645 <= Arbiter_timeout OR SOM_phase_9 ;
   rtlcn4566 <= SOM_phase_8 AND not_Arbiter_timeout ;
   rtlcn4570 <= SOM_phase_7 AND not_Arbiter_timeout ;
   rtlcn4574 <= SOM_phase_6 AND not_Arbiter_timeout ;
   rtlcn4578 <= SOM_phase_5 AND not_Arbiter_timeout ;
   rtlcn4582 <= SOM_phase_4 AND not_Arbiter_timeout ;
   rtlcn4586 <= SOM_phase_3 AND not_Arbiter_timeout ;
   rtlcn4590 <= Do_illegal_EXMPLR916 AND not_Arbiter_timeout ;
   rtlcn4594 <= SOM_phase_1 AND not_Arbiter_timeout ;
   rtlcn9435 <= EOM_phase(0) AND illegal_message_EXMPLR939 ;
   rtlcn4619 <= EOM_phase(3) AND not_Arbiter_timeout ;
   rtlcn4623 <= EOM_phase(2) AND not_Arbiter_timeout ;
   rtlcn4627 <= EOM_phase(1) AND not_Arbiter_timeout ;
   rtlcn5178 <= not_rtlc22n10248 AND not_rtlc22n8108 ;
   rtlcn8837 <= rtlc22n8108 OR rtlc22n8131 ;
   rtlcn8902 <= rtlc22n10248 OR rtlcn8837 ;
   not_rtlcn8902 <= NOT rtlcn8902 ;
   rtlcn5238 <= not_rtlc22n8155 AND not_rtlcn8902 ;
   rtlc_14669_or_582 : or_5u_5u port map ( a(4)=>rtlcn8875, a(3)=>rtlcs69, 
      a(2)=>rtlcs82, a(1)=>rtlcs85, a(0)=>rtlcs98, d=>rtlcn8668);
   rtlcn5529 <= Ack AND SOM_phase_3 ;
   rtlcn8954 <= rtlc26n14584 OR rtlc26n14562 ;
   rtlcn5635 <= BC_State(8) AND rtlcn8954 ;
   rtlcn6074 <= rtlc60n6494 AND rtlcs270 ;
   not_rtlc60n6476 <= NOT rtlc60n6476 ;
   rtlcn6078 <= not_rtlc60n6476 AND Read_from_int_vec ;
   rtlcn6091 <= Ack AND EOM_phase(1) ;
   not_rtlc22n8782 <= NOT rtlc22n8782 ;
   rtlcn6104 <= rtlcs62 AND not_rtlc22n8782 ;
   rtlcn6142 <= rtlc60n6494 AND rtlc60n5579 ;
   rtlcn6188 <= rtlcn9444 OR rtlcn9445 ;
   rtlcn6376 <= CPU_Data_in_wide(20) AND rtlcn2772 ;
   not_state_2 <= NOT state(2) ;
   not_rtlcn8901 <= NOT rtlcn8901 ;
   rtlcn8869 <= not_state_2 OR not_rtlcn8901 ;
   rtlc_14696_and_585 : and_4u_4u port map ( a(3)=>WM_On, a(2)=>rtlc87n646, 
      a(1)=>rtlcn8821, a(0)=>rtlcn8869, d=>rtlcn6662);
   rtlcn6683 <= rtlc60n6494 AND rtlcs246 ;
   Test_Status_reg_84n7ss1(0) <= Do_RAM_test AND rtlcs311 ;
   rtlcn6690 <= BC_msg_pointer(0) AND eBC_IRQ_do ;
   rtlcn8681 <= rtlcn6690 OR BIT_Test_complete ;
   not_rtlc60n6509 <= NOT rtlc60n6509 ;
   rtlcn6702 <= not_rtlc60n6509 AND Read_from_int_vec2 ;
   rtlcn6744 <= eBC_IRQ_do AND BC_msg_pointer(1) ;
   rtlcn6769 <= eBC_IRQ_do AND BC_msg_pointer(2) ;
   rtlcn6794 <= eBC_IRQ_do AND BC_msg_pointer(3) ;
   not_Config_reg_2_3 <= NOT Config_reg_2(3) ;
   rtlcn9456 <= not_Config_reg_2_3 AND rtlc29n526 ;
   rtlcn6997 <= not_rtlcn9898 OR rtlcn9456 ;
   not_rtlc87n790 <= NOT rtlc87n790 ;
   rtlcn7050 <= WM_On AND not_rtlc87n790 ;
   not_rtlc29n681 <= NOT rtlc29n681 ;
   rtlc_14718_or_587 : or_6u_6u port map ( a(5)=>Config_reg_2(3), a(4)=>
      rtlc29n464, a(3)=>rtlc29n472, a(2)=>rtlc29n518, a(1)=>not_rtlc29n681, 
      a(0)=>rtlcs157, d=>rtlcn8685);
   rtlcn7404 <= not_Ack AND rtlc26n18670 ;
   not_rtlc22n8022 <= NOT rtlc22n8022 ;
   rtlcn9461 <= SOM_phase_8 AND not_rtlc22n8022 ;
   rtlcn9462 <= rtlcs67 AND Read ;
   rtlcn9463 <= SOM_phase_1 AND illegalization_enable ;
   rtlcn9464 <= Do_illegal_EXMPLR916 AND rtlc22n7839 ;
   rtlcn7443 <= rtlcn9887 OR rtlc60n5353 ;
   rtlcn7451 <= not_Ack AND rtlc26n18672 ;
   rtlcn9468 <= not_rtlc22n10429 AND rtlc22n8856 ;
   not_rtlc22n10342 <= NOT rtlc22n10342 ;
   rtlcn7465 <= rtlcn9468 OR rtlcn9470 ;
   rtlcn7581 <= CE AND rtlc60n6587 ;
   not_rtlc60n5942 <= NOT rtlc60n5942 ;
   rtlcn7585 <= not_rtlc60n5942 AND RT_On_EXMPLR924 ;
   rtlcn7632 <= CPU_Data_in_wide(18) AND rtlcn2772 ;
   rtlc_14755_and_590 : and_4u_4u port map ( a(3)=>not_rtlc26n15497, a(2)=>
      BC_State(31), a(1)=>rtlc26n13151, a(0)=>not_rtlc26n13144, d=>rtlcn8254
   );
   rtlcn8277 <= not_arbiter AND rtlcn8957 ;
   rtlcn8867 <= Ack OR not_Record_enable ;
   rtlcn8958 <= rtlcs65 OR rtlcn8867 ;
   rtlcn9475 <= rtlcs65 AND rtlc22n10298 ;
   not_rtlc22n10298 <= NOT rtlc22n10298 ;
   rtlcn9480 <= not_rtlc22n10298 AND rtlcn8958 ;
   not_rtlcn8871 <= NOT rtlcn8871 ;
   rtlcn8846 <= rtlc22n8155 OR rtlc22n8177 ;
   not_rtlcn8837 <= NOT rtlcn8837 ;
   rtlcn8295 <= rtlc22n10248 OR not_rtlcn9900 ;
   not_rtlcn5178 <= NOT rtlcn5178 ;
   rtlcn8351 <= not_rtlcn5178 OR not_rtlcn9899 ;
   rtlcn8358 <= rtlcn8872 AND not_rtlcn8902 ;
   rtlcn8366 <= rtlcn5238 AND rtlcn8959 ;
   not_rtlcn8840 <= NOT rtlcn8840 ;
   rtlcn8379 <= rtlcn8669 OR not_rtlcn9901 ;
   rtlc_14791_or_594 : or_4u_4u port map ( a(3)=>not_rtlc22n8243, a(2)=>
      rtlcn8907, a(1)=>rtlcs70, a(0)=>rtlcs86, d=>rtlcn8383);
   rtlcn8897 <= not_rtlc60n5464 OR CPU_Data_in_wide(19) ;
   rtlcn9493 <= CPU_Data_in_wide(19) AND rtlcn2772 ;
   rtlcn9496 <= rtlc22n8155 AND rtlc22n8161 ;
   not_rtlcn8846 <= NOT rtlcn8846 ;
   rtlcn9500 <= rtlc22n8108 AND rtlc22n8113 ;
   rtlcn9501 <= not_rtlcn8837 AND rtlcn8961 ;
   rtlc_14808_or_601 : or_4u_4u port map ( a(3)=>rtlc22n10248, a(2)=>
      rtlcn9500, a(1)=>rtlcn9501, a(0)=>rtlcn9502, d=>rtlcn8802);
   not_rtlc22n8227 <= NOT rtlc22n8227 ;
   rtlcn9504 <= rtlc22n8221 AND not_rtlc22n8227 ;
   not_rtlc22n8249 <= NOT rtlc22n8249 ;
   rtlcn8825 <= rtlcn9504 OR rtlcn9507 ;
   not_rtlcn8802 <= NOT rtlcn8802 ;
   rtlcn9509 <= rtlcn8669 AND not_rtlcn8802 ;
   not_rtlcs84 <= NOT rtlcs84 ;
   not_rtlcs68 <= NOT rtlcs68 ;
   not_rtlcn8907 <= NOT rtlcn8907 ;
   rtlc_14820_and_603 : and_4u_4u port map ( a(3)=>not_rtlcs84, a(2)=>
      not_rtlcs68, a(1)=>rtlcn8825, a(0)=>not_rtlcn8907, d=>rtlcn9513);
   rtlcn8479 <= rtlcn9509 OR rtlcn9513 ;
   not_Write <= NOT Write ;
   rtlcn9517 <= rtlcs67 AND not_Write ;
   rtlcn9518 <= EOM_phase(4) AND not_rtlcs100 ;
   rtlcn9519 <= EOM_phase(2) AND rtlc22n7730 ;
   rtlc_14833_or_605 : or_4u_4u port map ( a(3)=>rtlc22n10048, a(2)=>
      rtlc22n10133, a(1)=>rtlcn9518, a(0)=>rtlcn9519, d=>rtlcn8964);
   not_rtlc22n7730 <= NOT rtlc22n7730 ;
   rtlcn9521 <= EOM_phase(2) AND not_rtlc22n7730 ;
   not_rtlc22n10133 <= NOT rtlc22n10133 ;
   not_rtlcs103 <= NOT rtlcs103 ;
   not_rtlc22n7221 <= NOT rtlc22n7221 ;
   rtlc_14842_and_607 : and_5u_5u port map ( a(4)=>not_First_After_Reset, 
      a(3)=>not_rtlc22n10133, a(2)=>not_rtlcs103, a(1)=>not_rtlc22n7221, 
      a(0)=>rtlcn8851, d=>rtlcn9526);
   rtlcn8963 <= rtlcn8913 OR rtlcn9526 ;
   rtlcn8962 <= rtlcn8920 OR rtlcn9528 ;
   rtlcn9530 <= rtlcn8808 AND rtlcn8963 ;
   rtlcn9531 <= not_Ack AND rtlcn8962 ;
   rtlcn9532 <= BC_State(2) AND rtlc26n14491 ;
   rtlcn8838 <= rtlcn8921 OR rtlcn9532 ;
   rtlcn9533 <= rtlc26n14584 AND not_rtlcn8819 ;
   rtlcn9536 <= BC_State(0) AND rtlc26n12419 ;
   rtlcn8898 <= rtlcn9536 OR rtlcn9537 ;
   rtlcn8965 <= rtlcn8563 OR rtlcn8898 ;
   rtlcn8558 <= not_rtlc26n15497 AND rtlcn8965 ;
   not_rtlcn8867 <= NOT rtlcn8867 ;
   rtlcn9540 <= rtlcn8548 AND rtlc22n8782 ;
   rtlcn8583 <= not_rtlcn8867 OR rtlcn9540 ;
   rtlcn3748 <= rtlcs121 AND not_rtlcn9888 ;
   rtlc_14945_and_616 : and_7u_7u port map ( a(6)=>BC_Num_Msgs_26n12s1(9), 
      a(5)=>Data_o_temp(11), a(4)=>not_Data_o_temp_12, a(3)=>Data_o_temp(13), 
      a(2)=>not_Data_o_temp_14, a(1)=>Ack, a(0)=>rtlcn3048, d=>rtlcn3693);
   rtlc_14947_and_618 : and_4u_4u port map ( a(3)=>BC_State(83), a(2)=>
      not_rtlc26n15497, a(1)=>NO, a(0)=>Ack, d=>rtlcn4087);
   rtlc_14952_or_622 : or_4u_4u port map ( a(3)=>rtlc22n10219, a(2)=>
      rtlcn9118, a(1)=>rtlcn9462, a(0)=>rtlcn9517, d=>rtlcn8808);
   rtlc_14959_and_626 : and_4u_4u port map ( a(3)=>BC_Num_Msgs_26n12s1(9), 
      a(2)=>Data_o_temp(11), a(1)=>not_Data_o_temp_14, a(0)=>Ack, d=>
      rtlcn9547);
   rtlc_14960_or_627 : or_8u_8u port map ( a(7)=>rtlc26_PS698_n14998, a(6)=>
      rtlc26_PS699_n15006, a(5)=>rtlcn1257, a(4)=>rtlcn9547, a(3)=>rtlcs117, 
      a(2)=>rtlcs120, a(1)=>rtlcs124, a(0)=>rtlcs127, d=>rtlc26n15015);
   rtlcn9534 <= rtlc26n13005 AND BC_State(24) ;
   rtlcn6637 <= rtlcn9094 OR rtlcn8992 ;
   not_rtlc26n16112 <= NOT rtlc26n16112 ;
   not_rtlc26n15497 <= NOT rtlc26n15497 ;
   not_rtlcn3748 <= NOT rtlcn3748 ;
   rtlcn9848 <= rtlc26n15497 OR not_rtlcn3748 ;
   not_rtlcn9848 <= NOT rtlcn9848 ;
   rtlc_16279_or_628 : or_4u_4u port map ( a(3)=>rtlc29n464, a(2)=>
      rtlc29n472, a(1)=>rtlc29n518, a(0)=>rtlc29n681, d=>rtlcn9860);
   not_rtlcn9862 <= NOT rtlcn9862 ;
   not_rtlcn9863 <= NOT rtlcn9863 ;
   not_rtlcn9864 <= NOT rtlcn9864 ;
   not_rtlcn9865 <= NOT rtlcn9865 ;
   rtlcn2412 <= rtlcs249 OR not_rtlcn8796 ;
   rtlcn9867 <= not_CPU_Address_4 OR CPU_Address(3) ;
   not_rtlcn9867 <= NOT rtlcn9867 ;
   rtlcn2408 <= rtlcs228 OR not_rtlcn8796 ;
   not_rtlcn9870 <= NOT rtlcn9870 ;
   not_rtlcn9873 <= NOT rtlcn9873 ;
   not_rtlcn9874 <= NOT rtlcn9874 ;
   not_rtlcn9875 <= NOT rtlcn9875 ;
   not_rtlcn9876 <= NOT rtlcn9876 ;
   not_rtlcn9877 <= NOT rtlcn9877 ;
   not_rtlcn9878 <= NOT rtlcn9878 ;
   not_rtlcn9879 <= NOT rtlcn9879 ;
   not_rtlcn9880 <= NOT rtlcn9880 ;
   not_rtlcn9881 <= NOT rtlcn9881 ;
   not_rtlcn9882 <= NOT rtlcn9882 ;
   not_rtlcn9883 <= NOT rtlcn9883 ;
   rtlc_16325_or_632 : or_8u_8u port map ( a(7)=>BC_State(18), a(6)=>
      BC_State(84), a(5)=>rtlc26n16088, a(4)=>rtlc26n16203, a(3)=>
      rtlc26n16205, a(2)=>rtlcn2170, a(1)=>rtlcn7083, a(0)=>rtlcn7081, d=>
      rtlcn9884);
   not_rtlcn9884 <= NOT rtlcn9884 ;
   not_rtlcn9885 <= NOT rtlcn9885 ;
   not_rtlcn9886 <= NOT rtlcn9886 ;
   not_rtlcn9887 <= NOT rtlcn9887 ;
   not_rtlcn9888 <= NOT rtlcn9888 ;
   not_rtlcn9889 <= NOT rtlcn9889 ;
   not_rtlcn9890 <= NOT rtlcn9890 ;
   not_rtlcn9891 <= NOT rtlcn9891 ;
   not_rtlcn9892 <= NOT rtlcn9892 ;
   not_rtlcn9893 <= NOT rtlcn9893 ;
   not_rtlcn9894 <= NOT rtlcn9894 ;
   not_rtlcn9895 <= NOT rtlcn9895 ;
   not_rtlcn9896 <= NOT rtlcn9896 ;
   not_rtlcn9897 <= NOT rtlcn9897 ;
   not_rtlcn9898 <= NOT rtlcn9898 ;
   not_rtlcn9899 <= NOT rtlcn9899 ;
   not_rtlcn9900 <= NOT rtlcn9900 ;
   not_rtlcn9901 <= NOT rtlcn9901 ;
   rtlc_16361_or_634 : or_6u_6u port map ( a(5)=>GMM(0), a(4)=>GMM(1), a(3)
      =>GMM(2), a(2)=>MM(0), a(1)=>MM(1), a(0)=>MM(2), d=>rtlcn9900);
   rtlc_16362_or_635 : or_4u_4u port map ( a(3)=>GMM(1), a(2)=>GMM(2), a(1)
      =>MM(1), a(0)=>MM(2), d=>rtlcn9899);
   rtlc_16365_or_636 : or_4u_4u port map ( a(3)=>GMM(2), a(2)=>MM(2), a(1)=>
      rtlcs77, a(0)=>rtlcs93, d=>rtlcn8872);
   rtlcn8959 <= MM(2) OR GMM(2) ;
   rtlc_16371_or_637 : or_9u_9u port map ( a(8)=>Phase(0), a(7)=>not_Phase_1, 
      a(6)=>not_rtlcn8840, a(5)=>rtlcs69, a(4)=>rtlcs78, a(3)=>rtlcs82, a(2)
      =>rtlcs85, a(1)=>rtlcs94, a(0)=>rtlcs98, d=>rtlcn8375);
   rtlc_16376_or_638 : or_4u_4u port map ( a(3)=>rtlcs72, a(2)=>rtlcs74, 
      a(1)=>rtlcs88, a(0)=>rtlcs90, d=>rtlcn8840);
   INTn <= INTn_level when Config_reg_2(3) = '1' else INTn_pulse ;
   CPU_Data_out_wide(0) <= MEM_Data_out_wide(0) when MEM_nREG = '1' else 
   reg_data_out_wide(0) ;
   CPU_Data_out_wide(1) <= MEM_Data_out_wide(1) when MEM_nREG = '1' else 
   reg_data_out_wide(1) ;
   CPU_Data_out_wide(2) <= MEM_Data_out_wide(2) when MEM_nREG = '1' else 
   reg_data_out_wide(2) ;
   CPU_Data_out_wide(3) <= MEM_Data_out_wide(3) when MEM_nREG = '1' else 
   reg_data_out_wide(3) ;
   CPU_Data_out_wide(4) <= MEM_Data_out_wide(4) when MEM_nREG = '1' else 
   reg_data_out_wide(4) ;
   CPU_Data_out_wide(5) <= MEM_Data_out_wide(5) when MEM_nREG = '1' else 
   reg_data_out_wide(5) ;
   CPU_Data_out_wide(6) <= MEM_Data_out_wide(6) when MEM_nREG = '1' else 
   reg_data_out_wide(6) ;
   CPU_Data_out_wide(7) <= MEM_Data_out_wide(7) when MEM_nREG = '1' else 
   reg_data_out_wide(7) ;
   CPU_Data_out_wide(8) <= MEM_Data_out_wide(8) when MEM_nREG = '1' else 
   reg_data_out_wide(8) ;
   CPU_Data_out_wide(9) <= MEM_Data_out_wide(9) when MEM_nREG = '1' else 
   reg_data_out_wide(9) ;
   CPU_Data_out_wide(10) <= MEM_Data_out_wide(10) when MEM_nREG = '1' else 
   reg_data_out_wide(10) ;
   CPU_Data_out_wide(11) <= MEM_Data_out_wide(11) when MEM_nREG = '1' else 
   reg_data_out_wide(11) ;
   CPU_Data_out_wide(12) <= MEM_Data_out_wide(12) when MEM_nREG = '1' else 
   reg_data_out_wide(12) ;
   CPU_Data_out_wide(13) <= MEM_Data_out_wide(13) when MEM_nREG = '1' else 
   reg_data_out_wide(13) ;
   CPU_Data_out_wide(14) <= MEM_Data_out_wide(14) when MEM_nREG = '1' else 
   reg_data_out_wide(14) ;
   CPU_Data_out_wide(15) <= MEM_Data_out_wide(15) when MEM_nREG = '1' else 
   reg_data_out_wide(15) ;
   CPU_Data_out_wide(16) <= MEM_Data_out_wide(16) when MEM_nREG = '1' else 
   reg_data_out_wide(16) ;
   CPU_Data_out_wide(17) <= MEM_Data_out_wide(17) when MEM_nREG = '1' else 
   reg_data_out_wide(17) ;
   CPU_Data_out_wide(18) <= MEM_Data_out_wide(18) when MEM_nREG = '1' else 
   reg_data_out_wide(18) ;
   CPU_Data_out_wide(19) <= MEM_Data_out_wide(19) when MEM_nREG = '1' else 
   reg_data_out_wide(19) ;
   CPU_Data_out_wide(20) <= MEM_Data_out_wide(20) when MEM_nREG = '1' else 
   reg_data_out_wide(20) ;
   CPU_Data_out_wide(21) <= MEM_Data_out_wide(21) when MEM_nREG = '1' else 
   reg_data_out_wide(21) ;
   CPU_Data_out_wide(22) <= MEM_Data_out_wide(22) when MEM_nREG = '1' else 
   reg_data_out_wide(22) ;
   CPU_Data_out_wide(23) <= MEM_Data_out_wide(23) when MEM_nREG = '1' else 
   reg_data_out_wide(23) ;
   CPU_Data_out_wide(24) <= MEM_Data_out_wide(24) when MEM_nREG = '1' else 
   reg_data_out_wide(24) ;
   CPU_Data_out_wide(25) <= MEM_Data_out_wide(25) when MEM_nREG = '1' else 
   reg_data_out_wide(25) ;
   CPU_Data_out_wide(26) <= MEM_Data_out_wide(26) when MEM_nREG = '1' else 
   reg_data_out_wide(26) ;
   CPU_Data_out_wide(27) <= MEM_Data_out_wide(27) when MEM_nREG = '1' else 
   reg_data_out_wide(27) ;
   CPU_Data_out_wide(28) <= MEM_Data_out_wide(28) when MEM_nREG = '1' else 
   reg_data_out_wide(28) ;
   CPU_Data_out_wide(29) <= MEM_Data_out_wide(29) when MEM_nREG = '1' else 
   reg_data_out_wide(29) ;
   CPU_Data_out_wide(30) <= MEM_Data_out_wide(30) when MEM_nREG = '1' else 
   reg_data_out_wide(30) ;
   CPU_Data_out_wide(31) <= MEM_Data_out_wide(31) when MEM_nREG = '1' else 
   reg_data_out_wide(31) ;
   BIT_Word(9) <= Data_to_FE_EXMPLR999(9) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_9 ;
   BIT_Word(10) <= Data_to_FE_EXMPLR999(10) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_10 ;
   BIT_Word(11) <= Data_to_FE_EXMPLR999(11) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_11 ;
   BIT_Word(13) <= Data_to_FE_EXMPLR999(13) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_13 ;
   BIT_Word(14) <= Data_to_FE_EXMPLR999(14) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_14 ;
   BIT_Word(15) <= Data_to_FE_EXMPLR999(15) when Config_reg_4_EXMPLR998(15)
    = '1' else Internal_BIT_Word_15 ;
   RT_Address_EXMPLR1000(0) <= Wire_RT_Address(0) when rtlc16n22 = '1' else 
   Config_reg_5(1) ;
   RT_Address_EXMPLR1000(1) <= Wire_RT_Address(1) when rtlc16n22 = '1' else 
   Config_reg_5(2) ;
   RT_Address_EXMPLR1000(2) <= Wire_RT_Address(2) when rtlc16n22 = '1' else 
   Config_reg_5(3) ;
   RT_Address_EXMPLR1000(3) <= Wire_RT_Address(3) when rtlc16n22 = '1' else 
   Config_reg_5(4) ;
   RT_Address_EXMPLR1000(4) <= Wire_RT_Address(4) when rtlc16n22 = '1' else 
   Config_reg_5(5) ;
   RT_Address_EXMPLR1000(5) <= Wire_RT_Address(5) when rtlc16n22 = '1' else 
   Config_reg_5(0) ;
   monitor_stack_pointer_plus4_22n1ss1_12 <= monitor_stack_pointer(12) when 
   rtlc22n10046 = '1' else monitor_stack_pointer_plus4_22n1s4_12 ;
   monitor_stack_pointer_plus4_22n1ss1_13 <= monitor_stack_pointer(13) when 
   rtlc22n10046 = '1' else monitor_stack_pointer_plus4_22n1s4_13 ;
   data_pointer_22n48ss1(0) <= Current_command(0) when rtlc22n8022
    = '1' else Data_o_temp(0) ;
   data_pointer_22n48ss1(1) <= Current_command(1) when rtlc22n8022
    = '1' else Data_o_temp(1) ;
   data_pointer_22n48ss1(2) <= Current_command(2) when rtlc22n8022
    = '1' else Data_o_temp(2) ;
   data_pointer_22n48ss1(3) <= Current_command(3) when rtlc22n8022
    = '1' else Data_o_temp(3) ;
   data_pointer_22n48ss1(4) <= data_pointer_22n46ss1(0) when rtlc22n8022
    = '1' else Data_o_temp(4) ;
   data_pointer_22n48ss1(5) <= data_pointer_22n46ss1(1) when rtlc22n8022
    = '1' else Data_o_temp(5) ;
   Ram_Address_22n52ss1_4 <= data_pointer(4) when rtlc22n9096 = '1' else 
   Address(4) ;
   Ram_data_i_22n108ss1_0 <= Monitor_write_data(0) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_0 ;
   Ram_data_i_22n108ss1_1 <= Monitor_write_data(1) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_1 ;
   Ram_data_i_22n108ss1_2 <= Monitor_write_data(2) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_2 ;
   Ram_data_i_22n108ss1_3 <= Monitor_write_data(3) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_3 ;
   Ram_data_i_22n108ss1_4 <= Monitor_write_data(4) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_4 ;
   Ram_data_i_22n108ss1_5 <= Monitor_write_data(5) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_5 ;
   Ram_data_i_22n108ss1_6 <= Monitor_write_data(6) when rtlc60n5337
    = '1' else rtlcn11034 ;
   Ram_data_i_22n108ss1_7 <= Monitor_write_data(7) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_7 ;
   Ram_data_i_22n108ss1_8 <= Monitor_write_data(8) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_8 ;
   Ram_data_i_22n108ss1_9 <= Monitor_write_data(9) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_9 ;
   Ram_data_i_22n108ss1_10 <= Monitor_write_data(10) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_10 ;
   Ram_data_i_22n108ss1_11 <= Monitor_write_data(11) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_11 ;
   Ram_data_i_22n108ss1_12 <= Monitor_write_data(12) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_12 ;
   Ram_data_i_22n108ss1_13 <= Monitor_write_data(13) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_13 ;
   Ram_data_i_22n108ss1_15 <= Monitor_write_data(15) when rtlc60n5337
    = '1' else Ram_data_i_22n103ss1_15 ;
   monitor_data_pointer_22n108ss1(0) <= rtlcn12140(0) when rtlcs48
    = '1' else Data_o_temp(0) ;
   monitor_data_pointer_22n108ss1(1) <= rtlcn12140(1) when rtlcs48
    = '1' else Data_o_temp(1) ;
   monitor_data_pointer_22n108ss1(2) <= rtlcn12140(2) when rtlcs48
    = '1' else Data_o_temp(2) ;
   monitor_data_pointer_22n108ss1(3) <= rtlcn12140(3) when rtlcs48
    = '1' else Data_o_temp(3) ;
   monitor_data_pointer_22n108ss1(4) <= rtlcn12140(4) when rtlcs48
    = '1' else Data_o_temp(4) ;
   monitor_data_pointer_22n108ss1(5) <= rtlcn12140(5) when rtlcs48
    = '1' else Data_o_temp(5) ;
   monitor_data_pointer_22n108ss1(6) <= rtlcn12140(6) when rtlcs48
    = '1' else Data_o_temp(6) ;
   monitor_data_pointer_22n108ss1(7) <= rtlcn12140(7) when rtlcs48
    = '1' else Data_o_temp(7) ;
   monitor_data_pointer_22n108ss1(8) <= rtlcn12140(8) when rtlcs48
    = '1' else Data_o_temp(8) ;
   rtlc22n8426 <= rtlc22n8384 when rtlcs66 = '1' else rtlc22n8059 ;
   rtlc22n8060 <= rtlc22n7975 when SOM_phase_1 = '1' else rtlc22n7782 ;
   rtlc22n8436 <= rtlc22n8391 when rtlcs66 = '1' else not_rtlc22n10119 ;
   rtlc22n8064 <= rtlc22n7981 when Do_illegal_EXMPLR916 = '1' else 
   not_rtlcn1240 ;
   BC_Echo_word_26n180ss1(0) <= Data_o_temp(0) when BC_State(32) = '1' else 
   BC_Rx_Data(0) ;
   BC_Echo_word_26n180ss1(1) <= Data_o_temp(1) when BC_State(32) = '1' else 
   BC_Rx_Data(1) ;
   BC_Echo_word_26n180ss1(2) <= Data_o_temp(2) when BC_State(32) = '1' else 
   BC_Rx_Data(2) ;
   BC_Echo_word_26n180ss1(3) <= Data_o_temp(3) when BC_State(32) = '1' else 
   BC_Rx_Data(3) ;
   BC_Echo_word_26n180ss1(4) <= Data_o_temp(4) when BC_State(32) = '1' else 
   BC_Rx_Data(4) ;
   BC_Echo_word_26n180ss1(5) <= Data_o_temp(5) when BC_State(32) = '1' else 
   BC_Rx_Data(5) ;
   BC_Echo_word_26n180ss1(6) <= Data_o_temp(6) when BC_State(32) = '1' else 
   BC_Rx_Data(6) ;
   BC_Echo_word_26n180ss1(7) <= Data_o_temp(7) when BC_State(32) = '1' else 
   BC_Rx_Data(7) ;
   BC_Echo_word_26n180ss1(8) <= Data_o_temp(8) when BC_State(32) = '1' else 
   BC_Rx_Data(8) ;
   BC_Echo_word_26n180ss1(9) <= Data_o_temp(9) when BC_State(32) = '1' else 
   BC_Rx_Data(9) ;
   BC_Echo_word_26n180ss1(10) <= Data_o_temp(10) when BC_State(32)
    = '1' else BC_Rx_Data(10) ;
   BC_Echo_word_26n180ss1(11) <= Data_o_temp(11) when BC_State(32)
    = '1' else BC_Rx_Data(11) ;
   BC_Echo_word_26n180ss1(12) <= Data_o_temp(12) when BC_State(32)
    = '1' else BC_Rx_Data(12) ;
   BC_Echo_word_26n180ss1(13) <= Data_o_temp(13) when BC_State(32)
    = '1' else BC_Rx_Data(13) ;
   BC_Echo_word_26n180ss1(14) <= Data_o_temp(14) when BC_State(32)
    = '1' else BC_Rx_Data(14) ;
   BC_Echo_word_26n180ss1(15) <= Data_o_temp(15) when BC_State(32)
    = '1' else BC_Rx_Data(15) ;
   BC_msg_pointer_26n43s1f1(8) <= BC_Stack_pointer(10) when rtlc26n19509
    = '1' else BC_msg_pointer(8) ;
   BC_Stack_pointer_26n167s1f1(8) <= BC_Stack_pointer(10) when rtlc26n19509
    = '1' else BC_Stack_pointer(8) ;
   VARAM_D_26n172s1f1(4) <= Data_o_temp(4) when BC_State(86) = '1' else 
   LIFO_Pointer(4) ;
   VARAM_D_26n172s1f1(3) <= Data_o_temp(3) when BC_State(86) = '1' else 
   LIFO_Pointer(3) ;
   VARAM_D_26n172s1f1(2) <= Data_o_temp(2) when BC_State(86) = '1' else 
   LIFO_Pointer(2) ;
   rtlc32n583 <= rtlc32n581 when arbiter = '1' else rtlc32n557 ;
   YES <= YES_45n2ss1 when rtlcs173 = '1' else YES_45n1ss1 ;
   frame_gap_eq_0_51n6ss1 <= frame_gap_eq_0_51n6s1 when 
   BC_Load_frame_gap_counter = '1' else frame_gap_eq_0_51n5ss1 ;
   MT_On_Async_60n28ss1 <= MT_On_Async_60n27ss1 when rtlc60n5464 = '1' else 
   MT_On_Async_60n18s1 ;
   time_tag_60n43ss1(0) <= time_tag_60n30ss1(0) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(0) ;
   time_tag_60n43ss1(1) <= time_tag_60n30ss1(1) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(1) ;
   time_tag_60n43ss1(2) <= time_tag_60n30ss1(2) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(2) ;
   time_tag_60n43ss1(3) <= time_tag_60n30ss1(3) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(3) ;
   time_tag_60n43ss1(4) <= time_tag_60n30ss1(4) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(4) ;
   time_tag_60n43ss1(5) <= time_tag_60n30ss1(5) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(5) ;
   time_tag_60n43ss1(6) <= time_tag_60n30ss1(6) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(6) ;
   time_tag_60n43ss1(7) <= time_tag_60n30ss1(7) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(7) ;
   time_tag_60n43ss1(8) <= time_tag_60n30ss1(8) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(8) ;
   time_tag_60n43ss1(9) <= time_tag_60n30ss1(9) when rtlc60n6494 = '1' else 
   time_tag_60n15ss1(9) ;
   time_tag_60n43ss1(10) <= time_tag_60n30ss1(10) when rtlc60n6494
    = '1' else time_tag_60n15ss1(10) ;
   time_tag_60n43ss1(11) <= time_tag_60n30ss1(11) when rtlc60n6494
    = '1' else time_tag_60n15ss1(11) ;
   time_tag_60n43ss1(12) <= time_tag_60n30ss1(12) when rtlc60n6494
    = '1' else time_tag_60n15ss1(12) ;
   time_tag_60n43ss1(13) <= time_tag_60n30ss1(13) when rtlc60n6494
    = '1' else time_tag_60n15ss1(13) ;
   time_tag_60n43ss1(14) <= time_tag_60n30ss1(14) when rtlc60n6494
    = '1' else time_tag_60n15ss1(14) ;
   time_tag_60n43ss1(15) <= time_tag_60n30ss1(15) when rtlc60n6494
    = '1' else time_tag_60n15ss1(15) ;
   host_status_bits_60n45ss1_0 <= not_Config_reg_1_7 when rtlc60n5942
    = '1' else Config_reg_1(1) ;
   host_status_bits_60n45ss1_2 <= host_status_bits_2_60n45s2 when 
   rtlc60n5942 = '1' else Config_reg_1(3) ;
   host_status_bits_60n45ss1_3 <= not_Config_reg_1_10 when rtlc60n5942
    = '1' else Config_reg_1(4) ;
   Config_reg_5_60n51ss1(0) <= RT_ADR_LAT when CE = '1' else 
   CPU_Data_in_wide(22) ;
   Config_reg_5_60n51ss1(1) <= Tx_InhB when CE = '1' else 
   CPU_Data_in_wide(28) ;
   Config_reg_5_60n51ss1(2) <= Tx_inhA when CE = '1' else 
   CPU_Data_in_wide(29) ;
   Config_reg_1_60n91ss1_1 <= Config_reg_1_60n90ss1(1) when CE = '1' else 
   Config_reg_1_60n43ss1_1 ;
   rtlc60n5903 <= rtlc60n5601 when rtlc60n6494 = '1' else rtlc60n5383 ;
   rtlc60n5904 <= rtlc60n5602 when rtlc60n6494 = '1' else rtlc60n5384 ;
   rtlc60n5560 <= rtlc60n5527 when rtlc60n5464 = '1' else rtlc60n5384 ;
   rtlc60n6684 <= rtlc60n6577 when CE = '1' else rtlc60n5981 ;
   rtlc60n6685 <= rtlc60n6679 when CE = '1' else rtlcn10206 ;
   rtlc60n6686 <= rtlc60n6680 when CE = '1' else rtlc60n5906 ;
   rtlc60n6687 <= rtlc60n6681 when CE = '1' else rtlcn10206 ;
   rtlc60n5920 <= rtlc60n5666 when rtlc60n6494 = '1' else not_CE ;
   rtlc60n5569 <= rtlc60n5557 when rtlc60n5464 = '1' else not_rtlc60n5424 ;
   rtlc60n6442 <= rtlc60n6438 when CE = '1' else rtlc60n5926 ;
   rtlc60n6443 <= rtlc60n6439 when CE = '1' else rtlc60n5927 ;
   reg_data_out_wide_75n41ss1(0) <= BC_Stack_pointer(0) when BC_on_EXMPLR883
    = '1' else stack_pointer(0) ;
   reg_data_out_wide_75n41ss1(1) <= BC_Stack_pointer(1) when BC_on_EXMPLR883
    = '1' else stack_pointer(1) ;
   reg_data_out_wide_75n41ss1(2) <= BC_Stack_pointer(2) when BC_on_EXMPLR883
    = '1' else stack_pointer(2) ;
   reg_data_out_wide_75n41ss1(3) <= BC_Stack_pointer(3) when BC_on_EXMPLR883
    = '1' else stack_pointer(3) ;
   reg_data_out_wide_75n41ss1(4) <= BC_Stack_pointer(4) when BC_on_EXMPLR883
    = '1' else stack_pointer(4) ;
   reg_data_out_wide_75n41ss1(5) <= BC_Stack_pointer(5) when BC_on_EXMPLR883
    = '1' else stack_pointer(5) ;
   reg_data_out_wide_75n41ss1(6) <= BC_Stack_pointer(6) when BC_on_EXMPLR883
    = '1' else stack_pointer(6) ;
   reg_data_out_wide_75n41ss1(7) <= BC_Stack_pointer(7) when BC_on_EXMPLR883
    = '1' else stack_pointer(7) ;
   reg_data_out_wide_75n41ss1(8) <= BC_Stack_pointer(8) when BC_on_EXMPLR883
    = '1' else stack_pointer(8) ;
   reg_data_out_wide_75n41ss1(9) <= BC_Stack_pointer(9) when BC_on_EXMPLR883
    = '1' else stack_pointer(9) ;
   reg_data_out_wide_75n41ss1(10) <= BC_Stack_pointer(10) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(10) ;
   reg_data_out_wide_75n41ss1(11) <= BC_Stack_pointer(11) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(11) ;
   reg_data_out_wide_75n41ss1(12) <= BC_Stack_pointer(12) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(12) ;
   reg_data_out_wide_75n41ss1(13) <= BC_Stack_pointer(13) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(13) ;
   reg_data_out_wide_75n41ss1(14) <= BC_Stack_pointer(14) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(14) ;
   reg_data_out_wide_75n41ss1(15) <= BC_Stack_pointer(15) when 
   BC_on_EXMPLR883 = '1' else stack_pointer(15) ;
   reg_data_out_wide_75n43ss1(0) <= BC_RT2RT_EXMPLR781 when BC_on_EXMPLR883
    = '1' else LUT_Control(0) ;
   reg_data_out_wide_75n43ss1(1) <= BC_Control_word_1 when BC_on_EXMPLR883
    = '1' else LUT_Control(1) ;
   reg_data_out_wide_75n43ss1(2) <= BC_Control_word_2 when BC_on_EXMPLR883
    = '1' else LUT_Control(2) ;
   reg_data_out_wide_75n43ss1(3) <= BC_1553A_EXMPLR864 when BC_on_EXMPLR883
    = '1' else LUT_Control(3) ;
   reg_data_out_wide_75n43ss1(4) <= BC_Control_word_4 when BC_on_EXMPLR883
    = '1' else LUT_Control(4) ;
   reg_data_out_wide_75n43ss1(5) <= BC_Control_word_5 when BC_on_EXMPLR883
    = '1' else LUT_Control(5) ;
   reg_data_out_wide_75n43ss1(6) <= BC_Test_EXMPLR782 when BC_on_EXMPLR883
    = '1' else LUT_Control(6) ;
   reg_data_out_wide_75n43ss1(7) <= BC_Control_word_7 when BC_on_EXMPLR883
    = '1' else LUT_Control(7) ;
   reg_data_out_wide_75n43ss1(8) <= BC_Control_word_8 when BC_on_EXMPLR883
    = '1' else LUT_Control(8) ;
   reg_data_out_wide_75n43ss1(9) <= BC_Control_word_9 when BC_on_EXMPLR883
    = '1' else LUT_Control(9) ;
   reg_data_out_wide_75n43ss1(10) <= BC_Control_word_10 when BC_on_EXMPLR883
    = '1' else LUT_Control(10) ;
   reg_data_out_wide_75n43ss1(11) <= BC_Control_word_11 when BC_on_EXMPLR883
    = '1' else LUT_Control(11) ;
   reg_data_out_wide_75n43ss1(12) <= BC_Control_word_12 when BC_on_EXMPLR883
    = '1' else LUT_Control(12) ;
   reg_data_out_wide_75n43ss1(13) <= BC_Control_word_13 when BC_on_EXMPLR883
    = '1' else LUT_Control(13) ;
   reg_data_out_wide_75n43ss1(14) <= BC_Control_word_14 when BC_on_EXMPLR883
    = '1' else LUT_Control(14) ;
   reg_data_out_wide_75n43ss1(15) <= BC_Control_word_15 when BC_on_EXMPLR883
    = '1' else LUT_Control(15) ;
   reg_data_out_wide_75n50ss1(0) <= WM_RAM_Address(0) when WM_On = '1' else 
   Data_Pointer_register(0) ;
   reg_data_out_wide_75n50ss1(1) <= WM_RAM_Address(1) when WM_On = '1' else 
   Data_Pointer_register(1) ;
   reg_data_out_wide_75n50ss1(2) <= WM_RAM_Address(2) when WM_On = '1' else 
   Data_Pointer_register(2) ;
   reg_data_out_wide_75n50ss1(3) <= WM_RAM_Address(3) when WM_On = '1' else 
   Data_Pointer_register(3) ;
   reg_data_out_wide_75n50ss1(4) <= WM_RAM_Address(4) when WM_On = '1' else 
   Data_Pointer_register(4) ;
   reg_data_out_wide_75n50ss1(5) <= WM_RAM_Address(5) when WM_On = '1' else 
   Data_Pointer_register(5) ;
   reg_data_out_wide_75n50ss1(6) <= WM_RAM_Address(6) when WM_On = '1' else 
   Data_Pointer_register(6) ;
   reg_data_out_wide_75n50ss1(7) <= WM_RAM_Address(7) when WM_On = '1' else 
   Data_Pointer_register(7) ;
   reg_data_out_wide_75n50ss1(8) <= WM_RAM_Address(8) when WM_On = '1' else 
   Data_Pointer_register(8) ;
   reg_data_out_wide_75n50ss1(9) <= WM_RAM_Address(9) when WM_On = '1' else 
   Data_Pointer_register(9) ;
   reg_data_out_wide_75n50ss1(10) <= WM_RAM_Address(10) when WM_On
    = '1' else Data_Pointer_register(10) ;
   reg_data_out_wide_75n50ss1(11) <= WM_RAM_Address(11) when WM_On
    = '1' else Data_Pointer_register(11) ;
   reg_data_out_wide_75n50ss1(12) <= WM_RAM_Address(12) when WM_On
    = '1' else Data_Pointer_register(12) ;
   reg_data_out_wide_75n50ss1(13) <= WM_RAM_Address(13) when WM_On
    = '1' else Data_Pointer_register(13) ;
   reg_data_out_wide_75n50ss1(14) <= WM_RAM_Address(14) when WM_On
    = '1' else Data_Pointer_register(14) ;
   reg_data_out_wide_75n50ss1(15) <= WM_RAM_Address(15) when WM_On
    = '1' else Data_Pointer_register(15) ;
   reg_data_out_wide_75n54ss1(0) <= Frame_length_reg_0xD(0) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(0) ;
   reg_data_out_wide_75n54ss1(1) <= Frame_length_reg_0xD(1) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(1) ;
   reg_data_out_wide_75n54ss1(2) <= Frame_length_reg_0xD(2) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(2) ;
   reg_data_out_wide_75n54ss1(3) <= Frame_length_reg_0xD(3) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(3) ;
   reg_data_out_wide_75n54ss1(4) <= Frame_length_reg_0xD(4) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(4) ;
   reg_data_out_wide_75n54ss1(5) <= Frame_length_reg_0xD(5) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(5) ;
   reg_data_out_wide_75n54ss1(6) <= Frame_length_reg_0xD(6) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(6) ;
   reg_data_out_wide_75n54ss1(7) <= Frame_length_reg_0xD(7) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(7) ;
   reg_data_out_wide_75n54ss1(8) <= Frame_length_reg_0xD(8) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(8) ;
   reg_data_out_wide_75n54ss1(9) <= Frame_length_reg_0xD(9) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(9) ;
   reg_data_out_wide_75n54ss1(10) <= Frame_length_reg_0xD(10) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(10) ;
   reg_data_out_wide_75n54ss1(11) <= Frame_length_reg_0xD(11) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(11) ;
   reg_data_out_wide_75n54ss1(12) <= Frame_length_reg_0xD(12) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(12) ;
   reg_data_out_wide_75n54ss1(13) <= Frame_length_reg_0xD(13) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(13) ;
   reg_data_out_wide_75n54ss1(14) <= Frame_length_reg_0xD(14) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(14) ;
   reg_data_out_wide_75n54ss1(15) <= Frame_length_reg_0xD(15) when 
   Ext_Trigger_Dx_0n0s6 = '1' else last_command(15) ;
   rtlc75n1968 <= rtlc75n1961 when eBC_IRQ_do = '1' else not_rtlcn11108 ;
   rtlc84n180 <= rtlc84n177 when Do_RAM_test = '1' else 
   not_Clear_Test_Status_reg ;
   rtlc84n141 <= rtlc84n177 when rtlc84n99 = '1' else 
   not_Clear_Test_Status_reg ;
   WM_RAM_data_i_87n13ss1(0) <= WM_Descriptor(0) when state(5) = '1' else 
   WM_Word(0) ;
   WM_RAM_data_i_87n13ss1(1) <= WM_Descriptor(1) when state(5) = '1' else 
   WM_Word(1) ;
   WM_RAM_data_i_87n13ss1(2) <= WM_Descriptor(2) when state(5) = '1' else 
   WM_Word(2) ;
   WM_RAM_data_i_87n13ss1(3) <= WM_Descriptor(3) when state(5) = '1' else 
   WM_Word(3) ;
   WM_RAM_data_i_87n13ss1(4) <= WM_Descriptor(4) when state(5) = '1' else 
   WM_Word(4) ;
   WM_RAM_data_i_87n13ss1(5) <= WM_Descriptor(5) when state(5) = '1' else 
   WM_Word(5) ;
   WM_RAM_data_i_87n13ss1(6) <= WM_RAM_data_i_6_87n9s2 when state(5)
    = '1' else WM_Word(6) ;
   WM_RAM_data_i_87n13ss1(7) <= WM_Descriptor(7) when state(5) = '1' else 
   WM_Word(7) ;
   WM_RAM_data_i_87n13ss1(8) <= WM_Descriptor(8) when state(5) = '1' else 
   WM_Word(8) ;
   WM_RAM_data_i_87n13ss1(9) <= WM_Descriptor(9) when state(5) = '1' else 
   WM_Word(9) ;
   WM_RAM_data_i_87n13ss1(10) <= WM_Descriptor(10) when state(5) = '1' else 
   WM_Word(10) ;
   WM_RAM_data_i_87n13ss1(11) <= WM_Descriptor(11) when state(5) = '1' else 
   WM_Word(11) ;
   WM_RAM_data_i_87n13ss1(12) <= WM_Descriptor(12) when state(5) = '1' else 
   WM_Word(12) ;
   WM_RAM_data_i_87n13ss1(13) <= WM_Descriptor(13) when state(5) = '1' else 
   WM_Word(13) ;
   WM_RAM_data_i_87n13ss1(14) <= WM_Descriptor(14) when state(5) = '1' else 
   WM_Word(14) ;
   WM_RAM_data_i_87n13ss1(15) <= WM_Descriptor(15) when state(5) = '1' else 
   WM_Word(15) ;
   monitor_stack_pointer_plus4_22n1ss1_8 <= 
   monitor_stack_pointer_plus4_22n1s4_8 when rtlcn2058 = '1' else 
   monitor_stack_pointer(8) ;
   monitor_stack_pointer_plus4_22n1ss1_9 <= 
   monitor_stack_pointer_plus4_22n1s4_9 when rtlcn2058 = '1' else 
   monitor_stack_pointer(9) ;
   monitor_stack_pointer_plus4_22n1ss1_10 <= 
   monitor_stack_pointer_plus4_22n1s4_10 when Config_reg_3_12 = '1' else 
   monitor_stack_pointer(10) ;
   monitor_stack_pointer_plus4_22n1ss1_11 <= 
   monitor_stack_pointer_plus4_22n1s4_11 when Config_reg_3_12 = '1' else 
   monitor_stack_pointer(11) ;
   rtlcn2081 <= not_MON_EOM_phase_go when rtlcs64 = '1' else rtlc22n8588 ;
   BC_msg_pointer_26n180ss1(0) <= BC_Ram_data_26n30s4(0) when rtlc26n19466
    = '1' else Data_o_temp(0) ;
   BC_msg_pointer_26n180ss1(1) <= BC_Ram_data_26n30s4(1) when rtlc26n19466
    = '1' else Data_o_temp(1) ;
   BC_msg_pointer_26n180ss1(2) <= BC_Ram_data_26n30s4(2) when rtlc26n19466
    = '1' else Data_o_temp(2) ;
   BC_msg_pointer_26n180ss1(3) <= BC_Ram_data_26n30s4(3) when rtlc26n19466
    = '1' else Data_o_temp(3) ;
   BC_msg_pointer_26n180ss1(4) <= BC_Ram_data_26n30s4(4) when rtlc26n19466
    = '1' else Data_o_temp(4) ;
   BC_msg_pointer_26n180ss1(5) <= BC_Ram_data_26n30s4(5) when rtlc26n19466
    = '1' else Data_o_temp(5) ;
   BC_msg_pointer_26n180ss1(6) <= BC_Ram_data_26n30s4(6) when rtlc26n19466
    = '1' else Data_o_temp(6) ;
   BC_msg_pointer_26n180ss1(7) <= BC_Ram_data_26n30s4(7) when rtlc26n19466
    = '1' else Data_o_temp(7) ;
   BC_msg_pointer_26n180ss1(8) <= BC_Ram_data_26n30s4(8) when rtlc26n19466
    = '1' else Data_o_temp(8) ;
   BC_msg_pointer_26n180ss1(9) <= BC_msg_pointer_26n43s1_9 when rtlc26n19466
    = '1' else Data_o_temp(9) ;
   BC_msg_pointer_26n180ss1(10) <= BC_msg_pointer_26n43s1_10 when 
   rtlc26n19466 = '1' else Data_o_temp(10) ;
   BC_msg_pointer_26n180ss1(11) <= BC_msg_pointer_26n43s1_11 when 
   rtlc26n19466 = '1' else Data_o_temp(11) ;
   BC_msg_pointer_26n180ss1(12) <= BC_msg_pointer_26n43s1_12 when 
   rtlc26n19466 = '1' else Data_o_temp(12) ;
   BC_msg_pointer_26n180ss1(13) <= BC_msg_pointer_26n43s1_13 when 
   rtlc26n19466 = '1' else Data_o_temp(13) ;
   BC_msg_pointer_26n180ss1(14) <= BC_msg_pointer_26n43s1_14 when 
   rtlc26n19466 = '1' else Data_o_temp(14) ;
   BC_msg_pointer_26n180ss1(15) <= BC_msg_pointer_26n43s1_15 when 
   rtlc26n19466 = '1' else Data_o_temp(15) ;
   BC_msg_pointer_26n43s1f1(7) <= BC_msg_pointer(7) when rtlc26n19466
    = '1' else BC_Stack_pointer(9) ;
   BC_msg_pointer_26n43s1f1(6) <= BC_msg_pointer(6) when rtlc26n19466
    = '1' else BC_Stack_pointer(8) ;
   BC_msg_pointer_26n43s1f1(5) <= BC_Stack_pointer(7) when BC_State(12)
    = '1' else BC_msg_pointer(5) ;
   BC_msg_pointer_26n43s1f1(4) <= BC_Stack_pointer(6) when BC_State(12)
    = '1' else BC_msg_pointer(4) ;
   BC_msg_pointer_26n43s1f1(3) <= BC_Stack_pointer(5) when BC_State(12)
    = '1' else BC_msg_pointer(3) ;
   BC_msg_pointer_26n43s1f1(2) <= BC_Stack_pointer(4) when BC_State(12)
    = '1' else BC_msg_pointer(2) ;
   BC_Stack_pointer_26n167s1f1(7) <= BC_Stack_pointer(7) when rtlcn2233
    = '1' else BC_Stack_pointer(9) ;
   BC_Stack_pointer_26n167s1f1(6) <= BC_Stack_pointer(6) when rtlcn2233
    = '1' else BC_Stack_pointer(8) ;
   BC_Stack_pointer_26n167s1f1(5) <= BC_Stack_pointer(7) when BC_State(12)
    = '1' else BC_Stack_pointer(5) ;
   BC_Stack_pointer_26n167s1f1(4) <= BC_Stack_pointer(6) when BC_State(12)
    = '1' else BC_Stack_pointer(4) ;
   BC_Stack_pointer_26n167s1f1(3) <= BC_Stack_pointer(5) when BC_State(12)
    = '1' else BC_Stack_pointer(3) ;
   BC_Stack_pointer_26n167s1f1(2) <= BC_Stack_pointer(4) when BC_State(12)
    = '1' else BC_Stack_pointer(2) ;
   BC_Stack_pointer_26n167s1f1(1) <= BC_Stack_pointer(3) when BC_State(12)
    = '1' else BC_Stack_pointer(1) ;
   BC_Stack_pointer_26n167s1f1(0) <= BC_Stack_pointer(2) when BC_State(12)
    = '1' else BC_Stack_pointer(0) ;
   eBC_GP_60n73ss1(7) <= eBC_GP_60n62ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n41ss1 ;
   eBC_GP_60n73ss1(6) <= eBC_GP_60n61ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n40ss1 ;
   eBC_GP_60n73ss1(5) <= eBC_GP_60n60ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n39ss1 ;
   eBC_GP_60n73ss1(4) <= eBC_GP_60n59ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n38ss1 ;
   eBC_GP_60n73ss1(3) <= eBC_GP_60n58ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n37ss1 ;
   eBC_GP_60n73ss1(2) <= eBC_GP_60n57ss1 when rtlcn3857 = '1' else 
   eBC_GP_60n36ss1 ;
   eBC_Q_pointer_60n51ss1(0) <= eBC_Q_pointer_60n50s1(0) when rtlcn4159
    = '1' else CPU_Data_in_wide(16) ;
   eBC_Q_pointer_60n51ss1(5) <= eBC_Q_pointer_60n50s1(5) when rtlcn4159
    = '1' else CPU_Data_in_wide(21) ;
   eBC_Q_pointer_60n51ss1(4) <= eBC_Q_pointer_60n50s1(4) when rtlcn4159
    = '1' else CPU_Data_in_wide(20) ;
   eBC_Q_pointer_60n51ss1(3) <= eBC_Q_pointer_60n50s1(3) when rtlcn4159
    = '1' else CPU_Data_in_wide(19) ;
   eBC_Q_pointer_60n51ss1(2) <= eBC_Q_pointer_60n50s1(2) when rtlcn4159
    = '1' else CPU_Data_in_wide(18) ;
   eBC_Q_pointer_60n51ss1(1) <= eBC_Q_pointer_60n50s1(1) when rtlcn4159
    = '1' else CPU_Data_in_wide(17) ;
   Ram_Address_22n54ss1_0 <= data_pointer(0) when rtlcn4187 = '1' else 
   Address(0) ;
   monitor_data_pointer_22n108ss1(9) <= Data_o_temp(9) when rtlcn8651
    = '1' else rtlcn12140(9) ;
   monitor_data_pointer_22n108ss1(10) <= Data_o_temp(10) when rtlcn8652
    = '1' else rtlcn12140(10) ;
   monitor_data_pointer_22n108ss1(11) <= Data_o_temp(11) when rtlcn8653
    = '1' else rtlcn12140(11) ;
   monitor_data_pointer_22n108ss1(12) <= Data_o_temp(12) when rtlcn4522
    = '1' else rtlcn12140(12) ;
   monitor_data_pointer_22n108ss1(13) <= rtlcn12140(13) when rtlcn4524
    = '1' else Data_o_temp(13) ;
   monitor_data_pointer_22n108ss1(14) <= rtlcn12140(14) when rtlcn4528
    = '1' else Data_o_temp(14) ;
   rtlc22n8427 <= rtlc22n8376 when rtlcn5178 = '1' else rtlc22n8059 ;
   rtlc22n8428 <= rtlc22n8059 when rtlcn8902 = '1' else rtlc22n8369 ;
   rtlc22n8429 <= rtlc22n8363 when rtlcn5238 = '1' else rtlc22n8059 ;
   rtlc22n8430 <= rtlc22n8059 when rtlcn8668 = '1' else rtlc22n8358 ;
   rtlc22n8431 <= rtlc22n8059 when rtlcn8669 = '1' else rtlc22n8354 ;
   Ram_Address_22n54ss1_3 <= data_pointer(3) when rtlcn4187 = '1' else 
   Address(3) ;
   Ram_Address_22n54ss1_2 <= data_pointer(2) when rtlcn4187 = '1' else 
   Address(2) ;
   Ram_Address_22n54ss1_1 <= data_pointer(1) when rtlcn4187 = '1' else 
   Address(1) ;
   Interrupt_status_register_1_75n7ss1(13) <= 
   Interrupt_status_register_1_75n6s1_13 when rtlcn6074 = '1' else 
   ISR1_during_clear_13 ;
   Interrupt_status_register_1_75n7ss1(12) <= 
   Interrupt_status_register_1_75n6s1_12 when rtlcn6074 = '1' else 
   ISR1_during_clear_12 ;
   Interrupt_status_register_1_75n7ss1(11) <= 
   Interrupt_status_register_1_75n6s1_11 when rtlcn6074 = '1' else 
   ISR1_during_clear_11 ;
   Interrupt_status_register_1_75n7ss1(10) <= 
   Interrupt_status_register_1_75n6s1_10 when rtlcn6074 = '1' else 
   ISR1_during_clear_10 ;
   Interrupt_status_register_1_75n7ss1(8) <= 
   Interrupt_status_register_1_75n6s1_8 when rtlcn6074 = '1' else 
   ISR1_during_clear_8 ;
   Interrupt_status_register_1_75n7ss1(6) <= 
   Interrupt_status_register_1_75n6s1_6 when rtlcn6074 = '1' else 
   ISR1_during_clear_6 ;
   Dummy_register_0x4_60n43ss1(15) <= CPU_Data_in_wide(15) when rtlcn6142
    = '1' else Monitor_write_data(15) ;
   Dummy_register_0x4_60n43ss1(14) <= CPU_Data_in_wide(14) when rtlcn6142
    = '1' else Monitor_write_data(14) ;
   Dummy_register_0x4_60n43ss1(13) <= CPU_Data_in_wide(13) when rtlcn6142
    = '1' else Monitor_write_data(13) ;
   Dummy_register_0x4_60n43ss1(12) <= CPU_Data_in_wide(12) when rtlcn6142
    = '1' else Monitor_write_data(12) ;
   Dummy_register_0x4_60n43ss1(11) <= CPU_Data_in_wide(11) when rtlcn6142
    = '1' else Monitor_write_data(11) ;
   Dummy_register_0x4_60n43ss1(10) <= CPU_Data_in_wide(10) when rtlcn6142
    = '1' else Monitor_write_data(10) ;
   Dummy_register_0x4_60n43ss1(9) <= CPU_Data_in_wide(9) when rtlcn6142
    = '1' else Monitor_write_data(9) ;
   Dummy_register_0x4_60n43ss1(8) <= CPU_Data_in_wide(8) when rtlcn6142
    = '1' else Monitor_write_data(8) ;
   Dummy_register_0x4_60n43ss1(7) <= CPU_Data_in_wide(7) when rtlcn6142
    = '1' else Monitor_write_data(7) ;
   Dummy_register_0x4_60n43ss1(6) <= CPU_Data_in_wide(6) when rtlcn6142
    = '1' else Monitor_write_data(6) ;
   Dummy_register_0x4_60n43ss1(5) <= CPU_Data_in_wide(5) when rtlcn6142
    = '1' else Monitor_write_data(5) ;
   Dummy_register_0x4_60n43ss1(4) <= CPU_Data_in_wide(4) when rtlcn6142
    = '1' else Monitor_write_data(4) ;
   Dummy_register_0x4_60n43ss1(3) <= CPU_Data_in_wide(3) when rtlcn6142
    = '1' else Monitor_write_data(3) ;
   Dummy_register_0x4_60n43ss1(2) <= CPU_Data_in_wide(2) when rtlcn6142
    = '1' else Monitor_write_data(2) ;
   Dummy_register_0x4_60n43ss1(1) <= CPU_Data_in_wide(1) when rtlcn6142
    = '1' else Monitor_write_data(1) ;
   Dummy_register_0x4_60n43ss1(0) <= CPU_Data_in_wide(0) when rtlcn6142
    = '1' else Monitor_write_data(0) ;
   Interrupt_status_register_1_75n7ss1(5) <= 
   Interrupt_status_register_1_75n6s1_5 when rtlcn6074 = '1' else 
   ISR1_during_clear_5 ;
   Interrupt_status_register_1_75n7ss1(4) <= 
   Interrupt_status_register_1_75n6s1_4 when rtlcn6074 = '1' else 
   ISR1_during_clear_4 ;
   Interrupt_status_register_1_75n7ss1(3) <= 
   Interrupt_status_register_1_75n6s1_3 when rtlcn6074 = '1' else 
   ISR1_during_clear_3 ;
   Interrupt_status_register_1_75n7ss1(2) <= 
   Interrupt_status_register_1_75n6s1_2 when rtlcn6074 = '1' else 
   ISR1_during_clear_2 ;
   Interrupt_status_register_1_75n7ss1(1) <= 
   Interrupt_status_register_1_75n6s1_1 when rtlcn6074 = '1' else 
   ISR1_during_clear_1 ;
   Interrupt_status_register_1_75n7ss1(0) <= 
   Interrupt_status_register_1_75n6s1_0 when rtlcn6074 = '1' else 
   ISR1_during_clear_0 ;
   Interrupt_status_register_2_75n7ss1_1 <= 
   Interrupt_status_register_2_75n6s1_1 when rtlcn6683 = '1' else 
   ISR2_during_clear_1 ;
   Interrupt_status_register_2_75n7ss1_3 <= 
   Interrupt_status_register_2_75n6s1_3 when rtlcn6683 = '1' else 
   ISR2_during_clear_3 ;
   Interrupt_status_register_2_75n7ss1_4 <= 
   Interrupt_status_register_2_75n6s1_4 when rtlcn6683 = '1' else 
   ISR2_during_clear_4 ;
   Interrupt_status_register_2_75n7ss1_5 <= 
   Interrupt_status_register_2_75n6s1_5 when rtlcn6683 = '1' else 
   ISR2_during_clear_5 ;
   Interrupt_status_register_2_75n7ss1_6 <= 
   Interrupt_status_register_2_75n6s1_6 when rtlcn6683 = '1' else 
   ISR2_during_clear_6 ;
   Interrupt_status_register_2_75n7ss1_7 <= 
   Interrupt_status_register_2_75n6s1_7 when rtlcn6683 = '1' else 
   ISR2_during_clear_7 ;
   Interrupt_status_register_2_75n7ss1_10 <= 
   Interrupt_status_register_2_75n6s1_10 when rtlcn6683 = '1' else 
   ISR2_during_clear_10 ;
   Interrupt_status_register_2_75n7ss1_11 <= 
   Interrupt_status_register_2_75n6s1_11 when rtlcn6683 = '1' else 
   ISR2_during_clear_11 ;
   Interrupt_status_register_2_75n7ss1_12 <= 
   Interrupt_status_register_2_75n6s1_12 when rtlcn6683 = '1' else 
   ISR2_during_clear_12 ;
   Interrupt_status_register_2_75n7ss1_14 <= 
   Interrupt_status_register_2_75n6s1_14 when rtlcn6683 = '1' else 
   ISR2_during_clear_14 ;
   Config_reg_1_60n90ss1(0) <= WM_Req when WM_On = '1' else 
   Config_reg_1_60n89ss1 ;
   Config_reg_1_60n90ss1(2) <= WM_Started_EXMPLR927 when WM_On = '1' else 
   Config_reg_1_60n84ss1 ;
   rtlc60n6683 <= rtlc60n6602 when rtlcn7581 = '1' else rtlc60n5981 ;
   data_pointer_22n76ss1(0) <= data_pointer_22n48ss1(0) when rtlcn8295
    = '1' else rtlcn12141(0) ;
   data_pointer_22n76ss1(1) <= data_pointer_22n48ss1(1) when rtlcn8295
    = '1' else rtlcn12141(1) ;
   data_pointer_22n76ss1(2) <= data_pointer_22n48ss1(2) when rtlcn8295
    = '1' else rtlcn12141(2) ;
   data_pointer_22n76ss1(3) <= data_pointer_22n48ss1(3) when rtlcn8295
    = '1' else rtlcn12141(3) ;
   data_pointer_22n76ss1(4) <= data_pointer_22n48ss1(4) when rtlcn8295
    = '1' else rtlcn12141(4) ;
   data_pointer_22n76ss1(5) <= data_pointer_22n48ss1(5) when rtlcn8295
    = '1' else rtlcn12141(5) ;
   data_pointer_22n76ss1(6) <= data_pointer_22n48ss1(6) when rtlcn8295
    = '1' else rtlcn12141(6) ;
   data_pointer_22n76ss1(7) <= data_pointer_22n48ss1(7) when rtlcn8351
    = '1' else rtlcn12141(7) ;
   data_pointer_22n76ss1(8) <= rtlcn12141(8) when rtlcn8358 = '1' else 
   data_pointer_22n48ss1(8) ;
   data_pointer_22n76ss1(9) <= rtlcn12141(9) when rtlcn8366 = '1' else 
   data_pointer_22n48ss1(9) ;
   data_pointer_22n76ss1(10) <= data_pointer_22n48ss1(10) when rtlcn8375
    = '1' else rtlcn12141(10) ;
   data_pointer_22n76ss1(11) <= data_pointer_22n48ss1(11) when rtlcn8379
    = '1' else rtlcn12141(11) ;
   data_pointer_22n76ss1(12) <= data_pointer_22n48ss1(12) when rtlcn8383
    = '1' else rtlcn12141(12) ;
   rtlcn9923 <= CE AND Arbiter_timeout ;
   not_rtlcn2077 <= NOT rtlcn2077 ;
   rtlcn9960 <= CE AND not_rtlcn2077 ;
   rtlc22n10748 <= rtlcn9923 OR rtlcn9960 ;
   not_rtlcn2079 <= NOT rtlcn2079 ;
   rtlcn9962 <= CE AND not_rtlcn2079 ;
   rtlc22n10743 <= rtlcn9923 OR rtlcn9962 ;
   not_rtlc22n8435 <= NOT rtlc22n8435 ;
   rtlcn9964 <= CE AND not_rtlc22n8435 ;
   rtlc22n10733 <= rtlcn9923 OR rtlcn9964 ;
   not_rtlcn2081 <= NOT rtlcn2081 ;
   rtlcn9966 <= CE AND not_rtlcn2081 ;
   rtlc22n10731 <= rtlcn9923 OR rtlcn9966 ;
   not_rtlcn2084 <= NOT rtlcn2084 ;
   rtlcn9968 <= CE AND not_rtlcn2084 ;
   rtlc22n10729 <= rtlcn9923 OR rtlcn9968 ;
   not_rtlcs60 <= NOT rtlcs60 ;
   rtlcn9918 <= MON_phase_go OR not_rtlcs60 ;
   rtlcn9917 <= CE AND Ack ;
   not_rtlc22n8856 <= NOT rtlc22n8856 ;
   not_rtlcs49 <= NOT rtlc60n5337 ;
   rtlcn9937 <= not_rtlc22n8856 OR not_rtlcs49 ;
   rtlcn9972 <= CE AND rtlcn9937 ;
   rtlcn9942 <= rtlcn9917 OR rtlcn9972 ;
   rtlcn9973 <= rtlcn9918 AND rtlcn9942 ;
   rtlc22n10721 <= rtlcn9923 OR rtlcn9973 ;
   not_rtlc22n8064 <= NOT rtlc22n8064 ;
   rtlc22n10718 <= CE AND not_rtlc22n8064 ;
   rtlcn9943 <= MON_SOM_phase(7) OR rtlcs47 ;
   rtlc22n10717 <= CE AND rtlcn9943 ;
   rtlc22n10716 <= CE AND rtlc22n9096 ;
   not_rtlc22n8436 <= NOT rtlc22n8436 ;
   rtlc22n10715 <= CE AND not_rtlc22n8436 ;
   not_rtlc22n8434 <= NOT rtlc22n8434 ;
   rtlc22n10658 <= CE AND not_rtlc22n8434 ;
   not_rtlc22n10316 <= NOT rtlc22n10316 ;
   not_rtlcn8854 <= NOT rtlcn8854 ;
   rtlc22n10640 <= CE AND not_rtlcn8854 ;
   rtlcn9982 <= CE AND rtlcn9981 ;
   rtlc22n10639 <= rtlc22n10640 OR rtlcn9982 ;
   rtlcn9984 <= CE AND rtlcn9983 ;
   rtlc22n10638 <= rtlc22n10640 OR rtlcn9984 ;
   rtlcn9986 <= CE AND rtlcn9985 ;
   rtlc22n10637 <= rtlc22n10640 OR rtlcn9986 ;
   not_rtlcn2468 <= NOT rtlcn2468 ;
   rtlcn9988 <= CE AND not_rtlcn2468 ;
   rtlc22n10636 <= rtlc22n10640 OR rtlcn9988 ;
   not_rtlcn2467 <= NOT rtlcn2467 ;
   rtlcn9990 <= CE AND not_rtlcn2467 ;
   rtlc22n10635 <= rtlc22n10640 OR rtlcn9990 ;
   not_rtlcn2466 <= NOT rtlcn2466 ;
   rtlcn9992 <= CE AND not_rtlcn2466 ;
   rtlc22n10634 <= rtlc22n10640 OR rtlcn9992 ;
   rtlcn9993 <= CE AND rtlcs48 ;
   rtlc22n10633 <= rtlc22n10640 OR rtlcn9993 ;
   not_rtlc22n8835 <= NOT rtlc22n8835 ;
   rtlc22n10608 <= CE AND not_rtlc22n8835 ;
   not_rtlc22n8834 <= NOT rtlc22n8834 ;
   rtlc22n10592 <= CE AND not_rtlc22n8834 ;
   not_rtlc22n8833 <= NOT rtlc22n8833 ;
   rtlc22n10591 <= CE AND not_rtlc22n8833 ;
   rtlc22n10590 <= CE AND MON_SOM_phase(7) ;
   rtlcn9944 <= SOM_phase_9 OR rtlcs66 ;
   rtlcn9997 <= CE AND rtlcn9944 ;
   rtlc22n10589 <= rtlc22n10633 OR rtlcn9997 ;
   not_rtlc22n8060 <= NOT rtlc22n8060 ;
   rtlc22n10573 <= CE AND not_rtlc22n8060 ;
   not_rtlc22n8059 <= NOT rtlc22n8059 ;
   rtlc22n10569 <= CE AND not_rtlc22n8059 ;
   not_rtlc22n8432 <= NOT rtlc22n8432 ;
   rtlc22n10566 <= CE AND not_rtlc22n8432 ;
   not_rtlc22n8431 <= NOT rtlc22n8431 ;
   rtlc22n10565 <= CE AND not_rtlc22n8431 ;
   not_rtlc22n8430 <= NOT rtlc22n8430 ;
   rtlc22n10564 <= CE AND not_rtlc22n8430 ;
   not_rtlc22n8429 <= NOT rtlc22n8429 ;
   rtlc22n10563 <= CE AND not_rtlc22n8429 ;
   not_rtlc22n8428 <= NOT rtlc22n8428 ;
   rtlc22n10562 <= CE AND not_rtlc22n8428 ;
   not_rtlc22n8427 <= NOT rtlc22n8427 ;
   rtlc22n10561 <= CE AND not_rtlc22n8427 ;
   not_rtlc22n8426 <= NOT rtlc22n8426 ;
   rtlc22n10560 <= CE AND not_rtlc22n8426 ;
   rtlc22n10553 <= CE AND rtlcn10007 ;
   rtlc22n10537 <= CE AND rtlcn5529 ;
   not_rtlc22n7771 <= NOT rtlc22n7771 ;
   rtlcn10010 <= CE AND not_rtlc22n7771 ;
   rtlc22n10532 <= rtlc22n10537 OR rtlcn10010 ;
   not_rtlc22n7770 <= NOT rtlc22n7770 ;
   rtlcn10012 <= CE AND not_rtlc22n7770 ;
   rtlc22n10531 <= rtlc22n10537 OR rtlcn10012 ;
   not_rtlc22n7769 <= NOT rtlc22n7769 ;
   rtlcn10014 <= CE AND not_rtlc22n7769 ;
   rtlc22n10530 <= rtlc22n10537 OR rtlcn10014 ;
   rtlcn10016 <= CE AND rtlcn6091 ;
   rtlc22n10529 <= rtlc22n10537 OR rtlcn10016 ;
   not_EOM_phase_0 <= NOT EOM_phase(0) ;
   not_rtlcs64 <= NOT rtlcs64 ;
   rtlcn9926 <= not_EOM_phase_0 OR not_rtlcs64 ;
   rtlcn9930 <= not_rtlcs66 OR rtlc22n8398 ;
   not_rtlc22n10219 <= NOT rtlc22n10219 ;
   rtlcn10022 <= not_rtlc22n10219 AND rtlcn9930 ;
   rtlc_17497_or_640 : or_6u_6u port map ( a(5)=>rtlc22n10133, a(4)=>
      not_rtlc22n10342, a(3)=>rtlcn9926, a(2)=>rtlcn10022, a(1)=>
      not_rtlcn11031, a(0)=>rtlc60n5337, d=>rtlcn9945);
   rtlc22n10520 <= CE AND rtlcn9945 ;
   rtlc22n7393 <= not_Ack OR rtlcs103 ;
   not_SOM_phase_0 <= NOT SOM_phase_0 ;
   not_rtlcs102 <= NOT rtlcs102 ;
   not_MON_SOM_phase_0 <= NOT MON_SOM_phase(0) ;
   rtlcn10032 <= not_rtlc22n7221 AND rtlcn9931 ;
   rtlc_17508_or_641 : or_6u_6u port map ( a(5)=>MON_Phase(0), a(4)=>
      rtlcn9926, a(3)=>not_SOM_phase_0, a(2)=>not_rtlcs102, a(1)=>
      not_MON_SOM_phase_0, a(0)=>rtlcn10032, d=>rtlcn9946);
   rtlc22n10504 <= CE AND rtlcn9946 ;
   not_rtlc26n16381 <= NOT rtlc26n16381 ;
   rtlcn9932 <= eBC_Conditions_11 OR not_rtlc26n16381 ;
   rtlc26n17097 <= CE AND rtlcn10035 ;
   not_rtlcn2497 <= NOT rtlcn2497 ;
   rtlc26n17091 <= not_rtlcn2497 AND rtlcn9917 ;
   rtlcn9919 <= rtlc26n13816 OR NOT_BC_State_59 ;
   not_BC_State_83 <= NOT BC_State(83) ;
   rtlcn10039 <= CE AND not_BC_State_83 ;
   rtlcn9938 <= rtlcn9917 OR rtlcn10039 ;
   not_rtlc26n13816 <= NOT rtlc26n13816 ;
   not_rtlcn2524 <= NOT rtlcn2524 ;
   rtlcn9933 <= rtlc26n13371 OR not_rtlcn2524 ;
   rtlc26n17069 <= CE AND rtlcn9947 ;
   rtlcn9927 <= not_BC_State_52 OR BC_reported_errors ;
   rtlcn10044 <= BC_reported_errors AND rtlcn9917 ;
   not_BC_State_13 <= NOT BC_State(13) ;
   rtlcn9948 <= rtlcn10044 OR rtlcn10046 ;
   rtlc26n17067 <= rtlc26n16356 AND rtlcn9948 ;
   not_BC_reported_errors <= NOT BC_reported_errors ;
   not_rtlc26n15481 <= NOT rtlc26n15481 ;
   rtlc26n17066 <= CE AND not_rtlc26n15481 ;
   not_BC_Write <= NOT BC_Write ;
   not_BC_State_44 <= NOT BC_State(44) ;
   rtlcn9924 <= not_BC_Write OR not_BC_State_44 ;
   not_rtlc26n19009 <= NOT rtlc26n19009 ;
   not_BC_State_15 <= NOT BC_State(15) ;
   rtlcn9925 <= not_rtlc26n19009 OR not_BC_State_15 ;
   not_BC_State_40 <= NOT BC_State(40) ;
   rtlcn9939 <= rtlcn10052 OR rtlcn10054 ;
   not_rtlcn2522 <= NOT rtlcn2522 ;
   rtlcn10057 <= CE AND not_rtlcn2522 ;
   rtlcn9949 <= rtlcn9917 OR rtlcn10057 ;
   rtlc26n17054 <= rtlc26n17317 AND rtlcn9949 ;
   not_rtlcn2520 <= NOT rtlcn2520 ;
   rtlcn10060 <= CE AND not_rtlcn2520 ;
   rtlcn9950 <= rtlcn9917 OR rtlcn10060 ;
   rtlc26n17038 <= rtlc26n17314 AND rtlcn9950 ;
   not_rtlc26n16321 <= NOT rtlc26n16321 ;
   rtlcn9914 <= Ack OR not_rtlc26n16321 ;
   rtlc22n7698 <= not_Ack OR not_rtlcs151 ;
   rtlcn9920 <= CE AND rtlc26n17300 ;
   rtlcn9922 <= rtlcn9914 AND rtlcn9920 ;
   rtlcn9941 <= NOT_BC_State_12 AND rtlcn9922 ;
   not_rtlc22n7698 <= NOT rtlc22n7698 ;
   rtlcn10068 <= not_rtlc22n7698 AND rtlcn9922 ;
   rtlc26n17016 <= rtlcn9941 OR rtlcn10068 ;
   rtlc22n7697 <= not_Ack OR not_Config_reg_3_14 ;
   not_rtlc22n7697 <= NOT rtlc22n7697 ;
   rtlcn10071 <= not_rtlc22n7697 AND rtlcn9922 ;
   rtlc26n17015 <= rtlcn9941 OR rtlcn10071 ;
   rtlc22n7696 <= not_Ack OR rtlcs152 ;
   not_rtlc22n7696 <= NOT rtlc22n7696 ;
   rtlcn10073 <= not_rtlc22n7696 AND rtlcn9922 ;
   rtlc26n17014 <= rtlcn9941 OR rtlcn10073 ;
   rtlcn10074 <= rtlc26n17300 AND rtlcn9917 ;
   not_rtlcn2512 <= NOT rtlcn2512 ;
   rtlcn10076 <= not_rtlcn2512 AND rtlcn9920 ;
   rtlc26n17013 <= rtlcn10074 OR rtlcn10076 ;
   not_BC_State_16 <= NOT BC_State(16) ;
   not_BC_State_17 <= NOT BC_State(17) ;
   not_BC_State_21 <= NOT BC_State(21) ;
   not_BC_State_23 <= NOT BC_State(23) ;
   not_BC_State_26 <= NOT BC_State(26) ;
   not_BC_State_27 <= NOT BC_State(27) ;
   not_BC_State_28 <= NOT BC_State(28) ;
   not_BC_State_29 <= NOT BC_State(29) ;
   not_BC_State_33 <= NOT BC_State(33) ;
   not_BC_State_34 <= NOT BC_State(34) ;
   not_BC_State_35 <= NOT BC_State(35) ;
   not_BC_State_41 <= NOT BC_State(41) ;
   not_BC_State_46 <= NOT BC_State(46) ;
   not_BC_State_50 <= NOT BC_State(50) ;
   not_BC_State_53 <= NOT BC_State(53) ;
   not_BC_State_55 <= NOT BC_State(55) ;
   not_BC_State_60 <= NOT BC_State(60) ;
   not_BC_State_61 <= NOT BC_State(61) ;
   not_BC_State_64 <= NOT BC_State(64) ;
   not_BC_State_66 <= NOT BC_State(66) ;
   not_BC_State_67 <= NOT BC_State(67) ;
   not_BC_State_68 <= NOT BC_State(68) ;
   not_BC_State_69 <= NOT BC_State(69) ;
   not_BC_State_70 <= NOT BC_State(70) ;
   not_BC_State_72 <= NOT BC_State(72) ;
   not_BC_State_76 <= NOT BC_State(76) ;
   not_BC_State_77 <= NOT BC_State(77) ;
   not_BC_State_78 <= NOT BC_State(78) ;
   not_BC_State_80 <= NOT BC_State(80) ;
   not_BC_State_81 <= NOT BC_State(81) ;
   not_BC_State_82 <= NOT BC_State(82) ;
   not_BC_State_85 <= NOT BC_State(85) ;
   not_BC_State_89 <= NOT BC_State(89) ;
   not_BC_State_90 <= NOT BC_State(90) ;
   not_BC_State_91 <= NOT BC_State(91) ;
   not_rtlcn9940 <= NOT rtlcn9940 ;
   rtlc_17633_and_651 : and_44u_44u port map ( a(43)=>CE, a(42)=>
      NOT_BC_State_59, a(41)=>not_BC_State_15, a(40)=>not_BC_State_40, a(39)
      =>not_BC_State_44, a(38)=>not_BC_State_16, a(37)=>not_BC_State_17, 
      a(36)=>not_BC_State_21, a(35)=>not_BC_State_23, a(34)=>not_BC_State_24, 
      a(33)=>not_BC_State_26, a(32)=>not_BC_State_27, a(31)=>not_BC_State_28, 
      a(30)=>not_BC_State_29, a(29)=>not_BC_State_33, a(28)=>not_BC_State_34, 
      a(27)=>not_BC_State_35, a(26)=>not_BC_State_41, a(25)=>not_BC_State_46, 
      a(24)=>not_BC_State_50, a(23)=>not_BC_State_53, a(22)=>not_BC_State_55, 
      a(21)=>not_BC_State_57, a(20)=>not_BC_State_60, a(19)=>not_BC_State_61, 
      a(18)=>not_BC_State_63, a(17)=>not_BC_State_64, a(16)=>not_BC_State_66, 
      a(15)=>not_BC_State_67, a(14)=>not_BC_State_68, a(13)=>not_BC_State_69, 
      a(12)=>not_BC_State_70, a(11)=>not_BC_State_72, a(10)=>not_BC_State_76, 
      a(9)=>not_BC_State_77, a(8)=>not_BC_State_78, a(7)=>not_BC_State_80, 
      a(6)=>not_BC_State_81, a(5)=>not_BC_State_82, a(4)=>not_BC_State_85, 
      a(3)=>not_BC_State_89, a(2)=>not_BC_State_90, a(1)=>not_BC_State_91, 
      a(0)=>not_rtlcn9940, d=>rtlc26n16986);
   not_rtlcn2297 <= NOT rtlcn2297 ;
   rtlc26n16970 <= CE AND not_rtlcn2297 ;
   not_BC_State_7 <= NOT BC_State(7) ;
   rtlcn9951 <= BC_State(15) OR BC_State(18) ;
   rtlc26n16949 <= CE AND rtlcn9951 ;
   rtlcn10120 <= CE AND not_BC_State_32 ;
   rtlcn9952 <= rtlcn9917 OR rtlcn10120 ;
   rtlc26n16947 <= rtlc26n17289 AND rtlcn9952 ;
   rtlc26n16929 <= CE AND rtlcn10122 ;
   rtlcn9936 <= YES_45n2s2 OR not_rtlc26n16088 ;
   rtlc_17652_or_654 : or_4u_4u port map ( a(3)=>Clear_Intn_level, a(2)=>
      rtlc29n262, a(1)=>rtlc29n371, a(0)=>rtlc29n443, d=>rtlcn9953);
   rtlc29n642 <= CE AND rtlcn9953 ;
   not_rtlc32n583 <= NOT rtlc32n583 ;
   rtlc32n706 <= CE AND not_rtlc32n583 ;
   not_rtlc32n556 <= NOT rtlc32n556 ;
   rtlc32n705 <= CE AND not_rtlc32n556 ;
   not_rtlc32n555 <= NOT rtlc32n555 ;
   rtlc32n704 <= CE AND not_rtlc32n555 ;
   not_rtlc32n554 <= NOT rtlc32n554 ;
   rtlc32n703 <= CE AND not_rtlc32n554 ;
   not_rtlcn2479 <= NOT rtlcn2479 ;
   rtlcn9954 <= rtlc32n441 OR not_rtlcn2479 ;
   rtlc32n702 <= CE AND rtlcn9954 ;
   not_rtlc32n552 <= NOT rtlc32n552 ;
   rtlc32n701 <= CE AND not_rtlc32n552 ;
   not_rtlc32n551 <= NOT rtlc32n551 ;
   rtlc32n700 <= CE AND not_rtlc32n551 ;
   rtlcn9915 <= CE AND BC_Go_EXMPLR866 ;
   rtlcn10132 <= CE AND BC_FE_All_Errors ;
   rtlc38n63 <= rtlcn9915 OR rtlcn10132 ;
   rtlcn10133 <= CE AND rtlc41n105 ;
   rtlc41n353 <= rtlcn9915 OR rtlcn10133 ;
   rtlcn10134 <= CE AND status_set_dt ;
   rtlc41n352 <= rtlcn9915 OR rtlcn10134 ;
   rtlcn10135 <= CE AND rtlc41n132 ;
   rtlc41n351 <= rtlcn9915 OR rtlcn10135 ;
   rtlcn10136 <= CE AND BC_Response_timeout_Error ;
   rtlc41n350 <= rtlcn9915 OR rtlcn10136 ;
   rtlcn10137 <= CE AND rtlc41n148 ;
   rtlc41n349 <= rtlcn9915 OR rtlcn10137 ;
   rtlcn10138 <= CE AND Enhanced_status_set_dt ;
   rtlc41n348 <= rtlcn9915 OR rtlcn10138 ;
   rtlcn10139 <= CE AND rtlcs150 ;
   rtlc41n347 <= rtlcn9915 OR rtlcn10139 ;
   rtlcn10140 <= CE AND YES_45n2s1 ;
   rtlc41n346 <= rtlcn9915 OR rtlcn10140 ;
   rtlcn10141 <= CE AND BC_Found_wrong_RT_Address ;
   rtlc41n344 <= rtlcn9915 OR rtlcn10141 ;
   rtlcn10142 <= CE AND BC_Found_wrong_word_count ;
   rtlc41n343 <= rtlcn9915 OR rtlcn10142 ;
   rtlcn10143 <= CE AND BC_wrong_sync ;
   rtlc41n342 <= rtlcn9915 OR rtlcn10143 ;
   rtlcn10144 <= CE AND BC_Found_Format_Error ;
   rtlc41n341 <= rtlcn9915 OR rtlcn10144 ;
   rtlc44n315 <= rtlcn9915 OR rtlcn10145 ;
   not_BC_Go <= NOT BC_Go_EXMPLR866 ;
   rtlc44n314 <= rtlcn9915 OR rtlcn10146 ;
   rtlcn10148 <= rtlcn1228 AND not_rtlc48n339 ;
   rtlcn9955 <= BC_Load_msg_gap_counter OR rtlcn10148 ;
   rtlc48n253 <= CE AND rtlcn9955 ;
   not_BC_Load_msg_gap_counter <= NOT BC_Load_msg_gap_counter ;
   rtlc51n394 <= CE AND eBC_FT_Load ;
   rtlcn10150 <= rtlcn1227 AND not_rtlc51n502 ;
   rtlc51n378 <= CE AND rtlcn9956 ;
   not_BC_Load_frame_gap_counter <= NOT BC_Load_frame_gap_counter ;
   rtlc60n7497 <= CE AND First_Thing ;
   rtlc60n7496 <= rtlc60n6494 AND rtlcs240 ;
   not_rtlc60n6449 <= NOT rtlc60n6449 ;
   not_rtlc60n6448 <= NOT rtlc60n6448 ;
   not_rtlc60n6447 <= NOT rtlc60n6447 ;
   not_rtlc60n6446 <= NOT rtlc60n6446 ;
   not_rtlc60n6445 <= NOT rtlc60n6445 ;
   not_rtlc60n6444 <= NOT rtlc60n6444 ;
   not_rtlc60n6443 <= NOT rtlc60n6443 ;
   not_rtlc60n6442 <= NOT rtlc60n6442 ;
   rtlc60n5925 <= not_rtlc60n6494 OR not_rtlcn10264 ;
   not_rtlc60n5925 <= NOT rtlc60n5925 ;
   not_rtlc60n6054 <= NOT rtlc60n6054 ;
   not_rtlc60n5569 <= NOT rtlc60n5569 ;
   rtlc60n7463 <= rtlc60n6494 AND not_rtlc60n5569 ;
   rtlc60n7462 <= CE AND rtlcn9957 ;
   rtlc60n7461 <= test_complete OR rtlcn10156 ;
   not_CPU_Data_in_wide_23 <= NOT CPU_Data_in_wide(23) ;
   not_test_complete <= NOT test_complete ;
   rtlc60n7460 <= test_complete OR rtlcn10157 ;
   not_CPU_Data_in_wide_25 <= NOT CPU_Data_in_wide(25) ;
   not_rtlc60n5920 <= NOT rtlc60n5920 ;
   not_rtlc60n6053 <= NOT rtlc60n6053 ;
   not_rtlc60n6052 <= NOT rtlc60n6052 ;
   rtlc60n7455 <= rtlc60n6494 AND rtlcs265 ;
   not_rtlc60n5916 <= NOT rtlc60n5916 ;
   not_rtlc60n5915 <= NOT rtlc60n5915 ;
   not_rtlc60n5914 <= NOT rtlc60n5914 ;
   not_rtlcn2487 <= NOT rtlcn2487 ;
   rtlc60n7422 <= not_rtlc60n5914 OR not_rtlcn2487 ;
   not_rtlcn2485 <= NOT rtlcn2485 ;
   rtlc60n7421 <= not_rtlc60n5914 OR not_rtlcn2485 ;
   rtlc60n7420 <= rtlc60n6494 AND rtlcs252 ;
   rtlc60n7372 <= rtlc60n6494 AND rtlcs262 ;
   rtlc60n7370 <= CE OR rtlc60n7372 ;
   not_rtlc60n5906 <= NOT rtlc60n5906 ;
   rtlc60n7302 <= not_rtlc60n5906 OR not_rtlcn8835 ;
   not_rtlc60n6687 <= NOT rtlc60n6687 ;
   not_rtlc60n6686 <= NOT rtlc60n6686 ;
   not_rtlc60n6685 <= NOT rtlc60n6685 ;
   not_Config_reg_3_15 <= NOT Config_reg_3_15 ;
   not_rtlc60n5981 <= NOT rtlc60n5981 ;
   not_rtlc60n6684 <= NOT rtlc60n6684 ;
   not_First_Thing <= NOT First_Thing ;
   not_M1760_D <= NOT M1760_D ;
   not_rtlc60n5385 <= NOT rtlc60n5385 ;
   rtlc_17782_or_663 : or_4u_4u port map ( a(3)=>Config_reg_3_15, a(2)=>
      not_RT_On, a(1)=>rtlc60n5942, a(0)=>not_rtlc60n5385, d=>rtlc60n7285);
   not_rtlc60n6683 <= NOT rtlc60n6683 ;
   not_rtlc60n5905 <= NOT rtlc60n5905 ;
   not_rtlc60n5904 <= NOT rtlc60n5904 ;
   not_rtlc60n5903 <= NOT rtlc60n5903 ;
   not_Read_from_int_vec <= NOT Read_from_int_vec ;
   rtlc75n2896 <= not_Read_from_int_vec OR MIL1553_errors_transmitter_timout
    ;
   rtlc75n1438 <= not_CE OR Read_from_int_vec2 ;
   not_rtlc75n1438 <= NOT rtlc75n1438 ;
   rtlc75n2894 <= not_rtlc75n1438 OR eBC_Bad_Parity ;
   rtlc75n2892 <= not_rtlc75n1438 OR rtlc75n1848 ;
   rtlc75n2891 <= not_rtlc75n1438 OR eBC_Stack_error ;
   rtlc75n2890 <= not_rtlc75n1438 OR eBC_Bad_instruction ;
   rtlc75n2887 <= not_rtlc75n1438 OR Monitor_command_stack_half_pass ;
   rtlc75n2886 <= not_rtlc75n1438 OR Monitor_data_stack_half_pass ;
   not_rtlc75n1972 <= NOT rtlc75n1972 ;
   not_rtlc75n1971 <= NOT rtlc75n1971 ;
   not_rtlc75n1970 <= NOT rtlc75n1970 ;
   not_rtlc75n1969 <= NOT rtlc75n1969 ;
   rtlc75n2881 <= not_rtlc75n1969 OR BIT_Test_complete ;
   rtlcn9912 <= not_CE OR Read_from_int_vec ;
   not_rtlcn9912 <= NOT rtlcn9912 ;
   rtlc75n2877 <= MIL1553_errors_transmitter_timout OR not_rtlcn9912 ;
   rtlc75n2876 <= not_rtlcn9912 OR rtlc75n1547 ;
   rtlc75n2875 <= not_rtlcn9912 OR Monitor_command_stack_rollover ;
   rtlc75n2874 <= not_rtlcn9912 OR Monitor_data_stack_rollover ;
   rtlc75n2872 <= not_rtlcn9912 OR BC_Retry_pulse ;
   rtlc75n2870 <= not_rtlcn9912 OR rtlc75n1647 ;
   rtlc75n2869 <= not_rtlcn9912 OR rtlc75n1665 ;
   rtlc75n2868 <= not_rtlcn9912 OR rtlc75n1714 ;
   rtlc75n2867 <= not_rtlcn9912 OR rtlc75n1730 ;
   rtlc75n2866 <= not_rtlcn9912 OR rtlc75n1765 ;
   rtlc75n2865 <= not_rtlcn9912 OR rtlc75n1795 ;
   rtlc75n2864 <= not_rtlcn9912 OR rtlc75n1819 ;
   not_rtlcn10215 <= NOT rtlcn10215 ;
   rtlc75n2863 <= CE OR not_rtlcn10215 ;
   not_rtlcn10214 <= NOT rtlcn10214 ;
   rtlc75n2862 <= CE OR not_rtlcn10214 ;
   not_rtlc75n1968 <= NOT rtlc75n1968 ;
   rtlc75n2861 <= BIT_Test_complete OR not_rtlc75n1968 ;
   not_rtlc75n1493 <= NOT rtlc75n1493 ;
   rtlc75n2860 <= eBC_Bad_Parity OR not_rtlc75n1493 ;
   rtlc75n2858 <= rtlc75n1848 OR not_rtlc75n1493 ;
   rtlc75n2857 <= eBC_Stack_error OR not_rtlc75n1493 ;
   rtlc75n2856 <= eBC_Bad_instruction OR not_rtlc75n1493 ;
   rtlc75n2853 <= Monitor_command_stack_half_pass OR not_rtlc75n1493 ;
   rtlc75n2852 <= Monitor_data_stack_half_pass OR not_rtlc75n1493 ;
   not_rtlcn10219 <= NOT rtlcn10219 ;
   rtlc75n2851 <= not_rtlc75n1493 OR not_rtlcn10219 ;
   not_rtlcn10218 <= NOT rtlcn10218 ;
   rtlc75n2850 <= not_rtlc75n1493 OR not_rtlcn10218 ;
   not_rtlcn10217 <= NOT rtlcn10217 ;
   rtlc75n2849 <= not_rtlc75n1493 OR not_rtlcn10217 ;
   not_rtlcn10216 <= NOT rtlcn10216 ;
   rtlc75n2848 <= not_rtlc75n1493 OR not_rtlcn10216 ;
   rtlc75n2847 <= BIT_Test_complete OR not_rtlc75n1493 ;
   not_rtlc75n1492 <= NOT rtlc75n1492 ;
   rtlc75n2845 <= MIL1553_errors_transmitter_timout OR not_rtlc75n1492 ;
   rtlc75n2844 <= rtlc75n1547 OR not_rtlc75n1492 ;
   rtlc75n2843 <= Monitor_command_stack_rollover OR not_rtlc75n1492 ;
   rtlc75n2842 <= Monitor_data_stack_rollover OR not_rtlc75n1492 ;
   rtlc75n2840 <= BC_Retry_pulse OR not_rtlc75n1492 ;
   rtlc75n2838 <= rtlc75n1647 OR not_rtlc75n1492 ;
   rtlc75n2837 <= rtlc75n1665 OR not_rtlc75n1492 ;
   rtlc75n2836 <= rtlc75n1714 OR not_rtlc75n1492 ;
   rtlc75n2835 <= rtlc75n1730 OR not_rtlc75n1492 ;
   rtlc75n2834 <= rtlc75n1765 OR not_rtlc75n1492 ;
   rtlc75n2833 <= rtlc75n1795 OR not_rtlc75n1492 ;
   rtlc75n2832 <= rtlc75n1819 OR not_rtlc75n1492 ;
   rtlcn9913 <= rtlc78n119 OR rtlc78n145 ;
   rtlcn9916 <= CE AND rtlcn9913 ;
   rtlcn10184 <= CE AND MIL1553_errors_transmitter_timout ;
   rtlc78n400 <= rtlcn9916 OR rtlcn10184 ;
   rtlcn10185 <= CE AND MIL1553_errors_echo_back_bus_B ;
   rtlc78n399 <= rtlcn9916 OR rtlcn10185 ;
   rtlcn10186 <= CE AND MIL1553_errors_echo_back_bus_A ;
   rtlc78n398 <= rtlcn9916 OR rtlcn10186 ;
   rtlcn10187 <= CE AND MIL1553_errors_bus_B_shutdown ;
   rtlc78n396 <= rtlcn9916 OR rtlcn10187 ;
   rtlcn10188 <= CE AND MIL1553_errors_bus_A_shutdown ;
   rtlc78n395 <= rtlcn9916 OR rtlcn10188 ;
   rtlcn10189 <= CE AND MIL1553_errors_Inhibit_TF ;
   rtlc78n394 <= rtlcn9916 OR rtlcn10189 ;
   not_rtlcn2496 <= NOT rtlcn2496 ;
   rtlc84n251 <= Clear_Test_Status_reg OR not_rtlcn2496 ;
   not_rtlc84n141 <= NOT rtlc84n141 ;
   not_rtlcn2495 <= NOT rtlcn2495 ;
   rtlc84n247 <= Clear_Test_Status_reg OR not_rtlcn2495 ;
   not_rtlc84n179 <= NOT rtlc84n179 ;
   not_rtlc84n180 <= NOT rtlc84n180 ;
   not_rtlcs311 <= NOT rtlcs311 ;
   not_rtlcn1246 <= NOT rtlcn1246 ;
   rtlcn9921 <= CE AND WM_On ;
   rtlc87n716 <= rtlc87n628 AND rtlcn9921 ;
   rtlcn9928 <= state(6) OR state(7) ;
   rtlc87n699 <= rtlcn9921 AND rtlcn9928 ;
   rtlc87n684 <= rtlcn9921 AND rtlcn9958 ;
   rtlc_17930_or_667 : or_4u_4u port map ( a(3)=>BC_State(1), a(2)=>
      BC_State(22), a(1)=>BC_State(51), a(0)=>BC_State(52), d=>rtlcn9940);
   rtlc_17932_and_669 : and_6u_6u port map ( a(5)=>rtlc60n6494, a(4)=>
      CPU_WE_vec(0), a(3)=>not_CPU_Address_1, a(2)=>not_CPU_Address_2, a(1)
      =>CPU_Address(3), a(0)=>CPU_Address(4), d=>rtlc60n7388);
   eBC_Watchdog_eq0_51n5ss1 <= eBC_Watchdog_enable AND rtlcn10201 ;
   rtlc32n552 <= not_rtlc32n429 AND rtlcn10203 ;
   rtlc60n5559 <= rtlc60n5383 AND rtlcn10204 ;
   rtlc60n5905 <= not_CE AND rtlcn10205 ;
   rtlc60n5906 <= rtlc60n5385 AND rtlcn10206 ;
   rtlc60n5914 <= not_CE AND rtlcn10207 ;
   rtlc60n5915 <= rtlc60n5386 AND rtlcn10208 ;
   rtlc60n6052 <= rtlc60n5918 AND rtlcn3547 ;
   rtlc60n6053 <= rtlc60n5919 AND rtlcn3516 ;
   rtlc60n6054 <= rtlc60n5925 AND rtlcn10211 ;
   rtlc75n1492 <= rtlc75n1435 AND rtlcn10214 ;
   rtlc75n1493 <= rtlc75n1436 AND rtlcn10215 ;
   rtlc75n1969 <= rtlc75n1438 AND rtlcn10216 ;
   rtlc75n1970 <= rtlc75n1438 AND rtlcn10217 ;
   rtlc75n1971 <= rtlc75n1438 AND rtlcn10218 ;
   rtlc75n1972 <= rtlc75n1438 AND rtlcn10219 ;
   rtlc84n179 <= not_Clear_Test_Status_reg AND rtlcn10220 ;
   rtlc60n5916 <= rtlc60n5387 AND rtlcn10221 ;
   rtlc60n6449 <= rtlc60n5933 AND rtlcn10222 ;
   rtlc60n6448 <= rtlc60n5932 AND rtlcn10223 ;
   rtlc60n6447 <= rtlc60n5931 AND rtlcn10224 ;
   rtlc60n6446 <= rtlc60n5930 AND rtlcn10225 ;
   rtlc60n6445 <= rtlc60n5929 AND rtlcn10226 ;
   rtlc60n6444 <= rtlc60n5928 AND rtlcn10227 ;
   rtlc32n551 <= not_rtlc32n411 AND rtlcn10228 ;
   rtlc32n556 <= not_rtlc32n468 AND rtlcn10229 ;
   rtlc32n555 <= not_rtlc32n451 AND rtlcn10230 ;
   rtlc32n554 <= not_rtlc32n459 AND rtlcn10231 ;
   rtlc22n8432 <= rtlc22n8059 AND rtlcn10232 ;
   rtlcn2417 <= rtlcs257 OR not_rtlcn9867 ;
   rtlcn1229 <= MT_On_Async_60n27s3 OR Monitor_new_command ;
   Stack_rollover_interrupt_22n8s8 <= stack_pointer(10) AND 
   Stack_rollover_interrupt_22n8s6 ;
   Stack_rollover_interrupt_22n8s6 <= stack_pointer(9) AND 
   Stack_rollover_interrupt_22n8s4 ;
   Stack_rollover_interrupt_22n8s4 <= stack_pointer(8) AND 
   Stack_rollover_interrupt_22n8s2 ;
   Monitor_command_stack_half_pass_22n80s4 <= rtlcs11 AND 
   Monitor_command_stack_rollover_22n80s3 ;
   Monitor_command_stack_rollover_22n80s4 <= rtlcs13 AND 
   Monitor_command_stack_rollover_22n80s3 ;
   Monitor_command_stack_rollover_22n80s3 <= rtlcs14 AND 
   Monitor_command_stack_rollover_22n80s2 ;
   Monitor_command_stack_half_pass_22n80s3 <= rtlcs16 AND 
   Monitor_command_stack_rollover_22n80s2 ;
   Monitor_command_stack_rollover_22n80s2 <= rtlc22n11324 AND 
   Monitor_command_stack_rollover_22n80s1 ;
   Monitor_command_stack_half_pass_22n80s2 <= rtlcs19 AND 
   Monitor_command_stack_rollover_22n80s1 ;
   Monitor_data_stack_rollover_22n107s1 <= monitor_data_pointer(14) AND 
   Monitor_data_stack_rollover_22n107s2 ;
   Monitor_data_stack_half_pass_22n107s1 <= not_monitor_data_pointer_14 AND 
   Monitor_data_stack_rollover_22n107s2 ;
   Monitor_data_stack_rollover_22n107s2 <= monitor_data_pointer(13) AND 
   Monitor_data_stack_rollover_22n107s3 ;
   Monitor_data_stack_half_pass_22n107s2 <= not_monitor_data_pointer_13 AND 
   Monitor_data_stack_rollover_22n107s3 ;
   Monitor_data_stack_rollover_22n107s3 <= monitor_data_pointer(12) AND 
   Monitor_data_stack_rollover_22n107s4 ;
   Monitor_data_stack_half_pass_22n107s3 <= not_monitor_data_pointer_12 AND 
   Monitor_data_stack_rollover_22n107s4 ;
   Monitor_data_stack_rollover_22n107s4 <= monitor_data_pointer(11) AND 
   Monitor_data_stack_rollover_22n107s5 ;
   Monitor_data_stack_half_pass_22n107s4 <= not_monitor_data_pointer_11 AND 
   Monitor_data_stack_rollover_22n107s5 ;
   Monitor_data_stack_rollover_22n107s5 <= monitor_data_pointer(10) AND 
   Monitor_data_stack_rollover_22n107s6 ;
   Monitor_data_stack_half_pass_22n107s5 <= not_monitor_data_pointer_10 AND 
   Monitor_data_stack_rollover_22n107s6 ;
   Monitor_data_stack_rollover_22n107s6 <= monitor_data_pointer(9) AND 
   Monitor_data_stack_rollover_22n107s7 ;
   Monitor_data_stack_half_pass_22n107s6 <= not_monitor_data_pointer_9 AND 
   Monitor_data_stack_rollover_22n107s7 ;
   rtlcs51 <= rtlcs50 AND rtlcs52 ;
   rtlcs54 <= not_Config_reg_3_8 AND rtlcs53 ;
   rtlcs57 <= not_Config_reg_3_9 AND rtlcs56 ;
   rtlcs69 <= rtlcs68 AND rtlcs70 ;
   rtlcs71 <= rtlcs70 AND rtlcs72 ;
   rtlcs73 <= rtlcs72 AND rtlcs74 ;
   rtlcs75 <= rtlcs76 AND rtlcs74 ;
   rtlcs79 <= not_GMM_0 AND rtlcs78 ;
   rtlcs81 <= rtlcs78 AND rtlcs82 ;
   rtlcs83 <= rtlcs76 AND rtlcs82 ;
   rtlcs85 <= rtlcs84 AND rtlcs86 ;
   rtlcs87 <= rtlcs86 AND rtlcs88 ;
   rtlcs89 <= rtlcs88 AND rtlcs90 ;
   rtlcs91 <= rtlcs92 AND rtlcs90 ;
   rtlcs95 <= not_MM_0 AND rtlcs94 ;
   rtlcs97 <= rtlcs94 AND rtlcs98 ;
   rtlcs99 <= rtlcs92 AND rtlcs98 ;
   rtlcs105 <= eBC_FT_Load_26n148s1 AND rtlcs106 ;
   rtlcs108 <= rtlcs106 AND rtlcs109 ;
   rtlcs114 <= eBC_TT_do_26n148s1 AND rtlcs109 ;
   rtlcs117 <= rtlcs118 AND rtlcs119 ;
   rtlcs121 <= rtlcs120 AND rtlcs119 ;
   rtlcs120 <= rtlcs122 AND rtlcs123 ;
   rtlcs124 <= Data_o_temp(13) AND rtlcs123 ;
   rtlcs127 <= rtlcs131 AND rtlcs123 ;
   rtlcs123 <= Ack AND rtlcs133 ;
   rtlcs137 <= rtlcs138 AND rtlcs136 ;
   rtlcs139 <= rtlcs140 AND rtlcs136 ;
   rtlcs148 <= Config_reg_4_EXMPLR998(8) AND YES_45n2s2 ;
   rtlcs319 <= rtlcs159 AND rtlcs161 ;
   Current_command_is_sync_without_data_60n11s2 <= rtlcs319 AND rtlcs162 ;
   rtlcs159 <= Current_command(10) AND rtlcs158 ;
   rtlcs320 <= rtlcs161 AND rtlcs162 ;
   Current_command_is_sync_without_data_60n11s3 <= rtlcs320 AND rtlcs165 ;
   rtlcs165 <= Current_command(10) AND rtlcs164 ;
   rtlcs170 <= rtlcs171 AND rtlcs172 ;
   BC_SP_54n1s4 <= BC_Stack_pointer(10) AND BC_SP_54n1s3 ;
   BC_SP_54n1s3 <= BC_Stack_pointer(9) AND BC_SP_54n1s2 ;
   BC_SP_54n1s2 <= BC_Stack_pointer(8) AND BC_SP_54n1s1 ;
   rtlcs161 <= not_Current_command_4 AND rtlcs192 ;
   rtlcs225 <= rtlcs224 AND rtlcs226 ;
   rtlcs227 <= rtlcs224 AND rtlcs228 ;
   rtlcs224 <= CPU_Address(4) AND rtlcs230 ;
   rtlcs232 <= CPU_WE_vec(1) AND rtlcs231 ;
   rtlcs231 <= rtlcs234 AND rtlcs235 ;
   rtlcs236 <= rtlcs237 AND rtlcs228 ;
   rtlcs228 <= not_CPU_Address_3 AND rtlcs235 ;
   rtlcs240 <= CPU_WE_vec(1) AND rtlcs239 ;
   rtlcs239 <= rtlcs235 AND rtlcs242 ;
   rtlcs244 <= CPU_WE_vec(1) AND rtlcs243 ;
   rtlcs246 <= CPU_WE_vec(0) AND rtlcs243 ;
   rtlcs243 <= rtlcs234 AND rtlcs248 ;
   rtlcs250 <= rtlcs249 AND rtlcs226 ;
   rtlcs252 <= CPU_WE_vec(1) AND rtlcs251 ;
   rtlcs251 <= CPU_Address(3) AND rtlcs249 ;
   rtlcs249 <= not_CPU_Address_1 AND rtlcs248 ;
   rtlcs226 <= not_CPU_Address_3 AND rtlcs248 ;
   rtlcs257 <= rtlcs258 AND rtlcs234 ;
   rtlcs259 <= rtlcs234 AND rtlcs260 ;
   rtlcs262 <= CPU_WE_vec(1) AND rtlcs261 ;
   rtlcs261 <= rtlcs260 AND rtlcs242 ;
   rtlcs265 <= CPU_WE_vec(1) AND rtlcs264 ;
   rtlcs264 <= rtlcs258 AND rtlcs242 ;
   rtlcs267 <= rtlcs274 AND rtlcs258 ;
   rtlcs270 <= CPU_WE_vec(0) AND rtlcs269 ;
   rtlcs269 <= rtlcs258 AND rtlcs230 ;
   rtlcs272 <= rtlcs260 AND rtlcs230 ;
   rtlcs273 <= rtlcs274 AND rtlcs260 ;
   rtlcs277 <= Config_reg_2(7) AND rtlcs276 ;
   rtlcs289 <= rtlcs290 AND rtlcs285 ;
   rtlcs285 <= not_count_T_RESus_3 AND rtlcs292 ;
   rtlcs293 <= rtlcs292 AND rtlcs294 ;
   rtlcs294 <= count_T_RESus(3) AND rtlcs290 ;
   rtlcs290 <= count_T_RESus(2) AND rtlcs288 ;
   not_CPU_Address_3 <= NOT CPU_Address(3) ;
   rtlcs274 <= not_CPU_Address_1 AND not_CPU_Address_3 ;
   rtlcs260 <= not_CPU_Address_2 AND not_CPU_Address_4 ;
   Config_reg_1_60n43ss1_15 <= CPU_Data_in_wide(31) OR not_rtlcn2638 ;
   rtlcs230 <= CPU_Address(1) AND not_CPU_Address_3 ;
   rtlcn10206 <= not_rtlc60n5424 OR not_rtlc60n6494 ;
   Config_reg_1_60n43ss1_14 <= CPU_Data_in_wide(30) AND rtlcn2638 ;
   Config_reg_1_60n43ss1_12 <= CPU_Data_in_wide(28) AND rtlcn2638 ;
   Config_reg_1_60n43ss1_11 <= CPU_Data_in_wide(27) OR not_rtlcn2638 ;
   rtlc_18006_and_675 : and_5u_5u port map ( a(4)=>Current_command(9), a(3)
      =>Current_command(8), a(2)=>Current_command(7), a(1)=>
      Current_command(6), a(0)=>Current_command(5), d=>rtlcs164);
   not_Current_command_9 <= NOT Current_command(9) ;
   not_Current_command_8 <= NOT Current_command(8) ;
   not_Current_command_7 <= NOT Current_command(7) ;
   not_Current_command_6 <= NOT Current_command(6) ;
   not_Current_command_5 <= NOT Current_command(5) ;
   rtlc_18012_and_676 : and_5u_5u port map ( a(4)=>not_Current_command_9, 
      a(3)=>not_Current_command_8, a(2)=>not_Current_command_7, a(1)=>
      not_Current_command_6, a(0)=>not_Current_command_5, d=>rtlcs158);
   not_Current_command_3 <= NOT Current_command(3) ;
   not_Current_command_0 <= NOT Current_command(0) ;
   not_Current_command_2 <= NOT Current_command(2) ;
   not_Current_command_1 <= NOT Current_command(1) ;
   rtlcs192 <= not_Current_command_2 AND not_Current_command_1 ;
   rtlcs258 <= CPU_Address(2) AND not_CPU_Address_4 ;
   rtlcn9874 <= rtlc60n6560 OR rtlcn8835 ;
   rtlcs242 <= CPU_Address(3) AND not_CPU_Address_1 ;
   rtlcs235 <= CPU_Address(4) AND not_CPU_Address_2 ;
   rtlcn9889 <= rtlc26n15497 OR BC_Write ;
   Config_reg_1_60n43ss1_8 <= CPU_Data_in_wide(24) OR not_rtlcn2638 ;
   not_Config_reg_4_2 <= NOT Config_reg_4_EXMPLR998(2) ;
   not_Config_reg_4_0 <= NOT Config_reg_4_EXMPLR998(0) ;
   rtlcs237 <= CPU_WE_vec(1) AND not_CPU_Address_1 ;
   rtlcn9862 <= rtlcs236 OR rtlc60n5464 ;
   Clear_Test_Status_reg_60n43ss1 <= Clear_Test_Status_reg_60n33ss1 AND 
   rtlc60n6494 ;
   rtlcs154 <= not_Config_reg_1_15 AND not_Config_reg_1_14 ;
   Config_reg_1_60n43ss1_4 <= CPU_Data_in_wide(20) AND rtlcn2638 ;
   rtlcs234 <= CPU_Address(3) AND CPU_Address(1) ;
   rtlcs248 <= CPU_Address(4) AND CPU_Address(2) ;
   not_rtlcn10264 <= NOT rtlcn10264 ;
   not_BC_Rx_Data_7 <= NOT BC_Rx_Data(7) ;
   not_BC_Rx_Data_6 <= NOT BC_Rx_Data(6) ;
   not_BC_Rx_Data_5 <= NOT BC_Rx_Data(5) ;
   not_rtlc26n13678 <= NOT rtlc26n13678 ;
   BC_State_fsm_26n116ss1_54 <= not_Ack AND not_rtlc26n13678 ;
   BC_State_fsm_26n182ss1_54 <= BC_State_fsm_26n180ss1_54 AND 
   not_rtlc26n15497 ;
   BC_State_fsm_26n182ss1_53 <= rtlc26n13678 AND rtlcn3059 ;
   rtlcs136 <= BC_Num_Msgs_26n12s1(7) AND BC_Num_Msgs_26n12s1(5) ;
   rtlcn9888 <= rtlc26n14920 OR rtlcn8803 ;
   BC_State_fsm_26n182ss1_61 <= BC_State_fsm_26n69ss1_61 AND rtlcn3048 ;
   BC_State_fsm_26n182ss1_70 <= BC_State_fsm_26n69ss1_70 AND rtlcn3048 ;
   rtlcs106 <= BC_Echo_word(11) AND YES ;
   rtlcs109 <= BC_Echo_word(10) AND YES ;
   rtlcs122 <= BC_Num_Msgs_26n12s1(10) AND Data_o_temp(12) ;
   rtlcs133 <= not_Data_o_temp_14 AND BC_Num_Msgs_26n12s1(9) ;
   not_Data_o_temp_11 <= NOT Data_o_temp(11) ;
   rtlcs119 <= not_Data_o_temp_11 AND not_Data_o_temp_13 ;
   not_LIFO_Pointer_3 <= NOT LIFO_Pointer(3) ;
   not_LIFO_Pointer_2 <= NOT LIFO_Pointer(2) ;
   not_LIFO_Pointer_1 <= NOT LIFO_Pointer(1) ;
   not_LIFO_Pointer_0 <= NOT LIFO_Pointer(0) ;
   BC_State_fsm_26n182ss1_34 <= BC_State_fsm_26n69ss1_34 AND rtlcn3048 ;
   BC_State_fsm_26n182ss1_63 <= BC_State_fsm_26n69ss1_63 AND rtlcn3048 ;
   rtlcs131 <= not_Data_o_temp_12 AND Data_o_temp(10) ;
   not_Frame_length_reg_0xD_15 <= NOT Frame_length_reg_0xD(15) ;
   not_Frame_length_reg_0xD_14 <= NOT Frame_length_reg_0xD(14) ;
   not_Frame_length_reg_0xD_13 <= NOT Frame_length_reg_0xD(13) ;
   not_Frame_length_reg_0xD_12 <= NOT Frame_length_reg_0xD(12) ;
   not_Frame_length_reg_0xD_11 <= NOT Frame_length_reg_0xD(11) ;
   not_Frame_length_reg_0xD_10 <= NOT Frame_length_reg_0xD(10) ;
   not_Frame_length_reg_0xD_9 <= NOT Frame_length_reg_0xD(9) ;
   not_Frame_length_reg_0xD_8 <= NOT Frame_length_reg_0xD(8) ;
   not_Frame_length_reg_0xD_7 <= NOT Frame_length_reg_0xD(7) ;
   not_Frame_length_reg_0xD_6 <= NOT Frame_length_reg_0xD(6) ;
   not_Frame_length_reg_0xD_5 <= NOT Frame_length_reg_0xD(5) ;
   not_Frame_length_reg_0xD_4 <= NOT Frame_length_reg_0xD(4) ;
   not_Frame_length_reg_0xD_3 <= NOT Frame_length_reg_0xD(3) ;
   not_Frame_length_reg_0xD_2 <= NOT Frame_length_reg_0xD(2) ;
   not_Frame_length_reg_0xD_1 <= NOT Frame_length_reg_0xD(1) ;
   not_Frame_length_reg_0xD_0 <= NOT Frame_length_reg_0xD(0) ;
   frame_gap_eq_0_and_51i2 : and_16u_16u port map ( a(15)=>
      not_Frame_length_reg_0xD_15, a(14)=>not_Frame_length_reg_0xD_14, a(13)
      =>not_Frame_length_reg_0xD_13, a(12)=>not_Frame_length_reg_0xD_12, 
      a(11)=>not_Frame_length_reg_0xD_11, a(10)=>not_Frame_length_reg_0xD_10, 
      a(9)=>not_Frame_length_reg_0xD_9, a(8)=>not_Frame_length_reg_0xD_8, 
      a(7)=>not_Frame_length_reg_0xD_7, a(6)=>not_Frame_length_reg_0xD_6, 
      a(5)=>not_Frame_length_reg_0xD_5, a(4)=>not_Frame_length_reg_0xD_4, 
      a(3)=>not_Frame_length_reg_0xD_3, a(2)=>not_Frame_length_reg_0xD_2, 
      a(1)=>not_Frame_length_reg_0xD_1, a(0)=>not_Frame_length_reg_0xD_0, d
      =>frame_gap_eq_0_51n6s1);
   frame_gap_eq_0_51n5ss1 <= frame_gap_eq_0_51n5s1 OR not_eBC_start_FT ;
   not_Counter_100us_11 <= NOT Counter_100us(11) ;
   not_Counter_100us_10 <= NOT Counter_100us(10) ;
   not_Counter_100us_9 <= NOT Counter_100us(9) ;
   not_Counter_100us_8 <= NOT Counter_100us(8) ;
   not_Counter_100us_7 <= NOT Counter_100us(7) ;
   not_Counter_100us_6 <= NOT Counter_100us(6) ;
   not_Counter_100us_5 <= NOT Counter_100us(5) ;
   not_Counter_100us_4 <= NOT Counter_100us(4) ;
   not_Counter_100us_3 <= NOT Counter_100us(3) ;
   not_Counter_100us_2 <= NOT Counter_100us(2) ;
   not_Counter_100us_1 <= NOT Counter_100us(1) ;
   not_Counter_100us_0 <= NOT Counter_100us(0) ;
   rtlc_18171_and_685 : and_12u_12u port map ( a(11)=>not_Counter_100us_11, 
      a(10)=>not_Counter_100us_10, a(9)=>not_Counter_100us_9, a(8)=>
      not_Counter_100us_8, a(7)=>not_Counter_100us_7, a(6)=>
      not_Counter_100us_6, a(5)=>not_Counter_100us_5, a(4)=>
      not_Counter_100us_4, a(3)=>not_Counter_100us_3, a(2)=>
      not_Counter_100us_2, a(1)=>not_Counter_100us_1, a(0)=>
      not_Counter_100us_0, d=>rtlcs178);
   not_Data_o_temp_15 <= NOT Data_o_temp(15) ;
   BC_Load_msg_gap_counter_26n180ss1 <= Ack AND rtlc26n16119 ;
   gap_eq_0_48n3ss1 <= gap_eq_0_48n3s1 OR not_BC_Load_msg_gap_counter ;
   not_Micro_second_counter_4 <= NOT Micro_second_counter(4) ;
   not_Micro_second_counter_3 <= NOT Micro_second_counter(3) ;
   not_Micro_second_counter_2 <= NOT Micro_second_counter(2) ;
   not_Micro_second_counter_1 <= NOT Micro_second_counter(1) ;
   not_Micro_second_counter_0 <= NOT Micro_second_counter(0) ;
   rtlc_18193_and_687 : and_5u_5u port map ( a(4)=>
      not_Micro_second_counter_4, a(3)=>not_Micro_second_counter_3, a(2)=>
      not_Micro_second_counter_2, a(1)=>not_Micro_second_counter_1, a(0)=>
      not_Micro_second_counter_0, d=>rtlcs174);
   Config_reg_1_60n43ss1_5 <= CPU_Data_in_wide(21) AND rtlcn2638 ;
   rtlcn9876 <= rtlcn3058 OR rtlcn3059 ;
   BC_State_fsm_26n116ss1_52 <= Ack AND not_rtlc26n13678 ;
   rtlcn9891 <= rtlc26n15497 OR BC_State(56) ;
   not_Config_reg_3_13 <= NOT Config_reg_3_13 ;
   rtlcs152 <= not_Config_reg_3_14 AND not_Config_reg_3_13 ;
   rtlcs151 <= Config_reg_3_14 AND Config_reg_3_13 ;
   BC_State_fsm_26n182ss1_29 <= not_BC_Message_Active AND rtlcn3308 ;
   rtlcn9878 <= BC_State(20) OR rtlcn3301 ;
   BC_State_fsm_26n182ss1_20 <= BC_State_fsm_26n180ss1_20 AND 
   not_rtlc26n15497 ;
   BC_State_fsm_26n182ss1_21 <= rtlc26n13678 AND rtlcn3297 ;
   ReTry_count_26n180ss1(0) <= BC_Ram_data_26n30s4(0) AND rtlc26n16305 ;
   Config_reg_1_60n43ss1_10 <= CPU_Data_in_wide(26) AND rtlcn2638 ;
   ReTry_count_26n180ss1(1) <= BC_Ram_data_26n30s4(1) AND rtlc26n16305 ;
   not_ReTry_count_0 <= NOT ReTry_count(0) ;
   YES_45n2s2 <= not_ReTry_count_1 AND not_ReTry_count_0 ;
   YES_45n2s1 <= not_ReTry_count_1 AND ReTry_count(0) ;
   rtlcs150 <= ReTry_count(1) AND not_ReTry_count_0 ;
   eBC_GP_do_26n180ss1 <= BC_Echo_word(13) AND rtlcn3860 ;
   not_CPU_Data_in_wide_31 <= NOT CPU_Data_in_wide(31) ;
   rtlcs217 <= not_CPU_Data_in_wide_31 AND not_CPU_Data_in_wide_23 ;
   not_rtlcs232 <= NOT rtlcs232 ;
   rtlc60n5901 <= rtlcs217 OR not_rtlcs232 ;
   not_BC_msg_pointer_15 <= NOT BC_msg_pointer(15) ;
   not_BC_msg_pointer_7 <= NOT BC_msg_pointer(7) ;
   rtlcs209 <= not_BC_msg_pointer_15 AND not_BC_msg_pointer_7 ;
   not_rtlcn3857 <= NOT rtlcn3857 ;
   rtlcn10222 <= rtlcs209 OR not_rtlcn3857 ;
   rtlcs218 <= not_CPU_Data_in_wide_30 AND not_CPU_Data_in_wide_22 ;
   rtlc60n5900 <= rtlcs218 OR not_rtlcs232 ;
   not_BC_msg_pointer_14 <= NOT BC_msg_pointer(14) ;
   not_BC_msg_pointer_6 <= NOT BC_msg_pointer(6) ;
   rtlcs210 <= not_BC_msg_pointer_14 AND not_BC_msg_pointer_6 ;
   rtlcn10223 <= rtlcs210 OR not_rtlcn3857 ;
   not_CPU_Data_in_wide_29 <= NOT CPU_Data_in_wide(29) ;
   rtlcs219 <= not_CPU_Data_in_wide_29 AND not_CPU_Data_in_wide_21 ;
   rtlc60n5899 <= rtlcs219 OR not_rtlcs232 ;
   not_BC_msg_pointer_13 <= NOT BC_msg_pointer(13) ;
   not_BC_msg_pointer_5 <= NOT BC_msg_pointer(5) ;
   rtlcs211 <= not_BC_msg_pointer_13 AND not_BC_msg_pointer_5 ;
   rtlcn10224 <= rtlcs211 OR not_rtlcn3857 ;
   not_CPU_Data_in_wide_28 <= NOT CPU_Data_in_wide(28) ;
   rtlcs220 <= not_CPU_Data_in_wide_28 AND not_CPU_Data_in_wide_20 ;
   rtlc60n5898 <= rtlcs220 OR not_rtlcs232 ;
   not_BC_msg_pointer_12 <= NOT BC_msg_pointer(12) ;
   rtlcs212 <= not_BC_msg_pointer_12 AND not_BC_msg_pointer_4 ;
   rtlcn10225 <= rtlcs212 OR not_rtlcn3857 ;
   not_CPU_Data_in_wide_27 <= NOT CPU_Data_in_wide(27) ;
   rtlcs221 <= not_CPU_Data_in_wide_27 AND not_CPU_Data_in_wide_19 ;
   rtlc60n5897 <= rtlcs221 OR not_rtlcs232 ;
   not_BC_msg_pointer_11 <= NOT BC_msg_pointer(11) ;
   rtlcs213 <= not_BC_msg_pointer_11 AND not_BC_msg_pointer_3 ;
   rtlcn10226 <= rtlcs213 OR not_rtlcn3857 ;
   not_CPU_Data_in_wide_26 <= NOT CPU_Data_in_wide(26) ;
   rtlcs222 <= not_CPU_Data_in_wide_26 AND not_CPU_Data_in_wide_18 ;
   rtlc60n5896 <= rtlcs222 OR not_rtlcs232 ;
   not_BC_msg_pointer_10 <= NOT BC_msg_pointer(10) ;
   rtlcs214 <= not_BC_msg_pointer_10 AND not_BC_msg_pointer_2 ;
   rtlcn10227 <= rtlcs214 OR not_rtlcn3857 ;
   eBC_CMV_do_26n180ss1 <= Ack AND BC_State(88) ;
   rtlc_18306_or_690 : or_4u_4u port map ( a(3)=>eBC_CFT_do, a(2)=>
      eBC_CMT_do, a(1)=>eBC_CMV_do, a(0)=>eBC_GP_do, d=>rtlcn10454);
   not_rtlcn10454 <= NOT rtlcn10454 ;
   rtlcs223 <= not_CPU_Data_in_wide_25 AND not_CPU_Data_in_wide_17 ;
   rtlc60n5895 <= rtlcs223 OR not_rtlcs232 ;
   not_BC_msg_pointer_9 <= NOT BC_msg_pointer(9) ;
   rtlcs215 <= not_BC_msg_pointer_9 AND not_BC_msg_pointer_1 ;
   not_eBC_GP_do <= NOT eBC_GP_do ;
   rtlcn10213 <= rtlcs215 OR not_eBC_GP_do ;
   not_CPU_Data_in_wide_24 <= NOT CPU_Data_in_wide(24) ;
   not_CPU_Data_in_wide_16 <= NOT CPU_Data_in_wide(16) ;
   rtlcs275 <= not_CPU_Data_in_wide_24 AND not_CPU_Data_in_wide_16 ;
   rtlc60n5894 <= rtlcs275 OR not_rtlcs232 ;
   not_BC_msg_pointer_8 <= NOT BC_msg_pointer(8) ;
   rtlcs216 <= not_BC_msg_pointer_8 AND not_BC_msg_pointer_0 ;
   rtlcn10212 <= rtlcs216 OR not_eBC_GP_do ;
   not_BC_Echo_word_1 <= NOT BC_Echo_word(1) ;
   rtlc_18345_and_691 : and_4u_4u port map ( a(3)=>BC_Echo_word(3), a(2)=>
      BC_Echo_word(2), a(1)=>not_BC_Echo_word_1, a(0)=>BC_Echo_word(0), d=>
      rtlcs173);
   Config_reg_1_60n43ss1_3 <= CPU_Data_in_wide(19) AND rtlcn2638 ;
   rtlcn9877 <= rtlcn3296 OR rtlcn3297 ;
   Config_reg_1_60n43ss1_6 <= CPU_Data_in_wide(22) AND rtlcn2638 ;
   Config_reg_1_60n43ss1_7 <= CPU_Data_in_wide(23) OR not_rtlcn2638 ;
   rtlcn9890 <= rtlc26n13019 OR rtlc26n13005 ;
   BC_Num_Msgs_26n12ss1_10 <= BC_Num_Msgs_26n12s1(10) AND rtlcs151 ;
   BC_Num_Msgs_26n12ss1_9 <= BC_Num_Msgs_26n12s1(9) AND Config_reg_3_14 ;
   BC_Num_Msgs_26n12ss1_8 <= BC_Num_Msgs_26n12s1(8) AND rtlc26n15803 ;
   BC_word_number_26n180ss1(1) <= LIFO_Pointer_26n126s1(1) AND rtlcn2269 ;
   BC_word_number_26n180ss1(0) <= LIFO_Pointer_26n126s1(0) AND rtlcn2269 ;
   VARAM_D_26n172s1f2(4) <= VARAM_Q(4) AND BC_State(86) ;
   VARAM_D_26n172s1f2(3) <= VARAM_Q(3) AND BC_State(86) ;
   VARAM_D_26n172s1f2(2) <= VARAM_Q(2) AND BC_State(86) ;
   VARAM_D_26n172s1f2(1) <= VARAM_Q(1) AND BC_State(86) ;
   not_BC_State_86 <= NOT BC_State(86) ;
   VARAM_D_26n172s1f2(0) <= VARAM_Q(0) OR not_BC_State_86 ;
   eBC_FT_Load_26n148s1 <= BC_Echo_word(11) AND not_BC_Echo_word_10 ;
   eBC_FT_Load_26n180ss1 <= eBC_FT_Load_26n148s1 AND rtlcn3579 ;
   not_eBC_Frame_length_15 <= NOT eBC_Frame_length(15) ;
   not_eBC_Frame_length_14 <= NOT eBC_Frame_length(14) ;
   not_eBC_Frame_length_13 <= NOT eBC_Frame_length(13) ;
   not_eBC_Frame_length_12 <= NOT eBC_Frame_length(12) ;
   not_eBC_Frame_length_11 <= NOT eBC_Frame_length(11) ;
   not_eBC_Frame_length_10 <= NOT eBC_Frame_length(10) ;
   not_eBC_Frame_length_9 <= NOT eBC_Frame_length(9) ;
   not_eBC_Frame_length_8 <= NOT eBC_Frame_length(8) ;
   not_eBC_Frame_length_7 <= NOT eBC_Frame_length(7) ;
   not_eBC_Frame_length_6 <= NOT eBC_Frame_length(6) ;
   not_eBC_Frame_length_5 <= NOT eBC_Frame_length(5) ;
   not_eBC_Frame_length_4 <= NOT eBC_Frame_length(4) ;
   not_eBC_Frame_length_3 <= NOT eBC_Frame_length(3) ;
   not_eBC_Frame_length_2 <= NOT eBC_Frame_length(2) ;
   not_eBC_Frame_length_1 <= NOT eBC_Frame_length(1) ;
   not_eBC_Frame_length_0 <= NOT eBC_Frame_length(0) ;
   frame_gap_eq_0_and_51i3 : and_16u_16u port map ( a(15)=>
      not_eBC_Frame_length_15, a(14)=>not_eBC_Frame_length_14, a(13)=>
      not_eBC_Frame_length_13, a(12)=>not_eBC_Frame_length_12, a(11)=>
      not_eBC_Frame_length_11, a(10)=>not_eBC_Frame_length_10, a(9)=>
      not_eBC_Frame_length_9, a(8)=>not_eBC_Frame_length_8, a(7)=>
      not_eBC_Frame_length_7, a(6)=>not_eBC_Frame_length_6, a(5)=>
      not_eBC_Frame_length_5, a(4)=>not_eBC_Frame_length_4, a(3)=>
      not_eBC_Frame_length_3, a(2)=>not_eBC_Frame_length_2, a(1)=>
      not_eBC_Frame_length_1, a(0)=>not_eBC_Frame_length_0, d=>
      frame_gap_eq_0_51n5s1);
   not_BC_frame_GAP_counter_15 <= NOT BC_frame_GAP_counter(15) ;
   not_BC_frame_GAP_counter_14 <= NOT BC_frame_GAP_counter(14) ;
   not_BC_frame_GAP_counter_13 <= NOT BC_frame_GAP_counter(13) ;
   not_BC_frame_GAP_counter_12 <= NOT BC_frame_GAP_counter(12) ;
   not_BC_frame_GAP_counter_11 <= NOT BC_frame_GAP_counter(11) ;
   not_BC_frame_GAP_counter_10 <= NOT BC_frame_GAP_counter(10) ;
   not_BC_frame_GAP_counter_9 <= NOT BC_frame_GAP_counter(9) ;
   not_BC_frame_GAP_counter_8 <= NOT BC_frame_GAP_counter(8) ;
   not_BC_frame_GAP_counter_7 <= NOT BC_frame_GAP_counter(7) ;
   not_BC_frame_GAP_counter_6 <= NOT BC_frame_GAP_counter(6) ;
   not_BC_frame_GAP_counter_5 <= NOT BC_frame_GAP_counter(5) ;
   not_BC_frame_GAP_counter_4 <= NOT BC_frame_GAP_counter(4) ;
   not_BC_frame_GAP_counter_3 <= NOT BC_frame_GAP_counter(3) ;
   not_BC_frame_GAP_counter_2 <= NOT BC_frame_GAP_counter(2) ;
   not_BC_frame_GAP_counter_1 <= NOT BC_frame_GAP_counter(1) ;
   rtlcn9875 <= rtlc51n160 OR eBC_start_FT ;
   eBC_Watchdog_eq0_51n6ss1 <= eBC_Watchdog_eq0_51n5ss1 AND 
   not_BC_Load_frame_gap_counter ;
   not_rtlcn2772 <= NOT rtlcn2772 ;
   rtlcn10221 <= not_CPU_Data_in_wide_17 OR not_rtlcn2772 ;
   rtlcn9873 <= rtlc87n636 OR rtlcn2683 ;
   WM_Ack_87n14ss1 <= WM_Ack_87n13ss1 AND WM_On ;
   WM_RAM_Address_87n11ss1(15) <= Data_o_temp(15) AND Ack ;
   WM_RAM_Address_87n11ss1(14) <= Data_o_temp(14) AND Ack ;
   WM_RAM_Address_87n11ss1(13) <= Data_o_temp(13) AND Ack ;
   WM_RAM_Address_87n11ss1(12) <= Data_o_temp(12) AND Ack ;
   WM_RAM_Address_87n11ss1(11) <= Data_o_temp(11) AND Ack ;
   WM_RAM_Address_87n11ss1(10) <= Data_o_temp(10) AND Ack ;
   WM_RAM_Address_87n11ss1(9) <= Data_o_temp(9) AND Ack ;
   WM_RAM_Address_87n11ss1(8) <= Data_o_temp(8) OR not_Ack ;
   WM_RAM_Address_87n11ss1(7) <= Data_o_temp(7) AND Ack ;
   WM_RAM_Address_87n11ss1(6) <= Data_o_temp(6) AND Ack ;
   WM_RAM_Address_87n11ss1(5) <= Data_o_temp(5) AND Ack ;
   WM_RAM_Address_87n11ss1(4) <= Data_o_temp(4) AND Ack ;
   WM_RAM_Address_87n11ss1(3) <= Data_o_temp(3) AND Ack ;
   WM_RAM_Address_87n11ss1(2) <= Data_o_temp(2) AND Ack ;
   WM_RAM_Address_87n11ss1(1) <= Data_o_temp(1) AND Ack ;
   WM_RAM_Address_select_87i34 : select_3_3 port map ( a(2)=>rtlcn2625, a(1)
      =>state(5), a(0)=>rtlcn2624, b(2)=>debug_EXMPLR1003(15), b(1)=>PWR, 
      b(0)=>Data_o_temp(0), d=>WM_RAM_Address_87n13ss1(0));
   rtlcn10632 <= not_state_6 AND rtlc87n684 ;
   not_BC_word_number_1 <= NOT BC_word_number(1) ;
   rtlcs143 <= not_BC_word_number_1 AND BC_word_number(0) ;
   eBC_Inc_Q_pointer_26n180ss1 <= Ack AND rtlc26n16131 ;
   rtlcn10211 <= not_eBC_Inc_Q_pointer OR not_CE ;
   not_rtlcn4244 <= NOT rtlcn4244 ;
   WRD_req_32n14ss1 <= RT_On_EXMPLR924 AND not_rtlcn4244 ;
   rtlcn2479 <= not_WRD_req OR arbiter ;
   rtlcn2478 <= not_EOM_req OR WRD_req ;
   rtlcn10203 <= rtlcn2478 OR arbiter ;
   rtlcn9879 <= CPU_Data_in_wide(17) OR CPU_Data_in_wide(22) ;
   host_status_bits_60n46ss1_3 <= host_status_bits_60n45ss1_3 AND 
   RT_On_EXMPLR924 ;
   rtlcn2477 <= not_SOM_req OR EOM_req ;
   rtlcn10228 <= rtlcn2477 OR rtlcn10652 ;
   not_rtlcn4285 <= NOT rtlcn4285 ;
   MON_WR_req_32n14ss1 <= MT_On AND not_rtlcn4285 ;
   rtlcn2482 <= not_MON_WR_req OR SOM_req ;
   rtlcn10229 <= rtlcn2482 OR rtlcn8829 ;
   rtlcn2481 <= not_MON_EOM_req OR MON_WR_req ;
   rtlcn10230 <= rtlcn2481 OR rtlcn10654 ;
   rtlcn2480 <= not_MON_SOM_req OR MON_EOM_req ;
   rtlcn10231 <= rtlcn2480 OR rtlcn10655 ;
   not_rtlcn10656 <= NOT rtlcn10656 ;
   illegal_message_22n50ss1 <= illegal_message_22n31s1 AND rtlcn4554 ;
   rtlc22n7772 <= rtlcn9164 OR not_rtlc22n10084 ;
   rtlc_18567_and_699 : and_5u_5u port map ( a(4)=>Current_command(15), a(3)
      =>Current_command(14), a(2)=>Current_command(13), a(1)=>
      Current_command(12), a(0)=>Current_command(11), d=>rtlcs168);
   GMM_60n92ss1(2) <= Config_reg_6_11 AND rtlc60n6724 ;
   GMM_60n92ss1(1) <= Config_reg_6_10 AND rtlc60n6724 ;
   GMM_60n92ss1(0) <= Config_reg_6_9 AND rtlc60n6724 ;
   not_GMM_2 <= NOT GMM(2) ;
   not_GMM_1 <= NOT GMM(1) ;
   not_GMM_0 <= NOT GMM(0) ;
   not_LUT_Control_15 <= NOT LUT_Control(15) ;
   MM_22n112ss1(2) <= MM_22n111ss1(2) AND not_LUT_Control_15 ;
   MM_22n112ss1(1) <= MM_22n111ss1(1) AND not_LUT_Control_15 ;
   MM_22n112ss1(0) <= MM_22n111ss1(0) AND not_LUT_Control_15 ;
   not_MM_2 <= NOT MM(2) ;
   not_MM_1 <= NOT MM(1) ;
   not_MM_0 <= NOT MM(0) ;
   Ram_Address_22n25ss1(1) <= Ack OR rtlcs100 ;
   rtlcn9896 <= Arbiter_timeout OR MON_Phase(0) ;
   rtlcs48 <= MON_Phase(1) AND not_MON_Phase_0 ;
   rtlcs52 <= Config_reg_3_10 AND Config_reg_3_9 ;
   not_Config_reg_3_10 <= NOT Config_reg_3_10 ;
   not_Config_reg_3_9 <= NOT Config_reg_3_9 ;
   not_Config_reg_3_8 <= NOT Config_reg_3_8 ;
   not_rtlcs48 <= NOT rtlcs48 ;
   rtlcn2467 <= rtlc22n10405 OR not_rtlcs48 ;
   rtlcs50 <= Config_reg_3_10 AND Config_reg_3_8 ;
   rtlcn2468 <= rtlc22n10407 OR not_rtlcs48 ;
   rtlcs53 <= not_Config_reg_3_10 AND Config_reg_3_9 ;
   rtlcs56 <= not_Config_reg_3_10 AND Config_reg_3_8 ;
   rtlcn2466 <= rtlc22_PS506_n8983 OR not_rtlcs48 ;
   rtlc22n8835 <= rtlc22n8782 OR not_MON_SOM_phase_2 ;
   rtlcs60 <= not_MON_Phase_1 AND not_MON_Phase_0 ;
   rtlcn9893 <= Arbiter_timeout OR rtlc22n10482 ;
   rtlcs47 <= MON_Phase(1) AND MON_Phase(0) ;
   rtlcn9894 <= Arbiter_timeout OR MON_EOM_phase(0) ;
   rtlcs64 <= not_MON_EOM_phase_1 AND not_MON_EOM_phase_0 ;
   rtlcs61 <= MON_EOM_phase(1) AND MON_EOM_phase(0) ;
   rtlcn9895 <= Arbiter_timeout OR rtlc22n10309 ;
   rtlcn9897 <= Phase(0) OR Arbiter_timeout ;
   rtlcs65 <= Phase(1) AND Phase(0) ;
   not_Phase_0 <= NOT Phase(0) ;
   rtlcs102 <= not_Phase_1 AND not_Phase_0 ;
   rtlcn9892 <= rtlc22n10219 OR Arbiter_timeout ;
   not_SOM_phase_8 <= NOT SOM_phase_8 ;
   rtlc22n8059 <= not_rtlcn10656 OR not_SOM_phase_8 ;
   rtlcs88 <= MM(2) AND MM(1) ;
   rtlcs90 <= MM(2) AND MM(0) ;
   rtlcs72 <= GMM(2) AND GMM(1) ;
   rtlcs74 <= GMM(2) AND GMM(0) ;
   rtlcs86 <= MM(2) AND not_MM_0 ;
   rtlcs70 <= GMM(2) AND not_GMM_0 ;
   rtlcs92 <= not_MM_1 AND MM(0) ;
   rtlcs76 <= not_GMM_1 AND GMM(0) ;
   rtlcs84 <= MM(2) AND not_MM_1 ;
   rtlcs68 <= GMM(2) AND not_GMM_1 ;
   rtlcs94 <= not_MM_2 AND MM(1) ;
   rtlcs98 <= not_MM_2 AND MM(0) ;
   rtlcs78 <= not_GMM_2 AND GMM(1) ;
   rtlcs82 <= not_GMM_2 AND GMM(0) ;
   rtlcs66 <= Phase(1) AND not_Phase_0 ;
   data_pointer_22n46ss1(0) <= not_Current_command_10 OR BCR ;
   data_pointer_22n46ss1(1) <= Current_command(10) OR BCR ;
   data_pointer_22n48ss1(6) <= Data_o_temp(6) AND not_rtlc22n8022 ;
   data_pointer_22n48ss1(7) <= Data_o_temp(7) AND not_rtlc22n8022 ;
   data_pointer_22n48ss1(8) <= Data_o_temp(8) OR rtlc22n8022 ;
   rtlcs93 <= MM(1) AND MM(0) ;
   rtlcs77 <= GMM(1) AND GMM(0) ;
   data_pointer_22n48ss1(9) <= Data_o_temp(9) AND not_rtlc22n8022 ;
   data_pointer_22n48ss1(10) <= Data_o_temp(10) AND not_rtlc22n8022 ;
   data_pointer_22n48ss1(11) <= Data_o_temp(11) AND not_rtlc22n8022 ;
   rtlcn9901 <= rtlcs88 OR rtlcs72 ;
   data_pointer_22n48ss1(12) <= Data_o_temp(12) AND not_rtlc22n8022 ;
   rtlcn2464 <= not_rtlc22n8243 OR rtlc22n8221 ;
   rtlcn10232 <= rtlcn2464 OR rtlcn8669 ;
   data_pointer_22n48ss1(13) <= Data_o_temp(13) AND not_rtlc22n8022 ;
   rtlcs67 <= not_Phase_1 AND Phase(0) ;
   Ram_Address_22n4ss1_15 <= Ram_Address_22n2s1(15) OR First_After_Reset ;
   data_pointer_22n48ss1(15) <= Data_o_temp(15) AND not_rtlc22n8022 ;
   rtlcn9865 <= MON_SOM_phase(0) OR rtlcn5404 ;
   not_Do_once_4 <= NOT Do_once(4) ;
   not_Do_once_3 <= NOT Do_once(3) ;
   not_Do_once_2 <= NOT Do_once(2) ;
   not_Do_once_1 <= NOT Do_once(1) ;
   not_Do_once_0 <= NOT Do_once(0) ;
   rtlc_18741_and_703 : and_5u_5u port map ( a(4)=>not_Do_once_4, a(3)=>
      not_Do_once_3, a(2)=>not_Do_once_2, a(1)=>not_Do_once_1, a(0)=>
      not_Do_once_0, d=>rtlcs103);
   Ram_Address_22n4ss1_14 <= Ram_Address_22n2s1(14) OR First_After_Reset ;
   data_pointer_22n48ss1(14) <= Data_o_temp(14) AND not_rtlc22n8022 ;
   Ram_Address_22n4ss1_13 <= Ram_Address_22n2s1(13) OR First_After_Reset ;
   Ram_Address_22n4ss1_12 <= Ram_Address_22n2s1(12) OR First_After_Reset ;
   Ram_Address_22n4ss1_11 <= Ram_Address_22n2s1(11) OR First_After_Reset ;
   not_EOM_phase_1 <= NOT EOM_phase(1) ;
   rtlc22n7770 <= rtlc22n7697 OR not_EOM_phase_1 ;
   rtlc22n7769 <= rtlc22n7696 OR not_EOM_phase_1 ;
   rtlc22n7771 <= rtlc22n7698 OR not_EOM_phase_1 ;
   Ram_Address_22n4ss1_10 <= Ram_Address_22n2s1(10) OR First_After_Reset ;
   Config_reg_1_60n43ss1_13 <= CPU_Data_in_wide(29) AND rtlcn2638 ;
   rtlc_18760_select_704 : select_4_4 port map ( a(3)=>rtlcn5418, a(2)=>
      rtlcn5416, a(1)=>rtlcn8390, a(0)=>rtlcn8386, b(3)=>stack_pointer(9), 
      b(2)=>data_pointer(9), b(1)=>PWR, b(0)=>Ram_Address_22n2s1(9), d=>
      rtlcn10752);
   Ram_Address_22n54ss1_8 <= data_pointer(8) OR rtlc22n8275 ;
   rtlc_18763_select_705 : select_4_4 port map ( a(3)=>SOM_phase_1, a(2)=>
      rtlcn5730, a(1)=>rtlcn8405, a(0)=>rtlcn5392, b(3)=>not_BCR, b(2)=>
      Current_Area_B, b(1)=>PWR, b(0)=>Ram_Address_22n2s1(7), d=>rtlcn10753
   );
   rtlc_18765_select_706 : select_4_4 port map ( a(3)=>rtlcs102, a(2)=>
      rtlcn5418, a(1)=>rtlcn5738, a(0)=>rtlcn5416, b(3)=>rtlcn10753, b(2)=>
      stack_pointer(7), b(1)=>PWR, b(0)=>data_pointer(7), d=>rtlcn10754);
   rtlc_18767_select_707 : select_4_4 port map ( a(3)=>SOM_phase_1, a(2)=>
      rtlcn8412, a(1)=>rtlcn5690, a(0)=>rtlcn5392, b(3)=>Current_command(10), 
      b(2)=>PWR, b(1)=>stack_pointer(6), b(0)=>Ram_Address_22n2s1(6), d=>
      rtlcn10755);
   rtlc_18769_select_708 : select_5_5 port map ( a(4)=>rtlcs102, a(3)=>
      rtlcs67, a(2)=>rtlcn5418, a(1)=>rtlcn5837, a(0)=>rtlcn5838, b(4)=>
      Ram_Address_22n50ss1_5, b(3)=>Ram_Address_22n54ss1_5, b(2)=>
      stack_pointer(5), b(1)=>PWR, b(0)=>Current_command(10), d=>rtlcn10756
   );
   rtlc_18771_select_709 : select_5_5 port map ( a(4)=>rtlcs102, a(3)=>
      rtlcs67, a(2)=>rtlcn5418, a(1)=>rtlcn5877, a(0)=>rtlcn5878, b(4)=>
      Ram_Address_22n50ss1_4, b(3)=>Ram_Address_22n54ss1_4, b(2)=>
      stack_pointer(4), b(1)=>Current_command(9), b(0)=>PWR, d=>rtlcn10757);
   rtlc_18773_select_710 : select_5_5 port map ( a(4)=>rtlcs102, a(3)=>
      rtlcs67, a(2)=>rtlcn5418, a(1)=>rtlcn5877, a(0)=>rtlcn5921, b(4)=>
      Ram_Address_22n50ss1_3, b(3)=>Ram_Address_22n54ss1_3, b(2)=>
      stack_pointer(3), b(1)=>Current_command(8), b(0)=>PWR, d=>rtlcn10758);
   Ram_Address_22n84ss1_2 <= Current_Area_B OR rtlcn8867 ;
   rtlc_18776_select_711 : select_5_5 port map ( a(4)=>SOM_phase_0, a(3)=>
      SOM_phase_1, a(2)=>rtlcn5967, a(1)=>rtlcn5994, a(0)=>rtlcn5396, b(4)=>
      Ram_Address_22n27ss1(1), b(3)=>Current_command(5), b(2)=>
      Current_command(10), b(1)=>PWR, b(0)=>Current_command(6), d=>
      rtlcn10759);
   not_rtlcs67 <= NOT rtlcs67 ;
   rtlc22n8434 <= rtlc22n8328 OR not_rtlcs67 ;
   rtlcs162 <= not_Current_command_3 AND Current_command(0) ;
   not_Current_command_4 <= NOT Current_command(4) ;
   BIT_Word(1) <= Data_to_FE_EXMPLR999(1) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(8) <= Data_to_FE_EXMPLR999(8) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(12) <= Data_to_FE_EXMPLR999(12) AND Config_reg_4_EXMPLR998(15) ;
   BUSY_in_LUT_22n50ss1 <= BUSY_in_LUT_22n33s1 AND rtlcn6071 ;
   Clean_status_bits_60n76ss1 <= rtlcn7632 OR rtlcn6078 ;
   rtlcn2486 <= not_CPU_Data_in_wide_18 OR not_rtlc60n5464 ;
   rtlcn10207 <= rtlcn2486 OR not_rtlc60n6494 ;
   rtlcn2485 <= not_Read_from_int_vec OR rtlc60n6476 ;
   rtlcn10214 <= not_rtlcs270 OR not_rtlc60n6494 ;
   rtlc75_ISR1_during_clear_D_n498_13 <= not_Tx_Timeout_D AND 
   MIL1553_errors_transmitter_timout ;
   rtlc75_Interrupt_status_register_1_D_n493_13 <= 
   Interrupt_status_register_1_75n7ss1(13) OR 
   MIL1553_errors_transmitter_timout ;
   BC_SP_and_54i2 : and_6u_6u port map ( a(5)=>BC_Stack_pointer(7), a(4)=>
      BC_Stack_pointer(6), a(3)=>BC_Stack_pointer(5), a(2)=>
      BC_Stack_pointer(4), a(1)=>BC_Stack_pointer(3), a(0)=>
      BC_Stack_pointer(2), d=>BC_SP_54n1s1);
   Stack_rollover_interrupt_and_22i238 : and_6u_6u port map ( a(5)=>
      stack_pointer(7), a(4)=>stack_pointer(6), a(3)=>stack_pointer(5), a(2)
      =>stack_pointer(4), a(1)=>stack_pointer(3), a(0)=>stack_pointer(2), d
      =>Stack_rollover_interrupt_22n8s2);
   Stack_rollover_interrupt_22n27ss1 <= Stack_rollover_interrupt_22n8ss1
    AND rtlcn6091 ;
   rtlc75_Interrupt_status_register_1_D_n493_12 <= 
   Interrupt_status_register_1_75n7ss1(12) OR rtlc75n1547 ;
   rtlcs13 <= monitor_stack_pointer(13) AND monitor_stack_pointer(12) ;
   rtlcs14 <= monitor_stack_pointer(11) AND monitor_stack_pointer(10) ;
   Monitor_command_stack_rollover_and_22i239 : and_6u_6u port map ( a(5)=>
      monitor_stack_pointer(7), a(4)=>monitor_stack_pointer(6), a(3)=>
      monitor_stack_pointer(5), a(2)=>monitor_stack_pointer(4), a(1)=>
      monitor_stack_pointer(3), a(0)=>monitor_stack_pointer(2), d=>
      Monitor_command_stack_rollover_22n80s1);
   rtlcs62 <= MON_EOM_phase(1) AND not_MON_EOM_phase_0 ;
   Monitor_command_stack_rollover_22n85ss1 <= 
   Monitor_command_stack_rollover_22n80ss1 AND rtlcn6104 ;
   rtlc75_Interrupt_status_register_1_D_n493_11 <= 
   Interrupt_status_register_1_75n7ss1(11) OR Monitor_command_stack_rollover
    ;
   Monitor_data_stack_rollover_and_22i240 : and_9u_9u port map ( a(8)=>
      monitor_data_pointer(8), a(7)=>monitor_data_pointer(7), a(6)=>
      monitor_data_pointer(6), a(5)=>monitor_data_pointer(5), a(4)=>
      monitor_data_pointer(4), a(3)=>monitor_data_pointer(3), a(2)=>
      monitor_data_pointer(2), a(1)=>monitor_data_pointer(1), a(0)=>
      monitor_data_pointer(0), d=>Monitor_data_stack_rollover_22n107s7);
   Monitor_data_stack_rollover_22n108ss1 <= 
   Monitor_data_stack_rollover_22n107ss1 AND rtlcs48 ;
   rtlc75_Interrupt_status_register_1_D_n493_10 <= 
   Interrupt_status_register_1_75n7ss1(10) OR Monitor_data_stack_rollover ;
   rtlc75_Interrupt_status_register_1_D_n493_8 <= 
   Interrupt_status_register_1_75n7ss1(8) OR BC_Retry_pulse ;
   not_Monitor_Active_command_10 <= NOT Monitor_Active_command(10) ;
   not_Monitor_Active_command_9 <= NOT Monitor_Active_command(9) ;
   not_Monitor_Active_command_8 <= NOT Monitor_Active_command(8) ;
   not_Monitor_Active_command_7 <= NOT Monitor_Active_command(7) ;
   not_Monitor_Active_command_6 <= NOT Monitor_Active_command(6) ;
   not_Monitor_Active_command_5 <= NOT Monitor_Active_command(5) ;
   not_Monitor_Active_command_3 <= NOT Monitor_Active_command(3) ;
   not_Monitor_Active_command_2 <= NOT Monitor_Active_command(2) ;
   not_Monitor_Active_command_1 <= NOT Monitor_Active_command(1) ;
   rtlc_18866_and_718 : and_4u_4u port map ( a(3)=>
      not_Monitor_Active_command_3, a(2)=>not_Monitor_Active_command_2, a(1)
      =>not_Monitor_Active_command_1, a(0)=>Monitor_Active_command(0), d=>
      rtlcs199);
   rtlcn10208 <= not_rtlc60n5579 OR not_rtlc60n6494 ;
   rtlcn9887 <= rtlc60n5359 OR rtlc60n5324 ;
   not_Address_9 <= NOT Address(9) ;
   not_Address_8 <= NOT Address(8) ;
   not_Address_7 <= NOT Address(7) ;
   not_Address_6 <= NOT Address(6) ;
   not_Address_5 <= NOT Address(5) ;
   not_Address_3 <= NOT Address(3) ;
   not_Address_2 <= NOT Address(2) ;
   not_Address_1 <= NOT Address(1) ;
   Current_command_is_sync_with_data_and_60i144 : and_11u_11u port map ( 
      a(10)=>not_Address_10, a(9)=>not_Address_9, a(8)=>not_Address_8, a(7)
      =>not_Address_7, a(6)=>not_Address_6, a(5)=>not_Address_5, a(4)=>
      Address(4), a(3)=>not_Address_3, a(2)=>not_Address_2, a(1)=>
      not_Address_1, a(0)=>Address(0), d=>
      Current_command_is_sync_with_data_60n11s2);
   Current_command_is_sync_with_data_and_60i145 : and_11u_11u port map ( 
      a(10)=>not_Address_10, a(9)=>Address(9), a(8)=>Address(8), a(7)=>
      Address(7), a(6)=>Address(6), a(5)=>Address(5), a(4)=>Address(4), a(3)
      =>not_Address_3, a(2)=>not_Address_2, a(1)=>not_Address_1, a(0)=>
      Address(0), d=>Current_command_is_sync_with_data_60n11s3);
   eBC_TT_do_26n180ss1 <= eBC_TT_do_26n148s1 AND rtlcn3579 ;
   rtlcn9881 <= rtlc60n5464 OR rtlc60n5595 ;
   rtlcs276 <= Config_reg_2(9) AND Config_reg_2(8) ;
   Tag_CLK_D_60n5ss1 <= Tag_CLK AND rtlcs277 ;
   Tag_CLK_D_60n43ss1 <= Tag_CLK_D_60n5ss1 OR rtlcn6376 ;
   rtlcn2483 <= not_CPU_Data_in_wide_20 OR not_rtlc60n5464 ;
   rtlcn10205 <= rtlcn2483 OR not_rtlc60n6494 ;
   rtlc_18896_and_722 : and_5u_5u port map ( a(4)=>count_1us(4), a(3)=>
      count_1us(3), a(2)=>count_1us(2), a(1)=>count_1us(1), a(0)=>
      count_1us(0), d=>rtlcs308);
   not_Config_reg_2_9 <= NOT Config_reg_2(9) ;
   not_Config_reg_2_8 <= NOT Config_reg_2(8) ;
   not_Config_reg_2_7 <= NOT Config_reg_2(7) ;
   not_rtlcn8707 <= NOT rtlcn8707 ;
   count_T_RESus_60n43ss1(5) <= count_T_RESus_60n6s1(5) AND not_rtlcn8707 ;
   not_rtlcn10838 <= NOT rtlcn10838 ;
   rtlcn10204 <= not_CPU_Data_in_wide_19 OR not_rtlc60n5464 ;
   count_T_RESus_60n43ss1(3) <= count_T_RESus_60n6s1(3) AND not_rtlcn8707 ;
   count_T_RESus_60n43ss1(2) <= count_T_RESus_60n6s1(2) AND not_rtlcn8707 ;
   count_T_RESus_60n43ss1(1) <= count_T_RESus_60n6s1(1) AND not_rtlcn8707 ;
   count_T_RESus_60n43ss1(0) <= count_T_RESus_60n6s1(0) AND not_rtlcn8707 ;
   count_T_RESus_60n43ss1(4) <= count_T_RESus_60n6s1(4) AND not_rtlcn8707 ;
   rtlcs288 <= count_T_RESus(0) AND count_T_RESus(1) ;
   not_count_T_RESus_5 <= NOT count_T_RESus(5) ;
   not_count_T_RESus_4 <= NOT count_T_RESus(4) ;
   rtlcs292 <= not_count_T_RESus_5 AND not_count_T_RESus_4 ;
   not_count_T_RESus_3 <= NOT count_T_RESus(3) ;
   not_count_T_RESus_2 <= NOT count_T_RESus(2) ;
   not_count_T_RESus_1 <= NOT count_T_RESus(1) ;
   rtlcn9445 <= one_micro_increment_wide AND rtlc60n5176 ;
   not_time_tag_14 <= NOT time_tag_EXMPLR1002(14) ;
   not_time_tag_13 <= NOT time_tag_EXMPLR1002(13) ;
   not_time_tag_12 <= NOT time_tag_EXMPLR1002(12) ;
   not_time_tag_11 <= NOT time_tag_EXMPLR1002(11) ;
   not_time_tag_10 <= NOT time_tag_EXMPLR1002(10) ;
   not_time_tag_9 <= NOT time_tag_EXMPLR1002(9) ;
   not_time_tag_8 <= NOT time_tag_EXMPLR1002(8) ;
   not_time_tag_7 <= NOT time_tag_EXMPLR1002(7) ;
   not_time_tag_6 <= NOT time_tag_EXMPLR1002(6) ;
   not_time_tag_5 <= NOT time_tag_EXMPLR1002(5) ;
   not_time_tag_3 <= NOT time_tag_EXMPLR1002(3) ;
   not_time_tag_2 <= NOT time_tag_EXMPLR1002(2) ;
   not_time_tag_1 <= NOT time_tag_EXMPLR1002(1) ;
   not_time_tag_0 <= NOT time_tag_EXMPLR1002(0) ;
   rtlc_18967_and_730 : and_16u_16u port map ( a(15)=>not_time_tag_15, a(14)
      =>not_time_tag_14, a(13)=>not_time_tag_13, a(12)=>not_time_tag_12, 
      a(11)=>not_time_tag_11, a(10)=>not_time_tag_10, a(9)=>not_time_tag_9, 
      a(8)=>not_time_tag_8, a(7)=>not_time_tag_7, a(6)=>not_time_tag_6, a(5)
      =>not_time_tag_5, a(4)=>time_tag_EXMPLR1002(4), a(3)=>not_time_tag_3, 
      a(2)=>not_time_tag_2, a(1)=>not_time_tag_1, a(0)=>not_time_tag_0, d=>
      rtlcs311);
   rtlcn2494 <= not_rtlcs311 OR not_rtlcn1246 ;
   not_rtlc84n99 <= NOT rtlc84n99 ;
   rtlcn2496 <= rtlcn2494 OR not_rtlc84n99 ;
   not_Do_RAM_test <= NOT Do_RAM_test ;
   rtlcn10220 <= rtlcn2494 OR not_Do_RAM_test ;
   Test_Status_reg_84n4ss1(0) <= not_rtlcn1246 AND rtlc84n99 ;
   Test_Status_reg_84n7ss1(1) <= not_rtlcn1246 AND Do_RAM_test ;
   not_Monitor_Active_command_4 <= NOT Monitor_Active_command(4) ;
   rtlcn9880 <= rtlc60n5595 OR rtlcn6137 ;
   rtlc75_Interrupt_status_register_1_D_n493_6 <= 
   Interrupt_status_register_1_75n7ss1(6) OR rtlc75n1647 ;
   rtlc75_Interrupt_status_register_1_D_n493_5 <= 
   Interrupt_status_register_1_75n7ss1(5) OR rtlc75n1665 ;
   rtlcn9882 <= BC_State(54) OR rtlcn6637 ;
   rtlc75_Interrupt_status_register_1_D_n493_4 <= 
   Interrupt_status_register_1_75n7ss1(4) OR rtlc75n1714 ;
   rtlc75_Interrupt_status_register_1_D_n493_3 <= 
   Interrupt_status_register_1_75n7ss1(3) OR rtlc75n1730 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_8 <= 
   Latched_Monitor_MIL1553_errors_5_22n1s6 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_6 <= 
   Latched_Monitor_MIL1553_errors_4_22n1s5 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_2 <= 
   Latched_Monitor_MIL1553_errors_1_22n1s2 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_4 <= 
   Latched_Monitor_MIL1553_errors_3_22n1s4 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_3 <= 
   Latched_Monitor_MIL1553_errors_2_22n1s3 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_1 <= 
   Latched_Monitor_MIL1553_errors_0_22n1s1 AND not_rtlcs61 ;
   Latched_Monitor_MIL1553_errors_22n85ss1_11 <= 
   Latched_Monitor_MIL1553_errors_6_22n1s8 AND not_rtlcs61 ;
   rtlc75_Interrupt_status_register_1_D_n493_2 <= 
   Interrupt_status_register_1_75n7ss1(2) OR rtlc75n1765 ;
   not_BC_Rx_Data_10 <= NOT BC_Rx_Data(10) ;
   not_BC_Rx_Data_9 <= NOT BC_Rx_Data(9) ;
   not_BC_Rx_Data_8 <= NOT BC_Rx_Data(8) ;
   rtlc75_Interrupt_status_register_1_D_n493_1 <= 
   Interrupt_status_register_1_75n7ss1(1) OR rtlc75n1795 ;
   rtlc75_Interrupt_status_register_1_D_n493_0 <= 
   Interrupt_status_register_1_75n7ss1(0) OR rtlc75n1819 ;
   rtlcn9883 <= rtlcn6681 OR rtlcn6679 ;
   reg_data_out_wide_75n71ss1(0) <= reg_data_out_wide_75n69ss1(0) AND CPU_CS
    ;
   eBC_IRQ_do_26n180ss1 <= not_BC_Echo_word_13 AND rtlcn3860 ;
   BIT_Test_complete_84n7ss1 <= Test_Status_reg_84n4ss1(1) OR 
   Test_Status_reg_84n7ss1(0) ;
   not_eBC_IRQ_do <= NOT eBC_IRQ_do ;
   rtlcn10216 <= not_BC_msg_pointer_0 OR not_eBC_IRQ_do ;
   rtlc75_Interrupt_status_register_2_D_n494_1 <= 
   Interrupt_status_register_2_75n7ss1_1 OR BIT_Test_complete ;
   Clean_status2_bits_60n78ss1 <= rtlcn7632 OR rtlcn6702 ;
   rtlcn2487 <= not_Read_from_int_vec2 OR rtlc60n6509 ;
   rtlcn10215 <= not_rtlcs246 OR not_rtlc60n6494 ;
   reg_data_out_wide_75n71ss1(1) <= reg_data_out_wide_75n69ss1(1) AND CPU_CS
    ;
   Interrupt_status_register_2_75n7ss1_2 <= 
   Interrupt_status_register_2_75n6s1_2 AND rtlcn6683 ;
   Interrupt_status_register_2_75n36ss1(0) <= 
   Interrupt_status_register_2_75n7ss1_2 OR rtlcn6690 ;
   reg_data_out_wide_75n71ss1(2) <= reg_data_out_wide_75n69ss1(2) AND CPU_CS
    ;
   rtlcn10217 <= not_BC_msg_pointer_1 OR not_eBC_IRQ_do ;
   Interrupt_status_register_2_75n36ss1(1) <= 
   Interrupt_status_register_2_75n7ss1_3 OR rtlcn6744 ;
   reg_data_out_wide_75n71ss1(3) <= reg_data_out_wide_75n69ss1(3) AND CPU_CS
    ;
   rtlcn10218 <= not_BC_msg_pointer_2 OR not_eBC_IRQ_do ;
   Interrupt_status_register_2_75n36ss1(2) <= 
   Interrupt_status_register_2_75n7ss1_4 OR rtlcn6769 ;
   reg_data_out_wide_75n71ss1(4) <= reg_data_out_wide_75n69ss1(4) AND CPU_CS
    ;
   rtlcn10219 <= not_BC_msg_pointer_3 OR not_eBC_IRQ_do ;
   Interrupt_status_register_2_75n36ss1(3) <= 
   Interrupt_status_register_2_75n7ss1_5 OR rtlcn6794 ;
   reg_data_out_wide_75n71ss1(5) <= reg_data_out_wide_75n69ss1(5) AND CPU_CS
    ;
   not_monitor_data_pointer_8 <= NOT monitor_data_pointer(8) ;
   Monitor_data_stack_half_pass_and_22i241 : and_9u_9u port map ( a(8)=>
      not_monitor_data_pointer_8, a(7)=>monitor_data_pointer(7), a(6)=>
      monitor_data_pointer(6), a(5)=>monitor_data_pointer(5), a(4)=>
      monitor_data_pointer(4), a(3)=>monitor_data_pointer(3), a(2)=>
      monitor_data_pointer(2), a(1)=>monitor_data_pointer(1), a(0)=>
      monitor_data_pointer(0), d=>Monitor_data_stack_half_pass_22n107s7);
   not_monitor_data_pointer_9 <= NOT monitor_data_pointer(9) ;
   not_monitor_data_pointer_10 <= NOT monitor_data_pointer(10) ;
   not_monitor_data_pointer_11 <= NOT monitor_data_pointer(11) ;
   not_monitor_data_pointer_12 <= NOT monitor_data_pointer(12) ;
   not_monitor_data_pointer_13 <= NOT monitor_data_pointer(13) ;
   not_monitor_data_pointer_14 <= NOT monitor_data_pointer(14) ;
   Monitor_data_stack_half_pass_22n108ss1 <= 
   Monitor_data_stack_half_pass_22n107ss1 AND rtlcs48 ;
   rtlc75_Interrupt_status_register_2_D_n494_6 <= 
   Interrupt_status_register_2_75n7ss1_6 OR Monitor_data_stack_half_pass ;
   reg_data_out_wide_75n71ss1(6) <= reg_data_out_wide_75n69ss1(6) AND CPU_CS
    ;
   not_monitor_stack_pointer_13 <= NOT monitor_stack_pointer(13) ;
   rtlcs11 <= monitor_stack_pointer(12) AND not_monitor_stack_pointer_13 ;
   not_monitor_stack_pointer_11 <= NOT monitor_stack_pointer(11) ;
   rtlcs16 <= monitor_stack_pointer(10) AND not_monitor_stack_pointer_11 ;
   not_monitor_stack_pointer_9 <= NOT monitor_stack_pointer(9) ;
   rtlcs19 <= monitor_stack_pointer(8) AND not_monitor_stack_pointer_9 ;
   not_monitor_stack_pointer_7 <= NOT monitor_stack_pointer(7) ;
   Monitor_command_stack_half_pass_and_22i242 : and_6u_6u port map ( a(5)=>
      not_monitor_stack_pointer_7, a(4)=>monitor_stack_pointer(6), a(3)=>
      monitor_stack_pointer(5), a(2)=>monitor_stack_pointer(4), a(1)=>
      monitor_stack_pointer(3), a(0)=>monitor_stack_pointer(2), d=>
      Monitor_command_stack_half_pass_22n80s1);
   Monitor_command_stack_half_pass_22n85ss1 <= 
   Monitor_command_stack_half_pass_22n80ss1 AND rtlcn6104 ;
   rtlc75_Interrupt_status_register_2_D_n494_7 <= 
   Interrupt_status_register_2_75n7ss1_7 OR Monitor_command_stack_half_pass
    ;
   reg_data_out_wide_75n71ss1(7) <= reg_data_out_wide_75n69ss1(7) AND CPU_CS
    ;
   reg_data_out_wide_75n71ss1(8) <= reg_data_out_wide_75n69ss1(8) AND CPU_CS
    ;
   reg_data_out_wide_75n71ss1(9) <= reg_data_out_wide_75n69ss1(9) AND CPU_CS
    ;
   rtlc75_Interrupt_status_register_2_D_n494_10 <= 
   Interrupt_status_register_2_75n7ss1_10 OR eBC_Bad_instruction ;
   reg_data_out_wide_75n71ss1(10) <= reg_data_out_wide_75n69ss1(10) AND 
   CPU_CS ;
   rtlc75_Interrupt_status_register_2_D_n494_11 <= 
   Interrupt_status_register_2_75n7ss1_11 OR eBC_Stack_error ;
   rtlcn2495 <= rtlcn1246 OR not_rtlc84n99 ;
   reg_data_out_wide_75n71ss1(11) <= reg_data_out_wide_75n69ss1(11) AND 
   CPU_CS ;
   rtlc75_Interrupt_status_register_2_D_n494_12 <= 
   Interrupt_status_register_2_75n7ss1_12 OR rtlc75n1848 ;
   reg_data_out_wide_75n71ss1(12) <= reg_data_out_wide_75n69ss1(12) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(13) <= reg_data_out_wide_75n69ss1(13) AND 
   CPU_CS ;
   eBC_Bad_Parity_26n180ss1 <= not_eBC_Bad_Parity_26n180s2 AND BC_State(76)
    ;
   Interrupt_status_register_2_75n26ss1(1) <= 
   Interrupt_status_register_2_75n7ss1_14 OR eBC_Bad_Parity ;
   reg_data_out_wide_75n71ss1(14) <= reg_data_out_wide_75n69ss1(14) AND 
   CPU_CS ;
   rtlcn9898 <= rtlc29n371 OR rtlc29n443 ;
   reg_data_out_wide_75n71ss1(15) <= reg_data_out_wide_75n69ss1(15) AND 
   CPU_CS ;
   not_Strobe_TT_D_1 <= NOT Strobe_TT_D(1) ;
   rtlcs309 <= not_Strobe_TT_D_1 AND Strobe_TT_D(0) ;
   rtlcn10962 <= BC_on_EXMPLR883 AND BC_Message_Active ;
   Config_reg_1_60n89ss1 <= rtlcn10962 OR rtlcn7037 ;
   reg_data_out_wide_75n71ss1(16) <= reg_data_out_wide_75n70ss1(0) AND 
   CPU_CS ;
   Config_reg_1_60n43ss1_1 <= CPU_Data_in_wide(17) AND rtlcn2638 ;
   reg_data_out_wide_75n71ss1(17) <= reg_data_out_wide_75n70ss1(1) AND 
   CPU_CS ;
   rtlcn10966 <= rtlcn7067 AND not_BC_IDLE ;
   Config_reg_1_60n84ss1 <= rtlcn7064 OR rtlcn10966 ;
   reg_data_out_wide_75n71ss1(18) <= reg_data_out_wide_75n70ss1(2) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(19) <= reg_data_out_wide_75n70ss1(3) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(20) <= reg_data_out_wide_75n70ss1(4) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(21) <= reg_data_out_wide_75n70ss1(5) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(22) <= reg_data_out_wide_75n70ss1(6) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(23) <= reg_data_out_wide_75n70ss1(7) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(24) <= reg_data_out_wide_75n70ss1(8) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(25) <= reg_data_out_wide_75n70ss1(9) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(26) <= reg_data_out_wide_75n70ss1(10) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(27) <= reg_data_out_wide_75n70ss1(11) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(28) <= reg_data_out_wide_75n70ss1(12) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(29) <= reg_data_out_wide_75n70ss1(13) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(30) <= reg_data_out_wide_75n70ss1(14) AND 
   CPU_CS ;
   reg_data_out_wide_75n71ss1(31) <= reg_data_out_wide_75n70ss1(15) AND 
   CPU_CS ;
   monitor_stack_pointer_plus4_inc12_22i243 : inc_12u_12u_0 port map ( cin=>
      PWR, a(11)=>monitor_stack_pointer(13), a(10)=>
      monitor_stack_pointer(12), a(9)=>monitor_stack_pointer(11), a(8)=>
      monitor_stack_pointer(10), a(7)=>monitor_stack_pointer(9), a(6)=>
      monitor_stack_pointer(8), a(5)=>monitor_stack_pointer(7), a(4)=>
      monitor_stack_pointer(6), a(3)=>monitor_stack_pointer(5), a(2)=>
      monitor_stack_pointer(4), a(1)=>monitor_stack_pointer(3), a(0)=>
      monitor_stack_pointer(2), d(11)=>monitor_stack_pointer_plus4_22n1s4_13, 
      d(10)=>monitor_stack_pointer_plus4_22n1s4_12, d(9)=>
      monitor_stack_pointer_plus4_22n1s4_11, d(8)=>
      monitor_stack_pointer_plus4_22n1s4_10, d(7)=>
      monitor_stack_pointer_plus4_22n1s4_9, d(6)=>
      monitor_stack_pointer_plus4_22n1s4_8, d(5)=>
      monitor_stack_pointer_plus4_22n1s4_7, d(4)=>
      monitor_stack_pointer_plus4_22n1s4_6, d(3)=>
      monitor_stack_pointer_plus4_22n1s4_5, d(2)=>
      monitor_stack_pointer_plus4_22n1s4_4, d(1)=>
      monitor_stack_pointer_plus4_22n1s4_3, d(0)=>
      monitor_stack_pointer_plus4_22n1s4_2, cout=>DANGLING(7));
   not_rtlcn11031 <= NOT rtlcn11031 ;
   BC_Sts_Word_41n13ss1_4 <= Good_data_block_recieved AND not_BC_Go ;
   rtlc_19175_select_739 : select_4_4 port map ( a(3)=>rtlc22n10342, a(2)=>
      MON_SOM_phase(5), a(1)=>rtlcn7184, a(0)=>MON_SOM_phase(7), b(3)=>
      Ram_data_i_22n85ss1(6), b(2)=>time_tag_EXMPLR1002(6), b(1)=>
      monitor_data_pointer(6), b(0)=>Monitor_Active_command(6), d=>
      rtlcn11034);
   Latched_Monitor_data_stack_rollover_22n85ss1 <= 
   Latched_Monitor_data_stack_rollover_22n1s1 AND not_rtlcs61 ;
   Latched_Monitor_ended_OK_22n85ss1 <= Latched_Monitor_ended_OK_22n1s1 AND 
   not_rtlcs61 ;
   Ram_data_i_inc5_22i244 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>
      Do_once(4), a(3)=>Do_once(3), a(2)=>Do_once(2), a(1)=>Do_once(1), a(0)
      =>Do_once(0), d(4)=>Ram_data_i_22n2s11(5), d(3)=>Ram_data_i_22n2s11(4), 
      d(2)=>Ram_data_i_22n2s11(3), d(1)=>Ram_data_i_22n2s11(2), d(0)=>
      Ram_data_i_22n2s11(1), cout=>DANGLING(8));
   rtlc_19183_select_741 : select_4_4 port map ( a(3)=>not_rtlc22n10133, 
      a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>rtlcn7235, b(3)=>
      Ram_data_i_22n27ss1(9), b(2)=>Current_command(9), b(1)=>
      time_tag_EXMPLR1002(9), b(0)=>data_pointer(9), d=>rtlcn11058);
   rtlc_19185_select_742 : select_4_4 port map ( a(3)=>not_rtlc22n10133, 
      a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>rtlcn7235, b(3)=>
      Ram_data_i_22n27ss1(10), b(2)=>Current_command(10), b(1)=>
      time_tag_EXMPLR1002(10), b(0)=>data_pointer(10), d=>rtlcn11059);
   rtlc_19187_select_743 : select_4_4 port map ( a(3)=>not_rtlc22n10133, 
      a(2)=>SOM_phase_6, a(1)=>SOM_phase_7, a(0)=>rtlcn7235, b(3)=>
      Ram_data_i_22n27ss1(12), b(2)=>Current_command(12), b(1)=>
      time_tag_EXMPLR1002(12), b(0)=>data_pointer(12), d=>rtlcn11060);
   rtlc_19191_select_744 : select_4_4 port map ( a(3)=>rtlc22n10429, a(2)=>
      not_rtlc22n10429, a(1)=>rtlcn7362, a(0)=>rtlcn7363, b(3)=>
      Ram_data_i_22n103ss1_14, b(2)=>Monitor_write_data(14), b(1)=>PWR, b(0)
      =>time_tag_EXMPLR1002(14), d=>rtlcn11062);
   rtlcn9885 <= BC_msg_pointer(2) OR BC_msg_pointer(3) ;
   not_rtlcn11108 <= NOT rtlcn11108 ;
   not_rtlc29n262 <= NOT rtlc29n262 ;
   Non_masked_Event_D_29n1ss1 <= Non_masked_Event AND not_rtlc29n262 ;
   not_INTn_count_3 <= NOT INTn_count(3) ;
   not_INTn_count_2 <= NOT INTn_count(2) ;
   not_INTn_count_1 <= NOT INTn_count(1) ;
   rtlc_19271_and_745 : and_5u_5u port map ( a(4)=>INTn_count(4), a(3)=>
      not_INTn_count_3, a(2)=>not_INTn_count_2, a(1)=>not_INTn_count_1, a(0)
      =>INTn_count(0), d=>rtlcs156);
   not_INTn_count_0 <= NOT INTn_count(0) ;
   rtlc_19277_and_746 : and_5u_5u port map ( a(4)=>not_INTn_count_4, a(3)=>
      not_INTn_count_3, a(2)=>not_INTn_count_2, a(1)=>not_INTn_count_1, a(0)
      =>not_INTn_count_0, d=>rtlcs157);
   not_Config_reg_5_10 <= NOT Config_reg_5(10) ;
   rtlcs307 <= not_Config_reg_5_10 AND Config_reg_5(9) ;
   rtlcs305 <= Config_reg_5(10) AND not_Config_reg_5_9 ;
   Ram_RE_22n103ss1 <= not_Ack AND rtlcn7433 ;
   rtlcn9470 <= not_rtlc22n10342 AND New_command_record ;
   mem_WE_vec(0) <= CPU_WE_vec(0) AND rtlc13n16 ;
   mem_WE_vec(1) <= CPU_WE_vec(1) AND rtlc13n16 ;
   one_micro_increment_60n16ss1 <= rtlcs308 AND CE ;
   not_BC_word_number_0 <= NOT BC_word_number(0) ;
   rtlcs142 <= BC_word_number(1) AND not_BC_word_number_0 ;
   not_BC_TX_Data_10 <= NOT BC_TX_Data_10_EXMPLR872 ;
   not_BC_TX_Data_3 <= NOT BC_TX_Data_3_EXMPLR879 ;
   not_BC_TX_Data_2 <= NOT BC_TX_Data_2_EXMPLR880 ;
   not_BC_TX_Data_1 <= NOT BC_TX_Data_1_EXMPLR881 ;
   rtlc_19313_and_747 : and_11u_11u port map ( a(10)=>not_BC_TX_Data_10, 
      a(9)=>BC_TX_Data_9_EXMPLR873, a(8)=>BC_TX_Data_8_EXMPLR874, a(7)=>
      BC_TX_Data_7_EXMPLR875, a(6)=>BC_TX_Data_6_EXMPLR876, a(5)=>
      BC_TX_Data_5_EXMPLR877, a(4)=>BC_TX_Data_4_EXMPLR878, a(3)=>
      not_BC_TX_Data_3, a(2)=>not_BC_TX_Data_2, a(1)=>not_BC_TX_Data_1, a(0)
      =>BC_TX_Data_0_EXMPLR882, d=>rtlcs145);
   not_BC_TX_Data_9 <= NOT BC_TX_Data_9_EXMPLR873 ;
   not_BC_TX_Data_8 <= NOT BC_TX_Data_8_EXMPLR874 ;
   not_BC_TX_Data_7 <= NOT BC_TX_Data_7_EXMPLR875 ;
   not_BC_TX_Data_6 <= NOT BC_TX_Data_6_EXMPLR876 ;
   not_BC_TX_Data_5 <= NOT BC_TX_Data_5_EXMPLR877 ;
   rtlc_19323_and_748 : and_11u_11u port map ( a(10)=>not_BC_TX_Data_10, 
      a(9)=>not_BC_TX_Data_9, a(8)=>not_BC_TX_Data_8, a(7)=>not_BC_TX_Data_7, 
      a(6)=>not_BC_TX_Data_6, a(5)=>not_BC_TX_Data_5, a(4)=>
      BC_TX_Data_4_EXMPLR878, a(3)=>not_BC_TX_Data_3, a(2)=>not_BC_TX_Data_2, 
      a(1)=>not_BC_TX_Data_1, a(0)=>BC_TX_Data_0_EXMPLR882, d=>rtlcs144);
   host_status_bits_60n46ss1_0 <= host_status_bits_60n45ss1_0 AND 
   RT_On_EXMPLR924 ;
   host_status_bits_60n91ss1(0) <= host_status_bits_60n46ss1_0 OR rtlcn7577
    ;
   host_status_bits_60n46ss1_1 <= Config_reg_1(2) AND rtlcn7585 ;
   host_status_bits_60n46ss1_2 <= host_status_bits_60n45ss1_2 AND 
   RT_On_EXMPLR924 ;
   host_status_bits_60n46ss1_4 <= Config_reg_1(5) AND rtlcn7585 ;
   host_status_bits_60n46ss1_5 <= Config_reg_1(6) AND rtlcn7585 ;
   host_status_bits_60n46ss1_6 <= Config_reg_1(7) AND rtlcn7585 ;
   host_status_bits_60n46ss1_7 <= Config_reg_1(8) AND rtlcn7585 ;
   host_status_bits_60n91ss1(1) <= host_status_bits_60n45ss1_8 AND 
   rtlcn11137 ;
   host_status_bits_60n46ss1_9 <= Config_reg_1(10) AND rtlcn7585 ;
   host_status_bits_60n46ss1_10 <= Config_reg_1(11) AND rtlcn7585 ;
   rtlcn10264 <= rtlcs236 OR rtlcs244 ;
   rtlcn10656 <= Ack OR rtlc22n8022 ;
   BC_Sts_Word_41n13ss1_13 <= NOT rtlcn11457 ;
   rtlcn11457 <= BC_BUS_A_EXMPLR865 OR BC_Go_EXMPLR866 ;
   reg_data_out_wide_select_75i146 : select_11_11 port map ( a(10)=>
      rtlcn12096, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>rtlcs257, a(6)=>
      rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>rtlcs269, a(2)=>
      rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(10)=>debug_EXMPLR1003(15), 
      b(9)=>debug_EXMPLR1003(15), b(8)=>Config_reg_6_8, b(7)=>
      Channel_Status(8), b(6)=>BC_GAP_to_next_msg_counter(8), b(5)=>
      reg_data_out_wide_75n50ss1(8), b(4)=>Config_reg_4_EXMPLR998(8), b(3)=>
      Interrupt_status_register_1(8), b(2)=>reg_data_out_wide_75n43ss1(8), 
      b(1)=>Config_reg_2(8), b(0)=>Interrupt_mask_register_1(8), d=>
      reg_data_out_wide_75n69ss1(8));
   reg_data_out_wide_select_75i147 : select_12_12 port map ( a(11)=>
      rtlcn12098, a(10)=>rtlcs231, a(9)=>rtlcs239, a(8)=>rtlcs224, a(7)=>
      rtlcs257, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      debug_EXMPLR1003(15), b(10)=>debug_EXMPLR1003(15), b(9)=>
      Config_reg_6_9, b(8)=>PWR, b(7)=>Channel_Status(9), b(6)=>
      BC_GAP_to_next_msg_counter(9), b(5)=>reg_data_out_wide_75n50ss1(9), 
      b(4)=>Config_reg_4_EXMPLR998(9), b(3)=>Interrupt_status_register_1(9), 
      b(2)=>reg_data_out_wide_75n43ss1(9), b(1)=>Config_reg_2(9), b(0)=>
      Interrupt_mask_register_1(9), d=>reg_data_out_wide_75n69ss1(9));
   reg_data_out_wide_select_75i11Bus171_13 : select_12_12 port map ( a(11)=>
      rtlcn12100, a(10)=>rtlcs251, a(9)=>rtlcs231, a(8)=>rtlcs239, a(7)=>
      rtlcs227, a(6)=>rtlcs264, a(5)=>rtlcs259, a(4)=>rtlcs261, a(3)=>
      rtlcs269, a(2)=>rtlcs267, a(1)=>rtlcs272, a(0)=>rtlcs273, b(11)=>
      debug_EXMPLR1003(15), b(10)=>Test_Status_reg_15, b(9)=>
      debug_EXMPLR1003(15), b(8)=>Config_reg_6_13, b(7)=>PWR, b(6)=>
      BC_GAP_to_next_msg_counter(13), b(5)=>reg_data_out_wide_75n50ss1(13), 
      b(4)=>Config_reg_4_EXMPLR998(13), b(3)=>
      Interrupt_status_register_1(13), b(2)=>reg_data_out_wide_75n43ss1(13), 
      b(1)=>Config_reg_2(13), b(0)=>Interrupt_mask_register_1(13), d=>
      reg_data_out_wide_75n69ss1(13));
   YES_45n2ss1 <= not_ReTry_count_1 AND rtlcs352 ;
   rtlcn10652 <= arbiter OR WRD_req ;
   rtlcn10654 <= SOM_req OR rtlcn8829 ;
   rtlcn10655 <= rtlcn8829 OR rtlcn8844 ;
   rtlcn11137 <= RT_On_EXMPLR924 AND rtlcn8835 ;
   rtlcn10035 <= Ack AND BC_State(83) ;
   rtlcn10122 <= Ack AND rtlc26n17286 ;
   rtlcn10007 <= Ack AND SOM_phase_4 ;
   rtlcn9985 <= rtlc22n10408 AND rtlcs48 ;
   rtlcn9983 <= rtlc22n10410 AND rtlcs48 ;
   rtlcn9981 <= rtlcs57 AND rtlcs48 ;
   Non_masked_Event_or_75i149 : or_10u_10u port map ( a(9)=>
      Non_masked_Event_75n3s3_1, a(8)=>Non_masked_Event_75n3s3_3, a(7)=>
      Non_masked_Event_75n3s3_4, a(6)=>Non_masked_Event_75n3s3_5, a(5)=>
      Non_masked_Event_75n3s3_6, a(4)=>Non_masked_Event_75n3s3_7, a(3)=>
      Non_masked_Event_75n3s3_10, a(2)=>Non_masked_Event_75n3s3_11, a(1)=>
      Non_masked_Event_75n3s3_12, a(0)=>Non_masked_Event_75n3s3_14, d=>
      Non_masked_Event_75n3s1);
   Non_masked_Event_or_75i150 : or_15u_15u port map ( a(14)=>
      Non_masked_Event_75n1s3_0, a(13)=>Non_masked_Event_75n1s3_1, a(12)=>
      Non_masked_Event_75n1s3_2, a(11)=>Non_masked_Event_75n1s3_3, a(10)=>
      Non_masked_Event_75n1s3_4, a(9)=>Non_masked_Event_75n1s3_5, a(8)=>
      Non_masked_Event_75n1s3_6, a(7)=>debug_EXMPLR1003(15), a(6)=>
      Non_masked_Event_75n1s3_8, a(5)=>debug_EXMPLR1003(15), a(4)=>
      Non_masked_Event_75n1s3_10, a(3)=>Non_masked_Event_75n1s3_11, a(2)=>
      Non_masked_Event_75n1s3_12, a(1)=>Non_masked_Event_75n1s3_13, a(0)=>
      debug_EXMPLR1003(15), d=>Non_masked_Event_75n1s1);
   rtlc60n7640 <= Config_reg_5(10) OR Config_reg_5(9) ;
   rtlcn12120 <= not_Config_reg_2_3 AND rtlcn9860 ;
   rtlcn12119 <= rtlcn12120 AND CE ;
   rtlcn12123 <= INTn_count(4) OR INTn_count(3) ;
   rtlcn12124 <= INTn_count(2) OR INTn_count(1) ;
   rtlcn12122 <= rtlcn12123 OR rtlcn12124 ;
   rtlcn12121 <= INTn_count(0) OR rtlcn12122 ;
   modgen_counter_INTn_count : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 port map ( 
      clock=>clock, q(4)=>INTn_count(4), q(3)=>INTn_count(3), q(2)=>
      INTn_count(2), q(1)=>INTn_count(1), q(0)=>INTn_count(0), clk_en=>
      rtlcn12119, aclear=>not_ResetN, sload=>rtlc29n609, data(4)=>
      debug_EXMPLR1003(15), data(3)=>debug_EXMPLR1003(15), data(2)=>
      debug_EXMPLR1003(15), data(1)=>debug_EXMPLR1003(15), data(0)=>PWR, 
      aset=>debug_EXMPLR1003(15), sclear=>rtlc29n518, updn=>PWR, cnt_en=>
      rtlcn12121);
   modgen_counter_Timeout_counter : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 port map ( clock=>
      clock, q(6)=>Timeout_counter(6), q(5)=>Timeout_counter(5), q(4)=>
      Timeout_counter(4), q(3)=>Timeout_counter(3), q(2)=>Timeout_counter(2), 
      q(1)=>Timeout_counter(1), q(0)=>Timeout_counter(0), clk_en=>CE, aclear
      =>not_ResetN, sload=>debug_EXMPLR1003(15), data(6)=>DANGLING(9), 
      data(5)=>DANGLING(10), data(4)=>DANGLING(11), data(3)=>DANGLING(12), 
      data(2)=>DANGLING(13), data(1)=>DANGLING(14), data(0)=>DANGLING(15), 
      aset=>debug_EXMPLR1003(15), sclear=>not_arbiter, updn=>PWR, cnt_en=>
      rtlc32n759);
   modgen_counter_Micro_second_counter : 
      counter_dn_sload_aclear_clock_clk_en_0_5 port map ( clock=>clock, q(4)
      =>Micro_second_counter(4), q(3)=>Micro_second_counter(3), q(2)=>
      Micro_second_counter(2), q(1)=>Micro_second_counter(1), q(0)=>
      Micro_second_counter(0), clk_en=>CE, aclear=>not_ResetN, sload=>
      rtlcn12131, data(4)=>PWR, data(3)=>PWR, data(2)=>rtlc48n177, data(1)=>
      PWR, data(0)=>PWR, aset=>debug_EXMPLR1003(15), sclear=>
      debug_EXMPLR1003(15), updn=>debug_EXMPLR1003(15), cnt_en=>PWR);
   modgen_counter_BC_GAP_to_next_msg_counter : 
      counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 port map ( 
      clock=>clock, q(15)=>BC_GAP_to_next_msg_counter(15), q(14)=>
      BC_GAP_to_next_msg_counter(14), q(13)=>BC_GAP_to_next_msg_counter(13), 
      q(12)=>BC_GAP_to_next_msg_counter(12), q(11)=>
      BC_GAP_to_next_msg_counter(11), q(10)=>BC_GAP_to_next_msg_counter(10), 
      q(9)=>BC_GAP_to_next_msg_counter(9), q(8)=>
      BC_GAP_to_next_msg_counter(8), q(7)=>BC_GAP_to_next_msg_counter(7), 
      q(6)=>BC_GAP_to_next_msg_counter(6), q(5)=>
      BC_GAP_to_next_msg_counter(5), q(4)=>BC_GAP_to_next_msg_counter(4), 
      q(3)=>BC_GAP_to_next_msg_counter(3), q(2)=>
      BC_GAP_to_next_msg_counter(2), q(1)=>BC_GAP_to_next_msg_counter(1), 
      q(0)=>BC_GAP_to_next_msg_counter(0), clk_en=>CE, aclear=>not_ResetN, 
      sload=>BC_Load_msg_gap_counter, data(15)=>Data_o_temp(15), data(14)=>
      Data_o_temp(14), data(13)=>Data_o_temp(13), data(12)=>Data_o_temp(12), 
      data(11)=>Data_o_temp(11), data(10)=>Data_o_temp(10), data(9)=>
      Data_o_temp(9), data(8)=>Data_o_temp(8), data(7)=>Data_o_temp(7), 
      data(6)=>Data_o_temp(6), data(5)=>Data_o_temp(5), data(4)=>
      Data_o_temp(4), data(3)=>Data_o_temp(3), data(2)=>Data_o_temp(2), 
      data(1)=>Data_o_temp(1), data(0)=>Data_o_temp(0), aset=>
      debug_EXMPLR1003(15), sclear=>rtlc48_X_0_n209, updn=>
      debug_EXMPLR1003(15), cnt_en=>rtlcn1228);
   modgen_counter_Counter_100us : counter_dn_sload_aclear_clock_clk_en_0_12
       port map ( clock=>clock, q(11)=>Counter_100us(11), q(10)=>
      Counter_100us(10), q(9)=>Counter_100us(9), q(8)=>Counter_100us(8), 
      q(7)=>Counter_100us(7), q(6)=>Counter_100us(6), q(5)=>Counter_100us(5), 
      q(4)=>Counter_100us(4), q(3)=>Counter_100us(3), q(2)=>Counter_100us(2), 
      q(1)=>Counter_100us(1), q(0)=>Counter_100us(0), clk_en=>CE, aclear=>
      not_ResetN, sload=>rtlcn12136, data(11)=>PWR, data(10)=>PWR, data(9)=>
      debug_EXMPLR1003(15), data(8)=>debug_EXMPLR1003(15), data(7)=>
      debug_EXMPLR1003(15), data(6)=>PWR, data(5)=>PWR, data(4)=>PWR, 
      data(3)=>PWR, data(2)=>PWR, data(1)=>not_rtlc51n276, data(0)=>
      not_rtlc51n276, aset=>debug_EXMPLR1003(15), sclear=>
      debug_EXMPLR1003(15), updn=>debug_EXMPLR1003(15), cnt_en=>PWR);
   modgen_counter_BC_frame_GAP_counter : 
      counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_16 port map ( 
      clock=>clock, q(15)=>BC_frame_GAP_counter(15), q(14)=>
      BC_frame_GAP_counter(14), q(13)=>BC_frame_GAP_counter(13), q(12)=>
      BC_frame_GAP_counter(12), q(11)=>BC_frame_GAP_counter(11), q(10)=>
      BC_frame_GAP_counter(10), q(9)=>BC_frame_GAP_counter(9), q(8)=>
      BC_frame_GAP_counter(8), q(7)=>BC_frame_GAP_counter(7), q(6)=>
      BC_frame_GAP_counter(6), q(5)=>BC_frame_GAP_counter(5), q(4)=>
      BC_frame_GAP_counter(4), q(3)=>BC_frame_GAP_counter(3), q(2)=>
      BC_frame_GAP_counter(2), q(1)=>BC_frame_GAP_counter(1), q(0)=>
      BC_frame_GAP_counter(0), clk_en=>CE, aclear=>not_ResetN, sload=>
      rtlc51n276, data(15)=>rtlcn12137(15), data(14)=>rtlcn12137(14), 
      data(13)=>rtlcn12137(13), data(12)=>rtlcn12137(12), data(11)=>
      rtlcn12137(11), data(10)=>rtlcn12137(10), data(9)=>rtlcn12137(9), 
      data(8)=>rtlcn12137(8), data(7)=>rtlcn12137(7), data(6)=>rtlcn12137(6), 
      data(5)=>rtlcn12137(5), data(4)=>rtlcn12137(4), data(3)=>rtlcn12137(3), 
      data(2)=>rtlcn12137(2), data(1)=>rtlcn12137(1), data(0)=>rtlcn12137(0), 
      aset=>debug_EXMPLR1003(15), sclear=>rtlc51_X_0_n319, updn=>
      debug_EXMPLR1003(15), cnt_en=>rtlcn1227);
   modgen_counter_count_1us : counter_up_sclear_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>count_1us(4), q(3)=>count_1us(3), q(2)
      =>count_1us(2), q(1)=>count_1us(1), q(0)=>count_1us(0), clk_en=>CE, 
      aclear=>not_ResetN, sload=>debug_EXMPLR1003(15), data(4)=>DANGLING(16), 
      data(3)=>DANGLING(17), data(2)=>DANGLING(18), data(1)=>DANGLING(19), 
      data(0)=>DANGLING(20), aset=>debug_EXMPLR1003(15), sclear=>rtlcs308, 
      updn=>PWR, cnt_en=>PWR);
   rtlc_19932_inc_757 : inc_15u_15u_0 port map ( cin=>PWR, a(14)=>
      monitor_data_pointer(14), a(13)=>monitor_data_pointer(13), a(12)=>
      monitor_data_pointer(12), a(11)=>monitor_data_pointer(11), a(10)=>
      monitor_data_pointer(10), a(9)=>monitor_data_pointer(9), a(8)=>
      monitor_data_pointer(8), a(7)=>monitor_data_pointer(7), a(6)=>
      monitor_data_pointer(6), a(5)=>monitor_data_pointer(5), a(4)=>
      monitor_data_pointer(4), a(3)=>monitor_data_pointer(3), a(2)=>
      monitor_data_pointer(2), a(1)=>monitor_data_pointer(1), a(0)=>
      monitor_data_pointer(0), d(14)=>rtlcn12140(14), d(13)=>rtlcn12140(13), 
      d(12)=>rtlcn12140(12), d(11)=>rtlcn12140(11), d(10)=>rtlcn12140(10), 
      d(9)=>rtlcn12140(9), d(8)=>rtlcn12140(8), d(7)=>rtlcn12140(7), d(6)=>
      rtlcn12140(6), d(5)=>rtlcn12140(5), d(4)=>rtlcn12140(4), d(3)=>
      rtlcn12140(3), d(2)=>rtlcn12140(2), d(1)=>rtlcn12140(1), d(0)=>
      rtlcn12140(0), cout=>DANGLING(21));
   rtlc_19948_inc_758 : inc_14u_14u_0 port map ( cin=>PWR, a(13)=>
      data_pointer(13), a(12)=>data_pointer(12), a(11)=>data_pointer(11), 
      a(10)=>data_pointer(10), a(9)=>data_pointer(9), a(8)=>data_pointer(8), 
      a(7)=>data_pointer(7), a(6)=>data_pointer(6), a(5)=>data_pointer(5), 
      a(4)=>data_pointer(4), a(3)=>data_pointer(3), a(2)=>data_pointer(2), 
      a(1)=>data_pointer(1), a(0)=>data_pointer(0), d(13)=>rtlcn12141(13), 
      d(12)=>rtlcn12141(12), d(11)=>rtlcn12141(11), d(10)=>rtlcn12141(10), 
      d(9)=>rtlcn12141(9), d(8)=>rtlcn12141(8), d(7)=>rtlcn12141(7), d(6)=>
      rtlcn12141(6), d(5)=>rtlcn12141(5), d(4)=>rtlcn12141(4), d(3)=>
      rtlcn12141(3), d(2)=>rtlcn12141(2), d(1)=>rtlcn12141(1), d(0)=>
      rtlcn12141(0), cout=>DANGLING(22));
   rtlcn12131 <= BC_Load_msg_gap_counter OR rtlcn1228 ;
   rtlcn12136 <= rtlc51n276 OR rtlc51_X_0_n289 ;
   not_rtlc51n276 <= NOT rtlc51n276 ;
   rtlcn12137(0) <= Frame_length_reg_0xD(0) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(0) ;
   rtlcn12137(1) <= Frame_length_reg_0xD(1) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(1) ;
   rtlcn12137(2) <= Frame_length_reg_0xD(2) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(2) ;
   rtlcn12137(3) <= Frame_length_reg_0xD(3) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(3) ;
   rtlcn12137(4) <= Frame_length_reg_0xD(4) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(4) ;
   rtlcn12137(5) <= Frame_length_reg_0xD(5) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(5) ;
   rtlcn12137(6) <= Frame_length_reg_0xD(6) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(6) ;
   rtlcn12137(7) <= Frame_length_reg_0xD(7) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(7) ;
   rtlcn12137(8) <= Frame_length_reg_0xD(8) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(8) ;
   rtlcn12137(9) <= Frame_length_reg_0xD(9) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(9) ;
   rtlcn12137(10) <= Frame_length_reg_0xD(10) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(10) ;
   rtlcn12137(11) <= Frame_length_reg_0xD(11) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(11) ;
   rtlcn12137(12) <= Frame_length_reg_0xD(12) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(12) ;
   rtlcn12137(13) <= Frame_length_reg_0xD(13) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(13) ;
   rtlcn12137(14) <= Frame_length_reg_0xD(14) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(14) ;
   rtlcn12137(15) <= Frame_length_reg_0xD(15) when BC_Load_frame_gap_counter
    = '1' else eBC_Frame_length(15) ;
   rtlcn12096 <= rtlcn2392 OR rtlcs243 ;
   rtlcn12098 <= rtlcn2412 OR rtlcs243 ;
   rtlcn12100 <= rtlcn2422 OR rtlcs243 ;
   YES_45n1ss1 <= BC_Echo_word(4) XOR YES_45n1s2 ;
   rtlcs352 <= BC_Echo_word(4) XOR ReTry_count(0) ;
   host_status_bits_60n45ss1_8 <= Config_reg_1(9) XOR rtlc60n5942 ;
   rtlc22n8249 <= NOT (data_pointer(13) XOR rtlcn12141(13)) ;
   rtlc22n8227 <= NOT (data_pointer(12) XOR rtlcn12141(12)) ;
   rtlc22n8205 <= NOT (data_pointer(11) XOR rtlcn12141(11)) ;
   rtlc22n8183 <= NOT (data_pointer(10) XOR rtlcn12141(10)) ;
   rtlc22n8161 <= NOT (data_pointer(9) XOR rtlcn12141(9)) ;
   rtlc22n8137 <= NOT (data_pointer(8) XOR rtlcn12141(8)) ;
   rtlc22n8113 <= NOT (data_pointer(7) XOR rtlcn12141(7)) ;
   rtlc44n263 <= NOT (BC_Rx_Data(4) XOR BC_Control_word_5) ;
   MT_On_Async_60n27s3 <= NOT (Config_reg_1(15) XOR Config_reg_1(14)) ;
   rtlceq_s738_eq_780 : eq_16u_16u port map ( a(15)=>VARAM_Q(15), a(14)=>
      VARAM_Q(14), a(13)=>VARAM_Q(13), a(12)=>VARAM_Q(12), a(11)=>
      VARAM_Q(11), a(10)=>VARAM_Q(10), a(9)=>VARAM_Q(9), a(8)=>VARAM_Q(8), 
      a(7)=>VARAM_Q(7), a(6)=>VARAM_Q(6), a(5)=>VARAM_Q(5), a(4)=>VARAM_Q(4), 
      a(3)=>VARAM_Q(3), a(2)=>VARAM_Q(2), a(1)=>VARAM_Q(1), a(0)=>VARAM_Q(0), 
      b(15)=>BC_msg_pointer(15), b(14)=>BC_msg_pointer(14), b(13)=>
      BC_msg_pointer(13), b(12)=>BC_msg_pointer(12), b(11)=>
      BC_msg_pointer(11), b(10)=>BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), 
      b(8)=>BC_msg_pointer(8), b(7)=>BC_msg_pointer(7), b(6)=>
      BC_msg_pointer(6), b(5)=>BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), 
      b(3)=>BC_msg_pointer(3), b(2)=>BC_msg_pointer(2), b(1)=>
      BC_msg_pointer(1), b(0)=>BC_msg_pointer(0), d=>rtlcs355);
   rtlceq_s740_eq_781 : eq_16u_16u port map ( a(15)=>
      BC_GAP_to_next_msg_counter(15), a(14)=>BC_GAP_to_next_msg_counter(14), 
      a(13)=>BC_GAP_to_next_msg_counter(13), a(12)=>
      BC_GAP_to_next_msg_counter(12), a(11)=>BC_GAP_to_next_msg_counter(11), 
      a(10)=>BC_GAP_to_next_msg_counter(10), a(9)=>
      BC_GAP_to_next_msg_counter(9), a(8)=>BC_GAP_to_next_msg_counter(8), 
      a(7)=>BC_GAP_to_next_msg_counter(7), a(6)=>
      BC_GAP_to_next_msg_counter(6), a(5)=>BC_GAP_to_next_msg_counter(5), 
      a(4)=>BC_GAP_to_next_msg_counter(4), a(3)=>
      BC_GAP_to_next_msg_counter(3), a(2)=>BC_GAP_to_next_msg_counter(2), 
      a(1)=>BC_GAP_to_next_msg_counter(1), a(0)=>
      BC_GAP_to_next_msg_counter(0), b(15)=>BC_msg_pointer(15), b(14)=>
      BC_msg_pointer(14), b(13)=>BC_msg_pointer(13), b(12)=>
      BC_msg_pointer(12), b(11)=>BC_msg_pointer(11), b(10)=>
      BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), b(8)=>BC_msg_pointer(8), 
      b(7)=>BC_msg_pointer(7), b(6)=>BC_msg_pointer(6), b(5)=>
      BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), b(3)=>BC_msg_pointer(3), 
      b(2)=>BC_msg_pointer(2), b(1)=>BC_msg_pointer(1), b(0)=>
      BC_msg_pointer(0), d=>rtlcs356);
   rtlceq_s742_eq_782 : eq_16u_16u port map ( a(15)=>
      BC_frame_GAP_counter(15), a(14)=>BC_frame_GAP_counter(14), a(13)=>
      BC_frame_GAP_counter(13), a(12)=>BC_frame_GAP_counter(12), a(11)=>
      BC_frame_GAP_counter(11), a(10)=>BC_frame_GAP_counter(10), a(9)=>
      BC_frame_GAP_counter(9), a(8)=>BC_frame_GAP_counter(8), a(7)=>
      BC_frame_GAP_counter(7), a(6)=>BC_frame_GAP_counter(6), a(5)=>
      BC_frame_GAP_counter(5), a(4)=>BC_frame_GAP_counter(4), a(3)=>
      BC_frame_GAP_counter(3), a(2)=>BC_frame_GAP_counter(2), a(1)=>
      BC_frame_GAP_counter(1), a(0)=>BC_frame_GAP_counter(0), b(15)=>
      BC_msg_pointer(15), b(14)=>BC_msg_pointer(14), b(13)=>
      BC_msg_pointer(13), b(12)=>BC_msg_pointer(12), b(11)=>
      BC_msg_pointer(11), b(10)=>BC_msg_pointer(10), b(9)=>BC_msg_pointer(9), 
      b(8)=>BC_msg_pointer(8), b(7)=>BC_msg_pointer(7), b(6)=>
      BC_msg_pointer(6), b(5)=>BC_msg_pointer(5), b(4)=>BC_msg_pointer(4), 
      b(3)=>BC_msg_pointer(3), b(2)=>BC_msg_pointer(2), b(1)=>
      BC_msg_pointer(1), b(0)=>BC_msg_pointer(0), d=>rtlcs357);
   WM_RAM_data_i_6_eq_87i35 : eq_5u_5u port map ( a(4)=>
      RT_Address_EXMPLR1000(4), a(3)=>RT_Address_EXMPLR1000(3), a(2)=>
      RT_Address_EXMPLR1000(2), a(1)=>RT_Address_EXMPLR1000(1), a(0)=>
      RT_Address_EXMPLR1000(0), b(4)=>WM_Word(15), b(3)=>WM_Word(14), b(2)=>
      WM_Word(13), b(1)=>WM_Word(12), b(0)=>WM_Word(11), d=>
      WM_RAM_data_i_6_87n9s3);
   rtlceq_s746_eq_784 : eq_16u_16u port map ( a(15)=>
      Frame_length_reg_0xD(15), a(14)=>Frame_length_reg_0xD(14), a(13)=>
      Frame_length_reg_0xD(13), a(12)=>Frame_length_reg_0xD(12), a(11)=>
      Frame_length_reg_0xD(11), a(10)=>Frame_length_reg_0xD(10), a(9)=>
      Frame_length_reg_0xD(9), a(8)=>Frame_length_reg_0xD(8), a(7)=>
      Frame_length_reg_0xD(7), a(6)=>Frame_length_reg_0xD(6), a(5)=>
      Frame_length_reg_0xD(5), a(4)=>Frame_length_reg_0xD(4), a(3)=>
      Frame_length_reg_0xD(3), a(2)=>Frame_length_reg_0xD(2), a(1)=>
      Frame_length_reg_0xD(1), a(0)=>Frame_length_reg_0xD(0), b(15)=>
      WM_Word(15), b(14)=>WM_Word(14), b(13)=>WM_Word(13), b(12)=>
      WM_Word(12), b(11)=>WM_Word(11), b(10)=>WM_Word(10), b(9)=>WM_Word(9), 
      b(8)=>WM_Word(8), b(7)=>WM_Word(7), b(6)=>WM_Word(6), b(5)=>WM_Word(5), 
      b(4)=>WM_Word(4), b(3)=>WM_Word(3), b(2)=>WM_Word(2), b(1)=>WM_Word(1), 
      b(0)=>WM_Word(0), d=>rtlcs359);
   rtlc87n429 <= NOT (WM_Descriptor(2) XOR eBC_Q_pointer(15)) ;
   rtlcn15001 <= EOM_phase(0) OR rtlcn7193 ;
   Ram_data_i_select_22i7Bus89_7 : select_4_4 port map ( a(3)=>rtlcn15001, 
      a(2)=>rtlc22n10068, a(1)=>EOM_phase(3), a(0)=>rtlcn7194, b(3)=>
      debug_EXMPLR1003(15), b(2)=>data_pointer(7), b(1)=>stack_pointer(7), 
      b(0)=>PWR, d=>Ram_data_i_22n27ss1(7));
   rtlcn15003 <= SOM_phase_1 OR rtlcn5392 ;
   not_rtlcn15003 <= NOT rtlcn15003 ;
   Ram_Address_select_22i249Bus95_5 : select_3_3 port map ( a(2)=>
      SOM_phase_1, a(1)=>rtlcn5392, a(0)=>not_rtlcn15003, b(2)=>
      Current_command(9), b(1)=>Ram_Address_22n2s1(5), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_Address_22n50ss1_5);
   Ram_Address_select_22i249Bus95_4 : select_3_3 port map ( a(2)=>
      SOM_phase_1, a(1)=>rtlcn5392, a(0)=>not_rtlcn15003, b(2)=>
      Current_command(8), b(1)=>Ram_Address_22n2s1(4), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_Address_22n50ss1_4);
   Ram_Address_select_22i249Bus95_3 : select_3_3 port map ( a(2)=>
      SOM_phase_1, a(1)=>rtlcn5392, a(0)=>not_rtlcn15003, b(2)=>
      Current_command(7), b(1)=>Ram_Address_22n2s1(3), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_Address_22n50ss1_3);
   rtlcn15009 <= rtlcn5979 OR rtlcn5982 ;
   not_rtlcn15009 <= NOT rtlcn15009 ;
   Ram_Address_select_22i250 : select_3_3 port map ( a(2)=>rtlcn5979, a(1)=>
      rtlcn5982, a(0)=>not_rtlcn15009, b(2)=>Ram_Address_22n2s1(1), b(1)=>
      Ram_Address_22n25ss1(1), b(0)=>debug_EXMPLR1003(15), d=>
      Ram_Address_22n27ss1(1));
   Ram_data_i_mux_22i65Bus105_6 : select_3_3 port map ( a(2)=>rtlcs64, a(1)
      =>rtlcs62, a(0)=>MON_EOM_phase(0), b(2)=>Ram_data_i_22n76ss1(6), b(1)
      =>monitor_stack_pointer_plus4(6), b(0)=>debug_EXMPLR1003(15), d=>
      Ram_data_i_22n85ss1(6));
   rtlcn15013 <= EOM_phase(0) OR EOM_phase(3) ;
   not_rtlcn15013 <= NOT rtlcn15013 ;
   Ram_data_i_select_22i252Bus90_9 : select_3_3 port map ( a(2)=>
      EOM_phase(0), a(1)=>EOM_phase(3), a(0)=>not_rtlcn15013, b(2)=>
      Ram_data_i_9_22n2s12, b(1)=>stack_pointer(9), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_data_i_22n27ss1(9));
   Ram_data_i_select_22i252Bus90_10 : select_3_3 port map ( a(2)=>
      EOM_phase(0), a(1)=>EOM_phase(3), a(0)=>not_rtlcn15013, b(2)=>
      Ram_data_i_10_22n2s13, b(1)=>stack_pointer(10), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_data_i_22n27ss1(10));
   Ram_data_i_select_22i254Bus91_12 : select_3_3 port map ( a(2)=>
      EOM_phase(0), a(1)=>EOM_phase(3), a(0)=>not_rtlcn15013, b(2)=>
      Ram_data_i_12_22n2s15, b(1)=>stack_pointer(12), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_data_i_22n27ss1(12));
   Ram_data_i_select_22i254Bus91_13 : select_3_3 port map ( a(2)=>
      EOM_phase(0), a(1)=>EOM_phase(3), a(0)=>not_rtlcn15013, b(2)=>
      Ram_data_i_13_22n2s16, b(1)=>stack_pointer(13), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_data_i_22n27ss1(13));
   Ram_data_i_select_22i254Bus91_14 : select_3_3 port map ( a(2)=>
      EOM_phase(0), a(1)=>EOM_phase(3), a(0)=>not_rtlcn15013, b(2)=>
      Ram_data_i_14_22n2s17, b(1)=>stack_pointer(14), b(0)=>
      debug_EXMPLR1003(15), d=>Ram_data_i_22n27ss1(14));
   rtlcn15023 <= rtlcs64 AND Ram_data_i_22n76ss1(14) ;
   rtlcn15024 <= rtlcs62 AND monitor_stack_pointer_plus4(14) ;
   Ram_data_i_22n85ss1(14) <= rtlcn15023 OR rtlcn15024 ;
   rtlcn15025 <= CE AND Config_reg_1_60n90ss1(0) ;
   rtlcn15026 <= rtlcn8482 AND CPU_Data_in_wide(16) ;
   rtlcn10964 <= rtlcn15025 OR rtlcn15026 ;
   rtlcn15027 <= CE AND Config_reg_1_60n90ss1(2) ;
   rtlcn15028 <= rtlcn7074 AND CPU_Data_in_wide(18) ;
   rtlcn10967 <= rtlcn15027 OR rtlcn15028 ;
   rtlcn15241 <= host_status_bits_60n91ss1(1) AND not_rtlc60n6684 ;
   rtlcn15242 <= host_status_bits_60n46ss1_3 AND rtlc60n7285 ;
   rtlcn15243 <= host_status_bits_60n91ss1(0) AND not_rtlc60n6683 ;
   DFFPC (Raw_resetN,debug_EXMPLR1003(15),debug_EXMPLR1003(15),clock,
   HW_ResetN) ;
   DFFRSE (not_SW_Reset,debug_EXMPLR1003(15),not_Raw_resetN,PWR,clock,
   ResetN_EXMPLR925) ;
   DFFPCE (rtlcn4619,debug_EXMPLR1003(15),not_ResetN,rtlc22n10748,clock,
   EOM_phase(4)) ;
   DFFPCE (rtlcn4623,debug_EXMPLR1003(15),not_ResetN,rtlc22n10748,clock,
   EOM_phase(3)) ;
   DFFPCE (rtlcn4627,debug_EXMPLR1003(15),not_ResetN,rtlc22n10748,clock,
   EOM_phase(2)) ;
   DFFPCE (rtlcn4635,debug_EXMPLR1003(15),not_ResetN,rtlc22n10748,clock,
   EOM_phase(1)) ;
   DFFPCE (rtlcn8646,not_ResetN,debug_EXMPLR1003(15),rtlc22n10748,clock,
   EOM_phase(0)) ;
   DFFPCE (rtlcn4566,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_9) ;
   DFFPCE (rtlcn4570,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_8) ;
   DFFPCE (rtlcn4574,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_7) ;
   DFFPCE (rtlcn4578,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_6) ;
   DFFPCE (rtlcn4582,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_5) ;
   DFFPCE (rtlcn4586,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_4) ;
   DFFPCE (rtlcn4590,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_3) ;
   DFFPCE (rtlcn4594,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   Do_illegal_EXMPLR916) ;
   DFFPCE (rtlcn4557,debug_EXMPLR1003(15),not_ResetN,rtlc22n10743,clock,
   SOM_phase_1) ;
   DFFPCE (rtlcn8645,not_ResetN,debug_EXMPLR1003(15),rtlc22n10743,clock,
   SOM_phase_0) ;
   DFFPCE (not_rtlcn9892,debug_EXMPLR1003(15),not_ResetN,rtlc22n10733,clock,
   Phase(1)) ;
   DFFPCE (not_rtlcn9897,debug_EXMPLR1003(15),not_ResetN,rtlc22n10733,clock,
   Phase(0)) ;
   DFFPCE (not_rtlcn9895,debug_EXMPLR1003(15),not_ResetN,rtlc22n10731,clock,
   MON_EOM_phase(1)) ;
   DFFPCE (not_rtlcn9894,debug_EXMPLR1003(15),not_ResetN,rtlc22n10731,clock,
   MON_EOM_phase(0)) ;
   DFFPCE (rtlcn4471,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(7)) ;
   DFFPCE (rtlcn4475,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(6)) ;
   DFFPCE (rtlcn4479,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(5)) ;
   DFFPCE (rtlcn4483,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(4)) ;
   DFFPCE (rtlcn4450,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(3)) ;
   DFFPCE (rtlcn4454,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(2)) ;
   DFFPCE (rtlcn4457,debug_EXMPLR1003(15),not_ResetN,rtlc22n10729,clock,
   MON_SOM_phase(1)) ;
   DFFPCE (rtlcn8643,not_ResetN,debug_EXMPLR1003(15),rtlc22n10729,clock,
   MON_SOM_phase(0)) ;
   DFFPCE (not_rtlcn9893,debug_EXMPLR1003(15),not_ResetN,rtlc22n10721,clock,
   MON_Phase(1)) ;
   DFFPCE (not_rtlcn9896,debug_EXMPLR1003(15),not_ResetN,rtlc22n10721,clock,
   MON_Phase(0)) ;
   DFFPCE (Stack_rollover_interrupt_22n27ss1,debug_EXMPLR1003(15),not_ResetN,
   CE,clock,Stack_rollover_interrupt) ;
   DFFPCE (BUSY_in_LUT_22n50ss1,debug_EXMPLR1003(15),not_ResetN,rtlc22n10718,
   clock,BUSY_in_LUT) ;
   DFFPCE (rtlc22n10479,debug_EXMPLR1003(15),not_ResetN,rtlc22n10717,clock,
   Once) ;
   DFFPCE (Rollover_Int_Enable_22n114ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10716,clock,Rollover_Int_Enable) ;
   DFFPCE (rtlcn8479,debug_EXMPLR1003(15),not_ResetN,rtlc22n10715,clock,
   Data_Rollover) ;
   DFFPCE (MM_Error_detected_22n1s1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   MM_Error_detected) ;
   DFFPCE (Latched_Monitor_ended_OK_22n85ss1,debug_EXMPLR1003(15),not_ResetN,
   CE,clock,Latched_Monitor_ended_OK) ;
   DFFPCE (Latched_Monitor_data_stack_rollover_22n85ss1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_data_stack_rollover) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_11,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_Address_Parity) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_8,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_high_word_count) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_6,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_incorrect_data_sync) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_4,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_Invalid_word) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_3,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_RT2RT_format_error) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_2,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_RT2RT_format_gap) ;
   DFFPCE (Latched_Monitor_MIL1553_errors_22n85ss1_1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Latched_Monitor_MIL1553_errors_invalid_command) ;
   DFFPCE (STM_ended_22n108ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   STM_ended) ;
   DFFPCE (Ram_RE_22n103ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,Ram_RE)
    ;
   DFFPCE (Monitor_data_stack_half_pass_22n108ss1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_data_stack_half_pass) ;
   DFFPCE (Monitor_command_stack_half_pass_22n85ss1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_command_stack_half_pass) ;
   DFFPCE (Monitor_data_stack_rollover_22n108ss1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_data_stack_rollover) ;
   DFFPCE (Monitor_command_stack_rollover_22n85ss1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_command_stack_rollover) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(15)) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(14)) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(13)) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(12)) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(11)) ;
   DFFPCE (Data_o_temp(10),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,
   clock,Data_to_FE_EXMPLR999(10)) ;
   DFFPCE (Data_o_temp(9),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(9)) ;
   DFFPCE (Data_o_temp(8),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(8)) ;
   DFFPCE (Data_o_temp(7),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(7)) ;
   DFFPCE (Data_o_temp(6),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(6)) ;
   DFFPCE (Data_o_temp(5),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(5)) ;
   DFFPCE (Data_o_temp(4),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(4)) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(3)) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc22n10658,clock,
   Data_to_FE_EXMPLR999(0)) ;
   DFFPCE (rtlcn4506,debug_EXMPLR1003(15),not_ResetN,rtlc22n10642,clock,
   New_command_record) ;
   DFFPCE (Record_enable_22n87s1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10641,clock,Record_enable) ;
   DFFPCE (Data_o_temp(15),not_ResetN,debug_EXMPLR1003(15),rtlc22n10640,
   clock,monitor_data_pointer(15)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(14),not_ResetN,
   debug_EXMPLR1003(15),rtlc22n10639,clock,monitor_data_pointer(14)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(13),not_ResetN,
   debug_EXMPLR1003(15),rtlc22n10638,clock,monitor_data_pointer(13)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(12),not_ResetN,
   debug_EXMPLR1003(15),rtlc22n10637,clock,monitor_data_pointer(12)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(11),not_ResetN,
   debug_EXMPLR1003(15),rtlc22n10636,clock,monitor_data_pointer(11)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(10),not_ResetN,
   debug_EXMPLR1003(15),rtlc22n10635,clock,monitor_data_pointer(10)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(9),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10634,clock,monitor_data_pointer(9)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(8),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(8)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(7),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(7)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(6),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(6)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(5),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(5)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(4),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(4)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(3),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(3)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(2),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(2)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(1),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(1)) ;
   DFFPCE (monitor_data_pointer_22n108ss1(0),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10633,clock,monitor_data_pointer(0)) ;
   DFFPCE (monitor_stack_pointer(15),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,monitor_stack_pointer_plus4(15)) ;
   DFFPCE (monitor_stack_pointer(14),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,monitor_stack_pointer_plus4(14)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_13,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(13)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_12,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(12)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_11,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(11)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_10,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(10)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_9,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(9)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1ss1_8,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(8)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_7,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(7)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_6,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(6)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_5,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(5)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_4,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(4)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_3,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(3)) ;
   DFFPCE (monitor_stack_pointer_plus4_22n1s4_2,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,monitor_stack_pointer_plus4(2)) ;
   DFFPCE (monitor_stack_pointer(1),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   monitor_stack_pointer_plus4(1)) ;
   DFFPCE (monitor_stack_pointer(0),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   monitor_stack_pointer_plus4(0)) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(15)) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(14)) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(13)) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(12)) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(11)) ;
   DFFPCE (Data_o_temp(10),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,
   clock,monitor_stack_pointer(10)) ;
   DFFPCE (Data_o_temp(9),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(9)) ;
   DFFPCE (Data_o_temp(8),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(8)) ;
   DFFPCE (Data_o_temp(7),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(7)) ;
   DFFPCE (Data_o_temp(6),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(6)) ;
   DFFPCE (Data_o_temp(5),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(5)) ;
   DFFPCE (Data_o_temp(4),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(4)) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(3)) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc22n10608,clock,
   monitor_stack_pointer(0)) ;
   DFFPCE (record_message_B_22n103ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10592,clock,record_message_B) ;
   DFFPCE (record_message_A_22n103ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10591,clock,record_message_A) ;
   DFFPCE (rtlc22n8769,debug_EXMPLR1003(15),not_ResetN,rtlc22n10590,clock,
   monitor_pointer_protection_error) ;
   DFFPCE (Data_Pointer_register_22n108ss1(15),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(15)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(14),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(14)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(13),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(13)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(12),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(12)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(11),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(11)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(10),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(10)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(9),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(9)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(8),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(8)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(7),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(7)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(6),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(6)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(5),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(5)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(4),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(4)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(3),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(3)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(2),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(2)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(1),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(1)) ;
   DFFPCE (Data_Pointer_register_22n108ss1(0),debug_EXMPLR1003(15),
   not_ResetN,rtlc22n10589,clock,Data_Pointer_register(0)) ;
   DFFPCE (illegal_message_22n50ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10573,clock,illegal_message_EXMPLR939) ;
   DFFPCE (MM_22n112ss1(2),debug_EXMPLR1003(15),not_ResetN,CE,clock,MM(2)) ;
   DFFPCE (MM_22n112ss1(1),debug_EXMPLR1003(15),not_ResetN,CE,clock,MM(1)) ;
   DFFPCE (MM_22n112ss1(0),debug_EXMPLR1003(15),not_ResetN,CE,clock,MM(0)) ;
   DFFPCE (data_pointer_22n48ss1(15),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10569,clock,data_pointer(15)) ;
   DFFPCE (data_pointer_22n48ss1(14),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10569,clock,data_pointer(14)) ;
   DFFPCE (data_pointer_22n48ss1(13),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10569,clock,data_pointer(13)) ;
   DFFPCE (data_pointer_22n76ss1(12),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10566,clock,data_pointer(12)) ;
   DFFPCE (data_pointer_22n76ss1(11),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10565,clock,data_pointer(11)) ;
   DFFPCE (data_pointer_22n76ss1(10),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10564,clock,data_pointer(10)) ;
   DFFPCE (data_pointer_22n76ss1(9),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10563,clock,data_pointer(9)) ;
   DFFPCE (data_pointer_22n76ss1(8),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10562,clock,data_pointer(8)) ;
   DFFPCE (data_pointer_22n76ss1(7),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10561,clock,data_pointer(7)) ;
   DFFPCE (data_pointer_22n76ss1(6),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(6)) ;
   DFFPCE (data_pointer_22n76ss1(5),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(5)) ;
   DFFPCE (data_pointer_22n76ss1(4),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(4)) ;
   DFFPCE (data_pointer_22n76ss1(3),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(3)) ;
   DFFPCE (data_pointer_22n76ss1(2),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(2)) ;
   DFFPCE (data_pointer_22n76ss1(1),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(1)) ;
   DFFPCE (data_pointer_22n76ss1(0),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10560,clock,data_pointer(0)) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(15)) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(14)) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(13)) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(12)) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(11)) ;
   DFFPCE (Data_o_temp(10),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,
   clock,LUT_Control(10)) ;
   DFFPCE (Data_o_temp(9),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(9)) ;
   DFFPCE (Data_o_temp(8),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(8)) ;
   DFFPCE (Data_o_temp(7),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(7)) ;
   DFFPCE (Data_o_temp(6),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(6)) ;
   DFFPCE (Data_o_temp(5),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(5)) ;
   DFFPCE (Data_o_temp(4),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(4)) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(3)) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc22n10553,clock,
   LUT_Control(0)) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,
   clock,stack_pointer(15)) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,
   clock,stack_pointer(14)) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,
   clock,stack_pointer(13)) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,
   clock,stack_pointer(12)) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,
   clock,stack_pointer(11)) ;
   DFFPCE (stack_pointer_22n50ss1_10,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10532,clock,stack_pointer(10)) ;
   DFFPCE (stack_pointer_22n50ss1_9,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10531,clock,stack_pointer(9)) ;
   DFFPCE (stack_pointer_22n50ss1_8,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10530,clock,stack_pointer(8)) ;
   DFFPCE (stack_pointer_22n50ss1_7,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(7)) ;
   DFFPCE (stack_pointer_22n50ss1_6,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(6)) ;
   DFFPCE (stack_pointer_22n50ss1_5,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(5)) ;
   DFFPCE (stack_pointer_22n50ss1_4,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(4)) ;
   DFFPCE (stack_pointer_22n50ss1_3,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(3)) ;
   DFFPCE (stack_pointer_22n50ss1_2,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10529,clock,stack_pointer(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,clock,
   stack_pointer(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc22n10537,clock,
   stack_pointer(0)) ;
   DFFPCE (Ram_WE_22n108ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,Ram_WE)
    ;
   DFFPCE (Ram_data_i_22n108ss1_15,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(15)) ;
   DFFPCE (rtlcn11062,debug_EXMPLR1003(15),not_ResetN,rtlc22n10520,clock,
   Ram_data_i(14)) ;
   DFFPCE (Ram_data_i_22n108ss1_13,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(13)) ;
   DFFPCE (Ram_data_i_22n108ss1_12,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(12)) ;
   DFFPCE (Ram_data_i_22n108ss1_11,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(11)) ;
   DFFPCE (Ram_data_i_22n108ss1_10,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(10)) ;
   DFFPCE (Ram_data_i_22n108ss1_9,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(9)) ;
   DFFPCE (Ram_data_i_22n108ss1_8,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(8)) ;
   DFFPCE (Ram_data_i_22n108ss1_7,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(7)) ;
   DFFPCE (Ram_data_i_22n108ss1_6,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(6)) ;
   DFFPCE (Ram_data_i_22n108ss1_5,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(5)) ;
   DFFPCE (Ram_data_i_22n108ss1_4,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(4)) ;
   DFFPCE (Ram_data_i_22n108ss1_3,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(3)) ;
   DFFPCE (Ram_data_i_22n108ss1_2,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(2)) ;
   DFFPCE (Ram_data_i_22n108ss1_1,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(1)) ;
   DFFPCE (Ram_data_i_22n108ss1_0,debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10520,clock,Ram_data_i(0)) ;
   DFFPCE (Ram_Address_22n108ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(15)) ;
   DFFPCE (Ram_Address_22n108ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(14)) ;
   DFFPCE (Ram_Address_22n108ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(13)) ;
   DFFPCE (Ram_Address_22n108ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(12)) ;
   DFFPCE (Ram_Address_22n108ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(11)) ;
   DFFPCE (Ram_Address_22n108ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(10)) ;
   DFFPCE (Ram_Address_22n108ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(9)) ;
   DFFPCE (Ram_Address_22n108ss1(8),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10504,clock,Ram_Address(8)) ;
   DFFPCE (Ram_Address_22n108ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(7)) ;
   DFFPCE (Ram_Address_22n108ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(6)) ;
   DFFPCE (Ram_Address_22n108ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(5)) ;
   DFFPCE (Ram_Address_22n108ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(4)) ;
   DFFPCE (Ram_Address_22n108ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc22n10504,clock,Ram_Address(3)) ;
   DFFPCE (Ram_Address_22n108ss1(2),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10504,clock,Ram_Address(2)) ;
   DFFPCE (Ram_Address_22n108ss1(1),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10504,clock,Ram_Address(1)) ;
   DFFPCE (Ram_Address_22n108ss1(0),not_ResetN,debug_EXMPLR1003(15),
   rtlc22n10504,clock,Ram_Address(0)) ;
   DFFPCE (rtlcn4099,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(91))
    ;
   DFFPCE (rtlcn2816,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(90))
    ;
   DFFPCE (rtlcn3736,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(89))
    ;
   DFFPCE (rtlcn3704,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(88))
    ;
   DFFPCE (rtlcn3837,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(87))
    ;
   DFFPCE (rtlcn3758,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(86))
    ;
   DFFPCE (rtlcn4087,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(85))
    ;
   DFFPCE (rtlcn4079,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(84))
    ;
   DFFPCE (rtlcn3849,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(83))
    ;
   DFFPCE (rtlcn3720,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(82))
    ;
   DFFPCE (rtlcn3504,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(81))
    ;
   DFFPCE (rtlcn3481,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(80))
    ;
   DFFPCE (rtlcn3677,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(79))
    ;
   DFFPCE (rtlcn4066,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(78))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_77,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(77)) ;
   DFFPCE (rtlcn4111,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(76))
    ;
   DFFPCE (rtlcn3668,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(75))
    ;
   DFFPCE (rtlcn3640,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(74))
    ;
   DFFPCE (rtlcn4057,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(73))
    ;
   DFFPCE (rtlcn9843,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(72))
    ;
   DFFPCE (rtlcn3591,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(71))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_70,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(70)) ;
   DFFPCE (rtlcn3693,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(69))
    ;
   DFFPCE (rtlcn4042,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(68))
    ;
   DFFPCE (rtlcn3826,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(67))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_66,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(66)) ;
   DFFPCE (rtlcn3961,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(65))
    ;
   DFFPCE (rtlcn3810,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(64))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_63,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(63)) ;
   DFFPCE (rtlcn3616,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(62))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_61,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(61)) ;
   DFFPCE (rtlcn3724,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(60))
    ;
   DFFPCE (not_rtlcn9848,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_State(59)) ;
   DFFPCE (rtlcn3773,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(58))
    ;
   DFFPCE (rtlcn9855,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(57))
    ;
   DFFPCE (rtlcn4031,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(56))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_55,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(55)) ;
   DFFPCE (BC_State_fsm_26n182ss1_54,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(54)) ;
   DFFPCE (BC_State_fsm_26n182ss1_53,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(53)) ;
   DFFPCE (BC_State_fsm_26n182ss1_52,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(52)) ;
   DFFPCE (BC_State_fsm_26n182ss1_51,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(51)) ;
   DFFPCE (rtlcn4001,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(50))
    ;
   DFFPCE (rtlcn3181,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(49))
    ;
   DFFPCE (rtlcn3170,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(48))
    ;
   DFFPCE (rtlcn3203,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(47))
    ;
   DFFPCE (rtlcn3159,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(46))
    ;
   DFFPCE (rtlcn4016,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(45))
    ;
   DFFPCE (rtlcn3137,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(44))
    ;
   DFFPCE (rtlcn3148,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(43))
    ;
   DFFPCE (rtlcn3098,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(42))
    ;
   DFFPCE (rtlcn3107,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(41))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_40,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(40)) ;
   DFFPCE (rtlcn3126,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(39))
    ;
   DFFPCE (rtlcn3192,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(38))
    ;
   DFFPCE (rtlcn3214,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(37))
    ;
   DFFPCE (rtlcn3225,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(36))
    ;
   DFFPCE (rtlcn3036,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(35))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_34,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(34)) ;
   DFFPCE (rtlcn8254,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(33))
    ;
   DFFPCE (rtlcn2996,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(32))
    ;
   DFFPCE (rtlcn2973,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(31))
    ;
   DFFPCE (rtlcn2941,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(30))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_29,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(29)) ;
   DFFPCE (rtlcn3458,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(28))
    ;
   DFFPCE (rtlcn3436,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(27))
    ;
   DFFPCE (rtlcn3416,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(26))
    ;
   DFFPCE (rtlcn3425,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(25))
    ;
   DFFPCE (rtlcn3568,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(24))
    ;
   DFFPCE (rtlcn4142,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(23))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_22,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(22)) ;
   DFFPCE (BC_State_fsm_26n182ss1_21,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(21)) ;
   DFFPCE (BC_State_fsm_26n182ss1_20,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(20)) ;
   DFFPCE (rtlcn3469,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(19))
    ;
   DFFPCE (rtlcn3390,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(18))
    ;
   DFFPCE (rtlcn3358,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(17))
    ;
   DFFPCE (rtlcn3405,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(16))
    ;
   DFFPCE (rtlcn3375,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(15))
    ;
   DFFPCE (rtlcn3447,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(14))
    ;
   DFFPCE (rtlcn3537,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(13))
    ;
   DFFPCE (BC_State_fsm_26n182ss1_12,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_State(12)) ;
   DFFPCE (rtlcn3335,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(11))
    ;
   DFFPCE (rtlcn3244,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(10))
    ;
   DFFPCE (rtlcn3263,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(9)) ;
   DFFPCE (rtlcn3286,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(8)) ;
   DFFPCE (rtlcn2878,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(7)) ;
   DFFPCE (rtlcn2915,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(6)) ;
   DFFPCE (rtlcn2889,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(5)) ;
   DFFPCE (rtlcn2926,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(4)) ;
   DFFPCE (rtlcn2900,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(3)) ;
   DFFPCE (rtlcn2797,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(2)) ;
   DFFPCE (rtlcn8558,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_State(1)) ;
   DFFPCE (rtlcn2861,not_ResetN,debug_EXMPLR1003(15),CE,clock,BC_State(0)) ;
   DFFPCE (rtlc26n16381,debug_EXMPLR1003(15),not_ResetN,rtlc26n17110,clock,
   status_set_in_frame) ;
   DFFPCE (eBC_start_FT_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_start_FT) ;
   DFFPCE (eBC_TT_do_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_TT_do) ;
   DFFPCE (rtlcn6918,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_Stack_error) ;
   DFFPCE (eBC_Inc_Q_pointer_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,eBC_Inc_Q_pointer) ;
   DFFPCE (eBC_IRQ_do_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_IRQ_do) ;
   DFFPCE (eBC_GP_do_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_GP_do) ;
   DFFPCE (eBC_FT_Load_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_FT_Load) ;
   DFFPCE (eBC_CMV_do_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_CMV_do) ;
   DFFPCE (rtlcn3950,debug_EXMPLR1003(15),not_ResetN,CE,clock,eBC_CMT_do) ;
   DFFPCE (rtlcn3938,debug_EXMPLR1003(15),not_ResetN,CE,clock,eBC_CFT_do) ;
   DFFPCE (rtlc26n15937,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_Bad_instruction) ;
   DFFPCE (eBC_Bad_Parity_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_Bad_Parity) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc26n17097,clock,
   WhichVAR(3)) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc26n17097,clock,
   WhichVAR(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc26n17097,clock,
   WhichVAR(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc26n17097,clock,
   WhichVAR(0)) ;
   DFFPCE (VARAM_WE_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   VARAM_WE) ;
   DFFPCE (VARAM_D_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(15)) ;
   DFFPCE (VARAM_D_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(14)) ;
   DFFPCE (VARAM_D_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(13)) ;
   DFFPCE (VARAM_D_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(12)) ;
   DFFPCE (VARAM_D_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(11)) ;
   DFFPCE (VARAM_D_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17091,clock,VARAM_D(10)) ;
   DFFPCE (VARAM_D_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(9)) ;
   DFFPCE (VARAM_D_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(8)) ;
   DFFPCE (VARAM_D_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(7)) ;
   DFFPCE (VARAM_D_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(6)) ;
   DFFPCE (VARAM_D_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(5)) ;
   DFFPCE (VARAM_D_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(4)) ;
   DFFPCE (VARAM_D_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(3)) ;
   DFFPCE (VARAM_D_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(2)) ;
   DFFPCE (VARAM_D_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(1)) ;
   DFFPCE (VARAM_D_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,rtlc26n17091,
   clock,VARAM_D(0)) ;
   DFFPCE (VARAM_ADD_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17075,clock,VARAM_ADD(4)) ;
   DFFPCE (VARAM_ADD_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17075,clock,VARAM_ADD(3)) ;
   DFFPCE (VARAM_ADD_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17075,clock,VARAM_ADD(2)) ;
   DFFPCE (VARAM_ADD_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17075,clock,VARAM_ADD(1)) ;
   DFFPCE (VARAM_ADD_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17075,clock,VARAM_ADD(0)) ;
   DFFPCE (not_rtlc26n16088,debug_EXMPLR1003(15),not_ResetN,rtlc26n17070,
   clock,Sync_with_Data) ;
   DFFPCE (ReTry_count_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17069,clock,ReTry_count(1)) ;
   DFFPCE (ReTry_count_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17069,clock,ReTry_count(0)) ;
   DFFPCE (rtlc26n16354,debug_EXMPLR1003(15),not_ResetN,rtlc26n17067,clock,
   Message_failed) ;
   DFFPCE (LIFO_Pointer_26n126s1(4),not_ResetN,debug_EXMPLR1003(15),
   rtlc26n17066,clock,LIFO_Pointer(4)) ;
   DFFPCE (LIFO_Pointer_26n126s1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17066,clock,LIFO_Pointer(3)) ;
   DFFPCE (LIFO_Pointer_26n126s1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17066,clock,LIFO_Pointer(2)) ;
   DFFPCE (LIFO_Pointer_26n126s1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17066,clock,LIFO_Pointer(1)) ;
   DFFPCE (LIFO_Pointer_26n126s1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17066,clock,LIFO_Pointer(0)) ;
   DFFPCE (rtlc26n16352,debug_EXMPLR1003(15),not_ResetN,CE,clock,ENC_TEST_on
   ) ;
   DFFPCE (BC_State(80),debug_EXMPLR1003(15),not_ResetN,CE,clock,ENC_TEST_GO
   ) ;
   DFFPCE (rtlcn3553,debug_EXMPLR1003(15),not_ResetN,CE,clock,Clear_Stop_EOM
   ) ;
   DFFPCE (rtlcn8563,debug_EXMPLR1003(15),not_ResetN,CE,clock,Clear_Stop_EOF
   ) ;
   DFFPCE (BC_word_number_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17057,clock,BC_word_number(1)) ;
   DFFPCE (BC_word_number_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17057,clock,BC_word_number(0)) ;
   DFFPCE (not_rtlc26n16783,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_on_EXMPLR883) ;
   DFFPCE (BC_msg_pointer_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(15)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(14)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(13)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(12)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(11)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(10)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(9)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(8)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(7)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(6)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(5)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(4)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(3)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(2)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(1)) ;
   DFFPCE (BC_msg_pointer_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17054,clock,BC_msg_pointer(0)) ;
   DFFPCE (BC_TX_Data_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data(15)) ;
   DFFPCE (BC_TX_Data_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data(14)) ;
   DFFPCE (BC_TX_Data_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data(13)) ;
   DFFPCE (BC_TX_Data_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data(12)) ;
   DFFPCE (BC_TX_Data_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data(11)) ;
   DFFPCE (BC_TX_Data_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_10_EXMPLR872) ;
   DFFPCE (BC_TX_Data_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_9_EXMPLR873) ;
   DFFPCE (BC_TX_Data_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_8_EXMPLR874) ;
   DFFPCE (BC_TX_Data_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_7_EXMPLR875) ;
   DFFPCE (BC_TX_Data_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_6_EXMPLR876) ;
   DFFPCE (BC_TX_Data_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_5_EXMPLR877) ;
   DFFPCE (BC_TX_Data_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_4_EXMPLR878) ;
   DFFPCE (BC_TX_Data_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_3_EXMPLR879) ;
   DFFPCE (BC_TX_Data_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_2_EXMPLR880) ;
   DFFPCE (BC_TX_Data_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_1_EXMPLR881) ;
   DFFPCE (BC_TX_Data_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17038,clock,BC_TX_Data_0_EXMPLR882) ;
   DFFPCE (rtlc26n16323,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_Started)
    ;
   DFFPCE (BC_Stack_pointer_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(15)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(14)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(13)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(12)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(11)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17016,clock,BC_Stack_pointer(10)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17015,clock,BC_Stack_pointer(9)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17014,clock,BC_Stack_pointer(8)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(7)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(6)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(5)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(4)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(3)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17013,clock,BC_Stack_pointer(2)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(1)) ;
   DFFPCE (BC_Stack_pointer_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n17021,clock,BC_Stack_pointer(0)) ;
   DFFPCE (rtlc26n16305,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Retry_pulse) ;
   DFFPCE (BC_Ram_data_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(15)) ;
   DFFPCE (BC_Ram_data_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(14)) ;
   DFFPCE (BC_Ram_data_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(13)) ;
   DFFPCE (BC_Ram_data_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(12)) ;
   DFFPCE (BC_Ram_data_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(11)) ;
   DFFPCE (BC_Ram_data_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,CE,
   clock,BC_Ram_data(10)) ;
   DFFPCE (BC_Ram_data_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(9)) ;
   DFFPCE (BC_Ram_data_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(8)) ;
   DFFPCE (BC_Ram_data_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(7)) ;
   DFFPCE (BC_Ram_data_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(6)) ;
   DFFPCE (BC_Ram_data_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(5)) ;
   DFFPCE (BC_Ram_data_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(4)) ;
   DFFPCE (BC_Ram_data_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(3)) ;
   DFFPCE (BC_Ram_data_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(2)) ;
   DFFPCE (BC_Ram_data_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(1)) ;
   DFFPCE (BC_Ram_data_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Ram_data(0)) ;
   DFFPCE (rtlcn7451,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_Ram_WE) ;
   DFFPCE (rtlcn7404,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_Ram_RE) ;
   DFFPCE (BC_Ram_Address_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(15)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(14)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(13)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(12)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(11)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(10)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(9)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(8),not_ResetN,debug_EXMPLR1003(15),
   rtlc26n16986,clock,BC_Ram_Address(8)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(7)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(6)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(5)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(4)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16986,clock,BC_Ram_Address(3)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(2),not_ResetN,debug_EXMPLR1003(15),
   rtlc26n16986,clock,BC_Ram_Address(2)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(1),not_ResetN,debug_EXMPLR1003(15),
   rtlc26n16986,clock,BC_Ram_Address(1)) ;
   DFFPCE (BC_Ram_Address_26n180ss1(0),not_ResetN,debug_EXMPLR1003(15),
   rtlc26n16986,clock,BC_Ram_Address(0)) ;
   DFFPCE (BC_Load_msg_gap_counter_26n180ss1,debug_EXMPLR1003(15),not_ResetN,
   CE,clock,BC_Load_msg_gap_counter) ;
   DFFPCE (BC_State(2),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Load_frame_gap_counter) ;
   DFFPCE (rtlc26n18667,not_ResetN,debug_EXMPLR1003(15),CE,clock,BC_IDLE) ;
   DFFPCE (BC_Go_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Go_EXMPLR866) ;
   DFFPCE (not_rtlc26n16112,debug_EXMPLR1003(15),not_ResetN,rtlc26n16950,
   clock,BC_Frame_active_part) ;
   DFFPCE (not_BC_State_18,debug_EXMPLR1003(15),not_ResetN,rtlc26n16949,
   clock,BC_First_write) ;
   DFFPCE (not_rtlc26n18663,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_FE_ResetN) ;
   DFFPCE (BC_Echo_word_26n180ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(15)) ;
   DFFPCE (BC_Echo_word_26n180ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(14)) ;
   DFFPCE (BC_Echo_word_26n180ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(13)) ;
   DFFPCE (BC_Echo_word_26n180ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(12)) ;
   DFFPCE (BC_Echo_word_26n180ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(11)) ;
   DFFPCE (BC_Echo_word_26n180ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(10)) ;
   DFFPCE (BC_Echo_word_26n180ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(9)) ;
   DFFPCE (BC_Echo_word_26n180ss1(8),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(8)) ;
   DFFPCE (BC_Echo_word_26n180ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(7)) ;
   DFFPCE (BC_Echo_word_26n180ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(6)) ;
   DFFPCE (BC_Echo_word_26n180ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(5)) ;
   DFFPCE (BC_Echo_word_26n180ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(4)) ;
   DFFPCE (BC_Echo_word_26n180ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(3)) ;
   DFFPCE (BC_Echo_word_26n180ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(2)) ;
   DFFPCE (BC_Echo_word_26n180ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(1)) ;
   DFFPCE (BC_Echo_word_26n180ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc26n16947,clock,BC_Echo_word(0)) ;
   DFFPCE (BC_EOM_26n180ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_EOM)
    ;
   DFFPCE (rtlcn5635,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_EOF) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_15) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_14) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_13) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_12) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_11) ;
   DFFPCE (Data_o_temp(10),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,
   clock,BC_Control_word_10) ;
   DFFPCE (Data_o_temp(9),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_9) ;
   DFFPCE (Data_o_temp(8),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_8) ;
   DFFPCE (Data_o_temp(7),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_7) ;
   DFFPCE (Data_o_temp(6),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Test_EXMPLR782) ;
   DFFPCE (Data_o_temp(5),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_5) ;
   DFFPCE (Data_o_temp(4),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_4) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_1553A_EXMPLR864) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_2) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_Control_word_1) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc26n16929,clock,
   BC_RT2RT_EXMPLR781) ;
   DFFPCE (BC_BUS_A_26n180ss1,not_ResetN,debug_EXMPLR1003(15),rtlc26n16913,
   clock,BC_BUS_A_EXMPLR865) ;
   DFFPCE (Non_masked_Event_D_29n1ss1,debug_EXMPLR1003(15),not_ResetN,CE,
   clock,Non_masked_Event_D) ;
   DFFPCE (rtlc29n262,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   Clear_Intn_level) ;
   DFFPCE (rtlc29n371,debug_EXMPLR1003(15),not_ResetN,CE,clock,Int1_Chain) ;
   DFFPCE (INTn_level,not_ResetN,debug_EXMPLR1003(15),CE,clock,INTn_level_D)
    ;
   DFFPCE (rtlcn8685,not_ResetN,debug_EXMPLR1003(15),CE,clock,INTn_pulse) ;
   DFFPCE (rtlcn6997,not_ResetN,debug_EXMPLR1003(15),rtlc29n642,clock,
   INTn_level) ;
   DFFPCE (Monitor_write,debug_EXMPLR1003(15),not_ResetN,CE,clock,M_W) ;
   DFFPCE (W_R_32n3s1,debug_EXMPLR1003(15),not_ResetN,CE,clock,W_R) ;
   DFFPCE (rtlcn4218,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   Arbiter_timeout) ;
   DFFPCE (rtlcn4285,debug_EXMPLR1003(15),not_ResetN,CE,clock,MON_phase_go)
    ;
   DFFPCE (rtlcn8284,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   MON_SOM_phase_go) ;
   DFFPCE (rtlcn4315,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   MON_EOM_phase_go) ;
   DFFPCE (rtlcn4244,debug_EXMPLR1003(15),not_ResetN,CE,clock,phase_go) ;
   DFFPCE (rtlcn4265,debug_EXMPLR1003(15),not_ResetN,CE,clock,SOM_phase_go)
    ;
   DFFPCE (rtlcn4253,debug_EXMPLR1003(15),not_ResetN,CE,clock,EOM_phase_go)
    ;
   DFFPCE (rtlcn8277,debug_EXMPLR1003(15),not_ResetN,rtlc32n706,clock,
   arbiter) ;
   DFFPCE (MON_WR_req_32n14ss1,debug_EXMPLR1003(15),not_ResetN,rtlc32n705,
   clock,MON_WR_req) ;
   DFFPCE (not_rtlcn4315,debug_EXMPLR1003(15),not_ResetN,rtlc32n704,clock,
   MON_EOM_req) ;
   DFFPCE (rtlcn4353,debug_EXMPLR1003(15),not_ResetN,rtlc32n703,clock,
   MON_SOM_req) ;
   DFFPCE (WRD_req_32n14ss1,debug_EXMPLR1003(15),not_ResetN,rtlc32n702,clock,
   WRD_req) ;
   DFFPCE (not_rtlcn4253,debug_EXMPLR1003(15),not_ResetN,rtlc32n701,clock,
   EOM_req) ;
   DFFPCE (not_rtlcn4265,debug_EXMPLR1003(15),not_ResetN,rtlc32n700,clock,
   SOM_req) ;
   DFFPCE (rtlc35n98,debug_EXMPLR1003(15),not_ResetN,CE,clock,mode_command)
    ;
   DFFPCE (rtlcs168,debug_EXMPLR1003(15),not_ResetN,CE,clock,BCR) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc38n63,clock,
   BC_reported_errors) ;
   DFFPCE (BC_Sts_Word_41n13ss1_13,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Sts_Word(13)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n353,clock,
   BC_Sts_Word(12)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n352,clock,
   BC_Sts_Word(11)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n351,clock,
   BC_Sts_Word(10)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n350,clock,
   BC_Sts_Word(9)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n349,clock,
   BC_Sts_Word(8)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n348,clock,
   BC_Sts_Word(7)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n347,clock,
   BC_Sts_Word(6)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n346,clock,
   BC_Sts_Word(5)) ;
   DFFPCE (BC_Sts_Word_41n13ss1_4,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_Sts_Word(4)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n344,clock,
   BC_Sts_Word(3)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n343,clock,
   BC_Sts_Word(2)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n342,clock,
   BC_Sts_Word(1)) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc41n341,clock,
   BC_Sts_Word(0)) ;
   DFFPCE (BC_Sts_Word(12),debug_EXMPLR1003(15),not_ResetN,CE,clock,
   BC_STS_Word_12_d) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc44n315,clock,
   eBC_Conditions_11) ;
   DFFPCE (not_BC_Go,debug_EXMPLR1003(15),not_ResetN,rtlc44n314,clock,
   status_set) ;
   DFFPCE (gap_eq_0_48n3ss1,debug_EXMPLR1003(15),not_ResetN,rtlc48n253,clock,
   gap_eq_0) ;
   DFFPCE (eBC_Watchdog_eq0_51n6ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   eBC_Watchdog_eq0) ;
   DFFPCE (Data_o_temp(15),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(15)) ;
   DFFPCE (Data_o_temp(14),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(14)) ;
   DFFPCE (Data_o_temp(13),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(13)) ;
   DFFPCE (Data_o_temp(12),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(12)) ;
   DFFPCE (Data_o_temp(11),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(11)) ;
   DFFPCE (Data_o_temp(10),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(10)) ;
   DFFPCE (Data_o_temp(9),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(9)) ;
   DFFPCE (Data_o_temp(8),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(8)) ;
   DFFPCE (Data_o_temp(7),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(7)) ;
   DFFPCE (Data_o_temp(6),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(6)) ;
   DFFPCE (Data_o_temp(5),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(5)) ;
   DFFPCE (Data_o_temp(4),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(4)) ;
   DFFPCE (Data_o_temp(3),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(3)) ;
   DFFPCE (Data_o_temp(2),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(2)) ;
   DFFPCE (Data_o_temp(1),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(1)) ;
   DFFPCE (Data_o_temp(0),debug_EXMPLR1003(15),not_ResetN,rtlc51n394,clock,
   eBC_Frame_length(0)) ;
   DFFPCE (frame_gap_eq_0_51n6ss1,debug_EXMPLR1003(15),not_ResetN,rtlc51n378,
   clock,frame_gap_eq_0) ;
   DFFPCE (BC_SP,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_SP_D) ;
   DFFPCE (BC_SP_54n1ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,BC_SP) ;
   DFFPCE (Ext_Trigger_D,not_ResetN,debug_EXMPLR1003(15),CE,clock,
   Ext_Trigger_DD) ;
   DFFPCE (Ext_Trigger,not_ResetN,debug_EXMPLR1003(15),CE,clock,
   Ext_Trigger_D) ;
   DFFPC (M1760,debug_EXMPLR1003(15),not_ResetN,clock,M1760_D) ;
   DFFPCE (debug_EXMPLR1003(15),not_ResetN,debug_EXMPLR1003(15),rtlc60n7497,
   clock,First_Thing) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,rtlc60n7496,
   clock,PrimeCheck) ;
   DFFPCE (eBC_GP_60n73ss1(7),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6449,clock,eBC_GP(7)) ;
   DFFPCE (eBC_GP_60n73ss1(6),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6448,clock,eBC_GP(6)) ;
   DFFPCE (eBC_GP_60n73ss1(5),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6447,clock,eBC_GP(5)) ;
   DFFPCE (eBC_GP_60n73ss1(4),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6446,clock,eBC_GP(4)) ;
   DFFPCE (eBC_GP_60n73ss1(3),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6445,clock,eBC_GP(3)) ;
   DFFPCE (eBC_GP_60n73ss1(2),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6444,clock,eBC_GP(2)) ;
   DFFPCE (eBC_GP_60n73ss1(1),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6443,clock,eBC_GP(1)) ;
   DFFPCE (eBC_GP_60n73ss1(0),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6442,clock,eBC_GP(0)) ;
   DFFPCE (CPU_Data_in_wide(31),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(15)) ;
   DFFPCE (CPU_Data_in_wide(30),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(14)) ;
   DFFPCE (CPU_Data_in_wide(29),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(13)) ;
   DFFPCE (CPU_Data_in_wide(28),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(12)) ;
   DFFPCE (CPU_Data_in_wide(27),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(11)) ;
   DFFPCE (CPU_Data_in_wide(26),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(10)) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(9)) ;
   DFFPCE (CPU_Data_in_wide(24),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(8)) ;
   DFFPCE (CPU_Data_in_wide(23),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(7)) ;
   DFFPCE (CPU_Data_in_wide(22),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5925,clock,eBC_Q_pointer(6)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(5),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(5)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(4),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(4)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(3),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(3)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(2),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(2)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(1),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(1)) ;
   DFFPCE (eBC_Q_pointer_60n51ss1(0),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6054,clock,eBC_Q_pointer(0)) ;
   DFFPCE (CPU_Data_in_wide(17),debug_EXMPLR1003(15),not_ResetN,rtlc60n7496,
   clock,eBC_Watchdog_enable) ;
   DFFPCE (rtlc60n7640,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   No_Response_timeout(2)) ;
   DFFPCE (not_rtlc60n7254,not_ResetN,debug_EXMPLR1003(15),CE,clock,
   No_Response_timeout(1)) ;
   DFFPCE (not_Config_reg_5_9,not_ResetN,debug_EXMPLR1003(15),CE,clock,
   No_Response_timeout(0)) ;
   DFFPCE (Monitor_command_is_sync_without_data_60n11s1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_command_is_sync_without_data) ;
   DFFPCE (Monitor_command_is_sync_with_data_60n11s1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Monitor_command_is_sync_with_data) ;
   DFFPCE (Current_command_is_sync_without_data_60n11s1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Current_command_is_sync_without_data) ;
   DFFPCE (Current_command_is_sync_with_data_60n11s1,debug_EXMPLR1003(15),
   not_ResetN,CE,clock,Current_command_is_sync_with_data) ;
   DFFPCE (MT_On_Async_60n28ss1,debug_EXMPLR1003(15),not_ResetN,rtlc60n7463,
   clock,MT_On_Async) ;
   DFFPCE (Config_reg_1(13),debug_EXMPLR1003(15),not_ResetN,rtlc60n7462,
   clock,Current_Area_B) ;
   DFFPCE (not_test_complete,debug_EXMPLR1003(15),not_ResetN,rtlc60n7461,
   clock,Do_Protocol_test) ;
   DFFPCE (not_test_complete,debug_EXMPLR1003(15),not_ResetN,rtlc60n7460,
   clock,Do_RAM_test) ;
   DFFPCE (Clear_Test_Status_reg_60n43ss1,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5920,clock,Clear_Test_Status_reg) ;
   DFFPCE (rtlcs308,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   one_micro_increment_wide) ;
   DFFPC (one_micro_increment_60n16ss1,debug_EXMPLR1003(15),not_ResetN,clock,
   one_micro_increment) ;
   DFFPCE (rtlcn3516,debug_EXMPLR1003(15),not_ResetN,not_rtlc60n6053,clock,
   BC_Stop_EOF) ;
   DFFPCE (rtlcn3547,debug_EXMPLR1003(15),not_ResetN,not_rtlc60n6052,clock,
   BC_Stop_EOM) ;
   DFFPCE (CPU_Data_in_wide(31),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(15)) ;
   DFFPCE (CPU_Data_in_wide(30),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(14)) ;
   DFFPCE (CPU_Data_in_wide(29),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(13)) ;
   DFFPCE (CPU_Data_in_wide(28),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(12)) ;
   DFFPCE (CPU_Data_in_wide(27),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(11)) ;
   DFFPCE (CPU_Data_in_wide(26),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(10)) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(9)) ;
   DFFPCE (CPU_Data_in_wide(24),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(8)) ;
   DFFPCE (CPU_Data_in_wide(23),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(7)) ;
   DFFPCE (CPU_Data_in_wide(22),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(6)) ;
   DFFPCE (CPU_Data_in_wide(21),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(5)) ;
   DFFPCE (CPU_Data_in_wide(20),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(4)) ;
   DFFPCE (CPU_Data_in_wide(19),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(3)) ;
   DFFPCE (CPU_Data_in_wide(18),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(2)) ;
   DFFPCE (CPU_Data_in_wide(17),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(1)) ;
   DFFPCE (CPU_Data_in_wide(16),debug_EXMPLR1003(15),not_ResetN,rtlc60n7455,
   clock,Frame_length_reg_0xD(0)) ;
   DFFPCE (rtlcn2768,debug_EXMPLR1003(15),not_ResetN,not_rtlc60n5916,clock,
   BC_START) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(15),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(15)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(14),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(14)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(13),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(13)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(12),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(12)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(11),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(11)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(10),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(10)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(9),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(9)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(8),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(8)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(7),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(7)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(6),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(6)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(5),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(5)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(4),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(4)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(3),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(3)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(2),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(2)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(1),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(1)) ;
   DFFPCE (Dummy_register_0x4_60n43ss1(0),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5915,clock,Dummy_register_0x4(0)) ;
   DFFPCE (Clean_status2_bits_60n78ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7422,clock,Clean_status2_bits) ;
   DFFPCE (Clean_status_bits_60n76ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7421,clock,Clean_status_bits) ;
   DFFPC (rtlc60n6509,debug_EXMPLR1003(15),not_ResetN,clock,
   Read_from_int_vec2) ;
   DFFPC (rtlc60n6476,debug_EXMPLR1003(15),not_ResetN,clock,
   Read_from_int_vec) ;
   DFFPCE (CPU_Data_in_wide(31),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(15)) ;
   DFFPCE (CPU_Data_in_wide(30),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(14)) ;
   DFFPCE (CPU_Data_in_wide(29),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(13)) ;
   DFFPCE (CPU_Data_in_wide(28),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(12)) ;
   DFFPCE (CPU_Data_in_wide(27),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(11)) ;
   DFFPCE (CPU_Data_in_wide(26),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(10)) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(9)) ;
   DFFPCE (CPU_Data_in_wide(24),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(8)) ;
   DFFPCE (CPU_Data_in_wide(23),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(7)) ;
   DFFPCE (CPU_Data_in_wide(22),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(6)) ;
   DFFPCE (CPU_Data_in_wide(21),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(5)) ;
   DFFPCE (CPU_Data_in_wide(20),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(4)) ;
   DFFPCE (CPU_Data_in_wide(19),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(3)) ;
   DFFPCE (CPU_Data_in_wide(18),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(2)) ;
   DFFPCE (CPU_Data_in_wide(17),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(1)) ;
   DFFPCE (CPU_Data_in_wide(16),debug_EXMPLR1003(15),not_ResetN,rtlc60n7420,
   clock,Interrupt_mask_register_2(0)) ;
   DFFPCE (CPU_Data_in_wide(15),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(15)) ;
   DFFPCE (CPU_Data_in_wide(14),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(14)) ;
   DFFPCE (CPU_Data_in_wide(13),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(13)) ;
   DFFPCE (CPU_Data_in_wide(12),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(12)) ;
   DFFPCE (CPU_Data_in_wide(11),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(11)) ;
   DFFPCE (CPU_Data_in_wide(10),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(10)) ;
   DFFPCE (CPU_Data_in_wide(9),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(9)) ;
   DFFPCE (CPU_Data_in_wide(8),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(8)) ;
   DFFPCE (CPU_Data_in_wide(7),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(7)) ;
   DFFPCE (CPU_Data_in_wide(6),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(6)) ;
   DFFPCE (CPU_Data_in_wide(5),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(5)) ;
   DFFPCE (CPU_Data_in_wide(4),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(4)) ;
   DFFPCE (CPU_Data_in_wide(3),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(3)) ;
   DFFPCE (CPU_Data_in_wide(2),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(2)) ;
   DFFPCE (CPU_Data_in_wide(1),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(1)) ;
   DFFPCE (CPU_Data_in_wide(0),debug_EXMPLR1003(15),not_ResetN,rtlc60n7404,
   clock,Interrupt_mask_register_1(0)) ;
   DFFPCE (CPU_Data_in_wide(15),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_15) ;
   DFFPCE (CPU_Data_in_wide(14),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_14) ;
   DFFPCE (CPU_Data_in_wide(13),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_13) ;
   DFFPCE (CPU_Data_in_wide(12),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_12) ;
   DFFPCE (CPU_Data_in_wide(11),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_11) ;
   DFFPCE (CPU_Data_in_wide(10),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_10) ;
   DFFPCE (CPU_Data_in_wide(9),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_9) ;
   DFFPCE (CPU_Data_in_wide(8),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_8) ;
   DFFPCE (CPU_Data_in_wide(7),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_7) ;
   DFFPCE (CPU_Data_in_wide(6),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_6) ;
   DFFPCE (CPU_Data_in_wide(5),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_5) ;
   DFFPCE (CPU_Data_in_wide(4),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_4) ;
   DFFPCE (CPU_Data_in_wide(3),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_3) ;
   DFFPCE (CPU_Data_in_wide(2),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,Config_reg_6_2) ;
   DFFPCE (CPU_Data_in_wide(1),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,IP_Freq_sel_EXMPLR994(1)) ;
   DFFPCE (CPU_Data_in_wide(0),debug_EXMPLR1003(15),not_ResetN,rtlc60n7388,
   clock,IP_Freq_sel_EXMPLR994(0)) ;
   DFFPCE (CPU_Data_in_wide(31),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,n16Mhz_12_EXMPLR860) ;
   DFFPCE (CPU_Data_in_wide(30),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(14)) ;
   DFFPCE (Config_reg_5_60n51ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7370,clock,Config_reg_5(13)) ;
   DFFPCE (Config_reg_5_60n51ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7370,clock,Config_reg_5(12)) ;
   DFFPCE (CPU_Data_in_wide(27),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(11)) ;
   DFFPCE (CPU_Data_in_wide(26),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(10)) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(9)) ;
   DFFPCE (CPU_Data_in_wide(24),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(8)) ;
   DFFPCE (CPU_Data_in_wide(23),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(7)) ;
   DFFPCE (Config_reg_5_60n51ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7370,clock,Config_reg_5(6)) ;
   DFFPCE (CPU_Data_in_wide(21),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(5)) ;
   DFFPCE (CPU_Data_in_wide(20),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(4)) ;
   DFFPCE (CPU_Data_in_wide(19),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(3)) ;
   DFFPCE (CPU_Data_in_wide(18),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(2)) ;
   DFFPCE (CPU_Data_in_wide(17),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(1)) ;
   DFFPCE (CPU_Data_in_wide(16),debug_EXMPLR1003(15),not_ResetN,rtlc60n7372,
   clock,Config_reg_5(0)) ;
   DFFPCE (CPU_Data_in_wide(15),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(15)) ;
   DFFPCE (CPU_Data_in_wide(14),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(14)) ;
   DFFPCE (CPU_Data_in_wide(13),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(13)) ;
   DFFPCE (CPU_Data_in_wide(12),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(12)) ;
   DFFPCE (CPU_Data_in_wide(11),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(11)) ;
   DFFPCE (CPU_Data_in_wide(10),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(10)) ;
   DFFPCE (CPU_Data_in_wide(9),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(9)) ;
   DFFPCE (CPU_Data_in_wide(8),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(8)) ;
   DFFPCE (CPU_Data_in_wide(7),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(7)) ;
   DFFPCE (CPU_Data_in_wide(6),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(6)) ;
   DFFPCE (CPU_Data_in_wide(5),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(5)) ;
   DFFPCE (CPU_Data_in_wide(4),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(4)) ;
   DFFPCE (CPU_Data_in_wide(3),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(3)) ;
   DFFPCE (CPU_Data_in_wide(2),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(2)) ;
   DFFPCE (CPU_Data_in_wide(1),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(1)) ;
   DFFPCE (CPU_Data_in_wide(0),debug_EXMPLR1003(15),not_ResetN,rtlc60n7356,
   clock,Config_reg_4_EXMPLR998(0)) ;
   DFFPCE (CPU_Data_in_wide(31),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_15) ;
   DFFPCE (CPU_Data_in_wide(30),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_14) ;
   DFFPCE (CPU_Data_in_wide(29),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_13) ;
   DFFPCE (CPU_Data_in_wide(28),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_12) ;
   DFFPCE (CPU_Data_in_wide(27),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_11) ;
   DFFPCE (CPU_Data_in_wide(26),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_10) ;
   DFFPCE (CPU_Data_in_wide(25),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_9) ;
   DFFPCE (CPU_Data_in_wide(24),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_8) ;
   DFFPCE (CPU_Data_in_wide(23),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_7) ;
   DFFPCE (CPU_Data_in_wide(22),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_6) ;
   DFFPCE (CPU_Data_in_wide(21),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_5) ;
   DFFPCE (CPU_Data_in_wide(20),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_4) ;
   DFFPCE (CPU_Data_in_wide(19),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_3) ;
   DFFPCE (CPU_Data_in_wide(18),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_2) ;
   DFFPCE (CPU_Data_in_wide(17),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,MODE_CODE1553A_EXMPLR917) ;
   DFFPCE (CPU_Data_in_wide(16),debug_EXMPLR1003(15),not_ResetN,rtlc60n7340,
   clock,Config_reg_3_0) ;
   DFFPCE (CPU_Data_in_wide(15),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(15)) ;
   DFFPCE (CPU_Data_in_wide(14),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(14)) ;
   DFFPCE (CPU_Data_in_wide(13),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(13)) ;
   DFFPCE (CPU_Data_in_wide(12),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(12)) ;
   DFFPCE (CPU_Data_in_wide(11),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(11)) ;
   DFFPCE (CPU_Data_in_wide(10),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(10)) ;
   DFFPCE (CPU_Data_in_wide(9),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(9)) ;
   DFFPCE (CPU_Data_in_wide(8),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(8)) ;
   DFFPCE (CPU_Data_in_wide(7),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(7)) ;
   DFFPCE (CPU_Data_in_wide(6),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(6)) ;
   DFFPCE (CPU_Data_in_wide(5),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(5)) ;
   DFFPCE (CPU_Data_in_wide(4),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(4)) ;
   DFFPCE (CPU_Data_in_wide(3),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(3)) ;
   DFFPCE (CPU_Data_in_wide(2),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(2)) ;
   DFFPCE (CPU_Data_in_wide(1),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(1)) ;
   DFFPCE (CPU_Data_in_wide(0),debug_EXMPLR1003(15),not_ResetN,rtlc60n7324,
   clock,Config_reg_2(0)) ;
   DFFPCE (Config_reg_1_60n43ss1_15,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(15)) ;
   DFFPCE (Config_reg_1_60n43ss1_14,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(14)) ;
   DFFPCE (Config_reg_1_60n43ss1_13,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(13)) ;
   DFFPCE (Config_reg_1_60n43ss1_12,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(12)) ;
   DFFPCE (Config_reg_1_60n43ss1_11,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(11)) ;
   DFFPCE (Config_reg_1_60n43ss1_10,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(10)) ;
   DFFPCE (Config_reg_1_60n91ss1_3,debug_EXMPLR1003(15),not_ResetN,
   rtlc60n7302,clock,Config_reg_1(9)) ;
   DFFPCE (Config_reg_1_60n43ss1_8,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(8)) ;
   DFFPCE (Config_reg_1_60n43ss1_7,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(7)) ;
   DFFPCE (Config_reg_1_60n43ss1_6,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(6)) ;
   DFFPCE (Config_reg_1_60n43ss1_5,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(5)) ;
   DFFPCE (Config_reg_1_60n43ss1_4,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(4)) ;
   DFFPCE (Config_reg_1_60n43ss1_3,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5906,clock,Config_reg_1(3)) ;
   DFFPCE (rtlcn10967,debug_EXMPLR1003(15),not_ResetN,not_rtlc60n6687,clock,
   Config_reg_1(2)) ;
   DFFPCE (Config_reg_1_60n91ss1_1,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n6686,clock,Config_reg_1(1)) ;
   DFFPCE (rtlcn10964,debug_EXMPLR1003(15),not_ResetN,not_rtlc60n6685,clock,
   Config_reg_1(0)) ;
   DFFPCE (host_status_bits_60n46ss1_10,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(10)) ;
   DFFPCE (host_status_bits_60n46ss1_9,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(9)) ;
   DFFPCE (host_status_bits_60n46ss1_7,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(7)) ;
   DFFPCE (host_status_bits_60n46ss1_6,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(6)) ;
   DFFPCE (host_status_bits_60n46ss1_5,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(5)) ;
   DFFPCE (host_status_bits_60n46ss1_4,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(4)) ;
   DFFPCE (host_status_bits_60n46ss1_2,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(2)) ;
   DFFPCE (host_status_bits_60n46ss1_1,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5981,clock,host_status_bits(1)) ;
   DFFPC (GMM_60n92ss1(2),debug_EXMPLR1003(15),not_ResetN,clock,GMM(2)) ;
   DFFPC (GMM_60n92ss1(1),debug_EXMPLR1003(15),not_ResetN,clock,GMM(1)) ;
   DFFPC (GMM_60n92ss1(0),debug_EXMPLR1003(15),not_ResetN,clock,GMM(0)) ;
   DFFPCE (Tag_CLK_D,debug_EXMPLR1003(15),not_ResetN,CE,clock,Tag_CLK_DD) ;
   DFFPCE (Tag_CLK_D_60n43ss1,debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5905,clock,Tag_CLK_D) ;
   DFFPCE (rtlcn6188,debug_EXMPLR1003(15),not_ResetN,CE,clock,time_tag_inc)
    ;
   DFFPC (time_tag_EXMPLR1002(15),debug_EXMPLR1003(15),not_ResetN,clock,
   time_tag15d) ;
   DFFPCE (time_tag_60n43ss1(15),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(15)) ;
   DFFPCE (time_tag_60n43ss1(14),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(14)) ;
   DFFPCE (time_tag_60n43ss1(13),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(13)) ;
   DFFPCE (time_tag_60n43ss1(12),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(12)) ;
   DFFPCE (time_tag_60n43ss1(11),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(11)) ;
   DFFPCE (time_tag_60n43ss1(10),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(10)) ;
   DFFPCE (time_tag_60n43ss1(9),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(9)) ;
   DFFPCE (time_tag_60n43ss1(8),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(8)) ;
   DFFPCE (time_tag_60n43ss1(7),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(7)) ;
   DFFPCE (time_tag_60n43ss1(6),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(6)) ;
   DFFPCE (time_tag_60n43ss1(5),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(5)) ;
   DFFPCE (time_tag_60n43ss1(4),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(4)) ;
   DFFPCE (time_tag_60n43ss1(3),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(3)) ;
   DFFPCE (time_tag_60n43ss1(2),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(2)) ;
   DFFPCE (time_tag_60n43ss1(1),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(1)) ;
   DFFPCE (time_tag_60n43ss1(0),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5904,clock,time_tag_EXMPLR1002(0)) ;
   DFFPCE (count_T_RESus_60n43ss1(5),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(5)) ;
   DFFPCE (count_T_RESus_60n43ss1(4),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(4)) ;
   DFFPCE (count_T_RESus_60n43ss1(3),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(3)) ;
   DFFPCE (count_T_RESus_60n43ss1(2),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(2)) ;
   DFFPCE (count_T_RESus_60n43ss1(1),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(1)) ;
   DFFPCE (count_T_RESus_60n43ss1(0),debug_EXMPLR1003(15),not_ResetN,
   not_rtlc60n5903,clock,count_T_RESus(0)) ;
   DFFPC (eBC_63n3s1,debug_EXMPLR1003(15),not_Raw_resetN,clock,eBC) ;
   DFFPC (WM_On_63n3s1,debug_EXMPLR1003(15),not_Raw_resetN,clock,WM_On) ;
   DFFPCE (rtlc32n459,debug_EXMPLR1003(15),not_Raw_resetN,rtlcn1229,clock,
   MT_On) ;
   DFFPC (RT_On_63n1s1,debug_EXMPLR1003(15),not_Raw_resetN,clock,
   RT_On_EXMPLR924) ;
   DFFPC (SW_Reset_66n1ss1,debug_EXMPLR1003(15),not_Raw_resetN,clock,
   SW_Reset) ;
   DFFPCE (PWR,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Ksts) ;
   DFFPC (Strobe_TT_D(0),debug_EXMPLR1003(15),not_ResetN,clock,
   Strobe_TT_D(1)) ;
   DFFPC (Strobe_TT,debug_EXMPLR1003(15),not_ResetN,clock,Strobe_TT_D(0)) ;
   DFFPCE (time_tag_EXMPLR1002(15),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(15)) ;
   DFFPCE (time_tag_EXMPLR1002(14),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(14)) ;
   DFFPCE (time_tag_EXMPLR1002(13),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(13)) ;
   DFFPCE (time_tag_EXMPLR1002(12),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(12)) ;
   DFFPCE (time_tag_EXMPLR1002(11),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(11)) ;
   DFFPCE (time_tag_EXMPLR1002(10),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(10)) ;
   DFFPCE (time_tag_EXMPLR1002(9),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(9)) ;
   DFFPCE (time_tag_EXMPLR1002(8),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(8)) ;
   DFFPCE (time_tag_EXMPLR1002(7),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(7)) ;
   DFFPCE (time_tag_EXMPLR1002(6),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(6)) ;
   DFFPCE (time_tag_EXMPLR1002(5),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(5)) ;
   DFFPCE (time_tag_EXMPLR1002(4),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(4)) ;
   DFFPCE (time_tag_EXMPLR1002(3),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(3)) ;
   DFFPCE (time_tag_EXMPLR1002(2),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(2)) ;
   DFFPCE (time_tag_EXMPLR1002(1),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(1)) ;
   DFFPCE (time_tag_EXMPLR1002(0),debug_EXMPLR1003(15),not_ResetN,rtlcs309,
   clock,Latched_TT(0)) ;
   DFFPCE (MIL1553_errors_transmitter_timout,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2896,clock,Tx_Timeout_D) ;
   DFFPCE (eBC_Bad_Parity,debug_EXMPLR1003(15),not_ResetN,rtlc75n2894,clock,
   ISR2_during_clear_14) ;
   DFFPCE (rtlc75n1848,debug_EXMPLR1003(15),not_ResetN,rtlc75n2892,clock,
   ISR2_during_clear_12) ;
   DFFPCE (eBC_Stack_error,debug_EXMPLR1003(15),not_ResetN,rtlc75n2891,clock,
   ISR2_during_clear_11) ;
   DFFPCE (eBC_Bad_instruction,debug_EXMPLR1003(15),not_ResetN,rtlc75n2890,
   clock,ISR2_during_clear_10) ;
   DFFPCE (Monitor_command_stack_half_pass,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2887,clock,ISR2_during_clear_7) ;
   DFFPCE (Monitor_data_stack_half_pass,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2886,clock,ISR2_during_clear_6) ;
   DFFPCE (rtlcn6794,debug_EXMPLR1003(15),not_ResetN,not_rtlc75n1972,clock,
   ISR2_during_clear_5) ;
   DFFPCE (rtlcn6769,debug_EXMPLR1003(15),not_ResetN,not_rtlc75n1971,clock,
   ISR2_during_clear_4) ;
   DFFPCE (rtlcn6744,debug_EXMPLR1003(15),not_ResetN,not_rtlc75n1970,clock,
   ISR2_during_clear_3) ;
   DFFPCE (rtlcn8681,debug_EXMPLR1003(15),not_ResetN,rtlc75n2881,clock,
   ISR2_during_clear_1) ;
   DFFPCE (rtlc75_ISR1_during_clear_D_n498_13,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2877,clock,ISR1_during_clear_13) ;
   DFFPCE (rtlc75n1547,debug_EXMPLR1003(15),not_ResetN,rtlc75n2876,clock,
   ISR1_during_clear_12) ;
   DFFPCE (Monitor_command_stack_rollover,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2875,clock,ISR1_during_clear_11) ;
   DFFPCE (Monitor_data_stack_rollover,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2874,clock,ISR1_during_clear_10) ;
   DFFPCE (BC_Retry_pulse,debug_EXMPLR1003(15),not_ResetN,rtlc75n2872,clock,
   ISR1_during_clear_8) ;
   DFFPCE (rtlc75n1647,debug_EXMPLR1003(15),not_ResetN,rtlc75n2870,clock,
   ISR1_during_clear_6) ;
   DFFPCE (rtlc75n1665,debug_EXMPLR1003(15),not_ResetN,rtlc75n2869,clock,
   ISR1_during_clear_5) ;
   DFFPCE (rtlc75n1714,debug_EXMPLR1003(15),not_ResetN,rtlc75n2868,clock,
   ISR1_during_clear_4) ;
   DFFPCE (rtlc75n1730,debug_EXMPLR1003(15),not_ResetN,rtlc75n2867,clock,
   ISR1_during_clear_3) ;
   DFFPCE (rtlc75n1765,debug_EXMPLR1003(15),not_ResetN,rtlc75n2866,clock,
   ISR1_during_clear_2) ;
   DFFPCE (rtlc75n1795,debug_EXMPLR1003(15),not_ResetN,rtlc75n2865,clock,
   ISR1_during_clear_1) ;
   DFFPCE (rtlc75n1819,debug_EXMPLR1003(15),not_ResetN,rtlc75n2864,clock,
   ISR1_during_clear_0) ;
   DFFPCE (rtlcn6683,debug_EXMPLR1003(15),not_ResetN,rtlc75n2863,clock,
   Clean_ISR2_by_write) ;
   DFFPCE (rtlcn6074,debug_EXMPLR1003(15),not_ResetN,rtlc75n2862,clock,
   Clean_ISR1_by_write) ;
   DFFPCE (Non_masked_Event_75n37ss1,debug_EXMPLR1003(15),not_ResetN,
   rtlc75n2861,clock,Non_masked_Event) ;
   DFFPC (rtlc75_Interrupt_status_register_2_D_n494_15,debug_EXMPLR1003(15),
   not_ResetN,clock,Interrupt_status_register_2_15) ;
   DFFPCE (Interrupt_status_register_2_75n26ss1(1),debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2860,clock,Interrupt_status_register_2_14) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_12,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2858,clock,Interrupt_status_register_2_12) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_11,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2857,clock,Interrupt_status_register_2_11) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_10,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2856,clock,Interrupt_status_register_2_10) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_7,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2853,clock,Interrupt_status_register_2_7) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_6,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2852,clock,Interrupt_status_register_2_6) ;
   DFFPCE (Interrupt_status_register_2_75n36ss1(3),debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2851,clock,Interrupt_status_register_2_5) ;
   DFFPCE (Interrupt_status_register_2_75n36ss1(2),debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2850,clock,Interrupt_status_register_2_4) ;
   DFFPCE (Interrupt_status_register_2_75n36ss1(1),debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2849,clock,Interrupt_status_register_2_3) ;
   DFFPCE (Interrupt_status_register_2_75n36ss1(0),debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2848,clock,Interrupt_status_register_2_2) ;
   DFFPCE (rtlc75_Interrupt_status_register_2_D_n494_1,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2847,clock,Interrupt_status_register_2_1) ;
   DFFPC (Int1_Chain,debug_EXMPLR1003(15),not_ResetN,clock,
   Interrupt_status_register_2_0) ;
   DFFPCE (Interrupt_status_register_1_75n7ss1(14),debug_EXMPLR1003(15),
   not_ResetN,not_rtlc75n1492,clock,Interrupt_status_register_1(14)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_13,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2845,clock,Interrupt_status_register_1(13)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_12,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2844,clock,Interrupt_status_register_1(12)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_11,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2843,clock,Interrupt_status_register_1(11)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_10,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2842,clock,Interrupt_status_register_1(10)) ;
   DFFPCE (Interrupt_status_register_1_75n7ss1(9),debug_EXMPLR1003(15),
   not_ResetN,not_rtlc75n1492,clock,Interrupt_status_register_1(9)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_8,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2840,clock,Interrupt_status_register_1(8)) ;
   DFFPCE (Interrupt_status_register_1_75n7ss1(7),debug_EXMPLR1003(15),
   not_ResetN,not_rtlc75n1492,clock,Interrupt_status_register_1(7)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_6,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2838,clock,Interrupt_status_register_1(6)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_5,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2837,clock,Interrupt_status_register_1(5)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_4,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2836,clock,Interrupt_status_register_1(4)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_3,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2835,clock,Interrupt_status_register_1(3)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_2,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2834,clock,Interrupt_status_register_1(2)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_1,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2833,clock,Interrupt_status_register_1(1)) ;
   DFFPCE (rtlc75_Interrupt_status_register_1_D_n493_0,debug_EXMPLR1003(15),
   not_ResetN,rtlc75n2832,clock,Interrupt_status_register_1(0)) ;
   DFFPC (reg_data_out_wide_75n71ss1(31),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(31)) ;
   DFFPC (reg_data_out_wide_75n71ss1(30),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(30)) ;
   DFFPC (reg_data_out_wide_75n71ss1(29),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(29)) ;
   DFFPC (reg_data_out_wide_75n71ss1(28),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(28)) ;
   DFFPC (reg_data_out_wide_75n71ss1(27),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(27)) ;
   DFFPC (reg_data_out_wide_75n71ss1(26),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(26)) ;
   DFFPC (reg_data_out_wide_75n71ss1(25),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(25)) ;
   DFFPC (reg_data_out_wide_75n71ss1(24),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(24)) ;
   DFFPC (reg_data_out_wide_75n71ss1(23),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(23)) ;
   DFFPC (reg_data_out_wide_75n71ss1(22),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(22)) ;
   DFFPC (reg_data_out_wide_75n71ss1(21),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(21)) ;
   DFFPC (reg_data_out_wide_75n71ss1(20),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(20)) ;
   DFFPC (reg_data_out_wide_75n71ss1(19),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(19)) ;
   DFFPC (reg_data_out_wide_75n71ss1(18),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(18)) ;
   DFFPC (reg_data_out_wide_75n71ss1(17),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(17)) ;
   DFFPC (reg_data_out_wide_75n71ss1(16),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(16)) ;
   DFFPC (reg_data_out_wide_75n71ss1(15),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(15)) ;
   DFFPC (reg_data_out_wide_75n71ss1(14),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(14)) ;
   DFFPC (reg_data_out_wide_75n71ss1(13),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(13)) ;
   DFFPC (reg_data_out_wide_75n71ss1(12),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(12)) ;
   DFFPC (reg_data_out_wide_75n71ss1(11),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(11)) ;
   DFFPC (reg_data_out_wide_75n71ss1(10),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(10)) ;
   DFFPC (reg_data_out_wide_75n71ss1(9),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(9)) ;
   DFFPC (reg_data_out_wide_75n71ss1(8),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(8)) ;
   DFFPC (reg_data_out_wide_75n71ss1(7),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(7)) ;
   DFFPC (reg_data_out_wide_75n71ss1(6),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(6)) ;
   DFFPC (reg_data_out_wide_75n71ss1(5),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(5)) ;
   DFFPC (reg_data_out_wide_75n71ss1(4),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(4)) ;
   DFFPC (reg_data_out_wide_75n71ss1(3),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(3)) ;
   DFFPC (reg_data_out_wide_75n71ss1(2),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(2)) ;
   DFFPC (reg_data_out_wide_75n71ss1(1),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(1)) ;
   DFFPC (reg_data_out_wide_75n71ss1(0),debug_EXMPLR1003(15),not_ResetN,
   clock,reg_data_out_wide(0)) ;
   DFFPCE (MIL1553_errors_transmitter_timout,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n400,clock,Internal_BIT_Word_15) ;
   DFFPCE (MIL1553_errors_echo_back_bus_B,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n399,clock,Internal_BIT_Word_14) ;
   DFFPCE (MIL1553_errors_echo_back_bus_A,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n398,clock,Internal_BIT_Word_13) ;
   DFFPCE (MIL1553_errors_bus_B_shutdown,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n396,clock,Internal_BIT_Word_11) ;
   DFFPCE (MIL1553_errors_bus_A_shutdown,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n395,clock,Internal_BIT_Word_10) ;
   DFFPCE (MIL1553_errors_Inhibit_TF,debug_EXMPLR1003(15),not_ResetN,
   rtlc78n394,clock,Internal_BIT_Word_9) ;
   DFFPCE (RTADP,not_Raw_resetN,debug_EXMPLR1003(15),rtlc81n121,clock,
   Wire_RT_Address(5)) ;
   DFFPCE (RTAD(4),not_Raw_resetN,debug_EXMPLR1003(15),rtlc81n121,clock,
   Wire_RT_Address(4)) ;
   DFFPCE (RTAD(3),not_Raw_resetN,debug_EXMPLR1003(15),rtlc81n121,clock,
   Wire_RT_Address(3)) ;
   DFFPCE (RTAD(2),not_Raw_resetN,debug_EXMPLR1003(15),rtlc81n121,clock,
   Wire_RT_Address(2)) ;
   DFFPCE (RTAD(1),not_Raw_resetN,debug_EXMPLR1003(15),rtlc81n121,clock,
   Wire_RT_Address(1)) ;
   DFFPCE (RTAD(0),debug_EXMPLR1003(15),not_Raw_resetN,rtlc81n121,clock,
   Wire_RT_Address(0)) ;
   DFFPCE (debug_EXMPLR1003(15),not_Raw_resetN,debug_EXMPLR1003(15),
   rtlc81n54,clock,First_After_Reset) ;
   DFFPC (BIT_Test_complete_84n7ss1,debug_EXMPLR1003(15),not_HW_ResetN,clock,
   BIT_Test_complete) ;
   DFFPCE (Test_Status_reg_84n4ss1(1),debug_EXMPLR1003(15),not_HW_ResetN,
   rtlc84n251,clock,Test_Status_reg_15) ;
   DFFPCE (Test_Status_reg_84n4ss1(0),debug_EXMPLR1003(15),not_HW_ResetN,
   not_rtlc84n141,clock,Test_Status_reg_14) ;
   DFFPCE (Test_Status_reg_84n4ss1(0),debug_EXMPLR1003(15),not_HW_ResetN,
   rtlc84n247,clock,Test_Status_reg_11) ;
   DFFPCE (Test_Status_reg_84n7ss1(0),debug_EXMPLR1003(15),not_HW_ResetN,
   not_rtlc84n179,clock,Test_Status_reg_7) ;
   DFFPCE (Test_Status_reg_84n7ss1(1),debug_EXMPLR1003(15),not_HW_ResetN,
   not_rtlc84n180,clock,Test_Status_reg_6) ;
   DFFPCE (debug_EXMPLR1003(15),not_HW_ResetN,debug_EXMPLR1003(15),
   rtlc84n235,clock,First_time) ;
   DFFPCE (rtlcn2673,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(8)) ;
   DFFPCE (rtlcn2724,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(7)) ;
   DFFPCE (state_fsm_87n14ss1_6,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   state(6)) ;
   DFFPCE (rtlcn2698,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(5)) ;
   DFFPCE (rtlcn2637,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(4)) ;
   DFFPCE (rtlcn2667,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(3)) ;
   DFFPCE (rtlcn2713,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(2)) ;
   DFFPCE (rtlcn2733,debug_EXMPLR1003(15),not_ResetN,CE,clock,state(1)) ;
   DFFPCE (rtlcn2741,not_ResetN,debug_EXMPLR1003(15),CE,clock,state(0)) ;
   DFFPCE (rtlcn7050,debug_EXMPLR1003(15),not_ResetN,CE,clock,WM_triggered)
    ;
   DFFPCE (rtlcn6662,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   WM_Trigger_event) ;
   DFFPCE (rtlcn4145,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   WM_Started_EXMPLR927) ;
   DFFPCE (WM_Ram_RE_87n14ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   WM_Ram_RE) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(15),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(15)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(14),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(14)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(13),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(13)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(12),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(12)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(11),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(11)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(10),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(10)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(9),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(9)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(8),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(8)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(7),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(7)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(6),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(6)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(5),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(5)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(4),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(4)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(3),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(3)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(2),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(2)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(1),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(1)) ;
   DFFPCE (WM_RAM_data_i_87n13ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlc87n716,clock,WM_RAM_data_i(0)) ;
   DFFPCE (WM_RAM_WE_87n14ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   WM_RAM_WE) ;
   DFFPCE (WM_Ack_87n14ss1,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   WM_Ack_EXMPLR926) ;
   DFFPCE (BC_DISABLE,debug_EXMPLR1003(15),not_Raw_resetN,rtlc81n54,clock,
   BC_OFF) ;
   DFFPCE (WM_RAM_Address_87n13ss1(0),debug_EXMPLR1003(15),not_ResetN,
   rtlcn10632,clock,WM_RAM_Address(0)) ;
   DFFPC (rtlcn15241,debug_EXMPLR1003(15),not_ResetN,clock,
   host_status_bits(8)) ;
   DFFPC (rtlcn15242,debug_EXMPLR1003(15),not_ResetN,clock,
   host_status_bits_3_EXMPLR935) ;
   DFFPC (rtlcn15243,debug_EXMPLR1003(15),not_ResetN,clock,
   host_status_bits(0)) ;
   Enhanced_status_set_dt <= eBC_Conditions_11 AND g0_I1_not_I_d ;
   g0_I1_not_I_d <= NOT g0_I1_I_d ;
   DFFPCE (eBC_Conditions_11,debug_EXMPLR1003(15),not_ResetN,CE,clock,
   g0_I1_I_d) ;
   status_set_dt <= status_set AND g0_I2_not_I_d ;
   g0_I2_not_I_d <= NOT g0_I2_I_d ;
   DFFPCE (status_set,debug_EXMPLR1003(15),not_ResetN,CE,clock,g0_I2_I_d) ;
   Interrupt_status_register_1_75n7ss1(9) <= 
   Interrupt_status_register_1_75n6s1_9 AND rtlcn6074 ;
   BIT_Word(7) <= Data_to_FE_EXMPLR999(7) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(6) <= Data_to_FE_EXMPLR999(6) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(5) <= Data_to_FE_EXMPLR999(5) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(4) <= Data_to_FE_EXMPLR999(4) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(3) <= Data_to_FE_EXMPLR999(3) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(2) <= Data_to_FE_EXMPLR999(2) AND Config_reg_4_EXMPLR998(15) ;
   BIT_Word(0) <= Data_to_FE_EXMPLR999(0) AND Config_reg_4_EXMPLR998(15) ;
   rtlc22_1116_or_59_nx0 <= MON_SOM_phase(1) OR MON_SOM_phase(2) ;
   rtlc22n10340 <= rtlc22_1116_or_59_nx0 OR MON_SOM_phase(3) ;
   rtlc26_1554_or_91_nx0 <= BC_State(19) OR BC_State(43) ;
   rtlc26n16205 <= rtlc26_1554_or_91_nx0 OR BC_State(45) ;
   rtlc26n16306 <= BC_State(2) OR BC_State(3) ;
   rtlc26n16321 <= rtlc26n16306 OR BC_State(58) ;
   rtlc26_2362_or_117_nx0 <= BC_State(0) OR BC_State(80) ;
   rtlc26n16783 <= rtlc26_2362_or_117_nx0 OR BC_State(81) ;
   rtlc26n17314 <= rtlcn2520 OR BC_State(80) ;
   rtlc26_3207_or_128_nx0 <= BC_State(58) OR BC_State(86) ;
   rtlc26n17337 <= rtlc26_3207_or_128_nx0 OR BC_State(87) ;
   rtlc26_3711_or_130_nx0 <= not_LIFO_Pointer_4 OR not_BC_Echo_word_10 ;
   rtlc26n15232 <= rtlc26_3711_or_130_nx0 OR not_Ack ;
   rtlc26_5650_and_133_nx0 <= Config_reg_4_EXMPLR998(7) AND ReTry_count(0) ;
   rtlc26_PS144_n12968 <= rtlc26_5650_and_133_nx0 AND not_ReTry_count_1 ;
   rtlc29n677 <= rtlcn12124 OR INTn_count(3) ;
   rtlc48_X_0_n209 <= rtlcn10148 AND not_BC_Load_msg_gap_counter ;
   rtlc51_258_and_151_nx0 <= rtlcn1227 AND not_eBC_start_FT ;
   rtlc51_X_0_n289 <= rtlc51_258_and_151_nx0 AND 
   not_BC_Load_frame_gap_counter ;
   rtlc60_1067_or_153_nx0 <= not_CPU_Data_in_wide_21 OR not_rtlc60n5464 ;
   rtlc60n5919 <= rtlc60_1067_or_153_nx0 OR not_rtlc60n6494 ;
   rtlc60_1071_or_154_nx0 <= not_CPU_Data_in_wide_22 OR not_rtlc60n5464 ;
   rtlc60n5918 <= rtlc60_1071_or_154_nx0 OR not_rtlc60n6494 ;
   rtlc_3211_or_204_nx0 <= BC_State(15) OR BC_State(40) ;
   rtlcn2269 <= rtlc_3211_or_204_nx0 OR BC_State(44) ;
   rtlc_12570_or_467_nx0 <= rtlcs50 OR rtlcs52 ;
   rtlc22n10407 <= rtlc_12570_or_467_nx0 OR rtlcs59 ;
   rtlc_12628_or_468_nx0 <= rtlcs106 OR rtlcs109 ;
   rtlc26n14359 <= rtlc_12628_or_468_nx0 OR rtlcs110 ;
   rtlc_13681_or_469_nx0 <= MON_SOM_phase(0) OR MON_SOM_phase(1) ;
   rtlcn8785 <= rtlc_13681_or_469_nx0 OR rtlc22n10314 ;
   rtlc_13716_or_471_nx0 <= BC_State(12) OR BC_State(40) ;
   rtlcn2142 <= rtlc_13716_or_471_nx0 OR BC_State(44) ;
   rtlc_13720_or_473_nx0 <= CPU_Address(1) OR CPU_Address(3) ;
   rtlcn8796 <= rtlc_13720_or_473_nx0 OR not_CPU_Address_4 ;
   rtlc_13736_or_474_nx0 <= BC_State(2) OR BC_State(58) ;
   rtlcn2512 <= rtlc_13736_or_474_nx0 OR rtlcn8883 ;
   rtlc_13784_and_476_nx0 <= not_rtlc26n15497 AND rtlc26n13657 ;
   rtlcn8999 <= rtlc_13784_and_476_nx0 AND BC_State(21) ;
   rtlc_13802_and_477_nx0 <= eBC_CFT_do AND not_eBC_CMT_do ;
   rtlcn8797 <= rtlc_13802_and_477_nx0 AND rtlcn8852 ;
   rtlc_13808_or_478_nx0 <= rtlcn9010 OR rtlcn9011 ;
   rtlcn3929 <= rtlc_13808_or_478_nx0 OR rtlcn9012 ;
   rtlc_13815_or_479_nx0 <= rtlcn9014 OR rtlcn9016 ;
   rtlcn3930 <= rtlc_13815_or_479_nx0 OR rtlcn9018 ;
   rtlc_13826_or_481_nx0 <= rtlcn9020 OR rtlcn9022 ;
   rtlcn3985 <= rtlc_13826_or_481_nx0 OR rtlcn9024 ;
   rtlc_13830_or_482_nx0 <= rtlcn9025 OR rtlcn9026 ;
   rtlcn3986 <= rtlc_13830_or_482_nx0 OR rtlcn9027 ;
   rtlc_13851_or_486_nx0 <= MON_SOM_phase(4) OR MON_SOM_phase(6) ;
   rtlcn4186 <= rtlc_13851_or_486_nx0 OR not_rtlcn8839 ;
   rtlc_13864_and_487_nx0 <= SOM_phase_0 AND First_After_Reset ;
   rtlcn8798 <= rtlc_13864_and_487_nx0 AND EOM_phase(0) ;
   rtlc_13881_or_489_nx0 <= rtlcn8799 OR rtlcn8922 ;
   rtlcn5396 <= rtlc_13881_or_489_nx0 OR rtlcn9043 ;
   rtlc_13905_or_492_nx0 <= rtlcn8886 OR rtlcn8888 ;
   rtlcn5690 <= rtlc_13905_or_492_nx0 OR rtlcn9053 ;
   rtlc_13938_and_493_nx0 <= rtlcs102 AND not_Current_Area_B ;
   rtlcn9070 <= rtlc_13938_and_493_nx0 AND rtlcn8817 ;
   rtlc_13967_or_495_nx0 <= SOM_phase_3 OR rtlcn8820 ;
   rtlcn5968 <= rtlc_13967_or_495_nx0 OR rtlcn9079 ;
   rtlc_13971_or_496_nx0 <= rtlcn8798 OR rtlcn8876 ;
   rtlcn5970 <= rtlc_13971_or_496_nx0 OR rtlcn9081 ;
   rtlc_13975_and_497_nx0 <= Ack AND not_rtlcs101 ;
   rtlcn9083 <= rtlc_13975_and_497_nx0 AND rtlcn8858 ;
   rtlc_13985_or_502_nx0 <= BC_State(49) OR rtlcn8885 ;
   rtlcn6014 <= rtlc_13985_or_502_nx0 OR rtlcn8892 ;
   rtlc_13989_or_503_nx0 <= rtlc26n16146 OR rtlcn9030 ;
   rtlcn6027 <= rtlc_13989_or_503_nx0 OR rtlcn9086 ;
   rtlc_13990_or_504_nx0 <= rtlc26n16146 OR rtlcn8831 ;
   rtlcn6031 <= rtlc_13990_or_504_nx0 OR rtlcn8841 ;
   rtlc_13992_or_505_nx0 <= CPU_Data_in_wide(19) OR CPU_Data_in_wide(23) ;
   rtlcn7659 <= rtlc_13992_or_505_nx0 OR CPU_Data_in_wide(25) ;
   rtlc_14015_and_506_nx0 <= rtlc22n10476 AND rtlc22n10248 ;
   rtlcn6679 <= rtlc_14015_and_506_nx0 AND rtlcn8854 ;
   rtlcs110 <= not_BC_Echo_word_10 AND not_BC_Echo_word_11 ;
   rtlcn9114 <= rtlcs110 AND BC_State(73) ;
   eBC_TT_do_26n148s1 <= BC_Echo_word(10) AND not_BC_Echo_word_11 ;
   rtlcn9115 <= eBC_TT_do_26n148s1 AND BC_State(73) ;
   rtlc_14136_or_509_nx0 <= not_rtlc22n10084 OR rtlcn8913 ;
   rtlcn7956 <= rtlc_14136_or_509_nx0 OR rtlcn9164 ;
   rtlc_14139_and_510_nx0 <= EOM_phase(4) AND Ack ;
   rtlcn9167 <= rtlc_14139_and_510_nx0 AND not_rtlcs101 ;
   rtlc_14148_or_511_nx0 <= rtlc22n10119 OR rtlcn8798 ;
   rtlcn8933 <= rtlc_14148_or_511_nx0 OR rtlcn9172 ;
   rtlcn9176 <= rtlcn8799 AND not_rtlcn8849 ;
   rtlc_14155_or_513_nx0 <= Do_illegal_EXMPLR916 OR rtlcn9172 ;
   rtlcn8394 <= rtlc_14155_or_513_nx0 OR rtlcn9176 ;
   rtlc_14166_and_514_nx0 <= rtlcn8799 AND not_Current_Area_B ;
   rtlcn9183 <= rtlc_14166_and_514_nx0 AND not_rtlcn8806 ;
   rtlcn2638 <= rtlc60n5424 AND rtlc60n6494 ;
   rtlcn8482 <= rtlcn2638 AND rtlcn8822 ;
   rtlc_14208_or_518_nx0 <= BC_State(7) OR BC_State(38) ;
   rtlc26n16119 <= rtlc_14208_or_518_nx0 OR BC_State(65) ;
   rtlc_14228_or_520_nx0 <= state(8) OR not_rtlcn8821 ;
   rtlcn8935 <= rtlc_14228_or_520_nx0 OR rtlcn9205 ;
   rtlc_14236_and_521_nx0 <= state(4) AND Ack ;
   rtlcn9210 <= rtlc_14236_and_521_nx0 AND WM_On ;
   rtlc_14243_and_522_nx0 <= WM_On AND BC_START ;
   rtlcn9214 <= rtlc_14243_and_522_nx0 AND state(1) ;
   rtlc_14253_and_523_nx0 <= not_rtlc26n15497 AND Config_reg_1(8) ;
   rtlcn9218 <= rtlc_14253_and_523_nx0 AND BC_State(90) ;
   rtlcn9220 <= rtlc_14295_and_533_nx0 AND rtlcn8809 ;
   rtlc_14258_and_525_nx0 <= rtlc26n13151 AND not_rtlc26n12464 ;
   rtlcn9222 <= rtlc_14258_and_525_nx0 AND BC_State(1) ;
   rtlc_14260_and_526_nx0 <= rtlc26n13019 AND not_rtlc26n13005 ;
   rtlcn9224 <= rtlc_14260_and_526_nx0 AND BC_State(24) ;
   rtlc_14277_and_529_nx0 <= not_rtlc26n15497 AND rtlc26n15182 ;
   rtlcn9235 <= rtlc_14277_and_529_nx0 AND BC_State(23) ;
   rtlcn9237 <= rtlc_14418_and_545_nx0 AND rtlcn8809 ;
   rtlc_14280_or_531_nx0 <= rtlcn9234 OR rtlcn9235 ;
   rtlcn2878 <= rtlc_14280_or_531_nx0 OR rtlcn9237 ;
   rtlc_14286_and_532_nx0 <= not_rtlc26n15497 AND not_Config_reg_1_8 ;
   rtlcn9242 <= rtlc_14286_and_532_nx0 AND BC_State(90) ;
   rtlc_14295_and_533_nx0 <= BC_State(2) AND not_rtlc26n14491 ;
   rtlcn9248 <= rtlc_14295_and_533_nx0 AND rtlcn8811 ;
   rtlc_14328_and_535_nx0 <= not_rtlc26n15015 AND rtlcn8809 ;
   rtlcn9270 <= rtlc_14328_and_535_nx0 AND not_rtlcn9888 ;
   rtlc_14329_or_536_nx0 <= rtlcn9267 OR rtlcn9268 ;
   rtlcn2996 <= rtlc_14329_or_536_nx0 OR rtlcn9270 ;
   rtlc_14367_or_541_nx0 <= rtlcn9290 OR rtlcn9291 ;
   rtlcn3098 <= rtlc_14367_or_541_nx0 OR rtlcn9292 ;
   rtlc_14380_and_542_nx0 <= not_rtlc26n15497 AND BC_State(42) ;
   rtlcn9299 <= rtlc_14380_and_542_nx0 AND rtlc26n13384 ;
   rtlc_14384_and_543_nx0 <= not_rtlc26n15497 AND not_BC_Message_Active ;
   rtlcn9302 <= rtlc_14384_and_543_nx0 AND BC_State(46) ;
   rtlc_14416_and_544_nx0 <= not_rtlc26n14584 AND rtlcn8811 ;
   rtlcn9323 <= rtlc_14416_and_544_nx0 AND not_rtlcn8819 ;
   rtlc_14418_and_545_nx0 <= BC_State(7) AND not_rtlc26n14530 ;
   rtlcn9324 <= rtlc_14418_and_545_nx0 AND rtlcn8811 ;
   rtlc_14419_and_546_nx0 <= not_rtlc26n14584 AND rtlcn8809 ;
   rtlcn9325 <= rtlc_14419_and_546_nx0 AND not_rtlcn8819 ;
   rtlc_14431_and_547_nx0 <= not_rtlc26n13393 AND rtlcn3308 ;
   rtlcn9332 <= rtlc_14431_and_547_nx0 AND rtlcn8918 ;
   rtlc_14432_or_548_nx0 <= rtlcn9329 OR rtlcn9330 ;
   rtlcn3335 <= rtlc_14432_or_548_nx0 OR rtlcn9332 ;
   rtlc_14434_and_549_nx0 <= rtlc26n13393 AND rtlcn3308 ;
   rtlcn9334 <= rtlc_14434_and_549_nx0 AND rtlcn8918 ;
   rtlcn9335 <= rtlc_14461_and_556_nx0 AND BC_First_write ;
   rtlcn9337 <= rtlc_14442_and_553_nx0 AND rtlcn8809 ;
   rtlc_14442_and_553_nx0 <= not_rtlc26n12839 AND BC_State(18) ;
   rtlcn9339 <= rtlc_14442_and_553_nx0 AND rtlcn8811 ;
   rtlc_14445_and_554_nx0 <= BC_State(26) AND not_rtlc26n15497 ;
   rtlcn9341 <= rtlc_14445_and_554_nx0 AND BC_Read ;
   rtlcn9345 <= rtlc_14384_and_543_nx0 AND BC_State(27) ;
   rtlc_14461_and_556_nx0 <= not_rtlc26n15497 AND BC_State(16) ;
   rtlcn9352 <= rtlc_14461_and_556_nx0 AND not_BC_First_write ;
   rtlc_14469_and_559_nx0 <= not_rtlc26n14300 AND not_Clear_Test_Status_reg
    ;
   rtlcn9357 <= rtlc_14469_and_559_nx0 AND rtlcn8911 ;
   rtlcn9361 <= rtlc_14581_and_573_nx0 AND rtlcn8809 ;
   rtlcn9373 <= rtlc_14502_and_564_nx0 AND rtlcn8809 ;
   rtlc_14498_and_563_nx0 <= BC_State(72) AND not_rtlc26n14110 ;
   rtlcn9375 <= rtlc_14498_and_563_nx0 AND rtlcn8833 ;
   rtlc_14502_and_564_nx0 <= BC_State(74) AND not_rtlc26n15369 ;
   rtlcn9377 <= rtlc_14502_and_564_nx0 AND rtlcn8811 ;
   rtlcn3938 <= rtlc_14534_and_566_nx0 AND not_BC_Echo_word_10 ;
   rtlc_14534_and_566_nx0 <= BC_State(79) AND Ack ;
   rtlcn3950 <= rtlc_14534_and_566_nx0 AND BC_Echo_word(10) ;
   rtlc_14549_and_568_nx0 <= rtlc26n15998 AND rtlcn8827 ;
   rtlcn4031 <= rtlc_14549_and_568_nx0 AND rtlcn8900 ;
   rtlc_14552_and_569_nx0 <= not_rtlc26n15497 AND not_rtlc26n14017 ;
   rtlcn9402 <= rtlc_14552_and_569_nx0 AND BC_State(68) ;
   rtlc_14560_or_570_nx0 <= rtlcn9405 OR rtlcn9406 ;
   rtlcn4057 <= rtlc_14560_or_570_nx0 OR rtlcn9407 ;
   rtlc_14573_and_571_nx0 <= not_rtlc26n15497 AND not_Ext_Trigger_Dx_0n0s4 ;
   rtlcn9415 <= rtlc_14573_and_571_nx0 AND BC_State(91) ;
   rtlc_14575_and_572_nx0 <= not_rtlc26n15497 AND rtlc26n14920 ;
   rtlcn4111 <= rtlc_14575_and_572_nx0 AND not_rtlcn8803 ;
   rtlc_14581_and_573_nx0 <= BC_State(13) AND not_rtlc26n14740 ;
   rtlcn9419 <= rtlc_14581_and_573_nx0 AND rtlcn8811 ;
   rtlc_14595_and_574_nx0 <= EOM_req AND not_arbiter ;
   rtlcn4253 <= rtlc_14595_and_574_nx0 AND not_WRD_req ;
   rtlc_14604_and_575_nx0 <= MON_WR_req AND not_SOM_req ;
   rtlcn4285 <= rtlc_14604_and_575_nx0 AND not_rtlcn8829 ;
   rtlc_14608_and_576_nx0 <= MON_EOM_req AND not_rtlcn8829 ;
   rtlcn4315 <= rtlc_14608_and_576_nx0 AND not_rtlcn8844 ;
   rtlc_14638_and_579_nx0 <= SOM_phase_1 AND Ack ;
   rtlcn4554 <= rtlc_14638_and_579_nx0 AND illegalization_enable ;
   rtlc_14650_or_580_nx0 <= Arbiter_timeout OR EOM_phase(4) ;
   rtlcn8646 <= rtlc_14650_or_580_nx0 OR rtlcn9435 ;
   rtlc_14673_or_583_nx0 <= rtlcn8907 OR rtlcs68 ;
   rtlcn8669 <= rtlc_14673_or_583_nx0 OR rtlcs84 ;
   rtlc_14677_and_584_nx0 <= Do_illegal_EXMPLR916 AND Ack ;
   rtlcn6071 <= rtlc_14677_and_584_nx0 AND rtlc22n7839 ;
   rtlc_14708_and_586_nx0 <= rtlc26n16375 AND rtlcn8804 ;
   rtlcn6918 <= rtlc_14708_and_586_nx0 AND not_rtlcn8912 ;
   rtlc_14746_and_589_nx0 <= CE AND Config_reg_3_2 ;
   rtlcn7577 <= rtlc_14746_and_589_nx0 AND rtlc60n6587 ;
   rtlc_14756_or_591_nx0 <= MON_SOM_req OR rtlcn8823 ;
   rtlcn8957 <= rtlc_14756_or_591_nx0 OR rtlcn8871 ;
   rtlc_14768_and_593_nx0 <= MON_SOM_req AND not_rtlcn8829 ;
   rtlcn8284 <= rtlc_14768_and_593_nx0 AND not_rtlcn8871 ;
   rtlc_14798_and_595_nx0 <= rtlc60n6494 AND rtlc60n5595 ;
   rtlcn9495 <= rtlc_14798_and_595_nx0 AND rtlcn8897 ;
   rtlc_14801_and_597_nx0 <= not_rtlc22n8155 AND rtlc22n8177 ;
   rtlcn9497 <= rtlc_14801_and_597_nx0 AND rtlc22n8183 ;
   rtlc_14803_and_598_nx0 <= rtlc22n8199 AND rtlc22n8205 ;
   rtlcn9499 <= rtlc_14803_and_598_nx0 AND not_rtlcn8846 ;
   rtlc_14804_or_599_nx0 <= rtlcn9496 OR rtlcn9497 ;
   rtlcn8961 <= rtlc_14804_or_599_nx0 OR rtlcn9499 ;
   rtlc_14807_and_600_nx0 <= not_rtlc22n8108 AND rtlc22n8131 ;
   rtlcn9502 <= rtlc_14807_and_600_nx0 AND rtlc22n8137 ;
   rtlc_14813_and_602_nx0 <= not_rtlc22n8221 AND rtlc22n8243 ;
   rtlcn9507 <= rtlc_14813_and_602_nx0 AND not_rtlc22n8249 ;
   rtlc_14830_or_604_nx0 <= SOM_phase_5 OR SOM_phase_9 ;
   rtlc22n10133 <= rtlc_14830_or_604_nx0 OR rtlcn8888 ;
   rtlc_14837_and_606_nx0 <= EOM_phase(4) AND rtlcs100 ;
   rtlcn9522 <= rtlc_14837_and_606_nx0 AND rtlcs101 ;
   rtlc_14845_and_608_nx0 <= rtlcs67 AND not_Read ;
   rtlcn9528 <= rtlc_14845_and_608_nx0 AND Write ;
   rtlc_14850_or_609_nx0 <= rtlcn9529 OR rtlcn9530 ;
   rtlcn8548 <= rtlc_14850_or_609_nx0 OR rtlcn9531 ;
   rtlc_14859_and_610_nx0 <= not_rtlc26n13151 AND not_rtlc26n12464 ;
   rtlcn9537 <= rtlc_14859_and_610_nx0 AND BC_State(1) ;
   rtlc_14939_or_611_nx0 <= BC_State(71) OR BC_State(79) ;
   rtlcn8906 <= rtlc_14939_or_611_nx0 OR BC_State(88) ;
   rtlc_14940_or_612_nx0 <= BC_State(11) OR BC_State(31) ;
   rtlcn8874 <= rtlc_14940_or_612_nx0 OR BC_State(42) ;
   rtlc_14942_and_613_nx0 <= rtlcs64 AND rtlcn7090 ;
   rtlcn8909 <= rtlc_14942_and_613_nx0 AND rtlcn8882 ;
   rtlc_14943_and_614_nx0 <= not_rtlc26n15497 AND NO ;
   rtlcn9283 <= rtlc_14943_and_614_nx0 AND rtlcn8943 ;
   rtlc_14944_and_615_nx0 <= BC_State(83) AND YES ;
   rtlcn9275 <= rtlc_14944_and_615_nx0 AND Ack ;
   rtlc_14948_or_619_nx0 <= rtlc22n10248 OR rtlcs78 ;
   rtlcn8875 <= rtlc_14948_or_619_nx0 OR rtlcs94 ;
   rtlc_14949_or_620_nx0 <= rtlcn8875 OR rtlcs76 ;
   rtlcn8907 <= rtlc_14949_or_620_nx0 OR rtlcs92 ;
   rtlc_14950_and_621_nx0 <= rtlcs276 AND Tag_CLK_D ;
   rtlcn9444 <= rtlc_14950_and_621_nx0 AND not_Tag_CLK_DD ;
   rtlc_14953_and_623_nx0 <= not_Ack AND rtlcn8808 ;
   rtlcn9529 <= rtlc_14953_and_623_nx0 AND rtlcn8964 ;
   rtlc_14954_or_624_nx0 <= EOM_phase(0) OR rtlcn9521 ;
   rtlcn8851 <= rtlc_14954_or_624_nx0 OR rtlcn9522 ;
   rtlc_14955_or_625_nx0 <= rtlcn8838 OR rtlcn9533 ;
   rtlcn8563 <= rtlc_14955_or_625_nx0 OR rtlcn9534 ;
   rtlc_16285_or_629_nx0 <= SOM_phase_0 OR SOM_phase_8 ;
   rtlcn9863 <= rtlc_16285_or_629_nx0 OR rtlc22n10119 ;
   rtlc_16287_or_630_nx0 <= MON_SOM_phase(0) OR MON_SOM_phase(2) ;
   rtlcn9864 <= rtlc_16287_or_630_nx0 OR rtlcn2082 ;
   rtlc_16298_or_631_nx0 <= CPU_Address(1) OR CPU_Address(2) ;
   rtlcn9870 <= rtlc_16298_or_631_nx0 OR not_CPU_Address_4 ;
   rtlc_16329_or_633_nx0 <= rtlcn5392 OR rtlcn5690 ;
   rtlcn9886 <= rtlc_16329_or_633_nx0 OR rtlcn8394 ;
   rtlc_17513_and_642_nx0 <= CE AND rtlc26n17341 ;
   rtlc26n17110 <= rtlc_17513_and_642_nx0 AND rtlcn9932 ;
   rtlc_17524_and_643_nx0 <= rtlc26n17334 AND rtlcn9919 ;
   rtlc26n17075 <= rtlc_17524_and_643_nx0 AND rtlcn9938 ;
   rtlc_17529_and_644_nx0 <= CE AND rtlc26n17331 ;
   rtlc26n17070 <= rtlc_17529_and_644_nx0 AND rtlcn9933 ;
   rtlc_17533_or_645_nx0 <= BC_State(13) OR BC_State(31) ;
   rtlcn9947 <= rtlc_17533_or_645_nx0 OR rtlcn9940 ;
   rtlc_17539_and_646_nx0 <= CE AND not_BC_State_13 ;
   rtlcn10046 <= rtlc_17539_and_646_nx0 AND rtlcn9927 ;
   rtlc_17551_and_647_nx0 <= not_rtlc26n19009 AND BC_Command_Sync ;
   rtlcn10052 <= rtlc_17551_and_647_nx0 AND rtlcn9924 ;
   rtlc_17553_and_648_nx0 <= not_BC_State_40 AND not_BC_State_44 ;
   rtlcn10054 <= rtlc_17553_and_648_nx0 AND rtlcn9925 ;
   rtlc_17556_and_649_nx0 <= CE AND rtlc26n17320 ;
   rtlc26n17057 <= rtlc_17556_and_649_nx0 AND rtlcn9939 ;
   rtlc_17570_and_650_nx0 <= CE AND rtlc26n17297 ;
   rtlc26n17021 <= rtlc_17570_and_650_nx0 AND rtlcn9914 ;
   rtlc_17638_and_652_nx0 <= CE AND not_BC_State_7 ;
   rtlc26n16950 <= rtlc_17638_and_652_nx0 AND not_BC_State_8 ;
   rtlc_17651_and_653_nx0 <= CE AND rtlc26n17283 ;
   rtlc26n16913 <= rtlc_17651_and_653_nx0 AND rtlcn9936 ;
   rtlcn10145 <= rtlc_17699_and_656_nx0 AND rtlc44n226 ;
   rtlc_17699_and_656_nx0 <= CE AND rtlc44n161 ;
   rtlcn10146 <= rtlc_17699_and_656_nx0 AND rtlc44n275 ;
   rtlc51n276 <= BC_Load_frame_gap_counter OR eBC_start_FT ;
   rtlcn9956 <= rtlc51n276 OR rtlcn10150 ;
   rtlc_17733_or_658_nx0 <= rtlc60n6061 OR rtlc60n6074 ;
   rtlcn9957 <= rtlc_17733_or_658_nx0 OR rtlc60n6084 ;
   rtlcn2772 <= rtlc60n6494 AND rtlc60n5464 ;
   rtlcn10156 <= rtlcn2772 AND CPU_Data_in_wide(23) ;
   rtlcn10157 <= rtlcn2772 AND CPU_Data_in_wide(25) ;
   rtlc_17772_and_661_nx0 <= not_Config_reg_3_15 AND not_rtlc60n5942 ;
   rtlc60n5981 <= rtlc_17772_and_661_nx0 AND RT_On_EXMPLR924 ;
   rtlc_17779_or_662_nx0 <= not_CE OR not_First_Thing ;
   rtlc60n5385 <= rtlc_17779_or_662_nx0 OR not_M1760_D ;
   rtlc_17910_or_664_nx0 <= not_RT_ADR_LAT OR rtlc81n54 ;
   rtlc81n121 <= rtlc_17910_or_664_nx0 OR rtlc81n82 ;
   Test_Status_reg_84n4ss1(1) <= rtlc84n99 AND rtlcs311 ;
   rtlc84n235 <= Test_Status_reg_84n4ss1(1) AND rtlcn1246 ;
   rtlc87n628 <= state(4) OR state(5) ;
   rtlcn9958 <= rtlc87n628 OR rtlcn9928 ;
   rtlc_17931_and_668_nx0 <= rtlc60n6494 AND rtlcs273 ;
   rtlc60n7404 <= rtlc_17931_and_668_nx0 AND CPU_WE_vec(0) ;
   rtlc_17933_and_670_nx0 <= rtlc60n6494 AND rtlcs261 ;
   rtlc60n7356 <= rtlc_17933_and_670_nx0 AND CPU_WE_vec(0) ;
   rtlc_17934_and_671_nx0 <= rtlc60n6494 AND rtlcs269 ;
   rtlc60n7340 <= rtlc_17934_and_671_nx0 AND CPU_WE_vec(1) ;
   rtlc60n7324 <= rtlc66n47 AND CPU_WE_vec(0) ;
   rtlcn2428 <= not_rtlcn9870 OR rtlcs228 ;
   rtlcn2444 <= rtlcn2428 OR rtlcs257 ;
   rtlc_17978_or_674_nx0 <= not_rtlcn8796 OR rtlcs226 ;
   rtlcn2422 <= rtlc_17978_or_674_nx0 OR rtlcs257 ;
   rtlc_18039_and_678_nx0 <= not_Config_reg_4_2 AND 
   Config_reg_4_EXMPLR998(1) ;
   rtlcs153 <= rtlc_18039_and_678_nx0 AND not_Config_reg_4_0 ;
   rtlc_18064_and_679_nx0 <= not_BC_Rx_Data_7 AND not_BC_Rx_Data_6 ;
   rtlcs172 <= rtlc_18064_and_679_nx0 AND not_BC_Rx_Data_5 ;
   rtlc_18085_and_680_nx0 <= BC_Num_Msgs_26n12s1(9) AND Data_o_temp(6) ;
   rtlcs138 <= rtlc_18085_and_680_nx0 AND Data_o_temp(8) ;
   rtlc_18090_and_681_nx0 <= Data_o_temp(9) AND BC_Num_Msgs_26n12s1(8) ;
   rtlcs140 <= rtlc_18090_and_681_nx0 AND Data_o_temp(6) ;
   rtlc_18225_and_689_nx0 <= Ack AND BC_Num_Msgs_26n12s1(9) ;
   rtlcs118 <= rtlc_18225_and_689_nx0 AND Data_o_temp(14) ;
   rtlc_18583_and_700_nx0 <= not_GMM_2 AND not_GMM_1 ;
   rtlcs100 <= rtlc_18583_and_700_nx0 AND not_GMM_0 ;
   rtlc_18593_and_701_nx0 <= not_MM_2 AND not_MM_1 ;
   rtlcs101 <= rtlc_18593_and_701_nx0 AND not_MM_0 ;
   rtlc_18624_and_702_nx0 <= not_Config_reg_3_10 AND not_Config_reg_3_9 ;
   rtlcs59 <= rtlc_18624_and_702_nx0 AND not_Config_reg_3_8 ;
   rtlc_18928_and_724_nx0 <= not_Config_reg_2_9 AND not_Config_reg_2_8 ;
   rtlc_18933_and_725_nx0 <= not_Config_reg_2_9 AND Config_reg_2(8) ;
   rtlcs282 <= rtlc_18933_and_725_nx0 AND not_Config_reg_2_7 ;
   rtlcs281 <= rtlc_18933_and_725_nx0 AND Config_reg_2(7) ;
   rtlc_18942_and_727_nx0 <= Config_reg_2(9) AND not_Config_reg_2_8 ;
   rtlc_19024_and_733_nx0 <= not_BC_Rx_Data_10 AND not_BC_Rx_Data_9 ;
   rtlcs171 <= rtlc_19024_and_733_nx0 AND not_BC_Rx_Data_8 ;
   rtlc_19168_or_738_nx0 <= First_After_Reset OR rtlc22n7221 ;
   rtlcn11031 <= rtlc_19168_or_738_nx0 OR rtlcs103 ;
   rtlc_19825_or_752_nx0 <= LUT_Control(0) OR LUT_Control(1) ;
   rtlc60n6706 <= rtlc_19825_or_752_nx0 OR LUT_Control(2) ;
   rtlc_19826_or_753_nx0 <= LUT_Control(5) OR LUT_Control(6) ;
   rtlc60n6721 <= rtlc_19826_or_753_nx0 OR LUT_Control(7) ;
   MM_22n111ss1(0) <= LUT_Control(10) when Current_command(10) = '1' else 
   nx101 ;
   nx101 <= LUT_Control(0) when BCR = '1' else LUT_Control(5) ;
   MM_22n111ss1(1) <= LUT_Control(11) when Current_command(10) = '1' else 
   nx109 ;
   nx109 <= LUT_Control(1) when BCR = '1' else LUT_Control(6) ;
   MM_22n111ss1(2) <= LUT_Control(12) when Current_command(10) = '1' else 
   nx116 ;
   nx116 <= LUT_Control(2) when BCR = '1' else LUT_Control(7) ;
   Rollover_Int_Enable_22n114ss1 <= LUT_Control(13) when Current_command(10)
    = '1' else nx123 ;
   nx123 <= LUT_Control(3) when BCR = '1' else LUT_Control(8) ;
   rtlc22n8391 <= rtlc22n8331 when rtlc22n8108 = '1' else nx151 ;
   nx151 <= rtlc22n8334 when rtlc22n8131 = '1' else nx155 ;
   nx155 <= rtlc22n8337 when rtlc22n8155 = '1' else nx158 ;
   nx158 <= rtlc22n8340 when rtlc22n8177 = '1' else nx161 ;
   rtlcn12102 <= rtlc22n8205 when rtlc22n8199 = '1' else nx169 ;
   nx169 <= rtlc22n8227 when rtlc22n8221 = '1' else nx172 ;
   time_tag_60n15ss1(0) <= BC_msg_pointer(0) when eBC_TT_do = '1' else nx178
    ;
   nx178 <= Data_From_FE(0) when rtlc60n5353 = '1' else time_tag_60n13ss1(0)
    ;
   time_tag_60n15ss1(1) <= BC_msg_pointer(1) when eBC_TT_do = '1' else nx185
    ;
   nx185 <= Data_From_FE(1) when rtlc60n5353 = '1' else time_tag_60n13ss1(1)
    ;
   time_tag_60n15ss1(2) <= BC_msg_pointer(2) when eBC_TT_do = '1' else nx191
    ;
   nx191 <= Data_From_FE(2) when rtlc60n5353 = '1' else time_tag_60n13ss1(2)
    ;
   time_tag_60n15ss1(3) <= BC_msg_pointer(3) when eBC_TT_do = '1' else nx198
    ;
   nx198 <= Data_From_FE(3) when rtlc60n5353 = '1' else time_tag_60n13ss1(3)
    ;
   time_tag_60n15ss1(4) <= BC_msg_pointer(4) when eBC_TT_do = '1' else nx204
    ;
   nx204 <= Data_From_FE(4) when rtlc60n5353 = '1' else time_tag_60n13ss1(4)
    ;
   time_tag_60n15ss1(5) <= BC_msg_pointer(5) when eBC_TT_do = '1' else nx212
    ;
   nx212 <= Data_From_FE(5) when rtlc60n5353 = '1' else time_tag_60n13ss1(5)
    ;
   time_tag_60n15ss1(6) <= BC_msg_pointer(6) when eBC_TT_do = '1' else nx218
    ;
   nx218 <= Data_From_FE(6) when rtlc60n5353 = '1' else time_tag_60n13ss1(6)
    ;
   time_tag_60n15ss1(7) <= BC_msg_pointer(7) when eBC_TT_do = '1' else nx224
    ;
   nx224 <= Data_From_FE(7) when rtlc60n5353 = '1' else time_tag_60n13ss1(7)
    ;
   time_tag_60n15ss1(8) <= BC_msg_pointer(8) when eBC_TT_do = '1' else nx230
    ;
   nx230 <= Data_From_FE(8) when rtlc60n5353 = '1' else time_tag_60n13ss1(8)
    ;
   time_tag_60n15ss1(9) <= BC_msg_pointer(9) when eBC_TT_do = '1' else nx236
    ;
   nx236 <= Data_From_FE(9) when rtlc60n5353 = '1' else time_tag_60n13ss1(9)
    ;
   time_tag_60n15ss1(10) <= BC_msg_pointer(10) when eBC_TT_do = '1' else 
   nx244 ;
   nx244 <= Data_From_FE(10) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(10) ;
   time_tag_60n15ss1(11) <= BC_msg_pointer(11) when eBC_TT_do = '1' else 
   nx252 ;
   nx252 <= Data_From_FE(11) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(11) ;
   time_tag_60n15ss1(12) <= BC_msg_pointer(12) when eBC_TT_do = '1' else 
   nx260 ;
   nx260 <= Data_From_FE(12) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(12) ;
   time_tag_60n15ss1(13) <= BC_msg_pointer(13) when eBC_TT_do = '1' else 
   nx267 ;
   nx267 <= Data_From_FE(13) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(13) ;
   time_tag_60n15ss1(14) <= BC_msg_pointer(14) when eBC_TT_do = '1' else 
   nx274 ;
   nx274 <= Data_From_FE(14) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(14) ;
   time_tag_60n15ss1(15) <= BC_msg_pointer(15) when eBC_TT_do = '1' else 
   nx282 ;
   nx282 <= Data_From_FE(15) when rtlc60n5353 = '1' else 
   time_tag_60n13ss1(15) ;
   Non_masked_Event_75n31ss1 <= Interrupt_mask_register_2(6) when 
   Monitor_data_stack_half_pass = '1' else nx290 ;
   nx290 <= Interrupt_mask_register_2(7) when 
   Monitor_command_stack_half_pass = '1' else nx294 ;
   nx294 <= Interrupt_mask_register_2(10) when eBC_Bad_instruction
    = '1' else nx298 ;
   nx298 <= Interrupt_mask_register_2(11) when eBC_Stack_error = '1' else 
   nx302 ;
   nx302 <= Interrupt_mask_register_2(12) when rtlc75n1848 = '1' else nx306
    ;
   nx306 <= Interrupt_mask_register_2(14) when eBC_Bad_Parity = '1' else 
   nx310 ;
   nx310 <= Interrupt_mask_register_1(0) when rtlc75n1819 = '1' else nx314 ;
   nx314 <= Interrupt_mask_register_1(1) when rtlc75n1795 = '1' else nx318 ;
   nx318 <= Interrupt_mask_register_1(2) when rtlc75n1765 = '1' else nx322 ;
   nx322 <= Interrupt_mask_register_1(3) when rtlc75n1730 = '1' else nx326 ;
   nx326 <= Interrupt_mask_register_1(4) when rtlc75n1714 = '1' else nx330 ;
   nx330 <= Interrupt_mask_register_1(5) when rtlc75n1665 = '1' else nx334 ;
   nx334 <= Interrupt_mask_register_1(6) when rtlc75n1647 = '1' else nx338 ;
   nx338 <= Interrupt_mask_register_1(8) when BC_Retry_pulse = '1' else 
   nx342 ;
   nx342 <= Interrupt_mask_register_1(10) when Monitor_data_stack_rollover
    = '1' else nx346 ;
   nx346 <= Interrupt_mask_register_1(11) when 
   Monitor_command_stack_rollover = '1' else nx350 ;
   nx350 <= Interrupt_mask_register_1(12) when rtlc75n1547 = '1' else nx354
    ;
   nx354 <= Non_masked_Event_75n10s1 when MIL1553_errors_transmitter_timout
    = '1' else nx358 ;
   nx358 <= Non_masked_Event_75n3s1 when Clean_status2_bits = '1' else nx362
    ;
   Non_masked_Event_75n35ss1 <= Interrupt_mask_register_2(2) when 
   BC_msg_pointer(0) = '1' else nx369 ;
   nx369 <= Interrupt_mask_register_2(3) when BC_msg_pointer(1) = '1' else 
   Non_masked_Event_75n33ss1 ;
   Non_masked_Event_75n37ss1 <= Interrupt_mask_register_2(1) when 
   BIT_Test_complete = '1' else nx375 ;
   nx375 <= Non_masked_Event_75n35ss1 when eBC_IRQ_do = '1' else 
   Non_masked_Event_75n31ss1 ;
   Ram_WE_22n108ss1 <= not_Ack when rtlcn7465 = '1' else nx381 ;
   nx381 <= rtlcn8548 when rtlcs64 = '1' else rtlcn8583 ;
   nx161 <= not_rtlc22n10119 AND rtlcn12102 ;
   nx362 <= Non_masked_Event_75n1s1 AND Clean_status_bits ;
   nx172 <= rtlc22n8249 OR not_rtlc22n8243 ;
   modgen_or_34 : or_6u_6u port map ( a(5)=>
      Latched_Monitor_MIL1553_errors_high_word_count, a(4)=>
      Latched_Monitor_MIL1553_errors_incorrect_data_sync, a(3)=>
      Latched_Monitor_MIL1553_errors_RT2RT_format_gap, a(2)=>
      Latched_Monitor_MIL1553_errors_Invalid_word, a(1)=>
      Latched_Monitor_MIL1553_errors_RT2RT_format_error, a(0)=>
      Latched_Monitor_MIL1553_errors_invalid_command, d=>
      MM_Error_detected_22n1s1);
   modgen_and_35 : and_5u_5u port map ( a(4)=>Config_reg_2(12), a(3)=>
      rtlc22n7720, a(2)=>not_Current_command_10, a(1)=>rtlcs100, a(0)=>
      not_mode_command, d=>rtlc22n7730);
   modgen_and_36 : and_6u_6u port map ( a(5)=>BC_Echo_word(14), a(4)=>
      not_BC_Echo_word_13, a(3)=>BC_Echo_word(12), a(2)=>eBC_TT_do_26n148s1, 
      a(1)=>rtlc26n15182, a(0)=>YES, d=>rtlc26n15172);
   modgen_or_37 : or_11u_11u port map ( a(10)=>rtlc29n383, a(9)=>rtlc29n388, 
      a(8)=>rtlc29n394, a(7)=>rtlc29n400, a(6)=>rtlc29n406, a(5)=>rtlc29n412, 
      a(4)=>rtlc29n418, a(3)=>rtlc29n424, a(2)=>rtlc29n430, a(1)=>rtlc29n436, 
      a(0)=>rtlc29n442, d=>rtlc29n443);
   modgen_or_38 : or_15u_15u port map ( a(14)=>rtlc29n287, a(13)=>rtlc29n292, 
      a(12)=>rtlc29n298, a(11)=>rtlc29n304, a(10)=>rtlc29n310, a(9)=>
      rtlc29n316, a(8)=>rtlc29n322, a(7)=>rtlc29n328, a(6)=>rtlc29n334, a(5)
      =>rtlc29n340, a(4)=>rtlc29n346, a(3)=>rtlc29n352, a(2)=>rtlc29n358, 
      a(1)=>rtlc29n364, a(0)=>rtlc29n370, d=>rtlc29n371);
   modgen_or_39 : or_10u_10u port map ( a(9)=>rtlc44n168, a(8)=>
      BC_Rx_Data(9), a(7)=>rtlc44n176, a(6)=>rtlc44n182, a(5)=>rtlc44n188, 
      a(4)=>BC_Rx_Data(1), a(3)=>rtlc44n197, a(2)=>not_rtlcn1224, a(1)=>
      not_rtlcn1225, a(0)=>rtlc44n225, d=>rtlc44n226);
   modgen_and_40 : and_7u_7u port map ( a(6)=>rtlc60n5906, a(5)=>
      not_rtlc60n6633, a(4)=>not_rtlc32n408, a(3)=>not_rtlc32n450, a(2)=>
      not_rtlc60n6648, a(1)=>not_BC_on, a(0)=>not_WM_On, d=>rtlc60n6679);
   modgen_and_41 : and_5u_5u port map ( a(4)=>rtlc60n5926, a(3)=>rtlcn10212, 
      a(2)=>not_eBC_CFT_do, a(1)=>not_eBC_CMT_do, a(0)=>not_eBC_CMV_do, d=>
      rtlc60n6438);
   modgen_and_42 : and_5u_5u port map ( a(4)=>rtlc60n5927, a(3)=>rtlcn10213, 
      a(2)=>not_eBC_CFT_do, a(1)=>not_eBC_CMT_do, a(0)=>not_eBC_CMV_do, d=>
      rtlc60n6439);
   modgen_and_43 : and_7u_7u port map ( a(6)=>not_Current_command_3, a(5)=>
      Current_command(4), a(4)=>not_Current_command_0, a(3)=>rtlcs192, a(2)
      =>Message_ended_OK, a(1)=>Config_reg_2(2), a(0)=>rtlc60n6544, d=>
      rtlc60n6552);
   modgen_and_44 : and_6u_6u port map ( a(5)=>not_count_T_RESus_2, a(4)=>
      not_count_T_RESus_1, a(3)=>count_T_RESus(0), a(2)=>rtlcs285, a(1)=>
      rtlc_18942_and_727_nx0, a(0)=>Config_reg_2(7), d=>rtlc60n5175);
   modgen_and_45 : and_5u_5u port map ( a(4)=>rtlcs285, a(3)=>
      not_count_T_RESus_2, a(2)=>rtlcs288, a(1)=>rtlc_18942_and_727_nx0, 
      a(0)=>not_Config_reg_2_7, d=>rtlc60n5162);
   modgen_and_46 : and_5u_5u port map ( a(4)=>not_count_T_RESus_5, a(3)=>
      count_T_RESus(4), a(2)=>rtlcs294, a(1)=>rtlc_18928_and_724_nx0, a(0)=>
      Config_reg_2(7), d=>rtlc60n5123);
   modgen_and_47 : and_5u_5u port map ( a(4)=>count_T_RESus(4), a(3)=>
      count_T_RESus(5), a(2)=>rtlcs294, a(1)=>rtlc_18928_and_724_nx0, a(0)=>
      not_Config_reg_2_7, d=>rtlc60n5111);
   modgen_or_48 : or_6u_6u port map ( a(5)=>rtlc60n5111, a(4)=>rtlc60n5123, 
      a(3)=>rtlc60n5136, a(2)=>rtlc60n5149, a(1)=>rtlc60n5162, a(0)=>
      rtlc60n5175, d=>rtlc60n5176);
   modgen_and_49 : and_3u_3u port map ( a(2)=>Config_reg_6_15, a(1)=>
      not_Config_reg_1_14, a(0)=>not_Config_reg_1_15, d=>eBC_63n3s1);
   modgen_and_50 : and_3u_3u port map ( a(2)=>rtlc66n47, a(1)=>CPU_WE_vec(1), 
      a(0)=>CPU_Data_in_wide(16), d=>SW_Reset_66n1ss1);
   modgen_and_51 : and_3u_3u port map ( a(2)=>Interrupt_status_register_1(7), 
      a(1)=>Interrupt_status_register_1_75n6s2(7), a(0)=>rtlcn6074, d=>
      Interrupt_status_register_1_75n7ss1(7));
   modgen_and_52 : and_3u_3u port map ( a(2)=>
      Interrupt_status_register_1(14), a(1)=>
      Interrupt_status_register_1_75n6s2(14), a(0)=>rtlcn6074, d=>
      Interrupt_status_register_1_75n7ss1(14));
   modgen_and_53 : and_5u_5u port map ( a(4)=>not_rtlcn11108, a(3)=>
      not_BC_msg_pointer_3, a(2)=>not_BC_msg_pointer_2, a(1)=>
      not_BC_msg_pointer_1, a(0)=>not_BC_msg_pointer_0, d=>rtlc75n1961);
   modgen_or_54 : or_6u_6u port map ( a(5)=>MIL1553_errors_Message_Error_set, 
      a(4)=>MIL1553_errors_Format_error, a(3)=>
      MIL1553_errors_echo_back_bus_A, a(2)=>MIL1553_errors_echo_back_bus_B, 
      a(1)=>rtlc75n1757, a(0)=>rtlc75n1764, d=>rtlc75n1765);
   modgen_and_55 : and_5u_5u port map ( a(4)=>not_Current_command_0, a(3)=>
      Current_command(3), a(2)=>rtlcs161, a(1)=>rtlc78n136, a(0)=>
      Message_ended_OK, d=>rtlc78n145);
   modgen_and_56 : and_6u_6u port map ( a(5)=>not_Current_command_2, a(4)=>
      Current_command(4), a(3)=>Current_command(1), a(2)=>rtlcs162, a(1)=>
      rtlc78n136, a(0)=>EOM_phase(4), d=>rtlc78n119);
   modgen_and_57 : and_5u_5u port map ( a(4)=>Config_reg_1(11), a(3)=>
      Config_reg_1(10), a(2)=>rtlcs359, a(1)=>WM_Req, a(0)=>WM_Descriptor(3), 
      d=>rtlc87n403);
   modgen_or_58 : or_5u_5u port map ( a(4)=>time_tag_inc, a(3)=>rtlc60n5324, 
      a(2)=>rtlc60n5359, a(1)=>rtlc60n5353, a(0)=>eBC_TT_do, d=>rtlcn1245);
   modgen_and_59 : and_3u_3u port map ( a(2)=>WM_On, a(1)=>state(5), a(0)=>
      Ack, d=>state_fsm_87n14ss1_6);
   modgen_and_60 : and_3u_3u port map ( a(2)=>not_BC_Read, a(1)=>rtlcn8919, 
      a(0)=>not_BC_Message_Active, d=>BC_State_fsm_26n182ss1_55);
   modgen_and_61 : and_3u_3u port map ( a(2)=>BC_State(39), a(1)=>
      not_rtlc26n15497, a(0)=>Ack, d=>BC_State_fsm_26n182ss1_40);
   modgen_and_62 : and_3u_3u port map ( a(2)=>not_rtlc26n15497, a(1)=>
      BC_State(53), a(0)=>not_rtlc26n13657, d=>BC_State_fsm_26n182ss1_51);
   modgen_and_63 : and_3u_3u port map ( a(2)=>rtlc26_PS698_n14998, a(1)=>
      not_rtlcn9888, a(0)=>not_rtlc26n15497, d=>rtlcn9843);
   modgen_and_64 : and_5u_5u port map ( a(4)=>not_Data_o_temp_12, a(3)=>
      not_Data_o_temp_11, a(2)=>BC_Num_Msgs_26n12s1(10), a(1)=>rtlcs124, 
      a(0)=>rtlcn3048, d=>rtlcn3810);
   modgen_and_65 : and_4u_4u port map ( a(3)=>rtlcs124, a(2)=>
      not_Data_o_temp_11, a(1)=>rtlcs127, a(0)=>rtlcn3048, d=>rtlcn3826);
   modgen_and_66 : and_3u_3u port map ( a(2)=>not_rtlc26n15497, a(1)=>
      BC_State(21), a(0)=>not_rtlc26n13657, d=>BC_State_fsm_26n182ss1_22);
   modgen_and_67 : and_3u_3u port map ( a(2)=>not_rtlc26n15497, a(1)=>
      BC_State(65), a(0)=>Ack, d=>BC_State_fsm_26n182ss1_66);
   modgen_and_68 : and_3u_3u port map ( a(2)=>not_rtlc26n15015, a(1)=>
      rtlcn3048, a(0)=>Ack, d=>BC_State_fsm_26n182ss1_77);
   modgen_and_69 : and_3u_3u port map ( a(2)=>WM_On, a(1)=>state(7), a(0)=>
      not_Ack, d=>WM_Ram_RE_87n14ss1);
   modgen_and_70 : and_3u_3u port map ( a(2)=>WM_On, a(1)=>rtlc87n628, a(0)
      =>not_Ack, d=>WM_RAM_WE_87n14ss1);
   modgen_and_71 : and_3u_3u port map ( a(2)=>MON_SOM_phase(3), a(1)=>
      Monitor_bus_a, a(0)=>Record_enable, d=>record_message_A_22n103ss1);
   modgen_and_72 : and_3u_3u port map ( a(2)=>MON_SOM_phase(3), a(1)=>
      not_Monitor_bus_a, a(0)=>Record_enable, d=>record_message_B_22n103ss1
   );
   modgen_and_73 : and_3u_3u port map ( a(2)=>Ack, a(1)=>MON_SOM_phase(1), 
      a(0)=>CE, d=>rtlc22n10641);
   modgen_and_74 : and_3u_3u port map ( a(2)=>BC_Echo_word(11), a(1)=>
      BC_Echo_word(10), a(0)=>rtlcn3579, d=>eBC_start_FT_26n180ss1);
   modgen_or_75 : or_6u_6u port map ( a(5)=>one_micro_increment_wide, a(4)=>
      rtlcs276, a(3)=>rtlc60n5324, a(2)=>rtlc60n5359, a(1)=>rtlc60n5353, 
      a(0)=>eBC_TT_do, d=>rtlcn10838);
   modgen_or_77 : or_3u_3u port map ( a(2)=>BC_State(0), a(1)=>BC_State(1), 
      a(0)=>BC_State(31), d=>rtlc26n18667);
   modgen_and_78 : and_3u_3u port map ( a(2)=>BC_Message_Active, a(1)=>
      BC_Read, a(0)=>rtlcn3308, d=>rtlcn3375);
   modgen_and_79 : and_3u_3u port map ( a(2)=>not_rtlc26n14300, a(1)=>
      Clear_Test_Status_reg, a(0)=>rtlcn8911, d=>rtlcn3481);
   modgen_or_80 : or_3u_3u port map ( a(2)=>not_MON_SOM_req, a(1)=>rtlcn8829, 
      a(0)=>rtlcn8871, d=>rtlcn4353);
   modgen_or_81 : or_3u_3u port map ( a(2)=>Arbiter_timeout, a(1)=>
      MON_SOM_phase(7), a(0)=>rtlcn8879, d=>rtlcn8643);
   modgen_and_82 : and_3u_3u port map ( a(2)=>EOM_phase(0), a(1)=>
      not_illegal_message, a(0)=>not_Arbiter_timeout, d=>rtlcn4635);
   modgen_and_83 : and_3u_3u port map ( a(2)=>CE, a(1)=>rtlc22n10316, a(0)=>
      rtlcn8839, d=>rtlc22n10642);
   modgen_select_84 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>debug_EXMPLR1003(15), b(0)=>Data_o_temp(15), d=>
      nx446);
   modgen_select_85 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>debug_EXMPLR1003(15), b(0)=>Data_o_temp(14), d=>
      nx447);
   modgen_select_86 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>debug_EXMPLR1003(15), b(0)=>Data_o_temp(13), d=>
      nx448);
   modgen_select_87 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>debug_EXMPLR1003(15), b(0)=>Data_o_temp(12), d=>
      nx449);
   modgen_select_88 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>debug_EXMPLR1003(15), b(0)=>Data_o_temp(11), d=>
      nx450);
   modgen_select_89 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12ss1_10, b(0)=>Data_o_temp(10), d
      =>nx451);
   modgen_select_90 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12ss1_9, b(0)=>Data_o_temp(9), d=>
      nx452);
   modgen_select_91 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12ss1_8, b(0)=>Data_o_temp(8), d=>
      nx453);
   modgen_select_92 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(7), b(0)=>Data_o_temp(7), d=>
      nx454);
   modgen_select_93 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(6), b(0)=>Data_o_temp(6), d=>
      nx455);
   modgen_select_94 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(5), b(0)=>Data_o_temp(5), d=>
      nx456);
   modgen_select_95 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(4), b(0)=>Data_o_temp(4), d=>
      nx457);
   modgen_select_96 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(3), b(0)=>Data_o_temp(3), d=>
      nx458);
   modgen_select_97 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(2), b(0)=>Data_o_temp(2), d=>
      nx459);
   modgen_select_98 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(1), b(0)=>Data_o_temp(1), d=>
      nx460);
   modgen_select_99 : select_2_2 port map ( a(1)=>rtlc26n16122, a(0)=>
      BC_State(47), b(1)=>BC_Num_Msgs_26n12s1(0), b(0)=>Data_o_temp(0), d=>
      nx461);
   nx462 <= rtlc26n16122 OR BC_State(47) ;
   modgen_counter_BC_Num_Msgs : 
      counter_updn_cnt_en_sload_aclear_clock_clk_en_0_16 port map ( clock=>
      clock, q(15)=>BC_Num_Msgs(15), q(14)=>BC_Num_Msgs(14), q(13)=>
      BC_Num_Msgs(13), q(12)=>BC_Num_Msgs(12), q(11)=>BC_Num_Msgs(11), q(10)
      =>BC_Num_Msgs(10), q(9)=>BC_Num_Msgs(9), q(8)=>BC_Num_Msgs(8), q(7)=>
      BC_Num_Msgs(7), q(6)=>BC_Num_Msgs(6), q(5)=>BC_Num_Msgs(5), q(4)=>
      BC_Num_Msgs(4), q(3)=>BC_Num_Msgs(3), q(2)=>BC_Num_Msgs(2), q(1)=>
      BC_Num_Msgs(1), q(0)=>BC_Num_Msgs(0), clk_en=>rtlc26n16970, aclear=>
      not_ResetN, sload=>nx462, data(15)=>nx446, data(14)=>nx447, data(13)=>
      nx448, data(12)=>nx449, data(11)=>nx450, data(10)=>nx451, data(9)=>
      nx452, data(8)=>nx453, data(7)=>nx454, data(6)=>nx455, data(5)=>nx456, 
      data(4)=>nx457, data(3)=>nx458, data(2)=>nx459, data(1)=>nx460, 
      data(0)=>nx461, aset=>debug_EXMPLR1003(15), sclear=>
      debug_EXMPLR1003(15), updn=>NOT_BC_State_12, cnt_en=>rtlcn2142);
   modgen_counter_WM_RAM_Address : counter_up_sload_aclear_clock_clk_en_1_15
       port map ( clock=>clock, q(15)=>WM_RAM_Address(15), q(14)=>
      WM_RAM_Address(14), q(13)=>WM_RAM_Address(13), q(12)=>
      WM_RAM_Address(12), q(11)=>WM_RAM_Address(11), q(10)=>
      WM_RAM_Address(10), q(9)=>WM_RAM_Address(9), q(8)=>WM_RAM_Address(8), 
      q(7)=>WM_RAM_Address(7), q(6)=>WM_RAM_Address(6), q(5)=>
      WM_RAM_Address(5), q(4)=>WM_RAM_Address(4), q(3)=>WM_RAM_Address(3), 
      q(2)=>WM_RAM_Address(2), q(1)=>WM_RAM_Address(1), clk_en=>rtlc87n699, 
      aclear=>not_ResetN, sload=>state(7), data(15)=>
      WM_RAM_Address_87n11ss1(15), data(14)=>WM_RAM_Address_87n11ss1(14), 
      data(13)=>WM_RAM_Address_87n11ss1(13), data(12)=>
      WM_RAM_Address_87n11ss1(12), data(11)=>WM_RAM_Address_87n11ss1(11), 
      data(10)=>WM_RAM_Address_87n11ss1(10), data(9)=>
      WM_RAM_Address_87n11ss1(9), data(8)=>WM_RAM_Address_87n11ss1(8), 
      data(7)=>WM_RAM_Address_87n11ss1(7), data(6)=>
      WM_RAM_Address_87n11ss1(6), data(5)=>WM_RAM_Address_87n11ss1(5), 
      data(4)=>WM_RAM_Address_87n11ss1(4), data(3)=>
      WM_RAM_Address_87n11ss1(3), data(2)=>WM_RAM_Address_87n11ss1(2), 
      data(1)=>WM_RAM_Address_87n11ss1(1), aset=>debug_EXMPLR1003(15), 
      sclear=>debug_EXMPLR1003(15), updn=>PWR, cnt_en=>PWR);
   modgen_rom_ix7675 : 
      rom_new_0_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
       port map ( rd_data1(3)=>BC_State_fsm_26n69ss1_63, rd_data1(2)=>
      BC_State_fsm_26n69ss1_61, rd_data1(1)=>BC_State_fsm_26n69ss1_70, 
      rd_data1(0)=>BC_State_fsm_26n69ss1_34, addr1(6)=>Ack, addr1(5)=>
      Data_o_temp(14), addr1(4)=>Data_o_temp(13), addr1(3)=>Data_o_temp(12), 
      addr1(2)=>Data_o_temp(11), addr1(1)=>Data_o_temp(10), addr1(0)=>
      Data_o_temp(9), rd_clk1=>DANGLING(23), rd_ena1=>PWR, regce1=>PWR, rst1
      =>debug_EXMPLR1003(15));
   rtlcn9931 <= not_rtlc22n7393 OR First_After_Reset ;
   modgen_counter_Do_once_nx18 <= rtlcn9931 OR rtlc22n7221 ;
   modgen_counter_Do_once_nx21 <= modgen_counter_Do_once_nx18 AND CE ;
   modgen_counter_Do_once_nx24 <= modgen_counter_Do_once_nx40 AND 
   not_rtlc22n7221 ;
   modgen_counter_Do_once_nx26 <= modgen_counter_Do_once_nx42 AND 
   not_rtlc22n7221 ;
   modgen_counter_Do_once_nx28 <= modgen_counter_Do_once_nx44 AND 
   not_rtlc22n7221 ;
   modgen_counter_Do_once_nx30 <= modgen_counter_Do_once_nx46 AND 
   not_rtlc22n7221 ;
   modgen_counter_Do_once_nx32 <= modgen_counter_Do_once_nx48 AND 
   not_rtlc22n7221 ;
   modgen_counter_Do_once_nx37 <= not_Do_once_1 XOR Do_once(0) ;
   modgen_counter_Do_once_dec_nx28 <= Do_once(1) OR Do_once(0) ;
   modgen_counter_Do_once_nx36 <= not_Do_once_2 XOR 
   modgen_counter_Do_once_dec_nx28 ;
   modgen_counter_Do_once_dec_nx42 <= Do_once(2) OR 
   modgen_counter_Do_once_dec_nx28 ;
   modgen_counter_Do_once_nx35 <= not_Do_once_3 XOR 
   modgen_counter_Do_once_dec_nx42 ;
   modgen_counter_Do_once_dec_nx56 <= Do_once(3) OR 
   modgen_counter_Do_once_dec_nx42 ;
   modgen_counter_Do_once_nx34 <= not_Do_once_4 XOR 
   modgen_counter_Do_once_dec_nx56 ;
   nx596 <= modgen_counter_Do_once_nx24 when modgen_counter_Do_once_nx21
    = '1' else Do_once(4) ;
   DFFPCE (nx596,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Do_once(4)) ;
   nx601 <= modgen_counter_Do_once_nx26 when modgen_counter_Do_once_nx21
    = '1' else Do_once(3) ;
   DFFPCE (nx601,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Do_once(3)) ;
   nx605 <= modgen_counter_Do_once_nx28 when modgen_counter_Do_once_nx21
    = '1' else Do_once(2) ;
   DFFPCE (nx605,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Do_once(2)) ;
   nx609 <= modgen_counter_Do_once_nx30 when modgen_counter_Do_once_nx21
    = '1' else Do_once(1) ;
   DFFPCE (nx609,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Do_once(1)) ;
   nx613 <= modgen_counter_Do_once_nx32 when modgen_counter_Do_once_nx21
    = '1' else Do_once(0) ;
   DFFPCE (nx613,debug_EXMPLR1003(15),not_ResetN,PWR,clock,Do_once(0)) ;
   modgen_rom_ix7676 : 
      rom_new_1_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
       port map ( rd_data1(6)=>Ram_data_i_6_22n2s8, rd_data1(5)=>
      Ram_data_i_5_22n2s7, rd_data1(4)=>Ram_data_i_4_22n2s6, rd_data1(3)=>
      Ram_data_i_3_22n2s5, rd_data1(2)=>Ram_data_i_2_22n2s4, rd_data1(1)=>
      Ram_data_i_1_22n2s3, rd_data1(0)=>Ram_data_i_0_22n2s1, addr1(4)=>nx596, 
      addr1(3)=>nx601, addr1(2)=>nx605, addr1(1)=>nx609, addr1(0)=>nx613, 
      rd_clk1=>clock, rd_ena1=>PWR, regce1=>PWR, rst1=>not_ResetN);
   modgen_rom_ix7677 : 
      rom_new_2_DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1_Sital_Ofer_hofman_unfold_3298
       port map ( rd_data1(6)=>Ram_data_i_14_22n2s17, rd_data1(5)=>
      Ram_data_i_13_22n2s16, rd_data1(4)=>Ram_data_i_12_22n2s15, rd_data1(3)
      =>Ram_data_i_11_22n2s14, rd_data1(2)=>Ram_data_i_10_22n2s13, 
      rd_data1(1)=>Ram_data_i_9_22n2s12, rd_data1(0)=>Ram_data_i_8_22n2s10, 
      addr1(4)=>Ram_data_i_22n2s11(5), addr1(3)=>Ram_data_i_22n2s11(4), 
      addr1(2)=>Ram_data_i_22n2s11(3), addr1(1)=>Ram_data_i_22n2s11(2), 
      addr1(0)=>Ram_data_i_22n2s11(1), rd_clk1=>DANGLING(24), rd_ena1=>PWR, 
      regce1=>PWR, rst1=>debug_EXMPLR1003(15));
   modgen_or_100 : or_8u_8u port map ( a(7)=>monitor_data_pointer(9), a(6)=>
      monitor_data_pointer(10), a(5)=>monitor_data_pointer(11), a(4)=>
      monitor_data_pointer(12), a(3)=>monitor_data_pointer(13), a(2)=>
      monitor_data_pointer(14), a(1)=>monitor_data_pointer(15), a(0)=>
      monitor_data_pointer(8), d=>rtlcn1231);
   modgen_or_101 : or_7u_7u port map ( a(6)=>monitor_data_pointer(10), a(5)
      =>monitor_data_pointer(11), a(4)=>monitor_data_pointer(12), a(3)=>
      monitor_data_pointer(13), a(2)=>monitor_data_pointer(14), a(1)=>
      monitor_data_pointer(15), a(0)=>rtlc22n11259, d=>rtlcn1232);
   modgen_or_102 : or_8u_8u port map ( a(7)=>monitor_stack_pointer(9), a(6)
      =>monitor_stack_pointer(10), a(5)=>monitor_stack_pointer(11), a(4)=>
      monitor_stack_pointer(12), a(3)=>monitor_stack_pointer(13), a(2)=>
      monitor_stack_pointer(14), a(1)=>monitor_stack_pointer(15), a(0)=>
      monitor_stack_pointer(8), d=>rtlcn1233);
   modgen_or_103 : or_7u_7u port map ( a(6)=>monitor_stack_pointer(10), a(5)
      =>monitor_stack_pointer(11), a(4)=>monitor_stack_pointer(12), a(3)=>
      monitor_stack_pointer(13), a(2)=>monitor_stack_pointer(14), a(1)=>
      monitor_stack_pointer(15), a(0)=>rtlc22n11324, d=>rtlcn1234);
   modgen_or_104 : or_12u_12u port map ( a(11)=>time_tag_EXMPLR1002(5), 
      a(10)=>time_tag_EXMPLR1002(6), a(9)=>time_tag_EXMPLR1002(7), a(8)=>
      time_tag_EXMPLR1002(8), a(7)=>time_tag_EXMPLR1002(9), a(6)=>
      time_tag_EXMPLR1002(10), a(5)=>time_tag_EXMPLR1002(11), a(4)=>
      time_tag_EXMPLR1002(12), a(3)=>time_tag_EXMPLR1002(13), a(2)=>
      time_tag_EXMPLR1002(14), a(1)=>time_tag_EXMPLR1002(15), a(0)=>
      time_tag_EXMPLR1002(4), d=>rtlcn1246);
   modgen_or_105 : or_5u_5u port map ( a(4)=>rtlcn8798, a(3)=>rtlcn8876, 
      a(2)=>rtlcn9039, a(1)=>rtlcn8888, a(0)=>rtlcn8914, d=>rtlcn5395);
   modgen_or_106 : or_6u_6u port map ( a(5)=>rtlcn8826, a(4)=>rtlcn8830, 
      a(3)=>rtlcn5781, a(2)=>rtlcn9050, a(1)=>rtlcn9051, a(0)=>rtlcn9052, d
      =>rtlcn5417);
   modgen_or_108 : or_7u_7u port map ( a(6)=>rtlcn8876, a(5)=>rtlcn8879, 
      a(4)=>rtlcn8881, a(3)=>rtlcn9475, a(2)=>rtlcn9480, a(1)=>rtlcs47, a(0)
      =>STM_ended_22n27ss1, d=>STM_ended_22n108ss1);
   modgen_or_109 : or_6u_6u port map ( a(5)=>rtlc60n5176, a(4)=>eBC_TT_do, 
      a(3)=>rtlcn7443, a(2)=>rtlcn9493, a(1)=>rtlcn9495, a(0)=>rtlcs276, d=>
      rtlcn8707);
   modgen_and_110 : and_8u_8u port map ( a(7)=>BC_Num_Msgs_26n12s1(9), a(6)
      =>Data_o_temp(11), a(5)=>not_Data_o_temp_12, a(4)=>not_Data_o_temp_13, 
      a(3)=>not_Data_o_temp_14, a(2)=>Ack, a(1)=>not_rtlcn9888, a(0)=>
      not_rtlc26n15497, d=>rtlcn9855);
   modgen_and_111 : and_6u_6u port map ( a(5)=>LIFO_Pointer(4), a(4)=>
      not_LIFO_Pointer_3, a(3)=>not_LIFO_Pointer_2, a(2)=>not_LIFO_Pointer_1, 
      a(1)=>not_LIFO_Pointer_0, a(0)=>YES, d=>rtlc26n15271);
   modgen_and_113 : and_17u_17u port map ( a(16)=>BC_Ram_data_26n15s1(15), 
      a(15)=>BC_Ram_data_26n15s1(14), a(14)=>BC_Ram_data_26n15s1(13), a(13)
      =>BC_Ram_data_26n15s1(12), a(12)=>BC_Ram_data_26n15s1(11), a(11)=>
      BC_Ram_data_26n15s1(10), a(10)=>BC_Ram_data_26n15s1(9), a(9)=>
      BC_Ram_data_26n15s1(8), a(8)=>BC_Ram_data_26n15s1(7), a(7)=>
      BC_Ram_data_26n15s1(6), a(6)=>BC_Ram_data_26n15s1(5), a(5)=>
      BC_Ram_data_26n15s1(4), a(4)=>BC_Ram_data_26n15s1(3), a(3)=>
      BC_Ram_data_26n15s1(2), a(2)=>BC_Ram_data_26n15s1(1), a(1)=>
      BC_Ram_data_26n15s1(0), a(0)=>Ack, d=>rtlc26n14576);
   modgen_and_114 : and_6u_6u port map ( a(5)=>LIFO_Pointer(4), a(4)=>
      LIFO_Pointer(3), a(3)=>LIFO_Pointer(2), a(2)=>LIFO_Pointer(1), a(1)=>
      LIFO_Pointer(0), a(0)=>BC_Echo_word(10), d=>rtlc26n15208);
   modgen_and_115 : and_28u_28u port map ( a(27)=>not_Counter_100us_11, 
      a(26)=>not_Counter_100us_10, a(25)=>not_Counter_100us_9, a(24)=>
      not_Counter_100us_8, a(23)=>not_Counter_100us_7, a(22)=>
      not_Counter_100us_6, a(21)=>not_Counter_100us_5, a(20)=>
      not_Counter_100us_4, a(19)=>not_Counter_100us_3, a(18)=>
      not_Counter_100us_2, a(17)=>not_Counter_100us_1, a(16)=>
      Counter_100us(0), a(15)=>not_BC_frame_GAP_counter_15, a(14)=>
      not_BC_frame_GAP_counter_14, a(13)=>not_BC_frame_GAP_counter_13, a(12)
      =>not_BC_frame_GAP_counter_12, a(11)=>not_BC_frame_GAP_counter_11, 
      a(10)=>not_BC_frame_GAP_counter_10, a(9)=>not_BC_frame_GAP_counter_9, 
      a(8)=>not_BC_frame_GAP_counter_8, a(7)=>not_BC_frame_GAP_counter_7, 
      a(6)=>not_BC_frame_GAP_counter_6, a(5)=>not_BC_frame_GAP_counter_5, 
      a(4)=>not_BC_frame_GAP_counter_4, a(3)=>not_BC_frame_GAP_counter_3, 
      a(2)=>not_BC_frame_GAP_counter_2, a(1)=>not_BC_frame_GAP_counter_1, 
      a(0)=>BC_frame_GAP_counter(0), d=>rtlc51n160);
   modgen_and_116 : and_8u_8u port map ( a(7)=>not_Monitor_Active_command_10, 
      a(6)=>not_Monitor_Active_command_9, a(5)=>not_Monitor_Active_command_8, 
      a(4)=>not_Monitor_Active_command_7, a(3)=>not_Monitor_Active_command_6, 
      a(2)=>not_Monitor_Active_command_5, a(1)=>Monitor_Active_command(4), 
      a(0)=>rtlcs199, d=>Monitor_command_is_sync_with_data_60n11s5);
   modgen_and_117 : and_8u_8u port map ( a(7)=>not_Monitor_Active_command_10, 
      a(6)=>Monitor_Active_command(4), a(5)=>Monitor_Active_command(9), a(4)
      =>Monitor_Active_command(8), a(3)=>Monitor_Active_command(7), a(2)=>
      Monitor_Active_command(6), a(1)=>Monitor_Active_command(5), a(0)=>
      rtlcs199, d=>Monitor_command_is_sync_with_data_60n11s6);
   modgen_and_118 : and_8u_8u port map ( a(7)=>not_Monitor_Active_command_9, 
      a(6)=>not_Monitor_Active_command_8, a(5)=>not_Monitor_Active_command_7, 
      a(4)=>not_Monitor_Active_command_6, a(3)=>not_Monitor_Active_command_5, 
      a(2)=>Monitor_Active_command(10), a(1)=>not_Monitor_Active_command_4, 
      a(0)=>rtlcs199, d=>Monitor_command_is_sync_without_data_60n11s5);
   modgen_and_119 : and_8u_8u port map ( a(7)=>Monitor_Active_command(9), 
      a(6)=>Monitor_Active_command(8), a(5)=>Monitor_Active_command(7), a(4)
      =>Monitor_Active_command(6), a(3)=>Monitor_Active_command(5), a(2)=>
      Monitor_Active_command(10), a(1)=>not_Monitor_Active_command_4, a(0)=>
      rtlcs199, d=>Monitor_command_is_sync_without_data_60n11s6);
   modgen_and_120 : and_7u_7u port map ( a(6)=>eBC_Q_pointer(5), a(5)=>
      eBC_Q_pointer(4), a(4)=>eBC_Q_pointer(3), a(3)=>eBC_Q_pointer(2), a(2)
      =>eBC_Q_pointer(1), a(1)=>eBC_Q_pointer(0), a(0)=>eBC_Inc_Q_pointer, d
      =>rtlc75n1848);
   modgen_or_122 : or_8u_8u port map ( a(7)=>SOM_phase_4, a(6)=>SOM_phase_3, 
      a(5)=>rtlcn9461, a(4)=>rtlcn9462, a(3)=>rtlcn9463, a(2)=>rtlcn9464, 
      a(1)=>rtlcn2082, a(0)=>not_rtlcn8839, d=>rtlcn7433);
   modgen_and_123 : and_13u_13u port map ( a(12)=>not_Data_o_temp_12, a(11)
      =>BC_Num_Msgs_26n12s1(10), a(10)=>BC_Num_Msgs_26n12s1(8), a(9)=>
      not_Data_o_temp_15, a(8)=>BC_Num_Msgs_26n12s1(6), a(7)=>
      BC_Num_Msgs_26n12s1(4), a(6)=>BC_Num_Msgs_26n12s1(3), a(5)=>
      BC_Num_Msgs_26n12s1(2), a(4)=>BC_Num_Msgs_26n12s1(1), a(3)=>
      BC_Num_Msgs_26n12s1(0), a(2)=>rtlcs136, a(1)=>rtlcs119, a(0)=>rtlcs133, 
      d=>gap_eq_0_48n3s1);
   modgen_or_125 : or_7u_7u port map ( a(6)=>BC_Rx_Data(0), a(5)=>
      BC_Rx_Data(1), a(4)=>BC_Rx_Data(2), a(3)=>BC_Rx_Data(3), a(2)=>
      not_rtlcs170, a(1)=>not_rtlcn1225, a(0)=>rtlc44n274, d=>rtlc44n275);
   modgen_or_126 : or_17u_17u port map ( a(16)=>CE, a(15)=>
      MIL1553_errors_transmitter_timout, a(14)=>rtlc75n1547, a(13)=>
      Monitor_command_stack_rollover, a(12)=>Monitor_data_stack_rollover, 
      a(11)=>BC_Retry_pulse, a(10)=>rtlc75n1647, a(9)=>rtlc75n1665, a(8)=>
      rtlc75n1714, a(7)=>rtlc75n1730, a(6)=>rtlc75n1795, a(5)=>rtlc75n1819, 
      a(4)=>eBC_Bad_Parity, a(3)=>eBC_Stack_error, a(2)=>eBC_Bad_instruction, 
      a(1)=>Monitor_command_stack_half_pass, a(0)=>
      Monitor_data_stack_half_pass, d=>nx642);
   modgen_or_127 : or_3u_3u port map ( a(2)=>rtlc75n1765, a(1)=>rtlc75n1848, 
      a(0)=>nx642, d=>rtlcn11108);
   modgen_counter_Do_once_nx42 <= modgen_counter_Do_once_nx35 AND 
   not_First_After_Reset ;
   modgen_counter_Do_once_nx44 <= modgen_counter_Do_once_nx36 AND 
   not_First_After_Reset ;
   modgen_counter_Do_once_nx48 <= not_Do_once_0 AND not_First_After_Reset ;
   modgen_counter_Do_once_nx40 <= modgen_counter_Do_once_nx34 OR 
   First_After_Reset ;
   modgen_counter_Do_once_nx46 <= modgen_counter_Do_once_nx37 OR 
   First_After_Reset ;
   ix670 : selcounter_9_9_9_0_1_up port map ( cin=>PWR, mode=>rtlcn5529, 
      updn=>PWR, a(8)=>stack_pointer(10), a(7)=>stack_pointer(9), a(6)=>
      stack_pointer(8), a(5)=>stack_pointer(7), a(4)=>stack_pointer(6), a(3)
      =>stack_pointer(5), a(2)=>stack_pointer(4), a(1)=>stack_pointer(3), 
      a(0)=>stack_pointer(2), k(8)=>Data_o_temp(10), k(7)=>Data_o_temp(9), 
      k(6)=>Data_o_temp(8), k(5)=>Data_o_temp(7), k(4)=>Data_o_temp(6), k(3)
      =>Data_o_temp(5), k(2)=>Data_o_temp(4), k(1)=>Data_o_temp(3), k(0)=>
      Data_o_temp(2), d(8)=>stack_pointer_22n50ss1_10, d(7)=>
      stack_pointer_22n50ss1_9, d(6)=>stack_pointer_22n50ss1_8, d(5)=>
      stack_pointer_22n50ss1_7, d(4)=>stack_pointer_22n50ss1_6, d(3)=>
      stack_pointer_22n50ss1_5, d(2)=>stack_pointer_22n50ss1_4, d(1)=>
      stack_pointer_22n50ss1_3, d(0)=>stack_pointer_22n50ss1_2);
   nx707 <= BC_Echo_word(1) XOR BC_Echo_word(0) ;
   nx709 <= BC_Echo_word(2) XOR nx707 ;
   nx711 <= BC_Echo_word(3) XOR nx709 ;
   nx713 <= BC_Echo_word(4) XOR nx711 ;
   nx716 <= BC_Echo_word(5) XOR nx713 ;
   nx718 <= BC_Echo_word(6) XOR nx716 ;
   nx720 <= BC_Echo_word(7) XOR nx718 ;
   nx722 <= BC_Echo_word(8) XOR nx720 ;
   nx724 <= BC_Echo_word(9) XOR nx722 ;
   nx726 <= BC_Echo_word(10) XOR nx724 ;
   nx728 <= BC_Echo_word(11) XOR nx726 ;
   nx730 <= BC_Echo_word(12) XOR nx728 ;
   nx732 <= BC_Echo_word(13) XOR nx730 ;
   nx734 <= BC_Echo_word(15) XOR nx732 ;
   eBC_Bad_Parity_26n180s2 <= BC_Echo_word(14) XOR nx734 ;
   nx742 <= Data_o_temp(14) XOR Data_o_temp(15) ;
   nx744 <= Data_o_temp(13) XOR nx742 ;
   nx746 <= Data_o_temp(12) XOR nx744 ;
   nx748 <= Data_o_temp(11) XOR nx746 ;
   nx750 <= Data_o_temp(10) XOR nx748 ;
   nx752 <= Data_o_temp(9) XOR nx750 ;
   nx754 <= Data_o_temp(8) XOR nx752 ;
   nx756 <= Data_o_temp(7) XOR nx754 ;
   nx758 <= Data_o_temp(6) XOR nx756 ;
   nx760 <= Data_o_temp(5) XOR nx758 ;
   nx762 <= Data_o_temp(4) XOR nx760 ;
   nx764 <= Data_o_temp(3) XOR nx762 ;
   nx766 <= Data_o_temp(2) XOR nx764 ;
   nx769 <= Data_o_temp(1) XOR nx766 ;
   rtlcs353 <= Data_o_temp(0) XOR nx769 ;
end Sital_Ofer_hofman_unfold_3298 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Auxilury_Ver_8_4_2_1_0 is 
   port (
      Clock : IN std_logic ;
      Cohen : IN std_logic ;
      H15530_record_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      H15530_record_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      H15530_record_A_Sync_error : IN std_logic ;
      H15530_record_A_Manchester_error : IN std_logic ;
      H15530_record_A_Parity_error : IN std_logic ;
      H15530_record_A_echo_back_bus : IN std_logic ;
      H15530_record_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      H15530_record_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      H15530_record_A_RxRDY_plus_12us : IN std_logic ;
      H15530_record_A_RxRDY_plus_10us : IN std_logic ;
      H15530_record_A_CS : IN std_logic ;
      H15530_record_A_Pre_EchoRdy : IN std_logic ;
      H15530_record_A_Command_Sync : IN std_logic ;
      H15530_record_A_Pre_RxRdy : IN std_logic ;
      H15530_record_A_recieving : IN std_logic ;
      H15530_record_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      H15530_record_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      H15530_record_B_Sync_error : IN std_logic ;
      H15530_record_B_Manchester_error : IN std_logic ;
      H15530_record_B_Parity_error : IN std_logic ;
      H15530_record_B_echo_back_bus : IN std_logic ;
      H15530_record_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      H15530_record_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      H15530_record_B_RxRDY_plus_12us : IN std_logic ;
      H15530_record_B_RxRDY_plus_10us : IN std_logic ;
      H15530_record_B_CS : IN std_logic ;
      H15530_record_B_Pre_EchoRdy : IN std_logic ;
      H15530_record_B_Command_Sync : IN std_logic ;
      H15530_record_B_Pre_RxRdy : IN std_logic ;
      H15530_record_B_recieving : IN std_logic ;
      RT_Address_wire : IN std_logic_vector (5 DOWNTO 0) ;
      ResetN : IN std_logic ;
      External_CE_In : IN std_logic ;
      CE : OUT std_logic ;
      RT_Address_A_valid : OUT std_logic ;
      RT_Address_B_valid : OUT std_logic ;
      RT_Address_Parity_Error : OUT std_logic) ;
end Auxilury_Ver_8_4_2_1_0 ;

architecture Sital_Ofer_Hofman_unfold_4078 of Auxilury_Ver_8_4_2_1_0 is 
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   signal CE_EXMPLR1006, clock_count, RT_Address_Parity_Error_EXMPLR1009, 
      not_ResetN, not_clock_count, RT_Address_A_valid_6n2s1, 
      RT_Address_B_valid_6n3s1, not_H15530_record_A_R_Data_13, 
      not_H15530_record_A_R_Data_12, not_H15530_record_A_R_Data_11, 
      not_H15530_record_B_R_Data_13, not_H15530_record_B_R_Data_12, 
      not_H15530_record_B_R_Data_11: std_logic ;

begin
   CE <= CE_EXMPLR1006 ;
   RT_Address_Parity_Error <= RT_Address_Parity_Error_EXMPLR1009 ;
   RT_Address_Parity_Error_EXMPLR1009 <= '0' ;
   not_ResetN <= NOT ResetN ;
   not_clock_count <= NOT clock_count ;
   not_H15530_record_A_R_Data_13 <= NOT H15530_record_A_R_Data(13) ;
   not_H15530_record_A_R_Data_12 <= NOT H15530_record_A_R_Data(12) ;
   not_H15530_record_A_R_Data_11 <= NOT H15530_record_A_R_Data(11) ;
   RT_Address_A_valid_and_6i1 : and_5u_5u port map ( a(4)=>
      H15530_record_A_R_Data(15), a(3)=>H15530_record_A_R_Data(14), a(2)=>
      not_H15530_record_A_R_Data_13, a(1)=>not_H15530_record_A_R_Data_12, 
      a(0)=>not_H15530_record_A_R_Data_11, d=>RT_Address_A_valid_6n2s1);
   not_H15530_record_B_R_Data_13 <= NOT H15530_record_B_R_Data(13) ;
   not_H15530_record_B_R_Data_12 <= NOT H15530_record_B_R_Data(12) ;
   not_H15530_record_B_R_Data_11 <= NOT H15530_record_B_R_Data(11) ;
   RT_Address_B_valid_and_6i2 : and_5u_5u port map ( a(4)=>
      H15530_record_B_R_Data(15), a(3)=>H15530_record_B_R_Data(14), a(2)=>
      not_H15530_record_B_R_Data_13, a(1)=>not_H15530_record_B_R_Data_12, 
      a(0)=>not_H15530_record_B_R_Data_11, d=>RT_Address_B_valid_6n3s1);
   DFFPC (not_clock_count,RT_Address_Parity_Error_EXMPLR1009,not_ResetN,
   Clock,clock_count) ;
   DFFPC (clock_count,RT_Address_Parity_Error_EXMPLR1009,not_ResetN,Clock,
   CE_EXMPLR1006) ;
   DFFPCE (RT_Address_B_valid_6n3s1,not_ResetN,
   RT_Address_Parity_Error_EXMPLR1009,CE_EXMPLR1006,Clock,RT_Address_B_valid
   ) ;
   DFFPCE (RT_Address_A_valid_6n2s1,RT_Address_Parity_Error_EXMPLR1009,
   not_ResetN,CE_EXMPLR1006,Clock,RT_Address_A_valid) ;
end Sital_Ofer_Hofman_unfold_4078 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_sload_sclear_aclear_clock_clk_en_0_7 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (6 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_sload_sclear_aclear_clock_clk_en_0_7 ;

architecture INTERFACE of counter_dn_sload_sclear_aclear_clock_clk_en_0_7
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, nx27, nx28, 
      nx29, nx30, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx41, 
      nx43, nx45, nx47, nx49, nx51, nx53, NOT_SCLEAR: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx20 ;
   q(5) <= nx22 ;
   q(4) <= nx24 ;
   q(3) <= nx26 ;
   q(2) <= nx28 ;
   q(1) <= nx30 ;
   q(0) <= nx32 ;
   GND <= '0' ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,clk_en,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,clk_en,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,clk_en,clock,nx32) ;
   dec : dec_7u_7u_0_0 port map ( cin=>GND, a(6)=>nx20, a(5)=>nx22, a(4)=>
      nx24, a(3)=>nx26, a(2)=>nx28, a(1)=>nx30, a(0)=>nx32, d(6)=>nx33, d(5)
      =>nx34, d(4)=>nx35, d(3)=>nx36, d(2)=>nx37, d(1)=>nx38, d(0)=>nx39, 
      cout=>DANGLING(0));
   nx41 <= data(6) when sload = '1' else nx33 ;
   nx43 <= data(5) when sload = '1' else nx34 ;
   nx45 <= data(4) when sload = '1' else nx35 ;
   nx47 <= data(3) when sload = '1' else nx36 ;
   nx49 <= data(2) when sload = '1' else nx37 ;
   nx51 <= data(1) when sload = '1' else nx38 ;
   nx53 <= data(0) when sload = '1' else nx39 ;
   NOT_SCLEAR <= NOT sclear ;
   nx19 <= nx41 AND NOT_SCLEAR ;
   nx21 <= nx43 AND NOT_SCLEAR ;
   nx23 <= nx45 AND NOT_SCLEAR ;
   nx25 <= nx47 AND NOT_SCLEAR ;
   nx27 <= nx49 AND NOT_SCLEAR ;
   nx29 <= nx51 AND NOT_SCLEAR ;
   nx31 <= nx53 AND NOT_SCLEAR ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_7 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (6 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_7 ;

architecture INTERFACE of 
   counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_7 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx22, nx25, nx28, nx29, nx30, nx31, nx32, nx33, nx34, 
      nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, 
      nx47, nx48, nx50, nx52, nx54, nx56, nx58, nx60, nx62, NOT_nx21: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx29 ;
   q(5) <= nx31 ;
   q(4) <= nx33 ;
   q(3) <= nx35 ;
   q(2) <= nx37 ;
   q(1) <= nx39 ;
   q(0) <= nx41 ;
   GND <= '0' ;
   nx19 <= cnt_en OR sload ;
   nx22 <= nx19 OR sclear ;
   nx25 <= nx22 AND clk_en ;
   DFFPCE (nx28,GND,aclear,nx25,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx25,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx25,clock,nx33) ;
   DFFPCE (nx34,GND,aclear,nx25,clock,nx35) ;
   DFFPCE (nx36,GND,aclear,nx25,clock,nx37) ;
   DFFPCE (nx38,GND,aclear,nx25,clock,nx39) ;
   DFFPCE (nx40,GND,aclear,nx25,clock,nx41) ;
   dec : dec_7u_7u_0_0 port map ( cin=>GND, a(6)=>nx29, a(5)=>nx31, a(4)=>
      nx33, a(3)=>nx35, a(2)=>nx37, a(1)=>nx39, a(0)=>nx41, d(6)=>nx42, d(5)
      =>nx43, d(4)=>nx44, d(3)=>nx45, d(2)=>nx46, d(1)=>nx47, d(0)=>nx48, 
      cout=>DANGLING(0));
   nx50 <= data(6) when sload = '1' else nx42 ;
   nx52 <= data(5) when sload = '1' else nx43 ;
   nx54 <= data(4) when sload = '1' else nx44 ;
   nx56 <= data(3) when sload = '1' else nx45 ;
   nx58 <= data(2) when sload = '1' else nx46 ;
   nx60 <= data(1) when sload = '1' else nx47 ;
   nx62 <= data(0) when sload = '1' else nx48 ;
   NOT_nx21 <= NOT sclear ;
   nx28 <= nx50 AND NOT_nx21 ;
   nx30 <= nx52 AND NOT_nx21 ;
   nx32 <= nx54 AND NOT_nx21 ;
   nx34 <= nx56 AND NOT_nx21 ;
   nx36 <= nx58 AND NOT_nx21 ;
   nx38 <= nx60 AND NOT_nx21 ;
   nx40 <= nx62 AND NOT_nx21 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Back_end_IF_8_4_0_32 is 
   port (
      Active_command : IN std_logic_vector (15 DOWNTO 0) ;
      Active_command_update : IN std_logic ;
      BIT_word : IN std_logic_vector (15 DOWNTO 0) ;
      Bus_Channel_status : IN std_logic_vector (10 DOWNTO 0) ;
      CE : IN std_logic ;
      CPU_ResetN : IN std_logic ;
      Clock : IN std_logic ;
      Data_in : IN std_logic_vector (15 DOWNTO 0) ;
      FE_Address : IN std_logic_vector (15 DOWNTO 0) ;
      Host_Status_Bits : IN std_logic_vector (10 DOWNTO 0) ;
      IDLE_MORE_THAN_NO_RESPONSE : IN std_logic ;
      Inhibit_TF : IN std_logic ;
      MODE_CODE1553A : IN std_logic ;
      Message_ended_OK : IN std_logic ;
      Read_req : IN std_logic ;
      Valid_command : IN std_logic ;
      Wrap_Address : IN std_logic_vector (4 DOWNTO 0) ;
      Write_Req : IN std_logic ;
      Write_data : IN std_logic_vector (15 DOWNTO 0) ;
      Xmitting_A : IN std_logic ;
      Xmitting_B : IN std_logic ;
      illegal_command : IN std_logic ;
      reset_RT_received : IN std_logic ;
      Channel_status : OUT std_logic_vector (10 DOWNTO 0) ;
      Clock_enable : OUT std_logic ;
      Read : OUT std_logic ;
      Write_Ack : OUT std_logic ;
      read_Ack : OUT std_logic ;
      read_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      Address : OUT std_logic_vector (15 DOWNTO 0) ;
      Data_out : OUT std_logic_vector (15 DOWNTO 0) ;
      Last_command : OUT std_logic_vector (15 DOWNTO 0) ;
      ResetN : OUT std_logic ;
      Write : OUT std_logic) ;
end Back_end_IF_8_4_0_32 ;

architecture Sital_Ofer_Hofman_no_reset_unfold_4194 of Back_end_IF_8_4_0_32
    is 
   component and_11u_11u
      port (
         a : IN std_logic_vector (10 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_dn_sload_sclear_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFRSE (
      constant data   : in std_logic;
      constant set    : in std_logic;
      constant reset  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (clk'event and clk'last_value = '0' and clk = '1') then
           if (reset = '1') then
               q <= '0' ;
           elsif (set = '1') then
               q <= '1' ;
           elsif (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((set/='1' or reset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFRSE ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal Read_EXMPLR1151: std_logic ;
   
   signal Last_command_EXMPLR1195: std_logic_vector (15 DOWNTO 0) ;
   
   signal ResetN_EXMPLR1186, Write_EXMPLR1187, CPU_ResetN_D: std_logic ;
   
   signal Cycle: std_logic_vector (6 DOWNTO 0) ;
   
   signal Message_ended_OK_level: std_logic ;
   
   signal Reset_Count_Down: std_logic_vector (6 DOWNTO 0) ;
   
   signal mode_word, GND, PWR, mode_word_3n0s2, not_MODE_CODE1553A, 
      mode_word_3n0s3, not_CPU_ResetN, not_ResetN, not_rtlcs3, not_Read_req, 
      rtlc8_X_0_n250, rtlc8n294, rtlc8n295: std_logic ;
   
   signal read_Data_11n3ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlc14n57, rtlc17_Channel_status_D_n4_10, 
      rtlc17_Channel_status_D_n4_4, rtlc17_Channel_status_D_n4_0, rtlc17n34, 
      rtlc17n68, not_CPU_ResetN_D, rtlc20n43, rtlc20n44, rtlc20n46, 
      rtlc20n47, not_rtlc20n47, rtlc20n123, rtlc20n149, rtlc23n34, rtlc23n35, 
      rtlc23n68, rtlcn23, rtlcn28, rtlcn36, rtlcn43, rtlcn46, rtlcn49, 
      rtlcn52, rtlcn55, rtlcn58, rtlcn61, rtlcn64, rtlcn67, rtlcn70, rtlcn73, 
      rtlcn76, rtlcn79, rtlcn82, rtlcn85, rtlcn88, not_CE, not_rtlcs6, 
      not_Write, rtlcn104, rtlcn105, rtlcn106, not_Write_Req, rtlcn108, 
      rtlcn109, rtlcs3, rtlcs4, rtlcs6, rtlcs8, rtlcs9, rtlcs10, 
      not_Inhibit_TF, not_Reset_Count_Down_6, not_Reset_Count_Down_5, 
      not_Reset_Count_Down_4, not_Reset_Count_Down_3, not_Reset_Count_Down_2, 
      not_Reset_Count_Down_1, not_Active_command_4, not_Active_command_2, 
      not_Active_command_1, not_Active_command_0, not_Active_command_9, 
      not_Active_command_8, not_Active_command_7, not_Active_command_6, 
      not_Active_command_5, not_Cycle_6, not_Cycle_5, not_Cycle_4, 
      not_Cycle_3, not_Cycle_2, not_Cycle_1, not_Cycle_0, not_Address_9, 
      not_Address_8, not_Address_7, not_Address_6, not_Address_5, 
      not_Address_3, not_Address_2, rtlcn163, rtlcn164, rtlc8_61_and_798_nx0, 
      rtlc_238_or_799_nx0, rtlc_241_and_800_nx0, rtlc_374_and_801_nx0: 
   std_logic ;

begin
   Read <= Read_EXMPLR1151 ;
   Address(15) <= GND ;
   Address(14) <= GND ;
   Address(13) <= GND ;
   Address(12) <= GND ;
   Address(11) <= GND ;
   Address(10) <= GND ;
   Address(9) <= GND ;
   Address(8) <= GND ;
   Address(7) <= GND ;
   Address(6) <= GND ;
   Address(5) <= GND ;
   Address(4) <= GND ;
   Address(3) <= GND ;
   Address(2) <= GND ;
   Address(1) <= GND ;
   Address(0) <= GND ;
   Data_out(15) <= GND ;
   Data_out(14) <= GND ;
   Data_out(13) <= GND ;
   Data_out(12) <= GND ;
   Data_out(11) <= GND ;
   Data_out(10) <= GND ;
   Data_out(9) <= GND ;
   Data_out(8) <= GND ;
   Data_out(7) <= GND ;
   Data_out(6) <= GND ;
   Data_out(5) <= GND ;
   Data_out(4) <= GND ;
   Data_out(3) <= GND ;
   Data_out(2) <= GND ;
   Data_out(1) <= GND ;
   Data_out(0) <= GND ;
   Last_command(15) <= Last_command_EXMPLR1195(15) ;
   Last_command(14) <= Last_command_EXMPLR1195(14) ;
   Last_command(13) <= Last_command_EXMPLR1195(13) ;
   Last_command(12) <= Last_command_EXMPLR1195(12) ;
   Last_command(11) <= Last_command_EXMPLR1195(11) ;
   Last_command(10) <= Last_command_EXMPLR1195(10) ;
   Last_command(9) <= Last_command_EXMPLR1195(9) ;
   Last_command(8) <= Last_command_EXMPLR1195(8) ;
   Last_command(7) <= Last_command_EXMPLR1195(7) ;
   Last_command(6) <= Last_command_EXMPLR1195(6) ;
   Last_command(5) <= Last_command_EXMPLR1195(5) ;
   Last_command(4) <= Last_command_EXMPLR1195(4) ;
   Last_command(3) <= Last_command_EXMPLR1195(3) ;
   Last_command(2) <= Last_command_EXMPLR1195(2) ;
   Last_command(1) <= Last_command_EXMPLR1195(1) ;
   Last_command(0) <= Last_command_EXMPLR1195(0) ;
   ResetN <= ResetN_EXMPLR1186 ;
   Write <= Write_EXMPLR1187 ;
   GND <= '0' ;
   PWR <= '1' ;
   mode_word <= mode_word_3n0s2 OR mode_word_3n0s3 ;
   not_MODE_CODE1553A <= NOT MODE_CODE1553A ;
   rtlc17_Channel_status_D_n4_4 <= Bus_Channel_status(4) OR 
   Host_Status_Bits(4) ;
   rtlc17_Channel_status_D_n4_10 <= Bus_Channel_status(10) OR 
   Host_Status_Bits(10) ;
   rtlc17n34 <= Valid_command OR IDLE_MORE_THAN_NO_RESPONSE ;
   rtlc20n123 <= rtlcs6 AND not_rtlc20n47 ;
   rtlc20n43 <= Message_ended_OK OR Xmitting_A ;
   rtlc20n44 <= rtlc20n43 OR Xmitting_B ;
   rtlc20n46 <= rtlc20n44 OR Message_ended_OK_level ;
   rtlc20n47 <= rtlc20n46 AND reset_RT_received ;
   rtlc23n34 <= rtlcs9 OR rtlcs8 ;
   rtlc23n35 <= Message_ended_OK AND rtlc23n34 ;
   not_rtlc20n47 <= NOT rtlc20n47 ;
   not_CPU_ResetN <= NOT CPU_ResetN ;
   not_CPU_ResetN_D <= NOT CPU_ResetN_D ;
   not_ResetN <= NOT ResetN_EXMPLR1186 ;
   not_CE <= NOT CE ;
   not_rtlcs6 <= NOT rtlcs6 ;
   rtlcn28 <= rtlcs3 AND Write_EXMPLR1187 ;
   not_Write <= NOT Write_EXMPLR1187 ;
   read_Data_11n3ss1(0) <= rtlcn43 when rtlcs10 = '1' else Data_in(0) ;
   read_Data_11n3ss1(1) <= rtlcn46 when rtlcs10 = '1' else Data_in(1) ;
   read_Data_11n3ss1(2) <= rtlcn49 when rtlcs10 = '1' else Data_in(2) ;
   read_Data_11n3ss1(3) <= rtlcn52 when rtlcs10 = '1' else Data_in(3) ;
   read_Data_11n3ss1(4) <= rtlcn55 when rtlcs10 = '1' else Data_in(4) ;
   read_Data_11n3ss1(5) <= rtlcn58 when rtlcs10 = '1' else Data_in(5) ;
   read_Data_11n3ss1(6) <= rtlcn61 when rtlcs10 = '1' else Data_in(6) ;
   read_Data_11n3ss1(7) <= rtlcn64 when rtlcs10 = '1' else Data_in(7) ;
   read_Data_11n3ss1(8) <= rtlcn67 when rtlcs10 = '1' else Data_in(8) ;
   read_Data_11n3ss1(9) <= rtlcn70 when rtlcs10 = '1' else Data_in(9) ;
   read_Data_11n3ss1(10) <= rtlcn73 when rtlcs10 = '1' else Data_in(10) ;
   read_Data_11n3ss1(11) <= rtlcn76 when rtlcs10 = '1' else Data_in(11) ;
   read_Data_11n3ss1(12) <= rtlcn79 when rtlcs10 = '1' else Data_in(12) ;
   read_Data_11n3ss1(13) <= rtlcn82 when rtlcs10 = '1' else Data_in(13) ;
   read_Data_11n3ss1(14) <= rtlcn85 when rtlcs10 = '1' else Data_in(14) ;
   read_Data_11n3ss1(15) <= rtlcn88 when rtlcs10 = '1' else Data_in(15) ;
   rtlcn43 <= BIT_word(0) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(0) ;
   rtlcn46 <= BIT_word(1) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(1) ;
   rtlcn49 <= BIT_word(2) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(2) ;
   rtlcn52 <= BIT_word(3) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(3) ;
   rtlcn55 <= BIT_word(4) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(4) ;
   rtlcn58 <= BIT_word(5) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(5) ;
   rtlcn61 <= BIT_word(6) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(6) ;
   rtlcn64 <= BIT_word(7) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(7) ;
   rtlcn67 <= BIT_word(8) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(8) ;
   rtlcn70 <= BIT_word(9) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(9) ;
   rtlcn73 <= BIT_word(10) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(10) ;
   rtlcn76 <= BIT_word(11) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(11) ;
   rtlcn79 <= BIT_word(12) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(12) ;
   rtlcn82 <= BIT_word(13) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(13) ;
   rtlcn85 <= BIT_word(14) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(14) ;
   rtlcn88 <= BIT_word(15) when FE_Address(0) = '1' else 
   Last_command_EXMPLR1195(15) ;
   not_Write_Req <= NOT Write_Req ;
   rtlcn104 <= rtlcs3 OR rtlcn108 ;
   rtlc8n295 <= CE AND rtlcn104 ;
   not_Read_req <= NOT Read_req ;
   not_rtlcs3 <= NOT rtlcs3 ;
   rtlcn109 <= Write_Req AND rtlcs4 ;
   rtlcn105 <= rtlcs3 OR rtlcn109 ;
   rtlc8n294 <= CE AND rtlcn105 ;
   rtlc14n57 <= CE AND Active_command_update ;
   rtlc17n68 <= CE AND rtlc17n34 ;
   rtlcn106 <= reset_RT_received OR rtlc23n35 ;
   rtlc23n68 <= CE AND rtlcn106 ;
   not_Inhibit_TF <= NOT Inhibit_TF ;
   rtlc17_Channel_status_D_n4_0 <= Host_Status_Bits(0) AND not_Inhibit_TF ;
   not_Reset_Count_Down_6 <= NOT Reset_Count_Down(6) ;
   not_Reset_Count_Down_5 <= NOT Reset_Count_Down(5) ;
   not_Reset_Count_Down_4 <= NOT Reset_Count_Down(4) ;
   not_Reset_Count_Down_3 <= NOT Reset_Count_Down(3) ;
   not_Reset_Count_Down_2 <= NOT Reset_Count_Down(2) ;
   not_Reset_Count_Down_1 <= NOT Reset_Count_Down(1) ;
   not_Active_command_4 <= NOT Active_command(4) ;
   not_Active_command_2 <= NOT Active_command(2) ;
   not_Active_command_1 <= NOT Active_command(1) ;
   not_Active_command_0 <= NOT Active_command(0) ;
   rtlc_403_and_803 : and_11u_11u port map ( a(10)=>Active_command(10), a(9)
      =>Active_command(9), a(8)=>Active_command(8), a(7)=>Active_command(7), 
      a(6)=>Active_command(6), a(5)=>Active_command(5), a(4)=>
      not_Active_command_4, a(3)=>Active_command(3), a(2)=>
      not_Active_command_2, a(1)=>not_Active_command_1, a(0)=>
      not_Active_command_0, d=>rtlcs9);
   not_Active_command_9 <= NOT Active_command(9) ;
   not_Active_command_8 <= NOT Active_command(8) ;
   not_Active_command_7 <= NOT Active_command(7) ;
   not_Active_command_6 <= NOT Active_command(6) ;
   not_Active_command_5 <= NOT Active_command(5) ;
   rtlc_413_and_804 : and_11u_11u port map ( a(10)=>Active_command(10), a(9)
      =>not_Active_command_9, a(8)=>not_Active_command_8, a(7)=>
      not_Active_command_7, a(6)=>not_Active_command_6, a(5)=>
      not_Active_command_5, a(4)=>not_Active_command_4, a(3)=>
      Active_command(3), a(2)=>not_Active_command_2, a(1)=>
      not_Active_command_1, a(0)=>not_Active_command_0, d=>rtlcs8);
   rtlc_421_and_805 : and_7u_7u port map ( a(6)=>not_Reset_Count_Down_6, 
      a(5)=>not_Reset_Count_Down_5, a(4)=>not_Reset_Count_Down_4, a(3)=>
      not_Reset_Count_Down_3, a(2)=>not_Reset_Count_Down_2, a(1)=>
      not_Reset_Count_Down_1, a(0)=>Reset_Count_Down(0), d=>rtlcs6);
   not_Cycle_6 <= NOT Cycle(6) ;
   not_Cycle_5 <= NOT Cycle(5) ;
   not_Cycle_4 <= NOT Cycle(4) ;
   not_Cycle_3 <= NOT Cycle(3) ;
   not_Cycle_2 <= NOT Cycle(2) ;
   not_Cycle_1 <= NOT Cycle(1) ;
   not_Cycle_0 <= NOT Cycle(0) ;
   rtlc_434_and_806 : and_7u_7u port map ( a(6)=>not_Cycle_6, a(5)=>
      not_Cycle_5, a(4)=>not_Cycle_4, a(3)=>not_Cycle_3, a(2)=>not_Cycle_2, 
      a(1)=>not_Cycle_1, a(0)=>not_Cycle_0, d=>rtlcs4);
   rtlc_441_and_807 : and_7u_7u port map ( a(6)=>not_Cycle_6, a(5)=>
      not_Cycle_5, a(4)=>not_Cycle_4, a(3)=>not_Cycle_3, a(2)=>not_Cycle_2, 
      a(1)=>Cycle(1), a(0)=>not_Cycle_0, d=>rtlcs3);
   not_Address_9 <= NOT FE_Address(9) ;
   not_Address_8 <= NOT FE_Address(8) ;
   not_Address_7 <= NOT FE_Address(7) ;
   not_Address_6 <= NOT FE_Address(6) ;
   not_Address_5 <= NOT FE_Address(5) ;
   mode_word_and_3i1 : and_5u_5u port map ( a(4)=>not_Address_9, a(3)=>
      not_Address_8, a(2)=>not_Address_7, a(1)=>not_Address_6, a(0)=>
      not_Address_5, d=>mode_word_3n0s2);
   not_Address_3 <= NOT FE_Address(3) ;
   not_Address_2 <= NOT FE_Address(2) ;
   rtlc_456_and_810 : and_5u_5u port map ( a(4)=>mode_word, a(3)=>
      FE_Address(4), a(2)=>not_Address_3, a(1)=>not_Address_2, a(0)=>
      FE_Address(1), d=>rtlcs10);
   Clock_enable <= CE ;
   rtlcn163 <= illegal_command OR rtlcn23 ;
   rtlc_486_or_811 : or_7u_7u port map ( a(6)=>Reset_Count_Down(0), a(5)=>
      Reset_Count_Down(1), a(4)=>Reset_Count_Down(2), a(3)=>
      Reset_Count_Down(3), a(2)=>Reset_Count_Down(4), a(1)=>
      Reset_Count_Down(5), a(0)=>Reset_Count_Down(6), d=>rtlc20n149);
   modgen_counter_Cycle : counter_dn_sload_sclear_aclear_clock_clk_en_0_7
       port map ( clock=>Clock, q(6)=>Cycle(6), q(5)=>Cycle(5), q(4)=>
      Cycle(4), q(3)=>Cycle(3), q(2)=>Cycle(2), q(1)=>Cycle(1), q(0)=>
      Cycle(0), clk_en=>CE, aclear=>not_ResetN, sload=>rtlcs4, data(6)=>PWR, 
      data(5)=>GND, data(4)=>GND, data(3)=>GND, data(2)=>GND, data(1)=>GND, 
      data(0)=>PWR, aset=>GND, sclear=>rtlc8_X_0_n250, updn=>GND, cnt_en=>
      PWR);
   modgen_counter_Reset_Count_Down : 
      counter_dn_cnt_en_sload_sclear_aclear_clock_clk_en_0_7 port map ( 
      clock=>Clock, q(6)=>Reset_Count_Down(6), q(5)=>Reset_Count_Down(5), 
      q(4)=>Reset_Count_Down(4), q(3)=>Reset_Count_Down(3), q(2)=>
      Reset_Count_Down(2), q(1)=>Reset_Count_Down(1), q(0)=>
      Reset_Count_Down(0), clk_en=>CE, aclear=>not_CPU_ResetN_D, sload=>
      rtlc20n47, data(6)=>PWR, data(5)=>PWR, data(4)=>PWR, data(3)=>PWR, 
      data(2)=>PWR, data(1)=>PWR, data(0)=>PWR, aset=>GND, sclear=>
      rtlc20n123, updn=>GND, cnt_en=>rtlc20n149);
   DFFPC (CPU_ResetN,GND,GND,Clock,CPU_ResetN_D) ;
   DFFRSE (rtlcn164,GND,not_CPU_ResetN,PWR,Clock,ResetN_EXMPLR1186) ;
   DFFPCE (not_rtlcs3,GND,not_ResetN,rtlc8n295,Clock,Read_EXMPLR1151) ;
   DFFPCE (rtlcn28,GND,not_ResetN,CE,Clock,Write_Ack) ;
   DFFPCE (rtlcn36,GND,not_ResetN,CE,Clock,read_Ack) ;
   DFFPCE (not_rtlcs3,GND,not_ResetN,rtlc8n294,Clock,Write_EXMPLR1187) ;
   DFFPCE (read_Data_11n3ss1(15),GND,not_ResetN,CE,Clock,read_Data(15)) ;
   DFFPCE (read_Data_11n3ss1(14),GND,not_ResetN,CE,Clock,read_Data(14)) ;
   DFFPCE (read_Data_11n3ss1(13),GND,not_ResetN,CE,Clock,read_Data(13)) ;
   DFFPCE (read_Data_11n3ss1(12),GND,not_ResetN,CE,Clock,read_Data(12)) ;
   DFFPCE (read_Data_11n3ss1(11),GND,not_ResetN,CE,Clock,read_Data(11)) ;
   DFFPCE (read_Data_11n3ss1(10),GND,not_ResetN,CE,Clock,read_Data(10)) ;
   DFFPCE (read_Data_11n3ss1(9),GND,not_ResetN,CE,Clock,read_Data(9)) ;
   DFFPCE (read_Data_11n3ss1(8),GND,not_ResetN,CE,Clock,read_Data(8)) ;
   DFFPCE (read_Data_11n3ss1(7),GND,not_ResetN,CE,Clock,read_Data(7)) ;
   DFFPCE (read_Data_11n3ss1(6),GND,not_ResetN,CE,Clock,read_Data(6)) ;
   DFFPCE (read_Data_11n3ss1(5),GND,not_ResetN,CE,Clock,read_Data(5)) ;
   DFFPCE (read_Data_11n3ss1(4),GND,not_ResetN,CE,Clock,read_Data(4)) ;
   DFFPCE (read_Data_11n3ss1(3),GND,not_ResetN,CE,Clock,read_Data(3)) ;
   DFFPCE (read_Data_11n3ss1(2),GND,not_ResetN,CE,Clock,read_Data(2)) ;
   DFFPCE (read_Data_11n3ss1(1),GND,not_ResetN,CE,Clock,read_Data(1)) ;
   DFFPCE (read_Data_11n3ss1(0),GND,not_ResetN,CE,Clock,read_Data(0)) ;
   DFFPCE (Active_command(15),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(15)) ;
   DFFPCE (Active_command(14),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(14)) ;
   DFFPCE (Active_command(13),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(13)) ;
   DFFPCE (Active_command(12),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(12)) ;
   DFFPCE (Active_command(11),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(11)) ;
   DFFPCE (Active_command(10),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(10)) ;
   DFFPCE (Active_command(9),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(9)) ;
   DFFPCE (Active_command(8),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(8)) ;
   DFFPCE (Active_command(7),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(7)) ;
   DFFPCE (Active_command(6),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(6)) ;
   DFFPCE (Active_command(5),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(5)) ;
   DFFPCE (Active_command(4),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(4)) ;
   DFFPCE (Active_command(3),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(3)) ;
   DFFPCE (Active_command(2),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(2)) ;
   DFFPCE (Active_command(1),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(1)) ;
   DFFPCE (Active_command(0),GND,not_CPU_ResetN,rtlc14n57,Clock,
   Last_command_EXMPLR1195(0)) ;
   DFFPCE (rtlc17_Channel_status_D_n4_10,GND,not_ResetN,CE,Clock,
   Channel_status(10)) ;
   DFFPCE (Host_Status_Bits(9),GND,not_ResetN,CE,Clock,Channel_status(9)) ;
   DFFPCE (Host_Status_Bits(8),GND,not_ResetN,CE,Clock,Channel_status(8)) ;
   DFFPCE (Host_Status_Bits(7),GND,not_ResetN,CE,Clock,Channel_status(7)) ;
   DFFPCE (Host_Status_Bits(6),GND,not_ResetN,CE,Clock,Channel_status(6)) ;
   DFFPCE (Host_Status_Bits(5),GND,not_ResetN,CE,Clock,Channel_status(5)) ;
   DFFPCE (rtlc17_Channel_status_D_n4_4,GND,not_ResetN,CE,Clock,
   Channel_status(4)) ;
   DFFPCE (Host_Status_Bits(3),GND,not_ResetN,rtlc17n68,Clock,
   Channel_status(3)) ;
   DFFPCE (Host_Status_Bits(2),GND,not_ResetN,CE,Clock,Channel_status(2)) ;
   DFFPCE (Host_Status_Bits(1),GND,not_ResetN,CE,Clock,Channel_status(1)) ;
   DFFPCE (rtlc17_Channel_status_D_n4_0,GND,not_ResetN,CE,Clock,
   Channel_status(0)) ;
   DFFPCE (rtlc23n35,GND,not_ResetN,rtlc23n68,Clock,Message_ended_OK_level)
    ;
   DFFPC (rtlcn163,not_CPU_ResetN_D,GND,Clock,rtlcn164) ;
   rtlc8_61_and_798_nx0 <= not_Read_req AND not_Write_Req ;
   rtlc8_X_0_n250 <= rtlc8_61_and_798_nx0 AND rtlcs4 ;
   rtlc_238_or_799_nx0 <= rtlc20n47 OR not_CE ;
   rtlcn23 <= rtlc_238_or_799_nx0 OR not_rtlcs6 ;
   rtlc_241_and_800_nx0 <= rtlcs3 AND not_Write ;
   rtlcn36 <= rtlc_241_and_800_nx0 AND Read_EXMPLR1151 ;
   rtlc_374_and_801_nx0 <= not_Write_Req AND rtlcs4 ;
   rtlcn108 <= rtlc_374_and_801_nx0 AND Read_req ;
   modgen_and_0 : and_6u_6u port map ( a(5)=>FE_Address(9), a(4)=>
      FE_Address(8), a(3)=>FE_Address(7), a(2)=>FE_Address(6), a(1)=>
      FE_Address(5), a(0)=>not_MODE_CODE1553A, d=>mode_word_3n0s3);
end Sital_Ofer_Hofman_no_reset_unfold_4194 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Dual_channel_stm_ver8_4_1 is 
   port (
      C : IN std_logic ;
      R : IN std_logic ;
      CE : IN std_logic ;
      Hila : IN std_logic ;
      RT_Address_valid_A : IN std_logic ;
      RT_Address_valid_B : IN std_logic ;
      Rcv_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      Rcv_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      Rcv_A_Sync_error : IN std_logic ;
      Rcv_A_Manchester_error : IN std_logic ;
      Rcv_A_Parity_error : IN std_logic ;
      Rcv_A_echo_back_bus : IN std_logic ;
      Rcv_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      Rcv_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      Rcv_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      Rcv_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      Rcv_A_RxRDY_plus_12us : IN std_logic ;
      Rcv_A_RxRDY_plus_10us : IN std_logic ;
      Rcv_A_CS : IN std_logic ;
      Rcv_A_Pre_EchoRdy : IN std_logic ;
      Rcv_A_Command_Sync : IN std_logic ;
      Rcv_A_Pre_RxRdy : IN std_logic ;
      Rcv_A_recieving : IN std_logic ;
      Rcv_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      Rcv_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      Rcv_B_Sync_error : IN std_logic ;
      Rcv_B_Manchester_error : IN std_logic ;
      Rcv_B_Parity_error : IN std_logic ;
      Rcv_B_echo_back_bus : IN std_logic ;
      Rcv_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      Rcv_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      Rcv_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      Rcv_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      Rcv_B_RxRDY_plus_12us : IN std_logic ;
      Rcv_B_RxRDY_plus_10us : IN std_logic ;
      Rcv_B_CS : IN std_logic ;
      Rcv_B_Pre_EchoRdy : IN std_logic ;
      Rcv_B_Command_Sync : IN std_logic ;
      Rcv_B_Pre_RxRdy : IN std_logic ;
      Rcv_B_recieving : IN std_logic ;
      No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
      TxRdy : IN std_logic ;
      Active_Bus_A : OUT std_logic ;
      Transmit_data : OUT std_logic_vector (15 DOWNTO 0) ;
      T_Sync : OUT std_logic ;
      Go : OUT std_logic ;
      end_of_tx : IN std_logic ;
      Bus_A_shut_down : OUT std_logic ;
      Bus_B_shut_down : OUT std_logic ;
      Address : OUT std_logic_vector (15 DOWNTO 0) ;
      reset_remote_terminal_received : OUT std_logic ;
      Inhibit_TF : OUT std_logic ;
      active_command : OUT std_logic_vector (15 DOWNTO 0) ;
      illegal_command : IN std_logic ;
      Do_illegal : IN std_logic ;
      Active_command_updated : OUT std_logic ;
      Message_ended_OK : OUT std_logic ;
      Message_ended_not_OK : OUT std_logic ;
      Valid_command : OUT std_logic ;
      Write_Req : OUT std_logic ;
      Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      Write_Ack : IN std_logic ;
      read_Req : OUT std_logic ;
      read_Data : IN std_logic_vector (15 DOWNTO 0) ;
      read_Ack : IN std_logic ;
      Channel_status_out : OUT std_logic_vector (10 DOWNTO 0) ;
      Channel_status : IN std_logic_vector (10 DOWNTO 0) ;
      RT2RT_message : OUT std_logic ;
      NO_BCST : IN std_logic ;
      MODE_CODE1553A : IN std_logic) ;
end Dual_channel_stm_ver8_4_1 ;

architecture SITAL_Technology_unfold_4468 of Dual_channel_stm_ver8_4_1 is 
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component mux_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component eq_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal Active_Bus_A_EXMPLR1205, Bus_A_shut_down_EXMPLR1225, 
      Bus_B_shut_down_EXMPLR1226: std_logic ;
   
   signal active_command_EXMPLR1380: std_logic_vector (15 DOWNTO 0) ;
   
   signal Valid_command_EXMPLR1261, Write_Req_EXMPLR1262, 
      Write_Data_10_EXMPLR1268, Write_Data_4_EXMPLR1274, 
      Write_Data_3_EXMPLR1275, Write_Data_2_EXMPLR1276, 
      Write_Data_1_EXMPLR1277, Write_Data_0_EXMPLR1278, read_Req_EXMPLR1280, 
      Channel_status_out_3_EXMPLR1300, int_Go: std_logic ;
   
   signal T_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal RxRdy, Rcv_CS, Rcv_CS_continous, mode_command, BCR, Rcv_recieving, 
      RT_Address_valid, Finished_message_OK, Message_ended_not_OK_pre, 
      Message_ended_not_OK_pre_D: std_logic ;
   
   signal Mode_req: std_logic_vector (6 DOWNTO 0) ;
   
   signal tx_state: std_logic_vector (1 DOWNTO 0) ;
   
   signal rcv_state: std_logic_vector (4 DOWNTO 0) ;
   
   signal PWR, Go_0n0s4, not_Active_Bus_A, Go_0n0s5, Go_0n0s3, not_Go_0n0s3, 
      not_Valid_command, Go_0n0s8, Go_0n0s10, Go_0n0s7, 
      Channel_status_out_5_EXMPLR1314, not_R: std_logic ;
   
   signal active_command_6n13ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Rcv_CS_6n13ss1, mode_command_6n13ss1, BCR_6n13ss1: std_logic ;
   
   signal active_command_6n14ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Rcv_CS_6n14ss1, Active_Bus_A_6n14ss1, mode_command_6n14ss1, 
      BCR_6n14ss1, rtlc6n476, mode_command_6n1s3, not_MODE_CODE1553A, 
      mode_command_6n1s2, mode_command_6n1s5, mode_command_6n1s1, BCR_6n1s2, 
      not_rtlc6n476, not_Rcv_A_CS, rtlc6n566, mode_command_6n5s3, 
      mode_command_6n5s2, mode_command_6n5s5, mode_command_6n5s1, BCR_6n5s2, 
      not_rtlc6n566, not_Rcv_B_CS, rtlc6n648, rtlc6n657, rtlc6n658, 
      not_rtlcn145, rtlc6n705, rtlc6n714, rtlc6n715, not_rtlc6n658, 
      rtlc6n731, rtlc6n740, rtlc6n741, not_rtlcn144, rtlc6n788, rtlc6n797, 
      rtlc6n798, not_rtlc6n741, rtlc6n822, rtlc6n832, rtlc6n846, rtlc6n848, 
      rtlc6n849, rtlc6n896, rtlc6n901: std_logic ;
   
   signal ri: std_logic_vector (5 DOWNTO 0) ;
   
   signal ti: std_logic_vector (5 DOWNTO 0) ;
   
   signal ri_9n16ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal Mode_req_9n17ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal ti_9n33ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal Address_9n36ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Mode_req_9n36ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal not_rtlcn1907, Message_ended_not_OK_9n45ss1, not_Do_illegal, 
      not_Channel_status_3, not_active_command_10, rtlc9n1359, rtlc9n1373, 
      rtlc9n1375, rtlc9_PS26_n1419, not_Rcv_Gap_found_0, not_Rcv_Gap_found_1, 
      not_Rcv_Gap_found_2, not_illegal_command, not_rtlc9n1825: std_logic ;
   
   signal ri_9n8s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_rtlc9n2220, not_Message_ended_not_OK_pre, not_Rcv_Command_Sync, 
      rtlc9n1457, rtlc9n1461, rtlc9n1487, rtlc9n1488, not_rtlc9n1461, 
      not_RT_Address_valid, rtlc9n1510, rtlc9n1511, rtlc9n1517, 
      not_Write_Data_4, rtlc9n1541, rtlc9n1583, rtlc9n1585, rtlc9n1588, 
      rtlc9n1590, rtlc9n1596, rtlc9n1597, rtlc9n1598, rtlc9n1599, rtlc9n1600, 
      rtlc9n1602, rtlc9n1609, not_rtlcs42, rtlc9n1628, not_rtlc9n1628, 
      not_rtlc9n1609, rtlc9n1643, rtlc9n1644, rtlc9n1646, rtlc9n1649, 
      rtlc9n1651, rtlc9n1652, rtlc9n1653, rtlc9n1654, rtlc9n1655, rtlc9n1656, 
      rtlc9n1660, rtlc9n1677, not_rtlc9n1660, rtlc9n1696, rtlc9n1698, 
      rtlc9n1704, not_rtlcs35, rtlc9n1712, not_rtlcs29, rtlc9n1720, 
      not_rtlc9n1720, not_read_Req, rtlc9n1736, rtlc9_PS116_n1741: std_logic
    ;
   
   signal rtlc9n1755: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc9n1768, rtlc9n1769, not_rtlc9n1769, rtlc9n1782, rtlc9n1783, 
      not_BCR, rtlc9n1808, rtlc9n1812, rtlc9n1813, rtlc9n1814, rtlc9n1815, 
      rtlc9n1821, rtlc9n1825, not_active_command_4, rtlc9n1832, rtlc9n1833, 
      not_rtlc9n1833, rtlc9n1841, rtlc9n1843, rtlc9n1845, rtlc9n1852, 
      rtlc9n1856, not_rtlc9n1856, rtlc9n1862, rtlc9n1869, rtlc9n1876, 
      rtlc9n1878, rtlc9n1880, rtlc9n1881, rtlc9n1883, rtlc9n1886, rtlc9n1887, 
      rtlc9n1888, rtlc9n1889, rtlc9n1890, rtlc9n1891, rtlc9n1892, rtlc9n1893, 
      rtlc9n1895, rtlc9n1897, rtlc9n1902, rtlc9n1918, rtlc9n1920, rtlc9n1923, 
      rtlc9n1924, rtlc9n1934, rtlc9n1935, rtlc9n1944, rtlc9n1946, rtlc9n1947, 
      not_rtlc9n1947, not_rcv_state_0, rtlc9n1966, rtlc9n1973, rtlc9n1974, 
      rtlc9n1981, rtlc9n1982, rtlc9n1989, rtlc9n1990, rtlc9n1991, 
      not_Message_ended_not_OK_pre_D, rtlc9n2008, rtlc9n2016, rtlc9n2209, 
      rtlc9n2220, rtlc9n2221, rtlc9n2243, rtlc9n2246, rtlc9n2247, rtlc9n2248, 
      rtlc9n2257, rtlc9n2273, rtlc9n2289, rtlc9n2290, rtlc9n2291, rtlc9n2294, 
      rtlc9n2296, rtlc9n2302, rtlc9n2308, rtlc9n2315, rtlc9n2316, rtlc9n2318, 
      rtlc9n2323, rtlc9n2327, not_rtlc9n2327, not_rtlc9_PS26_n1419, 
      rtlc9n2494, rtlc9n2495, rtlc9n2496, rtlc9n2497, rtlc9n2498, rtlc9n2499, 
      rtlc9n2513, rtlc9n2514, rtlc9n2515, rtlc9n2516, rtlc9n2517, rtlc9n2530, 
      rtlc9n2534, rtlc9n2535, rtlc12n107, rtlc12n109, rtlc12n111, rtlc12n228, 
      rtlc12n229, rtlc12n230, rtlc12n231, rtlc12n238, rtlcn144, rtlcn145, 
      rtlcn146, rtlcn191, rtlcn192, rtlcn193, rtlcn196, rtlcn197, rtlcn198, 
      rtlcn201, rtlcn268, rtlcn333, rtlcn392, rtlcn513, rtlcn519, rtlcn551, 
      rtlcn621, not_rtlcn1677, rtlcn635, rtlcn636, rtlcn637, rtlcn644, 
      rtlcn652, rtlcn702, rtlcn777, rtlcn778, rtlcn784, rtlcn894, rtlcn934, 
      not_rtlcn1681, rtlcn967, rtlcn972, rtlcn1053, not_rtlcn1477, rtlcn1059, 
      rtlcn1060, not_rtlcn1676, rtlcn1340, rtlcn1354, rtlcn1359, rtlcn1370, 
      rtlcn1376, rtlcn1388, rtlcn1391, rtlcn1392, rtlcn1393, rtlcn1400, 
      rtlcn1404, rtlcn1474, rtlcn1475, rtlcn1476, rtlcn1477, rtlcn1478, 
      rtlcn1479, rtlcn1480, rtlcn1481, rtlcn1483, rtlcn1484, rtlcn1485, 
      rtlcn1486, rtlcn1487, rtlcn1488, rtlcn1489, rtlcn1490, rtlcn1491, 
      rtlcn1492, rtlcn1493, rtlcn1495, rtlcn1496, rtlcn1497, rtlcn1500, 
      rtlcn1501, rtlcn1502, rtlcn1503, rtlcn1504, rtlcn1505, rtlcn1506, 
      rtlcn1507, rtlcn1508, rtlcn1509, rtlcn1510, rtlcn1511, rtlcn1513, 
      rtlcn1514, rtlcn1515, rtlcn1517, rtlcn1518, rtlcn1520, rtlcn1521, 
      rtlcn1522, rtlcn1523, not_rtlc9n1736, not_rtlc9n1696, not_tx_state_1, 
      rtlcn1527, not_rtlcn635, rtlcn1529, not_mode_command, rtlcn1533, 
      rtlcn1534, not_rtlc9n1698, not_rtlcn1485, rtlcn1539, not_RxRdy, 
      not_rtlc9n1488, rtlcn1543, not_rtlcs32, rtlcn1545, not_rtlc9n1359, 
      not_rtlcn1480, not_rtlc9n1541, rtlcn1550, rtlcn1552, rtlcn1553, 
      rtlcn1556, rtlcn1557, rtlcn1558, rtlcn1559, not_rtlcn1508, rtlcn1561, 
      not_rtlcn1479, rtlcn1565, not_rtlcn1488, not_rtlcn1481, rtlcn1568, 
      not_rtlc9n1517, rtlcn1571, rtlcn1573, rtlcn1574, not_rtlcn1474, 
      rtlcn1576, rtlcn1577, not_rtlcn1678, not_rtlcn1679, rtlcn1582, 
      rtlcn1584, rtlcn1586, not_rtlc9n2221, not_rtlcn1680, rtlcn1593, 
      rtlcn1594, not_rtlc9n1596, rtlcn1598, rtlcn1599, rtlcn1600, rtlcn1601, 
      rtlcn1602, rtlcn1603, not_rtlcn1478, rtlcn1608, rtlcn1610, rtlcn1611, 
      rtlcn1612, rtlcn1613, rtlcn1614, not_rtlcs19, rtlcn1617, not_rtlcs20, 
      rtlcn1619, rtlcn1620, rtlcn1621, rtlcn1622, rtlcn1623, not_rtlcn1486, 
      rtlcn1625, rtlcn1627, rtlcn1628, not_rtlcn1475, rtlcn1630, 
      not_rtlcn1682, rtlcn1634, rtlcn1635, not_rtlcn1476, rtlcn1637, 
      rtlcn1638, rtlcn1640, rtlcn1641, not_rtlc9n1902, rtlcn1643, 
      not_rtlcn268, rtlcn1676, rtlcn1677, rtlcn1678, rtlcn1679, rtlcn1680, 
      rtlcn1682, rtlcn1683, rtlcn1684, rtlcn1685, rtlcn1686, rtlcn1687, 
      rtlcn1688, rtlcn1689, rtlcn1690, rtlcn1691, rtlcn1692, rtlcn1693, 
      rtlcn1694, rtlcn1695, not_rtlc6n848, not_rtlc6n849, not_rtlc9n1889, 
      not_rtlc9n1890, rtlcn1700, rtlcn1702, rtlcn1703, not_rtlc9n1897, 
      not_rtlc9n1585, not_rtlc9n1895, rtlcn1709, rtlcn1710, not_tx_state_0, 
      rtlcn1713, not_rtlc9n1893, not_rtlc9n1892, not_rtlc9n1891, 
      not_rtlc9n1600, not_rtlc9n1888, not_rtlc9n1887, not_rtlc9n1886, 
      rtlcn1722, not_rtlcn201, rtlcn1726, rtlcn1727, rtlcn1728, rtlcs1, 
      rtlcs2, rtlcs6, rtlcs7, rtlcs8, rtlcs10, rtlcs11, rtlcs15, rtlcs16, 
      rtlcs17, rtlcs19, rtlcs20, rtlcs21, rtlcs23, rtlcs24, rtlcs25, rtlcs27, 
      rtlcs29, rtlcs30, rtlcs31, rtlcs32, rtlcs33, rtlcs34, rtlcs35, rtlcs36, 
      rtlcs37, not_active_command_0, rtlcs41, rtlcs42, rtlcs43, rtlcs44, 
      rtlcs48, rtlcs50, rtlcs51, rtlcs53, rtlcs54, rtlcs56, rtlcs57, rtlcs58, 
      rtlcs60, rtlcs61, not_Rcv_B_Pre_RxRdy, not_Rcv_A_Pre_RxRdy, 
      not_Rcv_B_R_Data_9, not_Rcv_B_R_Data_8, not_Rcv_B_R_Data_7, 
      not_Rcv_B_R_Data_6, not_Rcv_B_R_Data_5, not_Rcv_A_R_Data_9, 
      not_Rcv_A_R_Data_8, not_Rcv_A_R_Data_7, not_Rcv_A_R_Data_6, 
      not_Rcv_A_R_Data_5, not_ri_9n8s1_5, not_ri_9n8s1_4, not_ri_9n8s1_3, 
      not_ri_9n8s1_2, not_ri_9n8s1_1, not_ri_9n8s1_0, not_active_command_1, 
      not_active_command_3, not_active_command_2, not_rtlc9n1755_5, 
      not_rtlc9n1755_4, not_rtlc9n1755_3, not_rtlc9n1755_2, not_rtlc9n1755_1, 
      not_rtlc9n1755_0, not_Write_Data_3, not_Write_Data_2, not_Write_Data_0, 
      not_Mode_req_1, not_Mode_req_5, not_Mode_req_3, not_Mode_req_4, 
      not_Mode_req_2, not_Mode_req_0, not_Rcv_B_R_Data_3, not_Rcv_B_R_Data_2, 
      not_Rcv_B_R_Data_0, not_Rcv_A_R_Data_3, not_Rcv_A_R_Data_2, 
      not_Rcv_A_R_Data_0, not_No_Response_timeout_2, 
      not_No_Response_timeout_1, not_No_Response_timeout_0, rtlcn1907, 
      rtlcs62, rtlcs63: std_logic ;
   
   signal Rcv_RAW_GAP: std_logic_vector (6 DOWNTO 0) ;
   
   signal Rcv_Gap_found: std_logic_vector (2 DOWNTO 0) ;
   
   signal Rcv_RxRDY_plus_10us, rtlc_Rcv_CS_n2260, Rcv_Command_Sync, 
      rtlc_Rcv_recieving_n2261, nx239, rtlc9_1006_gt_816_nx0, 
      rtlc9_1006_gt_816_nx2, rtlc9_1006_gt_816_nx4, rtlc_1981_or_851_nx0, 
      rtlc_2196_and_852_nx0, rtlc_2198_and_853_nx0, rtlc_2199_or_854_nx0, 
      rtlc_2210_or_855_nx0, rtlc_2223_and_857_nx0, rtlc_2248_and_859_nx0, 
      rtlc_2256_and_860_nx0, rtlc_2260_and_861_nx0, rtlc_2273_and_862_nx0, 
      rtlc_2301_or_868_nx0, rtlc_2315_and_869_nx0, rtlc_2316_or_870_nx0, 
      rtlc_2332_or_872_nx0, rtlc_2346_or_873_nx0, rtlc_2537_or_874_nx0, 
      rtlc_2540_or_875_nx0, rtlc_2715_or_877_nx0, rtlc_2733_or_879_nx0, 
      rtlc_2797_and_886_nx0, rtlcs38, rtlc_2897_and_892_nx0, 
      rtlc_2938_and_896_nx0, rtlc_2941_and_897_nx0, rtlc_2946_and_900_nx0, 
      nx10, nx19, nx23: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   Active_Bus_A <= Active_Bus_A_EXMPLR1205 ;
   Bus_A_shut_down <= Bus_A_shut_down_EXMPLR1225 ;
   Bus_B_shut_down <= Bus_B_shut_down_EXMPLR1226 ;
   Address(15) <= Channel_status_out_5_EXMPLR1314 ;
   Address(14) <= Channel_status_out_5_EXMPLR1314 ;
   Address(13) <= Channel_status_out_5_EXMPLR1314 ;
   Address(12) <= Channel_status_out_5_EXMPLR1314 ;
   Address(11) <= Channel_status_out_5_EXMPLR1314 ;
   active_command(15) <= active_command_EXMPLR1380(15) ;
   active_command(14) <= active_command_EXMPLR1380(14) ;
   active_command(13) <= active_command_EXMPLR1380(13) ;
   active_command(12) <= active_command_EXMPLR1380(12) ;
   active_command(11) <= active_command_EXMPLR1380(11) ;
   active_command(10) <= active_command_EXMPLR1380(10) ;
   active_command(9) <= active_command_EXMPLR1380(9) ;
   active_command(8) <= active_command_EXMPLR1380(8) ;
   active_command(7) <= active_command_EXMPLR1380(7) ;
   active_command(6) <= active_command_EXMPLR1380(6) ;
   active_command(5) <= active_command_EXMPLR1380(5) ;
   active_command(4) <= active_command_EXMPLR1380(4) ;
   active_command(3) <= active_command_EXMPLR1380(3) ;
   active_command(2) <= active_command_EXMPLR1380(2) ;
   active_command(1) <= active_command_EXMPLR1380(1) ;
   active_command(0) <= active_command_EXMPLR1380(0) ;
   Valid_command <= Valid_command_EXMPLR1261 ;
   Write_Req <= Write_Req_EXMPLR1262 ;
   Write_Data(10) <= Write_Data_10_EXMPLR1268 ;
   Write_Data(4) <= Write_Data_4_EXMPLR1274 ;
   Write_Data(3) <= Write_Data_3_EXMPLR1275 ;
   Write_Data(2) <= Write_Data_2_EXMPLR1276 ;
   Write_Data(1) <= Write_Data_1_EXMPLR1277 ;
   Write_Data(0) <= Write_Data_0_EXMPLR1278 ;
   read_Req <= read_Req_EXMPLR1280 ;
   Channel_status_out(9) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(8) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(7) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(6) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(5) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(3) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(2) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(1) <= Channel_status_out_5_EXMPLR1314 ;
   Channel_status_out(0) <= Channel_status_out_5_EXMPLR1314 ;
   PWR <= '1' ;
   Channel_status_out_5_EXMPLR1314 <= '0' ;
   Go <= not_Go_0n0s3 AND Go_0n0s7 ;
   not_Go_0n0s3 <= NOT Go_0n0s3 ;
   Go_0n0s3 <= Go_0n0s4 OR Go_0n0s5 ;
   Go_0n0s4 <= Bus_A_shut_down_EXMPLR1225 AND Active_Bus_A_EXMPLR1205 ;
   Go_0n0s5 <= Bus_B_shut_down_EXMPLR1226 AND not_Active_Bus_A ;
   Go_0n0s7 <= Go_0n0s8 OR Go_0n0s10 ;
   Go_0n0s8 <= int_Go AND not_Valid_command ;
   Go_and_0i1 : and_4u_4u port map ( a(3)=>read_Ack, a(2)=>
      read_Req_EXMPLR1280, a(1)=>TxRdy, a(0)=>not_Valid_command, d=>
      Go_0n0s10);
   mode_command_6n1s1 <= mode_command_6n1s2 OR mode_command_6n1s5 ;
   mode_command_6n1s2 <= mode_command_6n1s3 AND not_MODE_CODE1553A ;
   not_MODE_CODE1553A <= NOT MODE_CODE1553A ;
   mode_command_6n5s1 <= mode_command_6n5s2 OR mode_command_6n5s5 ;
   mode_command_6n5s2 <= mode_command_6n5s3 AND not_MODE_CODE1553A ;
   rtlc6n832 <= not_Rcv_B_CS OR not_rtlc6n566 ;
   rtlc6n822 <= not_Rcv_A_CS OR not_rtlc6n476 ;
   rtlc6n788 <= not_rtlcn144 OR rtlcs7 ;
   rtlc6n797 <= rtlc6n788 OR rtlcs2 ;
   rtlc6n798 <= rtlc6n797 OR MODE_CODE1553A ;
   rtlc6n740 <= RT_Address_valid_A OR BCR_6n1s2 ;
   rtlc6n731 <= Rcv_A_CS AND Rcv_A_Command_Sync ;
   rtlc6n741 <= rtlc6n731 AND rtlc6n740 ;
   rtlc6n705 <= not_rtlcn145 OR rtlcs16 ;
   rtlc6n714 <= rtlc6n705 OR rtlcs11 ;
   rtlc6n715 <= rtlc6n714 OR MODE_CODE1553A ;
   rtlc6n657 <= RT_Address_valid_B OR BCR_6n5s2 ;
   rtlc6n648 <= Rcv_B_CS AND Rcv_B_Command_Sync ;
   rtlc6n658 <= rtlc6n648 AND rtlc6n657 ;
   not_Rcv_B_CS <= NOT Rcv_B_CS ;
   rtlc6n566 <= Rcv_B_Command_Sync AND rtlc6n657 ;
   not_Rcv_A_CS <= NOT Rcv_A_CS ;
   rtlc6n476 <= Rcv_A_Command_Sync AND rtlc6n740 ;
   not_rtlcs42 <= NOT rtlcs42 ;
   not_illegal_command <= NOT illegal_command ;
   rtlc9n2221 <= not_rtlc9n2220 OR rtlc9_PS26_n1419 ;
   not_Message_ended_not_OK_pre <= NOT Message_ended_not_OK_pre ;
   rtlc9n2243 <= rcv_state(0) OR rcv_state(3) ;
   rtlc9n1646 <= rtlc9n1643 AND rtlc9n1698 ;
   rtlc9n1643 <= rtlc9n1596 AND not_rtlc9n1628 ;
   rtlc9n1808 <= rtlc9n1782 AND not_BCR ;
   rtlc9n1782 <= rtlc9n1651 AND rtlc9n1677 ;
   rtlc9n1588 <= rtlc9n1583 AND not_rtlc9n1359 ;
   rtlc9_428_select_814 : select_4_4 port map ( a(3)=>rtlc9n2243, a(2)=>
      rcv_state(1), a(1)=>rcv_state(2), a(0)=>rcv_state(4), b(3)=>PWR, b(2)
      =>rtlc9n2220, b(1)=>rtlc9n1461, b(0)=>rtlc9n1517, d=>rtlc9n1583);
   rtlc9n1644 <= rtlc9n1597 AND rtlc9n1628 ;
   rtlc9n1783 <= rtlc9n1652 AND rtlc9n1677 ;
   rtlc9n1821 <= rtlc9n1653 AND not_rtlc9n1720 ;
   rtlc9n1814 <= rtlc9n1654 AND not_rtlc9n1660 ;
   rtlc9n1654 <= rtlc9n1599 AND not_rtlc9n1609 ;
   rtlc9n1590 <= rtlc9n2243 AND not_rtlc9n1359 ;
   rtlc9n1815 <= rtlc9n1596 AND not_rtlc9n1660 ;
   rtlc9n1878 <= rtlc9n1869 AND not_rtlc9n1696 ;
   rtlc9_466_select_815 : select_3_3 port map ( a(2)=>not_rtlc9n2327, a(1)=>
      rcv_state(1), a(0)=>rcv_state(2), b(2)=>PWR, b(1)=>
      not_rtlc9_PS26_n1419, b(0)=>not_rtlc9n1461, d=>rtlc9n1585);
   rtlc9n2327 <= rcv_state(1) OR rcv_state(2) ;
   not_rtlc9n2327 <= NOT rtlc9n2327 ;
   rtlc9n1649 <= not_rtlc9n1628 AND rtlc9n1698 ;
   rtlc9n1843 <= rtlc9n1841 AND not_rtlc9n1825 ;
   rtlc9n1841 <= rtlc9n1656 AND not_rtlc9n1833 ;
   rtlc9n1862 <= rtlc9n1852 AND not_rtlc9n1856 ;
   rtlc9n1852 <= rtlc9n1656 AND not_rtlc9n1769 ;
   rtlc9n1656 <= not_rtlc9n1609 OR rtlc9n1649 ;
   rtlc9n1655 <= not_rtlc9n1609 OR rtlc9n1698 ;
   rtlc9n1599 <= not_RxRdy OR rtlc9n1590 ;
   rtlc9n1597 <= not_RxRdy OR rtlc9n1588 ;
   rtlc9n1596 <= not_RxRdy OR not_rtlc9n1359 ;
   rtlc9n2016 <= Finished_message_OK AND Valid_command_EXMPLR1261 ;
   rtlc9n2008 <= not_Message_ended_not_OK_pre_D AND Message_ended_not_OK_pre
    ;
   rtlc9n1981 <= rtlc9n2535 AND rtlcs23 ;
   rtlc9n1973 <= rtlc9n2517 AND rtlcs24 ;
   rtlc9n1966 <= rtlc9n2499 AND rtlcs25 ;
   rtlc9n1974 <= rtlc9n1966 OR rtlc9n1973 ;
   rtlc9n1982 <= rtlc9n1974 OR rtlc9n1981 ;
   rtlc9n1990 <= rtlc9n1982 OR rtlc9n1989 ;
   not_rcv_state_0 <= NOT rcv_state(0) ;
   rtlc9n1991 <= not_rcv_state_0 AND rtlc9n1990 ;
   rtlc9n1944 <= read_Req_EXMPLR1280 AND TxRdy ;
   rtlc9n1946 <= rtlc9n1944 AND read_Ack ;
   rtlc9n1947 <= rtlc9n1946 OR Valid_command_EXMPLR1261 ;
   rtlc9n1934 <= Write_Req_EXMPLR1262 AND Write_Ack ;
   rtlc9n1935 <= rtlc9n1934 OR Valid_command_EXMPLR1261 ;
   rtlc9n1918 <= end_of_tx OR BCR ;
   rtlc9n1920 <= rtlc9n1918 OR Go_0n0s4 ;
   rtlc9n1923 <= rtlc9n1920 OR Go_0n0s5 ;
   rtlc9n1924 <= Finished_message_OK AND rtlc9n1923 ;
   rtlc9n1902 <= Do_illegal AND illegal_command ;
   rtlc9n1856 <= mode_command AND active_command_EXMPLR1380(4) ;
   rtlc9n1832 <= not_active_command_4 OR MODE_CODE1553A ;
   rtlc9n1833 <= mode_command AND rtlc9n1832 ;
   rtlc9n1825 <= Channel_status_out_3_EXMPLR1300 OR illegal_command ;
   rtlc9n1769 <= rtlcs27 OR rtlc9n1768 ;
   rtlc9n1736 <= TxRdy AND not_read_Req ;
   not_rtlcs29 <= NOT rtlcs29 ;
   not_rtlcs35 <= NOT rtlcs35 ;
   rtlc9n1704 <= mode_command AND not_MODE_CODE1553A ;
   rtlc9n1712 <= rtlc9n1704 AND not_rtlcs35 ;
   rtlc9n1720 <= rtlc9n1712 AND not_rtlcs29 ;
   rtlc9n1698 <= Rcv_recieving AND Rcv_CS_continous ;
   rtlc9n1696 <= Rcv_RxRDY_plus_10us AND tx_state(0) ;
   rtlc9n1660 <= Valid_command_EXMPLR1261 AND active_command_EXMPLR1380(10)
    ;
   rtlc9n1628 <= BCR AND not_rtlcs42 ;
   rtlc9n1609 <= Rcv_RxRDY_plus_10us AND rcv_state(3) ;
   rtlc9n1541 <= not_Write_Data_4 OR MODE_CODE1553A ;
   rtlc9n2209 <= NOT nx239 ;
   not_RT_Address_valid <= NOT RT_Address_valid ;
   rtlc9n1510 <= Rcv_Command_Sync AND not_RT_Address_valid ;
   rtlc9n1511 <= rtlc9n1510 AND Rcv_CS ;
   rtlc9n1517 <= rtlc9n1511 AND rtlc9n2209 ;
   rtlc9n1488 <= rtlcs41 OR rtlc9n1487 ;
   not_Rcv_Command_Sync <= NOT Rcv_Command_Sync ;
   rtlc9n1457 <= not_Rcv_Command_Sync AND Rcv_CS ;
   rtlc9n1461 <= rtlc9n1457 AND rtlcs42 ;
   rtlc9_1054_and_817 : and_5u_5u port map ( a(4)=>Rcv_CS, a(3)=>
      not_Rcv_Gap_found_0, a(2)=>not_Rcv_Gap_found_1, a(1)=>
      not_Rcv_Gap_found_2, a(0)=>not_Rcv_Command_Sync, d=>rtlc9_PS26_n1419);
   rtlc9n1373 <= not_rcv_state_0 OR rtlcn146 ;
   rtlc9n1375 <= rtlc9n1373 AND not_Message_ended_not_OK_pre ;
   rtlc9n1359 <= Valid_command_EXMPLR1261 AND not_active_command_10 ;
   not_Channel_status_3 <= NOT Channel_status(3) ;
   not_Do_illegal <= NOT Do_illegal ;
   ri_inc6_9i1 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>ri(5), a(4)=>ri(4), 
      a(3)=>ri(3), a(2)=>ri(2), a(1)=>ri(1), a(0)=>ri(0), d(5)=>ri_9n8s1(5), 
      d(4)=>ri_9n8s1(4), d(3)=>ri_9n8s1(3), d(2)=>ri_9n8s1(2), d(1)=>
      ri_9n8s1(1), d(0)=>ri_9n8s1(0), cout=>DANGLING(0));
   rtlc9_1108_inc_819 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>ti(5), a(4)=>
      ti(4), a(3)=>ti(3), a(2)=>ti(2), a(1)=>ti(1), a(0)=>ti(0), d(5)=>
      rtlc9n1755(5), d(4)=>rtlc9n1755(4), d(3)=>rtlc9n1755(3), d(2)=>
      rtlc9n1755(2), d(1)=>rtlc9n1755(1), d(0)=>rtlc9n1755(0), cout=>
      DANGLING(1));
   not_Write_Data_4 <= NOT Write_Data_4_EXMPLR1274 ;
   not_active_command_10 <= NOT active_command_EXMPLR1380(10) ;
   not_Rcv_Gap_found_0 <= NOT Rcv_Gap_found(0) ;
   not_Rcv_Gap_found_1 <= NOT Rcv_Gap_found(1) ;
   not_Rcv_Gap_found_2 <= NOT Rcv_Gap_found(2) ;
   not_active_command_4 <= NOT active_command_EXMPLR1380(4) ;
   not_read_Req <= NOT read_Req_EXMPLR1280 ;
   not_Message_ended_not_OK_pre_D <= NOT Message_ended_not_OK_pre_D ;
   rtlc9n2496 <= Rcv_RAW_GAP(0) AND Rcv_RAW_GAP(1) ;
   rtlc9n2497 <= rtlc9n2495 OR rtlc9n2496 ;
   rtlc9n2498 <= Rcv_RAW_GAP(4) AND rtlc9n2497 ;
   rtlc9n2499 <= rtlc9n2498 OR rtlc9n2494 ;
   rtlc9n2513 <= Rcv_RAW_GAP(2) AND Rcv_RAW_GAP(1) ;
   rtlc9n2514 <= Rcv_RAW_GAP(0) AND rtlc9n2513 ;
   rtlc9n2515 <= Rcv_RAW_GAP(3) OR rtlc9n2514 ;
   rtlc9n2516 <= Rcv_RAW_GAP(4) AND rtlc9n2515 ;
   rtlc9n2517 <= rtlc9n2516 OR rtlc9n2494 ;
   rtlc9n2530 <= Rcv_RAW_GAP(5) AND Rcv_RAW_GAP(4) ;
   rtlc9n2534 <= rtlc9n2530 AND rtlc9n2497 ;
   rtlc9n2535 <= rtlc9n2534 OR Rcv_RAW_GAP(6) ;
   rtlc12n107 <= Do_illegal AND Mode_req(6) ;
   rtlc12n109 <= rtlc12n107 AND not_illegal_command ;
   rtlc12n111 <= rtlc12n109 AND not_MODE_CODE1553A ;
   not_rtlcn144 <= NOT rtlcn144 ;
   not_rtlcn145 <= NOT rtlcn145 ;
   rtlc9n2495 <= Rcv_RAW_GAP(3) OR Rcv_RAW_GAP(2) ;
   rtlc9n2494 <= Rcv_RAW_GAP(6) OR Rcv_RAW_GAP(5) ;
   rtlcn144 <= rtlcs6 OR rtlcs1 ;
   rtlcn145 <= rtlcs15 OR rtlcs10 ;
   rtlcn146 <= tx_state(0) OR tx_state(1) ;
   rtlc9n1845 <= rtlc9n1651 AND rtlcn191 ;
   rtlc9n1876 <= rtlc9n1652 AND rtlcn192 ;
   rtlc9n1813 <= rtlc9n1653 AND rtlcn193 ;
   rtlc9n1653 <= rtlc9n1598 AND rtlc9n1655 ;
   rtlc9n1598 <= not_Channel_status_3 AND rtlc9n1596 ;
   rtlc9n1880 <= rtlc9n1655 AND rtlcn196 ;
   active_command_mux_6i1Bus13_0 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(0), a(2)=>Rcv_B_R_Data(0), a(1)=>
      Rcv_A_R_Data(0), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(0));
   active_command_mux_6i1Bus13_1 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(1), a(2)=>Rcv_B_R_Data(1), a(1)=>
      Rcv_A_R_Data(1), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(1));
   active_command_mux_6i1Bus13_2 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(2), a(2)=>Rcv_B_R_Data(2), a(1)=>
      Rcv_A_R_Data(2), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(2));
   active_command_mux_6i1Bus13_3 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(3), a(2)=>Rcv_B_R_Data(3), a(1)=>
      Rcv_A_R_Data(3), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(3));
   active_command_mux_6i1Bus13_4 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(4), a(2)=>Rcv_B_R_Data(4), a(1)=>
      Channel_status_out_5_EXMPLR1314, a(0)=>Channel_status_out_5_EXMPLR1314, 
      b(3)=>Channel_status_out_5_EXMPLR1314, b(2)=>
      Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>active_command_6n14ss1(4));
   active_command_mux_6i1Bus13_5 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(5), a(2)=>Rcv_B_R_Data(5), a(1)=>
      Rcv_A_R_Data(5), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(5));
   active_command_mux_6i1Bus13_6 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(6), a(2)=>Rcv_B_R_Data(6), a(1)=>
      Rcv_A_R_Data(6), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(6));
   active_command_mux_6i1Bus13_7 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(7), a(2)=>Rcv_B_R_Data(7), a(1)=>
      Rcv_A_R_Data(7), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(7));
   active_command_mux_6i1Bus13_8 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(8), a(2)=>Rcv_B_R_Data(8), a(1)=>
      Rcv_A_R_Data(8), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(8));
   active_command_mux_6i1Bus13_9 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(9), a(2)=>Rcv_B_R_Data(9), a(1)=>
      Rcv_A_R_Data(9), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(9));
   active_command_mux_6i1Bus13_10 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(10), a(2)=>Rcv_B_R_Data(10), a(1)=>
      Rcv_A_R_Data(10), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(10));
   active_command_mux_6i1Bus13_11 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(11), a(2)=>Rcv_B_R_Data(11), a(1)=>
      Rcv_A_R_Data(11), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(11));
   active_command_mux_6i1Bus13_12 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(12), a(2)=>Rcv_B_R_Data(12), a(1)=>
      Rcv_A_R_Data(12), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(12));
   active_command_mux_6i1Bus13_13 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(13), a(2)=>Rcv_B_R_Data(13), a(1)=>
      Rcv_A_R_Data(13), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(13));
   active_command_mux_6i1Bus13_14 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(14), a(2)=>Rcv_B_R_Data(14), a(1)=>
      Rcv_A_R_Data(14), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(14));
   active_command_mux_6i1Bus13_15 : mux_4u_4u port map ( a(3)=>
      active_command_6n13ss1(15), a(2)=>Rcv_B_R_Data(15), a(1)=>
      Rcv_A_R_Data(15), a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>
      active_command_6n14ss1(15));
   Rcv_CS_mux_6i17 : mux_4u_4u port map ( a(3)=>Rcv_CS_6n13ss1, a(2)=>
      Rcv_B_CS, a(1)=>Rcv_A_CS, a(0)=>Channel_status_out_5_EXMPLR1314, b(3)
      =>Channel_status_out_5_EXMPLR1314, b(2)=>
      Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>Rcv_CS_6n14ss1);
   Active_Bus_A_mux_6i18 : mux_4u_4u port map ( a(3)=>not_Active_Bus_A, a(2)
      =>Channel_status_out_5_EXMPLR1314, a(1)=>PWR, a(0)=>
      Channel_status_out_5_EXMPLR1314, b(3)=>Channel_status_out_5_EXMPLR1314, 
      b(2)=>Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>Active_Bus_A_6n14ss1);
   mode_command_mux_6i19 : mux_4u_4u port map ( a(3)=>mode_command_6n13ss1, 
      a(2)=>mode_command_6n5s1, a(1)=>mode_command_6n1s1, a(0)=>
      Channel_status_out_5_EXMPLR1314, b(3)=>Channel_status_out_5_EXMPLR1314, 
      b(2)=>Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>mode_command_6n14ss1);
   BCR_mux_6i20 : mux_4u_4u port map ( a(3)=>BCR_6n13ss1, a(2)=>BCR_6n5s2, 
      a(1)=>BCR_6n1s2, a(0)=>Channel_status_out_5_EXMPLR1314, b(3)=>
      Channel_status_out_5_EXMPLR1314, b(2)=>Channel_status_out_5_EXMPLR1314, 
      b(1)=>Rcv_B_Pre_RxRdy, b(0)=>Rcv_A_Pre_RxRdy, d=>BCR_6n14ss1);
   rtlc_399_mux_840 : mux_4u_4u port map ( a(3)=>rtlc6n846, a(2)=>rtlc6n832, 
      a(1)=>rtlc6n822, a(0)=>PWR, b(3)=>Channel_status_out_5_EXMPLR1314, 
      b(2)=>Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>rtlc6n848);
   rtlc_400_mux_841 : mux_4u_4u port map ( a(3)=>
      Channel_status_out_5_EXMPLR1314, a(2)=>Active_Bus_A_EXMPLR1205, a(1)=>
      not_Active_Bus_A, a(0)=>PWR, b(3)=>Channel_status_out_5_EXMPLR1314, 
      b(2)=>Channel_status_out_5_EXMPLR1314, b(1)=>Rcv_B_Pre_RxRdy, b(0)=>
      Rcv_A_Pre_RxRdy, d=>rtlc6n849);
   not_rtlc9_PS26_n1419 <= NOT rtlc9_PS26_n1419 ;
   rtlc_826_select_842 : select_3_3 port map ( a(2)=>rtlc9n1696, a(1)=>
      rtlcn636, a(0)=>rtlcn637, b(2)=>rtlc9n1698, b(1)=>PWR, b(0)=>
      rtlc9_PS116_n1741, d=>rtlcn1726);
   Address_select_9i2Bus19_0 : select_3_3 port map ( a(2)=>rtlcn777, a(1)=>
      rtlcn778, a(0)=>not_rtlcn1676, b(2)=>active_command_EXMPLR1380(0), 
      b(1)=>ri(0), b(0)=>ti(0), d=>Address_9n36ss1(0));
   Address_select_9i2Bus19_1 : select_3_3 port map ( a(2)=>rtlcn777, a(1)=>
      rtlcn778, a(0)=>not_rtlcn1676, b(2)=>active_command_EXMPLR1380(1), 
      b(1)=>ri(1), b(0)=>ti(1), d=>Address_9n36ss1(1));
   Address_select_9i2Bus19_2 : select_3_3 port map ( a(2)=>rtlcn777, a(1)=>
      rtlcn778, a(0)=>not_rtlcn1676, b(2)=>active_command_EXMPLR1380(2), 
      b(1)=>ri(2), b(0)=>ti(2), d=>Address_9n36ss1(2));
   Address_select_9i2Bus19_3 : select_3_3 port map ( a(2)=>rtlcn777, a(1)=>
      rtlcn778, a(0)=>not_rtlcn1676, b(2)=>active_command_EXMPLR1380(3), 
      b(1)=>ri(3), b(0)=>ti(3), d=>Address_9n36ss1(3));
   Address_select_9i2Bus19_4 : select_3_3 port map ( a(2)=>rtlcn777, a(1)=>
      rtlcn778, a(0)=>not_rtlcn1676, b(2)=>active_command_EXMPLR1380(4), 
      b(1)=>ri(4), b(0)=>ti(4), d=>Address_9n36ss1(4));
   rtlc_1185_select_848 : select_3_3 port map ( a(2)=>rtlcn972, a(1)=>
      rtlcn967, a(0)=>not_rtlcn1677, b(2)=>rtlc9n1656, b(1)=>rtlc9n1843, 
      b(0)=>rtlc9n1862, d=>rtlc9n1883);
   rtlc_1276_select_849 : select_3_3 port map ( a(2)=>rtlcn1060, a(1)=>
      not_rtlcn1477, a(0)=>rtlcn1059, b(2)=>rtlc9n1651, b(1)=>rtlc9n1808, 
      b(0)=>rtlc9n1845, d=>rtlc9n1886);
   not_rtlc9n1609 <= NOT rtlc9n1609 ;
   not_rtlc9n1660 <= NOT rtlc9n1660 ;
   not_rtlc9n1769 <= NOT rtlc9n1769 ;
   not_rtlc9n1856 <= NOT rtlc9n1856 ;
   not_rtlc9n1833 <= NOT rtlc9n1833 ;
   not_rtlc9n1825 <= NOT rtlc9n1825 ;
   not_rtlc9n1720 <= NOT rtlc9n1720 ;
   not_rtlc6n658 <= NOT rtlc6n658 ;
   not_rtlc6n741 <= NOT rtlc6n741 ;
   not_rtlc6n476 <= NOT rtlc6n476 ;
   not_rtlc6n566 <= NOT rtlc6n566 ;
   not_rtlc9n1628 <= NOT rtlc9n1628 ;
   not_rtlc9n1461 <= NOT rtlc9n1461 ;
   not_rtlc9n2220 <= NOT rtlc9n2220 ;
   Message_ended_not_OK_select_9i7 : select_3_3 port map ( a(2)=>rtlcn1392, 
      a(1)=>rtlcn1393, a(0)=>rtlcn1391, b(2)=>PWR, b(1)=>
      not_Message_ended_not_OK_pre, b(0)=>Channel_status_out_5_EXMPLR1314, d
      =>Message_ended_not_OK_9n45ss1);
   rtlcn201 <= rtlcs56 OR rtlcs54 ;
   not_rtlc9n1736 <= NOT rtlc9n1736 ;
   not_rtlc9n1696 <= NOT rtlc9n1696 ;
   rtlcn636 <= not_rtlc9n1736 AND not_rtlc9n1696 ;
   rtlcn637 <= not_rtlc9n1696 AND rtlc9n1736 ;
   not_tx_state_1 <= NOT tx_state(1) ;
   rtlcn1484 <= not_rtlc9n1736 OR not_tx_state_1 ;
   rtlcn1485 <= rtlc9n1696 OR RxRdy ;
   rtlcn635 <= rtlcn1484 OR rtlcn1485 ;
   rtlcn1527 <= mode_command AND rtlcn635 ;
   not_rtlcn635 <= NOT rtlcn635 ;
   rtlcn1529 <= rtlc9n1856 AND not_rtlcn635 ;
   rtlcn777 <= rtlcn1527 OR rtlcn1529 ;
   not_mode_command <= NOT mode_command ;
   rtlcn778 <= not_mode_command AND rtlcn635 ;
   rtlcn1533 <= rtlc9n1696 AND rtlc9n1698 ;
   rtlcn1534 <= not_rtlc9n1696 AND rtlcn1484 ;
   rtlcn972 <= rtlcn1533 OR rtlcn1534 ;
   not_rtlc9n1698 <= NOT rtlc9n1698 ;
   rtlcn967 <= rtlc9n1696 AND not_rtlc9n1698 ;
   not_rtlcn1485 <= NOT rtlcn1485 ;
   rtlcn1539 <= RxRdy AND not_rtlc9n1660 ;
   rtlcn1060 <= not_rtlcn1485 OR rtlcn1539 ;
   not_RxRdy <= NOT RxRdy ;
   rtlcn1477 <= not_RxRdy OR not_rtlc9n1660 ;
   not_rtlcn1477 <= NOT rtlcn1477 ;
   rtlcn1059 <= rtlc9n1696 AND not_RxRdy ;
   rtlcn1480 <= rtlc9n1609 OR not_rtlcn1477 ;
   rtlcn1510 <= rcv_state(2) AND rtlc9n1461 ;
   rtlcn1511 <= rcv_state(1) AND rtlc9_PS26_n1419 ;
   not_rtlc9n1488 <= NOT rtlc9n1488 ;
   rtlcn1543 <= not_rtlc9n1488 AND rtlcn1510 ;
   not_rtlcs32 <= NOT rtlcs32 ;
   rtlcn1545 <= not_rtlcs32 AND rtlcn1511 ;
   rtlcn1483 <= rtlcn1543 OR rtlcn1545 ;
   not_rtlc9n1359 <= NOT rtlc9n1359 ;
   not_rtlcn1480 <= NOT rtlcn1480 ;
   rtlcn1493 <= not_rtlc9n1359 AND not_rtlcn1480 ;
   rtlcn1501 <= not_mode_command AND rtlcn1493 ;
   not_rtlc9n1541 <= NOT rtlc9n1541 ;
   rtlcn1486 <= not_mode_command OR not_rtlc9n1541 ;
   rtlcn1508 <= BCR OR rtlcn1486 ;
   rtlcn1550 <= rcv_state(2) AND not_rtlc9n1461 ;
   rtlcn1552 <= rcv_state(1) AND not_rtlc9_PS26_n1419 ;
   rtlcn1553 <= rtlcn1483 AND rtlcn1501 ;
   not_BCR <= NOT BCR ;
   rtlcn1487 <= rtlcn1510 OR rtlcn1511 ;
   rtlcn1556 <= rtlc9n1488 AND rtlcn1510 ;
   rtlcn1557 <= rtlcs32 AND rtlcn1511 ;
   rtlcn1513 <= rtlcn1556 OR rtlcn1557 ;
   rtlcn1558 <= rtlcn1501 AND rtlcn1513 ;
   not_rtlcn1508 <= NOT rtlcn1508 ;
   rtlcn1478 <= not_rtlc9n1698 OR not_rtlc9n1609 ;
   rtlcn1479 <= rtlc9n1628 OR rtlcn1478 ;
   not_rtlcn1479 <= NOT rtlcn1479 ;
   rtlcn1481 <= not_rtlc9n1359 OR not_rtlcn1479 ;
   rtlcn1488 <= rtlc9n2016 OR rtlc9n2008 ;
   rtlcn1490 <= mode_command OR not_BCR ;
   rtlcn1495 <= not_RxRdy AND not_rtlc9n1698 ;
   rtlcn1565 <= RxRdy AND rtlcn1490 ;
   not_rtlcn1488 <= NOT rtlcn1488 ;
   rtlcn1496 <= rtlcn1474 AND not_rtlcn1488 ;
   not_rtlcn1481 <= NOT rtlcn1481 ;
   rtlc_2214_and_856 : and_4u_4u port map ( a(3)=>RxRdy, a(2)=>rtlc9n1375, 
      a(1)=>not_rtlcn1481, a(0)=>rtlcn1496, d=>rtlcn1568);
   rtlcn1392 <= rtlcn1488 OR rtlcn1568 ;
   not_rtlc9n1517 <= NOT rtlc9n1517 ;
   rtlcn1571 <= rcv_state(4) AND not_rtlc9n1517 ;
   rtlcn1489 <= rtlcn1550 OR rtlcn1571 ;
   rtlcn1573 <= rcv_state(1) AND not_rtlc9n2220 ;
   rtlcn1500 <= rtlcn1489 OR rtlcn1573 ;
   rtlcn1514 <= not_rtlcn1479 OR rtlcn1574 ;
   not_rtlcn1474 <= NOT rtlcn1474 ;
   rtlcn1576 <= not_rtlcn1474 AND not_rtlcn1488 ;
   rtlcn1577 <= rtlcn1496 AND rtlcn1514 ;
   rtlcn1393 <= rtlcn1576 OR rtlcn1577 ;
   rtlcn1506 <= not_RxRdy OR not_rtlcn1678 ;
   rtlcn1582 <= rtlcn1479 AND rtlcn1506 ;
   rtlcn1515 <= not_rtlcn1679 OR rtlcn1582 ;
   rtlcn1391 <= rtlcn1496 AND rtlcn1515 ;
   not_R <= NOT R ;
   rtlcn268 <= Mode_req(3) OR Mode_req(0) ;
   rtlcn1584 <= Active_Bus_A_EXMPLR1205 AND not_rtlc6n658 ;
   not_Active_Bus_A <= NOT Active_Bus_A_EXMPLR1205 ;
   rtlcn1586 <= not_Active_Bus_A AND rtlc6n741 ;
   rtlcn333 <= rtlcn1584 OR rtlcn1586 ;
   not_rtlc9n2221 <= NOT rtlc9n2221 ;
   rtlcn519 <= not_BCR AND not_rtlcn1477 ;
   rtlcn1502 <= rtlc9n1696 AND rtlcn1495 ;
   rtlcn551 <= not_rtlcn1680 OR rtlcn1593 ;
   rtlcn1497 <= not_rtlc9n1698 AND rtlc9n1609 ;
   rtlcn621 <= rtlcn1502 OR rtlcn1594 ;
   rtlcn644 <= mode_command AND not_rtlcn1477 ;
   not_rtlc9n1596 <= NOT rtlc9n1596 ;
   rtlcn652 <= mode_command AND not_rtlc9n1596 ;
   rtlcn702 <= rtlcn644 OR rtlcn652 ;
   rtlcn784 <= not_RxRdy AND rtlcn637 ;
   rtlcn894 <= rtlc12n111 AND rtlcs48 ;
   rtlcn1491 <= rtlcn1598 OR rtlcn1599 ;
   rtlcn1492 <= rtlcn1600 OR rtlcn1601 ;
   rtlcn1602 <= rtlc6n715 AND rtlcn1491 ;
   rtlcn1603 <= rtlc6n798 AND rtlcn1492 ;
   rtlcn934 <= rtlcn1602 OR rtlcn1603 ;
   not_rtlcn1478 <= NOT rtlcn1478 ;
   rtlcn1608 <= rtlc9n1698 AND not_rtlc9n1609 ;
   rtlcn1610 <= not_rtlc9n1720 AND rtlcn1478 ;
   rtlcn1507 <= rtlcn1608 OR rtlcn1610 ;
   rtlcn1611 <= rtlcn1060 AND rtlcn1478 ;
   rtlcn1612 <= not_rtlcn1478 AND rtlcn1477 ;
   rtlcn1613 <= not_RxRdy AND rtlcn1507 ;
   rtlc_2297_or_866 : or_5u_5u port map ( a(4)=>not_rtlcn1477, a(3)=>
      rtlcn1611, a(2)=>rtlcn1612, a(1)=>rtlcn1613, a(0)=>rtlcn1614, d=>
      rtlcn1517);
   rtlcn1053 <= BCR AND rtlcn1517 ;
   not_rtlcs19 <= NOT rtlcs19 ;
   rtlcn1617 <= rtlc6n476 AND Rcv_A_CS ;
   rtlcn1504 <= not_rtlcs19 OR rtlcn1617 ;
   not_rtlcs20 <= NOT rtlcs20 ;
   rtlcn1619 <= rtlc6n566 AND Rcv_B_CS ;
   rtlcn1505 <= not_rtlcs20 OR rtlcn1619 ;
   rtlcn1620 <= not_Active_Bus_A AND rtlcn1504 ;
   rtlcn1621 <= Active_Bus_A_EXMPLR1205 AND rtlcn1505 ;
   rtlcn1518 <= rtlcn1620 OR rtlcn1621 ;
   rtlcn1354 <= rtlcn1622 AND rtlcn1518 ;
   rtlcn1623 <= not_rtlc9n1359 AND rtlcn1500 ;
   not_rtlcn1486 <= NOT rtlcn1486 ;
   rtlcn1627 <= not_mode_command AND rtlcn1487 ;
   rtlcn1628 <= mode_command AND rtlc9n2327 ;
   rtlc_2321_or_871 : or_4u_4u port map ( a(3)=>rtlcn1489, a(2)=>rtlcn1552, 
      a(1)=>rtlcn1627, a(0)=>rtlcn1628, d=>rtlcn1475);
   not_rtlcn1475 <= NOT rtlcn1475 ;
   rtlcn1630 <= not_rtlcn1475 AND rtlcn1493 ;
   rtlcn1370 <= rtlcn1630 OR rtlcn1553 ;
   rtlcn1521 <= rtlc9n1609 OR rtlc9n1720 ;
   rtlcn1520 <= not_rtlcn1477 OR rtlcn1060 ;
   rtlcn1634 <= rtlcn1502 AND rtlcn1521 ;
   rtlcn1635 <= rtlcn1497 AND rtlcn1520 ;
   not_rtlcn1476 <= NOT rtlcn1476 ;
   rtlcn1376 <= not_rtlcn1476 AND rtlc9n1596 ;
   rtlcn1637 <= not_rtlcn1486 AND not_rtlc9n1596 ;
   rtlcn1522 <= rtlcn644 OR rtlcn1637 ;
   rtlcn1638 <= BCR AND rtlcn1522 ;
   rtlcn1388 <= rtlc9n1924 OR rtlcn1638 ;
   rtlcn1509 <= rtlcn1060 OR rtlcn1614 ;
   rtlcn1640 <= not_rtlc9n1359 AND rtlcn1495 ;
   rtlcn1641 <= rtlcn1481 AND rtlcn1509 ;
   rtlcn1523 <= rtlcn1640 OR rtlcn1641 ;
   not_rtlc9n1902 <= NOT rtlc9n1902 ;
   rtlcn1643 <= not_rtlc9n1902 AND rtlcn1523 ;
   rtlcn1404 <= not_rtlc9n1359 AND rtlcn1477 ;
   rtlc9n2220 <= rtlcs43 OR rtlc9_PS26_n1419 ;
   rtlc9_PS116_n1741 <= not_tx_state_1 OR tx_state(0) ;
   rtlcn1614 <= RxRdy AND rtlc9n1677 ;
   not_rtlcn268 <= NOT rtlcn268 ;
   not_rtlcn1676 <= NOT rtlcn1676 ;
   not_rtlcn1677 <= NOT rtlcn1677 ;
   not_rtlcn1678 <= NOT rtlcn1678 ;
   not_rtlcn1679 <= NOT rtlcn1679 ;
   not_rtlcn1680 <= NOT rtlcn1680 ;
   rtlcn1503 <= RxRdy OR not_rtlc9n1696 ;
   not_rtlcn1681 <= NOT rtlc_2540_or_875_nx0 ;
   not_rtlcn1682 <= NOT rtlcn1682 ;
   Write_Data_0_EXMPLR1278 <= Rcv_A_R_Data(0) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(0) ;
   Write_Data_1_EXMPLR1277 <= Rcv_A_R_Data(1) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(1) ;
   Write_Data_2_EXMPLR1276 <= Rcv_A_R_Data(2) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(2) ;
   Write_Data_3_EXMPLR1275 <= Rcv_A_R_Data(3) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(3) ;
   Write_Data_4_EXMPLR1274 <= Rcv_A_R_Data(4) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(4) ;
   Write_Data(5) <= Rcv_A_R_Data(5) when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_R_Data(5) ;
   Write_Data(6) <= Rcv_A_R_Data(6) when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_R_Data(6) ;
   Write_Data(7) <= Rcv_A_R_Data(7) when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_R_Data(7) ;
   Write_Data(8) <= Rcv_A_R_Data(8) when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_R_Data(8) ;
   Write_Data(9) <= Rcv_A_R_Data(9) when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_R_Data(9) ;
   Write_Data_10_EXMPLR1268 <= Rcv_A_R_Data(10) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(10) ;
   Write_Data(11) <= Rcv_A_R_Data(11) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(11) ;
   Write_Data(12) <= Rcv_A_R_Data(12) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(12) ;
   Write_Data(13) <= Rcv_A_R_Data(13) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(13) ;
   Write_Data(14) <= Rcv_A_R_Data(14) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(14) ;
   Write_Data(15) <= Rcv_A_R_Data(15) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_R_Data(15) ;
   Rcv_RAW_GAP(0) <= Rcv_A_RAW_GAP(0) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(0) ;
   Rcv_RAW_GAP(1) <= Rcv_A_RAW_GAP(1) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(1) ;
   Rcv_RAW_GAP(2) <= Rcv_A_RAW_GAP(2) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(2) ;
   Rcv_RAW_GAP(3) <= Rcv_A_RAW_GAP(3) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(3) ;
   Rcv_RAW_GAP(4) <= Rcv_A_RAW_GAP(4) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(4) ;
   Rcv_RAW_GAP(5) <= Rcv_A_RAW_GAP(5) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(5) ;
   Rcv_RAW_GAP(6) <= Rcv_A_RAW_GAP(6) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RAW_GAP(6) ;
   Rcv_Gap_found(0) <= Rcv_A_Gap_found(0) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_Gap_found(0) ;
   Rcv_Gap_found(1) <= Rcv_A_Gap_found(1) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_Gap_found(1) ;
   Rcv_Gap_found(2) <= Rcv_A_Gap_found(2) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_Gap_found(2) ;
   Rcv_RxRDY_plus_10us <= Rcv_A_RxRDY_plus_10us when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_RxRDY_plus_10us ;
   rtlc_Rcv_CS_n2260 <= Rcv_A_CS when Active_Bus_A_EXMPLR1205 = '1' else 
   Rcv_B_CS ;
   Rcv_Command_Sync <= Rcv_A_Command_Sync when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_Command_Sync ;
   rtlc_Rcv_recieving_n2261 <= Rcv_A_recieving when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_B_recieving ;
   RT_Address_valid <= RT_Address_valid_A when Active_Bus_A_EXMPLR1205
    = '1' else RT_Address_valid_B ;
   Transmit_data(0) <= T_Data(0) when int_Go = '1' else read_Data(0) ;
   Transmit_data(1) <= T_Data(1) when int_Go = '1' else read_Data(1) ;
   Transmit_data(2) <= T_Data(2) when int_Go = '1' else read_Data(2) ;
   Transmit_data(3) <= T_Data(3) when int_Go = '1' else read_Data(3) ;
   Transmit_data(4) <= T_Data(4) when int_Go = '1' else read_Data(4) ;
   Transmit_data(5) <= T_Data(5) when int_Go = '1' else read_Data(5) ;
   Transmit_data(6) <= T_Data(6) when int_Go = '1' else read_Data(6) ;
   Transmit_data(7) <= T_Data(7) when int_Go = '1' else read_Data(7) ;
   Transmit_data(8) <= T_Data(8) when int_Go = '1' else read_Data(8) ;
   Transmit_data(9) <= T_Data(9) when int_Go = '1' else read_Data(9) ;
   Transmit_data(10) <= T_Data(10) when int_Go = '1' else read_Data(10) ;
   Transmit_data(11) <= T_Data(11) when int_Go = '1' else read_Data(11) ;
   Transmit_data(12) <= T_Data(12) when int_Go = '1' else read_Data(12) ;
   Transmit_data(13) <= T_Data(13) when int_Go = '1' else read_Data(13) ;
   Transmit_data(14) <= T_Data(14) when int_Go = '1' else read_Data(14) ;
   Transmit_data(15) <= T_Data(15) when int_Go = '1' else read_Data(15) ;
   active_command_6n13ss1(0) <= Rcv_B_R_Data(0) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(0) ;
   active_command_6n13ss1(1) <= Rcv_B_R_Data(1) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(1) ;
   active_command_6n13ss1(2) <= Rcv_B_R_Data(2) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(2) ;
   active_command_6n13ss1(3) <= Rcv_B_R_Data(3) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(3) ;
   active_command_6n13ss1(4) <= Rcv_B_R_Data(4) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(4) ;
   active_command_6n13ss1(5) <= Rcv_B_R_Data(5) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(5) ;
   active_command_6n13ss1(6) <= Rcv_B_R_Data(6) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(6) ;
   active_command_6n13ss1(7) <= Rcv_B_R_Data(7) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(7) ;
   active_command_6n13ss1(8) <= Rcv_B_R_Data(8) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(8) ;
   active_command_6n13ss1(9) <= Rcv_B_R_Data(9) when Active_Bus_A_EXMPLR1205
    = '1' else Rcv_A_R_Data(9) ;
   active_command_6n13ss1(10) <= Rcv_B_R_Data(10) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(10) ;
   active_command_6n13ss1(11) <= Rcv_B_R_Data(11) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(11) ;
   active_command_6n13ss1(12) <= Rcv_B_R_Data(12) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(12) ;
   active_command_6n13ss1(13) <= Rcv_B_R_Data(13) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(13) ;
   active_command_6n13ss1(14) <= Rcv_B_R_Data(14) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(14) ;
   active_command_6n13ss1(15) <= Rcv_B_R_Data(15) when 
   Active_Bus_A_EXMPLR1205 = '1' else Rcv_A_R_Data(15) ;
   mode_command_6n13ss1 <= mode_command_6n5s1 when Active_Bus_A_EXMPLR1205
    = '1' else mode_command_6n1s1 ;
   BCR_6n13ss1 <= BCR_6n5s2 when Active_Bus_A_EXMPLR1205 = '1' else 
   BCR_6n1s2 ;
   rtlc6n846 <= not_rtlc6n658 when Active_Bus_A_EXMPLR1205 = '1' else 
   not_rtlc6n741 ;
   rtlc9n1651 <= rtlc9n1646 when rtlc9n1609 = '1' else rtlc9n1596 ;
   rtlc9n1887 <= rtlc9n1812 when RxRdy = '1' else rtlc9n1876 ;
   rtlc9n1812 <= rtlc9n1783 when rtlc9n1660 = '1' else rtlc9n1652 ;
   rtlc9n1889 <= rtlc9n1814 when RxRdy = '1' else rtlc9n1654 ;
   rtlc9n1890 <= rtlc9n1815 when RxRdy = '1' else rtlc9n1878 ;
   rtlc9n1869 <= rtlc9_PS116_n1741 when rtlc9n1736 = '1' else rtlc9n1596 ;
   rtlc9n1892 <= rtlc9n1655 when RxRdy = '1' else rtlc9n1880 ;
   rtlc9n1893 <= rtlc9n1655 when RxRdy = '1' else rtlc9n1881 ;
   rtlc9n1895 <= rtlc9n1656 when RxRdy = '1' else rtlc9n1883 ;
   Rcv_CS_6n13ss1 <= Rcv_A_CS when rtlcn333 = '1' else Rcv_B_CS ;
   Mode_req_9n36ss1(3) <= Write_Data_3_EXMPLR1275 when rtlcn644 = '1' else 
   Mode_req_9n17ss1(3) ;
   Mode_req_9n36ss1(0) <= Write_Data_0_EXMPLR1278 when rtlcn644 = '1' else 
   Mode_req_9n17ss1(0) ;
   Mode_req_9n36ss1(4) <= Write_Data_4_EXMPLR1274 when rtlcn644 = '1' else 
   Mode_req_9n17ss1(4) ;
   Mode_req_9n36ss1(2) <= Write_Data_2_EXMPLR1276 when rtlcn644 = '1' else 
   Mode_req_9n17ss1(2) ;
   Mode_req_9n36ss1(1) <= Write_Data_1_EXMPLR1277 when rtlcn644 = '1' else 
   Mode_req_9n17ss1(1) ;
   rtlc9n1891 <= rtlc9_PS116_n1741 when rtlcn784 = '1' else rtlc9n1600 ;
   rtlc9n1652 <= rtlc9n1597 when rtlcn1478 = '1' else rtlc9n1644 ;
   not_rtlc6n848 <= NOT rtlc6n848 ;
   rtlc6n901 <= CE AND not_rtlc6n848 ;
   not_rtlc6n849 <= NOT rtlc6n849 ;
   rtlc6n896 <= CE AND not_rtlc6n849 ;
   not_rtlc9n1889 <= NOT rtlc9n1889 ;
   rtlc9n2323 <= CE AND not_rtlc9n1889 ;
   not_rtlc9n1890 <= NOT rtlc9n1890 ;
   rtlc9n2318 <= CE AND not_rtlc9n1890 ;
   rtlcn1685 <= CE AND RxRdy ;
   rtlcn1687 <= rtlcn1700 OR rtlc9n1359 ;
   rtlcn1702 <= CE AND not_rtlcn1477 ;
   rtlcn1703 <= rtlcn1685 AND rtlcn1687 ;
   rtlc9n2316 <= rtlcn1702 OR rtlcn1703 ;
   not_rtlc9n1897 <= NOT rtlc9n1897 ;
   rtlc9n2315 <= CE AND not_rtlc9n1897 ;
   rtlc_2709_and_876 : and_4u_4u port map ( a(3)=>CE, a(2)=>not_RxRdy, a(1)
      =>not_rtlc9n1696, a(0)=>rtlc9n1736, d=>rtlc9n2308);
   not_rtlc9n1585 <= NOT rtlc9n1585 ;
   rtlcn1688 <= rtlc9n1359 OR not_rtlc9n1585 ;
   rtlc9n2302 <= rtlcn1685 AND rtlcn1688 ;
   rtlcn1686 <= CE AND Valid_command_EXMPLR1261 ;
   not_rtlc9n1895 <= NOT rtlc9n1895 ;
   rtlcn1709 <= CE AND rtlcn1689 ;
   rtlc9n2296 <= rtlcn1686 OR rtlcn1709 ;
   not_Valid_command <= NOT Valid_command_EXMPLR1261 ;
   rtlcn1710 <= CE AND rtlc9n1991 ;
   rtlc9n2294 <= rtlcn1686 OR rtlcn1710 ;
   not_tx_state_0 <= NOT tx_state(0) ;
   rtlc_2723_and_878 : and_4u_4u port map ( a(3)=>not_RxRdy, a(2)=>
      rtlc9n1736, a(1)=>not_tx_state_0, a(0)=>rtlcn146, d=>rtlcn1713);
   rtlcn1690 <= rtlc9n1947 OR rtlcn1713 ;
   rtlc9n2291 <= CE AND rtlcn1690 ;
   not_rtlc9n1947 <= NOT rtlc9n1947 ;
   not_rtlc9n1893 <= NOT rtlc9n1893 ;
   rtlc9n2290 <= CE AND not_rtlc9n1893 ;
   not_rtlc9n1892 <= NOT rtlc9n1892 ;
   rtlc9n2289 <= CE AND not_rtlc9n1892 ;
   not_rtlc9n1891 <= NOT rtlc9n1891 ;
   rtlc9n2273 <= CE AND not_rtlc9n1891 ;
   not_rtlc9n1600 <= NOT rtlc9n1600 ;
   rtlcn1691 <= not_rtlc9n1600 OR rtlc9n1935 ;
   rtlc9n2257 <= CE AND rtlcn1691 ;
   not_rtlc9n1888 <= NOT rtlc9n1888 ;
   rtlc9n2248 <= CE AND not_rtlc9n1888 ;
   not_rtlc9n1887 <= NOT rtlc9n1887 ;
   rtlcn1692 <= not_rtlc9n1887 OR rtlc9n1902 ;
   rtlc9n2247 <= CE AND rtlcn1692 ;
   not_rtlc9n1886 <= NOT rtlc9n1886 ;
   rtlc9n2246 <= CE AND not_rtlc9n1886 ;
   rtlcn1722 <= CE AND rtlcn894 ;
   rtlc12n231 <= rtlcn1686 OR rtlcn1722 ;
   rtlcn1683 <= CE AND rtlc12n111 ;
   rtlcn1693 <= rtlcs51 OR rtlcs48 ;
   rtlc12n230 <= rtlcn1683 AND rtlcn1693 ;
   rtlcn1684 <= rtlc12n238 AND rtlcn1683 ;
   not_rtlcn201 <= NOT rtlcn201 ;
   rtlcn1694 <= Active_Bus_A_EXMPLR1205 OR not_rtlcn201 ;
   rtlc12n229 <= rtlcn1684 AND rtlcn1694 ;
   rtlcn1695 <= not_Active_Bus_A OR not_rtlcn201 ;
   rtlc12n228 <= rtlcn1684 AND rtlcn1695 ;
   rtlc9n1881 <= rtlc9n1655 AND rtlcn1726 ;
   rtlc9n1897 <= rtlc9n1602 AND rtlcn1727 ;
   rtlc9n1602 <= not_Do_illegal AND rtlcn1728 ;
   rtlcs2 <= rtlcs1 AND BCR_6n1s2 ;
   rtlcs1 <= rtlcs8 AND mode_command_6n1s3 ;
   rtlcs7 <= rtlcs6 AND BCR_6n1s2 ;
   rtlcs6 <= rtlcs8 AND mode_command_6n1s5 ;
   rtlcs11 <= rtlcs10 AND BCR_6n5s2 ;
   rtlcs10 <= rtlcs17 AND mode_command_6n5s3 ;
   rtlcs16 <= rtlcs15 AND BCR_6n5s2 ;
   rtlcs15 <= rtlcs17 AND mode_command_6n5s5 ;
   rtlcs29 <= rtlcs30 AND rtlcs31 ;
   rtlcs32 <= rtlcs33 AND rtlcs34 ;
   rtlcs35 <= rtlcs36 AND rtlcs31 ;
   rtlcs37 <= rtlcs38 AND rtlcs31 ;
   rtlcs31 <= not_active_command_0 AND rtlcs34 ;
   rtlcs44 <= Rcv_Command_Sync AND rtlcs43 ;
   rtlcs60 <= rtlcs50 AND Mode_req(1) ;
   rtlcs51 <= rtlcs60 AND rtlcs53 ;
   rtlcs61 <= rtlcs50 AND rtlcs53 ;
   rtlcs54 <= rtlcs61 AND not_Mode_req_1 ;
   rtlcs56 <= rtlcs57 AND rtlcs53 ;
   BCR_and_6i40 : and_5u_5u port map ( a(4)=>Rcv_B_R_Data(15), a(3)=>
      Rcv_B_R_Data(14), a(2)=>Rcv_B_R_Data(13), a(1)=>Rcv_B_R_Data(12), a(0)
      =>Rcv_B_R_Data(11), d=>BCR_6n5s2);
   BCR_and_6i41 : and_5u_5u port map ( a(4)=>Rcv_A_R_Data(15), a(3)=>
      Rcv_A_R_Data(14), a(2)=>Rcv_A_R_Data(13), a(1)=>Rcv_A_R_Data(12), a(0)
      =>Rcv_A_R_Data(11), d=>BCR_6n1s2);
   not_Rcv_B_Pre_RxRdy <= NOT Rcv_B_Pre_RxRdy ;
   not_Rcv_A_Pre_RxRdy <= NOT Rcv_A_Pre_RxRdy ;
   rtlcs19 <= not_Rcv_B_Pre_RxRdy AND Rcv_A_Pre_RxRdy ;
   rtlcs20 <= Rcv_B_Pre_RxRdy AND not_Rcv_A_Pre_RxRdy ;
   rtlcs21 <= Rcv_B_Pre_RxRdy AND Rcv_A_Pre_RxRdy ;
   ri_9n16ss1(5) <= ri_9n8s1(5) AND not_rtlc9n1359 ;
   mode_command_and_6i42 : and_5u_5u port map ( a(4)=>Rcv_B_R_Data(9), a(3)
      =>Rcv_B_R_Data(8), a(2)=>Rcv_B_R_Data(7), a(1)=>Rcv_B_R_Data(6), a(0)
      =>Rcv_B_R_Data(5), d=>mode_command_6n5s3);
   not_Rcv_B_R_Data_9 <= NOT Rcv_B_R_Data(9) ;
   not_Rcv_B_R_Data_8 <= NOT Rcv_B_R_Data(8) ;
   not_Rcv_B_R_Data_7 <= NOT Rcv_B_R_Data(7) ;
   not_Rcv_B_R_Data_6 <= NOT Rcv_B_R_Data(6) ;
   not_Rcv_B_R_Data_5 <= NOT Rcv_B_R_Data(5) ;
   mode_command_and_6i43 : and_5u_5u port map ( a(4)=>not_Rcv_B_R_Data_9, 
      a(3)=>not_Rcv_B_R_Data_8, a(2)=>not_Rcv_B_R_Data_7, a(1)=>
      not_Rcv_B_R_Data_6, a(0)=>not_Rcv_B_R_Data_5, d=>mode_command_6n5s5);
   mode_command_and_6i44 : and_5u_5u port map ( a(4)=>Rcv_A_R_Data(9), a(3)
      =>Rcv_A_R_Data(8), a(2)=>Rcv_A_R_Data(7), a(1)=>Rcv_A_R_Data(6), a(0)
      =>Rcv_A_R_Data(5), d=>mode_command_6n1s3);
   not_Rcv_A_R_Data_9 <= NOT Rcv_A_R_Data(9) ;
   not_Rcv_A_R_Data_8 <= NOT Rcv_A_R_Data(8) ;
   not_Rcv_A_R_Data_7 <= NOT Rcv_A_R_Data(7) ;
   not_Rcv_A_R_Data_6 <= NOT Rcv_A_R_Data(6) ;
   not_Rcv_A_R_Data_5 <= NOT Rcv_A_R_Data(5) ;
   mode_command_and_6i45 : and_5u_5u port map ( a(4)=>not_Rcv_A_R_Data_9, 
      a(3)=>not_Rcv_A_R_Data_8, a(2)=>not_Rcv_A_R_Data_7, a(1)=>
      not_Rcv_A_R_Data_6, a(0)=>not_Rcv_A_R_Data_5, d=>mode_command_6n1s5);
   ri_9n16ss1(4) <= ri_9n8s1(4) AND not_rtlc9n1359 ;
   ri_9n16ss1(3) <= ri_9n8s1(3) AND not_rtlc9n1359 ;
   ri_9n16ss1(2) <= ri_9n8s1(2) AND not_rtlc9n1359 ;
   ri_9n16ss1(1) <= ri_9n8s1(1) AND not_rtlc9n1359 ;
   ri_9n16ss1(0) <= ri_9n8s1(0) AND not_rtlc9n1359 ;
   not_ri_9n8s1_5 <= NOT ri_9n8s1(5) ;
   rtlcs41 <= not_ri_9n8s1_5 AND rtlcs62 ;
   not_ri_9n8s1_4 <= NOT ri_9n8s1(4) ;
   not_ri_9n8s1_3 <= NOT ri_9n8s1(3) ;
   not_ri_9n8s1_2 <= NOT ri_9n8s1(2) ;
   not_ri_9n8s1_1 <= NOT ri_9n8s1(1) ;
   not_ri_9n8s1_0 <= NOT ri_9n8s1(0) ;
   not_active_command_1 <= NOT active_command_EXMPLR1380(1) ;
   not_active_command_0 <= NOT active_command_EXMPLR1380(0) ;
   not_active_command_3 <= NOT active_command_EXMPLR1380(3) ;
   not_active_command_2 <= NOT active_command_EXMPLR1380(2) ;
   rtlcs34 <= not_active_command_3 AND not_active_command_2 ;
   ti_9n33ss1(5) <= rtlc9n1755(5) AND tx_state(1) ;
   ti_9n33ss1(4) <= rtlc9n1755(4) AND tx_state(1) ;
   ti_9n33ss1(3) <= rtlc9n1755(3) AND tx_state(1) ;
   ti_9n33ss1(2) <= rtlc9n1755(2) AND tx_state(1) ;
   ti_9n33ss1(1) <= rtlc9n1755(1) AND tx_state(1) ;
   ti_9n33ss1(0) <= rtlc9n1755(0) AND tx_state(1) ;
   not_rtlc9n1755_5 <= NOT rtlc9n1755(5) ;
   rtlcs27 <= not_rtlc9n1755_5 AND rtlcs63 ;
   not_rtlc9n1755_4 <= NOT rtlc9n1755(4) ;
   not_rtlc9n1755_3 <= NOT rtlc9n1755(3) ;
   not_rtlc9n1755_2 <= NOT rtlc9n1755(2) ;
   not_rtlc9n1755_1 <= NOT rtlc9n1755(1) ;
   not_rtlc9n1755_0 <= NOT rtlc9n1755(0) ;
   not_Write_Data_3 <= NOT Write_Data_3_EXMPLR1275 ;
   not_Write_Data_2 <= NOT Write_Data_2_EXMPLR1276 ;
   not_Write_Data_0 <= NOT Write_Data_0_EXMPLR1278 ;
   rtlcn1682 <= rtlc9n1677 OR rtlcn1477 ;
   rtlcs36 <= active_command_EXMPLR1380(1) AND not_active_command_4 ;
   rtlcs30 <= active_command_EXMPLR1380(4) AND active_command_EXMPLR1380(1)
    ;
   rtlcn193 <= rtlc9n1677 OR not_rtlc9n1660 ;
   rtlcn196 <= rtlc9n1698 OR not_rtlc9n1696 ;
   Mode_req_9n17ss1(3) <= active_command_EXMPLR1380(3) AND rtlcn652 ;
   rtlcn198 <= not_mode_command OR not_rtlc9n1359 ;
   rtlcn1728 <= rtlcn198 OR not_RxRdy ;
   rtlcn197 <= not_mode_command OR not_rtlc9n1660 ;
   rtlcn1727 <= rtlcn197 OR not_RxRdy ;
   Mode_req_9n17ss1(0) <= active_command_EXMPLR1380(0) AND rtlcn652 ;
   Mode_req_9n17ss1(1) <= active_command_EXMPLR1380(1) AND rtlcn652 ;
   Mode_req_9n17ss1(4) <= active_command_EXMPLR1380(4) AND rtlcn652 ;
   not_Mode_req_1 <= NOT Mode_req(1) ;
   not_Mode_req_5 <= NOT Mode_req(5) ;
   Mode_req_9n17ss1(2) <= active_command_EXMPLR1380(2) AND rtlcn652 ;
   not_Mode_req_3 <= NOT Mode_req(3) ;
   rtlcs53 <= not_Mode_req_3 AND Mode_req(2) ;
   not_Mode_req_4 <= NOT Mode_req(4) ;
   rtlcs50 <= Mode_req(5) AND not_Mode_req_4 ;
   not_Mode_req_2 <= NOT Mode_req(2) ;
   not_Mode_req_0 <= NOT Mode_req(0) ;
   rtlcn1676 <= rtlcn777 OR rtlcn778 ;
   rtlcs58 <= not_Mode_req_3 AND not_Mode_req_0 ;
   not_Rcv_B_R_Data_3 <= NOT Rcv_B_R_Data(3) ;
   not_Rcv_B_R_Data_2 <= NOT Rcv_B_R_Data(2) ;
   not_Rcv_B_R_Data_0 <= NOT Rcv_B_R_Data(0) ;
   rtlc_2920_and_894 : and_6u_6u port map ( a(5)=>Rcv_B_R_Data(10), a(4)=>
      Rcv_B_R_Data(4), a(3)=>not_Rcv_B_R_Data_3, a(2)=>not_Rcv_B_R_Data_2, 
      a(1)=>Rcv_B_R_Data(1), a(0)=>not_Rcv_B_R_Data_0, d=>rtlcs17);
   not_Rcv_A_R_Data_3 <= NOT Rcv_A_R_Data(3) ;
   not_Rcv_A_R_Data_2 <= NOT Rcv_A_R_Data(2) ;
   not_Rcv_A_R_Data_0 <= NOT Rcv_A_R_Data(0) ;
   rtlc_2928_and_895 : and_6u_6u port map ( a(5)=>Rcv_A_R_Data(10), a(4)=>
      Rcv_A_R_Data(4), a(3)=>not_Rcv_A_R_Data_3, a(2)=>not_Rcv_A_R_Data_2, 
      a(1)=>Rcv_A_R_Data(1), a(0)=>not_Rcv_A_R_Data_0, d=>rtlcs8);
   rtlcn1677 <= rtlc9n1696 OR rtlcn1484 ;
   not_No_Response_timeout_2 <= NOT No_Response_timeout(2) ;
   not_No_Response_timeout_1 <= NOT No_Response_timeout(1) ;
   not_No_Response_timeout_0 <= NOT No_Response_timeout(0) ;
   rtlcn1679 <= rtlc9n1375 OR rtlcn1481 ;
   rtlcn1678 <= rtlc9n1359 OR rtlcn1500 ;
   rtlcn191 <= not_rtlc9n1720 OR rtlc9n1698 ;
   rtlcn192 <= not_rtlc9n1698 OR not_rtlc9n1696 ;
   not_rtlcn1907 <= NOT rtlcn1907 ;
   rtlcn1907 <= rtlc9n1825 OR rtlc9n1935 ;
   rtlcn1622 <= Rcv_B_Pre_RxRdy OR Rcv_A_Pre_RxRdy ;
   rtlcn1700 <= rtlcs44 AND rcv_state(1) ;
   rtlceq_s128_eq_901 : eq_5u_5u port map ( a(4)=>ri_9n8s1(4), a(3)=>
      ri_9n8s1(3), a(2)=>ri_9n8s1(2), a(1)=>ri_9n8s1(1), a(0)=>ri_9n8s1(0), 
      b(4)=>active_command_EXMPLR1380(4), b(3)=>active_command_EXMPLR1380(3), 
      b(2)=>active_command_EXMPLR1380(2), b(1)=>active_command_EXMPLR1380(1), 
      b(0)=>active_command_EXMPLR1380(0), d=>rtlcs62);
   rtlceq_s130_eq_902 : eq_5u_5u port map ( a(4)=>rtlc9n1755(4), a(3)=>
      rtlc9n1755(3), a(2)=>rtlc9n1755(2), a(1)=>rtlc9n1755(1), a(0)=>
      rtlc9n1755(0), b(4)=>active_command_EXMPLR1380(4), b(3)=>
      active_command_EXMPLR1380(3), b(2)=>active_command_EXMPLR1380(2), b(1)
      =>active_command_EXMPLR1380(1), b(0)=>active_command_EXMPLR1380(0), d
      =>rtlcs63);
   DFFPCE (BCR_6n14ss1,Channel_status_out_5_EXMPLR1314,not_R,rtlc6n901,C,BCR
   ) ;
   DFFPCE (mode_command_6n14ss1,Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,mode_command) ;
   DFFPCE (Active_Bus_A_6n14ss1,not_R,Channel_status_out_5_EXMPLR1314,
   rtlc6n901,C,Active_Bus_A_EXMPLR1205) ;
   DFFPCE (rtlc_Rcv_recieving_n2261,Channel_status_out_5_EXMPLR1314,not_R,CE,
   C,Rcv_recieving) ;
   DFFPCE (rtlc_Rcv_CS_n2260,Channel_status_out_5_EXMPLR1314,not_R,CE,C,
   Rcv_CS_continous) ;
   DFFPCE (Rcv_CS_6n14ss1,Channel_status_out_5_EXMPLR1314,not_R,rtlc6n896,C,
   Rcv_CS) ;
   DFFPCE (active_command_6n14ss1(15),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(15)) ;
   DFFPCE (active_command_6n14ss1(14),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(14)) ;
   DFFPCE (active_command_6n14ss1(13),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(13)) ;
   DFFPCE (active_command_6n14ss1(12),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(12)) ;
   DFFPCE (active_command_6n14ss1(11),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(11)) ;
   DFFPCE (active_command_6n14ss1(10),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(10)) ;
   DFFPCE (active_command_6n14ss1(9),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(9)) ;
   DFFPCE (active_command_6n14ss1(8),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(8)) ;
   DFFPCE (active_command_6n14ss1(7),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(7)) ;
   DFFPCE (active_command_6n14ss1(6),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(6)) ;
   DFFPCE (active_command_6n14ss1(5),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(5)) ;
   DFFPCE (active_command_6n14ss1(4),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(4)) ;
   DFFPCE (active_command_6n14ss1(3),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(3)) ;
   DFFPCE (active_command_6n14ss1(2),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(2)) ;
   DFFPCE (active_command_6n14ss1(1),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(1)) ;
   DFFPCE (active_command_6n14ss1(0),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc6n901,C,active_command_EXMPLR1380(0)) ;
   DFFPCE (rtlcn934,Channel_status_out_5_EXMPLR1314,not_R,CE,C,
   Active_command_updated) ;
   DFFPCE (rtlc_2301_or_868_nx0,Channel_status_out_5_EXMPLR1314,not_R,CE,C,
   Valid_command_EXMPLR1261) ;
   DFFPCE (rtlcn1354,Channel_status_out_5_EXMPLR1314,not_R,CE,C,RxRdy) ;
   DFFPCE (rtlcn513,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2323,C,
   rcv_state(4)) ;
   DFFPCE (rtlcn1340,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2323,C,
   rcv_state(3)) ;
   DFFPCE (rtlcn1370,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2323,C,
   rcv_state(2)) ;
   DFFPCE (rtlcn392,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2323,C,
   rcv_state(1)) ;
   DFFPCE (rtlcn1359,not_R,Channel_status_out_5_EXMPLR1314,rtlc9n2323,C,
   rcv_state(0)) ;
   DFFPCE (rtlcn551,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2318,C,
   tx_state(1)) ;
   DFFPCE (rtlcn519,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2318,C,
   tx_state(0)) ;
   DFFPCE (rtlcn1404,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2316,C,
   RT2RT_message) ;
   DFFPCE (rtlcn702,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2315,C,
   Mode_req(6)) ;
   DFFPCE (rtlcn644,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2315,C,
   Mode_req(5)) ;
   DFFPCE (Mode_req_9n36ss1(4),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2315,C,Mode_req(4)) ;
   DFFPCE (Mode_req_9n36ss1(3),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2315,C,Mode_req(3)) ;
   DFFPCE (Mode_req_9n36ss1(2),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2315,C,Mode_req(2)) ;
   DFFPCE (Mode_req_9n36ss1(1),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2315,C,Mode_req(1)) ;
   DFFPCE (Mode_req_9n36ss1(0),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2315,C,Mode_req(0)) ;
   DFFPCE (ti_9n33ss1(5),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(5)) ;
   DFFPCE (ti_9n33ss1(4),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(4)) ;
   DFFPCE (ti_9n33ss1(3),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(3)) ;
   DFFPCE (ti_9n33ss1(2),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(2)) ;
   DFFPCE (ti_9n33ss1(1),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(1)) ;
   DFFPCE (ti_9n33ss1(0),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2308,C,
   ti(0)) ;
   DFFPCE (ri_9n16ss1(5),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(5)) ;
   DFFPCE (ri_9n16ss1(4),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(4)) ;
   DFFPCE (ri_9n16ss1(3),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(3)) ;
   DFFPCE (ri_9n16ss1(2),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(2)) ;
   DFFPCE (ri_9n16ss1(1),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(1)) ;
   DFFPCE (ri_9n16ss1(0),Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2302,C,
   ri(0)) ;
   DFFPCE (not_rtlcn1681,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2296,C,
   Finished_message_OK) ;
   DFFPCE (Message_ended_not_OK_pre,Channel_status_out_5_EXMPLR1314,not_R,CE,
   C,Message_ended_not_OK_pre_D) ;
   DFFPCE (rtlc9n1991,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2294,C,
   Message_ended_not_OK_pre) ;
   DFFPCE (Message_ended_not_OK_9n45ss1,Channel_status_out_5_EXMPLR1314,
   not_R,CE,C,Message_ended_not_OK) ;
   DFFPCE (rtlcn1388,Channel_status_out_5_EXMPLR1314,not_R,CE,C,
   Message_ended_OK) ;
   DFFPCE (not_rtlc9n1947,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2291,C,
   read_Req_EXMPLR1280) ;
   DFFPCE (rtlcn635,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2290,C,
   T_Sync) ;
   DFFPCE (active_command_EXMPLR1380(15),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(15)) ;
   DFFPCE (active_command_EXMPLR1380(14),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(14)) ;
   DFFPCE (active_command_EXMPLR1380(13),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(13)) ;
   DFFPCE (active_command_EXMPLR1380(12),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(12)) ;
   DFFPCE (active_command_EXMPLR1380(11),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(11)) ;
   DFFPCE (Channel_status(10),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(10)) ;
   DFFPCE (Channel_status(9),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(9)) ;
   DFFPCE (Channel_status(8),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(8)) ;
   DFFPCE (Channel_status(7),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(7)) ;
   DFFPCE (Channel_status(6),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(6)) ;
   DFFPCE (Channel_status(5),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(5)) ;
   DFFPCE (Channel_status(4),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(4)) ;
   DFFPCE (Channel_status_out_3_EXMPLR1300,Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2289,C,T_Data(3)) ;
   DFFPCE (Channel_status(2),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(2)) ;
   DFFPCE (Channel_status(1),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(1)) ;
   DFFPCE (Channel_status(0),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2289,C,T_Data(0)) ;
   DFFPCE (active_command_EXMPLR1380(10),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(10)) ;
   DFFPCE (active_command_EXMPLR1380(9),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(9)) ;
   DFFPCE (active_command_EXMPLR1380(8),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(8)) ;
   DFFPCE (active_command_EXMPLR1380(7),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(7)) ;
   DFFPCE (active_command_EXMPLR1380(6),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(6)) ;
   DFFPCE (active_command_EXMPLR1380(5),Channel_status_out_5_EXMPLR1314,
   not_R,rtlc9n2273,C,Address(5)) ;
   DFFPCE (Address_9n36ss1(4),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2273,C,Address(4)) ;
   DFFPCE (Address_9n36ss1(3),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2273,C,Address(3)) ;
   DFFPCE (Address_9n36ss1(2),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2273,C,Address(2)) ;
   DFFPCE (Address_9n36ss1(1),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2273,C,Address(1)) ;
   DFFPCE (Address_9n36ss1(0),Channel_status_out_5_EXMPLR1314,not_R,
   rtlc9n2273,C,Address(0)) ;
   DFFPCE (not_rtlcn1907,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2257,C,
   Write_Req_EXMPLR1262) ;
   DFFPCE (rtlcn621,Channel_status_out_5_EXMPLR1314,not_R,CE,C,int_Go) ;
   DFFPCE (rtlcn1376,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2248,C,
   Channel_status_out_3_EXMPLR1300) ;
   DFFPCE (rtlcn1400,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2247,C,
   Channel_status_out(10)) ;
   DFFPCE (rtlcn1053,Channel_status_out_5_EXMPLR1314,not_R,rtlc9n2246,C,
   Channel_status_out(4)) ;
   DFFPCE (rtlcn894,Channel_status_out_5_EXMPLR1314,not_R,rtlc12n231,C,
   reset_remote_terminal_received) ;
   DFFPCE (rtlcs58,Channel_status_out_5_EXMPLR1314,not_R,rtlc12n230,C,
   Inhibit_TF) ;
   DFFPCE (not_rtlcn268,Channel_status_out_5_EXMPLR1314,not_R,rtlc12n229,C,
   Bus_B_shut_down_EXMPLR1226) ;
   DFFPCE (not_rtlcn268,Channel_status_out_5_EXMPLR1314,not_R,rtlc12n228,C,
   Bus_A_shut_down_EXMPLR1225) ;
   rtlc9_1006_gt_816_nx0 <= Rcv_Gap_found(0) XOR No_Response_timeout(0) ;
   rtlc9_1006_gt_816_nx2 <= Rcv_Gap_found(1) XOR No_Response_timeout(1) ;
   rtlc9_1006_gt_816_nx4 <= Rcv_Gap_found(2) XOR No_Response_timeout(2) ;
   rtlc_1981_or_851_nx0 <= rtlcs48 OR rtlcs54 ;
   rtlc12n238 <= rtlc_1981_or_851_nx0 OR rtlcs56 ;
   rtlc_2196_and_852_nx0 <= mode_command AND rtlcn1487 ;
   rtlcn1559 <= rtlc_2196_and_852_nx0 AND rtlcn1493 ;
   rtlc_2198_and_853_nx0 <= rtlc9n1359 AND not_rtlcn1480 ;
   rtlcn1561 <= rtlc_2198_and_853_nx0 AND not_rtlcn1508 ;
   rtlc_2199_or_854_nx0 <= rtlcn1558 OR rtlcn1559 ;
   rtlcn1340 <= rtlc_2199_or_854_nx0 OR rtlcn1561 ;
   rtlc_2210_or_855_nx0 <= rtlcn1060 OR rtlcn1495 ;
   rtlcn1474 <= rtlc_2210_or_855_nx0 OR rtlcn1565 ;
   rtlc_2223_and_857_nx0 <= RxRdy AND not_rtlc9n1359 ;
   rtlcn1574 <= rtlc_2223_and_857_nx0 AND rtlcn1500 ;
   rtlcn392 <= rtlc_2198_and_853_nx0 AND rtlcn1486 ;
   rtlc_2248_and_859_nx0 <= rcv_state(1) AND not_rtlc9n2221 ;
   rtlcn513 <= rtlc_2248_and_859_nx0 AND rtlcn1493 ;
   rtlc_2256_and_860_nx0 <= not_rtlc9n1833 AND not_rtlc9n1825 ;
   rtlcn1593 <= rtlc_2256_and_860_nx0 AND rtlcn1502 ;
   rtlc_2260_and_861_nx0 <= not_BCR AND rtlcn1497 ;
   rtlcn1594 <= rtlc_2260_and_861_nx0 AND rtlcn1503 ;
   rtlc_2273_and_862_nx0 <= Active_Bus_A_EXMPLR1205 AND rtlc6n658 ;
   rtlcn1598 <= rtlc_2273_and_862_nx0 AND rtlcs21 ;
   rtlcn1599 <= rtlcn1619 AND rtlcs20 ;
   rtlcn1600 <= rtlcn1586 AND rtlcs21 ;
   rtlcn1601 <= rtlcn1617 AND rtlcs19 ;
   rtlc_2301_or_868_nx0 <= rtlcn1491 OR rtlcn1492 ;
   rtlc_2315_and_869_nx0 <= rtlc9n1359 AND BCR ;
   rtlcn1625 <= rtlc_2315_and_869_nx0 AND not_rtlcn1486 ;
   rtlc_2316_or_870_nx0 <= rtlcn1480 OR rtlcn1623 ;
   rtlcn1359 <= rtlc_2316_or_870_nx0 OR rtlcn1625 ;
   rtlc_2332_or_872_nx0 <= not_rtlcn1682 OR rtlcn1634 ;
   rtlcn1476 <= rtlc_2332_or_872_nx0 OR rtlcn1635 ;
   rtlc_2346_or_873_nx0 <= rtlc9n1902 OR not_rtlcn1474 ;
   rtlcn1400 <= rtlc_2346_or_873_nx0 OR rtlcn1643 ;
   rtlc_2537_or_874_nx0 <= rtlc9n1769 OR rtlc9n1856 ;
   rtlcn1680 <= rtlc_2537_or_874_nx0 OR rtlcn635 ;
   rtlc_2540_or_875_nx0 <= Valid_command_EXMPLR1261 OR rtlc9n1924 ;
   rtlc_2715_or_877_nx0 <= rtlc9n1924 OR rtlc9n2016 ;
   rtlcn1689 <= rtlc_2715_or_877_nx0 OR not_rtlc9n1895 ;
   rtlc_2733_or_879_nx0 <= rtlc9n1359 OR rtlc9n1585 ;
   rtlc9n1600 <= rtlc_2733_or_879_nx0 OR not_RxRdy ;
   rtlc_2797_and_886_nx0 <= not_Rcv_Gap_found_2 AND not_Rcv_Gap_found_1 ;
   rtlcs42 <= rtlc_2797_and_886_nx0 AND not_Rcv_Gap_found_0 ;
   rtlcs38 <= not_active_command_4 AND not_active_command_1 ;
   rtlcs33 <= rtlcs38 AND active_command_EXMPLR1380(0) ;
   rtlc_2897_and_892_nx0 <= not_Mode_req_1 AND not_Mode_req_5 ;
   rtlcs57 <= rtlc_2897_and_892_nx0 AND Mode_req(4) ;
   rtlc_2938_and_896_nx0 <= not_No_Response_timeout_2 AND 
   No_Response_timeout(1) ;
   rtlcs25 <= rtlc_2938_and_896_nx0 AND No_Response_timeout(0) ;
   rtlc_2941_and_897_nx0 <= No_Response_timeout(2) AND 
   not_No_Response_timeout_1 ;
   rtlcs24 <= rtlc_2941_and_897_nx0 AND not_No_Response_timeout_0 ;
   rtlcs23 <= rtlc_2941_and_897_nx0 AND No_Response_timeout(0) ;
   rtlc_2946_and_900_nx0 <= No_Response_timeout(2) AND 
   No_Response_timeout(1) ;
   rtlc9n1888 <= rtlc9n1813 when RxRdy = '1' else nx10 ;
   nx10 <= rtlc9n1821 when rtlcn967 = '1' else rtlc9n1653 ;
   nx239 <= Rcv_Gap_found(2) when rtlc9_1006_gt_816_nx4 = '1' else nx19 ;
   nx19 <= Rcv_Gap_found(1) when rtlc9_1006_gt_816_nx2 = '1' else nx23 ;
   nx23 <= Rcv_Gap_found(0) AND rtlc9_1006_gt_816_nx0 ;
   modgen_and_4 : and_5u_5u port map ( a(4)=>Write_Data_10_EXMPLR1268, a(3)
      =>Rcv_CS, a(2)=>not_RT_Address_valid, a(1)=>not_rtlc9n1856, a(0)=>
      rtlcs42, d=>rtlcs43);
   modgen_and_5 : and_7u_7u port map ( a(6)=>ri_9n8s1(5), a(5)=>
      not_ri_9n8s1_4, a(4)=>not_ri_9n8s1_3, a(3)=>not_ri_9n8s1_2, a(2)=>
      not_ri_9n8s1_1, a(1)=>not_ri_9n8s1_0, a(0)=>rtlcs37, d=>rtlc9n1487);
   modgen_and_6 : and_7u_7u port map ( a(6)=>rtlc9n1755(5), a(5)=>
      not_rtlc9n1755_4, a(4)=>not_rtlc9n1755_3, a(3)=>not_rtlc9n1755_2, a(2)
      =>not_rtlc9n1755_1, a(1)=>not_rtlc9n1755_0, a(0)=>rtlcs37, d=>
      rtlc9n1768);
   modgen_and_7 : and_5u_5u port map ( a(4)=>not_Write_Data_3, a(3)=>
      not_Write_Data_2, a(2)=>Write_Data_1_EXMPLR1277, a(1)=>
      not_Write_Data_0, a(0)=>rtlc9n1704, d=>rtlc9n1677);
   modgen_and_8 : and_5u_5u port map ( a(4)=>Mode_req(3), a(3)=>
      not_Mode_req_2, a(2)=>not_Mode_req_1, a(1)=>not_Mode_req_0, a(0)=>
      rtlcs50, d=>rtlcs48);
   modgen_and_9 : and_9u_9u port map ( a(8)=>Rcv_RAW_GAP(6), a(7)=>
      Rcv_RAW_GAP(5), a(6)=>Rcv_RAW_GAP(4), a(5)=>Rcv_RAW_GAP(3), a(4)=>
      Rcv_RAW_GAP(2), a(3)=>Rcv_RAW_GAP(1), a(2)=>Rcv_RAW_GAP(0), a(1)=>
      rtlc_2946_and_900_nx0, a(0)=>not_No_Response_timeout_0, d=>rtlc9n1989
   );
end SITAL_Technology_unfold_4468 ;


architecture INTERFACE_unfold_2 of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, PWR, nx42, nx44, nx46, 
      nx48, nx50, NOT_nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx25 ;
   q(3) <= nx27 ;
   q(2) <= nx29 ;
   q(1) <= nx31 ;
   q(0) <= nx33 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 OR sclear ;
   nx21 <= nx18 AND clk_en ;
   DFFPCE (nx24,GND,aclear,nx21,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx21,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx21,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx21,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx21,clock,nx33) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx25, a(3)=>nx27, a(2)=>
      nx29, a(1)=>nx31, a(0)=>nx33, d(4)=>nx34, d(3)=>nx35, d(2)=>nx36, d(1)
      =>nx37, d(0)=>nx38, cout=>DANGLING(0));
   PWR <= '1' ;
   nx42 <= data(4) when sload = '1' else nx34 ;
   nx44 <= data(3) when sload = '1' else nx35 ;
   nx46 <= data(2) when sload = '1' else nx36 ;
   nx48 <= data(1) when sload = '1' else nx37 ;
   nx50 <= data(0) when sload = '1' else nx38 ;
   NOT_nx17 <= NOT sclear ;
   nx24 <= nx42 AND NOT_nx17 ;
   nx26 <= nx44 AND NOT_nx17 ;
   nx28 <= nx46 AND NOT_nx17 ;
   nx30 <= nx48 AND NOT_nx17 ;
   nx32 <= nx50 AND NOT_nx17 ;
end INTERFACE_unfold_2 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_sload_sclear_aclear_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_sload_sclear_aclear_clock_clk_en_0_5 ;

architecture INTERFACE of counter_up_sload_sclear_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, PWR, nx33, nx35, nx37, nx39, nx41, 
      NOT_SCLEAR: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   PWR <= '1' ;
   nx33 <= data(4) when sload = '1' else nx25 ;
   nx35 <= data(3) when sload = '1' else nx26 ;
   nx37 <= data(2) when sload = '1' else nx27 ;
   nx39 <= data(1) when sload = '1' else nx28 ;
   nx41 <= data(0) when sload = '1' else nx29 ;
   NOT_SCLEAR <= NOT sclear ;
   nx15 <= nx33 AND NOT_SCLEAR ;
   nx17 <= nx35 AND NOT_SCLEAR ;
   nx19 <= nx37 AND NOT_SCLEAR ;
   nx21 <= nx39 AND NOT_SCLEAR ;
   nx23 <= nx41 AND NOT_SCLEAR ;
end INTERFACE ;


architecture INTERFACE of counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx22, nx25, nx26, nx27, nx28, nx29, nx30, nx31, nx32, 
      nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, 
      nx45, PWR, NOT_nx18: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx26 ;
   q(5) <= nx28 ;
   q(4) <= nx30 ;
   q(3) <= nx32 ;
   q(2) <= nx34 ;
   q(1) <= nx36 ;
   q(0) <= nx38 ;
   GND <= '0' ;
   nx19 <= cnt_en OR sclear ;
   nx22 <= nx19 AND clk_en ;
   DFFPCE (nx25,GND,aclear,nx22,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,nx22,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,nx22,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx22,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx22,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx22,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx22,clock,nx38) ;
   inc : inc_7u_7u_0_0 port map ( cin=>PWR, a(6)=>nx26, a(5)=>nx28, a(4)=>
      nx30, a(3)=>nx32, a(2)=>nx34, a(1)=>nx36, a(0)=>nx38, d(6)=>nx39, d(5)
      =>nx40, d(4)=>nx41, d(3)=>nx42, d(2)=>nx43, d(1)=>nx44, d(0)=>nx45, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx18 <= NOT sclear ;
   nx25 <= nx39 AND NOT_nx18 ;
   nx27 <= nx40 AND NOT_nx18 ;
   nx29 <= nx41 AND NOT_nx18 ;
   nx31 <= nx42 AND NOT_nx18 ;
   nx33 <= nx43 AND NOT_nx18 ;
   nx35 <= nx44 AND NOT_nx18 ;
   nx37 <= nx45 AND NOT_nx18 ;
end INTERFACE ;


architecture INTERFACE of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, PWR, nx42, nx44, nx46, 
      nx48, nx50, NOT_nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx25 ;
   q(3) <= nx27 ;
   q(2) <= nx29 ;
   q(1) <= nx31 ;
   q(0) <= nx33 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 OR sclear ;
   nx21 <= nx18 AND clk_en ;
   DFFPCE (nx24,GND,aclear,nx21,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx21,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx21,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx21,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx21,clock,nx33) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx25, a(3)=>nx27, a(2)=>
      nx29, a(1)=>nx31, a(0)=>nx33, d(4)=>nx34, d(3)=>nx35, d(2)=>nx36, d(1)
      =>nx37, d(0)=>nx38, cout=>DANGLING(0));
   PWR <= '1' ;
   nx42 <= data(4) when sload = '1' else nx34 ;
   nx44 <= data(3) when sload = '1' else nx35 ;
   nx46 <= data(2) when sload = '1' else nx36 ;
   nx48 <= data(1) when sload = '1' else nx37 ;
   nx50 <= data(0) when sload = '1' else nx38 ;
   NOT_nx17 <= NOT sclear ;
   nx24 <= nx42 AND NOT_nx17 ;
   nx26 <= nx44 AND NOT_nx17 ;
   nx28 <= nx46 AND NOT_nx17 ;
   nx30 <= nx48 AND NOT_nx17 ;
   nx32 <= nx50 AND NOT_nx17 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (3 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (3 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4 ;

architecture INTERFACE of counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx13, nx16, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, PWR, NOT_nx12: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(3) <= nx20 ;
   q(2) <= nx22 ;
   q(1) <= nx24 ;
   q(0) <= nx26 ;
   GND <= '0' ;
   nx13 <= cnt_en OR sclear ;
   nx16 <= nx13 AND clk_en ;
   DFFPCE (nx19,GND,aclear,nx16,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,nx16,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,nx16,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,nx16,clock,nx26) ;
   inc : inc_4u_4u_0_0 port map ( cin=>PWR, a(3)=>nx20, a(2)=>nx22, a(1)=>
      nx24, a(0)=>nx26, d(3)=>nx27, d(2)=>nx28, d(1)=>nx29, d(0)=>nx30, cout
      =>DANGLING(0));
   PWR <= '1' ;
   NOT_nx12 <= NOT sclear ;
   nx19 <= nx27 AND NOT_nx12 ;
   nx21 <= nx28 AND NOT_nx12 ;
   nx23 <= nx29 AND NOT_nx12 ;
   nx25 <= nx30 AND NOT_nx12 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_sload_aclear_clock_clk_en_0_7 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (6 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_sload_aclear_clock_clk_en_0_7 ;

architecture INTERFACE of counter_up_sload_aclear_clock_clk_en_0_7 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR1454: std_logic_vector (6 DOWNTO 0) ;
   
   signal nx15, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, nx27, nx28, 
      nx29, nx30, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx41
   : std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx20 ;
   q(5) <= nx22 ;
   q(4) <= nx24 ;
   q(3) <= nx26 ;
   q(2) <= nx28 ;
   q(1) <= nx30 ;
   q(0) <= nx32 ;
   nx15 <= '0' ;
   DFFPCE (nx19,nx15,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx15,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx15,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,nx15,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,nx15,aclear,clk_en,clock,nx28) ;
   DFFPCE (nx29,nx15,aclear,clk_en,clock,nx30) ;
   DFFPCE (nx31,nx15,aclear,clk_en,clock,nx32) ;
   inc : inc_7u_7u_0_0 port map ( cin=>nx41, a(6)=>nx20, a(5)=>nx22, a(4)=>
      nx24, a(3)=>nx26, a(2)=>nx28, a(1)=>nx30, a(0)=>nx32, d(6)=>nx33, d(5)
      =>nx34, d(4)=>nx35, d(3)=>nx36, d(2)=>nx37, d(1)=>nx38, d(0)=>nx39, 
      cout=>DANGLING(0));
   nx41 <= '1' ;
   nx19 <= data(6) when sload = '1' else nx33 ;
   nx21 <= data(5) when sload = '1' else nx34 ;
   nx23 <= data(4) when sload = '1' else nx35 ;
   nx25 <= data(3) when sload = '1' else nx36 ;
   nx27 <= data(2) when sload = '1' else nx37 ;
   nx29 <= data(1) when sload = '1' else nx38 ;
   nx31 <= data(0) when sload = '1' else nx39 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity decoder_4 is 
   port (
      data : IN std_logic_vector (3 DOWNTO 0) ;
      eq : OUT std_logic_vector (15 DOWNTO 0)) ;
end decoder_4 ;

architecture INTERFACE of decoder_4 is 
   component eq_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal data_EXMPLR1476: std_logic_vector (3 DOWNTO 0) ;
   
   signal eq_EXMPLR1477: std_logic_vector (15 DOWNTO 0) ;
   
   signal nx24, nx26: std_logic ;

begin
   nx24 <= '0' ;
   nx26 <= '1' ;
   cmp_15 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(15));
   cmp_14 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(14));
   cmp_13 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(13));
   cmp_12 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(12));
   cmp_11 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(11));
   cmp_10 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(10));
   cmp_9 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(9));
   cmp_8 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(8));
   cmp_7 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(7));
   cmp_6 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(6));
   cmp_5 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(5));
   cmp_4 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(4));
   cmp_3 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(3));
   cmp_2 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(2));
   cmp_1 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(1));
   cmp_0 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity H15530_Ver17_32_0 is 
   port (
      CE : IN std_logic ;
      Check_loop_back : IN std_logic ;
      Check_value : IN std_logic ;
      Clock : IN std_logic ;
      Minus : IN std_logic ;
      PP194_CS : IN std_logic ;
      Plus : IN std_logic ;
      ResetN : IN std_logic ;
      Xmitting : IN std_logic ;
      Bi_error : OUT std_logic ;
      H15530_record_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
      H15530_record_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
      H15530_record_Sync_error : OUT std_logic ;
      H15530_record_Manchester_error : OUT std_logic ;
      H15530_record_Parity_error : OUT std_logic ;
      H15530_record_echo_back_bus : OUT std_logic ;
      H15530_record_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      H15530_record_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
      H15530_record_RxRDY_plus_12us : OUT std_logic ;
      H15530_record_RxRDY_plus_10us : OUT std_logic ;
      H15530_record_CS : OUT std_logic ;
      H15530_record_Pre_EchoRdy : OUT std_logic ;
      H15530_record_Command_Sync : OUT std_logic ;
      H15530_record_Pre_RxRdy : OUT std_logic ;
      H15530_record_recieving : OUT std_logic ;
      Echo_Error : OUT std_logic ;
      Parity_error : OUT std_logic ;
      Sync_error : OUT std_logic) ;
end H15530_Ver17_32_0 ;

architecture Sital_technology_unfold_1 of H15530_Ver17_32_0 is 
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component addsub_6u_6u_6u_0
      port (
         mode : IN std_logic ;
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_7u_7u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component mux_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_4u_4u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_sload_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (3 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component sub_6u_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_sload_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component decoder_4
      port (
         data : IN std_logic_vector (3 DOWNTO 0) ;
         eq : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   component and_12u_12u
      port (
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_gap_phase : 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE_unfold_2
   );
   for modgen_counter_Bit_number : 
   counter_up_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE);
   for modgen_counter_RxRdy_plus_us : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7(INTERFACE);
   for modgen_counter_RxRdy_plus_phase : 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE);
   for modgen_counter_Bit_Gap : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4(INTERFACE);
   for modgen_counter_one_shot : counter_up_sload_aclear_clock_clk_en_0_7
    use entity work.counter_up_sload_aclear_clock_clk_en_0_7(INTERFACE);
   
   for ix78 : decoder_4 use entity work.decoder_4(INTERFACE);
   signal Sync_error_EXMPLR1487, Advance, Big_Bit_Gap, Bit_Gap_3: std_logic
    ;
   
   signal Bit_number: std_logic_vector (4 DOWNTO 0) ;
   
   signal Bit_value, Calc_parity, Clean_minus, Clean_plus, Echo, 
      Found_CMD_Sync: std_logic ;
   
   signal Len: std_logic_vector (5 DOWNTO 0) ;
   
   signal Level_minus: std_logic ;
   
   signal Minus_shifter: std_logic_vector (8 DOWNTO 0) ;
   
   signal Phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal Plus_shifter: std_logic_vector (8 DOWNTO 0) ;
   
   signal Recieving, RxRdy: std_logic ;
   
   signal RxRdy_plus_phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal RxRdy_plus_us: std_logic_vector (6 DOWNTO 0) ;
   
   signal Stall, Strobe: std_logic ;
   
   signal energy: std_logic_vector (5 DOWNTO 0) ;
   
   signal first_sync: std_logic ;
   
   signal gap_phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal level_plus, minus_d, minus_d_falling_edge, minus_dd, 
      minus_dd_falling_edge: std_logic ;
   
   signal one_shot: std_logic_vector (6 DOWNTO 0) ;
   
   signal plus_d, plus_d_falling_edge, plus_dd, plus_dd_falling_edge, 
      resync_after_fault: std_logic ;
   
   signal Rcv_Filter: std_logic_vector (6 DOWNTO 0) ;
   
   signal state: std_logic_vector (1 DOWNTO 0) ;
   
   signal PWR: std_logic ;
   
   signal H15530_record_Bit_number_EXMPLR1529: std_logic_vector (4 DOWNTO 4)
    ;
   
   signal not_H15530_record_Manchester_error, not_ResetN, plus_dd_5n1ss1, 
      minus_dd_5n2ss1, rtlc5n44, not_Clock, plus_dd_falling_edge_11n1ss1, 
      minus_dd_falling_edge_11n2ss1, rtlc11n36, not_Minus_shifter_3, 
      rtlc14n57, not_Plus_shifter_3, rtlc14n77, Clean_plus_17n1s3, 
      Clean_plus_17n1s6, Clean_plus_17n1s2, Clean_plus_17n1s9, 
      Clean_plus_17n1s1, Clean_minus_17n1s3, Clean_minus_17n1s6, 
      Clean_minus_17n1s2, Clean_minus_17n1s9, Clean_minus_17n1s1, rtlc20n30, 
      not_minus_dd, rtlc20n32, rtlc20n33: std_logic ;
   
   signal energy_23n9ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc23n81, rtlc23n83, rtlc23n85, rtlc23n95, not_rtlc23n95, 
      not_rtlc23n85, rtlc23n150: std_logic ;
   
   signal energy_23n6s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_rtlc23n150, not_CE, rtlc23n193, not_Xmitting, not_rtlcn148, 
      rtlc23n217, not_rtlc23n394, rtlc23n258, rtlc23n259, rtlc23n361, 
      not_rtlcn154, rtlc23n378, rtlc23n379, not_energy_5, not_rtlcn155, 
      rtlc23n394, rtlc23n451, rtlc23n541, rtlc23n542, rtlc23n543, rtlc23n544, 
      rtlc23n547, rtlc26n62, rtlc26n79, rtlc26n93, rtlc26n95, not_rtlc26n93, 
      not_Clean_plus, rtlc29n57, not_Clean_minus: std_logic ;
   
   signal Actual_gap_35n1ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Gap_35n13ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Actual_gap_35n1s1: std_logic_vector (6 DOWNTO 1) ;
   
   signal not_rtlcs5, not_rtlcs40, rtlc35n264, not_rtlcs36: std_logic ;
   
   signal Gap_35n11s1: std_logic_vector (6 DOWNTO 0) ;
   
   signal not_rtlcs0, rtlc35n310, not_rtlc35n267, rtlc35_X_0_n377, 
      not_rtlc35n653, rtlc35n442, rtlc35n452, rtlc35n569, not_rtlc35n569, 
      not_RxRdy_plus_us_2, rtlc35n572, not_rtlcn161, rtlc35n612, rtlc35n613, 
      rtlc35n629, rtlc35n652, rtlc35n653, rtlc35n670, not_RxRdy_plus_us_6, 
      rtlc35n685, not_rtlc35n685, rtlc35n690, rtlc35n691: std_logic ;
   
   signal Phase_38n15ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Phase_38n17ss1_4, Phase_38n17ss1_2, Phase_38n17ss1_1, 
      Phase_38n17ss1_0: std_logic ;
   
   signal Phase_38n18ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc38n268: std_logic ;
   
   signal Phase_38n5s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal not_Manchester_error_41n2s2, not_Manchester_error_41n2s1, 
      rtlc38n365, rtlc38n367, rtlc38n368, not_rtlc38n368, rtlc38n389, 
      rtlc38n390, rtlc38n393, rtlc38n403, not_Bit_value, rtlc38n405, 
      rtlc38n406, rtlc38n407, not_rtlc38n407, rtlc38n420: std_logic ;
   
   signal Phase_38n15s1: std_logic_vector (4 DOWNTO 1) ;
   
   signal rtlc38n449, rtlc38n453, rtlc38n455, rtlc38n482, rtlc38n483, 
      not_rtlc38n483, rtlc38n485, not_rtlcs21, rtlc38_X_0_n587, rtlc38n588, 
      rtlc38n614, rtlc38n615, rtlc38n616, not_rtlc38n588, rtlc38n665, 
      rtlc38n666, rtlc38n667, rtlc38n668, rtlc38n669, rtlc38n770, rtlc38n771, 
      rtlc38n772, Manchester_error_41n2ss1, Bit_value_41n4ss1, 
      Manchester_error_41n4ss1, Manchester_error_41n2s1, 
      Manchester_error_41n2s2, rtlc41n108, rtlc41n109, Strobe_44n1s1, 
      Sync_error_47n7ss1, Command_sync_47n10ss1, Calc_parity_47n10ss1, 
      Sync_error_47n10ss1, rtlc47n218, rtlc47n235, Data_47n4s3_3, 
      Data_47n4s3_1, Data_47n4s3_0: std_logic ;
   
   signal Data_47n4s2: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlc47n417, Sync_error_47n7s1, not_rtlcn158, Calc_parity_47n7s1, 
      rtlc47n426, rtlc47n433, rtlc47n437, rtlc47n453, not_rtlc47n630, 
      rtlc47n551, rtlc47n552, rtlc47n553, rtlc47n571, rtlc47n614, 
      not_rtlc47n614, rtlc47n630, rtlc47n644, RxRdy_plus_10us_50n4s1, 
      not_rtlcs42, rtlc50n176, not_rtlc50n176, not_RxRdy, rtlc50_X_0_n204, 
      Found_CMD_Sync_56n8ss1: std_logic ;
   
   signal Len_56n8ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal state_fsm_56n8ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal state_fsm_56n9ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal Len_56n6s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc56n169, rtlc56n176, rtlc56n177, not_rtlc56n177, rtlc56n179, 
      Rcv_Filter_fsm_59n4ss1_4, Rcv_Filter_fsm_59n6ss1_3, 
      Rcv_Filter_fsm_59n13ss1_4, Rcv_Filter_fsm_59n13ss1_3, 
      Rcv_Filter_fsm_59n16ss1_6, Rcv_Filter_fsm_59n16ss1_5, 
      Rcv_Filter_fsm_59n16ss1_4, Rcv_Filter_fsm_59n16ss1_3, rtlc59n252, 
      rtlc59n281, rtlc59n430, not_rtlc59n464, not_rtlc59n467, rtlc59n464, 
      rtlc59n467, rtlc59n669, rtlc59n671, not_rtlcn160, rtlc62n94, 
      not_rtlc62n36, rtlcn148, rtlcn154, rtlcn155, rtlcn157, rtlcn158, 
      rtlcn159, rtlcn160, rtlcn161, rtlcn163, rtlcn290, rtlcn295, rtlcn300, 
      rtlcn305, rtlcn310, rtlcn315, rtlcn320, rtlcn325, rtlcn330, rtlcn335, 
      rtlcn340, rtlcn345, rtlcn350, rtlcn355, rtlcn360, rtlcn365, rtlcn371, 
      rtlcn399, rtlcn403, rtlcn407, rtlcn409, rtlcn410, not_rtlcn1057, 
      rtlcn445, rtlcn455, rtlcn482, rtlcn483, rtlcn495, rtlcn501, rtlcn502, 
      rtlcn508, rtlcn509, rtlcn519, rtlcn535, rtlcn581, rtlcn591, rtlcn623, 
      rtlcn648, rtlcn698, rtlcn738, rtlcn739, rtlcn740, rtlcn756, rtlcn757, 
      rtlcn758, rtlcn838, not_rtlcn1213, rtlcn843, rtlcn876, rtlcn998, 
      rtlcn1009, rtlcn1011, not_rtlcn1209, rtlcn1038, not_rtlcn1210, 
      rtlcn1057, rtlcn1058, not_state_1, not_state_0, rtlcn1074, rtlcn1075, 
      rtlcn1076, rtlcn1077, rtlcn1078, rtlcn1079, rtlcn1080, rtlcn1082, 
      rtlcn1083, rtlcn1084, rtlcn1085, rtlcn1086, rtlcn1087, rtlcn1088, 
      rtlcn1089, rtlcn1090, not_Advance, not_rtlcs18, not_rtlc38n485, 
      not_rtlc38n455, rtlcn1096, rtlcn1097, not_Recieving, rtlcn1099, 
      rtlcn1101, not_rtlcn698, not_rtlc59n252, not_rtlc59n281, 
      not_rtlc35n691, not_rtlcn1211, not_rtlcn1212, not_rtlc35n613, 
      not_rtlc35n629, not_RxRdy_plus_us_4, rtlcn1118, not_RxRdy_plus_us_3, 
      rtlcn1121, rtlcn1122, rtlcn1124, rtlcn1125, rtlcn1126, rtlcn1127, 
      not_rtlc56n179, rtlcn1130, not_rtlc23n451, not_rtlc23n379, rtlcn1133, 
      not_Stall, not_rtlcs35, rtlcn1140, rtlcn1141, rtlcn1142, rtlcn1143, 
      not_rtlc20n33, rtlcn1148, rtlcn1149, rtlcn1150, rtlcn1151, 
      not_rtlcn371, not_rtlcn399, rtlcn1208, rtlcn1209, rtlcn1210, rtlcn1211, 
      rtlcn1212, rtlcn1213, rtlcn1214, rtlcn1215, rtlcn1217, rtlcn1218, 
      rtlcn1219, rtlcn1220, rtlcn1221, rtlcn1222, rtlcn1223, rtlcn1224, 
      rtlcn1226, rtlcn1227, rtlcn1228, rtlcn1229, rtlcn1230, rtlcn1231, 
      not_rtlc23n217, not_rtlc23n193, not_rtlc26n62, not_rtlc35n310, 
      not_rtlcn1088, rtlcn1239, not_rtlc38n420, not_rtlcn1287, rtlcn1246, 
      rtlcn1247, rtlcn1248, not_Strobe, not_rtlcn1215, not_rtlc47n218, 
      rtlcn1256, not_rtlcn1387, rtlcn1259, rtlcn1260, not_rtlcn1214, 
      rtlcn1262, rtlcs0, rtlcs1, not_Phase_4, rtlcs3, rtlcs4, rtlcs5, rtlcs7, 
      rtlcs8, rtlcs10, rtlcs11, rtlcs13, rtlcs14, rtlcs15, rtlcs16, rtlcs17, 
      rtlcs18, rtlcs20, rtlcs21, rtlcs22, rtlcs23, rtlcs24, rtlcs25, rtlcs27, 
      rtlcs28, rtlcs30, rtlcs32, rtlcs35, rtlcs36, rtlcs37, rtlcs40, rtlcs42, 
      rtlcs44, rtlcs45, rtlcs46, rtlcs47, rtlcs48, not_Bit_number_4, 
      not_Bit_number_3, not_Bit_number_2, not_rtlc5n44, not_rtlc11n36, 
      not_rtlcn455, not_Found_CMD_Sync, not_Phase_3, not_Phase_1, 
      not_rtlcs13, rtlcn1287, not_Phase_2, not_Phase_0, not_rtlcn623, 
      not_rtlc56n169, not_Len_4, not_Len_2, not_Len_1, not_Len_0, not_Len_3, 
      not_rtlcs17, not_rtlcn509, rtlcn1387, not_energy_4, not_energy_3, 
      not_energy_2, not_energy_1, not_energy_0, not_rtlcs25, not_rtlc35n572, 
      not_RxRdy_plus_us_5, not_RxRdy_plus_us_1, not_RxRdy_plus_us_0, 
      not_RxRdy_plus_phase_4, not_RxRdy_plus_phase_3, not_RxRdy_plus_phase_2, 
      not_RxRdy_plus_phase_1, not_RxRdy_plus_phase_0, not_Echo, rtlcn1698, 
      rtlcn1701, rtlcn1715, not_Bit_Gap_3, not_rtlc38n616, 
      H15530_record_Manchester_error_EXMPLR1489: std_logic ;
   
   signal H15530_record_RAW_GAP_EXMPLR1531: std_logic_vector (6 DOWNTO 0) ;
   
   signal H15530_record_Command_Sync_EXMPLR1526: std_logic ;
   
   signal energy_23n6s1f1: std_logic_vector (1 DOWNTO 0) ;
   
   signal rtlc47n629, rtlc35_142_and_907_nx0, rtlc50_43_and_930_nx0, 
      rtlc59_194_or_932_nx0, rtlc59_198_or_933_nx0, rtlc59_670_or_935_nx0, 
      rtlc_232_and_937_nx0, rtlc_233_and_938_nx0, rtlc_235_and_939_nx0, 
      rtlc_320_and_940_nx0, rtlc_1479_or_956_nx0, rtlc_1621_or_957_nx0, 
      rtlc_1629_or_958_nx0, rtlc_1633_and_959_nx0, rtlc_1638_and_960_nx0, 
      rtlc_1656_and_961_nx0, rtlc_1677_and_963_nx0, rtlc_1681_or_964_nx0, 
      rtlc62n36, rtlc_1722_and_970_nx0, rtlc_1725_and_971_nx0, 
      rtlc_1729_and_972_nx0, rtlc_1731_and_973_nx0, rtlc_1742_or_974_nx0, 
      rtlc_2046_or_976_nx0, rtlc_2067_and_977_nx0, rtlc35n267, 
      rtlc_2106_and_980_nx0, rtlcs12, rtlc_2228_and_984_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (19 downto 0 );

begin
   Bi_error <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Bit_number(4) <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Bit_number(3) <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Bit_number(2) <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Bit_number(1) <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Bit_number(0) <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Response_Time(7) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(6) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(5) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(4) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(3) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(2) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(1) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Response_Time(0) <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Sync_error <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Manchester_error <= H15530_record_Bit_number_EXMPLR1529(4)
    ;
   H15530_record_Parity_error <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_echo_back_bus <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_RAW_GAP(6) <= H15530_record_RAW_GAP_EXMPLR1531(6) ;
   H15530_record_RAW_GAP(5) <= H15530_record_RAW_GAP_EXMPLR1531(5) ;
   H15530_record_RAW_GAP(4) <= H15530_record_RAW_GAP_EXMPLR1531(4) ;
   H15530_record_RAW_GAP(3) <= H15530_record_RAW_GAP_EXMPLR1531(3) ;
   H15530_record_RAW_GAP(2) <= H15530_record_RAW_GAP_EXMPLR1531(2) ;
   H15530_record_RAW_GAP(1) <= H15530_record_RAW_GAP_EXMPLR1531(1) ;
   H15530_record_RAW_GAP(0) <= H15530_record_RAW_GAP_EXMPLR1531(0) ;
   H15530_record_RxRDY_plus_12us <= H15530_record_Bit_number_EXMPLR1529(4) ;
   H15530_record_Command_Sync <= H15530_record_Command_Sync_EXMPLR1526 ;
   Parity_error <= H15530_record_Bit_number_EXMPLR1529(4) ;
   Sync_error <= Sync_error_EXMPLR1487 ;
   PWR <= '1' ;
   H15530_record_Bit_number_EXMPLR1529(4) <= '0' ;
   not_Clock <= NOT Clock ;
   rtlc14n77 <= Minus_shifter(3) AND not_Plus_shifter_3 ;
   rtlc14n57 <= Plus_shifter(3) AND not_Minus_shifter_3 ;
   not_Minus_shifter_3 <= NOT Minus_shifter(3) ;
   not_Plus_shifter_3 <= NOT Plus_shifter(3) ;
   Clean_plus_17n1s1 <= Clean_plus_17n1s2 OR Clean_plus_17n1s9 ;
   Clean_plus_17n1s2 <= Clean_plus_17n1s3 OR Clean_plus_17n1s6 ;
   Clean_plus_17n1s3 <= Plus_shifter(2) AND Plus_shifter(1) ;
   Clean_plus_17n1s6 <= Plus_shifter(2) AND Plus_shifter(0) ;
   Clean_plus_17n1s9 <= Plus_shifter(1) AND Plus_shifter(0) ;
   Clean_minus_17n1s1 <= Clean_minus_17n1s2 OR Clean_minus_17n1s9 ;
   Clean_minus_17n1s2 <= Clean_minus_17n1s3 OR Clean_minus_17n1s6 ;
   Clean_minus_17n1s3 <= Minus_shifter(2) AND Minus_shifter(1) ;
   Clean_minus_17n1s6 <= Minus_shifter(2) AND Minus_shifter(0) ;
   Clean_minus_17n1s9 <= Minus_shifter(1) AND Minus_shifter(0) ;
   not_minus_dd <= NOT minus_dd ;
   rtlc20n33 <= rtlc20n30 AND rtlc20n32 ;
   not_Xmitting <= NOT Xmitting ;
   not_rtlc23n150 <= NOT rtlc23n150 ;
   rtlc23n150 <= not_rtlcn154 AND first_sync ;
   not_rtlc23n95 <= NOT rtlc23n95 ;
   rtlc23n95 <= rtlc23n150 OR rtlcs35 ;
   rtlc23n81 <= plus_dd OR plus_dd_falling_edge ;
   rtlc23n83 <= rtlc23n81 OR minus_dd ;
   rtlc23n85 <= rtlc23n83 OR minus_dd_falling_edge ;
   rtlc23n378 <= energy(0) AND energy(1) ;
   not_rtlc23n394 <= NOT rtlc23n394 ;
   not_energy_5 <= NOT energy(5) ;
   rtlc23n394 <= not_rtlcn155 OR not_energy_5 ;
   rtlc23_203_or_905 : or_5u_5u port map ( a(4)=>energy(1), a(3)=>energy(2), 
      a(2)=>energy(3), a(1)=>energy(4), a(0)=>energy(5), d=>rtlc23n451);
   rtlc23n547 <= rtlc23n542 OR rtlc23n543 ;
   energy_addsub6_23i1 : addsub_6u_6u_6u_0 port map ( mode=>rtlcn371, cin=>
      not_rtlcn371, a(5)=>energy(5), a(4)=>energy(4), a(3)=>energy(3), a(2)
      =>energy(2), a(1)=>energy(1), a(0)=>energy(0), b(5)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(4)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>energy_23n6s1f1(1), b(0)
      =>energy_23n6s1f1(0), d(5)=>energy_23n6s1(5), d(4)=>energy_23n6s1(4), 
      d(3)=>energy_23n6s1(3), d(2)=>energy_23n6s1(2), d(1)=>energy_23n6s1(1), 
      d(0)=>energy_23n6s1(0), cout=>DANGLING(0));
   rtlc26n95 <= energy(3) AND energy(2) ;
   not_rtlcs0 <= NOT rtlcs0 ;
   not_rtlcs5 <= NOT rtlcs5 ;
   Gap_inc7_35i2 : inc_7u_7u_0 port map ( cin=>PWR, a(6)=>
      H15530_record_RAW_GAP_EXMPLR1531(6), a(5)=>
      H15530_record_RAW_GAP_EXMPLR1531(5), a(4)=>
      H15530_record_RAW_GAP_EXMPLR1531(4), a(3)=>
      H15530_record_RAW_GAP_EXMPLR1531(3), a(2)=>
      H15530_record_RAW_GAP_EXMPLR1531(2), a(1)=>
      H15530_record_RAW_GAP_EXMPLR1531(1), a(0)=>
      H15530_record_RAW_GAP_EXMPLR1531(0), d(6)=>Gap_35n11s1(6), d(5)=>
      Gap_35n11s1(5), d(4)=>Gap_35n11s1(4), d(3)=>Gap_35n11s1(3), d(2)=>
      Gap_35n11s1(2), d(1)=>Gap_35n11s1(1), d(0)=>Gap_35n11s1(0), cout=>
      DANGLING(1));
   rtlc35_286_or_910 : or_4u_4u port map ( a(3)=>RxRdy_plus_us(3), a(2)=>
      RxRdy_plus_us(4), a(1)=>RxRdy_plus_us(5), a(0)=>RxRdy_plus_us(6), d=>
      rtlc35n569);
   not_rtlc35n569 <= NOT rtlc35n569 ;
   not_RxRdy_plus_us_2 <= NOT RxRdy_plus_us(2) ;
   rtlc35n572 <= not_rtlc35n569 AND not_RxRdy_plus_us_2 ;
   rtlc35n612 <= not_RxRdy_plus_us_2 OR not_rtlcn161 ;
   rtlc35n613 <= not_rtlc35n569 AND rtlc35n612 ;
   rtlc35n653 <= not_rtlc35n629 AND rtlc35n652 ;
   rtlc35n670 <= RxRdy_plus_us(4) AND RxRdy_plus_us(3) ;
   not_RxRdy_plus_us_6 <= NOT RxRdy_plus_us(6) ;
   rtlc35n685 <= RxRdy_plus_us(5) AND RxRdy_plus_us(4) ;
   not_rtlc35n685 <= NOT rtlc35n685 ;
   rtlc35n690 <= not_rtlc35n685 OR rtlcn1121 ;
   rtlc35n691 <= not_RxRdy_plus_us_6 AND rtlc35n690 ;
   not_rtlcs21 <= NOT rtlcs21 ;
   rtlc38_134_and_911 : and_4u_4u port map ( a(3)=>not_rtlcs21, a(2)=>
      not_rtlcs18, a(1)=>not_rtlc38n485, a(0)=>Recieving, d=>rtlc38_X_0_n587
   );
   rtlc38n588 <= not_CE OR rtlc38_X_0_n587 ;
   not_rtlc38n588 <= NOT rtlc38n588 ;
   rtlc38n615 <= rtlcs35 AND not_rtlc38n485 ;
   rtlc38n614 <= not_rtlcs18 AND not_rtlc38n485 ;
   rtlc38n616 <= rtlc38n614 OR rtlc38n615 ;
   rtlc38n483 <= rtlcs27 AND rtlc38n482 ;
   not_rtlc38n483 <= NOT rtlc38n483 ;
   rtlc38n485 <= Found_CMD_Sync AND not_rtlc38n483 ;
   rtlc38n449 <= rtlcs32 AND first_sync ;
   rtlc38n453 <= rtlc38n449 AND rtlcs13 ;
   rtlc38n455 <= rtlc38n453 AND Manchester_error_41n2s2 ;
   not_rtlc38n407 <= NOT rtlc38n407 ;
   not_Bit_value <= NOT Bit_value ;
   rtlc38n405 <= not_Bit_value AND level_plus ;
   rtlc38n403 <= Bit_value AND Level_minus ;
   rtlc38n406 <= rtlc38n403 OR rtlc38n405 ;
   rtlc38n407 <= rtlcs18 AND rtlc38n406 ;
   not_rtlc38n368 <= NOT rtlc38n368 ;
   rtlc38n367 <= not_Bit_value AND Level_minus ;
   rtlc38n365 <= Bit_value AND level_plus ;
   rtlc38n368 <= rtlc38n365 OR rtlc38n367 ;
   not_Manchester_error_41n2s1 <= NOT Manchester_error_41n2s1 ;
   not_Manchester_error_41n2s2 <= NOT Manchester_error_41n2s2 ;
   rtlc38n268 <= Echo AND not_Xmitting ;
   Sync_error_47n7s1 <= H15530_record_Manchester_error_EXMPLR1489 OR 
   Sync_error_EXMPLR1487 ;
   Phase_inc5_38i1 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>Phase(4), a(3)=>
      Phase(3), a(2)=>Phase(2), a(1)=>Phase(1), a(0)=>Phase(0), d(4)=>
      Phase_38n5s1(4), d(3)=>Phase_38n5s1(3), d(2)=>Phase_38n5s1(2), d(1)=>
      Phase_38n5s1(1), d(0)=>Phase_38n5s1(0), cout=>DANGLING(2));
   rtlc38n771 <= one_shot(5) OR rtlc38n770 ;
   rtlc38n772 <= one_shot(6) AND rtlc38n771 ;
   Calc_parity_47n7s1 <= Calc_parity XOR Bit_value ;
   rtlc47_110_select_929 : select_4_4 port map ( a(3)=>not_rtlc47n614, a(2)
      =>rtlcs32, a(1)=>rtlcs27, a(0)=>rtlcs35, b(3)=>
      not_H15530_record_Manchester_error, b(2)=>rtlc47n417, b(1)=>
      not_rtlcn158, b(0)=>rtlc47n433, d=>rtlc47n437);
   rtlc47n417 <= not_H15530_record_Manchester_error AND rtlc47n235 ;
   rtlc47n433 <= not_H15530_record_Manchester_error AND rtlc47n426 ;
   rtlc47n453 <= RxRdy OR rtlcs37 ;
   rtlc47n218 <= not_rtlc47n630 AND rtlcn159 ;
   not_rtlc47n614 <= NOT rtlc47n614 ;
   not_rtlc47n630 <= NOT rtlc47n630 ;
   rtlc47n630 <= rtlc47n629 AND Bit_number(4) ;
   not_RxRdy <= NOT RxRdy ;
   not_rtlcs42 <= NOT rtlcs42 ;
   rtlc50n176 <= rtlcs40 OR not_rtlcs42 ;
   not_rtlc50n176 <= NOT rtlc50n176 ;
   rtlc56n177 <= first_sync OR resync_after_fault ;
   rtlc56n176 <= Clean_plus OR Found_CMD_Sync ;
   rtlc56n179 <= rtlc56n176 OR not_rtlc56n177 ;
   rtlc56n169 <= Clean_plus AND rtlc56n177 ;
   Len_inc6_56i1 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>Len(5), a(4)=>
      Len(4), a(3)=>Len(3), a(2)=>Len(2), a(1)=>Len(1), a(0)=>Len(0), d(5)=>
      Len_56n6s1(5), d(4)=>Len_56n6s1(4), d(3)=>Len_56n6s1(3), d(2)=>
      Len_56n6s1(2), d(1)=>Len_56n6s1(1), d(0)=>Len_56n6s1(0), cout=>
      DANGLING(3));
   rtlc59n430 <= Rcv_Filter(5) OR Rcv_Filter(6) ;
   not_rtlc59n464 <= NOT rtlc59n464 ;
   not_rtlc59n467 <= NOT rtlc59n467 ;
   rtlc59n281 <= not_Clean_plus AND not_rtlcn160 ;
   rtlc59n252 <= not_Clean_minus AND not_rtlcn160 ;
   rtlc59n671 <= one_shot(3) AND one_shot(2) ;
   rtlc62n94 <= Bit_Gap_3 AND rtlc62n36 ;
   not_rtlc62n36 <= NOT rtlc62n36 ;
   not_rtlcn148 <= NOT rtlcn148 ;
   not_rtlcn154 <= NOT rtlcn154 ;
   not_rtlcn155 <= NOT rtlcn155 ;
   not_rtlc26n93 <= NOT rtlc26n93 ;
   rtlc26n93 <= energy(5) OR energy(4) ;
   not_rtlcn158 <= NOT rtlcn158 ;
   rtlc47n644 <= Bit_number(4) OR Bit_number(3) ;
   not_rtlcn160 <= NOT rtlcn160 ;
   not_rtlcn161 <= NOT rtlcn161 ;
   rtlcn148 <= rtlcs32 OR Xmitting ;
   rtlcn154 <= rtlc23n361 OR Bit_number(1) ;
   rtlcn155 <= energy(4) OR energy(3) ;
   rtlcn157 <= rtlc26n93 OR rtlc26n95 ;
   rtlcn158 <= H15530_record_Manchester_error_EXMPLR1489 OR rtlc47n235 ;
   rtlcn159 <= rtlc47n644 OR Bit_number(2) ;
   rtlcn160 <= rtlc59n669 OR rtlc59n671 ;
   rtlcn161 <= RxRdy_plus_us(1) OR RxRdy_plus_us(0) ;
   rtlcn163 <= rtlc35n629 OR rtlc35n670 ;
   Sync_error_47n7ss1 <= H15530_record_Manchester_error_EXMPLR1489 OR 
   rtlcn409 ;
   rtlc_597_mux_941 : mux_4u_4u port map ( a(3)=>rtlc56n169, a(2)=>PWR, a(1)
      =>H15530_record_Bit_number_EXMPLR1529(4), a(0)=>PWR, b(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>state(1), b(0)=>state(0), 
      d=>rtlcn1698);
   rtlc_600_mux_942 : mux_4u_4u port map ( a(3)=>not_rtlc56n169, a(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), a(1)=>PWR, a(0)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>state(1), b(0)=>state(0), 
      d=>rtlcn1701);
   state_fsm_mux_56i2 : mux_4u_4u port map ( a(3)=>rtlcn838, a(2)=>
      Clean_minus, a(1)=>not_rtlcn1213, a(0)=>rtlc56n169, b(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>state(1), b(0)=>state(0), 
      d=>state_fsm_56n8ss1(0));
   Phase_select_38i8Bus12_4 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(4), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n5s1(4), d=>
      Phase_38n15ss1(4));
   Phase_select_38i8Bus12_3 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(3), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n5s1(3), d=>
      Phase_38n15ss1(3));
   Phase_select_38i8Bus12_2 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(2), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n5s1(2), d=>
      Phase_38n15ss1(2));
   Phase_select_38i9Bus13_2 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n15ss1(2), d=>
      Phase_38n17ss1_2);
   Phase_select_38i8Bus12_1 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(1), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n5s1(1), d=>
      Phase_38n15ss1(1));
   Phase_select_38i9Bus13_1 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n15ss1(1), d=>
      Phase_38n17ss1_1);
   Phase_select_38i8Bus12_0 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase(0), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n5s1(0), d=>
      Phase_38n15ss1(0));
   Phase_select_38i9Bus13_0 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>Phase_38n15ss1(0), d=>
      Phase_38n17ss1_0);
   Rcv_Filter_fsm_select_59i2Bus20_5 : select_3_3 port map ( a(2)=>rtlcn740, 
      a(1)=>rtlcn738, a(0)=>rtlcn739, b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>PWR, b(0)=>
      Rcv_Filter_fsm_59n6ss1_3, d=>Rcv_Filter_fsm_59n16ss1_5);
   Rcv_Filter_fsm_select_59i2Bus20_6 : select_3_3 port map ( a(2)=>rtlcn758, 
      a(1)=>rtlcn756, a(0)=>rtlcn757, b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>PWR, b(0)=>
      Rcv_Filter_fsm_59n4ss1_4, d=>Rcv_Filter_fsm_59n16ss1_6);
   not_rtlc56n177 <= NOT rtlc56n177 ;
   not_Clean_minus <= NOT Clean_minus ;
   not_rtlc23n85 <= NOT rtlc23n85 ;
   not_Clean_plus <= NOT Clean_plus ;
   not_rtlcs36 <= NOT rtlcs36 ;
   not_rtlc35n267 <= NOT rtlc35n267 ;
   Rcv_Filter_fsm_select_59i4Bus18_3 : select_3_3 port map ( a(2)=>
      not_rtlcn1209, a(1)=>Rcv_Filter(2), a(0)=>rtlcn1011, b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>Rcv_Filter_fsm_59n6ss1_3, 
      b(0)=>PWR, d=>Rcv_Filter_fsm_59n13ss1_3);
   Rcv_Filter_fsm_select_59i4Bus18_4 : select_3_3 port map ( a(2)=>
      not_rtlcn1210, a(1)=>Rcv_Filter(1), a(0)=>rtlcn1038, b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>Rcv_Filter_fsm_59n4ss1_4, 
      b(0)=>PWR, d=>Rcv_Filter_fsm_59n13ss1_4);
   rtlc38n393 <= rtlcs24 OR rtlc38n390 ;
   rtlc47n614 <= rtlcs30 OR rtlcs35 ;
   not_state_1 <= NOT state(1) ;
   not_state_0 <= NOT state(0) ;
   not_Advance <= NOT Advance ;
   rtlcn482 <= not_Advance AND rtlcs18 ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlcn483 <= not_Advance AND not_rtlcs18 ;
   not_rtlc38n485 <= NOT rtlc38n485 ;
   rtlcn508 <= not_rtlc38n485 AND rtlc38n455 ;
   not_rtlc38n455 <= NOT rtlc38n455 ;
   rtlcn509 <= not_rtlc38n485 AND not_rtlc38n455 ;
   rtlcn1096 <= not_Clean_minus AND Rcv_Filter(6) ;
   rtlcn1097 <= Clean_plus AND Rcv_Filter(5) ;
   rtlcn1077 <= rtlcn1096 OR rtlcn1097 ;
   not_Recieving <= NOT Recieving ;
   rtlcn1099 <= Clean_minus AND Rcv_Filter(6) ;
   rtlcn1101 <= not_Clean_plus AND Rcv_Filter(5) ;
   rtlcn1078 <= rtlcn1099 OR rtlcn1101 ;
   not_rtlcn698 <= NOT rtlcn698 ;
   rtlcn738 <= rtlcn1078 AND not_rtlcn698 ;
   rtlcn739 <= Rcv_Filter(4) AND not_rtlcn698 ;
   rtlcn756 <= rtlcn1077 AND not_rtlcn698 ;
   rtlcn757 <= Rcv_Filter(3) AND not_rtlcn698 ;
   not_rtlc59n252 <= NOT rtlc59n252 ;
   not_rtlc59n281 <= NOT rtlc59n281 ;
   not_ResetN <= NOT ResetN ;
   rtlcn371 <= rtlc23n543 OR rtlc23n544 ;
   rtlc35n629 <= RxRdy_plus_us(6) OR RxRdy_plus_us(5) ;
   not_rtlc35n691 <= NOT rtlc35n691 ;
   not_rtlc35n613 <= NOT rtlc35n613 ;
   not_rtlc35n629 <= NOT rtlc35n629 ;
   not_RxRdy_plus_us_4 <= NOT RxRdy_plus_us(4) ;
   rtlc_1657_or_962 : or_4u_4u port map ( a(3)=>rtlc35n572, a(2)=>
      not_rtlcn1211, a(1)=>not_rtlcn1212, a(0)=>rtlcn1118, d=>rtlcn399);
   not_rtlcs40 <= NOT rtlcs40 ;
   not_RxRdy_plus_us_3 <= NOT RxRdy_plus_us(3) ;
   rtlcn1121 <= not_RxRdy_plus_us_3 AND not_RxRdy_plus_us_2 ;
   rtlc35n652 <= not_RxRdy_plus_us_4 OR rtlcn1121 ;
   rtlcn1122 <= not_rtlc35n613 AND not_RxRdy_plus_us_4 ;
   rtlcn1124 <= rtlcn1208 AND rtlc35n652 ;
   rtlcn1085 <= rtlcn1122 OR rtlcn1124 ;
   rtlcn1125 <= not_rtlc35n629 AND rtlcn1085 ;
   rtlcn403 <= not_rtlc35n691 OR rtlcn1125 ;
   not_rtlc35n653 <= NOT rtlc35n653 ;
   rtlcn1057 <= rtlc47n453 OR Found_CMD_Sync ;
   not_rtlcn1057 <= NOT rtlcn1057 ;
   rtlcn1082 <= Clean_minus OR rtlc56n177 ;
   rtlcn1126 <= rtlcs46 AND rtlcn1082 ;
   not_rtlc56n179 <= NOT rtlc56n179 ;
   rtlcn445 <= Recieving AND rtlcn1086 ;
   not_rtlc23n451 <= NOT rtlc23n451 ;
   not_rtlc23n379 <= NOT rtlc23n379 ;
   rtlcn1133 <= not_rtlc23n379 AND rtlc23n150 ;
   rtlcn1087 <= not_rtlc23n451 OR rtlcn1133 ;
   rtlcn455 <= not_rtlc23n85 AND rtlcn1087 ;
   rtlcn495 <= Recieving AND rtlcn509 ;
   rtlcn501 <= not_Recieving OR rtlc38n268 ;
   rtlcn502 <= rtlc23n85 AND Xmitting ;
   not_Stall <= NOT Stall ;
   rtlc_1694_and_966 : and_4u_4u port map ( a(3)=>not_rtlc38n485, a(2)=>
      not_rtlc38n455, a(1)=>Recieving, a(0)=>not_Stall, d=>rtlcn535);
   not_rtlcs35 <= NOT rtlcs35 ;
   rtlcn1088 <= not_rtlcs35 OR not_rtlcs18 ;
   rtlcn581 <= Recieving AND rtlcn1088 ;
   rtlcn1058 <= Found_CMD_Sync OR rtlcs27 ;
   rtlcn1079 <= rtlcn1096 OR rtlcn1101 ;
   rtlcn1076 <= Rcv_Filter(4) OR Rcv_Filter(2) ;
   rtlcn1089 <= not_Clean_minus OR rtlc59n281 ;
   rtlcn1074 <= rtlcn1076 AND rtlcn1089 ;
   rtlcn1075 <= Rcv_Filter(3) OR Rcv_Filter(1) ;
   rtlcn1080 <= not_Clean_plus OR rtlc59n252 ;
   rtlcn1140 <= rtlcn1075 AND rtlcn1080 ;
   rtlcn1084 <= rtlcn1074 OR rtlcn1140 ;
   rtlcn623 <= rtlcn1079 OR rtlcn1084 ;
   rtlcn1141 <= rtlc59n252 AND rtlcn1075 ;
   rtlcn1142 <= rtlc59n281 AND rtlcn1076 ;
   rtlc_1716_or_969 : or_4u_4u port map ( a(3)=>rtlcn698, a(2)=>rtlcn1141, 
      a(1)=>rtlcn1142, a(0)=>rtlcn1143, d=>rtlcn648);
   rtlcn838 <= rtlc56n169 OR not_rtlc56n179 ;
   not_rtlc20n33 <= NOT rtlc20n33 ;
   rtlcn1148 <= not_rtlc59n252 AND Rcv_Filter(1) ;
   rtlcn1149 <= Clean_minus AND Rcv_Filter(0) ;
   rtlcn1083 <= rtlcn1148 OR rtlcn1149 ;
   rtlcn1150 <= Clean_plus AND Rcv_Filter(0) ;
   rtlcn1090 <= rtlcn1150 OR rtlcn1151 ;
   rtlcn1009 <= not_rtlcn698 AND rtlcn1090 ;
   rtlcn1130 <= not_rtlc56n179 AND rtlcs45 ;
   energy_23n6s1f1(1) <= NOT rtlc23n541 ;
   energy_23n6s1f1(0) <= NOT rtlc23n547 ;
   not_rtlcn371 <= NOT rtlcn371 ;
   not_rtlcn399 <= NOT rtlcn399 ;
   not_rtlcn1209 <= NOT rtlcn1209 ;
   not_rtlcn1210 <= NOT rtlcn1210 ;
   not_rtlcn1211 <= NOT rtlcn1211 ;
   not_rtlcn1212 <= NOT rtlcn1212 ;
   not_rtlcn1213 <= NOT rtlcn1213 ;
   rtlc23n193 <= not_rtlc23n394 when rtlc23n95 = '1' else energy(5) ;
   rtlc23n217 <= not_rtlcn148 when rtlc23n85 = '1' else rtlc23n451 ;
   rtlc26n62 <= rtlcn157 when Recieving = '1' else not_rtlc26n93 ;
   rtlc38n420 <= not_rtlc38n407 when rtlcs27 = '1' else rtlc38n393 ;
   Manchester_error_41n2ss1 <= Manchester_error_41n2s1 when rtlcs24
    = '1' else Manchester_error_41n2s2 ;
   rtlcn410 <= not_rtlc38n368 when Phase(4) = '1' else 
   not_Manchester_error_41n2s1 ;
   not_rtlc23n217 <= NOT rtlc23n217 ;
   rtlc23n259 <= CE AND not_rtlc23n217 ;
   not_CE <= NOT CE ;
   not_rtlc23n193 <= NOT rtlc23n193 ;
   rtlcn1223 <= not_rtlc23n193 OR not_rtlc23n85 ;
   rtlc23n258 <= CE AND rtlcn1223 ;
   not_rtlc26n62 <= NOT rtlc26n62 ;
   rtlc26n79 <= CE AND not_rtlc26n62 ;
   rtlc29n57 <= CE AND rtlcn1224 ;
   rtlc35n452 <= CE AND rtlcs28 ;
   not_rtlc35n310 <= NOT rtlc35n310 ;
   rtlc35n442 <= CE AND not_rtlc35n310 ;
   not_rtlcn1088 <= NOT rtlcn1088 ;
   rtlc38n669 <= CE AND rtlcn1226 ;
   rtlcn1239 <= rtlcs18 AND rtlcs35 ;
   rtlcn1227 <= not_Recieving OR rtlcn1239 ;
   rtlc38n668 <= CE AND rtlcn1227 ;
   rtlcn1217 <= not_Recieving OR rtlc38n485 ;
   rtlcn1218 <= Advance OR rtlcn1217 ;
   not_rtlc38n420 <= NOT rtlc38n420 ;
   rtlcn1228 <= not_rtlc38n420 OR rtlcn1218 ;
   rtlc38n667 <= CE AND rtlcn1228 ;
   rtlc_2040_or_975 : or_4u_4u port map ( a(3)=>Stall, a(2)=>rtlc38n455, 
      a(1)=>rtlcn1217, a(0)=>not_rtlcn1287, d=>rtlcn1229);
   rtlc38n666 <= CE AND rtlcn1229 ;
   rtlcn1221 <= rtlcs18 OR not_rtlcs21 ;
   rtlcn1246 <= not_Stall AND rtlcn1221 ;
   rtlc38n665 <= CE AND rtlcn1230 ;
   rtlcn1219 <= CE AND Found_CMD_Sync ;
   rtlcn1247 <= CE AND Strobe_44n1s1 ;
   rtlc41n109 <= rtlcn1219 OR rtlcn1247 ;
   rtlcn1248 <= CE AND rtlcs1 ;
   rtlc41n108 <= rtlcn1219 OR rtlcn1248 ;
   not_Strobe <= NOT Strobe ;
   rtlcn1215 <= not_CE OR not_Strobe ;
   rtlcn1220 <= CE AND rtlcn1057 ;
   not_rtlcn1215 <= NOT rtlcn1215 ;
   not_H15530_record_Manchester_error <= NOT 
   H15530_record_Manchester_error_EXMPLR1489 ;
   rtlcn1222 <= rtlcs24 OR rtlcs30 ;
   not_rtlc47n218 <= NOT rtlc47n218 ;
   rtlc47n571 <= rtlcn1220 OR rtlcn1256 ;
   rtlc47n553 <= rtlcn1220 OR not_rtlcn1387 ;
   rtlcn1231 <= rtlc47n218 OR rtlcs27 ;
   rtlcn1259 <= not_rtlcn1215 AND rtlcn1231 ;
   rtlc47n552 <= rtlcn1219 OR rtlcn1259 ;
   rtlcn1260 <= rtlcs25 AND not_rtlcn1215 ;
   rtlc47n551 <= rtlcn1219 OR rtlcn1260 ;
   rtlcn1214 <= not_rtlc47n218 OR rtlcn1215 ;
   not_rtlcn1214 <= NOT rtlcn1214 ;
   rtlcn290 <= Data_47n4s2(0) AND not_rtlcn1214 ;
   rtlcn295 <= not_rtlcn1214 AND Data_47n4s2(1) ;
   rtlcn300 <= not_rtlcn1214 AND Data_47n4s2(2) ;
   rtlcn305 <= not_rtlcn1214 AND Data_47n4s2(3) ;
   rtlcn310 <= not_rtlcn1214 AND Data_47n4s2(4) ;
   rtlcn315 <= not_rtlcn1214 AND Data_47n4s2(5) ;
   rtlcn320 <= not_rtlcn1214 AND Data_47n4s2(6) ;
   rtlcn325 <= not_rtlcn1214 AND Data_47n4s2(7) ;
   rtlcn330 <= not_rtlcn1214 AND Data_47n4s2(8) ;
   rtlcn335 <= not_rtlcn1214 AND Data_47n4s2(9) ;
   rtlcn340 <= not_rtlcn1214 AND Data_47n4s2(10) ;
   rtlcn345 <= not_rtlcn1214 AND Data_47n4s2(11) ;
   rtlcn350 <= not_rtlcn1214 AND Data_47n4s2(12) ;
   rtlcn355 <= not_rtlcn1214 AND Data_47n4s2(13) ;
   rtlcn360 <= not_rtlcn1214 AND Data_47n4s2(14) ;
   rtlcn365 <= not_rtlcn1214 AND Data_47n4s2(15) ;
   rtlc35n310 <= rtlc35n264 AND rtlcn1262 ;
   rtlcs48 <= not_Phase_4 AND rtlcs3 ;
   rtlcs1 <= rtlcs48 AND rtlcs4 ;
   rtlcs5 <= rtlcs48 AND rtlcs7 ;
   Strobe_44n1s1 <= rtlcs8 AND rtlcs10 ;
   rtlcs8 <= rtlcs11 AND rtlcs3 ;
   rtlcs10 <= rtlcs12 AND rtlcs4 ;
   rtlcs13 <= rtlcs14 AND rtlcs7 ;
   rtlcs15 <= rtlcs16 AND rtlcs7 ;
   rtlcs18 <= Phase(4) AND rtlcs17 ;
   rtlcs17 <= rtlcs20 AND rtlcs4 ;
   rtlcs21 <= rtlcs22 AND rtlcs23 ;
   rtlcs25 <= Data_47n4s3_1 AND rtlcs24 ;
   rtlcs28 <= Strobe AND rtlcs27 ;
   rtlcs27 <= rtlcs24 AND rtlcs30 ;
   rtlcs24 <= Bit_number(0) AND rtlcs23 ;
   rtlcs32 <= Data_47n4s3_0 AND rtlcs30 ;
   rtlcs30 <= Bit_number(1) AND rtlcs23 ;
   Data_47n4s3_0 <= NOT Bit_number(0) ;
   Data_47n4s3_1 <= NOT Bit_number(1) ;
   rtlcs22 <= Data_47n4s3_0 AND Data_47n4s3_1 ;
   not_Bit_number_4 <= NOT Bit_number(4) ;
   not_Bit_number_3 <= NOT Bit_number(3) ;
   not_Bit_number_2 <= NOT Bit_number(2) ;
   not_rtlc5n44 <= NOT rtlc5n44 ;
   plus_dd_5n1ss1 <= plus_d AND not_rtlc5n44 ;
   minus_dd_5n2ss1 <= minus_d AND not_rtlc5n44 ;
   not_rtlc11n36 <= NOT rtlc11n36 ;
   plus_dd_falling_edge_11n1ss1 <= plus_d_falling_edge AND not_rtlc11n36 ;
   minus_dd_falling_edge_11n2ss1 <= minus_d_falling_edge AND not_rtlc11n36 ;
   not_rtlcn455 <= NOT rtlcn455 ;
   energy_23n9ss1(1) <= energy_23n6s1(1) AND not_rtlcn455 ;
   energy_23n9ss1(3) <= energy_23n6s1(3) AND not_rtlcn455 ;
   energy_23n9ss1(2) <= energy_23n6s1(2) AND not_rtlcn455 ;
   energy_23n9ss1(0) <= energy_23n6s1(0) AND not_rtlcn455 ;
   energy_23n9ss1(4) <= energy_23n6s1(4) AND not_rtlcn455 ;
   energy_23n9ss1(5) <= energy_23n6s1(5) AND not_rtlcn455 ;
   not_Found_CMD_Sync <= NOT Found_CMD_Sync ;
   Bit_value_41n4ss1 <= level_plus AND not_Found_CMD_Sync ;
   not_Phase_4 <= NOT Phase(4) ;
   not_Phase_3 <= NOT Phase(3) ;
   not_Phase_1 <= NOT Phase(1) ;
   Phase_38n18ss1(0) <= Phase_38n17ss1_0 AND Recieving ;
   not_rtlcs13 <= NOT rtlcs13 ;
   rtlc38n389 <= not_Manchester_error_41n2s2 OR not_rtlcs13 ;
   not_rtlcn1287 <= NOT rtlcn1287 ;
   Phase_38n18ss1(2) <= Phase_38n17ss1_2 AND Recieving ;
   not_Phase_2 <= NOT Phase(2) ;
   not_Phase_0 <= NOT Phase(0) ;
   rtlcs7 <= not_Phase_2 AND not_Phase_0 ;
   Phase_38n18ss1(1) <= Phase_38n17ss1_1 AND Recieving ;
   rtlcs3 <= not_Phase_3 AND Phase(1) ;
   rtlcs4 <= Phase(2) AND Phase(0) ;
   Manchester_error_41n4ss1 <= Manchester_error_41n2ss1 AND 
   not_Found_CMD_Sync ;
   rtlcs11 <= Phase(4) AND Phase(2) ;
   rtlcn409 <= Sync_error_EXMPLR1487 AND Bit_number(1) ;
   Sync_error_47n10ss1 <= Sync_error_47n7ss1 AND not_rtlcn1057 ;
   rtlcn1210 <= Rcv_Filter(1) OR rtlcn1038 ;
   Rcv_Filter_fsm_59n4ss1_4 <= Clean_plus AND not_rtlc59n252 ;
   Rcv_Filter_fsm_59n16ss1_4 <= Rcv_Filter_fsm_59n13ss1_4 AND not_rtlcn698 ;
   rtlcn1209 <= Rcv_Filter(2) OR rtlcn1011 ;
   Rcv_Filter_fsm_59n6ss1_3 <= Clean_minus AND not_rtlc59n281 ;
   Rcv_Filter_fsm_59n16ss1_3 <= Rcv_Filter_fsm_59n13ss1_3 AND not_rtlcn698 ;
   not_rtlcn623 <= NOT rtlcn623 ;
   not_rtlc56n169 <= NOT rtlc56n169 ;
   not_Len_4 <= NOT Len(4) ;
   not_Len_2 <= NOT Len(2) ;
   not_Len_1 <= NOT Len(1) ;
   not_Len_0 <= NOT Len(0) ;
   rtlc_2208_and_982 : and_6u_6u port map ( a(5)=>Len(5), a(4)=>not_Len_4, 
      a(3)=>Len(3), a(2)=>not_Len_2, a(1)=>not_Len_1, a(0)=>not_Len_0, d=>
      rtlcs44);
   rtlcn1213 <= Clean_minus OR rtlcs44 ;
   state_fsm_56n9ss1(0) <= state_fsm_56n8ss1(0) AND Recieving ;
   rtlcs46 <= state(1) AND not_state_0 ;
   rtlcs47 <= not_state_1 AND state(0) ;
   rtlcs45 <= state(1) AND state(0) ;
   not_Len_3 <= NOT Len(3) ;
   rtlcs20 <= Phase(1) AND Phase(3) ;
   not_rtlcs17 <= NOT rtlcs17 ;
   rtlc38n390 <= rtlcn410 OR not_rtlcs17 ;
   Phase_38n18ss1(3) <= Phase_38n15ss1(3) AND rtlcn495 ;
   Phase_inc4_38i10 : inc_4u_4u_0 port map ( cin=>PWR, a(3)=>Phase(4), a(2)
      =>Phase(3), a(1)=>Phase(2), a(0)=>Phase(1), d(3)=>Phase_38n15s1(4), 
      d(2)=>Phase_38n15s1(3), d(1)=>Phase_38n15s1(2), d(0)=>Phase_38n15s1(1), 
      cout=>DANGLING(4));
   not_rtlcn509 <= NOT rtlcn509 ;
   Phase_38n17ss1_4 <= Phase_38n15ss1(4) OR not_rtlcn509 ;
   Phase_38n18ss1(4) <= Phase_38n17ss1_4 AND Recieving ;
   rtlc_2242_and_986 : and_5u_5u port map ( a(4)=>Bit_number(4), a(3)=>
      not_Bit_number_3, a(2)=>Bit_number(2), a(1)=>Data_47n4s3_1, a(0)=>
      Data_47n4s3_0, d=>rtlcs35);
   Command_sync_47n10ss1 <= Bit_value OR Found_CMD_Sync ;
   Calc_parity_47n10ss1 <= Calc_parity_47n7s1 OR rtlcn1058 ;
   not_rtlcn1387 <= NOT rtlcn1387 ;
   not_energy_4 <= NOT energy(4) ;
   not_energy_3 <= NOT energy(3) ;
   not_energy_2 <= NOT energy(2) ;
   not_energy_1 <= NOT energy(1) ;
   not_energy_0 <= NOT energy(0) ;
   rtlc_2258_and_987 : and_6u_6u port map ( a(5)=>not_energy_5, a(4)=>
      not_energy_4, a(3)=>not_energy_3, a(2)=>not_energy_2, a(1)=>
      not_energy_1, a(0)=>not_energy_0, d=>rtlcs37);
   Gap_35n13ss1(5) <= Gap_35n11s1(5) AND rtlcn876 ;
   not_rtlcs25 <= NOT rtlcs25 ;
   rtlc35n264 <= not_rtlcs5 OR not_rtlcs25 ;
   rtlc_2283_and_989 : and_5u_5u port map ( a(4)=>gap_phase(4), a(3)=>
      gap_phase(3), a(2)=>gap_phase(2), a(1)=>gap_phase(1), a(0)=>
      gap_phase(0), d=>rtlcs0);
   rtlcn407 <= not_rtlcs0 OR rtlcs36 ;
   rtlcn1262 <= rtlcn407 OR rtlc35n267 ;
   Gap_35n13ss1(4) <= Gap_35n11s1(4) AND rtlcn876 ;
   Gap_35n13ss1(3) <= Gap_35n11s1(3) AND rtlcn876 ;
   Gap_35n13ss1(2) <= Gap_35n11s1(2) AND rtlcn876 ;
   Gap_35n13ss1(1) <= Gap_35n11s1(1) AND rtlcn876 ;
   rtlc_2290_and_990 : and_7u_7u port map ( a(6)=>
      H15530_record_RAW_GAP_EXMPLR1531(6), a(5)=>
      H15530_record_RAW_GAP_EXMPLR1531(5), a(4)=>
      H15530_record_RAW_GAP_EXMPLR1531(4), a(3)=>
      H15530_record_RAW_GAP_EXMPLR1531(3), a(2)=>
      H15530_record_RAW_GAP_EXMPLR1531(2), a(1)=>
      H15530_record_RAW_GAP_EXMPLR1531(1), a(0)=>
      H15530_record_RAW_GAP_EXMPLR1531(0), d=>rtlcs36);
   Gap_35n13ss1(6) <= Gap_35n11s1(6) AND rtlcn876 ;
   Gap_35n13ss1(0) <= Gap_35n11s1(0) AND rtlcn876 ;
   rtlc_2293_and_991 : and_7u_7u port map ( a(6)=>RxRdy_plus_us(6), a(5)=>
      RxRdy_plus_us(5), a(4)=>RxRdy_plus_us(4), a(3)=>RxRdy_plus_us(3), a(2)
      =>RxRdy_plus_us(2), a(1)=>RxRdy_plus_us(1), a(0)=>RxRdy_plus_us(0), d
      =>rtlcs40);
   rtlc_2294_and_992 : and_5u_5u port map ( a(4)=>RxRdy_plus_phase(4), a(3)
      =>RxRdy_plus_phase(3), a(2)=>RxRdy_plus_phase(2), a(1)=>
      RxRdy_plus_phase(1), a(0)=>RxRdy_plus_phase(0), d=>rtlcs42);
   not_rtlc35n572 <= NOT rtlc35n572 ;
   Actual_gap_35n1ss1(0) <= not_RxRdy_plus_us_0 AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(1) <= Actual_gap_35n1s1(1) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(2) <= Actual_gap_35n1s1(2) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(3) <= Actual_gap_35n1s1(3) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(4) <= Actual_gap_35n1s1(4) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(5) <= Actual_gap_35n1s1(5) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(6) <= Actual_gap_35n1s1(6) AND not_rtlc35n572 ;
   rtlcn1211 <= rtlc35n691 OR rtlcs40 ;
   rtlcn1212 <= rtlc35n653 OR rtlcn163 ;
   rtlcn1208 <= rtlc35n629 OR RxRdy_plus_us(4) ;
   not_RxRdy_plus_us_5 <= NOT RxRdy_plus_us(5) ;
   not_RxRdy_plus_us_1 <= NOT RxRdy_plus_us(1) ;
   not_RxRdy_plus_us_0 <= NOT RxRdy_plus_us(0) ;
   not_RxRdy_plus_phase_4 <= NOT RxRdy_plus_phase(4) ;
   not_RxRdy_plus_phase_3 <= NOT RxRdy_plus_phase(3) ;
   not_RxRdy_plus_phase_2 <= NOT RxRdy_plus_phase(2) ;
   not_RxRdy_plus_phase_1 <= NOT RxRdy_plus_phase(1) ;
   not_RxRdy_plus_phase_0 <= NOT RxRdy_plus_phase(0) ;
   H15530_record_Pre_EchoRdy <= RxRdy AND Echo ;
   not_Echo <= NOT Echo ;
   H15530_record_Pre_RxRdy <= RxRdy AND not_Echo ;
   rtlcn1287 <= rtlcs24 OR rtlc38n389 ;
   rtlcn1387 <= rtlc47n437 OR rtlcn1215 ;
   Len_56n8ss1(0) <= Len_56n6s1(0) OR rtlcn1698 ;
   Len_56n8ss1(1) <= Len_56n6s1(1) AND rtlcn1701 ;
   Len_56n8ss1(2) <= Len_56n6s1(2) AND rtlcn1701 ;
   Len_56n8ss1(3) <= Len_56n6s1(3) AND rtlcn1701 ;
   Len_56n8ss1(4) <= Len_56n6s1(4) AND rtlcn1701 ;
   Len_56n8ss1(5) <= Len_56n6s1(5) AND rtlcn1701 ;
   modgen_counter_gap_phase : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 port map ( 
      clock=>Clock, q(4)=>gap_phase(4), q(3)=>gap_phase(3), q(2)=>
      gap_phase(2), q(1)=>gap_phase(1), q(0)=>gap_phase(0), clk_en=>CE, 
      aclear=>not_ResetN, sload=>rtlc35n267, data(4)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(3)=>PWR, data(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(1)=>PWR, data(0)=>
      H15530_record_Bit_number_EXMPLR1529(4), aset=>
      H15530_record_Bit_number_EXMPLR1529(4), sclear=>rtlc35_X_0_n377, updn
      =>PWR, cnt_en=>not_rtlcs36);
   modgen_counter_Bit_number : 
      counter_up_sload_sclear_aclear_clock_clk_en_0_5 port map ( clock=>
      Clock, q(4)=>Bit_number(4), q(3)=>Bit_number(3), q(2)=>Bit_number(2), 
      q(1)=>Bit_number(1), q(0)=>Bit_number(0), clk_en=>not_rtlc38n588, 
      aclear=>not_ResetN, sload=>rtlcn1715, data(4)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(1)=>not_rtlc38n616, 
      data(0)=>PWR, aset=>H15530_record_Bit_number_EXMPLR1529(4), sclear=>
      not_Recieving, updn=>PWR, cnt_en=>PWR);
   modgen_counter_RxRdy_plus_us : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 port map ( clock=>
      Clock, q(6)=>RxRdy_plus_us(6), q(5)=>RxRdy_plus_us(5), q(4)=>
      RxRdy_plus_us(4), q(3)=>RxRdy_plus_us(3), q(2)=>RxRdy_plus_us(2), q(1)
      =>RxRdy_plus_us(1), q(0)=>RxRdy_plus_us(0), clk_en=>CE, aclear=>
      not_ResetN, sload=>H15530_record_Bit_number_EXMPLR1529(4), data(6)=>
      DANGLING(5), data(5)=>DANGLING(6), data(4)=>DANGLING(7), data(3)=>
      DANGLING(8), data(2)=>DANGLING(9), data(1)=>DANGLING(10), data(0)=>
      DANGLING(11), aset=>H15530_record_Bit_number_EXMPLR1529(4), sclear=>
      RxRdy, updn=>PWR, cnt_en=>not_rtlc50n176);
   modgen_counter_RxRdy_plus_phase : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 port map ( 
      clock=>Clock, q(4)=>RxRdy_plus_phase(4), q(3)=>RxRdy_plus_phase(3), 
      q(2)=>RxRdy_plus_phase(2), q(1)=>RxRdy_plus_phase(1), q(0)=>
      RxRdy_plus_phase(0), clk_en=>CE, aclear=>not_ResetN, sload=>RxRdy, 
      data(4)=>H15530_record_Bit_number_EXMPLR1529(4), data(3)=>PWR, data(2)
      =>H15530_record_Bit_number_EXMPLR1529(4), data(1)=>PWR, data(0)=>
      H15530_record_Bit_number_EXMPLR1529(4), aset=>
      H15530_record_Bit_number_EXMPLR1529(4), sclear=>rtlc50_X_0_n204, updn
      =>PWR, cnt_en=>not_rtlcs40);
   not_Bit_Gap_3 <= NOT Bit_Gap_3 ;
   modgen_counter_Bit_Gap : counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4
       port map ( clock=>Clock, q(3)=>Bit_Gap_3, q(2)=>DANGLING(12), q(1)=>
      DANGLING(13), q(0)=>DANGLING(14), clk_en=>CE, aclear=>not_ResetN, 
      sload=>H15530_record_Bit_number_EXMPLR1529(4), data(3)=>DANGLING(15), 
      data(2)=>DANGLING(16), data(1)=>DANGLING(17), data(0)=>DANGLING(18), 
      aset=>H15530_record_Bit_number_EXMPLR1529(4), sclear=>not_rtlc62n36, 
      updn=>PWR, cnt_en=>not_Bit_Gap_3);
   rtlcn1715 <= rtlc38n485 OR rtlc38n616 ;
   not_rtlc38n616 <= NOT rtlc38n616 ;
   rtlc5n44 <= NOT (plus_d XOR minus_d) ;
   rtlc11n36 <= NOT (plus_d_falling_edge XOR minus_d_falling_edge) ;
   rtlc20n32 <= NOT (Check_value XOR not_minus_dd) ;
   rtlc20n30 <= NOT (Check_value XOR plus_dd) ;
   Manchester_error_41n2s2 <= NOT (Bit_value XOR level_plus) ;
   Manchester_error_41n2s1 <= NOT (Bit_value XOR Level_minus) ;
   rtlc47n426 <= NOT (Calc_parity XOR Bit_value) ;
   rtlc47n235 <= NOT (Bit_value XOR H15530_record_Command_Sync_EXMPLR1526) ;
   DFFPC (minus_dd_5n2ss1,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   Clock,minus_dd) ;
   DFFPC (Minus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,Clock,
   minus_d) ;
   DFFPC (plus_dd_5n1ss1,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   Clock,plus_dd) ;
   DFFPC (Plus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,Clock,
   plus_d) ;
   DFFPC (Minus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,not_Clock,
   minus_d_falling_edge) ;
   DFFPC (Plus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,not_Clock,
   plus_d_falling_edge) ;
   DFFPC (minus_dd_falling_edge_11n2ss1,
   H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,Clock,
   minus_dd_falling_edge) ;
   DFFPC (plus_dd_falling_edge_11n1ss1,
   H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,Clock,
   plus_dd_falling_edge) ;
   DFFPCE (minus_dd,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Minus_shifter(8)) ;
   DFFPCE (Minus_shifter(8),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(7)) ;
   DFFPCE (Minus_shifter(7),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(6)) ;
   DFFPCE (Minus_shifter(6),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(5)) ;
   DFFPCE (Minus_shifter(5),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(4)) ;
   DFFPCE (Minus_shifter(4),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(3)) ;
   DFFPCE (rtlc14n77,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Minus_shifter(2)) ;
   DFFPCE (Minus_shifter(2),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(1)) ;
   DFFPCE (Minus_shifter(1),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Minus_shifter(0)) ;
   DFFPCE (plus_dd,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Plus_shifter(8)) ;
   DFFPCE (Plus_shifter(8),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(7)) ;
   DFFPCE (Plus_shifter(7),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(6)) ;
   DFFPCE (Plus_shifter(6),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(5)) ;
   DFFPCE (Plus_shifter(5),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(4)) ;
   DFFPCE (Plus_shifter(4),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(3)) ;
   DFFPCE (rtlc14n57,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Plus_shifter(2)) ;
   DFFPCE (Plus_shifter(2),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(1)) ;
   DFFPCE (Plus_shifter(1),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Plus_shifter(0)) ;
   DFFPCE (Clean_minus_17n1s1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Clean_minus) ;
   DFFPCE (Clean_plus_17n1s1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Clean_plus) ;
   DFFPCE (rtlcn843,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Echo_Error) ;
   DFFPCE (rtlcn502,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc23n259,Clock,Echo) ;
   DFFPCE (energy_23n9ss1(5),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(5)) ;
   DFFPCE (energy_23n9ss1(4),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(4)) ;
   DFFPCE (energy_23n9ss1(3),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(3)) ;
   DFFPCE (energy_23n9ss1(2),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(2)) ;
   DFFPCE (energy_23n9ss1(1),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(1)) ;
   DFFPCE (energy_23n9ss1(0),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc23n258,Clock,energy(0)) ;
   DFFPCE (not_Recieving,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc26n79,Clock,Recieving) ;
   DFFPCE (Clean_plus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc29n57,Clock,level_plus) ;
   DFFPCE (Clean_minus,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc29n57,Clock,Level_minus) ;
   DFFPCE (not_rtlc35n653,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(2)) ;
   DFFPCE (rtlcn403,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(1)) ;
   DFFPCE (not_rtlcn399,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(0)) ;
   DFFPCE (Actual_gap_35n1ss1(6),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(6)) ;
   DFFPCE (Actual_gap_35n1ss1(5),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(5)) ;
   DFFPCE (Actual_gap_35n1ss1(4),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(4)) ;
   DFFPCE (Actual_gap_35n1ss1(3),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(3)) ;
   DFFPCE (Actual_gap_35n1ss1(2),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(2)) ;
   DFFPCE (Actual_gap_35n1ss1(1),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(1)) ;
   DFFPCE (Actual_gap_35n1ss1(0),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(0)) ;
   DFFPCE (Gap_35n13ss1(6),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(6)) ;
   DFFPCE (Gap_35n13ss1(5),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(5)) ;
   DFFPCE (Gap_35n13ss1(4),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(4)) ;
   DFFPCE (Gap_35n13ss1(3),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(3)) ;
   DFFPCE (Gap_35n13ss1(2),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(2)) ;
   DFFPCE (Gap_35n13ss1(1),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(1)) ;
   DFFPCE (Gap_35n13ss1(0),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1531(0)) ;
   DFFPCE (rtlcn581,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc38n669,Clock,resync_after_fault) ;
   DFFPCE (rtlcn501,not_ResetN,H15530_record_Bit_number_EXMPLR1529(4),
   rtlc38n668,Clock,first_sync) ;
   DFFPCE (rtlcn519,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc38n667,Clock,Advance) ;
   DFFPCE (rtlcn535,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlc38n666,Clock,Stall) ;
   DFFPCE (Phase_38n18ss1(4),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc38n665,Clock,Phase(4)) ;
   DFFPCE (Phase_38n18ss1(3),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc38n665,Clock,Phase(3)) ;
   DFFPCE (Phase_38n18ss1(2),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc38n665,Clock,Phase(2)) ;
   DFFPCE (Phase_38n18ss1(1),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc38n665,Clock,Phase(1)) ;
   DFFPCE (Phase_38n18ss1(0),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc38n665,Clock,Phase(0)) ;
   DFFPCE (Manchester_error_41n4ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc41n109,Clock,H15530_record_Manchester_error_EXMPLR1489) ;
   DFFPCE (Bit_value_41n4ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc41n108,Clock,Bit_value) ;
   DFFPCE (Strobe_44n1s1,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Strobe) ;
   DFFPCE (Sync_error_47n10ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc47n571,Clock,Sync_error_EXMPLR1487) ;
   DFFPCE (rtlcn591,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,RxRdy) ;
   DFFPCE (rtlcn1057,not_ResetN,H15530_record_Bit_number_EXMPLR1529(4),
   rtlc47n553,Clock,H15530_record_CS) ;
   DFFPCE (Calc_parity_47n10ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc47n552,Clock,Calc_parity) ;
   DFFPCE (Command_sync_47n10ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,rtlc47n551,Clock,H15530_record_Command_Sync_EXMPLR1526) ;
   DFFPCE (RxRdy_plus_10us_50n4s1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,H15530_record_RxRDY_plus_10us) ;
   DFFPCE (rtlcn445,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,state(1)) ;
   DFFPCE (state_fsm_56n9ss1(0),H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,state(0)) ;
   DFFPCE (Len_56n8ss1(5),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(5)) ;
   DFFPCE (Len_56n8ss1(4),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(4)) ;
   DFFPCE (Len_56n8ss1(3),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(3)) ;
   DFFPCE (Len_56n8ss1(2),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(2)) ;
   DFFPCE (Len_56n8ss1(1),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(1)) ;
   DFFPCE (Len_56n8ss1(0),H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   CE,Clock,Len(0)) ;
   DFFPCE (Found_CMD_Sync_56n8ss1,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Found_CMD_Sync) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_6,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Rcv_Filter(6)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_5,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Rcv_Filter(5)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_4,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Rcv_Filter(4)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_3,H15530_record_Bit_number_EXMPLR1529(4),
   not_ResetN,CE,Clock,Rcv_Filter(3)) ;
   DFFPCE (rtlcn1009,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Rcv_Filter(2)) ;
   DFFPCE (rtlcn998,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Rcv_Filter(1)) ;
   DFFPCE (rtlcn648,not_ResetN,H15530_record_Bit_number_EXMPLR1529(4),CE,
   Clock,Rcv_Filter(0)) ;
   DFFPCE (rtlc59n430,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,H15530_record_recieving) ;
   DFFPCE (rtlc62n94,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,CE,
   Clock,Big_Bit_Gap) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn290,Clock,H15530_record_R_Data(0)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn295,Clock,H15530_record_R_Data(1)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn300,Clock,H15530_record_R_Data(2)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn305,Clock,H15530_record_R_Data(3)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn310,Clock,H15530_record_R_Data(4)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn315,Clock,H15530_record_R_Data(5)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn320,Clock,H15530_record_R_Data(6)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn325,Clock,H15530_record_R_Data(7)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn330,Clock,H15530_record_R_Data(8)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn335,Clock,H15530_record_R_Data(9)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn340,Clock,H15530_record_R_Data(10)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn345,Clock,H15530_record_R_Data(11)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn350,Clock,H15530_record_R_Data(12)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn355,Clock,H15530_record_R_Data(13)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn360,Clock,H15530_record_R_Data(14)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1529(4),not_ResetN,
   rtlcn365,Clock,H15530_record_R_Data(15)) ;
   rtlc47n629 <= Bit_number(2) OR Bit_number(3) ;
   rtlc23n361 <= rtlc47n629 OR Bit_number(4) ;
   rtlc35_142_and_907_nx0 <= rtlcs0 AND not_rtlcs36 ;
   rtlc35_X_0_n377 <= rtlc35_142_and_907_nx0 AND not_rtlc35n267 ;
   rtlc50_43_and_930_nx0 <= rtlcs42 AND not_rtlcs40 ;
   rtlc50_X_0_n204 <= rtlc50_43_and_930_nx0 AND not_RxRdy ;
   rtlc59_194_or_932_nx0 <= Rcv_Filter(4) OR Rcv_Filter(5) ;
   rtlc59n464 <= rtlc59_194_or_932_nx0 OR Rcv_Filter(6) ;
   rtlc59_198_or_933_nx0 <= Rcv_Filter(3) OR Rcv_Filter(5) ;
   rtlc59n467 <= rtlc59_198_or_933_nx0 OR Rcv_Filter(6) ;
   rtlc59_670_or_935_nx0 <= one_shot(4) OR one_shot(5) ;
   rtlc59n669 <= rtlc59_670_or_935_nx0 OR one_shot(6) ;
   rtlc_232_and_937_nx0 <= rtlc23n85 AND not_rtlc23n95 ;
   rtlc23n544 <= rtlc_232_and_937_nx0 AND not_energy_5 ;
   rtlc_233_and_938_nx0 <= not_rtlc23n85 AND rtlc23n451 ;
   rtlc23n541 <= rtlc_233_and_938_nx0 AND not_rtlc23n150 ;
   rtlc_235_and_939_nx0 <= rtlc23n85 AND rtlc23n95 ;
   rtlc23n543 <= rtlc_235_and_939_nx0 AND rtlc23n394 ;
   rtlc_320_and_940_nx0 <= not_rtlc23n85 AND rtlc23n150 ;
   rtlc23n542 <= rtlc_320_and_940_nx0 AND rtlc23n379 ;
   rtlc_1479_or_956_nx0 <= rtlcs8 OR rtlcs10 ;
   rtlc38n482 <= rtlc_1479_or_956_nx0 OR rtlcs15 ;
   rtlc_1621_or_957_nx0 <= not_rtlc59n464 OR rtlcn698 ;
   rtlcn740 <= rtlc_1621_or_957_nx0 OR rtlcn1077 ;
   rtlc_1629_or_958_nx0 <= not_rtlc59n467 OR rtlcn698 ;
   rtlcn758 <= rtlc_1629_or_958_nx0 OR rtlcn1078 ;
   rtlc_1633_and_959_nx0 <= not_Clean_plus AND Rcv_Filter(3) ;
   rtlcn1011 <= rtlc_1633_and_959_nx0 AND not_rtlc59n252 ;
   rtlc_1638_and_960_nx0 <= not_Clean_minus AND Rcv_Filter(4) ;
   rtlcn1038 <= rtlc_1638_and_960_nx0 AND not_rtlc59n281 ;
   rtlc_1656_and_961_nx0 <= not_rtlc35n613 AND not_rtlc35n629 ;
   rtlcn1118 <= rtlc_1656_and_961_nx0 AND not_RxRdy_plus_us_4 ;
   rtlc_1677_and_963_nx0 <= not_Clean_minus AND rtlcs44 ;
   rtlcn1127 <= rtlc_1677_and_963_nx0 AND rtlcs47 ;
   rtlc_1681_or_964_nx0 <= rtlcn1126 OR rtlcn1127 ;
   rtlcn1086 <= rtlc_1681_or_964_nx0 OR rtlcn1130 ;
   rtlcn591 <= rtlcs35 AND Strobe ;
   rtlc62n36 <= not_Clean_minus AND not_Clean_plus ;
   rtlcn1143 <= rtlc62n36 AND Rcv_Filter(0) ;
   rtlc_1722_and_970_nx0 <= Xmitting AND not_rtlc20n33 ;
   rtlcn843 <= rtlc_1722_and_970_nx0 AND Check_loop_back ;
   rtlc_1725_and_971_nx0 <= not_rtlc35n267 AND not_rtlcs36 ;
   rtlcn876 <= rtlc_1725_and_971_nx0 AND rtlcs0 ;
   rtlc_1729_and_972_nx0 <= not_Clean_plus AND rtlcn1083 ;
   rtlcn998 <= rtlc_1729_and_972_nx0 AND not_rtlcn698 ;
   rtlc_1731_and_973_nx0 <= not_Clean_minus AND Rcv_Filter(2) ;
   rtlcn1151 <= rtlc_1731_and_973_nx0 AND not_rtlc59n281 ;
   rtlc_1742_or_974_nx0 <= Big_Bit_Gap OR rtlc38n772 ;
   rtlcn698 <= rtlc_1742_or_974_nx0 OR not_Recieving ;
   rtlc_2046_or_976_nx0 <= rtlc38n455 OR rtlcn1218 ;
   rtlcn1230 <= rtlc_2046_or_976_nx0 OR rtlcn1246 ;
   rtlc_2067_and_977_nx0 <= not_rtlc47n218 AND not_rtlcn1215 ;
   rtlcn1256 <= rtlc_2067_and_977_nx0 AND rtlcn1222 ;
   rtlc35n267 <= Clean_minus OR Clean_plus ;
   rtlcn1224 <= rtlc35n267 OR not_Recieving ;
   rtlc_2106_and_980_nx0 <= not_Bit_number_4 AND not_Bit_number_3 ;
   rtlcs23 <= rtlc_2106_and_980_nx0 AND not_Bit_number_2 ;
   rtlcs12 <= not_Phase_3 AND Phase(4) ;
   rtlcs14 <= rtlcs12 AND not_Phase_1 ;
   rtlc_2228_and_984_nx0 <= Phase(4) AND Phase(3) ;
   rtlcs16 <= rtlc_2228_and_984_nx0 AND not_Phase_1 ;
   Data_47n4s3_3 <= not_Bit_number_3 XOR not_Bit_number_2 ;
   Actual_gap_sub7_35i1 : sub_6u_6u_6u_0 port map ( cin=>RxRdy_plus_us(0), 
      a(5)=>RxRdy_plus_us(6), a(4)=>RxRdy_plus_us(5), a(3)=>RxRdy_plus_us(4), 
      a(2)=>RxRdy_plus_us(3), a(1)=>RxRdy_plus_us(2), a(0)=>RxRdy_plus_us(1), 
      b(5)=>H15530_record_Bit_number_EXMPLR1529(4), b(4)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), b(0)=>PWR, d(5)=>
      Actual_gap_35n1s1(6), d(4)=>Actual_gap_35n1s1(5), d(3)=>
      Actual_gap_35n1s1(4), d(2)=>Actual_gap_35n1s1(3), d(1)=>
      Actual_gap_35n1s1(2), d(0)=>Actual_gap_35n1s1(1), cout=>DANGLING(19));
   modgen_and_0 : and_3u_3u port map ( a(2)=>not_Advance, a(1)=>
      not_rtlc38n485, a(0)=>Recieving, d=>rtlcn519);
   modgen_counter_one_shot : counter_up_sload_aclear_clock_clk_en_0_7
       port map ( clock=>Clock, q(6)=>one_shot(6), q(5)=>one_shot(5), q(4)=>
      one_shot(4), q(3)=>one_shot(3), q(2)=>one_shot(2), q(1)=>one_shot(1), 
      q(0)=>one_shot(0), clk_en=>CE, aclear=>not_ResetN, sload=>not_rtlcn623, 
      data(6)=>H15530_record_Bit_number_EXMPLR1529(4), data(5)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(4)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(3)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(2)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(1)=>
      H15530_record_Bit_number_EXMPLR1529(4), data(0)=>PWR, aset=>
      H15530_record_Bit_number_EXMPLR1529(4), sclear=>
      H15530_record_Bit_number_EXMPLR1529(4), updn=>PWR, cnt_en=>PWR);
   ix78 : decoder_4 port map ( data(3)=>Data_47n4s3_3, data(2)=>
      Bit_number(2), data(1)=>Data_47n4s3_1, data(0)=>Data_47n4s3_0, eq(15)
      =>Data_47n4s2(15), eq(14)=>Data_47n4s2(14), eq(13)=>Data_47n4s2(13), 
      eq(12)=>Data_47n4s2(12), eq(11)=>Data_47n4s2(11), eq(10)=>
      Data_47n4s2(10), eq(9)=>Data_47n4s2(9), eq(8)=>Data_47n4s2(8), eq(7)=>
      Data_47n4s2(7), eq(6)=>Data_47n4s2(6), eq(5)=>Data_47n4s2(5), eq(4)=>
      Data_47n4s2(4), eq(3)=>Data_47n4s2(3), eq(2)=>Data_47n4s2(2), eq(1)=>
      Data_47n4s2(1), eq(0)=>Data_47n4s2(0));
   modgen_or_1 : or_5u_5u port map ( a(4)=>energy(2), a(3)=>energy(3), a(2)
      =>energy(4), a(1)=>energy(5), a(0)=>rtlc23n378, d=>rtlc23n379);
   modgen_and_2 : and_5u_5u port map ( a(4)=>one_shot(4), a(3)=>one_shot(3), 
      a(2)=>one_shot(2), a(1)=>one_shot(1), a(0)=>one_shot(0), d=>rtlc38n770
   );
   modgen_or_3 : or_5u_5u port map ( a(4)=>Sync_error_47n7s1, a(3)=>
      Big_Bit_Gap, a(2)=>rtlc38n772, a(1)=>not_Recieving, a(0)=>
      not_rtlcn1088, d=>rtlcn1226);
   modgen_and_4 : and_7u_7u port map ( a(6)=>Len(5), a(5)=>not_Len_4, a(4)=>
      not_Len_3, a(3)=>Len(2), a(2)=>Len(1), a(1)=>not_Len_0, a(0)=>rtlcs45, 
      d=>Found_CMD_Sync_56n8ss1);
   modgen_and_5 : and_12u_12u port map ( a(11)=>not_RxRdy_plus_phase_4, 
      a(10)=>not_RxRdy_plus_phase_3, a(9)=>not_RxRdy_plus_phase_2, a(8)=>
      not_RxRdy_plus_phase_1, a(7)=>not_RxRdy_plus_phase_0, a(6)=>
      not_RxRdy_plus_us_6, a(5)=>not_RxRdy_plus_us_5, a(4)=>
      not_RxRdy_plus_us_4, a(3)=>not_RxRdy_plus_us_3, a(2)=>RxRdy_plus_us(2), 
      a(1)=>not_RxRdy_plus_us_1, a(0)=>not_RxRdy_plus_us_0, d=>
      RxRdy_plus_10us_50n4s1);
end Sital_technology_unfold_1 ;


architecture INTERFACE_unfold_3 of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, PWR, nx42, nx44, nx46, 
      nx48, nx50, NOT_nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx25 ;
   q(3) <= nx27 ;
   q(2) <= nx29 ;
   q(1) <= nx31 ;
   q(0) <= nx33 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 OR sclear ;
   nx21 <= nx18 AND clk_en ;
   DFFPCE (nx24,GND,aclear,nx21,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx21,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx21,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx21,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx21,clock,nx33) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx25, a(3)=>nx27, a(2)=>
      nx29, a(1)=>nx31, a(0)=>nx33, d(4)=>nx34, d(3)=>nx35, d(2)=>nx36, d(1)
      =>nx37, d(0)=>nx38, cout=>DANGLING(0));
   PWR <= '1' ;
   nx42 <= data(4) when sload = '1' else nx34 ;
   nx44 <= data(3) when sload = '1' else nx35 ;
   nx46 <= data(2) when sload = '1' else nx36 ;
   nx48 <= data(1) when sload = '1' else nx37 ;
   nx50 <= data(0) when sload = '1' else nx38 ;
   NOT_nx17 <= NOT sclear ;
   nx24 <= nx42 AND NOT_nx17 ;
   nx26 <= nx44 AND NOT_nx17 ;
   nx28 <= nx46 AND NOT_nx17 ;
   nx30 <= nx48 AND NOT_nx17 ;
   nx32 <= nx50 AND NOT_nx17 ;
end INTERFACE_unfold_3 ;


architecture INTERFACE_unfold_1 of 
   counter_up_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, PWR, nx33, nx35, nx37, nx39, nx41, 
      NOT_SCLEAR: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   PWR <= '1' ;
   nx33 <= data(4) when sload = '1' else nx25 ;
   nx35 <= data(3) when sload = '1' else nx26 ;
   nx37 <= data(2) when sload = '1' else nx27 ;
   nx39 <= data(1) when sload = '1' else nx28 ;
   nx41 <= data(0) when sload = '1' else nx29 ;
   NOT_SCLEAR <= NOT sclear ;
   nx15 <= nx33 AND NOT_SCLEAR ;
   nx17 <= nx35 AND NOT_SCLEAR ;
   nx19 <= nx37 AND NOT_SCLEAR ;
   nx21 <= nx39 AND NOT_SCLEAR ;
   nx23 <= nx41 AND NOT_SCLEAR ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_2 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx22, nx25, nx26, nx27, nx28, nx29, nx30, nx31, nx32, 
      nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, 
      nx45, PWR, NOT_nx18: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx26 ;
   q(5) <= nx28 ;
   q(4) <= nx30 ;
   q(3) <= nx32 ;
   q(2) <= nx34 ;
   q(1) <= nx36 ;
   q(0) <= nx38 ;
   GND <= '0' ;
   nx19 <= cnt_en OR sclear ;
   nx22 <= nx19 AND clk_en ;
   DFFPCE (nx25,GND,aclear,nx22,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,nx22,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,nx22,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx22,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx22,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx22,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx22,clock,nx38) ;
   inc : inc_7u_7u_0_0 port map ( cin=>PWR, a(6)=>nx26, a(5)=>nx28, a(4)=>
      nx30, a(3)=>nx32, a(2)=>nx34, a(1)=>nx36, a(0)=>nx38, d(6)=>nx39, d(5)
      =>nx40, d(4)=>nx41, d(3)=>nx42, d(2)=>nx43, d(1)=>nx44, d(0)=>nx45, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx18 <= NOT sclear ;
   nx25 <= nx39 AND NOT_nx18 ;
   nx27 <= nx40 AND NOT_nx18 ;
   nx29 <= nx41 AND NOT_nx18 ;
   nx31 <= nx42 AND NOT_nx18 ;
   nx33 <= nx43 AND NOT_nx18 ;
   nx35 <= nx44 AND NOT_nx18 ;
   nx37 <= nx45 AND NOT_nx18 ;
end INTERFACE_unfold_2 ;


architecture INTERFACE_unfold_4 of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, PWR, nx42, nx44, nx46, 
      nx48, nx50, NOT_nx17: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx25 ;
   q(3) <= nx27 ;
   q(2) <= nx29 ;
   q(1) <= nx31 ;
   q(0) <= nx33 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 OR sclear ;
   nx21 <= nx18 AND clk_en ;
   DFFPCE (nx24,GND,aclear,nx21,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx21,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx21,clock,nx29) ;
   DFFPCE (nx30,GND,aclear,nx21,clock,nx31) ;
   DFFPCE (nx32,GND,aclear,nx21,clock,nx33) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx25, a(3)=>nx27, a(2)=>
      nx29, a(1)=>nx31, a(0)=>nx33, d(4)=>nx34, d(3)=>nx35, d(2)=>nx36, d(1)
      =>nx37, d(0)=>nx38, cout=>DANGLING(0));
   PWR <= '1' ;
   nx42 <= data(4) when sload = '1' else nx34 ;
   nx44 <= data(3) when sload = '1' else nx35 ;
   nx46 <= data(2) when sload = '1' else nx36 ;
   nx48 <= data(1) when sload = '1' else nx37 ;
   nx50 <= data(0) when sload = '1' else nx38 ;
   NOT_nx17 <= NOT sclear ;
   nx24 <= nx42 AND NOT_nx17 ;
   nx26 <= nx44 AND NOT_nx17 ;
   nx28 <= nx46 AND NOT_nx17 ;
   nx30 <= nx48 AND NOT_nx17 ;
   nx32 <= nx50 AND NOT_nx17 ;
end INTERFACE_unfold_4 ;


architecture INTERFACE_unfold_1 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx13, nx16, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, PWR, NOT_nx12: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(3) <= nx20 ;
   q(2) <= nx22 ;
   q(1) <= nx24 ;
   q(0) <= nx26 ;
   GND <= '0' ;
   nx13 <= cnt_en OR sclear ;
   nx16 <= nx13 AND clk_en ;
   DFFPCE (nx19,GND,aclear,nx16,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,nx16,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,nx16,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,nx16,clock,nx26) ;
   inc : inc_4u_4u_0_0 port map ( cin=>PWR, a(3)=>nx20, a(2)=>nx22, a(1)=>
      nx24, a(0)=>nx26, d(3)=>nx27, d(2)=>nx28, d(1)=>nx29, d(0)=>nx30, cout
      =>DANGLING(0));
   PWR <= '1' ;
   NOT_nx12 <= NOT sclear ;
   nx19 <= nx27 AND NOT_nx12 ;
   nx21 <= nx28 AND NOT_nx12 ;
   nx23 <= nx29 AND NOT_nx12 ;
   nx25 <= nx30 AND NOT_nx12 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_1 of counter_up_sload_aclear_clock_clk_en_0_7
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR1567: std_logic_vector (6 DOWNTO 0) ;
   
   signal nx15, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, nx27, nx28, 
      nx29, nx30, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx41
   : std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx20 ;
   q(5) <= nx22 ;
   q(4) <= nx24 ;
   q(3) <= nx26 ;
   q(2) <= nx28 ;
   q(1) <= nx30 ;
   q(0) <= nx32 ;
   nx15 <= '0' ;
   DFFPCE (nx19,nx15,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx15,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx15,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,nx15,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,nx15,aclear,clk_en,clock,nx28) ;
   DFFPCE (nx29,nx15,aclear,clk_en,clock,nx30) ;
   DFFPCE (nx31,nx15,aclear,clk_en,clock,nx32) ;
   inc : inc_7u_7u_0_0 port map ( cin=>nx41, a(6)=>nx20, a(5)=>nx22, a(4)=>
      nx24, a(3)=>nx26, a(2)=>nx28, a(1)=>nx30, a(0)=>nx32, d(6)=>nx33, d(5)
      =>nx34, d(4)=>nx35, d(3)=>nx36, d(2)=>nx37, d(1)=>nx38, d(0)=>nx39, 
      cout=>DANGLING(0));
   nx41 <= '1' ;
   nx19 <= data(6) when sload = '1' else nx33 ;
   nx21 <= data(5) when sload = '1' else nx34 ;
   nx23 <= data(4) when sload = '1' else nx35 ;
   nx25 <= data(3) when sload = '1' else nx36 ;
   nx27 <= data(2) when sload = '1' else nx37 ;
   nx29 <= data(1) when sload = '1' else nx38 ;
   nx31 <= data(0) when sload = '1' else nx39 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_1 of decoder_4 is 
   component eq_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal data_EXMPLR1589: std_logic_vector (3 DOWNTO 0) ;
   
   signal eq_EXMPLR1590: std_logic_vector (15 DOWNTO 0) ;
   
   signal nx24, nx26: std_logic ;

begin
   nx24 <= '0' ;
   nx26 <= '1' ;
   cmp_15 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(15));
   cmp_14 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(14));
   cmp_13 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(13));
   cmp_12 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(12));
   cmp_11 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(11));
   cmp_10 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(10));
   cmp_9 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(9));
   cmp_8 : eq_4u_4u port map ( a=>data, b(3)=>nx26, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(8));
   cmp_7 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(7));
   cmp_6 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(6));
   cmp_5 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(5));
   cmp_4 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx26, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(4));
   cmp_3 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx26, d=>eq(3));
   cmp_2 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx26, 
      b(0)=>nx24, d=>eq(2));
   cmp_1 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx26, d=>eq(1));
   cmp_0 : eq_4u_4u port map ( a=>data, b(3)=>nx24, b(2)=>nx24, b(1)=>nx24, 
      b(0)=>nx24, d=>eq(0));
end INTERFACE_unfold_1 ;


architecture Sital_technology_unfold_3721_0 of H15530_Ver17_32_0 is 
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component addsub_6u_6u_6u_0
      port (
         mode : IN std_logic ;
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_7u_7u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component mux_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_4u_4u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_sload_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (3 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component sub_6u_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_sload_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component decoder_4
      port (
         data : IN std_logic_vector (3 DOWNTO 0) ;
         eq : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   component and_12u_12u
      port (
         a : IN std_logic_vector (11 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_gap_phase : 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE_unfold_3
   );
   for modgen_counter_Bit_number : 
   counter_up_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE_unfold_1);
   for modgen_counter_RxRdy_plus_us : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7(INTERFACE_unfold_2);
   
   for modgen_counter_RxRdy_plus_phase : 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 use entity work.
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5(INTERFACE_unfold_4
   );
   for modgen_counter_Bit_Gap : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4(INTERFACE_unfold_1);
   
   for modgen_counter_one_shot : counter_up_sload_aclear_clock_clk_en_0_7
    use entity work.counter_up_sload_aclear_clock_clk_en_0_7(
   INTERFACE_unfold_1);
   for ix78 : decoder_4 use entity work.decoder_4(INTERFACE_unfold_1);
   signal Sync_error_EXMPLR1600, Advance, Big_Bit_Gap, Bit_Gap_3: std_logic
    ;
   
   signal Bit_number: std_logic_vector (4 DOWNTO 0) ;
   
   signal Bit_value, Calc_parity, Clean_minus, Clean_plus, Echo, 
      Found_CMD_Sync: std_logic ;
   
   signal Len: std_logic_vector (5 DOWNTO 0) ;
   
   signal Level_minus: std_logic ;
   
   signal Minus_shifter: std_logic_vector (8 DOWNTO 0) ;
   
   signal Phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal Plus_shifter: std_logic_vector (8 DOWNTO 0) ;
   
   signal Recieving, RxRdy: std_logic ;
   
   signal RxRdy_plus_phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal RxRdy_plus_us: std_logic_vector (6 DOWNTO 0) ;
   
   signal Stall, Strobe: std_logic ;
   
   signal energy: std_logic_vector (5 DOWNTO 0) ;
   
   signal first_sync: std_logic ;
   
   signal gap_phase: std_logic_vector (4 DOWNTO 0) ;
   
   signal level_plus, minus_d, minus_d_falling_edge, minus_dd, 
      minus_dd_falling_edge: std_logic ;
   
   signal one_shot: std_logic_vector (6 DOWNTO 0) ;
   
   signal plus_d, plus_d_falling_edge, plus_dd, plus_dd_falling_edge, 
      resync_after_fault: std_logic ;
   
   signal Rcv_Filter: std_logic_vector (6 DOWNTO 0) ;
   
   signal state: std_logic_vector (1 DOWNTO 0) ;
   
   signal PWR: std_logic ;
   
   signal H15530_record_Bit_number_EXMPLR1642: std_logic_vector (4 DOWNTO 4)
    ;
   
   signal not_H15530_record_Manchester_error, not_ResetN, plus_dd_5n1ss1, 
      minus_dd_5n2ss1, rtlc5n44, not_Clock, plus_dd_falling_edge_11n1ss1, 
      minus_dd_falling_edge_11n2ss1, rtlc11n36, not_Minus_shifter_3, 
      rtlc14n57, not_Plus_shifter_3, rtlc14n77, Clean_plus_17n1s3, 
      Clean_plus_17n1s6, Clean_plus_17n1s2, Clean_plus_17n1s9, 
      Clean_plus_17n1s1, Clean_minus_17n1s3, Clean_minus_17n1s6, 
      Clean_minus_17n1s2, Clean_minus_17n1s9, Clean_minus_17n1s1, rtlc20n30, 
      not_minus_dd, rtlc20n32, rtlc20n33: std_logic ;
   
   signal energy_23n9ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc23n81, rtlc23n83, rtlc23n85, rtlc23n95, not_rtlc23n95, 
      not_rtlc23n85, rtlc23n150: std_logic ;
   
   signal energy_23n6s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_rtlc23n150, not_CE, rtlc23n193, not_Xmitting, not_rtlcn148, 
      rtlc23n217, not_rtlc23n394, rtlc23n258, rtlc23n259, rtlc23n361, 
      not_rtlcn154, rtlc23n378, rtlc23n379, not_energy_5, not_rtlcn155, 
      rtlc23n394, rtlc23n451, rtlc23n541, rtlc23n542, rtlc23n543, rtlc23n544, 
      rtlc23n547, rtlc26n62, rtlc26n79, rtlc26n93, rtlc26n95, not_rtlc26n93, 
      not_Clean_plus, rtlc29n57, not_Clean_minus: std_logic ;
   
   signal Actual_gap_35n1ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Gap_35n13ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Actual_gap_35n1s1: std_logic_vector (6 DOWNTO 1) ;
   
   signal not_rtlcs5, not_rtlcs40, rtlc35n264, not_rtlcs36: std_logic ;
   
   signal Gap_35n11s1: std_logic_vector (6 DOWNTO 0) ;
   
   signal not_rtlcs0, rtlc35n310, not_rtlc35n267, rtlc35_X_0_n377, 
      not_rtlc35n653, rtlc35n442, rtlc35n452, rtlc35n569, not_rtlc35n569, 
      not_RxRdy_plus_us_2, rtlc35n572, not_rtlcn161, rtlc35n612, rtlc35n613, 
      rtlc35n629, rtlc35n652, rtlc35n653, rtlc35n670, not_RxRdy_plus_us_6, 
      rtlc35n685, not_rtlc35n685, rtlc35n690, rtlc35n691: std_logic ;
   
   signal Phase_38n15ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Phase_38n17ss1_4, Phase_38n17ss1_2, Phase_38n17ss1_1, 
      Phase_38n17ss1_0: std_logic ;
   
   signal Phase_38n18ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc38n268: std_logic ;
   
   signal Phase_38n5s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal not_Manchester_error_41n2s2, not_Manchester_error_41n2s1, 
      rtlc38n365, rtlc38n367, rtlc38n368, not_rtlc38n368, rtlc38n389, 
      rtlc38n390, rtlc38n393, rtlc38n403, not_Bit_value, rtlc38n405, 
      rtlc38n406, rtlc38n407, not_rtlc38n407, rtlc38n420: std_logic ;
   
   signal Phase_38n15s1: std_logic_vector (4 DOWNTO 1) ;
   
   signal rtlc38n449, rtlc38n453, rtlc38n455, rtlc38n482, rtlc38n483, 
      not_rtlc38n483, rtlc38n485, not_rtlcs21, rtlc38_X_0_n587, rtlc38n588, 
      rtlc38n614, rtlc38n615, rtlc38n616, not_rtlc38n588, rtlc38n665, 
      rtlc38n666, rtlc38n667, rtlc38n668, rtlc38n669, rtlc38n770, rtlc38n771, 
      rtlc38n772, Manchester_error_41n2ss1, Bit_value_41n4ss1, 
      Manchester_error_41n4ss1, Manchester_error_41n2s1, 
      Manchester_error_41n2s2, rtlc41n108, rtlc41n109, Strobe_44n1s1, 
      Sync_error_47n7ss1, Command_sync_47n10ss1, Calc_parity_47n10ss1, 
      Sync_error_47n10ss1, rtlc47n218, rtlc47n235, Data_47n4s3_3, 
      Data_47n4s3_1, Data_47n4s3_0: std_logic ;
   
   signal Data_47n4s2: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlc47n417, Sync_error_47n7s1, not_rtlcn158, Calc_parity_47n7s1, 
      rtlc47n426, rtlc47n433, rtlc47n437, rtlc47n453, not_rtlc47n630, 
      rtlc47n551, rtlc47n552, rtlc47n553, rtlc47n571, rtlc47n614, 
      not_rtlc47n614, rtlc47n630, rtlc47n644, RxRdy_plus_10us_50n4s1, 
      not_rtlcs42, rtlc50n176, not_rtlc50n176, not_RxRdy, rtlc50_X_0_n204, 
      Found_CMD_Sync_56n8ss1: std_logic ;
   
   signal Len_56n8ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal state_fsm_56n8ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal state_fsm_56n9ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal Len_56n6s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc56n169, rtlc56n176, rtlc56n177, not_rtlc56n177, rtlc56n179, 
      Rcv_Filter_fsm_59n4ss1_4, Rcv_Filter_fsm_59n6ss1_3, 
      Rcv_Filter_fsm_59n13ss1_4, Rcv_Filter_fsm_59n13ss1_3, 
      Rcv_Filter_fsm_59n16ss1_6, Rcv_Filter_fsm_59n16ss1_5, 
      Rcv_Filter_fsm_59n16ss1_4, Rcv_Filter_fsm_59n16ss1_3, rtlc59n252, 
      rtlc59n281, rtlc59n430, not_rtlc59n464, not_rtlc59n467, rtlc59n464, 
      rtlc59n467, rtlc59n669, rtlc59n671, not_rtlcn160, rtlc62n94, 
      not_rtlc62n36, rtlcn148, rtlcn154, rtlcn155, rtlcn157, rtlcn158, 
      rtlcn159, rtlcn160, rtlcn161, rtlcn163, rtlcn290, rtlcn295, rtlcn300, 
      rtlcn305, rtlcn310, rtlcn315, rtlcn320, rtlcn325, rtlcn330, rtlcn335, 
      rtlcn340, rtlcn345, rtlcn350, rtlcn355, rtlcn360, rtlcn365, rtlcn371, 
      rtlcn399, rtlcn403, rtlcn407, rtlcn409, rtlcn410, not_rtlcn1057, 
      rtlcn445, rtlcn455, rtlcn482, rtlcn483, rtlcn495, rtlcn501, rtlcn502, 
      rtlcn508, rtlcn509, rtlcn519, rtlcn535, rtlcn581, rtlcn591, rtlcn623, 
      rtlcn648, rtlcn698, rtlcn738, rtlcn739, rtlcn740, rtlcn756, rtlcn757, 
      rtlcn758, rtlcn838, not_rtlcn1213, rtlcn843, rtlcn876, rtlcn998, 
      rtlcn1009, rtlcn1011, not_rtlcn1209, rtlcn1038, not_rtlcn1210, 
      rtlcn1057, rtlcn1058, not_state_1, not_state_0, rtlcn1074, rtlcn1075, 
      rtlcn1076, rtlcn1077, rtlcn1078, rtlcn1079, rtlcn1080, rtlcn1082, 
      rtlcn1083, rtlcn1084, rtlcn1085, rtlcn1086, rtlcn1087, rtlcn1088, 
      rtlcn1089, rtlcn1090, not_Advance, not_rtlcs18, not_rtlc38n485, 
      not_rtlc38n455, rtlcn1096, rtlcn1097, not_Recieving, rtlcn1099, 
      rtlcn1101, not_rtlcn698, not_rtlc59n252, not_rtlc59n281, 
      not_rtlc35n691, not_rtlcn1211, not_rtlcn1212, not_rtlc35n613, 
      not_rtlc35n629, not_RxRdy_plus_us_4, rtlcn1118, not_RxRdy_plus_us_3, 
      rtlcn1121, rtlcn1122, rtlcn1124, rtlcn1125, rtlcn1126, rtlcn1127, 
      not_rtlc56n179, rtlcn1130, not_rtlc23n451, not_rtlc23n379, rtlcn1133, 
      not_Stall, not_rtlcs35, rtlcn1140, rtlcn1141, rtlcn1142, rtlcn1143, 
      not_rtlc20n33, rtlcn1148, rtlcn1149, rtlcn1150, rtlcn1151, 
      not_rtlcn371, not_rtlcn399, rtlcn1208, rtlcn1209, rtlcn1210, rtlcn1211, 
      rtlcn1212, rtlcn1213, rtlcn1214, rtlcn1215, rtlcn1217, rtlcn1218, 
      rtlcn1219, rtlcn1220, rtlcn1221, rtlcn1222, rtlcn1223, rtlcn1224, 
      rtlcn1226, rtlcn1227, rtlcn1228, rtlcn1229, rtlcn1230, rtlcn1231, 
      not_rtlc23n217, not_rtlc23n193, not_rtlc26n62, not_rtlc35n310, 
      not_rtlcn1088, rtlcn1239, not_rtlc38n420, not_rtlcn1287, rtlcn1246, 
      rtlcn1247, rtlcn1248, not_Strobe, not_rtlcn1215, not_rtlc47n218, 
      rtlcn1256, not_rtlcn1387, rtlcn1259, rtlcn1260, not_rtlcn1214, 
      rtlcn1262, rtlcs0, rtlcs1, not_Phase_4, rtlcs3, rtlcs4, rtlcs5, rtlcs7, 
      rtlcs8, rtlcs10, rtlcs11, rtlcs13, rtlcs14, rtlcs15, rtlcs16, rtlcs17, 
      rtlcs18, rtlcs20, rtlcs21, rtlcs22, rtlcs23, rtlcs24, rtlcs25, rtlcs27, 
      rtlcs28, rtlcs30, rtlcs32, rtlcs35, rtlcs36, rtlcs37, rtlcs40, rtlcs42, 
      rtlcs44, rtlcs45, rtlcs46, rtlcs47, rtlcs48, not_Bit_number_4, 
      not_Bit_number_3, not_Bit_number_2, not_rtlc5n44, not_rtlc11n36, 
      not_rtlcn455, not_Found_CMD_Sync, not_Phase_3, not_Phase_1, 
      not_rtlcs13, rtlcn1287, not_Phase_2, not_Phase_0, not_rtlcn623, 
      not_rtlc56n169, not_Len_4, not_Len_2, not_Len_1, not_Len_0, not_Len_3, 
      not_rtlcs17, not_rtlcn509, rtlcn1387, not_energy_4, not_energy_3, 
      not_energy_2, not_energy_1, not_energy_0, not_rtlcs25, not_rtlc35n572, 
      not_RxRdy_plus_us_5, not_RxRdy_plus_us_1, not_RxRdy_plus_us_0, 
      not_RxRdy_plus_phase_4, not_RxRdy_plus_phase_3, not_RxRdy_plus_phase_2, 
      not_RxRdy_plus_phase_1, not_RxRdy_plus_phase_0, not_Echo, rtlcn1698, 
      rtlcn1701, rtlcn1715, not_Bit_Gap_3, not_rtlc38n616, 
      H15530_record_Manchester_error_EXMPLR1602: std_logic ;
   
   signal H15530_record_RAW_GAP_EXMPLR1644: std_logic_vector (6 DOWNTO 0) ;
   
   signal H15530_record_Command_Sync_EXMPLR1639: std_logic ;
   
   signal energy_23n6s1f1: std_logic_vector (1 DOWNTO 0) ;
   
   signal rtlc47n629, rtlc35_142_and_907_nx0, rtlc50_43_and_930_nx0, 
      rtlc59_194_or_932_nx0, rtlc59_198_or_933_nx0, rtlc59_670_or_935_nx0, 
      rtlc_232_and_937_nx0, rtlc_233_and_938_nx0, rtlc_235_and_939_nx0, 
      rtlc_320_and_940_nx0, rtlc_1479_or_956_nx0, rtlc_1621_or_957_nx0, 
      rtlc_1629_or_958_nx0, rtlc_1633_and_959_nx0, rtlc_1638_and_960_nx0, 
      rtlc_1656_and_961_nx0, rtlc_1677_and_963_nx0, rtlc_1681_or_964_nx0, 
      rtlc62n36, rtlc_1722_and_970_nx0, rtlc_1725_and_971_nx0, 
      rtlc_1729_and_972_nx0, rtlc_1731_and_973_nx0, rtlc_1742_or_974_nx0, 
      rtlc_2046_or_976_nx0, rtlc_2067_and_977_nx0, rtlc35n267, 
      rtlc_2106_and_980_nx0, rtlcs12, rtlc_2228_and_984_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (19 downto 0 );

begin
   Bi_error <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Bit_number(4) <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Bit_number(3) <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Bit_number(2) <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Bit_number(1) <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Bit_number(0) <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Response_Time(7) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(6) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(5) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(4) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(3) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(2) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(1) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Response_Time(0) <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Sync_error <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Manchester_error <= H15530_record_Bit_number_EXMPLR1642(4)
    ;
   H15530_record_Parity_error <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_echo_back_bus <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_RAW_GAP(6) <= H15530_record_RAW_GAP_EXMPLR1644(6) ;
   H15530_record_RAW_GAP(5) <= H15530_record_RAW_GAP_EXMPLR1644(5) ;
   H15530_record_RAW_GAP(4) <= H15530_record_RAW_GAP_EXMPLR1644(4) ;
   H15530_record_RAW_GAP(3) <= H15530_record_RAW_GAP_EXMPLR1644(3) ;
   H15530_record_RAW_GAP(2) <= H15530_record_RAW_GAP_EXMPLR1644(2) ;
   H15530_record_RAW_GAP(1) <= H15530_record_RAW_GAP_EXMPLR1644(1) ;
   H15530_record_RAW_GAP(0) <= H15530_record_RAW_GAP_EXMPLR1644(0) ;
   H15530_record_RxRDY_plus_12us <= H15530_record_Bit_number_EXMPLR1642(4) ;
   H15530_record_Command_Sync <= H15530_record_Command_Sync_EXMPLR1639 ;
   Parity_error <= H15530_record_Bit_number_EXMPLR1642(4) ;
   Sync_error <= Sync_error_EXMPLR1600 ;
   PWR <= '1' ;
   H15530_record_Bit_number_EXMPLR1642(4) <= '0' ;
   not_Clock <= NOT Clock ;
   rtlc14n77 <= Minus_shifter(3) AND not_Plus_shifter_3 ;
   rtlc14n57 <= Plus_shifter(3) AND not_Minus_shifter_3 ;
   not_Minus_shifter_3 <= NOT Minus_shifter(3) ;
   not_Plus_shifter_3 <= NOT Plus_shifter(3) ;
   Clean_plus_17n1s1 <= Clean_plus_17n1s2 OR Clean_plus_17n1s9 ;
   Clean_plus_17n1s2 <= Clean_plus_17n1s3 OR Clean_plus_17n1s6 ;
   Clean_plus_17n1s3 <= Plus_shifter(2) AND Plus_shifter(1) ;
   Clean_plus_17n1s6 <= Plus_shifter(2) AND Plus_shifter(0) ;
   Clean_plus_17n1s9 <= Plus_shifter(1) AND Plus_shifter(0) ;
   Clean_minus_17n1s1 <= Clean_minus_17n1s2 OR Clean_minus_17n1s9 ;
   Clean_minus_17n1s2 <= Clean_minus_17n1s3 OR Clean_minus_17n1s6 ;
   Clean_minus_17n1s3 <= Minus_shifter(2) AND Minus_shifter(1) ;
   Clean_minus_17n1s6 <= Minus_shifter(2) AND Minus_shifter(0) ;
   Clean_minus_17n1s9 <= Minus_shifter(1) AND Minus_shifter(0) ;
   not_minus_dd <= NOT minus_dd ;
   rtlc20n33 <= rtlc20n30 AND rtlc20n32 ;
   not_Xmitting <= NOT Xmitting ;
   not_rtlc23n150 <= NOT rtlc23n150 ;
   rtlc23n150 <= not_rtlcn154 AND first_sync ;
   not_rtlc23n95 <= NOT rtlc23n95 ;
   rtlc23n95 <= rtlc23n150 OR rtlcs35 ;
   rtlc23n81 <= plus_dd OR plus_dd_falling_edge ;
   rtlc23n83 <= rtlc23n81 OR minus_dd ;
   rtlc23n85 <= rtlc23n83 OR minus_dd_falling_edge ;
   rtlc23n378 <= energy(0) AND energy(1) ;
   not_rtlc23n394 <= NOT rtlc23n394 ;
   not_energy_5 <= NOT energy(5) ;
   rtlc23n394 <= not_rtlcn155 OR not_energy_5 ;
   rtlc23_203_or_905 : or_5u_5u port map ( a(4)=>energy(1), a(3)=>energy(2), 
      a(2)=>energy(3), a(1)=>energy(4), a(0)=>energy(5), d=>rtlc23n451);
   rtlc23n547 <= rtlc23n542 OR rtlc23n543 ;
   energy_addsub6_23i1 : addsub_6u_6u_6u_0 port map ( mode=>rtlcn371, cin=>
      not_rtlcn371, a(5)=>energy(5), a(4)=>energy(4), a(3)=>energy(3), a(2)
      =>energy(2), a(1)=>energy(1), a(0)=>energy(0), b(5)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(4)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>energy_23n6s1f1(1), b(0)
      =>energy_23n6s1f1(0), d(5)=>energy_23n6s1(5), d(4)=>energy_23n6s1(4), 
      d(3)=>energy_23n6s1(3), d(2)=>energy_23n6s1(2), d(1)=>energy_23n6s1(1), 
      d(0)=>energy_23n6s1(0), cout=>DANGLING(0));
   rtlc26n95 <= energy(3) AND energy(2) ;
   not_rtlcs0 <= NOT rtlcs0 ;
   not_rtlcs5 <= NOT rtlcs5 ;
   Gap_inc7_35i2 : inc_7u_7u_0 port map ( cin=>PWR, a(6)=>
      H15530_record_RAW_GAP_EXMPLR1644(6), a(5)=>
      H15530_record_RAW_GAP_EXMPLR1644(5), a(4)=>
      H15530_record_RAW_GAP_EXMPLR1644(4), a(3)=>
      H15530_record_RAW_GAP_EXMPLR1644(3), a(2)=>
      H15530_record_RAW_GAP_EXMPLR1644(2), a(1)=>
      H15530_record_RAW_GAP_EXMPLR1644(1), a(0)=>
      H15530_record_RAW_GAP_EXMPLR1644(0), d(6)=>Gap_35n11s1(6), d(5)=>
      Gap_35n11s1(5), d(4)=>Gap_35n11s1(4), d(3)=>Gap_35n11s1(3), d(2)=>
      Gap_35n11s1(2), d(1)=>Gap_35n11s1(1), d(0)=>Gap_35n11s1(0), cout=>
      DANGLING(1));
   rtlc35_286_or_910 : or_4u_4u port map ( a(3)=>RxRdy_plus_us(3), a(2)=>
      RxRdy_plus_us(4), a(1)=>RxRdy_plus_us(5), a(0)=>RxRdy_plus_us(6), d=>
      rtlc35n569);
   not_rtlc35n569 <= NOT rtlc35n569 ;
   not_RxRdy_plus_us_2 <= NOT RxRdy_plus_us(2) ;
   rtlc35n572 <= not_rtlc35n569 AND not_RxRdy_plus_us_2 ;
   rtlc35n612 <= not_RxRdy_plus_us_2 OR not_rtlcn161 ;
   rtlc35n613 <= not_rtlc35n569 AND rtlc35n612 ;
   rtlc35n653 <= not_rtlc35n629 AND rtlc35n652 ;
   rtlc35n670 <= RxRdy_plus_us(4) AND RxRdy_plus_us(3) ;
   not_RxRdy_plus_us_6 <= NOT RxRdy_plus_us(6) ;
   rtlc35n685 <= RxRdy_plus_us(5) AND RxRdy_plus_us(4) ;
   not_rtlc35n685 <= NOT rtlc35n685 ;
   rtlc35n690 <= not_rtlc35n685 OR rtlcn1121 ;
   rtlc35n691 <= not_RxRdy_plus_us_6 AND rtlc35n690 ;
   not_rtlcs21 <= NOT rtlcs21 ;
   rtlc38_134_and_911 : and_4u_4u port map ( a(3)=>not_rtlcs21, a(2)=>
      not_rtlcs18, a(1)=>not_rtlc38n485, a(0)=>Recieving, d=>rtlc38_X_0_n587
   );
   rtlc38n588 <= not_CE OR rtlc38_X_0_n587 ;
   not_rtlc38n588 <= NOT rtlc38n588 ;
   rtlc38n615 <= rtlcs35 AND not_rtlc38n485 ;
   rtlc38n614 <= not_rtlcs18 AND not_rtlc38n485 ;
   rtlc38n616 <= rtlc38n614 OR rtlc38n615 ;
   rtlc38n483 <= rtlcs27 AND rtlc38n482 ;
   not_rtlc38n483 <= NOT rtlc38n483 ;
   rtlc38n485 <= Found_CMD_Sync AND not_rtlc38n483 ;
   rtlc38n449 <= rtlcs32 AND first_sync ;
   rtlc38n453 <= rtlc38n449 AND rtlcs13 ;
   rtlc38n455 <= rtlc38n453 AND Manchester_error_41n2s2 ;
   not_rtlc38n407 <= NOT rtlc38n407 ;
   not_Bit_value <= NOT Bit_value ;
   rtlc38n405 <= not_Bit_value AND level_plus ;
   rtlc38n403 <= Bit_value AND Level_minus ;
   rtlc38n406 <= rtlc38n403 OR rtlc38n405 ;
   rtlc38n407 <= rtlcs18 AND rtlc38n406 ;
   not_rtlc38n368 <= NOT rtlc38n368 ;
   rtlc38n367 <= not_Bit_value AND Level_minus ;
   rtlc38n365 <= Bit_value AND level_plus ;
   rtlc38n368 <= rtlc38n365 OR rtlc38n367 ;
   not_Manchester_error_41n2s1 <= NOT Manchester_error_41n2s1 ;
   not_Manchester_error_41n2s2 <= NOT Manchester_error_41n2s2 ;
   rtlc38n268 <= Echo AND not_Xmitting ;
   Sync_error_47n7s1 <= H15530_record_Manchester_error_EXMPLR1602 OR 
   Sync_error_EXMPLR1600 ;
   Phase_inc5_38i1 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>Phase(4), a(3)=>
      Phase(3), a(2)=>Phase(2), a(1)=>Phase(1), a(0)=>Phase(0), d(4)=>
      Phase_38n5s1(4), d(3)=>Phase_38n5s1(3), d(2)=>Phase_38n5s1(2), d(1)=>
      Phase_38n5s1(1), d(0)=>Phase_38n5s1(0), cout=>DANGLING(2));
   rtlc38n771 <= one_shot(5) OR rtlc38n770 ;
   rtlc38n772 <= one_shot(6) AND rtlc38n771 ;
   Calc_parity_47n7s1 <= Calc_parity XOR Bit_value ;
   rtlc47_110_select_929 : select_4_4 port map ( a(3)=>not_rtlc47n614, a(2)
      =>rtlcs32, a(1)=>rtlcs27, a(0)=>rtlcs35, b(3)=>
      not_H15530_record_Manchester_error, b(2)=>rtlc47n417, b(1)=>
      not_rtlcn158, b(0)=>rtlc47n433, d=>rtlc47n437);
   rtlc47n417 <= not_H15530_record_Manchester_error AND rtlc47n235 ;
   rtlc47n433 <= not_H15530_record_Manchester_error AND rtlc47n426 ;
   rtlc47n453 <= RxRdy OR rtlcs37 ;
   rtlc47n218 <= not_rtlc47n630 AND rtlcn159 ;
   not_rtlc47n614 <= NOT rtlc47n614 ;
   not_rtlc47n630 <= NOT rtlc47n630 ;
   rtlc47n630 <= rtlc47n629 AND Bit_number(4) ;
   not_RxRdy <= NOT RxRdy ;
   not_rtlcs42 <= NOT rtlcs42 ;
   rtlc50n176 <= rtlcs40 OR not_rtlcs42 ;
   not_rtlc50n176 <= NOT rtlc50n176 ;
   rtlc56n177 <= first_sync OR resync_after_fault ;
   rtlc56n176 <= Clean_plus OR Found_CMD_Sync ;
   rtlc56n179 <= rtlc56n176 OR not_rtlc56n177 ;
   rtlc56n169 <= Clean_plus AND rtlc56n177 ;
   Len_inc6_56i1 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>Len(5), a(4)=>
      Len(4), a(3)=>Len(3), a(2)=>Len(2), a(1)=>Len(1), a(0)=>Len(0), d(5)=>
      Len_56n6s1(5), d(4)=>Len_56n6s1(4), d(3)=>Len_56n6s1(3), d(2)=>
      Len_56n6s1(2), d(1)=>Len_56n6s1(1), d(0)=>Len_56n6s1(0), cout=>
      DANGLING(3));
   rtlc59n430 <= Rcv_Filter(5) OR Rcv_Filter(6) ;
   not_rtlc59n464 <= NOT rtlc59n464 ;
   not_rtlc59n467 <= NOT rtlc59n467 ;
   rtlc59n281 <= not_Clean_plus AND not_rtlcn160 ;
   rtlc59n252 <= not_Clean_minus AND not_rtlcn160 ;
   rtlc59n671 <= one_shot(3) AND one_shot(2) ;
   rtlc62n94 <= Bit_Gap_3 AND rtlc62n36 ;
   not_rtlc62n36 <= NOT rtlc62n36 ;
   not_rtlcn148 <= NOT rtlcn148 ;
   not_rtlcn154 <= NOT rtlcn154 ;
   not_rtlcn155 <= NOT rtlcn155 ;
   not_rtlc26n93 <= NOT rtlc26n93 ;
   rtlc26n93 <= energy(5) OR energy(4) ;
   not_rtlcn158 <= NOT rtlcn158 ;
   rtlc47n644 <= Bit_number(4) OR Bit_number(3) ;
   not_rtlcn160 <= NOT rtlcn160 ;
   not_rtlcn161 <= NOT rtlcn161 ;
   rtlcn148 <= rtlcs32 OR Xmitting ;
   rtlcn154 <= rtlc23n361 OR Bit_number(1) ;
   rtlcn155 <= energy(4) OR energy(3) ;
   rtlcn157 <= rtlc26n93 OR rtlc26n95 ;
   rtlcn158 <= H15530_record_Manchester_error_EXMPLR1602 OR rtlc47n235 ;
   rtlcn159 <= rtlc47n644 OR Bit_number(2) ;
   rtlcn160 <= rtlc59n669 OR rtlc59n671 ;
   rtlcn161 <= RxRdy_plus_us(1) OR RxRdy_plus_us(0) ;
   rtlcn163 <= rtlc35n629 OR rtlc35n670 ;
   Sync_error_47n7ss1 <= H15530_record_Manchester_error_EXMPLR1602 OR 
   rtlcn409 ;
   rtlc_597_mux_941 : mux_4u_4u port map ( a(3)=>rtlc56n169, a(2)=>PWR, a(1)
      =>H15530_record_Bit_number_EXMPLR1642(4), a(0)=>PWR, b(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>state(1), b(0)=>state(0), 
      d=>rtlcn1698);
   rtlc_600_mux_942 : mux_4u_4u port map ( a(3)=>not_rtlc56n169, a(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), a(1)=>PWR, a(0)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>state(1), b(0)=>state(0), 
      d=>rtlcn1701);
   state_fsm_mux_56i2 : mux_4u_4u port map ( a(3)=>rtlcn838, a(2)=>
      Clean_minus, a(1)=>not_rtlcn1213, a(0)=>rtlc56n169, b(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>state(1), b(0)=>state(0), 
      d=>state_fsm_56n8ss1(0));
   Phase_select_38i8Bus12_4 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(4), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n5s1(4), d=>
      Phase_38n15ss1(4));
   Phase_select_38i8Bus12_3 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(3), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n5s1(3), d=>
      Phase_38n15ss1(3));
   Phase_select_38i8Bus12_2 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(2), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n5s1(2), d=>
      Phase_38n15ss1(2));
   Phase_select_38i9Bus13_2 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n15ss1(2), d=>
      Phase_38n17ss1_2);
   Phase_select_38i8Bus12_1 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase_38n15s1(1), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n5s1(1), d=>
      Phase_38n15ss1(1));
   Phase_select_38i9Bus13_1 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n15ss1(1), d=>
      Phase_38n17ss1_1);
   Phase_select_38i8Bus12_0 : select_3_3 port map ( a(2)=>Advance, a(1)=>
      rtlcn482, a(0)=>rtlcn483, b(2)=>Phase(0), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n5s1(0), d=>
      Phase_38n15ss1(0));
   Phase_select_38i9Bus13_0 : select_3_3 port map ( a(2)=>rtlc38n485, a(1)=>
      rtlcn508, a(0)=>rtlcn509, b(2)=>PWR, b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>Phase_38n15ss1(0), d=>
      Phase_38n17ss1_0);
   Rcv_Filter_fsm_select_59i2Bus20_5 : select_3_3 port map ( a(2)=>rtlcn740, 
      a(1)=>rtlcn738, a(0)=>rtlcn739, b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>PWR, b(0)=>
      Rcv_Filter_fsm_59n6ss1_3, d=>Rcv_Filter_fsm_59n16ss1_5);
   Rcv_Filter_fsm_select_59i2Bus20_6 : select_3_3 port map ( a(2)=>rtlcn758, 
      a(1)=>rtlcn756, a(0)=>rtlcn757, b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>PWR, b(0)=>
      Rcv_Filter_fsm_59n4ss1_4, d=>Rcv_Filter_fsm_59n16ss1_6);
   not_rtlc56n177 <= NOT rtlc56n177 ;
   not_Clean_minus <= NOT Clean_minus ;
   not_rtlc23n85 <= NOT rtlc23n85 ;
   not_Clean_plus <= NOT Clean_plus ;
   not_rtlcs36 <= NOT rtlcs36 ;
   not_rtlc35n267 <= NOT rtlc35n267 ;
   Rcv_Filter_fsm_select_59i4Bus18_3 : select_3_3 port map ( a(2)=>
      not_rtlcn1209, a(1)=>Rcv_Filter(2), a(0)=>rtlcn1011, b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>Rcv_Filter_fsm_59n6ss1_3, 
      b(0)=>PWR, d=>Rcv_Filter_fsm_59n13ss1_3);
   Rcv_Filter_fsm_select_59i4Bus18_4 : select_3_3 port map ( a(2)=>
      not_rtlcn1210, a(1)=>Rcv_Filter(1), a(0)=>rtlcn1038, b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>Rcv_Filter_fsm_59n4ss1_4, 
      b(0)=>PWR, d=>Rcv_Filter_fsm_59n13ss1_4);
   rtlc38n393 <= rtlcs24 OR rtlc38n390 ;
   rtlc47n614 <= rtlcs30 OR rtlcs35 ;
   not_state_1 <= NOT state(1) ;
   not_state_0 <= NOT state(0) ;
   not_Advance <= NOT Advance ;
   rtlcn482 <= not_Advance AND rtlcs18 ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlcn483 <= not_Advance AND not_rtlcs18 ;
   not_rtlc38n485 <= NOT rtlc38n485 ;
   rtlcn508 <= not_rtlc38n485 AND rtlc38n455 ;
   not_rtlc38n455 <= NOT rtlc38n455 ;
   rtlcn509 <= not_rtlc38n485 AND not_rtlc38n455 ;
   rtlcn1096 <= not_Clean_minus AND Rcv_Filter(6) ;
   rtlcn1097 <= Clean_plus AND Rcv_Filter(5) ;
   rtlcn1077 <= rtlcn1096 OR rtlcn1097 ;
   not_Recieving <= NOT Recieving ;
   rtlcn1099 <= Clean_minus AND Rcv_Filter(6) ;
   rtlcn1101 <= not_Clean_plus AND Rcv_Filter(5) ;
   rtlcn1078 <= rtlcn1099 OR rtlcn1101 ;
   not_rtlcn698 <= NOT rtlcn698 ;
   rtlcn738 <= rtlcn1078 AND not_rtlcn698 ;
   rtlcn739 <= Rcv_Filter(4) AND not_rtlcn698 ;
   rtlcn756 <= rtlcn1077 AND not_rtlcn698 ;
   rtlcn757 <= Rcv_Filter(3) AND not_rtlcn698 ;
   not_rtlc59n252 <= NOT rtlc59n252 ;
   not_rtlc59n281 <= NOT rtlc59n281 ;
   not_ResetN <= NOT ResetN ;
   rtlcn371 <= rtlc23n543 OR rtlc23n544 ;
   rtlc35n629 <= RxRdy_plus_us(6) OR RxRdy_plus_us(5) ;
   not_rtlc35n691 <= NOT rtlc35n691 ;
   not_rtlc35n613 <= NOT rtlc35n613 ;
   not_rtlc35n629 <= NOT rtlc35n629 ;
   not_RxRdy_plus_us_4 <= NOT RxRdy_plus_us(4) ;
   rtlc_1657_or_962 : or_4u_4u port map ( a(3)=>rtlc35n572, a(2)=>
      not_rtlcn1211, a(1)=>not_rtlcn1212, a(0)=>rtlcn1118, d=>rtlcn399);
   not_rtlcs40 <= NOT rtlcs40 ;
   not_RxRdy_plus_us_3 <= NOT RxRdy_plus_us(3) ;
   rtlcn1121 <= not_RxRdy_plus_us_3 AND not_RxRdy_plus_us_2 ;
   rtlc35n652 <= not_RxRdy_plus_us_4 OR rtlcn1121 ;
   rtlcn1122 <= not_rtlc35n613 AND not_RxRdy_plus_us_4 ;
   rtlcn1124 <= rtlcn1208 AND rtlc35n652 ;
   rtlcn1085 <= rtlcn1122 OR rtlcn1124 ;
   rtlcn1125 <= not_rtlc35n629 AND rtlcn1085 ;
   rtlcn403 <= not_rtlc35n691 OR rtlcn1125 ;
   not_rtlc35n653 <= NOT rtlc35n653 ;
   rtlcn1057 <= rtlc47n453 OR Found_CMD_Sync ;
   not_rtlcn1057 <= NOT rtlcn1057 ;
   rtlcn1082 <= Clean_minus OR rtlc56n177 ;
   rtlcn1126 <= rtlcs46 AND rtlcn1082 ;
   not_rtlc56n179 <= NOT rtlc56n179 ;
   rtlcn445 <= Recieving AND rtlcn1086 ;
   not_rtlc23n451 <= NOT rtlc23n451 ;
   not_rtlc23n379 <= NOT rtlc23n379 ;
   rtlcn1133 <= not_rtlc23n379 AND rtlc23n150 ;
   rtlcn1087 <= not_rtlc23n451 OR rtlcn1133 ;
   rtlcn455 <= not_rtlc23n85 AND rtlcn1087 ;
   rtlcn495 <= Recieving AND rtlcn509 ;
   rtlcn501 <= not_Recieving OR rtlc38n268 ;
   rtlcn502 <= rtlc23n85 AND Xmitting ;
   not_Stall <= NOT Stall ;
   rtlc_1694_and_966 : and_4u_4u port map ( a(3)=>not_rtlc38n485, a(2)=>
      not_rtlc38n455, a(1)=>Recieving, a(0)=>not_Stall, d=>rtlcn535);
   not_rtlcs35 <= NOT rtlcs35 ;
   rtlcn1088 <= not_rtlcs35 OR not_rtlcs18 ;
   rtlcn581 <= Recieving AND rtlcn1088 ;
   rtlcn1058 <= Found_CMD_Sync OR rtlcs27 ;
   rtlcn1079 <= rtlcn1096 OR rtlcn1101 ;
   rtlcn1076 <= Rcv_Filter(4) OR Rcv_Filter(2) ;
   rtlcn1089 <= not_Clean_minus OR rtlc59n281 ;
   rtlcn1074 <= rtlcn1076 AND rtlcn1089 ;
   rtlcn1075 <= Rcv_Filter(3) OR Rcv_Filter(1) ;
   rtlcn1080 <= not_Clean_plus OR rtlc59n252 ;
   rtlcn1140 <= rtlcn1075 AND rtlcn1080 ;
   rtlcn1084 <= rtlcn1074 OR rtlcn1140 ;
   rtlcn623 <= rtlcn1079 OR rtlcn1084 ;
   rtlcn1141 <= rtlc59n252 AND rtlcn1075 ;
   rtlcn1142 <= rtlc59n281 AND rtlcn1076 ;
   rtlc_1716_or_969 : or_4u_4u port map ( a(3)=>rtlcn698, a(2)=>rtlcn1141, 
      a(1)=>rtlcn1142, a(0)=>rtlcn1143, d=>rtlcn648);
   rtlcn838 <= rtlc56n169 OR not_rtlc56n179 ;
   not_rtlc20n33 <= NOT rtlc20n33 ;
   rtlcn1148 <= not_rtlc59n252 AND Rcv_Filter(1) ;
   rtlcn1149 <= Clean_minus AND Rcv_Filter(0) ;
   rtlcn1083 <= rtlcn1148 OR rtlcn1149 ;
   rtlcn1150 <= Clean_plus AND Rcv_Filter(0) ;
   rtlcn1090 <= rtlcn1150 OR rtlcn1151 ;
   rtlcn1009 <= not_rtlcn698 AND rtlcn1090 ;
   rtlcn1130 <= not_rtlc56n179 AND rtlcs45 ;
   energy_23n6s1f1(1) <= NOT rtlc23n541 ;
   energy_23n6s1f1(0) <= NOT rtlc23n547 ;
   not_rtlcn371 <= NOT rtlcn371 ;
   not_rtlcn399 <= NOT rtlcn399 ;
   not_rtlcn1209 <= NOT rtlcn1209 ;
   not_rtlcn1210 <= NOT rtlcn1210 ;
   not_rtlcn1211 <= NOT rtlcn1211 ;
   not_rtlcn1212 <= NOT rtlcn1212 ;
   not_rtlcn1213 <= NOT rtlcn1213 ;
   rtlc23n193 <= not_rtlc23n394 when rtlc23n95 = '1' else energy(5) ;
   rtlc23n217 <= not_rtlcn148 when rtlc23n85 = '1' else rtlc23n451 ;
   rtlc26n62 <= rtlcn157 when Recieving = '1' else not_rtlc26n93 ;
   rtlc38n420 <= not_rtlc38n407 when rtlcs27 = '1' else rtlc38n393 ;
   Manchester_error_41n2ss1 <= Manchester_error_41n2s1 when rtlcs24
    = '1' else Manchester_error_41n2s2 ;
   rtlcn410 <= not_rtlc38n368 when Phase(4) = '1' else 
   not_Manchester_error_41n2s1 ;
   not_rtlc23n217 <= NOT rtlc23n217 ;
   rtlc23n259 <= CE AND not_rtlc23n217 ;
   not_CE <= NOT CE ;
   not_rtlc23n193 <= NOT rtlc23n193 ;
   rtlcn1223 <= not_rtlc23n193 OR not_rtlc23n85 ;
   rtlc23n258 <= CE AND rtlcn1223 ;
   not_rtlc26n62 <= NOT rtlc26n62 ;
   rtlc26n79 <= CE AND not_rtlc26n62 ;
   rtlc29n57 <= CE AND rtlcn1224 ;
   rtlc35n452 <= CE AND rtlcs28 ;
   not_rtlc35n310 <= NOT rtlc35n310 ;
   rtlc35n442 <= CE AND not_rtlc35n310 ;
   not_rtlcn1088 <= NOT rtlcn1088 ;
   rtlc38n669 <= CE AND rtlcn1226 ;
   rtlcn1239 <= rtlcs18 AND rtlcs35 ;
   rtlcn1227 <= not_Recieving OR rtlcn1239 ;
   rtlc38n668 <= CE AND rtlcn1227 ;
   rtlcn1217 <= not_Recieving OR rtlc38n485 ;
   rtlcn1218 <= Advance OR rtlcn1217 ;
   not_rtlc38n420 <= NOT rtlc38n420 ;
   rtlcn1228 <= not_rtlc38n420 OR rtlcn1218 ;
   rtlc38n667 <= CE AND rtlcn1228 ;
   rtlc_2040_or_975 : or_4u_4u port map ( a(3)=>Stall, a(2)=>rtlc38n455, 
      a(1)=>rtlcn1217, a(0)=>not_rtlcn1287, d=>rtlcn1229);
   rtlc38n666 <= CE AND rtlcn1229 ;
   rtlcn1221 <= rtlcs18 OR not_rtlcs21 ;
   rtlcn1246 <= not_Stall AND rtlcn1221 ;
   rtlc38n665 <= CE AND rtlcn1230 ;
   rtlcn1219 <= CE AND Found_CMD_Sync ;
   rtlcn1247 <= CE AND Strobe_44n1s1 ;
   rtlc41n109 <= rtlcn1219 OR rtlcn1247 ;
   rtlcn1248 <= CE AND rtlcs1 ;
   rtlc41n108 <= rtlcn1219 OR rtlcn1248 ;
   not_Strobe <= NOT Strobe ;
   rtlcn1215 <= not_CE OR not_Strobe ;
   rtlcn1220 <= CE AND rtlcn1057 ;
   not_rtlcn1215 <= NOT rtlcn1215 ;
   not_H15530_record_Manchester_error <= NOT 
   H15530_record_Manchester_error_EXMPLR1602 ;
   rtlcn1222 <= rtlcs24 OR rtlcs30 ;
   not_rtlc47n218 <= NOT rtlc47n218 ;
   rtlc47n571 <= rtlcn1220 OR rtlcn1256 ;
   rtlc47n553 <= rtlcn1220 OR not_rtlcn1387 ;
   rtlcn1231 <= rtlc47n218 OR rtlcs27 ;
   rtlcn1259 <= not_rtlcn1215 AND rtlcn1231 ;
   rtlc47n552 <= rtlcn1219 OR rtlcn1259 ;
   rtlcn1260 <= rtlcs25 AND not_rtlcn1215 ;
   rtlc47n551 <= rtlcn1219 OR rtlcn1260 ;
   rtlcn1214 <= not_rtlc47n218 OR rtlcn1215 ;
   not_rtlcn1214 <= NOT rtlcn1214 ;
   rtlcn290 <= Data_47n4s2(0) AND not_rtlcn1214 ;
   rtlcn295 <= not_rtlcn1214 AND Data_47n4s2(1) ;
   rtlcn300 <= not_rtlcn1214 AND Data_47n4s2(2) ;
   rtlcn305 <= not_rtlcn1214 AND Data_47n4s2(3) ;
   rtlcn310 <= not_rtlcn1214 AND Data_47n4s2(4) ;
   rtlcn315 <= not_rtlcn1214 AND Data_47n4s2(5) ;
   rtlcn320 <= not_rtlcn1214 AND Data_47n4s2(6) ;
   rtlcn325 <= not_rtlcn1214 AND Data_47n4s2(7) ;
   rtlcn330 <= not_rtlcn1214 AND Data_47n4s2(8) ;
   rtlcn335 <= not_rtlcn1214 AND Data_47n4s2(9) ;
   rtlcn340 <= not_rtlcn1214 AND Data_47n4s2(10) ;
   rtlcn345 <= not_rtlcn1214 AND Data_47n4s2(11) ;
   rtlcn350 <= not_rtlcn1214 AND Data_47n4s2(12) ;
   rtlcn355 <= not_rtlcn1214 AND Data_47n4s2(13) ;
   rtlcn360 <= not_rtlcn1214 AND Data_47n4s2(14) ;
   rtlcn365 <= not_rtlcn1214 AND Data_47n4s2(15) ;
   rtlc35n310 <= rtlc35n264 AND rtlcn1262 ;
   rtlcs48 <= not_Phase_4 AND rtlcs3 ;
   rtlcs1 <= rtlcs48 AND rtlcs4 ;
   rtlcs5 <= rtlcs48 AND rtlcs7 ;
   Strobe_44n1s1 <= rtlcs8 AND rtlcs10 ;
   rtlcs8 <= rtlcs11 AND rtlcs3 ;
   rtlcs10 <= rtlcs12 AND rtlcs4 ;
   rtlcs13 <= rtlcs14 AND rtlcs7 ;
   rtlcs15 <= rtlcs16 AND rtlcs7 ;
   rtlcs18 <= Phase(4) AND rtlcs17 ;
   rtlcs17 <= rtlcs20 AND rtlcs4 ;
   rtlcs21 <= rtlcs22 AND rtlcs23 ;
   rtlcs25 <= Data_47n4s3_1 AND rtlcs24 ;
   rtlcs28 <= Strobe AND rtlcs27 ;
   rtlcs27 <= rtlcs24 AND rtlcs30 ;
   rtlcs24 <= Bit_number(0) AND rtlcs23 ;
   rtlcs32 <= Data_47n4s3_0 AND rtlcs30 ;
   rtlcs30 <= Bit_number(1) AND rtlcs23 ;
   Data_47n4s3_0 <= NOT Bit_number(0) ;
   Data_47n4s3_1 <= NOT Bit_number(1) ;
   rtlcs22 <= Data_47n4s3_0 AND Data_47n4s3_1 ;
   not_Bit_number_4 <= NOT Bit_number(4) ;
   not_Bit_number_3 <= NOT Bit_number(3) ;
   not_Bit_number_2 <= NOT Bit_number(2) ;
   not_rtlc5n44 <= NOT rtlc5n44 ;
   plus_dd_5n1ss1 <= plus_d AND not_rtlc5n44 ;
   minus_dd_5n2ss1 <= minus_d AND not_rtlc5n44 ;
   not_rtlc11n36 <= NOT rtlc11n36 ;
   plus_dd_falling_edge_11n1ss1 <= plus_d_falling_edge AND not_rtlc11n36 ;
   minus_dd_falling_edge_11n2ss1 <= minus_d_falling_edge AND not_rtlc11n36 ;
   not_rtlcn455 <= NOT rtlcn455 ;
   energy_23n9ss1(1) <= energy_23n6s1(1) AND not_rtlcn455 ;
   energy_23n9ss1(3) <= energy_23n6s1(3) AND not_rtlcn455 ;
   energy_23n9ss1(2) <= energy_23n6s1(2) AND not_rtlcn455 ;
   energy_23n9ss1(0) <= energy_23n6s1(0) AND not_rtlcn455 ;
   energy_23n9ss1(4) <= energy_23n6s1(4) AND not_rtlcn455 ;
   energy_23n9ss1(5) <= energy_23n6s1(5) AND not_rtlcn455 ;
   not_Found_CMD_Sync <= NOT Found_CMD_Sync ;
   Bit_value_41n4ss1 <= level_plus AND not_Found_CMD_Sync ;
   not_Phase_4 <= NOT Phase(4) ;
   not_Phase_3 <= NOT Phase(3) ;
   not_Phase_1 <= NOT Phase(1) ;
   Phase_38n18ss1(0) <= Phase_38n17ss1_0 AND Recieving ;
   not_rtlcs13 <= NOT rtlcs13 ;
   rtlc38n389 <= not_Manchester_error_41n2s2 OR not_rtlcs13 ;
   not_rtlcn1287 <= NOT rtlcn1287 ;
   Phase_38n18ss1(2) <= Phase_38n17ss1_2 AND Recieving ;
   not_Phase_2 <= NOT Phase(2) ;
   not_Phase_0 <= NOT Phase(0) ;
   rtlcs7 <= not_Phase_2 AND not_Phase_0 ;
   Phase_38n18ss1(1) <= Phase_38n17ss1_1 AND Recieving ;
   rtlcs3 <= not_Phase_3 AND Phase(1) ;
   rtlcs4 <= Phase(2) AND Phase(0) ;
   Manchester_error_41n4ss1 <= Manchester_error_41n2ss1 AND 
   not_Found_CMD_Sync ;
   rtlcs11 <= Phase(4) AND Phase(2) ;
   rtlcn409 <= Sync_error_EXMPLR1600 AND Bit_number(1) ;
   Sync_error_47n10ss1 <= Sync_error_47n7ss1 AND not_rtlcn1057 ;
   rtlcn1210 <= Rcv_Filter(1) OR rtlcn1038 ;
   Rcv_Filter_fsm_59n4ss1_4 <= Clean_plus AND not_rtlc59n252 ;
   Rcv_Filter_fsm_59n16ss1_4 <= Rcv_Filter_fsm_59n13ss1_4 AND not_rtlcn698 ;
   rtlcn1209 <= Rcv_Filter(2) OR rtlcn1011 ;
   Rcv_Filter_fsm_59n6ss1_3 <= Clean_minus AND not_rtlc59n281 ;
   Rcv_Filter_fsm_59n16ss1_3 <= Rcv_Filter_fsm_59n13ss1_3 AND not_rtlcn698 ;
   not_rtlcn623 <= NOT rtlcn623 ;
   not_rtlc56n169 <= NOT rtlc56n169 ;
   not_Len_4 <= NOT Len(4) ;
   not_Len_2 <= NOT Len(2) ;
   not_Len_1 <= NOT Len(1) ;
   not_Len_0 <= NOT Len(0) ;
   rtlc_2208_and_982 : and_6u_6u port map ( a(5)=>Len(5), a(4)=>not_Len_4, 
      a(3)=>Len(3), a(2)=>not_Len_2, a(1)=>not_Len_1, a(0)=>not_Len_0, d=>
      rtlcs44);
   rtlcn1213 <= Clean_minus OR rtlcs44 ;
   state_fsm_56n9ss1(0) <= state_fsm_56n8ss1(0) AND Recieving ;
   rtlcs46 <= state(1) AND not_state_0 ;
   rtlcs47 <= not_state_1 AND state(0) ;
   rtlcs45 <= state(1) AND state(0) ;
   not_Len_3 <= NOT Len(3) ;
   rtlcs20 <= Phase(1) AND Phase(3) ;
   not_rtlcs17 <= NOT rtlcs17 ;
   rtlc38n390 <= rtlcn410 OR not_rtlcs17 ;
   Phase_38n18ss1(3) <= Phase_38n15ss1(3) AND rtlcn495 ;
   Phase_inc4_38i10 : inc_4u_4u_0 port map ( cin=>PWR, a(3)=>Phase(4), a(2)
      =>Phase(3), a(1)=>Phase(2), a(0)=>Phase(1), d(3)=>Phase_38n15s1(4), 
      d(2)=>Phase_38n15s1(3), d(1)=>Phase_38n15s1(2), d(0)=>Phase_38n15s1(1), 
      cout=>DANGLING(4));
   not_rtlcn509 <= NOT rtlcn509 ;
   Phase_38n17ss1_4 <= Phase_38n15ss1(4) OR not_rtlcn509 ;
   Phase_38n18ss1(4) <= Phase_38n17ss1_4 AND Recieving ;
   rtlc_2242_and_986 : and_5u_5u port map ( a(4)=>Bit_number(4), a(3)=>
      not_Bit_number_3, a(2)=>Bit_number(2), a(1)=>Data_47n4s3_1, a(0)=>
      Data_47n4s3_0, d=>rtlcs35);
   Command_sync_47n10ss1 <= Bit_value OR Found_CMD_Sync ;
   Calc_parity_47n10ss1 <= Calc_parity_47n7s1 OR rtlcn1058 ;
   not_rtlcn1387 <= NOT rtlcn1387 ;
   not_energy_4 <= NOT energy(4) ;
   not_energy_3 <= NOT energy(3) ;
   not_energy_2 <= NOT energy(2) ;
   not_energy_1 <= NOT energy(1) ;
   not_energy_0 <= NOT energy(0) ;
   rtlc_2258_and_987 : and_6u_6u port map ( a(5)=>not_energy_5, a(4)=>
      not_energy_4, a(3)=>not_energy_3, a(2)=>not_energy_2, a(1)=>
      not_energy_1, a(0)=>not_energy_0, d=>rtlcs37);
   Gap_35n13ss1(5) <= Gap_35n11s1(5) AND rtlcn876 ;
   not_rtlcs25 <= NOT rtlcs25 ;
   rtlc35n264 <= not_rtlcs5 OR not_rtlcs25 ;
   rtlc_2283_and_989 : and_5u_5u port map ( a(4)=>gap_phase(4), a(3)=>
      gap_phase(3), a(2)=>gap_phase(2), a(1)=>gap_phase(1), a(0)=>
      gap_phase(0), d=>rtlcs0);
   rtlcn407 <= not_rtlcs0 OR rtlcs36 ;
   rtlcn1262 <= rtlcn407 OR rtlc35n267 ;
   Gap_35n13ss1(4) <= Gap_35n11s1(4) AND rtlcn876 ;
   Gap_35n13ss1(3) <= Gap_35n11s1(3) AND rtlcn876 ;
   Gap_35n13ss1(2) <= Gap_35n11s1(2) AND rtlcn876 ;
   Gap_35n13ss1(1) <= Gap_35n11s1(1) AND rtlcn876 ;
   rtlc_2290_and_990 : and_7u_7u port map ( a(6)=>
      H15530_record_RAW_GAP_EXMPLR1644(6), a(5)=>
      H15530_record_RAW_GAP_EXMPLR1644(5), a(4)=>
      H15530_record_RAW_GAP_EXMPLR1644(4), a(3)=>
      H15530_record_RAW_GAP_EXMPLR1644(3), a(2)=>
      H15530_record_RAW_GAP_EXMPLR1644(2), a(1)=>
      H15530_record_RAW_GAP_EXMPLR1644(1), a(0)=>
      H15530_record_RAW_GAP_EXMPLR1644(0), d=>rtlcs36);
   Gap_35n13ss1(6) <= Gap_35n11s1(6) AND rtlcn876 ;
   Gap_35n13ss1(0) <= Gap_35n11s1(0) AND rtlcn876 ;
   rtlc_2293_and_991 : and_7u_7u port map ( a(6)=>RxRdy_plus_us(6), a(5)=>
      RxRdy_plus_us(5), a(4)=>RxRdy_plus_us(4), a(3)=>RxRdy_plus_us(3), a(2)
      =>RxRdy_plus_us(2), a(1)=>RxRdy_plus_us(1), a(0)=>RxRdy_plus_us(0), d
      =>rtlcs40);
   rtlc_2294_and_992 : and_5u_5u port map ( a(4)=>RxRdy_plus_phase(4), a(3)
      =>RxRdy_plus_phase(3), a(2)=>RxRdy_plus_phase(2), a(1)=>
      RxRdy_plus_phase(1), a(0)=>RxRdy_plus_phase(0), d=>rtlcs42);
   not_rtlc35n572 <= NOT rtlc35n572 ;
   Actual_gap_35n1ss1(0) <= not_RxRdy_plus_us_0 AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(1) <= Actual_gap_35n1s1(1) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(2) <= Actual_gap_35n1s1(2) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(3) <= Actual_gap_35n1s1(3) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(4) <= Actual_gap_35n1s1(4) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(5) <= Actual_gap_35n1s1(5) AND not_rtlc35n572 ;
   Actual_gap_35n1ss1(6) <= Actual_gap_35n1s1(6) AND not_rtlc35n572 ;
   rtlcn1211 <= rtlc35n691 OR rtlcs40 ;
   rtlcn1212 <= rtlc35n653 OR rtlcn163 ;
   rtlcn1208 <= rtlc35n629 OR RxRdy_plus_us(4) ;
   not_RxRdy_plus_us_5 <= NOT RxRdy_plus_us(5) ;
   not_RxRdy_plus_us_1 <= NOT RxRdy_plus_us(1) ;
   not_RxRdy_plus_us_0 <= NOT RxRdy_plus_us(0) ;
   not_RxRdy_plus_phase_4 <= NOT RxRdy_plus_phase(4) ;
   not_RxRdy_plus_phase_3 <= NOT RxRdy_plus_phase(3) ;
   not_RxRdy_plus_phase_2 <= NOT RxRdy_plus_phase(2) ;
   not_RxRdy_plus_phase_1 <= NOT RxRdy_plus_phase(1) ;
   not_RxRdy_plus_phase_0 <= NOT RxRdy_plus_phase(0) ;
   H15530_record_Pre_EchoRdy <= RxRdy AND Echo ;
   not_Echo <= NOT Echo ;
   H15530_record_Pre_RxRdy <= RxRdy AND not_Echo ;
   rtlcn1287 <= rtlcs24 OR rtlc38n389 ;
   rtlcn1387 <= rtlc47n437 OR rtlcn1215 ;
   Len_56n8ss1(0) <= Len_56n6s1(0) OR rtlcn1698 ;
   Len_56n8ss1(1) <= Len_56n6s1(1) AND rtlcn1701 ;
   Len_56n8ss1(2) <= Len_56n6s1(2) AND rtlcn1701 ;
   Len_56n8ss1(3) <= Len_56n6s1(3) AND rtlcn1701 ;
   Len_56n8ss1(4) <= Len_56n6s1(4) AND rtlcn1701 ;
   Len_56n8ss1(5) <= Len_56n6s1(5) AND rtlcn1701 ;
   modgen_counter_gap_phase : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 port map ( 
      clock=>Clock, q(4)=>gap_phase(4), q(3)=>gap_phase(3), q(2)=>
      gap_phase(2), q(1)=>gap_phase(1), q(0)=>gap_phase(0), clk_en=>CE, 
      aclear=>not_ResetN, sload=>rtlc35n267, data(4)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(3)=>PWR, data(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(1)=>PWR, data(0)=>
      H15530_record_Bit_number_EXMPLR1642(4), aset=>
      H15530_record_Bit_number_EXMPLR1642(4), sclear=>rtlc35_X_0_n377, updn
      =>PWR, cnt_en=>not_rtlcs36);
   modgen_counter_Bit_number : 
      counter_up_sload_sclear_aclear_clock_clk_en_0_5 port map ( clock=>
      Clock, q(4)=>Bit_number(4), q(3)=>Bit_number(3), q(2)=>Bit_number(2), 
      q(1)=>Bit_number(1), q(0)=>Bit_number(0), clk_en=>not_rtlc38n588, 
      aclear=>not_ResetN, sload=>rtlcn1715, data(4)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(1)=>not_rtlc38n616, 
      data(0)=>PWR, aset=>H15530_record_Bit_number_EXMPLR1642(4), sclear=>
      not_Recieving, updn=>PWR, cnt_en=>PWR);
   modgen_counter_RxRdy_plus_us : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_7 port map ( clock=>
      Clock, q(6)=>RxRdy_plus_us(6), q(5)=>RxRdy_plus_us(5), q(4)=>
      RxRdy_plus_us(4), q(3)=>RxRdy_plus_us(3), q(2)=>RxRdy_plus_us(2), q(1)
      =>RxRdy_plus_us(1), q(0)=>RxRdy_plus_us(0), clk_en=>CE, aclear=>
      not_ResetN, sload=>H15530_record_Bit_number_EXMPLR1642(4), data(6)=>
      DANGLING(5), data(5)=>DANGLING(6), data(4)=>DANGLING(7), data(3)=>
      DANGLING(8), data(2)=>DANGLING(9), data(1)=>DANGLING(10), data(0)=>
      DANGLING(11), aset=>H15530_record_Bit_number_EXMPLR1642(4), sclear=>
      RxRdy, updn=>PWR, cnt_en=>not_rtlc50n176);
   modgen_counter_RxRdy_plus_phase : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_5 port map ( 
      clock=>Clock, q(4)=>RxRdy_plus_phase(4), q(3)=>RxRdy_plus_phase(3), 
      q(2)=>RxRdy_plus_phase(2), q(1)=>RxRdy_plus_phase(1), q(0)=>
      RxRdy_plus_phase(0), clk_en=>CE, aclear=>not_ResetN, sload=>RxRdy, 
      data(4)=>H15530_record_Bit_number_EXMPLR1642(4), data(3)=>PWR, data(2)
      =>H15530_record_Bit_number_EXMPLR1642(4), data(1)=>PWR, data(0)=>
      H15530_record_Bit_number_EXMPLR1642(4), aset=>
      H15530_record_Bit_number_EXMPLR1642(4), sclear=>rtlc50_X_0_n204, updn
      =>PWR, cnt_en=>not_rtlcs40);
   not_Bit_Gap_3 <= NOT Bit_Gap_3 ;
   modgen_counter_Bit_Gap : counter_up_cnt_en_sclear_aclear_clock_clk_en_0_4
       port map ( clock=>Clock, q(3)=>Bit_Gap_3, q(2)=>DANGLING(12), q(1)=>
      DANGLING(13), q(0)=>DANGLING(14), clk_en=>CE, aclear=>not_ResetN, 
      sload=>H15530_record_Bit_number_EXMPLR1642(4), data(3)=>DANGLING(15), 
      data(2)=>DANGLING(16), data(1)=>DANGLING(17), data(0)=>DANGLING(18), 
      aset=>H15530_record_Bit_number_EXMPLR1642(4), sclear=>not_rtlc62n36, 
      updn=>PWR, cnt_en=>not_Bit_Gap_3);
   rtlcn1715 <= rtlc38n485 OR rtlc38n616 ;
   not_rtlc38n616 <= NOT rtlc38n616 ;
   rtlc5n44 <= NOT (plus_d XOR minus_d) ;
   rtlc11n36 <= NOT (plus_d_falling_edge XOR minus_d_falling_edge) ;
   rtlc20n32 <= NOT (Check_value XOR not_minus_dd) ;
   rtlc20n30 <= NOT (Check_value XOR plus_dd) ;
   Manchester_error_41n2s2 <= NOT (Bit_value XOR level_plus) ;
   Manchester_error_41n2s1 <= NOT (Bit_value XOR Level_minus) ;
   rtlc47n426 <= NOT (Calc_parity XOR Bit_value) ;
   rtlc47n235 <= NOT (Bit_value XOR H15530_record_Command_Sync_EXMPLR1639) ;
   DFFPC (minus_dd_5n2ss1,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   Clock,minus_dd) ;
   DFFPC (Minus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,Clock,
   minus_d) ;
   DFFPC (plus_dd_5n1ss1,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   Clock,plus_dd) ;
   DFFPC (Plus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,Clock,
   plus_d) ;
   DFFPC (Minus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,not_Clock,
   minus_d_falling_edge) ;
   DFFPC (Plus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,not_Clock,
   plus_d_falling_edge) ;
   DFFPC (minus_dd_falling_edge_11n2ss1,
   H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,Clock,
   minus_dd_falling_edge) ;
   DFFPC (plus_dd_falling_edge_11n1ss1,
   H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,Clock,
   plus_dd_falling_edge) ;
   DFFPCE (minus_dd,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Minus_shifter(8)) ;
   DFFPCE (Minus_shifter(8),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(7)) ;
   DFFPCE (Minus_shifter(7),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(6)) ;
   DFFPCE (Minus_shifter(6),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(5)) ;
   DFFPCE (Minus_shifter(5),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(4)) ;
   DFFPCE (Minus_shifter(4),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(3)) ;
   DFFPCE (rtlc14n77,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Minus_shifter(2)) ;
   DFFPCE (Minus_shifter(2),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(1)) ;
   DFFPCE (Minus_shifter(1),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Minus_shifter(0)) ;
   DFFPCE (plus_dd,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Plus_shifter(8)) ;
   DFFPCE (Plus_shifter(8),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(7)) ;
   DFFPCE (Plus_shifter(7),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(6)) ;
   DFFPCE (Plus_shifter(6),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(5)) ;
   DFFPCE (Plus_shifter(5),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(4)) ;
   DFFPCE (Plus_shifter(4),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(3)) ;
   DFFPCE (rtlc14n57,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Plus_shifter(2)) ;
   DFFPCE (Plus_shifter(2),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(1)) ;
   DFFPCE (Plus_shifter(1),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Plus_shifter(0)) ;
   DFFPCE (Clean_minus_17n1s1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Clean_minus) ;
   DFFPCE (Clean_plus_17n1s1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Clean_plus) ;
   DFFPCE (rtlcn843,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Echo_Error) ;
   DFFPCE (rtlcn502,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc23n259,Clock,Echo) ;
   DFFPCE (energy_23n9ss1(5),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(5)) ;
   DFFPCE (energy_23n9ss1(4),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(4)) ;
   DFFPCE (energy_23n9ss1(3),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(3)) ;
   DFFPCE (energy_23n9ss1(2),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(2)) ;
   DFFPCE (energy_23n9ss1(1),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(1)) ;
   DFFPCE (energy_23n9ss1(0),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc23n258,Clock,energy(0)) ;
   DFFPCE (not_Recieving,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc26n79,Clock,Recieving) ;
   DFFPCE (Clean_plus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc29n57,Clock,level_plus) ;
   DFFPCE (Clean_minus,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc29n57,Clock,Level_minus) ;
   DFFPCE (not_rtlc35n653,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(2)) ;
   DFFPCE (rtlcn403,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(1)) ;
   DFFPCE (not_rtlcn399,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n452,Clock,H15530_record_Gap_found(0)) ;
   DFFPCE (Actual_gap_35n1ss1(6),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(6)) ;
   DFFPCE (Actual_gap_35n1ss1(5),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(5)) ;
   DFFPCE (Actual_gap_35n1ss1(4),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(4)) ;
   DFFPCE (Actual_gap_35n1ss1(3),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(3)) ;
   DFFPCE (Actual_gap_35n1ss1(2),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(2)) ;
   DFFPCE (Actual_gap_35n1ss1(1),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(1)) ;
   DFFPCE (Actual_gap_35n1ss1(0),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc35n452,Clock,H15530_record_GAP(0)) ;
   DFFPCE (Gap_35n13ss1(6),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(6)) ;
   DFFPCE (Gap_35n13ss1(5),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(5)) ;
   DFFPCE (Gap_35n13ss1(4),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(4)) ;
   DFFPCE (Gap_35n13ss1(3),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(3)) ;
   DFFPCE (Gap_35n13ss1(2),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(2)) ;
   DFFPCE (Gap_35n13ss1(1),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(1)) ;
   DFFPCE (Gap_35n13ss1(0),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc35n442,Clock,H15530_record_RAW_GAP_EXMPLR1644(0)) ;
   DFFPCE (rtlcn581,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc38n669,Clock,resync_after_fault) ;
   DFFPCE (rtlcn501,not_ResetN,H15530_record_Bit_number_EXMPLR1642(4),
   rtlc38n668,Clock,first_sync) ;
   DFFPCE (rtlcn519,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc38n667,Clock,Advance) ;
   DFFPCE (rtlcn535,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlc38n666,Clock,Stall) ;
   DFFPCE (Phase_38n18ss1(4),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc38n665,Clock,Phase(4)) ;
   DFFPCE (Phase_38n18ss1(3),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc38n665,Clock,Phase(3)) ;
   DFFPCE (Phase_38n18ss1(2),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc38n665,Clock,Phase(2)) ;
   DFFPCE (Phase_38n18ss1(1),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc38n665,Clock,Phase(1)) ;
   DFFPCE (Phase_38n18ss1(0),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc38n665,Clock,Phase(0)) ;
   DFFPCE (Manchester_error_41n4ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc41n109,Clock,H15530_record_Manchester_error_EXMPLR1602) ;
   DFFPCE (Bit_value_41n4ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc41n108,Clock,Bit_value) ;
   DFFPCE (Strobe_44n1s1,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Strobe) ;
   DFFPCE (Sync_error_47n10ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc47n571,Clock,Sync_error_EXMPLR1600) ;
   DFFPCE (rtlcn591,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,RxRdy) ;
   DFFPCE (rtlcn1057,not_ResetN,H15530_record_Bit_number_EXMPLR1642(4),
   rtlc47n553,Clock,H15530_record_CS) ;
   DFFPCE (Calc_parity_47n10ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc47n552,Clock,Calc_parity) ;
   DFFPCE (Command_sync_47n10ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,rtlc47n551,Clock,H15530_record_Command_Sync_EXMPLR1639) ;
   DFFPCE (RxRdy_plus_10us_50n4s1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,H15530_record_RxRDY_plus_10us) ;
   DFFPCE (rtlcn445,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,state(1)) ;
   DFFPCE (state_fsm_56n9ss1(0),H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,state(0)) ;
   DFFPCE (Len_56n8ss1(5),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(5)) ;
   DFFPCE (Len_56n8ss1(4),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(4)) ;
   DFFPCE (Len_56n8ss1(3),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(3)) ;
   DFFPCE (Len_56n8ss1(2),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(2)) ;
   DFFPCE (Len_56n8ss1(1),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(1)) ;
   DFFPCE (Len_56n8ss1(0),H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   CE,Clock,Len(0)) ;
   DFFPCE (Found_CMD_Sync_56n8ss1,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Found_CMD_Sync) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_6,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Rcv_Filter(6)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_5,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Rcv_Filter(5)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_4,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Rcv_Filter(4)) ;
   DFFPCE (Rcv_Filter_fsm_59n16ss1_3,H15530_record_Bit_number_EXMPLR1642(4),
   not_ResetN,CE,Clock,Rcv_Filter(3)) ;
   DFFPCE (rtlcn1009,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Rcv_Filter(2)) ;
   DFFPCE (rtlcn998,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Rcv_Filter(1)) ;
   DFFPCE (rtlcn648,not_ResetN,H15530_record_Bit_number_EXMPLR1642(4),CE,
   Clock,Rcv_Filter(0)) ;
   DFFPCE (rtlc59n430,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,H15530_record_recieving) ;
   DFFPCE (rtlc62n94,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,CE,
   Clock,Big_Bit_Gap) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn290,Clock,H15530_record_R_Data(0)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn295,Clock,H15530_record_R_Data(1)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn300,Clock,H15530_record_R_Data(2)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn305,Clock,H15530_record_R_Data(3)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn310,Clock,H15530_record_R_Data(4)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn315,Clock,H15530_record_R_Data(5)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn320,Clock,H15530_record_R_Data(6)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn325,Clock,H15530_record_R_Data(7)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn330,Clock,H15530_record_R_Data(8)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn335,Clock,H15530_record_R_Data(9)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn340,Clock,H15530_record_R_Data(10)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn345,Clock,H15530_record_R_Data(11)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn350,Clock,H15530_record_R_Data(12)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn355,Clock,H15530_record_R_Data(13)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn360,Clock,H15530_record_R_Data(14)) ;
   DFFPCE (Bit_value,H15530_record_Bit_number_EXMPLR1642(4),not_ResetN,
   rtlcn365,Clock,H15530_record_R_Data(15)) ;
   rtlc47n629 <= Bit_number(2) OR Bit_number(3) ;
   rtlc23n361 <= rtlc47n629 OR Bit_number(4) ;
   rtlc35_142_and_907_nx0 <= rtlcs0 AND not_rtlcs36 ;
   rtlc35_X_0_n377 <= rtlc35_142_and_907_nx0 AND not_rtlc35n267 ;
   rtlc50_43_and_930_nx0 <= rtlcs42 AND not_rtlcs40 ;
   rtlc50_X_0_n204 <= rtlc50_43_and_930_nx0 AND not_RxRdy ;
   rtlc59_194_or_932_nx0 <= Rcv_Filter(4) OR Rcv_Filter(5) ;
   rtlc59n464 <= rtlc59_194_or_932_nx0 OR Rcv_Filter(6) ;
   rtlc59_198_or_933_nx0 <= Rcv_Filter(3) OR Rcv_Filter(5) ;
   rtlc59n467 <= rtlc59_198_or_933_nx0 OR Rcv_Filter(6) ;
   rtlc59_670_or_935_nx0 <= one_shot(4) OR one_shot(5) ;
   rtlc59n669 <= rtlc59_670_or_935_nx0 OR one_shot(6) ;
   rtlc_232_and_937_nx0 <= rtlc23n85 AND not_rtlc23n95 ;
   rtlc23n544 <= rtlc_232_and_937_nx0 AND not_energy_5 ;
   rtlc_233_and_938_nx0 <= not_rtlc23n85 AND rtlc23n451 ;
   rtlc23n541 <= rtlc_233_and_938_nx0 AND not_rtlc23n150 ;
   rtlc_235_and_939_nx0 <= rtlc23n85 AND rtlc23n95 ;
   rtlc23n543 <= rtlc_235_and_939_nx0 AND rtlc23n394 ;
   rtlc_320_and_940_nx0 <= not_rtlc23n85 AND rtlc23n150 ;
   rtlc23n542 <= rtlc_320_and_940_nx0 AND rtlc23n379 ;
   rtlc_1479_or_956_nx0 <= rtlcs8 OR rtlcs10 ;
   rtlc38n482 <= rtlc_1479_or_956_nx0 OR rtlcs15 ;
   rtlc_1621_or_957_nx0 <= not_rtlc59n464 OR rtlcn698 ;
   rtlcn740 <= rtlc_1621_or_957_nx0 OR rtlcn1077 ;
   rtlc_1629_or_958_nx0 <= not_rtlc59n467 OR rtlcn698 ;
   rtlcn758 <= rtlc_1629_or_958_nx0 OR rtlcn1078 ;
   rtlc_1633_and_959_nx0 <= not_Clean_plus AND Rcv_Filter(3) ;
   rtlcn1011 <= rtlc_1633_and_959_nx0 AND not_rtlc59n252 ;
   rtlc_1638_and_960_nx0 <= not_Clean_minus AND Rcv_Filter(4) ;
   rtlcn1038 <= rtlc_1638_and_960_nx0 AND not_rtlc59n281 ;
   rtlc_1656_and_961_nx0 <= not_rtlc35n613 AND not_rtlc35n629 ;
   rtlcn1118 <= rtlc_1656_and_961_nx0 AND not_RxRdy_plus_us_4 ;
   rtlc_1677_and_963_nx0 <= not_Clean_minus AND rtlcs44 ;
   rtlcn1127 <= rtlc_1677_and_963_nx0 AND rtlcs47 ;
   rtlc_1681_or_964_nx0 <= rtlcn1126 OR rtlcn1127 ;
   rtlcn1086 <= rtlc_1681_or_964_nx0 OR rtlcn1130 ;
   rtlcn591 <= rtlcs35 AND Strobe ;
   rtlc62n36 <= not_Clean_minus AND not_Clean_plus ;
   rtlcn1143 <= rtlc62n36 AND Rcv_Filter(0) ;
   rtlc_1722_and_970_nx0 <= Xmitting AND not_rtlc20n33 ;
   rtlcn843 <= rtlc_1722_and_970_nx0 AND Check_loop_back ;
   rtlc_1725_and_971_nx0 <= not_rtlc35n267 AND not_rtlcs36 ;
   rtlcn876 <= rtlc_1725_and_971_nx0 AND rtlcs0 ;
   rtlc_1729_and_972_nx0 <= not_Clean_plus AND rtlcn1083 ;
   rtlcn998 <= rtlc_1729_and_972_nx0 AND not_rtlcn698 ;
   rtlc_1731_and_973_nx0 <= not_Clean_minus AND Rcv_Filter(2) ;
   rtlcn1151 <= rtlc_1731_and_973_nx0 AND not_rtlc59n281 ;
   rtlc_1742_or_974_nx0 <= Big_Bit_Gap OR rtlc38n772 ;
   rtlcn698 <= rtlc_1742_or_974_nx0 OR not_Recieving ;
   rtlc_2046_or_976_nx0 <= rtlc38n455 OR rtlcn1218 ;
   rtlcn1230 <= rtlc_2046_or_976_nx0 OR rtlcn1246 ;
   rtlc_2067_and_977_nx0 <= not_rtlc47n218 AND not_rtlcn1215 ;
   rtlcn1256 <= rtlc_2067_and_977_nx0 AND rtlcn1222 ;
   rtlc35n267 <= Clean_minus OR Clean_plus ;
   rtlcn1224 <= rtlc35n267 OR not_Recieving ;
   rtlc_2106_and_980_nx0 <= not_Bit_number_4 AND not_Bit_number_3 ;
   rtlcs23 <= rtlc_2106_and_980_nx0 AND not_Bit_number_2 ;
   rtlcs12 <= not_Phase_3 AND Phase(4) ;
   rtlcs14 <= rtlcs12 AND not_Phase_1 ;
   rtlc_2228_and_984_nx0 <= Phase(4) AND Phase(3) ;
   rtlcs16 <= rtlc_2228_and_984_nx0 AND not_Phase_1 ;
   Data_47n4s3_3 <= not_Bit_number_3 XOR not_Bit_number_2 ;
   Actual_gap_sub7_35i1 : sub_6u_6u_6u_0 port map ( cin=>RxRdy_plus_us(0), 
      a(5)=>RxRdy_plus_us(6), a(4)=>RxRdy_plus_us(5), a(3)=>RxRdy_plus_us(4), 
      a(2)=>RxRdy_plus_us(3), a(1)=>RxRdy_plus_us(2), a(0)=>RxRdy_plus_us(1), 
      b(5)=>H15530_record_Bit_number_EXMPLR1642(4), b(4)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), b(0)=>PWR, d(5)=>
      Actual_gap_35n1s1(6), d(4)=>Actual_gap_35n1s1(5), d(3)=>
      Actual_gap_35n1s1(4), d(2)=>Actual_gap_35n1s1(3), d(1)=>
      Actual_gap_35n1s1(2), d(0)=>Actual_gap_35n1s1(1), cout=>DANGLING(19));
   modgen_and_0 : and_3u_3u port map ( a(2)=>not_Advance, a(1)=>
      not_rtlc38n485, a(0)=>Recieving, d=>rtlcn519);
   modgen_counter_one_shot : counter_up_sload_aclear_clock_clk_en_0_7
       port map ( clock=>Clock, q(6)=>one_shot(6), q(5)=>one_shot(5), q(4)=>
      one_shot(4), q(3)=>one_shot(3), q(2)=>one_shot(2), q(1)=>one_shot(1), 
      q(0)=>one_shot(0), clk_en=>CE, aclear=>not_ResetN, sload=>not_rtlcn623, 
      data(6)=>H15530_record_Bit_number_EXMPLR1642(4), data(5)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(4)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(3)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(2)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(1)=>
      H15530_record_Bit_number_EXMPLR1642(4), data(0)=>PWR, aset=>
      H15530_record_Bit_number_EXMPLR1642(4), sclear=>
      H15530_record_Bit_number_EXMPLR1642(4), updn=>PWR, cnt_en=>PWR);
   ix78 : decoder_4 port map ( data(3)=>Data_47n4s3_3, data(2)=>
      Bit_number(2), data(1)=>Data_47n4s3_1, data(0)=>Data_47n4s3_0, eq(15)
      =>Data_47n4s2(15), eq(14)=>Data_47n4s2(14), eq(13)=>Data_47n4s2(13), 
      eq(12)=>Data_47n4s2(12), eq(11)=>Data_47n4s2(11), eq(10)=>
      Data_47n4s2(10), eq(9)=>Data_47n4s2(9), eq(8)=>Data_47n4s2(8), eq(7)=>
      Data_47n4s2(7), eq(6)=>Data_47n4s2(6), eq(5)=>Data_47n4s2(5), eq(4)=>
      Data_47n4s2(4), eq(3)=>Data_47n4s2(3), eq(2)=>Data_47n4s2(2), eq(1)=>
      Data_47n4s2(1), eq(0)=>Data_47n4s2(0));
   modgen_or_1 : or_5u_5u port map ( a(4)=>energy(2), a(3)=>energy(3), a(2)
      =>energy(4), a(1)=>energy(5), a(0)=>rtlc23n378, d=>rtlc23n379);
   modgen_and_2 : and_5u_5u port map ( a(4)=>one_shot(4), a(3)=>one_shot(3), 
      a(2)=>one_shot(2), a(1)=>one_shot(1), a(0)=>one_shot(0), d=>rtlc38n770
   );
   modgen_or_3 : or_5u_5u port map ( a(4)=>Sync_error_47n7s1, a(3)=>
      Big_Bit_Gap, a(2)=>rtlc38n772, a(1)=>not_Recieving, a(0)=>
      not_rtlcn1088, d=>rtlcn1226);
   modgen_and_4 : and_7u_7u port map ( a(6)=>Len(5), a(5)=>not_Len_4, a(4)=>
      not_Len_3, a(3)=>Len(2), a(2)=>Len(1), a(1)=>not_Len_0, a(0)=>rtlcs45, 
      d=>Found_CMD_Sync_56n8ss1);
   modgen_and_5 : and_12u_12u port map ( a(11)=>not_RxRdy_plus_phase_4, 
      a(10)=>not_RxRdy_plus_phase_3, a(9)=>not_RxRdy_plus_phase_2, a(8)=>
      not_RxRdy_plus_phase_1, a(7)=>not_RxRdy_plus_phase_0, a(6)=>
      not_RxRdy_plus_us_6, a(5)=>not_RxRdy_plus_us_5, a(4)=>
      not_RxRdy_plus_us_4, a(3)=>not_RxRdy_plus_us_3, a(2)=>RxRdy_plus_us(2), 
      a(1)=>not_RxRdy_plus_us_1, a(0)=>not_RxRdy_plus_us_0, d=>
      RxRdy_plus_10us_50n4s1);
end Sital_technology_unfold_3721_0 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (9 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (9 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 ;

architecture INTERFACE_unfold_1 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_10u_10u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic_vector (9 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx25, nx28, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, 
      nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, PWR, 
      NOT_nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(9) <= nx32 ;
   q(8) <= nx34 ;
   q(7) <= nx36 ;
   q(6) <= nx38 ;
   q(5) <= nx40 ;
   q(4) <= nx42 ;
   q(3) <= nx44 ;
   q(2) <= nx46 ;
   q(1) <= nx48 ;
   q(0) <= nx50 ;
   GND <= '0' ;
   nx25 <= cnt_en OR sclear ;
   nx28 <= nx25 AND clk_en ;
   DFFPCE (nx31,GND,aclear,nx28,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx28,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx28,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx28,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,nx28,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,nx28,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,nx28,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,nx28,clock,nx46) ;
   DFFPCE (nx47,GND,aclear,nx28,clock,nx48) ;
   DFFPCE (nx49,GND,aclear,nx28,clock,nx50) ;
   inc : inc_10u_10u_0_0 port map ( cin=>PWR, a(9)=>nx32, a(8)=>nx34, a(7)=>
      nx36, a(6)=>nx38, a(5)=>nx40, a(4)=>nx42, a(3)=>nx44, a(2)=>nx46, a(1)
      =>nx48, a(0)=>nx50, d(9)=>nx51, d(8)=>nx52, d(7)=>nx53, d(6)=>nx54, 
      d(5)=>nx55, d(4)=>nx56, d(3)=>nx57, d(2)=>nx58, d(1)=>nx59, d(0)=>nx60, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx24 <= NOT sclear ;
   nx31 <= nx51 AND NOT_nx24 ;
   nx33 <= nx52 AND NOT_nx24 ;
   nx35 <= nx53 AND NOT_nx24 ;
   nx37 <= nx54 AND NOT_nx24 ;
   nx39 <= nx55 AND NOT_nx24 ;
   nx41 <= nx56 AND NOT_nx24 ;
   nx43 <= nx57 AND NOT_nx24 ;
   nx45 <= nx58 AND NOT_nx24 ;
   nx47 <= nx59 AND NOT_nx24 ;
   nx49 <= nx60 AND NOT_nx24 ;
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity single_Transmitter_FS_ver65_32 is 
   port (
      Clock : IN std_logic ;
      ResetN : IN std_logic ;
      CE : IN std_logic ;
      T_data : IN std_logic_vector (15 DOWNTO 0) ;
      T_Sync : IN std_logic ;
      ENC_TEST_On : IN std_logic ;
      Go : IN std_logic ;
      Bus_A : IN std_logic ;
      TxRdy : OUT std_logic ;
      Tx_A : OUT std_logic ;
      Tx_A_N : OUT std_logic ;
      Tx_B : OUT std_logic ;
      Tx_B_N : OUT std_logic ;
      Valid_command : IN std_logic ;
      BC_Mode : IN std_logic ;
      end_of_tx : OUT std_logic ;
      Tx_A_inhibit : OUT std_logic ;
      Tx_B_inhibit : OUT std_logic ;
      Xmitting_A : OUT std_logic ;
      Xmitting_B : OUT std_logic ;
      Check_loop_back : OUT std_logic ;
      Check_value : OUT std_logic ;
      Tx_inhibit_fail_safe : OUT std_logic) ;
end single_Transmitter_FS_ver65_32 ;

architecture Sital_Ofer_Hofman of single_Transmitter_FS_ver65_32 is 
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component mux_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         b : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_5_5
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (9 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (9 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   for modgen_counter_Fail_safe_counter : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10(INTERFACE_unfold_1);
   signal Tx_inhibit_fail_safe_EXMPLR1706: std_logic ;
   
   signal Buffer_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal Buffer_Sync, Buffer_full: std_logic ;
   
   signal Tx_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal Tx_Sync, Tx_Full: std_logic ;
   
   signal Tx_Counter_us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Tx_Counter_phase: std_logic_vector (5 DOWNTO 0) ;
   
   signal Parity, Fail_safe_counter_9, Fail_safe_counter_8, Tx, Tx_N, 
      Tx_inhibit, Xmitting, Bus_A_int, Switching, PWR, GND, not_ResetN, 
      rtlc3n23, rtlc5n141: std_logic ;
   
   signal Tx_Counter_us_6n7ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal Tx_Counter_phase_6n7ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal Tx_Counter_us_6n10ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Tx_Counter_phase_6n10ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc6n268, not_rtlcn425, rtlc6n294, rtlc6n302, rtlc6n303, 
      not_rtlc6n303, rtlc6n314, not_Tx_Full, rtlc6n316, not_rtlc6n316: 
   std_logic ;
   
   signal Tx_Counter_us_6n4s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal not_rtlcs0: std_logic ;
   
   signal Tx_Counter_phase_6n4s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc6n357, rtlc6n362, rtlc6n363, rtlc6n372, not_Tx_Sync, rtlc6n380, 
      not_rtlcn33, rtlc6n398, rtlc6n399, rtlc6n401, rtlc6n403, rtlc6n404, 
      rtlc6n409, rtlc6n414, rtlc6n555, rtlc6n572, rtlc6n573, rtlc6n578, 
      rtlc6n584, rtlc6n588, rtlc6n589, Tx_9n2ss1, Tx_N_9n2ss1, Tx_9n4ss1, 
      Tx_N_9n4ss1, Tx_9n5ss1, Tx_N_9n5ss1, Parity_9n5ss1, rtlc9n122, 
      Tx_9n2s2_3, Tx_9n2s2_1, Tx_9n2s2_0, Tx_9n2s1, not_Tx_9n2s1, not_Parity, 
      not_rtlc9n216, rtlc9n216, Parity_9n3s1, not_rtlc9n390, rtlc9n292, 
      rtlc9n295, rtlc9n389, rtlc9n390, rtlc9n404, rtlc9n420, rtlc9n421, 
      rtlc9n422, not_Valid_command, not_Xmitting, rtlc12_X_0_n139, 
      rtlc12n163, rtlc12n215, Tx_B_15n2ss1, Tx_B_N_15n2ss1, 
      Tx_B_inhibit_15n2ss1, Tx_A_15n2ss1, Tx_A_N_15n2ss1, 
      Tx_A_inhibit_15n2ss1, Xmitting_A_15n2ss1, Xmitting_B_15n2ss1, rtlcn32, 
      rtlcn33, not_rtlcn359, rtlcn118, rtlcn124, rtlcn136, rtlcn151, 
      not_rtlcn358, rtlcn259, rtlcn265, rtlcn266, rtlcn290, rtlcn305, 
      rtlcn322, rtlcn323, rtlcn327, not_rtlcn327, rtlcn329, not_rtlc9n422, 
      rtlcn336, rtlcn337, not_rtlc6n268, not_rtlc6n414, not_rtlcn322, 
      not_Switching, rtlcn358, rtlcn359, rtlcn360, rtlcn361, rtlcn362, 
      not_rtlc6n404, not_rtlc6n403, not_rtlc6n401, not_rtlc9n122, rtlcs0, 
      rtlcs1, rtlcs2, rtlcs3, rtlcs4, rtlcs5, rtlcs6, rtlcs7, rtlcs8, rtlcs9, 
      rtlcs10, rtlcs11, rtlcs12, rtlcs13, rtlcs16, rtlcs19, 
      not_Tx_Counter_phase_0, not_rtlcn151, not_rtlcn136, 
      not_Tx_Counter_us_4, not_Tx_Counter_us_3, not_Tx_Counter_us_2, 
      not_Tx_Counter_phase_4, not_Tx_Counter_phase_3, not_Tx_Counter_phase_2, 
      not_Tx_Counter_phase_1, not_Tx_Counter_phase_5, rtlcn425, not_rtlcn323, 
      not_rtlcn259, rtlc12_51_or_1000_nx0, rtlc_626_or_1006_nx0, 
      rtlc_635_and_1007_nx0, rtlc_664_and_1008_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (19 downto 0 );

begin
   Tx_inhibit_fail_safe <= Tx_inhibit_fail_safe_EXMPLR1706 ;
   PWR <= '1' ;
   GND <= '0' ;
   TxRdy <= NOT Buffer_full ;
   rtlc3n23 <= Tx_inhibit_fail_safe_EXMPLR1706 AND BC_Mode ;
   not_Tx_Sync <= NOT Tx_Sync ;
   rtlc6n362 <= rtlc6n357 AND not_rtlc6n303 ;
   rtlc6n398 <= rtlc6n362 AND Switching ;
   rtlc6n363 <= rtlcs7 AND not_rtlc6n303 ;
   rtlc6n399 <= rtlc6n363 AND Switching ;
   rtlc6n357 <= rtlcs7 OR not_rtlcs0 ;
   rtlc6n409 <= Tx_Full AND rtlcs19 ;
   rtlc6n414 <= rtlc6n409 AND rtlcs5 ;
   rtlc6n372 <= rtlcs0 AND rtlcs11 ;
   not_Tx_Full <= NOT Tx_Full ;
   rtlc6n314 <= rtlcs0 AND rtlcs19 ;
   rtlc6n316 <= rtlc6n314 AND not_Tx_Full ;
   rtlc6n294 <= rtlcs3 AND rtlcs7 ;
   rtlc6n302 <= rtlc6n294 OR rtlc6n314 ;
   rtlc6n303 <= rtlc6n302 AND Tx_Full ;
   rtlc6n268 <= Buffer_full AND not_Tx_Full ;
   Tx_Counter_us_inc5_6i1 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>
      Tx_Counter_us(4), a(3)=>Tx_Counter_us(3), a(2)=>Tx_Counter_us(2), a(1)
      =>Tx_Counter_us(1), a(0)=>Tx_Counter_us(0), d(4)=>
      Tx_Counter_us_6n4s1(4), d(3)=>Tx_Counter_us_6n4s1(3), d(2)=>
      Tx_Counter_us_6n4s1(2), d(1)=>Tx_Counter_us_6n4s1(1), d(0)=>
      Tx_Counter_us_6n4s1(0), cout=>DANGLING(0));
   Tx_Counter_phase_inc6_6i2 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>
      Tx_Counter_phase(5), a(4)=>Tx_Counter_phase(4), a(3)=>
      Tx_Counter_phase(3), a(2)=>Tx_Counter_phase(2), a(1)=>
      Tx_Counter_phase(1), a(0)=>Tx_Counter_phase(0), d(5)=>
      Tx_Counter_phase_6n4s1(5), d(4)=>Tx_Counter_phase_6n4s1(4), d(3)=>
      Tx_Counter_phase_6n4s1(3), d(2)=>Tx_Counter_phase_6n4s1(2), d(1)=>
      Tx_Counter_phase_6n4s1(1), d(0)=>Tx_Counter_phase_6n4s1(0), cout=>
      DANGLING(1));
   Tx_mux_9i1 : mux_16u_16u port map ( a(15)=>Tx_Data(15), a(14)=>
      Tx_Data(14), a(13)=>Tx_Data(13), a(12)=>Tx_Data(12), a(11)=>
      Tx_Data(11), a(10)=>Tx_Data(10), a(9)=>Tx_Data(9), a(8)=>Tx_Data(8), 
      a(7)=>Tx_Data(7), a(6)=>Tx_Data(6), a(5)=>Tx_Data(5), a(4)=>Tx_Data(4), 
      a(3)=>Tx_Data(3), a(2)=>Tx_Data(2), a(1)=>Tx_Data(1), a(0)=>Tx_Data(0), 
      b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, 
      b(9)=>GND, b(8)=>GND, b(7)=>GND, b(6)=>GND, b(5)=>GND, b(4)=>GND, b(3)
      =>Tx_9n2s2_3, b(2)=>Tx_Counter_us(2), b(1)=>Tx_9n2s2_1, b(0)=>
      Tx_9n2s2_0, d=>Tx_9n2s1);
   not_Tx_9n2s1 <= NOT Tx_9n2s1 ;
   not_Parity <= NOT Parity ;
   rtlc9n295 <= rtlcs11 OR rtlc9n122 ;
   rtlc9n122 <= not_rtlc9n390 AND rtlcn32 ;
   not_rtlc9n390 <= NOT rtlc9n390 ;
   rtlc9n390 <= rtlc9n389 AND Tx_Counter_us(4) ;
   rtlc9_235_or_999 : or_4u_4u port map ( a(3)=>Tx_Counter_phase(0), a(2)=>
      Tx_Counter_phase(1), a(1)=>Tx_Counter_phase(2), a(0)=>
      Tx_Counter_phase(3), d=>rtlc9n420);
   rtlc9n421 <= rtlc9n420 AND Tx_Counter_phase(4) ;
   rtlc9n422 <= rtlc9n421 OR Tx_Counter_phase(5) ;
   not_Xmitting <= NOT Xmitting ;
   rtlc12n215 <= Fail_safe_counter_9 AND Fail_safe_counter_8 ;
   rtlc9n389 <= Tx_Counter_us(3) OR Tx_Counter_us(2) ;
   rtlc9n404 <= Tx_Counter_us(4) OR Tx_Counter_us(3) ;
   rtlcn32 <= rtlc9n404 OR Tx_Counter_us(2) ;
   rtlcn33 <= rtlc6n380 OR ENC_TEST_On ;
   Tx_Counter_us_select_6i3 : select_3_3 port map ( a(2)=>not_rtlcn327, a(1)
      =>rtlc6n316, a(0)=>not_rtlcn359, b(2)=>PWR, b(1)=>GND, b(0)=>
      Tx_Counter_us_6n4s1(0), d=>Tx_Counter_us_6n7ss1(0));
   Tx_Counter_phase_select_6i4 : select_3_3 port map ( a(2)=>rtlcn305, a(1)
      =>rtlc6n316, a(0)=>not_rtlcn358, b(2)=>PWR, b(1)=>GND, b(0)=>
      Tx_Counter_phase_6n4s1(0), d=>Tx_Counter_phase_6n7ss1(0));
   Tx_select_9i2 : select_5_5 port map ( a(4)=>rtlcn265, a(3)=>rtlcn266, 
      a(2)=>not_rtlc9n216, a(1)=>rtlc9n122, a(0)=>rtlcs19, b(4)=>Tx_Sync, 
      b(3)=>not_Tx_Sync, b(2)=>GND, b(1)=>Tx_9n2ss1, b(0)=>Tx_9n4ss1, d=>
      Tx_9n5ss1);
   Tx_N_select_9i3 : select_5_5 port map ( a(4)=>rtlcn265, a(3)=>rtlcn266, 
      a(2)=>not_rtlc9n216, a(1)=>rtlc9n122, a(0)=>rtlcs19, b(4)=>not_Tx_Sync, 
      b(3)=>Tx_Sync, b(2)=>GND, b(1)=>Tx_N_9n2ss1, b(0)=>Tx_N_9n4ss1, d=>
      Tx_N_9n5ss1);
   rtlc_446_or_1005 : or_4u_4u port map ( a(3)=>rtlc9n122, a(2)=>rtlcs10, 
      a(1)=>rtlcs12, a(0)=>rtlcs19, d=>rtlc9n216);
   rtlcn327 <= rtlc6n316 OR not_rtlcn359 ;
   not_rtlcn327 <= NOT rtlcn327 ;
   not_rtlc6n303 <= NOT rtlc6n303 ;
   not_rtlc6n316 <= NOT rtlc6n316 ;
   rtlcn305 <= rtlcn358 AND not_rtlc6n316 ;
   not_rtlcs0 <= NOT rtlcs0 ;
   not_rtlc9n422 <= NOT rtlc9n422 ;
   rtlcn336 <= not_rtlc9n422 AND rtlcs13 ;
   rtlcn265 <= rtlcs16 OR rtlcn336 ;
   rtlcn337 <= rtlc9n422 AND rtlcs13 ;
   rtlcn266 <= rtlcs11 OR rtlcn337 ;
   not_rtlc9n216 <= NOT rtlc9n216 ;
   not_ResetN <= NOT ResetN ;
   not_rtlcn33 <= NOT rtlcn33 ;
   rtlcn322 <= rtlcn33 OR Switching ;
   not_rtlc6n268 <= NOT rtlc6n268 ;
   rtlcn329 <= Go OR not_rtlc6n268 ;
   rtlcn118 <= rtlcn322 AND rtlcn329 ;
   not_rtlc6n414 <= NOT rtlc6n414 ;
   rtlcn124 <= rtlcn322 AND not_rtlc6n414 ;
   not_rtlcn322 <= NOT rtlcn322 ;
   rtlcn136 <= rtlcn359 OR not_rtlcn322 ;
   rtlcn151 <= rtlcn358 OR not_rtlcn322 ;
   not_Switching <= NOT Switching ;
   rtlcn259 <= not_Switching AND Bus_A_int ;
   rtlcn323 <= Switching OR Bus_A_int ;
   rtlcn290 <= not_rtlc9n216 OR Tx_inhibit_fail_safe_EXMPLR1706 ;
   not_rtlcn358 <= NOT rtlcn358 ;
   not_rtlcn359 <= NOT rtlcn359 ;
   rtlc6n403 <= rtlc6n362 when rtlcn33 = '1' else rtlc6n398 ;
   rtlc6n404 <= rtlc6n363 when rtlcn33 = '1' else rtlc6n399 ;
   rtlc6n589 <= CE AND Go ;
   rtlc6n588 <= CE AND rtlc6n372 ;
   not_rtlc6n404 <= NOT rtlc6n404 ;
   rtlc6n584 <= CE AND not_rtlc6n404 ;
   not_rtlc6n403 <= NOT rtlc6n403 ;
   rtlc6n578 <= CE AND not_rtlc6n403 ;
   rtlc6n573 <= CE AND rtlcn361 ;
   rtlc6n572 <= CE AND rtlc6n268 ;
   not_rtlc6n401 <= NOT rtlc6n401 ;
   rtlc6n555 <= CE AND not_rtlc6n401 ;
   not_rtlc9n122 <= NOT rtlc9n122 ;
   rtlcn360 <= rtlcs5 OR not_rtlc9n122 ;
   rtlcn362 <= rtlc12n215 OR Valid_command ;
   rtlc12n163 <= CE AND rtlcn362 ;
   not_Valid_command <= NOT Valid_command ;
   rtlc6n380 <= NOT (Bus_A XOR Bus_A_int) ;
   rtlcs0 <= rtlcs1 AND rtlcs2 ;
   rtlcs3 <= rtlcs4 AND rtlcs2 ;
   rtlcs5 <= rtlcs6 AND rtlcs2 ;
   rtlcs7 <= rtlcs8 AND rtlcs9 ;
   rtlcs11 <= rtlcs10 AND rtlcs12 ;
   rtlcs13 <= Tx_9n2s2_0 AND rtlcs10 ;
   rtlcs10 <= Tx_Counter_us(1) AND rtlcs9 ;
   rtlcs16 <= Tx_9n2s2_1 AND rtlcs12 ;
   rtlcs12 <= Tx_Counter_us(0) AND rtlcs9 ;
   not_Tx_Counter_phase_0 <= NOT Tx_Counter_phase(0) ;
   rtlcs1 <= Tx_Counter_phase(5) AND not_Tx_Counter_phase_0 ;
   not_rtlcn151 <= NOT rtlcn151 ;
   Tx_Counter_phase_6n10ss1(3) <= Tx_Counter_phase_6n4s1(3) AND not_rtlcn151
    ;
   rtlcn359 <= rtlc6n316 OR rtlc6n303 ;
   not_rtlcn136 <= NOT rtlcn136 ;
   Tx_Counter_us_6n10ss1(4) <= Tx_Counter_us_6n4s1(4) AND not_rtlcn136 ;
   Tx_Counter_us_6n10ss1(3) <= Tx_Counter_us_6n4s1(3) AND not_rtlcn136 ;
   Tx_Counter_us_6n10ss1(2) <= Tx_Counter_us_6n4s1(2) AND not_rtlcn136 ;
   Tx_Counter_us_6n10ss1(0) <= Tx_Counter_us_6n7ss1(0) AND rtlcn322 ;
   Tx_Counter_us_6n10ss1(1) <= Tx_Counter_us_6n4s1(1) AND not_rtlcn136 ;
   Tx_9n2s2_1 <= NOT Tx_Counter_us(1) ;
   Tx_9n2s2_0 <= NOT Tx_Counter_us(0) ;
   rtlcs8 <= Tx_9n2s2_1 AND Tx_9n2s2_0 ;
   not_Tx_Counter_us_4 <= NOT Tx_Counter_us(4) ;
   not_Tx_Counter_us_3 <= NOT Tx_Counter_us(3) ;
   not_Tx_Counter_us_2 <= NOT Tx_Counter_us(2) ;
   Tx_Counter_phase_6n10ss1(2) <= Tx_Counter_phase_6n4s1(2) AND not_rtlcn151
    ;
   Tx_Counter_phase_6n10ss1(1) <= Tx_Counter_phase_6n4s1(1) AND not_rtlcn151
    ;
   not_Tx_Counter_phase_4 <= NOT Tx_Counter_phase(4) ;
   not_Tx_Counter_phase_3 <= NOT Tx_Counter_phase(3) ;
   not_Tx_Counter_phase_2 <= NOT Tx_Counter_phase(2) ;
   not_Tx_Counter_phase_1 <= NOT Tx_Counter_phase(1) ;
   rtlc_673_and_1009 : and_4u_4u port map ( a(3)=>not_Tx_Counter_phase_4, 
      a(2)=>not_Tx_Counter_phase_3, a(1)=>not_Tx_Counter_phase_2, a(0)=>
      not_Tx_Counter_phase_1, d=>rtlcs2);
   rtlc_677_and_1010 : and_5u_5u port map ( a(4)=>Tx_Counter_us(4), a(3)=>
      not_Tx_Counter_us_3, a(2)=>Tx_Counter_us(2), a(1)=>Tx_9n2s2_1, a(0)=>
      Tx_9n2s2_0, d=>rtlcs19);
   Tx_Counter_phase_6n10ss1(0) <= Tx_Counter_phase_6n7ss1(0) AND rtlcn322 ;
   not_Tx_Counter_phase_5 <= NOT Tx_Counter_phase(5) ;
   rtlcs4 <= not_Tx_Counter_phase_0 AND not_Tx_Counter_phase_5 ;
   rtlcn358 <= rtlc6n303 OR rtlcs0 ;
   Tx_Counter_phase_6n10ss1(4) <= Tx_Counter_phase_6n4s1(4) AND not_rtlcn151
    ;
   Tx_Counter_phase_6n10ss1(5) <= Tx_Counter_phase_6n4s1(5) AND not_rtlcn151
    ;
   rtlcs6 <= not_Tx_Counter_phase_5 AND Tx_Counter_phase(0) ;
   not_rtlcn425 <= NOT rtlcn425 ;
   Parity_9n5ss1 <= Parity_9n3s1 OR not_rtlc9n122 ;
   Tx_A_15n2ss1 <= Tx AND rtlcn259 ;
   Tx_A_N_15n2ss1 <= Tx_N AND rtlcn259 ;
   not_rtlcn323 <= NOT rtlcn323 ;
   Tx_B_15n2ss1 <= Tx AND not_rtlcn323 ;
   Tx_B_N_15n2ss1 <= Tx_N AND not_rtlcn323 ;
   not_rtlcn259 <= NOT rtlcn259 ;
   Tx_A_inhibit_15n2ss1 <= Tx_inhibit OR not_rtlcn259 ;
   Tx_B_inhibit_15n2ss1 <= Tx_inhibit OR rtlcn323 ;
   Xmitting_A_15n2ss1 <= Xmitting AND rtlcn259 ;
   Xmitting_B_15n2ss1 <= Xmitting AND not_rtlcn323 ;
   rtlcn425 <= Go OR rtlc6n268 ;
   rtlc6n401 <= not_rtlcn425 AND rtlcn322 ;
   modgen_counter_Fail_safe_counter : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 port map ( clock=>
      Clock, q(9)=>Fail_safe_counter_9, q(8)=>Fail_safe_counter_8, q(7)=>
      DANGLING(2), q(6)=>DANGLING(3), q(5)=>DANGLING(4), q(4)=>DANGLING(5), 
      q(3)=>DANGLING(6), q(2)=>DANGLING(7), q(1)=>DANGLING(8), q(0)=>
      DANGLING(9), clk_en=>CE, aclear=>rtlc5n141, sload=>GND, data(9)=>
      DANGLING(10), data(8)=>DANGLING(11), data(7)=>DANGLING(12), data(6)=>
      DANGLING(13), data(5)=>DANGLING(14), data(4)=>DANGLING(15), data(3)=>
      DANGLING(16), data(2)=>DANGLING(17), data(1)=>DANGLING(18), data(0)=>
      DANGLING(19), aset=>GND, sclear=>rtlc12_X_0_n139, updn=>PWR, cnt_en=>
      rtlcs5);
   Parity_9n3s1 <= Parity XOR Tx_9n2s1 ;
   Tx_9n4ss1 <= Parity XOR rtlc9n422 ;
   Tx_9n2ss1 <= Tx_9n2s1 XOR rtlc9n422 ;
   Tx_N_9n2ss1 <= rtlc9n422 XOR not_Tx_9n2s1 ;
   Tx_N_9n4ss1 <= rtlc9n422 XOR not_Parity ;
   DFFPCE (Bus_A,rtlc5n141,GND,rtlc6n589,Clock,Bus_A_int) ;
   DFFPCE (not_Tx_Sync,GND,rtlc5n141,rtlc6n588,Clock,Check_value) ;
   DFFPCE (rtlc6n372,GND,rtlc5n141,CE,Clock,Check_loop_back) ;
   DFFPCE (rtlc6n316,GND,rtlc5n141,CE,Clock,end_of_tx) ;
   DFFPCE (not_rtlcn33,GND,rtlc5n141,CE,Clock,Switching) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(5),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(5)) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(4),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(4)) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(3),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(3)) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(2),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(2)) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(1),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(1)) ;
   DFFPCE (Tx_Counter_phase_6n10ss1(0),GND,rtlc5n141,rtlc6n584,Clock,
   Tx_Counter_phase(0)) ;
   DFFPCE (Tx_Counter_us_6n10ss1(4),GND,rtlc5n141,rtlc6n578,Clock,
   Tx_Counter_us(4)) ;
   DFFPCE (Tx_Counter_us_6n10ss1(3),GND,rtlc5n141,rtlc6n578,Clock,
   Tx_Counter_us(3)) ;
   DFFPCE (Tx_Counter_us_6n10ss1(2),GND,rtlc5n141,rtlc6n578,Clock,
   Tx_Counter_us(2)) ;
   DFFPCE (Tx_Counter_us_6n10ss1(1),GND,rtlc5n141,rtlc6n578,Clock,
   Tx_Counter_us(1)) ;
   DFFPCE (Tx_Counter_us_6n10ss1(0),GND,rtlc5n141,rtlc6n578,Clock,
   Tx_Counter_us(0)) ;
   DFFPCE (rtlcn124,GND,rtlc5n141,rtlc6n573,Clock,Tx_Full) ;
   DFFPCE (Buffer_Sync,GND,rtlc5n141,rtlc6n572,Clock,Tx_Sync) ;
   DFFPCE (Buffer_Data(15),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(15)) ;
   DFFPCE (Buffer_Data(14),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(14)) ;
   DFFPCE (Buffer_Data(13),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(13)) ;
   DFFPCE (Buffer_Data(12),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(12)) ;
   DFFPCE (Buffer_Data(11),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(11)) ;
   DFFPCE (Buffer_Data(10),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(10)) ;
   DFFPCE (Buffer_Data(9),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(9)) ;
   DFFPCE (Buffer_Data(8),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(8)) ;
   DFFPCE (Buffer_Data(7),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(7)) ;
   DFFPCE (Buffer_Data(6),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(6)) ;
   DFFPCE (Buffer_Data(5),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(5)) ;
   DFFPCE (Buffer_Data(4),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(4)) ;
   DFFPCE (Buffer_Data(3),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(3)) ;
   DFFPCE (Buffer_Data(2),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(2)) ;
   DFFPCE (Buffer_Data(1),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(1)) ;
   DFFPCE (Buffer_Data(0),GND,rtlc5n141,rtlc6n572,Clock,Tx_Data(0)) ;
   DFFPCE (rtlcn118,GND,rtlc5n141,rtlc6n555,Clock,Buffer_full) ;
   DFFPCE (T_Sync,GND,rtlc5n141,rtlc6n589,Clock,Buffer_Sync) ;
   DFFPCE (T_data(15),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(15)) ;
   DFFPCE (T_data(14),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(14)) ;
   DFFPCE (T_data(13),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(13)) ;
   DFFPCE (T_data(12),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(12)) ;
   DFFPCE (T_data(11),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(11)) ;
   DFFPCE (T_data(10),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(10)) ;
   DFFPCE (T_data(9),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(9)) ;
   DFFPCE (T_data(8),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(8)) ;
   DFFPCE (T_data(7),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(7)) ;
   DFFPCE (T_data(6),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(6)) ;
   DFFPCE (T_data(5),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(5)) ;
   DFFPCE (T_data(4),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(4)) ;
   DFFPCE (T_data(3),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(3)) ;
   DFFPCE (T_data(2),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(2)) ;
   DFFPCE (T_data(1),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(1)) ;
   DFFPCE (T_data(0),GND,rtlc5n141,rtlc6n589,Clock,Buffer_Data(0)) ;
   DFFPCE (rtlcn290,rtlc5n141,GND,CE,Clock,Tx_inhibit) ;
   DFFPCE (rtlc9n216,GND,rtlc5n141,CE,Clock,Xmitting) ;
   DFFPCE (Parity_9n5ss1,GND,rtlc5n141,rtlc9n292,Clock,Parity) ;
   DFFPCE (Tx_N_9n5ss1,GND,rtlc5n141,CE,Clock,Tx_N) ;
   DFFPCE (Tx_9n5ss1,GND,rtlc5n141,CE,Clock,Tx) ;
   DFFPCE (not_Valid_command,GND,rtlc5n141,rtlc12n163,Clock,
   Tx_inhibit_fail_safe_EXMPLR1706) ;
   DFFPCE (Xmitting_B_15n2ss1,GND,rtlc5n141,CE,Clock,Xmitting_B) ;
   DFFPCE (Xmitting_A_15n2ss1,GND,rtlc5n141,CE,Clock,Xmitting_A) ;
   DFFPCE (Tx_A_inhibit_15n2ss1,rtlc5n141,GND,CE,Clock,Tx_A_inhibit) ;
   DFFPCE (Tx_A_N_15n2ss1,GND,rtlc5n141,CE,Clock,Tx_A_N) ;
   DFFPCE (Tx_A_15n2ss1,GND,rtlc5n141,CE,Clock,Tx_A) ;
   DFFPCE (Tx_B_inhibit_15n2ss1,rtlc5n141,GND,CE,Clock,Tx_B_inhibit) ;
   DFFPCE (Tx_B_N_15n2ss1,GND,rtlc5n141,CE,Clock,Tx_B_N) ;
   DFFPCE (Tx_B_15n2ss1,GND,rtlc5n141,CE,Clock,Tx_B) ;
   DFFPCE (rtlc3n23,not_ResetN,GND,CE,Clock,rtlc5n141) ;
   rtlc12_51_or_1000_nx0 <= Valid_command OR not_Xmitting ;
   rtlc12_X_0_n139 <= rtlc12_51_or_1000_nx0 OR rtlc12n215 ;
   rtlc_626_or_1006_nx0 <= rtlc6n268 OR rtlc6n414 ;
   rtlcn361 <= rtlc_626_or_1006_nx0 OR not_rtlcn322 ;
   rtlc_635_and_1007_nx0 <= CE AND rtlc9n295 ;
   rtlc9n292 <= rtlc_635_and_1007_nx0 AND rtlcn360 ;
   rtlc_664_and_1008_nx0 <= not_Tx_Counter_us_4 AND not_Tx_Counter_us_3 ;
   rtlcs9 <= rtlc_664_and_1008_nx0 AND not_Tx_Counter_us_2 ;
   Tx_9n2s2_3 <= not_Tx_Counter_us_3 XOR not_Tx_Counter_us_2 ;
end Sital_Ofer_Hofman ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity selcounter_13_13_13_0_1_up is 
   port (
      cin : IN std_logic ;
      mode : IN std_logic ;
      updn : IN std_logic ;
      a : IN std_logic_vector (12 DOWNTO 0) ;
      k : IN std_logic_vector (12 DOWNTO 0) ;
      d : OUT std_logic_vector (12 DOWNTO 0)) ;
end selcounter_13_13_13_0_1_up ;

architecture INTERFACE of selcounter_13_13_13_0_1_up is 
   component inc_13u_13u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic_vector (12 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, nx51, nx52, 
      nx53, nx54, nx55, nx57, nx59, nx61, nx63, nx65, nx67, nx69, nx71, nx73, 
      nx75, nx77, nx79, nx81, nx97, nx98, nx100: std_logic ;

begin
   nx55 <= k(12) when mode = '1' else a(12) ;
   nx57 <= k(11) when mode = '1' else a(11) ;
   nx59 <= k(10) when mode = '1' else a(10) ;
   nx61 <= k(9) when mode = '1' else a(9) ;
   nx63 <= k(8) when mode = '1' else a(8) ;
   nx65 <= k(7) when mode = '1' else a(7) ;
   nx67 <= k(6) when mode = '1' else a(6) ;
   nx69 <= k(5) when mode = '1' else a(5) ;
   nx71 <= k(4) when mode = '1' else a(4) ;
   nx73 <= k(3) when mode = '1' else a(3) ;
   nx75 <= k(2) when mode = '1' else a(2) ;
   nx77 <= k(1) when mode = '1' else a(1) ;
   nx79 <= k(0) when mode = '1' else a(0) ;
   modgen_inc_0 : inc_13u_13u_0 port map ( cin=>nx100, a(12)=>nx55, a(11)=>
      nx57, a(10)=>nx59, a(9)=>nx61, a(8)=>nx63, a(7)=>nx65, a(6)=>nx67, 
      a(5)=>nx69, a(4)=>nx71, a(3)=>nx73, a(2)=>nx75, a(1)=>nx77, a(0)=>nx79, 
      d=>d, cout=>nx97);
   nx98 <= '0' ;
   nx100 <= nx98 when mode = '1' else cin ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity RT_Real_switch_BRM_ver8_4_RTLC_LONGENT2 is 
   port (
      Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
      BC_Active_Bus_A : IN std_logic ;
      BC_Go : IN std_logic ;
      BC_T_sync : IN std_logic ;
      BC_Transmit_data : IN std_logic_vector (15 DOWNTO 0) ;
      BC_mode : IN std_logic ;
      BIT_word : IN std_logic_vector (15 DOWNTO 0) ;
      BUSY_in_LUT : IN std_logic ;
      CPU_ResetN : IN std_logic ;
      Clock : IN std_logic ;
      Cohen : IN std_logic ;
      Data_in : IN std_logic_vector (15 DOWNTO 0) ;
      Do_illegal : IN std_logic ;
      ENC_TEST_On : IN std_logic ;
      External_CE_In : IN std_logic ;
      Host_Status_Bits : IN std_logic_vector (10 DOWNTO 0) ;
      MODE_CODE1553A : IN std_logic ;
      Minus_A : IN std_logic ;
      Minus_B : IN std_logic ;
      NO_BCST : IN std_logic ;
      No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
      Plus_A : IN std_logic ;
      Plus_B : IN std_logic ;
      RT_Address_wire : IN std_logic_vector (5 DOWNTO 0) ;
      RT_On : IN std_logic ;
      Tx_Inh_A_in : IN std_logic ;
      Tx_Inh_B_in : IN std_logic ;
      Wrap_Address : IN std_logic_vector (4 DOWNTO 0) ;
      illegal_command : IN std_logic ;
      loopback_test : IN std_logic ;
      Address : OUT std_logic_vector (15 DOWNTO 0) ;
      BC_TxRdy : OUT std_logic ;
      BUS_A : OUT std_logic ;
      Clock_enable : OUT std_logic ;
      Current_command : OUT std_logic_vector (15 DOWNTO 0) ;
      Data_out : OUT std_logic_vector (15 DOWNTO 0) ;
      Last_command : OUT std_logic_vector (15 DOWNTO 0) ;
      Message_ended_OK : OUT std_logic ;
      New_Command : OUT std_logic ;
      RT2RT_message : OUT std_logic ;
      Read : OUT std_logic ;
      Revision : OUT std_logic_vector (15 DOWNTO 0) ;
      Tx_A : OUT std_logic ;
      Tx_A_N : OUT std_logic ;
      Tx_B : OUT std_logic ;
      Tx_B_N : OUT std_logic ;
      Tx_inh_A : OUT std_logic ;
      Tx_inh_B : OUT std_logic ;
      Write : OUT std_logic ;
      mil1553_errors_Inhibit_TF : OUT std_logic ;
      mil1553_errors_invalid_command : OUT std_logic ;
      mil1553_errors_RT2RT_format_gap : OUT std_logic ;
      mil1553_errors_RT2RT_format_error : OUT std_logic ;
      mil1553_errors_Invalid_word : OUT std_logic ;
      mil1553_errors_Parity_Manchester : OUT std_logic ;
      mil1553_errors_incorrect_data_sync : OUT std_logic ;
      mil1553_errors_Low_word_count : OUT std_logic ;
      mil1553_errors_high_word_count : OUT std_logic ;
      mil1553_errors_Format_error : OUT std_logic ;
      mil1553_errors_Message_Error_set : OUT std_logic ;
      mil1553_errors_Address_Parity : OUT std_logic ;
      mil1553_errors_echo_back_bus_B : OUT std_logic ;
      mil1553_errors_echo_back_bus_A : OUT std_logic ;
      mil1553_errors_bus_B_shutdown : OUT std_logic ;
      mil1553_errors_bus_A_shutdown : OUT std_logic ;
      mil1553_errors_transmitter_timout : OUT std_logic ;
      Channel_status : OUT std_logic_vector (10 DOWNTO 0) ;
      H15530_record_A_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
      H15530_record_A_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
      H15530_record_A_Sync_error : OUT std_logic ;
      H15530_record_A_Manchester_error : OUT std_logic ;
      H15530_record_A_Parity_error : OUT std_logic ;
      H15530_record_A_echo_back_bus : OUT std_logic ;
      H15530_record_A_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      H15530_record_A_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
      H15530_record_A_RxRDY_plus_12us : OUT std_logic ;
      H15530_record_A_RxRDY_plus_10us : OUT std_logic ;
      H15530_record_A_CS : OUT std_logic ;
      H15530_record_A_Pre_EchoRdy : OUT std_logic ;
      H15530_record_A_Command_Sync : OUT std_logic ;
      H15530_record_A_Pre_RxRdy : OUT std_logic ;
      H15530_record_A_recieving : OUT std_logic ;
      H15530_record_B_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
      H15530_record_B_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
      H15530_record_B_Sync_error : OUT std_logic ;
      H15530_record_B_Manchester_error : OUT std_logic ;
      H15530_record_B_Parity_error : OUT std_logic ;
      H15530_record_B_echo_back_bus : OUT std_logic ;
      H15530_record_B_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      H15530_record_B_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
      H15530_record_B_RxRDY_plus_12us : OUT std_logic ;
      H15530_record_B_RxRDY_plus_10us : OUT std_logic ;
      H15530_record_B_CS : OUT std_logic ;
      H15530_record_B_Pre_EchoRdy : OUT std_logic ;
      H15530_record_B_Command_Sync : OUT std_logic ;
      H15530_record_B_Pre_RxRdy : OUT std_logic ;
      H15530_record_B_recieving : OUT std_logic ;
      Message_ended_not_OK : OUT std_logic ;
      RCV_A_Sync_error : OUT std_logic ;
      RCV_B_Sync_error : OUT std_logic) ;
end RT_Real_switch_BRM_ver8_4_RTLC_LONGENT2 ;

architecture Sital_Ofer_hofman_unfold_2696 of 
   RT_Real_switch_BRM_ver8_4_RTLC_LONGENT2 is 
   component Auxilury_Ver_8_4_2_1_0
      port (
         Clock : IN std_logic ;
         Cohen : IN std_logic ;
         H15530_record_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         H15530_record_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         H15530_record_A_Sync_error : IN std_logic ;
         H15530_record_A_Manchester_error : IN std_logic ;
         H15530_record_A_Parity_error : IN std_logic ;
         H15530_record_A_echo_back_bus : IN std_logic ;
         H15530_record_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         H15530_record_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         H15530_record_A_RxRDY_plus_12us : IN std_logic ;
         H15530_record_A_RxRDY_plus_10us : IN std_logic ;
         H15530_record_A_CS : IN std_logic ;
         H15530_record_A_Pre_EchoRdy : IN std_logic ;
         H15530_record_A_Command_Sync : IN std_logic ;
         H15530_record_A_Pre_RxRdy : IN std_logic ;
         H15530_record_A_recieving : IN std_logic ;
         H15530_record_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         H15530_record_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         H15530_record_B_Sync_error : IN std_logic ;
         H15530_record_B_Manchester_error : IN std_logic ;
         H15530_record_B_Parity_error : IN std_logic ;
         H15530_record_B_echo_back_bus : IN std_logic ;
         H15530_record_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         H15530_record_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         H15530_record_B_RxRDY_plus_12us : IN std_logic ;
         H15530_record_B_RxRDY_plus_10us : IN std_logic ;
         H15530_record_B_CS : IN std_logic ;
         H15530_record_B_Pre_EchoRdy : IN std_logic ;
         H15530_record_B_Command_Sync : IN std_logic ;
         H15530_record_B_Pre_RxRdy : IN std_logic ;
         H15530_record_B_recieving : IN std_logic ;
         RT_Address_wire : IN std_logic_vector (5 DOWNTO 0) ;
         ResetN : IN std_logic ;
         External_CE_In : IN std_logic ;
         CE : OUT std_logic ;
         RT_Address_A_valid : OUT std_logic ;
         RT_Address_B_valid : OUT std_logic ;
         RT_Address_Parity_Error : OUT std_logic) ;
   end component ;
   component Back_end_IF_8_4_0_32
      port (
         Active_command : IN std_logic_vector (15 DOWNTO 0) ;
         Active_command_update : IN std_logic ;
         BIT_word : IN std_logic_vector (15 DOWNTO 0) ;
         Bus_Channel_status : IN std_logic_vector (10 DOWNTO 0) ;
         CE : IN std_logic ;
         CPU_ResetN : IN std_logic ;
         Clock : IN std_logic ;
         Data_in : IN std_logic_vector (15 DOWNTO 0) ;
         FE_Address : IN std_logic_vector (15 DOWNTO 0) ;
         Host_Status_Bits : IN std_logic_vector (10 DOWNTO 0) ;
         IDLE_MORE_THAN_NO_RESPONSE : IN std_logic ;
         Inhibit_TF : IN std_logic ;
         MODE_CODE1553A : IN std_logic ;
         Message_ended_OK : IN std_logic ;
         Read_req : IN std_logic ;
         Valid_command : IN std_logic ;
         Wrap_Address : IN std_logic_vector (4 DOWNTO 0) ;
         Write_Req : IN std_logic ;
         Write_data : IN std_logic_vector (15 DOWNTO 0) ;
         Xmitting_A : IN std_logic ;
         Xmitting_B : IN std_logic ;
         illegal_command : IN std_logic ;
         reset_RT_received : IN std_logic ;
         Channel_status : OUT std_logic_vector (10 DOWNTO 0) ;
         Clock_enable : OUT std_logic ;
         Read : OUT std_logic ;
         Write_Ack : OUT std_logic ;
         read_Ack : OUT std_logic ;
         read_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         Address : OUT std_logic_vector (15 DOWNTO 0) ;
         Data_out : OUT std_logic_vector (15 DOWNTO 0) ;
         Last_command : OUT std_logic_vector (15 DOWNTO 0) ;
         ResetN : OUT std_logic ;
         Write : OUT std_logic) ;
   end component ;
   component Dual_channel_stm_ver8_4_1
      port (
         C : IN std_logic ;
         R : IN std_logic ;
         CE : IN std_logic ;
         Hila : IN std_logic ;
         RT_Address_valid_A : IN std_logic ;
         RT_Address_valid_B : IN std_logic ;
         Rcv_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         Rcv_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         Rcv_A_Sync_error : IN std_logic ;
         Rcv_A_Manchester_error : IN std_logic ;
         Rcv_A_Parity_error : IN std_logic ;
         Rcv_A_echo_back_bus : IN std_logic ;
         Rcv_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         Rcv_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         Rcv_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         Rcv_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         Rcv_A_RxRDY_plus_12us : IN std_logic ;
         Rcv_A_RxRDY_plus_10us : IN std_logic ;
         Rcv_A_CS : IN std_logic ;
         Rcv_A_Pre_EchoRdy : IN std_logic ;
         Rcv_A_Command_Sync : IN std_logic ;
         Rcv_A_Pre_RxRdy : IN std_logic ;
         Rcv_A_recieving : IN std_logic ;
         Rcv_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         Rcv_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         Rcv_B_Sync_error : IN std_logic ;
         Rcv_B_Manchester_error : IN std_logic ;
         Rcv_B_Parity_error : IN std_logic ;
         Rcv_B_echo_back_bus : IN std_logic ;
         Rcv_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         Rcv_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         Rcv_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         Rcv_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         Rcv_B_RxRDY_plus_12us : IN std_logic ;
         Rcv_B_RxRDY_plus_10us : IN std_logic ;
         Rcv_B_CS : IN std_logic ;
         Rcv_B_Pre_EchoRdy : IN std_logic ;
         Rcv_B_Command_Sync : IN std_logic ;
         Rcv_B_Pre_RxRdy : IN std_logic ;
         Rcv_B_recieving : IN std_logic ;
         No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
         TxRdy : IN std_logic ;
         Active_Bus_A : OUT std_logic ;
         Transmit_data : OUT std_logic_vector (15 DOWNTO 0) ;
         T_Sync : OUT std_logic ;
         Go : OUT std_logic ;
         end_of_tx : IN std_logic ;
         Bus_A_shut_down : OUT std_logic ;
         Bus_B_shut_down : OUT std_logic ;
         Address : OUT std_logic_vector (15 DOWNTO 0) ;
         reset_remote_terminal_received : OUT std_logic ;
         Inhibit_TF : OUT std_logic ;
         active_command : OUT std_logic_vector (15 DOWNTO 0) ;
         illegal_command : IN std_logic ;
         Do_illegal : IN std_logic ;
         Active_command_updated : OUT std_logic ;
         Message_ended_OK : OUT std_logic ;
         Message_ended_not_OK : OUT std_logic ;
         Valid_command : OUT std_logic ;
         Write_Req : OUT std_logic ;
         Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         Write_Ack : IN std_logic ;
         read_Req : OUT std_logic ;
         read_Data : IN std_logic_vector (15 DOWNTO 0) ;
         read_Ack : IN std_logic ;
         Channel_status_out : OUT std_logic_vector (10 DOWNTO 0) ;
         Channel_status : IN std_logic_vector (10 DOWNTO 0) ;
         RT2RT_message : OUT std_logic ;
         NO_BCST : IN std_logic ;
         MODE_CODE1553A : IN std_logic) ;
   end component ;
   component H15530_Ver17_32_0
      port (
         CE : IN std_logic ;
         Check_loop_back : IN std_logic ;
         Check_value : IN std_logic ;
         Clock : IN std_logic ;
         Minus : IN std_logic ;
         PP194_CS : IN std_logic ;
         Plus : IN std_logic ;
         ResetN : IN std_logic ;
         Xmitting : IN std_logic ;
         Bi_error : OUT std_logic ;
         H15530_record_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
         H15530_record_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
         H15530_record_Sync_error : OUT std_logic ;
         H15530_record_Manchester_error : OUT std_logic ;
         H15530_record_Parity_error : OUT std_logic ;
         H15530_record_echo_back_bus : OUT std_logic ;
         H15530_record_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         H15530_record_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
         H15530_record_RxRDY_plus_12us : OUT std_logic ;
         H15530_record_RxRDY_plus_10us : OUT std_logic ;
         H15530_record_CS : OUT std_logic ;
         H15530_record_Pre_EchoRdy : OUT std_logic ;
         H15530_record_Command_Sync : OUT std_logic ;
         H15530_record_Pre_RxRdy : OUT std_logic ;
         H15530_record_recieving : OUT std_logic ;
         Echo_Error : OUT std_logic ;
         Parity_error : OUT std_logic ;
         Sync_error : OUT std_logic) ;
   end component ;
   component single_Transmitter_FS_ver65_32
      port (
         Clock : IN std_logic ;
         ResetN : IN std_logic ;
         CE : IN std_logic ;
         T_data : IN std_logic_vector (15 DOWNTO 0) ;
         T_Sync : IN std_logic ;
         ENC_TEST_On : IN std_logic ;
         Go : IN std_logic ;
         Bus_A : IN std_logic ;
         TxRdy : OUT std_logic ;
         Tx_A : OUT std_logic ;
         Tx_A_N : OUT std_logic ;
         Tx_B : OUT std_logic ;
         Tx_B_N : OUT std_logic ;
         Valid_command : IN std_logic ;
         BC_Mode : IN std_logic ;
         end_of_tx : OUT std_logic ;
         Tx_A_inhibit : OUT std_logic ;
         Tx_B_inhibit : OUT std_logic ;
         Xmitting_A : OUT std_logic ;
         Xmitting_B : OUT std_logic ;
         Check_loop_back : OUT std_logic ;
         Check_value : OUT std_logic ;
         Tx_inhibit_fail_safe : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_13u_13u
      port (
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component mux_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component selcounter_13_13_13_0_1_up
      port (
         cin : IN std_logic ;
         mode : IN std_logic ;
         updn : IN std_logic ;
         a : IN std_logic_vector (12 DOWNTO 0) ;
         k : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic_vector (12 DOWNTO 0)) ;
   end component ;
   for H15530_A : H15530_Ver17_32_0 use entity work.H15530_Ver17_32_0(
   Sital_technology_unfold_1);
   for H15530_B : H15530_Ver17_32_0 use entity work.H15530_Ver17_32_0(
   Sital_technology_unfold_3721_0);
   signal Address_9_EXMPLR1790, Address_8_EXMPLR1791, Address_7_EXMPLR1792, 
      Address_6_EXMPLR1793, Address_5_EXMPLR1794, Address_4_EXMPLR1795, 
      Address_3_EXMPLR1796, Address_2_EXMPLR1797, Address_1_EXMPLR1798, 
      Address_0_EXMPLR1799, BC_TxRdy_EXMPLR1800, BUS_A_EXMPLR1801: std_logic
    ;
   
   signal Current_command_EXMPLR1970: std_logic_vector (15 DOWNTO 0) ;
   
   signal Message_ended_OK_EXMPLR1851, New_Command_EXMPLR1852: std_logic ;
   
   signal Channel_status_EXMPLR1973: std_logic_vector (10 DOWNTO 0) ;
   
   signal Active_Bus_A, Active_command_updated, Bus_A_shut_down, 
      Bus_A_shut_down_dt, Bus_B_shut_down, Bus_B_shut_down_dt, 
      Bus_Channel_status_10, Bus_Channel_status_4, CE, CE_RT, 
      Revision_1_EXMPLR1876, Channel_status1_3, Channel_status_10_dt, 
      Check_loop_back, Check_value, Echo_Error_A, Echo_Error_B, Go, 
      H15530_ResetN, IDLE_MORE_THAN_NO_RESPONSE, Inhibit_TF_A, 
      Inhibit_TF_A_dt, ME_DvDt, Minus_AM, Minus_BM: std_logic ;
   
   signal One_Shot: std_logic_vector (12 DOWNTO 0) ;
   
   signal Plus_AM, Plus_BM, RT_Address_A_valid, RT_Address_B_valid, RT_Go, 
      RT_T_Sync: std_logic ;
   
   signal RT_Transmit_data: std_logic_vector (15 DOWNTO 0) ;
   
   signal ResetN, T_Sync: std_logic ;
   
   signal Transmit_data: std_logic_vector (15 DOWNTO 0) ;
   
   signal Tx_A1, Tx_A_N1, Tx_A_inhibit, Tx_B1, Tx_B_N1, Tx_B_inhibit, 
      Write_Ack_A, Write_Req_A, Xmitting_A, Xmitting_B, any_active, 
      end_of_tx, fail_safe_reset, loopback_test_D, read_Ack_A: std_logic ;
   
   signal read_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal read_Req_A, reset_RT_received_A, transmitter_timeout, 
      Revision_0_EXMPLR1877, rtlc3n12, not_ResetN, Tx_A_15n0r4, Tx_A_15n0r3, 
      not_Tx_A_15n0r3, Tx_A_15n0r1, Tx_A_N_19n0r1, Tx_B_23n0r4, Tx_B_23n0r3, 
      not_Tx_B_23n0r3, Tx_B_23n0r1, Tx_B_N_27n0r1, not_loopback_test, 
      H15530_ResetN_44n0r1, IDLE_MORE_THAN_NO_RESPONSE_52n4ss1, rtlc52n64, 
      not_rtlc52n64, rtlc52n66, not_rtlc52n66, rtlc52n68, 
      IDLE_MORE_THAN_NO_RESPONSE_52n4s4, rtlc52n283, rtlc52n284, rtlc52n285, 
      rtlc52n286, rtlc52n287, rtlc52n288, rtlc52n289, rtlc52n303, rtlc52n304, 
      rtlc52n305, rtlc52n306, rtlc52n307, rtlc52n308, rtlc52n321, rtlc52n322, 
      rtlc52n324, rtlc52n326, rtlc52n327, rtlc52n328, rtlc52n329, 
      not_rtlc3n12, not_One_Shot_11, not_One_Shot_10, not_One_Shot_9, 
      not_One_Shot_8, not_One_Shot_7, not_One_Shot_6, not_One_Shot_5, 
      not_One_Shot_4, not_One_Shot_3, not_One_Shot_2, not_One_Shot_1, 
      not_One_Shot_0, rtlcn36, not_One_Shot_12, rtlcn40: std_logic ;
   
   signal rtlcn41: std_logic_vector (12 DOWNTO 0) ;
   
   signal rtlcn42: std_logic ;
   
   signal H15530_record_A_R_Data_EXMPLR1974: std_logic_vector (15 DOWNTO 0)
    ;
   
   signal H15530_record_A_RAW_GAP_EXMPLR1975: std_logic_vector (6 DOWNTO 0)
    ;
   
   signal H15530_record_A_Gap_found_EXMPLR1977: std_logic_vector
    (2 DOWNTO 0) ;
   
   signal H15530_record_A_RxRDY_plus_10us_EXMPLR1919, 
      H15530_record_A_CS_EXMPLR1920, H15530_record_A_Command_Sync_EXMPLR1922, 
      H15530_record_A_Pre_RxRdy_EXMPLR1923, 
      H15530_record_A_recieving_EXMPLR1924: std_logic ;
   
   signal H15530_record_B_R_Data_EXMPLR1978: std_logic_vector (15 DOWNTO 0)
    ;
   
   signal H15530_record_B_RAW_GAP_EXMPLR1979: std_logic_vector (6 DOWNTO 0)
    ;
   
   signal H15530_record_B_Gap_found_EXMPLR1981: std_logic_vector
    (2 DOWNTO 0) ;
   
   signal H15530_record_B_RxRDY_plus_10us_EXMPLR1958, 
      H15530_record_B_CS_EXMPLR1959, H15530_record_B_Command_Sync_EXMPLR1961, 
      H15530_record_B_Pre_RxRdy_EXMPLR1962, 
      H15530_record_B_recieving_EXMPLR1963, I7_I_d, I7_not_I_d, I8_I_d, 
      I8_not_I_d, I9_I_d, I9_not_I_d, I10_I_d, I10_not_I_d, I11_I_d, 
      I11_not_I_d, rtlc52_127_or_1012_nx0, rtlc52_142_and_1014_nx0: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (86 downto 0 );

begin
   Address(15) <= Revision_1_EXMPLR1876 ;
   Address(14) <= Revision_1_EXMPLR1876 ;
   Address(13) <= Revision_1_EXMPLR1876 ;
   Address(12) <= Revision_1_EXMPLR1876 ;
   Address(11) <= Revision_1_EXMPLR1876 ;
   Address(9) <= Address_9_EXMPLR1790 ;
   Address(8) <= Address_8_EXMPLR1791 ;
   Address(7) <= Address_7_EXMPLR1792 ;
   Address(6) <= Address_6_EXMPLR1793 ;
   Address(5) <= Address_5_EXMPLR1794 ;
   Address(4) <= Address_4_EXMPLR1795 ;
   Address(3) <= Address_3_EXMPLR1796 ;
   Address(2) <= Address_2_EXMPLR1797 ;
   Address(1) <= Address_1_EXMPLR1798 ;
   Address(0) <= Address_0_EXMPLR1799 ;
   BC_TxRdy <= BC_TxRdy_EXMPLR1800 ;
   BUS_A <= BUS_A_EXMPLR1801 ;
   Current_command(15) <= Current_command_EXMPLR1970(15) ;
   Current_command(14) <= Current_command_EXMPLR1970(14) ;
   Current_command(13) <= Current_command_EXMPLR1970(13) ;
   Current_command(12) <= Current_command_EXMPLR1970(12) ;
   Current_command(11) <= Current_command_EXMPLR1970(11) ;
   Current_command(10) <= Current_command_EXMPLR1970(10) ;
   Current_command(9) <= Current_command_EXMPLR1970(9) ;
   Current_command(8) <= Current_command_EXMPLR1970(8) ;
   Current_command(7) <= Current_command_EXMPLR1970(7) ;
   Current_command(6) <= Current_command_EXMPLR1970(6) ;
   Current_command(5) <= Current_command_EXMPLR1970(5) ;
   Current_command(4) <= Current_command_EXMPLR1970(4) ;
   Current_command(3) <= Current_command_EXMPLR1970(3) ;
   Current_command(2) <= Current_command_EXMPLR1970(2) ;
   Current_command(1) <= Current_command_EXMPLR1970(1) ;
   Current_command(0) <= Current_command_EXMPLR1970(0) ;
   Message_ended_OK <= Message_ended_OK_EXMPLR1851 ;
   New_Command <= New_Command_EXMPLR1852 ;
   Revision(15) <= Revision_1_EXMPLR1876 ;
   Revision(14) <= Revision_1_EXMPLR1876 ;
   Revision(13) <= Revision_1_EXMPLR1876 ;
   Revision(12) <= Revision_1_EXMPLR1876 ;
   Revision(11) <= Revision_1_EXMPLR1876 ;
   Revision(10) <= Revision_0_EXMPLR1877 ;
   Revision(9) <= Revision_1_EXMPLR1876 ;
   Revision(8) <= Revision_1_EXMPLR1876 ;
   Revision(7) <= Revision_1_EXMPLR1876 ;
   Revision(6) <= Revision_0_EXMPLR1877 ;
   Revision(5) <= Revision_1_EXMPLR1876 ;
   Revision(4) <= Revision_1_EXMPLR1876 ;
   Revision(3) <= Revision_0_EXMPLR1877 ;
   Revision(2) <= Revision_1_EXMPLR1876 ;
   Revision(1) <= Revision_1_EXMPLR1876 ;
   Revision(0) <= Revision_0_EXMPLR1877 ;
   mil1553_errors_invalid_command <= Revision_1_EXMPLR1876 ;
   mil1553_errors_RT2RT_format_gap <= Revision_1_EXMPLR1876 ;
   mil1553_errors_RT2RT_format_error <= Revision_1_EXMPLR1876 ;
   mil1553_errors_Invalid_word <= Revision_1_EXMPLR1876 ;
   mil1553_errors_Parity_Manchester <= Revision_1_EXMPLR1876 ;
   mil1553_errors_incorrect_data_sync <= Revision_1_EXMPLR1876 ;
   mil1553_errors_Low_word_count <= Revision_1_EXMPLR1876 ;
   mil1553_errors_high_word_count <= Revision_1_EXMPLR1876 ;
   mil1553_errors_Address_Parity <= Revision_1_EXMPLR1876 ;
   Channel_status(10) <= Channel_status_EXMPLR1973(10) ;
   Channel_status(9) <= Channel_status_EXMPLR1973(9) ;
   Channel_status(8) <= Channel_status_EXMPLR1973(8) ;
   Channel_status(7) <= Channel_status_EXMPLR1973(7) ;
   Channel_status(6) <= Channel_status_EXMPLR1973(6) ;
   Channel_status(5) <= Channel_status_EXMPLR1973(5) ;
   Channel_status(4) <= Channel_status_EXMPLR1973(4) ;
   Channel_status(3) <= Channel_status_EXMPLR1973(3) ;
   Channel_status(2) <= Channel_status_EXMPLR1973(2) ;
   Channel_status(1) <= Channel_status_EXMPLR1973(1) ;
   Channel_status(0) <= Channel_status_EXMPLR1973(0) ;
   H15530_record_A_Bit_number(4) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Bit_number(3) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Bit_number(2) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Bit_number(1) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Bit_number(0) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(7) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(6) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(5) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(4) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(3) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(2) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(1) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Response_Time(0) <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Sync_error <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Manchester_error <= Revision_1_EXMPLR1876 ;
   H15530_record_A_Parity_error <= Revision_1_EXMPLR1876 ;
   H15530_record_A_echo_back_bus <= Revision_1_EXMPLR1876 ;
   H15530_record_A_R_Data(15) <= H15530_record_A_R_Data_EXMPLR1974(15) ;
   H15530_record_A_R_Data(14) <= H15530_record_A_R_Data_EXMPLR1974(14) ;
   H15530_record_A_R_Data(13) <= H15530_record_A_R_Data_EXMPLR1974(13) ;
   H15530_record_A_R_Data(12) <= H15530_record_A_R_Data_EXMPLR1974(12) ;
   H15530_record_A_R_Data(11) <= H15530_record_A_R_Data_EXMPLR1974(11) ;
   H15530_record_A_R_Data(10) <= H15530_record_A_R_Data_EXMPLR1974(10) ;
   H15530_record_A_R_Data(9) <= H15530_record_A_R_Data_EXMPLR1974(9) ;
   H15530_record_A_R_Data(8) <= H15530_record_A_R_Data_EXMPLR1974(8) ;
   H15530_record_A_R_Data(7) <= H15530_record_A_R_Data_EXMPLR1974(7) ;
   H15530_record_A_R_Data(6) <= H15530_record_A_R_Data_EXMPLR1974(6) ;
   H15530_record_A_R_Data(5) <= H15530_record_A_R_Data_EXMPLR1974(5) ;
   H15530_record_A_R_Data(4) <= H15530_record_A_R_Data_EXMPLR1974(4) ;
   H15530_record_A_R_Data(3) <= H15530_record_A_R_Data_EXMPLR1974(3) ;
   H15530_record_A_R_Data(2) <= H15530_record_A_R_Data_EXMPLR1974(2) ;
   H15530_record_A_R_Data(1) <= H15530_record_A_R_Data_EXMPLR1974(1) ;
   H15530_record_A_R_Data(0) <= H15530_record_A_R_Data_EXMPLR1974(0) ;
   H15530_record_A_RAW_GAP(6) <= H15530_record_A_RAW_GAP_EXMPLR1975(6) ;
   H15530_record_A_RAW_GAP(5) <= H15530_record_A_RAW_GAP_EXMPLR1975(5) ;
   H15530_record_A_RAW_GAP(4) <= H15530_record_A_RAW_GAP_EXMPLR1975(4) ;
   H15530_record_A_RAW_GAP(3) <= H15530_record_A_RAW_GAP_EXMPLR1975(3) ;
   H15530_record_A_RAW_GAP(2) <= H15530_record_A_RAW_GAP_EXMPLR1975(2) ;
   H15530_record_A_RAW_GAP(1) <= H15530_record_A_RAW_GAP_EXMPLR1975(1) ;
   H15530_record_A_RAW_GAP(0) <= H15530_record_A_RAW_GAP_EXMPLR1975(0) ;
   H15530_record_A_Gap_found(2) <= H15530_record_A_Gap_found_EXMPLR1977(2) ;
   H15530_record_A_Gap_found(1) <= H15530_record_A_Gap_found_EXMPLR1977(1) ;
   H15530_record_A_Gap_found(0) <= H15530_record_A_Gap_found_EXMPLR1977(0) ;
   H15530_record_A_RxRDY_plus_12us <= Revision_1_EXMPLR1876 ;
   H15530_record_A_RxRDY_plus_10us <= Revision_1_EXMPLR1876 ;
   H15530_record_A_CS <= H15530_record_A_CS_EXMPLR1920 ;
   H15530_record_A_Command_Sync <= H15530_record_A_Command_Sync_EXMPLR1922 ;
   H15530_record_A_Pre_RxRdy <= H15530_record_A_Pre_RxRdy_EXMPLR1923 ;
   H15530_record_A_recieving <= H15530_record_A_recieving_EXMPLR1924 ;
   H15530_record_B_Bit_number(4) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Bit_number(3) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Bit_number(2) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Bit_number(1) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Bit_number(0) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(7) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(6) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(5) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(4) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(3) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(2) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(1) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Response_Time(0) <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Sync_error <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Manchester_error <= Revision_1_EXMPLR1876 ;
   H15530_record_B_Parity_error <= Revision_1_EXMPLR1876 ;
   H15530_record_B_echo_back_bus <= Revision_1_EXMPLR1876 ;
   H15530_record_B_R_Data(15) <= H15530_record_B_R_Data_EXMPLR1978(15) ;
   H15530_record_B_R_Data(14) <= H15530_record_B_R_Data_EXMPLR1978(14) ;
   H15530_record_B_R_Data(13) <= H15530_record_B_R_Data_EXMPLR1978(13) ;
   H15530_record_B_R_Data(12) <= H15530_record_B_R_Data_EXMPLR1978(12) ;
   H15530_record_B_R_Data(11) <= H15530_record_B_R_Data_EXMPLR1978(11) ;
   H15530_record_B_R_Data(10) <= H15530_record_B_R_Data_EXMPLR1978(10) ;
   H15530_record_B_R_Data(9) <= H15530_record_B_R_Data_EXMPLR1978(9) ;
   H15530_record_B_R_Data(8) <= H15530_record_B_R_Data_EXMPLR1978(8) ;
   H15530_record_B_R_Data(7) <= H15530_record_B_R_Data_EXMPLR1978(7) ;
   H15530_record_B_R_Data(6) <= H15530_record_B_R_Data_EXMPLR1978(6) ;
   H15530_record_B_R_Data(5) <= H15530_record_B_R_Data_EXMPLR1978(5) ;
   H15530_record_B_R_Data(4) <= H15530_record_B_R_Data_EXMPLR1978(4) ;
   H15530_record_B_R_Data(3) <= H15530_record_B_R_Data_EXMPLR1978(3) ;
   H15530_record_B_R_Data(2) <= H15530_record_B_R_Data_EXMPLR1978(2) ;
   H15530_record_B_R_Data(1) <= H15530_record_B_R_Data_EXMPLR1978(1) ;
   H15530_record_B_R_Data(0) <= H15530_record_B_R_Data_EXMPLR1978(0) ;
   H15530_record_B_RAW_GAP(6) <= H15530_record_B_RAW_GAP_EXMPLR1979(6) ;
   H15530_record_B_RAW_GAP(5) <= H15530_record_B_RAW_GAP_EXMPLR1979(5) ;
   H15530_record_B_RAW_GAP(4) <= H15530_record_B_RAW_GAP_EXMPLR1979(4) ;
   H15530_record_B_RAW_GAP(3) <= H15530_record_B_RAW_GAP_EXMPLR1979(3) ;
   H15530_record_B_RAW_GAP(2) <= H15530_record_B_RAW_GAP_EXMPLR1979(2) ;
   H15530_record_B_RAW_GAP(1) <= H15530_record_B_RAW_GAP_EXMPLR1979(1) ;
   H15530_record_B_RAW_GAP(0) <= H15530_record_B_RAW_GAP_EXMPLR1979(0) ;
   H15530_record_B_Gap_found(2) <= H15530_record_B_Gap_found_EXMPLR1981(2) ;
   H15530_record_B_Gap_found(1) <= H15530_record_B_Gap_found_EXMPLR1981(1) ;
   H15530_record_B_Gap_found(0) <= H15530_record_B_Gap_found_EXMPLR1981(0) ;
   H15530_record_B_RxRDY_plus_12us <= Revision_1_EXMPLR1876 ;
   H15530_record_B_RxRDY_plus_10us <= Revision_1_EXMPLR1876 ;
   H15530_record_B_CS <= H15530_record_B_CS_EXMPLR1959 ;
   H15530_record_B_Command_Sync <= H15530_record_B_Command_Sync_EXMPLR1961 ;
   H15530_record_B_Pre_RxRdy <= H15530_record_B_Pre_RxRdy_EXMPLR1962 ;
   H15530_record_B_recieving <= H15530_record_B_recieving_EXMPLR1963 ;
   Revision_1_EXMPLR1876 <= '0' ;
   Revision_0_EXMPLR1877 <= '1' ;
   Auxilury : Auxilury_Ver_8_4_2_1_0 port map ( Clock=>Clock, Cohen=>
      Revision_0_EXMPLR1877, H15530_record_A_Bit_number(4)=>
      Revision_1_EXMPLR1876, H15530_record_A_Bit_number(3)=>
      Revision_1_EXMPLR1876, H15530_record_A_Bit_number(2)=>
      Revision_1_EXMPLR1876, H15530_record_A_Bit_number(1)=>
      Revision_1_EXMPLR1876, H15530_record_A_Bit_number(0)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(7)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(6)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(5)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(4)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(3)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(2)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(1)=>
      Revision_1_EXMPLR1876, H15530_record_A_Response_Time(0)=>
      Revision_1_EXMPLR1876, H15530_record_A_Sync_error=>
      Revision_1_EXMPLR1876, H15530_record_A_Manchester_error=>
      Revision_1_EXMPLR1876, H15530_record_A_Parity_error=>
      Revision_1_EXMPLR1876, H15530_record_A_echo_back_bus=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(15)=>
      H15530_record_A_R_Data_EXMPLR1974(15), H15530_record_A_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR1974(14), H15530_record_A_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR1974(13), H15530_record_A_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR1974(12), H15530_record_A_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR1974(11), H15530_record_A_R_Data(10)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(9)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(8)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(7)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(6)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(5)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(4)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(3)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(2)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(1)=>
      Revision_1_EXMPLR1876, H15530_record_A_R_Data(0)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(6)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(5)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(4)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(3)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(2)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(1)=>
      Revision_1_EXMPLR1876, H15530_record_A_RAW_GAP(0)=>
      Revision_1_EXMPLR1876, H15530_record_A_GAP(6)=>Revision_1_EXMPLR1876, 
      H15530_record_A_GAP(5)=>Revision_1_EXMPLR1876, H15530_record_A_GAP(4)
      =>Revision_1_EXMPLR1876, H15530_record_A_GAP(3)=>Revision_1_EXMPLR1876, 
      H15530_record_A_GAP(2)=>Revision_1_EXMPLR1876, H15530_record_A_GAP(1)
      =>Revision_1_EXMPLR1876, H15530_record_A_GAP(0)=>Revision_1_EXMPLR1876, 
      H15530_record_A_Gap_found(2)=>Revision_1_EXMPLR1876, 
      H15530_record_A_Gap_found(1)=>Revision_1_EXMPLR1876, 
      H15530_record_A_Gap_found(0)=>Revision_1_EXMPLR1876, 
      H15530_record_A_RxRDY_plus_12us=>Revision_1_EXMPLR1876, 
      H15530_record_A_RxRDY_plus_10us=>Revision_1_EXMPLR1876, 
      H15530_record_A_CS=>Revision_1_EXMPLR1876, H15530_record_A_Pre_EchoRdy
      =>Revision_1_EXMPLR1876, H15530_record_A_Command_Sync=>
      Revision_1_EXMPLR1876, H15530_record_A_Pre_RxRdy=>
      Revision_1_EXMPLR1876, H15530_record_A_recieving=>
      Revision_1_EXMPLR1876, H15530_record_B_Bit_number(4)=>
      Revision_1_EXMPLR1876, H15530_record_B_Bit_number(3)=>
      Revision_1_EXMPLR1876, H15530_record_B_Bit_number(2)=>
      Revision_1_EXMPLR1876, H15530_record_B_Bit_number(1)=>
      Revision_1_EXMPLR1876, H15530_record_B_Bit_number(0)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(7)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(6)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(5)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(4)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(3)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(2)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(1)=>
      Revision_1_EXMPLR1876, H15530_record_B_Response_Time(0)=>
      Revision_1_EXMPLR1876, H15530_record_B_Sync_error=>
      Revision_1_EXMPLR1876, H15530_record_B_Manchester_error=>
      Revision_1_EXMPLR1876, H15530_record_B_Parity_error=>
      Revision_1_EXMPLR1876, H15530_record_B_echo_back_bus=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(15)=>
      H15530_record_B_R_Data_EXMPLR1978(15), H15530_record_B_R_Data(14)=>
      H15530_record_B_R_Data_EXMPLR1978(14), H15530_record_B_R_Data(13)=>
      H15530_record_B_R_Data_EXMPLR1978(13), H15530_record_B_R_Data(12)=>
      H15530_record_B_R_Data_EXMPLR1978(12), H15530_record_B_R_Data(11)=>
      H15530_record_B_R_Data_EXMPLR1978(11), H15530_record_B_R_Data(10)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(9)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(8)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(7)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(6)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(5)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(4)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(3)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(2)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(1)=>
      Revision_1_EXMPLR1876, H15530_record_B_R_Data(0)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(6)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(5)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(4)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(3)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(2)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(1)=>
      Revision_1_EXMPLR1876, H15530_record_B_RAW_GAP(0)=>
      Revision_1_EXMPLR1876, H15530_record_B_GAP(6)=>Revision_1_EXMPLR1876, 
      H15530_record_B_GAP(5)=>Revision_1_EXMPLR1876, H15530_record_B_GAP(4)
      =>Revision_1_EXMPLR1876, H15530_record_B_GAP(3)=>Revision_1_EXMPLR1876, 
      H15530_record_B_GAP(2)=>Revision_1_EXMPLR1876, H15530_record_B_GAP(1)
      =>Revision_1_EXMPLR1876, H15530_record_B_GAP(0)=>Revision_1_EXMPLR1876, 
      H15530_record_B_Gap_found(2)=>Revision_1_EXMPLR1876, 
      H15530_record_B_Gap_found(1)=>Revision_1_EXMPLR1876, 
      H15530_record_B_Gap_found(0)=>Revision_1_EXMPLR1876, 
      H15530_record_B_RxRDY_plus_12us=>Revision_1_EXMPLR1876, 
      H15530_record_B_RxRDY_plus_10us=>Revision_1_EXMPLR1876, 
      H15530_record_B_CS=>Revision_1_EXMPLR1876, H15530_record_B_Pre_EchoRdy
      =>Revision_1_EXMPLR1876, H15530_record_B_Command_Sync=>
      Revision_1_EXMPLR1876, H15530_record_B_Pre_RxRdy=>
      Revision_1_EXMPLR1876, H15530_record_B_recieving=>
      Revision_1_EXMPLR1876, RT_Address_wire(5)=>Revision_1_EXMPLR1876, 
      RT_Address_wire(4)=>Revision_1_EXMPLR1876, RT_Address_wire(3)=>
      Revision_1_EXMPLR1876, RT_Address_wire(2)=>Revision_1_EXMPLR1876, 
      RT_Address_wire(1)=>Revision_1_EXMPLR1876, RT_Address_wire(0)=>
      Revision_1_EXMPLR1876, ResetN=>ResetN, External_CE_In=>
      Revision_1_EXMPLR1876, CE=>CE, RT_Address_A_valid=>RT_Address_A_valid, 
      RT_Address_B_valid=>RT_Address_B_valid, RT_Address_Parity_Error=>
      DANGLING(0));
   I0 : Back_end_IF_8_4_0_32 port map ( Active_command(15)=>
      Current_command_EXMPLR1970(15), Active_command(14)=>
      Current_command_EXMPLR1970(14), Active_command(13)=>
      Current_command_EXMPLR1970(13), Active_command(12)=>
      Current_command_EXMPLR1970(12), Active_command(11)=>
      Current_command_EXMPLR1970(11), Active_command(10)=>
      Current_command_EXMPLR1970(10), Active_command(9)=>
      Current_command_EXMPLR1970(9), Active_command(8)=>
      Current_command_EXMPLR1970(8), Active_command(7)=>
      Current_command_EXMPLR1970(7), Active_command(6)=>
      Current_command_EXMPLR1970(6), Active_command(5)=>
      Current_command_EXMPLR1970(5), Active_command(4)=>
      Current_command_EXMPLR1970(4), Active_command(3)=>
      Current_command_EXMPLR1970(3), Active_command(2)=>
      Current_command_EXMPLR1970(2), Active_command(1)=>
      Current_command_EXMPLR1970(1), Active_command(0)=>
      Current_command_EXMPLR1970(0), Active_command_update=>
      Active_command_updated, BIT_word(15)=>BIT_word(15), BIT_word(14)=>
      BIT_word(14), BIT_word(13)=>BIT_word(13), BIT_word(12)=>BIT_word(12), 
      BIT_word(11)=>BIT_word(11), BIT_word(10)=>BIT_word(10), BIT_word(9)=>
      BIT_word(9), BIT_word(8)=>BIT_word(8), BIT_word(7)=>BIT_word(7), 
      BIT_word(6)=>BIT_word(6), BIT_word(5)=>BIT_word(5), BIT_word(4)=>
      BIT_word(4), BIT_word(3)=>BIT_word(3), BIT_word(2)=>BIT_word(2), 
      BIT_word(1)=>BIT_word(1), BIT_word(0)=>BIT_word(0), 
      Bus_Channel_status(10)=>Bus_Channel_status_10, Bus_Channel_status(9)=>
      Revision_1_EXMPLR1876, Bus_Channel_status(8)=>Revision_1_EXMPLR1876, 
      Bus_Channel_status(7)=>Revision_1_EXMPLR1876, Bus_Channel_status(6)=>
      Revision_1_EXMPLR1876, Bus_Channel_status(5)=>Revision_1_EXMPLR1876, 
      Bus_Channel_status(4)=>Bus_Channel_status_4, Bus_Channel_status(3)=>
      Revision_1_EXMPLR1876, Bus_Channel_status(2)=>Revision_1_EXMPLR1876, 
      Bus_Channel_status(1)=>Revision_1_EXMPLR1876, Bus_Channel_status(0)=>
      Revision_1_EXMPLR1876, CE=>CE, CPU_ResetN=>CPU_ResetN, Clock=>Clock, 
      Data_in(15)=>Data_in(15), Data_in(14)=>Data_in(14), Data_in(13)=>
      Data_in(13), Data_in(12)=>Data_in(12), Data_in(11)=>Data_in(11), 
      Data_in(10)=>Data_in(10), Data_in(9)=>Data_in(9), Data_in(8)=>
      Data_in(8), Data_in(7)=>Data_in(7), Data_in(6)=>Data_in(6), Data_in(5)
      =>Data_in(5), Data_in(4)=>Data_in(4), Data_in(3)=>Data_in(3), 
      Data_in(2)=>Data_in(2), Data_in(1)=>Data_in(1), Data_in(0)=>Data_in(0), 
      FE_Address(15)=>Revision_1_EXMPLR1876, FE_Address(14)=>
      Revision_1_EXMPLR1876, FE_Address(13)=>Revision_1_EXMPLR1876, 
      FE_Address(12)=>Revision_1_EXMPLR1876, FE_Address(11)=>
      Revision_1_EXMPLR1876, FE_Address(10)=>Revision_1_EXMPLR1876, 
      FE_Address(9)=>Address_9_EXMPLR1790, FE_Address(8)=>
      Address_8_EXMPLR1791, FE_Address(7)=>Address_7_EXMPLR1792, 
      FE_Address(6)=>Address_6_EXMPLR1793, FE_Address(5)=>
      Address_5_EXMPLR1794, FE_Address(4)=>Address_4_EXMPLR1795, 
      FE_Address(3)=>Address_3_EXMPLR1796, FE_Address(2)=>
      Address_2_EXMPLR1797, FE_Address(1)=>Address_1_EXMPLR1798, 
      FE_Address(0)=>Address_0_EXMPLR1799, Host_Status_Bits(10)=>
      Host_Status_Bits(10), Host_Status_Bits(9)=>Host_Status_Bits(9), 
      Host_Status_Bits(8)=>Host_Status_Bits(8), Host_Status_Bits(7)=>
      Host_Status_Bits(7), Host_Status_Bits(6)=>Host_Status_Bits(6), 
      Host_Status_Bits(5)=>Host_Status_Bits(5), Host_Status_Bits(4)=>
      Host_Status_Bits(4), Host_Status_Bits(3)=>Host_Status_Bits(3), 
      Host_Status_Bits(2)=>Host_Status_Bits(2), Host_Status_Bits(1)=>
      Host_Status_Bits(1), Host_Status_Bits(0)=>Host_Status_Bits(0), 
      IDLE_MORE_THAN_NO_RESPONSE=>IDLE_MORE_THAN_NO_RESPONSE, Inhibit_TF=>
      Inhibit_TF_A, MODE_CODE1553A=>MODE_CODE1553A, Message_ended_OK=>
      Message_ended_OK_EXMPLR1851, Read_req=>read_Req_A, Valid_command=>
      New_Command_EXMPLR1852, Wrap_Address(4)=>Revision_1_EXMPLR1876, 
      Wrap_Address(3)=>Revision_1_EXMPLR1876, Wrap_Address(2)=>
      Revision_1_EXMPLR1876, Wrap_Address(1)=>Revision_1_EXMPLR1876, 
      Wrap_Address(0)=>Revision_1_EXMPLR1876, Write_Req=>Write_Req_A, 
      Write_data(15)=>Revision_1_EXMPLR1876, Write_data(14)=>
      Revision_1_EXMPLR1876, Write_data(13)=>Revision_1_EXMPLR1876, 
      Write_data(12)=>Revision_1_EXMPLR1876, Write_data(11)=>
      Revision_1_EXMPLR1876, Write_data(10)=>Revision_1_EXMPLR1876, 
      Write_data(9)=>Revision_1_EXMPLR1876, Write_data(8)=>
      Revision_1_EXMPLR1876, Write_data(7)=>Revision_1_EXMPLR1876, 
      Write_data(6)=>Revision_1_EXMPLR1876, Write_data(5)=>
      Revision_1_EXMPLR1876, Write_data(4)=>Revision_1_EXMPLR1876, 
      Write_data(3)=>Revision_1_EXMPLR1876, Write_data(2)=>
      Revision_1_EXMPLR1876, Write_data(1)=>Revision_1_EXMPLR1876, 
      Write_data(0)=>Revision_1_EXMPLR1876, Xmitting_A=>Xmitting_A, 
      Xmitting_B=>Xmitting_B, illegal_command=>illegal_command, 
      reset_RT_received=>reset_RT_received_A, Channel_status(10)=>
      Channel_status_EXMPLR1973(10), Channel_status(9)=>
      Channel_status_EXMPLR1973(9), Channel_status(8)=>
      Channel_status_EXMPLR1973(8), Channel_status(7)=>
      Channel_status_EXMPLR1973(7), Channel_status(6)=>
      Channel_status_EXMPLR1973(6), Channel_status(5)=>
      Channel_status_EXMPLR1973(5), Channel_status(4)=>
      Channel_status_EXMPLR1973(4), Channel_status(3)=>Channel_status1_3, 
      Channel_status(2)=>Channel_status_EXMPLR1973(2), Channel_status(1)=>
      Channel_status_EXMPLR1973(1), Channel_status(0)=>
      Channel_status_EXMPLR1973(0), Clock_enable=>Clock_enable, Read=>Read, 
      Write_Ack=>Write_Ack_A, read_Ack=>read_Ack_A, read_Data(15)=>
      read_Data(15), read_Data(14)=>read_Data(14), read_Data(13)=>
      read_Data(13), read_Data(12)=>read_Data(12), read_Data(11)=>
      read_Data(11), read_Data(10)=>read_Data(10), read_Data(9)=>
      read_Data(9), read_Data(8)=>read_Data(8), read_Data(7)=>read_Data(7), 
      read_Data(6)=>read_Data(6), read_Data(5)=>read_Data(5), read_Data(4)=>
      read_Data(4), read_Data(3)=>read_Data(3), read_Data(2)=>read_Data(2), 
      read_Data(1)=>read_Data(1), read_Data(0)=>read_Data(0), Address(15)=>
      DANGLING(1), Address(14)=>DANGLING(2), Address(13)=>DANGLING(3), 
      Address(12)=>DANGLING(4), Address(11)=>DANGLING(5), Address(10)=>
      DANGLING(6), Address(9)=>DANGLING(7), Address(8)=>DANGLING(8), 
      Address(7)=>DANGLING(9), Address(6)=>DANGLING(10), Address(5)=>
      DANGLING(11), Address(4)=>DANGLING(12), Address(3)=>DANGLING(13), 
      Address(2)=>DANGLING(14), Address(1)=>DANGLING(15), Address(0)=>
      DANGLING(16), Data_out(15)=>DANGLING(17), Data_out(14)=>DANGLING(18), 
      Data_out(13)=>DANGLING(19), Data_out(12)=>DANGLING(20), Data_out(11)=>
      DANGLING(21), Data_out(10)=>DANGLING(22), Data_out(9)=>DANGLING(23), 
      Data_out(8)=>DANGLING(24), Data_out(7)=>DANGLING(25), Data_out(6)=>
      DANGLING(26), Data_out(5)=>DANGLING(27), Data_out(4)=>DANGLING(28), 
      Data_out(3)=>DANGLING(29), Data_out(2)=>DANGLING(30), Data_out(1)=>
      DANGLING(31), Data_out(0)=>DANGLING(32), Last_command(15)=>
      Last_command(15), Last_command(14)=>Last_command(14), Last_command(13)
      =>Last_command(13), Last_command(12)=>Last_command(12), 
      Last_command(11)=>Last_command(11), Last_command(10)=>Last_command(10), 
      Last_command(9)=>Last_command(9), Last_command(8)=>Last_command(8), 
      Last_command(7)=>Last_command(7), Last_command(6)=>Last_command(6), 
      Last_command(5)=>Last_command(5), Last_command(4)=>Last_command(4), 
      Last_command(3)=>Last_command(3), Last_command(2)=>Last_command(2), 
      Last_command(1)=>Last_command(1), Last_command(0)=>Last_command(0), 
      ResetN=>ResetN, Write=>Write);
   Dual_channel_stm : Dual_channel_stm_ver8_4_1 port map ( C=>Clock, R=>
      ResetN, CE=>CE_RT, Hila=>Revision_0_EXMPLR1877, RT_Address_valid_A=>
      RT_Address_A_valid, RT_Address_valid_B=>RT_Address_B_valid, 
      Rcv_A_Bit_number(4)=>Revision_1_EXMPLR1876, Rcv_A_Bit_number(3)=>
      Revision_1_EXMPLR1876, Rcv_A_Bit_number(2)=>Revision_1_EXMPLR1876, 
      Rcv_A_Bit_number(1)=>Revision_1_EXMPLR1876, Rcv_A_Bit_number(0)=>
      Revision_1_EXMPLR1876, Rcv_A_Response_Time(7)=>Revision_1_EXMPLR1876, 
      Rcv_A_Response_Time(6)=>Revision_1_EXMPLR1876, Rcv_A_Response_Time(5)
      =>Revision_1_EXMPLR1876, Rcv_A_Response_Time(4)=>Revision_1_EXMPLR1876, 
      Rcv_A_Response_Time(3)=>Revision_1_EXMPLR1876, Rcv_A_Response_Time(2)
      =>Revision_1_EXMPLR1876, Rcv_A_Response_Time(1)=>Revision_1_EXMPLR1876, 
      Rcv_A_Response_Time(0)=>Revision_1_EXMPLR1876, Rcv_A_Sync_error=>
      Revision_1_EXMPLR1876, Rcv_A_Manchester_error=>Revision_1_EXMPLR1876, 
      Rcv_A_Parity_error=>Revision_1_EXMPLR1876, Rcv_A_echo_back_bus=>
      Revision_1_EXMPLR1876, Rcv_A_R_Data(15)=>
      H15530_record_A_R_Data_EXMPLR1974(15), Rcv_A_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR1974(14), Rcv_A_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR1974(13), Rcv_A_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR1974(12), Rcv_A_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR1974(11), Rcv_A_R_Data(10)=>
      H15530_record_A_R_Data_EXMPLR1974(10), Rcv_A_R_Data(9)=>
      H15530_record_A_R_Data_EXMPLR1974(9), Rcv_A_R_Data(8)=>
      H15530_record_A_R_Data_EXMPLR1974(8), Rcv_A_R_Data(7)=>
      H15530_record_A_R_Data_EXMPLR1974(7), Rcv_A_R_Data(6)=>
      H15530_record_A_R_Data_EXMPLR1974(6), Rcv_A_R_Data(5)=>
      H15530_record_A_R_Data_EXMPLR1974(5), Rcv_A_R_Data(4)=>
      H15530_record_A_R_Data_EXMPLR1974(4), Rcv_A_R_Data(3)=>
      H15530_record_A_R_Data_EXMPLR1974(3), Rcv_A_R_Data(2)=>
      H15530_record_A_R_Data_EXMPLR1974(2), Rcv_A_R_Data(1)=>
      H15530_record_A_R_Data_EXMPLR1974(1), Rcv_A_R_Data(0)=>
      H15530_record_A_R_Data_EXMPLR1974(0), Rcv_A_RAW_GAP(6)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(6), Rcv_A_RAW_GAP(5)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(5), Rcv_A_RAW_GAP(4)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(4), Rcv_A_RAW_GAP(3)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(3), Rcv_A_RAW_GAP(2)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(2), Rcv_A_RAW_GAP(1)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(1), Rcv_A_RAW_GAP(0)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(0), Rcv_A_GAP(6)=>
      Revision_1_EXMPLR1876, Rcv_A_GAP(5)=>Revision_1_EXMPLR1876, 
      Rcv_A_GAP(4)=>Revision_1_EXMPLR1876, Rcv_A_GAP(3)=>
      Revision_1_EXMPLR1876, Rcv_A_GAP(2)=>Revision_1_EXMPLR1876, 
      Rcv_A_GAP(1)=>Revision_1_EXMPLR1876, Rcv_A_GAP(0)=>
      Revision_1_EXMPLR1876, Rcv_A_Gap_found(2)=>
      H15530_record_A_Gap_found_EXMPLR1977(2), Rcv_A_Gap_found(1)=>
      H15530_record_A_Gap_found_EXMPLR1977(1), Rcv_A_Gap_found(0)=>
      H15530_record_A_Gap_found_EXMPLR1977(0), Rcv_A_RxRDY_plus_12us=>
      Revision_1_EXMPLR1876, Rcv_A_RxRDY_plus_10us=>
      H15530_record_A_RxRDY_plus_10us_EXMPLR1919, Rcv_A_CS=>
      H15530_record_A_CS_EXMPLR1920, Rcv_A_Pre_EchoRdy=>
      Revision_1_EXMPLR1876, Rcv_A_Command_Sync=>
      H15530_record_A_Command_Sync_EXMPLR1922, Rcv_A_Pre_RxRdy=>
      H15530_record_A_Pre_RxRdy_EXMPLR1923, Rcv_A_recieving=>
      H15530_record_A_recieving_EXMPLR1924, Rcv_B_Bit_number(4)=>
      Revision_1_EXMPLR1876, Rcv_B_Bit_number(3)=>Revision_1_EXMPLR1876, 
      Rcv_B_Bit_number(2)=>Revision_1_EXMPLR1876, Rcv_B_Bit_number(1)=>
      Revision_1_EXMPLR1876, Rcv_B_Bit_number(0)=>Revision_1_EXMPLR1876, 
      Rcv_B_Response_Time(7)=>Revision_1_EXMPLR1876, Rcv_B_Response_Time(6)
      =>Revision_1_EXMPLR1876, Rcv_B_Response_Time(5)=>Revision_1_EXMPLR1876, 
      Rcv_B_Response_Time(4)=>Revision_1_EXMPLR1876, Rcv_B_Response_Time(3)
      =>Revision_1_EXMPLR1876, Rcv_B_Response_Time(2)=>Revision_1_EXMPLR1876, 
      Rcv_B_Response_Time(1)=>Revision_1_EXMPLR1876, Rcv_B_Response_Time(0)
      =>Revision_1_EXMPLR1876, Rcv_B_Sync_error=>Revision_1_EXMPLR1876, 
      Rcv_B_Manchester_error=>Revision_1_EXMPLR1876, Rcv_B_Parity_error=>
      Revision_1_EXMPLR1876, Rcv_B_echo_back_bus=>Revision_1_EXMPLR1876, 
      Rcv_B_R_Data(15)=>H15530_record_B_R_Data_EXMPLR1978(15), 
      Rcv_B_R_Data(14)=>H15530_record_B_R_Data_EXMPLR1978(14), 
      Rcv_B_R_Data(13)=>H15530_record_B_R_Data_EXMPLR1978(13), 
      Rcv_B_R_Data(12)=>H15530_record_B_R_Data_EXMPLR1978(12), 
      Rcv_B_R_Data(11)=>H15530_record_B_R_Data_EXMPLR1978(11), 
      Rcv_B_R_Data(10)=>H15530_record_B_R_Data_EXMPLR1978(10), 
      Rcv_B_R_Data(9)=>H15530_record_B_R_Data_EXMPLR1978(9), Rcv_B_R_Data(8)
      =>H15530_record_B_R_Data_EXMPLR1978(8), Rcv_B_R_Data(7)=>
      H15530_record_B_R_Data_EXMPLR1978(7), Rcv_B_R_Data(6)=>
      H15530_record_B_R_Data_EXMPLR1978(6), Rcv_B_R_Data(5)=>
      H15530_record_B_R_Data_EXMPLR1978(5), Rcv_B_R_Data(4)=>
      H15530_record_B_R_Data_EXMPLR1978(4), Rcv_B_R_Data(3)=>
      H15530_record_B_R_Data_EXMPLR1978(3), Rcv_B_R_Data(2)=>
      H15530_record_B_R_Data_EXMPLR1978(2), Rcv_B_R_Data(1)=>
      H15530_record_B_R_Data_EXMPLR1978(1), Rcv_B_R_Data(0)=>
      H15530_record_B_R_Data_EXMPLR1978(0), Rcv_B_RAW_GAP(6)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(6), Rcv_B_RAW_GAP(5)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(5), Rcv_B_RAW_GAP(4)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(4), Rcv_B_RAW_GAP(3)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(3), Rcv_B_RAW_GAP(2)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(2), Rcv_B_RAW_GAP(1)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(1), Rcv_B_RAW_GAP(0)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(0), Rcv_B_GAP(6)=>
      Revision_1_EXMPLR1876, Rcv_B_GAP(5)=>Revision_1_EXMPLR1876, 
      Rcv_B_GAP(4)=>Revision_1_EXMPLR1876, Rcv_B_GAP(3)=>
      Revision_1_EXMPLR1876, Rcv_B_GAP(2)=>Revision_1_EXMPLR1876, 
      Rcv_B_GAP(1)=>Revision_1_EXMPLR1876, Rcv_B_GAP(0)=>
      Revision_1_EXMPLR1876, Rcv_B_Gap_found(2)=>
      H15530_record_B_Gap_found_EXMPLR1981(2), Rcv_B_Gap_found(1)=>
      H15530_record_B_Gap_found_EXMPLR1981(1), Rcv_B_Gap_found(0)=>
      H15530_record_B_Gap_found_EXMPLR1981(0), Rcv_B_RxRDY_plus_12us=>
      Revision_1_EXMPLR1876, Rcv_B_RxRDY_plus_10us=>
      H15530_record_B_RxRDY_plus_10us_EXMPLR1958, Rcv_B_CS=>
      H15530_record_B_CS_EXMPLR1959, Rcv_B_Pre_EchoRdy=>
      Revision_1_EXMPLR1876, Rcv_B_Command_Sync=>
      H15530_record_B_Command_Sync_EXMPLR1961, Rcv_B_Pre_RxRdy=>
      H15530_record_B_Pre_RxRdy_EXMPLR1962, Rcv_B_recieving=>
      H15530_record_B_recieving_EXMPLR1963, No_Response_timeout(2)=>
      No_Response_timeout(2), No_Response_timeout(1)=>No_Response_timeout(1), 
      No_Response_timeout(0)=>No_Response_timeout(0), TxRdy=>
      BC_TxRdy_EXMPLR1800, Active_Bus_A=>BUS_A_EXMPLR1801, Transmit_data(15)
      =>RT_Transmit_data(15), Transmit_data(14)=>RT_Transmit_data(14), 
      Transmit_data(13)=>RT_Transmit_data(13), Transmit_data(12)=>
      RT_Transmit_data(12), Transmit_data(11)=>RT_Transmit_data(11), 
      Transmit_data(10)=>RT_Transmit_data(10), Transmit_data(9)=>
      RT_Transmit_data(9), Transmit_data(8)=>RT_Transmit_data(8), 
      Transmit_data(7)=>RT_Transmit_data(7), Transmit_data(6)=>
      RT_Transmit_data(6), Transmit_data(5)=>RT_Transmit_data(5), 
      Transmit_data(4)=>RT_Transmit_data(4), Transmit_data(3)=>
      RT_Transmit_data(3), Transmit_data(2)=>RT_Transmit_data(2), 
      Transmit_data(1)=>RT_Transmit_data(1), Transmit_data(0)=>
      RT_Transmit_data(0), T_Sync=>RT_T_Sync, Go=>RT_Go, end_of_tx=>
      end_of_tx, Bus_A_shut_down=>Bus_A_shut_down, Bus_B_shut_down=>
      Bus_B_shut_down, Address(15)=>DANGLING(33), Address(14)=>DANGLING(34), 
      Address(13)=>DANGLING(35), Address(12)=>DANGLING(36), Address(11)=>
      DANGLING(37), Address(10)=>Address(10), Address(9)=>
      Address_9_EXMPLR1790, Address(8)=>Address_8_EXMPLR1791, Address(7)=>
      Address_7_EXMPLR1792, Address(6)=>Address_6_EXMPLR1793, Address(5)=>
      Address_5_EXMPLR1794, Address(4)=>Address_4_EXMPLR1795, Address(3)=>
      Address_3_EXMPLR1796, Address(2)=>Address_2_EXMPLR1797, Address(1)=>
      Address_1_EXMPLR1798, Address(0)=>Address_0_EXMPLR1799, 
      reset_remote_terminal_received=>reset_RT_received_A, Inhibit_TF=>
      Inhibit_TF_A, active_command(15)=>Current_command_EXMPLR1970(15), 
      active_command(14)=>Current_command_EXMPLR1970(14), active_command(13)
      =>Current_command_EXMPLR1970(13), active_command(12)=>
      Current_command_EXMPLR1970(12), active_command(11)=>
      Current_command_EXMPLR1970(11), active_command(10)=>
      Current_command_EXMPLR1970(10), active_command(9)=>
      Current_command_EXMPLR1970(9), active_command(8)=>
      Current_command_EXMPLR1970(8), active_command(7)=>
      Current_command_EXMPLR1970(7), active_command(6)=>
      Current_command_EXMPLR1970(6), active_command(5)=>
      Current_command_EXMPLR1970(5), active_command(4)=>
      Current_command_EXMPLR1970(4), active_command(3)=>
      Current_command_EXMPLR1970(3), active_command(2)=>
      Current_command_EXMPLR1970(2), active_command(1)=>
      Current_command_EXMPLR1970(1), active_command(0)=>
      Current_command_EXMPLR1970(0), illegal_command=>illegal_command, 
      Do_illegal=>Do_illegal, Active_command_updated=>Active_command_updated, 
      Message_ended_OK=>Message_ended_OK_EXMPLR1851, Message_ended_not_OK=>
      Message_ended_not_OK, Valid_command=>New_Command_EXMPLR1852, Write_Req
      =>Write_Req_A, Write_Data(15)=>Data_out(15), Write_Data(14)=>
      Data_out(14), Write_Data(13)=>Data_out(13), Write_Data(12)=>
      Data_out(12), Write_Data(11)=>Data_out(11), Write_Data(10)=>
      Data_out(10), Write_Data(9)=>Data_out(9), Write_Data(8)=>Data_out(8), 
      Write_Data(7)=>Data_out(7), Write_Data(6)=>Data_out(6), Write_Data(5)
      =>Data_out(5), Write_Data(4)=>Data_out(4), Write_Data(3)=>Data_out(3), 
      Write_Data(2)=>Data_out(2), Write_Data(1)=>Data_out(1), Write_Data(0)
      =>Data_out(0), Write_Ack=>Write_Ack_A, read_Req=>read_Req_A, 
      read_Data(15)=>read_Data(15), read_Data(14)=>read_Data(14), 
      read_Data(13)=>read_Data(13), read_Data(12)=>read_Data(12), 
      read_Data(11)=>read_Data(11), read_Data(10)=>read_Data(10), 
      read_Data(9)=>read_Data(9), read_Data(8)=>read_Data(8), read_Data(7)=>
      read_Data(7), read_Data(6)=>read_Data(6), read_Data(5)=>read_Data(5), 
      read_Data(4)=>read_Data(4), read_Data(3)=>read_Data(3), read_Data(2)=>
      read_Data(2), read_Data(1)=>read_Data(1), read_Data(0)=>read_Data(0), 
      read_Ack=>read_Ack_A, Channel_status_out(10)=>Bus_Channel_status_10, 
      Channel_status_out(9)=>DANGLING(38), Channel_status_out(8)=>DANGLING(
      39), Channel_status_out(7)=>DANGLING(40), Channel_status_out(6)=>
      DANGLING(41), Channel_status_out(5)=>DANGLING(42), 
      Channel_status_out(4)=>Bus_Channel_status_4, Channel_status_out(3)=>
      DANGLING(43), Channel_status_out(2)=>DANGLING(44), 
      Channel_status_out(1)=>DANGLING(45), Channel_status_out(0)=>DANGLING(
      46), Channel_status(10)=>Channel_status_EXMPLR1973(10), 
      Channel_status(9)=>Channel_status_EXMPLR1973(9), Channel_status(8)=>
      Channel_status_EXMPLR1973(8), Channel_status(7)=>
      Channel_status_EXMPLR1973(7), Channel_status(6)=>
      Channel_status_EXMPLR1973(6), Channel_status(5)=>
      Channel_status_EXMPLR1973(5), Channel_status(4)=>
      Channel_status_EXMPLR1973(4), Channel_status(3)=>
      Channel_status_EXMPLR1973(3), Channel_status(2)=>
      Channel_status_EXMPLR1973(2), Channel_status(1)=>
      Channel_status_EXMPLR1973(1), Channel_status(0)=>
      Channel_status_EXMPLR1973(0), RT2RT_message=>RT2RT_message, NO_BCST=>
      Revision_1_EXMPLR1876, MODE_CODE1553A=>MODE_CODE1553A);
   H15530_A : H15530_Ver17_32_0 port map ( CE=>CE, Check_loop_back=>
      Check_loop_back, Check_value=>Check_value, Clock=>Clock, Minus=>
      Minus_AM, PP194_CS=>Revision_1_EXMPLR1876, Plus=>Plus_AM, ResetN=>
      H15530_ResetN, Xmitting=>Xmitting_A, Bi_error=>DANGLING(47), 
      H15530_record_Bit_number(4)=>DANGLING(48), H15530_record_Bit_number(3)
      =>DANGLING(49), H15530_record_Bit_number(2)=>DANGLING(50), 
      H15530_record_Bit_number(1)=>DANGLING(51), H15530_record_Bit_number(0)
      =>DANGLING(52), H15530_record_Response_Time(7)=>DANGLING(53), 
      H15530_record_Response_Time(6)=>DANGLING(54), 
      H15530_record_Response_Time(5)=>DANGLING(55), 
      H15530_record_Response_Time(4)=>DANGLING(56), 
      H15530_record_Response_Time(3)=>DANGLING(57), 
      H15530_record_Response_Time(2)=>DANGLING(58), 
      H15530_record_Response_Time(1)=>DANGLING(59), 
      H15530_record_Response_Time(0)=>DANGLING(60), H15530_record_Sync_error
      =>DANGLING(61), H15530_record_Manchester_error=>DANGLING(62), 
      H15530_record_Parity_error=>DANGLING(63), H15530_record_echo_back_bus
      =>DANGLING(64), H15530_record_R_Data(15)=>
      H15530_record_A_R_Data_EXMPLR1974(15), H15530_record_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR1974(14), H15530_record_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR1974(13), H15530_record_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR1974(12), H15530_record_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR1974(11), H15530_record_R_Data(10)=>
      H15530_record_A_R_Data_EXMPLR1974(10), H15530_record_R_Data(9)=>
      H15530_record_A_R_Data_EXMPLR1974(9), H15530_record_R_Data(8)=>
      H15530_record_A_R_Data_EXMPLR1974(8), H15530_record_R_Data(7)=>
      H15530_record_A_R_Data_EXMPLR1974(7), H15530_record_R_Data(6)=>
      H15530_record_A_R_Data_EXMPLR1974(6), H15530_record_R_Data(5)=>
      H15530_record_A_R_Data_EXMPLR1974(5), H15530_record_R_Data(4)=>
      H15530_record_A_R_Data_EXMPLR1974(4), H15530_record_R_Data(3)=>
      H15530_record_A_R_Data_EXMPLR1974(3), H15530_record_R_Data(2)=>
      H15530_record_A_R_Data_EXMPLR1974(2), H15530_record_R_Data(1)=>
      H15530_record_A_R_Data_EXMPLR1974(1), H15530_record_R_Data(0)=>
      H15530_record_A_R_Data_EXMPLR1974(0), H15530_record_RAW_GAP(6)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(6), H15530_record_RAW_GAP(5)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(5), H15530_record_RAW_GAP(4)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(4), H15530_record_RAW_GAP(3)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(3), H15530_record_RAW_GAP(2)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(2), H15530_record_RAW_GAP(1)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(1), H15530_record_RAW_GAP(0)=>
      H15530_record_A_RAW_GAP_EXMPLR1975(0), H15530_record_GAP(6)=>
      H15530_record_A_GAP(6), H15530_record_GAP(5)=>H15530_record_A_GAP(5), 
      H15530_record_GAP(4)=>H15530_record_A_GAP(4), H15530_record_GAP(3)=>
      H15530_record_A_GAP(3), H15530_record_GAP(2)=>H15530_record_A_GAP(2), 
      H15530_record_GAP(1)=>H15530_record_A_GAP(1), H15530_record_GAP(0)=>
      H15530_record_A_GAP(0), H15530_record_Gap_found(2)=>
      H15530_record_A_Gap_found_EXMPLR1977(2), H15530_record_Gap_found(1)=>
      H15530_record_A_Gap_found_EXMPLR1977(1), H15530_record_Gap_found(0)=>
      H15530_record_A_Gap_found_EXMPLR1977(0), H15530_record_RxRDY_plus_12us
      =>DANGLING(65), H15530_record_RxRDY_plus_10us=>
      H15530_record_A_RxRDY_plus_10us_EXMPLR1919, H15530_record_CS=>
      H15530_record_A_CS_EXMPLR1920, H15530_record_Pre_EchoRdy=>
      H15530_record_A_Pre_EchoRdy, H15530_record_Command_Sync=>
      H15530_record_A_Command_Sync_EXMPLR1922, H15530_record_Pre_RxRdy=>
      H15530_record_A_Pre_RxRdy_EXMPLR1923, H15530_record_recieving=>
      H15530_record_A_recieving_EXMPLR1924, Echo_Error=>Echo_Error_A, 
      Parity_error=>DANGLING(66), Sync_error=>RCV_A_Sync_error);
   H15530_B : H15530_Ver17_32_0 port map ( CE=>CE, Check_loop_back=>
      Check_loop_back, Check_value=>Check_value, Clock=>Clock, Minus=>
      Minus_BM, PP194_CS=>Revision_1_EXMPLR1876, Plus=>Plus_BM, ResetN=>
      H15530_ResetN, Xmitting=>Xmitting_B, Bi_error=>DANGLING(67), 
      H15530_record_Bit_number(4)=>DANGLING(68), H15530_record_Bit_number(3)
      =>DANGLING(69), H15530_record_Bit_number(2)=>DANGLING(70), 
      H15530_record_Bit_number(1)=>DANGLING(71), H15530_record_Bit_number(0)
      =>DANGLING(72), H15530_record_Response_Time(7)=>DANGLING(73), 
      H15530_record_Response_Time(6)=>DANGLING(74), 
      H15530_record_Response_Time(5)=>DANGLING(75), 
      H15530_record_Response_Time(4)=>DANGLING(76), 
      H15530_record_Response_Time(3)=>DANGLING(77), 
      H15530_record_Response_Time(2)=>DANGLING(78), 
      H15530_record_Response_Time(1)=>DANGLING(79), 
      H15530_record_Response_Time(0)=>DANGLING(80), H15530_record_Sync_error
      =>DANGLING(81), H15530_record_Manchester_error=>DANGLING(82), 
      H15530_record_Parity_error=>DANGLING(83), H15530_record_echo_back_bus
      =>DANGLING(84), H15530_record_R_Data(15)=>
      H15530_record_B_R_Data_EXMPLR1978(15), H15530_record_R_Data(14)=>
      H15530_record_B_R_Data_EXMPLR1978(14), H15530_record_R_Data(13)=>
      H15530_record_B_R_Data_EXMPLR1978(13), H15530_record_R_Data(12)=>
      H15530_record_B_R_Data_EXMPLR1978(12), H15530_record_R_Data(11)=>
      H15530_record_B_R_Data_EXMPLR1978(11), H15530_record_R_Data(10)=>
      H15530_record_B_R_Data_EXMPLR1978(10), H15530_record_R_Data(9)=>
      H15530_record_B_R_Data_EXMPLR1978(9), H15530_record_R_Data(8)=>
      H15530_record_B_R_Data_EXMPLR1978(8), H15530_record_R_Data(7)=>
      H15530_record_B_R_Data_EXMPLR1978(7), H15530_record_R_Data(6)=>
      H15530_record_B_R_Data_EXMPLR1978(6), H15530_record_R_Data(5)=>
      H15530_record_B_R_Data_EXMPLR1978(5), H15530_record_R_Data(4)=>
      H15530_record_B_R_Data_EXMPLR1978(4), H15530_record_R_Data(3)=>
      H15530_record_B_R_Data_EXMPLR1978(3), H15530_record_R_Data(2)=>
      H15530_record_B_R_Data_EXMPLR1978(2), H15530_record_R_Data(1)=>
      H15530_record_B_R_Data_EXMPLR1978(1), H15530_record_R_Data(0)=>
      H15530_record_B_R_Data_EXMPLR1978(0), H15530_record_RAW_GAP(6)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(6), H15530_record_RAW_GAP(5)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(5), H15530_record_RAW_GAP(4)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(4), H15530_record_RAW_GAP(3)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(3), H15530_record_RAW_GAP(2)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(2), H15530_record_RAW_GAP(1)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(1), H15530_record_RAW_GAP(0)=>
      H15530_record_B_RAW_GAP_EXMPLR1979(0), H15530_record_GAP(6)=>
      H15530_record_B_GAP(6), H15530_record_GAP(5)=>H15530_record_B_GAP(5), 
      H15530_record_GAP(4)=>H15530_record_B_GAP(4), H15530_record_GAP(3)=>
      H15530_record_B_GAP(3), H15530_record_GAP(2)=>H15530_record_B_GAP(2), 
      H15530_record_GAP(1)=>H15530_record_B_GAP(1), H15530_record_GAP(0)=>
      H15530_record_B_GAP(0), H15530_record_Gap_found(2)=>
      H15530_record_B_Gap_found_EXMPLR1981(2), H15530_record_Gap_found(1)=>
      H15530_record_B_Gap_found_EXMPLR1981(1), H15530_record_Gap_found(0)=>
      H15530_record_B_Gap_found_EXMPLR1981(0), H15530_record_RxRDY_plus_12us
      =>DANGLING(85), H15530_record_RxRDY_plus_10us=>
      H15530_record_B_RxRDY_plus_10us_EXMPLR1958, H15530_record_CS=>
      H15530_record_B_CS_EXMPLR1959, H15530_record_Pre_EchoRdy=>
      H15530_record_B_Pre_EchoRdy, H15530_record_Command_Sync=>
      H15530_record_B_Command_Sync_EXMPLR1961, H15530_record_Pre_RxRdy=>
      H15530_record_B_Pre_RxRdy_EXMPLR1962, H15530_record_recieving=>
      H15530_record_B_recieving_EXMPLR1963, Echo_Error=>Echo_Error_B, 
      Parity_error=>DANGLING(86), Sync_error=>RCV_B_Sync_error);
   I3 : single_Transmitter_FS_ver65_32 port map ( Clock=>Clock, ResetN=>
      ResetN, CE=>CE, T_data(15)=>Transmit_data(15), T_data(14)=>
      Transmit_data(14), T_data(13)=>Transmit_data(13), T_data(12)=>
      Transmit_data(12), T_data(11)=>Transmit_data(11), T_data(10)=>
      Transmit_data(10), T_data(9)=>Transmit_data(9), T_data(8)=>
      Transmit_data(8), T_data(7)=>Transmit_data(7), T_data(6)=>
      Transmit_data(6), T_data(5)=>Transmit_data(5), T_data(4)=>
      Transmit_data(4), T_data(3)=>Transmit_data(3), T_data(2)=>
      Transmit_data(2), T_data(1)=>Transmit_data(1), T_data(0)=>
      Transmit_data(0), T_Sync=>T_Sync, ENC_TEST_On=>ENC_TEST_On, Go=>Go, 
      Bus_A=>Active_Bus_A, TxRdy=>BC_TxRdy_EXMPLR1800, Tx_A=>Tx_A1, Tx_A_N=>
      Tx_A_N1, Tx_B=>Tx_B1, Tx_B_N=>Tx_B_N1, Valid_command=>fail_safe_reset, 
      BC_Mode=>BC_mode, end_of_tx=>end_of_tx, Tx_A_inhibit=>Tx_A_inhibit, 
      Tx_B_inhibit=>Tx_B_inhibit, Xmitting_A=>Xmitting_A, Xmitting_B=>
      Xmitting_B, Check_loop_back=>Check_loop_back, Check_value=>Check_value, 
      Tx_inhibit_fail_safe=>transmitter_timeout);
   CE_RT <= CE AND RT_On ;
   Channel_status_EXMPLR1973(3) <= Channel_status1_3 OR BUSY_in_LUT ;
   rtlc3n12 <= BC_mode OR ENC_TEST_On ;
   not_loopback_test <= NOT loopback_test ;
   not_ResetN <= NOT ResetN ;
   Tx_A_15n0r1 <= Tx_A1 AND not_Tx_A_15n0r3 ;
   not_Tx_A_15n0r3 <= NOT Tx_A_15n0r3 ;
   Tx_A_15n0r3 <= Tx_A_15n0r4 OR Tx_Inh_A_in ;
   Tx_A_15n0r4 <= Tx_A_inhibit OR loopback_test ;
   Tx_A_N_19n0r1 <= Tx_A_N1 AND not_Tx_A_15n0r3 ;
   Tx_B_23n0r1 <= Tx_B1 AND not_Tx_B_23n0r3 ;
   not_Tx_B_23n0r3 <= NOT Tx_B_23n0r3 ;
   Tx_B_23n0r3 <= Tx_B_23n0r4 OR Tx_Inh_B_in ;
   Tx_B_23n0r4 <= Tx_B_inhibit OR loopback_test ;
   Tx_B_N_27n0r1 <= Tx_B_N1 AND not_Tx_B_23n0r3 ;
   H15530_ResetN_44n0r1 <= not_loopback_test OR loopback_test_D ;
   not_rtlc52n66 <= NOT rtlc52n66 ;
   not_rtlc52n64 <= NOT rtlc52n64 ;
   rtlc52n68 <= not_rtlc52n64 OR not_rtlc52n66 ;
   rtlc52_129_or_1013 : or_6u_6u port map ( a(5)=>One_Shot(0), a(4)=>
      One_Shot(1), a(3)=>One_Shot(2), a(2)=>One_Shot(3), a(1)=>One_Shot(4), 
      a(0)=>One_Shot(5), d=>rtlc52n285);
   rtlc52n286 <= rtlc52n285 AND One_Shot(6) ;
   rtlc52n287 <= rtlc52n284 OR rtlc52n286 ;
   rtlc52n288 <= One_Shot(9) AND rtlc52n287 ;
   rtlc52n289 <= rtlc52n288 OR rtlc52n283 ;
   rtlc52_143_or_1015 : or_5u_5u port map ( a(4)=>One_Shot(0), a(3)=>
      One_Shot(1), a(2)=>One_Shot(2), a(1)=>One_Shot(3), a(0)=>One_Shot(4), 
      d=>rtlc52n304);
   rtlc52n305 <= rtlc52n304 AND rtlc52n303 ;
   rtlc52n306 <= One_Shot(8) OR rtlc52n305 ;
   rtlc52n307 <= One_Shot(9) AND rtlc52n306 ;
   rtlc52n308 <= rtlc52n307 OR rtlc52n283 ;
   rtlc52n322 <= One_Shot(10) AND One_Shot(9) ;
   rtlc52n324 <= One_Shot(6) AND One_Shot(5) ;
   rtlc52n326 <= rtlc52n304 AND rtlc52n324 ;
   rtlc52n327 <= rtlc52n284 OR rtlc52n326 ;
   rtlc52n328 <= rtlc52n322 AND rtlc52n327 ;
   rtlc52n329 <= rtlc52n328 OR rtlc52n321 ;
   rtlc52n284 <= One_Shot(8) OR One_Shot(7) ;
   rtlc52n321 <= One_Shot(12) OR One_Shot(11) ;
   Transmit_data(0) <= BC_Transmit_data(0) when rtlc3n12 = '1' else 
   RT_Transmit_data(0) ;
   Transmit_data(1) <= BC_Transmit_data(1) when rtlc3n12 = '1' else 
   RT_Transmit_data(1) ;
   Transmit_data(2) <= BC_Transmit_data(2) when rtlc3n12 = '1' else 
   RT_Transmit_data(2) ;
   Transmit_data(3) <= BC_Transmit_data(3) when rtlc3n12 = '1' else 
   RT_Transmit_data(3) ;
   Transmit_data(4) <= BC_Transmit_data(4) when rtlc3n12 = '1' else 
   RT_Transmit_data(4) ;
   Transmit_data(5) <= BC_Transmit_data(5) when rtlc3n12 = '1' else 
   RT_Transmit_data(5) ;
   Transmit_data(6) <= BC_Transmit_data(6) when rtlc3n12 = '1' else 
   RT_Transmit_data(6) ;
   Transmit_data(7) <= BC_Transmit_data(7) when rtlc3n12 = '1' else 
   RT_Transmit_data(7) ;
   Transmit_data(8) <= BC_Transmit_data(8) when rtlc3n12 = '1' else 
   RT_Transmit_data(8) ;
   Transmit_data(9) <= BC_Transmit_data(9) when rtlc3n12 = '1' else 
   RT_Transmit_data(9) ;
   Transmit_data(10) <= BC_Transmit_data(10) when rtlc3n12 = '1' else 
   RT_Transmit_data(10) ;
   Transmit_data(11) <= BC_Transmit_data(11) when rtlc3n12 = '1' else 
   RT_Transmit_data(11) ;
   Transmit_data(12) <= BC_Transmit_data(12) when rtlc3n12 = '1' else 
   RT_Transmit_data(12) ;
   Transmit_data(13) <= BC_Transmit_data(13) when rtlc3n12 = '1' else 
   RT_Transmit_data(13) ;
   Transmit_data(14) <= BC_Transmit_data(14) when rtlc3n12 = '1' else 
   RT_Transmit_data(14) ;
   Transmit_data(15) <= BC_Transmit_data(15) when rtlc3n12 = '1' else 
   RT_Transmit_data(15) ;
   T_Sync <= BC_T_sync when rtlc3n12 = '1' else RT_T_Sync ;
   Go <= BC_Go when rtlc3n12 = '1' else RT_Go ;
   Active_Bus_A <= BC_Active_Bus_A when rtlc3n12 = '1' else BUS_A_EXMPLR1801
    ;
   Minus_AM <= Tx_A_N1 when loopback_test = '1' else Minus_A ;
   Plus_AM <= Tx_A1 when loopback_test = '1' else Plus_A ;
   Minus_BM <= Tx_B_N1 when loopback_test = '1' else Minus_B ;
   Plus_BM <= Tx_B1 when loopback_test = '1' else Plus_B ;
   not_rtlc3n12 <= NOT rtlc3n12 ;
   fail_safe_reset <= Active_command_updated AND not_rtlc3n12 ;
   not_One_Shot_11 <= NOT One_Shot(11) ;
   not_One_Shot_10 <= NOT One_Shot(10) ;
   not_One_Shot_9 <= NOT One_Shot(9) ;
   not_One_Shot_8 <= NOT One_Shot(8) ;
   not_One_Shot_7 <= NOT One_Shot(7) ;
   not_One_Shot_6 <= NOT One_Shot(6) ;
   not_One_Shot_5 <= NOT One_Shot(5) ;
   not_One_Shot_4 <= NOT One_Shot(4) ;
   not_One_Shot_3 <= NOT One_Shot(3) ;
   not_One_Shot_2 <= NOT One_Shot(2) ;
   not_One_Shot_1 <= NOT One_Shot(1) ;
   not_One_Shot_0 <= NOT One_Shot(0) ;
   IDLE_MORE_THAN_NO_RESPONSE_and_52i1 : and_13u_13u port map ( a(12)=>
      One_Shot(12), a(11)=>not_One_Shot_11, a(10)=>not_One_Shot_10, a(9)=>
      not_One_Shot_9, a(8)=>not_One_Shot_8, a(7)=>not_One_Shot_7, a(6)=>
      not_One_Shot_6, a(5)=>not_One_Shot_5, a(4)=>not_One_Shot_4, a(3)=>
      not_One_Shot_3, a(2)=>not_One_Shot_2, a(1)=>not_One_Shot_1, a(0)=>
      not_One_Shot_0, d=>IDLE_MORE_THAN_NO_RESPONSE_52n4s4);
   rtlc_219_mux_1017 : mux_4u_4u port map ( a(3)=>
      IDLE_MORE_THAN_NO_RESPONSE_52n4s4, a(2)=>
      IDLE_MORE_THAN_NO_RESPONSE_52n4s4, a(1)=>rtlc52n329, a(0)=>rtlc52n308, 
      b(3)=>Revision_1_EXMPLR1876, b(2)=>Revision_1_EXMPLR1876, b(1)=>
      No_Response_timeout(1), b(0)=>No_Response_timeout(0), d=>rtlcn36);
   IDLE_MORE_THAN_NO_RESPONSE_52n4ss1 <= rtlcn36 when No_Response_timeout(2)
    = '1' else rtlc52n289 ;
   not_One_Shot_12 <= NOT One_Shot(12) ;
   rtlcn40 <= not_One_Shot_12 OR any_active ;
   rtlcn42 <= CE AND rtlcn40 ;
   rtlc52n66 <= NOT (Minus_BM XOR Plus_BM) ;
   rtlc52n64 <= NOT (Minus_AM XOR Plus_AM) ;
   DFFPC (Tx_A_15n0r1,Revision_1_EXMPLR1876,not_ResetN,Clock,Tx_A) ;
   DFFPC (Tx_A_N_19n0r1,Revision_1_EXMPLR1876,not_ResetN,Clock,Tx_A_N) ;
   DFFPC (Tx_B_23n0r1,Revision_1_EXMPLR1876,not_ResetN,Clock,Tx_B) ;
   DFFPC (Tx_B_N_27n0r1,Revision_1_EXMPLR1876,not_ResetN,Clock,Tx_B_N) ;
   DFFPC (Tx_A_15n0r3,not_ResetN,Revision_1_EXMPLR1876,Clock,Tx_inh_A) ;
   DFFPC (Tx_B_23n0r3,not_ResetN,Revision_1_EXMPLR1876,Clock,Tx_inh_B) ;
   DFFPC (loopback_test,Revision_1_EXMPLR1876,not_ResetN,Clock,
   loopback_test_D) ;
   DFFPC (H15530_ResetN_44n0r1,Revision_1_EXMPLR1876,not_ResetN,Clock,
   H15530_ResetN) ;
   DFFPCE (transmitter_timeout,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_transmitter_timout) ;
   DFFPCE (Bus_A_shut_down_dt,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_bus_A_shutdown) ;
   DFFPCE (Bus_B_shut_down_dt,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_bus_B_shutdown) ;
   DFFPCE (Echo_Error_A,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_echo_back_bus_A) ;
   DFFPCE (Echo_Error_B,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_echo_back_bus_B) ;
   DFFPCE (Channel_status_10_dt,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_Message_Error_set) ;
   DFFPCE (ME_DvDt,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_Format_error) ;
   DFFPCE (Inhibit_TF_A_dt,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,
   mil1553_errors_Inhibit_TF) ;
   DFFPCE (IDLE_MORE_THAN_NO_RESPONSE_52n4ss1,not_ResetN,
   Revision_1_EXMPLR1876,CE,Clock,IDLE_MORE_THAN_NO_RESPONSE) ;
   DFFPCE (rtlc52n68,Revision_1_EXMPLR1876,not_ResetN,CE,Clock,any_active) ;
   DFFPCE (rtlcn41(0),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(0)) ;
   DFFPCE (rtlcn41(1),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(1)) ;
   DFFPCE (rtlcn41(2),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(2)) ;
   DFFPCE (rtlcn41(3),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(3)) ;
   DFFPCE (rtlcn41(4),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(4)) ;
   DFFPCE (rtlcn41(5),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(5)) ;
   DFFPCE (rtlcn41(6),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(6)) ;
   DFFPCE (rtlcn41(7),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(7)) ;
   DFFPCE (rtlcn41(8),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(8)) ;
   DFFPCE (rtlcn41(9),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(9)) ;
   DFFPCE (rtlcn41(10),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(10)) ;
   DFFPCE (rtlcn41(11),Revision_1_EXMPLR1876,not_ResetN,rtlcn42,Clock,
   One_Shot(11)) ;
   DFFPCE (rtlcn41(12),not_ResetN,Revision_1_EXMPLR1876,rtlcn42,Clock,
   One_Shot(12)) ;
   Channel_status_10_dt <= Channel_status_EXMPLR1973(10) AND I7_not_I_d ;
   I7_not_I_d <= NOT I7_I_d ;
   DFFPCE (Channel_status_EXMPLR1973(10),Revision_1_EXMPLR1876,not_ResetN,
   CE_RT,Clock,I7_I_d) ;
   Bus_A_shut_down_dt <= Bus_A_shut_down AND I8_not_I_d ;
   I8_not_I_d <= NOT I8_I_d ;
   DFFPCE (Bus_A_shut_down,Revision_1_EXMPLR1876,not_ResetN,CE_RT,Clock,
   I8_I_d) ;
   Bus_B_shut_down_dt <= Bus_B_shut_down AND I9_not_I_d ;
   I9_not_I_d <= NOT I9_I_d ;
   DFFPCE (Bus_B_shut_down,Revision_1_EXMPLR1876,not_ResetN,CE_RT,Clock,
   I9_I_d) ;
   Inhibit_TF_A_dt <= Inhibit_TF_A AND I10_not_I_d ;
   I10_not_I_d <= NOT I10_I_d ;
   DFFPCE (Inhibit_TF_A,Revision_1_EXMPLR1876,not_ResetN,CE_RT,Clock,I10_I_d
   ) ;
   ME_DvDt <= Bus_Channel_status_10 AND I11_not_I_d ;
   I11_not_I_d <= NOT I11_I_d ;
   DFFPCE (Bus_Channel_status_10,Revision_1_EXMPLR1876,not_ResetN,CE_RT,
   Clock,I11_I_d) ;
   rtlc52_127_or_1012_nx0 <= One_Shot(10) OR One_Shot(11) ;
   rtlc52n283 <= rtlc52_127_or_1012_nx0 OR One_Shot(12) ;
   rtlc52_142_and_1014_nx0 <= One_Shot(7) AND One_Shot(6) ;
   rtlc52n303 <= rtlc52_142_and_1014_nx0 AND One_Shot(5) ;
   ix5 : selcounter_13_13_13_0_1_up port map ( cin=>Revision_0_EXMPLR1877, 
      mode=>any_active, updn=>Revision_0_EXMPLR1877, a(12)=>One_Shot(12), 
      a(11)=>One_Shot(11), a(10)=>One_Shot(10), a(9)=>One_Shot(9), a(8)=>
      One_Shot(8), a(7)=>One_Shot(7), a(6)=>One_Shot(6), a(5)=>One_Shot(5), 
      a(4)=>One_Shot(4), a(3)=>One_Shot(3), a(2)=>One_Shot(2), a(1)=>
      One_Shot(1), a(0)=>One_Shot(0), k(12)=>Revision_1_EXMPLR1876, k(11)=>
      Revision_1_EXMPLR1876, k(10)=>Revision_1_EXMPLR1876, k(9)=>
      Revision_1_EXMPLR1876, k(8)=>Revision_1_EXMPLR1876, k(7)=>
      Revision_1_EXMPLR1876, k(6)=>Revision_1_EXMPLR1876, k(5)=>
      Revision_1_EXMPLR1876, k(4)=>Revision_1_EXMPLR1876, k(3)=>
      Revision_1_EXMPLR1876, k(2)=>Revision_1_EXMPLR1876, k(1)=>
      Revision_1_EXMPLR1876, k(0)=>Revision_1_EXMPLR1876, d(12)=>rtlcn41(12), 
      d(11)=>rtlcn41(11), d(10)=>rtlcn41(10), d(9)=>rtlcn41(9), d(8)=>
      rtlcn41(8), d(7)=>rtlcn41(7), d(6)=>rtlcn41(6), d(5)=>rtlcn41(5), d(4)
      =>rtlcn41(4), d(3)=>rtlcn41(3), d(2)=>rtlcn41(2), d(1)=>rtlcn41(1), 
      d(0)=>rtlcn41(0));
end Sital_Ofer_hofman_unfold_2696 ;


architecture INTERFACE of counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_10u_10u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic_vector (9 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx25, nx28, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, 
      nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, PWR, 
      NOT_nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(9) <= nx32 ;
   q(8) <= nx34 ;
   q(7) <= nx36 ;
   q(6) <= nx38 ;
   q(5) <= nx40 ;
   q(4) <= nx42 ;
   q(3) <= nx44 ;
   q(2) <= nx46 ;
   q(1) <= nx48 ;
   q(0) <= nx50 ;
   GND <= '0' ;
   nx25 <= cnt_en OR sclear ;
   nx28 <= nx25 AND clk_en ;
   DFFPCE (nx31,GND,aclear,nx28,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx28,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx28,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx28,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,nx28,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,nx28,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,nx28,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,nx28,clock,nx46) ;
   DFFPCE (nx47,GND,aclear,nx28,clock,nx48) ;
   DFFPCE (nx49,GND,aclear,nx28,clock,nx50) ;
   inc : inc_10u_10u_0_0 port map ( cin=>PWR, a(9)=>nx32, a(8)=>nx34, a(7)=>
      nx36, a(6)=>nx38, a(5)=>nx40, a(4)=>nx42, a(3)=>nx44, a(2)=>nx46, a(1)
      =>nx48, a(0)=>nx50, d(9)=>nx51, d(8)=>nx52, d(7)=>nx53, d(6)=>nx54, 
      d(5)=>nx55, d(4)=>nx56, d(3)=>nx57, d(2)=>nx58, d(1)=>nx59, d(0)=>nx60, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx24 <= NOT sclear ;
   nx31 <= nx51 AND NOT_nx24 ;
   nx33 <= nx52 AND NOT_nx24 ;
   nx35 <= nx53 AND NOT_nx24 ;
   nx37 <= nx54 AND NOT_nx24 ;
   nx39 <= nx55 AND NOT_nx24 ;
   nx41 <= nx56 AND NOT_nx24 ;
   nx43 <= nx57 AND NOT_nx24 ;
   nx45 <= nx58 AND NOT_nx24 ;
   nx47 <= nx59 AND NOT_nx24 ;
   nx49 <= nx60 AND NOT_nx24 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Monitor_Stm_8_4_1_32 is 
   port (
      C : IN std_logic ;
      R : IN std_logic ;
      yossy : IN std_logic ;
      CE : IN std_logic ;
      Sync_Error : IN std_logic ;
      RCV_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      RCV_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      RCV_Sync_error : IN std_logic ;
      RCV_Manchester_error : IN std_logic ;
      RCV_Parity_error : IN std_logic ;
      RCV_echo_back_bus : IN std_logic ;
      RCV_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      RCV_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_RxRDY_plus_12us : IN std_logic ;
      RCV_RxRDY_plus_10us : IN std_logic ;
      RCV_CS : IN std_logic ;
      RCV_Pre_EchoRdy : IN std_logic ;
      RCV_Command_Sync : IN std_logic ;
      RCV_Pre_RxRdy : IN std_logic ;
      RCV_recieving : IN std_logic ;
      No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
      Address : OUT std_logic_vector (15 DOWNTO 0) ;
      active_command : OUT std_logic_vector (15 DOWNTO 0) ;
      new_command : OUT std_logic ;
      Record_command : IN std_logic ;
      Monitor_ended_OK : OUT std_logic ;
      Monitor_ended_not_OK : OUT std_logic ;
      RT2RT_message : OUT std_logic ;
      Write_Req : OUT std_logic ;
      Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      MIL1553_ERRORS_Inhibit_TF : OUT std_logic ;
      MIL1553_ERRORS_invalid_command : OUT std_logic ;
      MIL1553_ERRORS_RT2RT_format_gap : OUT std_logic ;
      MIL1553_ERRORS_RT2RT_format_error : OUT std_logic ;
      MIL1553_ERRORS_Invalid_word : OUT std_logic ;
      MIL1553_ERRORS_Parity_Manchester : OUT std_logic ;
      MIL1553_ERRORS_incorrect_data_sync : OUT std_logic ;
      MIL1553_ERRORS_Low_word_count : OUT std_logic ;
      MIL1553_ERRORS_high_word_count : OUT std_logic ;
      MIL1553_ERRORS_Format_error : OUT std_logic ;
      MIL1553_ERRORS_Message_Error_set : OUT std_logic ;
      MIL1553_ERRORS_Address_Parity : OUT std_logic ;
      MIL1553_ERRORS_echo_back_bus_B : OUT std_logic ;
      MIL1553_ERRORS_echo_back_bus_A : OUT std_logic ;
      MIL1553_ERRORS_bus_B_shutdown : OUT std_logic ;
      MIL1553_ERRORS_bus_A_shutdown : OUT std_logic ;
      MIL1553_ERRORS_transmitter_timout : OUT std_logic ;
      Debug : OUT std_logic_vector (15 DOWNTO 0) ;
      Tx_command_time : OUT std_logic ;
      last_data_time : OUT std_logic ;
      MODE_CODE1553A : IN std_logic ;
      NO_BCST : IN std_logic) ;
end Monitor_Stm_8_4_1_32 ;

architecture SITAL_Technology_unfold_1 of Monitor_Stm_8_4_1_32 is 
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_5_5
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_6_6
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_9_9
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         b : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_13u_13u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic_vector (12 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_7_7
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         b : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (9 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (9 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component eq_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_Energy_Count : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10(INTERFACE);
   signal active_command_15_EXMPLR1989, active_command_14_EXMPLR1990, 
      active_command_13_EXMPLR1991, active_command_12_EXMPLR1992, 
      active_command_11_EXMPLR1993, active_command_10_EXMPLR1994, 
      active_command_4_EXMPLR2000, active_command_3_EXMPLR2001, 
      active_command_2_EXMPLR2002, active_command_1_EXMPLR2003, 
      active_command_0_EXMPLR2004, RT2RT_message_EXMPLR2009, Start_Clean, 
      mode_message: std_logic ;
   
   signal first_RT_command: std_logic_vector (15 DOWNTO 11) ;
   
   signal Word_number: std_logic_vector (4 DOWNTO 0) ;
   
   signal RxRdy, Timeout, Error_in_message, GOOD_Data_Block, 
      No_Words_Message: std_logic ;
   
   signal Energy_Count: std_logic_vector (9 DOWNTO 0) ;
   
   signal counter: std_logic_vector (12 DOWNTO 0) ;
   
   signal RxRdy_Plus3us, RxRdy_Plus_2us, RxRdy_Plus4_5us, Counter_is_21us, 
      Counter_is_37us: std_logic ;
   
   signal state: std_logic_vector (8 DOWNTO 0) ;
   
   signal PWR, BCR_message_0n0s2, Address_6_EXMPLR2028, not_R, rtlc3n59, 
      rtlc6n36, not_Energy_Count_9, rtlc6n159, rtlc6n161, not_rtlcn205, 
      rtlc6n164: std_logic ;
   
   signal MIL1553_ERRORS_9n17ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n22ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n51ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal active_command_9n55ss1_4, Monitor_ended_OK_9n55ss1, 
      Monitor_ended_not_OK_9n55ss1: std_logic ;
   
   signal Word_number_9n55ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n55ss1_11, MIL1553_ERRORS_9n55ss1_8, 
      MIL1553_ERRORS_9n55ss1_7, MIL1553_ERRORS_9n55ss1_6, 
      MIL1553_ERRORS_9n55ss1_4, MIL1553_ERRORS_9n55ss1_3, 
      MIL1553_ERRORS_9n55ss1_2, MIL1553_ERRORS_9n55ss1_0, 
      GOOD_Data_Block_9n55ss1, No_Words_Message_9n55ss1, Start_Clean_9n55ss1
   : std_logic ;
   
   signal counter_9n59ss1: std_logic_vector (12 DOWNTO 0) ;
   
   signal rtlc9n3352, not_rtlcs26, rtlc9n3360, not_MODE_CODE1553A, 
      mode_message_9n8s2, mode_message_9n8s1, rtlc9n3541, not_rtlc9n3541: 
   std_logic ;
   
   signal Word_number_9n30s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc9n3696, rtlc9n3700, rtlc9n3710, rtlc9n3737, not_rtlc9n3737, 
      rtlc9n3871, rtlc9n3880, rtlc9n3883, rtlc9n3896, rtlc9n3898, rtlc9n3914, 
      rtlc9n3916, not_RCV_recieving, not_rtlcn204, rtlc9n4008, rtlc9n4010, 
      rtlc9n4011, not_rtlcs38, rtlc9n4035, rtlc9n4040, rtlc9n4041, 
      rtlc9n4042, rtlc9n4072, rtlc9n4073, rtlc9n4075, rtlc9n4077, rtlc9n4083, 
      rtlc9n4086, rtlc9n4091, rtlc9n4092, rtlc9n4101, not_active_command_4, 
      rtlc9n4112, rtlc9n4113, not_RT2RT_message, not_rtlc9n4113, rtlc9n4130, 
      rtlc9n4132, rtlc9n4134, rtlc9n4140, rtlc9n4142, rtlc9n4154, 
      not_rtlcn1798, rtlc9n4181, rtlc9n4186, rtlc9n4189, rtlc9n4191, 
      rtlc9n4198, rtlc9n4200, rtlc9n4207, rtlc9n4209, rtlc9n4211, rtlc9n4212, 
      rtlc9n4213, rtlc9n4214, rtlc9n4216, rtlc9n4218, rtlc9n4219, rtlc9n4230, 
      rtlc9n4233, rtlc9n4235, rtlc9n4236, rtlc9n4239, rtlc9n4243, rtlc9n4245, 
      rtlc9n4248, rtlc9n4249, rtlc9n4254, rtlc9n4257, rtlc9n4265, rtlc9n4266, 
      rtlc9n4269, rtlc9n4270, rtlc9n4271, rtlc9n4282, rtlc9n4284, rtlc9n4285, 
      rtlc9n4286, rtlc9n4288, rtlc9n4289, rtlc9n4290, rtlc9n4291, rtlc9n4292, 
      rtlc9n4294, rtlc9_PS245_n4342, rtlc9_PS247_n4356, 
      not_No_Response_timeout_2, rtlc9_PS248_n4369, 
      not_No_Response_timeout_0, not_No_Response_timeout_1: std_logic ;
   
   signal counter_9n56s1: std_logic_vector (12 DOWNTO 0) ;
   
   signal RxRdy_Plus3us_9n59s1, RxRdy_Plus_2us_9n59s1, 
      RxRdy_Plus4_5us_9n59s1, not_RxRdy, Counter_is_21us_9n59s1, 
      Counter_is_37us_9n59s1, rtlc9n4826, not_rtlc9n5039, not_rtlc9n4908, 
      rtlc9n4906, rtlc9n4908, rtlc9n4936, rtlc9n4955, rtlc9n4958, rtlc9n4963, 
      rtlc9n4970, rtlc9n4972, rtlc9n4973, rtlc9n4974, rtlc9n4976, rtlc9n4977, 
      rtlc9n4978, rtlc9n4981, rtlc9n4987, rtlc9n4989, rtlc9n5019, rtlc9n5026, 
      not_rtlcn2041, rtlc9n5039, rtlc9n5043, not_rtlc9n5043, rtlc9n5047, 
      rtlc9n5051, not_rtlc9n5051, mode_message_9n1s3, mode_message_9n1s5, 
      not_mode_message_9n1s5, rtlc9n867, not_mode_message_9n1s3, rtlc9n875, 
      rtlc9n876, not_RCV_R_Data_4, rtlc9n903, rtlc9n904, not_counter_12, 
      rtlc9n5572, not_rtlc9n5572, not_counter_9, not_counter_8, 
      not_counter_7, rtlc9n5577, rtlc9n5578, rtlc9n5579, rtlc9n5580, 
      rtlc9n5597, not_rtlc9n5597, not_counter_10, not_rtlcn198, rtlc9n5604, 
      not_rtlc9n5625, not_rtlcn200, rtlc9n5631, rtlc9n5632, rtlc9n5633, 
      rtlc9n5656, not_rtlcn199, rtlc9n5660, rtlc9n5661, rtlc9n5662, 
      not_counter_11, rtlc9n5680, not_rtlc9n5680, rtlc9n5687, rtlc9n5688, 
      rtlc9n5757, rtlc9n5770, rtlc9n5771, rtlc9n5800, rtlc9n5801, rtlc9n5802, 
      rtlc9n5803, rtlcn198, rtlcn199, rtlcn200, rtlcn204, rtlcn205, rtlcn324, 
      rtlcn361, rtlcn381, rtlcn383, rtlcn384, rtlcn386, rtlcn387, rtlcn388, 
      rtlcn389, rtlcn390, rtlcn391, rtlcn394, rtlcn397, rtlcn461, rtlcn663, 
      rtlcn674, rtlcn676, rtlcn762, rtlcn841, rtlcn881, rtlcn887, rtlcn890, 
      rtlcn1038, rtlcn1135, rtlcn1144, rtlcn1173, rtlcn1176, rtlcn1178, 
      rtlcn1179, rtlcn1190, rtlcn1208, rtlcn1212, not_rtlcn1829, rtlcn1219, 
      rtlcn1222, rtlcn1227, rtlcn1233, rtlcn1237, rtlcn1246, not_rtlcn2031, 
      rtlcn1695, rtlcn1707, rtlcn1712, not_rtlcn1825, rtlcn1730, rtlcn1741, 
      rtlcn1745, rtlcn1750, not_rtlcn2032, not_rtlcn2033, rtlcn1798, 
      rtlcn1803, rtlcn1824, rtlcn1825, rtlcn1826, rtlcn1828, rtlcn1829, 
      rtlcn1830, rtlcn1831, rtlcn1834, rtlcn1835, rtlcn1836, rtlcn1837, 
      rtlcn1838, rtlcn1839, rtlcn1841, rtlcn1842, rtlcn1843, rtlcn1844, 
      rtlcn1845, rtlcn1846, rtlcn1848, rtlcn1850, rtlcn1851, rtlcn1852, 
      rtlcn1853, rtlcn1854, rtlcn1855, rtlcn1856, rtlcn1857, rtlcn1858, 
      rtlcn1859, rtlcn1860, not_Timeout, rtlcn1863, not_rtlc9n3898, 
      rtlcn1865, rtlcn1868, rtlcn1869, rtlcn1870, not_Counter_is_21us, 
      not_state_3, rtlcn1873, not_RCV_R_Data_10, not_rtlcs25, 
      not_RCV_Command_Sync, not_RCV_CS, not_Start_Clean, rtlcn1883, 
      not_rtlcn1834, rtlcn1885, rtlcn1886, not_rtlc9n3883, rtlcn1889, 
      not_rtlc9n3916, not_rtlcn1843, rtlcn1892, not_rtlcs31, rtlcn1897, 
      rtlcn1899, rtlcn1900, rtlcn1901, rtlcn1902, not_rtlcn1830, rtlcn1904, 
      not_rtlc9n4154, rtlcn1906, not_rtlc9n876, not_rtlcn1837, rtlcn1910, 
      rtlcn1911, not_rtlcn1827, rtlcn1913, rtlcn1914, rtlcn1916, rtlcn1917, 
      rtlcn1921, not_rtlcn1842, rtlcn1923, rtlcn1924, rtlcn1925, 
      not_BCR_message, rtlcn1928, rtlcn1929, not_rtlc9n3710, rtlcn1931, 
      rtlcn1932, rtlcn1933, not_rtlc9n913, rtlcn1935, not_rtlcn1212, 
      rtlcn1937, rtlcn1938, rtlcn1939, not_rtlc9n904, rtlcn1942, rtlcn1943, 
      rtlcn1944, rtlcn1945, rtlcn1947, not_rtlcn1831, rtlcn1949, rtlcn1951, 
      rtlcn1953, rtlcn1954, rtlcn1956, rtlcn1957, rtlcn1958, rtlcn1959, 
      rtlcn1960, not_rtlcn1178, not_rtlcn1838, rtlcn1965, not_rtlcn1839, 
      rtlcn1967, rtlcn1968, rtlcn1969, rtlcn1979, not_rtlcn2034, 
      not_rtlcn2035, rtlcn1987, not_Counter_is_37us, rtlcn1989, rtlcn1999, 
      rtlcn2031, rtlcn2032, rtlcn2033, rtlcn2034, rtlcn2035, rtlcn2041, 
      rtlcn2042, rtlcn2043, rtlcn2044, rtlcn2045, rtlcn2047, rtlcn2048, 
      rtlcn2049, rtlcn2050, rtlcn2051, rtlcn2052, rtlcn2053, rtlcn2054, 
      rtlcn2055, rtlcn2057, rtlcn2061, rtlcn2063, not_CE, 
      not_RxRdy_Plus4_5us, rtlcn2066, rtlcn2068, not_RxRdy_Plus3us, 
      rtlcn2071, not_rtlc9n4294, rtlcn2073, not_rtlc9_PS245_n4342, 
      not_rtlc9_PS247_n4356, not_rtlc9_PS248_n4369, not_rtlcs19, not_rtlcs18, 
      rtlcn2079, not_rtlc9n4292, not_rtlc9n4291, not_rtlc9n4290, 
      not_rtlc9n4289, not_rtlc9n4288, not_rtlc9n4286, not_rtlc9n4285, 
      not_rtlc9n4284, not_rtlc9n4282, not_rtlcn391, not_rtlcn386, rtlcn2092, 
      rtlcn2099, rtlcn2100, rtlcn2101, rtlcn2102, rtlcn2103, rtlcn2104, 
      rtlcn2105, rtlcn2107, not_rtlcn2042, not_rtlcn383, not_state_1, 
      not_rtlc9n4086, not_state_0, not_rtlc9n4214, not_state_4, rtlcn2115, 
      rtlcn2116, not_No_Words_Message_9n55ss1, not_rtlc9n4243, rtlcs3, 
      rtlcs4, rtlcs9, rtlcs11, not_counter_4, rtlcs15, rtlcs18, rtlcs19, 
      rtlcs21, rtlcs24, rtlcs25, rtlcs26, rtlcs27, rtlcs30, rtlcs31, 
      not_rtlcn1803, not_counter_3, not_counter_2, not_counter_1, 
      not_counter_0, not_counter_6, not_RCV_Gap_found_2, not_RCV_Gap_found_1, 
      not_RCV_Gap_found_0, not_RCV_R_Data_9, not_RCV_R_Data_8, 
      not_RCV_R_Data_7, not_RCV_R_Data_6, not_RCV_R_Data_5, not_counter_5, 
      not_active_command_3, not_active_command_2, not_active_command_1, 
      not_rtlcn841, not_RCV_RAW_GAP_6, not_RCV_RAW_GAP_5, not_RCV_RAW_GAP_4, 
      not_RCV_RAW_GAP_3, not_RCV_RAW_GAP_2, not_RCV_RAW_GAP_1, 
      not_RCV_RAW_GAP_0, rtlcn2326, rtlcs38, rtlcs39, rtlcs40, 
      not_rtlc9n4826, rtlc9_1618_or_1024_nx0, rtlc9_1779_or_1036_nx0, 
      rtlc9_1780_or_1037_nx0, rtlc9_1868_or_1038_nx0, rtlcn1827, 
      rtlc9_1900_or_1041_nx0, rtlc9_1918_or_1045_nx0, rtlc9_1919_or_1046_nx0, 
      rtlc9_1920_or_1047_nx0, rtlc9_1932_or_1050_nx0, rtlc9_1933_or_1051_nx0, 
      rtlc9_1944_or_1054_nx0, rtlc9_2356_gt_1058_nx0, rtlc9_2356_gt_1058_nx2, 
      rtlc9_2356_gt_1058_nx4, rtlc9n5625, rtlc_542_or_1067_nx0, 
      rtlc_545_or_1068_nx0, rtlc_2605_and_1078_nx0, rtlc_2616_and_1080_nx0, 
      rtlc_2633_and_1082_nx0, rtlc_2646_and_1085_nx0, rtlc_2662_or_1086_nx0, 
      rtlc_2676_and_1090_nx0, rtlc_2686_and_1091_nx0, rtlc_2691_and_1092_nx0, 
      rtlc_2693_and_1093_nx0, rtlc_2700_or_1095_nx0, rtlc_2710_and_1096_nx0, 
      rtlc_2712_and_1097_nx0, rtlc_2727_or_1099_nx0, rtlc_2731_and_1101_nx0, 
      rtlc_2732_and_1102_nx0, rtlc_2742_or_1104_nx0, rtlc_2769_or_1107_nx0, 
      rtlc_2776_and_1108_nx0, rtlc_2995_or_1110_nx0, rtlc_3047_and_1114_nx0, 
      rtlc_3058_and_1116_nx0, rtlc_3059_or_1117_nx0, rtlc_3068_and_1118_nx0, 
      rtlc_3081_or_1120_nx0, rtlc_3091_and_1121_nx0, rtlc_3095_and_1123_nx0, 
      rtlc_3105_or_1127_nx0, rtlc_3150_and_1129_nx0, rtlcs8, nx5, nx8: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (11 downto 0 );

begin
   Address(15) <= Address_6_EXMPLR2028 ;
   Address(14) <= Address_6_EXMPLR2028 ;
   Address(13) <= Address_6_EXMPLR2028 ;
   Address(12) <= Address_6_EXMPLR2028 ;
   Address(11) <= Address_6_EXMPLR2028 ;
   Address(10) <= Address_6_EXMPLR2028 ;
   Address(9) <= Address_6_EXMPLR2028 ;
   Address(8) <= Address_6_EXMPLR2028 ;
   Address(7) <= Address_6_EXMPLR2028 ;
   Address(6) <= Address_6_EXMPLR2028 ;
   Address(5) <= Address_6_EXMPLR2028 ;
   Address(4) <= Address_6_EXMPLR2028 ;
   Address(3) <= Address_6_EXMPLR2028 ;
   Address(2) <= Address_6_EXMPLR2028 ;
   Address(1) <= Address_6_EXMPLR2028 ;
   Address(0) <= Address_6_EXMPLR2028 ;
   active_command(15) <= active_command_15_EXMPLR1989 ;
   active_command(14) <= active_command_14_EXMPLR1990 ;
   active_command(13) <= active_command_13_EXMPLR1991 ;
   active_command(12) <= active_command_12_EXMPLR1992 ;
   active_command(11) <= active_command_11_EXMPLR1993 ;
   active_command(10) <= active_command_10_EXMPLR1994 ;
   active_command(4) <= active_command_4_EXMPLR2000 ;
   active_command(3) <= active_command_3_EXMPLR2001 ;
   active_command(2) <= active_command_2_EXMPLR2002 ;
   active_command(1) <= active_command_1_EXMPLR2003 ;
   active_command(0) <= active_command_0_EXMPLR2004 ;
   RT2RT_message <= RT2RT_message_EXMPLR2009 ;
   MIL1553_ERRORS_Parity_Manchester <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_Format_error <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_Message_Error_set <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_echo_back_bus_B <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_echo_back_bus_A <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_bus_B_shutdown <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_bus_A_shutdown <= Address_6_EXMPLR2028 ;
   MIL1553_ERRORS_transmitter_timout <= Address_6_EXMPLR2028 ;
   Debug(15) <= Address_6_EXMPLR2028 ;
   Debug(14) <= Address_6_EXMPLR2028 ;
   Debug(13) <= Address_6_EXMPLR2028 ;
   Debug(12) <= Address_6_EXMPLR2028 ;
   Debug(11) <= Address_6_EXMPLR2028 ;
   Debug(10) <= Address_6_EXMPLR2028 ;
   Debug(9) <= Address_6_EXMPLR2028 ;
   Debug(8) <= Address_6_EXMPLR2028 ;
   Debug(7) <= Address_6_EXMPLR2028 ;
   Debug(6) <= Address_6_EXMPLR2028 ;
   Debug(5) <= Address_6_EXMPLR2028 ;
   Debug(4) <= Address_6_EXMPLR2028 ;
   Debug(3) <= Address_6_EXMPLR2028 ;
   Debug(2) <= Address_6_EXMPLR2028 ;
   Debug(1) <= Address_6_EXMPLR2028 ;
   Debug(0) <= Address_6_EXMPLR2028 ;
   Tx_command_time <= Address_6_EXMPLR2028 ;
   last_data_time <= Address_6_EXMPLR2028 ;
   PWR <= '1' ;
   Address_6_EXMPLR2028 <= '0' ;
   Write_Data(0) <= RCV_R_Data(0) ;
   Write_Data(1) <= RCV_R_Data(1) ;
   Write_Data(2) <= RCV_R_Data(2) ;
   Write_Data(3) <= RCV_R_Data(3) ;
   Write_Data(4) <= RCV_R_Data(4) ;
   Write_Data(5) <= RCV_R_Data(5) ;
   Write_Data(6) <= RCV_R_Data(6) ;
   Write_Data(7) <= RCV_R_Data(7) ;
   Write_Data(8) <= RCV_R_Data(8) ;
   Write_Data(9) <= RCV_R_Data(9) ;
   Write_Data(10) <= RCV_R_Data(10) ;
   Write_Data(11) <= RCV_R_Data(11) ;
   Write_Data(12) <= RCV_R_Data(12) ;
   Write_Data(13) <= RCV_R_Data(13) ;
   Write_Data(14) <= RCV_R_Data(14) ;
   Write_Data(15) <= RCV_R_Data(15) ;
   RxRdy <= RCV_Pre_RxRdy OR RCV_Pre_EchoRdy ;
   rtlc6n36 <= RCV_recieving AND rtlc6n164 ;
   not_Energy_Count_9 <= NOT Energy_Count(9) ;
   rtlc6_61_and_1019 : and_7u_7u port map ( a(6)=>Energy_Count(6), a(5)=>
      Energy_Count(5), a(4)=>Energy_Count(4), a(3)=>Energy_Count(3), a(2)=>
      Energy_Count(2), a(1)=>Energy_Count(1), a(0)=>Energy_Count(0), d=>
      rtlc6n161);
   rtlc6n164 <= not_rtlcn205 OR not_Energy_Count_9 ;
   MIL1553_ERRORS_9n22ss1(0) <= NOT Error_in_message ;
   mode_message_9n8s1 <= mode_message_9n8s2 OR mode_message_9n1s5 ;
   mode_message_9n8s2 <= mode_message_9n1s3 AND not_MODE_CODE1553A ;
   not_MODE_CODE1553A <= NOT MODE_CODE1553A ;
   MIL1553_ERRORS_9n51ss1(0) <= GOOD_Data_Block OR No_Words_Message ;
   not_rtlc9n5039 <= NOT rtlc9n5039 ;
   rtlc9_1411_or_1020 : or_4u_4u port map ( a(3)=>state(5), a(2)=>state(6), 
      a(1)=>state(7), a(0)=>state(8), d=>rtlc9n4906);
   rtlc9_1415_or_1021 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(4), a(0)=>state(5), d=>rtlc9n4908);
   rtlc9_1611_select_1022 : select_4_4 port map ( a(3)=>state(0), a(2)=>
      state(1), a(1)=>not_rtlc9n5039, a(0)=>state(4), b(3)=>
      Address_6_EXMPLR2028, b(2)=>rtlcn381, b(1)=>PWR, b(0)=>rtlcn390, d=>
      rtlcn383);
   rtlc9_1617_select_1023 : select_4_4 port map ( a(3)=>state(0), a(2)=>
      state(1), a(1)=>not_rtlc9n5039, a(0)=>state(4), b(3)=>
      Address_6_EXMPLR2028, b(2)=>rtlcn384, b(1)=>PWR, b(0)=>rtlcn390, d=>
      rtlcn386);
   rtlc9n4040 <= rtlcs25 AND not_RCV_R_Data_10 ;
   rtlc9n4035 <= not_rtlcs38 AND rtlcs25 ;
   rtlc9_1639_select_1025 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n5043, a(1)=>state(3), a(0)=>state(4), b(4)=>
      Address_6_EXMPLR2028, b(3)=>rtlcn389, b(2)=>PWR, b(1)=>Counter_is_37us, 
      b(0)=>rtlcn390, d=>rtlcn391);
   rtlc9_1640_or_1026 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(3), a(0)=>state(4), d=>rtlc9n5043);
   not_rtlc9n5043 <= NOT rtlc9n5043 ;
   rtlc9n4072 <= rtlcs25 AND RCV_Command_Sync ;
   rtlc9_1648_select_1028 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>rtlc9n5047, a(2)=>state(4), a(1)=>state(5), a(0)=>
      state(7), b(5)=>RxRdy, b(4)=>rtlc9n4091, b(3)=>PWR, b(2)=>rtlc9n4245, 
      b(1)=>rtlc9n4270, b(0)=>not_RxRdy_Plus4_5us, d=>rtlc9n4282);
   rtlc9_1649_or_1029 : or_4u_4u port map ( a(3)=>state(2), a(2)=>state(3), 
      a(1)=>state(6), a(0)=>state(8), d=>rtlc9n5047);
   rtlc9n4245 <= rtlc9n4233 AND not_Timeout ;
   rtlc9n4270 <= rtlc9n4265 AND not_Counter_is_37us ;
   rtlc9_1660_or_1030 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(2), a(0)=>state(4), d=>rtlc9n5051);
   not_rtlc9n5051 <= NOT rtlc9n5051 ;
   rtlc9n4218 <= rtlc9n4211 AND RCV_CS ;
   rtlc9_1668_select_1031 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>state(2), a(1)=>not_rtlc9n5051, a(0)=>state(4), b(4)=>
      RxRdy, b(3)=>rtlc9n4092, b(2)=>rtlc9n4140, b(1)=>PWR, b(0)=>rtlc9n4243, 
      d=>rtlc9n4285);
   rtlc9n4042 <= rtlc9n4035 AND RCV_R_Data(10) ;
   rtlc9n4219 <= rtlc9n4209 AND RCV_CS ;
   rtlc9_1689_select_1032 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>state(2), a(2)=>state(3), a(1)=>state(4), a(0)=>
      rtlc9n4906, b(5)=>rtlc9n4010, b(4)=>rtlc9n4086, b(3)=>rtlc9n4142, b(2)
      =>rtlc9n4198, b(1)=>rtlc9n4248, b(0)=>PWR, d=>rtlc9n4288);
   rtlc9n4010 <= rtlc9n4008 AND RxRdy ;
   rtlc9_1701_select_1033 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n4908, a(1)=>state(4), a(0)=>state(5), b(4)=>
      RxRdy, b(3)=>rtlc9n4086, b(2)=>PWR, b(1)=>rtlc9n4249, b(0)=>rtlc9n4269, 
      d=>rtlc9n4290);
   rtlc9n4230 <= rtlc9n4216 AND rtlc9n4826 ;
   rtlc9_1715_select_1034 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n5043, a(1)=>state(3), a(0)=>state(4), b(4)=>
      RxRdy, b(3)=>rtlc9n4091, b(2)=>PWR, b(1)=>rtlc9n4200, b(0)=>rtlc9n4249, 
      d=>rtlc9n4292);
   rtlc9n4186 <= rtlc9n4181 AND not_rtlc9n4154 ;
   rtlc9n4181 <= not_rtlcn1798 AND RCV_CS ;
   rtlc9_1739_select_1035 : select_9_9 port map ( a(8)=>state(0), a(7)=>
      state(1), a(6)=>state(2), a(5)=>state(3), a(4)=>state(4), a(3)=>
      state(5), a(2)=>state(6), a(1)=>state(7), a(0)=>state(8), b(8)=>
      rtlc9n4011, b(7)=>not_Counter_is_21us, b(6)=>not_Timeout, b(5)=>
      not_Counter_is_37us, b(4)=>rtlc9n4245, b(3)=>rtlc9n4271, b(2)=>
      RCV_recieving, b(1)=>not_RxRdy_Plus4_5us, b(0)=>PWR, d=>rtlc9n4294);
   rtlc9n4271 <= rtlc9n4266 AND not_Counter_is_37us ;
   rtlc9n4257 <= rtlc9n4254 AND not_rtlc9n3898 ;
   rtlc9n4239 <= not_RxRdy OR rtlc9n4230 ;
   rtlc9n4134 <= not_RxRdy OR rtlc9n4826 ;
   rtlc9_1894_or_1040 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>rtlc9n4213, 
      a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>rtlc9n4249
   );
   rtlc9n4191 <= not_RxRdy OR not_rtlc9n4154 ;
   rtlc9_1905_or_1042 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>rtlc9n4212, 
      a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>rtlc9n4248
   );
   rtlc9_1906_or_1043 : or_5u_5u port map ( a(4)=>Counter_is_37us, a(3)=>
      rtlc9n4154, a(2)=>not_RxRdy, a(1)=>not_RCV_Command_Sync, a(0)=>
      not_RCV_CS, d=>rtlc9n4198);
   rtlc9_1907_or_1044 : or_5u_5u port map ( a(4)=>RCV_Command_Sync, a(3)=>
      Timeout, a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>
      rtlc9n4142);
   rtlc9n4008 <= not_RCV_CS OR RCV_Command_Sync ;
   rtlc9n4209 <= not_RCV_Command_Sync OR not_Start_Clean ;
   rtlc9n4083 <= not_RxRdy OR rtlc9n4075 ;
   rtlc9_1926_or_1048 : or_4u_4u port map ( a(3)=>Timeout, a(2)=>
      not_RT2RT_message, a(1)=>not_rtlc9n4113, a(0)=>not_RxRdy, d=>
      rtlc9n4140);
   rtlc9_1927_or_1049 : or_4u_4u port map ( a(3)=>Counter_is_21us, a(2)=>
      rtlc9n4042, a(1)=>not_RxRdy, a(0)=>not_RCV_Command_Sync, d=>rtlc9n4092
   );
   rtlc9_1942_or_1052 : or_4u_4u port map ( a(3)=>rtlc9n3883, a(2)=>
      rtlc9n3898, a(1)=>rtlc9n3916, a(0)=>not_RxRdy_Plus3us, d=>rtlc9n4265);
   rtlc9_1943_or_1053 : or_5u_5u port map ( a(4)=>not_RxRdy, a(3)=>
      not_RCV_Command_Sync, a(2)=>not_RCV_CS, a(1)=>not_Start_Clean, a(0)=>
      not_rtlc9n4826, d=>rtlc9n4233);
   rtlc9n4154 <= Sync_Error OR not_rtlcs25 ;
   rtlc9n4112 <= not_active_command_4 OR MODE_CODE1553A ;
   rtlc9n4113 <= mode_message AND rtlc9n4112 ;
   not_rtlcs38 <= NOT rtlcs38 ;
   rtlc9n3916 <= RCV_recieving AND rtlc9n3914 ;
   rtlc9n3896 <= RCV_recieving AND rtlcs25 ;
   rtlc9n3898 <= rtlc9n3896 AND RCV_CS ;
   rtlc9n3880 <= No_Words_Message AND rtlcs21 ;
   rtlc9n3871 <= RxRdy_Plus_2us AND not_RCV_recieving ;
   rtlc9n3883 <= rtlc9n3871 AND rtlc9n3880 ;
   rtlc9n4826 <= NOT not_rtlc9n4826 ;
   not_rtlc9n3737 <= NOT rtlc9n3737 ;
   rtlc9n3737 <= rtlc9n5803 AND not_RCV_recieving ;
   rtlc9n3700 <= active_command_10_EXMPLR1994 AND not_RT2RT_message ;
   rtlc9n3710 <= rtlc9n3700 OR rtlcs21 ;
   rtlc9n3696 <= rtlcs39 OR mode_message ;
   rtlc9n3541 <= rtlcs24 OR mode_message ;
   not_rtlcs26 <= NOT rtlcs26 ;
   rtlc9n3352 <= RCV_CS AND RCV_Command_Sync ;
   rtlc9n3360 <= rtlc9n3352 AND not_rtlcs26 ;
   rtlc9n903 <= not_RCV_R_Data_4 OR MODE_CODE1553A ;
   rtlc9n904 <= mode_message_9n8s1 AND rtlc9n903 ;
   not_mode_message_9n1s3 <= NOT mode_message_9n1s3 ;
   rtlc9n875 <= not_mode_message_9n1s3 OR MODE_CODE1553A ;
   not_mode_message_9n1s5 <= NOT mode_message_9n1s5 ;
   rtlc9n867 <= rtlcs30 AND not_mode_message_9n1s5 ;
   rtlc9n876 <= rtlc9n867 AND rtlc9n875 ;
   not_RCV_R_Data_4 <= NOT RCV_R_Data(4) ;
   Word_number_inc5_9i1 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>
      Word_number(4), a(3)=>Word_number(3), a(2)=>Word_number(2), a(1)=>
      Word_number(1), a(0)=>Word_number(0), d(4)=>Word_number_9n30s1(4), 
      d(3)=>Word_number_9n30s1(3), d(2)=>Word_number_9n30s1(2), d(1)=>
      Word_number_9n30s1(1), d(0)=>Word_number_9n30s1(0), cout=>DANGLING(0)
   );
   counter_inc13_9i3 : inc_13u_13u_0 port map ( cin=>PWR, a(12)=>counter(12), 
      a(11)=>counter(11), a(10)=>counter(10), a(9)=>counter(9), a(8)=>
      counter(8), a(7)=>counter(7), a(6)=>counter(6), a(5)=>counter(5), a(4)
      =>counter(4), a(3)=>counter(3), a(2)=>counter(2), a(1)=>counter(1), 
      a(0)=>counter(0), d(12)=>counter_9n56s1(12), d(11)=>counter_9n56s1(11), 
      d(10)=>counter_9n56s1(10), d(9)=>counter_9n56s1(9), d(8)=>
      counter_9n56s1(8), d(7)=>counter_9n56s1(7), d(6)=>counter_9n56s1(6), 
      d(5)=>counter_9n56s1(5), d(4)=>counter_9n56s1(4), d(3)=>
      counter_9n56s1(3), d(2)=>counter_9n56s1(2), d(1)=>counter_9n56s1(1), 
      d(0)=>counter_9n56s1(0), cout=>DANGLING(1));
   not_No_Response_timeout_0 <= NOT No_Response_timeout(0) ;
   not_No_Response_timeout_1 <= NOT No_Response_timeout(1) ;
   not_No_Response_timeout_2 <= NOT No_Response_timeout(2) ;
   not_active_command_4 <= NOT active_command_4_EXMPLR2000 ;
   not_counter_12 <= NOT counter(12) ;
   not_rtlc9n5572 <= NOT rtlc9n5572 ;
   not_counter_9 <= NOT counter(9) ;
   not_counter_8 <= NOT counter(8) ;
   not_counter_7 <= NOT counter(7) ;
   rtlc9n5577 <= not_counter_8 AND not_counter_7 ;
   rtlc9n5578 <= not_counter_9 OR rtlc9n5577 ;
   rtlc9n5579 <= not_rtlc9n5572 AND rtlc9n5578 ;
   rtlc9n5580 <= rtlc9n5579 OR not_counter_12 ;
   not_rtlc9n5597 <= NOT rtlc9n5597 ;
   not_counter_10 <= NOT counter(10) ;
   rtlc9n5604 <= not_counter_10 OR not_rtlcn198 ;
   not_rtlc9n5625 <= NOT rtlc9n5625 ;
   rtlc9n5631 <= not_counter_7 OR not_rtlcn200 ;
   rtlc9n5632 <= not_rtlc9n5625 AND rtlc9n5631 ;
   rtlc9n5633 <= not_counter_10 OR rtlc9n5632 ;
   rtlc9n5660 <= not_counter_8 OR not_rtlcn199 ;
   rtlc9n5661 <= not_counter_9 AND rtlc9n5660 ;
   rtlc9n5662 <= not_counter_10 OR rtlc9n5661 ;
   not_counter_11 <= NOT counter(11) ;
   not_rtlc9n5680 <= NOT rtlc9n5680 ;
   rtlc9n5687 <= not_rtlc9n5680 AND rtlc9n5631 ;
   rtlc9n5688 <= not_counter_11 OR rtlc9n5687 ;
   rtlc9n5770 <= RCV_Gap_found(0) AND RCV_Gap_found(1) ;
   rtlc9n5771 <= rtlc9n5770 OR RCV_Gap_found(2) ;
   rtlc9n5800 <= Energy_Count(8) AND Energy_Count(7) ;
   rtlc9_3509_or_1066 : or_7u_7u port map ( a(6)=>Energy_Count(0), a(5)=>
      Energy_Count(1), a(4)=>Energy_Count(2), a(3)=>Energy_Count(3), a(2)=>
      Energy_Count(4), a(1)=>Energy_Count(5), a(0)=>Energy_Count(6), d=>
      rtlc9n5801);
   rtlc9n5802 <= rtlc9n5801 AND rtlc9n5800 ;
   rtlc9n5803 <= rtlc9n5802 OR Energy_Count(9) ;
   rtlc9n5572 <= counter(11) OR counter(10) ;
   rtlc9n5597 <= counter(12) OR counter(11) ;
   not_rtlcn198 <= NOT rtlcn198 ;
   not_rtlcn199 <= NOT rtlcn199 ;
   not_rtlcn200 <= NOT rtlcn200 ;
   rtlc9n5656 <= counter(7) OR counter(6) ;
   rtlc9n5757 <= RCV_Gap_found(2) OR RCV_Gap_found(1) ;
   not_rtlcn204 <= NOT rtlcn204 ;
   rtlc6n159 <= Energy_Count(8) OR Energy_Count(7) ;
   not_rtlcn205 <= NOT rtlcn205 ;
   rtlcn200 <= counter(6) OR counter(5) ;
   rtlcn199 <= rtlc9n5656 OR counter(5) ;
   rtlcn204 <= rtlc9n3360 OR rtlc9n5771 ;
   rtlcn205 <= rtlc6n159 OR rtlc6n161 ;
   rtlc9n4041 <= rtlcs25 AND rtlcn388 ;
   rtlcn389 <= Counter_is_21us OR rtlc9n4072 ;
   rtlc_551_or_1069 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>
      not_RCV_Command_Sync, a(2)=>not_RCV_CS, a(1)=>not_Start_Clean, a(0)=>
      not_rtlc9n4826, d=>rtlcn390);
   rtlc9n4075 <= RCV_CS AND rtlcn394 ;
   Start_Clean_select_9i4 : select_3_3 port map ( a(2)=>rtlcn674, a(1)=>
      not_rtlcn2031, a(0)=>rtlcn676, b(2)=>Address_6_EXMPLR2028, b(1)=>PWR, 
      b(0)=>Error_in_message, d=>Start_Clean_9n55ss1);
   MIL1553_ERRORS_select_9i5 : select_4_4 port map ( a(3)=>rtlcn674, a(2)=>
      state(1), a(1)=>rtlcn361, a(0)=>rtlcn1135, b(3)=>Address_6_EXMPLR2028, 
      b(2)=>MIL1553_ERRORS_9n17ss1(0), b(1)=>MIL1553_ERRORS_9n51ss1(0), b(0)
      =>GOOD_Data_Block, d=>MIL1553_ERRORS_9n55ss1_0);
   rtlc_1420_select_1072 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>not_rtlc9n5051, a(2)=>rtlcn1179, a(1)=>rtlcn1176, a(0)
      =>rtlcn1178, b(5)=>RxRdy, b(4)=>rtlc9n4086, b(3)=>PWR, b(2)=>
      not_rtlc9n3737, b(1)=>rtlc9n4130, b(0)=>rtlc9n4235, d=>rtlc9n4284);
   rtlc_1463_select_1073 : select_7_7 port map ( a(6)=>state(0), a(5)=>
      rtlc9n4906, a(4)=>rtlcn1219, a(3)=>rtlcn1212, a(2)=>rtlcn1176, a(1)=>
      not_rtlcn1829, a(0)=>rtlcn1178, b(6)=>RxRdy, b(5)=>PWR, b(4)=>
      not_rtlc9n3737, b(3)=>rtlc9n4083, b(2)=>rtlc9n4132, b(1)=>rtlc9n4189, 
      b(0)=>rtlc9n4236, d=>rtlc9n4286);
   MIL1553_ERRORS_select_9i6 : select_3_3 port map ( a(2)=>state(0), a(1)=>
      rtlcn1222, a(0)=>not_rtlcn2032, b(2)=>RxRdy, b(1)=>
      Address_6_EXMPLR2028, b(0)=>MIL1553_ERRORS_9n22ss1(0), d=>
      MIL1553_ERRORS_9n55ss1_6);
   rtlc_1480_select_1075 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      not_rtlc9n5043, a(3)=>state(4), a(2)=>rtlcn1233, a(1)=>rtlcn1212, a(0)
      =>not_rtlcn1829, b(5)=>RxRdy, b(4)=>PWR, b(3)=>rtlc9n4243, b(2)=>
      rtlc9n3737, b(1)=>rtlc9n4077, b(0)=>rtlc9n4191, d=>rtlc9n4289);
   rtlc_1502_select_1076 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>not_rtlc9n5051, a(2)=>rtlcn1179, a(1)=>rtlcn1176, a(0)
      =>rtlcn1178, b(5)=>RxRdy, b(4)=>rtlc9n4086, b(3)=>PWR, b(2)=>
      rtlc9n3737, b(1)=>rtlc9n4134, b(0)=>rtlc9n4239, d=>rtlc9n4291);
   not_RCV_recieving <= NOT RCV_recieving ;
   not_rtlc9n4113 <= NOT rtlc9n4113 ;
   not_rtlc9n3541 <= NOT rtlc9n3541 ;
   not_RT2RT_message <= NOT RT2RT_message_EXMPLR2009 ;
   Monitor_ended_not_OK_select_9i7 : select_3_3 port map ( a(2)=>
      not_rtlcn2033, a(1)=>rtlcn1745, a(0)=>rtlcn1038, b(2)=>
      Address_6_EXMPLR2028, b(1)=>PWR, b(0)=>Error_in_message, d=>
      Monitor_ended_not_OK_9n55ss1);
   not_rtlcn1798 <= NOT rtlcn1798 ;
   not_rtlc9n4908 <= NOT rtlc9n4908 ;
   rtlcn397 <= state(2) OR state(4) ;
   not_Timeout <= NOT Timeout ;
   rtlcn1178 <= state(4) AND not_Timeout ;
   rtlcn674 <= state(0) OR rtlcn1178 ;
   rtlcn1863 <= state(5) AND Counter_is_37us ;
   rtlcn1844 <= state(7) OR rtlcn1863 ;
   not_rtlc9n3898 <= NOT rtlc9n3898 ;
   rtlcn1865 <= state(5) AND not_rtlc9n3898 ;
   rtlcn676 <= rtlcn1844 OR rtlcn1865 ;
   rtlcn361 <= state(5) OR state(7) ;
   rtlcn1135 <= Timeout AND state(4) ;
   rtlcn1868 <= state(2) AND Timeout ;
   rtlcn1179 <= rtlcn1135 OR rtlcn1868 ;
   rtlcn1176 <= state(2) AND not_Timeout ;
   rtlcn1869 <= state(3) AND Counter_is_37us ;
   rtlcn1870 <= state(1) AND Counter_is_21us ;
   rtlcn1233 <= rtlcn1869 OR rtlcn1870 ;
   rtlcn1219 <= rtlcn1233 OR rtlcn1179 ;
   not_Counter_is_21us <= NOT Counter_is_21us ;
   rtlcn1212 <= state(1) AND not_Counter_is_21us ;
   not_state_3 <= NOT state(3) ;
   rtlcn1829 <= not_state_3 OR Counter_is_37us ;
   not_rtlcn1829 <= NOT rtlcn1829 ;
   rtlcn1873 <= state(4) AND RCV_Command_Sync ;
   rtlcn1222 <= state(1) OR rtlcn1873 ;
   not_RCV_R_Data_10 <= NOT RCV_R_Data(10) ;
   not_rtlcs25 <= NOT rtlcs25 ;
   rtlcn1830 <= not_RCV_R_Data_10 OR not_rtlcs25 ;
   not_RCV_Command_Sync <= NOT RCV_Command_Sync ;
   not_RCV_CS <= NOT RCV_CS ;
   not_Start_Clean <= NOT Start_Clean ;
   rtlcn1834 <= not_rtlc9n4826 OR rtlc9n4216 ;
   rtlcn1883 <= state(6) AND not_RCV_recieving ;
   rtlcn1848 <= rtlcn1233 OR rtlcn1883 ;
   rtlcn1852 <= RxRdy AND rtlcn1178 ;
   rtlcn1853 <= state(1) AND RCV_Command_Sync ;
   not_rtlcn1834 <= NOT rtlcn1834 ;
   rtlcn1885 <= not_rtlcn1834 AND rtlcn1852 ;
   rtlc_2606_or_1079 : or_4u_4u port map ( a(3)=>rtlcn1179, a(2)=>rtlcn1848, 
      a(1)=>rtlcn1885, a(0)=>rtlcn1886, d=>rtlcn1745);
   not_rtlc9n3883 <= NOT rtlc9n3883 ;
   rtlcn1836 <= state(5) AND not_rtlc9n3883 ;
   rtlcn1889 <= state(7) AND RxRdy_Plus4_5us ;
   rtlcn1841 <= rtlcn1863 OR rtlcn1889 ;
   not_rtlc9n3916 <= NOT rtlc9n3916 ;
   rtlc9n4254 <= RCV_recieving AND not_rtlc9n3916 ;
   rtlcn1843 <= rtlc9n3898 OR rtlc9n4254 ;
   not_rtlcn1843 <= NOT rtlcn1843 ;
   rtlcn1038 <= rtlcn1841 OR rtlcn1892 ;
   not_R <= NOT R ;
   not_rtlcs31 <= NOT rtlcs31 ;
   rtlc9n3914 <= not_rtlcs25 OR not_rtlcs31 ;
   rtlcn1845 <= not_RCV_recieving OR rtlc9n3914 ;
   rtlcn1897 <= rtlcn397 AND Timeout ;
   not_RxRdy <= NOT RxRdy ;
   rtlcn1899 <= state(0) AND not_RxRdy ;
   rtlcn1900 <= state(8) AND not_rtlcs31 ;
   rtlc_2635_or_1084 : or_7u_7u port map ( a(6)=>rtlcn1844, a(5)=>rtlcn1848, 
      a(4)=>rtlcn1897, a(3)=>rtlcn1899, a(2)=>rtlcn1900, a(1)=>rtlcn1901, 
      a(0)=>rtlcn1902, d=>rtlcn461);
   rtlcn1803 <= RxRdy OR state(0) ;
   not_rtlcn1830 <= NOT rtlcn1830 ;
   rtlcn663 <= state(1) AND not_rtlcn1830 ;
   rtlcn1904 <= state(1) AND not_RCV_Command_Sync ;
   rtlcn841 <= state(3) OR rtlcn1904 ;
   not_rtlc9n4154 <= NOT rtlc9n4154 ;
   rtlcn1144 <= state(1) OR rtlcn1906 ;
   not_rtlc9n876 <= NOT rtlc9n876 ;
   rtlcn1837 <= not_RCV_R_Data_10 OR not_rtlc9n876 ;
   not_rtlcn1837 <= NOT rtlcn1837 ;
   No_Words_Message_9n55ss1 <= state(0) AND RxRdy ;
   rtlcn1846 <= state(2) OR rtlcn1135 ;
   rtlcn1910 <= state(4) AND rtlc9n4216 ;
   rtlcn1173 <= rtlcn1846 OR rtlcn1910 ;
   rtlcn1911 <= state(1) AND rtlcs25 ;
   rtlcn1190 <= state(2) OR rtlcn1911 ;
   not_rtlcn1827 <= NOT rtlcn1827 ;
   rtlcn1913 <= not_rtlcn1827 AND rtlcn1212 ;
   rtlcn1914 <= RCV_CS AND rtlcn1178 ;
   rtlcn1227 <= state(3) OR rtlcn1870 ;
   rtlcn1916 <= state(4) AND not_RCV_Command_Sync ;
   rtlcn1237 <= state(5) OR rtlcn1916 ;
   rtlcn1917 <= state(4) AND not_rtlc9n4826 ;
   rtlcn1246 <= rtlcn1846 OR rtlcn1917 ;
   rtlcn1842 <= not_rtlc9n4826 OR not_RCV_CS ;
   rtlcn1921 <= not_rtlcs25 AND rtlcn1212 ;
   not_rtlcn1842 <= NOT rtlcn1842 ;
   rtlcn1826 <= rtlcn1921 OR rtlcn1923 ;
   rtlcn1924 <= RCV_Command_Sync AND rtlcn1826 ;
   rtlcn1925 <= not_rtlcn1827 AND No_Words_Message_9n55ss1 ;
   rtlcn1828 <= rtlcn1924 OR rtlcn1925 ;
   rtlcn1850 <= rtlc9n3696 AND not_rtlcn1829 ;
   not_BCR_message <= NOT BCR_message_0n0s2 ;
   rtlcn1851 <= rtlc9n3541 AND not_BCR_message ;
   rtlcn1928 <= rtlcn1212 AND rtlcn1851 ;
   rtlcn1854 <= rtlcn1928 OR rtlcn1929 ;
   not_rtlc9n3710 <= NOT rtlc9n3710 ;
   rtlcn1931 <= not_rtlc9n3710 AND rtlcn1850 ;
   rtlcn1932 <= not_RCV_Command_Sync AND rtlcn1854 ;
   not_rtlc9n913 <= NOT rtlcs30 ;
   rtlc_2694_or_1094 : or_4u_4u port map ( a(3)=>rtlcn1931, a(2)=>rtlcn1932, 
      a(1)=>rtlcn1933, a(0)=>rtlcn1935, d=>rtlcn1695);
   not_rtlcn1212 <= NOT rtlcn1212 ;
   rtlcn1831 <= RCV_Command_Sync OR not_rtlcn1212 ;
   rtlcn1937 <= not_RCV_Command_Sync AND not_rtlcs25 ;
   rtlcn1938 <= RCV_Command_Sync AND not_Start_Clean ;
   rtlcn1939 <= rtlcs30 AND rtlc9n904 ;
   not_rtlc9n904 <= NOT rtlc9n904 ;
   rtlcn1855 <= rtlcn1939 OR not_rtlcn1837 ;
   rtlcn1942 <= rtlcn1827 AND No_Words_Message_9n55ss1 ;
   rtlcn1943 <= rtlc9n3710 AND rtlcn1850 ;
   rtlcn1944 <= rtlcn1178 AND rtlcn1856 ;
   rtlcn1945 <= rtlcn1828 AND rtlcn1855 ;
   not_rtlcn1831 <= NOT rtlcn1831 ;
   rtlc_2713_or_1098 : or_6u_6u port map ( a(5)=>rtlcn1942, a(4)=>rtlcn1943, 
      a(3)=>rtlcn1944, a(2)=>rtlcn1945, a(1)=>rtlcn1947, a(0)=>rtlcn1949, d
      =>rtlcn1707);
   rtlcn1951 <= not_rtlcn1834 AND rtlcn1178 ;
   rtlcn1858 <= rtlcn1925 OR rtlcn1951 ;
   rtlcn1824 <= not_rtlc9n904 AND rtlcn1858 ;
   rtlcn1857 <= rtlcn1824 OR rtlcn1958 ;
   rtlcn1712 <= not_RCV_R_Data_10 AND rtlcn1857 ;
   rtlcn1953 <= state(1) AND rtlcn1830 ;
   rtlcn1954 <= state(0) AND rtlcn1837 ;
   rtlcn1859 <= rtlcn1953 OR rtlcn1954 ;
   rtlcn1956 <= state(4) AND not_rtlcn1834 ;
   rtlcn1957 <= not_rtlcn1827 AND rtlcn1859 ;
   not_rtlcn1825 <= NOT rtlcn1825 ;
   rtlc_2729_and_1100 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      not_rtlcs25, a(1)=>not_rtlc9n904, a(0)=>rtlcn1212, d=>rtlcn1958);
   rtlcn1730 <= rtlcn1959 OR rtlcn1960 ;
   not_rtlcn1178 <= NOT rtlcn1178 ;
   rtlcn1835 <= RxRdy AND not_rtlcn1178 ;
   rtlcn1838 <= not_RCV_R_Data_10 OR Record_command ;
   not_rtlcn1838 <= NOT rtlcn1838 ;
   rtlcn1839 <= not_rtlcs25 OR not_rtlcn1838 ;
   rtlc_2741_and_1103 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      rtlcn1835, a(1)=>rtlcn1212, a(0)=>rtlcn1839, d=>rtlcn1965);
   not_rtlcn1839 <= NOT rtlcn1839 ;
   rtlcn1967 <= rtlcn1212 AND not_rtlcn1839 ;
   rtlc_2745_or_1105 : or_4u_4u port map ( a(3)=>rtlcn1176, a(2)=>
      not_rtlcn1829, a(1)=>not_rtlcn1831, a(0)=>rtlcn1967, d=>rtlcn1860);
   rtlcn1968 <= rtlcn1834 AND rtlcn1852 ;
   rtlcn1969 <= rtlcn1835 AND rtlcn1860 ;
   rtlcn1750 <= rtlcn1968 OR rtlcn1969 ;
   rtlcn1979 <= rtlcn1176 AND not_rtlc9n4113 ;
   rtlcn1987 <= state(6) AND RCV_recieving ;
   not_Counter_is_37us <= NOT Counter_is_37us ;
   rtlcn881 <= rtlcn1987 OR rtlcn1989 ;
   rtlcn890 <= rtlcs31 AND state(8) ;
   not_rtlcn2031 <= NOT rtlcn2031 ;
   not_rtlcn2032 <= NOT rtlcn2032 ;
   not_rtlcn2033 <= NOT rtlcn2033 ;
   not_rtlcn2034 <= NOT rtlcn2034 ;
   not_rtlcn2035 <= NOT rtlcn2035 ;
   rtlc9n4073 <= rtlcs25 when RCV_Command_Sync = '1' else not_rtlc9n3541 ;
   rtlc9n4211 <= rtlc9n4207 when RCV_Command_Sync = '1' else rtlcs25 ;
   rtlc9n4212 <= not_Start_Clean when RCV_Command_Sync = '1' else rtlcs25 ;
   rtlc9n4213 <= not_Start_Clean when RCV_Command_Sync = '1' else 
   not_rtlcs25 ;
   rtlc9n4214 <= rtlc9n4207 when RCV_Command_Sync = '1' else not_rtlcs25 ;
   rtlc3n59 <= CE AND RxRdy ;
   rtlcn2061 <= not_Timeout AND rtlcn397 ;
   rtlcn2063 <= not_Counter_is_37us AND state(3) ;
   not_CE <= NOT CE ;
   not_RxRdy_Plus4_5us <= NOT RxRdy_Plus4_5us ;
   rtlcn2066 <= not_RxRdy_Plus4_5us AND state(7) ;
   rtlcn2068 <= not_RxRdy AND rtlcn2053 ;
   not_RxRdy_Plus3us <= NOT RxRdy_Plus3us ;
   rtlc_3003_and_1111 : and_4u_4u port map ( a(3)=>not_Counter_is_37us, a(2)
      =>not_RxRdy_Plus3us, a(1)=>not_rtlc9n3883, a(0)=>state(5), d=>
      rtlcn2071);
   rtlc_3004_or_1112 : or_4u_4u port map ( a(3)=>not_CE, a(2)=>rtlcn2066, 
      a(1)=>rtlcn2068, a(0)=>rtlcn2071, d=>rtlcn2041);
   not_rtlcn2041 <= NOT rtlcn2041 ;
   not_rtlc9n4294 <= NOT rtlc9n4294 ;
   rtlc9n5026 <= CE AND not_rtlc9n4294 ;
   rtlcn2054 <= rtlc9n5580 OR state(0) ;
   rtlcn2073 <= CE AND rtlcn2054 ;
   rtlc9n5019 <= rtlc3n59 OR rtlcn2073 ;
   not_rtlc9_PS245_n4342 <= NOT rtlc9_PS245_n4342 ;
   not_rtlc9_PS247_n4356 <= NOT rtlc9_PS247_n4356 ;
   not_rtlc9_PS248_n4369 <= NOT rtlc9_PS248_n4369 ;
   not_rtlcs19 <= NOT rtlcs19 ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlc_3020_and_1113 : and_6u_6u port map ( a(5)=>CE, a(4)=>
      not_rtlc9_PS245_n4342, a(3)=>not_rtlc9_PS247_n4356, a(2)=>
      not_rtlc9_PS248_n4369, a(1)=>not_rtlcs19, a(0)=>not_rtlcs18, d=>
      rtlcn2079);
   rtlc9n4989 <= rtlc3n59 OR rtlcn2079 ;
   not_rtlc9n4292 <= NOT rtlc9n4292 ;
   rtlc9n4987 <= CE AND not_rtlc9n4292 ;
   not_rtlc9n4291 <= NOT rtlc9n4291 ;
   rtlc9n4981 <= CE AND not_rtlc9n4291 ;
   not_rtlc9n4290 <= NOT rtlc9n4290 ;
   rtlc9n4978 <= CE AND not_rtlc9n4290 ;
   not_rtlc9n4289 <= NOT rtlc9n4289 ;
   rtlc9n4977 <= CE AND not_rtlc9n4289 ;
   not_rtlc9n4288 <= NOT rtlc9n4288 ;
   rtlc9n4976 <= CE AND not_rtlc9n4288 ;
   not_rtlc9n4286 <= NOT rtlc9n4286 ;
   rtlc9n4974 <= CE AND not_rtlc9n4286 ;
   not_rtlc9n4285 <= NOT rtlc9n4285 ;
   rtlc9n4973 <= CE AND not_rtlc9n4285 ;
   not_rtlc9n4284 <= NOT rtlc9n4284 ;
   rtlc9n4972 <= CE AND not_rtlc9n4284 ;
   not_rtlc9n4282 <= NOT rtlc9n4282 ;
   rtlc9n4970 <= CE AND not_rtlc9n4282 ;
   not_rtlcn391 <= NOT rtlcn391 ;
   rtlc9n4963 <= not_rtlcn391 AND rtlc3n59 ;
   not_rtlcn386 <= NOT rtlcn386 ;
   rtlc9n4958 <= not_rtlcn386 AND rtlc3n59 ;
   rtlc9n4207 <= rtlcs38 AND not_Start_Clean ;
   rtlc_3051_or_1115 : or_4u_4u port map ( a(3)=>Counter_is_37us, a(2)=>
      rtlc9n3883, a(1)=>not_rtlc9n3898, a(0)=>not_RxRdy_Plus3us, d=>
      rtlc9n4269);
   rtlcn2048 <= not_RxRdy OR Timeout ;
   rtlcn2051 <= not_RxRdy OR Counter_is_21us ;
   rtlcn2100 <= RCV_CS AND rtlcn387 ;
   rtlcn2055 <= rtlcn2051 OR rtlcn2100 ;
   rtlcn2101 <= state(5) AND rtlc9n4269 ;
   rtlcn2102 <= state(3) AND rtlcn2057 ;
   rtlcn2103 <= rtlcn2048 AND rtlcn397 ;
   rtlcn2104 <= state(1) AND rtlcn2055 ;
   rtlc_3070_and_1119 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      rtlc9n4207, a(1)=>state(4), a(0)=>not_rtlcn1842, d=>rtlcn2107);
   not_rtlcn2042 <= NOT rtlcn2042 ;
   rtlc9n4955 <= CE AND not_rtlcn2042 ;
   not_rtlcn383 <= NOT rtlcn383 ;
   rtlc9n4936 <= not_rtlcn383 AND rtlc3n59 ;
   not_state_1 <= NOT state(1) ;
   not_rtlc9n4086 <= NOT rtlc9n4086 ;
   rtlcn2043 <= not_state_1 OR not_rtlc9n4086 ;
   not_state_0 <= NOT state(0) ;
   rtlcn2044 <= not_state_0 OR rtlc9n904 ;
   not_rtlc9n4214 <= NOT rtlc9n4214 ;
   rtlcn2047 <= not_rtlc9n4214 OR rtlcn1842 ;
   rtlcn2049 <= not_RxRdy OR rtlcn2044 ;
   not_state_4 <= NOT state(4) ;
   rtlc_3092_and_1122 : and_4u_4u port map ( a(3)=>not_Timeout, a(2)=>
      rtlcn2044, a(1)=>rtlc3n59, a(0)=>rtlcn2047, d=>rtlcn2116);
   rtlcn2052 <= rtlcn2115 OR rtlcn2116 ;
   not_No_Words_Message_9n55ss1 <= NOT No_Words_Message_9n55ss1 ;
   rtlc_3098_or_1124 : or_4u_4u port map ( a(3)=>rtlcn1842, a(2)=>
      not_RCV_Command_Sync, a(1)=>not_Start_Clean, a(0)=>rtlcn2048, d=>
      rtlc9n4243);
   not_rtlc9n4243 <= NOT rtlc9n4243 ;
   rtlcn2050 <= not_state_4 OR not_rtlc9n4243 ;
   rtlc_3101_and_1125 : and_5u_5u port map ( a(4)=>CE, a(3)=>rtlc9n5039, 
      a(2)=>rtlcn2043, a(1)=>rtlcn2045, a(0)=>rtlcn2050, d=>rtlcn1999);
   rtlc_3104_or_1126 : or_9u_9u port map ( a(8)=>state(6), a(7)=>state(7), 
      a(6)=>state(8), a(5)=>rtlcn2101, a(4)=>rtlcn2102, a(3)=>rtlcn2103, 
      a(2)=>rtlcn2104, a(1)=>rtlcn2105, a(0)=>rtlcn2107, d=>rtlcn2042);
   rtlcs3 <= counter(5) AND rtlcs11 ;
   rtlcs11 <= not_counter_4 AND rtlcs15 ;
   rtlcs26 <= rtlcs27 AND mode_message_9n1s5 ;
   not_rtlcn1803 <= NOT rtlcn1803 ;
   counter_9n59ss1(12) <= counter_9n56s1(12) AND not_rtlcn1803 ;
   counter_9n59ss1(11) <= counter_9n56s1(11) AND not_rtlcn1803 ;
   counter_9n59ss1(9) <= counter_9n56s1(9) AND not_rtlcn1803 ;
   counter_9n59ss1(8) <= counter_9n56s1(8) AND not_rtlcn1803 ;
   counter_9n59ss1(7) <= counter_9n56s1(7) AND not_rtlcn1803 ;
   counter_9n59ss1(6) <= counter_9n56s1(6) AND not_rtlcn1803 ;
   counter_9n59ss1(5) <= counter_9n56s1(5) AND not_rtlcn1803 ;
   counter_9n59ss1(4) <= counter_9n56s1(4) AND not_rtlcn1803 ;
   counter_9n59ss1(3) <= counter_9n56s1(3) AND not_rtlcn1803 ;
   counter_9n59ss1(2) <= counter_9n56s1(2) AND not_rtlcn1803 ;
   counter_9n59ss1(1) <= counter_9n56s1(1) AND not_rtlcn1803 ;
   counter_9n59ss1(0) <= counter_9n56s1(0) AND not_rtlcn1803 ;
   counter_9n59ss1(10) <= counter_9n56s1(10) AND not_rtlcn1803 ;
   not_counter_4 <= NOT counter(4) ;
   not_counter_3 <= NOT counter(3) ;
   not_counter_2 <= NOT counter(2) ;
   not_counter_1 <= NOT counter(1) ;
   not_counter_0 <= NOT counter(0) ;
   rtlc_3144_and_1128 : and_7u_7u port map ( a(6)=>not_counter_12, a(5)=>
      not_counter_11, a(4)=>not_counter_8, a(3)=>not_counter_3, a(2)=>
      not_counter_2, a(1)=>not_counter_1, a(0)=>not_counter_0, d=>rtlcs15);
   not_counter_6 <= NOT counter(6) ;
   rtlcs4 <= counter(7) AND not_counter_6 ;
   not_RCV_Gap_found_2 <= NOT RCV_Gap_found(2) ;
   not_RCV_Gap_found_1 <= NOT RCV_Gap_found(1) ;
   not_RCV_Gap_found_0 <= NOT RCV_Gap_found(0) ;
   mode_message_and_9i8 : and_5u_5u port map ( a(4)=>RCV_R_Data(9), a(3)=>
      RCV_R_Data(8), a(2)=>RCV_R_Data(7), a(1)=>RCV_R_Data(6), a(0)=>
      RCV_R_Data(5), d=>mode_message_9n1s3);
   not_RCV_R_Data_9 <= NOT RCV_R_Data(9) ;
   not_RCV_R_Data_8 <= NOT RCV_R_Data(8) ;
   not_RCV_R_Data_7 <= NOT RCV_R_Data(7) ;
   not_RCV_R_Data_6 <= NOT RCV_R_Data(6) ;
   not_RCV_R_Data_5 <= NOT RCV_R_Data(5) ;
   mode_message_and_9i9 : and_5u_5u port map ( a(4)=>not_RCV_R_Data_9, a(3)
      =>not_RCV_R_Data_8, a(2)=>not_RCV_R_Data_7, a(1)=>not_RCV_R_Data_6, 
      a(0)=>not_RCV_R_Data_5, d=>mode_message_9n1s5);
   rtlc_3163_and_1132 : and_5u_5u port map ( a(4)=>RCV_R_Data(15), a(3)=>
      RCV_R_Data(14), a(2)=>RCV_R_Data(13), a(1)=>RCV_R_Data(12), a(0)=>
      RCV_R_Data(11), d=>rtlcs30);
   rtlcs9 <= not_counter_10 AND not_counter_9 ;
   not_counter_5 <= NOT counter(5) ;
   rtlc_3174_and_1134 : and_4u_4u port map ( a(3)=>rtlc9n5580, a(2)=>
      No_Response_timeout(2), a(1)=>No_Response_timeout(1), a(0)=>
      not_No_Response_timeout_0, d=>rtlcs18);
   rtlc_3184_and_1136 : and_5u_5u port map ( a(4)=>first_RT_command(15), 
      a(3)=>first_RT_command(14), a(2)=>first_RT_command(13), a(1)=>
      first_RT_command(12), a(0)=>first_RT_command(11), d=>rtlcs21);
   active_command_9n55ss1_4 <= RCV_R_Data(4) AND rtlcn663 ;
   rtlcn2034 <= rtlc9n3696 OR rtlcn1829 ;
   not_active_command_3 <= NOT active_command_3_EXMPLR2001 ;
   not_active_command_2 <= NOT active_command_2_EXMPLR2002 ;
   not_active_command_1 <= NOT active_command_1_EXMPLR2003 ;
   rtlc_3191_and_1137 : and_5u_5u port map ( a(4)=>not_active_command_4, 
      a(3)=>not_active_command_3, a(2)=>not_active_command_2, a(1)=>
      not_active_command_1, a(0)=>active_command_0_EXMPLR2004, d=>rtlcs24);
   rtlcn2035 <= rtlc9n3541 OR rtlcn1831 ;
   Word_number_9n55ss1(3) <= Word_number_9n30s1(3) AND rtlcn841 ;
   Word_number_9n55ss1(2) <= Word_number_9n30s1(2) AND rtlcn841 ;
   Word_number_9n55ss1(1) <= Word_number_9n30s1(1) AND rtlcn841 ;
   not_rtlcn841 <= NOT rtlcn841 ;
   Word_number_9n55ss1(0) <= Word_number_9n30s1(0) OR not_rtlcn841 ;
   Word_number_9n55ss1(4) <= Word_number_9n30s1(4) AND rtlcn841 ;
   BCR_message_and_0i1 : and_5u_5u port map ( a(4)=>
      active_command_15_EXMPLR1989, a(3)=>active_command_14_EXMPLR1990, a(2)
      =>active_command_13_EXMPLR1991, a(1)=>active_command_12_EXMPLR1992, 
      a(0)=>active_command_11_EXMPLR1993, d=>BCR_message_0n0s2);
   rtlcn2031 <= rtlcn674 OR rtlcn676 ;
   not_RCV_RAW_GAP_6 <= NOT RCV_RAW_GAP(6) ;
   not_RCV_RAW_GAP_5 <= NOT RCV_RAW_GAP(5) ;
   not_RCV_RAW_GAP_4 <= NOT RCV_RAW_GAP(4) ;
   not_RCV_RAW_GAP_3 <= NOT RCV_RAW_GAP(3) ;
   not_RCV_RAW_GAP_2 <= NOT RCV_RAW_GAP(2) ;
   not_RCV_RAW_GAP_1 <= NOT RCV_RAW_GAP(1) ;
   not_RCV_RAW_GAP_0 <= NOT RCV_RAW_GAP(0) ;
   rtlc_3212_and_1139 : and_7u_7u port map ( a(6)=>not_RCV_RAW_GAP_6, a(5)=>
      not_RCV_RAW_GAP_5, a(4)=>not_RCV_RAW_GAP_4, a(3)=>not_RCV_RAW_GAP_3, 
      a(2)=>not_RCV_RAW_GAP_2, a(1)=>not_RCV_RAW_GAP_1, a(0)=>
      not_RCV_RAW_GAP_0, d=>rtlcs31);
   rtlcn388 <= not_rtlcs38 OR not_RCV_R_Data_10 ;
   rtlcn387 <= rtlc9n4041 OR not_RCV_Command_Sync ;
   rtlcs27 <= not_RCV_R_Data_10 AND not_RCV_R_Data_4 ;
   Monitor_ended_OK_9n55ss1 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1038 ;
   rtlcn2033 <= rtlcn1745 OR rtlcn1038 ;
   MIL1553_ERRORS_9n17ss1(0) <= MIL1553_ERRORS_9n22ss1(0) AND 
   not_RCV_Command_Sync ;
   GOOD_Data_Block_9n55ss1 <= MIL1553_ERRORS_9n17ss1(0) AND rtlcn1144 ;
   rtlcn1798 <= rtlc9n3696 OR RCV_Command_Sync ;
   MIL1553_ERRORS_9n55ss1_2 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1173 ;
   MIL1553_ERRORS_9n55ss1_3 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1190 ;
   rtlcn394 <= rtlcs25 OR not_RCV_Command_Sync ;
   rtlcn2032 <= state(0) OR rtlcn1222 ;
   MIL1553_ERRORS_9n55ss1_7 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1227 ;
   MIL1553_ERRORS_9n55ss1_8 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1237 ;
   MIL1553_ERRORS_9n55ss1_11 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1246 ;
   MIL1553_ERRORS_9n55ss1_4 <= NOT rtlcn2326 ;
   rtlcn2326 <= Error_in_message OR rtlcn1208 ;
   rtlcn2092 <= rtlcs40 AND rtlc9n5757 ;
   modgen_counter_Energy_Count : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 port map ( clock=>C, 
      q(9)=>Energy_Count(9), q(8)=>Energy_Count(8), q(7)=>Energy_Count(7), 
      q(6)=>Energy_Count(6), q(5)=>Energy_Count(5), q(4)=>Energy_Count(4), 
      q(3)=>Energy_Count(3), q(2)=>Energy_Count(2), q(1)=>Energy_Count(1), 
      q(0)=>Energy_Count(0), clk_en=>CE, aclear=>not_R, sload=>
      Address_6_EXMPLR2028, data(9)=>DANGLING(2), data(8)=>DANGLING(3), 
      data(7)=>DANGLING(4), data(6)=>DANGLING(5), data(5)=>DANGLING(6), 
      data(4)=>DANGLING(7), data(3)=>DANGLING(8), data(2)=>DANGLING(9), 
      data(1)=>DANGLING(10), data(0)=>DANGLING(11), aset=>
      Address_6_EXMPLR2028, sclear=>RxRdy, updn=>PWR, cnt_en=>rtlc6n36);
   rtlceq_s68_eq_1140 : eq_5u_5u port map ( a(4)=>first_RT_command(15), a(3)
      =>first_RT_command(14), a(2)=>first_RT_command(13), a(1)=>
      first_RT_command(12), a(0)=>first_RT_command(11), b(4)=>RCV_R_Data(15), 
      b(3)=>RCV_R_Data(14), b(2)=>RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)
      =>RCV_R_Data(11), d=>rtlcs38);
   rtlceq_s70_eq_1141 : eq_5u_5u port map ( a(4)=>Word_number(4), a(3)=>
      Word_number(3), a(2)=>Word_number(2), a(1)=>Word_number(1), a(0)=>
      Word_number(0), b(4)=>active_command_4_EXMPLR2000, b(3)=>
      active_command_3_EXMPLR2001, b(2)=>active_command_2_EXMPLR2002, b(1)=>
      active_command_1_EXMPLR2003, b(0)=>active_command_0_EXMPLR2004, d=>
      rtlcs39);
   rtlceq_s72_eq_1142 : eq_5u_5u port map ( a(4)=>
      active_command_15_EXMPLR1989, a(3)=>active_command_14_EXMPLR1990, a(2)
      =>active_command_13_EXMPLR1991, a(1)=>active_command_12_EXMPLR1992, 
      a(0)=>active_command_11_EXMPLR1993, b(4)=>RCV_R_Data(15), b(3)=>
      RCV_R_Data(14), b(2)=>RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)=>
      RCV_R_Data(11), d=>rtlcs40);
   DFFPCE (rtlcn890,not_R,Address_6_EXMPLR2028,not_rtlcn2041,C,state(8)) ;
   DFFPCE (rtlcn887,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(7)) ;
   DFFPCE (rtlcn881,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(6)) ;
   DFFPCE (rtlcn1707,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(5)) ;
   DFFPCE (rtlcn1695,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(4)) ;
   DFFPCE (rtlcn762,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(3)) ;
   DFFPCE (rtlcn1730,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(2)) ;
   DFFPCE (rtlcn1712,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(1)) ;
   DFFPCE (rtlcn461,Address_6_EXMPLR2028,not_R,not_rtlcn2041,C,state(0)) ;
   DFFPCE (Start_Clean_9n55ss1,not_R,Address_6_EXMPLR2028,rtlc9n5026,C,
   Start_Clean) ;
   DFFPCE (Counter_is_37us_9n59s1,Address_6_EXMPLR2028,not_R,CE,C,
   Counter_is_37us) ;
   DFFPCE (Counter_is_21us_9n59s1,Address_6_EXMPLR2028,not_R,CE,C,
   Counter_is_21us) ;
   DFFPCE (RxRdy_Plus4_5us_9n59s1,Address_6_EXMPLR2028,not_R,CE,C,
   RxRdy_Plus4_5us) ;
   DFFPCE (RxRdy_Plus_2us_9n59s1,Address_6_EXMPLR2028,not_R,CE,C,
   RxRdy_Plus_2us) ;
   DFFPCE (counter_9n59ss1(12),not_R,Address_6_EXMPLR2028,rtlc9n5019,C,
   counter(12)) ;
   DFFPCE (counter_9n59ss1(11),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(11)) ;
   DFFPCE (counter_9n59ss1(10),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(10)) ;
   DFFPCE (counter_9n59ss1(9),not_R,Address_6_EXMPLR2028,rtlc9n5019,C,
   counter(9)) ;
   DFFPCE (counter_9n59ss1(8),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(8)) ;
   DFFPCE (counter_9n59ss1(7),not_R,Address_6_EXMPLR2028,rtlc9n5019,C,
   counter(7)) ;
   DFFPCE (counter_9n59ss1(6),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(6)) ;
   DFFPCE (counter_9n59ss1(5),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(5)) ;
   DFFPCE (counter_9n59ss1(4),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(4)) ;
   DFFPCE (counter_9n59ss1(3),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(3)) ;
   DFFPCE (counter_9n59ss1(2),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(2)) ;
   DFFPCE (counter_9n59ss1(1),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(1)) ;
   DFFPCE (counter_9n59ss1(0),Address_6_EXMPLR2028,not_R,rtlc9n5019,C,
   counter(0)) ;
   DFFPCE (RxRdy_Plus3us_9n59s1,Address_6_EXMPLR2028,not_R,CE,C,
   RxRdy_Plus3us) ;
   DFFPCE (not_RxRdy,Address_6_EXMPLR2028,not_R,rtlc9n4989,C,Timeout) ;
   DFFPCE (GOOD_Data_Block_9n55ss1,Address_6_EXMPLR2028,not_R,rtlc9n4987,C,
   GOOD_Data_Block) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_11,Address_6_EXMPLR2028,not_R,rtlc9n4981,C,
   MIL1553_ERRORS_Address_Parity) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_8,Address_6_EXMPLR2028,not_R,rtlc9n4978,C,
   MIL1553_ERRORS_high_word_count) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_7,Address_6_EXMPLR2028,not_R,rtlc9n4977,C,
   MIL1553_ERRORS_Low_word_count) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_6,Address_6_EXMPLR2028,not_R,rtlc9n4976,C,
   MIL1553_ERRORS_incorrect_data_sync) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_4,Address_6_EXMPLR2028,not_R,rtlc9n4974,C,
   MIL1553_ERRORS_Invalid_word) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_3,Address_6_EXMPLR2028,not_R,rtlc9n4973,C,
   MIL1553_ERRORS_RT2RT_format_error) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_2,Address_6_EXMPLR2028,not_R,rtlc9n4972,C,
   MIL1553_ERRORS_RT2RT_format_gap) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_0,Address_6_EXMPLR2028,not_R,rtlc9n4970,C,
   MIL1553_ERRORS_Inhibit_TF) ;
   DFFPCE (Word_number_9n55ss1(4),Address_6_EXMPLR2028,not_R,rtlc9n4963,C,
   Word_number(4)) ;
   DFFPCE (Word_number_9n55ss1(3),Address_6_EXMPLR2028,not_R,rtlc9n4963,C,
   Word_number(3)) ;
   DFFPCE (Word_number_9n55ss1(2),Address_6_EXMPLR2028,not_R,rtlc9n4963,C,
   Word_number(2)) ;
   DFFPCE (Word_number_9n55ss1(1),Address_6_EXMPLR2028,not_R,rtlc9n4963,C,
   Word_number(1)) ;
   DFFPCE (Word_number_9n55ss1(0),Address_6_EXMPLR2028,not_R,rtlc9n4963,C,
   Word_number(0)) ;
   DFFPCE (mode_message_9n8s1,Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   mode_message) ;
   DFFPCE (rtlcn663,Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   RT2RT_message_EXMPLR2009) ;
   DFFPCE (rtlcn1741,Address_6_EXMPLR2028,not_R,CE,C,new_command) ;
   DFFPCE (not_rtlcn1825,Address_6_EXMPLR2028,not_R,rtlc9n4955,C,
   Error_in_message) ;
   DFFPCE (Monitor_ended_not_OK_9n55ss1,Address_6_EXMPLR2028,not_R,CE,C,
   Monitor_ended_not_OK) ;
   DFFPCE (Monitor_ended_OK_9n55ss1,Address_6_EXMPLR2028,not_R,CE,C,
   Monitor_ended_OK) ;
   DFFPCE (RCV_R_Data(15),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_15_EXMPLR1989) ;
   DFFPCE (RCV_R_Data(14),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_14_EXMPLR1990) ;
   DFFPCE (RCV_R_Data(13),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_13_EXMPLR1991) ;
   DFFPCE (RCV_R_Data(12),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_12_EXMPLR1992) ;
   DFFPCE (RCV_R_Data(11),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_11_EXMPLR1993) ;
   DFFPCE (RCV_R_Data(10),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_10_EXMPLR1994) ;
   DFFPCE (RCV_R_Data(9),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command(9)) ;
   DFFPCE (RCV_R_Data(8),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command(8)) ;
   DFFPCE (RCV_R_Data(7),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command(7)) ;
   DFFPCE (RCV_R_Data(6),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command(6)) ;
   DFFPCE (RCV_R_Data(5),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command(5)) ;
   DFFPCE (active_command_9n55ss1_4,Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_4_EXMPLR2000) ;
   DFFPCE (RCV_R_Data(3),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_3_EXMPLR2001) ;
   DFFPCE (RCV_R_Data(2),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_2_EXMPLR2002) ;
   DFFPCE (RCV_R_Data(1),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_1_EXMPLR2003) ;
   DFFPCE (RCV_R_Data(0),Address_6_EXMPLR2028,not_R,rtlc9n4958,C,
   active_command_0_EXMPLR2004) ;
   DFFPCE (RCV_R_Data(15),Address_6_EXMPLR2028,not_R,rtlc9n4936,C,
   first_RT_command(15)) ;
   DFFPCE (RCV_R_Data(14),Address_6_EXMPLR2028,not_R,rtlc9n4936,C,
   first_RT_command(14)) ;
   DFFPCE (RCV_R_Data(13),Address_6_EXMPLR2028,not_R,rtlc9n4936,C,
   first_RT_command(13)) ;
   DFFPCE (RCV_R_Data(12),Address_6_EXMPLR2028,not_R,rtlc9n4936,C,
   first_RT_command(12)) ;
   DFFPCE (RCV_R_Data(11),Address_6_EXMPLR2028,not_R,rtlc9n4936,C,
   first_RT_command(11)) ;
   DFFPCE (rtlcn1750,Address_6_EXMPLR2028,not_R,CE,C,Write_Req) ;
   DFFPCE (No_Words_Message_9n55ss1,Address_6_EXMPLR2028,not_R,rtlcn324,C,
   No_Words_Message) ;
   DFFPCE (No_Words_Message_9n55ss1,Address_6_EXMPLR2028,not_R,rtlcn1999,C,
   MIL1553_ERRORS_invalid_command) ;
   rtlc9_1618_or_1024_nx0 <= state(0) OR state(1) ;
   rtlc9n5039 <= rtlc9_1618_or_1024_nx0 OR state(4) ;
   rtlc9_1779_or_1036_nx0 <= rtlc9n3883 OR rtlc9n4257 ;
   rtlc9n4266 <= rtlc9_1779_or_1036_nx0 OR not_RxRdy_Plus3us ;
   rtlc9_1780_or_1037_nx0 <= not_rtlcn204 OR not_RxRdy ;
   rtlc9n4011 <= rtlc9_1780_or_1037_nx0 OR not_Start_Clean ;
   rtlc9_1868_or_1038_nx0 <= Counter_is_37us OR rtlc9n4186 ;
   rtlc9n4200 <= rtlc9_1868_or_1038_nx0 OR not_RxRdy ;
   rtlcn1827 <= not_RCV_Command_Sync OR not_RCV_CS ;
   rtlc9n4216 <= rtlcn1827 OR not_Start_Clean ;
   rtlc9_1900_or_1041_nx0 <= not_RxRdy OR not_RCV_Command_Sync ;
   rtlc9n4077 <= rtlc9_1900_or_1041_nx0 OR rtlcs25 ;
   rtlc9_1918_or_1045_nx0 <= rtlc9n4219 OR not_RxRdy ;
   rtlc9n4236 <= rtlc9_1918_or_1045_nx0 OR not_rtlc9n4826 ;
   rtlc9_1919_or_1046_nx0 <= RCV_CS OR rtlc9n4154 ;
   rtlc9n4189 <= rtlc9_1919_or_1046_nx0 OR not_RxRdy ;
   rtlc9_1920_or_1047_nx0 <= RCV_CS OR not_RxRdy ;
   rtlc9n4132 <= rtlc9_1920_or_1047_nx0 OR not_rtlc9n4826 ;
   rtlc9_1932_or_1050_nx0 <= rtlc9n4218 OR not_RxRdy ;
   rtlc9n4235 <= rtlc9_1932_or_1050_nx0 OR not_rtlc9n4826 ;
   rtlc9_1933_or_1051_nx0 <= rtlc9n4101 OR not_RxRdy ;
   rtlc9n4130 <= rtlc9_1933_or_1051_nx0 OR not_rtlc9n4826 ;
   rtlc9_1944_or_1054_nx0 <= Counter_is_21us OR rtlc9n4073 ;
   rtlc9n4091 <= rtlc9_1944_or_1054_nx0 OR not_RxRdy ;
   rtlc9_2356_gt_1058_nx0 <= RCV_Gap_found(0) XOR No_Response_timeout(0) ;
   rtlc9_2356_gt_1058_nx2 <= RCV_Gap_found(1) XOR No_Response_timeout(1) ;
   rtlc9_2356_gt_1058_nx4 <= RCV_Gap_found(2) XOR No_Response_timeout(2) ;
   rtlc9n5625 <= counter(8) OR counter(9) ;
   rtlc9n5680 <= rtlc9n5625 OR counter(10) ;
   rtlc_542_or_1067_nx0 <= Counter_is_21us OR not_RCV_Command_Sync ;
   rtlcn381 <= rtlc_542_or_1067_nx0 OR rtlcs25 ;
   rtlc_545_or_1068_nx0 <= Counter_is_21us OR rtlc9n4040 ;
   rtlcn384 <= rtlc_545_or_1068_nx0 OR not_RCV_Command_Sync ;
   rtlc_2605_and_1078_nx0 <= RxRdy AND rtlcn1830 ;
   rtlcn1886 <= rtlc_2605_and_1078_nx0 AND rtlcn1853 ;
   rtlc_2616_and_1080_nx0 <= RxRdy_Plus3us AND rtlcn1836 ;
   rtlcn1892 <= rtlc_2616_and_1080_nx0 AND not_rtlcn1843 ;
   rtlc_2633_and_1082_nx0 <= not_rtlc9n3898 AND rtlcn1836 ;
   rtlcn1901 <= rtlc_2633_and_1082_nx0 AND rtlcn1845 ;
   rtlcn1902 <= rtlc9n4040 AND rtlcn1853 ;
   rtlc_2646_and_1085_nx0 <= state(3) AND RCV_CS ;
   rtlcn1906 <= rtlc_2646_and_1085_nx0 AND not_rtlc9n4154 ;
   rtlc_2662_or_1086_nx0 <= state(0) OR rtlcn1913 ;
   rtlcn1208 <= rtlc_2662_or_1086_nx0 OR rtlcn1914 ;
   rtlc_2676_and_1090_nx0 <= Start_Clean AND not_rtlcn1842 ;
   rtlcn1923 <= rtlc_2676_and_1090_nx0 AND rtlcn1178 ;
   rtlc_2686_and_1091_nx0 <= rtlcs25 AND not_rtlcn1842 ;
   rtlcn1929 <= rtlc_2686_and_1091_nx0 AND rtlcn1178 ;
   rtlc_2691_and_1092_nx0 <= rtlcn1176 AND RT2RT_message_EXMPLR2009 ;
   rtlcn1933 <= rtlc_2691_and_1092_nx0 AND rtlc9n4113 ;
   rtlc_2693_and_1093_nx0 <= not_rtlc9n913 AND rtlc9n904 ;
   rtlcn1935 <= rtlc_2693_and_1093_nx0 AND rtlcn1828 ;
   rtlc_2700_or_1095_nx0 <= rtlcn1842 OR rtlcn1937 ;
   rtlcn1856 <= rtlc_2700_or_1095_nx0 OR rtlcn1938 ;
   rtlc_2710_and_1096_nx0 <= rtlcn1176 AND not_RT2RT_message ;
   rtlcn1947 <= rtlc_2710_and_1096_nx0 AND rtlc9n4113 ;
   rtlc_2712_and_1097_nx0 <= rtlc9n3541 AND BCR_message_0n0s2 ;
   rtlcn1949 <= rtlc_2712_and_1097_nx0 AND not_rtlcn1831 ;
   rtlc_2727_or_1099_nx0 <= rtlcn1899 OR rtlcn1956 ;
   rtlcn1825 <= rtlc_2727_or_1099_nx0 OR rtlcn1957 ;
   rtlc_2731_and_1101_nx0 <= RCV_Command_Sync AND not_rtlcn1830 ;
   rtlcn1959 <= rtlc_2731_and_1101_nx0 AND rtlcn1212 ;
   rtlc_2732_and_1102_nx0 <= RCV_R_Data(10) AND not_rtlc9n876 ;
   rtlcn1960 <= rtlc_2732_and_1102_nx0 AND rtlcn1857 ;
   rtlc_2742_or_1104_nx0 <= No_Words_Message_9n55ss1 OR rtlcn1885 ;
   rtlcn1741 <= rtlc_2742_or_1104_nx0 OR rtlcn1965 ;
   rtlc_2769_or_1107_nx0 <= rtlcn1979 OR not_rtlcn2034 ;
   rtlcn762 <= rtlc_2769_or_1107_nx0 OR not_rtlcn2035 ;
   rtlc_2776_and_1108_nx0 <= not_Counter_is_37us AND rtlcn1836 ;
   rtlcn1989 <= rtlc_2776_and_1108_nx0 AND rtlcn1843 ;
   rtlc_2995_or_1110_nx0 <= rtlcn1212 OR rtlcn2061 ;
   rtlcn2053 <= rtlc_2995_or_1110_nx0 OR rtlcn2063 ;
   rtlc_3047_and_1114_nx0 <= RCV_CS AND rtlcn2092 ;
   rtlc9n4101 <= rtlc_3047_and_1114_nx0 AND RCV_Command_Sync ;
   rtlc_3058_and_1116_nx0 <= RCV_CS AND not_RCV_Command_Sync ;
   rtlcn2099 <= rtlc_3058_and_1116_nx0 AND not_rtlc9n4154 ;
   rtlc_3059_or_1117_nx0 <= Counter_is_37us OR not_RxRdy ;
   rtlcn2057 <= rtlc_3059_or_1117_nx0 OR rtlcn2099 ;
   rtlc_3068_and_1118_nx0 <= rtlc9n4101 AND rtlc9n4826 ;
   rtlcn2105 <= rtlc_3068_and_1118_nx0 AND state(2) ;
   rtlc_3081_or_1120_nx0 <= not_RCV_Command_Sync OR rtlcn2051 ;
   rtlc9n4086 <= rtlc_3081_or_1120_nx0 OR rtlcs25 ;
   rtlc_3091_and_1121_nx0 <= CE AND not_state_4 ;
   rtlcn2115 <= rtlc_3091_and_1121_nx0 AND rtlcn2049 ;
   rtlc_3095_and_1123_nx0 <= rtlc9n5039 AND rtlcn2043 ;
   rtlcn324 <= rtlc_3095_and_1123_nx0 AND rtlcn2052 ;
   rtlc_3105_or_1127_nx0 <= not_RCV_CS OR not_rtlcn1837 ;
   rtlcn2045 <= rtlc_3105_or_1127_nx0 OR not_No_Words_Message_9n55ss1 ;
   rtlc_3150_and_1129_nx0 <= not_RCV_Gap_found_2 AND not_RCV_Gap_found_1 ;
   rtlcs25 <= rtlc_3150_and_1129_nx0 AND not_RCV_Gap_found_0 ;
   rtlcs8 <= not_counter_7 AND counter(6) ;
   not_rtlc9n4826 <= RCV_Gap_found(2) when rtlc9_2356_gt_1058_nx4
    = '1' else nx5 ;
   nx5 <= RCV_Gap_found(1) when rtlc9_2356_gt_1058_nx2 = '1' else nx8 ;
   nx8 <= RCV_Gap_found(0) AND rtlc9_2356_gt_1058_nx0 ;
   modgen_and_2 : and_5u_5u port map ( a(4)=>not_counter_10, a(3)=>
      counter(9), a(2)=>rtlcs3, a(1)=>rtlcs4, a(0)=>not_RxRdy, d=>
      Counter_is_21us_9n59s1);
   modgen_and_3 : and_4u_4u port map ( a(3)=>not_counter_9, a(2)=>
      counter(10), a(1)=>rtlcs3, a(0)=>rtlcs4, d=>Counter_is_37us_9n59s1);
   modgen_and_4 : and_3u_3u port map ( a(2)=>rtlcs3, a(1)=>rtlcs8, a(0)=>
      rtlcs9, d=>RxRdy_Plus3us_9n59s1);
   modgen_and_5 : and_4u_4u port map ( a(3)=>rtlcs8, a(2)=>not_counter_5, 
      a(1)=>rtlcs9, a(0)=>rtlcs11, d=>RxRdy_Plus_2us_9n59s1);
   modgen_and_6 : and_5u_5u port map ( a(4)=>not_counter_5, a(3)=>counter(4), 
      a(2)=>rtlcs15, a(1)=>rtlcs4, a(0)=>rtlcs9, d=>RxRdy_Plus4_5us_9n59s1);
   modgen_and_7 : and_3u_3u port map ( a(2)=>state(5), a(1)=>
      not_Counter_is_37us, a(0)=>rtlc9n3883, d=>rtlcn887);
   modgen_and_8 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5662, a(2)=>not_No_Response_timeout_0, a(1)=>
      not_No_Response_timeout_1, a(0)=>No_Response_timeout(2), d=>
      rtlc9_PS248_n4369);
   modgen_and_9 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5633, a(2)=>No_Response_timeout(0), a(1)=>No_Response_timeout(1), 
      a(0)=>not_No_Response_timeout_2, d=>rtlc9_PS247_n4356);
   modgen_and_10 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5604, a(2)=>not_No_Response_timeout_0, a(1)=>
      No_Response_timeout(1), a(0)=>not_No_Response_timeout_2, d=>
      rtlc9_PS245_n4342);
   modgen_or_11 : or_5u_5u port map ( a(4)=>counter(6), a(3)=>counter(7), 
      a(2)=>counter(8), a(1)=>counter(9), a(0)=>counter(5), d=>rtlcn198);
   modgen_and_12 : and_5u_5u port map ( a(4)=>No_Response_timeout(2), a(3)=>
      not_No_Response_timeout_1, a(2)=>No_Response_timeout(0), a(1)=>
      not_counter_12, a(0)=>rtlc9n5688, d=>rtlcs19);
end SITAL_Technology_unfold_1 ;


architecture INTERFACE_unfold_3 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_10u_10u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic_vector (9 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx25, nx28, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, 
      nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, PWR, 
      NOT_nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(9) <= nx32 ;
   q(8) <= nx34 ;
   q(7) <= nx36 ;
   q(6) <= nx38 ;
   q(5) <= nx40 ;
   q(4) <= nx42 ;
   q(3) <= nx44 ;
   q(2) <= nx46 ;
   q(1) <= nx48 ;
   q(0) <= nx50 ;
   GND <= '0' ;
   nx25 <= cnt_en OR sclear ;
   nx28 <= nx25 AND clk_en ;
   DFFPCE (nx31,GND,aclear,nx28,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx28,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx28,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx28,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,nx28,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,nx28,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,nx28,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,nx28,clock,nx46) ;
   DFFPCE (nx47,GND,aclear,nx28,clock,nx48) ;
   DFFPCE (nx49,GND,aclear,nx28,clock,nx50) ;
   inc : inc_10u_10u_0_0 port map ( cin=>PWR, a(9)=>nx32, a(8)=>nx34, a(7)=>
      nx36, a(6)=>nx38, a(5)=>nx40, a(4)=>nx42, a(3)=>nx44, a(2)=>nx46, a(1)
      =>nx48, a(0)=>nx50, d(9)=>nx51, d(8)=>nx52, d(7)=>nx53, d(6)=>nx54, 
      d(5)=>nx55, d(4)=>nx56, d(3)=>nx57, d(2)=>nx58, d(1)=>nx59, d(0)=>nx60, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx24 <= NOT sclear ;
   nx31 <= nx51 AND NOT_nx24 ;
   nx33 <= nx52 AND NOT_nx24 ;
   nx35 <= nx53 AND NOT_nx24 ;
   nx37 <= nx54 AND NOT_nx24 ;
   nx39 <= nx55 AND NOT_nx24 ;
   nx41 <= nx56 AND NOT_nx24 ;
   nx43 <= nx57 AND NOT_nx24 ;
   nx45 <= nx58 AND NOT_nx24 ;
   nx47 <= nx59 AND NOT_nx24 ;
   nx49 <= nx60 AND NOT_nx24 ;
end INTERFACE_unfold_3 ;


architecture SITAL_Technology_unfold_3816 of Monitor_Stm_8_4_1_32 is 
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_5_5
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_6_6
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_9_9
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         b : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_5u_5u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component inc_13u_13u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (12 DOWNTO 0) ;
         d : OUT std_logic_vector (12 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_7_7
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         b : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (9 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (9 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component eq_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_Energy_Count : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10(INTERFACE_unfold_3);
   signal active_command_15_EXMPLR2082, active_command_14_EXMPLR2083, 
      active_command_13_EXMPLR2084, active_command_12_EXMPLR2085, 
      active_command_11_EXMPLR2086, active_command_10_EXMPLR2087, 
      active_command_4_EXMPLR2093, active_command_3_EXMPLR2094, 
      active_command_2_EXMPLR2095, active_command_1_EXMPLR2096, 
      active_command_0_EXMPLR2097, RT2RT_message_EXMPLR2102, Start_Clean, 
      mode_message: std_logic ;
   
   signal first_RT_command: std_logic_vector (15 DOWNTO 11) ;
   
   signal Word_number: std_logic_vector (4 DOWNTO 0) ;
   
   signal RxRdy, Timeout, Error_in_message, GOOD_Data_Block, 
      No_Words_Message: std_logic ;
   
   signal Energy_Count: std_logic_vector (9 DOWNTO 0) ;
   
   signal counter: std_logic_vector (12 DOWNTO 0) ;
   
   signal RxRdy_Plus3us, RxRdy_Plus_2us, RxRdy_Plus4_5us, Counter_is_21us, 
      Counter_is_37us: std_logic ;
   
   signal state: std_logic_vector (8 DOWNTO 0) ;
   
   signal PWR, BCR_message_0n0s2, Address_6_EXMPLR2121, not_R, rtlc3n59, 
      rtlc6n36, not_Energy_Count_9, rtlc6n159, rtlc6n161, not_rtlcn205, 
      rtlc6n164: std_logic ;
   
   signal MIL1553_ERRORS_9n17ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n22ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n51ss1: std_logic_vector (0 DOWNTO 0) ;
   
   signal active_command_9n55ss1_4, Monitor_ended_OK_9n55ss1, 
      Monitor_ended_not_OK_9n55ss1: std_logic ;
   
   signal Word_number_9n55ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal MIL1553_ERRORS_9n55ss1_11, MIL1553_ERRORS_9n55ss1_8, 
      MIL1553_ERRORS_9n55ss1_7, MIL1553_ERRORS_9n55ss1_6, 
      MIL1553_ERRORS_9n55ss1_4, MIL1553_ERRORS_9n55ss1_3, 
      MIL1553_ERRORS_9n55ss1_2, MIL1553_ERRORS_9n55ss1_0, 
      GOOD_Data_Block_9n55ss1, No_Words_Message_9n55ss1, Start_Clean_9n55ss1
   : std_logic ;
   
   signal counter_9n59ss1: std_logic_vector (12 DOWNTO 0) ;
   
   signal rtlc9n3352, not_rtlcs26, rtlc9n3360, not_MODE_CODE1553A, 
      mode_message_9n8s2, mode_message_9n8s1, rtlc9n3541, not_rtlc9n3541: 
   std_logic ;
   
   signal Word_number_9n30s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc9n3696, rtlc9n3700, rtlc9n3710, rtlc9n3737, not_rtlc9n3737, 
      rtlc9n3871, rtlc9n3880, rtlc9n3883, rtlc9n3896, rtlc9n3898, rtlc9n3914, 
      rtlc9n3916, not_RCV_recieving, not_rtlcn204, rtlc9n4008, rtlc9n4010, 
      rtlc9n4011, not_rtlcs38, rtlc9n4035, rtlc9n4040, rtlc9n4041, 
      rtlc9n4042, rtlc9n4072, rtlc9n4073, rtlc9n4075, rtlc9n4077, rtlc9n4083, 
      rtlc9n4086, rtlc9n4091, rtlc9n4092, rtlc9n4101, not_active_command_4, 
      rtlc9n4112, rtlc9n4113, not_RT2RT_message, not_rtlc9n4113, rtlc9n4130, 
      rtlc9n4132, rtlc9n4134, rtlc9n4140, rtlc9n4142, rtlc9n4154, 
      not_rtlcn1798, rtlc9n4181, rtlc9n4186, rtlc9n4189, rtlc9n4191, 
      rtlc9n4198, rtlc9n4200, rtlc9n4207, rtlc9n4209, rtlc9n4211, rtlc9n4212, 
      rtlc9n4213, rtlc9n4214, rtlc9n4216, rtlc9n4218, rtlc9n4219, rtlc9n4230, 
      rtlc9n4233, rtlc9n4235, rtlc9n4236, rtlc9n4239, rtlc9n4243, rtlc9n4245, 
      rtlc9n4248, rtlc9n4249, rtlc9n4254, rtlc9n4257, rtlc9n4265, rtlc9n4266, 
      rtlc9n4269, rtlc9n4270, rtlc9n4271, rtlc9n4282, rtlc9n4284, rtlc9n4285, 
      rtlc9n4286, rtlc9n4288, rtlc9n4289, rtlc9n4290, rtlc9n4291, rtlc9n4292, 
      rtlc9n4294, rtlc9_PS245_n4342, rtlc9_PS247_n4356, 
      not_No_Response_timeout_2, rtlc9_PS248_n4369, 
      not_No_Response_timeout_0, not_No_Response_timeout_1: std_logic ;
   
   signal counter_9n56s1: std_logic_vector (12 DOWNTO 0) ;
   
   signal RxRdy_Plus3us_9n59s1, RxRdy_Plus_2us_9n59s1, 
      RxRdy_Plus4_5us_9n59s1, not_RxRdy, Counter_is_21us_9n59s1, 
      Counter_is_37us_9n59s1, rtlc9n4826, not_rtlc9n5039, not_rtlc9n4908, 
      rtlc9n4906, rtlc9n4908, rtlc9n4936, rtlc9n4955, rtlc9n4958, rtlc9n4963, 
      rtlc9n4970, rtlc9n4972, rtlc9n4973, rtlc9n4974, rtlc9n4976, rtlc9n4977, 
      rtlc9n4978, rtlc9n4981, rtlc9n4987, rtlc9n4989, rtlc9n5019, rtlc9n5026, 
      not_rtlcn2041, rtlc9n5039, rtlc9n5043, not_rtlc9n5043, rtlc9n5047, 
      rtlc9n5051, not_rtlc9n5051, mode_message_9n1s3, mode_message_9n1s5, 
      not_mode_message_9n1s5, rtlc9n867, not_mode_message_9n1s3, rtlc9n875, 
      rtlc9n876, not_RCV_R_Data_4, rtlc9n903, rtlc9n904, not_counter_12, 
      rtlc9n5572, not_rtlc9n5572, not_counter_9, not_counter_8, 
      not_counter_7, rtlc9n5577, rtlc9n5578, rtlc9n5579, rtlc9n5580, 
      rtlc9n5597, not_rtlc9n5597, not_counter_10, not_rtlcn198, rtlc9n5604, 
      not_rtlc9n5625, not_rtlcn200, rtlc9n5631, rtlc9n5632, rtlc9n5633, 
      rtlc9n5656, not_rtlcn199, rtlc9n5660, rtlc9n5661, rtlc9n5662, 
      not_counter_11, rtlc9n5680, not_rtlc9n5680, rtlc9n5687, rtlc9n5688, 
      rtlc9n5757, rtlc9n5770, rtlc9n5771, rtlc9n5800, rtlc9n5801, rtlc9n5802, 
      rtlc9n5803, rtlcn198, rtlcn199, rtlcn200, rtlcn204, rtlcn205, rtlcn324, 
      rtlcn361, rtlcn381, rtlcn383, rtlcn384, rtlcn386, rtlcn387, rtlcn388, 
      rtlcn389, rtlcn390, rtlcn391, rtlcn394, rtlcn397, rtlcn461, rtlcn663, 
      rtlcn674, rtlcn676, rtlcn762, rtlcn841, rtlcn881, rtlcn887, rtlcn890, 
      rtlcn1038, rtlcn1135, rtlcn1144, rtlcn1173, rtlcn1176, rtlcn1178, 
      rtlcn1179, rtlcn1190, rtlcn1208, rtlcn1212, not_rtlcn1829, rtlcn1219, 
      rtlcn1222, rtlcn1227, rtlcn1233, rtlcn1237, rtlcn1246, not_rtlcn2031, 
      rtlcn1695, rtlcn1707, rtlcn1712, not_rtlcn1825, rtlcn1730, rtlcn1741, 
      rtlcn1745, rtlcn1750, not_rtlcn2032, not_rtlcn2033, rtlcn1798, 
      rtlcn1803, rtlcn1824, rtlcn1825, rtlcn1826, rtlcn1828, rtlcn1829, 
      rtlcn1830, rtlcn1831, rtlcn1834, rtlcn1835, rtlcn1836, rtlcn1837, 
      rtlcn1838, rtlcn1839, rtlcn1841, rtlcn1842, rtlcn1843, rtlcn1844, 
      rtlcn1845, rtlcn1846, rtlcn1848, rtlcn1850, rtlcn1851, rtlcn1852, 
      rtlcn1853, rtlcn1854, rtlcn1855, rtlcn1856, rtlcn1857, rtlcn1858, 
      rtlcn1859, rtlcn1860, not_Timeout, rtlcn1863, not_rtlc9n3898, 
      rtlcn1865, rtlcn1868, rtlcn1869, rtlcn1870, not_Counter_is_21us, 
      not_state_3, rtlcn1873, not_RCV_R_Data_10, not_rtlcs25, 
      not_RCV_Command_Sync, not_RCV_CS, not_Start_Clean, rtlcn1883, 
      not_rtlcn1834, rtlcn1885, rtlcn1886, not_rtlc9n3883, rtlcn1889, 
      not_rtlc9n3916, not_rtlcn1843, rtlcn1892, not_rtlcs31, rtlcn1897, 
      rtlcn1899, rtlcn1900, rtlcn1901, rtlcn1902, not_rtlcn1830, rtlcn1904, 
      not_rtlc9n4154, rtlcn1906, not_rtlc9n876, not_rtlcn1837, rtlcn1910, 
      rtlcn1911, not_rtlcn1827, rtlcn1913, rtlcn1914, rtlcn1916, rtlcn1917, 
      rtlcn1921, not_rtlcn1842, rtlcn1923, rtlcn1924, rtlcn1925, 
      not_BCR_message, rtlcn1928, rtlcn1929, not_rtlc9n3710, rtlcn1931, 
      rtlcn1932, rtlcn1933, not_rtlc9n913, rtlcn1935, not_rtlcn1212, 
      rtlcn1937, rtlcn1938, rtlcn1939, not_rtlc9n904, rtlcn1942, rtlcn1943, 
      rtlcn1944, rtlcn1945, rtlcn1947, not_rtlcn1831, rtlcn1949, rtlcn1951, 
      rtlcn1953, rtlcn1954, rtlcn1956, rtlcn1957, rtlcn1958, rtlcn1959, 
      rtlcn1960, not_rtlcn1178, not_rtlcn1838, rtlcn1965, not_rtlcn1839, 
      rtlcn1967, rtlcn1968, rtlcn1969, rtlcn1979, not_rtlcn2034, 
      not_rtlcn2035, rtlcn1987, not_Counter_is_37us, rtlcn1989, rtlcn1999, 
      rtlcn2031, rtlcn2032, rtlcn2033, rtlcn2034, rtlcn2035, rtlcn2041, 
      rtlcn2042, rtlcn2043, rtlcn2044, rtlcn2045, rtlcn2047, rtlcn2048, 
      rtlcn2049, rtlcn2050, rtlcn2051, rtlcn2052, rtlcn2053, rtlcn2054, 
      rtlcn2055, rtlcn2057, rtlcn2061, rtlcn2063, not_CE, 
      not_RxRdy_Plus4_5us, rtlcn2066, rtlcn2068, not_RxRdy_Plus3us, 
      rtlcn2071, not_rtlc9n4294, rtlcn2073, not_rtlc9_PS245_n4342, 
      not_rtlc9_PS247_n4356, not_rtlc9_PS248_n4369, not_rtlcs19, not_rtlcs18, 
      rtlcn2079, not_rtlc9n4292, not_rtlc9n4291, not_rtlc9n4290, 
      not_rtlc9n4289, not_rtlc9n4288, not_rtlc9n4286, not_rtlc9n4285, 
      not_rtlc9n4284, not_rtlc9n4282, not_rtlcn391, not_rtlcn386, rtlcn2092, 
      rtlcn2099, rtlcn2100, rtlcn2101, rtlcn2102, rtlcn2103, rtlcn2104, 
      rtlcn2105, rtlcn2107, not_rtlcn2042, not_rtlcn383, not_state_1, 
      not_rtlc9n4086, not_state_0, not_rtlc9n4214, not_state_4, rtlcn2115, 
      rtlcn2116, not_No_Words_Message_9n55ss1, not_rtlc9n4243, rtlcs3, 
      rtlcs4, rtlcs9, rtlcs11, not_counter_4, rtlcs15, rtlcs18, rtlcs19, 
      rtlcs21, rtlcs24, rtlcs25, rtlcs26, rtlcs27, rtlcs30, rtlcs31, 
      not_rtlcn1803, not_counter_3, not_counter_2, not_counter_1, 
      not_counter_0, not_counter_6, not_RCV_Gap_found_2, not_RCV_Gap_found_1, 
      not_RCV_Gap_found_0, not_RCV_R_Data_9, not_RCV_R_Data_8, 
      not_RCV_R_Data_7, not_RCV_R_Data_6, not_RCV_R_Data_5, not_counter_5, 
      not_active_command_3, not_active_command_2, not_active_command_1, 
      not_rtlcn841, not_RCV_RAW_GAP_6, not_RCV_RAW_GAP_5, not_RCV_RAW_GAP_4, 
      not_RCV_RAW_GAP_3, not_RCV_RAW_GAP_2, not_RCV_RAW_GAP_1, 
      not_RCV_RAW_GAP_0, rtlcn2326, rtlcs38, rtlcs39, rtlcs40, 
      not_rtlc9n4826, rtlc9_1618_or_1024_nx0, rtlc9_1779_or_1036_nx0, 
      rtlc9_1780_or_1037_nx0, rtlc9_1868_or_1038_nx0, rtlcn1827, 
      rtlc9_1900_or_1041_nx0, rtlc9_1918_or_1045_nx0, rtlc9_1919_or_1046_nx0, 
      rtlc9_1920_or_1047_nx0, rtlc9_1932_or_1050_nx0, rtlc9_1933_or_1051_nx0, 
      rtlc9_1944_or_1054_nx0, rtlc9_2356_gt_1058_nx0, rtlc9_2356_gt_1058_nx2, 
      rtlc9_2356_gt_1058_nx4, rtlc9n5625, rtlc_542_or_1067_nx0, 
      rtlc_545_or_1068_nx0, rtlc_2605_and_1078_nx0, rtlc_2616_and_1080_nx0, 
      rtlc_2633_and_1082_nx0, rtlc_2646_and_1085_nx0, rtlc_2662_or_1086_nx0, 
      rtlc_2676_and_1090_nx0, rtlc_2686_and_1091_nx0, rtlc_2691_and_1092_nx0, 
      rtlc_2693_and_1093_nx0, rtlc_2700_or_1095_nx0, rtlc_2710_and_1096_nx0, 
      rtlc_2712_and_1097_nx0, rtlc_2727_or_1099_nx0, rtlc_2731_and_1101_nx0, 
      rtlc_2732_and_1102_nx0, rtlc_2742_or_1104_nx0, rtlc_2769_or_1107_nx0, 
      rtlc_2776_and_1108_nx0, rtlc_2995_or_1110_nx0, rtlc_3047_and_1114_nx0, 
      rtlc_3058_and_1116_nx0, rtlc_3059_or_1117_nx0, rtlc_3068_and_1118_nx0, 
      rtlc_3081_or_1120_nx0, rtlc_3091_and_1121_nx0, rtlc_3095_and_1123_nx0, 
      rtlc_3105_or_1127_nx0, rtlc_3150_and_1129_nx0, rtlcs8, nx5, nx8: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (11 downto 0 );

begin
   Address(15) <= Address_6_EXMPLR2121 ;
   Address(14) <= Address_6_EXMPLR2121 ;
   Address(13) <= Address_6_EXMPLR2121 ;
   Address(12) <= Address_6_EXMPLR2121 ;
   Address(11) <= Address_6_EXMPLR2121 ;
   Address(10) <= Address_6_EXMPLR2121 ;
   Address(9) <= Address_6_EXMPLR2121 ;
   Address(8) <= Address_6_EXMPLR2121 ;
   Address(7) <= Address_6_EXMPLR2121 ;
   Address(6) <= Address_6_EXMPLR2121 ;
   Address(5) <= Address_6_EXMPLR2121 ;
   Address(4) <= Address_6_EXMPLR2121 ;
   Address(3) <= Address_6_EXMPLR2121 ;
   Address(2) <= Address_6_EXMPLR2121 ;
   Address(1) <= Address_6_EXMPLR2121 ;
   Address(0) <= Address_6_EXMPLR2121 ;
   active_command(15) <= active_command_15_EXMPLR2082 ;
   active_command(14) <= active_command_14_EXMPLR2083 ;
   active_command(13) <= active_command_13_EXMPLR2084 ;
   active_command(12) <= active_command_12_EXMPLR2085 ;
   active_command(11) <= active_command_11_EXMPLR2086 ;
   active_command(10) <= active_command_10_EXMPLR2087 ;
   active_command(4) <= active_command_4_EXMPLR2093 ;
   active_command(3) <= active_command_3_EXMPLR2094 ;
   active_command(2) <= active_command_2_EXMPLR2095 ;
   active_command(1) <= active_command_1_EXMPLR2096 ;
   active_command(0) <= active_command_0_EXMPLR2097 ;
   RT2RT_message <= RT2RT_message_EXMPLR2102 ;
   MIL1553_ERRORS_Parity_Manchester <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_Format_error <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_Message_Error_set <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_echo_back_bus_B <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_echo_back_bus_A <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_bus_B_shutdown <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_bus_A_shutdown <= Address_6_EXMPLR2121 ;
   MIL1553_ERRORS_transmitter_timout <= Address_6_EXMPLR2121 ;
   Debug(15) <= Address_6_EXMPLR2121 ;
   Debug(14) <= Address_6_EXMPLR2121 ;
   Debug(13) <= Address_6_EXMPLR2121 ;
   Debug(12) <= Address_6_EXMPLR2121 ;
   Debug(11) <= Address_6_EXMPLR2121 ;
   Debug(10) <= Address_6_EXMPLR2121 ;
   Debug(9) <= Address_6_EXMPLR2121 ;
   Debug(8) <= Address_6_EXMPLR2121 ;
   Debug(7) <= Address_6_EXMPLR2121 ;
   Debug(6) <= Address_6_EXMPLR2121 ;
   Debug(5) <= Address_6_EXMPLR2121 ;
   Debug(4) <= Address_6_EXMPLR2121 ;
   Debug(3) <= Address_6_EXMPLR2121 ;
   Debug(2) <= Address_6_EXMPLR2121 ;
   Debug(1) <= Address_6_EXMPLR2121 ;
   Debug(0) <= Address_6_EXMPLR2121 ;
   Tx_command_time <= Address_6_EXMPLR2121 ;
   last_data_time <= Address_6_EXMPLR2121 ;
   PWR <= '1' ;
   Address_6_EXMPLR2121 <= '0' ;
   Write_Data(0) <= RCV_R_Data(0) ;
   Write_Data(1) <= RCV_R_Data(1) ;
   Write_Data(2) <= RCV_R_Data(2) ;
   Write_Data(3) <= RCV_R_Data(3) ;
   Write_Data(4) <= RCV_R_Data(4) ;
   Write_Data(5) <= RCV_R_Data(5) ;
   Write_Data(6) <= RCV_R_Data(6) ;
   Write_Data(7) <= RCV_R_Data(7) ;
   Write_Data(8) <= RCV_R_Data(8) ;
   Write_Data(9) <= RCV_R_Data(9) ;
   Write_Data(10) <= RCV_R_Data(10) ;
   Write_Data(11) <= RCV_R_Data(11) ;
   Write_Data(12) <= RCV_R_Data(12) ;
   Write_Data(13) <= RCV_R_Data(13) ;
   Write_Data(14) <= RCV_R_Data(14) ;
   Write_Data(15) <= RCV_R_Data(15) ;
   RxRdy <= RCV_Pre_RxRdy OR RCV_Pre_EchoRdy ;
   rtlc6n36 <= RCV_recieving AND rtlc6n164 ;
   not_Energy_Count_9 <= NOT Energy_Count(9) ;
   rtlc6_61_and_1019 : and_7u_7u port map ( a(6)=>Energy_Count(6), a(5)=>
      Energy_Count(5), a(4)=>Energy_Count(4), a(3)=>Energy_Count(3), a(2)=>
      Energy_Count(2), a(1)=>Energy_Count(1), a(0)=>Energy_Count(0), d=>
      rtlc6n161);
   rtlc6n164 <= not_rtlcn205 OR not_Energy_Count_9 ;
   MIL1553_ERRORS_9n22ss1(0) <= NOT Error_in_message ;
   mode_message_9n8s1 <= mode_message_9n8s2 OR mode_message_9n1s5 ;
   mode_message_9n8s2 <= mode_message_9n1s3 AND not_MODE_CODE1553A ;
   not_MODE_CODE1553A <= NOT MODE_CODE1553A ;
   MIL1553_ERRORS_9n51ss1(0) <= GOOD_Data_Block OR No_Words_Message ;
   not_rtlc9n5039 <= NOT rtlc9n5039 ;
   rtlc9_1411_or_1020 : or_4u_4u port map ( a(3)=>state(5), a(2)=>state(6), 
      a(1)=>state(7), a(0)=>state(8), d=>rtlc9n4906);
   rtlc9_1415_or_1021 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(4), a(0)=>state(5), d=>rtlc9n4908);
   rtlc9_1611_select_1022 : select_4_4 port map ( a(3)=>state(0), a(2)=>
      state(1), a(1)=>not_rtlc9n5039, a(0)=>state(4), b(3)=>
      Address_6_EXMPLR2121, b(2)=>rtlcn381, b(1)=>PWR, b(0)=>rtlcn390, d=>
      rtlcn383);
   rtlc9_1617_select_1023 : select_4_4 port map ( a(3)=>state(0), a(2)=>
      state(1), a(1)=>not_rtlc9n5039, a(0)=>state(4), b(3)=>
      Address_6_EXMPLR2121, b(2)=>rtlcn384, b(1)=>PWR, b(0)=>rtlcn390, d=>
      rtlcn386);
   rtlc9n4040 <= rtlcs25 AND not_RCV_R_Data_10 ;
   rtlc9n4035 <= not_rtlcs38 AND rtlcs25 ;
   rtlc9_1639_select_1025 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n5043, a(1)=>state(3), a(0)=>state(4), b(4)=>
      Address_6_EXMPLR2121, b(3)=>rtlcn389, b(2)=>PWR, b(1)=>Counter_is_37us, 
      b(0)=>rtlcn390, d=>rtlcn391);
   rtlc9_1640_or_1026 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(3), a(0)=>state(4), d=>rtlc9n5043);
   not_rtlc9n5043 <= NOT rtlc9n5043 ;
   rtlc9n4072 <= rtlcs25 AND RCV_Command_Sync ;
   rtlc9_1648_select_1028 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>rtlc9n5047, a(2)=>state(4), a(1)=>state(5), a(0)=>
      state(7), b(5)=>RxRdy, b(4)=>rtlc9n4091, b(3)=>PWR, b(2)=>rtlc9n4245, 
      b(1)=>rtlc9n4270, b(0)=>not_RxRdy_Plus4_5us, d=>rtlc9n4282);
   rtlc9_1649_or_1029 : or_4u_4u port map ( a(3)=>state(2), a(2)=>state(3), 
      a(1)=>state(6), a(0)=>state(8), d=>rtlc9n5047);
   rtlc9n4245 <= rtlc9n4233 AND not_Timeout ;
   rtlc9n4270 <= rtlc9n4265 AND not_Counter_is_37us ;
   rtlc9_1660_or_1030 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(1), 
      a(1)=>state(2), a(0)=>state(4), d=>rtlc9n5051);
   not_rtlc9n5051 <= NOT rtlc9n5051 ;
   rtlc9n4218 <= rtlc9n4211 AND RCV_CS ;
   rtlc9_1668_select_1031 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>state(2), a(1)=>not_rtlc9n5051, a(0)=>state(4), b(4)=>
      RxRdy, b(3)=>rtlc9n4092, b(2)=>rtlc9n4140, b(1)=>PWR, b(0)=>rtlc9n4243, 
      d=>rtlc9n4285);
   rtlc9n4042 <= rtlc9n4035 AND RCV_R_Data(10) ;
   rtlc9n4219 <= rtlc9n4209 AND RCV_CS ;
   rtlc9_1689_select_1032 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>state(2), a(2)=>state(3), a(1)=>state(4), a(0)=>
      rtlc9n4906, b(5)=>rtlc9n4010, b(4)=>rtlc9n4086, b(3)=>rtlc9n4142, b(2)
      =>rtlc9n4198, b(1)=>rtlc9n4248, b(0)=>PWR, d=>rtlc9n4288);
   rtlc9n4010 <= rtlc9n4008 AND RxRdy ;
   rtlc9_1701_select_1033 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n4908, a(1)=>state(4), a(0)=>state(5), b(4)=>
      RxRdy, b(3)=>rtlc9n4086, b(2)=>PWR, b(1)=>rtlc9n4249, b(0)=>rtlc9n4269, 
      d=>rtlc9n4290);
   rtlc9n4230 <= rtlc9n4216 AND rtlc9n4826 ;
   rtlc9_1715_select_1034 : select_5_5 port map ( a(4)=>state(0), a(3)=>
      state(1), a(2)=>not_rtlc9n5043, a(1)=>state(3), a(0)=>state(4), b(4)=>
      RxRdy, b(3)=>rtlc9n4091, b(2)=>PWR, b(1)=>rtlc9n4200, b(0)=>rtlc9n4249, 
      d=>rtlc9n4292);
   rtlc9n4186 <= rtlc9n4181 AND not_rtlc9n4154 ;
   rtlc9n4181 <= not_rtlcn1798 AND RCV_CS ;
   rtlc9_1739_select_1035 : select_9_9 port map ( a(8)=>state(0), a(7)=>
      state(1), a(6)=>state(2), a(5)=>state(3), a(4)=>state(4), a(3)=>
      state(5), a(2)=>state(6), a(1)=>state(7), a(0)=>state(8), b(8)=>
      rtlc9n4011, b(7)=>not_Counter_is_21us, b(6)=>not_Timeout, b(5)=>
      not_Counter_is_37us, b(4)=>rtlc9n4245, b(3)=>rtlc9n4271, b(2)=>
      RCV_recieving, b(1)=>not_RxRdy_Plus4_5us, b(0)=>PWR, d=>rtlc9n4294);
   rtlc9n4271 <= rtlc9n4266 AND not_Counter_is_37us ;
   rtlc9n4257 <= rtlc9n4254 AND not_rtlc9n3898 ;
   rtlc9n4239 <= not_RxRdy OR rtlc9n4230 ;
   rtlc9n4134 <= not_RxRdy OR rtlc9n4826 ;
   rtlc9_1894_or_1040 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>rtlc9n4213, 
      a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>rtlc9n4249
   );
   rtlc9n4191 <= not_RxRdy OR not_rtlc9n4154 ;
   rtlc9_1905_or_1042 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>rtlc9n4212, 
      a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>rtlc9n4248
   );
   rtlc9_1906_or_1043 : or_5u_5u port map ( a(4)=>Counter_is_37us, a(3)=>
      rtlc9n4154, a(2)=>not_RxRdy, a(1)=>not_RCV_Command_Sync, a(0)=>
      not_RCV_CS, d=>rtlc9n4198);
   rtlc9_1907_or_1044 : or_5u_5u port map ( a(4)=>RCV_Command_Sync, a(3)=>
      Timeout, a(2)=>not_RxRdy, a(1)=>not_RCV_CS, a(0)=>not_rtlc9n4826, d=>
      rtlc9n4142);
   rtlc9n4008 <= not_RCV_CS OR RCV_Command_Sync ;
   rtlc9n4209 <= not_RCV_Command_Sync OR not_Start_Clean ;
   rtlc9n4083 <= not_RxRdy OR rtlc9n4075 ;
   rtlc9_1926_or_1048 : or_4u_4u port map ( a(3)=>Timeout, a(2)=>
      not_RT2RT_message, a(1)=>not_rtlc9n4113, a(0)=>not_RxRdy, d=>
      rtlc9n4140);
   rtlc9_1927_or_1049 : or_4u_4u port map ( a(3)=>Counter_is_21us, a(2)=>
      rtlc9n4042, a(1)=>not_RxRdy, a(0)=>not_RCV_Command_Sync, d=>rtlc9n4092
   );
   rtlc9_1942_or_1052 : or_4u_4u port map ( a(3)=>rtlc9n3883, a(2)=>
      rtlc9n3898, a(1)=>rtlc9n3916, a(0)=>not_RxRdy_Plus3us, d=>rtlc9n4265);
   rtlc9_1943_or_1053 : or_5u_5u port map ( a(4)=>not_RxRdy, a(3)=>
      not_RCV_Command_Sync, a(2)=>not_RCV_CS, a(1)=>not_Start_Clean, a(0)=>
      not_rtlc9n4826, d=>rtlc9n4233);
   rtlc9n4154 <= Sync_Error OR not_rtlcs25 ;
   rtlc9n4112 <= not_active_command_4 OR MODE_CODE1553A ;
   rtlc9n4113 <= mode_message AND rtlc9n4112 ;
   not_rtlcs38 <= NOT rtlcs38 ;
   rtlc9n3916 <= RCV_recieving AND rtlc9n3914 ;
   rtlc9n3896 <= RCV_recieving AND rtlcs25 ;
   rtlc9n3898 <= rtlc9n3896 AND RCV_CS ;
   rtlc9n3880 <= No_Words_Message AND rtlcs21 ;
   rtlc9n3871 <= RxRdy_Plus_2us AND not_RCV_recieving ;
   rtlc9n3883 <= rtlc9n3871 AND rtlc9n3880 ;
   rtlc9n4826 <= NOT not_rtlc9n4826 ;
   not_rtlc9n3737 <= NOT rtlc9n3737 ;
   rtlc9n3737 <= rtlc9n5803 AND not_RCV_recieving ;
   rtlc9n3700 <= active_command_10_EXMPLR2087 AND not_RT2RT_message ;
   rtlc9n3710 <= rtlc9n3700 OR rtlcs21 ;
   rtlc9n3696 <= rtlcs39 OR mode_message ;
   rtlc9n3541 <= rtlcs24 OR mode_message ;
   not_rtlcs26 <= NOT rtlcs26 ;
   rtlc9n3352 <= RCV_CS AND RCV_Command_Sync ;
   rtlc9n3360 <= rtlc9n3352 AND not_rtlcs26 ;
   rtlc9n903 <= not_RCV_R_Data_4 OR MODE_CODE1553A ;
   rtlc9n904 <= mode_message_9n8s1 AND rtlc9n903 ;
   not_mode_message_9n1s3 <= NOT mode_message_9n1s3 ;
   rtlc9n875 <= not_mode_message_9n1s3 OR MODE_CODE1553A ;
   not_mode_message_9n1s5 <= NOT mode_message_9n1s5 ;
   rtlc9n867 <= rtlcs30 AND not_mode_message_9n1s5 ;
   rtlc9n876 <= rtlc9n867 AND rtlc9n875 ;
   not_RCV_R_Data_4 <= NOT RCV_R_Data(4) ;
   Word_number_inc5_9i1 : inc_5u_5u_0 port map ( cin=>PWR, a(4)=>
      Word_number(4), a(3)=>Word_number(3), a(2)=>Word_number(2), a(1)=>
      Word_number(1), a(0)=>Word_number(0), d(4)=>Word_number_9n30s1(4), 
      d(3)=>Word_number_9n30s1(3), d(2)=>Word_number_9n30s1(2), d(1)=>
      Word_number_9n30s1(1), d(0)=>Word_number_9n30s1(0), cout=>DANGLING(0)
   );
   counter_inc13_9i3 : inc_13u_13u_0 port map ( cin=>PWR, a(12)=>counter(12), 
      a(11)=>counter(11), a(10)=>counter(10), a(9)=>counter(9), a(8)=>
      counter(8), a(7)=>counter(7), a(6)=>counter(6), a(5)=>counter(5), a(4)
      =>counter(4), a(3)=>counter(3), a(2)=>counter(2), a(1)=>counter(1), 
      a(0)=>counter(0), d(12)=>counter_9n56s1(12), d(11)=>counter_9n56s1(11), 
      d(10)=>counter_9n56s1(10), d(9)=>counter_9n56s1(9), d(8)=>
      counter_9n56s1(8), d(7)=>counter_9n56s1(7), d(6)=>counter_9n56s1(6), 
      d(5)=>counter_9n56s1(5), d(4)=>counter_9n56s1(4), d(3)=>
      counter_9n56s1(3), d(2)=>counter_9n56s1(2), d(1)=>counter_9n56s1(1), 
      d(0)=>counter_9n56s1(0), cout=>DANGLING(1));
   not_No_Response_timeout_0 <= NOT No_Response_timeout(0) ;
   not_No_Response_timeout_1 <= NOT No_Response_timeout(1) ;
   not_No_Response_timeout_2 <= NOT No_Response_timeout(2) ;
   not_active_command_4 <= NOT active_command_4_EXMPLR2093 ;
   not_counter_12 <= NOT counter(12) ;
   not_rtlc9n5572 <= NOT rtlc9n5572 ;
   not_counter_9 <= NOT counter(9) ;
   not_counter_8 <= NOT counter(8) ;
   not_counter_7 <= NOT counter(7) ;
   rtlc9n5577 <= not_counter_8 AND not_counter_7 ;
   rtlc9n5578 <= not_counter_9 OR rtlc9n5577 ;
   rtlc9n5579 <= not_rtlc9n5572 AND rtlc9n5578 ;
   rtlc9n5580 <= rtlc9n5579 OR not_counter_12 ;
   not_rtlc9n5597 <= NOT rtlc9n5597 ;
   not_counter_10 <= NOT counter(10) ;
   rtlc9n5604 <= not_counter_10 OR not_rtlcn198 ;
   not_rtlc9n5625 <= NOT rtlc9n5625 ;
   rtlc9n5631 <= not_counter_7 OR not_rtlcn200 ;
   rtlc9n5632 <= not_rtlc9n5625 AND rtlc9n5631 ;
   rtlc9n5633 <= not_counter_10 OR rtlc9n5632 ;
   rtlc9n5660 <= not_counter_8 OR not_rtlcn199 ;
   rtlc9n5661 <= not_counter_9 AND rtlc9n5660 ;
   rtlc9n5662 <= not_counter_10 OR rtlc9n5661 ;
   not_counter_11 <= NOT counter(11) ;
   not_rtlc9n5680 <= NOT rtlc9n5680 ;
   rtlc9n5687 <= not_rtlc9n5680 AND rtlc9n5631 ;
   rtlc9n5688 <= not_counter_11 OR rtlc9n5687 ;
   rtlc9n5770 <= RCV_Gap_found(0) AND RCV_Gap_found(1) ;
   rtlc9n5771 <= rtlc9n5770 OR RCV_Gap_found(2) ;
   rtlc9n5800 <= Energy_Count(8) AND Energy_Count(7) ;
   rtlc9_3509_or_1066 : or_7u_7u port map ( a(6)=>Energy_Count(0), a(5)=>
      Energy_Count(1), a(4)=>Energy_Count(2), a(3)=>Energy_Count(3), a(2)=>
      Energy_Count(4), a(1)=>Energy_Count(5), a(0)=>Energy_Count(6), d=>
      rtlc9n5801);
   rtlc9n5802 <= rtlc9n5801 AND rtlc9n5800 ;
   rtlc9n5803 <= rtlc9n5802 OR Energy_Count(9) ;
   rtlc9n5572 <= counter(11) OR counter(10) ;
   rtlc9n5597 <= counter(12) OR counter(11) ;
   not_rtlcn198 <= NOT rtlcn198 ;
   not_rtlcn199 <= NOT rtlcn199 ;
   not_rtlcn200 <= NOT rtlcn200 ;
   rtlc9n5656 <= counter(7) OR counter(6) ;
   rtlc9n5757 <= RCV_Gap_found(2) OR RCV_Gap_found(1) ;
   not_rtlcn204 <= NOT rtlcn204 ;
   rtlc6n159 <= Energy_Count(8) OR Energy_Count(7) ;
   not_rtlcn205 <= NOT rtlcn205 ;
   rtlcn200 <= counter(6) OR counter(5) ;
   rtlcn199 <= rtlc9n5656 OR counter(5) ;
   rtlcn204 <= rtlc9n3360 OR rtlc9n5771 ;
   rtlcn205 <= rtlc6n159 OR rtlc6n161 ;
   rtlc9n4041 <= rtlcs25 AND rtlcn388 ;
   rtlcn389 <= Counter_is_21us OR rtlc9n4072 ;
   rtlc_551_or_1069 : or_5u_5u port map ( a(4)=>Timeout, a(3)=>
      not_RCV_Command_Sync, a(2)=>not_RCV_CS, a(1)=>not_Start_Clean, a(0)=>
      not_rtlc9n4826, d=>rtlcn390);
   rtlc9n4075 <= RCV_CS AND rtlcn394 ;
   Start_Clean_select_9i4 : select_3_3 port map ( a(2)=>rtlcn674, a(1)=>
      not_rtlcn2031, a(0)=>rtlcn676, b(2)=>Address_6_EXMPLR2121, b(1)=>PWR, 
      b(0)=>Error_in_message, d=>Start_Clean_9n55ss1);
   MIL1553_ERRORS_select_9i5 : select_4_4 port map ( a(3)=>rtlcn674, a(2)=>
      state(1), a(1)=>rtlcn361, a(0)=>rtlcn1135, b(3)=>Address_6_EXMPLR2121, 
      b(2)=>MIL1553_ERRORS_9n17ss1(0), b(1)=>MIL1553_ERRORS_9n51ss1(0), b(0)
      =>GOOD_Data_Block, d=>MIL1553_ERRORS_9n55ss1_0);
   rtlc_1420_select_1072 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>not_rtlc9n5051, a(2)=>rtlcn1179, a(1)=>rtlcn1176, a(0)
      =>rtlcn1178, b(5)=>RxRdy, b(4)=>rtlc9n4086, b(3)=>PWR, b(2)=>
      not_rtlc9n3737, b(1)=>rtlc9n4130, b(0)=>rtlc9n4235, d=>rtlc9n4284);
   rtlc_1463_select_1073 : select_7_7 port map ( a(6)=>state(0), a(5)=>
      rtlc9n4906, a(4)=>rtlcn1219, a(3)=>rtlcn1212, a(2)=>rtlcn1176, a(1)=>
      not_rtlcn1829, a(0)=>rtlcn1178, b(6)=>RxRdy, b(5)=>PWR, b(4)=>
      not_rtlc9n3737, b(3)=>rtlc9n4083, b(2)=>rtlc9n4132, b(1)=>rtlc9n4189, 
      b(0)=>rtlc9n4236, d=>rtlc9n4286);
   MIL1553_ERRORS_select_9i6 : select_3_3 port map ( a(2)=>state(0), a(1)=>
      rtlcn1222, a(0)=>not_rtlcn2032, b(2)=>RxRdy, b(1)=>
      Address_6_EXMPLR2121, b(0)=>MIL1553_ERRORS_9n22ss1(0), d=>
      MIL1553_ERRORS_9n55ss1_6);
   rtlc_1480_select_1075 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      not_rtlc9n5043, a(3)=>state(4), a(2)=>rtlcn1233, a(1)=>rtlcn1212, a(0)
      =>not_rtlcn1829, b(5)=>RxRdy, b(4)=>PWR, b(3)=>rtlc9n4243, b(2)=>
      rtlc9n3737, b(1)=>rtlc9n4077, b(0)=>rtlc9n4191, d=>rtlc9n4289);
   rtlc_1502_select_1076 : select_6_6 port map ( a(5)=>state(0), a(4)=>
      state(1), a(3)=>not_rtlc9n5051, a(2)=>rtlcn1179, a(1)=>rtlcn1176, a(0)
      =>rtlcn1178, b(5)=>RxRdy, b(4)=>rtlc9n4086, b(3)=>PWR, b(2)=>
      rtlc9n3737, b(1)=>rtlc9n4134, b(0)=>rtlc9n4239, d=>rtlc9n4291);
   not_RCV_recieving <= NOT RCV_recieving ;
   not_rtlc9n4113 <= NOT rtlc9n4113 ;
   not_rtlc9n3541 <= NOT rtlc9n3541 ;
   not_RT2RT_message <= NOT RT2RT_message_EXMPLR2102 ;
   Monitor_ended_not_OK_select_9i7 : select_3_3 port map ( a(2)=>
      not_rtlcn2033, a(1)=>rtlcn1745, a(0)=>rtlcn1038, b(2)=>
      Address_6_EXMPLR2121, b(1)=>PWR, b(0)=>Error_in_message, d=>
      Monitor_ended_not_OK_9n55ss1);
   not_rtlcn1798 <= NOT rtlcn1798 ;
   not_rtlc9n4908 <= NOT rtlc9n4908 ;
   rtlcn397 <= state(2) OR state(4) ;
   not_Timeout <= NOT Timeout ;
   rtlcn1178 <= state(4) AND not_Timeout ;
   rtlcn674 <= state(0) OR rtlcn1178 ;
   rtlcn1863 <= state(5) AND Counter_is_37us ;
   rtlcn1844 <= state(7) OR rtlcn1863 ;
   not_rtlc9n3898 <= NOT rtlc9n3898 ;
   rtlcn1865 <= state(5) AND not_rtlc9n3898 ;
   rtlcn676 <= rtlcn1844 OR rtlcn1865 ;
   rtlcn361 <= state(5) OR state(7) ;
   rtlcn1135 <= Timeout AND state(4) ;
   rtlcn1868 <= state(2) AND Timeout ;
   rtlcn1179 <= rtlcn1135 OR rtlcn1868 ;
   rtlcn1176 <= state(2) AND not_Timeout ;
   rtlcn1869 <= state(3) AND Counter_is_37us ;
   rtlcn1870 <= state(1) AND Counter_is_21us ;
   rtlcn1233 <= rtlcn1869 OR rtlcn1870 ;
   rtlcn1219 <= rtlcn1233 OR rtlcn1179 ;
   not_Counter_is_21us <= NOT Counter_is_21us ;
   rtlcn1212 <= state(1) AND not_Counter_is_21us ;
   not_state_3 <= NOT state(3) ;
   rtlcn1829 <= not_state_3 OR Counter_is_37us ;
   not_rtlcn1829 <= NOT rtlcn1829 ;
   rtlcn1873 <= state(4) AND RCV_Command_Sync ;
   rtlcn1222 <= state(1) OR rtlcn1873 ;
   not_RCV_R_Data_10 <= NOT RCV_R_Data(10) ;
   not_rtlcs25 <= NOT rtlcs25 ;
   rtlcn1830 <= not_RCV_R_Data_10 OR not_rtlcs25 ;
   not_RCV_Command_Sync <= NOT RCV_Command_Sync ;
   not_RCV_CS <= NOT RCV_CS ;
   not_Start_Clean <= NOT Start_Clean ;
   rtlcn1834 <= not_rtlc9n4826 OR rtlc9n4216 ;
   rtlcn1883 <= state(6) AND not_RCV_recieving ;
   rtlcn1848 <= rtlcn1233 OR rtlcn1883 ;
   rtlcn1852 <= RxRdy AND rtlcn1178 ;
   rtlcn1853 <= state(1) AND RCV_Command_Sync ;
   not_rtlcn1834 <= NOT rtlcn1834 ;
   rtlcn1885 <= not_rtlcn1834 AND rtlcn1852 ;
   rtlc_2606_or_1079 : or_4u_4u port map ( a(3)=>rtlcn1179, a(2)=>rtlcn1848, 
      a(1)=>rtlcn1885, a(0)=>rtlcn1886, d=>rtlcn1745);
   not_rtlc9n3883 <= NOT rtlc9n3883 ;
   rtlcn1836 <= state(5) AND not_rtlc9n3883 ;
   rtlcn1889 <= state(7) AND RxRdy_Plus4_5us ;
   rtlcn1841 <= rtlcn1863 OR rtlcn1889 ;
   not_rtlc9n3916 <= NOT rtlc9n3916 ;
   rtlc9n4254 <= RCV_recieving AND not_rtlc9n3916 ;
   rtlcn1843 <= rtlc9n3898 OR rtlc9n4254 ;
   not_rtlcn1843 <= NOT rtlcn1843 ;
   rtlcn1038 <= rtlcn1841 OR rtlcn1892 ;
   not_R <= NOT R ;
   not_rtlcs31 <= NOT rtlcs31 ;
   rtlc9n3914 <= not_rtlcs25 OR not_rtlcs31 ;
   rtlcn1845 <= not_RCV_recieving OR rtlc9n3914 ;
   rtlcn1897 <= rtlcn397 AND Timeout ;
   not_RxRdy <= NOT RxRdy ;
   rtlcn1899 <= state(0) AND not_RxRdy ;
   rtlcn1900 <= state(8) AND not_rtlcs31 ;
   rtlc_2635_or_1084 : or_7u_7u port map ( a(6)=>rtlcn1844, a(5)=>rtlcn1848, 
      a(4)=>rtlcn1897, a(3)=>rtlcn1899, a(2)=>rtlcn1900, a(1)=>rtlcn1901, 
      a(0)=>rtlcn1902, d=>rtlcn461);
   rtlcn1803 <= RxRdy OR state(0) ;
   not_rtlcn1830 <= NOT rtlcn1830 ;
   rtlcn663 <= state(1) AND not_rtlcn1830 ;
   rtlcn1904 <= state(1) AND not_RCV_Command_Sync ;
   rtlcn841 <= state(3) OR rtlcn1904 ;
   not_rtlc9n4154 <= NOT rtlc9n4154 ;
   rtlcn1144 <= state(1) OR rtlcn1906 ;
   not_rtlc9n876 <= NOT rtlc9n876 ;
   rtlcn1837 <= not_RCV_R_Data_10 OR not_rtlc9n876 ;
   not_rtlcn1837 <= NOT rtlcn1837 ;
   No_Words_Message_9n55ss1 <= state(0) AND RxRdy ;
   rtlcn1846 <= state(2) OR rtlcn1135 ;
   rtlcn1910 <= state(4) AND rtlc9n4216 ;
   rtlcn1173 <= rtlcn1846 OR rtlcn1910 ;
   rtlcn1911 <= state(1) AND rtlcs25 ;
   rtlcn1190 <= state(2) OR rtlcn1911 ;
   not_rtlcn1827 <= NOT rtlcn1827 ;
   rtlcn1913 <= not_rtlcn1827 AND rtlcn1212 ;
   rtlcn1914 <= RCV_CS AND rtlcn1178 ;
   rtlcn1227 <= state(3) OR rtlcn1870 ;
   rtlcn1916 <= state(4) AND not_RCV_Command_Sync ;
   rtlcn1237 <= state(5) OR rtlcn1916 ;
   rtlcn1917 <= state(4) AND not_rtlc9n4826 ;
   rtlcn1246 <= rtlcn1846 OR rtlcn1917 ;
   rtlcn1842 <= not_rtlc9n4826 OR not_RCV_CS ;
   rtlcn1921 <= not_rtlcs25 AND rtlcn1212 ;
   not_rtlcn1842 <= NOT rtlcn1842 ;
   rtlcn1826 <= rtlcn1921 OR rtlcn1923 ;
   rtlcn1924 <= RCV_Command_Sync AND rtlcn1826 ;
   rtlcn1925 <= not_rtlcn1827 AND No_Words_Message_9n55ss1 ;
   rtlcn1828 <= rtlcn1924 OR rtlcn1925 ;
   rtlcn1850 <= rtlc9n3696 AND not_rtlcn1829 ;
   not_BCR_message <= NOT BCR_message_0n0s2 ;
   rtlcn1851 <= rtlc9n3541 AND not_BCR_message ;
   rtlcn1928 <= rtlcn1212 AND rtlcn1851 ;
   rtlcn1854 <= rtlcn1928 OR rtlcn1929 ;
   not_rtlc9n3710 <= NOT rtlc9n3710 ;
   rtlcn1931 <= not_rtlc9n3710 AND rtlcn1850 ;
   rtlcn1932 <= not_RCV_Command_Sync AND rtlcn1854 ;
   not_rtlc9n913 <= NOT rtlcs30 ;
   rtlc_2694_or_1094 : or_4u_4u port map ( a(3)=>rtlcn1931, a(2)=>rtlcn1932, 
      a(1)=>rtlcn1933, a(0)=>rtlcn1935, d=>rtlcn1695);
   not_rtlcn1212 <= NOT rtlcn1212 ;
   rtlcn1831 <= RCV_Command_Sync OR not_rtlcn1212 ;
   rtlcn1937 <= not_RCV_Command_Sync AND not_rtlcs25 ;
   rtlcn1938 <= RCV_Command_Sync AND not_Start_Clean ;
   rtlcn1939 <= rtlcs30 AND rtlc9n904 ;
   not_rtlc9n904 <= NOT rtlc9n904 ;
   rtlcn1855 <= rtlcn1939 OR not_rtlcn1837 ;
   rtlcn1942 <= rtlcn1827 AND No_Words_Message_9n55ss1 ;
   rtlcn1943 <= rtlc9n3710 AND rtlcn1850 ;
   rtlcn1944 <= rtlcn1178 AND rtlcn1856 ;
   rtlcn1945 <= rtlcn1828 AND rtlcn1855 ;
   not_rtlcn1831 <= NOT rtlcn1831 ;
   rtlc_2713_or_1098 : or_6u_6u port map ( a(5)=>rtlcn1942, a(4)=>rtlcn1943, 
      a(3)=>rtlcn1944, a(2)=>rtlcn1945, a(1)=>rtlcn1947, a(0)=>rtlcn1949, d
      =>rtlcn1707);
   rtlcn1951 <= not_rtlcn1834 AND rtlcn1178 ;
   rtlcn1858 <= rtlcn1925 OR rtlcn1951 ;
   rtlcn1824 <= not_rtlc9n904 AND rtlcn1858 ;
   rtlcn1857 <= rtlcn1824 OR rtlcn1958 ;
   rtlcn1712 <= not_RCV_R_Data_10 AND rtlcn1857 ;
   rtlcn1953 <= state(1) AND rtlcn1830 ;
   rtlcn1954 <= state(0) AND rtlcn1837 ;
   rtlcn1859 <= rtlcn1953 OR rtlcn1954 ;
   rtlcn1956 <= state(4) AND not_rtlcn1834 ;
   rtlcn1957 <= not_rtlcn1827 AND rtlcn1859 ;
   not_rtlcn1825 <= NOT rtlcn1825 ;
   rtlc_2729_and_1100 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      not_rtlcs25, a(1)=>not_rtlc9n904, a(0)=>rtlcn1212, d=>rtlcn1958);
   rtlcn1730 <= rtlcn1959 OR rtlcn1960 ;
   not_rtlcn1178 <= NOT rtlcn1178 ;
   rtlcn1835 <= RxRdy AND not_rtlcn1178 ;
   rtlcn1838 <= not_RCV_R_Data_10 OR Record_command ;
   not_rtlcn1838 <= NOT rtlcn1838 ;
   rtlcn1839 <= not_rtlcs25 OR not_rtlcn1838 ;
   rtlc_2741_and_1103 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      rtlcn1835, a(1)=>rtlcn1212, a(0)=>rtlcn1839, d=>rtlcn1965);
   not_rtlcn1839 <= NOT rtlcn1839 ;
   rtlcn1967 <= rtlcn1212 AND not_rtlcn1839 ;
   rtlc_2745_or_1105 : or_4u_4u port map ( a(3)=>rtlcn1176, a(2)=>
      not_rtlcn1829, a(1)=>not_rtlcn1831, a(0)=>rtlcn1967, d=>rtlcn1860);
   rtlcn1968 <= rtlcn1834 AND rtlcn1852 ;
   rtlcn1969 <= rtlcn1835 AND rtlcn1860 ;
   rtlcn1750 <= rtlcn1968 OR rtlcn1969 ;
   rtlcn1979 <= rtlcn1176 AND not_rtlc9n4113 ;
   rtlcn1987 <= state(6) AND RCV_recieving ;
   not_Counter_is_37us <= NOT Counter_is_37us ;
   rtlcn881 <= rtlcn1987 OR rtlcn1989 ;
   rtlcn890 <= rtlcs31 AND state(8) ;
   not_rtlcn2031 <= NOT rtlcn2031 ;
   not_rtlcn2032 <= NOT rtlcn2032 ;
   not_rtlcn2033 <= NOT rtlcn2033 ;
   not_rtlcn2034 <= NOT rtlcn2034 ;
   not_rtlcn2035 <= NOT rtlcn2035 ;
   rtlc9n4073 <= rtlcs25 when RCV_Command_Sync = '1' else not_rtlc9n3541 ;
   rtlc9n4211 <= rtlc9n4207 when RCV_Command_Sync = '1' else rtlcs25 ;
   rtlc9n4212 <= not_Start_Clean when RCV_Command_Sync = '1' else rtlcs25 ;
   rtlc9n4213 <= not_Start_Clean when RCV_Command_Sync = '1' else 
   not_rtlcs25 ;
   rtlc9n4214 <= rtlc9n4207 when RCV_Command_Sync = '1' else not_rtlcs25 ;
   rtlc3n59 <= CE AND RxRdy ;
   rtlcn2061 <= not_Timeout AND rtlcn397 ;
   rtlcn2063 <= not_Counter_is_37us AND state(3) ;
   not_CE <= NOT CE ;
   not_RxRdy_Plus4_5us <= NOT RxRdy_Plus4_5us ;
   rtlcn2066 <= not_RxRdy_Plus4_5us AND state(7) ;
   rtlcn2068 <= not_RxRdy AND rtlcn2053 ;
   not_RxRdy_Plus3us <= NOT RxRdy_Plus3us ;
   rtlc_3003_and_1111 : and_4u_4u port map ( a(3)=>not_Counter_is_37us, a(2)
      =>not_RxRdy_Plus3us, a(1)=>not_rtlc9n3883, a(0)=>state(5), d=>
      rtlcn2071);
   rtlc_3004_or_1112 : or_4u_4u port map ( a(3)=>not_CE, a(2)=>rtlcn2066, 
      a(1)=>rtlcn2068, a(0)=>rtlcn2071, d=>rtlcn2041);
   not_rtlcn2041 <= NOT rtlcn2041 ;
   not_rtlc9n4294 <= NOT rtlc9n4294 ;
   rtlc9n5026 <= CE AND not_rtlc9n4294 ;
   rtlcn2054 <= rtlc9n5580 OR state(0) ;
   rtlcn2073 <= CE AND rtlcn2054 ;
   rtlc9n5019 <= rtlc3n59 OR rtlcn2073 ;
   not_rtlc9_PS245_n4342 <= NOT rtlc9_PS245_n4342 ;
   not_rtlc9_PS247_n4356 <= NOT rtlc9_PS247_n4356 ;
   not_rtlc9_PS248_n4369 <= NOT rtlc9_PS248_n4369 ;
   not_rtlcs19 <= NOT rtlcs19 ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlc_3020_and_1113 : and_6u_6u port map ( a(5)=>CE, a(4)=>
      not_rtlc9_PS245_n4342, a(3)=>not_rtlc9_PS247_n4356, a(2)=>
      not_rtlc9_PS248_n4369, a(1)=>not_rtlcs19, a(0)=>not_rtlcs18, d=>
      rtlcn2079);
   rtlc9n4989 <= rtlc3n59 OR rtlcn2079 ;
   not_rtlc9n4292 <= NOT rtlc9n4292 ;
   rtlc9n4987 <= CE AND not_rtlc9n4292 ;
   not_rtlc9n4291 <= NOT rtlc9n4291 ;
   rtlc9n4981 <= CE AND not_rtlc9n4291 ;
   not_rtlc9n4290 <= NOT rtlc9n4290 ;
   rtlc9n4978 <= CE AND not_rtlc9n4290 ;
   not_rtlc9n4289 <= NOT rtlc9n4289 ;
   rtlc9n4977 <= CE AND not_rtlc9n4289 ;
   not_rtlc9n4288 <= NOT rtlc9n4288 ;
   rtlc9n4976 <= CE AND not_rtlc9n4288 ;
   not_rtlc9n4286 <= NOT rtlc9n4286 ;
   rtlc9n4974 <= CE AND not_rtlc9n4286 ;
   not_rtlc9n4285 <= NOT rtlc9n4285 ;
   rtlc9n4973 <= CE AND not_rtlc9n4285 ;
   not_rtlc9n4284 <= NOT rtlc9n4284 ;
   rtlc9n4972 <= CE AND not_rtlc9n4284 ;
   not_rtlc9n4282 <= NOT rtlc9n4282 ;
   rtlc9n4970 <= CE AND not_rtlc9n4282 ;
   not_rtlcn391 <= NOT rtlcn391 ;
   rtlc9n4963 <= not_rtlcn391 AND rtlc3n59 ;
   not_rtlcn386 <= NOT rtlcn386 ;
   rtlc9n4958 <= not_rtlcn386 AND rtlc3n59 ;
   rtlc9n4207 <= rtlcs38 AND not_Start_Clean ;
   rtlc_3051_or_1115 : or_4u_4u port map ( a(3)=>Counter_is_37us, a(2)=>
      rtlc9n3883, a(1)=>not_rtlc9n3898, a(0)=>not_RxRdy_Plus3us, d=>
      rtlc9n4269);
   rtlcn2048 <= not_RxRdy OR Timeout ;
   rtlcn2051 <= not_RxRdy OR Counter_is_21us ;
   rtlcn2100 <= RCV_CS AND rtlcn387 ;
   rtlcn2055 <= rtlcn2051 OR rtlcn2100 ;
   rtlcn2101 <= state(5) AND rtlc9n4269 ;
   rtlcn2102 <= state(3) AND rtlcn2057 ;
   rtlcn2103 <= rtlcn2048 AND rtlcn397 ;
   rtlcn2104 <= state(1) AND rtlcn2055 ;
   rtlc_3070_and_1119 : and_4u_4u port map ( a(3)=>RCV_Command_Sync, a(2)=>
      rtlc9n4207, a(1)=>state(4), a(0)=>not_rtlcn1842, d=>rtlcn2107);
   not_rtlcn2042 <= NOT rtlcn2042 ;
   rtlc9n4955 <= CE AND not_rtlcn2042 ;
   not_rtlcn383 <= NOT rtlcn383 ;
   rtlc9n4936 <= not_rtlcn383 AND rtlc3n59 ;
   not_state_1 <= NOT state(1) ;
   not_rtlc9n4086 <= NOT rtlc9n4086 ;
   rtlcn2043 <= not_state_1 OR not_rtlc9n4086 ;
   not_state_0 <= NOT state(0) ;
   rtlcn2044 <= not_state_0 OR rtlc9n904 ;
   not_rtlc9n4214 <= NOT rtlc9n4214 ;
   rtlcn2047 <= not_rtlc9n4214 OR rtlcn1842 ;
   rtlcn2049 <= not_RxRdy OR rtlcn2044 ;
   not_state_4 <= NOT state(4) ;
   rtlc_3092_and_1122 : and_4u_4u port map ( a(3)=>not_Timeout, a(2)=>
      rtlcn2044, a(1)=>rtlc3n59, a(0)=>rtlcn2047, d=>rtlcn2116);
   rtlcn2052 <= rtlcn2115 OR rtlcn2116 ;
   not_No_Words_Message_9n55ss1 <= NOT No_Words_Message_9n55ss1 ;
   rtlc_3098_or_1124 : or_4u_4u port map ( a(3)=>rtlcn1842, a(2)=>
      not_RCV_Command_Sync, a(1)=>not_Start_Clean, a(0)=>rtlcn2048, d=>
      rtlc9n4243);
   not_rtlc9n4243 <= NOT rtlc9n4243 ;
   rtlcn2050 <= not_state_4 OR not_rtlc9n4243 ;
   rtlc_3101_and_1125 : and_5u_5u port map ( a(4)=>CE, a(3)=>rtlc9n5039, 
      a(2)=>rtlcn2043, a(1)=>rtlcn2045, a(0)=>rtlcn2050, d=>rtlcn1999);
   rtlc_3104_or_1126 : or_9u_9u port map ( a(8)=>state(6), a(7)=>state(7), 
      a(6)=>state(8), a(5)=>rtlcn2101, a(4)=>rtlcn2102, a(3)=>rtlcn2103, 
      a(2)=>rtlcn2104, a(1)=>rtlcn2105, a(0)=>rtlcn2107, d=>rtlcn2042);
   rtlcs3 <= counter(5) AND rtlcs11 ;
   rtlcs11 <= not_counter_4 AND rtlcs15 ;
   rtlcs26 <= rtlcs27 AND mode_message_9n1s5 ;
   not_rtlcn1803 <= NOT rtlcn1803 ;
   counter_9n59ss1(12) <= counter_9n56s1(12) AND not_rtlcn1803 ;
   counter_9n59ss1(11) <= counter_9n56s1(11) AND not_rtlcn1803 ;
   counter_9n59ss1(9) <= counter_9n56s1(9) AND not_rtlcn1803 ;
   counter_9n59ss1(8) <= counter_9n56s1(8) AND not_rtlcn1803 ;
   counter_9n59ss1(7) <= counter_9n56s1(7) AND not_rtlcn1803 ;
   counter_9n59ss1(6) <= counter_9n56s1(6) AND not_rtlcn1803 ;
   counter_9n59ss1(5) <= counter_9n56s1(5) AND not_rtlcn1803 ;
   counter_9n59ss1(4) <= counter_9n56s1(4) AND not_rtlcn1803 ;
   counter_9n59ss1(3) <= counter_9n56s1(3) AND not_rtlcn1803 ;
   counter_9n59ss1(2) <= counter_9n56s1(2) AND not_rtlcn1803 ;
   counter_9n59ss1(1) <= counter_9n56s1(1) AND not_rtlcn1803 ;
   counter_9n59ss1(0) <= counter_9n56s1(0) AND not_rtlcn1803 ;
   counter_9n59ss1(10) <= counter_9n56s1(10) AND not_rtlcn1803 ;
   not_counter_4 <= NOT counter(4) ;
   not_counter_3 <= NOT counter(3) ;
   not_counter_2 <= NOT counter(2) ;
   not_counter_1 <= NOT counter(1) ;
   not_counter_0 <= NOT counter(0) ;
   rtlc_3144_and_1128 : and_7u_7u port map ( a(6)=>not_counter_12, a(5)=>
      not_counter_11, a(4)=>not_counter_8, a(3)=>not_counter_3, a(2)=>
      not_counter_2, a(1)=>not_counter_1, a(0)=>not_counter_0, d=>rtlcs15);
   not_counter_6 <= NOT counter(6) ;
   rtlcs4 <= counter(7) AND not_counter_6 ;
   not_RCV_Gap_found_2 <= NOT RCV_Gap_found(2) ;
   not_RCV_Gap_found_1 <= NOT RCV_Gap_found(1) ;
   not_RCV_Gap_found_0 <= NOT RCV_Gap_found(0) ;
   mode_message_and_9i8 : and_5u_5u port map ( a(4)=>RCV_R_Data(9), a(3)=>
      RCV_R_Data(8), a(2)=>RCV_R_Data(7), a(1)=>RCV_R_Data(6), a(0)=>
      RCV_R_Data(5), d=>mode_message_9n1s3);
   not_RCV_R_Data_9 <= NOT RCV_R_Data(9) ;
   not_RCV_R_Data_8 <= NOT RCV_R_Data(8) ;
   not_RCV_R_Data_7 <= NOT RCV_R_Data(7) ;
   not_RCV_R_Data_6 <= NOT RCV_R_Data(6) ;
   not_RCV_R_Data_5 <= NOT RCV_R_Data(5) ;
   mode_message_and_9i9 : and_5u_5u port map ( a(4)=>not_RCV_R_Data_9, a(3)
      =>not_RCV_R_Data_8, a(2)=>not_RCV_R_Data_7, a(1)=>not_RCV_R_Data_6, 
      a(0)=>not_RCV_R_Data_5, d=>mode_message_9n1s5);
   rtlc_3163_and_1132 : and_5u_5u port map ( a(4)=>RCV_R_Data(15), a(3)=>
      RCV_R_Data(14), a(2)=>RCV_R_Data(13), a(1)=>RCV_R_Data(12), a(0)=>
      RCV_R_Data(11), d=>rtlcs30);
   rtlcs9 <= not_counter_10 AND not_counter_9 ;
   not_counter_5 <= NOT counter(5) ;
   rtlc_3174_and_1134 : and_4u_4u port map ( a(3)=>rtlc9n5580, a(2)=>
      No_Response_timeout(2), a(1)=>No_Response_timeout(1), a(0)=>
      not_No_Response_timeout_0, d=>rtlcs18);
   rtlc_3184_and_1136 : and_5u_5u port map ( a(4)=>first_RT_command(15), 
      a(3)=>first_RT_command(14), a(2)=>first_RT_command(13), a(1)=>
      first_RT_command(12), a(0)=>first_RT_command(11), d=>rtlcs21);
   active_command_9n55ss1_4 <= RCV_R_Data(4) AND rtlcn663 ;
   rtlcn2034 <= rtlc9n3696 OR rtlcn1829 ;
   not_active_command_3 <= NOT active_command_3_EXMPLR2094 ;
   not_active_command_2 <= NOT active_command_2_EXMPLR2095 ;
   not_active_command_1 <= NOT active_command_1_EXMPLR2096 ;
   rtlc_3191_and_1137 : and_5u_5u port map ( a(4)=>not_active_command_4, 
      a(3)=>not_active_command_3, a(2)=>not_active_command_2, a(1)=>
      not_active_command_1, a(0)=>active_command_0_EXMPLR2097, d=>rtlcs24);
   rtlcn2035 <= rtlc9n3541 OR rtlcn1831 ;
   Word_number_9n55ss1(3) <= Word_number_9n30s1(3) AND rtlcn841 ;
   Word_number_9n55ss1(2) <= Word_number_9n30s1(2) AND rtlcn841 ;
   Word_number_9n55ss1(1) <= Word_number_9n30s1(1) AND rtlcn841 ;
   not_rtlcn841 <= NOT rtlcn841 ;
   Word_number_9n55ss1(0) <= Word_number_9n30s1(0) OR not_rtlcn841 ;
   Word_number_9n55ss1(4) <= Word_number_9n30s1(4) AND rtlcn841 ;
   BCR_message_and_0i1 : and_5u_5u port map ( a(4)=>
      active_command_15_EXMPLR2082, a(3)=>active_command_14_EXMPLR2083, a(2)
      =>active_command_13_EXMPLR2084, a(1)=>active_command_12_EXMPLR2085, 
      a(0)=>active_command_11_EXMPLR2086, d=>BCR_message_0n0s2);
   rtlcn2031 <= rtlcn674 OR rtlcn676 ;
   not_RCV_RAW_GAP_6 <= NOT RCV_RAW_GAP(6) ;
   not_RCV_RAW_GAP_5 <= NOT RCV_RAW_GAP(5) ;
   not_RCV_RAW_GAP_4 <= NOT RCV_RAW_GAP(4) ;
   not_RCV_RAW_GAP_3 <= NOT RCV_RAW_GAP(3) ;
   not_RCV_RAW_GAP_2 <= NOT RCV_RAW_GAP(2) ;
   not_RCV_RAW_GAP_1 <= NOT RCV_RAW_GAP(1) ;
   not_RCV_RAW_GAP_0 <= NOT RCV_RAW_GAP(0) ;
   rtlc_3212_and_1139 : and_7u_7u port map ( a(6)=>not_RCV_RAW_GAP_6, a(5)=>
      not_RCV_RAW_GAP_5, a(4)=>not_RCV_RAW_GAP_4, a(3)=>not_RCV_RAW_GAP_3, 
      a(2)=>not_RCV_RAW_GAP_2, a(1)=>not_RCV_RAW_GAP_1, a(0)=>
      not_RCV_RAW_GAP_0, d=>rtlcs31);
   rtlcn388 <= not_rtlcs38 OR not_RCV_R_Data_10 ;
   rtlcn387 <= rtlc9n4041 OR not_RCV_Command_Sync ;
   rtlcs27 <= not_RCV_R_Data_10 AND not_RCV_R_Data_4 ;
   Monitor_ended_OK_9n55ss1 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1038 ;
   rtlcn2033 <= rtlcn1745 OR rtlcn1038 ;
   MIL1553_ERRORS_9n17ss1(0) <= MIL1553_ERRORS_9n22ss1(0) AND 
   not_RCV_Command_Sync ;
   GOOD_Data_Block_9n55ss1 <= MIL1553_ERRORS_9n17ss1(0) AND rtlcn1144 ;
   rtlcn1798 <= rtlc9n3696 OR RCV_Command_Sync ;
   MIL1553_ERRORS_9n55ss1_2 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1173 ;
   MIL1553_ERRORS_9n55ss1_3 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1190 ;
   rtlcn394 <= rtlcs25 OR not_RCV_Command_Sync ;
   rtlcn2032 <= state(0) OR rtlcn1222 ;
   MIL1553_ERRORS_9n55ss1_7 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1227 ;
   MIL1553_ERRORS_9n55ss1_8 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1237 ;
   MIL1553_ERRORS_9n55ss1_11 <= MIL1553_ERRORS_9n22ss1(0) AND rtlcn1246 ;
   MIL1553_ERRORS_9n55ss1_4 <= NOT rtlcn2326 ;
   rtlcn2326 <= Error_in_message OR rtlcn1208 ;
   rtlcn2092 <= rtlcs40 AND rtlc9n5757 ;
   modgen_counter_Energy_Count : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 port map ( clock=>C, 
      q(9)=>Energy_Count(9), q(8)=>Energy_Count(8), q(7)=>Energy_Count(7), 
      q(6)=>Energy_Count(6), q(5)=>Energy_Count(5), q(4)=>Energy_Count(4), 
      q(3)=>Energy_Count(3), q(2)=>Energy_Count(2), q(1)=>Energy_Count(1), 
      q(0)=>Energy_Count(0), clk_en=>CE, aclear=>not_R, sload=>
      Address_6_EXMPLR2121, data(9)=>DANGLING(2), data(8)=>DANGLING(3), 
      data(7)=>DANGLING(4), data(6)=>DANGLING(5), data(5)=>DANGLING(6), 
      data(4)=>DANGLING(7), data(3)=>DANGLING(8), data(2)=>DANGLING(9), 
      data(1)=>DANGLING(10), data(0)=>DANGLING(11), aset=>
      Address_6_EXMPLR2121, sclear=>RxRdy, updn=>PWR, cnt_en=>rtlc6n36);
   rtlceq_s68_eq_1140 : eq_5u_5u port map ( a(4)=>first_RT_command(15), a(3)
      =>first_RT_command(14), a(2)=>first_RT_command(13), a(1)=>
      first_RT_command(12), a(0)=>first_RT_command(11), b(4)=>RCV_R_Data(15), 
      b(3)=>RCV_R_Data(14), b(2)=>RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)
      =>RCV_R_Data(11), d=>rtlcs38);
   rtlceq_s70_eq_1141 : eq_5u_5u port map ( a(4)=>Word_number(4), a(3)=>
      Word_number(3), a(2)=>Word_number(2), a(1)=>Word_number(1), a(0)=>
      Word_number(0), b(4)=>active_command_4_EXMPLR2093, b(3)=>
      active_command_3_EXMPLR2094, b(2)=>active_command_2_EXMPLR2095, b(1)=>
      active_command_1_EXMPLR2096, b(0)=>active_command_0_EXMPLR2097, d=>
      rtlcs39);
   rtlceq_s72_eq_1142 : eq_5u_5u port map ( a(4)=>
      active_command_15_EXMPLR2082, a(3)=>active_command_14_EXMPLR2083, a(2)
      =>active_command_13_EXMPLR2084, a(1)=>active_command_12_EXMPLR2085, 
      a(0)=>active_command_11_EXMPLR2086, b(4)=>RCV_R_Data(15), b(3)=>
      RCV_R_Data(14), b(2)=>RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)=>
      RCV_R_Data(11), d=>rtlcs40);
   DFFPCE (rtlcn890,not_R,Address_6_EXMPLR2121,not_rtlcn2041,C,state(8)) ;
   DFFPCE (rtlcn887,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(7)) ;
   DFFPCE (rtlcn881,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(6)) ;
   DFFPCE (rtlcn1707,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(5)) ;
   DFFPCE (rtlcn1695,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(4)) ;
   DFFPCE (rtlcn762,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(3)) ;
   DFFPCE (rtlcn1730,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(2)) ;
   DFFPCE (rtlcn1712,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(1)) ;
   DFFPCE (rtlcn461,Address_6_EXMPLR2121,not_R,not_rtlcn2041,C,state(0)) ;
   DFFPCE (Start_Clean_9n55ss1,not_R,Address_6_EXMPLR2121,rtlc9n5026,C,
   Start_Clean) ;
   DFFPCE (Counter_is_37us_9n59s1,Address_6_EXMPLR2121,not_R,CE,C,
   Counter_is_37us) ;
   DFFPCE (Counter_is_21us_9n59s1,Address_6_EXMPLR2121,not_R,CE,C,
   Counter_is_21us) ;
   DFFPCE (RxRdy_Plus4_5us_9n59s1,Address_6_EXMPLR2121,not_R,CE,C,
   RxRdy_Plus4_5us) ;
   DFFPCE (RxRdy_Plus_2us_9n59s1,Address_6_EXMPLR2121,not_R,CE,C,
   RxRdy_Plus_2us) ;
   DFFPCE (counter_9n59ss1(12),not_R,Address_6_EXMPLR2121,rtlc9n5019,C,
   counter(12)) ;
   DFFPCE (counter_9n59ss1(11),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(11)) ;
   DFFPCE (counter_9n59ss1(10),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(10)) ;
   DFFPCE (counter_9n59ss1(9),not_R,Address_6_EXMPLR2121,rtlc9n5019,C,
   counter(9)) ;
   DFFPCE (counter_9n59ss1(8),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(8)) ;
   DFFPCE (counter_9n59ss1(7),not_R,Address_6_EXMPLR2121,rtlc9n5019,C,
   counter(7)) ;
   DFFPCE (counter_9n59ss1(6),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(6)) ;
   DFFPCE (counter_9n59ss1(5),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(5)) ;
   DFFPCE (counter_9n59ss1(4),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(4)) ;
   DFFPCE (counter_9n59ss1(3),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(3)) ;
   DFFPCE (counter_9n59ss1(2),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(2)) ;
   DFFPCE (counter_9n59ss1(1),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(1)) ;
   DFFPCE (counter_9n59ss1(0),Address_6_EXMPLR2121,not_R,rtlc9n5019,C,
   counter(0)) ;
   DFFPCE (RxRdy_Plus3us_9n59s1,Address_6_EXMPLR2121,not_R,CE,C,
   RxRdy_Plus3us) ;
   DFFPCE (not_RxRdy,Address_6_EXMPLR2121,not_R,rtlc9n4989,C,Timeout) ;
   DFFPCE (GOOD_Data_Block_9n55ss1,Address_6_EXMPLR2121,not_R,rtlc9n4987,C,
   GOOD_Data_Block) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_11,Address_6_EXMPLR2121,not_R,rtlc9n4981,C,
   MIL1553_ERRORS_Address_Parity) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_8,Address_6_EXMPLR2121,not_R,rtlc9n4978,C,
   MIL1553_ERRORS_high_word_count) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_7,Address_6_EXMPLR2121,not_R,rtlc9n4977,C,
   MIL1553_ERRORS_Low_word_count) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_6,Address_6_EXMPLR2121,not_R,rtlc9n4976,C,
   MIL1553_ERRORS_incorrect_data_sync) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_4,Address_6_EXMPLR2121,not_R,rtlc9n4974,C,
   MIL1553_ERRORS_Invalid_word) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_3,Address_6_EXMPLR2121,not_R,rtlc9n4973,C,
   MIL1553_ERRORS_RT2RT_format_error) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_2,Address_6_EXMPLR2121,not_R,rtlc9n4972,C,
   MIL1553_ERRORS_RT2RT_format_gap) ;
   DFFPCE (MIL1553_ERRORS_9n55ss1_0,Address_6_EXMPLR2121,not_R,rtlc9n4970,C,
   MIL1553_ERRORS_Inhibit_TF) ;
   DFFPCE (Word_number_9n55ss1(4),Address_6_EXMPLR2121,not_R,rtlc9n4963,C,
   Word_number(4)) ;
   DFFPCE (Word_number_9n55ss1(3),Address_6_EXMPLR2121,not_R,rtlc9n4963,C,
   Word_number(3)) ;
   DFFPCE (Word_number_9n55ss1(2),Address_6_EXMPLR2121,not_R,rtlc9n4963,C,
   Word_number(2)) ;
   DFFPCE (Word_number_9n55ss1(1),Address_6_EXMPLR2121,not_R,rtlc9n4963,C,
   Word_number(1)) ;
   DFFPCE (Word_number_9n55ss1(0),Address_6_EXMPLR2121,not_R,rtlc9n4963,C,
   Word_number(0)) ;
   DFFPCE (mode_message_9n8s1,Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   mode_message) ;
   DFFPCE (rtlcn663,Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   RT2RT_message_EXMPLR2102) ;
   DFFPCE (rtlcn1741,Address_6_EXMPLR2121,not_R,CE,C,new_command) ;
   DFFPCE (not_rtlcn1825,Address_6_EXMPLR2121,not_R,rtlc9n4955,C,
   Error_in_message) ;
   DFFPCE (Monitor_ended_not_OK_9n55ss1,Address_6_EXMPLR2121,not_R,CE,C,
   Monitor_ended_not_OK) ;
   DFFPCE (Monitor_ended_OK_9n55ss1,Address_6_EXMPLR2121,not_R,CE,C,
   Monitor_ended_OK) ;
   DFFPCE (RCV_R_Data(15),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_15_EXMPLR2082) ;
   DFFPCE (RCV_R_Data(14),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_14_EXMPLR2083) ;
   DFFPCE (RCV_R_Data(13),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_13_EXMPLR2084) ;
   DFFPCE (RCV_R_Data(12),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_12_EXMPLR2085) ;
   DFFPCE (RCV_R_Data(11),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_11_EXMPLR2086) ;
   DFFPCE (RCV_R_Data(10),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_10_EXMPLR2087) ;
   DFFPCE (RCV_R_Data(9),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command(9)) ;
   DFFPCE (RCV_R_Data(8),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command(8)) ;
   DFFPCE (RCV_R_Data(7),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command(7)) ;
   DFFPCE (RCV_R_Data(6),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command(6)) ;
   DFFPCE (RCV_R_Data(5),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command(5)) ;
   DFFPCE (active_command_9n55ss1_4,Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_4_EXMPLR2093) ;
   DFFPCE (RCV_R_Data(3),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_3_EXMPLR2094) ;
   DFFPCE (RCV_R_Data(2),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_2_EXMPLR2095) ;
   DFFPCE (RCV_R_Data(1),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_1_EXMPLR2096) ;
   DFFPCE (RCV_R_Data(0),Address_6_EXMPLR2121,not_R,rtlc9n4958,C,
   active_command_0_EXMPLR2097) ;
   DFFPCE (RCV_R_Data(15),Address_6_EXMPLR2121,not_R,rtlc9n4936,C,
   first_RT_command(15)) ;
   DFFPCE (RCV_R_Data(14),Address_6_EXMPLR2121,not_R,rtlc9n4936,C,
   first_RT_command(14)) ;
   DFFPCE (RCV_R_Data(13),Address_6_EXMPLR2121,not_R,rtlc9n4936,C,
   first_RT_command(13)) ;
   DFFPCE (RCV_R_Data(12),Address_6_EXMPLR2121,not_R,rtlc9n4936,C,
   first_RT_command(12)) ;
   DFFPCE (RCV_R_Data(11),Address_6_EXMPLR2121,not_R,rtlc9n4936,C,
   first_RT_command(11)) ;
   DFFPCE (rtlcn1750,Address_6_EXMPLR2121,not_R,CE,C,Write_Req) ;
   DFFPCE (No_Words_Message_9n55ss1,Address_6_EXMPLR2121,not_R,rtlcn324,C,
   No_Words_Message) ;
   DFFPCE (No_Words_Message_9n55ss1,Address_6_EXMPLR2121,not_R,rtlcn1999,C,
   MIL1553_ERRORS_invalid_command) ;
   rtlc9_1618_or_1024_nx0 <= state(0) OR state(1) ;
   rtlc9n5039 <= rtlc9_1618_or_1024_nx0 OR state(4) ;
   rtlc9_1779_or_1036_nx0 <= rtlc9n3883 OR rtlc9n4257 ;
   rtlc9n4266 <= rtlc9_1779_or_1036_nx0 OR not_RxRdy_Plus3us ;
   rtlc9_1780_or_1037_nx0 <= not_rtlcn204 OR not_RxRdy ;
   rtlc9n4011 <= rtlc9_1780_or_1037_nx0 OR not_Start_Clean ;
   rtlc9_1868_or_1038_nx0 <= Counter_is_37us OR rtlc9n4186 ;
   rtlc9n4200 <= rtlc9_1868_or_1038_nx0 OR not_RxRdy ;
   rtlcn1827 <= not_RCV_Command_Sync OR not_RCV_CS ;
   rtlc9n4216 <= rtlcn1827 OR not_Start_Clean ;
   rtlc9_1900_or_1041_nx0 <= not_RxRdy OR not_RCV_Command_Sync ;
   rtlc9n4077 <= rtlc9_1900_or_1041_nx0 OR rtlcs25 ;
   rtlc9_1918_or_1045_nx0 <= rtlc9n4219 OR not_RxRdy ;
   rtlc9n4236 <= rtlc9_1918_or_1045_nx0 OR not_rtlc9n4826 ;
   rtlc9_1919_or_1046_nx0 <= RCV_CS OR rtlc9n4154 ;
   rtlc9n4189 <= rtlc9_1919_or_1046_nx0 OR not_RxRdy ;
   rtlc9_1920_or_1047_nx0 <= RCV_CS OR not_RxRdy ;
   rtlc9n4132 <= rtlc9_1920_or_1047_nx0 OR not_rtlc9n4826 ;
   rtlc9_1932_or_1050_nx0 <= rtlc9n4218 OR not_RxRdy ;
   rtlc9n4235 <= rtlc9_1932_or_1050_nx0 OR not_rtlc9n4826 ;
   rtlc9_1933_or_1051_nx0 <= rtlc9n4101 OR not_RxRdy ;
   rtlc9n4130 <= rtlc9_1933_or_1051_nx0 OR not_rtlc9n4826 ;
   rtlc9_1944_or_1054_nx0 <= Counter_is_21us OR rtlc9n4073 ;
   rtlc9n4091 <= rtlc9_1944_or_1054_nx0 OR not_RxRdy ;
   rtlc9_2356_gt_1058_nx0 <= RCV_Gap_found(0) XOR No_Response_timeout(0) ;
   rtlc9_2356_gt_1058_nx2 <= RCV_Gap_found(1) XOR No_Response_timeout(1) ;
   rtlc9_2356_gt_1058_nx4 <= RCV_Gap_found(2) XOR No_Response_timeout(2) ;
   rtlc9n5625 <= counter(8) OR counter(9) ;
   rtlc9n5680 <= rtlc9n5625 OR counter(10) ;
   rtlc_542_or_1067_nx0 <= Counter_is_21us OR not_RCV_Command_Sync ;
   rtlcn381 <= rtlc_542_or_1067_nx0 OR rtlcs25 ;
   rtlc_545_or_1068_nx0 <= Counter_is_21us OR rtlc9n4040 ;
   rtlcn384 <= rtlc_545_or_1068_nx0 OR not_RCV_Command_Sync ;
   rtlc_2605_and_1078_nx0 <= RxRdy AND rtlcn1830 ;
   rtlcn1886 <= rtlc_2605_and_1078_nx0 AND rtlcn1853 ;
   rtlc_2616_and_1080_nx0 <= RxRdy_Plus3us AND rtlcn1836 ;
   rtlcn1892 <= rtlc_2616_and_1080_nx0 AND not_rtlcn1843 ;
   rtlc_2633_and_1082_nx0 <= not_rtlc9n3898 AND rtlcn1836 ;
   rtlcn1901 <= rtlc_2633_and_1082_nx0 AND rtlcn1845 ;
   rtlcn1902 <= rtlc9n4040 AND rtlcn1853 ;
   rtlc_2646_and_1085_nx0 <= state(3) AND RCV_CS ;
   rtlcn1906 <= rtlc_2646_and_1085_nx0 AND not_rtlc9n4154 ;
   rtlc_2662_or_1086_nx0 <= state(0) OR rtlcn1913 ;
   rtlcn1208 <= rtlc_2662_or_1086_nx0 OR rtlcn1914 ;
   rtlc_2676_and_1090_nx0 <= Start_Clean AND not_rtlcn1842 ;
   rtlcn1923 <= rtlc_2676_and_1090_nx0 AND rtlcn1178 ;
   rtlc_2686_and_1091_nx0 <= rtlcs25 AND not_rtlcn1842 ;
   rtlcn1929 <= rtlc_2686_and_1091_nx0 AND rtlcn1178 ;
   rtlc_2691_and_1092_nx0 <= rtlcn1176 AND RT2RT_message_EXMPLR2102 ;
   rtlcn1933 <= rtlc_2691_and_1092_nx0 AND rtlc9n4113 ;
   rtlc_2693_and_1093_nx0 <= not_rtlc9n913 AND rtlc9n904 ;
   rtlcn1935 <= rtlc_2693_and_1093_nx0 AND rtlcn1828 ;
   rtlc_2700_or_1095_nx0 <= rtlcn1842 OR rtlcn1937 ;
   rtlcn1856 <= rtlc_2700_or_1095_nx0 OR rtlcn1938 ;
   rtlc_2710_and_1096_nx0 <= rtlcn1176 AND not_RT2RT_message ;
   rtlcn1947 <= rtlc_2710_and_1096_nx0 AND rtlc9n4113 ;
   rtlc_2712_and_1097_nx0 <= rtlc9n3541 AND BCR_message_0n0s2 ;
   rtlcn1949 <= rtlc_2712_and_1097_nx0 AND not_rtlcn1831 ;
   rtlc_2727_or_1099_nx0 <= rtlcn1899 OR rtlcn1956 ;
   rtlcn1825 <= rtlc_2727_or_1099_nx0 OR rtlcn1957 ;
   rtlc_2731_and_1101_nx0 <= RCV_Command_Sync AND not_rtlcn1830 ;
   rtlcn1959 <= rtlc_2731_and_1101_nx0 AND rtlcn1212 ;
   rtlc_2732_and_1102_nx0 <= RCV_R_Data(10) AND not_rtlc9n876 ;
   rtlcn1960 <= rtlc_2732_and_1102_nx0 AND rtlcn1857 ;
   rtlc_2742_or_1104_nx0 <= No_Words_Message_9n55ss1 OR rtlcn1885 ;
   rtlcn1741 <= rtlc_2742_or_1104_nx0 OR rtlcn1965 ;
   rtlc_2769_or_1107_nx0 <= rtlcn1979 OR not_rtlcn2034 ;
   rtlcn762 <= rtlc_2769_or_1107_nx0 OR not_rtlcn2035 ;
   rtlc_2776_and_1108_nx0 <= not_Counter_is_37us AND rtlcn1836 ;
   rtlcn1989 <= rtlc_2776_and_1108_nx0 AND rtlcn1843 ;
   rtlc_2995_or_1110_nx0 <= rtlcn1212 OR rtlcn2061 ;
   rtlcn2053 <= rtlc_2995_or_1110_nx0 OR rtlcn2063 ;
   rtlc_3047_and_1114_nx0 <= RCV_CS AND rtlcn2092 ;
   rtlc9n4101 <= rtlc_3047_and_1114_nx0 AND RCV_Command_Sync ;
   rtlc_3058_and_1116_nx0 <= RCV_CS AND not_RCV_Command_Sync ;
   rtlcn2099 <= rtlc_3058_and_1116_nx0 AND not_rtlc9n4154 ;
   rtlc_3059_or_1117_nx0 <= Counter_is_37us OR not_RxRdy ;
   rtlcn2057 <= rtlc_3059_or_1117_nx0 OR rtlcn2099 ;
   rtlc_3068_and_1118_nx0 <= rtlc9n4101 AND rtlc9n4826 ;
   rtlcn2105 <= rtlc_3068_and_1118_nx0 AND state(2) ;
   rtlc_3081_or_1120_nx0 <= not_RCV_Command_Sync OR rtlcn2051 ;
   rtlc9n4086 <= rtlc_3081_or_1120_nx0 OR rtlcs25 ;
   rtlc_3091_and_1121_nx0 <= CE AND not_state_4 ;
   rtlcn2115 <= rtlc_3091_and_1121_nx0 AND rtlcn2049 ;
   rtlc_3095_and_1123_nx0 <= rtlc9n5039 AND rtlcn2043 ;
   rtlcn324 <= rtlc_3095_and_1123_nx0 AND rtlcn2052 ;
   rtlc_3105_or_1127_nx0 <= not_RCV_CS OR not_rtlcn1837 ;
   rtlcn2045 <= rtlc_3105_or_1127_nx0 OR not_No_Words_Message_9n55ss1 ;
   rtlc_3150_and_1129_nx0 <= not_RCV_Gap_found_2 AND not_RCV_Gap_found_1 ;
   rtlcs25 <= rtlc_3150_and_1129_nx0 AND not_RCV_Gap_found_0 ;
   rtlcs8 <= not_counter_7 AND counter(6) ;
   not_rtlc9n4826 <= RCV_Gap_found(2) when rtlc9_2356_gt_1058_nx4
    = '1' else nx5 ;
   nx5 <= RCV_Gap_found(1) when rtlc9_2356_gt_1058_nx2 = '1' else nx8 ;
   nx8 <= RCV_Gap_found(0) AND rtlc9_2356_gt_1058_nx0 ;
   modgen_and_2 : and_5u_5u port map ( a(4)=>not_counter_10, a(3)=>
      counter(9), a(2)=>rtlcs3, a(1)=>rtlcs4, a(0)=>not_RxRdy, d=>
      Counter_is_21us_9n59s1);
   modgen_and_3 : and_4u_4u port map ( a(3)=>not_counter_9, a(2)=>
      counter(10), a(1)=>rtlcs3, a(0)=>rtlcs4, d=>Counter_is_37us_9n59s1);
   modgen_and_4 : and_3u_3u port map ( a(2)=>rtlcs3, a(1)=>rtlcs8, a(0)=>
      rtlcs9, d=>RxRdy_Plus3us_9n59s1);
   modgen_and_5 : and_4u_4u port map ( a(3)=>rtlcs8, a(2)=>not_counter_5, 
      a(1)=>rtlcs9, a(0)=>rtlcs11, d=>RxRdy_Plus_2us_9n59s1);
   modgen_and_6 : and_5u_5u port map ( a(4)=>not_counter_5, a(3)=>counter(4), 
      a(2)=>rtlcs15, a(1)=>rtlcs4, a(0)=>rtlcs9, d=>RxRdy_Plus4_5us_9n59s1);
   modgen_and_7 : and_3u_3u port map ( a(2)=>state(5), a(1)=>
      not_Counter_is_37us, a(0)=>rtlc9n3883, d=>rtlcn887);
   modgen_and_8 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5662, a(2)=>not_No_Response_timeout_0, a(1)=>
      not_No_Response_timeout_1, a(0)=>No_Response_timeout(2), d=>
      rtlc9_PS248_n4369);
   modgen_and_9 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5633, a(2)=>No_Response_timeout(0), a(1)=>No_Response_timeout(1), 
      a(0)=>not_No_Response_timeout_2, d=>rtlc9_PS247_n4356);
   modgen_and_10 : and_5u_5u port map ( a(4)=>not_rtlc9n5597, a(3)=>
      rtlc9n5604, a(2)=>not_No_Response_timeout_0, a(1)=>
      No_Response_timeout(1), a(0)=>not_No_Response_timeout_2, d=>
      rtlc9_PS245_n4342);
   modgen_or_11 : or_5u_5u port map ( a(4)=>counter(6), a(3)=>counter(7), 
      a(2)=>counter(8), a(1)=>counter(9), a(0)=>counter(5), d=>rtlcn198);
   modgen_and_12 : and_5u_5u port map ( a(4)=>No_Response_timeout(2), a(3)=>
      not_No_Response_timeout_1, a(2)=>No_Response_timeout(0), a(1)=>
      not_counter_12, a(0)=>rtlc9n5688, d=>rtlcs19);
end SITAL_Technology_unfold_3816 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_cnt_en_sload_aclear_clock_clk_en_0_7 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (6 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (6 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_cnt_en_sload_aclear_clock_clk_en_0_7 ;

architecture INTERFACE of counter_dn_cnt_en_sload_aclear_clock_clk_en_0_7
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_7u_7u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx19, nx22, nx25, nx26, nx27, nx28, nx29, nx30, nx31, nx32, 
      nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, 
      nx45: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(6) <= nx26 ;
   q(5) <= nx28 ;
   q(4) <= nx30 ;
   q(3) <= nx32 ;
   q(2) <= nx34 ;
   q(1) <= nx36 ;
   q(0) <= nx38 ;
   GND <= '0' ;
   nx19 <= cnt_en OR sload ;
   nx22 <= nx19 AND clk_en ;
   DFFPCE (nx25,GND,aclear,nx22,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,nx22,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,nx22,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx22,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx22,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx22,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx22,clock,nx38) ;
   dec : dec_7u_7u_0_0 port map ( cin=>GND, a(6)=>nx26, a(5)=>nx28, a(4)=>
      nx30, a(3)=>nx32, a(2)=>nx34, a(1)=>nx36, a(0)=>nx38, d(6)=>nx39, d(5)
      =>nx40, d(4)=>nx41, d(3)=>nx42, d(2)=>nx43, d(1)=>nx44, d(0)=>nx45, 
      cout=>DANGLING(0));
   nx25 <= data(6) when sload = '1' else nx39 ;
   nx27 <= data(5) when sload = '1' else nx40 ;
   nx29 <= data(4) when sload = '1' else nx41 ;
   nx31 <= data(3) when sload = '1' else nx42 ;
   nx33 <= data(2) when sload = '1' else nx43 ;
   nx35 <= data(1) when sload = '1' else nx44 ;
   nx37 <= data(0) when sload = '1' else nx45 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Monitor_two_channel_8_4_1_32 is 
   port (
      C : IN std_logic ;
      CE : IN std_logic ;
      MODE_CODE1553A : IN std_logic ;
      NO_BCST : IN std_logic ;
      No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
      R : IN std_logic ;
      RCV_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      RCV_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      rtlc_RCV_A_Sync_error_n139 : IN std_logic ;
      RCV_A_Manchester_error : IN std_logic ;
      RCV_A_Parity_error : IN std_logic ;
      RCV_A_echo_back_bus : IN std_logic ;
      RCV_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      RCV_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_A_RxRDY_plus_12us : IN std_logic ;
      RCV_A_RxRDY_plus_10us : IN std_logic ;
      RCV_A_CS : IN std_logic ;
      RCV_A_Pre_EchoRdy : IN std_logic ;
      RCV_A_Command_Sync : IN std_logic ;
      RCV_A_Pre_RxRdy : IN std_logic ;
      RCV_A_recieving : IN std_logic ;
      RCV_A_Sync_Error : IN std_logic ;
      RCV_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      RCV_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      rtlc_RCV_B_Sync_error_n140 : IN std_logic ;
      RCV_B_Manchester_error : IN std_logic ;
      RCV_B_Parity_error : IN std_logic ;
      RCV_B_echo_back_bus : IN std_logic ;
      RCV_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      RCV_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_B_RxRDY_plus_12us : IN std_logic ;
      RCV_B_RxRDY_plus_10us : IN std_logic ;
      RCV_B_CS : IN std_logic ;
      RCV_B_Pre_EchoRdy : IN std_logic ;
      RCV_B_Command_Sync : IN std_logic ;
      RCV_B_Pre_RxRdy : IN std_logic ;
      RCV_B_recieving : IN std_logic ;
      RCV_B_Sync_Error : IN std_logic ;
      Record_command_A : IN std_logic ;
      Record_command_B : IN std_logic ;
      yossy : IN std_logic ;
      Address : OUT std_logic_vector (15 DOWNTO 0) ;
      BM_OK_A : OUT std_logic ;
      BM_OK_B : OUT std_logic ;
      BM_not_OK_A : OUT std_logic ;
      BM_not_OK_B : OUT std_logic ;
      Debug : OUT std_logic_vector (15 DOWNTO 0) ;
      Debug_BM1 : OUT std_logic_vector (15 DOWNTO 0) ;
      Debug_BM2 : OUT std_logic_vector (15 DOWNTO 0) ;
      MIL1553_Errors_Inhibit_TF : OUT std_logic ;
      MIL1553_Errors_invalid_command : OUT std_logic ;
      MIL1553_Errors_RT2RT_format_gap : OUT std_logic ;
      MIL1553_Errors_RT2RT_format_error : OUT std_logic ;
      MIL1553_Errors_Invalid_word : OUT std_logic ;
      MIL1553_Errors_Parity_Manchester : OUT std_logic ;
      MIL1553_Errors_incorrect_data_sync : OUT std_logic ;
      MIL1553_Errors_Low_word_count : OUT std_logic ;
      MIL1553_Errors_high_word_count : OUT std_logic ;
      MIL1553_Errors_Format_error : OUT std_logic ;
      MIL1553_Errors_Message_Error_set : OUT std_logic ;
      MIL1553_Errors_Address_Parity : OUT std_logic ;
      MIL1553_Errors_echo_back_bus_B : OUT std_logic ;
      MIL1553_Errors_echo_back_bus_A : OUT std_logic ;
      MIL1553_Errors_bus_B_shutdown : OUT std_logic ;
      MIL1553_Errors_bus_A_shutdown : OUT std_logic ;
      MIL1553_Errors_transmitter_timout : OUT std_logic ;
      Monitor_ended_OK : OUT std_logic ;
      Monitor_ended_not_OK : OUT std_logic ;
      RT2RT_message : OUT std_logic ;
      Write : OUT std_logic ;
      Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      active_command : OUT std_logic_vector (15 DOWNTO 0) ;
      new_command : OUT std_logic ;
      Monitor_Bus_A : OUT std_logic) ;
end Monitor_two_channel_8_4_1_32 ;

architecture Sital_ofer_hofman_unfold_3022 of Monitor_two_channel_8_4_1_32
    is 
   component Monitor_Stm_8_4_1_32
      port (
         C : IN std_logic ;
         R : IN std_logic ;
         yossy : IN std_logic ;
         CE : IN std_logic ;
         Sync_Error : IN std_logic ;
         RCV_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         RCV_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         RCV_Sync_error : IN std_logic ;
         RCV_Manchester_error : IN std_logic ;
         RCV_Parity_error : IN std_logic ;
         RCV_echo_back_bus : IN std_logic ;
         RCV_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         RCV_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_RxRDY_plus_12us : IN std_logic ;
         RCV_RxRDY_plus_10us : IN std_logic ;
         RCV_CS : IN std_logic ;
         RCV_Pre_EchoRdy : IN std_logic ;
         RCV_Command_Sync : IN std_logic ;
         RCV_Pre_RxRdy : IN std_logic ;
         RCV_recieving : IN std_logic ;
         No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
         Address : OUT std_logic_vector (15 DOWNTO 0) ;
         active_command : OUT std_logic_vector (15 DOWNTO 0) ;
         new_command : OUT std_logic ;
         Record_command : IN std_logic ;
         Monitor_ended_OK : OUT std_logic ;
         Monitor_ended_not_OK : OUT std_logic ;
         RT2RT_message : OUT std_logic ;
         Write_Req : OUT std_logic ;
         Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         MIL1553_ERRORS_Inhibit_TF : OUT std_logic ;
         MIL1553_ERRORS_invalid_command : OUT std_logic ;
         MIL1553_ERRORS_RT2RT_format_gap : OUT std_logic ;
         MIL1553_ERRORS_RT2RT_format_error : OUT std_logic ;
         MIL1553_ERRORS_Invalid_word : OUT std_logic ;
         MIL1553_ERRORS_Parity_Manchester : OUT std_logic ;
         MIL1553_ERRORS_incorrect_data_sync : OUT std_logic ;
         MIL1553_ERRORS_Low_word_count : OUT std_logic ;
         MIL1553_ERRORS_high_word_count : OUT std_logic ;
         MIL1553_ERRORS_Format_error : OUT std_logic ;
         MIL1553_ERRORS_Message_Error_set : OUT std_logic ;
         MIL1553_ERRORS_Address_Parity : OUT std_logic ;
         MIL1553_ERRORS_echo_back_bus_B : OUT std_logic ;
         MIL1553_ERRORS_echo_back_bus_A : OUT std_logic ;
         MIL1553_ERRORS_bus_B_shutdown : OUT std_logic ;
         MIL1553_ERRORS_bus_A_shutdown : OUT std_logic ;
         MIL1553_ERRORS_transmitter_timout : OUT std_logic ;
         Debug : OUT std_logic_vector (15 DOWNTO 0) ;
         Tx_command_time : OUT std_logic ;
         last_data_time : OUT std_logic ;
         MODE_CODE1553A : IN std_logic ;
         NO_BCST : IN std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_dn_cnt_en_sload_aclear_clock_clk_en_0_7
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (6 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (6 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for Monitor_Stm_a : Monitor_Stm_8_4_1_32 use entity work.
   Monitor_Stm_8_4_1_32(SITAL_Technology_unfold_1);
   for Monitor_Stm_b : Monitor_Stm_8_4_1_32 use entity work.
   Monitor_Stm_8_4_1_32(SITAL_Technology_unfold_3816);
   signal BM_OK_A_EXMPLR2187, BM_OK_B_EXMPLR2188, BM_not_OK_A_EXMPLR2189, 
      BM_not_OK_B_EXMPLR2190, Debug_0_EXMPLR2191, Monitor_Bus_A_EXMPLR2229, 
      RT2RT_message_a, RT2RT_message_b: std_logic ;
   
   signal Write_Data_a: std_logic_vector (15 DOWNTO 0) ;
   
   signal Write_Data_b: std_logic_vector (15 DOWNTO 0) ;
   
   signal Write_Length: std_logic_vector (6 DOWNTO 0) ;
   
   signal Write_Req_a, Write_Req_b: std_logic ;
   
   signal active_command_a: std_logic_vector (15 DOWNTO 0) ;
   
   signal active_command_b: std_logic_vector (15 DOWNTO 0) ;
   
   signal new_command_a, new_command_b, PWR, Debug_1_EXMPLR2230, not_R, 
      Monitor_ended_not_OK_3n1ss1: std_logic ;
   
   signal active_command_3n5ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal Monitor_ended_not_OK_3n1s1, not_Monitor_Bus_A, 
      Monitor_ended_not_OK_3n1s2, rtlc3n133, rtlc3n145, not_new_command_b, 
      rtlc3n162, rtlc3n163, rtlc3n165, rtlc3n166, rtlc3n170, rtlc3n173, 
      rtlc3n174, rtlc3n183, rtlc3n185, rtlc3n188, rtlc3n190, rtlc3n191, 
      not_rtlc3n191, rtlc3n234, rtlc3n237, rtlc3n253, Write_6n2ss1, rtlc6n36, 
      rtlc6n48, Write_6n1s1: std_logic ;
   
   signal Write_Data_9n2ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal MIL1553_Errors_9n2ss1_11, MIL1553_Errors_9n2ss1_8, 
      MIL1553_Errors_9n2ss1_7, MIL1553_Errors_9n2ss1_6, 
      MIL1553_Errors_9n2ss1_4, MIL1553_Errors_9n2ss1_3, 
      MIL1553_Errors_9n2ss1_2, MIL1553_Errors_9n2ss1_1, 
      MIL1553_Errors_9n2ss1_0: std_logic ;
   
   signal Write_Data_9n3ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal MIL1553_Errors_9n3ss1_11, MIL1553_Errors_9n3ss1_8, 
      MIL1553_Errors_9n3ss1_7, MIL1553_Errors_9n3ss1_6, 
      MIL1553_Errors_9n3ss1_4, MIL1553_Errors_9n3ss1_3, 
      MIL1553_Errors_9n3ss1_2, MIL1553_Errors_9n3ss1_1, 
      MIL1553_Errors_9n3ss1_0, rtlc9n150, rtlc9n151, rtlcn10, rtlcn15, 
      rtlcn27, rtlcn28, rtlcn30, rtlcn37, rtlcn38, rtlcn39, not_rtlc3n165, 
      not_rtlc3n166, not_Debug_0, MIL1553_Errors_A_Inhibit_TF, 
      MIL1553_Errors_A_invalid_command, MIL1553_Errors_A_RT2RT_format_gap, 
      MIL1553_Errors_A_RT2RT_format_error, MIL1553_Errors_A_Invalid_word, 
      MIL1553_Errors_A_incorrect_data_sync, MIL1553_Errors_A_Low_word_count, 
      MIL1553_Errors_A_high_word_count, MIL1553_Errors_A_Address_Parity, 
      MIL1553_Errors_B_Inhibit_TF, MIL1553_Errors_B_invalid_command, 
      MIL1553_Errors_B_RT2RT_format_gap, MIL1553_Errors_B_RT2RT_format_error, 
      MIL1553_Errors_B_Invalid_word, MIL1553_Errors_B_incorrect_data_sync, 
      MIL1553_Errors_B_Low_word_count, MIL1553_Errors_B_high_word_count, 
      MIL1553_Errors_B_Address_Parity: std_logic ;
   
   signal DANGLING : std_logic_vector (83 downto 0 );

begin
   Address(15) <= Debug_1_EXMPLR2230 ;
   Address(14) <= Debug_1_EXMPLR2230 ;
   Address(13) <= Debug_1_EXMPLR2230 ;
   Address(12) <= Debug_1_EXMPLR2230 ;
   Address(11) <= Debug_1_EXMPLR2230 ;
   Address(10) <= Debug_1_EXMPLR2230 ;
   Address(9) <= Debug_1_EXMPLR2230 ;
   Address(8) <= Debug_1_EXMPLR2230 ;
   Address(7) <= Debug_1_EXMPLR2230 ;
   Address(6) <= Debug_1_EXMPLR2230 ;
   Address(5) <= Debug_1_EXMPLR2230 ;
   Address(4) <= Debug_1_EXMPLR2230 ;
   Address(3) <= Debug_1_EXMPLR2230 ;
   Address(2) <= Debug_1_EXMPLR2230 ;
   Address(1) <= Debug_1_EXMPLR2230 ;
   Address(0) <= Debug_1_EXMPLR2230 ;
   BM_OK_A <= Debug_1_EXMPLR2230 ;
   BM_OK_B <= Debug_1_EXMPLR2230 ;
   BM_not_OK_A <= Debug_1_EXMPLR2230 ;
   BM_not_OK_B <= Debug_1_EXMPLR2230 ;
   Debug(15) <= Debug_1_EXMPLR2230 ;
   Debug(14) <= Debug_1_EXMPLR2230 ;
   Debug(13) <= Debug_1_EXMPLR2230 ;
   Debug(12) <= Debug_1_EXMPLR2230 ;
   Debug(11) <= Debug_1_EXMPLR2230 ;
   Debug(10) <= Debug_1_EXMPLR2230 ;
   Debug(9) <= Debug_1_EXMPLR2230 ;
   Debug(8) <= Debug_1_EXMPLR2230 ;
   Debug(7) <= Debug_1_EXMPLR2230 ;
   Debug(6) <= Debug_1_EXMPLR2230 ;
   Debug(5) <= Debug_1_EXMPLR2230 ;
   Debug(4) <= Debug_1_EXMPLR2230 ;
   Debug(3) <= Debug_1_EXMPLR2230 ;
   Debug(2) <= Debug_1_EXMPLR2230 ;
   Debug(1) <= Debug_1_EXMPLR2230 ;
   Debug(0) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(15) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(14) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(13) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(12) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(11) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(10) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(9) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(8) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(7) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(6) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(5) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(4) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(3) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(2) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(1) <= Debug_1_EXMPLR2230 ;
   Debug_BM1(0) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(15) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(14) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(13) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(12) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(11) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(10) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(9) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(8) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(7) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(6) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(5) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(4) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(3) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(2) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(1) <= Debug_1_EXMPLR2230 ;
   Debug_BM2(0) <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_Parity_Manchester <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_Format_error <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_Message_Error_set <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_echo_back_bus_B <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_echo_back_bus_A <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_bus_B_shutdown <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_bus_A_shutdown <= Debug_1_EXMPLR2230 ;
   MIL1553_Errors_transmitter_timout <= Debug_1_EXMPLR2230 ;
   Monitor_Bus_A <= Monitor_Bus_A_EXMPLR2229 ;
   PWR <= '1' ;
   Debug_1_EXMPLR2230 <= '0' ;
   Monitor_Stm_a : Monitor_Stm_8_4_1_32 port map ( C=>C, R=>R, yossy=>PWR, 
      CE=>CE, Sync_Error=>RCV_A_Sync_Error, RCV_Bit_number(4)=>
      Debug_1_EXMPLR2230, RCV_Bit_number(3)=>Debug_1_EXMPLR2230, 
      RCV_Bit_number(2)=>Debug_1_EXMPLR2230, RCV_Bit_number(1)=>
      Debug_1_EXMPLR2230, RCV_Bit_number(0)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(7)=>Debug_1_EXMPLR2230, RCV_Response_Time(6)=>
      Debug_1_EXMPLR2230, RCV_Response_Time(5)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(4)=>Debug_1_EXMPLR2230, RCV_Response_Time(3)=>
      Debug_1_EXMPLR2230, RCV_Response_Time(2)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(1)=>Debug_1_EXMPLR2230, RCV_Response_Time(0)=>
      Debug_1_EXMPLR2230, RCV_Sync_error=>Debug_1_EXMPLR2230, 
      RCV_Manchester_error=>Debug_1_EXMPLR2230, RCV_Parity_error=>
      Debug_1_EXMPLR2230, RCV_echo_back_bus=>Debug_1_EXMPLR2230, 
      RCV_R_Data(15)=>RCV_A_R_Data(15), RCV_R_Data(14)=>RCV_A_R_Data(14), 
      RCV_R_Data(13)=>RCV_A_R_Data(13), RCV_R_Data(12)=>RCV_A_R_Data(12), 
      RCV_R_Data(11)=>RCV_A_R_Data(11), RCV_R_Data(10)=>RCV_A_R_Data(10), 
      RCV_R_Data(9)=>RCV_A_R_Data(9), RCV_R_Data(8)=>RCV_A_R_Data(8), 
      RCV_R_Data(7)=>RCV_A_R_Data(7), RCV_R_Data(6)=>RCV_A_R_Data(6), 
      RCV_R_Data(5)=>RCV_A_R_Data(5), RCV_R_Data(4)=>RCV_A_R_Data(4), 
      RCV_R_Data(3)=>RCV_A_R_Data(3), RCV_R_Data(2)=>RCV_A_R_Data(2), 
      RCV_R_Data(1)=>RCV_A_R_Data(1), RCV_R_Data(0)=>RCV_A_R_Data(0), 
      RCV_RAW_GAP(6)=>RCV_A_RAW_GAP(6), RCV_RAW_GAP(5)=>RCV_A_RAW_GAP(5), 
      RCV_RAW_GAP(4)=>RCV_A_RAW_GAP(4), RCV_RAW_GAP(3)=>RCV_A_RAW_GAP(3), 
      RCV_RAW_GAP(2)=>RCV_A_RAW_GAP(2), RCV_RAW_GAP(1)=>RCV_A_RAW_GAP(1), 
      RCV_RAW_GAP(0)=>RCV_A_RAW_GAP(0), RCV_GAP(6)=>Debug_1_EXMPLR2230, 
      RCV_GAP(5)=>Debug_1_EXMPLR2230, RCV_GAP(4)=>Debug_1_EXMPLR2230, 
      RCV_GAP(3)=>Debug_1_EXMPLR2230, RCV_GAP(2)=>Debug_1_EXMPLR2230, 
      RCV_GAP(1)=>Debug_1_EXMPLR2230, RCV_GAP(0)=>Debug_1_EXMPLR2230, 
      RCV_Gap_found(2)=>RCV_A_Gap_found(2), RCV_Gap_found(1)=>
      RCV_A_Gap_found(1), RCV_Gap_found(0)=>RCV_A_Gap_found(0), 
      RCV_RxRDY_plus_12us=>Debug_1_EXMPLR2230, RCV_RxRDY_plus_10us=>
      Debug_1_EXMPLR2230, RCV_CS=>RCV_A_CS, RCV_Pre_EchoRdy=>
      RCV_A_Pre_EchoRdy, RCV_Command_Sync=>RCV_A_Command_Sync, RCV_Pre_RxRdy
      =>RCV_A_Pre_RxRdy, RCV_recieving=>RCV_A_recieving, 
      No_Response_timeout(2)=>No_Response_timeout(2), No_Response_timeout(1)
      =>No_Response_timeout(1), No_Response_timeout(0)=>
      No_Response_timeout(0), Address(15)=>DANGLING(0), Address(14)=>
      DANGLING(1), Address(13)=>DANGLING(2), Address(12)=>DANGLING(3), 
      Address(11)=>DANGLING(4), Address(10)=>DANGLING(5), Address(9)=>
      DANGLING(6), Address(8)=>DANGLING(7), Address(7)=>DANGLING(8), 
      Address(6)=>DANGLING(9), Address(5)=>DANGLING(10), Address(4)=>
      DANGLING(11), Address(3)=>DANGLING(12), Address(2)=>DANGLING(13), 
      Address(1)=>DANGLING(14), Address(0)=>DANGLING(15), active_command(15)
      =>active_command_a(15), active_command(14)=>active_command_a(14), 
      active_command(13)=>active_command_a(13), active_command(12)=>
      active_command_a(12), active_command(11)=>active_command_a(11), 
      active_command(10)=>active_command_a(10), active_command(9)=>
      active_command_a(9), active_command(8)=>active_command_a(8), 
      active_command(7)=>active_command_a(7), active_command(6)=>
      active_command_a(6), active_command(5)=>active_command_a(5), 
      active_command(4)=>active_command_a(4), active_command(3)=>
      active_command_a(3), active_command(2)=>active_command_a(2), 
      active_command(1)=>active_command_a(1), active_command(0)=>
      active_command_a(0), new_command=>new_command_a, Record_command=>
      Record_command_A, Monitor_ended_OK=>BM_OK_A_EXMPLR2187, 
      Monitor_ended_not_OK=>BM_not_OK_A_EXMPLR2189, RT2RT_message=>
      RT2RT_message_a, Write_Req=>Write_Req_a, Write_Data(15)=>
      Write_Data_a(15), Write_Data(14)=>Write_Data_a(14), Write_Data(13)=>
      Write_Data_a(13), Write_Data(12)=>Write_Data_a(12), Write_Data(11)=>
      Write_Data_a(11), Write_Data(10)=>Write_Data_a(10), Write_Data(9)=>
      Write_Data_a(9), Write_Data(8)=>Write_Data_a(8), Write_Data(7)=>
      Write_Data_a(7), Write_Data(6)=>Write_Data_a(6), Write_Data(5)=>
      Write_Data_a(5), Write_Data(4)=>Write_Data_a(4), Write_Data(3)=>
      Write_Data_a(3), Write_Data(2)=>Write_Data_a(2), Write_Data(1)=>
      Write_Data_a(1), Write_Data(0)=>Write_Data_a(0), 
      MIL1553_ERRORS_Inhibit_TF=>MIL1553_Errors_A_Inhibit_TF, 
      MIL1553_ERRORS_invalid_command=>MIL1553_Errors_A_invalid_command, 
      MIL1553_ERRORS_RT2RT_format_gap=>MIL1553_Errors_A_RT2RT_format_gap, 
      MIL1553_ERRORS_RT2RT_format_error=>MIL1553_Errors_A_RT2RT_format_error, 
      MIL1553_ERRORS_Invalid_word=>MIL1553_Errors_A_Invalid_word, 
      MIL1553_ERRORS_Parity_Manchester=>DANGLING(16), 
      MIL1553_ERRORS_incorrect_data_sync=>
      MIL1553_Errors_A_incorrect_data_sync, MIL1553_ERRORS_Low_word_count=>
      MIL1553_Errors_A_Low_word_count, MIL1553_ERRORS_high_word_count=>
      MIL1553_Errors_A_high_word_count, MIL1553_ERRORS_Format_error=>
      DANGLING(17), MIL1553_ERRORS_Message_Error_set=>DANGLING(18), 
      MIL1553_ERRORS_Address_Parity=>MIL1553_Errors_A_Address_Parity, 
      MIL1553_ERRORS_echo_back_bus_B=>DANGLING(19), 
      MIL1553_ERRORS_echo_back_bus_A=>DANGLING(20), 
      MIL1553_ERRORS_bus_B_shutdown=>DANGLING(21), 
      MIL1553_ERRORS_bus_A_shutdown=>DANGLING(22), 
      MIL1553_ERRORS_transmitter_timout=>DANGLING(23), Debug(15)=>DANGLING(
      24), Debug(14)=>DANGLING(25), Debug(13)=>DANGLING(26), Debug(12)=>
      DANGLING(27), Debug(11)=>DANGLING(28), Debug(10)=>DANGLING(29), 
      Debug(9)=>DANGLING(30), Debug(8)=>DANGLING(31), Debug(7)=>DANGLING(32), 
      Debug(6)=>DANGLING(33), Debug(5)=>DANGLING(34), Debug(4)=>DANGLING(35), 
      Debug(3)=>DANGLING(36), Debug(2)=>DANGLING(37), Debug(1)=>DANGLING(38), 
      Debug(0)=>DANGLING(39), Tx_command_time=>DANGLING(40), last_data_time
      =>DANGLING(41), MODE_CODE1553A=>MODE_CODE1553A, NO_BCST=>
      Debug_1_EXMPLR2230);
   Monitor_Stm_b : Monitor_Stm_8_4_1_32 port map ( C=>C, R=>R, yossy=>PWR, 
      CE=>CE, Sync_Error=>RCV_B_Sync_Error, RCV_Bit_number(4)=>
      Debug_1_EXMPLR2230, RCV_Bit_number(3)=>Debug_1_EXMPLR2230, 
      RCV_Bit_number(2)=>Debug_1_EXMPLR2230, RCV_Bit_number(1)=>
      Debug_1_EXMPLR2230, RCV_Bit_number(0)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(7)=>Debug_1_EXMPLR2230, RCV_Response_Time(6)=>
      Debug_1_EXMPLR2230, RCV_Response_Time(5)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(4)=>Debug_1_EXMPLR2230, RCV_Response_Time(3)=>
      Debug_1_EXMPLR2230, RCV_Response_Time(2)=>Debug_1_EXMPLR2230, 
      RCV_Response_Time(1)=>Debug_1_EXMPLR2230, RCV_Response_Time(0)=>
      Debug_1_EXMPLR2230, RCV_Sync_error=>Debug_1_EXMPLR2230, 
      RCV_Manchester_error=>Debug_1_EXMPLR2230, RCV_Parity_error=>
      Debug_1_EXMPLR2230, RCV_echo_back_bus=>Debug_1_EXMPLR2230, 
      RCV_R_Data(15)=>RCV_B_R_Data(15), RCV_R_Data(14)=>RCV_B_R_Data(14), 
      RCV_R_Data(13)=>RCV_B_R_Data(13), RCV_R_Data(12)=>RCV_B_R_Data(12), 
      RCV_R_Data(11)=>RCV_B_R_Data(11), RCV_R_Data(10)=>RCV_B_R_Data(10), 
      RCV_R_Data(9)=>RCV_B_R_Data(9), RCV_R_Data(8)=>RCV_B_R_Data(8), 
      RCV_R_Data(7)=>RCV_B_R_Data(7), RCV_R_Data(6)=>RCV_B_R_Data(6), 
      RCV_R_Data(5)=>RCV_B_R_Data(5), RCV_R_Data(4)=>RCV_B_R_Data(4), 
      RCV_R_Data(3)=>RCV_B_R_Data(3), RCV_R_Data(2)=>RCV_B_R_Data(2), 
      RCV_R_Data(1)=>RCV_B_R_Data(1), RCV_R_Data(0)=>RCV_B_R_Data(0), 
      RCV_RAW_GAP(6)=>RCV_B_RAW_GAP(6), RCV_RAW_GAP(5)=>RCV_B_RAW_GAP(5), 
      RCV_RAW_GAP(4)=>RCV_B_RAW_GAP(4), RCV_RAW_GAP(3)=>RCV_B_RAW_GAP(3), 
      RCV_RAW_GAP(2)=>RCV_B_RAW_GAP(2), RCV_RAW_GAP(1)=>RCV_B_RAW_GAP(1), 
      RCV_RAW_GAP(0)=>RCV_B_RAW_GAP(0), RCV_GAP(6)=>Debug_1_EXMPLR2230, 
      RCV_GAP(5)=>Debug_1_EXMPLR2230, RCV_GAP(4)=>Debug_1_EXMPLR2230, 
      RCV_GAP(3)=>Debug_1_EXMPLR2230, RCV_GAP(2)=>Debug_1_EXMPLR2230, 
      RCV_GAP(1)=>Debug_1_EXMPLR2230, RCV_GAP(0)=>Debug_1_EXMPLR2230, 
      RCV_Gap_found(2)=>RCV_B_Gap_found(2), RCV_Gap_found(1)=>
      RCV_B_Gap_found(1), RCV_Gap_found(0)=>RCV_B_Gap_found(0), 
      RCV_RxRDY_plus_12us=>Debug_1_EXMPLR2230, RCV_RxRDY_plus_10us=>
      Debug_1_EXMPLR2230, RCV_CS=>RCV_B_CS, RCV_Pre_EchoRdy=>
      RCV_B_Pre_EchoRdy, RCV_Command_Sync=>RCV_B_Command_Sync, RCV_Pre_RxRdy
      =>RCV_B_Pre_RxRdy, RCV_recieving=>RCV_B_recieving, 
      No_Response_timeout(2)=>No_Response_timeout(2), No_Response_timeout(1)
      =>No_Response_timeout(1), No_Response_timeout(0)=>
      No_Response_timeout(0), Address(15)=>DANGLING(42), Address(14)=>
      DANGLING(43), Address(13)=>DANGLING(44), Address(12)=>DANGLING(45), 
      Address(11)=>DANGLING(46), Address(10)=>DANGLING(47), Address(9)=>
      DANGLING(48), Address(8)=>DANGLING(49), Address(7)=>DANGLING(50), 
      Address(6)=>DANGLING(51), Address(5)=>DANGLING(52), Address(4)=>
      DANGLING(53), Address(3)=>DANGLING(54), Address(2)=>DANGLING(55), 
      Address(1)=>DANGLING(56), Address(0)=>DANGLING(57), active_command(15)
      =>active_command_b(15), active_command(14)=>active_command_b(14), 
      active_command(13)=>active_command_b(13), active_command(12)=>
      active_command_b(12), active_command(11)=>active_command_b(11), 
      active_command(10)=>active_command_b(10), active_command(9)=>
      active_command_b(9), active_command(8)=>active_command_b(8), 
      active_command(7)=>active_command_b(7), active_command(6)=>
      active_command_b(6), active_command(5)=>active_command_b(5), 
      active_command(4)=>active_command_b(4), active_command(3)=>
      active_command_b(3), active_command(2)=>active_command_b(2), 
      active_command(1)=>active_command_b(1), active_command(0)=>
      active_command_b(0), new_command=>new_command_b, Record_command=>
      Record_command_B, Monitor_ended_OK=>BM_OK_B_EXMPLR2188, 
      Monitor_ended_not_OK=>BM_not_OK_B_EXMPLR2190, RT2RT_message=>
      RT2RT_message_b, Write_Req=>Write_Req_b, Write_Data(15)=>
      Write_Data_b(15), Write_Data(14)=>Write_Data_b(14), Write_Data(13)=>
      Write_Data_b(13), Write_Data(12)=>Write_Data_b(12), Write_Data(11)=>
      Write_Data_b(11), Write_Data(10)=>Write_Data_b(10), Write_Data(9)=>
      Write_Data_b(9), Write_Data(8)=>Write_Data_b(8), Write_Data(7)=>
      Write_Data_b(7), Write_Data(6)=>Write_Data_b(6), Write_Data(5)=>
      Write_Data_b(5), Write_Data(4)=>Write_Data_b(4), Write_Data(3)=>
      Write_Data_b(3), Write_Data(2)=>Write_Data_b(2), Write_Data(1)=>
      Write_Data_b(1), Write_Data(0)=>Write_Data_b(0), 
      MIL1553_ERRORS_Inhibit_TF=>MIL1553_Errors_B_Inhibit_TF, 
      MIL1553_ERRORS_invalid_command=>MIL1553_Errors_B_invalid_command, 
      MIL1553_ERRORS_RT2RT_format_gap=>MIL1553_Errors_B_RT2RT_format_gap, 
      MIL1553_ERRORS_RT2RT_format_error=>MIL1553_Errors_B_RT2RT_format_error, 
      MIL1553_ERRORS_Invalid_word=>MIL1553_Errors_B_Invalid_word, 
      MIL1553_ERRORS_Parity_Manchester=>DANGLING(58), 
      MIL1553_ERRORS_incorrect_data_sync=>
      MIL1553_Errors_B_incorrect_data_sync, MIL1553_ERRORS_Low_word_count=>
      MIL1553_Errors_B_Low_word_count, MIL1553_ERRORS_high_word_count=>
      MIL1553_Errors_B_high_word_count, MIL1553_ERRORS_Format_error=>
      DANGLING(59), MIL1553_ERRORS_Message_Error_set=>DANGLING(60), 
      MIL1553_ERRORS_Address_Parity=>MIL1553_Errors_B_Address_Parity, 
      MIL1553_ERRORS_echo_back_bus_B=>DANGLING(61), 
      MIL1553_ERRORS_echo_back_bus_A=>DANGLING(62), 
      MIL1553_ERRORS_bus_B_shutdown=>DANGLING(63), 
      MIL1553_ERRORS_bus_A_shutdown=>DANGLING(64), 
      MIL1553_ERRORS_transmitter_timout=>DANGLING(65), Debug(15)=>DANGLING(
      66), Debug(14)=>DANGLING(67), Debug(13)=>DANGLING(68), Debug(12)=>
      DANGLING(69), Debug(11)=>DANGLING(70), Debug(10)=>DANGLING(71), 
      Debug(9)=>DANGLING(72), Debug(8)=>DANGLING(73), Debug(7)=>DANGLING(74), 
      Debug(6)=>DANGLING(75), Debug(5)=>DANGLING(76), Debug(4)=>DANGLING(77), 
      Debug(3)=>DANGLING(78), Debug(2)=>DANGLING(79), Debug(1)=>DANGLING(80), 
      Debug(0)=>DANGLING(81), Tx_command_time=>DANGLING(82), last_data_time
      =>DANGLING(83), MODE_CODE1553A=>MODE_CODE1553A, NO_BCST=>
      Debug_1_EXMPLR2230);
   Monitor_ended_not_OK_3n1s1 <= BM_not_OK_A_EXMPLR2189 AND Record_command_A
    ;
   Monitor_ended_not_OK_3n1s2 <= BM_not_OK_B_EXMPLR2190 AND Record_command_B
    ;
   rtlc3n163 <= rtlc3n145 AND new_command_b ;
   rtlc3n162 <= not_new_command_b OR rtlc3n145 ;
   rtlc3n188 <= BM_OK_B_EXMPLR2188 OR BM_not_OK_B_EXMPLR2190 ;
   rtlc3n190 <= rtlc3n188 AND not_Monitor_Bus_A ;
   rtlc3n183 <= BM_OK_A_EXMPLR2187 OR BM_not_OK_A_EXMPLR2189 ;
   rtlc3n185 <= rtlc3n183 AND Monitor_Bus_A_EXMPLR2229 ;
   rtlc3n191 <= rtlc3n185 OR rtlc3n190 ;
   rtlc3n173 <= BM_OK_B_EXMPLR2188 AND Record_command_B ;
   rtlc3n170 <= BM_OK_A_EXMPLR2187 AND Record_command_A ;
   rtlc3n174 <= rtlc3n170 OR rtlc3n173 ;
   rtlc3n145 <= Monitor_Bus_A_EXMPLR2229 AND Debug_0_EXMPLR2191 ;
   rtlc3n133 <= not_Monitor_Bus_A AND Debug_0_EXMPLR2191 ;
   Write_6n1s1 <= Record_command_A OR Record_command_B ;
   rtlc6n36 <= Write_Req_a OR Write_Req_b ;
   not_Monitor_Bus_A <= NOT Monitor_Bus_A_EXMPLR2229 ;
   not_new_command_b <= NOT new_command_b ;
   not_R <= NOT R ;
   rtlcn28 <= Monitor_Bus_A_EXMPLR2229 AND RT2RT_message_a ;
   rtlcn30 <= not_Monitor_Bus_A AND RT2RT_message_b ;
   rtlcn10 <= rtlcn28 OR rtlcn30 ;
   rtlcn15 <= rtlc6n36 OR rtlc6n48 ;
   rtlcn27 <= new_command_b OR new_command_a ;
   Monitor_ended_not_OK_3n1ss1 <= Monitor_ended_not_OK_3n1s1 when 
   Monitor_Bus_A_EXMPLR2229 = '1' else Monitor_ended_not_OK_3n1s2 ;
   active_command_3n5ss1(0) <= active_command_a(0) when new_command_a
    = '1' else active_command_b(0) ;
   active_command_3n5ss1(1) <= active_command_a(1) when new_command_a
    = '1' else active_command_b(1) ;
   active_command_3n5ss1(2) <= active_command_a(2) when new_command_a
    = '1' else active_command_b(2) ;
   active_command_3n5ss1(3) <= active_command_a(3) when new_command_a
    = '1' else active_command_b(3) ;
   active_command_3n5ss1(4) <= active_command_a(4) when new_command_a
    = '1' else active_command_b(4) ;
   active_command_3n5ss1(5) <= active_command_a(5) when new_command_a
    = '1' else active_command_b(5) ;
   active_command_3n5ss1(6) <= active_command_a(6) when new_command_a
    = '1' else active_command_b(6) ;
   active_command_3n5ss1(7) <= active_command_a(7) when new_command_a
    = '1' else active_command_b(7) ;
   active_command_3n5ss1(8) <= active_command_a(8) when new_command_a
    = '1' else active_command_b(8) ;
   active_command_3n5ss1(9) <= active_command_a(9) when new_command_a
    = '1' else active_command_b(9) ;
   active_command_3n5ss1(10) <= active_command_a(10) when new_command_a
    = '1' else active_command_b(10) ;
   active_command_3n5ss1(11) <= active_command_a(11) when new_command_a
    = '1' else active_command_b(11) ;
   active_command_3n5ss1(12) <= active_command_a(12) when new_command_a
    = '1' else active_command_b(12) ;
   active_command_3n5ss1(13) <= active_command_a(13) when new_command_a
    = '1' else active_command_b(13) ;
   active_command_3n5ss1(14) <= active_command_a(14) when new_command_a
    = '1' else active_command_b(14) ;
   active_command_3n5ss1(15) <= active_command_a(15) when new_command_a
    = '1' else active_command_b(15) ;
   rtlc3n165 <= rtlc3n133 when new_command_a = '1' else rtlc3n162 ;
   rtlc3n166 <= rtlc3n133 when new_command_a = '1' else rtlc3n163 ;
   Write_Data_9n2ss1(0) <= Write_Data_a(0) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(0) ;
   Write_Data_9n2ss1(1) <= Write_Data_a(1) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(1) ;
   Write_Data_9n2ss1(2) <= Write_Data_a(2) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(2) ;
   Write_Data_9n2ss1(3) <= Write_Data_a(3) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(3) ;
   Write_Data_9n2ss1(4) <= Write_Data_a(4) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(4) ;
   Write_Data_9n2ss1(5) <= Write_Data_a(5) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(5) ;
   Write_Data_9n2ss1(6) <= Write_Data_a(6) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(6) ;
   Write_Data_9n2ss1(7) <= Write_Data_a(7) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(7) ;
   Write_Data_9n2ss1(8) <= Write_Data_a(8) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(8) ;
   Write_Data_9n2ss1(9) <= Write_Data_a(9) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(9) ;
   Write_Data_9n2ss1(10) <= Write_Data_a(10) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(10) ;
   Write_Data_9n2ss1(11) <= Write_Data_a(11) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(11) ;
   Write_Data_9n2ss1(12) <= Write_Data_a(12) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(12) ;
   Write_Data_9n2ss1(13) <= Write_Data_a(13) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(13) ;
   Write_Data_9n2ss1(14) <= Write_Data_a(14) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(14) ;
   Write_Data_9n2ss1(15) <= Write_Data_a(15) when Monitor_Bus_A_EXMPLR2229
    = '1' else Write_Data_b(15) ;
   MIL1553_Errors_9n2ss1_0 <= MIL1553_Errors_A_Inhibit_TF when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_Inhibit_TF ;
   MIL1553_Errors_9n2ss1_1 <= MIL1553_Errors_A_invalid_command when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_invalid_command ;
   MIL1553_Errors_9n2ss1_2 <= MIL1553_Errors_A_RT2RT_format_gap when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_RT2RT_format_gap ;
   MIL1553_Errors_9n2ss1_3 <= MIL1553_Errors_A_RT2RT_format_error when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_RT2RT_format_error ;
   MIL1553_Errors_9n2ss1_4 <= MIL1553_Errors_A_Invalid_word when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_Invalid_word ;
   MIL1553_Errors_9n2ss1_6 <= MIL1553_Errors_A_incorrect_data_sync when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_incorrect_data_sync
    ;
   MIL1553_Errors_9n2ss1_7 <= MIL1553_Errors_A_Low_word_count when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_Low_word_count ;
   MIL1553_Errors_9n2ss1_8 <= MIL1553_Errors_A_high_word_count when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_high_word_count ;
   MIL1553_Errors_9n2ss1_11 <= MIL1553_Errors_A_Address_Parity when 
   Monitor_Bus_A_EXMPLR2229 = '1' else MIL1553_Errors_B_Address_Parity ;
   not_rtlc3n165 <= NOT rtlc3n165 ;
   rtlc3n253 <= CE AND not_rtlc3n165 ;
   rtlcn38 <= not_rtlc3n165 OR rtlc3n191 ;
   rtlc3n237 <= CE AND rtlcn38 ;
   not_rtlc3n191 <= NOT rtlc3n191 ;
   not_rtlc3n166 <= NOT rtlc3n166 ;
   rtlc3n234 <= CE AND not_rtlc3n166 ;
   rtlcn37 <= Record_command_B OR Monitor_Bus_A_EXMPLR2229 ;
   not_Debug_0 <= NOT Debug_0_EXMPLR2191 ;
   rtlcn39 <= not_Debug_0 OR rtlcn37 ;
   rtlc9n150 <= CE AND rtlcn39 ;
   MIL1553_Errors_9n3ss1_0 <= MIL1553_Errors_9n2ss1_0 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_1 <= MIL1553_Errors_9n2ss1_1 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_2 <= MIL1553_Errors_9n2ss1_2 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_3 <= MIL1553_Errors_9n2ss1_3 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_4 <= MIL1553_Errors_9n2ss1_4 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_6 <= MIL1553_Errors_9n2ss1_6 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_7 <= MIL1553_Errors_9n2ss1_7 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_8 <= MIL1553_Errors_9n2ss1_8 AND Debug_0_EXMPLR2191
    ;
   MIL1553_Errors_9n3ss1_11 <= MIL1553_Errors_9n2ss1_11 AND 
   Debug_0_EXMPLR2191 ;
   Write_6n2ss1 <= Write_6n1s1 AND rtlcn15 ;
   Write_Data_9n3ss1(0) <= Write_Data_9n2ss1(0) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(1) <= Write_Data_9n2ss1(1) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(2) <= Write_Data_9n2ss1(2) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(3) <= Write_Data_9n2ss1(3) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(4) <= Write_Data_9n2ss1(4) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(5) <= Write_Data_9n2ss1(5) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(6) <= Write_Data_9n2ss1(6) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(7) <= Write_Data_9n2ss1(7) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(8) <= Write_Data_9n2ss1(8) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(9) <= Write_Data_9n2ss1(9) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(10) <= Write_Data_9n2ss1(10) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(11) <= Write_Data_9n2ss1(11) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(12) <= Write_Data_9n2ss1(12) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(13) <= Write_Data_9n2ss1(13) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(14) <= Write_Data_9n2ss1(14) AND Debug_0_EXMPLR2191 ;
   Write_Data_9n3ss1(15) <= Write_Data_9n2ss1(15) AND Debug_0_EXMPLR2191 ;
   rtlc_522_or_1144 : or_7u_7u port map ( a(6)=>Write_Length(0), a(5)=>
      Write_Length(1), a(4)=>Write_Length(2), a(3)=>Write_Length(3), a(2)=>
      Write_Length(4), a(1)=>Write_Length(5), a(0)=>Write_Length(6), d=>
      rtlc6n48);
   modgen_counter_Write_Length : 
      counter_dn_cnt_en_sload_aclear_clock_clk_en_0_7 port map ( clock=>C, 
      q(6)=>Write_Length(6), q(5)=>Write_Length(5), q(4)=>Write_Length(4), 
      q(3)=>Write_Length(3), q(2)=>Write_Length(2), q(1)=>Write_Length(1), 
      q(0)=>Write_Length(0), clk_en=>CE, aclear=>not_R, sload=>rtlc6n36, 
      data(6)=>Debug_1_EXMPLR2230, data(5)=>PWR, data(4)=>PWR, data(3)=>PWR, 
      data(2)=>PWR, data(1)=>PWR, data(0)=>PWR, aset=>Debug_1_EXMPLR2230, 
      sclear=>Debug_1_EXMPLR2230, updn=>Debug_1_EXMPLR2230, cnt_en=>rtlc6n48
   );
   DFFPCE (active_command_3n5ss1(15),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(15)) ;
   DFFPCE (active_command_3n5ss1(14),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(14)) ;
   DFFPCE (active_command_3n5ss1(13),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(13)) ;
   DFFPCE (active_command_3n5ss1(12),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(12)) ;
   DFFPCE (active_command_3n5ss1(11),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(11)) ;
   DFFPCE (active_command_3n5ss1(10),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(10)) ;
   DFFPCE (active_command_3n5ss1(9),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(9)) ;
   DFFPCE (active_command_3n5ss1(8),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(8)) ;
   DFFPCE (active_command_3n5ss1(7),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(7)) ;
   DFFPCE (active_command_3n5ss1(6),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(6)) ;
   DFFPCE (active_command_3n5ss1(5),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(5)) ;
   DFFPCE (active_command_3n5ss1(4),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(4)) ;
   DFFPCE (active_command_3n5ss1(3),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(3)) ;
   DFFPCE (active_command_3n5ss1(2),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(2)) ;
   DFFPCE (active_command_3n5ss1(1),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(1)) ;
   DFFPCE (active_command_3n5ss1(0),Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   active_command(0)) ;
   DFFPCE (not_rtlc3n191,Debug_1_EXMPLR2230,not_R,rtlc3n237,C,
   Debug_0_EXMPLR2191) ;
   DFFPCE (Monitor_ended_not_OK_3n1ss1,Debug_1_EXMPLR2230,not_R,CE,C,
   Monitor_ended_not_OK) ;
   DFFPCE (rtlc3n174,Debug_1_EXMPLR2230,not_R,CE,C,Monitor_ended_OK) ;
   DFFPCE (rtlcn27,Debug_1_EXMPLR2230,not_R,rtlc3n234,C,new_command) ;
   DFFPCE (new_command_a,Debug_1_EXMPLR2230,not_R,rtlc3n253,C,
   Monitor_Bus_A_EXMPLR2229) ;
   DFFPCE (Write_6n2ss1,Debug_1_EXMPLR2230,not_R,CE,C,Write) ;
   DFFPCE (rtlcn10,Debug_1_EXMPLR2230,not_R,rtlc9n151,C,RT2RT_message) ;
   DFFPCE (MIL1553_Errors_9n3ss1_11,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_Address_Parity) ;
   DFFPCE (MIL1553_Errors_9n3ss1_8,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_high_word_count) ;
   DFFPCE (MIL1553_Errors_9n3ss1_7,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_Low_word_count) ;
   DFFPCE (MIL1553_Errors_9n3ss1_6,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_incorrect_data_sync) ;
   DFFPCE (MIL1553_Errors_9n3ss1_4,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_Invalid_word) ;
   DFFPCE (MIL1553_Errors_9n3ss1_3,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_RT2RT_format_error) ;
   DFFPCE (MIL1553_Errors_9n3ss1_2,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_RT2RT_format_gap) ;
   DFFPCE (MIL1553_Errors_9n3ss1_1,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_invalid_command) ;
   DFFPCE (MIL1553_Errors_9n3ss1_0,Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   MIL1553_Errors_Inhibit_TF) ;
   DFFPCE (Write_Data_9n3ss1(15),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(15)) ;
   DFFPCE (Write_Data_9n3ss1(14),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(14)) ;
   DFFPCE (Write_Data_9n3ss1(13),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(13)) ;
   DFFPCE (Write_Data_9n3ss1(12),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(12)) ;
   DFFPCE (Write_Data_9n3ss1(11),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(11)) ;
   DFFPCE (Write_Data_9n3ss1(10),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(10)) ;
   DFFPCE (Write_Data_9n3ss1(9),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(9)) ;
   DFFPCE (Write_Data_9n3ss1(8),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(8)) ;
   DFFPCE (Write_Data_9n3ss1(7),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(7)) ;
   DFFPCE (Write_Data_9n3ss1(6),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(6)) ;
   DFFPCE (Write_Data_9n3ss1(5),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(5)) ;
   DFFPCE (Write_Data_9n3ss1(4),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(4)) ;
   DFFPCE (Write_Data_9n3ss1(3),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(3)) ;
   DFFPCE (Write_Data_9n3ss1(2),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(2)) ;
   DFFPCE (Write_Data_9n3ss1(1),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(1)) ;
   DFFPCE (Write_Data_9n3ss1(0),Debug_1_EXMPLR2230,not_R,rtlc9n150,C,
   Write_Data(0)) ;
   modgen_and_0 : and_3u_3u port map ( a(2)=>CE, a(1)=>Debug_0_EXMPLR2191, 
      a(0)=>rtlcn37, d=>rtlc9n151);
end Sital_ofer_hofman_unfold_3022 ;


architecture INTERFACE_unfold_2 of 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_10u_10u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic_vector (9 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx25, nx28, nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, 
      nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, nx49, nx50, 
      nx51, nx52, nx53, nx54, nx55, nx56, nx57, nx58, nx59, nx60, PWR, 
      NOT_nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(9) <= nx32 ;
   q(8) <= nx34 ;
   q(7) <= nx36 ;
   q(6) <= nx38 ;
   q(5) <= nx40 ;
   q(4) <= nx42 ;
   q(3) <= nx44 ;
   q(2) <= nx46 ;
   q(1) <= nx48 ;
   q(0) <= nx50 ;
   GND <= '0' ;
   nx25 <= cnt_en OR sclear ;
   nx28 <= nx25 AND clk_en ;
   DFFPCE (nx31,GND,aclear,nx28,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx28,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx28,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx28,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,nx28,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,nx28,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,nx28,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,nx28,clock,nx46) ;
   DFFPCE (nx47,GND,aclear,nx28,clock,nx48) ;
   DFFPCE (nx49,GND,aclear,nx28,clock,nx50) ;
   inc : inc_10u_10u_0_0 port map ( cin=>PWR, a(9)=>nx32, a(8)=>nx34, a(7)=>
      nx36, a(6)=>nx38, a(5)=>nx40, a(4)=>nx42, a(3)=>nx44, a(2)=>nx46, a(1)
      =>nx48, a(0)=>nx50, d(9)=>nx51, d(8)=>nx52, d(7)=>nx53, d(6)=>nx54, 
      d(5)=>nx55, d(4)=>nx56, d(3)=>nx57, d(2)=>nx58, d(1)=>nx59, d(0)=>nx60, 
      cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx24 <= NOT sclear ;
   nx31 <= nx51 AND NOT_nx24 ;
   nx33 <= nx52 AND NOT_nx24 ;
   nx35 <= nx53 AND NOT_nx24 ;
   nx37 <= nx54 AND NOT_nx24 ;
   nx39 <= nx55 AND NOT_nx24 ;
   nx41 <= nx56 AND NOT_nx24 ;
   nx43 <= nx57 AND NOT_nx24 ;
   nx45 <= nx58 AND NOT_nx24 ;
   nx47 <= nx59 AND NOT_nx24 ;
   nx49 <= nx60 AND NOT_nx24 ;
end INTERFACE_unfold_2 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_cnt_en_sload_aset_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_cnt_en_sload_aset_clock_clk_en_0_5 ;

architecture INTERFACE of counter_dn_cnt_en_sload_aset_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx18, nx21, nx22, nx23, nx24, nx25, nx26, nx27, nx28, 
      nx29, nx30, nx31, nx32, nx33, nx34, nx35: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx22 ;
   q(3) <= nx24 ;
   q(2) <= nx26 ;
   q(1) <= nx28 ;
   q(0) <= nx30 ;
   GND <= '0' ;
   nx15 <= cnt_en OR sload ;
   nx18 <= nx15 AND clk_en ;
   DFFPCE (nx21,aset,GND,nx18,clock,nx22) ;
   DFFPCE (nx23,aset,GND,nx18,clock,nx24) ;
   DFFPCE (nx25,aset,GND,nx18,clock,nx26) ;
   DFFPCE (nx27,aset,GND,nx18,clock,nx28) ;
   DFFPCE (nx29,aset,GND,nx18,clock,nx30) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx22, a(3)=>nx24, a(2)=>
      nx26, a(1)=>nx28, a(0)=>nx30, d(4)=>nx31, d(3)=>nx32, d(2)=>nx33, d(1)
      =>nx34, d(0)=>nx35, cout=>DANGLING(0));
   nx21 <= data(4) when sload = '1' else nx31 ;
   nx23 <= data(3) when sload = '1' else nx32 ;
   nx25 <= data(2) when sload = '1' else nx33 ;
   nx27 <= data(1) when sload = '1' else nx34 ;
   nx29 <= data(0) when sload = '1' else nx35 ;
end INTERFACE ;


architecture INTERFACE of counter_up_sclear_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, PWR, NOT_SCLEAR: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>PWR, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_SCLEAR <= NOT sclear ;
   nx15 <= nx25 AND NOT_SCLEAR ;
   nx17 <= nx26 AND NOT_SCLEAR ;
   nx19 <= nx27 AND NOT_SCLEAR ;
   nx21 <= nx28 AND NOT_SCLEAR ;
   nx23 <= nx29 AND NOT_SCLEAR ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity BC_Stm_ver8_4_1_32 is 
   port (
      C : IN std_logic ;
      R : IN std_logic ;
      CE : IN std_logic ;
      Yoav : IN std_logic ;
      RCV_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      RCV_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      rtlc_RCV_A_Sync_error_n2598 : IN std_logic ;
      RCV_A_Manchester_error : IN std_logic ;
      RCV_A_Parity_error : IN std_logic ;
      RCV_A_echo_back_bus : IN std_logic ;
      RCV_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      RCV_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_A_RxRDY_plus_12us : IN std_logic ;
      RCV_A_RxRDY_plus_10us : IN std_logic ;
      RCV_A_CS : IN std_logic ;
      RCV_A_Pre_EchoRdy : IN std_logic ;
      RCV_A_Command_Sync : IN std_logic ;
      RCV_A_Pre_RxRdy : IN std_logic ;
      RCV_A_recieving : IN std_logic ;
      RCV_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      RCV_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      rtlc_RCV_B_Sync_error_n2599 : IN std_logic ;
      RCV_B_Manchester_error : IN std_logic ;
      RCV_B_Parity_error : IN std_logic ;
      RCV_B_echo_back_bus : IN std_logic ;
      RCV_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      RCV_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      RCV_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_B_RxRDY_plus_12us : IN std_logic ;
      RCV_B_RxRDY_plus_10us : IN std_logic ;
      RCV_B_CS : IN std_logic ;
      RCV_B_Pre_EchoRdy : IN std_logic ;
      RCV_B_Command_Sync : IN std_logic ;
      RCV_B_Pre_RxRdy : IN std_logic ;
      RCV_B_recieving : IN std_logic ;
      No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
      RCV_A_Sync_error : IN std_logic ;
      RCV_B_Sync_error : IN std_logic ;
      Transmit_data : OUT std_logic_vector (15 DOWNTO 0) ;
      T_Sync : OUT std_logic ;
      Go_Tx : OUT std_logic ;
      Tx_Rdy : IN std_logic ;
      Tx_Bus_A : OUT std_logic ;
      Tx_Data : IN std_logic_vector (15 DOWNTO 0) ;
      Read : OUT std_logic ;
      Go : IN std_logic ;
      ENC_TEST_Go : IN std_logic ;
      RT2RT : IN std_logic ;
      Bus_A : IN std_logic ;
      Rx_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      Write : OUT std_logic ;
      Echo : OUT std_logic ;
      Message_Active : OUT std_logic ;
      Command_Sync : OUT std_logic ;
      Idle_state : OUT std_logic ;
      Activity_on_wrong_bus : OUT std_logic ;
      Response_timeout_Error : OUT std_logic ;
      Found_Format_Error : OUT std_logic ;
      Loopback_error : OUT std_logic ;
      Found_wrong_RT_Address : OUT std_logic ;
      Found_wrong_word_count : OUT std_logic ;
      Bus_Coupling_error : OUT std_logic ;
      BC_logic_error : OUT std_logic ;
      Wrong_Sync_error : OUT std_logic ;
      FE_All_Errors : OUT std_logic ;
      Good_data_block_recieved : OUT std_logic ;
      NO_BCST : IN std_logic ;
      BC_1553A : IN std_logic ;
      BC_1553A_ME : OUT std_logic ;
      Config_reg_4 : IN std_logic_vector (15 DOWNTO 0) ;
      Debug : OUT std_logic_vector (15 DOWNTO 0)) ;
end BC_Stm_ver8_4_1_32 ;

architecture SITAL_Technology_unfold_3026 of BC_Stm_ver8_4_1_32 is 
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_8u_8u
      port (
         a : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_5_5
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_6u_6u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_8u_8u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic_vector (7 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_6_6
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         b : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_16u_16u
      port (
         a : IN std_logic_vector (15 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_8u_8u
      port (
         a : IN std_logic_vector (7 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (9 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (9 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_cnt_en_sload_aset_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_sclear_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component eq_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         b : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_Energy_Count : 
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 use entity work.
   counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10(INTERFACE_unfold_2);
   
   for modgen_counter_us_counter : counter_up_sclear_aclear_clock_clk_en_0_5
    use entity work.counter_up_sclear_aclear_clock_clk_en_0_5(INTERFACE);
   signal Tx_Bus_A_EXMPLR2345, FE_All_Errors_EXMPLR2395, recieving_on_A, 
      recieving_on_B, first_command_15, first_command_14, first_command_13, 
      first_command_12, first_command_11, first_command_10, first_command_9, 
      first_command_8, first_command_7, first_command_6, first_command_5, 
      Debug_2_EXMPLR2401, first_command_3, first_command_2, first_command_1, 
      first_command_0, active_command_15, active_command_14, 
      active_command_13, active_command_12, active_command_11, 
      active_command_10, active_command_9, active_command_8, 
      active_command_7, active_command_6, active_command_5, active_command_3, 
      active_command_2, active_command_1, active_command_0, WC_5, WC_3, WC_2, 
      WC_1, WC_0, mode_message_no_data, BCR_message, ME_message, 
      BUSY_message, Tx_message: std_logic ;
   
   signal word_counter: std_logic_vector (5 DOWNTO 0) ;
   
   signal timeout_count_enable, timeout, Set_time_out_to_5us, 
      Set_time_out_to_echo, Set_time_out_to_rcv, Receive_problem: std_logic
    ;
   
   signal us_counter: std_logic_vector (4 DOWNTO 0) ;
   
   signal Found_errors, Sync_error, RT2RT_int, read_req, read_ack, write_req, 
      write_ack: std_logic ;
   
   signal Down_count: std_logic_vector (4 DOWNTO 0) ;
   
   signal Energy_Count: std_logic_vector (9 DOWNTO 0) ;
   
   signal state: std_logic_vector (19 DOWNTO 0) ;
   
   signal PWR, not_R, BCR_message_10n2s2, not_BC_1553A, 
      mode_message_no_data_10n2s3, mode_message_no_data_10n2s6, 
      mode_message_no_data_10n2s2, rtlc13n27, rtlc13n39, not_Energy_Count_9, 
      rtlc13n162, rtlc13n164, not_rtlcn122, rtlc13n167, RCV_16n5ss1_56, 
      RCV_16n5ss1_55, RCV_16n5ss1_54, RCV_16n5ss1_53, RCV_16n5ss1_52, 
      RCV_16n5ss1_49, RCV_16n5ss1_48, RCV_16n5ss1_47, RCV_16n5ss1_32, 
      RCV_16n5ss1_31, RCV_16n5ss1_30, RCV_16n5ss1_29, RCV_16n5ss1_28, 
      RCV_16n5ss1_27, RCV_16n5ss1_26, RCV_16n5ss1_25, RCV_16n5ss1_24, 
      RCV_16n5ss1_23, RCV_16n5ss1_22, RCV_16n5ss1_21, RCV_16n5ss1_20, 
      RCV_16n5ss1_19, RCV_16n5ss1_18, RCV_16n5ss1_17, Sync_error_16n5ss1, 
      not_Go: std_logic ;
   
   signal time_out_counter_var: std_logic_vector (7 DOWNTO 0) ;
   
   signal FE_All_Errors_20n21ss1, FE_All_Errors_20n22ss1, 
      state_fsm_20n23ss1_17, state_fsm_20n32ss1_17, 
      Response_timeout_Error_20n33ss1, state_fsm_20n33ss1_10, 
      state_fsm_20n43ss1_10, state_fsm_20n45ss1_17, state_fsm_20n45ss1_10, 
      state_fsm_20n63ss1_17, state_fsm_20n76ss1_10, RT2RT_int_20n83ss1: 
   std_logic ;
   
   signal Rx_Data_20n83ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal T_Sync_20n83ss1, active_command_20n83ss1_15, 
      active_command_20n83ss1_14, active_command_20n83ss1_13, 
      active_command_20n83ss1_12, active_command_20n83ss1_11, 
      active_command_20n83ss1_10, active_command_20n83ss1_9, 
      active_command_20n83ss1_8, active_command_20n83ss1_7, 
      active_command_20n83ss1_6, active_command_20n83ss1_5, 
      active_command_20n83ss1_3, active_command_20n83ss1_2, 
      active_command_20n83ss1_1, active_command_20n83ss1_0: std_logic ;
   
   signal word_counter_20n83ss1: std_logic_vector (5 DOWNTO 0) ;
   
   signal Set_time_out_to_5us_20n83ss1, Set_time_out_to_rcv_20n83ss1, 
      Response_timeout_Error_20n83ss1, Found_Format_Error_20n83ss1, 
      Loopback_error_20n83ss1, Found_wrong_RT_Address_20n83ss1, 
      Found_wrong_word_count_20n83ss1, Wrong_Sync_error_20n83ss1, 
      BC_logic_error_20n83ss1, Bus_Coupling_error_20n83ss1, 
      FE_All_Errors_20n83ss1, Good_data_block_recieved_20n83ss1, 
      Found_errors_20n83ss1, ME_message_20n83ss1, BUSY_message_20n83ss1, 
      state_fsm_20n83ss1_17, state_fsm_20n83ss1_10, state_fsm_20n83ss1_7, 
      time_out_counter_var_20n97ss1_7, time_out_counter_var_20n97ss1_6, 
      time_out_counter_var_20n97ss1_3, time_out_counter_var_20n97ss1_0, 
      time_out_counter_var_20n98ss1_2: std_logic ;
   
   signal time_out_counter_var_20n99ss1: std_logic_vector (7 DOWNTO 0) ;
   
   signal not_ENC_TEST_Go, not_Found_errors, rtlc20n5255, not_Bus_A, 
      rtlc20n5257, rtlc20n5258, BC_1553A_ME_20n26s1, not_rtlcs18, 
      rtlc20n5499, not_rtlcs14, not_BCR_message, rtlc20n5751, rtlc20n5769, 
      rtlc20n5770, rtlc20n5790, rtlc20n5807, rtlc20n5809, rtlc20n5810, 
      not_FE_All_Errors, Loopback_error_20n18s1, rtlc20n5893, rtlc20n5894, 
      rtlc20n5898, rtlc20n5912, rtlc20n5932, rtlc20n6009, not_rtlc20n6009, 
      not_RCV_Pre_RxRdy, rtlc20n6070, not_RCV_Command_Sync: std_logic ;
   
   signal word_counter_20n69s1: std_logic_vector (5 DOWNTO 0) ;
   
   signal not_RCV_CS, rtlc20n6165, not_rtlc20n6165, rtlc20n6172, rtlc20n6189, 
      rtlc20n6194, rtlc20n6195, rtlc20n6196, rtlc20n6201, rtlc20n6202, 
      not_rtlcs5, read_ack_20n87s2, read_ack_20n87s1, write_ack_20n90s1, 
      rtlc20n6319: std_logic ;
   
   signal time_out_counter_var_20n92s1: std_logic_vector (7 DOWNTO 0) ;
   
   signal rtlc20n6615, rtlc20n6619, rtlc20_X_0_n6664, rtlc20n6820, 
      rtlc20n6830, rtlc20n6843, not_rtlc20n6843, rtlc20n6855, rtlc20n6890, 
      rtlc20n6894, not_rtlc20n6894, rtlc20n6914, rtlc20n6921, rtlc20n6931, 
      rtlc20n7016, rtlc20n7044, rtlc20n7045, rtlc20n7062, rtlc20n7063, 
      rtlc20n7065, rtlc20n7082, rtlc20n7083, rtlc20n7084, rtlc20n7100, 
      rtlc20n7116, not_rtlcn1947, rtlc20n7131, rtlc20n7133, rtlc20n7137, 
      rtlc20n7138, rtlc20n7140, rtlc20n7152, rtlc20n7153, rtlc20n7155, 
      rtlc20n7156, rtlc20n7192, rtlc20n7196, not_rtlc20n7196, rtlc20n7199, 
      rtlc20n7206, not_rtlc20n7206, rtlc20n7215, not_rtlc20n7215, 
      rtlc20n7218, rtlc20n7221, rtlc20n7224, not_rtlc20n7224, not_state_0, 
      not_rtlc20n6921, rtlc20n7482, rtlc20n7483, rtlcn122, rtlcn125, 
      rtlcn189, rtlcn193, rtlcn209, rtlcn218, rtlcn219, rtlcn220, rtlcn222, 
      rtlcn224, rtlcn234, rtlcn236, rtlcn240, rtlcn245, rtlcn259, rtlcn263, 
      rtlcn274, rtlcn318, rtlcn360, rtlcn371, rtlcn383, rtlcn425, rtlcn615, 
      rtlcn659, rtlcn667, rtlcn704, rtlcn767, rtlcn784, rtlcn785, rtlcn786, 
      rtlcn796, rtlcn799, rtlcn800, rtlcn809, rtlcn810, rtlcn821, rtlcn824, 
      rtlcn863, rtlcn877, rtlcn881, rtlcn884, rtlcn969, rtlcn1008, rtlcn1009, 
      rtlcn1010, rtlcn1018, rtlcn1019, rtlcn1119, rtlcn1120, rtlcn1122, 
      rtlcn1185, rtlcn1213, rtlcn1221, not_rtlcn1935, not_rtlcn1936, 
      not_rtlcn1940, not_rtlcn1943, rtlcn1468, rtlcn1470, rtlcn1476, 
      rtlcn1484, rtlcn1490, rtlcn1497, rtlcn1503, rtlcn1508, rtlcn1513, 
      rtlcn1517, rtlcn1526, rtlcn1531, rtlcn1535, rtlcn1536, rtlcn1537, 
      rtlcn1542, rtlcn1551, rtlcn1552, rtlcn1554, rtlcn1555, rtlcn1561, 
      rtlcn1564, not_rtlcn1937, not_rtlcn1938, rtlcn1611, rtlcn1614, 
      not_rtlcn1939, not_rtlcn1944, rtlcn1645, not_rtlcn1645, rtlcn1647, 
      not_rtlcn1647, rtlcn1649, rtlcn1650, rtlcn1651, rtlcn1652, rtlcn1653, 
      rtlcn1654, rtlcn1655, rtlcn1656, rtlcn1657, rtlcn1659, rtlcn1660, 
      rtlcn1661, rtlcn1662, rtlcn1663, rtlcn1664, rtlcn1665, rtlcn1666, 
      rtlcn1667, rtlcn1668, rtlcn1669, rtlcn1670, rtlcn1671, rtlcn1673, 
      not_rtlcn1941, rtlcn1676, rtlcn1677, rtlcn1678, rtlcn1679, rtlcn1680, 
      rtlcn1681, rtlcn1682, rtlcn1683, rtlcn1684, rtlcn1685, rtlcn1686, 
      rtlcn1687, rtlcn1688, rtlcn1689, rtlcn1690, rtlcn1691, rtlcn1692, 
      rtlcn1693, rtlcn1694, rtlcn1695, rtlcn1697, rtlcn1698, rtlcn1699, 
      rtlcn1700, rtlcn1701, rtlcn1702, rtlcn1703, rtlcn1704, rtlcn1705, 
      rtlcn1706, rtlcn1707, rtlcn1708, rtlcn1709, rtlcn1710, not_timeout, 
      rtlcn1712, not_RT2RT_int, rtlcn1714, not_mode_message_no_data, 
      not_rtlcn704, rtlcn1722, not_state_7, not_state_16, 
      not_Set_time_out_to_echo, rtlcn1728, not_Receive_problem, 
      not_Set_time_out_to_5us, rtlcn1731, not_rtlc20n7016, rtlcn1733, 
      not_Set_time_out_to_rcv, not_rtlcs7, rtlcn1736, rtlcn1737, rtlcn1738, 
      not_rtlcs9, not_rtlc20n7483, not_rtlcn240, rtlcn1750, rtlcn1751, 
      rtlcn1752, rtlcn1753, not_rtlc20n5499, rtlcn1755, rtlcn1756, rtlcn1757, 
      not_rtlcn1682, rtlcn1759, not_rtlc20n5894, not_rtlcn1942, 
      not_rtlc20n6172, rtlcn1766, rtlcn1767, rtlcn1769, not_rtlcn1659, 
      rtlcn1771, rtlcn1774, not_Tx_message, not_read_ack, not_Tx_Rdy, 
      not_rtlcn1690, rtlcn1781, rtlcn1782, rtlcn1783, rtlcn1785, rtlcn1786, 
      not_state_3, not_rtlcn1655, not_RCV_Pre_EchoRdy, rtlcn1790, 
      not_state_5, not_rtlcn1653, rtlcn1793, not_rtlcn1656, rtlcn1796, 
      rtlcn1797, not_write_ack, rtlcn1799, not_rtlcn1651, rtlcn1801, 
      rtlcn1802, rtlcn1803, rtlcn1804, rtlcn1805, rtlcn1806, not_rtlcn1669, 
      rtlcn1808, not_rtlcn1665, not_rtlcs19, rtlcn1811, not_rtlcs20, 
      rtlcn1813, rtlcn1814, rtlcn1815, rtlcn1816, not_rtlcn1677, rtlcn1819, 
      rtlcn1820, rtlcn1821, rtlcn1822, not_rtlcn236, rtlcn1827, not_read_req, 
      not_rtlcs13, rtlcn1830, rtlcn1831, rtlcn1833, rtlcn1834, rtlcn1835, 
      rtlcn1837, rtlcn1840, not_rtlcn1685, rtlcn1842, rtlcn1843, rtlcn1844, 
      not_write_req, rtlcn1847, rtlcn1848, not_rtlcn1668, rtlcn1850, 
      rtlcn1852, rtlcn1853, rtlcn1854, not_state_14, not_state_15, 
      not_rtlcn1678, not_rtlcn1660, rtlcn1860, rtlcn1861, rtlcn1862, 
      rtlcn1863, rtlcn1864, rtlcn1865, rtlcn1866, rtlcn1869, rtlcn1871, 
      rtlcn1872, rtlcn1873, rtlcn1875, rtlcn1877, rtlcn1878, rtlcn1880, 
      rtlcn1883, rtlcn1884, not_rtlcn1945, rtlcn1888, rtlcn1889, 
      not_rtlc20n6890, rtlcn1935, rtlcn1936, rtlcn1937, rtlcn1938, rtlcn1939, 
      rtlcn1940, rtlcn1941, rtlcn1942, rtlcn1943, rtlcn1944, rtlcn1945, 
      rtlcn1946, rtlcn1947, rtlcn1948, rtlcn1949, rtlcn1950, rtlcn1951, 
      rtlcn1953, rtlcn1954, rtlcn1957, rtlcn1958, rtlcn1959, rtlcn1960, 
      rtlcn1962, rtlcn1963, rtlcn1965, rtlcn1966, rtlcn1967, rtlcn1968, 
      rtlcn1969, not_rtlc20n5751, not_state_10, not_rtlcn234, rtlcn1977, 
      not_rtlcn224, not_rtlcn222, not_rtlc20n6202, not_rtlc20n6201, 
      not_rtlcn1953, rtlcn1985, not_rtlcn1946, not_rtlcn1476, rtlcn1990, 
      not_state_12, not_rtlcn1963, not_rtlcn1702, rtlcn1999, not_rtlc20n6931, 
      not_rtlc20n6319, not_rtlcn1960, rtlcn2004, rtlcn2006, not_CE, 
      rtlcn2008, rtlcn2009, rtlcn2012, rtlcn2013, not_rtlc20n6196, 
      not_rtlc20n6195, not_rtlc20n6194, not_rtlcn220, not_rtlcn218, 
      not_rtlc20n5932, not_rtlc20n7199, not_rtlc20n6189, rtlcn2023, 
      rtlcn2024, rtlcn2025, rtlcs3, rtlcs5, rtlcs7, rtlcs8, rtlcs9, rtlcs13, 
      rtlcs14, rtlcs17, rtlcs18, not_active_command_9, not_active_command_8, 
      not_active_command_7, not_active_command_6, not_active_command_5, 
      not_active_command_3, not_active_command_2, not_active_command_1, 
      not_active_command_0, not_word_counter_4, not_word_counter_5, 
      not_word_counter_3, not_word_counter_2, not_word_counter_1, 
      not_word_counter_0, rtlcn2072, rtlcn2074, not_Down_count_4, 
      not_Down_count_3, not_Down_count_2, not_Down_count_1, not_Down_count_0, 
      not_No_Response_timeout_1, not_No_Response_timeout_0, not_rtlcn767, 
      not_time_out_counter_var_7, not_time_out_counter_var_6, 
      not_time_out_counter_var_5, not_time_out_counter_var_4, 
      not_time_out_counter_var_3, not_time_out_counter_var_2, 
      not_time_out_counter_var_1, not_time_out_counter_var_0, not_rtlcn884, 
      not_RCV_Gap_found_2, not_RCV_Gap_found_1, not_RCV_Gap_found_0, 
      not_rtlcn209, rtlcn2231, rtlcs19, rtlcs20, rtlcs21: std_logic ;
   
   signal RCV_R_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal RCV_Gap_found: std_logic_vector (2 DOWNTO 0) ;
   
   signal RCV_CS, RCV_Pre_EchoRdy, RCV_Command_Sync, RCV_Pre_RxRdy, 
      RCV_recieving, not_rtlc20n6802, rtlc20_788_or_1146_nx0, 
      rtlc20_846_or_1150_nx0, rtlc20_2308_gt_1164_nx0, 
      rtlc20_2308_gt_1164_nx2, rtlc20_2308_gt_1164_nx4, 
      rtlc_2266_and_1187_nx0, rtlc_2267_or_1188_nx0, rtlc_2308_or_1189_nx0, 
      rtlc_2325_and_1190_nx0, rtlc_2339_and_1191_nx0, rtlcn1780, 
      rtlc_2359_and_1194_nx0, rtlc_2410_and_1197_nx0, rtlc_2431_and_1198_nx0, 
      rtlc_2450_and_1200_nx0, rtlc_2457_or_1202_nx0, rtlc_2479_and_1203_nx0, 
      rtlc_2481_and_1204_nx0, rtlc_2486_and_1206_nx0, rtlc_2503_and_1209_nx0, 
      rtlc_2521_and_1212_nx0, rtlc_2522_or_1213_nx0, rtlc_2525_and_1214_nx0, 
      rtlc_2541_and_1215_nx0, rtlc_2551_and_1216_nx0, rtlc_2559_and_1217_nx0, 
      rtlc_2567_or_1220_nx0, rtlc_2572_or_1221_nx0, rtlc_2584_and_1222_nx0, 
      rtlc_2585_or_1223_nx0, rtlc_2591_and_1224_nx0, rtlc_2958_and_1229_nx0, 
      rtlc_2977_or_1230_nx0, rtlc_3007_and_1232_nx0, rtlc_3057_or_1237_nx0, 
      rtlc_3058_or_1238_nx0, rtlc_3177_and_1249_nx0, rtlc_3181_and_1250_nx0, 
      rtlc_3230_and_1252_nx0, nx5, nx8: std_logic ;
   
   signal DANGLING : std_logic_vector (16 downto 0 );

begin
   Tx_Bus_A <= Tx_Bus_A_EXMPLR2345 ;
   Idle_state <= Debug_2_EXMPLR2401 ;
   Activity_on_wrong_bus <= Debug_2_EXMPLR2401 ;
   FE_All_Errors <= FE_All_Errors_EXMPLR2395 ;
   Debug(15) <= Debug_2_EXMPLR2401 ;
   Debug(14) <= Debug_2_EXMPLR2401 ;
   Debug(13) <= Debug_2_EXMPLR2401 ;
   Debug(12) <= Debug_2_EXMPLR2401 ;
   Debug(11) <= Debug_2_EXMPLR2401 ;
   Debug(10) <= Debug_2_EXMPLR2401 ;
   Debug(9) <= Debug_2_EXMPLR2401 ;
   Debug(8) <= Debug_2_EXMPLR2401 ;
   Debug(7) <= Debug_2_EXMPLR2401 ;
   Debug(6) <= Debug_2_EXMPLR2401 ;
   Debug(5) <= Debug_2_EXMPLR2401 ;
   Debug(4) <= Debug_2_EXMPLR2401 ;
   Debug(3) <= Debug_2_EXMPLR2401 ;
   Debug(2) <= Debug_2_EXMPLR2401 ;
   Debug(1) <= Debug_2_EXMPLR2401 ;
   Debug(0) <= Debug_2_EXMPLR2401 ;
   Debug_2_EXMPLR2401 <= '0' ;
   PWR <= '1' ;
   mode_message_no_data_10n2s2 <= mode_message_no_data_10n2s3 OR 
   mode_message_no_data_10n2s6 ;
   not_BC_1553A <= NOT BC_1553A ;
   rtlc13n39 <= RCV_recieving AND rtlc13n167 ;
   rtlc13n27 <= RCV_Pre_RxRdy OR RCV_Pre_EchoRdy ;
   not_Energy_Count_9 <= NOT Energy_Count(9) ;
   rtlc13_62_and_1145 : and_7u_7u port map ( a(6)=>Energy_Count(6), a(5)=>
      Energy_Count(5), a(4)=>Energy_Count(4), a(3)=>Energy_Count(3), a(2)=>
      Energy_Count(2), a(1)=>Energy_Count(1), a(0)=>Energy_Count(0), d=>
      rtlc13n164);
   rtlc13n167 <= not_rtlcn122 OR not_Energy_Count_9 ;
   not_rtlcs18 <= NOT rtlcs18 ;
   not_Found_errors <= NOT Found_errors ;
   Loopback_error_20n18s1 <= not_Found_errors AND not_FE_All_Errors ;
   not_FE_All_Errors <= NOT FE_All_Errors_EXMPLR2395 ;
   BC_1553A_ME_20n26s1 <= RCV_R_Data(10) AND BC_1553A ;
   rtlc20n6830 <= state(4) OR state(5) ;
   rtlc20n6843 <= state(3) OR state(5) ;
   rtlc20n6855 <= state(14) OR state(16) ;
   rtlc20_795_or_1147 : or_5u_5u port map ( a(4)=>state(0), a(3)=>state(3), 
      a(2)=>state(5), a(1)=>state(13), a(0)=>state(15), d=>rtlc20n6894);
   not_rtlc20n6894 <= NOT rtlc20n6894 ;
   T_Sync_select_20i1 : select_3_3 port map ( a(2)=>state(0), a(1)=>
      rtlc20n6843, a(0)=>rtlc20n6914, b(2)=>Go, b(1)=>PWR, b(0)=>
      Debug_2_EXMPLR2401, d=>T_Sync_20n83ss1);
   rtlc20n6914 <= state(13) OR state(15) ;
   rtlc20_832_or_1149 : or_8u_8u port map ( a(7)=>state(0), a(6)=>state(1), 
      a(5)=>state(2), a(4)=>state(3), a(3)=>state(4), a(2)=>state(9), a(1)=>
      state(12), a(0)=>state(14), d=>rtlc20n6921);
   read_ack_20n87s1 <= read_ack_20n87s2 AND read_req ;
   write_ack_20n90s1 <= read_ack_20n87s2 AND write_req ;
   rtlc20n7016 <= rtlcs8 OR rtlcs7 ;
   rtlc20_1242_select_1151 : select_3_3 port map ( a(2)=>not_rtlc20n6843, 
      a(1)=>state(3), a(0)=>state(5), b(2)=>PWR, b(1)=>rtlc20n5769, b(0)=>
      rtlc20n5809, d=>rtlc20n6189);
   rtlc20_1249_or_1152 : or_9u_9u port map ( a(8)=>state(2), a(7)=>state(5), 
      a(6)=>state(6), a(5)=>state(7), a(4)=>state(9), a(3)=>state(10), a(2)
      =>state(11), a(1)=>state(15), a(0)=>state(16), d=>rtlc20n7196);
   not_rtlc20n7196 <= NOT rtlc20n7196 ;
   rtlc20_1261_or_1153 : or_7u_7u port map ( a(6)=>state(0), a(5)=>state(3), 
      a(4)=>state(9), a(3)=>state(13), a(2)=>state(17), a(1)=>state(18), 
      a(0)=>state(19), d=>rtlc20n7199);
   rtlc20_1273_select_1154 : select_3_3 port map ( a(2)=>not_rtlc20n7206, 
      a(1)=>state(0), a(0)=>state(3), b(2)=>PWR, b(1)=>not_ENC_TEST_Go, b(0)
      =>rtlc20n5769, d=>rtlc20n6194);
   rtlc20n7206 <= state(0) OR state(3) ;
   not_rtlc20n7206 <= NOT rtlc20n7206 ;
   rtlc20_1281_select_1155 : select_3_3 port map ( a(2)=>not_rtlc20n6843, 
      a(1)=>state(3), a(0)=>state(5), b(2)=>PWR, b(1)=>rtlc20n5769, b(0)=>
      rtlc20n5810, d=>rtlc20n6196);
   rtlc20n5807 <= rtlc20n5790 AND not_rtlcs13 ;
   rtlc20n5790 <= not_read_req AND Tx_message ;
   rtlc20_1294_or_1156 : or_6u_6u port map ( a(5)=>state(0), a(4)=>state(3), 
      a(3)=>state(5), a(2)=>state(8), a(1)=>state(13), a(0)=>state(15), d=>
      rtlc20n7215);
   not_rtlc20n7215 <= NOT rtlc20n7215 ;
   rtlc20_1308_or_1157 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(11), 
      a(1)=>state(15), a(0)=>state(16), d=>rtlc20n7218);
   rtlc20_1314_or_1158 : or_5u_5u port map ( a(4)=>state(1), a(3)=>state(3), 
      a(2)=>state(4), a(1)=>state(12), a(0)=>state(14), d=>rtlc20n7221);
   rtlc20_1322_select_1159 : select_5_5 port map ( a(4)=>not_rtlc20n7224, 
      a(3)=>state(0), a(2)=>state(9), a(1)=>state(10), a(0)=>state(17), b(4)
      =>PWR, b(3)=>rtlc20n5751, b(2)=>not_rtlcs14, b(1)=>rtlc20n6070, b(0)=>
      rtlc20n6172, d=>rtlc20n6201);
   rtlc20_1323_or_1160 : or_4u_4u port map ( a(3)=>state(0), a(2)=>state(9), 
      a(1)=>state(10), a(0)=>state(17), d=>rtlc20n7224);
   not_rtlc20n7224 <= NOT rtlc20n7224 ;
   rtlc20n6172 <= not_timeout OR not_rtlc20n6165 ;
   rtlc20_1436_or_1161 : or_5u_5u port map ( a(4)=>timeout, a(3)=>
      not_rtlc20n6802, a(2)=>not_rtlc20n6009, a(1)=>not_RCV_Pre_RxRdy, a(0)
      =>not_RCV_CS, d=>rtlc20n6070);
   rtlc20_1600_or_1162 : or_4u_4u port map ( a(3)=>rtlc20n5258, a(2)=>
      not_read_ack, a(1)=>not_Tx_Rdy, a(0)=>rtlcs13, d=>rtlc20n5770);
   rtlc20n5769 <= rtlc20n5258 OR not_Tx_Rdy ;
   rtlc20_1749_or_1163 : or_5u_5u port map ( a(4)=>Set_time_out_to_5us, a(3)
      =>Set_time_out_to_echo, a(2)=>Set_time_out_to_rcv, a(1)=>rtlc20n6820, 
      a(0)=>not_rtlc20n6319, d=>rtlc20_X_0_n6664);
   rtlc20n6615 <= rtlcs5 AND write_req ;
   rtlc20n6319 <= timeout_count_enable AND not_timeout ;
   rtlc20n6165 <= RCV_recieving AND RCV_CS ;
   rtlc20n6009 <= rtlcs18 AND not_RCV_Command_Sync ;
   rtlc20n5912 <= Config_reg_4(6) AND ME_message ;
   rtlc20n5898 <= Config_reg_4(5) AND BUSY_message ;
   rtlc20n5893 <= ME_message OR BUSY_message ;
   rtlc20n5499 <= Sync_error OR not_rtlcs18 ;
   rtlc20n5257 <= recieving_on_B AND not_Bus_A ;
   rtlc20n5255 <= recieving_on_A AND Bus_A ;
   rtlc20n5258 <= rtlc20n5255 OR rtlc20n5257 ;
   word_counter_inc6_20i2 : inc_6u_6u_0 port map ( cin=>PWR, a(5)=>
      word_counter(5), a(4)=>word_counter(4), a(3)=>word_counter(3), a(2)=>
      word_counter(2), a(1)=>word_counter(1), a(0)=>word_counter(0), d(5)=>
      word_counter_20n69s1(5), d(4)=>word_counter_20n69s1(4), d(3)=>
      word_counter_20n69s1(3), d(2)=>word_counter_20n69s1(2), d(1)=>
      word_counter_20n69s1(1), d(0)=>word_counter_20n69s1(0), cout=>DANGLING
      (0));
   time_out_counter_var_dec8_20i3 : dec_8u_8u_0 port map ( cin=>
      Debug_2_EXMPLR2401, a(7)=>time_out_counter_var(7), a(6)=>
      time_out_counter_var(6), a(5)=>time_out_counter_var(5), a(4)=>
      time_out_counter_var(4), a(3)=>time_out_counter_var(3), a(2)=>
      time_out_counter_var(2), a(1)=>time_out_counter_var(1), a(0)=>
      time_out_counter_var(0), d(7)=>time_out_counter_var_20n92s1(7), d(6)=>
      time_out_counter_var_20n92s1(6), d(5)=>time_out_counter_var_20n92s1(5), 
      d(4)=>time_out_counter_var_20n92s1(4), d(3)=>
      time_out_counter_var_20n92s1(3), d(2)=>time_out_counter_var_20n92s1(2), 
      d(1)=>time_out_counter_var_20n92s1(1), d(0)=>
      time_out_counter_var_20n92s1(0), cout=>DANGLING(1));
   not_Bus_A <= NOT Bus_A ;
   rtlc20n7482 <= Energy_Count(7) AND Energy_Count(8) ;
   rtlc20n7483 <= rtlc20n7482 OR Energy_Count(9) ;
   rtlc13n162 <= Energy_Count(8) OR Energy_Count(7) ;
   not_rtlcn122 <= NOT rtlcn122 ;
   rtlcn122 <= rtlc13n162 OR rtlc13n164 ;
   rtlcn125 <= rtlcs5 AND read_req ;
   rtlc20n6619 <= rtlc20n6615 OR rtlcn125 ;
   word_counter_select_20i4 : select_3_3 port map ( a(2)=>not_rtlcn1645, 
      a(1)=>rtlcn189, a(0)=>state(13), b(2)=>Debug_2_EXMPLR2401, b(1)=>
      word_counter_20n69s1(0), b(0)=>PWR, d=>word_counter_20n83ss1(0));
   rtlc_311_select_1168 : select_5_5 port map ( a(4)=>not_rtlc20n6894, a(3)
      =>state(0), a(2)=>state(3), a(1)=>state(5), a(0)=>rtlc20n6914, b(4)=>
      PWR, b(3)=>not_ENC_TEST_Go, b(2)=>rtlc20n5769, b(1)=>not_read_req, 
      b(0)=>not_read_ack, d=>rtlcn218);
   rtlc_314_select_1169 : select_4_4 port map ( a(3)=>not_rtlc20n6894, a(2)
      =>state(0), a(1)=>state(3), a(0)=>rtlcn219, b(3)=>PWR, b(2)=>
      not_ENC_TEST_Go, b(1)=>rtlc20n5770, b(0)=>not_read_ack, d=>rtlcn220);
   rtlc_317_select_1170 : select_3_3 port map ( a(2)=>not_rtlcn1647, a(1)=>
      state(0), a(0)=>rtlcn209, b(2)=>PWR, b(1)=>rtlc20n5751, b(0)=>
      rtlc20n5932, d=>rtlcn222);
   state_fsm_select_20i5 : select_6_6 port map ( a(5)=>not_rtlcn1935, a(4)=>
      rtlcn263, a(3)=>rtlcn193, a(2)=>state(9), a(1)=>state(11), a(0)=>
      rtlcn259, b(5)=>Debug_2_EXMPLR2401, b(4)=>PWR, b(3)=>
      state_fsm_20n23ss1_17, b(2)=>state_fsm_20n45ss1_17, b(1)=>
      state_fsm_20n63ss1_17, b(0)=>state_fsm_20n32ss1_17, d=>
      state_fsm_20n83ss1_17);
   state_fsm_select_20i6 : select_6_6 port map ( a(5)=>not_rtlcn1936, a(4)=>
      state(7), a(3)=>state(8), a(2)=>state(9), a(1)=>state(16), a(0)=>
      rtlcn659, b(5)=>Debug_2_EXMPLR2401, b(4)=>state_fsm_20n33ss1_10, b(3)
      =>state_fsm_20n43ss1_10, b(2)=>state_fsm_20n45ss1_10, b(1)=>
      state_fsm_20n76ss1_10, b(0)=>not_BCR_message, d=>state_fsm_20n83ss1_10
   );
   time_out_counter_var_select_20i8Bus22_5 : select_3_3 port map ( a(2)=>
      rtlcn786, a(1)=>rtlcn784, a(0)=>rtlcn785, b(2)=>Debug_2_EXMPLR2401, 
      b(1)=>PWR, b(0)=>time_out_counter_var_20n92s1(5), d=>
      time_out_counter_var_20n99ss1(5));
   time_out_counter_var_select_20i8Bus22_4 : select_3_3 port map ( a(2)=>
      rtlcn799, a(1)=>rtlcn796, a(0)=>rtlcn785, b(2)=>Debug_2_EXMPLR2401, 
      b(1)=>PWR, b(0)=>time_out_counter_var_20n92s1(4), d=>
      time_out_counter_var_20n99ss1(4));
   time_out_counter_var_select_20i9 : select_3_3 port map ( a(2)=>
      not_Set_time_out_to_rcv, a(1)=>rtlcn800, a(0)=>rtlcn1564, b(2)=>
      time_out_counter_var_20n92s1(3), b(1)=>Debug_2_EXMPLR2401, b(0)=>PWR, 
      d=>time_out_counter_var_20n97ss1_3);
   time_out_counter_var_select_20i10 : select_3_3 port map ( a(2)=>
      not_rtlcn1939, a(1)=>rtlcn809, a(0)=>rtlcn810, b(2)=>
      Debug_2_EXMPLR2401, b(1)=>PWR, b(0)=>time_out_counter_var_20n92s1(2), 
      d=>time_out_counter_var_20n98ss1_2);
   time_out_counter_var_select_20i11 : select_3_3 port map ( a(2)=>rtlcn824, 
      a(1)=>rtlcn821, a(0)=>rtlcn785, b(2)=>Debug_2_EXMPLR2401, b(1)=>PWR, 
      b(0)=>time_out_counter_var_20n92s1(1), d=>
      time_out_counter_var_20n99ss1(1));
   rtlc_1061_select_1178 : select_3_3 port map ( a(2)=>not_rtlcn1940, a(1)=>
      rtlcn877, a(0)=>rtlcn881, b(2)=>Debug_2_EXMPLR2401, b(1)=>PWR, b(0)=>
      not_FE_All_Errors, d=>rtlcn2023);
   rtlc_1192_select_1179 : select_3_3 port map ( a(2)=>rtlcn1008, a(1)=>
      rtlcn1009, a(0)=>rtlcn1010, b(2)=>Debug_2_EXMPLR2401, b(1)=>not_RCV_CS, 
      b(0)=>not_FE_All_Errors, d=>rtlcn2231);
   rtlc_1305_select_1180 : select_3_3 port map ( a(2)=>not_rtlcn1943, a(1)=>
      rtlcn1119, a(0)=>rtlcn1120, b(2)=>Debug_2_EXMPLR2401, b(1)=>
      not_FE_All_Errors, b(0)=>PWR, d=>rtlcn2024);
   not_rtlc20n6165 <= NOT rtlc20n6165 ;
   not_rtlcs14 <= NOT rtlcs14 ;
   not_ENC_TEST_Go <= NOT ENC_TEST_Go ;
   not_RCV_CS <= NOT RCV_CS ;
   not_RCV_Command_Sync <= NOT RCV_Command_Sync ;
   not_rtlc20n6009 <= NOT rtlc20n6009 ;
   Set_time_out_to_rcv_select_20i12 : select_5_5 port map ( a(4)=>
      not_rtlcn1937, a(3)=>state(7), a(2)=>state(8), a(1)=>state(9), a(0)=>
      rtlcn1517, b(4)=>Debug_2_EXMPLR2401, b(3)=>state_fsm_20n33ss1_10, b(2)
      =>state_fsm_20n43ss1_10, b(1)=>state_fsm_20n45ss1_10, b(0)=>PWR, d=>
      Set_time_out_to_rcv_20n83ss1);
   Set_time_out_to_5us_select_20i13 : select_6_6 port map ( a(5)=>
      not_rtlcn1938, a(4)=>rtlcn193, a(3)=>state(9), a(2)=>state(11), a(1)=>
      rtlcn1535, a(0)=>rtlcn259, b(5)=>Debug_2_EXMPLR2401, b(4)=>
      state_fsm_20n23ss1_17, b(3)=>state_fsm_20n45ss1_17, b(2)=>
      state_fsm_20n63ss1_17, b(1)=>PWR, b(0)=>state_fsm_20n32ss1_17, d=>
      Set_time_out_to_5us_20n83ss1);
   time_out_counter_var_select_20i14 : select_3_3 port map ( a(2)=>
      not_Set_time_out_to_rcv, a(1)=>rtlcn1536, a(0)=>rtlcn1537, b(2)=>
      time_out_counter_var_20n92s1(7), b(1)=>Debug_2_EXMPLR2401, b(0)=>PWR, 
      d=>time_out_counter_var_20n97ss1_7);
   FE_All_Errors_select_20i15 : select_3_3 port map ( a(2)=>rtlcn1551, a(1)
      =>rtlcn1552, a(0)=>rtlcn969, b(2)=>Debug_2_EXMPLR2401, b(1)=>
      not_Found_errors, b(0)=>FE_All_Errors_20n22ss1, d=>
      FE_All_Errors_20n83ss1);
   Loopback_error_select_20i16 : select_4_4 port map ( a(3)=>rtlcn1555, a(2)
      =>rtlcn1018, a(1)=>rtlcn1019, a(0)=>rtlcn1554, b(3)=>
      Debug_2_EXMPLR2401, b(2)=>Loopback_error_20n18s1, b(1)=>
      FE_All_Errors_20n22ss1, b(0)=>not_Found_errors, d=>
      Loopback_error_20n83ss1);
   state_fsm_select_20i17 : select_3_3 port map ( a(2)=>not_rtlcn1944, a(1)
      =>state(6), a(0)=>rtlcn1611, b(2)=>Debug_2_EXMPLR2401, b(1)=>
      state_fsm_20n76ss1_10, b(0)=>PWR, d=>state_fsm_20n83ss1_7);
   rtlcn1645 <= rtlcn189 OR state(13) ;
   not_rtlcn1645 <= NOT rtlcn1645 ;
   rtlcn1647 <= state(0) OR rtlcn209 ;
   not_rtlcn1647 <= NOT rtlcn1647 ;
   not_rtlc20n6843 <= NOT rtlc20n6843 ;
   rtlcn189 <= state(8) OR state(15) ;
   rtlcn1662 <= state(5) OR state(15) ;
   rtlcn219 <= state(13) OR rtlcn1662 ;
   rtlcn209 <= state(10) OR state(7) ;
   rtlcn234 <= state(17) OR state(18) ;
   rtlcn193 <= state(6) OR state(16) ;
   rtlcn1673 <= state(11) OR rtlcn1662 ;
   rtlcn236 <= rtlcn193 OR rtlcn1673 ;
   rtlcn240 <= state(8) OR rtlcn209 ;
   rtlcn1670 <= state(8) AND timeout ;
   not_timeout <= NOT timeout ;
   rtlcn1712 <= state(10) AND not_timeout ;
   not_RT2RT_int <= NOT RT2RT_int ;
   rtlcn259 <= state(7) AND not_timeout ;
   rtlcn704 <= timeout OR RCV_Pre_EchoRdy ;
   not_mode_message_no_data <= NOT mode_message_no_data ;
   not_rtlcn704 <= NOT rtlcn704 ;
   rtlcn659 <= state(11) AND rtlcn1722 ;
   not_state_7 <= NOT state(7) ;
   not_state_16 <= NOT state(16) ;
   not_Set_time_out_to_echo <= NOT Set_time_out_to_echo ;
   rtlcn1671 <= Set_time_out_to_rcv AND not_Set_time_out_to_echo ;
   rtlcn1728 <= rtlc20n7016 AND rtlcn1671 ;
   rtlcn1681 <= Set_time_out_to_5us OR rtlcn1728 ;
   rtlcn1692 <= Set_time_out_to_echo AND Receive_problem ;
   rtlcn786 <= rtlcn1681 OR rtlcn1692 ;
   not_Receive_problem <= NOT Receive_problem ;
   rtlcn1693 <= Set_time_out_to_echo AND not_Receive_problem ;
   not_Set_time_out_to_5us <= NOT Set_time_out_to_5us ;
   rtlcn1694 <= not_Set_time_out_to_5us AND rtlcn1671 ;
   rtlcn1731 <= not_Set_time_out_to_5us AND rtlcn1693 ;
   not_rtlc20n7016 <= NOT rtlc20n7016 ;
   rtlcn1733 <= not_rtlc20n7016 AND rtlcn1694 ;
   rtlcn784 <= rtlcn1731 OR rtlcn1733 ;
   not_Set_time_out_to_rcv <= NOT Set_time_out_to_rcv ;
   rtlcn810 <= not_Set_time_out_to_rcv AND not_Set_time_out_to_echo ;
   rtlcn785 <= not_Set_time_out_to_5us AND rtlcn810 ;
   not_rtlcs7 <= NOT rtlcs7 ;
   rtlcn1736 <= not_rtlcs7 AND rtlcn1671 ;
   rtlcn1737 <= not_Set_time_out_to_5us AND rtlcn1692 ;
   rtlcn1738 <= rtlcs7 AND rtlcn1694 ;
   rtlcn796 <= rtlcn1737 OR rtlcn1738 ;
   not_rtlcs9 <= NOT rtlcs9 ;
   rtlcn800 <= Set_time_out_to_rcv AND not_rtlcs9 ;
   rtlcn1564 <= Set_time_out_to_rcv AND rtlcs9 ;
   rtlcn809 <= not_Set_time_out_to_echo AND rtlcn800 ;
   rtlcn824 <= rtlcn1681 OR rtlcn1693 ;
   rtlcn821 <= rtlcn1737 OR rtlcn1733 ;
   rtlcn1649 <= not_timeout AND RCV_Pre_RxRdy ;
   not_rtlc20n7483 <= NOT rtlc20n7483 ;
   rtlcn1682 <= not_rtlc20n6802 OR not_rtlc20n7483 ;
   rtlcn881 <= timeout AND rtlcn1682 ;
   not_rtlcn240 <= NOT rtlcn240 ;
   rtlcn1750 <= rtlcn881 AND rtlcn209 ;
   rtlcn1751 <= not_rtlc20n7483 AND rtlcn1670 ;
   rtlcn1752 <= not_rtlcn1941 AND rtlcn240 ;
   rtlc_2340_or_1192 : or_5u_5u port map ( a(4)=>not_rtlcn240, a(3)=>
      rtlcn1750, a(2)=>rtlcn1751, a(1)=>rtlcn1752, a(0)=>rtlcn1753, d=>
      rtlcn1008);
   rtlcn1614 <= state(8) AND rtlcn1649 ;
   not_rtlc20n5499 <= NOT rtlc20n5499 ;
   rtlcn1755 <= not_rtlc20n5499 AND rtlcn1614 ;
   rtlcn1756 <= rtlcn1649 AND rtlcn209 ;
   rtlcn1009 <= rtlcn1755 OR rtlcn1756 ;
   rtlcn1757 <= rtlc20n7483 AND rtlcn1670 ;
   not_rtlcn1682 <= NOT rtlcn1682 ;
   rtlcn1010 <= rtlcn1757 OR rtlcn1759 ;
   not_rtlc20n5894 <= NOT rtlc20n5894 ;
   rtlcn1664 <= not_rtlc20n5894 OR not_rtlcn1942 ;
   not_rtlc20n6172 <= NOT rtlc20n6172 ;
   rtlcn1766 <= state(17) AND not_rtlc20n6172 ;
   rtlcn1119 <= rtlcn1766 OR rtlcn1767 ;
   rtlcn1659 <= not_rtlc20n6802 OR not_RCV_CS ;
   rtlcn1769 <= rtlc20n5499 AND rtlcn1614 ;
   not_rtlcn1659 <= NOT rtlcn1659 ;
   rtlc_2365_and_1195 : and_4u_4u port map ( a(3)=>state(10), a(2)=>
      rtlcn1649, a(1)=>rtlc20n6009, a(0)=>not_rtlcn1659, d=>rtlcn1771);
   rtlcn1120 <= rtlcn1769 OR rtlcn1771 ;
   rtlcn1774 <= rtlcn193 AND rtlcn704 ;
   rtlcn1517 <= rtlcn659 OR rtlcn1774 ;
   not_Tx_message <= NOT Tx_message ;
   rtlcn1656 <= not_Tx_message OR rtlcs13 ;
   not_read_ack <= NOT read_ack ;
   rtlcn1668 <= not_read_ack OR rtlcn1656 ;
   rtlcn1690 <= not_RT2RT_int OR rtlcn1668 ;
   not_Tx_Rdy <= NOT Tx_Rdy ;
   not_rtlcn1690 <= NOT rtlcn1690 ;
   rtlcn1654 <= not_Tx_Rdy OR not_rtlcn1690 ;
   rtlcn1679 <= rtlc20n5258 OR rtlcn1654 ;
   rtlcn1650 <= state(3) AND rtlcn1679 ;
   rtlcn1687 <= rtlcn1650 OR rtlcn1780 ;
   rtlcn1697 <= RCV_Pre_RxRdy OR rtlcn1781 ;
   rtlcn1782 <= timeout AND rtlcn234 ;
   rtlcn1783 <= state(10) AND rtlcn1697 ;
   rtlc_2390_or_1196 : or_4u_4u port map ( a(3)=>rtlcn1670, a(2)=>rtlcn1687, 
      a(1)=>rtlcn1782, a(0)=>rtlcn1783, d=>rtlcn1535);
   rtlcn1536 <= Set_time_out_to_rcv AND not_rtlcs7 ;
   rtlcn1537 <= rtlcs7 AND Set_time_out_to_rcv ;
   rtlcn1685 <= not_RCV_CS OR rtlc20n5499 ;
   rtlcn1698 <= RCV_Command_Sync OR rtlcn1685 ;
   rtlcn1785 <= timeout AND rtlcn1664 ;
   rtlcn1786 <= rtlcn1649 AND rtlcn1698 ;
   rtlcn1651 <= rtlcn1785 OR rtlcn1786 ;
   not_state_3 <= NOT state(3) ;
   rtlcn1655 <= not_state_3 OR rtlc20n5258 ;
   not_rtlcn1655 <= NOT rtlcn1655 ;
   rtlcn1661 <= Tx_Rdy AND not_rtlcn1655 ;
   not_RCV_Pre_EchoRdy <= NOT RCV_Pre_EchoRdy ;
   rtlcn1665 <= not_RCV_Pre_EchoRdy OR rtlcn1790 ;
   not_state_5 <= NOT state(5) ;
   rtlcn1653 <= not_state_5 OR rtlcn704 ;
   not_rtlcn1653 <= NOT rtlcn1653 ;
   rtlcn1667 <= not_rtlcn1653 OR rtlcn1793 ;
   rtlcn1669 <= not_RCV_Command_Sync OR rtlcn1659 ;
   not_rtlcn1656 <= NOT rtlcn1656 ;
   rtlcn1677 <= not_read_ack OR not_rtlcn1656 ;
   rtlcn1683 <= state(12) OR state(4) ;
   rtlcn1796 <= state(10) AND rtlcs19 ;
   rtlcn1797 <= state(7) AND rtlcs20 ;
   rtlcn1684 <= rtlcn1796 OR rtlcn1797 ;
   rtlcn1695 <= state(11) AND not_timeout ;
   not_write_ack <= NOT write_ack ;
   rtlcn1799 <= not_write_ack AND state(2) ;
   not_rtlcn1651 <= NOT rtlcn1651 ;
   rtlcn1801 <= state(8) AND not_rtlcn1651 ;
   rtlcn1802 <= rtlcn209 AND not_rtlcn1941 ;
   rtlcn1803 <= state(17) AND rtlc20n6172 ;
   rtlcn1804 <= rtlcn1667 AND rtlcn1677 ;
   rtlcn1805 <= rtlcn1661 AND rtlcn1690 ;
   rtlcn1806 <= rtlcn1665 AND rtlcn1695 ;
   not_rtlcn1669 <= NOT rtlcn1669 ;
   rtlc_2432_or_1199 : or_16u_16u port map ( a(15)=>state(0), a(14)=>
      state(1), a(13)=>state(9), a(12)=>state(13), a(11)=>state(14), a(10)=>
      state(18), a(9)=>state(19), a(8)=>rtlcn1683, a(7)=>rtlcn1799, a(6)=>
      rtlcn1801, a(5)=>rtlcn1802, a(4)=>rtlcn1803, a(3)=>rtlcn1804, a(2)=>
      rtlcn1805, a(1)=>rtlcn1806, a(0)=>rtlcn1808, d=>rtlcn1551);
   not_rtlcn1665 <= NOT rtlcn1665 ;
   rtlcn1554 <= not_rtlcn1665 AND rtlcn1695 ;
   not_rtlcs19 <= NOT rtlcs19 ;
   rtlcn1811 <= state(10) AND not_rtlcs19 ;
   not_rtlcs20 <= NOT rtlcs20 ;
   rtlcn1813 <= state(7) AND not_rtlcs20 ;
   rtlcn1663 <= rtlcn1811 OR rtlcn1813 ;
   rtlcn1814 <= rtlcn209 AND rtlcn1669 ;
   rtlcn1699 <= rtlcn1663 OR rtlcn1814 ;
   rtlcn1815 <= write_ack AND state(2) ;
   rtlcn1816 <= state(8) AND rtlcn1651 ;
   not_rtlcn1677 <= NOT rtlcn1677 ;
   rtlcn1819 <= rtlcn1667 AND not_rtlcn1677 ;
   rtlcn1820 <= timeout AND rtlcn236 ;
   rtlcn1821 <= RCV_Pre_RxRdy AND rtlcn1699 ;
   rtlc_2451_or_1201 : or_9u_9u port map ( a(8)=>rtlcn1554, a(7)=>rtlcn1687, 
      a(6)=>rtlcn1766, a(5)=>rtlcn1815, a(4)=>rtlcn1816, a(3)=>rtlcn1819, 
      a(2)=>rtlcn1820, a(1)=>rtlcn1821, a(0)=>rtlcn1822, d=>rtlcn1552);
   rtlcn1700 <= state(15) OR rtlcn193 ;
   rtlcn969 <= not_timeout AND rtlcn1700 ;
   rtlcn1122 <= timeout AND rtlcn193 ;
   not_rtlcn236 <= NOT rtlcn236 ;
   rtlcn1018 <= timeout AND rtlcn1673 ;
   rtlcn1701 <= rtlcn1662 OR rtlcn193 ;
   rtlcn1019 <= not_timeout AND rtlcn1701 ;
   rtlcn1611 <= state(7) AND not_rtlcn1941 ;
   not_R <= NOT R ;
   not_BCR_message <= NOT BCR_message ;
   not_state_0 <= NOT state(0) ;
   not_rtlc20n6921 <= NOT rtlc20n6921 ;
   not_rtlcs5 <= NOT rtlcs5 ;
   rtlcn245 <= state(17) AND not_rtlc20n6165 ;
   rtlcn1827 <= not_read_ack AND rtlcn1661 ;
   rtlcn274 <= state(1) OR rtlcn1827 ;
   not_read_req <= NOT read_req ;
   rtlcn1702 <= not_read_ack OR not_read_req ;
   rtlcn318 <= not_state_3 AND rtlcn1702 ;
   not_rtlcs13 <= NOT rtlcs13 ;
   rtlcn1830 <= not_rtlcn1653 AND not_rtlcn1677 ;
   rtlcn360 <= rtlcn1830 OR rtlcn1831 ;
   rtlcn371 <= not_state_3 AND not_rtlcn1677 ;
   rtlc_2484_and_1205 : and_4u_4u port map ( a(3)=>not_Set_time_out_to_5us, 
      a(2)=>not_Set_time_out_to_rcv, a(1)=>not_Set_time_out_to_echo, a(0)=>
      rtlc20n6319, d=>rtlcn383);
   rtlcn425 <= rtlcn1799 OR rtlcn1833 ;
   rtlcn1834 <= state(12) AND not_mode_message_no_data ;
   rtlcn1835 <= state(13) AND not_read_ack ;
   rtlcn615 <= rtlcn1834 OR rtlcn1835 ;
   rtlcn667 <= state(18) OR rtlcn1815 ;
   rtlcn767 <= not_Set_time_out_to_5us AND not_Set_time_out_to_echo ;
   rtlcn1837 <= RCV_Command_Sync AND rtlcn236 ;
   rtlc_2495_or_1207 : or_4u_4u port map ( a(3)=>state(1), a(2)=>state(4), 
      a(1)=>rtlcn209, a(0)=>rtlcn1837, d=>rtlcn863);
   rtlcn884 <= state(0) AND not_ENC_TEST_Go ;
   rtlcn1840 <= state(10) AND not_rtlc20n6009 ;
   rtlcn1676 <= state(7) OR rtlcn1840 ;
   not_rtlcn1685 <= NOT rtlcn1685 ;
   rtlc_2504_and_1210 : and_4u_4u port map ( a(3)=>rtlcn1649, a(2)=>
      not_RCV_Command_Sync, a(1)=>not_rtlcn1659, a(0)=>rtlcn1676, d=>
      rtlcn1843);
   rtlcn1185 <= rtlcn1842 OR rtlcn1843 ;
   rtlcn1221 <= RCV_Pre_RxRdy AND mode_message_no_data ;
   rtlcn1213 <= not_timeout AND rtlcn1221 ;
   rtlcn1691 <= rtlcn704 OR rtlcn1677 ;
   rtlcn1844 <= not_rtlcn704 AND rtlcn1691 ;
   rtlcn1703 <= not_state_5 OR rtlcn1844 ;
   rtlcn1468 <= rtlc20n6830 AND rtlcn1703 ;
   not_write_req <= NOT write_req ;
   rtlcn1476 <= not_write_ack OR not_write_req ;
   rtlcn1847 <= state(5) AND rtlcn704 ;
   rtlcn1848 <= state(6) AND not_rtlcn704 ;
   not_rtlcn1668 <= NOT rtlcn1668 ;
   rtlcn1852 <= state(9) AND not_rtlcs14 ;
   rtlcn1704 <= rtlcn1852 OR rtlcn1853 ;
   rtlcn1854 <= state(8) AND not_rtlcn1941 ;
   rtlcn1490 <= rtlcn1854 OR rtlcn1704 ;
   not_state_14 <= NOT state(14) ;
   rtlcn1660 <= not_state_14 OR rtlcs14 ;
   not_state_15 <= NOT state(15) ;
   rtlcn1678 <= not_state_15 OR rtlcn704 ;
   not_rtlcn1678 <= NOT rtlcn1678 ;
   not_rtlcn1660 <= NOT rtlcn1660 ;
   rtlcn1860 <= write_ack AND not_rtlcn1660 ;
   rtlcn1497 <= not_rtlcn1678 OR rtlcn1860 ;
   rtlcn1861 <= state(11) AND not_mode_message_no_data ;
   rtlcn1705 <= state(15) OR rtlcn1861 ;
   rtlcn1862 <= rtlcn704 AND rtlcn1705 ;
   rtlcn1503 <= rtlcn1862 OR rtlcn1863 ;
   rtlcn1864 <= state(12) AND mode_message_no_data ;
   rtlcn1865 <= state(13) AND read_ack ;
   rtlcn1706 <= rtlcn1864 OR rtlcn1865 ;
   rtlcn1866 <= state(11) AND not_rtlcn704 ;
   rtlcn1508 <= rtlcn1866 OR rtlcn1706 ;
   rtlcn1689 <= not_state_16 OR not_rtlcn704 ;
   rtlcn1666 <= not_state_7 AND rtlcn1653 ;
   rtlcn1869 <= rtlcn1649 AND rtlcn1653 ;
   rtlcn1680 <= rtlcn1666 OR rtlcn1869 ;
   rtlcn1686 <= write_ack OR rtlcs14 ;
   rtlcn1871 <= state(14) AND rtlcn1686 ;
   rtlc_2560_or_1218 : or_4u_4u port map ( a(3)=>rtlcn1683, a(2)=>rtlcn1852, 
      a(1)=>rtlcn1871, a(0)=>rtlcn1872, d=>rtlcn1708);
   rtlcn1707 <= rtlcn1873 OR rtlcn1847 ;
   rtlc_2566_and_1219 : and_4u_4u port map ( a(3)=>not_RT2RT_int, a(2)=>
      rtlcn1661, a(1)=>not_rtlcn1668, a(0)=>rtlcn1680, d=>rtlcn1877);
   rtlcn1878 <= state(17) AND rtlc20n6165 ;
   rtlcn1880 <= not_rtlc20n5894 AND rtlcn1670 ;
   rtlcn1531 <= rtlcn1650 OR rtlcn1709 ;
   rtlcn1657 <= not_state_5 OR not_read_ack ;
   rtlcn1688 <= not_RT2RT_int OR not_Tx_message ;
   rtlcn1883 <= state(0) AND ENC_TEST_Go ;
   rtlcn1884 <= rtlcn1652 AND rtlcn1688 ;
   rtlcn1710 <= rtlcn1883 OR rtlcn1884 ;
   rtlcn1889 <= state(5) AND not_rtlcn1677 ;
   rtlcn1561 <= rtlcn1650 OR rtlcn1889 ;
   rtlcn1873 <= state(7) AND rtlcn1649 ;
   not_rtlc20n6890 <= NOT rtlc20n6890 ;
   rtlc_2781_or_1225 : or_5u_5u port map ( a(4)=>state(9), a(3)=>state(11), 
      a(2)=>rtlcn193, a(1)=>rtlcn259, a(0)=>rtlcn263, d=>rtlcn1935);
   not_rtlcn1935 <= NOT rtlcn1935 ;
   rtlc_2783_or_1226 : or_5u_5u port map ( a(4)=>state(7), a(3)=>state(8), 
      a(2)=>state(9), a(1)=>state(16), a(0)=>rtlcn659, d=>rtlcn1936);
   not_rtlcn1936 <= NOT rtlcn1936 ;
   rtlc_2785_or_1227 : or_4u_4u port map ( a(3)=>state(7), a(2)=>state(8), 
      a(1)=>state(9), a(0)=>rtlcn1517, d=>rtlcn1937);
   not_rtlcn1937 <= NOT rtlcn1937 ;
   rtlc_2787_or_1228 : or_5u_5u port map ( a(4)=>state(9), a(3)=>state(11), 
      a(2)=>rtlcn193, a(1)=>rtlcn259, a(0)=>rtlcn1535, d=>rtlcn1938);
   not_rtlcn1938 <= NOT rtlcn1938 ;
   not_rtlcn1939 <= NOT rtlcn1939 ;
   not_rtlcn1940 <= NOT rtlcn1940 ;
   not_rtlcn1941 <= NOT rtlcn1941 ;
   not_rtlcn1942 <= NOT rtlcn1942 ;
   not_rtlcn1943 <= NOT rtlcn1943 ;
   not_rtlcn1944 <= NOT rtlcn1944 ;
   not_rtlcn1945 <= NOT rtlcn1945 ;
   RCV_16n5ss1_17 <= RCV_A_R_Data(0) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(0) ;
   RCV_16n5ss1_18 <= RCV_A_R_Data(1) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(1) ;
   RCV_16n5ss1_19 <= RCV_A_R_Data(2) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(2) ;
   RCV_16n5ss1_20 <= RCV_A_R_Data(3) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(3) ;
   RCV_16n5ss1_21 <= RCV_A_R_Data(4) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(4) ;
   RCV_16n5ss1_22 <= RCV_A_R_Data(5) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(5) ;
   RCV_16n5ss1_23 <= RCV_A_R_Data(6) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(6) ;
   RCV_16n5ss1_24 <= RCV_A_R_Data(7) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(7) ;
   RCV_16n5ss1_25 <= RCV_A_R_Data(8) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(8) ;
   RCV_16n5ss1_26 <= RCV_A_R_Data(9) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(9) ;
   RCV_16n5ss1_27 <= RCV_A_R_Data(10) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(10) ;
   RCV_16n5ss1_28 <= RCV_A_R_Data(11) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(11) ;
   RCV_16n5ss1_29 <= RCV_A_R_Data(12) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(12) ;
   RCV_16n5ss1_30 <= RCV_A_R_Data(13) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(13) ;
   RCV_16n5ss1_31 <= RCV_A_R_Data(14) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(14) ;
   RCV_16n5ss1_32 <= RCV_A_R_Data(15) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_R_Data(15) ;
   RCV_16n5ss1_47 <= RCV_A_Gap_found(0) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Gap_found(0) ;
   RCV_16n5ss1_48 <= RCV_A_Gap_found(1) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Gap_found(1) ;
   RCV_16n5ss1_49 <= RCV_A_Gap_found(2) when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Gap_found(2) ;
   RCV_16n5ss1_52 <= RCV_A_CS when Tx_Bus_A_EXMPLR2345 = '1' else RCV_B_CS ;
   RCV_16n5ss1_53 <= RCV_A_Pre_EchoRdy when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Pre_EchoRdy ;
   RCV_16n5ss1_54 <= RCV_A_Command_Sync when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Command_Sync ;
   RCV_16n5ss1_55 <= RCV_A_Pre_RxRdy when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_Pre_RxRdy ;
   RCV_16n5ss1_56 <= RCV_A_recieving when Tx_Bus_A_EXMPLR2345 = '1' else 
   RCV_B_recieving ;
   Sync_error_16n5ss1 <= RCV_A_Sync_error when Tx_Bus_A_EXMPLR2345
    = '1' else RCV_B_Sync_error ;
   time_out_counter_var_20n97ss1_0 <= rtlcs8 when Set_time_out_to_rcv
    = '1' else time_out_counter_var_20n92s1(0) ;
   time_out_counter_var_20n97ss1_6 <= rtlcs8 when Set_time_out_to_rcv
    = '1' else time_out_counter_var_20n92s1(6) ;
   rtlc20n5810 <= rtlc20n5807 when read_ack = '1' else not_read_req ;
   active_command_20n83ss1_10 <= first_command_10 when rtlcn371 = '1' else 
   Tx_Data(10) ;
   active_command_20n83ss1_15 <= first_command_15 when rtlcn371 = '1' else 
   Tx_Data(15) ;
   active_command_20n83ss1_14 <= first_command_14 when rtlcn371 = '1' else 
   Tx_Data(14) ;
   active_command_20n83ss1_13 <= first_command_13 when rtlcn371 = '1' else 
   Tx_Data(13) ;
   active_command_20n83ss1_12 <= first_command_12 when rtlcn371 = '1' else 
   Tx_Data(12) ;
   active_command_20n83ss1_11 <= first_command_11 when rtlcn371 = '1' else 
   Tx_Data(11) ;
   active_command_20n83ss1_9 <= first_command_9 when rtlcn371 = '1' else 
   Tx_Data(9) ;
   active_command_20n83ss1_8 <= first_command_8 when rtlcn371 = '1' else 
   Tx_Data(8) ;
   active_command_20n83ss1_7 <= first_command_7 when rtlcn371 = '1' else 
   Tx_Data(7) ;
   active_command_20n83ss1_6 <= first_command_6 when rtlcn371 = '1' else 
   Tx_Data(6) ;
   active_command_20n83ss1_5 <= first_command_5 when rtlcn371 = '1' else 
   Tx_Data(5) ;
   active_command_20n83ss1_3 <= first_command_3 when rtlcn371 = '1' else 
   Tx_Data(3) ;
   active_command_20n83ss1_2 <= first_command_2 when rtlcn371 = '1' else 
   Tx_Data(2) ;
   active_command_20n83ss1_1 <= first_command_1 when rtlcn371 = '1' else 
   Tx_Data(1) ;
   active_command_20n83ss1_0 <= first_command_0 when rtlcn371 = '1' else 
   Tx_Data(0) ;
   not_Go <= NOT Go ;
   rtlc20n5751 <= not_Go OR ENC_TEST_Go ;
   not_rtlc20n5751 <= NOT rtlc20n5751 ;
   rtlcn1951 <= not_rtlc20n5751 OR not_state_0 ;
   not_state_10 <= NOT state(10) ;
   not_rtlcn234 <= NOT rtlcn234 ;
   rtlcn1977 <= not_rtlcn234 AND rtlcn1958 ;
   rtlcn1962 <= timeout OR rtlcn1977 ;
   not_RCV_Pre_RxRdy <= NOT RCV_Pre_RxRdy ;
   not_rtlcn224 <= NOT rtlcn224 ;
   rtlc20n7156 <= CE AND not_rtlcn224 ;
   not_rtlcn222 <= NOT rtlcn222 ;
   rtlc20n7155 <= CE AND not_rtlcn222 ;
   not_rtlc20n6202 <= NOT rtlc20n6202 ;
   rtlc20n7153 <= CE AND not_rtlc20n6202 ;
   not_rtlc20n6201 <= NOT rtlc20n6201 ;
   rtlc20n7152 <= CE AND not_rtlc20n6201 ;
   rtlc20n5932 <= not_RCV_Pre_RxRdy OR timeout ;
   rtlcn1953 <= not_rtlcn236 OR rtlcn704 ;
   not_rtlcn1953 <= NOT rtlcn1953 ;
   rtlcn1985 <= rtlc20n5932 AND rtlcn209 ;
   not_rtlcn1946 <= NOT rtlcn1946 ;
   not_rtlcn1476 <= NOT rtlcn1476 ;
   rtlcn1965 <= not_rtlcn1946 OR not_rtlcn1476 ;
   rtlc20n7140 <= CE AND rtlcn1965 ;
   rtlcn1990 <= not_rtlcs14 AND write_ack ;
   rtlcn1948 <= not_state_14 OR rtlcn1990 ;
   not_state_12 <= NOT state(12) ;
   rtlcn1949 <= not_mode_message_no_data OR not_state_12 ;
   not_rtlcn1963 <= NOT rtlcn1963 ;
   rtlcn1954 <= not_state_3 OR not_rtlcn1963 ;
   not_rtlcn1702 <= NOT rtlcn1702 ;
   rtlc_2998_and_1231 : and_4u_4u port map ( a(3)=>rtlc20n7221, a(2)=>
      rtlcn1948, a(1)=>rtlcn1949, a(0)=>rtlcn1954, d=>rtlcn1999);
   rtlcn1966 <= not_rtlcn1702 OR rtlcn1999 ;
   rtlc20n7138 <= CE AND rtlcn1966 ;
   not_rtlc20n6931 <= NOT rtlc20n6931 ;
   rtlcn1959 <= timeout OR not_rtlc20n6931 ;
   not_rtlc20n6319 <= NOT rtlc20n6319 ;
   rtlcn1960 <= rtlcs17 OR not_rtlc20n6319 ;
   rtlcn1967 <= rtlcn1957 OR rtlcn1960 ;
   rtlc20n7133 <= CE AND rtlcn1967 ;
   not_rtlcn1960 <= NOT rtlcn1960 ;
   rtlcn2004 <= rtlc20n6820 AND not_rtlcn1960 ;
   rtlcn1968 <= rtlcn1957 OR rtlcn2004 ;
   rtlc20n7131 <= CE AND rtlcn1968 ;
   rtlcn2006 <= Tx_message AND not_rtlcs13 ;
   rtlc20n5809 <= not_read_ack OR rtlcn2006 ;
   rtlc_3023_or_1233 : or_4u_4u port map ( a(3)=>Tx_message, a(2)=>RT2RT_int, 
      a(1)=>rtlcn1963, a(0)=>rtlcs13, d=>rtlcn1969);
   not_CE <= NOT CE ;
   rtlcn2008 <= rtlc20n5809 AND state(5) ;
   rtlcn2009 <= rtlc20n5932 AND state(8) ;
   rtlcn2012 <= state(15) AND not_rtlcn704 ;
   rtlcn2013 <= state(3) AND rtlcn1969 ;
   rtlc_3031_or_1234 : or_7u_7u port map ( a(6)=>not_rtlc20n7215, a(5)=>
      rtlcn1835, a(4)=>not_CE, a(3)=>rtlcn2008, a(2)=>rtlcn2009, a(1)=>
      rtlcn2012, a(0)=>rtlcn2013, d=>rtlcn1947);
   not_rtlcn1947 <= NOT rtlcn1947 ;
   not_rtlc20n6196 <= NOT rtlc20n6196 ;
   rtlc20n7116 <= CE AND not_rtlc20n6196 ;
   not_rtlc20n6195 <= NOT rtlc20n6195 ;
   rtlc20n7100 <= CE AND not_rtlc20n6195 ;
   not_rtlc20n6194 <= NOT rtlc20n6194 ;
   rtlc20n7084 <= CE AND not_rtlc20n6194 ;
   not_rtlcn220 <= NOT rtlcn220 ;
   rtlc20n7083 <= CE AND not_rtlcn220 ;
   not_rtlcn218 <= NOT rtlcn218 ;
   rtlc20n7082 <= CE AND not_rtlcn218 ;
   not_rtlc20n5932 <= NOT rtlc20n5932 ;
   rtlcn1950 <= not_rtlc20n5932 OR not_rtlcn240 ;
   not_rtlc20n7199 <= NOT rtlc20n7199 ;
   rtlc_3048_and_1235 : and_6u_6u port map ( a(5)=>CE, a(4)=>not_rtlc20n7199, 
      a(3)=>rtlcn1948, a(2)=>rtlcn1949, a(1)=>rtlcn1950, a(0)=>rtlcn1953, d
      =>rtlc20n7065);
   rtlc20n7063 <= CE AND not_rtlcn1946 ;
   rtlc20n7062 <= CE AND write_req ;
   not_rtlc20n6189 <= NOT rtlc20n6189 ;
   rtlc20n7045 <= CE AND not_rtlc20n6189 ;
   rtlc20n7044 <= CE AND read_req ;
   Response_timeout_Error_20n33ss1 <= not_Found_errors AND rtlcn2023 ;
   Found_wrong_word_count_20n83ss1 <= not_Found_errors AND rtlcn2024 ;
   rtlc20n6202 <= not_FE_All_Errors AND rtlcn2025 ;
   rtlc20n6195 <= rtlc20n5769 OR not_state_3 ;
   rtlc_3070_and_1239 : and_16u_16u port map ( a(15)=>Tx_Data(15), a(14)=>
      Tx_Data(14), a(13)=>Tx_Data(13), a(12)=>Tx_Data(12), a(11)=>
      Tx_Data(11), a(10)=>Tx_Data(10), a(9)=>Tx_Data(9), a(8)=>Tx_Data(8), 
      a(7)=>Tx_Data(7), a(6)=>Tx_Data(6), a(5)=>Tx_Data(5), a(4)=>Tx_Data(4), 
      a(3)=>Tx_Data(3), a(2)=>Tx_Data(2), a(1)=>Tx_Data(1), a(0)=>Tx_Data(0), 
      d=>rtlcs13);
   rtlcn1944 <= state(6) OR rtlcn1611 ;
   BCR_message_and_10i1 : and_5u_5u port map ( a(4)=>active_command_15, a(3)
      =>active_command_14, a(2)=>active_command_13, a(1)=>active_command_12, 
      a(0)=>active_command_11, d=>BCR_message_10n2s2);
   state_fsm_20n76ss1_10 <= not_BCR_message AND rtlcn704 ;
   not_active_command_9 <= NOT active_command_9 ;
   not_active_command_8 <= NOT active_command_8 ;
   not_active_command_7 <= NOT active_command_7 ;
   not_active_command_6 <= NOT active_command_6 ;
   not_active_command_5 <= NOT active_command_5 ;
   mode_message_no_data_and_10i3 : and_5u_5u port map ( a(4)=>
      not_active_command_9, a(3)=>not_active_command_8, a(2)=>
      not_active_command_7, a(1)=>not_active_command_6, a(0)=>
      not_active_command_5, d=>mode_message_no_data_10n2s6);
   not_active_command_3 <= NOT active_command_3 ;
   not_active_command_2 <= NOT active_command_2 ;
   not_active_command_1 <= NOT active_command_1 ;
   not_active_command_0 <= NOT active_command_0 ;
   rtlc_3091_and_1243 : and_4u_4u port map ( a(3)=>not_active_command_3, 
      a(2)=>not_active_command_2, a(1)=>not_active_command_1, a(0)=>
      not_active_command_0, d=>rtlcs3);
   word_counter_20n83ss1(4) <= word_counter_20n69s1(4) AND rtlcn189 ;
   word_counter_20n83ss1(3) <= word_counter_20n69s1(3) AND rtlcn189 ;
   word_counter_20n83ss1(2) <= word_counter_20n69s1(2) AND rtlcn189 ;
   word_counter_20n83ss1(1) <= word_counter_20n69s1(1) AND rtlcn189 ;
   word_counter_20n83ss1(5) <= word_counter_20n69s1(5) AND rtlcn189 ;
   not_word_counter_4 <= NOT word_counter(4) ;
   rtlcs14 <= not_word_counter_4 AND rtlcs21 ;
   not_word_counter_5 <= NOT word_counter(5) ;
   not_word_counter_3 <= NOT word_counter(3) ;
   not_word_counter_2 <= NOT word_counter(2) ;
   not_word_counter_1 <= NOT word_counter(1) ;
   state_fsm_20n33ss1_10 <= RT2RT_int AND rtlcn1213 ;
   not_word_counter_0 <= NOT word_counter(0) ;
   ME_message_20n83ss1 <= RCV_R_Data(10) AND not_state_0 ;
   BUSY_message_20n83ss1 <= RCV_R_Data(3) AND not_state_0 ;
   state_fsm_20n43ss1_10 <= RT2RT_int AND rtlcn2072 ;
   state_fsm_20n45ss1_10 <= RT2RT_int AND rtlcs14 ;
   not_Down_count_4 <= NOT Down_count(4) ;
   not_Down_count_3 <= NOT Down_count(3) ;
   not_Down_count_2 <= NOT Down_count(2) ;
   not_Down_count_1 <= NOT Down_count(1) ;
   not_Down_count_0 <= NOT Down_count(0) ;
   rtlc_3147_and_1245 : and_5u_5u port map ( a(4)=>not_Down_count_4, a(3)=>
      not_Down_count_3, a(2)=>not_Down_count_2, a(1)=>not_Down_count_1, a(0)
      =>not_Down_count_0, d=>rtlcs5);
   read_ack_and_20i35 : and_5u_5u port map ( a(4)=>not_Down_count_4, a(3)=>
      not_Down_count_3, a(2)=>not_Down_count_2, a(1)=>not_Down_count_1, a(0)
      =>Down_count(0), d=>read_ack_20n87s2);
   RT2RT_int_20n83ss1 <= RT2RT AND not_state_5 ;
   state_fsm_20n23ss1_17 <= BCR_message AND rtlcn704 ;
   state_fsm_20n45ss1_17 <= not_RT2RT_int AND rtlcs14 ;
   state_fsm_20n63ss1_17 <= BCR_message AND rtlcn1722 ;
   state_fsm_20n32ss1_17 <= not_RT2RT_int AND rtlcn1221 ;
   not_No_Response_timeout_1 <= NOT No_Response_timeout(1) ;
   time_out_counter_var_20n99ss1(6) <= time_out_counter_var_20n97ss1_6 AND 
   rtlcn767 ;
   not_No_Response_timeout_0 <= NOT No_Response_timeout(0) ;
   time_out_counter_var_20n99ss1(3) <= time_out_counter_var_20n97ss1_3 AND 
   rtlcn767 ;
   rtlcn1939 <= rtlcn809 OR rtlcn810 ;
   time_out_counter_var_20n99ss1(2) <= time_out_counter_var_20n98ss1_2 OR 
   Set_time_out_to_5us ;
   not_rtlcn767 <= NOT rtlcn767 ;
   time_out_counter_var_20n99ss1(0) <= time_out_counter_var_20n97ss1_0 OR 
   not_rtlcn767 ;
   time_out_counter_var_20n99ss1(7) <= time_out_counter_var_20n97ss1_7 AND 
   rtlcn767 ;
   not_time_out_counter_var_7 <= NOT time_out_counter_var(7) ;
   not_time_out_counter_var_6 <= NOT time_out_counter_var(6) ;
   not_time_out_counter_var_5 <= NOT time_out_counter_var(5) ;
   not_time_out_counter_var_4 <= NOT time_out_counter_var(4) ;
   not_time_out_counter_var_3 <= NOT time_out_counter_var(3) ;
   not_time_out_counter_var_2 <= NOT time_out_counter_var(2) ;
   not_time_out_counter_var_1 <= NOT time_out_counter_var(1) ;
   not_time_out_counter_var_0 <= NOT time_out_counter_var(0) ;
   rtlc_3196_and_1251 : and_8u_8u port map ( a(7)=>
      not_time_out_counter_var_7, a(6)=>not_time_out_counter_var_6, a(5)=>
      not_time_out_counter_var_5, a(4)=>not_time_out_counter_var_4, a(3)=>
      not_time_out_counter_var_3, a(2)=>not_time_out_counter_var_2, a(1)=>
      not_time_out_counter_var_1, a(0)=>not_time_out_counter_var_0, d=>
      rtlcs17);
   rtlcn1941 <= timeout OR RCV_Pre_RxRdy ;
   rtlcn1945 <= rtlcn1656 OR rtlcn1657 ;
   Rx_Data_20n83ss1(0) <= RCV_R_Data(0) OR state(2) ;
   Rx_Data_20n83ss1(1) <= RCV_R_Data(1) OR state(2) ;
   Rx_Data_20n83ss1(2) <= RCV_R_Data(2) OR state(2) ;
   Rx_Data_20n83ss1(3) <= RCV_R_Data(3) OR state(2) ;
   Rx_Data_20n83ss1(4) <= RCV_R_Data(4) OR state(2) ;
   Rx_Data_20n83ss1(5) <= RCV_R_Data(5) OR state(2) ;
   Rx_Data_20n83ss1(6) <= RCV_R_Data(6) OR state(2) ;
   Rx_Data_20n83ss1(7) <= RCV_R_Data(7) OR state(2) ;
   Rx_Data_20n83ss1(8) <= RCV_R_Data(8) OR state(2) ;
   Rx_Data_20n83ss1(9) <= RCV_R_Data(9) OR state(2) ;
   Rx_Data_20n83ss1(10) <= RCV_R_Data(10) OR state(2) ;
   Rx_Data_20n83ss1(11) <= RCV_R_Data(11) OR state(2) ;
   Rx_Data_20n83ss1(12) <= RCV_R_Data(12) OR state(2) ;
   Rx_Data_20n83ss1(13) <= RCV_R_Data(13) OR state(2) ;
   Rx_Data_20n83ss1(14) <= RCV_R_Data(14) OR state(2) ;
   Rx_Data_20n83ss1(15) <= RCV_R_Data(15) OR state(2) ;
   not_rtlcn884 <= NOT rtlcn884 ;
   Found_errors_20n83ss1 <= not_Go OR not_rtlcn884 ;
   rtlcn1942 <= rtlc20n5898 OR rtlc20n5912 ;
   not_RCV_Gap_found_2 <= NOT RCV_Gap_found(2) ;
   not_RCV_Gap_found_1 <= NOT RCV_Gap_found(1) ;
   not_RCV_Gap_found_0 <= NOT RCV_Gap_found(0) ;
   FE_All_Errors_20n21ss1 <= not_Found_errors AND not_RCV_CS ;
   FE_All_Errors_20n22ss1 <= FE_All_Errors_20n21ss1 AND RCV_Pre_EchoRdy ;
   rtlcn2025 <= rtlc20n5751 OR not_state_0 ;
   rtlcn1940 <= rtlcn877 OR rtlcn881 ;
   Response_timeout_Error_20n83ss1 <= Response_timeout_Error_20n33ss1 AND 
   rtlcn209 ;
   rtlcn1943 <= rtlcn1119 OR rtlcn1120 ;
   Bus_Coupling_error_20n83ss1 <= Loopback_error_20n18s1 AND rtlcn1122 ;
   BC_logic_error_20n83ss1 <= not_Found_errors AND rtlcn1561 ;
   Wrong_Sync_error_20n83ss1 <= not_Found_errors AND rtlcn1185 ;
   Good_data_block_recieved_20n83ss1 <= Loopback_error_20n18s1 AND state(9)
    ;
   not_rtlcn209 <= NOT rtlcn209 ;
   rtlcn224 <= rtlc20n5932 OR not_rtlcn209 ;
   rtlcn2074 <= read_req OR write_req ;
   Found_Format_Error_20n83ss1 <= not_Found_errors AND rtlcn2231 ;
   rtlcn1790 <= RCV_CS AND RCV_Command_Sync ;
   rtlcn1722 <= mode_message_no_data AND rtlcn704 ;
   rtlcn2072 <= timeout AND rtlc20n5894 ;
   modgen_counter_Energy_Count : 
      counter_up_cnt_en_sclear_aclear_clock_clk_en_0_10 port map ( clock=>C, 
      q(9)=>Energy_Count(9), q(8)=>Energy_Count(8), q(7)=>Energy_Count(7), 
      q(6)=>Energy_Count(6), q(5)=>Energy_Count(5), q(4)=>Energy_Count(4), 
      q(3)=>Energy_Count(3), q(2)=>Energy_Count(2), q(1)=>Energy_Count(1), 
      q(0)=>Energy_Count(0), clk_en=>CE, aclear=>not_R, sload=>
      Debug_2_EXMPLR2401, data(9)=>DANGLING(2), data(8)=>DANGLING(3), 
      data(7)=>DANGLING(4), data(6)=>DANGLING(5), data(5)=>DANGLING(6), 
      data(4)=>DANGLING(7), data(3)=>DANGLING(8), data(2)=>DANGLING(9), 
      data(1)=>DANGLING(10), data(0)=>DANGLING(11), aset=>Debug_2_EXMPLR2401, 
      sclear=>rtlc13n27, updn=>PWR, cnt_en=>rtlc13n39);
   modgen_counter_Down_count : counter_dn_cnt_en_sload_aset_clock_clk_en_0_5
       port map ( clock=>C, q(4)=>Down_count(4), q(3)=>Down_count(3), q(2)=>
      Down_count(2), q(1)=>Down_count(1), q(0)=>Down_count(0), clk_en=>CE, 
      aclear=>Debug_2_EXMPLR2401, sload=>rtlc20n6619, data(4)=>PWR, data(3)
      =>PWR, data(2)=>PWR, data(1)=>PWR, data(0)=>PWR, aset=>not_R, sclear=>
      Debug_2_EXMPLR2401, updn=>Debug_2_EXMPLR2401, cnt_en=>rtlcn2074);
   modgen_counter_us_counter : counter_up_sclear_aclear_clock_clk_en_0_5
       port map ( clock=>C, q(4)=>us_counter(4), q(3)=>us_counter(3), q(2)=>
      us_counter(2), q(1)=>us_counter(1), q(0)=>us_counter(0), clk_en=>CE, 
      aclear=>not_R, sload=>Debug_2_EXMPLR2401, data(4)=>DANGLING(12), 
      data(3)=>DANGLING(13), data(2)=>DANGLING(14), data(1)=>DANGLING(15), 
      data(0)=>DANGLING(16), aset=>Debug_2_EXMPLR2401, sclear=>
      rtlc20_X_0_n6664, updn=>PWR, cnt_en=>PWR);
   rtlc_3536_and_1253 : and_5u_5u port map ( a(4)=>us_counter(4), a(3)=>
      us_counter(3), a(2)=>us_counter(2), a(1)=>us_counter(1), a(0)=>
      us_counter(0), d=>rtlc20n6820);
   rtlceq_s39_eq_1254 : eq_5u_5u port map ( a(4)=>first_command_15, a(3)=>
      first_command_14, a(2)=>first_command_13, a(1)=>first_command_12, a(0)
      =>first_command_11, b(4)=>RCV_R_Data(15), b(3)=>RCV_R_Data(14), b(2)=>
      RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)=>RCV_R_Data(11), d=>rtlcs19
   );
   rtlceq_s41_eq_1255 : eq_5u_5u port map ( a(4)=>active_command_15, a(3)=>
      active_command_14, a(2)=>active_command_13, a(1)=>active_command_12, 
      a(0)=>active_command_11, b(4)=>RCV_R_Data(15), b(3)=>RCV_R_Data(14), 
      b(2)=>RCV_R_Data(13), b(1)=>RCV_R_Data(12), b(0)=>RCV_R_Data(11), d=>
      rtlcs20);
   rtlceq_s43_eq_1256 : eq_5u_5u port map ( a(4)=>WC_5, a(3)=>WC_3, a(2)=>
      WC_2, a(1)=>WC_1, a(0)=>WC_0, b(4)=>word_counter(5), b(3)=>
      word_counter(3), b(2)=>word_counter(2), b(1)=>word_counter(1), b(0)=>
      word_counter(0), d=>rtlcs21);
   DFFPC (RCV_A_recieving,Debug_2_EXMPLR2401,not_R,C,recieving_on_A) ;
   DFFPC (RCV_B_recieving,Debug_2_EXMPLR2401,not_R,C,recieving_on_B) ;
   DFFPCE (mode_message_no_data_10n2s2,Debug_2_EXMPLR2401,not_R,CE,C,
   mode_message_no_data) ;
   DFFPCE (active_command_10,Debug_2_EXMPLR2401,not_R,CE,C,Tx_message) ;
   DFFPCE (BCR_message_10n2s2,Debug_2_EXMPLR2401,not_R,CE,C,BCR_message) ;
   DFFPCE (rtlcs3,Debug_2_EXMPLR2401,not_R,CE,C,WC_5) ;
   DFFPCE (active_command_3,Debug_2_EXMPLR2401,not_R,CE,C,WC_3) ;
   DFFPCE (active_command_2,Debug_2_EXMPLR2401,not_R,CE,C,WC_2) ;
   DFFPCE (active_command_1,Debug_2_EXMPLR2401,not_R,CE,C,WC_1) ;
   DFFPCE (active_command_0,Debug_2_EXMPLR2401,not_R,CE,C,WC_0) ;
   DFFPCE (Sync_error_16n5ss1,Debug_2_EXMPLR2401,not_R,CE,C,Sync_error) ;
   DFFPCE (RCV_16n5ss1_56,Debug_2_EXMPLR2401,not_R,CE,C,RCV_recieving) ;
   DFFPCE (RCV_16n5ss1_55,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Pre_RxRdy) ;
   DFFPCE (RCV_16n5ss1_54,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Command_Sync) ;
   DFFPCE (RCV_16n5ss1_53,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Pre_EchoRdy) ;
   DFFPCE (RCV_16n5ss1_52,Debug_2_EXMPLR2401,not_R,CE,C,RCV_CS) ;
   DFFPCE (RCV_16n5ss1_49,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Gap_found(2)) ;
   DFFPCE (RCV_16n5ss1_48,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Gap_found(1)) ;
   DFFPCE (RCV_16n5ss1_47,Debug_2_EXMPLR2401,not_R,CE,C,RCV_Gap_found(0)) ;
   DFFPCE (RCV_16n5ss1_32,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(15)) ;
   DFFPCE (RCV_16n5ss1_31,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(14)) ;
   DFFPCE (RCV_16n5ss1_30,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(13)) ;
   DFFPCE (RCV_16n5ss1_29,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(12)) ;
   DFFPCE (RCV_16n5ss1_28,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(11)) ;
   DFFPCE (RCV_16n5ss1_27,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(10)) ;
   DFFPCE (RCV_16n5ss1_26,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(9)) ;
   DFFPCE (RCV_16n5ss1_25,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(8)) ;
   DFFPCE (RCV_16n5ss1_24,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(7)) ;
   DFFPCE (RCV_16n5ss1_23,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(6)) ;
   DFFPCE (RCV_16n5ss1_22,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(5)) ;
   DFFPCE (RCV_16n5ss1_21,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(4)) ;
   DFFPCE (RCV_16n5ss1_20,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(3)) ;
   DFFPCE (RCV_16n5ss1_19,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(2)) ;
   DFFPCE (RCV_16n5ss1_18,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(1)) ;
   DFFPCE (RCV_16n5ss1_17,Debug_2_EXMPLR2401,not_R,CE,C,RCV_R_Data(0)) ;
   DFFPCE (rtlcn667,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(19)) ;
   DFFPCE (rtlcn1531,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(18)) ;
   DFFPCE (state_fsm_20n83ss1_17,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,
   state(17)) ;
   DFFPCE (rtlcn1513,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(16)) ;
   DFFPCE (rtlcn1497,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(15)) ;
   DFFPCE (rtlcn1503,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(14)) ;
   DFFPCE (rtlcn615,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(13)) ;
   DFFPCE (rtlcn360,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(12)) ;
   DFFPCE (rtlcn1508,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(11)) ;
   DFFPCE (state_fsm_20n83ss1_10,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,
   state(10)) ;
   DFFPCE (rtlcn1614,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(9)) ;
   DFFPCE (rtlcn1490,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(8)) ;
   DFFPCE (state_fsm_20n83ss1_7,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,
   state(7)) ;
   DFFPCE (rtlcn1484,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(6)) ;
   DFFPCE (rtlcn1468,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(5)) ;
   DFFPCE (rtlcn1470,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(4)) ;
   DFFPCE (rtlcn274,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(3)) ;
   DFFPCE (rtlcn425,Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(2)) ;
   DFFPCE (state(0),Debug_2_EXMPLR2401,not_R,rtlc20n7192,C,state(1)) ;
   DFFPCE (rtlcn245,not_R,Debug_2_EXMPLR2401,rtlc20n7192,C,state(0)) ;
   DFFPCE (BC_1553A_ME_20n26s1,Debug_2_EXMPLR2401,not_R,rtlc20n7156,C,
   BC_1553A_ME) ;
   DFFPCE (BUSY_message_20n83ss1,Debug_2_EXMPLR2401,not_R,rtlc20n7155,C,
   BUSY_message) ;
   DFFPCE (ME_message_20n83ss1,Debug_2_EXMPLR2401,not_R,rtlc20n7155,C,
   ME_message) ;
   DFFPCE (Found_errors_20n83ss1,Debug_2_EXMPLR2401,not_R,rtlc20n7153,C,
   Found_errors) ;
   DFFPCE (Good_data_block_recieved_20n83ss1,Debug_2_EXMPLR2401,not_R,
   rtlc20n7152,C,Good_data_block_recieved) ;
   DFFPCE (FE_All_Errors_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   FE_All_Errors_EXMPLR2395) ;
   DFFPCE (Bus_Coupling_error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Bus_Coupling_error) ;
   DFFPCE (BC_logic_error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   BC_logic_error) ;
   DFFPCE (Wrong_Sync_error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Wrong_Sync_error) ;
   DFFPCE (Found_wrong_word_count_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Found_wrong_word_count) ;
   DFFPCE (Found_wrong_RT_Address_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Found_wrong_RT_Address) ;
   DFFPCE (Loopback_error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Loopback_error) ;
   DFFPCE (Found_Format_Error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Found_Format_Error) ;
   DFFPCE (Response_timeout_Error_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Response_timeout_Error) ;
   DFFPCE (write_ack_20n90s1,Debug_2_EXMPLR2401,not_R,CE,C,write_ack) ;
   DFFPCE (rtlcn1476,Debug_2_EXMPLR2401,not_R,rtlc20n7140,C,write_req) ;
   DFFPCE (read_ack_20n87s1,Debug_2_EXMPLR2401,not_R,CE,C,read_ack) ;
   DFFPCE (rtlcn318,Debug_2_EXMPLR2401,not_R,rtlc20n7138,C,read_req) ;
   DFFPCE (not_state_0,Debug_2_EXMPLR2401,not_R,rtlc20n7137,C,
   Receive_problem) ;
   DFFPCE (Set_time_out_to_rcv_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Set_time_out_to_rcv) ;
   DFFPCE (rtlcn1526,Debug_2_EXMPLR2401,not_R,CE,C,Set_time_out_to_echo) ;
   DFFPCE (Set_time_out_to_5us_20n83ss1,Debug_2_EXMPLR2401,not_R,CE,C,
   Set_time_out_to_5us) ;
   DFFPCE (rtlcn383,Debug_2_EXMPLR2401,not_R,rtlc20n7133,C,timeout) ;
   DFFPCE (not_rtlc20n6921,Debug_2_EXMPLR2401,not_R,CE,C,
   timeout_count_enable) ;
   DFFPCE (time_out_counter_var_20n99ss1(7),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(7)) ;
   DFFPCE (time_out_counter_var_20n99ss1(6),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(6)) ;
   DFFPCE (time_out_counter_var_20n99ss1(5),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(5)) ;
   DFFPCE (time_out_counter_var_20n99ss1(4),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(4)) ;
   DFFPCE (time_out_counter_var_20n99ss1(3),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(3)) ;
   DFFPCE (time_out_counter_var_20n99ss1(2),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(2)) ;
   DFFPCE (time_out_counter_var_20n99ss1(1),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(1)) ;
   DFFPCE (time_out_counter_var_20n99ss1(0),Debug_2_EXMPLR2401,not_R,
   rtlc20n7131,C,time_out_counter_var(0)) ;
   DFFPCE (word_counter_20n83ss1(5),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(5)) ;
   DFFPCE (word_counter_20n83ss1(4),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(4)) ;
   DFFPCE (word_counter_20n83ss1(3),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(3)) ;
   DFFPCE (word_counter_20n83ss1(2),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(2)) ;
   DFFPCE (word_counter_20n83ss1(1),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(1)) ;
   DFFPCE (word_counter_20n83ss1(0),Debug_2_EXMPLR2401,not_R,not_rtlcn1947,C,
   word_counter(0)) ;
   DFFPCE (active_command_20n83ss1_15,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_15) ;
   DFFPCE (active_command_20n83ss1_14,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_14) ;
   DFFPCE (active_command_20n83ss1_13,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_13) ;
   DFFPCE (active_command_20n83ss1_12,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_12) ;
   DFFPCE (active_command_20n83ss1_11,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_11) ;
   DFFPCE (active_command_20n83ss1_10,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_10) ;
   DFFPCE (active_command_20n83ss1_9,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_9) ;
   DFFPCE (active_command_20n83ss1_8,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_8) ;
   DFFPCE (active_command_20n83ss1_7,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_7) ;
   DFFPCE (active_command_20n83ss1_6,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_6) ;
   DFFPCE (active_command_20n83ss1_5,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_5) ;
   DFFPCE (active_command_20n83ss1_3,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_3) ;
   DFFPCE (active_command_20n83ss1_2,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_2) ;
   DFFPCE (active_command_20n83ss1_1,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_1) ;
   DFFPCE (active_command_20n83ss1_0,Debug_2_EXMPLR2401,not_R,rtlc20n7116,C,
   active_command_0) ;
   DFFPCE (Tx_Data(15),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_15) ;
   DFFPCE (Tx_Data(14),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_14) ;
   DFFPCE (Tx_Data(13),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_13) ;
   DFFPCE (Tx_Data(12),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_12) ;
   DFFPCE (Tx_Data(11),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_11) ;
   DFFPCE (Tx_Data(10),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,
   first_command_10) ;
   DFFPCE (Tx_Data(9),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_9
   ) ;
   DFFPCE (Tx_Data(8),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_8
   ) ;
   DFFPCE (Tx_Data(7),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_7
   ) ;
   DFFPCE (Tx_Data(6),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_6
   ) ;
   DFFPCE (Tx_Data(5),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_5
   ) ;
   DFFPCE (Tx_Data(3),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_3
   ) ;
   DFFPCE (Tx_Data(2),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_2
   ) ;
   DFFPCE (Tx_Data(1),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_1
   ) ;
   DFFPCE (Tx_Data(0),Debug_2_EXMPLR2401,not_R,rtlc20n7100,C,first_command_0
   ) ;
   DFFPCE (Bus_A,Debug_2_EXMPLR2401,not_R,rtlc20n7084,C,Tx_Bus_A_EXMPLR2345)
    ;
   DFFPCE (T_Sync_20n83ss1,Debug_2_EXMPLR2401,not_R,rtlc20n7083,C,T_Sync) ;
   DFFPCE (Tx_Data(15),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(15)) ;
   DFFPCE (Tx_Data(14),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(14)) ;
   DFFPCE (Tx_Data(13),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(13)) ;
   DFFPCE (Tx_Data(12),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(12)) ;
   DFFPCE (Tx_Data(11),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(11)) ;
   DFFPCE (Tx_Data(10),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(10)) ;
   DFFPCE (Tx_Data(9),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(9)) ;
   DFFPCE (Tx_Data(8),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(8)) ;
   DFFPCE (Tx_Data(7),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(7)) ;
   DFFPCE (Tx_Data(6),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(6)) ;
   DFFPCE (Tx_Data(5),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(5)) ;
   DFFPCE (Tx_Data(4),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(4)) ;
   DFFPCE (Tx_Data(3),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(3)) ;
   DFFPCE (Tx_Data(2),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(2)) ;
   DFFPCE (Tx_Data(1),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(1)) ;
   DFFPCE (Tx_Data(0),Debug_2_EXMPLR2401,not_R,rtlc20n7082,C,
   Transmit_data(0)) ;
   DFFPCE (rtlcn1542,Debug_2_EXMPLR2401,not_R,CE,C,Go_Tx) ;
   DFFPCE (rtlcn863,Debug_2_EXMPLR2401,not_R,rtlc20n7065,C,Command_Sync) ;
   DFFPCE (not_state_0,Debug_2_EXMPLR2401,not_R,CE,C,Message_Active) ;
   DFFPCE (not_rtlc20n6890,Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,Echo) ;
   DFFPCE (not_rtlcs5,Debug_2_EXMPLR2401,not_R,rtlc20n7062,C,Write) ;
   DFFPCE (Rx_Data_20n83ss1(15),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(15)) ;
   DFFPCE (Rx_Data_20n83ss1(14),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(14)) ;
   DFFPCE (Rx_Data_20n83ss1(13),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(13)) ;
   DFFPCE (Rx_Data_20n83ss1(12),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(12)) ;
   DFFPCE (Rx_Data_20n83ss1(11),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(11)) ;
   DFFPCE (Rx_Data_20n83ss1(10),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(10)) ;
   DFFPCE (Rx_Data_20n83ss1(9),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(9)) ;
   DFFPCE (Rx_Data_20n83ss1(8),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(8)) ;
   DFFPCE (Rx_Data_20n83ss1(7),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(7)) ;
   DFFPCE (Rx_Data_20n83ss1(6),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(6)) ;
   DFFPCE (Rx_Data_20n83ss1(5),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(5)) ;
   DFFPCE (Rx_Data_20n83ss1(4),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(4)) ;
   DFFPCE (Rx_Data_20n83ss1(3),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(3)) ;
   DFFPCE (Rx_Data_20n83ss1(2),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(2)) ;
   DFFPCE (Rx_Data_20n83ss1(1),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(1)) ;
   DFFPCE (Rx_Data_20n83ss1(0),Debug_2_EXMPLR2401,not_R,rtlc20n7063,C,
   Rx_Data(0)) ;
   DFFPCE (RT2RT_int_20n83ss1,Debug_2_EXMPLR2401,not_R,rtlc20n7045,C,
   RT2RT_int) ;
   DFFPCE (not_rtlcs5,Debug_2_EXMPLR2401,not_R,rtlc20n7044,C,Read) ;
   rtlc20_788_or_1146_nx0 <= state(7) OR state(9) ;
   rtlc20n6890 <= rtlc20_788_or_1146_nx0 OR state(10) ;
   rtlc20_846_or_1150_nx0 <= state(11) OR state(15) ;
   rtlc20n6931 <= rtlc20_846_or_1150_nx0 OR state(16) ;
   rtlc20_2308_gt_1164_nx0 <= RCV_Gap_found(0) XOR No_Response_timeout(0) ;
   rtlc20_2308_gt_1164_nx2 <= RCV_Gap_found(1) XOR No_Response_timeout(1) ;
   rtlc20_2308_gt_1164_nx4 <= RCV_Gap_found(2) XOR No_Response_timeout(2) ;
   rtlc_2266_and_1187_nx0 <= rtlc20n5894 AND not_RT2RT_int ;
   rtlcn1714 <= rtlc_2266_and_1187_nx0 AND rtlcn1670 ;
   rtlc_2267_or_1188_nx0 <= state(19) OR rtlcn1712 ;
   rtlcn263 <= rtlc_2267_or_1188_nx0 OR rtlcn1714 ;
   rtlc_2308_or_1189_nx0 <= Set_time_out_to_5us OR rtlcn1693 ;
   rtlcn799 <= rtlc_2308_or_1189_nx0 OR rtlcn1736 ;
   rtlc_2325_and_1190_nx0 <= not_rtlc20n6802 AND RCV_CS ;
   rtlcn877 <= rtlc_2325_and_1190_nx0 AND rtlcn1649 ;
   rtlc_2339_and_1191_nx0 <= state(8) AND not_timeout ;
   rtlcn1753 <= rtlc_2339_and_1191_nx0 AND rtlc20n5499 ;
   rtlcn1780 <= timeout AND rtlcn209 ;
   rtlcn1759 <= rtlcn1780 AND not_rtlcn1682 ;
   rtlc_2359_and_1194_nx0 <= not_rtlc20n7483 AND rtlcn1664 ;
   rtlcn1767 <= rtlc_2359_and_1194_nx0 AND rtlcn1670 ;
   rtlc_2410_and_1197_nx0 <= state(5) AND not_timeout ;
   rtlcn1793 <= rtlc_2410_and_1197_nx0 AND RCV_CS ;
   rtlc_2431_and_1198_nx0 <= not_timeout AND not_rtlcn1669 ;
   rtlcn1808 <= rtlc_2431_and_1198_nx0 AND rtlcn1684 ;
   rtlc_2450_and_1200_nx0 <= state(5) AND RCV_Pre_EchoRdy ;
   rtlcn1822 <= rtlc_2450_and_1200_nx0 AND not_RCV_CS ;
   rtlc_2457_or_1202_nx0 <= rtlcn1122 OR rtlcn1806 ;
   rtlcn1555 <= rtlc_2457_or_1202_nx0 OR not_rtlcn236 ;
   rtlc_2479_and_1203_nx0 <= read_ack AND not_rtlcs13 ;
   rtlcn1652 <= rtlc_2479_and_1203_nx0 AND rtlcn1661 ;
   rtlc_2481_and_1204_nx0 <= not_RT2RT_int AND not_Tx_message ;
   rtlcn1831 <= rtlc_2481_and_1204_nx0 AND rtlcn1652 ;
   rtlc_2486_and_1206_nx0 <= read_ack AND rtlcs13 ;
   rtlcn1833 <= rtlc_2486_and_1206_nx0 AND rtlcn1661 ;
   rtlc_2503_and_1209_nx0 <= rtlcn1614 AND RCV_Command_Sync ;
   rtlcn1842 <= rtlc_2503_and_1209_nx0 AND not_rtlcn1685 ;
   rtlc_2521_and_1212_nx0 <= not_RT2RT_int AND rtlcn1661 ;
   rtlcn1850 <= rtlc_2521_and_1212_nx0 AND not_rtlcn1668 ;
   rtlc_2522_or_1213_nx0 <= rtlcn1847 OR rtlcn1848 ;
   rtlcn1484 <= rtlc_2522_or_1213_nx0 OR rtlcn1850 ;
   rtlc_2525_and_1214_nx0 <= state(7) AND not_mode_message_no_data ;
   rtlcn1853 <= rtlc_2525_and_1214_nx0 AND rtlcn1649 ;
   rtlc_2541_and_1215_nx0 <= not_write_ack AND not_rtlcn1660 ;
   rtlcn1863 <= rtlc_2541_and_1215_nx0 AND rtlcn1678 ;
   rtlc_2551_and_1216_nx0 <= rtlc20n6855 AND rtlcn1660 ;
   rtlcn1513 <= rtlc_2551_and_1216_nx0 AND rtlcn1689 ;
   rtlc_2559_and_1217_nx0 <= state(18) AND not_timeout ;
   rtlcn1872 <= rtlc_2559_and_1217_nx0 AND RCV_recieving ;
   rtlc_2567_or_1220_nx0 <= rtlcn1707 OR rtlcn1875 ;
   rtlcn1526 <= rtlc_2567_or_1220_nx0 OR rtlcn1877 ;
   rtlc_2572_or_1221_nx0 <= rtlcn1780 OR rtlcn1878 ;
   rtlcn1709 <= rtlc_2572_or_1221_nx0 OR rtlcn1880 ;
   rtlc_2584_and_1222_nx0 <= not_state_5 AND rtlc20n6914 ;
   rtlcn1888 <= rtlc_2584_and_1222_nx0 AND read_ack ;
   rtlc_2585_or_1223_nx0 <= rtlcn1710 OR not_rtlcn1945 ;
   rtlcn1542 <= rtlc_2585_or_1223_nx0 OR rtlcn1888 ;
   rtlc_2591_and_1224_nx0 <= not_state_3 AND rtlcn1666 ;
   rtlcn1875 <= rtlc_2591_and_1224_nx0 AND rtlcn1708 ;
   rtlc_2958_and_1229_nx0 <= CE AND rtlcn1951 ;
   rtlc20n7192 <= rtlc_2958_and_1229_nx0 AND rtlcn1962 ;
   rtlc_2977_or_1230_nx0 <= not_rtlc20n7196 OR not_rtlcn1953 ;
   rtlcn1946 <= rtlc_2977_or_1230_nx0 OR rtlcn1985 ;
   rtlc_3007_and_1232_nx0 <= CE AND rtlc20n7218 ;
   rtlc20n7137 <= rtlc_3007_and_1232_nx0 AND rtlcn1959 ;
   rtlcn1958 <= rtlcn1697 OR not_state_10 ;
   rtlc_3057_or_1237_nx0 <= rtlc20n5258 OR not_read_ack ;
   rtlcn1963 <= rtlc_3057_or_1237_nx0 OR not_Tx_Rdy ;
   rtlc_3058_or_1238_nx0 <= Set_time_out_to_5us OR Set_time_out_to_echo ;
   rtlcn1957 <= rtlc_3058_or_1238_nx0 OR Set_time_out_to_rcv ;
   rtlcs8 <= rtlc_3181_and_1250_nx0 AND No_Response_timeout(0) ;
   rtlc_3177_and_1249_nx0 <= No_Response_timeout(2) AND 
   No_Response_timeout(1) ;
   rtlcs7 <= rtlc_3177_and_1249_nx0 AND not_No_Response_timeout_0 ;
   rtlc_3181_and_1250_nx0 <= No_Response_timeout(2) AND 
   not_No_Response_timeout_1 ;
   rtlcs9 <= rtlc_3181_and_1250_nx0 AND not_No_Response_timeout_0 ;
   rtlc_3230_and_1252_nx0 <= not_RCV_Gap_found_2 AND not_RCV_Gap_found_1 ;
   rtlcs18 <= rtlc_3230_and_1252_nx0 AND not_RCV_Gap_found_0 ;
   not_rtlc20n6802 <= RCV_Gap_found(2) when rtlc20_2308_gt_1164_nx4
    = '1' else nx5 ;
   nx5 <= RCV_Gap_found(1) when rtlc20_2308_gt_1164_nx2 = '1' else nx8 ;
   nx8 <= RCV_Gap_found(0) AND rtlc20_2308_gt_1164_nx0 ;
   modgen_and_2 : and_4u_4u port map ( a(3)=>rtlcn1649, a(2)=>rtlcn1663, 
      a(1)=>not_rtlcn1669, a(0)=>not_Found_errors, d=>
      Found_wrong_RT_Address_20n83ss1);
   modgen_and_3 : and_3u_3u port map ( a(2)=>RT2RT_int, a(1)=>not_Tx_message, 
      a(0)=>rtlcn1652, d=>rtlcn1470);
   modgen_and_4 : and_6u_6u port map ( a(5)=>active_command_9, a(4)=>
      active_command_8, a(3)=>active_command_7, a(2)=>active_command_6, a(1)
      =>active_command_5, a(0)=>not_BC_1553A, d=>mode_message_no_data_10n2s3
   );
   modgen_and_6 : and_6u_6u port map ( a(5)=>first_command_15, a(4)=>
      first_command_14, a(3)=>first_command_13, a(2)=>first_command_12, a(1)
      =>first_command_11, a(0)=>RT2RT_int, d=>rtlcn1781);
   modgen_and_7 : and_8u_8u port map ( a(7)=>not_word_counter_5, a(6)=>
      not_word_counter_4, a(5)=>not_word_counter_3, a(4)=>not_word_counter_2, 
      a(3)=>not_word_counter_1, a(2)=>not_word_counter_0, a(1)=>Tx_message, 
      a(0)=>rtlc20n5893, d=>rtlc20n5894);
end SITAL_Technology_unfold_3026 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sclear_aclear_clock_clk_en_0_6 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (5 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (5 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sclear_aclear_clock_clk_en_0_6 ;

architecture INTERFACE of counter_up_cnt_en_sclear_aclear_clock_clk_en_0_6
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx17, nx20, nx23, nx24, nx25, nx26, nx27, nx28, nx29, nx30, 
      nx31, nx32, nx33, nx34, nx35, nx36, nx37, nx38, nx39, nx40, PWR, 
      NOT_nx16: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(5) <= nx24 ;
   q(4) <= nx26 ;
   q(3) <= nx28 ;
   q(2) <= nx30 ;
   q(1) <= nx32 ;
   q(0) <= nx34 ;
   GND <= '0' ;
   nx17 <= cnt_en OR sclear ;
   nx20 <= nx17 AND clk_en ;
   DFFPCE (nx23,GND,aclear,nx20,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,nx20,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,nx20,clock,nx28) ;
   DFFPCE (nx29,GND,aclear,nx20,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx20,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx20,clock,nx34) ;
   inc : inc_6u_6u_0_0 port map ( cin=>PWR, a(5)=>nx24, a(4)=>nx26, a(3)=>
      nx28, a(2)=>nx30, a(1)=>nx32, a(0)=>nx34, d(5)=>nx35, d(4)=>nx36, d(3)
      =>nx37, d(2)=>nx38, d(1)=>nx39, d(0)=>nx40, cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx16 <= NOT sclear ;
   nx23 <= nx35 AND NOT_nx16 ;
   nx25 <= nx36 AND NOT_nx16 ;
   nx27 <= nx37 AND NOT_nx16 ;
   nx29 <= nx38 AND NOT_nx16 ;
   nx31 <= nx39 AND NOT_nx16 ;
   nx33 <= nx40 AND NOT_nx16 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_4 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (3 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (3 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_4 ;

architecture INTERFACE of 
   counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_4 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx13, nx16, nx19, nx22, nx23, nx24, nx25, nx26, nx27, nx28, 
      nx29, nx30, nx31, nx32, nx33, PWR, nx37, nx39, nx41, nx43, NOT_nx15: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(3) <= nx23 ;
   q(2) <= nx25 ;
   q(1) <= nx27 ;
   q(0) <= nx29 ;
   GND <= '0' ;
   nx13 <= cnt_en OR sload ;
   nx16 <= nx13 OR sclear ;
   nx19 <= nx16 AND clk_en ;
   DFFPCE (nx22,GND,aclear,nx19,clock,nx23) ;
   DFFPCE (nx24,GND,aclear,nx19,clock,nx25) ;
   DFFPCE (nx26,GND,aclear,nx19,clock,nx27) ;
   DFFPCE (nx28,GND,aclear,nx19,clock,nx29) ;
   inc : inc_4u_4u_0_0 port map ( cin=>PWR, a(3)=>nx23, a(2)=>nx25, a(1)=>
      nx27, a(0)=>nx29, d(3)=>nx30, d(2)=>nx31, d(1)=>nx32, d(0)=>nx33, cout
      =>DANGLING(0));
   PWR <= '1' ;
   nx37 <= data(3) when sload = '1' else nx30 ;
   nx39 <= data(2) when sload = '1' else nx31 ;
   nx41 <= data(1) when sload = '1' else nx32 ;
   nx43 <= data(0) when sload = '1' else nx33 ;
   NOT_nx15 <= NOT sclear ;
   nx22 <= nx37 AND NOT_nx15 ;
   nx24 <= nx39 AND NOT_nx15 ;
   nx26 <= nx41 AND NOT_nx15 ;
   nx28 <= nx43 AND NOT_nx15 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_up_cnt_en_sclear_aclear_clock_clk_en_0_9 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (8 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (8 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_up_cnt_en_sclear_aclear_clock_clk_en_0_9 ;

architecture INTERFACE of counter_up_cnt_en_sclear_aclear_clock_clk_en_0_9
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_9u_9u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic_vector (8 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx23, nx26, nx29, nx30, nx31, nx32, nx33, nx34, nx35, nx36, 
      nx37, nx38, nx39, nx40, nx41, nx42, nx43, nx44, nx45, nx46, nx47, nx48, 
      nx49, nx50, nx51, nx52, nx53, nx54, nx55, PWR, NOT_nx22: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(8) <= nx30 ;
   q(7) <= nx32 ;
   q(6) <= nx34 ;
   q(5) <= nx36 ;
   q(4) <= nx38 ;
   q(3) <= nx40 ;
   q(2) <= nx42 ;
   q(1) <= nx44 ;
   q(0) <= nx46 ;
   GND <= '0' ;
   nx23 <= cnt_en OR sclear ;
   nx26 <= nx23 AND clk_en ;
   DFFPCE (nx29,GND,aclear,nx26,clock,nx30) ;
   DFFPCE (nx31,GND,aclear,nx26,clock,nx32) ;
   DFFPCE (nx33,GND,aclear,nx26,clock,nx34) ;
   DFFPCE (nx35,GND,aclear,nx26,clock,nx36) ;
   DFFPCE (nx37,GND,aclear,nx26,clock,nx38) ;
   DFFPCE (nx39,GND,aclear,nx26,clock,nx40) ;
   DFFPCE (nx41,GND,aclear,nx26,clock,nx42) ;
   DFFPCE (nx43,GND,aclear,nx26,clock,nx44) ;
   DFFPCE (nx45,GND,aclear,nx26,clock,nx46) ;
   inc : inc_9u_9u_0_0 port map ( cin=>PWR, a(8)=>nx30, a(7)=>nx32, a(6)=>
      nx34, a(5)=>nx36, a(4)=>nx38, a(3)=>nx40, a(2)=>nx42, a(1)=>nx44, a(0)
      =>nx46, d(8)=>nx47, d(7)=>nx48, d(6)=>nx49, d(5)=>nx50, d(4)=>nx51, 
      d(3)=>nx52, d(2)=>nx53, d(1)=>nx54, d(0)=>nx55, cout=>DANGLING(0));
   PWR <= '1' ;
   NOT_nx22 <= NOT sclear ;
   nx29 <= nx47 AND NOT_nx22 ;
   nx31 <= nx48 AND NOT_nx22 ;
   nx33 <= nx49 AND NOT_nx22 ;
   nx35 <= nx50 AND NOT_nx22 ;
   nx37 <= nx51 AND NOT_nx22 ;
   nx39 <= nx52 AND NOT_nx22 ;
   nx41 <= nx53 AND NOT_nx22 ;
   nx43 <= nx54 AND NOT_nx22 ;
   nx45 <= nx55 AND NOT_nx22 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Monitor_Word_DDC_8_4_32 is 
   port (
      A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      A_Sync_error : IN std_logic ;
      A_Manchester_error : IN std_logic ;
      A_Parity_error : IN std_logic ;
      A_echo_back_bus : IN std_logic ;
      A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      A_RxRDY_plus_12us : IN std_logic ;
      A_RxRDY_plus_10us : IN std_logic ;
      A_CS : IN std_logic ;
      A_Pre_EchoRdy : IN std_logic ;
      A_Command_Sync : IN std_logic ;
      A_Pre_RxRdy : IN std_logic ;
      A_recieving : IN std_logic ;
      Ack : IN std_logic ;
      B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
      B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
      B_Sync_error : IN std_logic ;
      B_Manchester_error : IN std_logic ;
      B_Parity_error : IN std_logic ;
      B_echo_back_bus : IN std_logic ;
      B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
      B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
      B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
      B_RxRDY_plus_12us : IN std_logic ;
      B_RxRDY_plus_10us : IN std_logic ;
      B_CS : IN std_logic ;
      B_Pre_EchoRdy : IN std_logic ;
      B_Command_Sync : IN std_logic ;
      B_Pre_RxRdy : IN std_logic ;
      B_recieving : IN std_logic ;
      C : IN std_logic ;
      CE : IN std_logic ;
      R : IN std_logic ;
      Descriptor : OUT std_logic_vector (15 DOWNTO 0) ;
      Req : OUT std_logic ;
      Word : OUT std_logic_vector (15 DOWNTO 0)) ;
end Monitor_Word_DDC_8_4_32 ;

architecture Sital_OH_unfold_3180 of Monitor_Word_DDC_8_4_32 is 
   component and_9u_9u
      port (
         a : IN std_logic_vector (8 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_6
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (5 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (5 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_4
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (3 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_up_cnt_en_sclear_aclear_clock_clk_en_0_9
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (8 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (8 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component sub_4u_4u_4u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal BusA: std_logic ;
   
   signal D_BusA: std_logic_vector (15 DOWNTO 0) ;
   
   signal D_BusB: std_logic_vector (15 DOWNTO 0) ;
   
   signal Descriptor_A_15, Descriptor_A_14, Descriptor_A_13, Descriptor_A_12, 
      Descriptor_A_11, Descriptor_A_10, Descriptor_A_9, Descriptor_A_8, 
      Descriptor_A_7, Descriptor_6_EXMPLR2533, Descriptor_A_5, 
      Descriptor_A_4, Descriptor_A_3, Descriptor_A_1, Descriptor_A_0, 
      Descriptor_B_15, Descriptor_B_14, Descriptor_B_13, Descriptor_B_12, 
      Descriptor_B_11, Descriptor_B_10, Descriptor_B_9, Descriptor_B_8, 
      Descriptor_B_5, Descriptor_B_4, Descriptor_B_3, Descriptor_B_2, 
      Descriptor_B_1, Descriptor_B_0, Grant_A, Grant_B: std_logic ;
   
   signal Half_us_counter: std_logic_vector (3 DOWNTO 0) ;
   
   signal Req_A, Req_B: std_logic ;
   
   signal Timeout: std_logic_vector (5 DOWNTO 0) ;
   
   signal Timer: std_logic_vector (8 DOWNTO 0) ;
   
   signal Timer_minus_40_7, Timer_minus_40_6, Timer_minus_40_5, 
      Timer_minus_40_4: std_logic ;
   
   signal state: std_logic_vector (5 DOWNTO 0) ;
   
   signal PWR, not_R, Descriptor_3n6ss1_15, Descriptor_3n6ss1_14, 
      Descriptor_3n6ss1_13, Descriptor_3n6ss1_12, Descriptor_3n6ss1_11, 
      Descriptor_3n6ss1_10, Descriptor_3n6ss1_9, Descriptor_3n6ss1_8, 
      Descriptor_3n6ss1_7, Descriptor_3n6ss1_5, Descriptor_3n6ss1_4, 
      Descriptor_3n6ss1_3, Descriptor_3n6ss1_2, Descriptor_3n6ss1_1, 
      Descriptor_3n6ss1_0, Req_3n6ss1: std_logic ;
   
   signal Word_3n6ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal state_fsm_3n7ss1_4, state_fsm_3n7ss1_2, not_Ack, rtlc3n337, 
      rtlc3n399, rtlc3n452, rtlc6n60, not_rtlcs1, not_rtlc6n60, 
      rtlc6_X_0_n170, rtlc6n216, not_rtlc6n216, rtlc6n323, not_rtlc6n323, 
      rtlc9n42, rtlc9n61: std_logic ;
   
   signal Descriptor_A_12n4ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal Descriptor_A_12n5ss1_7, Descriptor_A_12n5ss1_6, 
      Descriptor_A_12n5ss1_5, Descriptor_A_12n5ss1_4, Descriptor_A_12n5ss1_3
   : std_logic ;
   
   signal Descriptor_A_12n6ss1: std_logic_vector (8 DOWNTO 1) ;
   
   signal rtlc12n130, rtlc12n144, rtlc12n146, not_rtlc12n146, not_A_CS, 
      Descriptor_A_5_12n7s6, not_Descriptor_A_5_12n7s6, rtlc12n276, 
      rtlc12n277, rtlc12n299, not_rtlcn42, rtlc12n349, rtlc12n350, 
      rtlc12n351, rtlc12n352, rtlc12n353, Descriptor_B_15n5ss1_7, 
      Descriptor_B_15n5ss1_6, Descriptor_B_15n5ss1_5, Descriptor_B_15n5ss1_4, 
      Descriptor_B_15n5ss1_3: std_logic ;
   
   signal Descriptor_B_15n6ss1: std_logic_vector (8 DOWNTO 1) ;
   
   signal rtlc15n131, rtlc15n145, rtlc15n147, not_rtlc15n147, not_B_CS, 
      Descriptor_B_5_15n7s6, not_Descriptor_B_5_15n7s6, rtlc15n278, 
      rtlc15n279, rtlc15n301, not_rtlcn43, rtlcn42, rtlcn43, rtlcn71, 
      rtlcn84, rtlcn111, rtlcn129, rtlcn130, not_rtlc3n452, rtlcn132, 
      rtlcn134, rtlcn135, not_Req_A, not_Req_B, rtlcn138, rtlcn139, rtlcn140, 
      not_B_Pre_RxRdy, rtlcn157, rtlcn158, rtlcs1, rtlcs2, rtlcs3, rtlcs5, 
      rtlcs6, rtlcs8, rtlcs9, not_B_R_Data_9, not_B_R_Data_8, not_B_R_Data_7, 
      not_B_R_Data_6, not_B_R_Data_5, not_A_R_Data_9, not_A_R_Data_8, 
      not_A_R_Data_7, not_A_R_Data_6, not_A_R_Data_5, not_A_Pre_RxRdy, 
      rtlcn212, rtlcn213, rtlcn214, rtlcn215, rtlcn216, rtlcn217, rtlcn218, 
      rtlcn219, rtlcn220, rtlcn221, not_Timeout_5, not_Timeout_4, 
      not_Timeout_3, not_Timeout_2, not_Timeout_1, not_Timeout_0, rtlcn229, 
      rtlc6_48_and_1257_nx0, rtlc_287_and_1261_nx0, rtlc_292_and_1262_nx0, 
      rtlc_297_and_1263_nx0, rtlc_298_and_1264_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (15 downto 0 );

begin
   Descriptor(6) <= Descriptor_6_EXMPLR2533 ;
   Descriptor_6_EXMPLR2533 <= '0' ;
   PWR <= '1' ;
   rtlc3n337 <= state(1) OR state(3) ;
   rtlc3n452 <= Timeout(4) AND Timeout(5) ;
   not_rtlcs1 <= NOT rtlcs1 ;
   rtlc6n216 <= rtlc6n323 OR not_rtlcs1 ;
   not_rtlc6n216 <= NOT rtlc6n216 ;
   not_rtlc6n60 <= NOT rtlc6n60 ;
   rtlc6n60 <= A_Pre_RxRdy OR B_Pre_RxRdy ;
   rtlc6_100_and_1258 : and_9u_9u port map ( a(8)=>Timer(8), a(7)=>Timer(7), 
      a(6)=>Timer(6), a(5)=>Timer(5), a(4)=>Timer(4), a(3)=>Timer(3), a(2)=>
      Timer(2), a(1)=>Timer(1), a(0)=>Timer(0), d=>rtlc6n323);
   not_rtlc6n323 <= NOT rtlc6n323 ;
   rtlc9n42 <= rtlcs3 OR rtlcs2 ;
   rtlc12n144 <= rtlcs6 OR rtlcs5 ;
   rtlc12n146 <= A_Command_Sync AND rtlc12n144 ;
   rtlc12n130 <= A_Pre_RxRdy OR A_Pre_EchoRdy ;
   rtlc12n299 <= A_GAP(1) AND A_GAP(0) ;
   rtlc12n351 <= rtlc12n350 AND Timer(5) ;
   rtlc12n352 <= rtlc12n349 OR rtlc12n351 ;
   rtlc12n353 <= Timer(8) AND rtlc12n352 ;
   rtlc15n145 <= rtlcs9 OR rtlcs8 ;
   rtlc15n147 <= B_Command_Sync AND rtlc15n145 ;
   rtlc15n131 <= B_Pre_RxRdy OR B_Pre_EchoRdy ;
   rtlc15n301 <= B_GAP(1) AND B_GAP(0) ;
   rtlc12n349 <= Timer(7) OR Timer(6) ;
   rtlc12n350 <= Timer(4) OR Timer(3) ;
   not_Ack <= NOT Ack ;
   not_R <= NOT R ;
   not_rtlc12n146 <= NOT rtlc12n146 ;
   not_rtlcn42 <= NOT rtlcn42 ;
   not_A_CS <= NOT A_CS ;
   not_Descriptor_A_5_12n7s6 <= NOT Descriptor_A_5_12n7s6 ;
   not_rtlc15n147 <= NOT rtlc15n147 ;
   not_rtlcn43 <= NOT rtlcn43 ;
   not_B_CS <= NOT B_CS ;
   not_Descriptor_B_5_15n7s6 <= NOT Descriptor_B_5_15n7s6 ;
   not_rtlc3n452 <= NOT rtlc3n452 ;
   rtlcn130 <= state(0) AND not_rtlc3n452 ;
   rtlcn132 <= Req_A AND rtlcn130 ;
   rtlcn71 <= rtlcn132 OR rtlcn134 ;
   rtlcn135 <= not_rtlc3n452 AND state(5) ;
   not_Req_A <= NOT Req_A ;
   not_Req_B <= NOT Req_B ;
   rtlcn84 <= rtlcn135 OR rtlcn138 ;
   rtlcn111 <= rtlcn139 OR rtlcn140 ;
   not_B_Pre_RxRdy <= NOT B_Pre_RxRdy ;
   Descriptor_3n6ss1_0 <= Descriptor_B_0 when state(3) = '1' else 
   Descriptor_A_0 ;
   Descriptor_3n6ss1_1 <= Descriptor_B_1 when state(3) = '1' else 
   Descriptor_A_1 ;
   Descriptor_3n6ss1_3 <= Descriptor_B_3 when state(3) = '1' else 
   Descriptor_A_3 ;
   Descriptor_3n6ss1_4 <= Descriptor_B_4 when state(3) = '1' else 
   Descriptor_A_4 ;
   Descriptor_3n6ss1_5 <= Descriptor_B_5 when state(3) = '1' else 
   Descriptor_A_5 ;
   Descriptor_3n6ss1_7 <= Descriptor_B_2 when state(3) = '1' else 
   Descriptor_A_7 ;
   Descriptor_3n6ss1_8 <= Descriptor_B_8 when state(3) = '1' else 
   Descriptor_A_8 ;
   Descriptor_3n6ss1_9 <= Descriptor_B_9 when state(3) = '1' else 
   Descriptor_A_9 ;
   Descriptor_3n6ss1_10 <= Descriptor_B_10 when state(3) = '1' else 
   Descriptor_A_10 ;
   Descriptor_3n6ss1_11 <= Descriptor_B_11 when state(3) = '1' else 
   Descriptor_A_11 ;
   Descriptor_3n6ss1_12 <= Descriptor_B_12 when state(3) = '1' else 
   Descriptor_A_12 ;
   Descriptor_3n6ss1_13 <= Descriptor_B_13 when state(3) = '1' else 
   Descriptor_A_13 ;
   Descriptor_3n6ss1_14 <= Descriptor_B_14 when state(3) = '1' else 
   Descriptor_A_14 ;
   Descriptor_3n6ss1_15 <= Descriptor_B_15 when state(3) = '1' else 
   Descriptor_A_15 ;
   Word_3n6ss1(0) <= D_BusB(0) when state(3) = '1' else D_BusA(0) ;
   Word_3n6ss1(1) <= D_BusB(1) when state(3) = '1' else D_BusA(1) ;
   Word_3n6ss1(2) <= D_BusB(2) when state(3) = '1' else D_BusA(2) ;
   Word_3n6ss1(3) <= D_BusB(3) when state(3) = '1' else D_BusA(3) ;
   Word_3n6ss1(4) <= D_BusB(4) when state(3) = '1' else D_BusA(4) ;
   Word_3n6ss1(5) <= D_BusB(5) when state(3) = '1' else D_BusA(5) ;
   Word_3n6ss1(6) <= D_BusB(6) when state(3) = '1' else D_BusA(6) ;
   Word_3n6ss1(7) <= D_BusB(7) when state(3) = '1' else D_BusA(7) ;
   Word_3n6ss1(8) <= D_BusB(8) when state(3) = '1' else D_BusA(8) ;
   Word_3n6ss1(9) <= D_BusB(9) when state(3) = '1' else D_BusA(9) ;
   Word_3n6ss1(10) <= D_BusB(10) when state(3) = '1' else D_BusA(10) ;
   Word_3n6ss1(11) <= D_BusB(11) when state(3) = '1' else D_BusA(11) ;
   Word_3n6ss1(12) <= D_BusB(12) when state(3) = '1' else D_BusA(12) ;
   Word_3n6ss1(13) <= D_BusB(13) when state(3) = '1' else D_BusA(13) ;
   Word_3n6ss1(14) <= D_BusB(14) when state(3) = '1' else D_BusA(14) ;
   Word_3n6ss1(15) <= D_BusB(15) when state(3) = '1' else D_BusA(15) ;
   rtlcn213 <= Timer_minus_40_4 when BusA = '1' else Timer(4) ;
   rtlcn214 <= Timer_minus_40_5 when BusA = '1' else Timer(5) ;
   rtlcn215 <= Timer_minus_40_6 when BusA = '1' else Timer(6) ;
   rtlcn216 <= Timer_minus_40_7 when BusA = '1' else Timer(7) ;
   rtlcn218 <= Timer(4) when BusA = '1' else Timer_minus_40_4 ;
   rtlcn219 <= Timer(5) when BusA = '1' else Timer_minus_40_5 ;
   rtlcn220 <= Timer(6) when BusA = '1' else Timer_minus_40_6 ;
   rtlcn221 <= Timer(7) when BusA = '1' else Timer_minus_40_7 ;
   rtlc3n399 <= CE AND rtlc3n337 ;
   rtlc9n61 <= CE AND rtlc9n42 ;
   rtlcn157 <= Grant_A OR rtlc12n130 ;
   rtlc12n277 <= CE AND rtlcn157 ;
   rtlc12n276 <= CE AND rtlc12n130 ;
   rtlcn158 <= Grant_B OR rtlc15n131 ;
   rtlc15n279 <= CE AND rtlcn158 ;
   rtlc15n278 <= CE AND rtlc15n131 ;
   rtlc_533_and_1266 : and_5u_5u port map ( a(4)=>B_R_Data(9), a(3)=>
      B_R_Data(8), a(2)=>B_R_Data(7), a(1)=>B_R_Data(6), a(0)=>B_R_Data(5), 
      d=>rtlcs9);
   not_B_R_Data_9 <= NOT B_R_Data(9) ;
   not_B_R_Data_8 <= NOT B_R_Data(8) ;
   not_B_R_Data_7 <= NOT B_R_Data(7) ;
   not_B_R_Data_6 <= NOT B_R_Data(6) ;
   not_B_R_Data_5 <= NOT B_R_Data(5) ;
   rtlc_539_and_1267 : and_5u_5u port map ( a(4)=>not_B_R_Data_9, a(3)=>
      not_B_R_Data_8, a(2)=>not_B_R_Data_7, a(1)=>not_B_R_Data_6, a(0)=>
      not_B_R_Data_5, d=>rtlcs8);
   rtlc_542_and_1268 : and_5u_5u port map ( a(4)=>A_R_Data(9), a(3)=>
      A_R_Data(8), a(2)=>A_R_Data(7), a(1)=>A_R_Data(6), a(0)=>A_R_Data(5), 
      d=>rtlcs6);
   not_A_R_Data_9 <= NOT A_R_Data(9) ;
   not_A_R_Data_8 <= NOT A_R_Data(8) ;
   not_A_R_Data_7 <= NOT A_R_Data(7) ;
   not_A_R_Data_6 <= NOT A_R_Data(6) ;
   not_A_R_Data_5 <= NOT A_R_Data(5) ;
   rtlc_548_and_1269 : and_5u_5u port map ( a(4)=>not_A_R_Data_9, a(3)=>
      not_A_R_Data_8, a(2)=>not_A_R_Data_7, a(1)=>not_A_R_Data_6, a(0)=>
      not_A_R_Data_5, d=>rtlcs5);
   Descriptor_3n6ss1_2 <= Descriptor_B_2 AND state(3) ;
   rtlc_574_and_1272 : and_4u_4u port map ( a(3)=>Half_us_counter(3), a(2)=>
      Half_us_counter(2), a(1)=>Half_us_counter(1), a(0)=>Half_us_counter(0), 
      d=>rtlcs1);
   Descriptor_A_12n4ss1(0) <= Timer(0) OR rtlc12n353 ;
   rtlcs3 <= A_Pre_RxRdy AND not_B_Pre_RxRdy ;
   not_A_Pre_RxRdy <= NOT A_Pre_RxRdy ;
   rtlcs2 <= not_A_Pre_RxRdy AND B_Pre_RxRdy ;
   Descriptor_B_15n6ss1(1) <= Descriptor_A_12n4ss1(0) AND rtlcn43 ;
   Descriptor_A_12n6ss1(1) <= Descriptor_A_12n4ss1(0) AND rtlcn42 ;
   Descriptor_A_12n4ss1(1) <= Timer(1) OR rtlc12n353 ;
   Descriptor_B_15n6ss1(2) <= Descriptor_A_12n4ss1(1) AND rtlcn43 ;
   Descriptor_A_12n6ss1(2) <= Descriptor_A_12n4ss1(1) AND rtlcn42 ;
   Descriptor_A_12n4ss1(2) <= Timer(2) OR rtlc12n353 ;
   Descriptor_B_15n6ss1(3) <= Descriptor_A_12n4ss1(2) AND rtlcn43 ;
   Descriptor_A_12n6ss1(3) <= Descriptor_A_12n4ss1(2) AND rtlcn42 ;
   Descriptor_B_15n6ss1(4) <= Descriptor_B_15n5ss1_3 AND rtlcn43 ;
   Descriptor_A_12n6ss1(4) <= Descriptor_A_12n5ss1_3 AND rtlcn42 ;
   Descriptor_B_15n6ss1(5) <= Descriptor_B_15n5ss1_4 AND rtlcn43 ;
   Descriptor_A_12n6ss1(5) <= Descriptor_A_12n5ss1_4 AND rtlcn42 ;
   Descriptor_B_15n6ss1(6) <= Descriptor_B_15n5ss1_5 AND rtlcn43 ;
   Descriptor_A_12n6ss1(6) <= Descriptor_A_12n5ss1_5 AND rtlcn42 ;
   Descriptor_B_15n6ss1(7) <= Descriptor_B_15n5ss1_6 AND rtlcn43 ;
   Descriptor_A_12n6ss1(7) <= Descriptor_A_12n5ss1_6 AND rtlcn42 ;
   Descriptor_B_15n6ss1(8) <= Descriptor_B_15n5ss1_7 AND rtlcn43 ;
   Descriptor_A_12n6ss1(8) <= Descriptor_A_12n5ss1_7 AND rtlcn42 ;
   Req_3n6ss1 <= not_Ack AND rtlc3n337 ;
   Descriptor_A_12n5ss1_3 <= rtlc12n353 OR rtlcn212 ;
   Descriptor_A_12n5ss1_4 <= rtlc12n353 OR rtlcn213 ;
   Descriptor_A_12n5ss1_5 <= rtlc12n353 OR rtlcn214 ;
   Descriptor_A_12n5ss1_6 <= rtlc12n353 OR rtlcn215 ;
   Descriptor_A_12n5ss1_7 <= rtlc12n353 OR rtlcn216 ;
   Descriptor_B_15n5ss1_3 <= rtlc12n353 OR rtlcn217 ;
   Descriptor_B_15n5ss1_4 <= rtlc12n353 OR rtlcn218 ;
   Descriptor_B_15n5ss1_5 <= rtlc12n353 OR rtlcn219 ;
   Descriptor_B_15n5ss1_6 <= rtlc12n353 OR rtlcn220 ;
   Descriptor_B_15n5ss1_7 <= rtlc12n353 OR rtlcn221 ;
   not_Timeout_5 <= NOT Timeout(5) ;
   not_Timeout_4 <= NOT Timeout(4) ;
   not_Timeout_3 <= NOT Timeout(3) ;
   not_Timeout_2 <= NOT Timeout(2) ;
   not_Timeout_1 <= NOT Timeout(1) ;
   not_Timeout_0 <= NOT Timeout(0) ;
   modgen_counter_Timeout : counter_up_cnt_en_sclear_aclear_clock_clk_en_0_6
       port map ( clock=>C, q(5)=>Timeout(5), q(4)=>Timeout(4), q(3)=>
      Timeout(3), q(2)=>Timeout(2), q(1)=>Timeout(1), q(0)=>Timeout(0), 
      clk_en=>CE, aclear=>not_R, sload=>Descriptor_6_EXMPLR2533, data(5)=>
      DANGLING(0), data(4)=>DANGLING(1), data(3)=>DANGLING(2), data(2)=>
      DANGLING(3), data(1)=>DANGLING(4), data(0)=>DANGLING(5), aset=>
      Descriptor_6_EXMPLR2533, sclear=>state(0), updn=>PWR, cnt_en=>rtlcn229
   );
   modgen_counter_Half_us_counter : 
      counter_up_cnt_en_sload_sclear_aclear_clock_clk_en_0_4 port map ( 
      clock=>C, q(3)=>Half_us_counter(3), q(2)=>Half_us_counter(2), q(1)=>
      Half_us_counter(1), q(0)=>Half_us_counter(0), clk_en=>CE, aclear=>
      not_R, sload=>rtlc6n60, data(3)=>Descriptor_6_EXMPLR2533, data(2)=>PWR, 
      data(1)=>PWR, data(0)=>PWR, aset=>Descriptor_6_EXMPLR2533, sclear=>
      rtlc6_X_0_n170, updn=>PWR, cnt_en=>not_rtlc6n323);
   modgen_counter_Timer : counter_up_cnt_en_sclear_aclear_clock_clk_en_0_9
       port map ( clock=>C, q(8)=>Timer(8), q(7)=>Timer(7), q(6)=>Timer(6), 
      q(5)=>Timer(5), q(4)=>Timer(4), q(3)=>Timer(3), q(2)=>Timer(2), q(1)=>
      Timer(1), q(0)=>Timer(0), clk_en=>CE, aclear=>not_R, sload=>
      Descriptor_6_EXMPLR2533, data(8)=>DANGLING(6), data(7)=>DANGLING(7), 
      data(6)=>DANGLING(8), data(5)=>DANGLING(9), data(4)=>DANGLING(10), 
      data(3)=>DANGLING(11), data(2)=>DANGLING(12), data(1)=>DANGLING(13), 
      data(0)=>DANGLING(14), aset=>Descriptor_6_EXMPLR2533, sclear=>rtlc6n60, 
      updn=>PWR, cnt_en=>not_rtlc6n216);
   DFFPCE (rtlcn129,Descriptor_6_EXMPLR2533,not_R,CE,C,state(5)) ;
   DFFPCE (state_fsm_3n7ss1_4,Descriptor_6_EXMPLR2533,not_R,CE,C,state(4)) ;
   DFFPCE (rtlcn111,Descriptor_6_EXMPLR2533,not_R,CE,C,state(3)) ;
   DFFPCE (state_fsm_3n7ss1_2,Descriptor_6_EXMPLR2533,not_R,CE,C,state(2)) ;
   DFFPCE (rtlcn71,Descriptor_6_EXMPLR2533,not_R,CE,C,state(1)) ;
   DFFPCE (rtlcn84,not_R,Descriptor_6_EXMPLR2533,CE,C,state(0)) ;
   DFFPCE (Word_3n6ss1(15),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(15)) ;
   DFFPCE (Word_3n6ss1(14),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(14)) ;
   DFFPCE (Word_3n6ss1(13),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(13)) ;
   DFFPCE (Word_3n6ss1(12),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(12)) ;
   DFFPCE (Word_3n6ss1(11),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(11)) ;
   DFFPCE (Word_3n6ss1(10),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Word(10)) ;
   DFFPCE (Word_3n6ss1(9),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(9))
    ;
   DFFPCE (Word_3n6ss1(8),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(8))
    ;
   DFFPCE (Word_3n6ss1(7),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(7))
    ;
   DFFPCE (Word_3n6ss1(6),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(6))
    ;
   DFFPCE (Word_3n6ss1(5),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(5))
    ;
   DFFPCE (Word_3n6ss1(4),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(4))
    ;
   DFFPCE (Word_3n6ss1(3),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(3))
    ;
   DFFPCE (Word_3n6ss1(2),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(2))
    ;
   DFFPCE (Word_3n6ss1(1),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(1))
    ;
   DFFPCE (Word_3n6ss1(0),Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,Word(0))
    ;
   DFFPCE (Req_3n6ss1,Descriptor_6_EXMPLR2533,not_R,CE,C,Req) ;
   DFFPCE (state(4),Descriptor_6_EXMPLR2533,not_R,CE,C,Grant_B) ;
   DFFPCE (state(2),Descriptor_6_EXMPLR2533,not_R,CE,C,Grant_A) ;
   DFFPCE (Descriptor_3n6ss1_15,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(15)) ;
   DFFPCE (Descriptor_3n6ss1_14,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(14)) ;
   DFFPCE (Descriptor_3n6ss1_13,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(13)) ;
   DFFPCE (Descriptor_3n6ss1_12,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(12)) ;
   DFFPCE (Descriptor_3n6ss1_11,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(11)) ;
   DFFPCE (Descriptor_3n6ss1_10,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(10)) ;
   DFFPCE (Descriptor_3n6ss1_9,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(9)) ;
   DFFPCE (Descriptor_3n6ss1_8,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(8)) ;
   DFFPCE (Descriptor_3n6ss1_7,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(7)) ;
   DFFPCE (Descriptor_3n6ss1_5,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(5)) ;
   DFFPCE (Descriptor_3n6ss1_4,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(4)) ;
   DFFPCE (Descriptor_3n6ss1_3,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(3)) ;
   DFFPCE (Descriptor_3n6ss1_2,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(2)) ;
   DFFPCE (Descriptor_3n6ss1_1,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(1)) ;
   DFFPCE (Descriptor_3n6ss1_0,Descriptor_6_EXMPLR2533,not_R,rtlc3n399,C,
   Descriptor(0)) ;
   DFFPCE (not_B_Pre_RxRdy,Descriptor_6_EXMPLR2533,not_R,rtlc9n61,C,BusA) ;
   DFFPCE (rtlc12n130,Descriptor_6_EXMPLR2533,not_R,rtlc12n277,C,Req_A) ;
   DFFPCE (Descriptor_A_12n6ss1(8),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_15) ;
   DFFPCE (Descriptor_A_12n6ss1(7),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_14) ;
   DFFPCE (Descriptor_A_12n6ss1(6),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_13) ;
   DFFPCE (Descriptor_A_12n6ss1(5),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_12) ;
   DFFPCE (Descriptor_A_12n6ss1(4),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_11) ;
   DFFPCE (Descriptor_A_12n6ss1(3),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_10) ;
   DFFPCE (Descriptor_A_12n6ss1(2),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_9) ;
   DFFPCE (Descriptor_A_12n6ss1(1),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,
   C,Descriptor_A_8) ;
   DFFPCE (PWR,Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,Descriptor_A_7) ;
   DFFPCE (not_Descriptor_A_5_12n7s6,Descriptor_6_EXMPLR2533,not_R,
   rtlc12n276,C,Descriptor_A_5) ;
   DFFPCE (not_A_CS,Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   Descriptor_A_4) ;
   DFFPCE (A_Command_Sync,Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   Descriptor_A_3) ;
   DFFPCE (not_rtlcn42,Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   Descriptor_A_1) ;
   DFFPCE (not_rtlc12n146,Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   Descriptor_A_0) ;
   DFFPCE (A_R_Data(15),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(15)) ;
   DFFPCE (A_R_Data(14),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(14)) ;
   DFFPCE (A_R_Data(13),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(13)) ;
   DFFPCE (A_R_Data(12),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(12)) ;
   DFFPCE (A_R_Data(11),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(11)) ;
   DFFPCE (A_R_Data(10),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,
   D_BusA(10)) ;
   DFFPCE (A_R_Data(9),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(9))
    ;
   DFFPCE (A_R_Data(8),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(8))
    ;
   DFFPCE (A_R_Data(7),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(7))
    ;
   DFFPCE (A_R_Data(6),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(6))
    ;
   DFFPCE (A_R_Data(5),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(5))
    ;
   DFFPCE (A_R_Data(4),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(4))
    ;
   DFFPCE (A_R_Data(3),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(3))
    ;
   DFFPCE (A_R_Data(2),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(2))
    ;
   DFFPCE (A_R_Data(1),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(1))
    ;
   DFFPCE (A_R_Data(0),Descriptor_6_EXMPLR2533,not_R,rtlc12n276,C,D_BusA(0))
    ;
   DFFPCE (rtlc15n131,Descriptor_6_EXMPLR2533,not_R,rtlc15n279,C,Req_B) ;
   DFFPCE (Descriptor_B_15n6ss1(8),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_15) ;
   DFFPCE (Descriptor_B_15n6ss1(7),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_14) ;
   DFFPCE (Descriptor_B_15n6ss1(6),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_13) ;
   DFFPCE (Descriptor_B_15n6ss1(5),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_12) ;
   DFFPCE (Descriptor_B_15n6ss1(4),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_11) ;
   DFFPCE (Descriptor_B_15n6ss1(3),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_10) ;
   DFFPCE (Descriptor_B_15n6ss1(2),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_9) ;
   DFFPCE (Descriptor_B_15n6ss1(1),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,
   C,Descriptor_B_8) ;
   DFFPCE (not_Descriptor_B_5_15n7s6,Descriptor_6_EXMPLR2533,not_R,
   rtlc15n278,C,Descriptor_B_5) ;
   DFFPCE (not_B_CS,Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   Descriptor_B_4) ;
   DFFPCE (B_Command_Sync,Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   Descriptor_B_3) ;
   DFFPCE (PWR,Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,Descriptor_B_2) ;
   DFFPCE (not_rtlcn43,Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   Descriptor_B_1) ;
   DFFPCE (not_rtlc15n147,Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   Descriptor_B_0) ;
   DFFPCE (B_R_Data(15),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(15)) ;
   DFFPCE (B_R_Data(14),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(14)) ;
   DFFPCE (B_R_Data(13),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(13)) ;
   DFFPCE (B_R_Data(12),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(12)) ;
   DFFPCE (B_R_Data(11),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(11)) ;
   DFFPCE (B_R_Data(10),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,
   D_BusB(10)) ;
   DFFPCE (B_R_Data(9),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(9))
    ;
   DFFPCE (B_R_Data(8),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(8))
    ;
   DFFPCE (B_R_Data(7),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(7))
    ;
   DFFPCE (B_R_Data(6),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(6))
    ;
   DFFPCE (B_R_Data(5),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(5))
    ;
   DFFPCE (B_R_Data(4),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(4))
    ;
   DFFPCE (B_R_Data(3),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(3))
    ;
   DFFPCE (B_R_Data(2),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(2))
    ;
   DFFPCE (B_R_Data(1),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(1))
    ;
   DFFPCE (B_R_Data(0),Descriptor_6_EXMPLR2533,not_R,rtlc15n278,C,D_BusB(0))
    ;
   rtlc6_48_and_1257_nx0 <= rtlcs1 AND not_rtlc6n323 ;
   rtlc6_X_0_n170 <= rtlc6_48_and_1257_nx0 AND not_rtlc6n60 ;
   rtlc_287_and_1261_nx0 <= not_Ack AND not_rtlc3n452 ;
   rtlcn134 <= rtlc_287_and_1261_nx0 AND state(1) ;
   rtlc_292_and_1262_nx0 <= not_Req_A AND not_Req_B ;
   rtlcn138 <= rtlc_292_and_1262_nx0 AND rtlcn130 ;
   rtlc_297_and_1263_nx0 <= not_Ack AND state(3) ;
   rtlcn139 <= rtlc_297_and_1263_nx0 AND not_rtlc3n452 ;
   rtlc_298_and_1264_nx0 <= not_Req_A AND Req_B ;
   rtlcn140 <= rtlc_298_and_1264_nx0 AND rtlcn130 ;
   Timer_minus_40_sub5_0 : sub_4u_4u_4u_0 port map ( cin=>Timer(3), a(3)=>
      Timer(7), a(2)=>Timer(6), a(1)=>Timer(5), a(0)=>Timer(4), b(3)=>
      Descriptor_6_EXMPLR2533, b(2)=>Descriptor_6_EXMPLR2533, b(1)=>PWR, 
      b(0)=>Descriptor_6_EXMPLR2533, d(3)=>Timer_minus_40_7, d(2)=>
      Timer_minus_40_6, d(1)=>Timer_minus_40_5, d(0)=>Timer_minus_40_4, cout
      =>DANGLING(15));
   rtlcn212 <= Timer(3) XOR BusA ;
   rtlcn217 <= NOT (Timer(3) XOR BusA) ;
   modgen_and_0 : and_3u_3u port map ( a(2)=>not_rtlc3n452, a(1)=>state(1), 
      a(0)=>Ack, d=>state_fsm_3n7ss1_2);
   modgen_and_1 : and_3u_3u port map ( a(2)=>state(3), a(1)=>not_rtlc3n452, 
      a(0)=>Ack, d=>state_fsm_3n7ss1_4);
   modgen_or_2 : or_6u_6u port map ( a(5)=>not_Timeout_3, a(4)=>
      not_Timeout_2, a(3)=>not_Timeout_5, a(2)=>not_Timeout_4, a(1)=>
      not_Timeout_1, a(0)=>not_Timeout_0, d=>rtlcn229);
   modgen_or_3 : or_3u_3u port map ( a(2)=>state(2), a(1)=>state(4), a(0)=>
      rtlc3n452, d=>rtlcn129);
   modgen_or_4 : or_6u_6u port map ( a(5)=>A_GAP(2), a(4)=>A_GAP(3), a(3)=>
      A_GAP(4), a(2)=>A_GAP(5), a(1)=>A_GAP(6), a(0)=>rtlc12n299, d=>rtlcn42
   );
   modgen_or_5 : or_6u_6u port map ( a(5)=>B_GAP(2), a(4)=>B_GAP(3), a(3)=>
      B_GAP(4), a(2)=>B_GAP(5), a(1)=>B_GAP(6), a(0)=>rtlc15n301, d=>rtlcn43
   );
   modgen_and_6 : and_6u_6u port map ( a(5)=>B_R_Data(15), a(4)=>
      B_R_Data(14), a(3)=>B_R_Data(13), a(2)=>B_R_Data(12), a(1)=>
      B_R_Data(11), a(0)=>B_Command_Sync, d=>Descriptor_B_5_15n7s6);
   modgen_and_7 : and_6u_6u port map ( a(5)=>A_R_Data(15), a(4)=>
      A_R_Data(14), a(3)=>A_R_Data(13), a(2)=>A_R_Data(12), a(1)=>
      A_R_Data(11), a(0)=>A_Command_Sync, d=>Descriptor_A_5_12n7s6);
end Sital_OH_unfold_3180 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity BRM1553D_ver8_4_RTLC_LONGENT0 is 
   port (
      Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
      BC_DISABLE : IN std_logic ;
      CPU_Address : IN std_logic_vector (15 DOWNTO 0) ;
      CPU_CS : IN std_logic ;
      CPU_Data_in_wide : IN std_logic_vector (31 DOWNTO 0) ;
      CPU_RE_vec : IN std_logic_vector (1 DOWNTO 0) ;
      CPU_Side_MEM_Data_o : IN std_logic_vector (31 DOWNTO 0) ;
      CPU_WE : IN std_logic_vector (1 DOWNTO 0) ;
      Clock_0 : IN std_logic ;
      Clock_1 : IN std_logic ;
      Clock_2 : IN std_logic ;
      Clock_3 : IN std_logic ;
      Constants_readback : IN std_logic_vector (15 DOWNTO 0) ;
      Ext_Trigger : IN std_logic ;
      External_CE_In : IN std_logic ;
      FromK : IN std_logic ;
      Handshake_Error : IN std_logic ;
      M1760 : IN std_logic ;
      MEM_nREG : IN std_logic ;
      Mem_Ack : IN std_logic ;
      Mem_Data_o : IN std_logic_vector (15 DOWNTO 0) ;
      Minus_A : IN std_logic ;
      Minus_B : IN std_logic ;
      Plus_A : IN std_logic ;
      Plus_B : IN std_logic ;
      RTAD : IN std_logic_vector (4 DOWNTO 0) ;
      RTADP : IN std_logic ;
      RTAD_SW_EN : IN std_logic ;
      RT_ADR_LAT : IN std_logic ;
      Raw_resetN : IN std_logic ;
      Set_SSFLAG : IN std_logic ;
      Strobe_TT : IN std_logic ;
      Tag_CLK : IN std_logic ;
      Tx_InhB : IN std_logic ;
      Tx_inhA : IN std_logic ;
      clock : IN std_logic ;
      key_ports_In : IN std_logic_vector (23 DOWNTO 0) ;
      CE_out : OUT std_logic ;
      CPU_Data_out_wide : OUT std_logic_vector (31 DOWNTO 0) ;
      CPU_Side_WE : OUT std_logic_vector (1 DOWNTO 0) ;
      Fault_value : OUT std_logic_vector (15 DOWNTO 0) ;
      INTn : OUT std_logic ;
      IP_Freq_sel : OUT std_logic_vector (1 DOWNTO 0) ;
      Mem_Address : OUT std_logic_vector (15 DOWNTO 0) ;
      Mem_RE : OUT std_logic ;
      Mem_data_in : OUT std_logic_vector (15 DOWNTO 0) ;
      OE_High : OUT std_logic ;
      TT_Load : OUT std_logic ;
      Tok : OUT std_logic ;
      Tx_A : OUT std_logic ;
      Tx_A_N : OUT std_logic ;
      Tx_B : OUT std_logic ;
      Tx_B_N : OUT std_logic ;
      Tx_inh_A : OUT std_logic ;
      Tx_inh_B : OUT std_logic ;
      Update : OUT std_logic ;
      debug_out : OUT std_logic_vector (63 DOWNTO 0) ;
      fault_type : OUT std_logic_vector (3 DOWNTO 0) ;
      mem_WE : OUT std_logic ;
      n16Mhz_12 : OUT std_logic ;
      BC_Message_Active : OUT std_logic ;
      BC_on : OUT std_logic ;
      H15530_record_A_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
      H15530_record_A_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
      H15530_record_A_Sync_error : OUT std_logic ;
      H15530_record_A_Manchester_error : OUT std_logic ;
      H15530_record_A_Parity_error : OUT std_logic ;
      H15530_record_A_echo_back_bus : OUT std_logic ;
      H15530_record_A_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      H15530_record_A_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_A_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
      H15530_record_A_RxRDY_plus_12us : OUT std_logic ;
      H15530_record_A_RxRDY_plus_10us : OUT std_logic ;
      H15530_record_A_CS : OUT std_logic ;
      H15530_record_A_Pre_EchoRdy : OUT std_logic ;
      H15530_record_A_Command_Sync : OUT std_logic ;
      H15530_record_A_Pre_RxRdy : OUT std_logic ;
      H15530_record_A_recieving : OUT std_logic ;
      H15530_record_B_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
      H15530_record_B_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
      H15530_record_B_Sync_error : OUT std_logic ;
      H15530_record_B_Manchester_error : OUT std_logic ;
      H15530_record_B_Parity_error : OUT std_logic ;
      H15530_record_B_echo_back_bus : OUT std_logic ;
      H15530_record_B_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
      H15530_record_B_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
      H15530_record_B_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
      H15530_record_B_RxRDY_plus_12us : OUT std_logic ;
      H15530_record_B_RxRDY_plus_10us : OUT std_logic ;
      H15530_record_B_CS : OUT std_logic ;
      H15530_record_B_Pre_EchoRdy : OUT std_logic ;
      H15530_record_B_Command_Sync : OUT std_logic ;
      H15530_record_B_Pre_RxRdy : OUT std_logic ;
      H15530_record_B_recieving : OUT std_logic ;
      key_ports_out : OUT std_logic_vector (23 DOWNTO 0) ;
      one_micro_increment : OUT std_logic ;
      pTDR_INT : OUT std_logic ;
      time_tag : OUT std_logic_vector (15 DOWNTO 0)) ;
end BRM1553D_ver8_4_RTLC_LONGENT0 ;

architecture no_int_mem_unfold_2437 of BRM1553D_ver8_4_RTLC_LONGENT0 is 
   component DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1
      port (
         Ack : IN std_logic ;
         Address : IN std_logic_vector (15 DOWNTO 0) ;
         Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
         BC_1553A_ME : IN std_logic ;
         BC_Command_Sync : IN std_logic ;
         BC_Coupling_error : IN std_logic ;
         BC_DISABLE : IN std_logic ;
         BC_Echo : IN std_logic ;
         BC_FE_All_Errors : IN std_logic ;
         BC_FE_Logic_error : IN std_logic ;
         BC_Found_Format_Error : IN std_logic ;
         BC_Found_wrong_RT_Address : IN std_logic ;
         BC_Found_wrong_word_count : IN std_logic ;
         BC_Loopback_error : IN std_logic ;
         BC_Message_Active : IN std_logic ;
         BC_Read : IN std_logic ;
         BC_Response_timeout_Error : IN std_logic ;
         BC_Rx_Data : IN std_logic_vector (15 DOWNTO 0) ;
         BC_Write : IN std_logic ;
         BC_wrong_sync : IN std_logic ;
         BE_Revision : IN std_logic_vector (15 DOWNTO 0) ;
         CE : IN std_logic ;
         CPU_Address : IN std_logic_vector (15 DOWNTO 0) ;
         CPU_CS : IN std_logic ;
         CPU_Data_in_wide : IN std_logic_vector (31 DOWNTO 0) ;
         CPU_RE_vec : IN std_logic_vector (1 DOWNTO 0) ;
         CPU_WE_vec : IN std_logic_vector (1 DOWNTO 0) ;
         Channel_Status : IN std_logic_vector (10 DOWNTO 0) ;
         Constants_readback : IN std_logic_vector (15 DOWNTO 0) ;
         Current_command : IN std_logic_vector (15 DOWNTO 0) ;
         Data_From_FE : IN std_logic_vector (15 DOWNTO 0) ;
         Data_o_temp : IN std_logic_vector (15 DOWNTO 0) ;
         Ext_Trigger : IN std_logic ;
         Goldenberg : IN std_logic ;
         Good_data_block_recieved : IN std_logic ;
         Handshake_Error : IN std_logic ;
         M1760 : IN std_logic ;
         MEM_Data_out_wide : IN std_logic_vector (31 DOWNTO 0) ;
         MEM_nREG : IN std_logic ;
         MIL1553_errors_Inhibit_TF : IN std_logic ;
         MIL1553_errors_invalid_command : IN std_logic ;
         MIL1553_errors_RT2RT_format_gap : IN std_logic ;
         MIL1553_errors_RT2RT_format_error : IN std_logic ;
         MIL1553_errors_Invalid_word : IN std_logic ;
         MIL1553_errors_Parity_Manchester : IN std_logic ;
         MIL1553_errors_incorrect_data_sync : IN std_logic ;
         MIL1553_errors_Low_word_count : IN std_logic ;
         MIL1553_errors_high_word_count : IN std_logic ;
         MIL1553_errors_Format_error : IN std_logic ;
         MIL1553_errors_Message_Error_set : IN std_logic ;
         MIL1553_errors_Address_Parity : IN std_logic ;
         MIL1553_errors_echo_back_bus_B : IN std_logic ;
         MIL1553_errors_echo_back_bus_A : IN std_logic ;
         MIL1553_errors_bus_B_shutdown : IN std_logic ;
         MIL1553_errors_bus_A_shutdown : IN std_logic ;
         MIL1553_errors_transmitter_timout : IN std_logic ;
         Message_ended_OK : IN std_logic ;
         Message_ended_not_OK : IN std_logic ;
         Monitor_Active_command : IN std_logic_vector (15 DOWNTO 0) ;
         Monitor_Ended_not_OK : IN std_logic ;
         Monitor_MIL1553_errors_Inhibit_TF : IN std_logic ;
         Monitor_MIL1553_errors_invalid_command : IN std_logic ;
         Monitor_MIL1553_errors_RT2RT_format_gap : IN std_logic ;
         Monitor_MIL1553_errors_RT2RT_format_error : IN std_logic ;
         Monitor_MIL1553_errors_Invalid_word : IN std_logic ;
         Monitor_MIL1553_errors_Parity_Manchester : IN std_logic ;
         Monitor_MIL1553_errors_incorrect_data_sync : IN std_logic ;
         Monitor_MIL1553_errors_Low_word_count : IN std_logic ;
         Monitor_MIL1553_errors_high_word_count : IN std_logic ;
         Monitor_MIL1553_errors_Format_error : IN std_logic ;
         Monitor_MIL1553_errors_Message_Error_set : IN std_logic ;
         Monitor_MIL1553_errors_Address_Parity : IN std_logic ;
         Monitor_MIL1553_errors_echo_back_bus_B : IN std_logic ;
         Monitor_MIL1553_errors_echo_back_bus_A : IN std_logic ;
         Monitor_MIL1553_errors_bus_B_shutdown : IN std_logic ;
         Monitor_MIL1553_errors_bus_A_shutdown : IN std_logic ;
         Monitor_MIL1553_errors_transmitter_timout : IN std_logic ;
         Monitor_RT2RT_Message : IN std_logic ;
         Monitor_bus_a : IN std_logic ;
         Monitor_ended_OK : IN std_logic ;
         Monitor_new_command : IN std_logic ;
         Monitor_write : IN std_logic ;
         Monitor_write_data : IN std_logic_vector (15 DOWNTO 0) ;
         New_command : IN std_logic ;
         RT2RT_Message : IN std_logic ;
         RTAD : IN std_logic_vector (4 DOWNTO 0) ;
         RTADP : IN std_logic ;
         RTAD_SW_EN : IN std_logic ;
         RT_ADR_LAT : IN std_logic ;
         Raw_resetN : IN std_logic ;
         Read : IN std_logic ;
         Set_SSFLAG : IN std_logic ;
         Strobe_TT : IN std_logic ;
         Tag_CLK : IN std_logic ;
         Tails_data_out_wide : IN std_logic_vector (31 DOWNTO 0) ;
         Tx_InhB : IN std_logic ;
         Tx_inhA : IN std_logic ;
         WM_Descriptor : IN std_logic_vector (15 DOWNTO 0) ;
         WM_Req : IN std_logic ;
         WM_Word : IN std_logic_vector (15 DOWNTO 0) ;
         Write : IN std_logic ;
         bus_A : IN std_logic ;
         clock : IN std_logic ;
         last_command : IN std_logic_vector (15 DOWNTO 0) ;
         pTDR_INT : IN std_logic ;
         ADDr_i_A : OUT std_logic_vector (15 DOWNTO 0) ;
         BC_FE_ResetN : OUT std_logic ;
         BC_RT2RT : OUT std_logic ;
         BC_Test : OUT std_logic ;
         BIT_Word : OUT std_logic_vector (15 DOWNTO 0) ;
         BUSY_in_LUT : OUT std_logic ;
         CPU_Data_out_wide : OUT std_logic_vector (31 DOWNTO 0) ;
         Data_i_A : OUT std_logic_vector (15 DOWNTO 0) ;
         ENC_TEST_GO : OUT std_logic ;
         ENC_TEST_on : OUT std_logic ;
         INTn : OUT std_logic ;
         IP_Freq_sel : OUT std_logic_vector (1 DOWNTO 0) ;
         No_Response_timeout : OUT std_logic_vector (2 DOWNTO 0) ;
         RE_A : OUT std_logic ;
         TT_Load : OUT std_logic ;
         Tails_WE_vec : OUT std_logic_vector (1 DOWNTO 0) ;
         WE_A : OUT std_logic ;
         debug : OUT std_logic_vector (15 DOWNTO 0) ;
         mem_WE_vec : OUT std_logic_vector (1 DOWNTO 0) ;
         n16Mhz_12 : OUT std_logic ;
         one_micro_increment : OUT std_logic ;
         pTDR_CS : OUT std_logic ;
         record_message_A : OUT std_logic ;
         record_message_B : OUT std_logic ;
         BC_1553A : OUT std_logic ;
         BC_BUS_A : OUT std_logic ;
         BC_Go : OUT std_logic ;
         BC_TX_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         BC_on : OUT std_logic ;
         Config_reg_4 : OUT std_logic_vector (15 DOWNTO 0) ;
         Data_to_FE : OUT std_logic_vector (15 DOWNTO 0) ;
         Do_illegal : OUT std_logic ;
         MODE_CODE1553A : OUT std_logic ;
         NO_BCST : OUT std_logic ;
         RT_Address : OUT std_logic_vector (5 DOWNTO 0) ;
         RT_On : OUT std_logic ;
         ResetN : OUT std_logic ;
         WM_Ack : OUT std_logic ;
         WM_Started : OUT std_logic ;
         host_status_bits : OUT std_logic_vector (10 DOWNTO 0) ;
         illegal_message : OUT std_logic ;
         time_tag : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   component RT_Real_switch_BRM_ver8_4_RTLC_LONGENT2
      port (
         Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
         BC_Active_Bus_A : IN std_logic ;
         BC_Go : IN std_logic ;
         BC_T_sync : IN std_logic ;
         BC_Transmit_data : IN std_logic_vector (15 DOWNTO 0) ;
         BC_mode : IN std_logic ;
         BIT_word : IN std_logic_vector (15 DOWNTO 0) ;
         BUSY_in_LUT : IN std_logic ;
         CPU_ResetN : IN std_logic ;
         Clock : IN std_logic ;
         Cohen : IN std_logic ;
         Data_in : IN std_logic_vector (15 DOWNTO 0) ;
         Do_illegal : IN std_logic ;
         ENC_TEST_On : IN std_logic ;
         External_CE_In : IN std_logic ;
         Host_Status_Bits : IN std_logic_vector (10 DOWNTO 0) ;
         MODE_CODE1553A : IN std_logic ;
         Minus_A : IN std_logic ;
         Minus_B : IN std_logic ;
         NO_BCST : IN std_logic ;
         No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
         Plus_A : IN std_logic ;
         Plus_B : IN std_logic ;
         RT_Address_wire : IN std_logic_vector (5 DOWNTO 0) ;
         RT_On : IN std_logic ;
         Tx_Inh_A_in : IN std_logic ;
         Tx_Inh_B_in : IN std_logic ;
         Wrap_Address : IN std_logic_vector (4 DOWNTO 0) ;
         illegal_command : IN std_logic ;
         loopback_test : IN std_logic ;
         Address : OUT std_logic_vector (15 DOWNTO 0) ;
         BC_TxRdy : OUT std_logic ;
         BUS_A : OUT std_logic ;
         Clock_enable : OUT std_logic ;
         Current_command : OUT std_logic_vector (15 DOWNTO 0) ;
         Data_out : OUT std_logic_vector (15 DOWNTO 0) ;
         Last_command : OUT std_logic_vector (15 DOWNTO 0) ;
         Message_ended_OK : OUT std_logic ;
         New_Command : OUT std_logic ;
         RT2RT_message : OUT std_logic ;
         Read : OUT std_logic ;
         Revision : OUT std_logic_vector (15 DOWNTO 0) ;
         Tx_A : OUT std_logic ;
         Tx_A_N : OUT std_logic ;
         Tx_B : OUT std_logic ;
         Tx_B_N : OUT std_logic ;
         Tx_inh_A : OUT std_logic ;
         Tx_inh_B : OUT std_logic ;
         Write : OUT std_logic ;
         mil1553_errors_Inhibit_TF : OUT std_logic ;
         mil1553_errors_invalid_command : OUT std_logic ;
         mil1553_errors_RT2RT_format_gap : OUT std_logic ;
         mil1553_errors_RT2RT_format_error : OUT std_logic ;
         mil1553_errors_Invalid_word : OUT std_logic ;
         mil1553_errors_Parity_Manchester : OUT std_logic ;
         mil1553_errors_incorrect_data_sync : OUT std_logic ;
         mil1553_errors_Low_word_count : OUT std_logic ;
         mil1553_errors_high_word_count : OUT std_logic ;
         mil1553_errors_Format_error : OUT std_logic ;
         mil1553_errors_Message_Error_set : OUT std_logic ;
         mil1553_errors_Address_Parity : OUT std_logic ;
         mil1553_errors_echo_back_bus_B : OUT std_logic ;
         mil1553_errors_echo_back_bus_A : OUT std_logic ;
         mil1553_errors_bus_B_shutdown : OUT std_logic ;
         mil1553_errors_bus_A_shutdown : OUT std_logic ;
         mil1553_errors_transmitter_timout : OUT std_logic ;
         Channel_status : OUT std_logic_vector (10 DOWNTO 0) ;
         H15530_record_A_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
         H15530_record_A_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
         
         H15530_record_A_Sync_error : OUT std_logic ;
         H15530_record_A_Manchester_error : OUT std_logic ;
         H15530_record_A_Parity_error : OUT std_logic ;
         H15530_record_A_echo_back_bus : OUT std_logic ;
         H15530_record_A_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         H15530_record_A_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
         H15530_record_A_RxRDY_plus_12us : OUT std_logic ;
         H15530_record_A_RxRDY_plus_10us : OUT std_logic ;
         H15530_record_A_CS : OUT std_logic ;
         H15530_record_A_Pre_EchoRdy : OUT std_logic ;
         H15530_record_A_Command_Sync : OUT std_logic ;
         H15530_record_A_Pre_RxRdy : OUT std_logic ;
         H15530_record_A_recieving : OUT std_logic ;
         H15530_record_B_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
         H15530_record_B_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
         
         H15530_record_B_Sync_error : OUT std_logic ;
         H15530_record_B_Manchester_error : OUT std_logic ;
         H15530_record_B_Parity_error : OUT std_logic ;
         H15530_record_B_echo_back_bus : OUT std_logic ;
         H15530_record_B_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         H15530_record_B_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
         H15530_record_B_RxRDY_plus_12us : OUT std_logic ;
         H15530_record_B_RxRDY_plus_10us : OUT std_logic ;
         H15530_record_B_CS : OUT std_logic ;
         H15530_record_B_Pre_EchoRdy : OUT std_logic ;
         H15530_record_B_Command_Sync : OUT std_logic ;
         H15530_record_B_Pre_RxRdy : OUT std_logic ;
         H15530_record_B_recieving : OUT std_logic ;
         Message_ended_not_OK : OUT std_logic ;
         RCV_A_Sync_error : OUT std_logic ;
         RCV_B_Sync_error : OUT std_logic) ;
   end component ;
   component Monitor_two_channel_8_4_1_32
      port (
         C : IN std_logic ;
         CE : IN std_logic ;
         MODE_CODE1553A : IN std_logic ;
         NO_BCST : IN std_logic ;
         No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
         R : IN std_logic ;
         RCV_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         RCV_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         rtlc_RCV_A_Sync_error_n139 : IN std_logic ;
         RCV_A_Manchester_error : IN std_logic ;
         RCV_A_Parity_error : IN std_logic ;
         RCV_A_echo_back_bus : IN std_logic ;
         RCV_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         RCV_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_A_RxRDY_plus_12us : IN std_logic ;
         RCV_A_RxRDY_plus_10us : IN std_logic ;
         RCV_A_CS : IN std_logic ;
         RCV_A_Pre_EchoRdy : IN std_logic ;
         RCV_A_Command_Sync : IN std_logic ;
         RCV_A_Pre_RxRdy : IN std_logic ;
         RCV_A_recieving : IN std_logic ;
         RCV_A_Sync_Error : IN std_logic ;
         RCV_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         RCV_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         rtlc_RCV_B_Sync_error_n140 : IN std_logic ;
         RCV_B_Manchester_error : IN std_logic ;
         RCV_B_Parity_error : IN std_logic ;
         RCV_B_echo_back_bus : IN std_logic ;
         RCV_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         RCV_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_B_RxRDY_plus_12us : IN std_logic ;
         RCV_B_RxRDY_plus_10us : IN std_logic ;
         RCV_B_CS : IN std_logic ;
         RCV_B_Pre_EchoRdy : IN std_logic ;
         RCV_B_Command_Sync : IN std_logic ;
         RCV_B_Pre_RxRdy : IN std_logic ;
         RCV_B_recieving : IN std_logic ;
         RCV_B_Sync_Error : IN std_logic ;
         Record_command_A : IN std_logic ;
         Record_command_B : IN std_logic ;
         yossy : IN std_logic ;
         Address : OUT std_logic_vector (15 DOWNTO 0) ;
         BM_OK_A : OUT std_logic ;
         BM_OK_B : OUT std_logic ;
         BM_not_OK_A : OUT std_logic ;
         BM_not_OK_B : OUT std_logic ;
         Debug : OUT std_logic_vector (15 DOWNTO 0) ;
         Debug_BM1 : OUT std_logic_vector (15 DOWNTO 0) ;
         Debug_BM2 : OUT std_logic_vector (15 DOWNTO 0) ;
         MIL1553_Errors_Inhibit_TF : OUT std_logic ;
         MIL1553_Errors_invalid_command : OUT std_logic ;
         MIL1553_Errors_RT2RT_format_gap : OUT std_logic ;
         MIL1553_Errors_RT2RT_format_error : OUT std_logic ;
         MIL1553_Errors_Invalid_word : OUT std_logic ;
         MIL1553_Errors_Parity_Manchester : OUT std_logic ;
         MIL1553_Errors_incorrect_data_sync : OUT std_logic ;
         MIL1553_Errors_Low_word_count : OUT std_logic ;
         MIL1553_Errors_high_word_count : OUT std_logic ;
         MIL1553_Errors_Format_error : OUT std_logic ;
         MIL1553_Errors_Message_Error_set : OUT std_logic ;
         MIL1553_Errors_Address_Parity : OUT std_logic ;
         MIL1553_Errors_echo_back_bus_B : OUT std_logic ;
         MIL1553_Errors_echo_back_bus_A : OUT std_logic ;
         MIL1553_Errors_bus_B_shutdown : OUT std_logic ;
         MIL1553_Errors_bus_A_shutdown : OUT std_logic ;
         MIL1553_Errors_transmitter_timout : OUT std_logic ;
         Monitor_ended_OK : OUT std_logic ;
         Monitor_ended_not_OK : OUT std_logic ;
         RT2RT_message : OUT std_logic ;
         Write : OUT std_logic ;
         Write_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         active_command : OUT std_logic_vector (15 DOWNTO 0) ;
         new_command : OUT std_logic ;
         Monitor_Bus_A : OUT std_logic) ;
   end component ;
   component BC_Stm_ver8_4_1_32
      port (
         C : IN std_logic ;
         R : IN std_logic ;
         CE : IN std_logic ;
         Yoav : IN std_logic ;
         RCV_A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         RCV_A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         rtlc_RCV_A_Sync_error_n2598 : IN std_logic ;
         RCV_A_Manchester_error : IN std_logic ;
         RCV_A_Parity_error : IN std_logic ;
         RCV_A_echo_back_bus : IN std_logic ;
         RCV_A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         RCV_A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_A_RxRDY_plus_12us : IN std_logic ;
         RCV_A_RxRDY_plus_10us : IN std_logic ;
         RCV_A_CS : IN std_logic ;
         RCV_A_Pre_EchoRdy : IN std_logic ;
         RCV_A_Command_Sync : IN std_logic ;
         RCV_A_Pre_RxRdy : IN std_logic ;
         RCV_A_recieving : IN std_logic ;
         RCV_B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         RCV_B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         rtlc_RCV_B_Sync_error_n2599 : IN std_logic ;
         RCV_B_Manchester_error : IN std_logic ;
         RCV_B_Parity_error : IN std_logic ;
         RCV_B_echo_back_bus : IN std_logic ;
         RCV_B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         RCV_B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         RCV_B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_B_RxRDY_plus_12us : IN std_logic ;
         RCV_B_RxRDY_plus_10us : IN std_logic ;
         RCV_B_CS : IN std_logic ;
         RCV_B_Pre_EchoRdy : IN std_logic ;
         RCV_B_Command_Sync : IN std_logic ;
         RCV_B_Pre_RxRdy : IN std_logic ;
         RCV_B_recieving : IN std_logic ;
         No_Response_timeout : IN std_logic_vector (2 DOWNTO 0) ;
         RCV_A_Sync_error : IN std_logic ;
         RCV_B_Sync_error : IN std_logic ;
         Transmit_data : OUT std_logic_vector (15 DOWNTO 0) ;
         T_Sync : OUT std_logic ;
         Go_Tx : OUT std_logic ;
         Tx_Rdy : IN std_logic ;
         Tx_Bus_A : OUT std_logic ;
         Tx_Data : IN std_logic_vector (15 DOWNTO 0) ;
         Read : OUT std_logic ;
         Go : IN std_logic ;
         ENC_TEST_Go : IN std_logic ;
         RT2RT : IN std_logic ;
         Bus_A : IN std_logic ;
         Rx_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         Write : OUT std_logic ;
         Echo : OUT std_logic ;
         Message_Active : OUT std_logic ;
         Command_Sync : OUT std_logic ;
         Idle_state : OUT std_logic ;
         Activity_on_wrong_bus : OUT std_logic ;
         Response_timeout_Error : OUT std_logic ;
         Found_Format_Error : OUT std_logic ;
         Loopback_error : OUT std_logic ;
         Found_wrong_RT_Address : OUT std_logic ;
         Found_wrong_word_count : OUT std_logic ;
         Bus_Coupling_error : OUT std_logic ;
         BC_logic_error : OUT std_logic ;
         Wrong_Sync_error : OUT std_logic ;
         FE_All_Errors : OUT std_logic ;
         Good_data_block_recieved : OUT std_logic ;
         NO_BCST : IN std_logic ;
         BC_1553A : IN std_logic ;
         BC_1553A_ME : OUT std_logic ;
         Config_reg_4 : IN std_logic_vector (15 DOWNTO 0) ;
         Debug : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   component Monitor_Word_DDC_8_4_32
      port (
         A_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         A_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         A_Sync_error : IN std_logic ;
         A_Manchester_error : IN std_logic ;
         A_Parity_error : IN std_logic ;
         A_echo_back_bus : IN std_logic ;
         A_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         A_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         A_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         A_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         A_RxRDY_plus_12us : IN std_logic ;
         A_RxRDY_plus_10us : IN std_logic ;
         A_CS : IN std_logic ;
         A_Pre_EchoRdy : IN std_logic ;
         A_Command_Sync : IN std_logic ;
         A_Pre_RxRdy : IN std_logic ;
         A_recieving : IN std_logic ;
         Ack : IN std_logic ;
         B_Bit_number : IN std_logic_vector (4 DOWNTO 0) ;
         B_Response_Time : IN std_logic_vector (7 DOWNTO 0) ;
         B_Sync_error : IN std_logic ;
         B_Manchester_error : IN std_logic ;
         B_Parity_error : IN std_logic ;
         B_echo_back_bus : IN std_logic ;
         B_R_Data : IN std_logic_vector (15 DOWNTO 0) ;
         B_RAW_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         B_GAP : IN std_logic_vector (6 DOWNTO 0) ;
         B_Gap_found : IN std_logic_vector (2 DOWNTO 0) ;
         B_RxRDY_plus_12us : IN std_logic ;
         B_RxRDY_plus_10us : IN std_logic ;
         B_CS : IN std_logic ;
         B_Pre_EchoRdy : IN std_logic ;
         B_Command_Sync : IN std_logic ;
         B_Pre_RxRdy : IN std_logic ;
         B_recieving : IN std_logic ;
         C : IN std_logic ;
         CE : IN std_logic ;
         R : IN std_logic ;
         Descriptor : OUT std_logic_vector (15 DOWNTO 0) ;
         Req : OUT std_logic ;
         Word : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   signal CE_out_EXMPLR2706, BC_Message_Active_EXMPLR2782, BC_on_EXMPLR2783
   : std_logic ;
   
   signal Address: std_logic_vector (10 DOWNTO 0) ;
   
   signal BC_1553A, BC_1553A_ME, BC_BUS_A, BC_Command_Sync, 
      BC_Coupling_error, BC_Echo, BC_FE_All_Errors, BC_FE_Logic_error, 
      BC_Found_Format_Error, BC_Found_wrong_RT_Address, 
      BC_Found_wrong_word_count, BC_Go, BC_Go_Tx, BC_Loopback_error, 
      BC_RT2RT, BC_Read, BC_Response_timeout_Error: std_logic ;
   
   signal BC_Rx_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_STM_ResetN: std_logic ;
   
   signal BC_TX_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Test: std_logic ;
   
   signal BC_Transmit_data: std_logic_vector (15 DOWNTO 0) ;
   
   signal BC_Write, BC_wrong_sync: std_logic ;
   
   signal BIT_word: std_logic_vector (15 DOWNTO 0) ;
   
   signal BUSY_in_LUT: std_logic ;
   
   signal Channel_status: std_logic_vector (10 DOWNTO 0) ;
   
   signal Config_reg_4_6, Config_reg_4_5: std_logic ;
   
   signal Current_command: std_logic_vector (15 DOWNTO 0) ;
   
   signal Data_From_FE: std_logic_vector (15 DOWNTO 0) ;
   
   signal Data_to_FE: std_logic_vector (15 DOWNTO 0) ;
   
   signal Do_illegal, ENC_TEST_Go, ENC_TEST_On, Good_data_block_recieved: 
   std_logic ;
   
   signal Host_Status_Bits: std_logic_vector (10 DOWNTO 0) ;
   
   signal Last_command: std_logic_vector (15 DOWNTO 0) ;
   
   signal MODE_CODE1553A, Message_ended_OK, Message_ended_not_OK, 
      Monitor_Bus_A, Monitor_New_command, Monitor_RT2RT_message, 
      Monitor_Record_command_A, Monitor_Record_command_B, Monitor_Write: 
   std_logic ;
   
   signal Monitor_Write_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal Monitor_active_command: std_logic_vector (15 DOWNTO 0) ;
   
   signal Monitor_ended_OK, Monitor_ended_not_OK, New_command: std_logic ;
   
   signal No_Response_timeout: std_logic_vector (2 DOWNTO 0) ;
   
   signal RCV_A_Sync_error, RCV_B_Sync_error, RT2RT_message, RT_On, Read, 
      ResetN, T_Sync, Tx_Bus_A, Tx_Rdy, WM_Ack, WM_Descriptor_15, 
      WM_Descriptor_14, WM_Descriptor_13, WM_Descriptor_12, WM_Descriptor_11, 
      WM_Descriptor_10, WM_Descriptor_9, WM_Descriptor_8, WM_Descriptor_7, 
      WM_Descriptor_5, WM_Descriptor_4, WM_Descriptor_3, WM_Descriptor_2, 
      WM_Descriptor_1, WM_Descriptor_0, WM_Req, WM_Started: std_logic ;
   
   signal WM_Word: std_logic_vector (15 DOWNTO 0) ;
   
   signal Write, bus_A, illegal_command, PWR, Tok_EXMPLR2801: std_logic ;
   
   signal H15530_record_A_R_Data_EXMPLR2890: std_logic_vector (15 DOWNTO 0)
    ;
   
   signal H15530_record_A_RAW_GAP_EXMPLR2891: std_logic_vector (6 DOWNTO 0)
    ;
   
   signal H15530_record_A_GAP_EXMPLR2892: std_logic_vector (6 DOWNTO 0) ;
   
   signal H15530_record_A_Gap_found_EXMPLR2893: std_logic_vector
    (2 DOWNTO 0) ;
   
   signal H15530_record_A_CS_EXMPLR2835, 
      H15530_record_A_Pre_EchoRdy_EXMPLR2836, 
      H15530_record_A_Command_Sync_EXMPLR2837, 
      H15530_record_A_Pre_RxRdy_EXMPLR2838, 
      H15530_record_A_recieving_EXMPLR2839: std_logic ;
   
   signal H15530_record_B_R_Data_EXMPLR2894: std_logic_vector (15 DOWNTO 0)
    ;
   
   signal H15530_record_B_RAW_GAP_EXMPLR2895: std_logic_vector (6 DOWNTO 0)
    ;
   
   signal H15530_record_B_GAP_EXMPLR2896: std_logic_vector (6 DOWNTO 0) ;
   
   signal H15530_record_B_Gap_found_EXMPLR2897: std_logic_vector
    (2 DOWNTO 0) ;
   
   signal H15530_record_B_CS_EXMPLR2873, 
      H15530_record_B_Pre_EchoRdy_EXMPLR2874, 
      H15530_record_B_Command_Sync_EXMPLR2875, 
      H15530_record_B_Pre_RxRdy_EXMPLR2876, 
      H15530_record_B_recieving_EXMPLR2877, 
      Monitor_MIL1553_errors_Inhibit_TF, 
      Monitor_MIL1553_errors_invalid_command, 
      Monitor_MIL1553_errors_RT2RT_format_gap, 
      Monitor_MIL1553_errors_RT2RT_format_error, 
      Monitor_MIL1553_errors_Invalid_word, 
      Monitor_MIL1553_errors_incorrect_data_sync, 
      Monitor_MIL1553_errors_Low_word_count, 
      Monitor_MIL1553_errors_high_word_count, 
      Monitor_MIL1553_errors_Address_Parity, mil1553_errors_Inhibit_TF, 
      mil1553_errors_Format_error, mil1553_errors_Message_Error_set, 
      mil1553_errors_echo_back_bus_B, mil1553_errors_echo_back_bus_A, 
      mil1553_errors_bus_B_shutdown, mil1553_errors_bus_A_shutdown, 
      mil1553_errors_transmitter_timout: std_logic ;
   
   signal DANGLING : std_logic_vector (206 downto 0 );

begin
   CE_out <= CE_out_EXMPLR2706 ;
   Fault_value(15) <= Tok_EXMPLR2801 ;
   Fault_value(14) <= Tok_EXMPLR2801 ;
   Fault_value(13) <= Tok_EXMPLR2801 ;
   Fault_value(12) <= Tok_EXMPLR2801 ;
   Fault_value(11) <= Tok_EXMPLR2801 ;
   Fault_value(10) <= Tok_EXMPLR2801 ;
   Fault_value(9) <= Tok_EXMPLR2801 ;
   Fault_value(8) <= Tok_EXMPLR2801 ;
   Fault_value(7) <= Tok_EXMPLR2801 ;
   Fault_value(6) <= Tok_EXMPLR2801 ;
   Fault_value(5) <= Tok_EXMPLR2801 ;
   Fault_value(4) <= Tok_EXMPLR2801 ;
   Fault_value(3) <= Tok_EXMPLR2801 ;
   Fault_value(2) <= Tok_EXMPLR2801 ;
   Fault_value(1) <= Tok_EXMPLR2801 ;
   Fault_value(0) <= Tok_EXMPLR2801 ;
   IP_Freq_sel(1) <= Tok_EXMPLR2801 ;
   IP_Freq_sel(0) <= Tok_EXMPLR2801 ;
   OE_High <= Tok_EXMPLR2801 ;
   TT_Load <= Tok_EXMPLR2801 ;
   Tok <= Tok_EXMPLR2801 ;
   Update <= Tok_EXMPLR2801 ;
   debug_out(63) <= Tok_EXMPLR2801 ;
   debug_out(62) <= Tok_EXMPLR2801 ;
   debug_out(61) <= Tok_EXMPLR2801 ;
   debug_out(60) <= Tok_EXMPLR2801 ;
   debug_out(59) <= Tok_EXMPLR2801 ;
   debug_out(58) <= Tok_EXMPLR2801 ;
   debug_out(57) <= Tok_EXMPLR2801 ;
   debug_out(56) <= Tok_EXMPLR2801 ;
   debug_out(55) <= Tok_EXMPLR2801 ;
   debug_out(54) <= Tok_EXMPLR2801 ;
   debug_out(53) <= Tok_EXMPLR2801 ;
   debug_out(52) <= Tok_EXMPLR2801 ;
   debug_out(51) <= Tok_EXMPLR2801 ;
   debug_out(50) <= Tok_EXMPLR2801 ;
   debug_out(49) <= Tok_EXMPLR2801 ;
   debug_out(48) <= Tok_EXMPLR2801 ;
   debug_out(47) <= Tok_EXMPLR2801 ;
   debug_out(46) <= Tok_EXMPLR2801 ;
   debug_out(45) <= Tok_EXMPLR2801 ;
   debug_out(44) <= Tok_EXMPLR2801 ;
   debug_out(43) <= Tok_EXMPLR2801 ;
   debug_out(42) <= Tok_EXMPLR2801 ;
   debug_out(41) <= Tok_EXMPLR2801 ;
   debug_out(40) <= Tok_EXMPLR2801 ;
   debug_out(39) <= Tok_EXMPLR2801 ;
   debug_out(38) <= Tok_EXMPLR2801 ;
   debug_out(37) <= Tok_EXMPLR2801 ;
   debug_out(36) <= Tok_EXMPLR2801 ;
   debug_out(35) <= Tok_EXMPLR2801 ;
   debug_out(34) <= Tok_EXMPLR2801 ;
   debug_out(33) <= Tok_EXMPLR2801 ;
   debug_out(32) <= Tok_EXMPLR2801 ;
   debug_out(31) <= Tok_EXMPLR2801 ;
   debug_out(30) <= Tok_EXMPLR2801 ;
   debug_out(29) <= Tok_EXMPLR2801 ;
   debug_out(28) <= Tok_EXMPLR2801 ;
   debug_out(27) <= Tok_EXMPLR2801 ;
   debug_out(26) <= Tok_EXMPLR2801 ;
   debug_out(25) <= Tok_EXMPLR2801 ;
   debug_out(24) <= Tok_EXMPLR2801 ;
   debug_out(23) <= Tok_EXMPLR2801 ;
   debug_out(22) <= Tok_EXMPLR2801 ;
   debug_out(21) <= Tok_EXMPLR2801 ;
   debug_out(20) <= Tok_EXMPLR2801 ;
   debug_out(19) <= Tok_EXMPLR2801 ;
   debug_out(18) <= Tok_EXMPLR2801 ;
   debug_out(17) <= Tok_EXMPLR2801 ;
   debug_out(16) <= Tok_EXMPLR2801 ;
   debug_out(15) <= Tok_EXMPLR2801 ;
   debug_out(14) <= Tok_EXMPLR2801 ;
   debug_out(13) <= Tok_EXMPLR2801 ;
   debug_out(12) <= Tok_EXMPLR2801 ;
   debug_out(11) <= Tok_EXMPLR2801 ;
   debug_out(10) <= Tok_EXMPLR2801 ;
   debug_out(9) <= Tok_EXMPLR2801 ;
   debug_out(8) <= Tok_EXMPLR2801 ;
   debug_out(7) <= Tok_EXMPLR2801 ;
   debug_out(6) <= Tok_EXMPLR2801 ;
   debug_out(5) <= Tok_EXMPLR2801 ;
   debug_out(4) <= Tok_EXMPLR2801 ;
   debug_out(3) <= Tok_EXMPLR2801 ;
   debug_out(2) <= Tok_EXMPLR2801 ;
   debug_out(1) <= Tok_EXMPLR2801 ;
   debug_out(0) <= Tok_EXMPLR2801 ;
   fault_type(3) <= Tok_EXMPLR2801 ;
   fault_type(2) <= Tok_EXMPLR2801 ;
   fault_type(1) <= Tok_EXMPLR2801 ;
   fault_type(0) <= Tok_EXMPLR2801 ;
   n16Mhz_12 <= Tok_EXMPLR2801 ;
   BC_Message_Active <= BC_Message_Active_EXMPLR2782 ;
   BC_on <= BC_on_EXMPLR2783 ;
   H15530_record_A_Bit_number(4) <= Tok_EXMPLR2801 ;
   H15530_record_A_Bit_number(3) <= Tok_EXMPLR2801 ;
   H15530_record_A_Bit_number(2) <= Tok_EXMPLR2801 ;
   H15530_record_A_Bit_number(1) <= Tok_EXMPLR2801 ;
   H15530_record_A_Bit_number(0) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(7) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(6) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(5) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(4) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(3) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(2) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(1) <= Tok_EXMPLR2801 ;
   H15530_record_A_Response_Time(0) <= Tok_EXMPLR2801 ;
   H15530_record_A_Sync_error <= Tok_EXMPLR2801 ;
   H15530_record_A_Manchester_error <= Tok_EXMPLR2801 ;
   H15530_record_A_Parity_error <= Tok_EXMPLR2801 ;
   H15530_record_A_echo_back_bus <= Tok_EXMPLR2801 ;
   H15530_record_A_R_Data(15) <= H15530_record_A_R_Data_EXMPLR2890(15) ;
   H15530_record_A_R_Data(14) <= H15530_record_A_R_Data_EXMPLR2890(14) ;
   H15530_record_A_R_Data(13) <= H15530_record_A_R_Data_EXMPLR2890(13) ;
   H15530_record_A_R_Data(12) <= H15530_record_A_R_Data_EXMPLR2890(12) ;
   H15530_record_A_R_Data(11) <= H15530_record_A_R_Data_EXMPLR2890(11) ;
   H15530_record_A_R_Data(10) <= H15530_record_A_R_Data_EXMPLR2890(10) ;
   H15530_record_A_R_Data(9) <= H15530_record_A_R_Data_EXMPLR2890(9) ;
   H15530_record_A_R_Data(8) <= H15530_record_A_R_Data_EXMPLR2890(8) ;
   H15530_record_A_R_Data(7) <= H15530_record_A_R_Data_EXMPLR2890(7) ;
   H15530_record_A_R_Data(6) <= H15530_record_A_R_Data_EXMPLR2890(6) ;
   H15530_record_A_R_Data(5) <= H15530_record_A_R_Data_EXMPLR2890(5) ;
   H15530_record_A_R_Data(4) <= H15530_record_A_R_Data_EXMPLR2890(4) ;
   H15530_record_A_R_Data(3) <= H15530_record_A_R_Data_EXMPLR2890(3) ;
   H15530_record_A_R_Data(2) <= H15530_record_A_R_Data_EXMPLR2890(2) ;
   H15530_record_A_R_Data(1) <= H15530_record_A_R_Data_EXMPLR2890(1) ;
   H15530_record_A_R_Data(0) <= H15530_record_A_R_Data_EXMPLR2890(0) ;
   H15530_record_A_RAW_GAP(6) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(5) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(4) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(3) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(2) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(1) <= Tok_EXMPLR2801 ;
   H15530_record_A_RAW_GAP(0) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(6) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(5) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(4) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(3) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(2) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(1) <= Tok_EXMPLR2801 ;
   H15530_record_A_GAP(0) <= Tok_EXMPLR2801 ;
   H15530_record_A_Gap_found(2) <= Tok_EXMPLR2801 ;
   H15530_record_A_Gap_found(1) <= Tok_EXMPLR2801 ;
   H15530_record_A_Gap_found(0) <= Tok_EXMPLR2801 ;
   H15530_record_A_RxRDY_plus_12us <= Tok_EXMPLR2801 ;
   H15530_record_A_RxRDY_plus_10us <= Tok_EXMPLR2801 ;
   H15530_record_A_CS <= H15530_record_A_CS_EXMPLR2835 ;
   H15530_record_A_Pre_EchoRdy <= Tok_EXMPLR2801 ;
   H15530_record_A_Command_Sync <= H15530_record_A_Command_Sync_EXMPLR2837 ;
   H15530_record_A_Pre_RxRdy <= H15530_record_A_Pre_RxRdy_EXMPLR2838 ;
   H15530_record_A_recieving <= Tok_EXMPLR2801 ;
   H15530_record_B_Bit_number(4) <= Tok_EXMPLR2801 ;
   H15530_record_B_Bit_number(3) <= Tok_EXMPLR2801 ;
   H15530_record_B_Bit_number(2) <= Tok_EXMPLR2801 ;
   H15530_record_B_Bit_number(1) <= Tok_EXMPLR2801 ;
   H15530_record_B_Bit_number(0) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(7) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(6) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(5) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(4) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(3) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(2) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(1) <= Tok_EXMPLR2801 ;
   H15530_record_B_Response_Time(0) <= Tok_EXMPLR2801 ;
   H15530_record_B_Sync_error <= Tok_EXMPLR2801 ;
   H15530_record_B_Manchester_error <= Tok_EXMPLR2801 ;
   H15530_record_B_Parity_error <= Tok_EXMPLR2801 ;
   H15530_record_B_echo_back_bus <= Tok_EXMPLR2801 ;
   H15530_record_B_R_Data(15) <= H15530_record_B_R_Data_EXMPLR2894(15) ;
   H15530_record_B_R_Data(14) <= H15530_record_B_R_Data_EXMPLR2894(14) ;
   H15530_record_B_R_Data(13) <= H15530_record_B_R_Data_EXMPLR2894(13) ;
   H15530_record_B_R_Data(12) <= H15530_record_B_R_Data_EXMPLR2894(12) ;
   H15530_record_B_R_Data(11) <= H15530_record_B_R_Data_EXMPLR2894(11) ;
   H15530_record_B_R_Data(10) <= H15530_record_B_R_Data_EXMPLR2894(10) ;
   H15530_record_B_R_Data(9) <= H15530_record_B_R_Data_EXMPLR2894(9) ;
   H15530_record_B_R_Data(8) <= H15530_record_B_R_Data_EXMPLR2894(8) ;
   H15530_record_B_R_Data(7) <= H15530_record_B_R_Data_EXMPLR2894(7) ;
   H15530_record_B_R_Data(6) <= H15530_record_B_R_Data_EXMPLR2894(6) ;
   H15530_record_B_R_Data(5) <= H15530_record_B_R_Data_EXMPLR2894(5) ;
   H15530_record_B_R_Data(4) <= H15530_record_B_R_Data_EXMPLR2894(4) ;
   H15530_record_B_R_Data(3) <= H15530_record_B_R_Data_EXMPLR2894(3) ;
   H15530_record_B_R_Data(2) <= H15530_record_B_R_Data_EXMPLR2894(2) ;
   H15530_record_B_R_Data(1) <= H15530_record_B_R_Data_EXMPLR2894(1) ;
   H15530_record_B_R_Data(0) <= H15530_record_B_R_Data_EXMPLR2894(0) ;
   H15530_record_B_RAW_GAP(6) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(5) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(4) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(3) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(2) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(1) <= Tok_EXMPLR2801 ;
   H15530_record_B_RAW_GAP(0) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(6) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(5) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(4) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(3) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(2) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(1) <= Tok_EXMPLR2801 ;
   H15530_record_B_GAP(0) <= Tok_EXMPLR2801 ;
   H15530_record_B_Gap_found(2) <= Tok_EXMPLR2801 ;
   H15530_record_B_Gap_found(1) <= Tok_EXMPLR2801 ;
   H15530_record_B_Gap_found(0) <= Tok_EXMPLR2801 ;
   H15530_record_B_RxRDY_plus_12us <= Tok_EXMPLR2801 ;
   H15530_record_B_RxRDY_plus_10us <= Tok_EXMPLR2801 ;
   H15530_record_B_CS <= H15530_record_B_CS_EXMPLR2873 ;
   H15530_record_B_Pre_EchoRdy <= Tok_EXMPLR2801 ;
   H15530_record_B_Command_Sync <= H15530_record_B_Command_Sync_EXMPLR2875 ;
   H15530_record_B_Pre_RxRdy <= H15530_record_B_Pre_RxRdy_EXMPLR2876 ;
   H15530_record_B_recieving <= Tok_EXMPLR2801 ;
   key_ports_out(23) <= Tok_EXMPLR2801 ;
   key_ports_out(22) <= Tok_EXMPLR2801 ;
   key_ports_out(21) <= Tok_EXMPLR2801 ;
   key_ports_out(20) <= Tok_EXMPLR2801 ;
   key_ports_out(19) <= Tok_EXMPLR2801 ;
   key_ports_out(18) <= Tok_EXMPLR2801 ;
   key_ports_out(17) <= Tok_EXMPLR2801 ;
   key_ports_out(16) <= Tok_EXMPLR2801 ;
   key_ports_out(15) <= Tok_EXMPLR2801 ;
   key_ports_out(14) <= Tok_EXMPLR2801 ;
   key_ports_out(13) <= Tok_EXMPLR2801 ;
   key_ports_out(12) <= Tok_EXMPLR2801 ;
   key_ports_out(11) <= Tok_EXMPLR2801 ;
   key_ports_out(10) <= Tok_EXMPLR2801 ;
   key_ports_out(9) <= Tok_EXMPLR2801 ;
   key_ports_out(8) <= Tok_EXMPLR2801 ;
   key_ports_out(7) <= Tok_EXMPLR2801 ;
   key_ports_out(6) <= Tok_EXMPLR2801 ;
   key_ports_out(5) <= Tok_EXMPLR2801 ;
   key_ports_out(4) <= Tok_EXMPLR2801 ;
   key_ports_out(3) <= Tok_EXMPLR2801 ;
   key_ports_out(2) <= Tok_EXMPLR2801 ;
   key_ports_out(1) <= Tok_EXMPLR2801 ;
   key_ports_out(0) <= Tok_EXMPLR2801 ;
   pTDR_INT <= Tok_EXMPLR2801 ;
   PWR <= '1' ;
   Tok_EXMPLR2801 <= '0' ;
   DDC_Enhanced : DDC_enhanced_ACE_BRM_8_4_RTLC_LONGENT1 port map ( Ack=>
      Mem_Ack, Address(15)=>Tok_EXMPLR2801, Address(14)=>Tok_EXMPLR2801, 
      Address(13)=>Tok_EXMPLR2801, Address(12)=>Tok_EXMPLR2801, Address(11)
      =>Tok_EXMPLR2801, Address(10)=>Address(10), Address(9)=>Address(9), 
      Address(8)=>Address(8), Address(7)=>Address(7), Address(6)=>Address(6), 
      Address(5)=>Address(5), Address(4)=>Address(4), Address(3)=>Address(3), 
      Address(2)=>Address(2), Address(1)=>Address(1), Address(0)=>Address(0), 
      Aux_in(15)=>Tok_EXMPLR2801, Aux_in(14)=>Tok_EXMPLR2801, Aux_in(13)=>
      Tok_EXMPLR2801, Aux_in(12)=>Tok_EXMPLR2801, Aux_in(11)=>Tok_EXMPLR2801, 
      Aux_in(10)=>Tok_EXMPLR2801, Aux_in(9)=>Tok_EXMPLR2801, Aux_in(8)=>
      Tok_EXMPLR2801, Aux_in(7)=>Tok_EXMPLR2801, Aux_in(6)=>Tok_EXMPLR2801, 
      Aux_in(5)=>Tok_EXMPLR2801, Aux_in(4)=>Tok_EXMPLR2801, Aux_in(3)=>
      Tok_EXMPLR2801, Aux_in(2)=>Tok_EXMPLR2801, Aux_in(1)=>Tok_EXMPLR2801, 
      Aux_in(0)=>Tok_EXMPLR2801, BC_1553A_ME=>BC_1553A_ME, BC_Command_Sync=>
      BC_Command_Sync, BC_Coupling_error=>BC_Coupling_error, BC_DISABLE=>
      BC_DISABLE, BC_Echo=>BC_Echo, BC_FE_All_Errors=>BC_FE_All_Errors, 
      BC_FE_Logic_error=>BC_FE_Logic_error, BC_Found_Format_Error=>
      BC_Found_Format_Error, BC_Found_wrong_RT_Address=>
      BC_Found_wrong_RT_Address, BC_Found_wrong_word_count=>
      BC_Found_wrong_word_count, BC_Loopback_error=>BC_Loopback_error, 
      BC_Message_Active=>BC_Message_Active_EXMPLR2782, BC_Read=>BC_Read, 
      BC_Response_timeout_Error=>BC_Response_timeout_Error, BC_Rx_Data(15)=>
      BC_Rx_Data(15), BC_Rx_Data(14)=>BC_Rx_Data(14), BC_Rx_Data(13)=>
      BC_Rx_Data(13), BC_Rx_Data(12)=>BC_Rx_Data(12), BC_Rx_Data(11)=>
      BC_Rx_Data(11), BC_Rx_Data(10)=>BC_Rx_Data(10), BC_Rx_Data(9)=>
      BC_Rx_Data(9), BC_Rx_Data(8)=>BC_Rx_Data(8), BC_Rx_Data(7)=>
      BC_Rx_Data(7), BC_Rx_Data(6)=>BC_Rx_Data(6), BC_Rx_Data(5)=>
      BC_Rx_Data(5), BC_Rx_Data(4)=>BC_Rx_Data(4), BC_Rx_Data(3)=>
      BC_Rx_Data(3), BC_Rx_Data(2)=>BC_Rx_Data(2), BC_Rx_Data(1)=>
      BC_Rx_Data(1), BC_Rx_Data(0)=>BC_Rx_Data(0), BC_Write=>BC_Write, 
      BC_wrong_sync=>BC_wrong_sync, BE_Revision(15)=>Tok_EXMPLR2801, 
      BE_Revision(14)=>Tok_EXMPLR2801, BE_Revision(13)=>Tok_EXMPLR2801, 
      BE_Revision(12)=>Tok_EXMPLR2801, BE_Revision(11)=>Tok_EXMPLR2801, 
      BE_Revision(10)=>PWR, BE_Revision(9)=>Tok_EXMPLR2801, BE_Revision(8)=>
      Tok_EXMPLR2801, BE_Revision(7)=>Tok_EXMPLR2801, BE_Revision(6)=>PWR, 
      BE_Revision(5)=>PWR, BE_Revision(4)=>Tok_EXMPLR2801, BE_Revision(3)=>
      PWR, BE_Revision(2)=>Tok_EXMPLR2801, BE_Revision(1)=>Tok_EXMPLR2801, 
      BE_Revision(0)=>PWR, CE=>CE_out_EXMPLR2706, CPU_Address(15)=>
      Tok_EXMPLR2801, CPU_Address(14)=>Tok_EXMPLR2801, CPU_Address(13)=>
      Tok_EXMPLR2801, CPU_Address(12)=>Tok_EXMPLR2801, CPU_Address(11)=>
      Tok_EXMPLR2801, CPU_Address(10)=>Tok_EXMPLR2801, CPU_Address(9)=>
      Tok_EXMPLR2801, CPU_Address(8)=>Tok_EXMPLR2801, CPU_Address(7)=>
      Tok_EXMPLR2801, CPU_Address(6)=>Tok_EXMPLR2801, CPU_Address(5)=>
      Tok_EXMPLR2801, CPU_Address(4)=>CPU_Address(4), CPU_Address(3)=>
      CPU_Address(3), CPU_Address(2)=>CPU_Address(2), CPU_Address(1)=>
      CPU_Address(1), CPU_Address(0)=>Tok_EXMPLR2801, CPU_CS=>CPU_CS, 
      CPU_Data_in_wide(31)=>CPU_Data_in_wide(31), CPU_Data_in_wide(30)=>
      CPU_Data_in_wide(30), CPU_Data_in_wide(29)=>CPU_Data_in_wide(29), 
      CPU_Data_in_wide(28)=>CPU_Data_in_wide(28), CPU_Data_in_wide(27)=>
      CPU_Data_in_wide(27), CPU_Data_in_wide(26)=>CPU_Data_in_wide(26), 
      CPU_Data_in_wide(25)=>CPU_Data_in_wide(25), CPU_Data_in_wide(24)=>
      CPU_Data_in_wide(24), CPU_Data_in_wide(23)=>CPU_Data_in_wide(23), 
      CPU_Data_in_wide(22)=>CPU_Data_in_wide(22), CPU_Data_in_wide(21)=>
      CPU_Data_in_wide(21), CPU_Data_in_wide(20)=>CPU_Data_in_wide(20), 
      CPU_Data_in_wide(19)=>CPU_Data_in_wide(19), CPU_Data_in_wide(18)=>
      CPU_Data_in_wide(18), CPU_Data_in_wide(17)=>CPU_Data_in_wide(17), 
      CPU_Data_in_wide(16)=>CPU_Data_in_wide(16), CPU_Data_in_wide(15)=>
      CPU_Data_in_wide(15), CPU_Data_in_wide(14)=>CPU_Data_in_wide(14), 
      CPU_Data_in_wide(13)=>CPU_Data_in_wide(13), CPU_Data_in_wide(12)=>
      CPU_Data_in_wide(12), CPU_Data_in_wide(11)=>CPU_Data_in_wide(11), 
      CPU_Data_in_wide(10)=>CPU_Data_in_wide(10), CPU_Data_in_wide(9)=>
      CPU_Data_in_wide(9), CPU_Data_in_wide(8)=>CPU_Data_in_wide(8), 
      CPU_Data_in_wide(7)=>CPU_Data_in_wide(7), CPU_Data_in_wide(6)=>
      CPU_Data_in_wide(6), CPU_Data_in_wide(5)=>CPU_Data_in_wide(5), 
      CPU_Data_in_wide(4)=>CPU_Data_in_wide(4), CPU_Data_in_wide(3)=>
      CPU_Data_in_wide(3), CPU_Data_in_wide(2)=>CPU_Data_in_wide(2), 
      CPU_Data_in_wide(1)=>CPU_Data_in_wide(1), CPU_Data_in_wide(0)=>
      CPU_Data_in_wide(0), CPU_RE_vec(1)=>Tok_EXMPLR2801, CPU_RE_vec(0)=>
      CPU_RE_vec(0), CPU_WE_vec(1)=>CPU_WE(1), CPU_WE_vec(0)=>CPU_WE(0), 
      Channel_Status(10)=>Channel_status(10), Channel_Status(9)=>
      Channel_status(9), Channel_Status(8)=>Channel_status(8), 
      Channel_Status(7)=>Channel_status(7), Channel_Status(6)=>
      Channel_status(6), Channel_Status(5)=>Channel_status(5), 
      Channel_Status(4)=>Channel_status(4), Channel_Status(3)=>
      Channel_status(3), Channel_Status(2)=>Channel_status(2), 
      Channel_Status(1)=>Channel_status(1), Channel_Status(0)=>
      Channel_status(0), Constants_readback(15)=>Tok_EXMPLR2801, 
      Constants_readback(14)=>Tok_EXMPLR2801, Constants_readback(13)=>
      Tok_EXMPLR2801, Constants_readback(12)=>Tok_EXMPLR2801, 
      Constants_readback(11)=>Tok_EXMPLR2801, Constants_readback(10)=>
      Tok_EXMPLR2801, Constants_readback(9)=>Tok_EXMPLR2801, 
      Constants_readback(8)=>Tok_EXMPLR2801, Constants_readback(7)=>
      Tok_EXMPLR2801, Constants_readback(6)=>Tok_EXMPLR2801, 
      Constants_readback(5)=>Tok_EXMPLR2801, Constants_readback(4)=>
      Tok_EXMPLR2801, Constants_readback(3)=>Tok_EXMPLR2801, 
      Constants_readback(2)=>Tok_EXMPLR2801, Constants_readback(1)=>
      Tok_EXMPLR2801, Constants_readback(0)=>Tok_EXMPLR2801, 
      Current_command(15)=>Current_command(15), Current_command(14)=>
      Current_command(14), Current_command(13)=>Current_command(13), 
      Current_command(12)=>Current_command(12), Current_command(11)=>
      Current_command(11), Current_command(10)=>Current_command(10), 
      Current_command(9)=>Current_command(9), Current_command(8)=>
      Current_command(8), Current_command(7)=>Current_command(7), 
      Current_command(6)=>Current_command(6), Current_command(5)=>
      Current_command(5), Current_command(4)=>Current_command(4), 
      Current_command(3)=>Current_command(3), Current_command(2)=>
      Current_command(2), Current_command(1)=>Current_command(1), 
      Current_command(0)=>Current_command(0), Data_From_FE(15)=>
      Data_From_FE(15), Data_From_FE(14)=>Data_From_FE(14), Data_From_FE(13)
      =>Data_From_FE(13), Data_From_FE(12)=>Data_From_FE(12), 
      Data_From_FE(11)=>Data_From_FE(11), Data_From_FE(10)=>Data_From_FE(10), 
      Data_From_FE(9)=>Data_From_FE(9), Data_From_FE(8)=>Data_From_FE(8), 
      Data_From_FE(7)=>Data_From_FE(7), Data_From_FE(6)=>Data_From_FE(6), 
      Data_From_FE(5)=>Data_From_FE(5), Data_From_FE(4)=>Data_From_FE(4), 
      Data_From_FE(3)=>Data_From_FE(3), Data_From_FE(2)=>Data_From_FE(2), 
      Data_From_FE(1)=>Data_From_FE(1), Data_From_FE(0)=>Data_From_FE(0), 
      Data_o_temp(15)=>Mem_Data_o(15), Data_o_temp(14)=>Mem_Data_o(14), 
      Data_o_temp(13)=>Mem_Data_o(13), Data_o_temp(12)=>Mem_Data_o(12), 
      Data_o_temp(11)=>Mem_Data_o(11), Data_o_temp(10)=>Mem_Data_o(10), 
      Data_o_temp(9)=>Mem_Data_o(9), Data_o_temp(8)=>Mem_Data_o(8), 
      Data_o_temp(7)=>Mem_Data_o(7), Data_o_temp(6)=>Mem_Data_o(6), 
      Data_o_temp(5)=>Mem_Data_o(5), Data_o_temp(4)=>Mem_Data_o(4), 
      Data_o_temp(3)=>Mem_Data_o(3), Data_o_temp(2)=>Mem_Data_o(2), 
      Data_o_temp(1)=>Mem_Data_o(1), Data_o_temp(0)=>Mem_Data_o(0), 
      Ext_Trigger=>Ext_Trigger, Goldenberg=>PWR, Good_data_block_recieved=>
      Good_data_block_recieved, Handshake_Error=>Tok_EXMPLR2801, M1760=>
      M1760, MEM_Data_out_wide(31)=>CPU_Side_MEM_Data_o(31), 
      MEM_Data_out_wide(30)=>CPU_Side_MEM_Data_o(30), MEM_Data_out_wide(29)
      =>CPU_Side_MEM_Data_o(29), MEM_Data_out_wide(28)=>
      CPU_Side_MEM_Data_o(28), MEM_Data_out_wide(27)=>
      CPU_Side_MEM_Data_o(27), MEM_Data_out_wide(26)=>
      CPU_Side_MEM_Data_o(26), MEM_Data_out_wide(25)=>
      CPU_Side_MEM_Data_o(25), MEM_Data_out_wide(24)=>
      CPU_Side_MEM_Data_o(24), MEM_Data_out_wide(23)=>
      CPU_Side_MEM_Data_o(23), MEM_Data_out_wide(22)=>
      CPU_Side_MEM_Data_o(22), MEM_Data_out_wide(21)=>
      CPU_Side_MEM_Data_o(21), MEM_Data_out_wide(20)=>
      CPU_Side_MEM_Data_o(20), MEM_Data_out_wide(19)=>
      CPU_Side_MEM_Data_o(19), MEM_Data_out_wide(18)=>
      CPU_Side_MEM_Data_o(18), MEM_Data_out_wide(17)=>
      CPU_Side_MEM_Data_o(17), MEM_Data_out_wide(16)=>
      CPU_Side_MEM_Data_o(16), MEM_Data_out_wide(15)=>
      CPU_Side_MEM_Data_o(15), MEM_Data_out_wide(14)=>
      CPU_Side_MEM_Data_o(14), MEM_Data_out_wide(13)=>
      CPU_Side_MEM_Data_o(13), MEM_Data_out_wide(12)=>
      CPU_Side_MEM_Data_o(12), MEM_Data_out_wide(11)=>
      CPU_Side_MEM_Data_o(11), MEM_Data_out_wide(10)=>
      CPU_Side_MEM_Data_o(10), MEM_Data_out_wide(9)=>CPU_Side_MEM_Data_o(9), 
      MEM_Data_out_wide(8)=>CPU_Side_MEM_Data_o(8), MEM_Data_out_wide(7)=>
      CPU_Side_MEM_Data_o(7), MEM_Data_out_wide(6)=>CPU_Side_MEM_Data_o(6), 
      MEM_Data_out_wide(5)=>CPU_Side_MEM_Data_o(5), MEM_Data_out_wide(4)=>
      CPU_Side_MEM_Data_o(4), MEM_Data_out_wide(3)=>CPU_Side_MEM_Data_o(3), 
      MEM_Data_out_wide(2)=>CPU_Side_MEM_Data_o(2), MEM_Data_out_wide(1)=>
      CPU_Side_MEM_Data_o(1), MEM_Data_out_wide(0)=>CPU_Side_MEM_Data_o(0), 
      MEM_nREG=>MEM_nREG, MIL1553_errors_Inhibit_TF=>
      mil1553_errors_Inhibit_TF, MIL1553_errors_invalid_command=>
      Tok_EXMPLR2801, MIL1553_errors_RT2RT_format_gap=>Tok_EXMPLR2801, 
      MIL1553_errors_RT2RT_format_error=>Tok_EXMPLR2801, 
      MIL1553_errors_Invalid_word=>Tok_EXMPLR2801, 
      MIL1553_errors_Parity_Manchester=>Tok_EXMPLR2801, 
      MIL1553_errors_incorrect_data_sync=>Tok_EXMPLR2801, 
      MIL1553_errors_Low_word_count=>Tok_EXMPLR2801, 
      MIL1553_errors_high_word_count=>Tok_EXMPLR2801, 
      MIL1553_errors_Format_error=>mil1553_errors_Format_error, 
      MIL1553_errors_Message_Error_set=>mil1553_errors_Message_Error_set, 
      MIL1553_errors_Address_Parity=>Tok_EXMPLR2801, 
      MIL1553_errors_echo_back_bus_B=>mil1553_errors_echo_back_bus_B, 
      MIL1553_errors_echo_back_bus_A=>mil1553_errors_echo_back_bus_A, 
      MIL1553_errors_bus_B_shutdown=>mil1553_errors_bus_B_shutdown, 
      MIL1553_errors_bus_A_shutdown=>mil1553_errors_bus_A_shutdown, 
      MIL1553_errors_transmitter_timout=>mil1553_errors_transmitter_timout, 
      Message_ended_OK=>Message_ended_OK, Message_ended_not_OK=>
      Message_ended_not_OK, Monitor_Active_command(15)=>
      Monitor_active_command(15), Monitor_Active_command(14)=>
      Monitor_active_command(14), Monitor_Active_command(13)=>
      Monitor_active_command(13), Monitor_Active_command(12)=>
      Monitor_active_command(12), Monitor_Active_command(11)=>
      Monitor_active_command(11), Monitor_Active_command(10)=>
      Monitor_active_command(10), Monitor_Active_command(9)=>
      Monitor_active_command(9), Monitor_Active_command(8)=>
      Monitor_active_command(8), Monitor_Active_command(7)=>
      Monitor_active_command(7), Monitor_Active_command(6)=>
      Monitor_active_command(6), Monitor_Active_command(5)=>
      Monitor_active_command(5), Monitor_Active_command(4)=>
      Monitor_active_command(4), Monitor_Active_command(3)=>
      Monitor_active_command(3), Monitor_Active_command(2)=>
      Monitor_active_command(2), Monitor_Active_command(1)=>
      Monitor_active_command(1), Monitor_Active_command(0)=>
      Monitor_active_command(0), Monitor_Ended_not_OK=>Monitor_ended_not_OK, 
      Monitor_MIL1553_errors_Inhibit_TF=>Monitor_MIL1553_errors_Inhibit_TF, 
      Monitor_MIL1553_errors_invalid_command=>
      Monitor_MIL1553_errors_invalid_command, 
      Monitor_MIL1553_errors_RT2RT_format_gap=>
      Monitor_MIL1553_errors_RT2RT_format_gap, 
      Monitor_MIL1553_errors_RT2RT_format_error=>
      Monitor_MIL1553_errors_RT2RT_format_error, 
      Monitor_MIL1553_errors_Invalid_word=>
      Monitor_MIL1553_errors_Invalid_word, 
      Monitor_MIL1553_errors_Parity_Manchester=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_incorrect_data_sync=>
      Monitor_MIL1553_errors_incorrect_data_sync, 
      Monitor_MIL1553_errors_Low_word_count=>
      Monitor_MIL1553_errors_Low_word_count, 
      Monitor_MIL1553_errors_high_word_count=>
      Monitor_MIL1553_errors_high_word_count, 
      Monitor_MIL1553_errors_Format_error=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_Message_Error_set=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_Address_Parity=>
      Monitor_MIL1553_errors_Address_Parity, 
      Monitor_MIL1553_errors_echo_back_bus_B=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_echo_back_bus_A=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_bus_B_shutdown=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_bus_A_shutdown=>Tok_EXMPLR2801, 
      Monitor_MIL1553_errors_transmitter_timout=>Tok_EXMPLR2801, 
      Monitor_RT2RT_Message=>Monitor_RT2RT_message, Monitor_bus_a=>
      Monitor_Bus_A, Monitor_ended_OK=>Monitor_ended_OK, Monitor_new_command
      =>Monitor_New_command, Monitor_write=>Monitor_Write, 
      Monitor_write_data(15)=>Monitor_Write_Data(15), Monitor_write_data(14)
      =>Monitor_Write_Data(14), Monitor_write_data(13)=>
      Monitor_Write_Data(13), Monitor_write_data(12)=>Monitor_Write_Data(12), 
      Monitor_write_data(11)=>Monitor_Write_Data(11), Monitor_write_data(10)
      =>Monitor_Write_Data(10), Monitor_write_data(9)=>Monitor_Write_Data(9), 
      Monitor_write_data(8)=>Monitor_Write_Data(8), Monitor_write_data(7)=>
      Monitor_Write_Data(7), Monitor_write_data(6)=>Monitor_Write_Data(6), 
      Monitor_write_data(5)=>Monitor_Write_Data(5), Monitor_write_data(4)=>
      Monitor_Write_Data(4), Monitor_write_data(3)=>Monitor_Write_Data(3), 
      Monitor_write_data(2)=>Monitor_Write_Data(2), Monitor_write_data(1)=>
      Monitor_Write_Data(1), Monitor_write_data(0)=>Monitor_Write_Data(0), 
      New_command=>New_command, RT2RT_Message=>RT2RT_message, RTAD(4)=>
      RTAD(4), RTAD(3)=>RTAD(3), RTAD(2)=>RTAD(2), RTAD(1)=>RTAD(1), RTAD(0)
      =>RTAD(0), RTADP=>RTADP, RTAD_SW_EN=>RTAD_SW_EN, RT_ADR_LAT=>
      RT_ADR_LAT, Raw_resetN=>Raw_resetN, Read=>Read, Set_SSFLAG=>Set_SSFLAG, 
      Strobe_TT=>Strobe_TT, Tag_CLK=>Tag_CLK, Tails_data_out_wide(31)=>
      Tok_EXMPLR2801, Tails_data_out_wide(30)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(29)=>Tok_EXMPLR2801, Tails_data_out_wide(28)=>
      Tok_EXMPLR2801, Tails_data_out_wide(27)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(26)=>Tok_EXMPLR2801, Tails_data_out_wide(25)=>
      Tok_EXMPLR2801, Tails_data_out_wide(24)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(23)=>Tok_EXMPLR2801, Tails_data_out_wide(22)=>
      Tok_EXMPLR2801, Tails_data_out_wide(21)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(20)=>Tok_EXMPLR2801, Tails_data_out_wide(19)=>
      Tok_EXMPLR2801, Tails_data_out_wide(18)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(17)=>Tok_EXMPLR2801, Tails_data_out_wide(16)=>
      Tok_EXMPLR2801, Tails_data_out_wide(15)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(14)=>Tok_EXMPLR2801, Tails_data_out_wide(13)=>
      Tok_EXMPLR2801, Tails_data_out_wide(12)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(11)=>Tok_EXMPLR2801, Tails_data_out_wide(10)=>
      Tok_EXMPLR2801, Tails_data_out_wide(9)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(8)=>Tok_EXMPLR2801, Tails_data_out_wide(7)=>
      Tok_EXMPLR2801, Tails_data_out_wide(6)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(5)=>Tok_EXMPLR2801, Tails_data_out_wide(4)=>
      Tok_EXMPLR2801, Tails_data_out_wide(3)=>Tok_EXMPLR2801, 
      Tails_data_out_wide(2)=>Tok_EXMPLR2801, Tails_data_out_wide(1)=>
      Tok_EXMPLR2801, Tails_data_out_wide(0)=>Tok_EXMPLR2801, Tx_InhB=>
      Tx_InhB, Tx_inhA=>Tx_inhA, WM_Descriptor(15)=>WM_Descriptor_15, 
      WM_Descriptor(14)=>WM_Descriptor_14, WM_Descriptor(13)=>
      WM_Descriptor_13, WM_Descriptor(12)=>WM_Descriptor_12, 
      WM_Descriptor(11)=>WM_Descriptor_11, WM_Descriptor(10)=>
      WM_Descriptor_10, WM_Descriptor(9)=>WM_Descriptor_9, WM_Descriptor(8)
      =>WM_Descriptor_8, WM_Descriptor(7)=>WM_Descriptor_7, WM_Descriptor(6)
      =>Tok_EXMPLR2801, WM_Descriptor(5)=>WM_Descriptor_5, WM_Descriptor(4)
      =>WM_Descriptor_4, WM_Descriptor(3)=>WM_Descriptor_3, WM_Descriptor(2)
      =>WM_Descriptor_2, WM_Descriptor(1)=>WM_Descriptor_1, WM_Descriptor(0)
      =>WM_Descriptor_0, WM_Req=>WM_Req, WM_Word(15)=>WM_Word(15), 
      WM_Word(14)=>WM_Word(14), WM_Word(13)=>WM_Word(13), WM_Word(12)=>
      WM_Word(12), WM_Word(11)=>WM_Word(11), WM_Word(10)=>WM_Word(10), 
      WM_Word(9)=>WM_Word(9), WM_Word(8)=>WM_Word(8), WM_Word(7)=>WM_Word(7), 
      WM_Word(6)=>WM_Word(6), WM_Word(5)=>WM_Word(5), WM_Word(4)=>WM_Word(4), 
      WM_Word(3)=>WM_Word(3), WM_Word(2)=>WM_Word(2), WM_Word(1)=>WM_Word(1), 
      WM_Word(0)=>WM_Word(0), Write=>Write, bus_A=>bus_A, clock=>clock, 
      last_command(15)=>Last_command(15), last_command(14)=>Last_command(14), 
      last_command(13)=>Last_command(13), last_command(12)=>Last_command(12), 
      last_command(11)=>Last_command(11), last_command(10)=>Last_command(10), 
      last_command(9)=>Last_command(9), last_command(8)=>Last_command(8), 
      last_command(7)=>Last_command(7), last_command(6)=>Last_command(6), 
      last_command(5)=>Last_command(5), last_command(4)=>Last_command(4), 
      last_command(3)=>Last_command(3), last_command(2)=>Last_command(2), 
      last_command(1)=>Last_command(1), last_command(0)=>Last_command(0), 
      pTDR_INT=>Tok_EXMPLR2801, ADDr_i_A(15)=>Mem_Address(15), ADDr_i_A(14)
      =>Mem_Address(14), ADDr_i_A(13)=>Mem_Address(13), ADDr_i_A(12)=>
      Mem_Address(12), ADDr_i_A(11)=>Mem_Address(11), ADDr_i_A(10)=>
      Mem_Address(10), ADDr_i_A(9)=>Mem_Address(9), ADDr_i_A(8)=>
      Mem_Address(8), ADDr_i_A(7)=>Mem_Address(7), ADDr_i_A(6)=>
      Mem_Address(6), ADDr_i_A(5)=>Mem_Address(5), ADDr_i_A(4)=>
      Mem_Address(4), ADDr_i_A(3)=>Mem_Address(3), ADDr_i_A(2)=>
      Mem_Address(2), ADDr_i_A(1)=>Mem_Address(1), ADDr_i_A(0)=>
      Mem_Address(0), BC_FE_ResetN=>BC_STM_ResetN, BC_RT2RT=>BC_RT2RT, 
      BC_Test=>BC_Test, BIT_Word(15)=>BIT_word(15), BIT_Word(14)=>
      BIT_word(14), BIT_Word(13)=>BIT_word(13), BIT_Word(12)=>BIT_word(12), 
      BIT_Word(11)=>BIT_word(11), BIT_Word(10)=>BIT_word(10), BIT_Word(9)=>
      BIT_word(9), BIT_Word(8)=>BIT_word(8), BIT_Word(7)=>BIT_word(7), 
      BIT_Word(6)=>BIT_word(6), BIT_Word(5)=>BIT_word(5), BIT_Word(4)=>
      BIT_word(4), BIT_Word(3)=>BIT_word(3), BIT_Word(2)=>BIT_word(2), 
      BIT_Word(1)=>BIT_word(1), BIT_Word(0)=>BIT_word(0), BUSY_in_LUT=>
      BUSY_in_LUT, CPU_Data_out_wide(31)=>CPU_Data_out_wide(31), 
      CPU_Data_out_wide(30)=>CPU_Data_out_wide(30), CPU_Data_out_wide(29)=>
      CPU_Data_out_wide(29), CPU_Data_out_wide(28)=>CPU_Data_out_wide(28), 
      CPU_Data_out_wide(27)=>CPU_Data_out_wide(27), CPU_Data_out_wide(26)=>
      CPU_Data_out_wide(26), CPU_Data_out_wide(25)=>CPU_Data_out_wide(25), 
      CPU_Data_out_wide(24)=>CPU_Data_out_wide(24), CPU_Data_out_wide(23)=>
      CPU_Data_out_wide(23), CPU_Data_out_wide(22)=>CPU_Data_out_wide(22), 
      CPU_Data_out_wide(21)=>CPU_Data_out_wide(21), CPU_Data_out_wide(20)=>
      CPU_Data_out_wide(20), CPU_Data_out_wide(19)=>CPU_Data_out_wide(19), 
      CPU_Data_out_wide(18)=>CPU_Data_out_wide(18), CPU_Data_out_wide(17)=>
      CPU_Data_out_wide(17), CPU_Data_out_wide(16)=>CPU_Data_out_wide(16), 
      CPU_Data_out_wide(15)=>CPU_Data_out_wide(15), CPU_Data_out_wide(14)=>
      CPU_Data_out_wide(14), CPU_Data_out_wide(13)=>CPU_Data_out_wide(13), 
      CPU_Data_out_wide(12)=>CPU_Data_out_wide(12), CPU_Data_out_wide(11)=>
      CPU_Data_out_wide(11), CPU_Data_out_wide(10)=>CPU_Data_out_wide(10), 
      CPU_Data_out_wide(9)=>CPU_Data_out_wide(9), CPU_Data_out_wide(8)=>
      CPU_Data_out_wide(8), CPU_Data_out_wide(7)=>CPU_Data_out_wide(7), 
      CPU_Data_out_wide(6)=>CPU_Data_out_wide(6), CPU_Data_out_wide(5)=>
      CPU_Data_out_wide(5), CPU_Data_out_wide(4)=>CPU_Data_out_wide(4), 
      CPU_Data_out_wide(3)=>CPU_Data_out_wide(3), CPU_Data_out_wide(2)=>
      CPU_Data_out_wide(2), CPU_Data_out_wide(1)=>CPU_Data_out_wide(1), 
      CPU_Data_out_wide(0)=>CPU_Data_out_wide(0), Data_i_A(15)=>
      Mem_data_in(15), Data_i_A(14)=>Mem_data_in(14), Data_i_A(13)=>
      Mem_data_in(13), Data_i_A(12)=>Mem_data_in(12), Data_i_A(11)=>
      Mem_data_in(11), Data_i_A(10)=>Mem_data_in(10), Data_i_A(9)=>
      Mem_data_in(9), Data_i_A(8)=>Mem_data_in(8), Data_i_A(7)=>
      Mem_data_in(7), Data_i_A(6)=>Mem_data_in(6), Data_i_A(5)=>
      Mem_data_in(5), Data_i_A(4)=>Mem_data_in(4), Data_i_A(3)=>
      Mem_data_in(3), Data_i_A(2)=>Mem_data_in(2), Data_i_A(1)=>
      Mem_data_in(1), Data_i_A(0)=>Mem_data_in(0), ENC_TEST_GO=>ENC_TEST_Go, 
      ENC_TEST_on=>ENC_TEST_On, INTn=>INTn, IP_Freq_sel(1)=>DANGLING(0), 
      IP_Freq_sel(0)=>DANGLING(1), No_Response_timeout(2)=>
      No_Response_timeout(2), No_Response_timeout(1)=>No_Response_timeout(1), 
      No_Response_timeout(0)=>No_Response_timeout(0), RE_A=>Mem_RE, TT_Load
      =>DANGLING(2), Tails_WE_vec(1)=>DANGLING(3), Tails_WE_vec(0)=>DANGLING
      (4), WE_A=>mem_WE, debug(15)=>DANGLING(5), debug(14)=>DANGLING(6), 
      debug(13)=>DANGLING(7), debug(12)=>DANGLING(8), debug(11)=>DANGLING(9), 
      debug(10)=>DANGLING(10), debug(9)=>DANGLING(11), debug(8)=>DANGLING(12
      ), debug(7)=>DANGLING(13), debug(6)=>DANGLING(14), debug(5)=>DANGLING(
      15), debug(4)=>DANGLING(16), debug(3)=>DANGLING(17), debug(2)=>
      DANGLING(18), debug(1)=>DANGLING(19), debug(0)=>DANGLING(20), 
      mem_WE_vec(1)=>CPU_Side_WE(1), mem_WE_vec(0)=>CPU_Side_WE(0), 
      n16Mhz_12=>DANGLING(21), one_micro_increment=>one_micro_increment, 
      pTDR_CS=>DANGLING(22), record_message_A=>Monitor_Record_command_A, 
      record_message_B=>Monitor_Record_command_B, BC_1553A=>BC_1553A, 
      BC_BUS_A=>BC_BUS_A, BC_Go=>BC_Go, BC_TX_Data(15)=>BC_TX_Data(15), 
      BC_TX_Data(14)=>BC_TX_Data(14), BC_TX_Data(13)=>BC_TX_Data(13), 
      BC_TX_Data(12)=>BC_TX_Data(12), BC_TX_Data(11)=>BC_TX_Data(11), 
      BC_TX_Data(10)=>BC_TX_Data(10), BC_TX_Data(9)=>BC_TX_Data(9), 
      BC_TX_Data(8)=>BC_TX_Data(8), BC_TX_Data(7)=>BC_TX_Data(7), 
      BC_TX_Data(6)=>BC_TX_Data(6), BC_TX_Data(5)=>BC_TX_Data(5), 
      BC_TX_Data(4)=>BC_TX_Data(4), BC_TX_Data(3)=>BC_TX_Data(3), 
      BC_TX_Data(2)=>BC_TX_Data(2), BC_TX_Data(1)=>BC_TX_Data(1), 
      BC_TX_Data(0)=>BC_TX_Data(0), BC_on=>BC_on_EXMPLR2783, 
      Config_reg_4(15)=>DANGLING(23), Config_reg_4(14)=>DANGLING(24), 
      Config_reg_4(13)=>DANGLING(25), Config_reg_4(12)=>DANGLING(26), 
      Config_reg_4(11)=>DANGLING(27), Config_reg_4(10)=>DANGLING(28), 
      Config_reg_4(9)=>DANGLING(29), Config_reg_4(8)=>DANGLING(30), 
      Config_reg_4(7)=>DANGLING(31), Config_reg_4(6)=>Config_reg_4_6, 
      Config_reg_4(5)=>Config_reg_4_5, Config_reg_4(4)=>DANGLING(32), 
      Config_reg_4(3)=>DANGLING(33), Config_reg_4(2)=>DANGLING(34), 
      Config_reg_4(1)=>DANGLING(35), Config_reg_4(0)=>DANGLING(36), 
      Data_to_FE(15)=>Data_to_FE(15), Data_to_FE(14)=>Data_to_FE(14), 
      Data_to_FE(13)=>Data_to_FE(13), Data_to_FE(12)=>Data_to_FE(12), 
      Data_to_FE(11)=>Data_to_FE(11), Data_to_FE(10)=>Data_to_FE(10), 
      Data_to_FE(9)=>Data_to_FE(9), Data_to_FE(8)=>Data_to_FE(8), 
      Data_to_FE(7)=>Data_to_FE(7), Data_to_FE(6)=>Data_to_FE(6), 
      Data_to_FE(5)=>Data_to_FE(5), Data_to_FE(4)=>Data_to_FE(4), 
      Data_to_FE(3)=>Data_to_FE(3), Data_to_FE(2)=>Data_to_FE(2), 
      Data_to_FE(1)=>Data_to_FE(1), Data_to_FE(0)=>Data_to_FE(0), Do_illegal
      =>Do_illegal, MODE_CODE1553A=>MODE_CODE1553A, NO_BCST=>DANGLING(37), 
      RT_Address(5)=>DANGLING(38), RT_Address(4)=>DANGLING(39), 
      RT_Address(3)=>DANGLING(40), RT_Address(2)=>DANGLING(41), 
      RT_Address(1)=>DANGLING(42), RT_Address(0)=>DANGLING(43), RT_On=>RT_On, 
      ResetN=>ResetN, WM_Ack=>WM_Ack, WM_Started=>WM_Started, 
      host_status_bits(10)=>Host_Status_Bits(10), host_status_bits(9)=>
      Host_Status_Bits(9), host_status_bits(8)=>Host_Status_Bits(8), 
      host_status_bits(7)=>Host_Status_Bits(7), host_status_bits(6)=>
      Host_Status_Bits(6), host_status_bits(5)=>Host_Status_Bits(5), 
      host_status_bits(4)=>Host_Status_Bits(4), host_status_bits(3)=>
      Host_Status_Bits(3), host_status_bits(2)=>Host_Status_Bits(2), 
      host_status_bits(1)=>Host_Status_Bits(1), host_status_bits(0)=>
      Host_Status_Bits(0), illegal_message=>illegal_command, time_tag(15)=>
      time_tag(15), time_tag(14)=>time_tag(14), time_tag(13)=>time_tag(13), 
      time_tag(12)=>time_tag(12), time_tag(11)=>time_tag(11), time_tag(10)=>
      time_tag(10), time_tag(9)=>time_tag(9), time_tag(8)=>time_tag(8), 
      time_tag(7)=>time_tag(7), time_tag(6)=>time_tag(6), time_tag(5)=>
      time_tag(5), time_tag(4)=>time_tag(4), time_tag(3)=>time_tag(3), 
      time_tag(2)=>time_tag(2), time_tag(1)=>time_tag(1), time_tag(0)=>
      time_tag(0));
   RT : RT_Real_switch_BRM_ver8_4_RTLC_LONGENT2 port map ( Aux_in(15)=>
      Tok_EXMPLR2801, Aux_in(14)=>Tok_EXMPLR2801, Aux_in(13)=>Tok_EXMPLR2801, 
      Aux_in(12)=>Tok_EXMPLR2801, Aux_in(11)=>Tok_EXMPLR2801, Aux_in(10)=>
      Tok_EXMPLR2801, Aux_in(9)=>Tok_EXMPLR2801, Aux_in(8)=>Tok_EXMPLR2801, 
      Aux_in(7)=>Tok_EXMPLR2801, Aux_in(6)=>Tok_EXMPLR2801, Aux_in(5)=>
      Tok_EXMPLR2801, Aux_in(4)=>Tok_EXMPLR2801, Aux_in(3)=>Tok_EXMPLR2801, 
      Aux_in(2)=>Tok_EXMPLR2801, Aux_in(1)=>Tok_EXMPLR2801, Aux_in(0)=>
      Tok_EXMPLR2801, BC_Active_Bus_A=>Tx_Bus_A, BC_Go=>BC_Go_Tx, BC_T_sync
      =>T_Sync, BC_Transmit_data(15)=>BC_Transmit_data(15), 
      BC_Transmit_data(14)=>BC_Transmit_data(14), BC_Transmit_data(13)=>
      BC_Transmit_data(13), BC_Transmit_data(12)=>BC_Transmit_data(12), 
      BC_Transmit_data(11)=>BC_Transmit_data(11), BC_Transmit_data(10)=>
      BC_Transmit_data(10), BC_Transmit_data(9)=>BC_Transmit_data(9), 
      BC_Transmit_data(8)=>BC_Transmit_data(8), BC_Transmit_data(7)=>
      BC_Transmit_data(7), BC_Transmit_data(6)=>BC_Transmit_data(6), 
      BC_Transmit_data(5)=>BC_Transmit_data(5), BC_Transmit_data(4)=>
      BC_Transmit_data(4), BC_Transmit_data(3)=>BC_Transmit_data(3), 
      BC_Transmit_data(2)=>BC_Transmit_data(2), BC_Transmit_data(1)=>
      BC_Transmit_data(1), BC_Transmit_data(0)=>BC_Transmit_data(0), BC_mode
      =>BC_on_EXMPLR2783, BIT_word(15)=>BIT_word(15), BIT_word(14)=>
      BIT_word(14), BIT_word(13)=>BIT_word(13), BIT_word(12)=>BIT_word(12), 
      BIT_word(11)=>BIT_word(11), BIT_word(10)=>BIT_word(10), BIT_word(9)=>
      BIT_word(9), BIT_word(8)=>BIT_word(8), BIT_word(7)=>BIT_word(7), 
      BIT_word(6)=>BIT_word(6), BIT_word(5)=>BIT_word(5), BIT_word(4)=>
      BIT_word(4), BIT_word(3)=>BIT_word(3), BIT_word(2)=>BIT_word(2), 
      BIT_word(1)=>BIT_word(1), BIT_word(0)=>BIT_word(0), BUSY_in_LUT=>
      BUSY_in_LUT, CPU_ResetN=>ResetN, Clock=>clock, Cohen=>PWR, Data_in(15)
      =>Data_to_FE(15), Data_in(14)=>Data_to_FE(14), Data_in(13)=>
      Data_to_FE(13), Data_in(12)=>Data_to_FE(12), Data_in(11)=>
      Data_to_FE(11), Data_in(10)=>Data_to_FE(10), Data_in(9)=>Data_to_FE(9), 
      Data_in(8)=>Data_to_FE(8), Data_in(7)=>Data_to_FE(7), Data_in(6)=>
      Data_to_FE(6), Data_in(5)=>Data_to_FE(5), Data_in(4)=>Data_to_FE(4), 
      Data_in(3)=>Data_to_FE(3), Data_in(2)=>Data_to_FE(2), Data_in(1)=>
      Data_to_FE(1), Data_in(0)=>Data_to_FE(0), Do_illegal=>Do_illegal, 
      ENC_TEST_On=>ENC_TEST_On, External_CE_In=>Tok_EXMPLR2801, 
      Host_Status_Bits(10)=>Host_Status_Bits(10), Host_Status_Bits(9)=>
      Host_Status_Bits(9), Host_Status_Bits(8)=>Host_Status_Bits(8), 
      Host_Status_Bits(7)=>Host_Status_Bits(7), Host_Status_Bits(6)=>
      Host_Status_Bits(6), Host_Status_Bits(5)=>Host_Status_Bits(5), 
      Host_Status_Bits(4)=>Host_Status_Bits(4), Host_Status_Bits(3)=>
      Host_Status_Bits(3), Host_Status_Bits(2)=>Host_Status_Bits(2), 
      Host_Status_Bits(1)=>Host_Status_Bits(1), Host_Status_Bits(0)=>
      Host_Status_Bits(0), MODE_CODE1553A=>MODE_CODE1553A, Minus_A=>Minus_A, 
      Minus_B=>Minus_B, NO_BCST=>Tok_EXMPLR2801, No_Response_timeout(2)=>
      No_Response_timeout(2), No_Response_timeout(1)=>No_Response_timeout(1), 
      No_Response_timeout(0)=>No_Response_timeout(0), Plus_A=>Plus_A, Plus_B
      =>Plus_B, RT_Address_wire(5)=>Tok_EXMPLR2801, RT_Address_wire(4)=>
      Tok_EXMPLR2801, RT_Address_wire(3)=>Tok_EXMPLR2801, RT_Address_wire(2)
      =>Tok_EXMPLR2801, RT_Address_wire(1)=>Tok_EXMPLR2801, 
      RT_Address_wire(0)=>Tok_EXMPLR2801, RT_On=>RT_On, Tx_Inh_A_in=>Tx_inhA, 
      Tx_Inh_B_in=>Tx_InhB, Wrap_Address(4)=>Tok_EXMPLR2801, Wrap_Address(3)
      =>Tok_EXMPLR2801, Wrap_Address(2)=>Tok_EXMPLR2801, Wrap_Address(1)=>
      Tok_EXMPLR2801, Wrap_Address(0)=>Tok_EXMPLR2801, illegal_command=>
      illegal_command, loopback_test=>BC_Test, Address(15)=>DANGLING(44), 
      Address(14)=>DANGLING(45), Address(13)=>DANGLING(46), Address(12)=>
      DANGLING(47), Address(11)=>DANGLING(48), Address(10)=>Address(10), 
      Address(9)=>Address(9), Address(8)=>Address(8), Address(7)=>Address(7), 
      Address(6)=>Address(6), Address(5)=>Address(5), Address(4)=>Address(4), 
      Address(3)=>Address(3), Address(2)=>Address(2), Address(1)=>Address(1), 
      Address(0)=>Address(0), BC_TxRdy=>Tx_Rdy, BUS_A=>bus_A, Clock_enable=>
      CE_out_EXMPLR2706, Current_command(15)=>Current_command(15), 
      Current_command(14)=>Current_command(14), Current_command(13)=>
      Current_command(13), Current_command(12)=>Current_command(12), 
      Current_command(11)=>Current_command(11), Current_command(10)=>
      Current_command(10), Current_command(9)=>Current_command(9), 
      Current_command(8)=>Current_command(8), Current_command(7)=>
      Current_command(7), Current_command(6)=>Current_command(6), 
      Current_command(5)=>Current_command(5), Current_command(4)=>
      Current_command(4), Current_command(3)=>Current_command(3), 
      Current_command(2)=>Current_command(2), Current_command(1)=>
      Current_command(1), Current_command(0)=>Current_command(0), 
      Data_out(15)=>Data_From_FE(15), Data_out(14)=>Data_From_FE(14), 
      Data_out(13)=>Data_From_FE(13), Data_out(12)=>Data_From_FE(12), 
      Data_out(11)=>Data_From_FE(11), Data_out(10)=>Data_From_FE(10), 
      Data_out(9)=>Data_From_FE(9), Data_out(8)=>Data_From_FE(8), 
      Data_out(7)=>Data_From_FE(7), Data_out(6)=>Data_From_FE(6), 
      Data_out(5)=>Data_From_FE(5), Data_out(4)=>Data_From_FE(4), 
      Data_out(3)=>Data_From_FE(3), Data_out(2)=>Data_From_FE(2), 
      Data_out(1)=>Data_From_FE(1), Data_out(0)=>Data_From_FE(0), 
      Last_command(15)=>Last_command(15), Last_command(14)=>Last_command(14), 
      Last_command(13)=>Last_command(13), Last_command(12)=>Last_command(12), 
      Last_command(11)=>Last_command(11), Last_command(10)=>Last_command(10), 
      Last_command(9)=>Last_command(9), Last_command(8)=>Last_command(8), 
      Last_command(7)=>Last_command(7), Last_command(6)=>Last_command(6), 
      Last_command(5)=>Last_command(5), Last_command(4)=>Last_command(4), 
      Last_command(3)=>Last_command(3), Last_command(2)=>Last_command(2), 
      Last_command(1)=>Last_command(1), Last_command(0)=>Last_command(0), 
      Message_ended_OK=>Message_ended_OK, New_Command=>New_command, 
      RT2RT_message=>RT2RT_message, Read=>Read, Revision(15)=>DANGLING(49), 
      Revision(14)=>DANGLING(50), Revision(13)=>DANGLING(51), Revision(12)=>
      DANGLING(52), Revision(11)=>DANGLING(53), Revision(10)=>DANGLING(54), 
      Revision(9)=>DANGLING(55), Revision(8)=>DANGLING(56), Revision(7)=>
      DANGLING(57), Revision(6)=>DANGLING(58), Revision(5)=>DANGLING(59), 
      Revision(4)=>DANGLING(60), Revision(3)=>DANGLING(61), Revision(2)=>
      DANGLING(62), Revision(1)=>DANGLING(63), Revision(0)=>DANGLING(64), 
      Tx_A=>Tx_A, Tx_A_N=>Tx_A_N, Tx_B=>Tx_B, Tx_B_N=>Tx_B_N, Tx_inh_A=>
      Tx_inh_A, Tx_inh_B=>Tx_inh_B, Write=>Write, mil1553_errors_Inhibit_TF
      =>mil1553_errors_Inhibit_TF, mil1553_errors_invalid_command=>DANGLING(
      65), mil1553_errors_RT2RT_format_gap=>DANGLING(66), 
      mil1553_errors_RT2RT_format_error=>DANGLING(67), 
      mil1553_errors_Invalid_word=>DANGLING(68), 
      mil1553_errors_Parity_Manchester=>DANGLING(69), 
      mil1553_errors_incorrect_data_sync=>DANGLING(70), 
      mil1553_errors_Low_word_count=>DANGLING(71), 
      mil1553_errors_high_word_count=>DANGLING(72), 
      mil1553_errors_Format_error=>mil1553_errors_Format_error, 
      mil1553_errors_Message_Error_set=>mil1553_errors_Message_Error_set, 
      mil1553_errors_Address_Parity=>DANGLING(73), 
      mil1553_errors_echo_back_bus_B=>mil1553_errors_echo_back_bus_B, 
      mil1553_errors_echo_back_bus_A=>mil1553_errors_echo_back_bus_A, 
      mil1553_errors_bus_B_shutdown=>mil1553_errors_bus_B_shutdown, 
      mil1553_errors_bus_A_shutdown=>mil1553_errors_bus_A_shutdown, 
      mil1553_errors_transmitter_timout=>mil1553_errors_transmitter_timout, 
      Channel_status(10)=>Channel_status(10), Channel_status(9)=>
      Channel_status(9), Channel_status(8)=>Channel_status(8), 
      Channel_status(7)=>Channel_status(7), Channel_status(6)=>
      Channel_status(6), Channel_status(5)=>Channel_status(5), 
      Channel_status(4)=>Channel_status(4), Channel_status(3)=>
      Channel_status(3), Channel_status(2)=>Channel_status(2), 
      Channel_status(1)=>Channel_status(1), Channel_status(0)=>
      Channel_status(0), H15530_record_A_Bit_number(4)=>DANGLING(74), 
      H15530_record_A_Bit_number(3)=>DANGLING(75), 
      H15530_record_A_Bit_number(2)=>DANGLING(76), 
      H15530_record_A_Bit_number(1)=>DANGLING(77), 
      H15530_record_A_Bit_number(0)=>DANGLING(78), 
      H15530_record_A_Response_Time(7)=>DANGLING(79), 
      H15530_record_A_Response_Time(6)=>DANGLING(80), 
      H15530_record_A_Response_Time(5)=>DANGLING(81), 
      H15530_record_A_Response_Time(4)=>DANGLING(82), 
      H15530_record_A_Response_Time(3)=>DANGLING(83), 
      H15530_record_A_Response_Time(2)=>DANGLING(84), 
      H15530_record_A_Response_Time(1)=>DANGLING(85), 
      H15530_record_A_Response_Time(0)=>DANGLING(86), 
      H15530_record_A_Sync_error=>DANGLING(87), 
      H15530_record_A_Manchester_error=>DANGLING(88), 
      H15530_record_A_Parity_error=>DANGLING(89), 
      H15530_record_A_echo_back_bus=>DANGLING(90), 
      H15530_record_A_R_Data(15)=>H15530_record_A_R_Data_EXMPLR2890(15), 
      H15530_record_A_R_Data(14)=>H15530_record_A_R_Data_EXMPLR2890(14), 
      H15530_record_A_R_Data(13)=>H15530_record_A_R_Data_EXMPLR2890(13), 
      H15530_record_A_R_Data(12)=>H15530_record_A_R_Data_EXMPLR2890(12), 
      H15530_record_A_R_Data(11)=>H15530_record_A_R_Data_EXMPLR2890(11), 
      H15530_record_A_R_Data(10)=>H15530_record_A_R_Data_EXMPLR2890(10), 
      H15530_record_A_R_Data(9)=>H15530_record_A_R_Data_EXMPLR2890(9), 
      H15530_record_A_R_Data(8)=>H15530_record_A_R_Data_EXMPLR2890(8), 
      H15530_record_A_R_Data(7)=>H15530_record_A_R_Data_EXMPLR2890(7), 
      H15530_record_A_R_Data(6)=>H15530_record_A_R_Data_EXMPLR2890(6), 
      H15530_record_A_R_Data(5)=>H15530_record_A_R_Data_EXMPLR2890(5), 
      H15530_record_A_R_Data(4)=>H15530_record_A_R_Data_EXMPLR2890(4), 
      H15530_record_A_R_Data(3)=>H15530_record_A_R_Data_EXMPLR2890(3), 
      H15530_record_A_R_Data(2)=>H15530_record_A_R_Data_EXMPLR2890(2), 
      H15530_record_A_R_Data(1)=>H15530_record_A_R_Data_EXMPLR2890(1), 
      H15530_record_A_R_Data(0)=>H15530_record_A_R_Data_EXMPLR2890(0), 
      H15530_record_A_RAW_GAP(6)=>H15530_record_A_RAW_GAP_EXMPLR2891(6), 
      H15530_record_A_RAW_GAP(5)=>H15530_record_A_RAW_GAP_EXMPLR2891(5), 
      H15530_record_A_RAW_GAP(4)=>H15530_record_A_RAW_GAP_EXMPLR2891(4), 
      H15530_record_A_RAW_GAP(3)=>H15530_record_A_RAW_GAP_EXMPLR2891(3), 
      H15530_record_A_RAW_GAP(2)=>H15530_record_A_RAW_GAP_EXMPLR2891(2), 
      H15530_record_A_RAW_GAP(1)=>H15530_record_A_RAW_GAP_EXMPLR2891(1), 
      H15530_record_A_RAW_GAP(0)=>H15530_record_A_RAW_GAP_EXMPLR2891(0), 
      H15530_record_A_GAP(6)=>H15530_record_A_GAP_EXMPLR2892(6), 
      H15530_record_A_GAP(5)=>H15530_record_A_GAP_EXMPLR2892(5), 
      H15530_record_A_GAP(4)=>H15530_record_A_GAP_EXMPLR2892(4), 
      H15530_record_A_GAP(3)=>H15530_record_A_GAP_EXMPLR2892(3), 
      H15530_record_A_GAP(2)=>H15530_record_A_GAP_EXMPLR2892(2), 
      H15530_record_A_GAP(1)=>H15530_record_A_GAP_EXMPLR2892(1), 
      H15530_record_A_GAP(0)=>H15530_record_A_GAP_EXMPLR2892(0), 
      H15530_record_A_Gap_found(2)=>H15530_record_A_Gap_found_EXMPLR2893(2), 
      H15530_record_A_Gap_found(1)=>H15530_record_A_Gap_found_EXMPLR2893(1), 
      H15530_record_A_Gap_found(0)=>H15530_record_A_Gap_found_EXMPLR2893(0), 
      H15530_record_A_RxRDY_plus_12us=>DANGLING(91), 
      H15530_record_A_RxRDY_plus_10us=>DANGLING(92), H15530_record_A_CS=>
      H15530_record_A_CS_EXMPLR2835, H15530_record_A_Pre_EchoRdy=>
      H15530_record_A_Pre_EchoRdy_EXMPLR2836, H15530_record_A_Command_Sync=>
      H15530_record_A_Command_Sync_EXMPLR2837, H15530_record_A_Pre_RxRdy=>
      H15530_record_A_Pre_RxRdy_EXMPLR2838, H15530_record_A_recieving=>
      H15530_record_A_recieving_EXMPLR2839, H15530_record_B_Bit_number(4)=>
      DANGLING(93), H15530_record_B_Bit_number(3)=>DANGLING(94), 
      H15530_record_B_Bit_number(2)=>DANGLING(95), 
      H15530_record_B_Bit_number(1)=>DANGLING(96), 
      H15530_record_B_Bit_number(0)=>DANGLING(97), 
      H15530_record_B_Response_Time(7)=>DANGLING(98), 
      H15530_record_B_Response_Time(6)=>DANGLING(99), 
      H15530_record_B_Response_Time(5)=>DANGLING(100), 
      H15530_record_B_Response_Time(4)=>DANGLING(101), 
      H15530_record_B_Response_Time(3)=>DANGLING(102), 
      H15530_record_B_Response_Time(2)=>DANGLING(103), 
      H15530_record_B_Response_Time(1)=>DANGLING(104), 
      H15530_record_B_Response_Time(0)=>DANGLING(105), 
      H15530_record_B_Sync_error=>DANGLING(106), 
      H15530_record_B_Manchester_error=>DANGLING(107), 
      H15530_record_B_Parity_error=>DANGLING(108), 
      H15530_record_B_echo_back_bus=>DANGLING(109), 
      H15530_record_B_R_Data(15)=>H15530_record_B_R_Data_EXMPLR2894(15), 
      H15530_record_B_R_Data(14)=>H15530_record_B_R_Data_EXMPLR2894(14), 
      H15530_record_B_R_Data(13)=>H15530_record_B_R_Data_EXMPLR2894(13), 
      H15530_record_B_R_Data(12)=>H15530_record_B_R_Data_EXMPLR2894(12), 
      H15530_record_B_R_Data(11)=>H15530_record_B_R_Data_EXMPLR2894(11), 
      H15530_record_B_R_Data(10)=>H15530_record_B_R_Data_EXMPLR2894(10), 
      H15530_record_B_R_Data(9)=>H15530_record_B_R_Data_EXMPLR2894(9), 
      H15530_record_B_R_Data(8)=>H15530_record_B_R_Data_EXMPLR2894(8), 
      H15530_record_B_R_Data(7)=>H15530_record_B_R_Data_EXMPLR2894(7), 
      H15530_record_B_R_Data(6)=>H15530_record_B_R_Data_EXMPLR2894(6), 
      H15530_record_B_R_Data(5)=>H15530_record_B_R_Data_EXMPLR2894(5), 
      H15530_record_B_R_Data(4)=>H15530_record_B_R_Data_EXMPLR2894(4), 
      H15530_record_B_R_Data(3)=>H15530_record_B_R_Data_EXMPLR2894(3), 
      H15530_record_B_R_Data(2)=>H15530_record_B_R_Data_EXMPLR2894(2), 
      H15530_record_B_R_Data(1)=>H15530_record_B_R_Data_EXMPLR2894(1), 
      H15530_record_B_R_Data(0)=>H15530_record_B_R_Data_EXMPLR2894(0), 
      H15530_record_B_RAW_GAP(6)=>H15530_record_B_RAW_GAP_EXMPLR2895(6), 
      H15530_record_B_RAW_GAP(5)=>H15530_record_B_RAW_GAP_EXMPLR2895(5), 
      H15530_record_B_RAW_GAP(4)=>H15530_record_B_RAW_GAP_EXMPLR2895(4), 
      H15530_record_B_RAW_GAP(3)=>H15530_record_B_RAW_GAP_EXMPLR2895(3), 
      H15530_record_B_RAW_GAP(2)=>H15530_record_B_RAW_GAP_EXMPLR2895(2), 
      H15530_record_B_RAW_GAP(1)=>H15530_record_B_RAW_GAP_EXMPLR2895(1), 
      H15530_record_B_RAW_GAP(0)=>H15530_record_B_RAW_GAP_EXMPLR2895(0), 
      H15530_record_B_GAP(6)=>H15530_record_B_GAP_EXMPLR2896(6), 
      H15530_record_B_GAP(5)=>H15530_record_B_GAP_EXMPLR2896(5), 
      H15530_record_B_GAP(4)=>H15530_record_B_GAP_EXMPLR2896(4), 
      H15530_record_B_GAP(3)=>H15530_record_B_GAP_EXMPLR2896(3), 
      H15530_record_B_GAP(2)=>H15530_record_B_GAP_EXMPLR2896(2), 
      H15530_record_B_GAP(1)=>H15530_record_B_GAP_EXMPLR2896(1), 
      H15530_record_B_GAP(0)=>H15530_record_B_GAP_EXMPLR2896(0), 
      H15530_record_B_Gap_found(2)=>H15530_record_B_Gap_found_EXMPLR2897(2), 
      H15530_record_B_Gap_found(1)=>H15530_record_B_Gap_found_EXMPLR2897(1), 
      H15530_record_B_Gap_found(0)=>H15530_record_B_Gap_found_EXMPLR2897(0), 
      H15530_record_B_RxRDY_plus_12us=>DANGLING(110), 
      H15530_record_B_RxRDY_plus_10us=>DANGLING(111), H15530_record_B_CS=>
      H15530_record_B_CS_EXMPLR2873, H15530_record_B_Pre_EchoRdy=>
      H15530_record_B_Pre_EchoRdy_EXMPLR2874, H15530_record_B_Command_Sync=>
      H15530_record_B_Command_Sync_EXMPLR2875, H15530_record_B_Pre_RxRdy=>
      H15530_record_B_Pre_RxRdy_EXMPLR2876, H15530_record_B_recieving=>
      H15530_record_B_recieving_EXMPLR2877, Message_ended_not_OK=>
      Message_ended_not_OK, RCV_A_Sync_error=>RCV_A_Sync_error, 
      RCV_B_Sync_error=>RCV_B_Sync_error);
   gMon_I3 : Monitor_two_channel_8_4_1_32 port map ( C=>clock, CE=>
      CE_out_EXMPLR2706, MODE_CODE1553A=>MODE_CODE1553A, NO_BCST=>
      Tok_EXMPLR2801, No_Response_timeout(2)=>No_Response_timeout(2), 
      No_Response_timeout(1)=>No_Response_timeout(1), No_Response_timeout(0)
      =>No_Response_timeout(0), R=>ResetN, RCV_A_Bit_number(4)=>
      Tok_EXMPLR2801, RCV_A_Bit_number(3)=>Tok_EXMPLR2801, 
      RCV_A_Bit_number(2)=>Tok_EXMPLR2801, RCV_A_Bit_number(1)=>
      Tok_EXMPLR2801, RCV_A_Bit_number(0)=>Tok_EXMPLR2801, 
      RCV_A_Response_Time(7)=>Tok_EXMPLR2801, RCV_A_Response_Time(6)=>
      Tok_EXMPLR2801, RCV_A_Response_Time(5)=>Tok_EXMPLR2801, 
      RCV_A_Response_Time(4)=>Tok_EXMPLR2801, RCV_A_Response_Time(3)=>
      Tok_EXMPLR2801, RCV_A_Response_Time(2)=>Tok_EXMPLR2801, 
      RCV_A_Response_Time(1)=>Tok_EXMPLR2801, RCV_A_Response_Time(0)=>
      Tok_EXMPLR2801, rtlc_RCV_A_Sync_error_n139=>Tok_EXMPLR2801, 
      RCV_A_Manchester_error=>Tok_EXMPLR2801, RCV_A_Parity_error=>
      Tok_EXMPLR2801, RCV_A_echo_back_bus=>Tok_EXMPLR2801, RCV_A_R_Data(15)
      =>H15530_record_A_R_Data_EXMPLR2890(15), RCV_A_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR2890(14), RCV_A_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR2890(13), RCV_A_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR2890(12), RCV_A_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR2890(11), RCV_A_R_Data(10)=>
      H15530_record_A_R_Data_EXMPLR2890(10), RCV_A_R_Data(9)=>
      H15530_record_A_R_Data_EXMPLR2890(9), RCV_A_R_Data(8)=>
      H15530_record_A_R_Data_EXMPLR2890(8), RCV_A_R_Data(7)=>
      H15530_record_A_R_Data_EXMPLR2890(7), RCV_A_R_Data(6)=>
      H15530_record_A_R_Data_EXMPLR2890(6), RCV_A_R_Data(5)=>
      H15530_record_A_R_Data_EXMPLR2890(5), RCV_A_R_Data(4)=>
      H15530_record_A_R_Data_EXMPLR2890(4), RCV_A_R_Data(3)=>
      H15530_record_A_R_Data_EXMPLR2890(3), RCV_A_R_Data(2)=>
      H15530_record_A_R_Data_EXMPLR2890(2), RCV_A_R_Data(1)=>
      H15530_record_A_R_Data_EXMPLR2890(1), RCV_A_R_Data(0)=>
      H15530_record_A_R_Data_EXMPLR2890(0), RCV_A_RAW_GAP(6)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(6), RCV_A_RAW_GAP(5)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(5), RCV_A_RAW_GAP(4)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(4), RCV_A_RAW_GAP(3)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(3), RCV_A_RAW_GAP(2)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(2), RCV_A_RAW_GAP(1)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(1), RCV_A_RAW_GAP(0)=>
      H15530_record_A_RAW_GAP_EXMPLR2891(0), RCV_A_GAP(6)=>Tok_EXMPLR2801, 
      RCV_A_GAP(5)=>Tok_EXMPLR2801, RCV_A_GAP(4)=>Tok_EXMPLR2801, 
      RCV_A_GAP(3)=>Tok_EXMPLR2801, RCV_A_GAP(2)=>Tok_EXMPLR2801, 
      RCV_A_GAP(1)=>Tok_EXMPLR2801, RCV_A_GAP(0)=>Tok_EXMPLR2801, 
      RCV_A_Gap_found(2)=>H15530_record_A_Gap_found_EXMPLR2893(2), 
      RCV_A_Gap_found(1)=>H15530_record_A_Gap_found_EXMPLR2893(1), 
      RCV_A_Gap_found(0)=>H15530_record_A_Gap_found_EXMPLR2893(0), 
      RCV_A_RxRDY_plus_12us=>Tok_EXMPLR2801, RCV_A_RxRDY_plus_10us=>
      Tok_EXMPLR2801, RCV_A_CS=>H15530_record_A_CS_EXMPLR2835, 
      RCV_A_Pre_EchoRdy=>H15530_record_A_Pre_EchoRdy_EXMPLR2836, 
      RCV_A_Command_Sync=>H15530_record_A_Command_Sync_EXMPLR2837, 
      RCV_A_Pre_RxRdy=>H15530_record_A_Pre_RxRdy_EXMPLR2838, RCV_A_recieving
      =>H15530_record_A_recieving_EXMPLR2839, RCV_A_Sync_Error=>
      RCV_A_Sync_error, RCV_B_Bit_number(4)=>Tok_EXMPLR2801, 
      RCV_B_Bit_number(3)=>Tok_EXMPLR2801, RCV_B_Bit_number(2)=>
      Tok_EXMPLR2801, RCV_B_Bit_number(1)=>Tok_EXMPLR2801, 
      RCV_B_Bit_number(0)=>Tok_EXMPLR2801, RCV_B_Response_Time(7)=>
      Tok_EXMPLR2801, RCV_B_Response_Time(6)=>Tok_EXMPLR2801, 
      RCV_B_Response_Time(5)=>Tok_EXMPLR2801, RCV_B_Response_Time(4)=>
      Tok_EXMPLR2801, RCV_B_Response_Time(3)=>Tok_EXMPLR2801, 
      RCV_B_Response_Time(2)=>Tok_EXMPLR2801, RCV_B_Response_Time(1)=>
      Tok_EXMPLR2801, RCV_B_Response_Time(0)=>Tok_EXMPLR2801, 
      rtlc_RCV_B_Sync_error_n140=>Tok_EXMPLR2801, RCV_B_Manchester_error=>
      Tok_EXMPLR2801, RCV_B_Parity_error=>Tok_EXMPLR2801, 
      RCV_B_echo_back_bus=>Tok_EXMPLR2801, RCV_B_R_Data(15)=>
      H15530_record_B_R_Data_EXMPLR2894(15), RCV_B_R_Data(14)=>
      H15530_record_B_R_Data_EXMPLR2894(14), RCV_B_R_Data(13)=>
      H15530_record_B_R_Data_EXMPLR2894(13), RCV_B_R_Data(12)=>
      H15530_record_B_R_Data_EXMPLR2894(12), RCV_B_R_Data(11)=>
      H15530_record_B_R_Data_EXMPLR2894(11), RCV_B_R_Data(10)=>
      H15530_record_B_R_Data_EXMPLR2894(10), RCV_B_R_Data(9)=>
      H15530_record_B_R_Data_EXMPLR2894(9), RCV_B_R_Data(8)=>
      H15530_record_B_R_Data_EXMPLR2894(8), RCV_B_R_Data(7)=>
      H15530_record_B_R_Data_EXMPLR2894(7), RCV_B_R_Data(6)=>
      H15530_record_B_R_Data_EXMPLR2894(6), RCV_B_R_Data(5)=>
      H15530_record_B_R_Data_EXMPLR2894(5), RCV_B_R_Data(4)=>
      H15530_record_B_R_Data_EXMPLR2894(4), RCV_B_R_Data(3)=>
      H15530_record_B_R_Data_EXMPLR2894(3), RCV_B_R_Data(2)=>
      H15530_record_B_R_Data_EXMPLR2894(2), RCV_B_R_Data(1)=>
      H15530_record_B_R_Data_EXMPLR2894(1), RCV_B_R_Data(0)=>
      H15530_record_B_R_Data_EXMPLR2894(0), RCV_B_RAW_GAP(6)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(6), RCV_B_RAW_GAP(5)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(5), RCV_B_RAW_GAP(4)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(4), RCV_B_RAW_GAP(3)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(3), RCV_B_RAW_GAP(2)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(2), RCV_B_RAW_GAP(1)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(1), RCV_B_RAW_GAP(0)=>
      H15530_record_B_RAW_GAP_EXMPLR2895(0), RCV_B_GAP(6)=>Tok_EXMPLR2801, 
      RCV_B_GAP(5)=>Tok_EXMPLR2801, RCV_B_GAP(4)=>Tok_EXMPLR2801, 
      RCV_B_GAP(3)=>Tok_EXMPLR2801, RCV_B_GAP(2)=>Tok_EXMPLR2801, 
      RCV_B_GAP(1)=>Tok_EXMPLR2801, RCV_B_GAP(0)=>Tok_EXMPLR2801, 
      RCV_B_Gap_found(2)=>H15530_record_B_Gap_found_EXMPLR2897(2), 
      RCV_B_Gap_found(1)=>H15530_record_B_Gap_found_EXMPLR2897(1), 
      RCV_B_Gap_found(0)=>H15530_record_B_Gap_found_EXMPLR2897(0), 
      RCV_B_RxRDY_plus_12us=>Tok_EXMPLR2801, RCV_B_RxRDY_plus_10us=>
      Tok_EXMPLR2801, RCV_B_CS=>H15530_record_B_CS_EXMPLR2873, 
      RCV_B_Pre_EchoRdy=>H15530_record_B_Pre_EchoRdy_EXMPLR2874, 
      RCV_B_Command_Sync=>H15530_record_B_Command_Sync_EXMPLR2875, 
      RCV_B_Pre_RxRdy=>H15530_record_B_Pre_RxRdy_EXMPLR2876, RCV_B_recieving
      =>H15530_record_B_recieving_EXMPLR2877, RCV_B_Sync_Error=>
      RCV_B_Sync_error, Record_command_A=>Monitor_Record_command_A, 
      Record_command_B=>Monitor_Record_command_B, yossy=>PWR, Address(15)=>
      DANGLING(112), Address(14)=>DANGLING(113), Address(13)=>DANGLING(114), 
      Address(12)=>DANGLING(115), Address(11)=>DANGLING(116), Address(10)=>
      DANGLING(117), Address(9)=>DANGLING(118), Address(8)=>DANGLING(119), 
      Address(7)=>DANGLING(120), Address(6)=>DANGLING(121), Address(5)=>
      DANGLING(122), Address(4)=>DANGLING(123), Address(3)=>DANGLING(124), 
      Address(2)=>DANGLING(125), Address(1)=>DANGLING(126), Address(0)=>
      DANGLING(127), BM_OK_A=>DANGLING(128), BM_OK_B=>DANGLING(129), 
      BM_not_OK_A=>DANGLING(130), BM_not_OK_B=>DANGLING(131), Debug(15)=>
      DANGLING(132), Debug(14)=>DANGLING(133), Debug(13)=>DANGLING(134), 
      Debug(12)=>DANGLING(135), Debug(11)=>DANGLING(136), Debug(10)=>
      DANGLING(137), Debug(9)=>DANGLING(138), Debug(8)=>DANGLING(139), 
      Debug(7)=>DANGLING(140), Debug(6)=>DANGLING(141), Debug(5)=>DANGLING(
      142), Debug(4)=>DANGLING(143), Debug(3)=>DANGLING(144), Debug(2)=>
      DANGLING(145), Debug(1)=>DANGLING(146), Debug(0)=>DANGLING(147), 
      Debug_BM1(15)=>DANGLING(148), Debug_BM1(14)=>DANGLING(149), 
      Debug_BM1(13)=>DANGLING(150), Debug_BM1(12)=>DANGLING(151), 
      Debug_BM1(11)=>DANGLING(152), Debug_BM1(10)=>DANGLING(153), 
      Debug_BM1(9)=>DANGLING(154), Debug_BM1(8)=>DANGLING(155), Debug_BM1(7)
      =>DANGLING(156), Debug_BM1(6)=>DANGLING(157), Debug_BM1(5)=>DANGLING(
      158), Debug_BM1(4)=>DANGLING(159), Debug_BM1(3)=>DANGLING(160), 
      Debug_BM1(2)=>DANGLING(161), Debug_BM1(1)=>DANGLING(162), Debug_BM1(0)
      =>DANGLING(163), Debug_BM2(15)=>DANGLING(164), Debug_BM2(14)=>DANGLING
      (165), Debug_BM2(13)=>DANGLING(166), Debug_BM2(12)=>DANGLING(167), 
      Debug_BM2(11)=>DANGLING(168), Debug_BM2(10)=>DANGLING(169), 
      Debug_BM2(9)=>DANGLING(170), Debug_BM2(8)=>DANGLING(171), Debug_BM2(7)
      =>DANGLING(172), Debug_BM2(6)=>DANGLING(173), Debug_BM2(5)=>DANGLING(
      174), Debug_BM2(4)=>DANGLING(175), Debug_BM2(3)=>DANGLING(176), 
      Debug_BM2(2)=>DANGLING(177), Debug_BM2(1)=>DANGLING(178), Debug_BM2(0)
      =>DANGLING(179), MIL1553_Errors_Inhibit_TF=>
      Monitor_MIL1553_errors_Inhibit_TF, MIL1553_Errors_invalid_command=>
      Monitor_MIL1553_errors_invalid_command, 
      MIL1553_Errors_RT2RT_format_gap=>
      Monitor_MIL1553_errors_RT2RT_format_gap, 
      MIL1553_Errors_RT2RT_format_error=>
      Monitor_MIL1553_errors_RT2RT_format_error, MIL1553_Errors_Invalid_word
      =>Monitor_MIL1553_errors_Invalid_word, 
      MIL1553_Errors_Parity_Manchester=>DANGLING(180), 
      MIL1553_Errors_incorrect_data_sync=>
      Monitor_MIL1553_errors_incorrect_data_sync, 
      MIL1553_Errors_Low_word_count=>Monitor_MIL1553_errors_Low_word_count, 
      MIL1553_Errors_high_word_count=>Monitor_MIL1553_errors_high_word_count, 
      MIL1553_Errors_Format_error=>DANGLING(181), 
      MIL1553_Errors_Message_Error_set=>DANGLING(182), 
      MIL1553_Errors_Address_Parity=>Monitor_MIL1553_errors_Address_Parity, 
      MIL1553_Errors_echo_back_bus_B=>DANGLING(183), 
      MIL1553_Errors_echo_back_bus_A=>DANGLING(184), 
      MIL1553_Errors_bus_B_shutdown=>DANGLING(185), 
      MIL1553_Errors_bus_A_shutdown=>DANGLING(186), 
      MIL1553_Errors_transmitter_timout=>DANGLING(187), Monitor_ended_OK=>
      Monitor_ended_OK, Monitor_ended_not_OK=>Monitor_ended_not_OK, 
      RT2RT_message=>Monitor_RT2RT_message, Write=>Monitor_Write, 
      Write_Data(15)=>Monitor_Write_Data(15), Write_Data(14)=>
      Monitor_Write_Data(14), Write_Data(13)=>Monitor_Write_Data(13), 
      Write_Data(12)=>Monitor_Write_Data(12), Write_Data(11)=>
      Monitor_Write_Data(11), Write_Data(10)=>Monitor_Write_Data(10), 
      Write_Data(9)=>Monitor_Write_Data(9), Write_Data(8)=>
      Monitor_Write_Data(8), Write_Data(7)=>Monitor_Write_Data(7), 
      Write_Data(6)=>Monitor_Write_Data(6), Write_Data(5)=>
      Monitor_Write_Data(5), Write_Data(4)=>Monitor_Write_Data(4), 
      Write_Data(3)=>Monitor_Write_Data(3), Write_Data(2)=>
      Monitor_Write_Data(2), Write_Data(1)=>Monitor_Write_Data(1), 
      Write_Data(0)=>Monitor_Write_Data(0), active_command(15)=>
      Monitor_active_command(15), active_command(14)=>
      Monitor_active_command(14), active_command(13)=>
      Monitor_active_command(13), active_command(12)=>
      Monitor_active_command(12), active_command(11)=>
      Monitor_active_command(11), active_command(10)=>
      Monitor_active_command(10), active_command(9)=>
      Monitor_active_command(9), active_command(8)=>
      Monitor_active_command(8), active_command(7)=>
      Monitor_active_command(7), active_command(6)=>
      Monitor_active_command(6), active_command(5)=>
      Monitor_active_command(5), active_command(4)=>
      Monitor_active_command(4), active_command(3)=>
      Monitor_active_command(3), active_command(2)=>
      Monitor_active_command(2), active_command(1)=>
      Monitor_active_command(1), active_command(0)=>
      Monitor_active_command(0), new_command=>Monitor_New_command, 
      Monitor_Bus_A=>Monitor_Bus_A);
   gBC_UBC_Stm : BC_Stm_ver8_4_1_32 port map ( C=>clock, R=>BC_STM_ResetN, 
      CE=>CE_out_EXMPLR2706, Yoav=>PWR, RCV_A_Bit_number(4)=>Tok_EXMPLR2801, 
      RCV_A_Bit_number(3)=>Tok_EXMPLR2801, RCV_A_Bit_number(2)=>
      Tok_EXMPLR2801, RCV_A_Bit_number(1)=>Tok_EXMPLR2801, 
      RCV_A_Bit_number(0)=>Tok_EXMPLR2801, RCV_A_Response_Time(7)=>
      Tok_EXMPLR2801, RCV_A_Response_Time(6)=>Tok_EXMPLR2801, 
      RCV_A_Response_Time(5)=>Tok_EXMPLR2801, RCV_A_Response_Time(4)=>
      Tok_EXMPLR2801, RCV_A_Response_Time(3)=>Tok_EXMPLR2801, 
      RCV_A_Response_Time(2)=>Tok_EXMPLR2801, RCV_A_Response_Time(1)=>
      Tok_EXMPLR2801, RCV_A_Response_Time(0)=>Tok_EXMPLR2801, 
      rtlc_RCV_A_Sync_error_n2598=>Tok_EXMPLR2801, RCV_A_Manchester_error=>
      Tok_EXMPLR2801, RCV_A_Parity_error=>Tok_EXMPLR2801, 
      RCV_A_echo_back_bus=>Tok_EXMPLR2801, RCV_A_R_Data(15)=>
      H15530_record_A_R_Data_EXMPLR2890(15), RCV_A_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR2890(14), RCV_A_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR2890(13), RCV_A_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR2890(12), RCV_A_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR2890(11), RCV_A_R_Data(10)=>
      H15530_record_A_R_Data_EXMPLR2890(10), RCV_A_R_Data(9)=>
      H15530_record_A_R_Data_EXMPLR2890(9), RCV_A_R_Data(8)=>
      H15530_record_A_R_Data_EXMPLR2890(8), RCV_A_R_Data(7)=>
      H15530_record_A_R_Data_EXMPLR2890(7), RCV_A_R_Data(6)=>
      H15530_record_A_R_Data_EXMPLR2890(6), RCV_A_R_Data(5)=>
      H15530_record_A_R_Data_EXMPLR2890(5), RCV_A_R_Data(4)=>
      H15530_record_A_R_Data_EXMPLR2890(4), RCV_A_R_Data(3)=>
      H15530_record_A_R_Data_EXMPLR2890(3), RCV_A_R_Data(2)=>
      H15530_record_A_R_Data_EXMPLR2890(2), RCV_A_R_Data(1)=>
      H15530_record_A_R_Data_EXMPLR2890(1), RCV_A_R_Data(0)=>
      H15530_record_A_R_Data_EXMPLR2890(0), RCV_A_RAW_GAP(6)=>Tok_EXMPLR2801, 
      RCV_A_RAW_GAP(5)=>Tok_EXMPLR2801, RCV_A_RAW_GAP(4)=>Tok_EXMPLR2801, 
      RCV_A_RAW_GAP(3)=>Tok_EXMPLR2801, RCV_A_RAW_GAP(2)=>Tok_EXMPLR2801, 
      RCV_A_RAW_GAP(1)=>Tok_EXMPLR2801, RCV_A_RAW_GAP(0)=>Tok_EXMPLR2801, 
      RCV_A_GAP(6)=>Tok_EXMPLR2801, RCV_A_GAP(5)=>Tok_EXMPLR2801, 
      RCV_A_GAP(4)=>Tok_EXMPLR2801, RCV_A_GAP(3)=>Tok_EXMPLR2801, 
      RCV_A_GAP(2)=>Tok_EXMPLR2801, RCV_A_GAP(1)=>Tok_EXMPLR2801, 
      RCV_A_GAP(0)=>Tok_EXMPLR2801, RCV_A_Gap_found(2)=>
      H15530_record_A_Gap_found_EXMPLR2893(2), RCV_A_Gap_found(1)=>
      H15530_record_A_Gap_found_EXMPLR2893(1), RCV_A_Gap_found(0)=>
      H15530_record_A_Gap_found_EXMPLR2893(0), RCV_A_RxRDY_plus_12us=>
      Tok_EXMPLR2801, RCV_A_RxRDY_plus_10us=>Tok_EXMPLR2801, RCV_A_CS=>
      H15530_record_A_CS_EXMPLR2835, RCV_A_Pre_EchoRdy=>
      H15530_record_A_Pre_EchoRdy_EXMPLR2836, RCV_A_Command_Sync=>
      H15530_record_A_Command_Sync_EXMPLR2837, RCV_A_Pre_RxRdy=>
      H15530_record_A_Pre_RxRdy_EXMPLR2838, RCV_A_recieving=>
      H15530_record_A_recieving_EXMPLR2839, RCV_B_Bit_number(4)=>
      Tok_EXMPLR2801, RCV_B_Bit_number(3)=>Tok_EXMPLR2801, 
      RCV_B_Bit_number(2)=>Tok_EXMPLR2801, RCV_B_Bit_number(1)=>
      Tok_EXMPLR2801, RCV_B_Bit_number(0)=>Tok_EXMPLR2801, 
      RCV_B_Response_Time(7)=>Tok_EXMPLR2801, RCV_B_Response_Time(6)=>
      Tok_EXMPLR2801, RCV_B_Response_Time(5)=>Tok_EXMPLR2801, 
      RCV_B_Response_Time(4)=>Tok_EXMPLR2801, RCV_B_Response_Time(3)=>
      Tok_EXMPLR2801, RCV_B_Response_Time(2)=>Tok_EXMPLR2801, 
      RCV_B_Response_Time(1)=>Tok_EXMPLR2801, RCV_B_Response_Time(0)=>
      Tok_EXMPLR2801, rtlc_RCV_B_Sync_error_n2599=>Tok_EXMPLR2801, 
      RCV_B_Manchester_error=>Tok_EXMPLR2801, RCV_B_Parity_error=>
      Tok_EXMPLR2801, RCV_B_echo_back_bus=>Tok_EXMPLR2801, RCV_B_R_Data(15)
      =>H15530_record_B_R_Data_EXMPLR2894(15), RCV_B_R_Data(14)=>
      H15530_record_B_R_Data_EXMPLR2894(14), RCV_B_R_Data(13)=>
      H15530_record_B_R_Data_EXMPLR2894(13), RCV_B_R_Data(12)=>
      H15530_record_B_R_Data_EXMPLR2894(12), RCV_B_R_Data(11)=>
      H15530_record_B_R_Data_EXMPLR2894(11), RCV_B_R_Data(10)=>
      H15530_record_B_R_Data_EXMPLR2894(10), RCV_B_R_Data(9)=>
      H15530_record_B_R_Data_EXMPLR2894(9), RCV_B_R_Data(8)=>
      H15530_record_B_R_Data_EXMPLR2894(8), RCV_B_R_Data(7)=>
      H15530_record_B_R_Data_EXMPLR2894(7), RCV_B_R_Data(6)=>
      H15530_record_B_R_Data_EXMPLR2894(6), RCV_B_R_Data(5)=>
      H15530_record_B_R_Data_EXMPLR2894(5), RCV_B_R_Data(4)=>
      H15530_record_B_R_Data_EXMPLR2894(4), RCV_B_R_Data(3)=>
      H15530_record_B_R_Data_EXMPLR2894(3), RCV_B_R_Data(2)=>
      H15530_record_B_R_Data_EXMPLR2894(2), RCV_B_R_Data(1)=>
      H15530_record_B_R_Data_EXMPLR2894(1), RCV_B_R_Data(0)=>
      H15530_record_B_R_Data_EXMPLR2894(0), RCV_B_RAW_GAP(6)=>Tok_EXMPLR2801, 
      RCV_B_RAW_GAP(5)=>Tok_EXMPLR2801, RCV_B_RAW_GAP(4)=>Tok_EXMPLR2801, 
      RCV_B_RAW_GAP(3)=>Tok_EXMPLR2801, RCV_B_RAW_GAP(2)=>Tok_EXMPLR2801, 
      RCV_B_RAW_GAP(1)=>Tok_EXMPLR2801, RCV_B_RAW_GAP(0)=>Tok_EXMPLR2801, 
      RCV_B_GAP(6)=>Tok_EXMPLR2801, RCV_B_GAP(5)=>Tok_EXMPLR2801, 
      RCV_B_GAP(4)=>Tok_EXMPLR2801, RCV_B_GAP(3)=>Tok_EXMPLR2801, 
      RCV_B_GAP(2)=>Tok_EXMPLR2801, RCV_B_GAP(1)=>Tok_EXMPLR2801, 
      RCV_B_GAP(0)=>Tok_EXMPLR2801, RCV_B_Gap_found(2)=>
      H15530_record_B_Gap_found_EXMPLR2897(2), RCV_B_Gap_found(1)=>
      H15530_record_B_Gap_found_EXMPLR2897(1), RCV_B_Gap_found(0)=>
      H15530_record_B_Gap_found_EXMPLR2897(0), RCV_B_RxRDY_plus_12us=>
      Tok_EXMPLR2801, RCV_B_RxRDY_plus_10us=>Tok_EXMPLR2801, RCV_B_CS=>
      H15530_record_B_CS_EXMPLR2873, RCV_B_Pre_EchoRdy=>
      H15530_record_B_Pre_EchoRdy_EXMPLR2874, RCV_B_Command_Sync=>
      H15530_record_B_Command_Sync_EXMPLR2875, RCV_B_Pre_RxRdy=>
      H15530_record_B_Pre_RxRdy_EXMPLR2876, RCV_B_recieving=>
      H15530_record_B_recieving_EXMPLR2877, No_Response_timeout(2)=>
      No_Response_timeout(2), No_Response_timeout(1)=>No_Response_timeout(1), 
      No_Response_timeout(0)=>No_Response_timeout(0), RCV_A_Sync_error=>
      RCV_A_Sync_error, RCV_B_Sync_error=>RCV_B_Sync_error, 
      Transmit_data(15)=>BC_Transmit_data(15), Transmit_data(14)=>
      BC_Transmit_data(14), Transmit_data(13)=>BC_Transmit_data(13), 
      Transmit_data(12)=>BC_Transmit_data(12), Transmit_data(11)=>
      BC_Transmit_data(11), Transmit_data(10)=>BC_Transmit_data(10), 
      Transmit_data(9)=>BC_Transmit_data(9), Transmit_data(8)=>
      BC_Transmit_data(8), Transmit_data(7)=>BC_Transmit_data(7), 
      Transmit_data(6)=>BC_Transmit_data(6), Transmit_data(5)=>
      BC_Transmit_data(5), Transmit_data(4)=>BC_Transmit_data(4), 
      Transmit_data(3)=>BC_Transmit_data(3), Transmit_data(2)=>
      BC_Transmit_data(2), Transmit_data(1)=>BC_Transmit_data(1), 
      Transmit_data(0)=>BC_Transmit_data(0), T_Sync=>T_Sync, Go_Tx=>BC_Go_Tx, 
      Tx_Rdy=>Tx_Rdy, Tx_Bus_A=>Tx_Bus_A, Tx_Data(15)=>BC_TX_Data(15), 
      Tx_Data(14)=>BC_TX_Data(14), Tx_Data(13)=>BC_TX_Data(13), Tx_Data(12)
      =>BC_TX_Data(12), Tx_Data(11)=>BC_TX_Data(11), Tx_Data(10)=>
      BC_TX_Data(10), Tx_Data(9)=>BC_TX_Data(9), Tx_Data(8)=>BC_TX_Data(8), 
      Tx_Data(7)=>BC_TX_Data(7), Tx_Data(6)=>BC_TX_Data(6), Tx_Data(5)=>
      BC_TX_Data(5), Tx_Data(4)=>BC_TX_Data(4), Tx_Data(3)=>BC_TX_Data(3), 
      Tx_Data(2)=>BC_TX_Data(2), Tx_Data(1)=>BC_TX_Data(1), Tx_Data(0)=>
      BC_TX_Data(0), Read=>BC_Read, Go=>BC_Go, ENC_TEST_Go=>ENC_TEST_Go, 
      RT2RT=>BC_RT2RT, Bus_A=>BC_BUS_A, Rx_Data(15)=>BC_Rx_Data(15), 
      Rx_Data(14)=>BC_Rx_Data(14), Rx_Data(13)=>BC_Rx_Data(13), Rx_Data(12)
      =>BC_Rx_Data(12), Rx_Data(11)=>BC_Rx_Data(11), Rx_Data(10)=>
      BC_Rx_Data(10), Rx_Data(9)=>BC_Rx_Data(9), Rx_Data(8)=>BC_Rx_Data(8), 
      Rx_Data(7)=>BC_Rx_Data(7), Rx_Data(6)=>BC_Rx_Data(6), Rx_Data(5)=>
      BC_Rx_Data(5), Rx_Data(4)=>BC_Rx_Data(4), Rx_Data(3)=>BC_Rx_Data(3), 
      Rx_Data(2)=>BC_Rx_Data(2), Rx_Data(1)=>BC_Rx_Data(1), Rx_Data(0)=>
      BC_Rx_Data(0), Write=>BC_Write, Echo=>BC_Echo, Message_Active=>
      BC_Message_Active_EXMPLR2782, Command_Sync=>BC_Command_Sync, 
      Idle_state=>DANGLING(188), Activity_on_wrong_bus=>DANGLING(189), 
      Response_timeout_Error=>BC_Response_timeout_Error, Found_Format_Error
      =>BC_Found_Format_Error, Loopback_error=>BC_Loopback_error, 
      Found_wrong_RT_Address=>BC_Found_wrong_RT_Address, 
      Found_wrong_word_count=>BC_Found_wrong_word_count, Bus_Coupling_error
      =>BC_Coupling_error, BC_logic_error=>BC_FE_Logic_error, 
      Wrong_Sync_error=>BC_wrong_sync, FE_All_Errors=>BC_FE_All_Errors, 
      Good_data_block_recieved=>Good_data_block_recieved, NO_BCST=>
      Tok_EXMPLR2801, BC_1553A=>BC_1553A, BC_1553A_ME=>BC_1553A_ME, 
      Config_reg_4(15)=>Tok_EXMPLR2801, Config_reg_4(14)=>Tok_EXMPLR2801, 
      Config_reg_4(13)=>Tok_EXMPLR2801, Config_reg_4(12)=>Tok_EXMPLR2801, 
      Config_reg_4(11)=>Tok_EXMPLR2801, Config_reg_4(10)=>Tok_EXMPLR2801, 
      Config_reg_4(9)=>Tok_EXMPLR2801, Config_reg_4(8)=>Tok_EXMPLR2801, 
      Config_reg_4(7)=>Tok_EXMPLR2801, Config_reg_4(6)=>Config_reg_4_6, 
      Config_reg_4(5)=>Config_reg_4_5, Config_reg_4(4)=>Tok_EXMPLR2801, 
      Config_reg_4(3)=>Tok_EXMPLR2801, Config_reg_4(2)=>Tok_EXMPLR2801, 
      Config_reg_4(1)=>Tok_EXMPLR2801, Config_reg_4(0)=>Tok_EXMPLR2801, 
      Debug(15)=>DANGLING(190), Debug(14)=>DANGLING(191), Debug(13)=>
      DANGLING(192), Debug(12)=>DANGLING(193), Debug(11)=>DANGLING(194), 
      Debug(10)=>DANGLING(195), Debug(9)=>DANGLING(196), Debug(8)=>DANGLING(
      197), Debug(7)=>DANGLING(198), Debug(6)=>DANGLING(199), Debug(5)=>
      DANGLING(200), Debug(4)=>DANGLING(201), Debug(3)=>DANGLING(202), 
      Debug(2)=>DANGLING(203), Debug(1)=>DANGLING(204), Debug(0)=>DANGLING(
      205));
   gWM_Monitor_Word_DDC : Monitor_Word_DDC_8_4_32 port map ( A_Bit_number(4)
      =>Tok_EXMPLR2801, A_Bit_number(3)=>Tok_EXMPLR2801, A_Bit_number(2)=>
      Tok_EXMPLR2801, A_Bit_number(1)=>Tok_EXMPLR2801, A_Bit_number(0)=>
      Tok_EXMPLR2801, A_Response_Time(7)=>Tok_EXMPLR2801, A_Response_Time(6)
      =>Tok_EXMPLR2801, A_Response_Time(5)=>Tok_EXMPLR2801, 
      A_Response_Time(4)=>Tok_EXMPLR2801, A_Response_Time(3)=>Tok_EXMPLR2801, 
      A_Response_Time(2)=>Tok_EXMPLR2801, A_Response_Time(1)=>Tok_EXMPLR2801, 
      A_Response_Time(0)=>Tok_EXMPLR2801, A_Sync_error=>Tok_EXMPLR2801, 
      A_Manchester_error=>Tok_EXMPLR2801, A_Parity_error=>Tok_EXMPLR2801, 
      A_echo_back_bus=>Tok_EXMPLR2801, A_R_Data(15)=>
      H15530_record_A_R_Data_EXMPLR2890(15), A_R_Data(14)=>
      H15530_record_A_R_Data_EXMPLR2890(14), A_R_Data(13)=>
      H15530_record_A_R_Data_EXMPLR2890(13), A_R_Data(12)=>
      H15530_record_A_R_Data_EXMPLR2890(12), A_R_Data(11)=>
      H15530_record_A_R_Data_EXMPLR2890(11), A_R_Data(10)=>
      H15530_record_A_R_Data_EXMPLR2890(10), A_R_Data(9)=>
      H15530_record_A_R_Data_EXMPLR2890(9), A_R_Data(8)=>
      H15530_record_A_R_Data_EXMPLR2890(8), A_R_Data(7)=>
      H15530_record_A_R_Data_EXMPLR2890(7), A_R_Data(6)=>
      H15530_record_A_R_Data_EXMPLR2890(6), A_R_Data(5)=>
      H15530_record_A_R_Data_EXMPLR2890(5), A_R_Data(4)=>
      H15530_record_A_R_Data_EXMPLR2890(4), A_R_Data(3)=>
      H15530_record_A_R_Data_EXMPLR2890(3), A_R_Data(2)=>
      H15530_record_A_R_Data_EXMPLR2890(2), A_R_Data(1)=>
      H15530_record_A_R_Data_EXMPLR2890(1), A_R_Data(0)=>
      H15530_record_A_R_Data_EXMPLR2890(0), A_RAW_GAP(6)=>Tok_EXMPLR2801, 
      A_RAW_GAP(5)=>Tok_EXMPLR2801, A_RAW_GAP(4)=>Tok_EXMPLR2801, 
      A_RAW_GAP(3)=>Tok_EXMPLR2801, A_RAW_GAP(2)=>Tok_EXMPLR2801, 
      A_RAW_GAP(1)=>Tok_EXMPLR2801, A_RAW_GAP(0)=>Tok_EXMPLR2801, A_GAP(6)=>
      H15530_record_A_GAP_EXMPLR2892(6), A_GAP(5)=>
      H15530_record_A_GAP_EXMPLR2892(5), A_GAP(4)=>
      H15530_record_A_GAP_EXMPLR2892(4), A_GAP(3)=>
      H15530_record_A_GAP_EXMPLR2892(3), A_GAP(2)=>
      H15530_record_A_GAP_EXMPLR2892(2), A_GAP(1)=>
      H15530_record_A_GAP_EXMPLR2892(1), A_GAP(0)=>
      H15530_record_A_GAP_EXMPLR2892(0), A_Gap_found(2)=>Tok_EXMPLR2801, 
      A_Gap_found(1)=>Tok_EXMPLR2801, A_Gap_found(0)=>Tok_EXMPLR2801, 
      A_RxRDY_plus_12us=>Tok_EXMPLR2801, A_RxRDY_plus_10us=>Tok_EXMPLR2801, 
      A_CS=>H15530_record_A_CS_EXMPLR2835, A_Pre_EchoRdy=>
      H15530_record_A_Pre_EchoRdy_EXMPLR2836, A_Command_Sync=>
      H15530_record_A_Command_Sync_EXMPLR2837, A_Pre_RxRdy=>
      H15530_record_A_Pre_RxRdy_EXMPLR2838, A_recieving=>Tok_EXMPLR2801, Ack
      =>WM_Ack, B_Bit_number(4)=>Tok_EXMPLR2801, B_Bit_number(3)=>
      Tok_EXMPLR2801, B_Bit_number(2)=>Tok_EXMPLR2801, B_Bit_number(1)=>
      Tok_EXMPLR2801, B_Bit_number(0)=>Tok_EXMPLR2801, B_Response_Time(7)=>
      Tok_EXMPLR2801, B_Response_Time(6)=>Tok_EXMPLR2801, B_Response_Time(5)
      =>Tok_EXMPLR2801, B_Response_Time(4)=>Tok_EXMPLR2801, 
      B_Response_Time(3)=>Tok_EXMPLR2801, B_Response_Time(2)=>Tok_EXMPLR2801, 
      B_Response_Time(1)=>Tok_EXMPLR2801, B_Response_Time(0)=>Tok_EXMPLR2801, 
      B_Sync_error=>Tok_EXMPLR2801, B_Manchester_error=>Tok_EXMPLR2801, 
      B_Parity_error=>Tok_EXMPLR2801, B_echo_back_bus=>Tok_EXMPLR2801, 
      B_R_Data(15)=>H15530_record_B_R_Data_EXMPLR2894(15), B_R_Data(14)=>
      H15530_record_B_R_Data_EXMPLR2894(14), B_R_Data(13)=>
      H15530_record_B_R_Data_EXMPLR2894(13), B_R_Data(12)=>
      H15530_record_B_R_Data_EXMPLR2894(12), B_R_Data(11)=>
      H15530_record_B_R_Data_EXMPLR2894(11), B_R_Data(10)=>
      H15530_record_B_R_Data_EXMPLR2894(10), B_R_Data(9)=>
      H15530_record_B_R_Data_EXMPLR2894(9), B_R_Data(8)=>
      H15530_record_B_R_Data_EXMPLR2894(8), B_R_Data(7)=>
      H15530_record_B_R_Data_EXMPLR2894(7), B_R_Data(6)=>
      H15530_record_B_R_Data_EXMPLR2894(6), B_R_Data(5)=>
      H15530_record_B_R_Data_EXMPLR2894(5), B_R_Data(4)=>
      H15530_record_B_R_Data_EXMPLR2894(4), B_R_Data(3)=>
      H15530_record_B_R_Data_EXMPLR2894(3), B_R_Data(2)=>
      H15530_record_B_R_Data_EXMPLR2894(2), B_R_Data(1)=>
      H15530_record_B_R_Data_EXMPLR2894(1), B_R_Data(0)=>
      H15530_record_B_R_Data_EXMPLR2894(0), B_RAW_GAP(6)=>Tok_EXMPLR2801, 
      B_RAW_GAP(5)=>Tok_EXMPLR2801, B_RAW_GAP(4)=>Tok_EXMPLR2801, 
      B_RAW_GAP(3)=>Tok_EXMPLR2801, B_RAW_GAP(2)=>Tok_EXMPLR2801, 
      B_RAW_GAP(1)=>Tok_EXMPLR2801, B_RAW_GAP(0)=>Tok_EXMPLR2801, B_GAP(6)=>
      H15530_record_B_GAP_EXMPLR2896(6), B_GAP(5)=>
      H15530_record_B_GAP_EXMPLR2896(5), B_GAP(4)=>
      H15530_record_B_GAP_EXMPLR2896(4), B_GAP(3)=>
      H15530_record_B_GAP_EXMPLR2896(3), B_GAP(2)=>
      H15530_record_B_GAP_EXMPLR2896(2), B_GAP(1)=>
      H15530_record_B_GAP_EXMPLR2896(1), B_GAP(0)=>
      H15530_record_B_GAP_EXMPLR2896(0), B_Gap_found(2)=>Tok_EXMPLR2801, 
      B_Gap_found(1)=>Tok_EXMPLR2801, B_Gap_found(0)=>Tok_EXMPLR2801, 
      B_RxRDY_plus_12us=>Tok_EXMPLR2801, B_RxRDY_plus_10us=>Tok_EXMPLR2801, 
      B_CS=>H15530_record_B_CS_EXMPLR2873, B_Pre_EchoRdy=>
      H15530_record_B_Pre_EchoRdy_EXMPLR2874, B_Command_Sync=>
      H15530_record_B_Command_Sync_EXMPLR2875, B_Pre_RxRdy=>
      H15530_record_B_Pre_RxRdy_EXMPLR2876, B_recieving=>Tok_EXMPLR2801, C=>
      clock, CE=>CE_out_EXMPLR2706, R=>WM_Started, Descriptor(15)=>
      WM_Descriptor_15, Descriptor(14)=>WM_Descriptor_14, Descriptor(13)=>
      WM_Descriptor_13, Descriptor(12)=>WM_Descriptor_12, Descriptor(11)=>
      WM_Descriptor_11, Descriptor(10)=>WM_Descriptor_10, Descriptor(9)=>
      WM_Descriptor_9, Descriptor(8)=>WM_Descriptor_8, Descriptor(7)=>
      WM_Descriptor_7, Descriptor(6)=>DANGLING(206), Descriptor(5)=>
      WM_Descriptor_5, Descriptor(4)=>WM_Descriptor_4, Descriptor(3)=>
      WM_Descriptor_3, Descriptor(2)=>WM_Descriptor_2, Descriptor(1)=>
      WM_Descriptor_1, Descriptor(0)=>WM_Descriptor_0, Req=>WM_Req, Word(15)
      =>WM_Word(15), Word(14)=>WM_Word(14), Word(13)=>WM_Word(13), Word(12)
      =>WM_Word(12), Word(11)=>WM_Word(11), Word(10)=>WM_Word(10), Word(9)=>
      WM_Word(9), Word(8)=>WM_Word(8), Word(7)=>WM_Word(7), Word(6)=>
      WM_Word(6), Word(5)=>WM_Word(5), Word(4)=>WM_Word(4), Word(3)=>
      WM_Word(3), Word(2)=>WM_Word(2), Word(1)=>WM_Word(1), Word(0)=>
      WM_Word(0));
end no_int_mem_unfold_2437 ;

-- library IEEE;
--  use IEEE.STD_LOGIC_1164.ALL;
--  Library MODGEN_SITAL;

-- entity ram_new_4_interlace_Actel is 
--    port (
--       wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
--       rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
--       addr1 : IN std_logic_vector (14 DOWNTO 0) ;
--       wr_clk1 : IN std_logic ;
--       rd_clk1 : IN std_logic ;
--       wr_ena1 : IN std_logic ;
--       rd_ena1 : IN std_logic ;
--       ena1 : IN std_logic ;
--       rst1 : IN std_logic ;
--       regce1 : IN std_logic ;
--       wr_data2 : IN std_logic_vector (15 DOWNTO 0) ;
--       rd_data2 : OUT std_logic_vector (15 DOWNTO 0) ;
--       addr2 : IN std_logic_vector (14 DOWNTO 0) ;
--       wr_clk2 : IN std_logic ;
--       rd_clk2 : IN std_logic ;
--       wr_ena2 : IN std_logic ;
--       rd_ena2 : IN std_logic ;
--       ena2 : IN std_logic ;
--       rst2 : IN std_logic ;
--       regce2 : IN std_logic) ;
-- end ram_new_4_interlace_Actel ;

-- architecture INTERFACE of 
--    ram_new_4_interlace_Actel is 
--    procedure DFFPCE (
--       constant data   : in std_logic;
--       constant preset : in std_logic;
--       constant clear  : in std_logic;
--       constant enable : in std_logic;
--       signal clk      : in std_logic;
--       signal q        : out std_logic)
--    is begin
--        if (preset = '1') then
--            q <= '1' ;
--        elsif (clear = '1') then
--            q <= '0' ;
--        elsif (clk'event and clk'last_value = '0' and clk = '1') then
--            if (enable = '1') then
--                q <= data and data ;    -- takes care of q<='X' if data='Z'
--            end if ;
--        end if ;
--        if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
--            q <= 'X' ;
--        end if ;
--    end DFFPCE ;
--    component clocked_ram_16_15_32768_F_T_F_F_T_T_F_F_F
--       generic (ram_type : integer := 2;
--          dual_addresses : string := "TRUE"
--          ;
--          dual_data_ports : string := "TRUE"
--          ;
--          dual_out_ports : string := "TRUE") ;
--       
--       port (
--          clk : IN std_logic ;
--          we : IN std_logic ;
--          address : IN std_logic_vector (14 DOWNTO 0) ;
--          data : IN std_logic_vector (15 DOWNTO 0) ;
--          q : OUT std_logic_vector (15 DOWNTO 0) ;
--          we2 : IN std_logic ;
--          addr2 : IN std_logic_vector (14 DOWNTO 0) ;
--          data2 : IN std_logic_vector (15 DOWNTO 0) ;
--          q2 : OUT std_logic_vector (15 DOWNTO 0)) ;
--    end component ;
--    signal nx108, nx110, dup_0_rtlc_rdout_n26_9, dup_0_rtlc_rdout_n26_8, 
--       dup_0_rtlc_rdout_n26_7, dup_0_rtlc_rdout_n26_6, dup_0_rtlc_rdout_n26_5, 
--       dup_0_rtlc_rdout_n26_4, dup_0_rtlc_rdout_n26_3, dup_0_rtlc_rdout_n26_2, 
--       dup_0_rtlc_rdout_n26_15, dup_0_rtlc_rdout_n26_14, 
--       dup_0_rtlc_rdout_n26_13, dup_0_rtlc_rdout_n26_12, 
--       dup_0_rtlc_rdout_n26_11, dup_0_rtlc_rdout_n26_10, 
--       dup_0_rtlc_rdout_n26_1, dup_0_rtlc_rdout_n26_0, dup_0_rtlc_rdout_n19_9, 
--       dup_0_rtlc_rdout_n19_8, dup_0_rtlc_rdout_n19_7, dup_0_rtlc_rdout_n19_6, 
--       dup_0_rtlc_rdout_n19_5, dup_0_rtlc_rdout_n19_4, dup_0_rtlc_rdout_n19_3, 
--       dup_0_rtlc_rdout_n19_2, dup_0_rtlc_rdout_n19_15, 
--       dup_0_rtlc_rdout_n19_14, dup_0_rtlc_rdout_n19_13, 
--       dup_0_rtlc_rdout_n19_12, dup_0_rtlc_rdout_n19_11, 
--       dup_0_rtlc_rdout_n19_10, dup_0_rtlc_rdout_n19_1, 
--       dup_0_rtlc_rdout_n19_0, nx112, nx114, nx116, nx118: std_logic ;

-- begin
--    nx108 <= '0' ;
--    nx110 <= '1' ;
--    DFFPCE (dup_0_rtlc_rdout_n26_9,nx108,nx108,nx118,rd_clk2,rd_data2(9)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_8,nx108,nx108,nx118,rd_clk2,rd_data2(8)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_7,nx108,nx108,nx118,rd_clk2,rd_data2(7)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_6,nx108,nx108,nx118,rd_clk2,rd_data2(6)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_5,nx108,nx108,nx118,rd_clk2,rd_data2(5)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_4,nx108,nx108,nx118,rd_clk2,rd_data2(4)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_3,nx108,nx108,nx118,rd_clk2,rd_data2(3)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_2,nx108,nx108,nx118,rd_clk2,rd_data2(2)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_15,nx108,nx108,nx118,rd_clk2,rd_data2(15)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_14,nx108,nx108,nx118,rd_clk2,rd_data2(14)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_13,nx108,nx108,nx118,rd_clk2,rd_data2(13)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_12,nx108,nx108,nx118,rd_clk2,rd_data2(12)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_11,nx108,nx108,nx118,rd_clk2,rd_data2(11)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_10,nx108,nx108,nx118,rd_clk2,rd_data2(10)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_1,nx108,nx108,nx118,rd_clk2,rd_data2(1)) ;
--    DFFPCE (dup_0_rtlc_rdout_n26_0,nx108,nx108,nx118,rd_clk2,rd_data2(0)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_9,nx108,nx108,nx114,rd_clk1,rd_data1(9)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_8,nx108,nx108,nx114,rd_clk1,rd_data1(8)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_7,nx108,nx108,nx114,rd_clk1,rd_data1(7)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_6,nx108,nx108,nx114,rd_clk1,rd_data1(6)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_5,nx108,nx108,nx114,rd_clk1,rd_data1(5)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_4,nx108,nx108,nx114,rd_clk1,rd_data1(4)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_3,nx108,nx108,nx114,rd_clk1,rd_data1(3)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_2,nx108,nx108,nx114,rd_clk1,rd_data1(2)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_15,nx108,nx108,nx114,rd_clk1,rd_data1(15)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_14,nx108,nx108,nx114,rd_clk1,rd_data1(14)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_13,nx108,nx108,nx114,rd_clk1,rd_data1(13)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_12,nx108,nx108,nx114,rd_clk1,rd_data1(12)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_11,nx108,nx108,nx114,rd_clk1,rd_data1(11)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_10,nx108,nx108,nx114,rd_clk1,rd_data1(10)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_1,nx108,nx108,nx114,rd_clk1,rd_data1(1)) ;
--    DFFPCE (dup_0_rtlc_rdout_n19_0,nx108,nx108,nx114,rd_clk1,rd_data1(0)) ;
--    mem_655350 : clocked_ram_16_15_32768_F_T_F_F_T_T_F_F_F port map ( clk=>
--       wr_clk1, we=>nx112, address(14)=>addr1(14), address(13)=>addr1(13), 
--       address(12)=>addr1(12), address(11)=>addr1(11), address(10)=>addr1(10), 
--       address(9)=>addr1(9), address(8)=>addr1(8), address(7)=>addr1(7), 
--       address(6)=>addr1(6), address(5)=>addr1(5), address(4)=>addr1(4), 
--       address(3)=>addr1(3), address(2)=>addr1(2), address(1)=>addr1(1), 
--       address(0)=>addr1(0), data(15)=>wr_data1(15), data(14)=>wr_data1(14), 
--       data(13)=>wr_data1(13), data(12)=>wr_data1(12), data(11)=>wr_data1(11), 
--       data(10)=>wr_data1(10), data(9)=>wr_data1(9), data(8)=>wr_data1(8), 
--       data(7)=>wr_data1(7), data(6)=>wr_data1(6), data(5)=>wr_data1(5), 
--       data(4)=>wr_data1(4), data(3)=>wr_data1(3), data(2)=>wr_data1(2), 
--       data(1)=>wr_data1(1), data(0)=>wr_data1(0), q(15)=>
--       dup_0_rtlc_rdout_n19_15, q(14)=>dup_0_rtlc_rdout_n19_14, q(13)=>
--       dup_0_rtlc_rdout_n19_13, q(12)=>dup_0_rtlc_rdout_n19_12, q(11)=>
--       dup_0_rtlc_rdout_n19_11, q(10)=>dup_0_rtlc_rdout_n19_10, q(9)=>
--       dup_0_rtlc_rdout_n19_9, q(8)=>dup_0_rtlc_rdout_n19_8, q(7)=>
--       dup_0_rtlc_rdout_n19_7, q(6)=>dup_0_rtlc_rdout_n19_6, q(5)=>
--       dup_0_rtlc_rdout_n19_5, q(4)=>dup_0_rtlc_rdout_n19_4, q(3)=>
--       dup_0_rtlc_rdout_n19_3, q(2)=>dup_0_rtlc_rdout_n19_2, q(1)=>
--       dup_0_rtlc_rdout_n19_1, q(0)=>dup_0_rtlc_rdout_n19_0, we2=>nx116, 
--       addr2(14)=>addr2(14), addr2(13)=>addr2(13), addr2(12)=>addr2(12), 
--       addr2(11)=>addr2(11), addr2(10)=>addr2(10), addr2(9)=>addr2(9), 
--       addr2(8)=>addr2(8), addr2(7)=>addr2(7), addr2(6)=>addr2(6), addr2(5)=>
--       addr2(5), addr2(4)=>addr2(4), addr2(3)=>addr2(3), addr2(2)=>addr2(2), 
--       addr2(1)=>addr2(1), addr2(0)=>addr2(0), data2(15)=>wr_data2(15), 
--       data2(14)=>wr_data2(14), data2(13)=>wr_data2(13), data2(12)=>
--       wr_data2(12), data2(11)=>wr_data2(11), data2(10)=>wr_data2(10), 
--       data2(9)=>wr_data2(9), data2(8)=>wr_data2(8), data2(7)=>wr_data2(7), 
--       data2(6)=>wr_data2(6), data2(5)=>wr_data2(5), data2(4)=>wr_data2(4), 
--       data2(3)=>wr_data2(3), data2(2)=>wr_data2(2), data2(1)=>wr_data2(1), 
--       data2(0)=>wr_data2(0), q2(15)=>dup_0_rtlc_rdout_n26_15, q2(14)=>
--       dup_0_rtlc_rdout_n26_14, q2(13)=>dup_0_rtlc_rdout_n26_13, q2(12)=>
--       dup_0_rtlc_rdout_n26_12, q2(11)=>dup_0_rtlc_rdout_n26_11, q2(10)=>
--       dup_0_rtlc_rdout_n26_10, q2(9)=>dup_0_rtlc_rdout_n26_9, q2(8)=>
--       dup_0_rtlc_rdout_n26_8, q2(7)=>dup_0_rtlc_rdout_n26_7, q2(6)=>
--       dup_0_rtlc_rdout_n26_6, q2(5)=>dup_0_rtlc_rdout_n26_5, q2(4)=>
--       dup_0_rtlc_rdout_n26_4, q2(3)=>dup_0_rtlc_rdout_n26_3, q2(2)=>
--       dup_0_rtlc_rdout_n26_2, q2(1)=>dup_0_rtlc_rdout_n26_1, q2(0)=>
--       dup_0_rtlc_rdout_n26_0);
--    nx112 <= wr_ena1 AND ena1 ;
--    nx114 <= rd_ena1 AND ena1 ;
--    nx116 <= wr_ena2 AND ena2 ;
--    nx118 <= rd_ena2 AND ena2 ;
-- end INTERFACE ;

-- library IEEE;
--  use IEEE.STD_LOGIC_1164.ALL;
--  Library MODGEN_SITAL;

-- entity ram_new_4_interlace_Actel is 
--    port (
--       wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
--       rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
--       addr1 : IN std_logic_vector (14 DOWNTO 0) ;
--       wr_clk1 : IN std_logic ;
--       rd_clk1 : IN std_logic ;
--       wr_ena1 : IN std_logic ;
--       rd_ena1 : IN std_logic ;
--       ena1 : IN std_logic ;
--       rst1 : IN std_logic ;
--       regce1 : IN std_logic ;
--       wr_data2 : IN std_logic_vector (15 DOWNTO 0) ;
--       rd_data2 : OUT std_logic_vector (15 DOWNTO 0) ;
--       addr2 : IN std_logic_vector (14 DOWNTO 0) ;
--       wr_clk2 : IN std_logic ;
--       rd_clk2 : IN std_logic ;
--       wr_ena2 : IN std_logic ;
--       rd_ena2 : IN std_logic ;
--       ena2 : IN std_logic ;
--       rst2 : IN std_logic ;
--       regce2 : IN std_logic) ;
-- end ram_new_4_interlace_Actel ;

-- architecture INTERFACE of 
--    ram_new_4_interlace_Actel is 
--    procedure DFFPCE (
--       constant data   : in std_logic;
--       constant preset : in std_logic;
--       constant clear  : in std_logic;
--       constant enable : in std_logic;
--       signal clk      : in std_logic;
--       signal q        : out std_logic)
--    is begin
--        if (preset = '1') then
--            q <= '1' ;
--        elsif (clear = '1') then
--            q <= '0' ;
--        elsif (clk'event and clk'last_value = '0' and clk = '1') then
--            if (enable = '1') then
--                q <= data and data ;    -- takes care of q<='X' if data='Z'
--            end if ;
--        end if ;
--        if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
--            q <= 'X' ;
--        end if ;
--    end DFFPCE ;
--    component clocked_ram_16_15_32768_F_T_F_F_T_T_F_F_F
--       generic (ram_type : integer := 2;
--          dual_addresses : string := "TRUE"
--          ;
--          dual_data_ports : string := "TRUE"
--          ;
--          dual_out_ports : string := "TRUE") ;
--       
--       port (
--          clk : IN std_logic ;
--          we : IN std_logic ;
--          address : IN std_logic_vector (14 DOWNTO 0) ;
--          data : IN std_logic_vector (15 DOWNTO 0) ;
--          q : OUT std_logic_vector (15 DOWNTO 0) ;
--          we2 : IN std_logic ;
--          addr2 : IN std_logic_vector (14 DOWNTO 0) ;
--          data2 : IN std_logic_vector (15 DOWNTO 0) ;
--          q2 : OUT std_logic_vector (15 DOWNTO 0)) ;
--    end component ;
--    signal nx108, nx110, dup_0_rtlc_rdout_n12_15, dup_0_rtlc_rdout_n12_14, 
--       dup_0_rtlc_rdout_n12_13, dup_0_rtlc_rdout_n12_12, 
--       dup_0_rtlc_rdout_n12_11, dup_0_rtlc_rdout_n12_10, 
--       dup_0_rtlc_rdout_n12_9, dup_0_rtlc_rdout_n12_8, dup_0_rtlc_rdout_n12_7, 
--       dup_0_rtlc_rdout_n12_6, dup_0_rtlc_rdout_n12_5, dup_0_rtlc_rdout_n12_4, 
--       dup_0_rtlc_rdout_n12_3, dup_0_rtlc_rdout_n12_2, dup_0_rtlc_rdout_n12_1, 
--       dup_0_rtlc_rdout_n12_0, dup_0_rtlc_rdout_n5_15, dup_0_rtlc_rdout_n5_14, 
--       dup_0_rtlc_rdout_n5_13, dup_0_rtlc_rdout_n5_12, dup_0_rtlc_rdout_n5_11, 
--       dup_0_rtlc_rdout_n5_10, dup_0_rtlc_rdout_n5_9, dup_0_rtlc_rdout_n5_8, 
--       dup_0_rtlc_rdout_n5_7, dup_0_rtlc_rdout_n5_6, dup_0_rtlc_rdout_n5_5, 
--       dup_0_rtlc_rdout_n5_4, dup_0_rtlc_rdout_n5_3, dup_0_rtlc_rdout_n5_2, 
--       dup_0_rtlc_rdout_n5_1, dup_0_rtlc_rdout_n5_0, nx112, nx114, nx116, 
--       nx118: std_logic ;

-- begin
--    nx108 <= '0' ;
--    nx110 <= '1' ;
--    DFFPCE (dup_0_rtlc_rdout_n12_15,nx108,nx108,nx118,rd_clk2,rd_data2(15)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_14,nx108,nx108,nx118,rd_clk2,rd_data2(14)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_13,nx108,nx108,nx118,rd_clk2,rd_data2(13)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_12,nx108,nx108,nx118,rd_clk2,rd_data2(12)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_11,nx108,nx108,nx118,rd_clk2,rd_data2(11)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_10,nx108,nx108,nx118,rd_clk2,rd_data2(10)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_9,nx108,nx108,nx118,rd_clk2,rd_data2(9)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_8,nx108,nx108,nx118,rd_clk2,rd_data2(8)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_7,nx108,nx108,nx118,rd_clk2,rd_data2(7)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_6,nx108,nx108,nx118,rd_clk2,rd_data2(6)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_5,nx108,nx108,nx118,rd_clk2,rd_data2(5)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_4,nx108,nx108,nx118,rd_clk2,rd_data2(4)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_3,nx108,nx108,nx118,rd_clk2,rd_data2(3)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_2,nx108,nx108,nx118,rd_clk2,rd_data2(2)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_1,nx108,nx108,nx118,rd_clk2,rd_data2(1)) ;
--    DFFPCE (dup_0_rtlc_rdout_n12_0,nx108,nx108,nx118,rd_clk2,rd_data2(0)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_15,nx108,nx108,nx114,rd_clk1,rd_data1(15)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_14,nx108,nx108,nx114,rd_clk1,rd_data1(14)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_13,nx108,nx108,nx114,rd_clk1,rd_data1(13)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_12,nx108,nx108,nx114,rd_clk1,rd_data1(12)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_11,nx108,nx108,nx114,rd_clk1,rd_data1(11)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_10,nx108,nx108,nx114,rd_clk1,rd_data1(10)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_9,nx108,nx108,nx114,rd_clk1,rd_data1(9)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_8,nx108,nx108,nx114,rd_clk1,rd_data1(8)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_7,nx108,nx108,nx114,rd_clk1,rd_data1(7)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_6,nx108,nx108,nx114,rd_clk1,rd_data1(6)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_5,nx108,nx108,nx114,rd_clk1,rd_data1(5)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_4,nx108,nx108,nx114,rd_clk1,rd_data1(4)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_3,nx108,nx108,nx114,rd_clk1,rd_data1(3)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_2,nx108,nx108,nx114,rd_clk1,rd_data1(2)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_1,nx108,nx108,nx114,rd_clk1,rd_data1(1)) ;
--    DFFPCE (dup_0_rtlc_rdout_n5_0,nx108,nx108,nx114,rd_clk1,rd_data1(0)) ;
--    mem_327671 : clocked_ram_16_15_32768_F_T_F_F_T_T_F_F_F port map ( clk=>
--       wr_clk1, we=>nx112, address(14)=>addr1(14), address(13)=>addr1(13), 
--       address(12)=>addr1(12), address(11)=>addr1(11), address(10)=>addr1(10), 
--       address(9)=>addr1(9), address(8)=>addr1(8), address(7)=>addr1(7), 
--       address(6)=>addr1(6), address(5)=>addr1(5), address(4)=>addr1(4), 
--       address(3)=>addr1(3), address(2)=>addr1(2), address(1)=>addr1(1), 
--       address(0)=>addr1(0), data(15)=>wr_data1(15), data(14)=>wr_data1(14), 
--       data(13)=>wr_data1(13), data(12)=>wr_data1(12), data(11)=>wr_data1(11), 
--       data(10)=>wr_data1(10), data(9)=>wr_data1(9), data(8)=>wr_data1(8), 
--       data(7)=>wr_data1(7), data(6)=>wr_data1(6), data(5)=>wr_data1(5), 
--       data(4)=>wr_data1(4), data(3)=>wr_data1(3), data(2)=>wr_data1(2), 
--       data(1)=>wr_data1(1), data(0)=>wr_data1(0), q(15)=>
--       dup_0_rtlc_rdout_n5_15, q(14)=>dup_0_rtlc_rdout_n5_14, q(13)=>
--       dup_0_rtlc_rdout_n5_13, q(12)=>dup_0_rtlc_rdout_n5_12, q(11)=>
--       dup_0_rtlc_rdout_n5_11, q(10)=>dup_0_rtlc_rdout_n5_10, q(9)=>
--       dup_0_rtlc_rdout_n5_9, q(8)=>dup_0_rtlc_rdout_n5_8, q(7)=>
--       dup_0_rtlc_rdout_n5_7, q(6)=>dup_0_rtlc_rdout_n5_6, q(5)=>
--       dup_0_rtlc_rdout_n5_5, q(4)=>dup_0_rtlc_rdout_n5_4, q(3)=>
--       dup_0_rtlc_rdout_n5_3, q(2)=>dup_0_rtlc_rdout_n5_2, q(1)=>
--       dup_0_rtlc_rdout_n5_1, q(0)=>dup_0_rtlc_rdout_n5_0, we2=>nx116, 
--       addr2(14)=>addr2(14), addr2(13)=>addr2(13), addr2(12)=>addr2(12), 
--       addr2(11)=>addr2(11), addr2(10)=>addr2(10), addr2(9)=>addr2(9), 
--       addr2(8)=>addr2(8), addr2(7)=>addr2(7), addr2(6)=>addr2(6), addr2(5)=>
--       addr2(5), addr2(4)=>addr2(4), addr2(3)=>addr2(3), addr2(2)=>addr2(2), 
--       addr2(1)=>addr2(1), addr2(0)=>addr2(0), data2(15)=>wr_data2(15), 
--       data2(14)=>wr_data2(14), data2(13)=>wr_data2(13), data2(12)=>
--       wr_data2(12), data2(11)=>wr_data2(11), data2(10)=>wr_data2(10), 
--       data2(9)=>wr_data2(9), data2(8)=>wr_data2(8), data2(7)=>wr_data2(7), 
--       data2(6)=>wr_data2(6), data2(5)=>wr_data2(5), data2(4)=>wr_data2(4), 
--       data2(3)=>wr_data2(3), data2(2)=>wr_data2(2), data2(1)=>wr_data2(1), 
--       data2(0)=>wr_data2(0), q2(15)=>dup_0_rtlc_rdout_n12_15, q2(14)=>
--       dup_0_rtlc_rdout_n12_14, q2(13)=>dup_0_rtlc_rdout_n12_13, q2(12)=>
--       dup_0_rtlc_rdout_n12_12, q2(11)=>dup_0_rtlc_rdout_n12_11, q2(10)=>
--       dup_0_rtlc_rdout_n12_10, q2(9)=>dup_0_rtlc_rdout_n12_9, q2(8)=>
--       dup_0_rtlc_rdout_n12_8, q2(7)=>dup_0_rtlc_rdout_n12_7, q2(6)=>
--       dup_0_rtlc_rdout_n12_6, q2(5)=>dup_0_rtlc_rdout_n12_5, q2(4)=>
--       dup_0_rtlc_rdout_n12_4, q2(3)=>dup_0_rtlc_rdout_n12_3, q2(2)=>
--       dup_0_rtlc_rdout_n12_2, q2(1)=>dup_0_rtlc_rdout_n12_1, q2(0)=>
--       dup_0_rtlc_rdout_n12_0);
--    nx112 <= wr_ena1 AND ena1 ;
--    nx114 <= rd_ena1 AND ena1 ;
--    nx116 <= wr_ena2 AND ena2 ;
--    nx118 <= rd_ena2 AND ena2 ;
-- end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity DPRAM_ACTEL_Infer_16_1_1 is 
   port (
      clock : IN std_logic ;
      Data_i_A : IN std_logic_vector (15 DOWNTO 0) ;
      ADDr_i_A : IN std_logic_vector (15 DOWNTO 0) ;
      WE_A : IN std_logic ;
      Data_o_A : OUT std_logic_vector (15 DOWNTO 0) ;
      Data_i_B : IN std_logic_vector (31 DOWNTO 0) ;
      ADDr_i_B : IN std_logic_vector (15 DOWNTO 0) ;
      WE_B_vec : IN std_logic_vector (1 DOWNTO 0) ;
      Data_o_B : OUT std_logic_vector (31 DOWNTO 0)) ;
end DPRAM_ACTEL_Infer_16_1_1 ;

architecture Sital_OH_unfold_1 of DPRAM_ACTEL_Infer_16_1_1 is 
   component eq_15u_15u
      port (
         a : IN std_logic_vector (14 DOWNTO 0) ;
         b : IN std_logic_vector (14 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   component ram_new_4_interlace_Actel
      port (
         wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
         rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
         addr1 : IN std_logic_vector (14 DOWNTO 0) ;
         wr_clk1 : IN std_logic ;
         rd_clk1 : IN std_logic ;
         wr_ena1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         ena1 : IN std_logic ;
         rst1 : IN std_logic ;
         regce1 : IN std_logic ;
         wr_data2 : IN std_logic_vector (15 DOWNTO 0) ;
         rd_data2 : OUT std_logic_vector (15 DOWNTO 0) ;
         addr2 : IN std_logic_vector (14 DOWNTO 0) ;
         wr_clk2 : IN std_logic ;
         rd_clk2 : IN std_logic ;
         wr_ena2 : IN std_logic ;
         rd_ena2 : IN std_logic ;
         ena2 : IN std_logic ;
         rst2 : IN std_logic ;
         regce2 : IN std_logic) ;
   end component ;
--    component ram_new_4_interlace_Actel
--       port (
--          wr_data1 : IN std_logic_vector (15 DOWNTO 0) ;
--          rd_data1 : OUT std_logic_vector (15 DOWNTO 0) ;
--          addr1 : IN std_logic_vector (14 DOWNTO 0) ;
--          wr_clk1 : IN std_logic ;
--          rd_clk1 : IN std_logic ;
--          wr_ena1 : IN std_logic ;
--          rd_ena1 : IN std_logic ;
--          ena1 : IN std_logic ;
--          rst1 : IN std_logic ;
--          regce1 : IN std_logic ;
--          wr_data2 : IN std_logic_vector (15 DOWNTO 0) ;
--          rd_data2 : OUT std_logic_vector (15 DOWNTO 0) ;
--          addr2 : IN std_logic_vector (14 DOWNTO 0) ;
--          wr_clk2 : IN std_logic ;
--          rd_clk2 : IN std_logic ;
--          wr_ena2 : IN std_logic ;
--          rd_ena2 : IN std_logic ;
--          ena2 : IN std_logic ;
--          rst2 : IN std_logic ;
--          regce2 : IN std_logic) ;
--    end component ;
   signal INT_ADD_A_D: std_logic ;
   
   signal Data_o_A_array: std_logic_vector (31 DOWNTO 0) ;
   
   signal GND: std_logic ;
   
   signal Data_o_A_4n0r1: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r2: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r3: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r4: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r5: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r6: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r7: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r8: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r9: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r10: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r11: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r12: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r13: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r14: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r15: std_logic_vector (0 DOWNTO 0) ;
   
   signal Data_o_A_4n0r16: std_logic_vector (0 DOWNTO 0) ;
   
   signal rtlcn38, nx15, nx19, nx23, nx27, nx29, nx31, NOT_WE_B_vec_0, nx37, 
      nx41, nx45, nx47, nx49, NOT_WE_B_vec_1, NOT_ADDr_i_A_0, NOT_WE_A, 
      NOT_rtlcn38: std_logic ;

begin
   GND <= '0' ;
   Data_o_A_4n0r1(0) <= Data_o_A_array(16) when INT_ADD_A_D = '1' else 
   Data_o_A_array(0) ;
   Data_o_A_4n0r2(0) <= Data_o_A_array(17) when INT_ADD_A_D = '1' else 
   Data_o_A_array(1) ;
   Data_o_A_4n0r3(0) <= Data_o_A_array(18) when INT_ADD_A_D = '1' else 
   Data_o_A_array(2) ;
   Data_o_A_4n0r4(0) <= Data_o_A_array(19) when INT_ADD_A_D = '1' else 
   Data_o_A_array(3) ;
   Data_o_A_4n0r5(0) <= Data_o_A_array(20) when INT_ADD_A_D = '1' else 
   Data_o_A_array(4) ;
   Data_o_A_4n0r6(0) <= Data_o_A_array(21) when INT_ADD_A_D = '1' else 
   Data_o_A_array(5) ;
   Data_o_A_4n0r7(0) <= Data_o_A_array(22) when INT_ADD_A_D = '1' else 
   Data_o_A_array(6) ;
   Data_o_A_4n0r8(0) <= Data_o_A_array(23) when INT_ADD_A_D = '1' else 
   Data_o_A_array(7) ;
   Data_o_A_4n0r9(0) <= Data_o_A_array(24) when INT_ADD_A_D = '1' else 
   Data_o_A_array(8) ;
   Data_o_A_4n0r10(0) <= Data_o_A_array(25) when INT_ADD_A_D = '1' else 
   Data_o_A_array(9) ;
   Data_o_A_4n0r11(0) <= Data_o_A_array(26) when INT_ADD_A_D = '1' else 
   Data_o_A_array(10) ;
   Data_o_A_4n0r12(0) <= Data_o_A_array(27) when INT_ADD_A_D = '1' else 
   Data_o_A_array(11) ;
   Data_o_A_4n0r13(0) <= Data_o_A_array(28) when INT_ADD_A_D = '1' else 
   Data_o_A_array(12) ;
   Data_o_A_4n0r14(0) <= Data_o_A_array(29) when INT_ADD_A_D = '1' else 
   Data_o_A_array(13) ;
   Data_o_A_4n0r15(0) <= Data_o_A_array(30) when INT_ADD_A_D = '1' else 
   Data_o_A_array(14) ;
   Data_o_A_4n0r16(0) <= Data_o_A_array(31) when INT_ADD_A_D = '1' else 
   Data_o_A_array(15) ;
   rtlceq_n82_eq_1276 : eq_15u_15u port map ( a(14)=>ADDr_i_B(1), a(13)=>
      ADDr_i_B(2), a(12)=>ADDr_i_B(3), a(11)=>ADDr_i_B(4), a(10)=>
      ADDr_i_B(5), a(9)=>ADDr_i_B(6), a(8)=>ADDr_i_B(7), a(7)=>ADDr_i_B(8), 
      a(6)=>ADDr_i_B(9), a(5)=>ADDr_i_B(10), a(4)=>ADDr_i_B(11), a(3)=>
      ADDr_i_B(12), a(2)=>ADDr_i_B(13), a(1)=>ADDr_i_B(14), a(0)=>
      ADDr_i_B(15), b(14)=>ADDr_i_A(1), b(13)=>ADDr_i_A(2), b(12)=>
      ADDr_i_A(3), b(11)=>ADDr_i_A(4), b(10)=>ADDr_i_A(5), b(9)=>ADDr_i_A(6), 
      b(8)=>ADDr_i_A(7), b(7)=>ADDr_i_A(8), b(6)=>ADDr_i_A(9), b(5)=>
      ADDr_i_A(10), b(4)=>ADDr_i_A(11), b(3)=>ADDr_i_A(12), b(2)=>
      ADDr_i_A(13), b(1)=>ADDr_i_A(14), b(0)=>ADDr_i_A(15), d=>rtlcn38);
   DFFPC (Data_o_A_4n0r16(0),GND,GND,clock,Data_o_A(15)) ;
   DFFPC (Data_o_A_4n0r15(0),GND,GND,clock,Data_o_A(14)) ;
   DFFPC (Data_o_A_4n0r14(0),GND,GND,clock,Data_o_A(13)) ;
   DFFPC (Data_o_A_4n0r13(0),GND,GND,clock,Data_o_A(12)) ;
   DFFPC (Data_o_A_4n0r12(0),GND,GND,clock,Data_o_A(11)) ;
   DFFPC (Data_o_A_4n0r11(0),GND,GND,clock,Data_o_A(10)) ;
   DFFPC (Data_o_A_4n0r10(0),GND,GND,clock,Data_o_A(9)) ;
   DFFPC (Data_o_A_4n0r9(0),GND,GND,clock,Data_o_A(8)) ;
   DFFPC (Data_o_A_4n0r8(0),GND,GND,clock,Data_o_A(7)) ;
   DFFPC (Data_o_A_4n0r7(0),GND,GND,clock,Data_o_A(6)) ;
   DFFPC (Data_o_A_4n0r6(0),GND,GND,clock,Data_o_A(5)) ;
   DFFPC (Data_o_A_4n0r5(0),GND,GND,clock,Data_o_A(4)) ;
   DFFPC (Data_o_A_4n0r4(0),GND,GND,clock,Data_o_A(3)) ;
   DFFPC (Data_o_A_4n0r3(0),GND,GND,clock,Data_o_A(2)) ;
   DFFPC (Data_o_A_4n0r2(0),GND,GND,clock,Data_o_A(1)) ;
   DFFPC (Data_o_A_4n0r1(0),GND,GND,clock,Data_o_A(0)) ;
   DFFPC (ADDr_i_A(0),GND,GND,clock,INT_ADD_A_D) ;
   nx15 <= '1' ;
   NOT_WE_B_vec_0 <= NOT WE_B_vec(0) ;
   mem_655350 : ram_new_4_interlace_Actel
       port map ( wr_data1(15)=>Data_i_A(15), wr_data1(14)=>Data_i_A(14), 
      wr_data1(13)=>Data_i_A(13), wr_data1(12)=>Data_i_A(12), wr_data1(11)=>
      Data_i_A(11), wr_data1(10)=>Data_i_A(10), wr_data1(9)=>Data_i_A(9), 
      wr_data1(8)=>Data_i_A(8), wr_data1(7)=>Data_i_A(7), wr_data1(6)=>
      Data_i_A(6), wr_data1(5)=>Data_i_A(5), wr_data1(4)=>Data_i_A(4), 
      wr_data1(3)=>Data_i_A(3), wr_data1(2)=>Data_i_A(2), wr_data1(1)=>
      Data_i_A(1), wr_data1(0)=>Data_i_A(0), rd_data1(15)=>
      Data_o_A_array(15), rd_data1(14)=>Data_o_A_array(14), rd_data1(13)=>
      Data_o_A_array(13), rd_data1(12)=>Data_o_A_array(12), rd_data1(11)=>
      Data_o_A_array(11), rd_data1(10)=>Data_o_A_array(10), rd_data1(9)=>
      Data_o_A_array(9), rd_data1(8)=>Data_o_A_array(8), rd_data1(7)=>
      Data_o_A_array(7), rd_data1(6)=>Data_o_A_array(6), rd_data1(5)=>
      Data_o_A_array(5), rd_data1(4)=>Data_o_A_array(4), rd_data1(3)=>
      Data_o_A_array(3), rd_data1(2)=>Data_o_A_array(2), rd_data1(1)=>
      Data_o_A_array(1), rd_data1(0)=>Data_o_A_array(0), addr1(14)=>
      ADDr_i_A(15), addr1(13)=>ADDr_i_A(14), addr1(12)=>ADDr_i_A(13), 
      addr1(11)=>ADDr_i_A(12), addr1(10)=>ADDr_i_A(11), addr1(9)=>
      ADDr_i_A(10), addr1(8)=>ADDr_i_A(9), addr1(7)=>ADDr_i_A(8), addr1(6)=>
      ADDr_i_A(7), addr1(5)=>ADDr_i_A(6), addr1(4)=>ADDr_i_A(5), addr1(3)=>
      ADDr_i_A(4), addr1(2)=>ADDr_i_A(3), addr1(1)=>ADDr_i_A(2), addr1(0)=>
      ADDr_i_A(1), wr_clk1=>clock, rd_clk1=>clock, wr_ena1=>nx19, rd_ena1=>
      nx23, ena1=>nx31, rst1=>GND, regce1=>nx15, wr_data2(15)=>Data_i_B(15), 
      wr_data2(14)=>Data_i_B(14), wr_data2(13)=>Data_i_B(13), wr_data2(12)=>
      Data_i_B(12), wr_data2(11)=>Data_i_B(11), wr_data2(10)=>Data_i_B(10), 
      wr_data2(9)=>Data_i_B(9), wr_data2(8)=>Data_i_B(8), wr_data2(7)=>
      Data_i_B(7), wr_data2(6)=>Data_i_B(6), wr_data2(5)=>Data_i_B(5), 
      wr_data2(4)=>Data_i_B(4), wr_data2(3)=>Data_i_B(3), wr_data2(2)=>
      Data_i_B(2), wr_data2(1)=>Data_i_B(1), wr_data2(0)=>Data_i_B(0), 
      rd_data2(15)=>Data_o_B(15), rd_data2(14)=>Data_o_B(14), rd_data2(13)=>
      Data_o_B(13), rd_data2(12)=>Data_o_B(12), rd_data2(11)=>Data_o_B(11), 
      rd_data2(10)=>Data_o_B(10), rd_data2(9)=>Data_o_B(9), rd_data2(8)=>
      Data_o_B(8), rd_data2(7)=>Data_o_B(7), rd_data2(6)=>Data_o_B(6), 
      rd_data2(5)=>Data_o_B(5), rd_data2(4)=>Data_o_B(4), rd_data2(3)=>
      Data_o_B(3), rd_data2(2)=>Data_o_B(2), rd_data2(1)=>Data_o_B(1), 
      rd_data2(0)=>Data_o_B(0), addr2(14)=>ADDr_i_B(15), addr2(13)=>
      ADDr_i_B(14), addr2(12)=>ADDr_i_B(13), addr2(11)=>ADDr_i_B(12), 
      addr2(10)=>ADDr_i_B(11), addr2(9)=>ADDr_i_B(10), addr2(8)=>ADDr_i_B(9), 
      addr2(7)=>ADDr_i_B(8), addr2(6)=>ADDr_i_B(7), addr2(5)=>ADDr_i_B(6), 
      addr2(4)=>ADDr_i_B(5), addr2(3)=>ADDr_i_B(4), addr2(2)=>ADDr_i_B(3), 
      addr2(1)=>ADDr_i_B(2), addr2(0)=>ADDr_i_B(1), wr_clk2=>clock, rd_clk2
      =>clock, wr_ena2=>WE_B_vec(0), rd_ena2=>NOT_WE_B_vec_0, ena2=>nx15, 
      rst2=>GND, regce2=>nx15);
   NOT_WE_B_vec_1 <= NOT WE_B_vec(1) ;
   mem_327671 : ram_new_4_interlace_Actel
       port map ( wr_data1(15)=>Data_i_A(15), wr_data1(14)=>Data_i_A(14), 
      wr_data1(13)=>Data_i_A(13), wr_data1(12)=>Data_i_A(12), wr_data1(11)=>
      Data_i_A(11), wr_data1(10)=>Data_i_A(10), wr_data1(9)=>Data_i_A(9), 
      wr_data1(8)=>Data_i_A(8), wr_data1(7)=>Data_i_A(7), wr_data1(6)=>
      Data_i_A(6), wr_data1(5)=>Data_i_A(5), wr_data1(4)=>Data_i_A(4), 
      wr_data1(3)=>Data_i_A(3), wr_data1(2)=>Data_i_A(2), wr_data1(1)=>
      Data_i_A(1), wr_data1(0)=>Data_i_A(0), rd_data1(15)=>
      Data_o_A_array(31), rd_data1(14)=>Data_o_A_array(30), rd_data1(13)=>
      Data_o_A_array(29), rd_data1(12)=>Data_o_A_array(28), rd_data1(11)=>
      Data_o_A_array(27), rd_data1(10)=>Data_o_A_array(26), rd_data1(9)=>
      Data_o_A_array(25), rd_data1(8)=>Data_o_A_array(24), rd_data1(7)=>
      Data_o_A_array(23), rd_data1(6)=>Data_o_A_array(22), rd_data1(5)=>
      Data_o_A_array(21), rd_data1(4)=>Data_o_A_array(20), rd_data1(3)=>
      Data_o_A_array(19), rd_data1(2)=>Data_o_A_array(18), rd_data1(1)=>
      Data_o_A_array(17), rd_data1(0)=>Data_o_A_array(16), addr1(14)=>
      ADDr_i_A(15), addr1(13)=>ADDr_i_A(14), addr1(12)=>ADDr_i_A(13), 
      addr1(11)=>ADDr_i_A(12), addr1(10)=>ADDr_i_A(11), addr1(9)=>
      ADDr_i_A(10), addr1(8)=>ADDr_i_A(9), addr1(7)=>ADDr_i_A(8), addr1(6)=>
      ADDr_i_A(7), addr1(5)=>ADDr_i_A(6), addr1(4)=>ADDr_i_A(5), addr1(3)=>
      ADDr_i_A(4), addr1(2)=>ADDr_i_A(3), addr1(1)=>ADDr_i_A(2), addr1(0)=>
      ADDr_i_A(1), wr_clk1=>clock, rd_clk1=>clock, wr_ena1=>nx37, rd_ena1=>
      nx41, ena1=>nx49, rst1=>GND, regce1=>nx15, wr_data2(15)=>Data_i_B(31), 
      wr_data2(14)=>Data_i_B(30), wr_data2(13)=>Data_i_B(29), wr_data2(12)=>
      Data_i_B(28), wr_data2(11)=>Data_i_B(27), wr_data2(10)=>Data_i_B(26), 
      wr_data2(9)=>Data_i_B(25), wr_data2(8)=>Data_i_B(24), wr_data2(7)=>
      Data_i_B(23), wr_data2(6)=>Data_i_B(22), wr_data2(5)=>Data_i_B(21), 
      wr_data2(4)=>Data_i_B(20), wr_data2(3)=>Data_i_B(19), wr_data2(2)=>
      Data_i_B(18), wr_data2(1)=>Data_i_B(17), wr_data2(0)=>Data_i_B(16), 
      rd_data2(15)=>Data_o_B(31), rd_data2(14)=>Data_o_B(30), rd_data2(13)=>
      Data_o_B(29), rd_data2(12)=>Data_o_B(28), rd_data2(11)=>Data_o_B(27), 
      rd_data2(10)=>Data_o_B(26), rd_data2(9)=>Data_o_B(25), rd_data2(8)=>
      Data_o_B(24), rd_data2(7)=>Data_o_B(23), rd_data2(6)=>Data_o_B(22), 
      rd_data2(5)=>Data_o_B(21), rd_data2(4)=>Data_o_B(20), rd_data2(3)=>
      Data_o_B(19), rd_data2(2)=>Data_o_B(18), rd_data2(1)=>Data_o_B(17), 
      rd_data2(0)=>Data_o_B(16), addr2(14)=>ADDr_i_B(15), addr2(13)=>
      ADDr_i_B(14), addr2(12)=>ADDr_i_B(13), addr2(11)=>ADDr_i_B(12), 
      addr2(10)=>ADDr_i_B(11), addr2(9)=>ADDr_i_B(10), addr2(8)=>ADDr_i_B(9), 
      addr2(7)=>ADDr_i_B(8), addr2(6)=>ADDr_i_B(7), addr2(5)=>ADDr_i_B(6), 
      addr2(4)=>ADDr_i_B(5), addr2(3)=>ADDr_i_B(4), addr2(2)=>ADDr_i_B(3), 
      addr2(1)=>ADDr_i_B(2), addr2(0)=>ADDr_i_B(1), wr_clk2=>clock, rd_clk2
      =>clock, wr_ena2=>WE_B_vec(1), rd_ena2=>NOT_WE_B_vec_1, ena2=>nx15, 
      rst2=>GND, regce2=>nx15);
   NOT_ADDr_i_A_0 <= NOT ADDr_i_A(0) ;
   nx19 <= NOT_ADDr_i_A_0 AND WE_A ;
   nx37 <= ADDr_i_A(0) AND WE_A ;
   NOT_WE_A <= NOT WE_A ;
   nx23 <= ADDr_i_A(0) OR NOT_WE_A ;
   NOT_rtlcn38 <= NOT rtlcn38 ;
   nx27 <= NOT_WE_B_vec_0 OR NOT_rtlcn38 ;
   nx29 <= nx27 OR ADDr_i_A(0) ;
   nx31 <= nx29 OR NOT_WE_A ;
   nx41 <= NOT_ADDr_i_A_0 OR NOT_WE_A ;
   nx45 <= NOT_WE_B_vec_1 OR NOT_rtlcn38 ;
   nx47 <= nx45 OR NOT_ADDr_i_A_0 ;
   nx49 <= nx47 OR NOT_WE_A ;
end Sital_OH_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity DPRAM_Interlaced2_16_1_1 is 
   port (
      ADDr_i_A : IN std_logic_vector (15 DOWNTO 0) ;
      ADDr_i_B : IN std_logic_vector (15 DOWNTO 0) ;
      Data_i_A : IN std_logic_vector (15 DOWNTO 0) ;
      Data_i_B : IN std_logic_vector (31 DOWNTO 0) ;
      WE_A : IN std_logic ;
      WE_B_vec : IN std_logic_vector (1 DOWNTO 0) ;
      clock : IN std_logic ;
      Data_o_A : OUT std_logic_vector (15 DOWNTO 0) ;
      Data_o_B : OUT std_logic_vector (31 DOWNTO 0)) ;
end DPRAM_Interlaced2_16_1_1 ;

architecture sital_ofer_hofman_unfold_2945 of DPRAM_Interlaced2_16_1_1 is 
   component DPRAM_ACTEL_Infer_16_1_1
      port (
         clock : IN std_logic ;
         Data_i_A : IN std_logic_vector (15 DOWNTO 0) ;
         ADDr_i_A : IN std_logic_vector (15 DOWNTO 0) ;
         WE_A : IN std_logic ;
         Data_o_A : OUT std_logic_vector (15 DOWNTO 0) ;
         Data_i_B : IN std_logic_vector (31 DOWNTO 0) ;
         ADDr_i_B : IN std_logic_vector (15 DOWNTO 0) ;
         WE_B_vec : IN std_logic_vector (1 DOWNTO 0) ;
         Data_o_B : OUT std_logic_vector (31 DOWNTO 0)) ;
   end component ;
   signal nx4: std_logic ;

begin
   U_0 : DPRAM_ACTEL_Infer_16_1_1 port map ( clock=>clock, Data_i_A(15)=>
      Data_i_A(15), Data_i_A(14)=>Data_i_A(14), Data_i_A(13)=>Data_i_A(13), 
      Data_i_A(12)=>Data_i_A(12), Data_i_A(11)=>Data_i_A(11), Data_i_A(10)=>
      Data_i_A(10), Data_i_A(9)=>Data_i_A(9), Data_i_A(8)=>Data_i_A(8), 
      Data_i_A(7)=>Data_i_A(7), Data_i_A(6)=>Data_i_A(6), Data_i_A(5)=>
      Data_i_A(5), Data_i_A(4)=>Data_i_A(4), Data_i_A(3)=>Data_i_A(3), 
      Data_i_A(2)=>Data_i_A(2), Data_i_A(1)=>Data_i_A(1), Data_i_A(0)=>
      Data_i_A(0), ADDr_i_A(15)=>ADDr_i_A(15), ADDr_i_A(14)=>ADDr_i_A(14), 
      ADDr_i_A(13)=>ADDr_i_A(13), ADDr_i_A(12)=>ADDr_i_A(12), ADDr_i_A(11)=>
      ADDr_i_A(11), ADDr_i_A(10)=>ADDr_i_A(10), ADDr_i_A(9)=>ADDr_i_A(9), 
      ADDr_i_A(8)=>ADDr_i_A(8), ADDr_i_A(7)=>ADDr_i_A(7), ADDr_i_A(6)=>
      ADDr_i_A(6), ADDr_i_A(5)=>ADDr_i_A(5), ADDr_i_A(4)=>ADDr_i_A(4), 
      ADDr_i_A(3)=>ADDr_i_A(3), ADDr_i_A(2)=>ADDr_i_A(2), ADDr_i_A(1)=>
      ADDr_i_A(1), ADDr_i_A(0)=>ADDr_i_A(0), WE_A=>WE_A, Data_o_A(15)=>
      Data_o_A(15), Data_o_A(14)=>Data_o_A(14), Data_o_A(13)=>Data_o_A(13), 
      Data_o_A(12)=>Data_o_A(12), Data_o_A(11)=>Data_o_A(11), Data_o_A(10)=>
      Data_o_A(10), Data_o_A(9)=>Data_o_A(9), Data_o_A(8)=>Data_o_A(8), 
      Data_o_A(7)=>Data_o_A(7), Data_o_A(6)=>Data_o_A(6), Data_o_A(5)=>
      Data_o_A(5), Data_o_A(4)=>Data_o_A(4), Data_o_A(3)=>Data_o_A(3), 
      Data_o_A(2)=>Data_o_A(2), Data_o_A(1)=>Data_o_A(1), Data_o_A(0)=>
      Data_o_A(0), Data_i_B(31)=>Data_i_B(31), Data_i_B(30)=>Data_i_B(30), 
      Data_i_B(29)=>Data_i_B(29), Data_i_B(28)=>Data_i_B(28), Data_i_B(27)=>
      Data_i_B(27), Data_i_B(26)=>Data_i_B(26), Data_i_B(25)=>Data_i_B(25), 
      Data_i_B(24)=>Data_i_B(24), Data_i_B(23)=>Data_i_B(23), Data_i_B(22)=>
      Data_i_B(22), Data_i_B(21)=>Data_i_B(21), Data_i_B(20)=>Data_i_B(20), 
      Data_i_B(19)=>Data_i_B(19), Data_i_B(18)=>Data_i_B(18), Data_i_B(17)=>
      Data_i_B(17), Data_i_B(16)=>Data_i_B(16), Data_i_B(15)=>Data_i_B(15), 
      Data_i_B(14)=>Data_i_B(14), Data_i_B(13)=>Data_i_B(13), Data_i_B(12)=>
      Data_i_B(12), Data_i_B(11)=>Data_i_B(11), Data_i_B(10)=>Data_i_B(10), 
      Data_i_B(9)=>Data_i_B(9), Data_i_B(8)=>Data_i_B(8), Data_i_B(7)=>
      Data_i_B(7), Data_i_B(6)=>Data_i_B(6), Data_i_B(5)=>Data_i_B(5), 
      Data_i_B(4)=>Data_i_B(4), Data_i_B(3)=>Data_i_B(3), Data_i_B(2)=>
      Data_i_B(2), Data_i_B(1)=>Data_i_B(1), Data_i_B(0)=>Data_i_B(0), 
      ADDr_i_B(15)=>ADDr_i_B(15), ADDr_i_B(14)=>ADDr_i_B(14), ADDr_i_B(13)=>
      ADDr_i_B(13), ADDr_i_B(12)=>ADDr_i_B(12), ADDr_i_B(11)=>ADDr_i_B(11), 
      ADDr_i_B(10)=>ADDr_i_B(10), ADDr_i_B(9)=>ADDr_i_B(9), ADDr_i_B(8)=>
      ADDr_i_B(8), ADDr_i_B(7)=>ADDr_i_B(7), ADDr_i_B(6)=>ADDr_i_B(6), 
      ADDr_i_B(5)=>ADDr_i_B(5), ADDr_i_B(4)=>ADDr_i_B(4), ADDr_i_B(3)=>
      ADDr_i_B(3), ADDr_i_B(2)=>ADDr_i_B(2), ADDr_i_B(1)=>ADDr_i_B(1), 
      ADDr_i_B(0)=>nx4, WE_B_vec(1)=>WE_B_vec(1), WE_B_vec(0)=>WE_B_vec(0), 
      Data_o_B(31)=>Data_o_B(31), Data_o_B(30)=>Data_o_B(30), Data_o_B(29)=>
      Data_o_B(29), Data_o_B(28)=>Data_o_B(28), Data_o_B(27)=>Data_o_B(27), 
      Data_o_B(26)=>Data_o_B(26), Data_o_B(25)=>Data_o_B(25), Data_o_B(24)=>
      Data_o_B(24), Data_o_B(23)=>Data_o_B(23), Data_o_B(22)=>Data_o_B(22), 
      Data_o_B(21)=>Data_o_B(21), Data_o_B(20)=>Data_o_B(20), Data_o_B(19)=>
      Data_o_B(19), Data_o_B(18)=>Data_o_B(18), Data_o_B(17)=>Data_o_B(17), 
      Data_o_B(16)=>Data_o_B(16), Data_o_B(15)=>Data_o_B(15), Data_o_B(14)=>
      Data_o_B(14), Data_o_B(13)=>Data_o_B(13), Data_o_B(12)=>Data_o_B(12), 
      Data_o_B(11)=>Data_o_B(11), Data_o_B(10)=>Data_o_B(10), Data_o_B(9)=>
      Data_o_B(9), Data_o_B(8)=>Data_o_B(8), Data_o_B(7)=>Data_o_B(7), 
      Data_o_B(6)=>Data_o_B(6), Data_o_B(5)=>Data_o_B(5), Data_o_B(4)=>
      Data_o_B(4), Data_o_B(3)=>Data_o_B(3), Data_o_B(2)=>Data_o_B(2), 
      Data_o_B(1)=>Data_o_B(1), Data_o_B(0)=>Data_o_B(0));
   nx4 <= '0' ;
end sital_ofer_hofman_unfold_2945 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_updn_aclear_clock_clk_en_0_6 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (5 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (5 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_updn_aclear_clock_clk_en_0_6 ;

architecture INTERFACE of counter_updn_aclear_clock_clk_en_0_6 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, nx31, nx32, nx33, nx34, PWR, nx38, nx39, nx40, 
      nx41, nx42, nx43: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(5) <= nx18 ;
   q(4) <= nx20 ;
   q(3) <= nx22 ;
   q(2) <= nx24 ;
   q(1) <= nx26 ;
   q(0) <= nx28 ;
   GND <= '0' ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,clk_en,clock,nx28) ;
   inc : inc_6u_6u_0_0 port map ( cin=>PWR, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx29, d(4)=>nx30, d(3)
      =>nx31, d(2)=>nx32, d(1)=>nx33, d(0)=>nx34, cout=>DANGLING(0));
   PWR <= '1' ;
   dec : dec_6u_6u_0_0 port map ( cin=>GND, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx38, d(4)=>nx39, d(3)
      =>nx40, d(2)=>nx41, d(1)=>nx42, d(0)=>nx43, cout=>DANGLING(1));
   nx17 <= nx29 when updn = '1' else nx38 ;
   nx19 <= nx30 when updn = '1' else nx39 ;
   nx21 <= nx31 when updn = '1' else nx40 ;
   nx23 <= nx32 when updn = '1' else nx41 ;
   nx25 <= nx33 when updn = '1' else nx42 ;
   nx27 <= nx34 when updn = '1' else nx43 ;
end INTERFACE ;


architecture INTERFACE_unfold_4 of counter_dn_sload_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx15 <= data(4) when sload = '1' else nx25 ;
   nx17 <= data(3) when sload = '1' else nx26 ;
   nx19 <= data(2) when sload = '1' else nx27 ;
   nx21 <= data(1) when sload = '1' else nx28 ;
   nx23 <= data(0) when sload = '1' else nx29 ;
end INTERFACE_unfold_4 ;


architecture INTERFACE of counter_dn_sload_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx15 <= data(4) when sload = '1' else nx25 ;
   nx17 <= data(3) when sload = '1' else nx26 ;
   nx19 <= data(2) when sload = '1' else nx27 ;
   nx21 <= data(1) when sload = '1' else nx28 ;
   nx23 <= data(0) when sload = '1' else nx29 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_dn_sload_aclear_clock_clk_en_0_4 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (3 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (3 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_dn_sload_aclear_clock_clk_en_0_4 ;

architecture INTERFACE of counter_dn_sload_aclear_clock_clk_en_0_4 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx13, nx14, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, 
      nx23, nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(3) <= nx14 ;
   q(2) <= nx16 ;
   q(1) <= nx18 ;
   q(0) <= nx20 ;
   GND <= '0' ;
   DFFPCE (nx13,GND,aclear,clk_en,clock,nx14) ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   dec : dec_4u_4u_0_0 port map ( cin=>GND, a(3)=>nx14, a(2)=>nx16, a(1)=>
      nx18, a(0)=>nx20, d(3)=>nx21, d(2)=>nx22, d(1)=>nx23, d(0)=>nx24, cout
      =>DANGLING(0));
   nx13 <= data(3) when sload = '1' else nx21 ;
   nx15 <= data(2) when sload = '1' else nx22 ;
   nx17 <= data(1) when sload = '1' else nx23 ;
   nx19 <= data(0) when sload = '1' else nx24 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_updn_sclear_aclear_clock_clk_en_0_6 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (5 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (5 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_updn_sclear_aclear_clock_clk_en_0_6 ;

architecture INTERFACE of counter_updn_sclear_aclear_clock_clk_en_0_6 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR3458: std_logic_vector (5 DOWNTO 0) ;
   
   signal nx13, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, nx31, nx32, nx33, nx34, nx36, nx38, nx39, nx40, 
      nx41, nx42, nx43, nx45, nx47, nx49, nx51, nx53, nx55, NOT_SCLEAR: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(5) <= nx18 ;
   q(4) <= nx20 ;
   q(3) <= nx22 ;
   q(2) <= nx24 ;
   q(1) <= nx26 ;
   q(0) <= nx28 ;
   nx13 <= '0' ;
   DFFPCE (nx17,nx13,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,nx13,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx13,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx13,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,nx13,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,nx13,aclear,clk_en,clock,nx28) ;
   inc : inc_6u_6u_0_0 port map ( cin=>nx36, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx29, d(4)=>nx30, d(3)
      =>nx31, d(2)=>nx32, d(1)=>nx33, d(0)=>nx34, cout=>DANGLING(0));
   nx36 <= '1' ;
   dec : dec_6u_6u_0_0 port map ( cin=>nx13, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx38, d(4)=>nx39, d(3)
      =>nx40, d(2)=>nx41, d(1)=>nx42, d(0)=>nx43, cout=>DANGLING(1));
   nx45 <= nx29 when updn = '1' else nx38 ;
   nx47 <= nx30 when updn = '1' else nx39 ;
   nx49 <= nx31 when updn = '1' else nx40 ;
   nx51 <= nx32 when updn = '1' else nx41 ;
   nx53 <= nx33 when updn = '1' else nx42 ;
   nx55 <= nx34 when updn = '1' else nx43 ;
   NOT_SCLEAR <= NOT sclear ;
   nx17 <= nx45 AND NOT_SCLEAR ;
   nx19 <= nx47 AND NOT_SCLEAR ;
   nx21 <= nx49 AND NOT_SCLEAR ;
   nx23 <= nx51 AND NOT_SCLEAR ;
   nx25 <= nx53 AND NOT_SCLEAR ;
   nx27 <= nx55 AND NOT_SCLEAR ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity counter_updn_sload_aclear_clock_clk_en_0_5 is 
   port (
      clock : IN std_logic ;
      q : OUT std_logic_vector (4 DOWNTO 0) ;
      clk_en : IN std_logic ;
      aclear : IN std_logic ;
      sload : IN std_logic ;
      data : IN std_logic_vector (4 DOWNTO 0) ;
      aset : IN std_logic ;
      sclear : IN std_logic ;
      updn : IN std_logic ;
      cnt_en : IN std_logic) ;
end counter_updn_sload_aclear_clock_clk_en_0_5 ;

architecture INTERFACE of counter_updn_sload_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR3471: std_logic_vector (4 DOWNTO 0) ;
   
   signal nx11, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, nx31, nx33, nx34, nx35, nx36, nx37, nx39, 
      nx41, nx43, nx45, nx47: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   nx11 <= '0' ;
   DFFPCE (nx15,nx11,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,nx11,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,nx11,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx11,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx11,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>nx31, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx31 <= '1' ;
   dec : dec_5u_5u_0_0 port map ( cin=>nx11, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx33, d(3)=>nx34, d(2)=>nx35, d(1)
      =>nx36, d(0)=>nx37, cout=>DANGLING(1));
   nx39 <= nx25 when updn = '1' else nx33 ;
   nx41 <= nx26 when updn = '1' else nx34 ;
   nx43 <= nx27 when updn = '1' else nx35 ;
   nx45 <= nx28 when updn = '1' else nx36 ;
   nx47 <= nx29 when updn = '1' else nx37 ;
   nx15 <= data(4) when sload = '1' else nx39 ;
   nx17 <= data(3) when sload = '1' else nx41 ;
   nx19 <= data(2) when sload = '1' else nx43 ;
   nx21 <= data(1) when sload = '1' else nx45 ;
   nx23 <= data(0) when sload = '1' else nx47 ;
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   port (
      address : IN std_logic_vector (8 DOWNTO 0) ;
      inclock : IN std_logic ;
      outclock : IN std_logic ;
      outclockena : IN std_logic ;
      q : OUT std_logic_vector (0 DOWNTO 0)) ;
end rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate ;

architecture INTERFACE_unfold_1 of 
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component mux_512u_512u
      port (
         a : IN std_logic_vector (511 DOWNTO 0) ;
         b : IN std_logic_vector (511 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_1337 : mux_512u_512u port map ( a(511)=>GND, a(510)=>GND, 
      a(509)=>GND, a(508)=>GND, a(507)=>GND, a(506)=>GND, a(505)=>GND, 
      a(504)=>GND, a(503)=>GND, a(502)=>GND, a(501)=>GND, a(500)=>GND, 
      a(499)=>GND, a(498)=>GND, a(497)=>GND, a(496)=>GND, a(495)=>GND, 
      a(494)=>GND, a(493)=>GND, a(492)=>GND, a(491)=>GND, a(490)=>GND, 
      a(489)=>GND, a(488)=>GND, a(487)=>GND, a(486)=>GND, a(485)=>GND, 
      a(484)=>GND, a(483)=>GND, a(482)=>GND, a(481)=>GND, a(480)=>GND, 
      a(479)=>GND, a(478)=>GND, a(477)=>GND, a(476)=>GND, a(475)=>GND, 
      a(474)=>GND, a(473)=>GND, a(472)=>GND, a(471)=>GND, a(470)=>GND, 
      a(469)=>GND, a(468)=>GND, a(467)=>GND, a(466)=>GND, a(465)=>GND, 
      a(464)=>GND, a(463)=>GND, a(462)=>GND, a(461)=>GND, a(460)=>GND, 
      a(459)=>GND, a(458)=>GND, a(457)=>GND, a(456)=>GND, a(455)=>GND, 
      a(454)=>GND, a(453)=>GND, a(452)=>GND, a(451)=>GND, a(450)=>GND, 
      a(449)=>GND, a(448)=>GND, a(447)=>GND, a(446)=>GND, a(445)=>GND, 
      a(444)=>GND, a(443)=>GND, a(442)=>GND, a(441)=>GND, a(440)=>GND, 
      a(439)=>GND, a(438)=>GND, a(437)=>GND, a(436)=>GND, a(435)=>GND, 
      a(434)=>GND, a(433)=>GND, a(432)=>GND, a(431)=>GND, a(430)=>GND, 
      a(429)=>GND, a(428)=>GND, a(427)=>GND, a(426)=>GND, a(425)=>GND, 
      a(424)=>GND, a(423)=>GND, a(422)=>GND, a(421)=>GND, a(420)=>GND, 
      a(419)=>GND, a(418)=>GND, a(417)=>GND, a(416)=>GND, a(415)=>GND, 
      a(414)=>GND, a(413)=>GND, a(412)=>GND, a(411)=>GND, a(410)=>GND, 
      a(409)=>GND, a(408)=>GND, a(407)=>GND, a(406)=>GND, a(405)=>GND, 
      a(404)=>GND, a(403)=>GND, a(402)=>GND, a(401)=>GND, a(400)=>GND, 
      a(399)=>GND, a(398)=>GND, a(397)=>GND, a(396)=>GND, a(395)=>GND, 
      a(394)=>GND, a(393)=>GND, a(392)=>GND, a(391)=>GND, a(390)=>GND, 
      a(389)=>GND, a(388)=>GND, a(387)=>GND, a(386)=>GND, a(385)=>GND, 
      a(384)=>GND, a(383)=>GND, a(382)=>GND, a(381)=>GND, a(380)=>GND, 
      a(379)=>GND, a(378)=>GND, a(377)=>GND, a(376)=>GND, a(375)=>GND, 
      a(374)=>GND, a(373)=>GND, a(372)=>GND, a(371)=>GND, a(370)=>GND, 
      a(369)=>GND, a(368)=>GND, a(367)=>GND, a(366)=>GND, a(365)=>GND, 
      a(364)=>GND, a(363)=>GND, a(362)=>GND, a(361)=>GND, a(360)=>GND, 
      a(359)=>GND, a(358)=>GND, a(357)=>GND, a(356)=>GND, a(355)=>GND, 
      a(354)=>GND, a(353)=>GND, a(352)=>GND, a(351)=>GND, a(350)=>GND, 
      a(349)=>GND, a(348)=>GND, a(347)=>GND, a(346)=>GND, a(345)=>GND, 
      a(344)=>GND, a(343)=>GND, a(342)=>GND, a(341)=>GND, a(340)=>GND, 
      a(339)=>GND, a(338)=>GND, a(337)=>GND, a(336)=>GND, a(335)=>GND, 
      a(334)=>GND, a(333)=>GND, a(332)=>GND, a(331)=>GND, a(330)=>GND, 
      a(329)=>GND, a(328)=>GND, a(327)=>GND, a(326)=>GND, a(325)=>GND, 
      a(324)=>GND, a(323)=>GND, a(322)=>GND, a(321)=>GND, a(320)=>GND, 
      a(319)=>GND, a(318)=>GND, a(317)=>GND, a(316)=>GND, a(315)=>GND, 
      a(314)=>GND, a(313)=>GND, a(312)=>GND, a(311)=>GND, a(310)=>GND, 
      a(309)=>GND, a(308)=>GND, a(307)=>GND, a(306)=>GND, a(305)=>GND, 
      a(304)=>GND, a(303)=>GND, a(302)=>GND, a(301)=>GND, a(300)=>GND, 
      a(299)=>GND, a(298)=>GND, a(297)=>GND, a(296)=>GND, a(295)=>GND, 
      a(294)=>GND, a(293)=>GND, a(292)=>GND, a(291)=>GND, a(290)=>GND, 
      a(289)=>GND, a(288)=>GND, a(287)=>GND, a(286)=>GND, a(285)=>GND, 
      a(284)=>GND, a(283)=>GND, a(282)=>GND, a(281)=>GND, a(280)=>GND, 
      a(279)=>GND, a(278)=>GND, a(277)=>GND, a(276)=>GND, a(275)=>GND, 
      a(274)=>GND, a(273)=>GND, a(272)=>GND, a(271)=>GND, a(270)=>GND, 
      a(269)=>GND, a(268)=>GND, a(267)=>GND, a(266)=>GND, a(265)=>PWR, 
      a(264)=>GND, a(263)=>GND, a(262)=>GND, a(261)=>GND, a(260)=>GND, 
      a(259)=>GND, a(258)=>GND, a(257)=>GND, a(256)=>GND, a(255)=>GND, 
      a(254)=>GND, a(253)=>GND, a(252)=>GND, a(251)=>GND, a(250)=>GND, 
      a(249)=>GND, a(248)=>GND, a(247)=>GND, a(246)=>GND, a(245)=>GND, 
      a(244)=>GND, a(243)=>GND, a(242)=>GND, a(241)=>GND, a(240)=>GND, 
      a(239)=>GND, a(238)=>GND, a(237)=>GND, a(236)=>GND, a(235)=>GND, 
      a(234)=>GND, a(233)=>GND, a(232)=>GND, a(231)=>GND, a(230)=>GND, 
      a(229)=>GND, a(228)=>GND, a(227)=>GND, a(226)=>GND, a(225)=>GND, 
      a(224)=>GND, a(223)=>GND, a(222)=>GND, a(221)=>GND, a(220)=>GND, 
      a(219)=>GND, a(218)=>GND, a(217)=>GND, a(216)=>GND, a(215)=>GND, 
      a(214)=>GND, a(213)=>GND, a(212)=>GND, a(211)=>GND, a(210)=>GND, 
      a(209)=>GND, a(208)=>GND, a(207)=>GND, a(206)=>GND, a(205)=>GND, 
      a(204)=>GND, a(203)=>GND, a(202)=>GND, a(201)=>GND, a(200)=>GND, 
      a(199)=>GND, a(198)=>GND, a(197)=>GND, a(196)=>GND, a(195)=>GND, 
      a(194)=>GND, a(193)=>GND, a(192)=>GND, a(191)=>GND, a(190)=>GND, 
      a(189)=>GND, a(188)=>GND, a(187)=>GND, a(186)=>GND, a(185)=>GND, 
      a(184)=>GND, a(183)=>GND, a(182)=>GND, a(181)=>GND, a(180)=>GND, 
      a(179)=>GND, a(178)=>GND, a(177)=>GND, a(176)=>GND, a(175)=>GND, 
      a(174)=>GND, a(173)=>GND, a(172)=>GND, a(171)=>GND, a(170)=>GND, 
      a(169)=>GND, a(168)=>GND, a(167)=>GND, a(166)=>GND, a(165)=>GND, 
      a(164)=>GND, a(163)=>GND, a(162)=>GND, a(161)=>GND, a(160)=>GND, 
      a(159)=>GND, a(158)=>GND, a(157)=>GND, a(156)=>GND, a(155)=>GND, 
      a(154)=>GND, a(153)=>GND, a(152)=>GND, a(151)=>GND, a(150)=>GND, 
      a(149)=>GND, a(148)=>GND, a(147)=>GND, a(146)=>GND, a(145)=>GND, 
      a(144)=>GND, a(143)=>GND, a(142)=>GND, a(141)=>GND, a(140)=>GND, 
      a(139)=>GND, a(138)=>GND, a(137)=>GND, a(136)=>GND, a(135)=>GND, 
      a(134)=>GND, a(133)=>GND, a(132)=>GND, a(131)=>GND, a(130)=>GND, 
      a(129)=>GND, a(128)=>GND, a(127)=>GND, a(126)=>GND, a(125)=>GND, 
      a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, a(120)=>GND, 
      a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, a(115)=>GND, 
      a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, a(110)=>GND, 
      a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, a(105)=>GND, 
      a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, a(100)=>GND, a(99)
      =>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>GND, a(94)=>GND, 
      a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)=>GND, a(88)=>GND, 
      a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, a(83)=>GND, a(82)=>GND, 
      a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, a(77)=>GND, a(76)=>GND, 
      a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, a(71)=>GND, a(70)=>GND, 
      a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, a(65)=>GND, a(64)=>GND, 
      a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, a(59)=>GND, a(58)=>GND, 
      a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, a(53)=>GND, a(52)=>GND, 
      a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, a(47)=>GND, a(46)=>GND, 
      a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, a(41)=>GND, a(40)=>GND, 
      a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, a(35)=>GND, a(34)=>GND, 
      a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, a(29)=>GND, a(28)=>GND, 
      a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, a(23)=>GND, a(22)=>GND, 
      a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, a(17)=>GND, a(16)=>GND, 
      a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)=>GND, a(10)=>GND, 
      a(9)=>GND, a(8)=>GND, a(7)=>PWR, a(6)=>GND, a(5)=>GND, a(4)=>GND, a(3)
      =>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(511)=>GND, b(510)=>GND, 
      b(509)=>GND, b(508)=>GND, b(507)=>GND, b(506)=>GND, b(505)=>GND, 
      b(504)=>GND, b(503)=>GND, b(502)=>GND, b(501)=>GND, b(500)=>GND, 
      b(499)=>GND, b(498)=>GND, b(497)=>GND, b(496)=>GND, b(495)=>GND, 
      b(494)=>GND, b(493)=>GND, b(492)=>GND, b(491)=>GND, b(490)=>GND, 
      b(489)=>GND, b(488)=>GND, b(487)=>GND, b(486)=>GND, b(485)=>GND, 
      b(484)=>GND, b(483)=>GND, b(482)=>GND, b(481)=>GND, b(480)=>GND, 
      b(479)=>GND, b(478)=>GND, b(477)=>GND, b(476)=>GND, b(475)=>GND, 
      b(474)=>GND, b(473)=>GND, b(472)=>GND, b(471)=>GND, b(470)=>GND, 
      b(469)=>GND, b(468)=>GND, b(467)=>GND, b(466)=>GND, b(465)=>GND, 
      b(464)=>GND, b(463)=>GND, b(462)=>GND, b(461)=>GND, b(460)=>GND, 
      b(459)=>GND, b(458)=>GND, b(457)=>GND, b(456)=>GND, b(455)=>GND, 
      b(454)=>GND, b(453)=>GND, b(452)=>GND, b(451)=>GND, b(450)=>GND, 
      b(449)=>GND, b(448)=>GND, b(447)=>GND, b(446)=>GND, b(445)=>GND, 
      b(444)=>GND, b(443)=>GND, b(442)=>GND, b(441)=>GND, b(440)=>GND, 
      b(439)=>GND, b(438)=>GND, b(437)=>GND, b(436)=>GND, b(435)=>GND, 
      b(434)=>GND, b(433)=>GND, b(432)=>GND, b(431)=>GND, b(430)=>GND, 
      b(429)=>GND, b(428)=>GND, b(427)=>GND, b(426)=>GND, b(425)=>GND, 
      b(424)=>GND, b(423)=>GND, b(422)=>GND, b(421)=>GND, b(420)=>GND, 
      b(419)=>GND, b(418)=>GND, b(417)=>GND, b(416)=>GND, b(415)=>GND, 
      b(414)=>GND, b(413)=>GND, b(412)=>GND, b(411)=>GND, b(410)=>GND, 
      b(409)=>GND, b(408)=>GND, b(407)=>GND, b(406)=>GND, b(405)=>GND, 
      b(404)=>GND, b(403)=>GND, b(402)=>GND, b(401)=>GND, b(400)=>GND, 
      b(399)=>GND, b(398)=>GND, b(397)=>GND, b(396)=>GND, b(395)=>GND, 
      b(394)=>GND, b(393)=>GND, b(392)=>GND, b(391)=>GND, b(390)=>GND, 
      b(389)=>GND, b(388)=>GND, b(387)=>GND, b(386)=>GND, b(385)=>GND, 
      b(384)=>GND, b(383)=>GND, b(382)=>GND, b(381)=>GND, b(380)=>GND, 
      b(379)=>GND, b(378)=>GND, b(377)=>GND, b(376)=>GND, b(375)=>GND, 
      b(374)=>GND, b(373)=>GND, b(372)=>GND, b(371)=>GND, b(370)=>GND, 
      b(369)=>GND, b(368)=>GND, b(367)=>GND, b(366)=>GND, b(365)=>GND, 
      b(364)=>GND, b(363)=>GND, b(362)=>GND, b(361)=>GND, b(360)=>GND, 
      b(359)=>GND, b(358)=>GND, b(357)=>GND, b(356)=>GND, b(355)=>GND, 
      b(354)=>GND, b(353)=>GND, b(352)=>GND, b(351)=>GND, b(350)=>GND, 
      b(349)=>GND, b(348)=>GND, b(347)=>GND, b(346)=>GND, b(345)=>GND, 
      b(344)=>GND, b(343)=>GND, b(342)=>GND, b(341)=>GND, b(340)=>GND, 
      b(339)=>GND, b(338)=>GND, b(337)=>GND, b(336)=>GND, b(335)=>GND, 
      b(334)=>GND, b(333)=>GND, b(332)=>GND, b(331)=>GND, b(330)=>GND, 
      b(329)=>GND, b(328)=>GND, b(327)=>GND, b(326)=>GND, b(325)=>GND, 
      b(324)=>GND, b(323)=>GND, b(322)=>GND, b(321)=>GND, b(320)=>GND, 
      b(319)=>GND, b(318)=>GND, b(317)=>GND, b(316)=>GND, b(315)=>GND, 
      b(314)=>GND, b(313)=>GND, b(312)=>GND, b(311)=>GND, b(310)=>GND, 
      b(309)=>GND, b(308)=>GND, b(307)=>GND, b(306)=>GND, b(305)=>GND, 
      b(304)=>GND, b(303)=>GND, b(302)=>GND, b(301)=>GND, b(300)=>GND, 
      b(299)=>GND, b(298)=>GND, b(297)=>GND, b(296)=>GND, b(295)=>GND, 
      b(294)=>GND, b(293)=>GND, b(292)=>GND, b(291)=>GND, b(290)=>GND, 
      b(289)=>GND, b(288)=>GND, b(287)=>GND, b(286)=>GND, b(285)=>GND, 
      b(284)=>GND, b(283)=>GND, b(282)=>GND, b(281)=>GND, b(280)=>GND, 
      b(279)=>GND, b(278)=>GND, b(277)=>GND, b(276)=>GND, b(275)=>GND, 
      b(274)=>GND, b(273)=>GND, b(272)=>GND, b(271)=>GND, b(270)=>GND, 
      b(269)=>GND, b(268)=>GND, b(267)=>GND, b(266)=>GND, b(265)=>GND, 
      b(264)=>GND, b(263)=>GND, b(262)=>GND, b(261)=>GND, b(260)=>GND, 
      b(259)=>GND, b(258)=>GND, b(257)=>GND, b(256)=>GND, b(255)=>GND, 
      b(254)=>GND, b(253)=>GND, b(252)=>GND, b(251)=>GND, b(250)=>GND, 
      b(249)=>GND, b(248)=>GND, b(247)=>GND, b(246)=>GND, b(245)=>GND, 
      b(244)=>GND, b(243)=>GND, b(242)=>GND, b(241)=>GND, b(240)=>GND, 
      b(239)=>GND, b(238)=>GND, b(237)=>GND, b(236)=>GND, b(235)=>GND, 
      b(234)=>GND, b(233)=>GND, b(232)=>GND, b(231)=>GND, b(230)=>GND, 
      b(229)=>GND, b(228)=>GND, b(227)=>GND, b(226)=>GND, b(225)=>GND, 
      b(224)=>GND, b(223)=>GND, b(222)=>GND, b(221)=>GND, b(220)=>GND, 
      b(219)=>GND, b(218)=>GND, b(217)=>GND, b(216)=>GND, b(215)=>GND, 
      b(214)=>GND, b(213)=>GND, b(212)=>GND, b(211)=>GND, b(210)=>GND, 
      b(209)=>GND, b(208)=>GND, b(207)=>GND, b(206)=>GND, b(205)=>GND, 
      b(204)=>GND, b(203)=>GND, b(202)=>GND, b(201)=>GND, b(200)=>GND, 
      b(199)=>GND, b(198)=>GND, b(197)=>GND, b(196)=>GND, b(195)=>GND, 
      b(194)=>GND, b(193)=>GND, b(192)=>GND, b(191)=>GND, b(190)=>GND, 
      b(189)=>GND, b(188)=>GND, b(187)=>GND, b(186)=>GND, b(185)=>GND, 
      b(184)=>GND, b(183)=>GND, b(182)=>GND, b(181)=>GND, b(180)=>GND, 
      b(179)=>GND, b(178)=>GND, b(177)=>GND, b(176)=>GND, b(175)=>GND, 
      b(174)=>GND, b(173)=>GND, b(172)=>GND, b(171)=>GND, b(170)=>GND, 
      b(169)=>GND, b(168)=>GND, b(167)=>GND, b(166)=>GND, b(165)=>GND, 
      b(164)=>GND, b(163)=>GND, b(162)=>GND, b(161)=>GND, b(160)=>GND, 
      b(159)=>GND, b(158)=>GND, b(157)=>GND, b(156)=>GND, b(155)=>GND, 
      b(154)=>GND, b(153)=>GND, b(152)=>GND, b(151)=>GND, b(150)=>GND, 
      b(149)=>GND, b(148)=>GND, b(147)=>GND, b(146)=>GND, b(145)=>GND, 
      b(144)=>GND, b(143)=>GND, b(142)=>GND, b(141)=>GND, b(140)=>GND, 
      b(139)=>GND, b(138)=>GND, b(137)=>GND, b(136)=>GND, b(135)=>GND, 
      b(134)=>GND, b(133)=>GND, b(132)=>GND, b(131)=>GND, b(130)=>GND, 
      b(129)=>GND, b(128)=>GND, b(127)=>GND, b(126)=>GND, b(125)=>GND, 
      b(124)=>GND, b(123)=>GND, b(122)=>GND, b(121)=>GND, b(120)=>GND, 
      b(119)=>GND, b(118)=>GND, b(117)=>GND, b(116)=>GND, b(115)=>GND, 
      b(114)=>GND, b(113)=>GND, b(112)=>GND, b(111)=>GND, b(110)=>GND, 
      b(109)=>GND, b(108)=>GND, b(107)=>GND, b(106)=>GND, b(105)=>GND, 
      b(104)=>GND, b(103)=>GND, b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)
      =>GND, b(98)=>GND, b(97)=>GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, 
      b(93)=>GND, b(92)=>GND, b(91)=>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, 
      b(87)=>GND, b(86)=>GND, b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, 
      b(81)=>GND, b(80)=>GND, b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, 
      b(75)=>GND, b(74)=>GND, b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, 
      b(69)=>GND, b(68)=>GND, b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, 
      b(63)=>GND, b(62)=>GND, b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, 
      b(57)=>GND, b(56)=>GND, b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, 
      b(51)=>GND, b(50)=>GND, b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, 
      b(45)=>GND, b(44)=>GND, b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, 
      b(39)=>GND, b(38)=>GND, b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, 
      b(33)=>GND, b(32)=>GND, b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, 
      b(27)=>GND, b(26)=>GND, b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, 
      b(21)=>GND, b(20)=>GND, b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, 
      b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, 
      b(9)=>GND, b(8)=>address(8), b(7)=>address(7), b(6)=>address(6), b(5)
      =>address(5), b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), 
      b(1)=>address(1), b(0)=>address(0), d=>q(0));
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   port (
      rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
      addr1 : IN std_logic_vector (8 DOWNTO 0) ;
      rd_clk1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      regce1 : IN std_logic ;
      rst1 : IN std_logic) ;
end rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate ;

architecture INTERFACE of 
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         address : IN std_logic_vector (8 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (0 DOWNTO 0)) ;
   end component ;
   for modgen_rom_ix679 : 
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(
   INTERFACE_unfold_1);
   signal nx14, nx16: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx14 <= '0' ;
   nx16 <= '1' ;
   modgen_rom_ix679 : 
      rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate port map ( 
      address(8)=>addr1(8), address(7)=>addr1(7), address(6)=>addr1(6), 
      address(5)=>addr1(5), address(4)=>addr1(4), address(3)=>addr1(3), 
      address(2)=>addr1(2), address(1)=>addr1(1), address(0)=>addr1(0), 
      inclock=>DANGLING(0), outclock=>DANGLING(1), outclockena=>DANGLING(2), 
      q(0)=>rd_data1(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   port (
      address : IN std_logic_vector (8 DOWNTO 0) ;
      inclock : IN std_logic ;
      outclock : IN std_logic ;
      outclockena : IN std_logic ;
      q : OUT std_logic_vector (0 DOWNTO 0)) ;
end rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate ;

architecture INTERFACE_unfold_1 of 
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component mux_512u_512u
      port (
         a : IN std_logic_vector (511 DOWNTO 0) ;
         b : IN std_logic_vector (511 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_1338 : mux_512u_512u port map ( a(511)=>GND, a(510)=>GND, 
      a(509)=>GND, a(508)=>GND, a(507)=>GND, a(506)=>GND, a(505)=>GND, 
      a(504)=>GND, a(503)=>GND, a(502)=>GND, a(501)=>GND, a(500)=>GND, 
      a(499)=>GND, a(498)=>GND, a(497)=>GND, a(496)=>GND, a(495)=>GND, 
      a(494)=>GND, a(493)=>GND, a(492)=>GND, a(491)=>GND, a(490)=>GND, 
      a(489)=>GND, a(488)=>GND, a(487)=>GND, a(486)=>GND, a(485)=>GND, 
      a(484)=>GND, a(483)=>GND, a(482)=>GND, a(481)=>GND, a(480)=>GND, 
      a(479)=>GND, a(478)=>GND, a(477)=>GND, a(476)=>GND, a(475)=>GND, 
      a(474)=>GND, a(473)=>GND, a(472)=>GND, a(471)=>GND, a(470)=>GND, 
      a(469)=>GND, a(468)=>GND, a(467)=>GND, a(466)=>GND, a(465)=>GND, 
      a(464)=>GND, a(463)=>GND, a(462)=>GND, a(461)=>GND, a(460)=>GND, 
      a(459)=>GND, a(458)=>GND, a(457)=>GND, a(456)=>GND, a(455)=>GND, 
      a(454)=>GND, a(453)=>GND, a(452)=>GND, a(451)=>GND, a(450)=>GND, 
      a(449)=>GND, a(448)=>GND, a(447)=>GND, a(446)=>GND, a(445)=>GND, 
      a(444)=>GND, a(443)=>GND, a(442)=>GND, a(441)=>GND, a(440)=>GND, 
      a(439)=>GND, a(438)=>GND, a(437)=>GND, a(436)=>GND, a(435)=>GND, 
      a(434)=>GND, a(433)=>GND, a(432)=>GND, a(431)=>GND, a(430)=>GND, 
      a(429)=>GND, a(428)=>GND, a(427)=>GND, a(426)=>GND, a(425)=>GND, 
      a(424)=>GND, a(423)=>GND, a(422)=>GND, a(421)=>GND, a(420)=>GND, 
      a(419)=>GND, a(418)=>GND, a(417)=>GND, a(416)=>GND, a(415)=>GND, 
      a(414)=>GND, a(413)=>GND, a(412)=>GND, a(411)=>GND, a(410)=>GND, 
      a(409)=>GND, a(408)=>GND, a(407)=>GND, a(406)=>GND, a(405)=>GND, 
      a(404)=>GND, a(403)=>GND, a(402)=>GND, a(401)=>GND, a(400)=>GND, 
      a(399)=>GND, a(398)=>GND, a(397)=>GND, a(396)=>GND, a(395)=>GND, 
      a(394)=>GND, a(393)=>GND, a(392)=>GND, a(391)=>GND, a(390)=>GND, 
      a(389)=>GND, a(388)=>GND, a(387)=>GND, a(386)=>GND, a(385)=>GND, 
      a(384)=>GND, a(383)=>GND, a(382)=>GND, a(381)=>GND, a(380)=>GND, 
      a(379)=>GND, a(378)=>GND, a(377)=>GND, a(376)=>GND, a(375)=>GND, 
      a(374)=>GND, a(373)=>GND, a(372)=>GND, a(371)=>GND, a(370)=>GND, 
      a(369)=>GND, a(368)=>GND, a(367)=>GND, a(366)=>GND, a(365)=>GND, 
      a(364)=>GND, a(363)=>GND, a(362)=>GND, a(361)=>GND, a(360)=>GND, 
      a(359)=>GND, a(358)=>GND, a(357)=>GND, a(356)=>GND, a(355)=>GND, 
      a(354)=>GND, a(353)=>GND, a(352)=>GND, a(351)=>GND, a(350)=>GND, 
      a(349)=>GND, a(348)=>GND, a(347)=>GND, a(346)=>GND, a(345)=>GND, 
      a(344)=>GND, a(343)=>GND, a(342)=>GND, a(341)=>GND, a(340)=>GND, 
      a(339)=>GND, a(338)=>GND, a(337)=>GND, a(336)=>GND, a(335)=>GND, 
      a(334)=>GND, a(333)=>GND, a(332)=>GND, a(331)=>GND, a(330)=>GND, 
      a(329)=>GND, a(328)=>GND, a(327)=>GND, a(326)=>GND, a(325)=>GND, 
      a(324)=>GND, a(323)=>GND, a(322)=>GND, a(321)=>GND, a(320)=>GND, 
      a(319)=>GND, a(318)=>GND, a(317)=>GND, a(316)=>GND, a(315)=>GND, 
      a(314)=>GND, a(313)=>GND, a(312)=>GND, a(311)=>GND, a(310)=>GND, 
      a(309)=>GND, a(308)=>GND, a(307)=>GND, a(306)=>GND, a(305)=>GND, 
      a(304)=>GND, a(303)=>GND, a(302)=>GND, a(301)=>GND, a(300)=>GND, 
      a(299)=>GND, a(298)=>GND, a(297)=>GND, a(296)=>GND, a(295)=>GND, 
      a(294)=>GND, a(293)=>GND, a(292)=>GND, a(291)=>GND, a(290)=>GND, 
      a(289)=>GND, a(288)=>GND, a(287)=>GND, a(286)=>GND, a(285)=>GND, 
      a(284)=>GND, a(283)=>GND, a(282)=>GND, a(281)=>GND, a(280)=>GND, 
      a(279)=>GND, a(278)=>GND, a(277)=>GND, a(276)=>GND, a(275)=>GND, 
      a(274)=>GND, a(273)=>GND, a(272)=>GND, a(271)=>GND, a(270)=>GND, 
      a(269)=>GND, a(268)=>GND, a(267)=>GND, a(266)=>GND, a(265)=>PWR, 
      a(264)=>GND, a(263)=>GND, a(262)=>GND, a(261)=>GND, a(260)=>GND, 
      a(259)=>GND, a(258)=>GND, a(257)=>GND, a(256)=>GND, a(255)=>GND, 
      a(254)=>GND, a(253)=>GND, a(252)=>GND, a(251)=>GND, a(250)=>GND, 
      a(249)=>GND, a(248)=>GND, a(247)=>GND, a(246)=>GND, a(245)=>GND, 
      a(244)=>GND, a(243)=>GND, a(242)=>GND, a(241)=>GND, a(240)=>GND, 
      a(239)=>GND, a(238)=>GND, a(237)=>GND, a(236)=>GND, a(235)=>GND, 
      a(234)=>GND, a(233)=>GND, a(232)=>GND, a(231)=>GND, a(230)=>GND, 
      a(229)=>GND, a(228)=>GND, a(227)=>GND, a(226)=>GND, a(225)=>GND, 
      a(224)=>GND, a(223)=>GND, a(222)=>GND, a(221)=>GND, a(220)=>GND, 
      a(219)=>GND, a(218)=>GND, a(217)=>GND, a(216)=>GND, a(215)=>GND, 
      a(214)=>GND, a(213)=>GND, a(212)=>GND, a(211)=>GND, a(210)=>GND, 
      a(209)=>GND, a(208)=>GND, a(207)=>GND, a(206)=>GND, a(205)=>GND, 
      a(204)=>GND, a(203)=>GND, a(202)=>GND, a(201)=>GND, a(200)=>GND, 
      a(199)=>GND, a(198)=>GND, a(197)=>GND, a(196)=>GND, a(195)=>GND, 
      a(194)=>GND, a(193)=>GND, a(192)=>GND, a(191)=>GND, a(190)=>GND, 
      a(189)=>GND, a(188)=>GND, a(187)=>GND, a(186)=>GND, a(185)=>GND, 
      a(184)=>GND, a(183)=>GND, a(182)=>GND, a(181)=>GND, a(180)=>GND, 
      a(179)=>GND, a(178)=>GND, a(177)=>GND, a(176)=>GND, a(175)=>GND, 
      a(174)=>GND, a(173)=>GND, a(172)=>GND, a(171)=>GND, a(170)=>GND, 
      a(169)=>GND, a(168)=>GND, a(167)=>GND, a(166)=>GND, a(165)=>GND, 
      a(164)=>GND, a(163)=>GND, a(162)=>GND, a(161)=>GND, a(160)=>GND, 
      a(159)=>GND, a(158)=>GND, a(157)=>GND, a(156)=>GND, a(155)=>GND, 
      a(154)=>GND, a(153)=>GND, a(152)=>GND, a(151)=>GND, a(150)=>GND, 
      a(149)=>GND, a(148)=>GND, a(147)=>GND, a(146)=>GND, a(145)=>GND, 
      a(144)=>GND, a(143)=>GND, a(142)=>GND, a(141)=>GND, a(140)=>GND, 
      a(139)=>GND, a(138)=>GND, a(137)=>GND, a(136)=>GND, a(135)=>GND, 
      a(134)=>GND, a(133)=>GND, a(132)=>GND, a(131)=>GND, a(130)=>GND, 
      a(129)=>GND, a(128)=>GND, a(127)=>GND, a(126)=>GND, a(125)=>GND, 
      a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, a(120)=>GND, 
      a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, a(115)=>GND, 
      a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, a(110)=>GND, 
      a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, a(105)=>GND, 
      a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, a(100)=>GND, a(99)
      =>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>GND, a(94)=>GND, 
      a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)=>GND, a(88)=>GND, 
      a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, a(83)=>GND, a(82)=>GND, 
      a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, a(77)=>GND, a(76)=>GND, 
      a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, a(71)=>GND, a(70)=>GND, 
      a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, a(65)=>GND, a(64)=>GND, 
      a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, a(59)=>GND, a(58)=>GND, 
      a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, a(53)=>GND, a(52)=>GND, 
      a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, a(47)=>GND, a(46)=>GND, 
      a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, a(41)=>GND, a(40)=>GND, 
      a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, a(35)=>GND, a(34)=>GND, 
      a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, a(29)=>GND, a(28)=>GND, 
      a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, a(23)=>GND, a(22)=>GND, 
      a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, a(17)=>GND, a(16)=>GND, 
      a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)=>GND, a(10)=>GND, 
      a(9)=>GND, a(8)=>GND, a(7)=>PWR, a(6)=>GND, a(5)=>GND, a(4)=>GND, a(3)
      =>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(511)=>GND, b(510)=>GND, 
      b(509)=>GND, b(508)=>GND, b(507)=>GND, b(506)=>GND, b(505)=>GND, 
      b(504)=>GND, b(503)=>GND, b(502)=>GND, b(501)=>GND, b(500)=>GND, 
      b(499)=>GND, b(498)=>GND, b(497)=>GND, b(496)=>GND, b(495)=>GND, 
      b(494)=>GND, b(493)=>GND, b(492)=>GND, b(491)=>GND, b(490)=>GND, 
      b(489)=>GND, b(488)=>GND, b(487)=>GND, b(486)=>GND, b(485)=>GND, 
      b(484)=>GND, b(483)=>GND, b(482)=>GND, b(481)=>GND, b(480)=>GND, 
      b(479)=>GND, b(478)=>GND, b(477)=>GND, b(476)=>GND, b(475)=>GND, 
      b(474)=>GND, b(473)=>GND, b(472)=>GND, b(471)=>GND, b(470)=>GND, 
      b(469)=>GND, b(468)=>GND, b(467)=>GND, b(466)=>GND, b(465)=>GND, 
      b(464)=>GND, b(463)=>GND, b(462)=>GND, b(461)=>GND, b(460)=>GND, 
      b(459)=>GND, b(458)=>GND, b(457)=>GND, b(456)=>GND, b(455)=>GND, 
      b(454)=>GND, b(453)=>GND, b(452)=>GND, b(451)=>GND, b(450)=>GND, 
      b(449)=>GND, b(448)=>GND, b(447)=>GND, b(446)=>GND, b(445)=>GND, 
      b(444)=>GND, b(443)=>GND, b(442)=>GND, b(441)=>GND, b(440)=>GND, 
      b(439)=>GND, b(438)=>GND, b(437)=>GND, b(436)=>GND, b(435)=>GND, 
      b(434)=>GND, b(433)=>GND, b(432)=>GND, b(431)=>GND, b(430)=>GND, 
      b(429)=>GND, b(428)=>GND, b(427)=>GND, b(426)=>GND, b(425)=>GND, 
      b(424)=>GND, b(423)=>GND, b(422)=>GND, b(421)=>GND, b(420)=>GND, 
      b(419)=>GND, b(418)=>GND, b(417)=>GND, b(416)=>GND, b(415)=>GND, 
      b(414)=>GND, b(413)=>GND, b(412)=>GND, b(411)=>GND, b(410)=>GND, 
      b(409)=>GND, b(408)=>GND, b(407)=>GND, b(406)=>GND, b(405)=>GND, 
      b(404)=>GND, b(403)=>GND, b(402)=>GND, b(401)=>GND, b(400)=>GND, 
      b(399)=>GND, b(398)=>GND, b(397)=>GND, b(396)=>GND, b(395)=>GND, 
      b(394)=>GND, b(393)=>GND, b(392)=>GND, b(391)=>GND, b(390)=>GND, 
      b(389)=>GND, b(388)=>GND, b(387)=>GND, b(386)=>GND, b(385)=>GND, 
      b(384)=>GND, b(383)=>GND, b(382)=>GND, b(381)=>GND, b(380)=>GND, 
      b(379)=>GND, b(378)=>GND, b(377)=>GND, b(376)=>GND, b(375)=>GND, 
      b(374)=>GND, b(373)=>GND, b(372)=>GND, b(371)=>GND, b(370)=>GND, 
      b(369)=>GND, b(368)=>GND, b(367)=>GND, b(366)=>GND, b(365)=>GND, 
      b(364)=>GND, b(363)=>GND, b(362)=>GND, b(361)=>GND, b(360)=>GND, 
      b(359)=>GND, b(358)=>GND, b(357)=>GND, b(356)=>GND, b(355)=>GND, 
      b(354)=>GND, b(353)=>GND, b(352)=>GND, b(351)=>GND, b(350)=>GND, 
      b(349)=>GND, b(348)=>GND, b(347)=>GND, b(346)=>GND, b(345)=>GND, 
      b(344)=>GND, b(343)=>GND, b(342)=>GND, b(341)=>GND, b(340)=>GND, 
      b(339)=>GND, b(338)=>GND, b(337)=>GND, b(336)=>GND, b(335)=>GND, 
      b(334)=>GND, b(333)=>GND, b(332)=>GND, b(331)=>GND, b(330)=>GND, 
      b(329)=>GND, b(328)=>GND, b(327)=>GND, b(326)=>GND, b(325)=>GND, 
      b(324)=>GND, b(323)=>GND, b(322)=>GND, b(321)=>GND, b(320)=>GND, 
      b(319)=>GND, b(318)=>GND, b(317)=>GND, b(316)=>GND, b(315)=>GND, 
      b(314)=>GND, b(313)=>GND, b(312)=>GND, b(311)=>GND, b(310)=>GND, 
      b(309)=>GND, b(308)=>GND, b(307)=>GND, b(306)=>GND, b(305)=>GND, 
      b(304)=>GND, b(303)=>GND, b(302)=>GND, b(301)=>GND, b(300)=>GND, 
      b(299)=>GND, b(298)=>GND, b(297)=>GND, b(296)=>GND, b(295)=>GND, 
      b(294)=>GND, b(293)=>GND, b(292)=>GND, b(291)=>GND, b(290)=>GND, 
      b(289)=>GND, b(288)=>GND, b(287)=>GND, b(286)=>GND, b(285)=>GND, 
      b(284)=>GND, b(283)=>GND, b(282)=>GND, b(281)=>GND, b(280)=>GND, 
      b(279)=>GND, b(278)=>GND, b(277)=>GND, b(276)=>GND, b(275)=>GND, 
      b(274)=>GND, b(273)=>GND, b(272)=>GND, b(271)=>GND, b(270)=>GND, 
      b(269)=>GND, b(268)=>GND, b(267)=>GND, b(266)=>GND, b(265)=>GND, 
      b(264)=>GND, b(263)=>GND, b(262)=>GND, b(261)=>GND, b(260)=>GND, 
      b(259)=>GND, b(258)=>GND, b(257)=>GND, b(256)=>GND, b(255)=>GND, 
      b(254)=>GND, b(253)=>GND, b(252)=>GND, b(251)=>GND, b(250)=>GND, 
      b(249)=>GND, b(248)=>GND, b(247)=>GND, b(246)=>GND, b(245)=>GND, 
      b(244)=>GND, b(243)=>GND, b(242)=>GND, b(241)=>GND, b(240)=>GND, 
      b(239)=>GND, b(238)=>GND, b(237)=>GND, b(236)=>GND, b(235)=>GND, 
      b(234)=>GND, b(233)=>GND, b(232)=>GND, b(231)=>GND, b(230)=>GND, 
      b(229)=>GND, b(228)=>GND, b(227)=>GND, b(226)=>GND, b(225)=>GND, 
      b(224)=>GND, b(223)=>GND, b(222)=>GND, b(221)=>GND, b(220)=>GND, 
      b(219)=>GND, b(218)=>GND, b(217)=>GND, b(216)=>GND, b(215)=>GND, 
      b(214)=>GND, b(213)=>GND, b(212)=>GND, b(211)=>GND, b(210)=>GND, 
      b(209)=>GND, b(208)=>GND, b(207)=>GND, b(206)=>GND, b(205)=>GND, 
      b(204)=>GND, b(203)=>GND, b(202)=>GND, b(201)=>GND, b(200)=>GND, 
      b(199)=>GND, b(198)=>GND, b(197)=>GND, b(196)=>GND, b(195)=>GND, 
      b(194)=>GND, b(193)=>GND, b(192)=>GND, b(191)=>GND, b(190)=>GND, 
      b(189)=>GND, b(188)=>GND, b(187)=>GND, b(186)=>GND, b(185)=>GND, 
      b(184)=>GND, b(183)=>GND, b(182)=>GND, b(181)=>GND, b(180)=>GND, 
      b(179)=>GND, b(178)=>GND, b(177)=>GND, b(176)=>GND, b(175)=>GND, 
      b(174)=>GND, b(173)=>GND, b(172)=>GND, b(171)=>GND, b(170)=>GND, 
      b(169)=>GND, b(168)=>GND, b(167)=>GND, b(166)=>GND, b(165)=>GND, 
      b(164)=>GND, b(163)=>GND, b(162)=>GND, b(161)=>GND, b(160)=>GND, 
      b(159)=>GND, b(158)=>GND, b(157)=>GND, b(156)=>GND, b(155)=>GND, 
      b(154)=>GND, b(153)=>GND, b(152)=>GND, b(151)=>GND, b(150)=>GND, 
      b(149)=>GND, b(148)=>GND, b(147)=>GND, b(146)=>GND, b(145)=>GND, 
      b(144)=>GND, b(143)=>GND, b(142)=>GND, b(141)=>GND, b(140)=>GND, 
      b(139)=>GND, b(138)=>GND, b(137)=>GND, b(136)=>GND, b(135)=>GND, 
      b(134)=>GND, b(133)=>GND, b(132)=>GND, b(131)=>GND, b(130)=>GND, 
      b(129)=>GND, b(128)=>GND, b(127)=>GND, b(126)=>GND, b(125)=>GND, 
      b(124)=>GND, b(123)=>GND, b(122)=>GND, b(121)=>GND, b(120)=>GND, 
      b(119)=>GND, b(118)=>GND, b(117)=>GND, b(116)=>GND, b(115)=>GND, 
      b(114)=>GND, b(113)=>GND, b(112)=>GND, b(111)=>GND, b(110)=>GND, 
      b(109)=>GND, b(108)=>GND, b(107)=>GND, b(106)=>GND, b(105)=>GND, 
      b(104)=>GND, b(103)=>GND, b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)
      =>GND, b(98)=>GND, b(97)=>GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, 
      b(93)=>GND, b(92)=>GND, b(91)=>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, 
      b(87)=>GND, b(86)=>GND, b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, 
      b(81)=>GND, b(80)=>GND, b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, 
      b(75)=>GND, b(74)=>GND, b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, 
      b(69)=>GND, b(68)=>GND, b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, 
      b(63)=>GND, b(62)=>GND, b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, 
      b(57)=>GND, b(56)=>GND, b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, 
      b(51)=>GND, b(50)=>GND, b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, 
      b(45)=>GND, b(44)=>GND, b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, 
      b(39)=>GND, b(38)=>GND, b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, 
      b(33)=>GND, b(32)=>GND, b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, 
      b(27)=>GND, b(26)=>GND, b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, 
      b(21)=>GND, b(20)=>GND, b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, 
      b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, 
      b(9)=>GND, b(8)=>address(8), b(7)=>address(7), b(6)=>address(6), b(5)
      =>address(5), b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), 
      b(1)=>address(1), b(0)=>address(0), d=>q(0));
end INTERFACE_unfold_1 ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   port (
      rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
      addr1 : IN std_logic_vector (8 DOWNTO 0) ;
      rd_clk1 : IN std_logic ;
      rd_ena1 : IN std_logic ;
      regce1 : IN std_logic ;
      rst1 : IN std_logic) ;
end rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate ;

architecture INTERFACE of 
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         address : IN std_logic_vector (8 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (0 DOWNTO 0)) ;
   end component ;
   for modgen_rom_ix680 : 
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(
   INTERFACE_unfold_1);
   signal nx14, nx16: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx14 <= '0' ;
   nx16 <= '1' ;
   modgen_rom_ix680 : 
      rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate port map ( 
      address(8)=>addr1(8), address(7)=>addr1(7), address(6)=>addr1(6), 
      address(5)=>addr1(5), address(4)=>addr1(4), address(3)=>addr1(3), 
      address(2)=>addr1(2), address(1)=>addr1(1), address(0)=>addr1(0), 
      inclock=>DANGLING(0), outclock=>DANGLING(1), outclockena=>DANGLING(2), 
      q(0)=>rd_data1(0));
end INTERFACE ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity Xcvr_Snubber_sital_8_4_4_32_7 is 
   port (
      CE : IN std_logic ;
      Regular : IN std_logic ;
      RxNSital : IN std_logic ;
      RxSital : IN std_logic ;
      Tx : IN std_logic ;
      TxN : IN std_logic ;
      Tx_Inhibit : IN std_logic ;
      clock : IN std_logic ;
      resetN : IN std_logic ;
      Rx : OUT std_logic ;
      RxN : OUT std_logic ;
      TxN_SN : OUT std_logic ;
      Tx_SN : OUT std_logic ;
      TxN_Sital : OUT std_logic ;
      TxSense : OUT std_logic ;
      Tx_Sital : OUT std_logic) ;
end Xcvr_Snubber_sital_8_4_4_32_7 ;

architecture OH_Calibrate_unfold_1 of Xcvr_Snubber_sital_8_4_4_32_7 is 
   component abs_5s_5s
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0)) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_7u_7u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_10u_10u
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_updn_aclear_clock_clk_en_0_6
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (5 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (5 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_4
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (3 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component add_4u_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component sub_4u_4u_4u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_updn_sclear_aclear_clock_clk_en_0_6
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (5 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (5 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_updn_sload_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
         addr1 : IN std_logic_vector (8 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
         addr1 : IN std_logic_vector (8 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_10u_10u
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_Rx_energy : counter_updn_aclear_clock_clk_en_0_6
    use entity work.counter_updn_aclear_clock_clk_en_0_6(INTERFACE);
   for modgen_counter_Count_1us : counter_dn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_5(
   INTERFACE_unfold_4);
   for modgen_counter_Count23us : counter_dn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_5(INTERFACE);
   
   for modgen_counter_Fixed : counter_dn_sload_aclear_clock_clk_en_0_4
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_4(INTERFACE);
   
   for modgen_counter_Sum : counter_updn_sclear_aclear_clock_clk_en_0_6
    use entity work.counter_updn_sclear_aclear_clock_clk_en_0_6(INTERFACE);
   
   for modgen_counter_Micro : counter_updn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_updn_sload_aclear_clock_clk_en_0_5(INTERFACE);
   
   for modgen_rom_ix679 : 
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE);
   for modgen_rom_ix680 : 
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE);
   signal TxSense_EXMPLR3543: std_logic ;
   
   signal Cal: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count: std_logic_vector (6 DOWNTO 0) ;
   
   signal Count23us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count_1us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Delta: std_logic_vector (3 DOWNTO 0) ;
   
   signal Fixed: std_logic_vector (3 DOWNTO 0) ;
   
   signal Half_us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Micro: std_logic_vector (4 DOWNTO 0) ;
   
   signal Num_Of_Fixes: std_logic_vector (3 DOWNTO 0) ;
   
   signal Reduce_Minus_On, Reduce_Plus_On, Rx_On: std_logic ;
   
   signal Rx_energy: std_logic_vector (5 DOWNTO 0) ;
   
   signal Rx_ok, Shorten_Minus, Shorten_Plus: std_logic ;
   
   signal Sum: std_logic_vector (5 DOWNTO 0) ;
   
   signal AmnonHofman: std_logic_vector (11 DOWNTO 0) ;
   
   signal calib: std_logic_vector (7 DOWNTO 0) ;
   
   signal snubb: std_logic_vector (1 DOWNTO 0) ;
   
   signal PWR, GND, not_resetN, Rx_On_17n1s2, not_Rx_On_17n1s2, not_CE, 
      rtlc17n121, not_Rx_On, rtlc17n124, rtlc17_X_0_n125, 
      not_rtlc17_X_0_n125, not_Regular, rtlc23n167, rtlc23n172, rtlc23n173, 
      not_rtlc23n503, rtlc23n227, rtlc23n238, rtlc23n272, rtlc23n302, 
      not_snubb_0, rtlc23_X_0_n387, rtlc23n413, rtlc23n414, not_rtlc23n414, 
      not_rtlc23n227, rtlc23n457, not_rtlc23n272, rtlc23n461, 
      rtlc23_X_0_n462, not_rtlc23_X_0_n462, rtlc23n503, not_Count23us_4, 
      rtlc23n604, not_rtlcn136, rtlc23n608, rtlc23n620, not_rtlc23n620, 
      rtlc23n634, rtlc23n635, rtlc23n636, Cal_26n7ss1_4: std_logic ;
   
   signal Cal_26n9ss1: std_logic_vector (3 DOWNTO 1) ;
   
   signal Cal_26n14ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Delta_26n14ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal Num_Of_Fixes_26n1s1: std_logic_vector (3 DOWNTO 0) ;
   
   signal Reduce_Minus_On_26n1s1: std_logic ;
   
   signal rtlc26n345: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc26n373: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc26n455, rtlc26n623, rtlc26n626, rtlc26n663, rtlc26n672, 
      rtlc26n677, rtlc26n683, rtlc26n694, rtlc26n699, rtlc26n911, rtlc26n912, 
      rtlc26n913, rtlc26n914, not_Sum_5, rtlc26n916, not_Sum_4, not_Sum_3, 
      rtlc26n930, not_rtlcn137, rtlc26n933, rtlc26n934, rtlc26n935, 
      rtlc26n936, rtlc26n949, rtlc26n950, not_rtlc26n345_5, rtlc26n952, 
      rtlc26n971, not_rtlcn138, rtlc26n974, rtlc26n987, not_rtlcn4016, 
      rtlc26n1050, not_Cal_4, AmnonHofman_fsm_29n4ss1_2, 
      AmnonHofman_fsm_29n8ss1_4: std_logic ;
   
   signal Count_29n20ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Half_us_29n20ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal TxNSital_29n20ss1, TxN_SN_29n20ss1, TxSense_29n20ss1, 
      TxSital_29n20ss1, Tx_SN_29n20ss1, AmnonHofman_fsm_29n20ss1_4, 
      AmnonHofman_fsm_29n20ss1_2, not_TxN, not_Tx: std_logic ;
   
   signal Half_us_29n9s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count_29n13s1_6, Count_29n13s1_5, rtlc29n673, rtlc29n698, 
      rtlc29n845, rtlc29n859, rtlc29n870, rtlc29n876, rtlc29n929, rtlc29n995, 
      rtlc29n1013, rtlc29n1263, rtlc29n1264, rtlc29n1265, rtlc29n1298, 
      rtlc29n1349, rtlcn134, rtlcn136, rtlcn137, rtlcn138, rtlcn312, 
      rtlcn323, rtlcn330, rtlcn336, rtlcn343, rtlcn349, not_rtlcn704, 
      rtlcn385, rtlcn398, rtlcn405, rtlcn412, rtlcn427, rtlcn438, rtlcn450, 
      rtlcn458, rtlcn464, rtlcn475, rtlcn478, rtlcn481, rtlcn485, rtlcn489, 
      rtlcn495, rtlcn502, rtlcn513, rtlcn527, rtlcn530, rtlcn539, rtlcn549, 
      rtlcn551, rtlcn552, rtlcn567, rtlcn573, rtlcn575, rtlcn578, 
      not_rtlcn835, not_rtlcn836, not_rtlcn837, not_rtlcn838, not_rtlcn839, 
      not_rtlcn840, not_rtlcn841, rtlcn700, rtlcn704, rtlcn705, rtlcn706, 
      rtlcn707, rtlcn708, rtlcn709, rtlcn710, rtlcn711, rtlcn712, rtlcn713, 
      rtlcn715, rtlcn716, rtlcn719, rtlcn720, rtlcn724, not_rtlc26n974, 
      rtlcn728, not_rtlc26n952, rtlcn732, not_rtlc29n698, not_rtlc29n673, 
      rtlcn742, not_rtlcs31, rtlcn744, rtlcn745, not_rtlc29n859, rtlcn747, 
      not_rtlc29n845, rtlcn749, rtlcn750, rtlcn751, rtlcn752, rtlcn753, 
      not_rtlcs18, rtlcn755, not_rtlcs13, rtlcn757, rtlcn758, rtlcn759, 
      not_Tx_Inhibit, rtlcn761, rtlcn762, rtlcn763, rtlcn764, 
      not_rtlc29n1265, rtlcn766, rtlcn767, rtlcn768, not_rtlc29n870, 
      rtlcn770, not_rtlcn707, rtlcn772, not_rtlc29n876, rtlcn774, rtlcn775, 
      rtlcn776, not_rtlc23n302, rtlcn779, not_rtlcs7, rtlcn781, rtlcn782, 
      not_TxSense, rtlcn784, not_rtlcs10, rtlcn786, rtlcn787, rtlcn788, 
      rtlcn789, not_rtlc26n936, not_rtlc26n916, rtlcn792, not_Reduce_Plus_On, 
      not_rtlcn134, not_calib_7, not_RxSital, rtlcn835, rtlcn836, rtlcn837, 
      rtlcn838, rtlcn839, rtlcn840, rtlcn841, rtlcn842, rtlcn843, rtlcn844, 
      not_rtlcn312, not_rtlc29n1349, not_rtlc29n1013, rtlcs7, rtlcs8, rtlcs9, 
      rtlcs10, rtlcs11, rtlcs12, rtlcs13, rtlcs15, rtlcs16, rtlcs17, rtlcs18, 
      rtlcs20, rtlcs22, rtlcs23, rtlcs24, rtlcs25, rtlcs26, rtlcs27, 
      not_Count_1, rtlcs30, rtlcs31, rtlcs33, not_Shorten_Plus, rtlcs35, 
      not_Shorten_Minus, rtlcs37, rtlcs38, rtlcs39, rtlcs40, not_Rx_energy_5, 
      not_Rx_energy_4, not_Rx_energy_3, not_Rx_energy_2, not_Rx_energy_1, 
      not_Rx_energy_0, not_rtlcn700, not_Count_6, not_Count_5, not_Count_4, 
      not_Count_3, not_Count_2, not_Count_1us_4, not_Count_1us_2, 
      not_Count_1us_1, not_Micro_4, not_Micro_3, not_Micro_2, not_Micro_1, 
      not_RxNSital, not_Micro_0, not_calib_6, not_Count23us_3, 
      not_Count23us_2, not_Count23us_1, not_Count_1us_3, not_Count_0, 
      not_Count_1us_0, not_rtlcn4033, rtlcn4016, rtlcn4033: std_logic ;
   
   signal Count_29n13s1f1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc17_25_or_1277_nx0, rtlc23n426, rtlc23_258_or_1280_nx0, 
      rtlc23_274_or_1281_nx0, rtlc26_204_or_1284_nx0, rtlc26_631_or_1285_nx0, 
      rtlc26_649_or_1287_nx0, rtlc29_209_or_1291_nx0, rtlc_283_or_1296_nx0, 
      rtlc_1039_and_1310_nx0, rtlc_1043_and_1311_nx0, rtlc_1073_and_1314_nx0, 
      rtlc_1089_or_1318_nx0, rtlc_1095_or_1319_nx0, rtlc_1283_and_1320_nx0, 
      rtlc26n668, rtlc_1298_and_1322_nx0, rtlc_1432_and_1331_nx0, 
      rtlc_1435_and_1332_nx0, rtlc_1442_and_1333_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (15 downto 0 );

begin
   TxSense <= TxSense_EXMPLR3543 ;
   PWR <= '1' ;
   GND <= '0' ;
   Rx <= RxSital ;
   RxN <= RxNSital ;
   not_Rx_On_17n1s2 <= NOT Rx_On_17n1s2 ;
   not_rtlc17_X_0_n125 <= NOT rtlc17_X_0_n125 ;
   not_Rx_On <= NOT Rx_On ;
   not_rtlc23n503 <= NOT rtlc23n503 ;
   not_rtlc23n272 <= NOT rtlc23n272 ;
   rtlc23n461 <= not_rtlc23n272 AND snubb(0) ;
   rtlc23n457 <= not_rtlc23n227 AND snubb(0) ;
   not_rtlc23_X_0_n462 <= NOT rtlc23_X_0_n462 ;
   rtlc23n413 <= not_rtlc23n503 AND snubb(0) ;
   rtlc23n414 <= not_CE OR rtlc23n413 ;
   not_rtlc23n414 <= NOT rtlc23n414 ;
   not_snubb_0 <= NOT snubb(0) ;
   rtlc23n238 <= not_rtlc23n620 AND rtlc23n636 ;
   rtlc23n227 <= rtlc23n608 AND rtlc23n172 ;
   rtlc23n167 <= not_Regular AND TxSense_EXMPLR3543 ;
   rtlc23n173 <= rtlc23n167 AND rtlc23n172 ;
   not_Count23us_4 <= NOT Count23us(4) ;
   rtlc23n608 <= not_rtlcn136 OR not_Count23us_4 ;
   rtlc23n620 <= Count_1us(4) AND Count_1us(3) ;
   not_rtlc23n620 <= NOT rtlc23n620 ;
   rtlc23n635 <= rtlc23n634 AND Count_1us(3) ;
   rtlc23n636 <= rtlc23n635 OR Count_1us(4) ;
   Num_Of_Fixes_abs5_26i1 : abs_5s_5s port map ( a(4)=>Cal(4), a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), d(4)=>DANGLING(0), d(3)=>
      Num_Of_Fixes_26n1s1(3), d(2)=>Num_Of_Fixes_26n1s1(2), d(1)=>
      Num_Of_Fixes_26n1s1(1), d(0)=>Num_Of_Fixes_26n1s1(0));
   rtlc26n623 <= calib(0) OR calib(6) ;
   rtlc26n626 <= calib(2) OR calib(7) ;
   rtlc26n455 <= rtlcs9 OR rtlcs8 ;
   rtlc26n911 <= Sum(1) AND Sum(2) ;
   rtlc26n912 <= Sum(3) OR rtlc26n911 ;
   rtlc26n913 <= Sum(4) AND rtlc26n912 ;
   rtlc26n914 <= rtlc26n913 OR Sum(5) ;
   not_Sum_5 <= NOT Sum(5) ;
   rtlc26n916 <= rtlc26n914 AND not_Sum_5 ;
   not_Sum_4 <= NOT Sum(4) ;
   not_Sum_3 <= NOT Sum(3) ;
   rtlc26n930 <= Sum(1) AND Sum(0) ;
   rtlc26n933 <= not_Sum_3 OR not_rtlcn137 ;
   rtlc26n934 <= not_Sum_4 AND rtlc26n933 ;
   rtlc26n935 <= rtlc26n934 OR not_Sum_5 ;
   rtlc26n936 <= rtlc26n935 AND Sum(5) ;
   rtlc26n950 <= rtlc26n949 AND rtlc26n345(4) ;
   not_rtlc26n345_5 <= NOT rtlc26n345(5) ;
   rtlc26n952 <= rtlc26n950 OR not_rtlc26n345_5 ;
   rtlc26_638_and_1286 : and_4u_4u port map ( a(3)=>rtlc26n373(3), a(2)=>
      rtlc26n373(2), a(1)=>rtlc26n373(1), a(0)=>rtlc26n373(0), d=>rtlc26n971
   );
   rtlc26n974 <= not_rtlcn138 OR rtlc26n373(5) ;
   rtlc26n373(4) <= rtlcn4016 XOR Cal(4) ;
   not_rtlcn4016 <= NOT rtlcn4016 ;
   rtlc26n373(5) <= not_rtlcn4016 AND Cal(4) ;
   rtlc26n345(5) <= not_rtlcn4033 OR Cal(4) ;
   rtlc26_680_or_1288 : or_5u_5u port map ( a(4)=>Cal(0), a(3)=>Cal(1), a(2)
      =>Cal(2), a(1)=>Cal(3), a(0)=>Cal(4), d=>rtlc26n1050);
   not_Cal_4 <= NOT Cal(4) ;
   Reduce_Minus_On_26n1s1 <= rtlc26n1050 AND not_Cal_4 ;
   rtlc29_312_or_1292 : or_6u_6u port map ( a(5)=>AmnonHofman(1), a(4)=>
      AmnonHofman(3), a(3)=>AmnonHofman(5), a(2)=>AmnonHofman(6), a(1)=>
      AmnonHofman(8), a(0)=>AmnonHofman(9), d=>rtlc29n1013);
   rtlc29n698 <= Shorten_Minus AND not_TxN ;
   rtlc29n673 <= Shorten_Plus AND not_Tx ;
   rtlc29_858_or_1293 : or_5u_5u port map ( a(4)=>Count(0), a(3)=>Count(1), 
      a(2)=>Count(2), a(1)=>Count(3), a(0)=>Count(4), d=>rtlc29n1263);
   rtlc29n1264 <= rtlc29n1263 AND Count(5) ;
   rtlc29n1265 <= rtlc29n1264 OR Count(6) ;
   rtlc29_864_and_1294 : and_4u_4u port map ( a(3)=>Half_us(3), a(2)=>
      Half_us(2), a(1)=>Half_us(1), a(0)=>Half_us(0), d=>rtlc29n1298);
   Count_inc7_29i1 : inc_7u_7u_0 port map ( cin=>PWR, a(6)=>Count(6), a(5)=>
      Count(5), a(4)=>Count_29n13s1f1(4), a(3)=>Count_29n13s1f1(3), a(2)=>
      Count_29n13s1f1(2), a(1)=>Count_29n13s1f1(1), a(0)=>Count_29n13s1f1(0), 
      d(6)=>Count_29n13s1_6, d(5)=>Count_29n13s1_5, d(4)=>Half_us_29n9s1(4), 
      d(3)=>Half_us_29n9s1(3), d(2)=>Half_us_29n9s1(2), d(1)=>
      Half_us_29n9s1(1), d(0)=>Half_us_29n9s1(0), cout=>DANGLING(1));
   rtlc29n1349 <= AmnonHofman(2) OR AmnonHofman(4) ;
   not_rtlcn136 <= NOT rtlcn136 ;
   not_rtlcn137 <= NOT rtlcn137 ;
   not_rtlcn138 <= NOT rtlcn138 ;
   rtlcn134 <= Half_us(4) OR rtlc29n1298 ;
   rtlcn136 <= rtlc23n604 OR Count23us(0) ;
   rtlcn137 <= Sum(2) OR rtlc26n930 ;
   rtlcn138 <= rtlc26n373(4) OR rtlc26n971 ;
   AmnonHofman_fsm_select_29i2 : select_3_3 port map ( a(2)=>not_rtlcn835, 
      a(1)=>AmnonHofman(3), a(0)=>rtlcn330, b(2)=>GND, b(1)=>
      AmnonHofman_fsm_29n8ss1_4, b(0)=>PWR, d=>AmnonHofman_fsm_29n20ss1_4);
   AmnonHofman_fsm_select_29i3 : select_3_3 port map ( a(2)=>not_rtlcn836, 
      a(1)=>AmnonHofman(1), a(0)=>rtlcn343, b(2)=>GND, b(1)=>
      AmnonHofman_fsm_29n4ss1_2, b(0)=>PWR, d=>AmnonHofman_fsm_29n20ss1_2);
   TxSense_select_29i4 : select_3_3 port map ( a(2)=>not_rtlcn837, a(1)=>
      AmnonHofman(7), a(0)=>rtlcn464, b(2)=>PWR, b(1)=>Tx_Inhibit, b(0)=>GND, 
      d=>TxSense_29n20ss1);
   Cal_select_26i7Bus12_4 : select_3_3 port map ( a(2)=>calib(4), a(1)=>
      rtlcn478, a(0)=>not_rtlcn838, b(2)=>Cal_26n7ss1_4, b(1)=>GND, b(0)=>
      rtlc26n373(4), d=>Cal_26n14ss1(4));
   Cal_select_26i7Bus12_3 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(3), b(1)=>GND, b(0)=>
      rtlc26n345(3), d=>Cal_26n14ss1(3));
   Cal_select_26i7Bus12_2 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(2), b(1)=>GND, b(0)=>
      rtlc26n345(2), d=>Cal_26n14ss1(2));
   Cal_select_26i7Bus12_1 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(1), b(1)=>GND, b(0)=>
      rtlc26n345(1), d=>Cal_26n14ss1(1));
   Cal_select_26i8 : select_4_4 port map ( a(3)=>calib(6), a(2)=>rtlcn552, 
      a(1)=>rtlcn549, a(0)=>rtlcn551, b(3)=>GND, b(2)=>PWR, b(1)=>
      rtlc26n345(0), b(0)=>rtlc26n373(0), d=>Cal_26n14ss1(0));
   TxNSital_select_29i5 : select_3_3 port map ( a(2)=>not_rtlcn840, a(1)=>
      rtlc29n929, a(0)=>rtlcn575, b(2)=>GND, b(1)=>TxN, b(0)=>Rx_ok, d=>
      TxNSital_29n20ss1);
   TxSital_select_29i6 : select_3_3 port map ( a(2)=>not_rtlcn841, a(1)=>
      rtlc29n929, a(0)=>rtlcn578, b(2)=>GND, b(1)=>Tx, b(0)=>Rx_ok, d=>
      TxSital_29n20ss1);
   not_Tx <= NOT Tx ;
   not_TxN <= NOT TxN ;
   not_Regular <= NOT Regular ;
   not_rtlc23n227 <= NOT rtlc23n227 ;
   rtlc_876_or_1307 : or_5u_5u port map ( a(4)=>AmnonHofman(0), a(3)=>
      AmnonHofman(2), a(2)=>AmnonHofman(4), a(1)=>AmnonHofman(7), a(0)=>
      AmnonHofman(10), d=>rtlcn700);
   rtlcn312 <= calib(4) OR calib(5) ;
   rtlcn715 <= AmnonHofman(4) AND TxN ;
   rtlcn716 <= rtlcs20 AND AmnonHofman(9) ;
   rtlcn330 <= rtlcn715 OR rtlcn716 ;
   rtlcn719 <= AmnonHofman(2) AND Tx ;
   rtlcn720 <= rtlcs27 AND AmnonHofman(8) ;
   rtlcn343 <= rtlcn719 OR rtlcn720 ;
   rtlcn724 <= not_Regular AND AmnonHofman(0) ;
   rtlc_964_or_1308 : or_5u_5u port map ( a(4)=>AmnonHofman(8), a(3)=>
      AmnonHofman(9), a(2)=>AmnonHofman(10), a(1)=>AmnonHofman(11), a(0)=>
      rtlcn724, d=>rtlcn464);
   not_rtlc26n974 <= NOT rtlc26n974 ;
   rtlcn728 <= calib(5) AND not_rtlc26n974 ;
   rtlcn478 <= calib(6) OR rtlcn728 ;
   not_rtlc26n952 <= NOT rtlc26n952 ;
   rtlcn732 <= calib(4) AND not_rtlc26n952 ;
   rtlcn481 <= calib(6) OR rtlcn732 ;
   rtlcn552 <= rtlcn728 OR rtlcn732 ;
   rtlcn549 <= rtlc26n952 AND calib(4) ;
   rtlcn551 <= rtlc26n974 AND calib(5) ;
   not_rtlc29n698 <= NOT rtlc29n698 ;
   rtlcn575 <= AmnonHofman(4) AND not_rtlc29n698 ;
   not_rtlc29n673 <= NOT rtlc29n673 ;
   rtlcn578 <= AmnonHofman(2) AND not_rtlc29n673 ;
   not_resetN <= NOT resetN ;
   rtlcn742 <= AmnonHofman(4) AND rtlcs11 ;
   not_rtlcs31 <= NOT rtlcs31 ;
   rtlcn744 <= AmnonHofman(6) AND not_rtlcs31 ;
   rtlcn323 <= rtlcn742 OR rtlcn744 ;
   rtlcn745 <= AmnonHofman(2) AND rtlcs17 ;
   not_rtlc29n859 <= NOT rtlc29n859 ;
   rtlcn747 <= AmnonHofman(3) AND not_rtlc29n859 ;
   rtlcn336 <= rtlcn745 OR rtlcn747 ;
   not_rtlc29n845 <= NOT rtlc29n845 ;
   rtlcn749 <= AmnonHofman(1) AND not_rtlc29n845 ;
   rtlcn750 <= AmnonHofman(4) AND rtlcs12 ;
   rtlcn349 <= rtlcn749 OR rtlcn750 ;
   rtlcn751 <= AmnonHofman(7) AND Regular ;
   rtlcn706 <= AmnonHofman(10) OR rtlcn751 ;
   rtlcn709 <= AmnonHofman(6) OR AmnonHofman(5) ;
   rtlcn707 <= TxN OR Regular ;
   rtlcn708 <= Tx OR rtlcn707 ;
   rtlcn752 <= TxN AND AmnonHofman(9) ;
   rtlcn753 <= Tx AND AmnonHofman(8) ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlcn755 <= AmnonHofman(1) AND not_rtlcs18 ;
   not_rtlcs13 <= NOT rtlcs13 ;
   rtlcn757 <= AmnonHofman(3) AND not_rtlcs13 ;
   rtlcn758 <= not_rtlcs31 AND rtlcn709 ;
   rtlcn759 <= AmnonHofman(0) AND rtlcn708 ;
   rtlc_1020_or_1309 : or_10u_10u port map ( a(9)=>AmnonHofman(2), a(8)=>
      AmnonHofman(4), a(7)=>AmnonHofman(11), a(6)=>rtlcn706, a(5)=>rtlcn752, 
      a(4)=>rtlcn753, a(3)=>rtlcn755, a(2)=>rtlcn757, a(1)=>rtlcn758, a(0)=>
      rtlcn759, d=>rtlcn704);
   not_rtlcn704 <= NOT rtlcn704 ;
   not_Tx_Inhibit <= NOT Tx_Inhibit ;
   rtlcn385 <= not_Tx_Inhibit AND rtlcn706 ;
   rtlcn761 <= AmnonHofman(7) AND Tx_Inhibit ;
   rtlcn710 <= AmnonHofman(0) OR rtlcn761 ;
   rtlcn762 <= AmnonHofman(11) AND rtlc29n1265 ;
   rtlcn763 <= Regular AND rtlcn710 ;
   rtlcn398 <= rtlcn762 OR rtlcn763 ;
   rtlcn764 <= AmnonHofman(10) AND Tx_Inhibit ;
   not_rtlc29n1265 <= NOT rtlc29n1265 ;
   rtlcn766 <= AmnonHofman(11) AND not_rtlc29n1265 ;
   rtlcn405 <= rtlcn764 OR rtlcn766 ;
   rtlcn767 <= AmnonHofman(5) AND not_rtlcs31 ;
   rtlcn768 <= AmnonHofman(2) AND rtlcs16 ;
   rtlcn412 <= rtlcn767 OR rtlcn768 ;
   not_rtlc29n870 <= NOT rtlc29n870 ;
   rtlcn770 <= AmnonHofman(8) AND not_rtlc29n870 ;
   not_rtlcn707 <= NOT rtlcn707 ;
   rtlcn427 <= rtlcn770 OR rtlcn772 ;
   not_rtlc29n876 <= NOT rtlc29n876 ;
   rtlcn774 <= AmnonHofman(9) AND not_rtlc29n876 ;
   rtlcn438 <= rtlcn774 OR rtlcn775 ;
   rtlc_1045_and_1312 : and_4u_4u port map ( a(3)=>rtlc23n227, a(2)=>
      rtlc23n238, a(1)=>Reduce_Plus_On, a(0)=>snubb(0), d=>rtlcn450);
   rtlcn705 <= rtlc23n173 OR rtlcn776 ;
   not_rtlc23n302 <= NOT rtlc23n302 ;
   rtlcn779 <= TxSense_EXMPLR3543 AND not_rtlc23n302 ;
   rtlcn711 <= not_snubb_0 OR rtlcn779 ;
   rtlcn475 <= rtlcn705 AND rtlcn711 ;
   rtlcn485 <= calib(3) AND rtlc26n936 ;
   rtlcn489 <= calib(7) AND rtlcs7 ;
   not_rtlcs7 <= NOT rtlcs7 ;
   rtlcn781 <= calib(7) AND not_rtlcs7 ;
   rtlcn782 <= rtlcs10 AND calib(2) ;
   rtlcn495 <= rtlcn781 OR rtlcn782 ;
   not_TxSense <= NOT TxSense_EXMPLR3543 ;
   rtlcn784 <= calib(1) AND not_TxSense ;
   not_rtlcs10 <= NOT rtlcs10 ;
   rtlcn786 <= not_rtlcs10 AND calib(2) ;
   rtlcn502 <= rtlcn784 OR rtlcn786 ;
   rtlcn787 <= not_Regular AND calib(0) ;
   rtlcn712 <= calib(1) OR rtlcn787 ;
   rtlcn513 <= TxSense_EXMPLR3543 AND rtlcn712 ;
   rtlcn788 <= not_TxSense AND calib(0) ;
   rtlcn713 <= calib(6) OR rtlcn788 ;
   rtlcn789 <= not_Regular AND rtlcn713 ;
   not_rtlc26n936 <= NOT rtlc26n936 ;
   not_rtlc26n916 <= NOT rtlc26n916 ;
   rtlcn530 <= calib(3) AND rtlc26n916 ;
   rtlcn539 <= Regular AND rtlc26n623 ;
   not_Reduce_Plus_On <= NOT Reduce_Plus_On ;
   rtlc_1079_and_1315 : and_5u_5u port map ( a(4)=>rtlc23n227, a(3)=>
      rtlc23n238, a(2)=>not_Reduce_Plus_On, a(1)=>snubb(0), a(0)=>
      Reduce_Minus_On, d=>rtlcn567);
   not_rtlcn134 <= NOT rtlcn134 ;
   rtlc_1082_or_1316 : or_4u_4u port map ( a(3)=>calib(4), a(2)=>calib(5), 
      a(1)=>rtlcn789, a(0)=>rtlcn792, d=>rtlcn527);
   rtlc29n870 <= rtlcs22 OR not_Tx ;
   rtlc29n876 <= rtlcs22 OR not_TxN ;
   not_calib_7 <= NOT calib(7) ;
   not_RxSital <= NOT RxSital ;
   not_rtlcn835 <= NOT rtlcn835 ;
   not_rtlcn836 <= NOT rtlcn836 ;
   not_rtlcn837 <= NOT rtlcn837 ;
   not_rtlcn838 <= NOT rtlcn838 ;
   not_rtlcn839 <= NOT rtlcn839 ;
   not_rtlcn840 <= NOT rtlcn840 ;
   not_rtlcn841 <= NOT rtlcn841 ;
   Count_29n13s1f1(4) <= Half_us(4) when rtlc29n1349 = '1' else Count(4) ;
   Count_29n13s1f1(3) <= Half_us(3) when rtlc29n1349 = '1' else Count(3) ;
   Count_29n13s1f1(2) <= Half_us(2) when rtlc29n1349 = '1' else Count(2) ;
   Count_29n13s1f1(1) <= Half_us(1) when rtlc29n1349 = '1' else Count(1) ;
   Count_29n13s1f1(0) <= Half_us(0) when rtlc29n1349 = '1' else Count(0) ;
   rtlcn842 <= rtlc26n455 OR not_calib_7 ;
   not_CE <= NOT CE ;
   rtlc26n677 <= CE AND rtlc26n699 ;
   not_rtlcn312 <= NOT rtlcn312 ;
   rtlcn843 <= rtlc26n987 OR not_rtlcn312 ;
   rtlc26n663 <= CE AND rtlc26n623 ;
   not_rtlc29n1349 <= NOT rtlc29n1349 ;
   rtlcn844 <= not_rtlcn134 OR not_rtlc29n1349 ;
   not_rtlc29n1013 <= NOT rtlc29n1013 ;
   rtlcs13 <= not_TxN AND rtlcs15 ;
   rtlcs18 <= not_Tx AND rtlcs15 ;
   rtlcs20 <= TxN AND rtlcs22 ;
   rtlcs23 <= rtlcs24 AND rtlcs25 ;
   rtlcs27 <= Tx AND rtlcs22 ;
   rtlcs40 <= rtlcs26 AND not_Count_1 ;
   rtlcs22 <= rtlcs40 AND rtlcs30 ;
   rtlcs33 <= not_Shorten_Plus AND rtlcs15 ;
   rtlcs35 <= not_Shorten_Minus AND rtlcs15 ;
   rtlcs15 <= rtlcs37 AND rtlcs30 ;
   rtlcs38 <= rtlcs39 AND rtlcs25 ;
   not_Rx_energy_5 <= NOT Rx_energy(5) ;
   not_Rx_energy_4 <= NOT Rx_energy(4) ;
   not_Rx_energy_3 <= NOT Rx_energy(3) ;
   not_Rx_energy_2 <= NOT Rx_energy(2) ;
   not_Rx_energy_1 <= NOT Rx_energy(1) ;
   not_Rx_energy_0 <= NOT Rx_energy(0) ;
   not_rtlcn700 <= NOT rtlcn700 ;
   Count_29n20ss1(5) <= Count_29n13s1_5 AND not_rtlcn700 ;
   Count_29n20ss1(4) <= Half_us_29n9s1(4) AND not_rtlcn700 ;
   Count_29n20ss1(3) <= Half_us_29n9s1(3) AND not_rtlcn700 ;
   not_Count_6 <= NOT Count(6) ;
   not_Count_5 <= NOT Count(5) ;
   not_Count_4 <= NOT Count(4) ;
   not_Count_3 <= NOT Count(3) ;
   rtlc_1319_and_1325 : and_4u_4u port map ( a(3)=>not_Count_6, a(2)=>
      not_Count_5, a(1)=>not_Count_4, a(0)=>not_Count_3, d=>rtlcs26);
   Count_29n20ss1(1) <= Half_us_29n9s1(1) AND not_rtlcn700 ;
   not_Count_1 <= NOT Count(1) ;
   Count_29n20ss1(2) <= Half_us_29n9s1(2) AND not_rtlcn700 ;
   Count_29n20ss1(0) <= Half_us_29n9s1(0) AND not_rtlcn700 ;
   not_Count_2 <= NOT Count(2) ;
   rtlcs30 <= not_Count_2 AND Count(0) ;
   rtlcs37 <= rtlcs26 AND Count(1) ;
   rtlcn837 <= AmnonHofman(7) OR rtlcn464 ;
   not_Count_1us_4 <= NOT Count_1us(4) ;
   not_Count_1us_2 <= NOT Count_1us(2) ;
   not_Count_1us_1 <= NOT Count_1us(1) ;
   Cal_26n9ss1(2) <= rtlc26n373(2) OR not_rtlc26n974 ;
   not_Micro_4 <= NOT Micro(4) ;
   not_Micro_3 <= NOT Micro(3) ;
   not_Micro_2 <= NOT Micro(2) ;
   not_Micro_1 <= NOT Micro(1) ;
   rtlc_1351_and_1327 : and_5u_5u port map ( a(4)=>not_Micro_4, a(3)=>
      not_Micro_3, a(2)=>not_Micro_2, a(1)=>not_Micro_1, a(0)=>Micro(0), d=>
      rtlcs10);
   not_RxNSital <= NOT RxNSital ;
   rtlcs9 <= not_RxNSital AND RxSital ;
   rtlcs8 <= RxNSital AND not_RxSital ;
   not_Micro_0 <= NOT Micro(0) ;
   rtlc_1376_and_1328 : and_5u_5u port map ( a(4)=>Micro(4), a(3)=>Micro(3), 
      a(2)=>Micro(2), a(1)=>Micro(1), a(0)=>not_Micro_0, d=>rtlcs7);
   rtlcn839 <= calib(5) OR rtlcn481 ;
   Cal_26n9ss1(1) <= rtlc26n373(1) OR not_rtlc26n974 ;
   not_calib_6 <= NOT calib(6) ;
   Delta_26n14ss1(2) <= Delta(3) AND not_calib_6 ;
   Delta_26n14ss1(1) <= Delta(2) AND not_calib_6 ;
   Delta_26n14ss1(0) <= Delta(1) AND not_calib_6 ;
   Cal_26n9ss1(3) <= rtlc26n373(3) OR not_rtlc26n974 ;
   Cal_26n7ss1_4 <= rtlc26n345(4) OR not_rtlc26n952 ;
   rtlcn838 <= rtlcn478 OR calib(4) ;
   not_Count23us_3 <= NOT Count23us(3) ;
   not_Count23us_2 <= NOT Count23us(2) ;
   not_Count23us_1 <= NOT Count23us(1) ;
   not_Count_1us_3 <= NOT Count_1us(3) ;
   not_Shorten_Plus <= NOT Shorten_Plus ;
   not_Count_0 <= NOT Count(0) ;
   rtlcs17 <= not_Tx AND not_Tx_Inhibit ;
   not_Shorten_Minus <= NOT Shorten_Minus ;
   rtlcn835 <= rtlcn330 OR AmnonHofman(3) ;
   rtlcs12 <= not_TxN AND not_Tx_Inhibit ;
   rtlcn836 <= rtlcn343 OR AmnonHofman(1) ;
   rtlcs11 <= not_TxN AND Tx_Inhibit ;
   rtlcs16 <= not_Tx AND Tx_Inhibit ;
   Count_29n20ss1(6) <= Count_29n13s1_6 AND not_rtlcn700 ;
   Half_us_29n20ss1(3) <= Half_us_29n9s1(3) AND rtlc29n1349 ;
   Half_us_29n20ss1(2) <= Half_us_29n9s1(2) AND rtlc29n1349 ;
   Half_us_29n20ss1(1) <= Half_us_29n9s1(1) AND rtlc29n1349 ;
   Half_us_29n20ss1(0) <= Half_us_29n9s1(0) AND rtlc29n1349 ;
   Half_us_29n20ss1(4) <= Half_us_29n9s1(4) AND rtlc29n1349 ;
   TxN_SN_29n20ss1 <= Rx_ok AND AmnonHofman(6) ;
   Tx_SN_29n20ss1 <= Rx_ok AND AmnonHofman(5) ;
   rtlcn840 <= rtlc29n929 OR rtlcn575 ;
   rtlcn841 <= rtlc29n929 OR rtlcn578 ;
   rtlc_1797_or_1335 : or_4u_4u port map ( a(3)=>Fixed(0), a(2)=>Fixed(1), 
      a(1)=>Fixed(2), a(0)=>Fixed(3), d=>rtlc23n172);
   rtlcn776 <= snubb(1) OR snubb(0) ;
   modgen_counter_Rx_energy : counter_updn_aclear_clock_clk_en_0_6
       port map ( clock=>clock, q(5)=>Rx_energy(5), q(4)=>Rx_energy(4), q(3)
      =>Rx_energy(3), q(2)=>Rx_energy(2), q(1)=>Rx_energy(1), q(0)=>
      Rx_energy(0), clk_en=>not_rtlc17_X_0_n125, aclear=>not_resetN, sload=>
      GND, data(5)=>DANGLING(2), data(4)=>DANGLING(3), data(3)=>DANGLING(4), 
      data(2)=>DANGLING(5), data(1)=>DANGLING(6), data(0)=>DANGLING(7), aset
      =>GND, sclear=>GND, updn=>Rx_On, cnt_en=>PWR);
   modgen_counter_Count_1us : counter_dn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Count_1us(4), q(3)=>Count_1us(3), q(2)
      =>Count_1us(2), q(1)=>Count_1us(1), q(0)=>Count_1us(0), clk_en=>CE, 
      aclear=>not_resetN, sload=>rtlc23_X_0_n387, data(4)=>PWR, data(3)=>PWR, 
      data(2)=>PWR, data(1)=>PWR, data(0)=>PWR, aset=>GND, sclear=>GND, updn
      =>GND, cnt_en=>PWR);
   modgen_counter_Count23us : counter_dn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Count23us(4), q(3)=>Count23us(3), q(2)
      =>Count23us(2), q(1)=>Count23us(1), q(0)=>Count23us(0), clk_en=>
      not_rtlc23n414, aclear=>not_resetN, sload=>rtlc23n426, data(4)=>PWR, 
      data(3)=>GND, data(2)=>PWR, data(1)=>GND, data(0)=>GND, aset=>GND, 
      sclear=>GND, updn=>GND, cnt_en=>PWR);
   modgen_counter_Fixed : counter_dn_sload_aclear_clock_clk_en_0_4
       port map ( clock=>clock, q(3)=>Fixed(3), q(2)=>Fixed(2), q(1)=>
      Fixed(1), q(0)=>Fixed(0), clk_en=>not_rtlc23_X_0_n462, aclear=>
      not_resetN, sload=>rtlc23n426, data(3)=>Num_Of_Fixes(3), data(2)=>
      Num_Of_Fixes(2), data(1)=>Num_Of_Fixes(1), data(0)=>Num_Of_Fixes(0), 
      aset=>GND, sclear=>GND, updn=>GND, cnt_en=>PWR);
   not_Count_1us_0 <= NOT Count_1us(0) ;
   rtlc_1920_and_1336 : and_5u_5u port map ( a(4)=>not_Count_1us_4, a(3)=>
      not_Count_1us_3, a(2)=>not_Count_1us_2, a(1)=>not_Count_1us_1, a(0)=>
      not_Count_1us_0, d=>rtlc23n503);
   not_rtlcn4033 <= NOT rtlcn4033 ;
   rtlc_2505_add_1339 : add_4u_4u_4u_0_0 port map ( cin=>GND, a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), b(3)=>Delta(3), b(2)=>
      Delta(2), b(1)=>Delta(1), b(0)=>Delta(0), d(3)=>rtlc26n373(3), d(2)=>
      rtlc26n373(2), d(1)=>rtlc26n373(1), d(0)=>rtlc26n373(0), cout=>
      rtlcn4016);
   rtlc_2514_sub_1340 : sub_4u_4u_4u_0 port map ( cin=>PWR, a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), b(3)=>Delta(3), b(2)=>
      Delta(2), b(1)=>Delta(1), b(0)=>Delta(0), d(3)=>rtlc26n345(3), d(2)=>
      rtlc26n345(2), d(1)=>rtlc26n345(1), d(0)=>rtlc26n345(0), cout=>
      rtlcn4033);
   Rx_On_17n1s2 <= NOT (RxSital XOR RxNSital) ;
   rtlc26n345(4) <= NOT (rtlcn4033 XOR Cal(4)) ;
   DFFPCE (not_Rx_On_17n1s2,GND,not_resetN,CE,clock,Rx_On) ;
   DFFPCE (rtlcn573,not_resetN,GND,CE,clock,Rx_ok) ;
   DFFPCE (rtlcn458,GND,not_resetN,CE,clock,snubb(1)) ;
   DFFPCE (rtlcn475,GND,not_resetN,CE,clock,snubb(0)) ;
   DFFPCE (rtlcn450,GND,not_resetN,CE,clock,Shorten_Plus) ;
   DFFPCE (rtlcn567,GND,not_resetN,CE,clock,Shorten_Minus) ;
   DFFPCE (rtlcn495,GND,not_resetN,CE,clock,calib(7)) ;
   DFFPCE (rtlcn539,not_resetN,GND,CE,clock,calib(6)) ;
   DFFPCE (rtlcn530,GND,not_resetN,CE,clock,calib(5)) ;
   DFFPCE (rtlcn485,GND,not_resetN,CE,clock,calib(4)) ;
   DFFPCE (rtlcn489,GND,not_resetN,CE,clock,calib(3)) ;
   DFFPCE (rtlcn502,GND,not_resetN,CE,clock,calib(2)) ;
   DFFPCE (rtlcn513,GND,not_resetN,CE,clock,calib(1)) ;
   DFFPCE (rtlcn527,GND,not_resetN,CE,clock,calib(0)) ;
   DFFPCE (calib(6),not_resetN,GND,rtlc26n672,clock,Delta(3)) ;
   DFFPCE (Delta_26n14ss1(2),GND,not_resetN,rtlc26n672,clock,Delta(2)) ;
   DFFPCE (Delta_26n14ss1(1),GND,not_resetN,rtlc26n672,clock,Delta(1)) ;
   DFFPCE (Delta_26n14ss1(0),GND,not_resetN,rtlc26n672,clock,Delta(0)) ;
   DFFPCE (Cal_26n14ss1(4),GND,not_resetN,rtlc26n668,clock,Cal(4)) ;
   DFFPCE (Cal_26n14ss1(3),GND,not_resetN,rtlc26n668,clock,Cal(3)) ;
   DFFPCE (Cal_26n14ss1(2),GND,not_resetN,rtlc26n668,clock,Cal(2)) ;
   DFFPCE (Cal_26n14ss1(1),GND,not_resetN,rtlc26n668,clock,Cal(1)) ;
   DFFPCE (Cal_26n14ss1(0),GND,not_resetN,rtlc26n668,clock,Cal(0)) ;
   DFFPCE (Cal(4),GND,not_resetN,rtlc26n663,clock,Reduce_Plus_On) ;
   DFFPCE (Reduce_Minus_On_26n1s1,GND,not_resetN,rtlc26n663,clock,
   Reduce_Minus_On) ;
   DFFPCE (Num_Of_Fixes_26n1s1(3),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(3)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(2),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(2)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(1),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(1)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(0),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(0)) ;
   DFFPCE (rtlcn405,GND,not_resetN,CE,clock,AmnonHofman(11)) ;
   DFFPCE (rtlcn385,GND,not_resetN,CE,clock,AmnonHofman(10)) ;
   DFFPCE (rtlcn438,GND,not_resetN,CE,clock,AmnonHofman(9)) ;
   DFFPCE (rtlcn427,GND,not_resetN,CE,clock,AmnonHofman(8)) ;
   DFFPCE (rtlcn398,GND,not_resetN,CE,clock,AmnonHofman(7)) ;
   DFFPCE (rtlcn323,GND,not_resetN,CE,clock,AmnonHofman(6)) ;
   DFFPCE (rtlcn412,GND,not_resetN,CE,clock,AmnonHofman(5)) ;
   DFFPCE (AmnonHofman_fsm_29n20ss1_4,GND,not_resetN,CE,clock,AmnonHofman(4)
   ) ;
   DFFPCE (rtlcn336,GND,not_resetN,CE,clock,AmnonHofman(3)) ;
   DFFPCE (AmnonHofman_fsm_29n20ss1_2,GND,not_resetN,CE,clock,AmnonHofman(2)
   ) ;
   DFFPCE (rtlcn349,GND,not_resetN,CE,clock,AmnonHofman(1)) ;
   DFFPCE (not_rtlcn704,not_resetN,GND,CE,clock,AmnonHofman(0)) ;
   DFFPCE (Tx_SN_29n20ss1,GND,not_resetN,CE,clock,Tx_SN) ;
   DFFPCE (TxSital_29n20ss1,GND,not_resetN,CE,clock,Tx_Sital) ;
   DFFPCE (TxSense_29n20ss1,not_resetN,GND,CE,clock,TxSense_EXMPLR3543) ;
   DFFPCE (TxN_SN_29n20ss1,GND,not_resetN,CE,clock,TxN_SN) ;
   DFFPCE (TxNSital_29n20ss1,GND,not_resetN,CE,clock,TxN_Sital) ;
   DFFPCE (Half_us_29n20ss1(4),GND,not_resetN,rtlc29n995,clock,Half_us(4)) ;
   DFFPCE (Half_us_29n20ss1(3),GND,not_resetN,rtlc29n995,clock,Half_us(3)) ;
   DFFPCE (Half_us_29n20ss1(2),GND,not_resetN,rtlc29n995,clock,Half_us(2)) ;
   DFFPCE (Half_us_29n20ss1(1),GND,not_resetN,rtlc29n995,clock,Half_us(1)) ;
   DFFPCE (Half_us_29n20ss1(0),GND,not_resetN,rtlc29n995,clock,Half_us(0)) ;
   DFFPCE (Count_29n20ss1(6),GND,not_resetN,CE,clock,Count(6)) ;
   DFFPCE (Count_29n20ss1(5),GND,not_resetN,CE,clock,Count(5)) ;
   DFFPCE (Count_29n20ss1(4),GND,not_resetN,CE,clock,Count(4)) ;
   DFFPCE (Count_29n20ss1(3),GND,not_resetN,CE,clock,Count(3)) ;
   DFFPCE (Count_29n20ss1(2),GND,not_resetN,CE,clock,Count(2)) ;
   DFFPCE (Count_29n20ss1(1),GND,not_resetN,CE,clock,Count(1)) ;
   DFFPCE (Count_29n20ss1(0),GND,not_resetN,CE,clock,Count(0)) ;
   rtlc17_25_or_1277_nx0 <= not_CE OR rtlc17n121 ;
   rtlc17_X_0_n125 <= rtlc17_25_or_1277_nx0 OR rtlc17n124 ;
   rtlc23n426 <= snubb(1) OR not_snubb_0 ;
   rtlc23_X_0_n387 <= rtlc23n426 OR rtlc23n503 ;
   rtlc23_258_or_1280_nx0 <= Count23us(1) OR Count23us(2) ;
   rtlc23n604 <= rtlc23_258_or_1280_nx0 OR Count23us(3) ;
   rtlc23_274_or_1281_nx0 <= Count_1us(0) OR Count_1us(1) ;
   rtlc23n634 <= rtlc23_274_or_1281_nx0 OR Count_1us(2) ;
   rtlc26n694 <= rtlcn312 OR calib(6) ;
   rtlc26_204_or_1284_nx0 <= calib(1) OR calib(2) ;
   rtlc26n699 <= rtlc26_204_or_1284_nx0 OR calib(7) ;
   rtlc26_631_or_1285_nx0 <= rtlc26n345(1) OR rtlc26n345(2) ;
   rtlc26n949 <= rtlc26_631_or_1285_nx0 OR rtlc26n345(3) ;
   rtlc26_649_or_1287_nx0 <= Delta(1) OR Delta(2) ;
   rtlc26n987 <= rtlc26_649_or_1287_nx0 OR Delta(3) ;
   rtlc29_209_or_1291_nx0 <= AmnonHofman(7) OR AmnonHofman(10) ;
   rtlc29n929 <= rtlc29_209_or_1291_nx0 OR AmnonHofman(11) ;
   rtlc_283_or_1296_nx0 <= not_CE OR rtlc23n457 ;
   rtlc23_X_0_n462 <= rtlc_283_or_1296_nx0 OR rtlc23n461 ;
   rtlc_1039_and_1310_nx0 <= Tx AND AmnonHofman(0) ;
   rtlcn772 <= rtlc_1039_and_1310_nx0 AND not_rtlcn707 ;
   rtlc_1043_and_1311_nx0 <= TxN AND not_Regular ;
   rtlcn775 <= rtlc_1043_and_1311_nx0 AND AmnonHofman(0) ;
   rtlc_1073_and_1314_nx0 <= calib(3) AND not_rtlc26n936 ;
   rtlcn792 <= rtlc_1073_and_1314_nx0 AND not_rtlc26n916 ;
   rtlc_1089_or_1318_nx0 <= rtlcs18 OR rtlcs33 ;
   rtlc29n845 <= rtlc_1089_or_1318_nx0 OR rtlcs38 ;
   rtlc_1095_or_1319_nx0 <= rtlcs13 OR rtlcs23 ;
   rtlc29n859 <= rtlc_1095_or_1319_nx0 OR rtlcs35 ;
   rtlc_1283_and_1320_nx0 <= CE AND rtlc26n626 ;
   rtlc26n683 <= rtlc_1283_and_1320_nx0 AND rtlcn842 ;
   rtlc26n668 <= CE AND rtlc26n694 ;
   rtlc26n672 <= rtlc26n668 AND rtlcn843 ;
   rtlc_1298_and_1322_nx0 <= CE AND not_rtlc29n1013 ;
   rtlc29n995 <= rtlc_1298_and_1322_nx0 AND rtlcn844 ;
   rtlc_1432_and_1331_nx0 <= Tx AND rtlcs26 ;
   rtlcs39 <= rtlc_1432_and_1331_nx0 AND Shorten_Plus ;
   rtlc_1435_and_1332_nx0 <= not_Count_1 AND Count(2) ;
   rtlcs25 <= rtlc_1435_and_1332_nx0 AND not_Count_0 ;
   rtlc_1442_and_1333_nx0 <= TxN AND rtlcs26 ;
   rtlcs24 <= rtlc_1442_and_1333_nx0 AND Shorten_Minus ;
   modgen_or_0 : or_5u_5u port map ( a(4)=>Rx_energy(3), a(3)=>Rx_energy(4), 
      a(2)=>Rx_energy(5), a(1)=>Rx_energy(2), a(0)=>not_rtlcn134, d=>
      rtlcn573);
   modgen_and_1 : and_3u_3u port map ( a(2)=>snubb(0), a(1)=>
      TxSense_EXMPLR3543, a(0)=>rtlc23n302, d=>rtlcn458);
   modgen_counter_Sum : counter_updn_sclear_aclear_clock_clk_en_0_6
       port map ( clock=>clock, q(5)=>Sum(5), q(4)=>Sum(4), q(3)=>Sum(3), 
      q(2)=>Sum(2), q(1)=>Sum(1), q(0)=>Sum(0), clk_en=>rtlc26n683, aclear=>
      not_resetN, sload=>GND, data(5)=>DANGLING(8), data(4)=>DANGLING(9), 
      data(3)=>DANGLING(10), data(2)=>DANGLING(11), data(1)=>DANGLING(12), 
      data(0)=>DANGLING(13), aset=>GND, sclear=>not_calib_7, updn=>RxSital, 
      cnt_en=>PWR);
   modgen_counter_Micro : counter_updn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Micro(4), q(3)=>Micro(3), q(2)=>
      Micro(2), q(1)=>Micro(1), q(0)=>Micro(0), clk_en=>rtlc26n677, aclear=>
      not_resetN, sload=>calib(1), data(4)=>PWR, data(3)=>GND, data(2)=>PWR, 
      data(1)=>PWR, data(0)=>PWR, aset=>GND, sclear=>GND, updn=>calib(7), 
      cnt_en=>PWR);
   modgen_rom_ix679 : rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
       port map ( rd_data1(0)=>AmnonHofman_fsm_29n4ss1_2, addr1(8)=>
      Shorten_Plus, addr1(7)=>Count(6), addr1(6)=>Count(5), addr1(5)=>
      Count(4), addr1(4)=>Count(3), addr1(3)=>Count(2), addr1(2)=>Count(1), 
      addr1(1)=>Count(0), addr1(0)=>Tx, rd_clk1=>DANGLING(14), rd_ena1=>PWR, 
      regce1=>PWR, rst1=>GND);
   modgen_rom_ix680 : rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
       port map ( rd_data1(0)=>AmnonHofman_fsm_29n8ss1_4, addr1(8)=>
      Shorten_Minus, addr1(7)=>Count(6), addr1(6)=>Count(5), addr1(5)=>
      Count(4), addr1(4)=>Count(3), addr1(3)=>Count(2), addr1(2)=>Count(1), 
      addr1(1)=>Count(0), addr1(0)=>TxN, rd_clk1=>DANGLING(15), rd_ena1=>PWR, 
      regce1=>PWR, rst1=>GND);
   modgen_and_2 : and_7u_7u port map ( a(6)=>Rx_energy(5), a(5)=>
      Rx_energy(4), a(4)=>Rx_energy(3), a(3)=>Rx_energy(2), a(2)=>
      Rx_energy(1), a(1)=>Rx_energy(0), a(0)=>Rx_On, d=>rtlc17n121);
   modgen_and_3 : and_7u_7u port map ( a(6)=>not_Rx_energy_5, a(5)=>
      not_Rx_energy_4, a(4)=>not_Rx_energy_3, a(3)=>not_Rx_energy_2, a(2)=>
      not_Rx_energy_1, a(1)=>not_Rx_energy_0, a(0)=>not_Rx_On, d=>rtlc17n124
   );
   modgen_and_4 : and_6u_6u port map ( a(5)=>not_Count_1us_4, a(4)=>
      Count_1us(3), a(3)=>not_Count_1us_2, a(2)=>not_Count_1us_1, a(1)=>
      Count_1us(0), a(0)=>rtlc23n172, d=>rtlc23n272);
   modgen_and_5 : and_10u_10u port map ( a(9)=>not_Count23us_4, a(8)=>
      not_Count23us_3, a(7)=>not_Count23us_2, a(6)=>not_Count23us_1, a(5)=>
      Count23us(0), a(4)=>not_Count_1us_4, a(3)=>not_Count_1us_3, a(2)=>
      not_Count_1us_2, a(1)=>not_Count_1us_1, a(0)=>Count_1us(0), d=>
      rtlc23n302);
   modgen_and_6 : and_5u_5u port map ( a(4)=>not_Count_6, a(3)=>not_Count_5, 
      a(2)=>not_Count_4, a(1)=>Count(3), a(0)=>rtlcs25, d=>rtlcs31);
end OH_Calibrate_unfold_1 ;


architecture INTERFACE_unfold_1 of counter_updn_aclear_clock_clk_en_0_6 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, nx31, nx32, nx33, nx34, PWR, nx38, nx39, nx40, 
      nx41, nx42, nx43: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(5) <= nx18 ;
   q(4) <= nx20 ;
   q(3) <= nx22 ;
   q(2) <= nx24 ;
   q(1) <= nx26 ;
   q(0) <= nx28 ;
   GND <= '0' ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,GND,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,GND,aclear,clk_en,clock,nx28) ;
   inc : inc_6u_6u_0_0 port map ( cin=>PWR, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx29, d(4)=>nx30, d(3)
      =>nx31, d(2)=>nx32, d(1)=>nx33, d(0)=>nx34, cout=>DANGLING(0));
   PWR <= '1' ;
   dec : dec_6u_6u_0_0 port map ( cin=>GND, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx38, d(4)=>nx39, d(3)
      =>nx40, d(2)=>nx41, d(1)=>nx42, d(0)=>nx43, cout=>DANGLING(1));
   nx17 <= nx29 when updn = '1' else nx38 ;
   nx19 <= nx30 when updn = '1' else nx39 ;
   nx21 <= nx31 when updn = '1' else nx40 ;
   nx23 <= nx32 when updn = '1' else nx41 ;
   nx25 <= nx33 when updn = '1' else nx42 ;
   nx27 <= nx34 when updn = '1' else nx43 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_1 of counter_dn_sload_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx15 <= data(4) when sload = '1' else nx25 ;
   nx17 <= data(3) when sload = '1' else nx26 ;
   nx19 <= data(2) when sload = '1' else nx27 ;
   nx21 <= data(1) when sload = '1' else nx28 ;
   nx23 <= data(0) when sload = '1' else nx29 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_2 of counter_dn_sload_aclear_clock_clk_en_0_5
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   GND <= '0' ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,GND,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,GND,aclear,clk_en,clock,nx24) ;
   dec : dec_5u_5u_0_0 port map ( cin=>GND, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx15 <= data(4) when sload = '1' else nx25 ;
   nx17 <= data(3) when sload = '1' else nx26 ;
   nx19 <= data(2) when sload = '1' else nx27 ;
   nx21 <= data(1) when sload = '1' else nx28 ;
   nx23 <= data(0) when sload = '1' else nx29 ;
end INTERFACE_unfold_2 ;


architecture INTERFACE_unfold_1 of counter_dn_sload_aclear_clock_clk_en_0_4
    is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component dec_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal GND, nx13, nx14, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, 
      nx23, nx24: std_logic ;
   
   signal DANGLING : std_logic_vector (0 downto 0 );

begin
   q(3) <= nx14 ;
   q(2) <= nx16 ;
   q(1) <= nx18 ;
   q(0) <= nx20 ;
   GND <= '0' ;
   DFFPCE (nx13,GND,aclear,clk_en,clock,nx14) ;
   DFFPCE (nx15,GND,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,GND,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,GND,aclear,clk_en,clock,nx20) ;
   dec : dec_4u_4u_0_0 port map ( cin=>GND, a(3)=>nx14, a(2)=>nx16, a(1)=>
      nx18, a(0)=>nx20, d(3)=>nx21, d(2)=>nx22, d(1)=>nx23, d(0)=>nx24, cout
      =>DANGLING(0));
   nx13 <= data(3) when sload = '1' else nx21 ;
   nx15 <= data(2) when sload = '1' else nx22 ;
   nx17 <= data(1) when sload = '1' else nx23 ;
   nx19 <= data(0) when sload = '1' else nx24 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_1 of 
   counter_updn_sclear_aclear_clock_clk_en_0_6 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_6u_6u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic_vector (5 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR3577: std_logic_vector (5 DOWNTO 0) ;
   
   signal nx13, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, nx25, nx26, 
      nx27, nx28, nx29, nx30, nx31, nx32, nx33, nx34, nx36, nx38, nx39, nx40, 
      nx41, nx42, nx43, nx45, nx47, nx49, nx51, nx53, nx55, NOT_SCLEAR: 
   std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(5) <= nx18 ;
   q(4) <= nx20 ;
   q(3) <= nx22 ;
   q(2) <= nx24 ;
   q(1) <= nx26 ;
   q(0) <= nx28 ;
   nx13 <= '0' ;
   DFFPCE (nx17,nx13,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,nx13,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx13,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx13,aclear,clk_en,clock,nx24) ;
   DFFPCE (nx25,nx13,aclear,clk_en,clock,nx26) ;
   DFFPCE (nx27,nx13,aclear,clk_en,clock,nx28) ;
   inc : inc_6u_6u_0_0 port map ( cin=>nx36, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx29, d(4)=>nx30, d(3)
      =>nx31, d(2)=>nx32, d(1)=>nx33, d(0)=>nx34, cout=>DANGLING(0));
   nx36 <= '1' ;
   dec : dec_6u_6u_0_0 port map ( cin=>nx13, a(5)=>nx18, a(4)=>nx20, a(3)=>
      nx22, a(2)=>nx24, a(1)=>nx26, a(0)=>nx28, d(5)=>nx38, d(4)=>nx39, d(3)
      =>nx40, d(2)=>nx41, d(1)=>nx42, d(0)=>nx43, cout=>DANGLING(1));
   nx45 <= nx29 when updn = '1' else nx38 ;
   nx47 <= nx30 when updn = '1' else nx39 ;
   nx49 <= nx31 when updn = '1' else nx40 ;
   nx51 <= nx32 when updn = '1' else nx41 ;
   nx53 <= nx33 when updn = '1' else nx42 ;
   nx55 <= nx34 when updn = '1' else nx43 ;
   NOT_SCLEAR <= NOT sclear ;
   nx17 <= nx45 AND NOT_SCLEAR ;
   nx19 <= nx47 AND NOT_SCLEAR ;
   nx21 <= nx49 AND NOT_SCLEAR ;
   nx23 <= nx51 AND NOT_SCLEAR ;
   nx25 <= nx53 AND NOT_SCLEAR ;
   nx27 <= nx55 AND NOT_SCLEAR ;
end INTERFACE_unfold_1 ;


architecture INTERFACE_unfold_1 of 
   counter_updn_sload_aclear_clock_clk_en_0_5 is 
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component inc_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component dec_5u_5u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   signal q_EXMPLR3590: std_logic_vector (4 DOWNTO 0) ;
   
   signal nx11, nx15, nx16, nx17, nx18, nx19, nx20, nx21, nx22, nx23, nx24, 
      nx25, nx26, nx27, nx28, nx29, nx31, nx33, nx34, nx35, nx36, nx37, nx39, 
      nx41, nx43, nx45, nx47: std_logic ;
   
   signal DANGLING : std_logic_vector (1 downto 0 );

begin
   q(4) <= nx16 ;
   q(3) <= nx18 ;
   q(2) <= nx20 ;
   q(1) <= nx22 ;
   q(0) <= nx24 ;
   nx11 <= '0' ;
   DFFPCE (nx15,nx11,aclear,clk_en,clock,nx16) ;
   DFFPCE (nx17,nx11,aclear,clk_en,clock,nx18) ;
   DFFPCE (nx19,nx11,aclear,clk_en,clock,nx20) ;
   DFFPCE (nx21,nx11,aclear,clk_en,clock,nx22) ;
   DFFPCE (nx23,nx11,aclear,clk_en,clock,nx24) ;
   inc : inc_5u_5u_0_0 port map ( cin=>nx31, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx25, d(3)=>nx26, d(2)=>nx27, d(1)
      =>nx28, d(0)=>nx29, cout=>DANGLING(0));
   nx31 <= '1' ;
   dec : dec_5u_5u_0_0 port map ( cin=>nx11, a(4)=>nx16, a(3)=>nx18, a(2)=>
      nx20, a(1)=>nx22, a(0)=>nx24, d(4)=>nx33, d(3)=>nx34, d(2)=>nx35, d(1)
      =>nx36, d(0)=>nx37, cout=>DANGLING(1));
   nx39 <= nx25 when updn = '1' else nx33 ;
   nx41 <= nx26 when updn = '1' else nx34 ;
   nx43 <= nx27 when updn = '1' else nx35 ;
   nx45 <= nx28 when updn = '1' else nx36 ;
   nx47 <= nx29 when updn = '1' else nx37 ;
   nx15 <= data(4) when sload = '1' else nx39 ;
   nx17 <= data(3) when sload = '1' else nx41 ;
   nx19 <= data(2) when sload = '1' else nx43 ;
   nx21 <= data(1) when sload = '1' else nx45 ;
   nx23 <= data(0) when sload = '1' else nx47 ;
end INTERFACE_unfold_1 ;


architecture INTERFACE of 
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component mux_512u_512u
      port (
         a : IN std_logic_vector (511 DOWNTO 0) ;
         b : IN std_logic_vector (511 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_1337 : mux_512u_512u port map ( a(511)=>GND, a(510)=>GND, 
      a(509)=>GND, a(508)=>GND, a(507)=>GND, a(506)=>GND, a(505)=>GND, 
      a(504)=>GND, a(503)=>GND, a(502)=>GND, a(501)=>GND, a(500)=>GND, 
      a(499)=>GND, a(498)=>GND, a(497)=>GND, a(496)=>GND, a(495)=>GND, 
      a(494)=>GND, a(493)=>GND, a(492)=>GND, a(491)=>GND, a(490)=>GND, 
      a(489)=>GND, a(488)=>GND, a(487)=>GND, a(486)=>GND, a(485)=>GND, 
      a(484)=>GND, a(483)=>GND, a(482)=>GND, a(481)=>GND, a(480)=>GND, 
      a(479)=>GND, a(478)=>GND, a(477)=>GND, a(476)=>GND, a(475)=>GND, 
      a(474)=>GND, a(473)=>GND, a(472)=>GND, a(471)=>GND, a(470)=>GND, 
      a(469)=>GND, a(468)=>GND, a(467)=>GND, a(466)=>GND, a(465)=>GND, 
      a(464)=>GND, a(463)=>GND, a(462)=>GND, a(461)=>GND, a(460)=>GND, 
      a(459)=>GND, a(458)=>GND, a(457)=>GND, a(456)=>GND, a(455)=>GND, 
      a(454)=>GND, a(453)=>GND, a(452)=>GND, a(451)=>GND, a(450)=>GND, 
      a(449)=>GND, a(448)=>GND, a(447)=>GND, a(446)=>GND, a(445)=>GND, 
      a(444)=>GND, a(443)=>GND, a(442)=>GND, a(441)=>GND, a(440)=>GND, 
      a(439)=>GND, a(438)=>GND, a(437)=>GND, a(436)=>GND, a(435)=>GND, 
      a(434)=>GND, a(433)=>GND, a(432)=>GND, a(431)=>GND, a(430)=>GND, 
      a(429)=>GND, a(428)=>GND, a(427)=>GND, a(426)=>GND, a(425)=>GND, 
      a(424)=>GND, a(423)=>GND, a(422)=>GND, a(421)=>GND, a(420)=>GND, 
      a(419)=>GND, a(418)=>GND, a(417)=>GND, a(416)=>GND, a(415)=>GND, 
      a(414)=>GND, a(413)=>GND, a(412)=>GND, a(411)=>GND, a(410)=>GND, 
      a(409)=>GND, a(408)=>GND, a(407)=>GND, a(406)=>GND, a(405)=>GND, 
      a(404)=>GND, a(403)=>GND, a(402)=>GND, a(401)=>GND, a(400)=>GND, 
      a(399)=>GND, a(398)=>GND, a(397)=>GND, a(396)=>GND, a(395)=>GND, 
      a(394)=>GND, a(393)=>GND, a(392)=>GND, a(391)=>GND, a(390)=>GND, 
      a(389)=>GND, a(388)=>GND, a(387)=>GND, a(386)=>GND, a(385)=>GND, 
      a(384)=>GND, a(383)=>GND, a(382)=>GND, a(381)=>GND, a(380)=>GND, 
      a(379)=>GND, a(378)=>GND, a(377)=>GND, a(376)=>GND, a(375)=>GND, 
      a(374)=>GND, a(373)=>GND, a(372)=>GND, a(371)=>GND, a(370)=>GND, 
      a(369)=>GND, a(368)=>GND, a(367)=>GND, a(366)=>GND, a(365)=>GND, 
      a(364)=>GND, a(363)=>GND, a(362)=>GND, a(361)=>GND, a(360)=>GND, 
      a(359)=>GND, a(358)=>GND, a(357)=>GND, a(356)=>GND, a(355)=>GND, 
      a(354)=>GND, a(353)=>GND, a(352)=>GND, a(351)=>GND, a(350)=>GND, 
      a(349)=>GND, a(348)=>GND, a(347)=>GND, a(346)=>GND, a(345)=>GND, 
      a(344)=>GND, a(343)=>GND, a(342)=>GND, a(341)=>GND, a(340)=>GND, 
      a(339)=>GND, a(338)=>GND, a(337)=>GND, a(336)=>GND, a(335)=>GND, 
      a(334)=>GND, a(333)=>GND, a(332)=>GND, a(331)=>GND, a(330)=>GND, 
      a(329)=>GND, a(328)=>GND, a(327)=>GND, a(326)=>GND, a(325)=>GND, 
      a(324)=>GND, a(323)=>GND, a(322)=>GND, a(321)=>GND, a(320)=>GND, 
      a(319)=>GND, a(318)=>GND, a(317)=>GND, a(316)=>GND, a(315)=>GND, 
      a(314)=>GND, a(313)=>GND, a(312)=>GND, a(311)=>GND, a(310)=>GND, 
      a(309)=>GND, a(308)=>GND, a(307)=>GND, a(306)=>GND, a(305)=>GND, 
      a(304)=>GND, a(303)=>GND, a(302)=>GND, a(301)=>GND, a(300)=>GND, 
      a(299)=>GND, a(298)=>GND, a(297)=>GND, a(296)=>GND, a(295)=>GND, 
      a(294)=>GND, a(293)=>GND, a(292)=>GND, a(291)=>GND, a(290)=>GND, 
      a(289)=>GND, a(288)=>GND, a(287)=>GND, a(286)=>GND, a(285)=>GND, 
      a(284)=>GND, a(283)=>GND, a(282)=>GND, a(281)=>GND, a(280)=>GND, 
      a(279)=>GND, a(278)=>GND, a(277)=>GND, a(276)=>GND, a(275)=>GND, 
      a(274)=>GND, a(273)=>GND, a(272)=>GND, a(271)=>GND, a(270)=>GND, 
      a(269)=>GND, a(268)=>GND, a(267)=>GND, a(266)=>GND, a(265)=>PWR, 
      a(264)=>GND, a(263)=>GND, a(262)=>GND, a(261)=>GND, a(260)=>GND, 
      a(259)=>GND, a(258)=>GND, a(257)=>GND, a(256)=>GND, a(255)=>GND, 
      a(254)=>GND, a(253)=>GND, a(252)=>GND, a(251)=>GND, a(250)=>GND, 
      a(249)=>GND, a(248)=>GND, a(247)=>GND, a(246)=>GND, a(245)=>GND, 
      a(244)=>GND, a(243)=>GND, a(242)=>GND, a(241)=>GND, a(240)=>GND, 
      a(239)=>GND, a(238)=>GND, a(237)=>GND, a(236)=>GND, a(235)=>GND, 
      a(234)=>GND, a(233)=>GND, a(232)=>GND, a(231)=>GND, a(230)=>GND, 
      a(229)=>GND, a(228)=>GND, a(227)=>GND, a(226)=>GND, a(225)=>GND, 
      a(224)=>GND, a(223)=>GND, a(222)=>GND, a(221)=>GND, a(220)=>GND, 
      a(219)=>GND, a(218)=>GND, a(217)=>GND, a(216)=>GND, a(215)=>GND, 
      a(214)=>GND, a(213)=>GND, a(212)=>GND, a(211)=>GND, a(210)=>GND, 
      a(209)=>GND, a(208)=>GND, a(207)=>GND, a(206)=>GND, a(205)=>GND, 
      a(204)=>GND, a(203)=>GND, a(202)=>GND, a(201)=>GND, a(200)=>GND, 
      a(199)=>GND, a(198)=>GND, a(197)=>GND, a(196)=>GND, a(195)=>GND, 
      a(194)=>GND, a(193)=>GND, a(192)=>GND, a(191)=>GND, a(190)=>GND, 
      a(189)=>GND, a(188)=>GND, a(187)=>GND, a(186)=>GND, a(185)=>GND, 
      a(184)=>GND, a(183)=>GND, a(182)=>GND, a(181)=>GND, a(180)=>GND, 
      a(179)=>GND, a(178)=>GND, a(177)=>GND, a(176)=>GND, a(175)=>GND, 
      a(174)=>GND, a(173)=>GND, a(172)=>GND, a(171)=>GND, a(170)=>GND, 
      a(169)=>GND, a(168)=>GND, a(167)=>GND, a(166)=>GND, a(165)=>GND, 
      a(164)=>GND, a(163)=>GND, a(162)=>GND, a(161)=>GND, a(160)=>GND, 
      a(159)=>GND, a(158)=>GND, a(157)=>GND, a(156)=>GND, a(155)=>GND, 
      a(154)=>GND, a(153)=>GND, a(152)=>GND, a(151)=>GND, a(150)=>GND, 
      a(149)=>GND, a(148)=>GND, a(147)=>GND, a(146)=>GND, a(145)=>GND, 
      a(144)=>GND, a(143)=>GND, a(142)=>GND, a(141)=>GND, a(140)=>GND, 
      a(139)=>GND, a(138)=>GND, a(137)=>GND, a(136)=>GND, a(135)=>GND, 
      a(134)=>GND, a(133)=>GND, a(132)=>GND, a(131)=>GND, a(130)=>GND, 
      a(129)=>GND, a(128)=>GND, a(127)=>GND, a(126)=>GND, a(125)=>GND, 
      a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, a(120)=>GND, 
      a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, a(115)=>GND, 
      a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, a(110)=>GND, 
      a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, a(105)=>GND, 
      a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, a(100)=>GND, a(99)
      =>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>GND, a(94)=>GND, 
      a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)=>GND, a(88)=>GND, 
      a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, a(83)=>GND, a(82)=>GND, 
      a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, a(77)=>GND, a(76)=>GND, 
      a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, a(71)=>GND, a(70)=>GND, 
      a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, a(65)=>GND, a(64)=>GND, 
      a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, a(59)=>GND, a(58)=>GND, 
      a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, a(53)=>GND, a(52)=>GND, 
      a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, a(47)=>GND, a(46)=>GND, 
      a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, a(41)=>GND, a(40)=>GND, 
      a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, a(35)=>GND, a(34)=>GND, 
      a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, a(29)=>GND, a(28)=>GND, 
      a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, a(23)=>GND, a(22)=>GND, 
      a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, a(17)=>GND, a(16)=>GND, 
      a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)=>GND, a(10)=>GND, 
      a(9)=>GND, a(8)=>GND, a(7)=>PWR, a(6)=>GND, a(5)=>GND, a(4)=>GND, a(3)
      =>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(511)=>GND, b(510)=>GND, 
      b(509)=>GND, b(508)=>GND, b(507)=>GND, b(506)=>GND, b(505)=>GND, 
      b(504)=>GND, b(503)=>GND, b(502)=>GND, b(501)=>GND, b(500)=>GND, 
      b(499)=>GND, b(498)=>GND, b(497)=>GND, b(496)=>GND, b(495)=>GND, 
      b(494)=>GND, b(493)=>GND, b(492)=>GND, b(491)=>GND, b(490)=>GND, 
      b(489)=>GND, b(488)=>GND, b(487)=>GND, b(486)=>GND, b(485)=>GND, 
      b(484)=>GND, b(483)=>GND, b(482)=>GND, b(481)=>GND, b(480)=>GND, 
      b(479)=>GND, b(478)=>GND, b(477)=>GND, b(476)=>GND, b(475)=>GND, 
      b(474)=>GND, b(473)=>GND, b(472)=>GND, b(471)=>GND, b(470)=>GND, 
      b(469)=>GND, b(468)=>GND, b(467)=>GND, b(466)=>GND, b(465)=>GND, 
      b(464)=>GND, b(463)=>GND, b(462)=>GND, b(461)=>GND, b(460)=>GND, 
      b(459)=>GND, b(458)=>GND, b(457)=>GND, b(456)=>GND, b(455)=>GND, 
      b(454)=>GND, b(453)=>GND, b(452)=>GND, b(451)=>GND, b(450)=>GND, 
      b(449)=>GND, b(448)=>GND, b(447)=>GND, b(446)=>GND, b(445)=>GND, 
      b(444)=>GND, b(443)=>GND, b(442)=>GND, b(441)=>GND, b(440)=>GND, 
      b(439)=>GND, b(438)=>GND, b(437)=>GND, b(436)=>GND, b(435)=>GND, 
      b(434)=>GND, b(433)=>GND, b(432)=>GND, b(431)=>GND, b(430)=>GND, 
      b(429)=>GND, b(428)=>GND, b(427)=>GND, b(426)=>GND, b(425)=>GND, 
      b(424)=>GND, b(423)=>GND, b(422)=>GND, b(421)=>GND, b(420)=>GND, 
      b(419)=>GND, b(418)=>GND, b(417)=>GND, b(416)=>GND, b(415)=>GND, 
      b(414)=>GND, b(413)=>GND, b(412)=>GND, b(411)=>GND, b(410)=>GND, 
      b(409)=>GND, b(408)=>GND, b(407)=>GND, b(406)=>GND, b(405)=>GND, 
      b(404)=>GND, b(403)=>GND, b(402)=>GND, b(401)=>GND, b(400)=>GND, 
      b(399)=>GND, b(398)=>GND, b(397)=>GND, b(396)=>GND, b(395)=>GND, 
      b(394)=>GND, b(393)=>GND, b(392)=>GND, b(391)=>GND, b(390)=>GND, 
      b(389)=>GND, b(388)=>GND, b(387)=>GND, b(386)=>GND, b(385)=>GND, 
      b(384)=>GND, b(383)=>GND, b(382)=>GND, b(381)=>GND, b(380)=>GND, 
      b(379)=>GND, b(378)=>GND, b(377)=>GND, b(376)=>GND, b(375)=>GND, 
      b(374)=>GND, b(373)=>GND, b(372)=>GND, b(371)=>GND, b(370)=>GND, 
      b(369)=>GND, b(368)=>GND, b(367)=>GND, b(366)=>GND, b(365)=>GND, 
      b(364)=>GND, b(363)=>GND, b(362)=>GND, b(361)=>GND, b(360)=>GND, 
      b(359)=>GND, b(358)=>GND, b(357)=>GND, b(356)=>GND, b(355)=>GND, 
      b(354)=>GND, b(353)=>GND, b(352)=>GND, b(351)=>GND, b(350)=>GND, 
      b(349)=>GND, b(348)=>GND, b(347)=>GND, b(346)=>GND, b(345)=>GND, 
      b(344)=>GND, b(343)=>GND, b(342)=>GND, b(341)=>GND, b(340)=>GND, 
      b(339)=>GND, b(338)=>GND, b(337)=>GND, b(336)=>GND, b(335)=>GND, 
      b(334)=>GND, b(333)=>GND, b(332)=>GND, b(331)=>GND, b(330)=>GND, 
      b(329)=>GND, b(328)=>GND, b(327)=>GND, b(326)=>GND, b(325)=>GND, 
      b(324)=>GND, b(323)=>GND, b(322)=>GND, b(321)=>GND, b(320)=>GND, 
      b(319)=>GND, b(318)=>GND, b(317)=>GND, b(316)=>GND, b(315)=>GND, 
      b(314)=>GND, b(313)=>GND, b(312)=>GND, b(311)=>GND, b(310)=>GND, 
      b(309)=>GND, b(308)=>GND, b(307)=>GND, b(306)=>GND, b(305)=>GND, 
      b(304)=>GND, b(303)=>GND, b(302)=>GND, b(301)=>GND, b(300)=>GND, 
      b(299)=>GND, b(298)=>GND, b(297)=>GND, b(296)=>GND, b(295)=>GND, 
      b(294)=>GND, b(293)=>GND, b(292)=>GND, b(291)=>GND, b(290)=>GND, 
      b(289)=>GND, b(288)=>GND, b(287)=>GND, b(286)=>GND, b(285)=>GND, 
      b(284)=>GND, b(283)=>GND, b(282)=>GND, b(281)=>GND, b(280)=>GND, 
      b(279)=>GND, b(278)=>GND, b(277)=>GND, b(276)=>GND, b(275)=>GND, 
      b(274)=>GND, b(273)=>GND, b(272)=>GND, b(271)=>GND, b(270)=>GND, 
      b(269)=>GND, b(268)=>GND, b(267)=>GND, b(266)=>GND, b(265)=>GND, 
      b(264)=>GND, b(263)=>GND, b(262)=>GND, b(261)=>GND, b(260)=>GND, 
      b(259)=>GND, b(258)=>GND, b(257)=>GND, b(256)=>GND, b(255)=>GND, 
      b(254)=>GND, b(253)=>GND, b(252)=>GND, b(251)=>GND, b(250)=>GND, 
      b(249)=>GND, b(248)=>GND, b(247)=>GND, b(246)=>GND, b(245)=>GND, 
      b(244)=>GND, b(243)=>GND, b(242)=>GND, b(241)=>GND, b(240)=>GND, 
      b(239)=>GND, b(238)=>GND, b(237)=>GND, b(236)=>GND, b(235)=>GND, 
      b(234)=>GND, b(233)=>GND, b(232)=>GND, b(231)=>GND, b(230)=>GND, 
      b(229)=>GND, b(228)=>GND, b(227)=>GND, b(226)=>GND, b(225)=>GND, 
      b(224)=>GND, b(223)=>GND, b(222)=>GND, b(221)=>GND, b(220)=>GND, 
      b(219)=>GND, b(218)=>GND, b(217)=>GND, b(216)=>GND, b(215)=>GND, 
      b(214)=>GND, b(213)=>GND, b(212)=>GND, b(211)=>GND, b(210)=>GND, 
      b(209)=>GND, b(208)=>GND, b(207)=>GND, b(206)=>GND, b(205)=>GND, 
      b(204)=>GND, b(203)=>GND, b(202)=>GND, b(201)=>GND, b(200)=>GND, 
      b(199)=>GND, b(198)=>GND, b(197)=>GND, b(196)=>GND, b(195)=>GND, 
      b(194)=>GND, b(193)=>GND, b(192)=>GND, b(191)=>GND, b(190)=>GND, 
      b(189)=>GND, b(188)=>GND, b(187)=>GND, b(186)=>GND, b(185)=>GND, 
      b(184)=>GND, b(183)=>GND, b(182)=>GND, b(181)=>GND, b(180)=>GND, 
      b(179)=>GND, b(178)=>GND, b(177)=>GND, b(176)=>GND, b(175)=>GND, 
      b(174)=>GND, b(173)=>GND, b(172)=>GND, b(171)=>GND, b(170)=>GND, 
      b(169)=>GND, b(168)=>GND, b(167)=>GND, b(166)=>GND, b(165)=>GND, 
      b(164)=>GND, b(163)=>GND, b(162)=>GND, b(161)=>GND, b(160)=>GND, 
      b(159)=>GND, b(158)=>GND, b(157)=>GND, b(156)=>GND, b(155)=>GND, 
      b(154)=>GND, b(153)=>GND, b(152)=>GND, b(151)=>GND, b(150)=>GND, 
      b(149)=>GND, b(148)=>GND, b(147)=>GND, b(146)=>GND, b(145)=>GND, 
      b(144)=>GND, b(143)=>GND, b(142)=>GND, b(141)=>GND, b(140)=>GND, 
      b(139)=>GND, b(138)=>GND, b(137)=>GND, b(136)=>GND, b(135)=>GND, 
      b(134)=>GND, b(133)=>GND, b(132)=>GND, b(131)=>GND, b(130)=>GND, 
      b(129)=>GND, b(128)=>GND, b(127)=>GND, b(126)=>GND, b(125)=>GND, 
      b(124)=>GND, b(123)=>GND, b(122)=>GND, b(121)=>GND, b(120)=>GND, 
      b(119)=>GND, b(118)=>GND, b(117)=>GND, b(116)=>GND, b(115)=>GND, 
      b(114)=>GND, b(113)=>GND, b(112)=>GND, b(111)=>GND, b(110)=>GND, 
      b(109)=>GND, b(108)=>GND, b(107)=>GND, b(106)=>GND, b(105)=>GND, 
      b(104)=>GND, b(103)=>GND, b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)
      =>GND, b(98)=>GND, b(97)=>GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, 
      b(93)=>GND, b(92)=>GND, b(91)=>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, 
      b(87)=>GND, b(86)=>GND, b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, 
      b(81)=>GND, b(80)=>GND, b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, 
      b(75)=>GND, b(74)=>GND, b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, 
      b(69)=>GND, b(68)=>GND, b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, 
      b(63)=>GND, b(62)=>GND, b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, 
      b(57)=>GND, b(56)=>GND, b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, 
      b(51)=>GND, b(50)=>GND, b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, 
      b(45)=>GND, b(44)=>GND, b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, 
      b(39)=>GND, b(38)=>GND, b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, 
      b(33)=>GND, b(32)=>GND, b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, 
      b(27)=>GND, b(26)=>GND, b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, 
      b(21)=>GND, b(20)=>GND, b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, 
      b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, 
      b(9)=>GND, b(8)=>address(8), b(7)=>address(7), b(6)=>address(6), b(5)
      =>address(5), b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), 
      b(1)=>address(1), b(0)=>address(0), d=>q(0));
end INTERFACE ;


architecture INTERFACE_unfold_1 of 
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         address : IN std_logic_vector (8 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (0 DOWNTO 0)) ;
   end component ;
   for modgen_rom_ix679 : 
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE);
   signal nx14, nx16: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx14 <= '0' ;
   nx16 <= '1' ;
   modgen_rom_ix679 : 
      rom_1_9_512_3_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate port map ( 
      address(8)=>addr1(8), address(7)=>addr1(7), address(6)=>addr1(6), 
      address(5)=>addr1(5), address(4)=>addr1(4), address(3)=>addr1(3), 
      address(2)=>addr1(2), address(1)=>addr1(1), address(0)=>addr1(0), 
      inclock=>DANGLING(0), outclock=>DANGLING(1), outclockena=>DANGLING(2), 
      q(0)=>rd_data1(0));
end INTERFACE_unfold_1 ;


architecture INTERFACE of 
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component mux_512u_512u
      port (
         a : IN std_logic_vector (511 DOWNTO 0) ;
         b : IN std_logic_vector (511 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   signal GND, PWR: std_logic ;

begin
   GND <= '0' ;
   PWR <= '1' ;
   modgen_mux_1338 : mux_512u_512u port map ( a(511)=>GND, a(510)=>GND, 
      a(509)=>GND, a(508)=>GND, a(507)=>GND, a(506)=>GND, a(505)=>GND, 
      a(504)=>GND, a(503)=>GND, a(502)=>GND, a(501)=>GND, a(500)=>GND, 
      a(499)=>GND, a(498)=>GND, a(497)=>GND, a(496)=>GND, a(495)=>GND, 
      a(494)=>GND, a(493)=>GND, a(492)=>GND, a(491)=>GND, a(490)=>GND, 
      a(489)=>GND, a(488)=>GND, a(487)=>GND, a(486)=>GND, a(485)=>GND, 
      a(484)=>GND, a(483)=>GND, a(482)=>GND, a(481)=>GND, a(480)=>GND, 
      a(479)=>GND, a(478)=>GND, a(477)=>GND, a(476)=>GND, a(475)=>GND, 
      a(474)=>GND, a(473)=>GND, a(472)=>GND, a(471)=>GND, a(470)=>GND, 
      a(469)=>GND, a(468)=>GND, a(467)=>GND, a(466)=>GND, a(465)=>GND, 
      a(464)=>GND, a(463)=>GND, a(462)=>GND, a(461)=>GND, a(460)=>GND, 
      a(459)=>GND, a(458)=>GND, a(457)=>GND, a(456)=>GND, a(455)=>GND, 
      a(454)=>GND, a(453)=>GND, a(452)=>GND, a(451)=>GND, a(450)=>GND, 
      a(449)=>GND, a(448)=>GND, a(447)=>GND, a(446)=>GND, a(445)=>GND, 
      a(444)=>GND, a(443)=>GND, a(442)=>GND, a(441)=>GND, a(440)=>GND, 
      a(439)=>GND, a(438)=>GND, a(437)=>GND, a(436)=>GND, a(435)=>GND, 
      a(434)=>GND, a(433)=>GND, a(432)=>GND, a(431)=>GND, a(430)=>GND, 
      a(429)=>GND, a(428)=>GND, a(427)=>GND, a(426)=>GND, a(425)=>GND, 
      a(424)=>GND, a(423)=>GND, a(422)=>GND, a(421)=>GND, a(420)=>GND, 
      a(419)=>GND, a(418)=>GND, a(417)=>GND, a(416)=>GND, a(415)=>GND, 
      a(414)=>GND, a(413)=>GND, a(412)=>GND, a(411)=>GND, a(410)=>GND, 
      a(409)=>GND, a(408)=>GND, a(407)=>GND, a(406)=>GND, a(405)=>GND, 
      a(404)=>GND, a(403)=>GND, a(402)=>GND, a(401)=>GND, a(400)=>GND, 
      a(399)=>GND, a(398)=>GND, a(397)=>GND, a(396)=>GND, a(395)=>GND, 
      a(394)=>GND, a(393)=>GND, a(392)=>GND, a(391)=>GND, a(390)=>GND, 
      a(389)=>GND, a(388)=>GND, a(387)=>GND, a(386)=>GND, a(385)=>GND, 
      a(384)=>GND, a(383)=>GND, a(382)=>GND, a(381)=>GND, a(380)=>GND, 
      a(379)=>GND, a(378)=>GND, a(377)=>GND, a(376)=>GND, a(375)=>GND, 
      a(374)=>GND, a(373)=>GND, a(372)=>GND, a(371)=>GND, a(370)=>GND, 
      a(369)=>GND, a(368)=>GND, a(367)=>GND, a(366)=>GND, a(365)=>GND, 
      a(364)=>GND, a(363)=>GND, a(362)=>GND, a(361)=>GND, a(360)=>GND, 
      a(359)=>GND, a(358)=>GND, a(357)=>GND, a(356)=>GND, a(355)=>GND, 
      a(354)=>GND, a(353)=>GND, a(352)=>GND, a(351)=>GND, a(350)=>GND, 
      a(349)=>GND, a(348)=>GND, a(347)=>GND, a(346)=>GND, a(345)=>GND, 
      a(344)=>GND, a(343)=>GND, a(342)=>GND, a(341)=>GND, a(340)=>GND, 
      a(339)=>GND, a(338)=>GND, a(337)=>GND, a(336)=>GND, a(335)=>GND, 
      a(334)=>GND, a(333)=>GND, a(332)=>GND, a(331)=>GND, a(330)=>GND, 
      a(329)=>GND, a(328)=>GND, a(327)=>GND, a(326)=>GND, a(325)=>GND, 
      a(324)=>GND, a(323)=>GND, a(322)=>GND, a(321)=>GND, a(320)=>GND, 
      a(319)=>GND, a(318)=>GND, a(317)=>GND, a(316)=>GND, a(315)=>GND, 
      a(314)=>GND, a(313)=>GND, a(312)=>GND, a(311)=>GND, a(310)=>GND, 
      a(309)=>GND, a(308)=>GND, a(307)=>GND, a(306)=>GND, a(305)=>GND, 
      a(304)=>GND, a(303)=>GND, a(302)=>GND, a(301)=>GND, a(300)=>GND, 
      a(299)=>GND, a(298)=>GND, a(297)=>GND, a(296)=>GND, a(295)=>GND, 
      a(294)=>GND, a(293)=>GND, a(292)=>GND, a(291)=>GND, a(290)=>GND, 
      a(289)=>GND, a(288)=>GND, a(287)=>GND, a(286)=>GND, a(285)=>GND, 
      a(284)=>GND, a(283)=>GND, a(282)=>GND, a(281)=>GND, a(280)=>GND, 
      a(279)=>GND, a(278)=>GND, a(277)=>GND, a(276)=>GND, a(275)=>GND, 
      a(274)=>GND, a(273)=>GND, a(272)=>GND, a(271)=>GND, a(270)=>GND, 
      a(269)=>GND, a(268)=>GND, a(267)=>GND, a(266)=>GND, a(265)=>PWR, 
      a(264)=>GND, a(263)=>GND, a(262)=>GND, a(261)=>GND, a(260)=>GND, 
      a(259)=>GND, a(258)=>GND, a(257)=>GND, a(256)=>GND, a(255)=>GND, 
      a(254)=>GND, a(253)=>GND, a(252)=>GND, a(251)=>GND, a(250)=>GND, 
      a(249)=>GND, a(248)=>GND, a(247)=>GND, a(246)=>GND, a(245)=>GND, 
      a(244)=>GND, a(243)=>GND, a(242)=>GND, a(241)=>GND, a(240)=>GND, 
      a(239)=>GND, a(238)=>GND, a(237)=>GND, a(236)=>GND, a(235)=>GND, 
      a(234)=>GND, a(233)=>GND, a(232)=>GND, a(231)=>GND, a(230)=>GND, 
      a(229)=>GND, a(228)=>GND, a(227)=>GND, a(226)=>GND, a(225)=>GND, 
      a(224)=>GND, a(223)=>GND, a(222)=>GND, a(221)=>GND, a(220)=>GND, 
      a(219)=>GND, a(218)=>GND, a(217)=>GND, a(216)=>GND, a(215)=>GND, 
      a(214)=>GND, a(213)=>GND, a(212)=>GND, a(211)=>GND, a(210)=>GND, 
      a(209)=>GND, a(208)=>GND, a(207)=>GND, a(206)=>GND, a(205)=>GND, 
      a(204)=>GND, a(203)=>GND, a(202)=>GND, a(201)=>GND, a(200)=>GND, 
      a(199)=>GND, a(198)=>GND, a(197)=>GND, a(196)=>GND, a(195)=>GND, 
      a(194)=>GND, a(193)=>GND, a(192)=>GND, a(191)=>GND, a(190)=>GND, 
      a(189)=>GND, a(188)=>GND, a(187)=>GND, a(186)=>GND, a(185)=>GND, 
      a(184)=>GND, a(183)=>GND, a(182)=>GND, a(181)=>GND, a(180)=>GND, 
      a(179)=>GND, a(178)=>GND, a(177)=>GND, a(176)=>GND, a(175)=>GND, 
      a(174)=>GND, a(173)=>GND, a(172)=>GND, a(171)=>GND, a(170)=>GND, 
      a(169)=>GND, a(168)=>GND, a(167)=>GND, a(166)=>GND, a(165)=>GND, 
      a(164)=>GND, a(163)=>GND, a(162)=>GND, a(161)=>GND, a(160)=>GND, 
      a(159)=>GND, a(158)=>GND, a(157)=>GND, a(156)=>GND, a(155)=>GND, 
      a(154)=>GND, a(153)=>GND, a(152)=>GND, a(151)=>GND, a(150)=>GND, 
      a(149)=>GND, a(148)=>GND, a(147)=>GND, a(146)=>GND, a(145)=>GND, 
      a(144)=>GND, a(143)=>GND, a(142)=>GND, a(141)=>GND, a(140)=>GND, 
      a(139)=>GND, a(138)=>GND, a(137)=>GND, a(136)=>GND, a(135)=>GND, 
      a(134)=>GND, a(133)=>GND, a(132)=>GND, a(131)=>GND, a(130)=>GND, 
      a(129)=>GND, a(128)=>GND, a(127)=>GND, a(126)=>GND, a(125)=>GND, 
      a(124)=>GND, a(123)=>GND, a(122)=>GND, a(121)=>GND, a(120)=>GND, 
      a(119)=>GND, a(118)=>GND, a(117)=>GND, a(116)=>GND, a(115)=>GND, 
      a(114)=>GND, a(113)=>GND, a(112)=>GND, a(111)=>GND, a(110)=>GND, 
      a(109)=>GND, a(108)=>GND, a(107)=>GND, a(106)=>GND, a(105)=>GND, 
      a(104)=>GND, a(103)=>GND, a(102)=>GND, a(101)=>GND, a(100)=>GND, a(99)
      =>GND, a(98)=>GND, a(97)=>GND, a(96)=>GND, a(95)=>GND, a(94)=>GND, 
      a(93)=>GND, a(92)=>GND, a(91)=>GND, a(90)=>GND, a(89)=>GND, a(88)=>GND, 
      a(87)=>GND, a(86)=>GND, a(85)=>GND, a(84)=>GND, a(83)=>GND, a(82)=>GND, 
      a(81)=>GND, a(80)=>GND, a(79)=>GND, a(78)=>GND, a(77)=>GND, a(76)=>GND, 
      a(75)=>GND, a(74)=>GND, a(73)=>GND, a(72)=>GND, a(71)=>GND, a(70)=>GND, 
      a(69)=>GND, a(68)=>GND, a(67)=>GND, a(66)=>GND, a(65)=>GND, a(64)=>GND, 
      a(63)=>GND, a(62)=>GND, a(61)=>GND, a(60)=>GND, a(59)=>GND, a(58)=>GND, 
      a(57)=>GND, a(56)=>GND, a(55)=>GND, a(54)=>GND, a(53)=>GND, a(52)=>GND, 
      a(51)=>GND, a(50)=>GND, a(49)=>GND, a(48)=>GND, a(47)=>GND, a(46)=>GND, 
      a(45)=>GND, a(44)=>GND, a(43)=>GND, a(42)=>GND, a(41)=>GND, a(40)=>GND, 
      a(39)=>GND, a(38)=>GND, a(37)=>GND, a(36)=>GND, a(35)=>GND, a(34)=>GND, 
      a(33)=>GND, a(32)=>GND, a(31)=>GND, a(30)=>GND, a(29)=>GND, a(28)=>GND, 
      a(27)=>GND, a(26)=>GND, a(25)=>GND, a(24)=>GND, a(23)=>GND, a(22)=>GND, 
      a(21)=>GND, a(20)=>GND, a(19)=>GND, a(18)=>GND, a(17)=>GND, a(16)=>GND, 
      a(15)=>GND, a(14)=>GND, a(13)=>GND, a(12)=>GND, a(11)=>GND, a(10)=>GND, 
      a(9)=>GND, a(8)=>GND, a(7)=>PWR, a(6)=>GND, a(5)=>GND, a(4)=>GND, a(3)
      =>GND, a(2)=>GND, a(1)=>GND, a(0)=>GND, b(511)=>GND, b(510)=>GND, 
      b(509)=>GND, b(508)=>GND, b(507)=>GND, b(506)=>GND, b(505)=>GND, 
      b(504)=>GND, b(503)=>GND, b(502)=>GND, b(501)=>GND, b(500)=>GND, 
      b(499)=>GND, b(498)=>GND, b(497)=>GND, b(496)=>GND, b(495)=>GND, 
      b(494)=>GND, b(493)=>GND, b(492)=>GND, b(491)=>GND, b(490)=>GND, 
      b(489)=>GND, b(488)=>GND, b(487)=>GND, b(486)=>GND, b(485)=>GND, 
      b(484)=>GND, b(483)=>GND, b(482)=>GND, b(481)=>GND, b(480)=>GND, 
      b(479)=>GND, b(478)=>GND, b(477)=>GND, b(476)=>GND, b(475)=>GND, 
      b(474)=>GND, b(473)=>GND, b(472)=>GND, b(471)=>GND, b(470)=>GND, 
      b(469)=>GND, b(468)=>GND, b(467)=>GND, b(466)=>GND, b(465)=>GND, 
      b(464)=>GND, b(463)=>GND, b(462)=>GND, b(461)=>GND, b(460)=>GND, 
      b(459)=>GND, b(458)=>GND, b(457)=>GND, b(456)=>GND, b(455)=>GND, 
      b(454)=>GND, b(453)=>GND, b(452)=>GND, b(451)=>GND, b(450)=>GND, 
      b(449)=>GND, b(448)=>GND, b(447)=>GND, b(446)=>GND, b(445)=>GND, 
      b(444)=>GND, b(443)=>GND, b(442)=>GND, b(441)=>GND, b(440)=>GND, 
      b(439)=>GND, b(438)=>GND, b(437)=>GND, b(436)=>GND, b(435)=>GND, 
      b(434)=>GND, b(433)=>GND, b(432)=>GND, b(431)=>GND, b(430)=>GND, 
      b(429)=>GND, b(428)=>GND, b(427)=>GND, b(426)=>GND, b(425)=>GND, 
      b(424)=>GND, b(423)=>GND, b(422)=>GND, b(421)=>GND, b(420)=>GND, 
      b(419)=>GND, b(418)=>GND, b(417)=>GND, b(416)=>GND, b(415)=>GND, 
      b(414)=>GND, b(413)=>GND, b(412)=>GND, b(411)=>GND, b(410)=>GND, 
      b(409)=>GND, b(408)=>GND, b(407)=>GND, b(406)=>GND, b(405)=>GND, 
      b(404)=>GND, b(403)=>GND, b(402)=>GND, b(401)=>GND, b(400)=>GND, 
      b(399)=>GND, b(398)=>GND, b(397)=>GND, b(396)=>GND, b(395)=>GND, 
      b(394)=>GND, b(393)=>GND, b(392)=>GND, b(391)=>GND, b(390)=>GND, 
      b(389)=>GND, b(388)=>GND, b(387)=>GND, b(386)=>GND, b(385)=>GND, 
      b(384)=>GND, b(383)=>GND, b(382)=>GND, b(381)=>GND, b(380)=>GND, 
      b(379)=>GND, b(378)=>GND, b(377)=>GND, b(376)=>GND, b(375)=>GND, 
      b(374)=>GND, b(373)=>GND, b(372)=>GND, b(371)=>GND, b(370)=>GND, 
      b(369)=>GND, b(368)=>GND, b(367)=>GND, b(366)=>GND, b(365)=>GND, 
      b(364)=>GND, b(363)=>GND, b(362)=>GND, b(361)=>GND, b(360)=>GND, 
      b(359)=>GND, b(358)=>GND, b(357)=>GND, b(356)=>GND, b(355)=>GND, 
      b(354)=>GND, b(353)=>GND, b(352)=>GND, b(351)=>GND, b(350)=>GND, 
      b(349)=>GND, b(348)=>GND, b(347)=>GND, b(346)=>GND, b(345)=>GND, 
      b(344)=>GND, b(343)=>GND, b(342)=>GND, b(341)=>GND, b(340)=>GND, 
      b(339)=>GND, b(338)=>GND, b(337)=>GND, b(336)=>GND, b(335)=>GND, 
      b(334)=>GND, b(333)=>GND, b(332)=>GND, b(331)=>GND, b(330)=>GND, 
      b(329)=>GND, b(328)=>GND, b(327)=>GND, b(326)=>GND, b(325)=>GND, 
      b(324)=>GND, b(323)=>GND, b(322)=>GND, b(321)=>GND, b(320)=>GND, 
      b(319)=>GND, b(318)=>GND, b(317)=>GND, b(316)=>GND, b(315)=>GND, 
      b(314)=>GND, b(313)=>GND, b(312)=>GND, b(311)=>GND, b(310)=>GND, 
      b(309)=>GND, b(308)=>GND, b(307)=>GND, b(306)=>GND, b(305)=>GND, 
      b(304)=>GND, b(303)=>GND, b(302)=>GND, b(301)=>GND, b(300)=>GND, 
      b(299)=>GND, b(298)=>GND, b(297)=>GND, b(296)=>GND, b(295)=>GND, 
      b(294)=>GND, b(293)=>GND, b(292)=>GND, b(291)=>GND, b(290)=>GND, 
      b(289)=>GND, b(288)=>GND, b(287)=>GND, b(286)=>GND, b(285)=>GND, 
      b(284)=>GND, b(283)=>GND, b(282)=>GND, b(281)=>GND, b(280)=>GND, 
      b(279)=>GND, b(278)=>GND, b(277)=>GND, b(276)=>GND, b(275)=>GND, 
      b(274)=>GND, b(273)=>GND, b(272)=>GND, b(271)=>GND, b(270)=>GND, 
      b(269)=>GND, b(268)=>GND, b(267)=>GND, b(266)=>GND, b(265)=>GND, 
      b(264)=>GND, b(263)=>GND, b(262)=>GND, b(261)=>GND, b(260)=>GND, 
      b(259)=>GND, b(258)=>GND, b(257)=>GND, b(256)=>GND, b(255)=>GND, 
      b(254)=>GND, b(253)=>GND, b(252)=>GND, b(251)=>GND, b(250)=>GND, 
      b(249)=>GND, b(248)=>GND, b(247)=>GND, b(246)=>GND, b(245)=>GND, 
      b(244)=>GND, b(243)=>GND, b(242)=>GND, b(241)=>GND, b(240)=>GND, 
      b(239)=>GND, b(238)=>GND, b(237)=>GND, b(236)=>GND, b(235)=>GND, 
      b(234)=>GND, b(233)=>GND, b(232)=>GND, b(231)=>GND, b(230)=>GND, 
      b(229)=>GND, b(228)=>GND, b(227)=>GND, b(226)=>GND, b(225)=>GND, 
      b(224)=>GND, b(223)=>GND, b(222)=>GND, b(221)=>GND, b(220)=>GND, 
      b(219)=>GND, b(218)=>GND, b(217)=>GND, b(216)=>GND, b(215)=>GND, 
      b(214)=>GND, b(213)=>GND, b(212)=>GND, b(211)=>GND, b(210)=>GND, 
      b(209)=>GND, b(208)=>GND, b(207)=>GND, b(206)=>GND, b(205)=>GND, 
      b(204)=>GND, b(203)=>GND, b(202)=>GND, b(201)=>GND, b(200)=>GND, 
      b(199)=>GND, b(198)=>GND, b(197)=>GND, b(196)=>GND, b(195)=>GND, 
      b(194)=>GND, b(193)=>GND, b(192)=>GND, b(191)=>GND, b(190)=>GND, 
      b(189)=>GND, b(188)=>GND, b(187)=>GND, b(186)=>GND, b(185)=>GND, 
      b(184)=>GND, b(183)=>GND, b(182)=>GND, b(181)=>GND, b(180)=>GND, 
      b(179)=>GND, b(178)=>GND, b(177)=>GND, b(176)=>GND, b(175)=>GND, 
      b(174)=>GND, b(173)=>GND, b(172)=>GND, b(171)=>GND, b(170)=>GND, 
      b(169)=>GND, b(168)=>GND, b(167)=>GND, b(166)=>GND, b(165)=>GND, 
      b(164)=>GND, b(163)=>GND, b(162)=>GND, b(161)=>GND, b(160)=>GND, 
      b(159)=>GND, b(158)=>GND, b(157)=>GND, b(156)=>GND, b(155)=>GND, 
      b(154)=>GND, b(153)=>GND, b(152)=>GND, b(151)=>GND, b(150)=>GND, 
      b(149)=>GND, b(148)=>GND, b(147)=>GND, b(146)=>GND, b(145)=>GND, 
      b(144)=>GND, b(143)=>GND, b(142)=>GND, b(141)=>GND, b(140)=>GND, 
      b(139)=>GND, b(138)=>GND, b(137)=>GND, b(136)=>GND, b(135)=>GND, 
      b(134)=>GND, b(133)=>GND, b(132)=>GND, b(131)=>GND, b(130)=>GND, 
      b(129)=>GND, b(128)=>GND, b(127)=>GND, b(126)=>GND, b(125)=>GND, 
      b(124)=>GND, b(123)=>GND, b(122)=>GND, b(121)=>GND, b(120)=>GND, 
      b(119)=>GND, b(118)=>GND, b(117)=>GND, b(116)=>GND, b(115)=>GND, 
      b(114)=>GND, b(113)=>GND, b(112)=>GND, b(111)=>GND, b(110)=>GND, 
      b(109)=>GND, b(108)=>GND, b(107)=>GND, b(106)=>GND, b(105)=>GND, 
      b(104)=>GND, b(103)=>GND, b(102)=>GND, b(101)=>GND, b(100)=>GND, b(99)
      =>GND, b(98)=>GND, b(97)=>GND, b(96)=>GND, b(95)=>GND, b(94)=>GND, 
      b(93)=>GND, b(92)=>GND, b(91)=>GND, b(90)=>GND, b(89)=>GND, b(88)=>GND, 
      b(87)=>GND, b(86)=>GND, b(85)=>GND, b(84)=>GND, b(83)=>GND, b(82)=>GND, 
      b(81)=>GND, b(80)=>GND, b(79)=>GND, b(78)=>GND, b(77)=>GND, b(76)=>GND, 
      b(75)=>GND, b(74)=>GND, b(73)=>GND, b(72)=>GND, b(71)=>GND, b(70)=>GND, 
      b(69)=>GND, b(68)=>GND, b(67)=>GND, b(66)=>GND, b(65)=>GND, b(64)=>GND, 
      b(63)=>GND, b(62)=>GND, b(61)=>GND, b(60)=>GND, b(59)=>GND, b(58)=>GND, 
      b(57)=>GND, b(56)=>GND, b(55)=>GND, b(54)=>GND, b(53)=>GND, b(52)=>GND, 
      b(51)=>GND, b(50)=>GND, b(49)=>GND, b(48)=>GND, b(47)=>GND, b(46)=>GND, 
      b(45)=>GND, b(44)=>GND, b(43)=>GND, b(42)=>GND, b(41)=>GND, b(40)=>GND, 
      b(39)=>GND, b(38)=>GND, b(37)=>GND, b(36)=>GND, b(35)=>GND, b(34)=>GND, 
      b(33)=>GND, b(32)=>GND, b(31)=>GND, b(30)=>GND, b(29)=>GND, b(28)=>GND, 
      b(27)=>GND, b(26)=>GND, b(25)=>GND, b(24)=>GND, b(23)=>GND, b(22)=>GND, 
      b(21)=>GND, b(20)=>GND, b(19)=>GND, b(18)=>GND, b(17)=>GND, b(16)=>GND, 
      b(15)=>GND, b(14)=>GND, b(13)=>GND, b(12)=>GND, b(11)=>GND, b(10)=>GND, 
      b(9)=>GND, b(8)=>address(8), b(7)=>address(7), b(6)=>address(6), b(5)
      =>address(5), b(4)=>address(4), b(3)=>address(3), b(2)=>address(2), 
      b(1)=>address(1), b(0)=>address(0), d=>q(0));
end INTERFACE ;


architecture INTERFACE_unfold_1 of 
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate is 
   component rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         address : IN std_logic_vector (8 DOWNTO 0) ;
         inclock : IN std_logic ;
         outclock : IN std_logic ;
         outclockena : IN std_logic ;
         q : OUT std_logic_vector (0 DOWNTO 0)) ;
   end component ;
   for modgen_rom_ix680 : 
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE);
   signal nx14, nx16: std_logic ;
   
   signal DANGLING : std_logic_vector (2 downto 0 );

begin
   nx14 <= '0' ;
   nx16 <= '1' ;
   modgen_rom_ix680 : 
      rom_1_9_512_4_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate port map ( 
      address(8)=>addr1(8), address(7)=>addr1(7), address(6)=>addr1(6), 
      address(5)=>addr1(5), address(4)=>addr1(4), address(3)=>addr1(3), 
      address(2)=>addr1(2), address(1)=>addr1(1), address(0)=>addr1(0), 
      inclock=>DANGLING(0), outclock=>DANGLING(1), outclockena=>DANGLING(2), 
      q(0)=>rd_data1(0));
end INTERFACE_unfold_1 ;


architecture OH_Calibrate of Xcvr_Snubber_sital_8_4_4_32_7 is 
   component abs_5s_5s
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic_vector (4 DOWNTO 0)) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component inc_7u_7u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic_vector (6 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component select_3_3
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         b : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component select_4_4
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_10u_10u
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_5u_5u
      port (
         a : IN std_logic_vector (4 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_updn_aclear_clock_clk_en_0_6
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (5 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (5 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_dn_sload_aclear_clock_clk_en_0_4
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (3 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (3 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component add_4u_4u_4u_0_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   component sub_4u_4u_4u_0
      port (
         cin : IN std_logic ;
         a : IN std_logic_vector (3 DOWNTO 0) ;
         b : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic_vector (3 DOWNTO 0) ;
         cout : OUT std_logic) ;
   end component ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component counter_updn_sclear_aclear_clock_clk_en_0_6
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (5 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (5 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component counter_updn_sload_aclear_clock_clk_en_0_5
      port (
         clock : IN std_logic ;
         q : OUT std_logic_vector (4 DOWNTO 0) ;
         clk_en : IN std_logic ;
         aclear : IN std_logic ;
         sload : IN std_logic ;
         data : IN std_logic_vector (4 DOWNTO 0) ;
         aset : IN std_logic ;
         sclear : IN std_logic ;
         updn : IN std_logic ;
         cnt_en : IN std_logic) ;
   end component ;
   component rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
         addr1 : IN std_logic_vector (8 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
      port (
         rd_data1 : OUT std_logic_vector (0 DOWNTO 0) ;
         addr1 : IN std_logic_vector (8 DOWNTO 0) ;
         rd_clk1 : IN std_logic ;
         rd_ena1 : IN std_logic ;
         regce1 : IN std_logic ;
         rst1 : IN std_logic) ;
   end component ;
   component and_7u_7u
      port (
         a : IN std_logic_vector (6 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_6u_6u
      port (
         a : IN std_logic_vector (5 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component and_10u_10u
      port (
         a : IN std_logic_vector (9 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for modgen_counter_Rx_energy : counter_updn_aclear_clock_clk_en_0_6
    use entity work.counter_updn_aclear_clock_clk_en_0_6(INTERFACE_unfold_1
   );
   for modgen_counter_Count_1us : counter_dn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_5(
   INTERFACE_unfold_1);
   for modgen_counter_Count23us : counter_dn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_5(
   INTERFACE_unfold_2);
   for modgen_counter_Fixed : counter_dn_sload_aclear_clock_clk_en_0_4
    use entity work.counter_dn_sload_aclear_clock_clk_en_0_4(
   INTERFACE_unfold_1);
   for modgen_counter_Sum : counter_updn_sclear_aclear_clock_clk_en_0_6
    use entity work.counter_updn_sclear_aclear_clock_clk_en_0_6(
   INTERFACE_unfold_1);
   for modgen_counter_Micro : counter_updn_sload_aclear_clock_clk_en_0_5
    use entity work.counter_updn_sload_aclear_clock_clk_en_0_5(
   INTERFACE_unfold_1);
   for modgen_rom_ix679 : 
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE_unfold_1);
   
   for modgen_rom_ix680 : 
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate use entity work.
   rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate(INTERFACE_unfold_1);
   signal TxSense_EXMPLR3662: std_logic ;
   
   signal Cal: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count: std_logic_vector (6 DOWNTO 0) ;
   
   signal Count23us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count_1us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Delta: std_logic_vector (3 DOWNTO 0) ;
   
   signal Fixed: std_logic_vector (3 DOWNTO 0) ;
   
   signal Half_us: std_logic_vector (4 DOWNTO 0) ;
   
   signal Micro: std_logic_vector (4 DOWNTO 0) ;
   
   signal Num_Of_Fixes: std_logic_vector (3 DOWNTO 0) ;
   
   signal Reduce_Minus_On, Reduce_Plus_On, Rx_On: std_logic ;
   
   signal Rx_energy: std_logic_vector (5 DOWNTO 0) ;
   
   signal Rx_ok, Shorten_Minus, Shorten_Plus: std_logic ;
   
   signal Sum: std_logic_vector (5 DOWNTO 0) ;
   
   signal AmnonHofman: std_logic_vector (11 DOWNTO 0) ;
   
   signal calib: std_logic_vector (7 DOWNTO 0) ;
   
   signal snubb: std_logic_vector (1 DOWNTO 0) ;
   
   signal PWR, GND, not_resetN, Rx_On_17n1s2, not_Rx_On_17n1s2, not_CE, 
      rtlc17n121, not_Rx_On, rtlc17n124, rtlc17_X_0_n125, 
      not_rtlc17_X_0_n125, not_Regular, rtlc23n167, rtlc23n172, rtlc23n173, 
      not_rtlc23n503, rtlc23n227, rtlc23n238, rtlc23n272, rtlc23n302, 
      not_snubb_0, rtlc23_X_0_n387, rtlc23n413, rtlc23n414, not_rtlc23n414, 
      not_rtlc23n227, rtlc23n457, not_rtlc23n272, rtlc23n461, 
      rtlc23_X_0_n462, not_rtlc23_X_0_n462, rtlc23n503, not_Count23us_4, 
      rtlc23n604, not_rtlcn136, rtlc23n608, rtlc23n620, not_rtlc23n620, 
      rtlc23n634, rtlc23n635, rtlc23n636, Cal_26n7ss1_4: std_logic ;
   
   signal Cal_26n9ss1: std_logic_vector (3 DOWNTO 1) ;
   
   signal Cal_26n14ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Delta_26n14ss1: std_logic_vector (2 DOWNTO 0) ;
   
   signal Num_Of_Fixes_26n1s1: std_logic_vector (3 DOWNTO 0) ;
   
   signal Reduce_Minus_On_26n1s1: std_logic ;
   
   signal rtlc26n345: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc26n373: std_logic_vector (5 DOWNTO 0) ;
   
   signal rtlc26n455, rtlc26n623, rtlc26n626, rtlc26n663, rtlc26n672, 
      rtlc26n677, rtlc26n683, rtlc26n694, rtlc26n699, rtlc26n911, rtlc26n912, 
      rtlc26n913, rtlc26n914, not_Sum_5, rtlc26n916, not_Sum_4, not_Sum_3, 
      rtlc26n930, not_rtlcn137, rtlc26n933, rtlc26n934, rtlc26n935, 
      rtlc26n936, rtlc26n949, rtlc26n950, not_rtlc26n345_5, rtlc26n952, 
      rtlc26n971, not_rtlcn138, rtlc26n974, rtlc26n987, not_rtlcn4016, 
      rtlc26n1050, not_Cal_4, AmnonHofman_fsm_29n4ss1_2, 
      AmnonHofman_fsm_29n8ss1_4: std_logic ;
   
   signal Count_29n20ss1: std_logic_vector (6 DOWNTO 0) ;
   
   signal Half_us_29n20ss1: std_logic_vector (4 DOWNTO 0) ;
   
   signal TxNSital_29n20ss1, TxN_SN_29n20ss1, TxSense_29n20ss1, 
      TxSital_29n20ss1, Tx_SN_29n20ss1, AmnonHofman_fsm_29n20ss1_4, 
      AmnonHofman_fsm_29n20ss1_2, not_TxN, not_Tx: std_logic ;
   
   signal Half_us_29n9s1: std_logic_vector (4 DOWNTO 0) ;
   
   signal Count_29n13s1_6, Count_29n13s1_5, rtlc29n673, rtlc29n698, 
      rtlc29n845, rtlc29n859, rtlc29n870, rtlc29n876, rtlc29n929, rtlc29n995, 
      rtlc29n1013, rtlc29n1263, rtlc29n1264, rtlc29n1265, rtlc29n1298, 
      rtlc29n1349, rtlcn134, rtlcn136, rtlcn137, rtlcn138, rtlcn312, 
      rtlcn323, rtlcn330, rtlcn336, rtlcn343, rtlcn349, not_rtlcn704, 
      rtlcn385, rtlcn398, rtlcn405, rtlcn412, rtlcn427, rtlcn438, rtlcn450, 
      rtlcn458, rtlcn464, rtlcn475, rtlcn478, rtlcn481, rtlcn485, rtlcn489, 
      rtlcn495, rtlcn502, rtlcn513, rtlcn527, rtlcn530, rtlcn539, rtlcn549, 
      rtlcn551, rtlcn552, rtlcn567, rtlcn573, rtlcn575, rtlcn578, 
      not_rtlcn835, not_rtlcn836, not_rtlcn837, not_rtlcn838, not_rtlcn839, 
      not_rtlcn840, not_rtlcn841, rtlcn700, rtlcn704, rtlcn705, rtlcn706, 
      rtlcn707, rtlcn708, rtlcn709, rtlcn710, rtlcn711, rtlcn712, rtlcn713, 
      rtlcn715, rtlcn716, rtlcn719, rtlcn720, rtlcn724, not_rtlc26n974, 
      rtlcn728, not_rtlc26n952, rtlcn732, not_rtlc29n698, not_rtlc29n673, 
      rtlcn742, not_rtlcs31, rtlcn744, rtlcn745, not_rtlc29n859, rtlcn747, 
      not_rtlc29n845, rtlcn749, rtlcn750, rtlcn751, rtlcn752, rtlcn753, 
      not_rtlcs18, rtlcn755, not_rtlcs13, rtlcn757, rtlcn758, rtlcn759, 
      not_Tx_Inhibit, rtlcn761, rtlcn762, rtlcn763, rtlcn764, 
      not_rtlc29n1265, rtlcn766, rtlcn767, rtlcn768, not_rtlc29n870, 
      rtlcn770, not_rtlcn707, rtlcn772, not_rtlc29n876, rtlcn774, rtlcn775, 
      rtlcn776, not_rtlc23n302, rtlcn779, not_rtlcs7, rtlcn781, rtlcn782, 
      not_TxSense, rtlcn784, not_rtlcs10, rtlcn786, rtlcn787, rtlcn788, 
      rtlcn789, not_rtlc26n936, not_rtlc26n916, rtlcn792, not_Reduce_Plus_On, 
      not_rtlcn134, not_calib_7, not_RxSital, rtlcn835, rtlcn836, rtlcn837, 
      rtlcn838, rtlcn839, rtlcn840, rtlcn841, rtlcn842, rtlcn843, rtlcn844, 
      not_rtlcn312, not_rtlc29n1349, not_rtlc29n1013, rtlcs7, rtlcs8, rtlcs9, 
      rtlcs10, rtlcs11, rtlcs12, rtlcs13, rtlcs15, rtlcs16, rtlcs17, rtlcs18, 
      rtlcs20, rtlcs22, rtlcs23, rtlcs24, rtlcs25, rtlcs26, rtlcs27, 
      not_Count_1, rtlcs30, rtlcs31, rtlcs33, not_Shorten_Plus, rtlcs35, 
      not_Shorten_Minus, rtlcs37, rtlcs38, rtlcs39, rtlcs40, not_Rx_energy_5, 
      not_Rx_energy_4, not_Rx_energy_3, not_Rx_energy_2, not_Rx_energy_1, 
      not_Rx_energy_0, not_rtlcn700, not_Count_6, not_Count_5, not_Count_4, 
      not_Count_3, not_Count_2, not_Count_1us_4, not_Count_1us_2, 
      not_Count_1us_1, not_Micro_4, not_Micro_3, not_Micro_2, not_Micro_1, 
      not_RxNSital, not_Micro_0, not_calib_6, not_Count23us_3, 
      not_Count23us_2, not_Count23us_1, not_Count_1us_3, not_Count_0, 
      not_Count_1us_0, not_rtlcn4033, rtlcn4016, rtlcn4033: std_logic ;
   
   signal Count_29n13s1f1: std_logic_vector (4 DOWNTO 0) ;
   
   signal rtlc17_25_or_1277_nx0, rtlc23n426, rtlc23_258_or_1280_nx0, 
      rtlc23_274_or_1281_nx0, rtlc26_204_or_1284_nx0, rtlc26_631_or_1285_nx0, 
      rtlc26_649_or_1287_nx0, rtlc29_209_or_1291_nx0, rtlc_283_or_1296_nx0, 
      rtlc_1039_and_1310_nx0, rtlc_1043_and_1311_nx0, rtlc_1073_and_1314_nx0, 
      rtlc_1089_or_1318_nx0, rtlc_1095_or_1319_nx0, rtlc_1283_and_1320_nx0, 
      rtlc26n668, rtlc_1298_and_1322_nx0, rtlc_1432_and_1331_nx0, 
      rtlc_1435_and_1332_nx0, rtlc_1442_and_1333_nx0: std_logic ;
   
   signal DANGLING : std_logic_vector (15 downto 0 );

begin
   TxSense <= TxSense_EXMPLR3662 ;
   PWR <= '1' ;
   GND <= '0' ;
   Rx <= RxSital ;
   RxN <= RxNSital ;
   not_Rx_On_17n1s2 <= NOT Rx_On_17n1s2 ;
   not_rtlc17_X_0_n125 <= NOT rtlc17_X_0_n125 ;
   not_Rx_On <= NOT Rx_On ;
   not_rtlc23n503 <= NOT rtlc23n503 ;
   not_rtlc23n272 <= NOT rtlc23n272 ;
   rtlc23n461 <= not_rtlc23n272 AND snubb(0) ;
   rtlc23n457 <= not_rtlc23n227 AND snubb(0) ;
   not_rtlc23_X_0_n462 <= NOT rtlc23_X_0_n462 ;
   rtlc23n413 <= not_rtlc23n503 AND snubb(0) ;
   rtlc23n414 <= not_CE OR rtlc23n413 ;
   not_rtlc23n414 <= NOT rtlc23n414 ;
   not_snubb_0 <= NOT snubb(0) ;
   rtlc23n238 <= not_rtlc23n620 AND rtlc23n636 ;
   rtlc23n227 <= rtlc23n608 AND rtlc23n172 ;
   rtlc23n167 <= not_Regular AND TxSense_EXMPLR3662 ;
   rtlc23n173 <= rtlc23n167 AND rtlc23n172 ;
   not_Count23us_4 <= NOT Count23us(4) ;
   rtlc23n608 <= not_rtlcn136 OR not_Count23us_4 ;
   rtlc23n620 <= Count_1us(4) AND Count_1us(3) ;
   not_rtlc23n620 <= NOT rtlc23n620 ;
   rtlc23n635 <= rtlc23n634 AND Count_1us(3) ;
   rtlc23n636 <= rtlc23n635 OR Count_1us(4) ;
   Num_Of_Fixes_abs5_26i1 : abs_5s_5s port map ( a(4)=>Cal(4), a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), d(4)=>DANGLING(0), d(3)=>
      Num_Of_Fixes_26n1s1(3), d(2)=>Num_Of_Fixes_26n1s1(2), d(1)=>
      Num_Of_Fixes_26n1s1(1), d(0)=>Num_Of_Fixes_26n1s1(0));
   rtlc26n623 <= calib(0) OR calib(6) ;
   rtlc26n626 <= calib(2) OR calib(7) ;
   rtlc26n455 <= rtlcs9 OR rtlcs8 ;
   rtlc26n911 <= Sum(1) AND Sum(2) ;
   rtlc26n912 <= Sum(3) OR rtlc26n911 ;
   rtlc26n913 <= Sum(4) AND rtlc26n912 ;
   rtlc26n914 <= rtlc26n913 OR Sum(5) ;
   not_Sum_5 <= NOT Sum(5) ;
   rtlc26n916 <= rtlc26n914 AND not_Sum_5 ;
   not_Sum_4 <= NOT Sum(4) ;
   not_Sum_3 <= NOT Sum(3) ;
   rtlc26n930 <= Sum(1) AND Sum(0) ;
   rtlc26n933 <= not_Sum_3 OR not_rtlcn137 ;
   rtlc26n934 <= not_Sum_4 AND rtlc26n933 ;
   rtlc26n935 <= rtlc26n934 OR not_Sum_5 ;
   rtlc26n936 <= rtlc26n935 AND Sum(5) ;
   rtlc26n950 <= rtlc26n949 AND rtlc26n345(4) ;
   not_rtlc26n345_5 <= NOT rtlc26n345(5) ;
   rtlc26n952 <= rtlc26n950 OR not_rtlc26n345_5 ;
   rtlc26_638_and_1286 : and_4u_4u port map ( a(3)=>rtlc26n373(3), a(2)=>
      rtlc26n373(2), a(1)=>rtlc26n373(1), a(0)=>rtlc26n373(0), d=>rtlc26n971
   );
   rtlc26n974 <= not_rtlcn138 OR rtlc26n373(5) ;
   rtlc26n373(4) <= rtlcn4016 XOR Cal(4) ;
   not_rtlcn4016 <= NOT rtlcn4016 ;
   rtlc26n373(5) <= not_rtlcn4016 AND Cal(4) ;
   rtlc26n345(5) <= not_rtlcn4033 OR Cal(4) ;
   rtlc26_680_or_1288 : or_5u_5u port map ( a(4)=>Cal(0), a(3)=>Cal(1), a(2)
      =>Cal(2), a(1)=>Cal(3), a(0)=>Cal(4), d=>rtlc26n1050);
   not_Cal_4 <= NOT Cal(4) ;
   Reduce_Minus_On_26n1s1 <= rtlc26n1050 AND not_Cal_4 ;
   rtlc29_312_or_1292 : or_6u_6u port map ( a(5)=>AmnonHofman(1), a(4)=>
      AmnonHofman(3), a(3)=>AmnonHofman(5), a(2)=>AmnonHofman(6), a(1)=>
      AmnonHofman(8), a(0)=>AmnonHofman(9), d=>rtlc29n1013);
   rtlc29n698 <= Shorten_Minus AND not_TxN ;
   rtlc29n673 <= Shorten_Plus AND not_Tx ;
   rtlc29_858_or_1293 : or_5u_5u port map ( a(4)=>Count(0), a(3)=>Count(1), 
      a(2)=>Count(2), a(1)=>Count(3), a(0)=>Count(4), d=>rtlc29n1263);
   rtlc29n1264 <= rtlc29n1263 AND Count(5) ;
   rtlc29n1265 <= rtlc29n1264 OR Count(6) ;
   rtlc29_864_and_1294 : and_4u_4u port map ( a(3)=>Half_us(3), a(2)=>
      Half_us(2), a(1)=>Half_us(1), a(0)=>Half_us(0), d=>rtlc29n1298);
   Count_inc7_29i1 : inc_7u_7u_0 port map ( cin=>PWR, a(6)=>Count(6), a(5)=>
      Count(5), a(4)=>Count_29n13s1f1(4), a(3)=>Count_29n13s1f1(3), a(2)=>
      Count_29n13s1f1(2), a(1)=>Count_29n13s1f1(1), a(0)=>Count_29n13s1f1(0), 
      d(6)=>Count_29n13s1_6, d(5)=>Count_29n13s1_5, d(4)=>Half_us_29n9s1(4), 
      d(3)=>Half_us_29n9s1(3), d(2)=>Half_us_29n9s1(2), d(1)=>
      Half_us_29n9s1(1), d(0)=>Half_us_29n9s1(0), cout=>DANGLING(1));
   rtlc29n1349 <= AmnonHofman(2) OR AmnonHofman(4) ;
   not_rtlcn136 <= NOT rtlcn136 ;
   not_rtlcn137 <= NOT rtlcn137 ;
   not_rtlcn138 <= NOT rtlcn138 ;
   rtlcn134 <= Half_us(4) OR rtlc29n1298 ;
   rtlcn136 <= rtlc23n604 OR Count23us(0) ;
   rtlcn137 <= Sum(2) OR rtlc26n930 ;
   rtlcn138 <= rtlc26n373(4) OR rtlc26n971 ;
   AmnonHofman_fsm_select_29i2 : select_3_3 port map ( a(2)=>not_rtlcn835, 
      a(1)=>AmnonHofman(3), a(0)=>rtlcn330, b(2)=>GND, b(1)=>
      AmnonHofman_fsm_29n8ss1_4, b(0)=>PWR, d=>AmnonHofman_fsm_29n20ss1_4);
   AmnonHofman_fsm_select_29i3 : select_3_3 port map ( a(2)=>not_rtlcn836, 
      a(1)=>AmnonHofman(1), a(0)=>rtlcn343, b(2)=>GND, b(1)=>
      AmnonHofman_fsm_29n4ss1_2, b(0)=>PWR, d=>AmnonHofman_fsm_29n20ss1_2);
   TxSense_select_29i4 : select_3_3 port map ( a(2)=>not_rtlcn837, a(1)=>
      AmnonHofman(7), a(0)=>rtlcn464, b(2)=>PWR, b(1)=>Tx_Inhibit, b(0)=>GND, 
      d=>TxSense_29n20ss1);
   Cal_select_26i7Bus12_4 : select_3_3 port map ( a(2)=>calib(4), a(1)=>
      rtlcn478, a(0)=>not_rtlcn838, b(2)=>Cal_26n7ss1_4, b(1)=>GND, b(0)=>
      rtlc26n373(4), d=>Cal_26n14ss1(4));
   Cal_select_26i7Bus12_3 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(3), b(1)=>GND, b(0)=>
      rtlc26n345(3), d=>Cal_26n14ss1(3));
   Cal_select_26i7Bus12_2 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(2), b(1)=>GND, b(0)=>
      rtlc26n345(2), d=>Cal_26n14ss1(2));
   Cal_select_26i7Bus12_1 : select_3_3 port map ( a(2)=>calib(5), a(1)=>
      rtlcn481, a(0)=>not_rtlcn839, b(2)=>Cal_26n9ss1(1), b(1)=>GND, b(0)=>
      rtlc26n345(1), d=>Cal_26n14ss1(1));
   Cal_select_26i8 : select_4_4 port map ( a(3)=>calib(6), a(2)=>rtlcn552, 
      a(1)=>rtlcn549, a(0)=>rtlcn551, b(3)=>GND, b(2)=>PWR, b(1)=>
      rtlc26n345(0), b(0)=>rtlc26n373(0), d=>Cal_26n14ss1(0));
   TxNSital_select_29i5 : select_3_3 port map ( a(2)=>not_rtlcn840, a(1)=>
      rtlc29n929, a(0)=>rtlcn575, b(2)=>GND, b(1)=>TxN, b(0)=>Rx_ok, d=>
      TxNSital_29n20ss1);
   TxSital_select_29i6 : select_3_3 port map ( a(2)=>not_rtlcn841, a(1)=>
      rtlc29n929, a(0)=>rtlcn578, b(2)=>GND, b(1)=>Tx, b(0)=>Rx_ok, d=>
      TxSital_29n20ss1);
   not_Tx <= NOT Tx ;
   not_TxN <= NOT TxN ;
   not_Regular <= NOT Regular ;
   not_rtlc23n227 <= NOT rtlc23n227 ;
   rtlc_876_or_1307 : or_5u_5u port map ( a(4)=>AmnonHofman(0), a(3)=>
      AmnonHofman(2), a(2)=>AmnonHofman(4), a(1)=>AmnonHofman(7), a(0)=>
      AmnonHofman(10), d=>rtlcn700);
   rtlcn312 <= calib(4) OR calib(5) ;
   rtlcn715 <= AmnonHofman(4) AND TxN ;
   rtlcn716 <= rtlcs20 AND AmnonHofman(9) ;
   rtlcn330 <= rtlcn715 OR rtlcn716 ;
   rtlcn719 <= AmnonHofman(2) AND Tx ;
   rtlcn720 <= rtlcs27 AND AmnonHofman(8) ;
   rtlcn343 <= rtlcn719 OR rtlcn720 ;
   rtlcn724 <= not_Regular AND AmnonHofman(0) ;
   rtlc_964_or_1308 : or_5u_5u port map ( a(4)=>AmnonHofman(8), a(3)=>
      AmnonHofman(9), a(2)=>AmnonHofman(10), a(1)=>AmnonHofman(11), a(0)=>
      rtlcn724, d=>rtlcn464);
   not_rtlc26n974 <= NOT rtlc26n974 ;
   rtlcn728 <= calib(5) AND not_rtlc26n974 ;
   rtlcn478 <= calib(6) OR rtlcn728 ;
   not_rtlc26n952 <= NOT rtlc26n952 ;
   rtlcn732 <= calib(4) AND not_rtlc26n952 ;
   rtlcn481 <= calib(6) OR rtlcn732 ;
   rtlcn552 <= rtlcn728 OR rtlcn732 ;
   rtlcn549 <= rtlc26n952 AND calib(4) ;
   rtlcn551 <= rtlc26n974 AND calib(5) ;
   not_rtlc29n698 <= NOT rtlc29n698 ;
   rtlcn575 <= AmnonHofman(4) AND not_rtlc29n698 ;
   not_rtlc29n673 <= NOT rtlc29n673 ;
   rtlcn578 <= AmnonHofman(2) AND not_rtlc29n673 ;
   not_resetN <= NOT resetN ;
   rtlcn742 <= AmnonHofman(4) AND rtlcs11 ;
   not_rtlcs31 <= NOT rtlcs31 ;
   rtlcn744 <= AmnonHofman(6) AND not_rtlcs31 ;
   rtlcn323 <= rtlcn742 OR rtlcn744 ;
   rtlcn745 <= AmnonHofman(2) AND rtlcs17 ;
   not_rtlc29n859 <= NOT rtlc29n859 ;
   rtlcn747 <= AmnonHofman(3) AND not_rtlc29n859 ;
   rtlcn336 <= rtlcn745 OR rtlcn747 ;
   not_rtlc29n845 <= NOT rtlc29n845 ;
   rtlcn749 <= AmnonHofman(1) AND not_rtlc29n845 ;
   rtlcn750 <= AmnonHofman(4) AND rtlcs12 ;
   rtlcn349 <= rtlcn749 OR rtlcn750 ;
   rtlcn751 <= AmnonHofman(7) AND Regular ;
   rtlcn706 <= AmnonHofman(10) OR rtlcn751 ;
   rtlcn709 <= AmnonHofman(6) OR AmnonHofman(5) ;
   rtlcn707 <= TxN OR Regular ;
   rtlcn708 <= Tx OR rtlcn707 ;
   rtlcn752 <= TxN AND AmnonHofman(9) ;
   rtlcn753 <= Tx AND AmnonHofman(8) ;
   not_rtlcs18 <= NOT rtlcs18 ;
   rtlcn755 <= AmnonHofman(1) AND not_rtlcs18 ;
   not_rtlcs13 <= NOT rtlcs13 ;
   rtlcn757 <= AmnonHofman(3) AND not_rtlcs13 ;
   rtlcn758 <= not_rtlcs31 AND rtlcn709 ;
   rtlcn759 <= AmnonHofman(0) AND rtlcn708 ;
   rtlc_1020_or_1309 : or_10u_10u port map ( a(9)=>AmnonHofman(2), a(8)=>
      AmnonHofman(4), a(7)=>AmnonHofman(11), a(6)=>rtlcn706, a(5)=>rtlcn752, 
      a(4)=>rtlcn753, a(3)=>rtlcn755, a(2)=>rtlcn757, a(1)=>rtlcn758, a(0)=>
      rtlcn759, d=>rtlcn704);
   not_rtlcn704 <= NOT rtlcn704 ;
   not_Tx_Inhibit <= NOT Tx_Inhibit ;
   rtlcn385 <= not_Tx_Inhibit AND rtlcn706 ;
   rtlcn761 <= AmnonHofman(7) AND Tx_Inhibit ;
   rtlcn710 <= AmnonHofman(0) OR rtlcn761 ;
   rtlcn762 <= AmnonHofman(11) AND rtlc29n1265 ;
   rtlcn763 <= Regular AND rtlcn710 ;
   rtlcn398 <= rtlcn762 OR rtlcn763 ;
   rtlcn764 <= AmnonHofman(10) AND Tx_Inhibit ;
   not_rtlc29n1265 <= NOT rtlc29n1265 ;
   rtlcn766 <= AmnonHofman(11) AND not_rtlc29n1265 ;
   rtlcn405 <= rtlcn764 OR rtlcn766 ;
   rtlcn767 <= AmnonHofman(5) AND not_rtlcs31 ;
   rtlcn768 <= AmnonHofman(2) AND rtlcs16 ;
   rtlcn412 <= rtlcn767 OR rtlcn768 ;
   not_rtlc29n870 <= NOT rtlc29n870 ;
   rtlcn770 <= AmnonHofman(8) AND not_rtlc29n870 ;
   not_rtlcn707 <= NOT rtlcn707 ;
   rtlcn427 <= rtlcn770 OR rtlcn772 ;
   not_rtlc29n876 <= NOT rtlc29n876 ;
   rtlcn774 <= AmnonHofman(9) AND not_rtlc29n876 ;
   rtlcn438 <= rtlcn774 OR rtlcn775 ;
   rtlc_1045_and_1312 : and_4u_4u port map ( a(3)=>rtlc23n227, a(2)=>
      rtlc23n238, a(1)=>Reduce_Plus_On, a(0)=>snubb(0), d=>rtlcn450);
   rtlcn705 <= rtlc23n173 OR rtlcn776 ;
   not_rtlc23n302 <= NOT rtlc23n302 ;
   rtlcn779 <= TxSense_EXMPLR3662 AND not_rtlc23n302 ;
   rtlcn711 <= not_snubb_0 OR rtlcn779 ;
   rtlcn475 <= rtlcn705 AND rtlcn711 ;
   rtlcn485 <= calib(3) AND rtlc26n936 ;
   rtlcn489 <= calib(7) AND rtlcs7 ;
   not_rtlcs7 <= NOT rtlcs7 ;
   rtlcn781 <= calib(7) AND not_rtlcs7 ;
   rtlcn782 <= rtlcs10 AND calib(2) ;
   rtlcn495 <= rtlcn781 OR rtlcn782 ;
   not_TxSense <= NOT TxSense_EXMPLR3662 ;
   rtlcn784 <= calib(1) AND not_TxSense ;
   not_rtlcs10 <= NOT rtlcs10 ;
   rtlcn786 <= not_rtlcs10 AND calib(2) ;
   rtlcn502 <= rtlcn784 OR rtlcn786 ;
   rtlcn787 <= not_Regular AND calib(0) ;
   rtlcn712 <= calib(1) OR rtlcn787 ;
   rtlcn513 <= TxSense_EXMPLR3662 AND rtlcn712 ;
   rtlcn788 <= not_TxSense AND calib(0) ;
   rtlcn713 <= calib(6) OR rtlcn788 ;
   rtlcn789 <= not_Regular AND rtlcn713 ;
   not_rtlc26n936 <= NOT rtlc26n936 ;
   not_rtlc26n916 <= NOT rtlc26n916 ;
   rtlcn530 <= calib(3) AND rtlc26n916 ;
   rtlcn539 <= Regular AND rtlc26n623 ;
   not_Reduce_Plus_On <= NOT Reduce_Plus_On ;
   rtlc_1079_and_1315 : and_5u_5u port map ( a(4)=>rtlc23n227, a(3)=>
      rtlc23n238, a(2)=>not_Reduce_Plus_On, a(1)=>snubb(0), a(0)=>
      Reduce_Minus_On, d=>rtlcn567);
   not_rtlcn134 <= NOT rtlcn134 ;
   rtlc_1082_or_1316 : or_4u_4u port map ( a(3)=>calib(4), a(2)=>calib(5), 
      a(1)=>rtlcn789, a(0)=>rtlcn792, d=>rtlcn527);
   rtlc29n870 <= rtlcs22 OR not_Tx ;
   rtlc29n876 <= rtlcs22 OR not_TxN ;
   not_calib_7 <= NOT calib(7) ;
   not_RxSital <= NOT RxSital ;
   not_rtlcn835 <= NOT rtlcn835 ;
   not_rtlcn836 <= NOT rtlcn836 ;
   not_rtlcn837 <= NOT rtlcn837 ;
   not_rtlcn838 <= NOT rtlcn838 ;
   not_rtlcn839 <= NOT rtlcn839 ;
   not_rtlcn840 <= NOT rtlcn840 ;
   not_rtlcn841 <= NOT rtlcn841 ;
   Count_29n13s1f1(4) <= Half_us(4) when rtlc29n1349 = '1' else Count(4) ;
   Count_29n13s1f1(3) <= Half_us(3) when rtlc29n1349 = '1' else Count(3) ;
   Count_29n13s1f1(2) <= Half_us(2) when rtlc29n1349 = '1' else Count(2) ;
   Count_29n13s1f1(1) <= Half_us(1) when rtlc29n1349 = '1' else Count(1) ;
   Count_29n13s1f1(0) <= Half_us(0) when rtlc29n1349 = '1' else Count(0) ;
   rtlcn842 <= rtlc26n455 OR not_calib_7 ;
   not_CE <= NOT CE ;
   rtlc26n677 <= CE AND rtlc26n699 ;
   not_rtlcn312 <= NOT rtlcn312 ;
   rtlcn843 <= rtlc26n987 OR not_rtlcn312 ;
   rtlc26n663 <= CE AND rtlc26n623 ;
   not_rtlc29n1349 <= NOT rtlc29n1349 ;
   rtlcn844 <= not_rtlcn134 OR not_rtlc29n1349 ;
   not_rtlc29n1013 <= NOT rtlc29n1013 ;
   rtlcs13 <= not_TxN AND rtlcs15 ;
   rtlcs18 <= not_Tx AND rtlcs15 ;
   rtlcs20 <= TxN AND rtlcs22 ;
   rtlcs23 <= rtlcs24 AND rtlcs25 ;
   rtlcs27 <= Tx AND rtlcs22 ;
   rtlcs40 <= rtlcs26 AND not_Count_1 ;
   rtlcs22 <= rtlcs40 AND rtlcs30 ;
   rtlcs33 <= not_Shorten_Plus AND rtlcs15 ;
   rtlcs35 <= not_Shorten_Minus AND rtlcs15 ;
   rtlcs15 <= rtlcs37 AND rtlcs30 ;
   rtlcs38 <= rtlcs39 AND rtlcs25 ;
   not_Rx_energy_5 <= NOT Rx_energy(5) ;
   not_Rx_energy_4 <= NOT Rx_energy(4) ;
   not_Rx_energy_3 <= NOT Rx_energy(3) ;
   not_Rx_energy_2 <= NOT Rx_energy(2) ;
   not_Rx_energy_1 <= NOT Rx_energy(1) ;
   not_Rx_energy_0 <= NOT Rx_energy(0) ;
   not_rtlcn700 <= NOT rtlcn700 ;
   Count_29n20ss1(5) <= Count_29n13s1_5 AND not_rtlcn700 ;
   Count_29n20ss1(4) <= Half_us_29n9s1(4) AND not_rtlcn700 ;
   Count_29n20ss1(3) <= Half_us_29n9s1(3) AND not_rtlcn700 ;
   not_Count_6 <= NOT Count(6) ;
   not_Count_5 <= NOT Count(5) ;
   not_Count_4 <= NOT Count(4) ;
   not_Count_3 <= NOT Count(3) ;
   rtlc_1319_and_1325 : and_4u_4u port map ( a(3)=>not_Count_6, a(2)=>
      not_Count_5, a(1)=>not_Count_4, a(0)=>not_Count_3, d=>rtlcs26);
   Count_29n20ss1(1) <= Half_us_29n9s1(1) AND not_rtlcn700 ;
   not_Count_1 <= NOT Count(1) ;
   Count_29n20ss1(2) <= Half_us_29n9s1(2) AND not_rtlcn700 ;
   Count_29n20ss1(0) <= Half_us_29n9s1(0) AND not_rtlcn700 ;
   not_Count_2 <= NOT Count(2) ;
   rtlcs30 <= not_Count_2 AND Count(0) ;
   rtlcs37 <= rtlcs26 AND Count(1) ;
   rtlcn837 <= AmnonHofman(7) OR rtlcn464 ;
   not_Count_1us_4 <= NOT Count_1us(4) ;
   not_Count_1us_2 <= NOT Count_1us(2) ;
   not_Count_1us_1 <= NOT Count_1us(1) ;
   Cal_26n9ss1(2) <= rtlc26n373(2) OR not_rtlc26n974 ;
   not_Micro_4 <= NOT Micro(4) ;
   not_Micro_3 <= NOT Micro(3) ;
   not_Micro_2 <= NOT Micro(2) ;
   not_Micro_1 <= NOT Micro(1) ;
   rtlc_1351_and_1327 : and_5u_5u port map ( a(4)=>not_Micro_4, a(3)=>
      not_Micro_3, a(2)=>not_Micro_2, a(1)=>not_Micro_1, a(0)=>Micro(0), d=>
      rtlcs10);
   not_RxNSital <= NOT RxNSital ;
   rtlcs9 <= not_RxNSital AND RxSital ;
   rtlcs8 <= RxNSital AND not_RxSital ;
   not_Micro_0 <= NOT Micro(0) ;
   rtlc_1376_and_1328 : and_5u_5u port map ( a(4)=>Micro(4), a(3)=>Micro(3), 
      a(2)=>Micro(2), a(1)=>Micro(1), a(0)=>not_Micro_0, d=>rtlcs7);
   rtlcn839 <= calib(5) OR rtlcn481 ;
   Cal_26n9ss1(1) <= rtlc26n373(1) OR not_rtlc26n974 ;
   not_calib_6 <= NOT calib(6) ;
   Delta_26n14ss1(2) <= Delta(3) AND not_calib_6 ;
   Delta_26n14ss1(1) <= Delta(2) AND not_calib_6 ;
   Delta_26n14ss1(0) <= Delta(1) AND not_calib_6 ;
   Cal_26n9ss1(3) <= rtlc26n373(3) OR not_rtlc26n974 ;
   Cal_26n7ss1_4 <= rtlc26n345(4) OR not_rtlc26n952 ;
   rtlcn838 <= rtlcn478 OR calib(4) ;
   not_Count23us_3 <= NOT Count23us(3) ;
   not_Count23us_2 <= NOT Count23us(2) ;
   not_Count23us_1 <= NOT Count23us(1) ;
   not_Count_1us_3 <= NOT Count_1us(3) ;
   not_Shorten_Plus <= NOT Shorten_Plus ;
   not_Count_0 <= NOT Count(0) ;
   rtlcs17 <= not_Tx AND not_Tx_Inhibit ;
   not_Shorten_Minus <= NOT Shorten_Minus ;
   rtlcn835 <= rtlcn330 OR AmnonHofman(3) ;
   rtlcs12 <= not_TxN AND not_Tx_Inhibit ;
   rtlcn836 <= rtlcn343 OR AmnonHofman(1) ;
   rtlcs11 <= not_TxN AND Tx_Inhibit ;
   rtlcs16 <= not_Tx AND Tx_Inhibit ;
   Count_29n20ss1(6) <= Count_29n13s1_6 AND not_rtlcn700 ;
   Half_us_29n20ss1(3) <= Half_us_29n9s1(3) AND rtlc29n1349 ;
   Half_us_29n20ss1(2) <= Half_us_29n9s1(2) AND rtlc29n1349 ;
   Half_us_29n20ss1(1) <= Half_us_29n9s1(1) AND rtlc29n1349 ;
   Half_us_29n20ss1(0) <= Half_us_29n9s1(0) AND rtlc29n1349 ;
   Half_us_29n20ss1(4) <= Half_us_29n9s1(4) AND rtlc29n1349 ;
   TxN_SN_29n20ss1 <= Rx_ok AND AmnonHofman(6) ;
   Tx_SN_29n20ss1 <= Rx_ok AND AmnonHofman(5) ;
   rtlcn840 <= rtlc29n929 OR rtlcn575 ;
   rtlcn841 <= rtlc29n929 OR rtlcn578 ;
   rtlc_1797_or_1335 : or_4u_4u port map ( a(3)=>Fixed(0), a(2)=>Fixed(1), 
      a(1)=>Fixed(2), a(0)=>Fixed(3), d=>rtlc23n172);
   rtlcn776 <= snubb(1) OR snubb(0) ;
   modgen_counter_Rx_energy : counter_updn_aclear_clock_clk_en_0_6
       port map ( clock=>clock, q(5)=>Rx_energy(5), q(4)=>Rx_energy(4), q(3)
      =>Rx_energy(3), q(2)=>Rx_energy(2), q(1)=>Rx_energy(1), q(0)=>
      Rx_energy(0), clk_en=>not_rtlc17_X_0_n125, aclear=>not_resetN, sload=>
      GND, data(5)=>DANGLING(2), data(4)=>DANGLING(3), data(3)=>DANGLING(4), 
      data(2)=>DANGLING(5), data(1)=>DANGLING(6), data(0)=>DANGLING(7), aset
      =>GND, sclear=>GND, updn=>Rx_On, cnt_en=>PWR);
   modgen_counter_Count_1us : counter_dn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Count_1us(4), q(3)=>Count_1us(3), q(2)
      =>Count_1us(2), q(1)=>Count_1us(1), q(0)=>Count_1us(0), clk_en=>CE, 
      aclear=>not_resetN, sload=>rtlc23_X_0_n387, data(4)=>PWR, data(3)=>PWR, 
      data(2)=>PWR, data(1)=>PWR, data(0)=>PWR, aset=>GND, sclear=>GND, updn
      =>GND, cnt_en=>PWR);
   modgen_counter_Count23us : counter_dn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Count23us(4), q(3)=>Count23us(3), q(2)
      =>Count23us(2), q(1)=>Count23us(1), q(0)=>Count23us(0), clk_en=>
      not_rtlc23n414, aclear=>not_resetN, sload=>rtlc23n426, data(4)=>PWR, 
      data(3)=>GND, data(2)=>PWR, data(1)=>GND, data(0)=>GND, aset=>GND, 
      sclear=>GND, updn=>GND, cnt_en=>PWR);
   modgen_counter_Fixed : counter_dn_sload_aclear_clock_clk_en_0_4
       port map ( clock=>clock, q(3)=>Fixed(3), q(2)=>Fixed(2), q(1)=>
      Fixed(1), q(0)=>Fixed(0), clk_en=>not_rtlc23_X_0_n462, aclear=>
      not_resetN, sload=>rtlc23n426, data(3)=>Num_Of_Fixes(3), data(2)=>
      Num_Of_Fixes(2), data(1)=>Num_Of_Fixes(1), data(0)=>Num_Of_Fixes(0), 
      aset=>GND, sclear=>GND, updn=>GND, cnt_en=>PWR);
   not_Count_1us_0 <= NOT Count_1us(0) ;
   rtlc_1920_and_1336 : and_5u_5u port map ( a(4)=>not_Count_1us_4, a(3)=>
      not_Count_1us_3, a(2)=>not_Count_1us_2, a(1)=>not_Count_1us_1, a(0)=>
      not_Count_1us_0, d=>rtlc23n503);
   not_rtlcn4033 <= NOT rtlcn4033 ;
   rtlc_2505_add_1339 : add_4u_4u_4u_0_0 port map ( cin=>GND, a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), b(3)=>Delta(3), b(2)=>
      Delta(2), b(1)=>Delta(1), b(0)=>Delta(0), d(3)=>rtlc26n373(3), d(2)=>
      rtlc26n373(2), d(1)=>rtlc26n373(1), d(0)=>rtlc26n373(0), cout=>
      rtlcn4016);
   rtlc_2514_sub_1340 : sub_4u_4u_4u_0 port map ( cin=>PWR, a(3)=>Cal(3), 
      a(2)=>Cal(2), a(1)=>Cal(1), a(0)=>Cal(0), b(3)=>Delta(3), b(2)=>
      Delta(2), b(1)=>Delta(1), b(0)=>Delta(0), d(3)=>rtlc26n345(3), d(2)=>
      rtlc26n345(2), d(1)=>rtlc26n345(1), d(0)=>rtlc26n345(0), cout=>
      rtlcn4033);
   Rx_On_17n1s2 <= NOT (RxSital XOR RxNSital) ;
   rtlc26n345(4) <= NOT (rtlcn4033 XOR Cal(4)) ;
   DFFPCE (not_Rx_On_17n1s2,GND,not_resetN,CE,clock,Rx_On) ;
   DFFPCE (rtlcn573,not_resetN,GND,CE,clock,Rx_ok) ;
   DFFPCE (rtlcn458,GND,not_resetN,CE,clock,snubb(1)) ;
   DFFPCE (rtlcn475,GND,not_resetN,CE,clock,snubb(0)) ;
   DFFPCE (rtlcn450,GND,not_resetN,CE,clock,Shorten_Plus) ;
   DFFPCE (rtlcn567,GND,not_resetN,CE,clock,Shorten_Minus) ;
   DFFPCE (rtlcn495,GND,not_resetN,CE,clock,calib(7)) ;
   DFFPCE (rtlcn539,not_resetN,GND,CE,clock,calib(6)) ;
   DFFPCE (rtlcn530,GND,not_resetN,CE,clock,calib(5)) ;
   DFFPCE (rtlcn485,GND,not_resetN,CE,clock,calib(4)) ;
   DFFPCE (rtlcn489,GND,not_resetN,CE,clock,calib(3)) ;
   DFFPCE (rtlcn502,GND,not_resetN,CE,clock,calib(2)) ;
   DFFPCE (rtlcn513,GND,not_resetN,CE,clock,calib(1)) ;
   DFFPCE (rtlcn527,GND,not_resetN,CE,clock,calib(0)) ;
   DFFPCE (calib(6),not_resetN,GND,rtlc26n672,clock,Delta(3)) ;
   DFFPCE (Delta_26n14ss1(2),GND,not_resetN,rtlc26n672,clock,Delta(2)) ;
   DFFPCE (Delta_26n14ss1(1),GND,not_resetN,rtlc26n672,clock,Delta(1)) ;
   DFFPCE (Delta_26n14ss1(0),GND,not_resetN,rtlc26n672,clock,Delta(0)) ;
   DFFPCE (Cal_26n14ss1(4),GND,not_resetN,rtlc26n668,clock,Cal(4)) ;
   DFFPCE (Cal_26n14ss1(3),GND,not_resetN,rtlc26n668,clock,Cal(3)) ;
   DFFPCE (Cal_26n14ss1(2),GND,not_resetN,rtlc26n668,clock,Cal(2)) ;
   DFFPCE (Cal_26n14ss1(1),GND,not_resetN,rtlc26n668,clock,Cal(1)) ;
   DFFPCE (Cal_26n14ss1(0),GND,not_resetN,rtlc26n668,clock,Cal(0)) ;
   DFFPCE (Cal(4),GND,not_resetN,rtlc26n663,clock,Reduce_Plus_On) ;
   DFFPCE (Reduce_Minus_On_26n1s1,GND,not_resetN,rtlc26n663,clock,
   Reduce_Minus_On) ;
   DFFPCE (Num_Of_Fixes_26n1s1(3),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(3)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(2),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(2)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(1),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(1)) ;
   DFFPCE (Num_Of_Fixes_26n1s1(0),GND,not_resetN,rtlc26n663,clock,
   Num_Of_Fixes(0)) ;
   DFFPCE (rtlcn405,GND,not_resetN,CE,clock,AmnonHofman(11)) ;
   DFFPCE (rtlcn385,GND,not_resetN,CE,clock,AmnonHofman(10)) ;
   DFFPCE (rtlcn438,GND,not_resetN,CE,clock,AmnonHofman(9)) ;
   DFFPCE (rtlcn427,GND,not_resetN,CE,clock,AmnonHofman(8)) ;
   DFFPCE (rtlcn398,GND,not_resetN,CE,clock,AmnonHofman(7)) ;
   DFFPCE (rtlcn323,GND,not_resetN,CE,clock,AmnonHofman(6)) ;
   DFFPCE (rtlcn412,GND,not_resetN,CE,clock,AmnonHofman(5)) ;
   DFFPCE (AmnonHofman_fsm_29n20ss1_4,GND,not_resetN,CE,clock,AmnonHofman(4)
   ) ;
   DFFPCE (rtlcn336,GND,not_resetN,CE,clock,AmnonHofman(3)) ;
   DFFPCE (AmnonHofman_fsm_29n20ss1_2,GND,not_resetN,CE,clock,AmnonHofman(2)
   ) ;
   DFFPCE (rtlcn349,GND,not_resetN,CE,clock,AmnonHofman(1)) ;
   DFFPCE (not_rtlcn704,not_resetN,GND,CE,clock,AmnonHofman(0)) ;
   DFFPCE (Tx_SN_29n20ss1,GND,not_resetN,CE,clock,Tx_SN) ;
   DFFPCE (TxSital_29n20ss1,GND,not_resetN,CE,clock,Tx_Sital) ;
   DFFPCE (TxSense_29n20ss1,not_resetN,GND,CE,clock,TxSense_EXMPLR3662) ;
   DFFPCE (TxN_SN_29n20ss1,GND,not_resetN,CE,clock,TxN_SN) ;
   DFFPCE (TxNSital_29n20ss1,GND,not_resetN,CE,clock,TxN_Sital) ;
   DFFPCE (Half_us_29n20ss1(4),GND,not_resetN,rtlc29n995,clock,Half_us(4)) ;
   DFFPCE (Half_us_29n20ss1(3),GND,not_resetN,rtlc29n995,clock,Half_us(3)) ;
   DFFPCE (Half_us_29n20ss1(2),GND,not_resetN,rtlc29n995,clock,Half_us(2)) ;
   DFFPCE (Half_us_29n20ss1(1),GND,not_resetN,rtlc29n995,clock,Half_us(1)) ;
   DFFPCE (Half_us_29n20ss1(0),GND,not_resetN,rtlc29n995,clock,Half_us(0)) ;
   DFFPCE (Count_29n20ss1(6),GND,not_resetN,CE,clock,Count(6)) ;
   DFFPCE (Count_29n20ss1(5),GND,not_resetN,CE,clock,Count(5)) ;
   DFFPCE (Count_29n20ss1(4),GND,not_resetN,CE,clock,Count(4)) ;
   DFFPCE (Count_29n20ss1(3),GND,not_resetN,CE,clock,Count(3)) ;
   DFFPCE (Count_29n20ss1(2),GND,not_resetN,CE,clock,Count(2)) ;
   DFFPCE (Count_29n20ss1(1),GND,not_resetN,CE,clock,Count(1)) ;
   DFFPCE (Count_29n20ss1(0),GND,not_resetN,CE,clock,Count(0)) ;
   rtlc17_25_or_1277_nx0 <= not_CE OR rtlc17n121 ;
   rtlc17_X_0_n125 <= rtlc17_25_or_1277_nx0 OR rtlc17n124 ;
   rtlc23n426 <= snubb(1) OR not_snubb_0 ;
   rtlc23_X_0_n387 <= rtlc23n426 OR rtlc23n503 ;
   rtlc23_258_or_1280_nx0 <= Count23us(1) OR Count23us(2) ;
   rtlc23n604 <= rtlc23_258_or_1280_nx0 OR Count23us(3) ;
   rtlc23_274_or_1281_nx0 <= Count_1us(0) OR Count_1us(1) ;
   rtlc23n634 <= rtlc23_274_or_1281_nx0 OR Count_1us(2) ;
   rtlc26n694 <= rtlcn312 OR calib(6) ;
   rtlc26_204_or_1284_nx0 <= calib(1) OR calib(2) ;
   rtlc26n699 <= rtlc26_204_or_1284_nx0 OR calib(7) ;
   rtlc26_631_or_1285_nx0 <= rtlc26n345(1) OR rtlc26n345(2) ;
   rtlc26n949 <= rtlc26_631_or_1285_nx0 OR rtlc26n345(3) ;
   rtlc26_649_or_1287_nx0 <= Delta(1) OR Delta(2) ;
   rtlc26n987 <= rtlc26_649_or_1287_nx0 OR Delta(3) ;
   rtlc29_209_or_1291_nx0 <= AmnonHofman(7) OR AmnonHofman(10) ;
   rtlc29n929 <= rtlc29_209_or_1291_nx0 OR AmnonHofman(11) ;
   rtlc_283_or_1296_nx0 <= not_CE OR rtlc23n457 ;
   rtlc23_X_0_n462 <= rtlc_283_or_1296_nx0 OR rtlc23n461 ;
   rtlc_1039_and_1310_nx0 <= Tx AND AmnonHofman(0) ;
   rtlcn772 <= rtlc_1039_and_1310_nx0 AND not_rtlcn707 ;
   rtlc_1043_and_1311_nx0 <= TxN AND not_Regular ;
   rtlcn775 <= rtlc_1043_and_1311_nx0 AND AmnonHofman(0) ;
   rtlc_1073_and_1314_nx0 <= calib(3) AND not_rtlc26n936 ;
   rtlcn792 <= rtlc_1073_and_1314_nx0 AND not_rtlc26n916 ;
   rtlc_1089_or_1318_nx0 <= rtlcs18 OR rtlcs33 ;
   rtlc29n845 <= rtlc_1089_or_1318_nx0 OR rtlcs38 ;
   rtlc_1095_or_1319_nx0 <= rtlcs13 OR rtlcs23 ;
   rtlc29n859 <= rtlc_1095_or_1319_nx0 OR rtlcs35 ;
   rtlc_1283_and_1320_nx0 <= CE AND rtlc26n626 ;
   rtlc26n683 <= rtlc_1283_and_1320_nx0 AND rtlcn842 ;
   rtlc26n668 <= CE AND rtlc26n694 ;
   rtlc26n672 <= rtlc26n668 AND rtlcn843 ;
   rtlc_1298_and_1322_nx0 <= CE AND not_rtlc29n1013 ;
   rtlc29n995 <= rtlc_1298_and_1322_nx0 AND rtlcn844 ;
   rtlc_1432_and_1331_nx0 <= Tx AND rtlcs26 ;
   rtlcs39 <= rtlc_1432_and_1331_nx0 AND Shorten_Plus ;
   rtlc_1435_and_1332_nx0 <= not_Count_1 AND Count(2) ;
   rtlcs25 <= rtlc_1435_and_1332_nx0 AND not_Count_0 ;
   rtlc_1442_and_1333_nx0 <= TxN AND rtlcs26 ;
   rtlcs24 <= rtlc_1442_and_1333_nx0 AND Shorten_Minus ;
   modgen_or_0 : or_5u_5u port map ( a(4)=>Rx_energy(3), a(3)=>Rx_energy(4), 
      a(2)=>Rx_energy(5), a(1)=>Rx_energy(2), a(0)=>not_rtlcn134, d=>
      rtlcn573);
   modgen_and_1 : and_3u_3u port map ( a(2)=>snubb(0), a(1)=>
      TxSense_EXMPLR3662, a(0)=>rtlc23n302, d=>rtlcn458);
   modgen_counter_Sum : counter_updn_sclear_aclear_clock_clk_en_0_6
       port map ( clock=>clock, q(5)=>Sum(5), q(4)=>Sum(4), q(3)=>Sum(3), 
      q(2)=>Sum(2), q(1)=>Sum(1), q(0)=>Sum(0), clk_en=>rtlc26n683, aclear=>
      not_resetN, sload=>GND, data(5)=>DANGLING(8), data(4)=>DANGLING(9), 
      data(3)=>DANGLING(10), data(2)=>DANGLING(11), data(1)=>DANGLING(12), 
      data(0)=>DANGLING(13), aset=>GND, sclear=>not_calib_7, updn=>RxSital, 
      cnt_en=>PWR);
   modgen_counter_Micro : counter_updn_sload_aclear_clock_clk_en_0_5
       port map ( clock=>clock, q(4)=>Micro(4), q(3)=>Micro(3), q(2)=>
      Micro(2), q(1)=>Micro(1), q(0)=>Micro(0), clk_en=>rtlc26n677, aclear=>
      not_resetN, sload=>calib(1), data(4)=>PWR, data(3)=>GND, data(2)=>PWR, 
      data(1)=>PWR, data(0)=>PWR, aset=>GND, sclear=>GND, updn=>calib(7), 
      cnt_en=>PWR);
   modgen_rom_ix679 : rom_new_0_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
       port map ( rd_data1(0)=>AmnonHofman_fsm_29n4ss1_2, addr1(8)=>
      Shorten_Plus, addr1(7)=>Count(6), addr1(6)=>Count(5), addr1(5)=>
      Count(4), addr1(4)=>Count(3), addr1(3)=>Count(2), addr1(2)=>Count(1), 
      addr1(1)=>Count(0), addr1(0)=>Tx, rd_clk1=>DANGLING(14), rd_ena1=>PWR, 
      regce1=>PWR, rst1=>GND);
   modgen_rom_ix680 : rom_new_1_Xcvr_Snubber_sital_8_4_4_32_7_OH_Calibrate
       port map ( rd_data1(0)=>AmnonHofman_fsm_29n8ss1_4, addr1(8)=>
      Shorten_Minus, addr1(7)=>Count(6), addr1(6)=>Count(5), addr1(5)=>
      Count(4), addr1(4)=>Count(3), addr1(3)=>Count(2), addr1(2)=>Count(1), 
      addr1(1)=>Count(0), addr1(0)=>TxN, rd_clk1=>DANGLING(15), rd_ena1=>PWR, 
      regce1=>PWR, rst1=>GND);
   modgen_and_2 : and_7u_7u port map ( a(6)=>Rx_energy(5), a(5)=>
      Rx_energy(4), a(4)=>Rx_energy(3), a(3)=>Rx_energy(2), a(2)=>
      Rx_energy(1), a(1)=>Rx_energy(0), a(0)=>Rx_On, d=>rtlc17n121);
   modgen_and_3 : and_7u_7u port map ( a(6)=>not_Rx_energy_5, a(5)=>
      not_Rx_energy_4, a(4)=>not_Rx_energy_3, a(3)=>not_Rx_energy_2, a(2)=>
      not_Rx_energy_1, a(1)=>not_Rx_energy_0, a(0)=>not_Rx_On, d=>rtlc17n124
   );
   modgen_and_4 : and_6u_6u port map ( a(5)=>not_Count_1us_4, a(4)=>
      Count_1us(3), a(3)=>not_Count_1us_2, a(2)=>not_Count_1us_1, a(1)=>
      Count_1us(0), a(0)=>rtlc23n172, d=>rtlc23n272);
   modgen_and_5 : and_10u_10u port map ( a(9)=>not_Count23us_4, a(8)=>
      not_Count23us_3, a(7)=>not_Count23us_2, a(6)=>not_Count23us_1, a(5)=>
      Count23us(0), a(4)=>not_Count_1us_4, a(3)=>not_Count_1us_3, a(2)=>
      not_Count_1us_2, a(1)=>not_Count_1us_1, a(0)=>Count_1us(0), d=>
      rtlc23n302);
   modgen_and_6 : and_5u_5u port map ( a(4)=>not_Count_6, a(3)=>not_Count_5, 
      a(2)=>not_Count_4, a(1)=>Count(3), a(0)=>rtlcs25, d=>rtlcs31);
end OH_Calibrate ;

library IEEE;
 use IEEE.STD_LOGIC_1164.ALL;
 Library MODGEN_SITAL;

entity BRM1553D_ver8_4_Limited_64Mhz is 
   port (
      BC_DISABLE : IN std_logic ;
      CPU_Address : IN std_logic_vector (15 DOWNTO 0) ;
      CPU_CS : IN std_logic ;
      CPU_Data_in : IN std_logic_vector (31 DOWNTO 0) ;
      CPU_RE : IN std_logic_vector (1 DOWNTO 0) ;
      CPU_WE : IN std_logic_vector (1 DOWNTO 0) ;
      Ext_Trigger : IN std_logic ;
      M1760 : IN std_logic ;
      MEM_nREG : IN std_logic ;
      RTAD_SW_EN : IN std_logic ;
      RT_ADR_LAT : IN std_logic ;
      RT_Address_Parity : IN std_logic ;
      RT_Address_wire : IN std_logic_vector (4 DOWNTO 0) ;
      Raw_resetN : IN std_logic ;
      Regular_XCVR : IN std_logic ;
      RxA : IN std_logic ;
      RxAn : IN std_logic ;
      RxB : IN std_logic ;
      RxBn : IN std_logic ;
      Set_SSFLAG : IN std_logic ;
      Strobe_TT : IN std_logic ;
      Tag_CLK : IN std_logic ;
      Tx_InhB : IN std_logic ;
      Tx_inhA : IN std_logic ;
      clock : IN std_logic ;
      CPU_Data_out : OUT std_logic_vector (31 DOWNTO 0) ;
      Cyber_Attack_Bus_A : OUT std_logic ;
      Cyber_Attack_Command : OUT std_logic_vector (15 DOWNTO 0) ;
      Cyber_Attack_TTag : OUT std_logic_vector (15 DOWNTO 0) ;
      Cyber_Attck_Type1 : OUT std_logic ;
      DEBUG_A_command_sync : OUT std_logic ;
      DEBUG_F500Khz : OUT std_logic ;
      DEBUG_RxAs : OUT std_logic ;
      DEBUG_Rx_Ok : OUT std_logic ;
      DEBUG_Rx_Strobe : OUT std_logic ;
      DEBUG_TT_MSB : OUT std_logic ;
      INTn : OUT std_logic ;
      TxA : OUT std_logic ;
      TxAN : OUT std_logic ;
      TxB : OUT std_logic ;
      TxBN : OUT std_logic ;
      Tx_AN_SN : OUT std_logic ;
      Tx_A_SN : OUT std_logic ;
      Tx_BN_SN : OUT std_logic ;
      Tx_B_SN : OUT std_logic ;
      Tx_Inh_B : OUT std_logic ;
      Tx_inh_A : OUT std_logic) ;
end BRM1553D_ver8_4_Limited_64Mhz ;

architecture External_Mem of BRM1553D_ver8_4_Limited_64Mhz is 
   component BRM1553D_ver8_4_RTLC_LONGENT0
      port (
         Aux_in : IN std_logic_vector (15 DOWNTO 0) ;
         BC_DISABLE : IN std_logic ;
         CPU_Address : IN std_logic_vector (15 DOWNTO 0) ;
         CPU_CS : IN std_logic ;
         CPU_Data_in_wide : IN std_logic_vector (31 DOWNTO 0) ;
         CPU_RE_vec : IN std_logic_vector (1 DOWNTO 0) ;
         CPU_Side_MEM_Data_o : IN std_logic_vector (31 DOWNTO 0) ;
         CPU_WE : IN std_logic_vector (1 DOWNTO 0) ;
         Clock_0 : IN std_logic ;
         Clock_1 : IN std_logic ;
         Clock_2 : IN std_logic ;
         Clock_3 : IN std_logic ;
         Constants_readback : IN std_logic_vector (15 DOWNTO 0) ;
         Ext_Trigger : IN std_logic ;
         External_CE_In : IN std_logic ;
         FromK : IN std_logic ;
         Handshake_Error : IN std_logic ;
         M1760 : IN std_logic ;
         MEM_nREG : IN std_logic ;
         Mem_Ack : IN std_logic ;
         Mem_Data_o : IN std_logic_vector (15 DOWNTO 0) ;
         Minus_A : IN std_logic ;
         Minus_B : IN std_logic ;
         Plus_A : IN std_logic ;
         Plus_B : IN std_logic ;
         RTAD : IN std_logic_vector (4 DOWNTO 0) ;
         RTADP : IN std_logic ;
         RTAD_SW_EN : IN std_logic ;
         RT_ADR_LAT : IN std_logic ;
         Raw_resetN : IN std_logic ;
         Set_SSFLAG : IN std_logic ;
         Strobe_TT : IN std_logic ;
         Tag_CLK : IN std_logic ;
         Tx_InhB : IN std_logic ;
         Tx_inhA : IN std_logic ;
         clock : IN std_logic ;
         key_ports_In : IN std_logic_vector (23 DOWNTO 0) ;
         CE_out : OUT std_logic ;
         CPU_Data_out_wide : OUT std_logic_vector (31 DOWNTO 0) ;
         CPU_Side_WE : OUT std_logic_vector (1 DOWNTO 0) ;
         Fault_value : OUT std_logic_vector (15 DOWNTO 0) ;
         INTn : OUT std_logic ;
         IP_Freq_sel : OUT std_logic_vector (1 DOWNTO 0) ;
         Mem_Address : OUT std_logic_vector (15 DOWNTO 0) ;
         Mem_RE : OUT std_logic ;
         Mem_data_in : OUT std_logic_vector (15 DOWNTO 0) ;
         OE_High : OUT std_logic ;
         TT_Load : OUT std_logic ;
         Tok : OUT std_logic ;
         Tx_A : OUT std_logic ;
         Tx_A_N : OUT std_logic ;
         Tx_B : OUT std_logic ;
         Tx_B_N : OUT std_logic ;
         Tx_inh_A : OUT std_logic ;
         Tx_inh_B : OUT std_logic ;
         Update : OUT std_logic ;
         debug_out : OUT std_logic_vector (63 DOWNTO 0) ;
         fault_type : OUT std_logic_vector (3 DOWNTO 0) ;
         mem_WE : OUT std_logic ;
         n16Mhz_12 : OUT std_logic ;
         BC_Message_Active : OUT std_logic ;
         BC_on : OUT std_logic ;
         H15530_record_A_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
         H15530_record_A_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
         
         H15530_record_A_Sync_error : OUT std_logic ;
         H15530_record_A_Manchester_error : OUT std_logic ;
         H15530_record_A_Parity_error : OUT std_logic ;
         H15530_record_A_echo_back_bus : OUT std_logic ;
         H15530_record_A_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         H15530_record_A_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_A_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
         H15530_record_A_RxRDY_plus_12us : OUT std_logic ;
         H15530_record_A_RxRDY_plus_10us : OUT std_logic ;
         H15530_record_A_CS : OUT std_logic ;
         H15530_record_A_Pre_EchoRdy : OUT std_logic ;
         H15530_record_A_Command_Sync : OUT std_logic ;
         H15530_record_A_Pre_RxRdy : OUT std_logic ;
         H15530_record_A_recieving : OUT std_logic ;
         H15530_record_B_Bit_number : OUT std_logic_vector (4 DOWNTO 0) ;
         H15530_record_B_Response_Time : OUT std_logic_vector (7 DOWNTO 0) ;
         
         H15530_record_B_Sync_error : OUT std_logic ;
         H15530_record_B_Manchester_error : OUT std_logic ;
         H15530_record_B_Parity_error : OUT std_logic ;
         H15530_record_B_echo_back_bus : OUT std_logic ;
         H15530_record_B_R_Data : OUT std_logic_vector (15 DOWNTO 0) ;
         H15530_record_B_RAW_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_GAP : OUT std_logic_vector (6 DOWNTO 0) ;
         H15530_record_B_Gap_found : OUT std_logic_vector (2 DOWNTO 0) ;
         H15530_record_B_RxRDY_plus_12us : OUT std_logic ;
         H15530_record_B_RxRDY_plus_10us : OUT std_logic ;
         H15530_record_B_CS : OUT std_logic ;
         H15530_record_B_Pre_EchoRdy : OUT std_logic ;
         H15530_record_B_Command_Sync : OUT std_logic ;
         H15530_record_B_Pre_RxRdy : OUT std_logic ;
         H15530_record_B_recieving : OUT std_logic ;
         key_ports_out : OUT std_logic_vector (23 DOWNTO 0) ;
         one_micro_increment : OUT std_logic ;
         pTDR_INT : OUT std_logic ;
         time_tag : OUT std_logic_vector (15 DOWNTO 0)) ;
   end component ;
   component DPRAM_Interlaced2_16_1_1
      port (
         ADDr_i_A : IN std_logic_vector (15 DOWNTO 0) ;
         ADDr_i_B : IN std_logic_vector (15 DOWNTO 0) ;
         Data_i_A : IN std_logic_vector (15 DOWNTO 0) ;
         Data_i_B : IN std_logic_vector (31 DOWNTO 0) ;
         WE_A : IN std_logic ;
         WE_B_vec : IN std_logic_vector (1 DOWNTO 0) ;
         clock : IN std_logic ;
         Data_o_A : OUT std_logic_vector (15 DOWNTO 0) ;
         Data_o_B : OUT std_logic_vector (31 DOWNTO 0)) ;
   end component ;
   component Xcvr_Snubber_sital_8_4_4_32_7
      port (
         CE : IN std_logic ;
         Regular : IN std_logic ;
         RxNSital : IN std_logic ;
         RxSital : IN std_logic ;
         Tx : IN std_logic ;
         TxN : IN std_logic ;
         Tx_Inhibit : IN std_logic ;
         clock : IN std_logic ;
         resetN : IN std_logic ;
         Rx : OUT std_logic ;
         RxN : OUT std_logic ;
         TxN_SN : OUT std_logic ;
         Tx_SN : OUT std_logic ;
         TxN_Sital : OUT std_logic ;
         TxSense : OUT std_logic ;
         Tx_Sital : OUT std_logic) ;
   end component ;
   component and_4u_4u
      port (
         a : IN std_logic_vector (3 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   component or_11u_11u
      port (
         a : IN std_logic_vector (10 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   procedure DFFPC (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           q <= data and data ;    -- takes care of q<='X' if data='Z'
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPC ;
   procedure DFFPCE (
      constant data   : in std_logic;
      constant preset : in std_logic;
      constant clear  : in std_logic;
      constant enable : in std_logic;
      signal clk      : in std_logic;
      signal q        : out std_logic)
   is begin
       if (preset = '1') then
           q <= '1' ;
       elsif (clear = '1') then
           q <= '0' ;
       elsif (clk'event and clk'last_value = '0' and clk = '1') then
           if (enable = '1') then
               q <= data and data ;    -- takes care of q<='X' if data='Z'
           end if ;
       end if ;
       if ((clear/='1' or preset/='1') and clk/='0' and clk/='1') then
           q <= 'X' ;
       end if ;
   end DFFPCE ;
   component and_3u_3u
      port (
         a : IN std_logic_vector (2 DOWNTO 0) ;
         d : OUT std_logic) ;
   end component ;
   for I2 : Xcvr_Snubber_sital_8_4_4_32_7 use entity work.
   Xcvr_Snubber_sital_8_4_4_32_7(OH_Calibrate_unfold_1);
   for I3 : Xcvr_Snubber_sital_8_4_4_32_7 use entity work.
   Xcvr_Snubber_sital_8_4_4_32_7(OH_Calibrate);
   signal DEBUG_F500Khz_EXMPLR3806, Ack, BC_Message_Active, BC_on, CE_out: 
   std_logic ;
   
   signal Data_o_A: std_logic_vector (15 DOWNTO 0) ;
   
   signal Data_o_B: std_logic_vector (31 DOWNTO 0) ;
   
   signal Mem_Address: std_logic_vector (15 DOWNTO 0) ;
   
   signal Mem_RE: std_logic ;
   
   signal Mem_data_in: std_logic_vector (15 DOWNTO 0) ;
   
   signal Minus_A, Minus_B, Pipe_Delay, Plus_A, Plus_B, Tx_A, Tx_A_N, Tx_B, 
      Tx_B_N, Tx_inh_A1, Tx_inh_B1: std_logic ;
   
   signal WE_B_vec: std_logic_vector (1 DOWNTO 0) ;
   
   signal mem_WE, mem_WE_CE, one_micro_increment, resetN: std_logic ;
   
   signal time_tag: std_logic_vector (15 DOWNTO 0) ;
   
   signal GND, not_resetN, not_DEBUG_F500Khz, DEBUG_Rx_Strobe_4n2s2, 
      DEBUG_Rx_Ok_4n2s2, rtlc4n67, not_rtlc4n67, not_rtlcn0, rtlc8n45, 
      rtlc8n46, rtlc8n90: std_logic ;
   
   signal Cyber_Attack_Command_11n2ss1: std_logic_vector (15 DOWNTO 0) ;
   
   signal rtlc11n83, rtlc11n91, rtlc11n92, rtlc11n94, rtlc11n103, rtlc11n111, 
      rtlc11n112, rtlc11n114, rtlc11n193, rtlcn0, rtlcn12, rtlcn17, 
      not_BC_Message_Active, rtlcn25, not_rtlc8n46: std_logic ;
   
   signal H15530_record_A_R_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal H15530_record_A_CS, H15530_record_A_Command_Sync, 
      H15530_record_A_Pre_RxRdy: std_logic ;
   
   signal H15530_record_B_R_Data: std_logic_vector (15 DOWNTO 0) ;
   
   signal H15530_record_B_CS, H15530_record_B_Command_Sync, 
      H15530_record_B_Pre_RxRdy: std_logic ;
   
   signal DANGLING : std_logic_vector (191 downto 0 );

begin
   DEBUG_F500Khz <= DEBUG_F500Khz_EXMPLR3806 ;
   GND <= '0' ;
   I0 : BRM1553D_ver8_4_RTLC_LONGENT0 port map ( Aux_in(15)=>GND, Aux_in(14)
      =>GND, Aux_in(13)=>GND, Aux_in(12)=>GND, Aux_in(11)=>GND, Aux_in(10)=>
      GND, Aux_in(9)=>GND, Aux_in(8)=>GND, Aux_in(7)=>GND, Aux_in(6)=>GND, 
      Aux_in(5)=>GND, Aux_in(4)=>GND, Aux_in(3)=>GND, Aux_in(2)=>GND, 
      Aux_in(1)=>GND, Aux_in(0)=>GND, BC_DISABLE=>BC_DISABLE, 
      CPU_Address(15)=>GND, CPU_Address(14)=>GND, CPU_Address(13)=>GND, 
      CPU_Address(12)=>GND, CPU_Address(11)=>GND, CPU_Address(10)=>GND, 
      CPU_Address(9)=>GND, CPU_Address(8)=>GND, CPU_Address(7)=>GND, 
      CPU_Address(6)=>GND, CPU_Address(5)=>GND, CPU_Address(4)=>
      CPU_Address(4), CPU_Address(3)=>CPU_Address(3), CPU_Address(2)=>
      CPU_Address(2), CPU_Address(1)=>CPU_Address(1), CPU_Address(0)=>GND, 
      CPU_CS=>CPU_CS, CPU_Data_in_wide(31)=>CPU_Data_in(31), 
      CPU_Data_in_wide(30)=>CPU_Data_in(30), CPU_Data_in_wide(29)=>
      CPU_Data_in(29), CPU_Data_in_wide(28)=>CPU_Data_in(28), 
      CPU_Data_in_wide(27)=>CPU_Data_in(27), CPU_Data_in_wide(26)=>
      CPU_Data_in(26), CPU_Data_in_wide(25)=>CPU_Data_in(25), 
      CPU_Data_in_wide(24)=>CPU_Data_in(24), CPU_Data_in_wide(23)=>
      CPU_Data_in(23), CPU_Data_in_wide(22)=>CPU_Data_in(22), 
      CPU_Data_in_wide(21)=>CPU_Data_in(21), CPU_Data_in_wide(20)=>
      CPU_Data_in(20), CPU_Data_in_wide(19)=>CPU_Data_in(19), 
      CPU_Data_in_wide(18)=>CPU_Data_in(18), CPU_Data_in_wide(17)=>
      CPU_Data_in(17), CPU_Data_in_wide(16)=>CPU_Data_in(16), 
      CPU_Data_in_wide(15)=>CPU_Data_in(15), CPU_Data_in_wide(14)=>
      CPU_Data_in(14), CPU_Data_in_wide(13)=>CPU_Data_in(13), 
      CPU_Data_in_wide(12)=>CPU_Data_in(12), CPU_Data_in_wide(11)=>
      CPU_Data_in(11), CPU_Data_in_wide(10)=>CPU_Data_in(10), 
      CPU_Data_in_wide(9)=>CPU_Data_in(9), CPU_Data_in_wide(8)=>
      CPU_Data_in(8), CPU_Data_in_wide(7)=>CPU_Data_in(7), 
      CPU_Data_in_wide(6)=>CPU_Data_in(6), CPU_Data_in_wide(5)=>
      CPU_Data_in(5), CPU_Data_in_wide(4)=>CPU_Data_in(4), 
      CPU_Data_in_wide(3)=>CPU_Data_in(3), CPU_Data_in_wide(2)=>
      CPU_Data_in(2), CPU_Data_in_wide(1)=>CPU_Data_in(1), 
      CPU_Data_in_wide(0)=>CPU_Data_in(0), CPU_RE_vec(1)=>GND, CPU_RE_vec(0)
      =>CPU_RE(0), CPU_Side_MEM_Data_o(31)=>Data_o_B(31), 
      CPU_Side_MEM_Data_o(30)=>Data_o_B(30), CPU_Side_MEM_Data_o(29)=>
      Data_o_B(29), CPU_Side_MEM_Data_o(28)=>Data_o_B(28), 
      CPU_Side_MEM_Data_o(27)=>Data_o_B(27), CPU_Side_MEM_Data_o(26)=>
      Data_o_B(26), CPU_Side_MEM_Data_o(25)=>Data_o_B(25), 
      CPU_Side_MEM_Data_o(24)=>Data_o_B(24), CPU_Side_MEM_Data_o(23)=>
      Data_o_B(23), CPU_Side_MEM_Data_o(22)=>Data_o_B(22), 
      CPU_Side_MEM_Data_o(21)=>Data_o_B(21), CPU_Side_MEM_Data_o(20)=>
      Data_o_B(20), CPU_Side_MEM_Data_o(19)=>Data_o_B(19), 
      CPU_Side_MEM_Data_o(18)=>Data_o_B(18), CPU_Side_MEM_Data_o(17)=>
      Data_o_B(17), CPU_Side_MEM_Data_o(16)=>Data_o_B(16), 
      CPU_Side_MEM_Data_o(15)=>Data_o_B(15), CPU_Side_MEM_Data_o(14)=>
      Data_o_B(14), CPU_Side_MEM_Data_o(13)=>Data_o_B(13), 
      CPU_Side_MEM_Data_o(12)=>Data_o_B(12), CPU_Side_MEM_Data_o(11)=>
      Data_o_B(11), CPU_Side_MEM_Data_o(10)=>Data_o_B(10), 
      CPU_Side_MEM_Data_o(9)=>Data_o_B(9), CPU_Side_MEM_Data_o(8)=>
      Data_o_B(8), CPU_Side_MEM_Data_o(7)=>Data_o_B(7), 
      CPU_Side_MEM_Data_o(6)=>Data_o_B(6), CPU_Side_MEM_Data_o(5)=>
      Data_o_B(5), CPU_Side_MEM_Data_o(4)=>Data_o_B(4), 
      CPU_Side_MEM_Data_o(3)=>Data_o_B(3), CPU_Side_MEM_Data_o(2)=>
      Data_o_B(2), CPU_Side_MEM_Data_o(1)=>Data_o_B(1), 
      CPU_Side_MEM_Data_o(0)=>Data_o_B(0), CPU_WE(1)=>CPU_WE(1), CPU_WE(0)=>
      CPU_WE(0), Clock_0=>GND, Clock_1=>GND, Clock_2=>GND, Clock_3=>GND, 
      Constants_readback(15)=>GND, Constants_readback(14)=>GND, 
      Constants_readback(13)=>GND, Constants_readback(12)=>GND, 
      Constants_readback(11)=>GND, Constants_readback(10)=>GND, 
      Constants_readback(9)=>GND, Constants_readback(8)=>GND, 
      Constants_readback(7)=>GND, Constants_readback(6)=>GND, 
      Constants_readback(5)=>GND, Constants_readback(4)=>GND, 
      Constants_readback(3)=>GND, Constants_readback(2)=>GND, 
      Constants_readback(1)=>GND, Constants_readback(0)=>GND, Ext_Trigger=>
      Ext_Trigger, External_CE_In=>GND, FromK=>GND, Handshake_Error=>GND, 
      M1760=>M1760, MEM_nREG=>MEM_nREG, Mem_Ack=>Ack, Mem_Data_o(15)=>
      Data_o_A(15), Mem_Data_o(14)=>Data_o_A(14), Mem_Data_o(13)=>
      Data_o_A(13), Mem_Data_o(12)=>Data_o_A(12), Mem_Data_o(11)=>
      Data_o_A(11), Mem_Data_o(10)=>Data_o_A(10), Mem_Data_o(9)=>Data_o_A(9), 
      Mem_Data_o(8)=>Data_o_A(8), Mem_Data_o(7)=>Data_o_A(7), Mem_Data_o(6)
      =>Data_o_A(6), Mem_Data_o(5)=>Data_o_A(5), Mem_Data_o(4)=>Data_o_A(4), 
      Mem_Data_o(3)=>Data_o_A(3), Mem_Data_o(2)=>Data_o_A(2), Mem_Data_o(1)
      =>Data_o_A(1), Mem_Data_o(0)=>Data_o_A(0), Minus_A=>Minus_A, Minus_B=>
      Minus_B, Plus_A=>Plus_A, Plus_B=>Plus_B, RTAD(4)=>RT_Address_wire(4), 
      RTAD(3)=>RT_Address_wire(3), RTAD(2)=>RT_Address_wire(2), RTAD(1)=>
      RT_Address_wire(1), RTAD(0)=>RT_Address_wire(0), RTADP=>
      RT_Address_Parity, RTAD_SW_EN=>RTAD_SW_EN, RT_ADR_LAT=>RT_ADR_LAT, 
      Raw_resetN=>Raw_resetN, Set_SSFLAG=>Set_SSFLAG, Strobe_TT=>Strobe_TT, 
      Tag_CLK=>Tag_CLK, Tx_InhB=>Tx_InhB, Tx_inhA=>Tx_inhA, clock=>clock, 
      key_ports_In(23)=>GND, key_ports_In(22)=>GND, key_ports_In(21)=>GND, 
      key_ports_In(20)=>GND, key_ports_In(19)=>GND, key_ports_In(18)=>GND, 
      key_ports_In(17)=>GND, key_ports_In(16)=>GND, key_ports_In(15)=>GND, 
      key_ports_In(14)=>GND, key_ports_In(13)=>GND, key_ports_In(12)=>GND, 
      key_ports_In(11)=>GND, key_ports_In(10)=>GND, key_ports_In(9)=>GND, 
      key_ports_In(8)=>GND, key_ports_In(7)=>GND, key_ports_In(6)=>GND, 
      key_ports_In(5)=>GND, key_ports_In(4)=>GND, key_ports_In(3)=>GND, 
      key_ports_In(2)=>GND, key_ports_In(1)=>GND, key_ports_In(0)=>GND, 
      CE_out=>CE_out, CPU_Data_out_wide(31)=>CPU_Data_out(31), 
      CPU_Data_out_wide(30)=>CPU_Data_out(30), CPU_Data_out_wide(29)=>
      CPU_Data_out(29), CPU_Data_out_wide(28)=>CPU_Data_out(28), 
      CPU_Data_out_wide(27)=>CPU_Data_out(27), CPU_Data_out_wide(26)=>
      CPU_Data_out(26), CPU_Data_out_wide(25)=>CPU_Data_out(25), 
      CPU_Data_out_wide(24)=>CPU_Data_out(24), CPU_Data_out_wide(23)=>
      CPU_Data_out(23), CPU_Data_out_wide(22)=>CPU_Data_out(22), 
      CPU_Data_out_wide(21)=>CPU_Data_out(21), CPU_Data_out_wide(20)=>
      CPU_Data_out(20), CPU_Data_out_wide(19)=>CPU_Data_out(19), 
      CPU_Data_out_wide(18)=>CPU_Data_out(18), CPU_Data_out_wide(17)=>
      CPU_Data_out(17), CPU_Data_out_wide(16)=>CPU_Data_out(16), 
      CPU_Data_out_wide(15)=>CPU_Data_out(15), CPU_Data_out_wide(14)=>
      CPU_Data_out(14), CPU_Data_out_wide(13)=>CPU_Data_out(13), 
      CPU_Data_out_wide(12)=>CPU_Data_out(12), CPU_Data_out_wide(11)=>
      CPU_Data_out(11), CPU_Data_out_wide(10)=>CPU_Data_out(10), 
      CPU_Data_out_wide(9)=>CPU_Data_out(9), CPU_Data_out_wide(8)=>
      CPU_Data_out(8), CPU_Data_out_wide(7)=>CPU_Data_out(7), 
      CPU_Data_out_wide(6)=>CPU_Data_out(6), CPU_Data_out_wide(5)=>
      CPU_Data_out(5), CPU_Data_out_wide(4)=>CPU_Data_out(4), 
      CPU_Data_out_wide(3)=>CPU_Data_out(3), CPU_Data_out_wide(2)=>
      CPU_Data_out(2), CPU_Data_out_wide(1)=>CPU_Data_out(1), 
      CPU_Data_out_wide(0)=>CPU_Data_out(0), CPU_Side_WE(1)=>WE_B_vec(1), 
      CPU_Side_WE(0)=>WE_B_vec(0), Fault_value(15)=>DANGLING(0), 
      Fault_value(14)=>DANGLING(1), Fault_value(13)=>DANGLING(2), 
      Fault_value(12)=>DANGLING(3), Fault_value(11)=>DANGLING(4), 
      Fault_value(10)=>DANGLING(5), Fault_value(9)=>DANGLING(6), 
      Fault_value(8)=>DANGLING(7), Fault_value(7)=>DANGLING(8), 
      Fault_value(6)=>DANGLING(9), Fault_value(5)=>DANGLING(10), 
      Fault_value(4)=>DANGLING(11), Fault_value(3)=>DANGLING(12), 
      Fault_value(2)=>DANGLING(13), Fault_value(1)=>DANGLING(14), 
      Fault_value(0)=>DANGLING(15), INTn=>INTn, IP_Freq_sel(1)=>DANGLING(16), 
      IP_Freq_sel(0)=>DANGLING(17), Mem_Address(15)=>Mem_Address(15), 
      Mem_Address(14)=>Mem_Address(14), Mem_Address(13)=>Mem_Address(13), 
      Mem_Address(12)=>Mem_Address(12), Mem_Address(11)=>Mem_Address(11), 
      Mem_Address(10)=>Mem_Address(10), Mem_Address(9)=>Mem_Address(9), 
      Mem_Address(8)=>Mem_Address(8), Mem_Address(7)=>Mem_Address(7), 
      Mem_Address(6)=>Mem_Address(6), Mem_Address(5)=>Mem_Address(5), 
      Mem_Address(4)=>Mem_Address(4), Mem_Address(3)=>Mem_Address(3), 
      Mem_Address(2)=>Mem_Address(2), Mem_Address(1)=>Mem_Address(1), 
      Mem_Address(0)=>Mem_Address(0), Mem_RE=>Mem_RE, Mem_data_in(15)=>
      Mem_data_in(15), Mem_data_in(14)=>Mem_data_in(14), Mem_data_in(13)=>
      Mem_data_in(13), Mem_data_in(12)=>Mem_data_in(12), Mem_data_in(11)=>
      Mem_data_in(11), Mem_data_in(10)=>Mem_data_in(10), Mem_data_in(9)=>
      Mem_data_in(9), Mem_data_in(8)=>Mem_data_in(8), Mem_data_in(7)=>
      Mem_data_in(7), Mem_data_in(6)=>Mem_data_in(6), Mem_data_in(5)=>
      Mem_data_in(5), Mem_data_in(4)=>Mem_data_in(4), Mem_data_in(3)=>
      Mem_data_in(3), Mem_data_in(2)=>Mem_data_in(2), Mem_data_in(1)=>
      Mem_data_in(1), Mem_data_in(0)=>Mem_data_in(0), OE_High=>DANGLING(18), 
      TT_Load=>DANGLING(19), Tok=>DANGLING(20), Tx_A=>Tx_A, Tx_A_N=>Tx_A_N, 
      Tx_B=>Tx_B, Tx_B_N=>Tx_B_N, Tx_inh_A=>Tx_inh_A1, Tx_inh_B=>Tx_inh_B1, 
      Update=>DANGLING(21), debug_out(63)=>DANGLING(22), debug_out(62)=>
      DANGLING(23), debug_out(61)=>DANGLING(24), debug_out(60)=>DANGLING(25), 
      debug_out(59)=>DANGLING(26), debug_out(58)=>DANGLING(27), 
      debug_out(57)=>DANGLING(28), debug_out(56)=>DANGLING(29), 
      debug_out(55)=>DANGLING(30), debug_out(54)=>DANGLING(31), 
      debug_out(53)=>DANGLING(32), debug_out(52)=>DANGLING(33), 
      debug_out(51)=>DANGLING(34), debug_out(50)=>DANGLING(35), 
      debug_out(49)=>DANGLING(36), debug_out(48)=>DANGLING(37), 
      debug_out(47)=>DANGLING(38), debug_out(46)=>DANGLING(39), 
      debug_out(45)=>DANGLING(40), debug_out(44)=>DANGLING(41), 
      debug_out(43)=>DANGLING(42), debug_out(42)=>DANGLING(43), 
      debug_out(41)=>DANGLING(44), debug_out(40)=>DANGLING(45), 
      debug_out(39)=>DANGLING(46), debug_out(38)=>DANGLING(47), 
      debug_out(37)=>DANGLING(48), debug_out(36)=>DANGLING(49), 
      debug_out(35)=>DANGLING(50), debug_out(34)=>DANGLING(51), 
      debug_out(33)=>DANGLING(52), debug_out(32)=>DANGLING(53), 
      debug_out(31)=>DANGLING(54), debug_out(30)=>DANGLING(55), 
      debug_out(29)=>DANGLING(56), debug_out(28)=>DANGLING(57), 
      debug_out(27)=>DANGLING(58), debug_out(26)=>DANGLING(59), 
      debug_out(25)=>DANGLING(60), debug_out(24)=>DANGLING(61), 
      debug_out(23)=>DANGLING(62), debug_out(22)=>DANGLING(63), 
      debug_out(21)=>DANGLING(64), debug_out(20)=>DANGLING(65), 
      debug_out(19)=>DANGLING(66), debug_out(18)=>DANGLING(67), 
      debug_out(17)=>DANGLING(68), debug_out(16)=>DANGLING(69), 
      debug_out(15)=>DANGLING(70), debug_out(14)=>DANGLING(71), 
      debug_out(13)=>DANGLING(72), debug_out(12)=>DANGLING(73), 
      debug_out(11)=>DANGLING(74), debug_out(10)=>DANGLING(75), debug_out(9)
      =>DANGLING(76), debug_out(8)=>DANGLING(77), debug_out(7)=>DANGLING(78), 
      debug_out(6)=>DANGLING(79), debug_out(5)=>DANGLING(80), debug_out(4)=>
      DANGLING(81), debug_out(3)=>DANGLING(82), debug_out(2)=>DANGLING(83), 
      debug_out(1)=>DANGLING(84), debug_out(0)=>DANGLING(85), fault_type(3)
      =>DANGLING(86), fault_type(2)=>DANGLING(87), fault_type(1)=>DANGLING(
      88), fault_type(0)=>DANGLING(89), mem_WE=>mem_WE, n16Mhz_12=>DANGLING(
      90), BC_Message_Active=>BC_Message_Active, BC_on=>BC_on, 
      H15530_record_A_Bit_number(4)=>DANGLING(91), 
      H15530_record_A_Bit_number(3)=>DANGLING(92), 
      H15530_record_A_Bit_number(2)=>DANGLING(93), 
      H15530_record_A_Bit_number(1)=>DANGLING(94), 
      H15530_record_A_Bit_number(0)=>DANGLING(95), 
      H15530_record_A_Response_Time(7)=>DANGLING(96), 
      H15530_record_A_Response_Time(6)=>DANGLING(97), 
      H15530_record_A_Response_Time(5)=>DANGLING(98), 
      H15530_record_A_Response_Time(4)=>DANGLING(99), 
      H15530_record_A_Response_Time(3)=>DANGLING(100), 
      H15530_record_A_Response_Time(2)=>DANGLING(101), 
      H15530_record_A_Response_Time(1)=>DANGLING(102), 
      H15530_record_A_Response_Time(0)=>DANGLING(103), 
      H15530_record_A_Sync_error=>DANGLING(104), 
      H15530_record_A_Manchester_error=>DANGLING(105), 
      H15530_record_A_Parity_error=>DANGLING(106), 
      H15530_record_A_echo_back_bus=>DANGLING(107), 
      H15530_record_A_R_Data(15)=>H15530_record_A_R_Data(15), 
      H15530_record_A_R_Data(14)=>H15530_record_A_R_Data(14), 
      H15530_record_A_R_Data(13)=>H15530_record_A_R_Data(13), 
      H15530_record_A_R_Data(12)=>H15530_record_A_R_Data(12), 
      H15530_record_A_R_Data(11)=>H15530_record_A_R_Data(11), 
      H15530_record_A_R_Data(10)=>H15530_record_A_R_Data(10), 
      H15530_record_A_R_Data(9)=>H15530_record_A_R_Data(9), 
      H15530_record_A_R_Data(8)=>H15530_record_A_R_Data(8), 
      H15530_record_A_R_Data(7)=>H15530_record_A_R_Data(7), 
      H15530_record_A_R_Data(6)=>H15530_record_A_R_Data(6), 
      H15530_record_A_R_Data(5)=>H15530_record_A_R_Data(5), 
      H15530_record_A_R_Data(4)=>H15530_record_A_R_Data(4), 
      H15530_record_A_R_Data(3)=>H15530_record_A_R_Data(3), 
      H15530_record_A_R_Data(2)=>H15530_record_A_R_Data(2), 
      H15530_record_A_R_Data(1)=>H15530_record_A_R_Data(1), 
      H15530_record_A_R_Data(0)=>H15530_record_A_R_Data(0), 
      H15530_record_A_RAW_GAP(6)=>DANGLING(108), H15530_record_A_RAW_GAP(5)
      =>DANGLING(109), H15530_record_A_RAW_GAP(4)=>DANGLING(110), 
      H15530_record_A_RAW_GAP(3)=>DANGLING(111), H15530_record_A_RAW_GAP(2)
      =>DANGLING(112), H15530_record_A_RAW_GAP(1)=>DANGLING(113), 
      H15530_record_A_RAW_GAP(0)=>DANGLING(114), H15530_record_A_GAP(6)=>
      DANGLING(115), H15530_record_A_GAP(5)=>DANGLING(116), 
      H15530_record_A_GAP(4)=>DANGLING(117), H15530_record_A_GAP(3)=>
      DANGLING(118), H15530_record_A_GAP(2)=>DANGLING(119), 
      H15530_record_A_GAP(1)=>DANGLING(120), H15530_record_A_GAP(0)=>
      DANGLING(121), H15530_record_A_Gap_found(2)=>DANGLING(122), 
      H15530_record_A_Gap_found(1)=>DANGLING(123), 
      H15530_record_A_Gap_found(0)=>DANGLING(124), 
      H15530_record_A_RxRDY_plus_12us=>DANGLING(125), 
      H15530_record_A_RxRDY_plus_10us=>DANGLING(126), H15530_record_A_CS=>
      H15530_record_A_CS, H15530_record_A_Pre_EchoRdy=>DANGLING(127), 
      H15530_record_A_Command_Sync=>H15530_record_A_Command_Sync, 
      H15530_record_A_Pre_RxRdy=>H15530_record_A_Pre_RxRdy, 
      H15530_record_A_recieving=>DANGLING(128), 
      H15530_record_B_Bit_number(4)=>DANGLING(129), 
      H15530_record_B_Bit_number(3)=>DANGLING(130), 
      H15530_record_B_Bit_number(2)=>DANGLING(131), 
      H15530_record_B_Bit_number(1)=>DANGLING(132), 
      H15530_record_B_Bit_number(0)=>DANGLING(133), 
      H15530_record_B_Response_Time(7)=>DANGLING(134), 
      H15530_record_B_Response_Time(6)=>DANGLING(135), 
      H15530_record_B_Response_Time(5)=>DANGLING(136), 
      H15530_record_B_Response_Time(4)=>DANGLING(137), 
      H15530_record_B_Response_Time(3)=>DANGLING(138), 
      H15530_record_B_Response_Time(2)=>DANGLING(139), 
      H15530_record_B_Response_Time(1)=>DANGLING(140), 
      H15530_record_B_Response_Time(0)=>DANGLING(141), 
      H15530_record_B_Sync_error=>DANGLING(142), 
      H15530_record_B_Manchester_error=>DANGLING(143), 
      H15530_record_B_Parity_error=>DANGLING(144), 
      H15530_record_B_echo_back_bus=>DANGLING(145), 
      H15530_record_B_R_Data(15)=>H15530_record_B_R_Data(15), 
      H15530_record_B_R_Data(14)=>H15530_record_B_R_Data(14), 
      H15530_record_B_R_Data(13)=>H15530_record_B_R_Data(13), 
      H15530_record_B_R_Data(12)=>H15530_record_B_R_Data(12), 
      H15530_record_B_R_Data(11)=>H15530_record_B_R_Data(11), 
      H15530_record_B_R_Data(10)=>H15530_record_B_R_Data(10), 
      H15530_record_B_R_Data(9)=>H15530_record_B_R_Data(9), 
      H15530_record_B_R_Data(8)=>H15530_record_B_R_Data(8), 
      H15530_record_B_R_Data(7)=>H15530_record_B_R_Data(7), 
      H15530_record_B_R_Data(6)=>H15530_record_B_R_Data(6), 
      H15530_record_B_R_Data(5)=>H15530_record_B_R_Data(5), 
      H15530_record_B_R_Data(4)=>H15530_record_B_R_Data(4), 
      H15530_record_B_R_Data(3)=>H15530_record_B_R_Data(3), 
      H15530_record_B_R_Data(2)=>H15530_record_B_R_Data(2), 
      H15530_record_B_R_Data(1)=>H15530_record_B_R_Data(1), 
      H15530_record_B_R_Data(0)=>H15530_record_B_R_Data(0), 
      H15530_record_B_RAW_GAP(6)=>DANGLING(146), H15530_record_B_RAW_GAP(5)
      =>DANGLING(147), H15530_record_B_RAW_GAP(4)=>DANGLING(148), 
      H15530_record_B_RAW_GAP(3)=>DANGLING(149), H15530_record_B_RAW_GAP(2)
      =>DANGLING(150), H15530_record_B_RAW_GAP(1)=>DANGLING(151), 
      H15530_record_B_RAW_GAP(0)=>DANGLING(152), H15530_record_B_GAP(6)=>
      DANGLING(153), H15530_record_B_GAP(5)=>DANGLING(154), 
      H15530_record_B_GAP(4)=>DANGLING(155), H15530_record_B_GAP(3)=>
      DANGLING(156), H15530_record_B_GAP(2)=>DANGLING(157), 
      H15530_record_B_GAP(1)=>DANGLING(158), H15530_record_B_GAP(0)=>
      DANGLING(159), H15530_record_B_Gap_found(2)=>DANGLING(160), 
      H15530_record_B_Gap_found(1)=>DANGLING(161), 
      H15530_record_B_Gap_found(0)=>DANGLING(162), 
      H15530_record_B_RxRDY_plus_12us=>DANGLING(163), 
      H15530_record_B_RxRDY_plus_10us=>DANGLING(164), H15530_record_B_CS=>
      H15530_record_B_CS, H15530_record_B_Pre_EchoRdy=>DANGLING(165), 
      H15530_record_B_Command_Sync=>H15530_record_B_Command_Sync, 
      H15530_record_B_Pre_RxRdy=>H15530_record_B_Pre_RxRdy, 
      H15530_record_B_recieving=>DANGLING(166), key_ports_out(23)=>DANGLING(
      167), key_ports_out(22)=>DANGLING(168), key_ports_out(21)=>DANGLING(
      169), key_ports_out(20)=>DANGLING(170), key_ports_out(19)=>DANGLING(
      171), key_ports_out(18)=>DANGLING(172), key_ports_out(17)=>DANGLING(
      173), key_ports_out(16)=>DANGLING(174), key_ports_out(15)=>DANGLING(
      175), key_ports_out(14)=>DANGLING(176), key_ports_out(13)=>DANGLING(
      177), key_ports_out(12)=>DANGLING(178), key_ports_out(11)=>DANGLING(
      179), key_ports_out(10)=>DANGLING(180), key_ports_out(9)=>DANGLING(181
      ), key_ports_out(8)=>DANGLING(182), key_ports_out(7)=>DANGLING(183), 
      key_ports_out(6)=>DANGLING(184), key_ports_out(5)=>DANGLING(185), 
      key_ports_out(4)=>DANGLING(186), key_ports_out(3)=>DANGLING(187), 
      key_ports_out(2)=>DANGLING(188), key_ports_out(1)=>DANGLING(189), 
      key_ports_out(0)=>DANGLING(190), one_micro_increment=>
      one_micro_increment, pTDR_INT=>DANGLING(191), time_tag(15)=>
      time_tag(15), time_tag(14)=>time_tag(14), time_tag(13)=>time_tag(13), 
      time_tag(12)=>time_tag(12), time_tag(11)=>time_tag(11), time_tag(10)=>
      time_tag(10), time_tag(9)=>time_tag(9), time_tag(8)=>time_tag(8), 
      time_tag(7)=>time_tag(7), time_tag(6)=>time_tag(6), time_tag(5)=>
      time_tag(5), time_tag(4)=>time_tag(4), time_tag(3)=>time_tag(3), 
      time_tag(2)=>time_tag(2), time_tag(1)=>time_tag(1), time_tag(0)=>
      time_tag(0));
   I1 : DPRAM_Interlaced2_16_1_1 port map ( ADDr_i_A(15)=>Mem_Address(15), 
      ADDr_i_A(14)=>Mem_Address(14), ADDr_i_A(13)=>Mem_Address(13), 
      ADDr_i_A(12)=>Mem_Address(12), ADDr_i_A(11)=>Mem_Address(11), 
      ADDr_i_A(10)=>Mem_Address(10), ADDr_i_A(9)=>Mem_Address(9), 
      ADDr_i_A(8)=>Mem_Address(8), ADDr_i_A(7)=>Mem_Address(7), ADDr_i_A(6)
      =>Mem_Address(6), ADDr_i_A(5)=>Mem_Address(5), ADDr_i_A(4)=>
      Mem_Address(4), ADDr_i_A(3)=>Mem_Address(3), ADDr_i_A(2)=>
      Mem_Address(2), ADDr_i_A(1)=>Mem_Address(1), ADDr_i_A(0)=>
      Mem_Address(0), ADDr_i_B(15)=>CPU_Address(15), ADDr_i_B(14)=>
      CPU_Address(14), ADDr_i_B(13)=>CPU_Address(13), ADDr_i_B(12)=>
      CPU_Address(12), ADDr_i_B(11)=>CPU_Address(11), ADDr_i_B(10)=>
      CPU_Address(10), ADDr_i_B(9)=>CPU_Address(9), ADDr_i_B(8)=>
      CPU_Address(8), ADDr_i_B(7)=>CPU_Address(7), ADDr_i_B(6)=>
      CPU_Address(6), ADDr_i_B(5)=>CPU_Address(5), ADDr_i_B(4)=>
      CPU_Address(4), ADDr_i_B(3)=>CPU_Address(3), ADDr_i_B(2)=>
      CPU_Address(2), ADDr_i_B(1)=>CPU_Address(1), ADDr_i_B(0)=>GND, 
      Data_i_A(15)=>Mem_data_in(15), Data_i_A(14)=>Mem_data_in(14), 
      Data_i_A(13)=>Mem_data_in(13), Data_i_A(12)=>Mem_data_in(12), 
      Data_i_A(11)=>Mem_data_in(11), Data_i_A(10)=>Mem_data_in(10), 
      Data_i_A(9)=>Mem_data_in(9), Data_i_A(8)=>Mem_data_in(8), Data_i_A(7)
      =>Mem_data_in(7), Data_i_A(6)=>Mem_data_in(6), Data_i_A(5)=>
      Mem_data_in(5), Data_i_A(4)=>Mem_data_in(4), Data_i_A(3)=>
      Mem_data_in(3), Data_i_A(2)=>Mem_data_in(2), Data_i_A(1)=>
      Mem_data_in(1), Data_i_A(0)=>Mem_data_in(0), Data_i_B(31)=>
      CPU_Data_in(31), Data_i_B(30)=>CPU_Data_in(30), Data_i_B(29)=>
      CPU_Data_in(29), Data_i_B(28)=>CPU_Data_in(28), Data_i_B(27)=>
      CPU_Data_in(27), Data_i_B(26)=>CPU_Data_in(26), Data_i_B(25)=>
      CPU_Data_in(25), Data_i_B(24)=>CPU_Data_in(24), Data_i_B(23)=>
      CPU_Data_in(23), Data_i_B(22)=>CPU_Data_in(22), Data_i_B(21)=>
      CPU_Data_in(21), Data_i_B(20)=>CPU_Data_in(20), Data_i_B(19)=>
      CPU_Data_in(19), Data_i_B(18)=>CPU_Data_in(18), Data_i_B(17)=>
      CPU_Data_in(17), Data_i_B(16)=>CPU_Data_in(16), Data_i_B(15)=>
      CPU_Data_in(15), Data_i_B(14)=>CPU_Data_in(14), Data_i_B(13)=>
      CPU_Data_in(13), Data_i_B(12)=>CPU_Data_in(12), Data_i_B(11)=>
      CPU_Data_in(11), Data_i_B(10)=>CPU_Data_in(10), Data_i_B(9)=>
      CPU_Data_in(9), Data_i_B(8)=>CPU_Data_in(8), Data_i_B(7)=>
      CPU_Data_in(7), Data_i_B(6)=>CPU_Data_in(6), Data_i_B(5)=>
      CPU_Data_in(5), Data_i_B(4)=>CPU_Data_in(4), Data_i_B(3)=>
      CPU_Data_in(3), Data_i_B(2)=>CPU_Data_in(2), Data_i_B(1)=>
      CPU_Data_in(1), Data_i_B(0)=>CPU_Data_in(0), WE_A=>mem_WE_CE, 
      WE_B_vec(1)=>WE_B_vec(1), WE_B_vec(0)=>WE_B_vec(0), clock=>clock, 
      Data_o_A(15)=>Data_o_A(15), Data_o_A(14)=>Data_o_A(14), Data_o_A(13)=>
      Data_o_A(13), Data_o_A(12)=>Data_o_A(12), Data_o_A(11)=>Data_o_A(11), 
      Data_o_A(10)=>Data_o_A(10), Data_o_A(9)=>Data_o_A(9), Data_o_A(8)=>
      Data_o_A(8), Data_o_A(7)=>Data_o_A(7), Data_o_A(6)=>Data_o_A(6), 
      Data_o_A(5)=>Data_o_A(5), Data_o_A(4)=>Data_o_A(4), Data_o_A(3)=>
      Data_o_A(3), Data_o_A(2)=>Data_o_A(2), Data_o_A(1)=>Data_o_A(1), 
      Data_o_A(0)=>Data_o_A(0), Data_o_B(31)=>Data_o_B(31), Data_o_B(30)=>
      Data_o_B(30), Data_o_B(29)=>Data_o_B(29), Data_o_B(28)=>Data_o_B(28), 
      Data_o_B(27)=>Data_o_B(27), Data_o_B(26)=>Data_o_B(26), Data_o_B(25)=>
      Data_o_B(25), Data_o_B(24)=>Data_o_B(24), Data_o_B(23)=>Data_o_B(23), 
      Data_o_B(22)=>Data_o_B(22), Data_o_B(21)=>Data_o_B(21), Data_o_B(20)=>
      Data_o_B(20), Data_o_B(19)=>Data_o_B(19), Data_o_B(18)=>Data_o_B(18), 
      Data_o_B(17)=>Data_o_B(17), Data_o_B(16)=>Data_o_B(16), Data_o_B(15)=>
      Data_o_B(15), Data_o_B(14)=>Data_o_B(14), Data_o_B(13)=>Data_o_B(13), 
      Data_o_B(12)=>Data_o_B(12), Data_o_B(11)=>Data_o_B(11), Data_o_B(10)=>
      Data_o_B(10), Data_o_B(9)=>Data_o_B(9), Data_o_B(8)=>Data_o_B(8), 
      Data_o_B(7)=>Data_o_B(7), Data_o_B(6)=>Data_o_B(6), Data_o_B(5)=>
      Data_o_B(5), Data_o_B(4)=>Data_o_B(4), Data_o_B(3)=>Data_o_B(3), 
      Data_o_B(2)=>Data_o_B(2), Data_o_B(1)=>Data_o_B(1), Data_o_B(0)=>
      Data_o_B(0));
   I2 : Xcvr_Snubber_sital_8_4_4_32_7 port map ( CE=>CE_out, Regular=>
      Regular_XCVR, RxNSital=>RxAn, RxSital=>RxA, Tx=>Tx_A, TxN=>Tx_A_N, 
      Tx_Inhibit=>Tx_inh_A1, clock=>clock, resetN=>resetN, Rx=>Plus_A, RxN=>
      Minus_A, TxN_SN=>Tx_AN_SN, Tx_SN=>Tx_A_SN, TxN_Sital=>TxAN, TxSense=>
      Tx_inh_A, Tx_Sital=>TxA);
   I3 : Xcvr_Snubber_sital_8_4_4_32_7 port map ( CE=>CE_out, Regular=>
      Regular_XCVR, RxNSital=>RxBn, RxSital=>RxB, Tx=>Tx_B, TxN=>Tx_B_N, 
      Tx_Inhibit=>Tx_inh_B1, clock=>clock, resetN=>resetN, Rx=>Plus_B, RxN=>
      Minus_B, TxN_SN=>Tx_BN_SN, Tx_SN=>Tx_B_SN, TxN_Sital=>TxBN, TxSense=>
      Tx_Inh_B, Tx_Sital=>TxB);
   mem_WE_CE <= mem_WE AND CE_out ;
   not_DEBUG_F500Khz <= NOT DEBUG_F500Khz_EXMPLR3806 ;
   DEBUG_Rx_Strobe_4n2s2 <= H15530_record_A_Pre_RxRdy OR 
   H15530_record_B_Pre_RxRdy ;
   DEBUG_Rx_Ok_4n2s2 <= H15530_record_A_CS AND H15530_record_B_CS ;
   rtlc8n45 <= mem_WE OR Mem_RE ;
   rtlc8n46 <= not_rtlcn0 AND rtlc8n45 ;
   rtlc11n103 <= H15530_record_B_Pre_RxRdy AND H15530_record_B_Command_Sync
    ;
   rtlc11n112 <= rtlc11n103 AND rtlc11n111 ;
   rtlc11n114 <= rtlc11n112 AND H15530_record_B_CS ;
   rtlc11n83 <= H15530_record_A_Pre_RxRdy AND H15530_record_A_Command_Sync ;
   rtlc11n92 <= rtlc11n83 AND rtlc11n91 ;
   rtlc11n94 <= rtlc11n92 AND H15530_record_A_CS ;
   not_rtlcn0 <= NOT rtlcn0 ;
   rtlcn0 <= Ack OR Pipe_Delay ;
   not_rtlc4n67 <= NOT rtlc4n67 ;
   not_resetN <= NOT resetN ;
   not_BC_Message_Active <= NOT BC_Message_Active ;
   Cyber_Attack_Command_11n2ss1(0) <= H15530_record_A_R_Data(0) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(0) ;
   Cyber_Attack_Command_11n2ss1(1) <= H15530_record_A_R_Data(1) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(1) ;
   Cyber_Attack_Command_11n2ss1(2) <= H15530_record_A_R_Data(2) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(2) ;
   Cyber_Attack_Command_11n2ss1(3) <= H15530_record_A_R_Data(3) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(3) ;
   Cyber_Attack_Command_11n2ss1(4) <= H15530_record_A_R_Data(4) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(4) ;
   Cyber_Attack_Command_11n2ss1(5) <= H15530_record_A_R_Data(5) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(5) ;
   Cyber_Attack_Command_11n2ss1(6) <= H15530_record_A_R_Data(6) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(6) ;
   Cyber_Attack_Command_11n2ss1(7) <= H15530_record_A_R_Data(7) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(7) ;
   Cyber_Attack_Command_11n2ss1(8) <= H15530_record_A_R_Data(8) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(8) ;
   Cyber_Attack_Command_11n2ss1(9) <= H15530_record_A_R_Data(9) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(9) ;
   Cyber_Attack_Command_11n2ss1(10) <= H15530_record_A_R_Data(10) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(10) ;
   Cyber_Attack_Command_11n2ss1(11) <= H15530_record_A_R_Data(11) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(11) ;
   Cyber_Attack_Command_11n2ss1(12) <= H15530_record_A_R_Data(12) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(12) ;
   Cyber_Attack_Command_11n2ss1(13) <= H15530_record_A_R_Data(13) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(13) ;
   Cyber_Attack_Command_11n2ss1(14) <= H15530_record_A_R_Data(14) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(14) ;
   Cyber_Attack_Command_11n2ss1(15) <= H15530_record_A_R_Data(15) when 
   rtlc11n94 = '1' else H15530_record_B_R_Data(15) ;
   rtlcn25 <= Pipe_Delay OR CE_out ;
   not_rtlc8n46 <= NOT rtlc8n46 ;
   rtlc8n90 <= not_rtlc8n46 AND rtlcn25 ;
   rtlcn17 <= rtlc11n114 OR rtlc11n94 ;
   rtlc_145_and_1342 : and_4u_4u port map ( a(3)=>CE_out, a(2)=>
      not_BC_Message_Active, a(1)=>BC_on, a(0)=>rtlcn17, d=>rtlc11n193);
   rtlc4n67 <= NOT (RxA XOR RxAn) ;
   rtlc_181_or_1343 : or_11u_11u port map ( a(10)=>H15530_record_A_R_Data(0), 
      a(9)=>H15530_record_A_R_Data(1), a(8)=>H15530_record_A_R_Data(2), a(7)
      =>H15530_record_A_R_Data(3), a(6)=>H15530_record_A_R_Data(4), a(5)=>
      H15530_record_A_R_Data(5), a(4)=>H15530_record_A_R_Data(6), a(3)=>
      H15530_record_A_R_Data(7), a(2)=>H15530_record_A_R_Data(8), a(1)=>
      H15530_record_A_R_Data(9), a(0)=>H15530_record_A_R_Data(10), d=>
      rtlc11n91);
   rtlc_182_or_1344 : or_11u_11u port map ( a(10)=>H15530_record_B_R_Data(0), 
      a(9)=>H15530_record_B_R_Data(1), a(8)=>H15530_record_B_R_Data(2), a(7)
      =>H15530_record_B_R_Data(3), a(6)=>H15530_record_B_R_Data(4), a(5)=>
      H15530_record_B_R_Data(5), a(4)=>H15530_record_B_R_Data(6), a(3)=>
      H15530_record_B_R_Data(7), a(2)=>H15530_record_B_R_Data(8), a(1)=>
      H15530_record_B_R_Data(9), a(0)=>H15530_record_B_R_Data(10), d=>
      rtlc11n111);
   DFFPC (Raw_resetN,GND,GND,clock,resetN) ;
   DFFPC (not_rtlc4n67,GND,not_resetN,clock,DEBUG_RxAs) ;
   DFFPC (DEBUG_Rx_Ok_4n2s2,GND,not_resetN,clock,DEBUG_Rx_Ok) ;
   DFFPC (DEBUG_Rx_Strobe_4n2s2,GND,not_resetN,clock,DEBUG_Rx_Strobe) ;
   DFFPC (H15530_record_A_Command_Sync,GND,not_resetN,clock,
   DEBUG_A_command_sync) ;
   DFFPC (time_tag(15),GND,not_resetN,clock,DEBUG_TT_MSB) ;
   DFFPCE (not_DEBUG_F500Khz,GND,not_resetN,one_micro_increment,clock,
   DEBUG_F500Khz_EXMPLR3806) ;
   DFFPCE (Pipe_Delay,GND,not_resetN,rtlc8n90,clock,Ack) ;
   DFFPCE (rtlc11n94,GND,not_resetN,rtlc11n193,clock,Cyber_Attack_Bus_A) ;
   DFFPCE (time_tag(15),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(15)) ;
   DFFPCE (time_tag(14),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(14)) ;
   DFFPCE (time_tag(13),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(13)) ;
   DFFPCE (time_tag(12),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(12)) ;
   DFFPCE (time_tag(11),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(11)) ;
   DFFPCE (time_tag(10),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_TTag(10)) ;
   DFFPCE (time_tag(9),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(9))
    ;
   DFFPCE (time_tag(8),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(8))
    ;
   DFFPCE (time_tag(7),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(7))
    ;
   DFFPCE (time_tag(6),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(6))
    ;
   DFFPCE (time_tag(5),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(5))
    ;
   DFFPCE (time_tag(4),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(4))
    ;
   DFFPCE (time_tag(3),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(3))
    ;
   DFFPCE (time_tag(2),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(2))
    ;
   DFFPCE (time_tag(1),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(1))
    ;
   DFFPCE (time_tag(0),GND,not_resetN,rtlc11n193,clock,Cyber_Attack_TTag(0))
    ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(15),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(15)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(14),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(14)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(13),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(13)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(12),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(12)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(11),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(11)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(10),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(10)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(9),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(9)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(8),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(8)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(7),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(7)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(6),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(6)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(5),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(5)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(4),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(4)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(3),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(3)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(2),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(2)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(1),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(1)) ;
   DFFPCE (Cyber_Attack_Command_11n2ss1(0),GND,not_resetN,rtlc11n193,clock,
   Cyber_Attack_Command(0)) ;
   DFFPCE (rtlcn12,GND,not_resetN,CE_out,clock,Cyber_Attck_Type1) ;
   DFFPC (rtlc8n46,GND,not_resetN,clock,Pipe_Delay) ;
   modgen_and_0 : and_3u_3u port map ( a(2)=>BC_on, a(1)=>
      not_BC_Message_Active, a(0)=>rtlcn17, d=>rtlcn12);
end External_Mem ;

